/* TimedQueue.c generated by valac 0.56.17, the Vala compiler
 * generated from TimedQueue.vala, do not modify */

/* Copyright 2016 Software Freedom Conservancy Inc.
 *
 * This software is licensed under the GNU Lesser General Public License
 * (version 2.1 or later).  See the COPYING file in this distribution.
 */
/* TimedQueue is a specialized collection class.  It holds items in order, but rather than being*/
/* manually dequeued, they are dequeued automatically after a specified amount of time has elapsed*/
/* for that item.  As of today, it's possible the item will be dequeued a bit later than asked*/
/* for, but it will never be early.  Future implementations might tighten up the lateness.*/
/**/
/* The original design was to use a signal to notify when an item has been dequeued, but Vala has*/
/* a bug with passing an unnamed type as a signal parameter:*/
/* https://bugzilla.gnome.org/show_bug.cgi?id=628639*/
/**/
/* The rate the items come off the queue can be spaced out.  Note that this can cause items to back*/
/* up.  As of today, TimedQueue makes no effort to combat this.*/

#include <glib.h>
#include <glib-object.h>
#include <gee.h>
#include <gobject/gvaluecollector.h>
#include <string.h>

#if !defined(VALA_STRICT_C)
#if !defined(__clang__) && defined(__GNUC__) && (__GNUC__ >= 14)
#pragma GCC diagnostic warning "-Wincompatible-pointer-types"
#elif defined(__clang__) && (__clang_major__ >= 16)
#pragma clang diagnostic ignored "-Wincompatible-function-pointer-types"
#pragma clang diagnostic ignored "-Wincompatible-pointer-types"
#endif
#endif
#if !defined(VALA_EXTERN)
#if defined(_MSC_VER)
#define VALA_EXTERN __declspec(dllexport) extern
#elif __GNUC__ >= 4
#define VALA_EXTERN __attribute__((visibility("default"))) extern
#else
#define VALA_EXTERN extern
#endif
#endif

typedef void (*DequeuedCallback) (gconstpointer item, gpointer user_data);

#define TYPE_HASH_TIMED_QUEUE (hash_timed_queue_get_type ())
#define HASH_TIMED_QUEUE(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_HASH_TIMED_QUEUE, HashTimedQueue))
#define HASH_TIMED_QUEUE_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_HASH_TIMED_QUEUE, HashTimedQueueClass))
#define IS_HASH_TIMED_QUEUE(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_HASH_TIMED_QUEUE))
#define IS_HASH_TIMED_QUEUE_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_HASH_TIMED_QUEUE))
#define HASH_TIMED_QUEUE_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_HASH_TIMED_QUEUE, HashTimedQueueClass))

typedef struct _HashTimedQueue HashTimedQueue;
typedef struct _HashTimedQueueClass HashTimedQueueClass;
typedef struct _HashTimedQueuePrivate HashTimedQueuePrivate;

#define TYPE_SORTED_LIST (sorted_list_get_type ())
#define SORTED_LIST(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_SORTED_LIST, SortedList))
#define SORTED_LIST_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_SORTED_LIST, SortedListClass))
#define IS_SORTED_LIST(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_SORTED_LIST))
#define IS_SORTED_LIST_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_SORTED_LIST))
#define SORTED_LIST_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_SORTED_LIST, SortedListClass))

typedef struct _SortedList SortedList;
typedef struct _SortedListClass SortedListClass;

#define HASH_TIMED_QUEUE_TYPE_ELEMENT (hash_timed_queue_element_get_type ())
#define HASH_TIMED_QUEUE_ELEMENT(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), HASH_TIMED_QUEUE_TYPE_ELEMENT, HashTimedQueueElement))
#define HASH_TIMED_QUEUE_ELEMENT_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), HASH_TIMED_QUEUE_TYPE_ELEMENT, HashTimedQueueElementClass))
#define HASH_TIMED_QUEUE_IS_ELEMENT(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), HASH_TIMED_QUEUE_TYPE_ELEMENT))
#define HASH_TIMED_QUEUE_IS_ELEMENT_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), HASH_TIMED_QUEUE_TYPE_ELEMENT))
#define HASH_TIMED_QUEUE_ELEMENT_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), HASH_TIMED_QUEUE_TYPE_ELEMENT, HashTimedQueueElementClass))

typedef struct _HashTimedQueueElement HashTimedQueueElement;
typedef struct _HashTimedQueueElementClass HashTimedQueueElementClass;
#define _g_object_unref0(var) ((var == NULL) ? NULL : (var = (g_object_unref (var), NULL)))
typedef gint64 (*Comparator) (void* a, void* b, gpointer user_data);
#define _hash_timed_queue_element_unref0(var) ((var == NULL) ? NULL : (var = (hash_timed_queue_element_unref (var), NULL)))
typedef struct _HashTimedQueueElementPrivate HashTimedQueueElementPrivate;
typedef struct _HashTimedQueueParamSpecElement HashTimedQueueParamSpecElement;
typedef struct _ParamSpecHashTimedQueue ParamSpecHashTimedQueue;
enum  {
	HASH_TIMED_QUEUE_PAUSED_SIGNAL,
	HASH_TIMED_QUEUE_NUM_SIGNALS
};
static guint hash_timed_queue_signals[HASH_TIMED_QUEUE_NUM_SIGNALS] = {0};
#define _vala_assert(expr, msg) if G_LIKELY (expr) ; else g_assertion_message_expr (G_LOG_DOMAIN, __FILE__, __LINE__, G_STRFUNC, msg);
#define _vala_return_if_fail(expr, msg) if G_LIKELY (expr) ; else { g_return_if_fail_warning (G_LOG_DOMAIN, G_STRFUNC, msg); return; }
#define _vala_return_val_if_fail(expr, msg, val) if G_LIKELY (expr) ; else { g_return_if_fail_warning (G_LOG_DOMAIN, G_STRFUNC, msg); return val; }
#define _vala_warn_if_fail(expr, msg) if G_LIKELY (expr) ; else g_warn_message (G_LOG_DOMAIN, __FILE__, __LINE__, G_STRFUNC, msg);

struct _HashTimedQueue {
	GTypeInstance parent_instance;
	volatile int ref_count;
	HashTimedQueuePrivate * priv;
};

struct _HashTimedQueueClass {
	GTypeClass parent_class;
	void (*finalize) (HashTimedQueue *self);
	void (*paused) (HashTimedQueue* self, gboolean is_paused);
};

struct _HashTimedQueuePrivate {
	GType g_type;
	GBoxedCopyFunc g_dup_func;
	GDestroyNotify g_destroy_func;
	guint hold_msec;
	DequeuedCallback callback;
	gpointer callback_target;
	GeeEqualDataFunc equal_func;
	gpointer equal_func_target;
	GDestroyNotify equal_func_target_destroy_notify;
	gint priority;
	guint timer_id;
	SortedList* queue;
	GRecMutex __lock_queue;
	guint dequeue_spacing_msec;
	gulong last_dequeue;
	gboolean paused_state;
	GeeHashMap* item_count;
};

struct _HashTimedQueueElement {
	GTypeInstance parent_instance;
	volatile int ref_count;
	HashTimedQueueElementPrivate * priv;
	gpointer item;
	gulong ready;
};

struct _HashTimedQueueElementClass {
	GTypeClass parent_class;
	void (*finalize) (HashTimedQueueElement *self);
};

struct _HashTimedQueueElementPrivate {
	GType g_type;
	GBoxedCopyFunc g_dup_func;
	GDestroyNotify g_destroy_func;
};

struct _HashTimedQueueParamSpecElement {
	GParamSpec parent_instance;
};

struct _ParamSpecHashTimedQueue {
	GParamSpec parent_instance;
};

static gint HashTimedQueue_private_offset;
static gpointer hash_timed_queue_parent_class = NULL;
static gint HashTimedQueueElement_private_offset;
static gpointer hash_timed_queue_element_parent_class = NULL;

VALA_EXTERN gpointer hash_timed_queue_ref (gpointer instance);
VALA_EXTERN void hash_timed_queue_unref (gpointer instance);
VALA_EXTERN GParamSpec* param_spec_hash_timed_queue (const gchar* name,
                                         const gchar* nick,
                                         const gchar* blurb,
                                         GType object_type,
                                         GParamFlags flags);
VALA_EXTERN void value_set_hash_timed_queue (GValue* value,
                                 gpointer v_object);
VALA_EXTERN void value_take_hash_timed_queue (GValue* value,
                                  gpointer v_object);
VALA_EXTERN gpointer value_get_hash_timed_queue (const GValue* value);
VALA_EXTERN GType hash_timed_queue_get_type (void) G_GNUC_CONST ;
G_DEFINE_AUTOPTR_CLEANUP_FUNC (HashTimedQueue, hash_timed_queue_unref)
VALA_EXTERN GType sorted_list_get_type (void) G_GNUC_CONST ;
G_DEFINE_AUTOPTR_CLEANUP_FUNC (SortedList, g_object_unref)
static gpointer hash_timed_queue_element_ref (gpointer instance);
static void hash_timed_queue_element_unref (gpointer instance);
static GParamSpec* hash_timed_queue_param_spec_element (const gchar* name,
                                                 const gchar* nick,
                                                 const gchar* blurb,
                                                 GType object_type,
                                                 GParamFlags flags) G_GNUC_UNUSED ;
static void hash_timed_queue_value_set_element (GValue* value,
                                         gpointer v_object) G_GNUC_UNUSED ;
static void hash_timed_queue_value_take_element (GValue* value,
                                          gpointer v_object) G_GNUC_UNUSED ;
static gpointer hash_timed_queue_value_get_element (const GValue* value) G_GNUC_UNUSED ;
static GType hash_timed_queue_element_get_type (void) G_GNUC_CONST  G_GNUC_UNUSED ;
G_DEFINE_AUTOPTR_CLEANUP_FUNC (HashTimedQueueElement, hash_timed_queue_element_unref)
VALA_EXTERN HashTimedQueue* hash_timed_queue_new (GType g_type,
                                      GBoxedCopyFunc g_dup_func,
                                      GDestroyNotify g_destroy_func,
                                      guint hold_msec,
                                      DequeuedCallback callback,
                                      gpointer callback_target,
                                      GeeHashDataFunc hash_func,
                                      gpointer hash_func_target,
                                      GDestroyNotify hash_func_target_destroy_notify,
                                      GeeEqualDataFunc equal_func,
                                      gpointer equal_func_target,
                                      GDestroyNotify equal_func_target_destroy_notify,
                                      gint priority);
VALA_EXTERN HashTimedQueue* hash_timed_queue_construct (GType object_type,
                                            GType g_type,
                                            GBoxedCopyFunc g_dup_func,
                                            GDestroyNotify g_destroy_func,
                                            guint hold_msec,
                                            DequeuedCallback callback,
                                            gpointer callback_target,
                                            GeeHashDataFunc hash_func,
                                            gpointer hash_func_target,
                                            GDestroyNotify hash_func_target_destroy_notify,
                                            GeeEqualDataFunc equal_func,
                                            gpointer equal_func_target,
                                            GDestroyNotify equal_func_target_destroy_notify,
                                            gint priority);
static gint64 hash_timed_queue_element_comparator (void* a,
                                            void* b);
static gint64 _hash_timed_queue_element_comparator_comparator (void* a,
                                                        void* b,
                                                        gpointer self);
VALA_EXTERN SortedList* sorted_list_new (GType g_type,
                             GBoxedCopyFunc g_dup_func,
                             GDestroyNotify g_destroy_func,
                             Comparator cmp,
                             gpointer cmp_target);
VALA_EXTERN SortedList* sorted_list_construct (GType object_type,
                                   GType g_type,
                                   GBoxedCopyFunc g_dup_func,
                                   GDestroyNotify g_destroy_func,
                                   Comparator cmp,
                                   gpointer cmp_target);
static guint hash_timed_queue_get_heartbeat_timeout (HashTimedQueue* self);
static gboolean hash_timed_queue_on_heartbeat (HashTimedQueue* self);
static gboolean _hash_timed_queue_on_heartbeat_gsource_func (gpointer self);
VALA_EXTERN guint hash_timed_queue_get_dequeue_spacing_msec (HashTimedQueue* self);
VALA_EXTERN void hash_timed_queue_set_dequeue_spacing_msec (HashTimedQueue* self,
                                                guint msec);
VALA_EXTERN gboolean hash_timed_queue_is_paused (HashTimedQueue* self);
VALA_EXTERN void hash_timed_queue_pause (HashTimedQueue* self);
VALA_EXTERN void hash_timed_queue_unpause (HashTimedQueue* self);
VALA_EXTERN void hash_timed_queue_clear (HashTimedQueue* self);
VALA_EXTERN gboolean hash_timed_queue_contains (HashTimedQueue* self,
                                    gconstpointer item);
VALA_EXTERN gboolean hash_timed_queue_enqueue (HashTimedQueue* self,
                                   gconstpointer item);
static gulong hash_timed_queue_calc_ready_time (HashTimedQueue* self);
static HashTimedQueueElement* hash_timed_queue_element_new (GType g_type,
                                                     GBoxedCopyFunc g_dup_func,
                                                     GDestroyNotify g_destroy_func,
                                                     gconstpointer item,
                                                     gulong ready);
static HashTimedQueueElement* hash_timed_queue_element_construct (GType object_type,
                                                           GType g_type,
                                                           GBoxedCopyFunc g_dup_func,
                                                           GDestroyNotify g_destroy_func,
                                                           gconstpointer item,
                                                           gulong ready);
VALA_EXTERN gboolean hash_timed_queue_enqueue_many (HashTimedQueue* self,
                                        GeeCollection* items);
VALA_EXTERN gboolean sorted_list_add_list (SortedList* self,
                               GeeList* items);
VALA_EXTERN gboolean hash_timed_queue_remove_first (HashTimedQueue* self,
                                        gconstpointer item);
static void hash_timed_queue_removed (HashTimedQueue* self,
                               gconstpointer item);
VALA_EXTERN gulong now_ms (void);
VALA_EXTERN gpointer sorted_list_get_at (SortedList* self,
                             gint index);
VALA_EXTERN gpointer sorted_list_remove_at (SortedList* self,
                                gint index);
VALA_EXTERN gint hash_timed_queue_get_size (HashTimedQueue* self);
static void hash_timed_queue_real_paused (HashTimedQueue* self,
                                   gboolean is_paused);
static void hash_timed_queue_element_finalize (HashTimedQueueElement * obj);
static GType hash_timed_queue_element_get_type_once (void);
static void hash_timed_queue_finalize (HashTimedQueue * obj);
static GType hash_timed_queue_get_type_once (void);
static inline gpointer _vala_memdup2 (gconstpointer mem,
                        gsize byte_size);

static inline gpointer
hash_timed_queue_get_instance_private (HashTimedQueue* self)
{
	return G_STRUCT_MEMBER_P (self, HashTimedQueue_private_offset);
}

static gint64
_hash_timed_queue_element_comparator_comparator (void* a,
                                                 void* b,
                                                 gpointer self)
{
	gint64 result;
	result = hash_timed_queue_element_comparator (a, b);
#line 66 "../src/TimedQueue.vala"
	return result;
#line 295 "TimedQueue.c"
}

static gboolean
_hash_timed_queue_on_heartbeat_gsource_func (gpointer self)
{
	gboolean result;
	result = hash_timed_queue_on_heartbeat ((HashTimedQueue*) self);
#line 68 "../src/TimedQueue.vala"
	return result;
#line 305 "TimedQueue.c"
}

HashTimedQueue*
hash_timed_queue_construct (GType object_type,
                            GType g_type,
                            GBoxedCopyFunc g_dup_func,
                            GDestroyNotify g_destroy_func,
                            guint hold_msec,
                            DequeuedCallback callback,
                            gpointer callback_target,
                            GeeHashDataFunc hash_func,
                            gpointer hash_func_target,
                            GDestroyNotify hash_func_target_destroy_notify,
                            GeeEqualDataFunc equal_func,
                            gpointer equal_func_target,
                            GDestroyNotify equal_func_target_destroy_notify,
                            gint priority)
{
	HashTimedQueue* self = NULL;
	SortedList* _tmp4_;
	GeeHashDataFunc _tmp5_;
	gpointer _tmp5__target;
	GDestroyNotify _tmp5__target_destroy_notify;
	GeeEqualDataFunc _tmp6_;
	gpointer _tmp6__target;
	GDestroyNotify _tmp6__target_destroy_notify;
	GeeHashMap* _tmp7_;
#line 53 "../src/TimedQueue.vala"
	self = (HashTimedQueue*) g_type_create_instance (object_type);
#line 53 "../src/TimedQueue.vala"
	self->priv->g_type = g_type;
#line 53 "../src/TimedQueue.vala"
	self->priv->g_dup_func = g_dup_func;
#line 53 "../src/TimedQueue.vala"
	self->priv->g_destroy_func = g_destroy_func;
#line 56 "../src/TimedQueue.vala"
	self->priv->hold_msec = hold_msec;
#line 57 "../src/TimedQueue.vala"
	self->priv->callback = callback;
#line 57 "../src/TimedQueue.vala"
	self->priv->callback_target = callback_target;
#line 59 "../src/TimedQueue.vala"
	if (equal_func != NULL) {
#line 349 "TimedQueue.c"
		GeeEqualDataFunc _tmp0_;
		gpointer _tmp0__target;
		GDestroyNotify _tmp0__target_destroy_notify;
#line 60 "../src/TimedQueue.vala"
		_tmp0_ = equal_func;
#line 60 "../src/TimedQueue.vala"
		_tmp0__target = equal_func_target;
#line 60 "../src/TimedQueue.vala"
		_tmp0__target_destroy_notify = equal_func_target_destroy_notify;
#line 60 "../src/TimedQueue.vala"
		equal_func = NULL;
#line 60 "../src/TimedQueue.vala"
		equal_func_target = NULL;
#line 60 "../src/TimedQueue.vala"
		equal_func_target_destroy_notify = NULL;
#line 60 "../src/TimedQueue.vala"
		(self->priv->equal_func_target_destroy_notify == NULL) ? NULL : (self->priv->equal_func_target_destroy_notify (self->priv->equal_func_target), NULL);
#line 60 "../src/TimedQueue.vala"
		self->priv->equal_func = NULL;
#line 60 "../src/TimedQueue.vala"
		self->priv->equal_func_target = NULL;
#line 60 "../src/TimedQueue.vala"
		self->priv->equal_func_target_destroy_notify = NULL;
#line 60 "../src/TimedQueue.vala"
		self->priv->equal_func = _tmp0_;
#line 60 "../src/TimedQueue.vala"
		self->priv->equal_func_target = _tmp0__target;
#line 60 "../src/TimedQueue.vala"
		self->priv->equal_func_target_destroy_notify = _tmp0__target_destroy_notify;
#line 379 "TimedQueue.c"
	} else {
		gpointer _tmp1_ = NULL;
		GDestroyNotify _tmp2_ = NULL;
		GeeEqualDataFunc _tmp3_;
#line 62 "../src/TimedQueue.vala"
		_tmp3_ = gee_functions_get_equal_func_for (g_type, &_tmp1_, &_tmp2_);
#line 62 "../src/TimedQueue.vala"
		(self->priv->equal_func_target_destroy_notify == NULL) ? NULL : (self->priv->equal_func_target_destroy_notify (self->priv->equal_func_target), NULL);
#line 62 "../src/TimedQueue.vala"
		self->priv->equal_func = NULL;
#line 62 "../src/TimedQueue.vala"
		self->priv->equal_func_target = NULL;
#line 62 "../src/TimedQueue.vala"
		self->priv->equal_func_target_destroy_notify = NULL;
#line 62 "../src/TimedQueue.vala"
		self->priv->equal_func = (GeeEqualDataFunc) _tmp3_;
#line 62 "../src/TimedQueue.vala"
		self->priv->equal_func_target = _tmp1_;
#line 62 "../src/TimedQueue.vala"
		self->priv->equal_func_target_destroy_notify = _tmp2_;
#line 400 "TimedQueue.c"
	}
#line 64 "../src/TimedQueue.vala"
	self->priv->priority = priority;
#line 66 "../src/TimedQueue.vala"
	_tmp4_ = sorted_list_new (HASH_TIMED_QUEUE_TYPE_ELEMENT, (GBoxedCopyFunc) hash_timed_queue_element_ref, (GDestroyNotify) hash_timed_queue_element_unref, _hash_timed_queue_element_comparator_comparator, NULL);
#line 66 "../src/TimedQueue.vala"
	_g_object_unref0 (self->priv->queue);
#line 66 "../src/TimedQueue.vala"
	self->priv->queue = _tmp4_;
#line 68 "../src/TimedQueue.vala"
	self->priv->timer_id = g_timeout_add_full (priority, hash_timed_queue_get_heartbeat_timeout (self), _hash_timed_queue_on_heartbeat_gsource_func, hash_timed_queue_ref (self), hash_timed_queue_unref);
#line 69 "../src/TimedQueue.vala"
	_tmp5_ = hash_func;
#line 69 "../src/TimedQueue.vala"
	_tmp5__target = hash_func_target;
#line 69 "../src/TimedQueue.vala"
	_tmp5__target_destroy_notify = hash_func_target_destroy_notify;
#line 69 "../src/TimedQueue.vala"
	hash_func = NULL;
#line 69 "../src/TimedQueue.vala"
	hash_func_target = NULL;
#line 69 "../src/TimedQueue.vala"
	hash_func_target_destroy_notify = NULL;
#line 69 "../src/TimedQueue.vala"
	_tmp6_ = equal_func;
#line 69 "../src/TimedQueue.vala"
	_tmp6__target = equal_func_target;
#line 69 "../src/TimedQueue.vala"
	_tmp6__target_destroy_notify = equal_func_target_destroy_notify;
#line 69 "../src/TimedQueue.vala"
	equal_func = NULL;
#line 69 "../src/TimedQueue.vala"
	equal_func_target = NULL;
#line 69 "../src/TimedQueue.vala"
	equal_func_target_destroy_notify = NULL;
#line 69 "../src/TimedQueue.vala"
	_tmp7_ = gee_hash_map_new (g_type, (GBoxedCopyFunc) g_dup_func, (GDestroyNotify) g_destroy_func, G_TYPE_INT, NULL, NULL, _tmp5_, _tmp5__target, _tmp5__target_destroy_notify, _tmp6_, _tmp6__target, _tmp6__target_destroy_notify, NULL, NULL, NULL);
#line 69 "../src/TimedQueue.vala"
	_g_object_unref0 (self->priv->item_count);
#line 69 "../src/TimedQueue.vala"
	self->priv->item_count = _tmp7_;
#line 53 "../src/TimedQueue.vala"
	(hash_func_target_destroy_notify == NULL) ? NULL : (hash_func_target_destroy_notify (hash_func_target), NULL);
#line 53 "../src/TimedQueue.vala"
	hash_func = NULL;
#line 53 "../src/TimedQueue.vala"
	hash_func_target = NULL;
#line 53 "../src/TimedQueue.vala"
	hash_func_target_destroy_notify = NULL;
#line 53 "../src/TimedQueue.vala"
	(equal_func_target_destroy_notify == NULL) ? NULL : (equal_func_target_destroy_notify (equal_func_target), NULL);
#line 53 "../src/TimedQueue.vala"
	equal_func = NULL;
#line 53 "../src/TimedQueue.vala"
	equal_func_target = NULL;
#line 53 "../src/TimedQueue.vala"
	equal_func_target_destroy_notify = NULL;
#line 53 "../src/TimedQueue.vala"
	return self;
#line 460 "TimedQueue.c"
}

HashTimedQueue*
hash_timed_queue_new (GType g_type,
                      GBoxedCopyFunc g_dup_func,
                      GDestroyNotify g_destroy_func,
                      guint hold_msec,
                      DequeuedCallback callback,
                      gpointer callback_target,
                      GeeHashDataFunc hash_func,
                      gpointer hash_func_target,
                      GDestroyNotify hash_func_target_destroy_notify,
                      GeeEqualDataFunc equal_func,
                      gpointer equal_func_target,
                      GDestroyNotify equal_func_target_destroy_notify,
                      gint priority)
{
#line 53 "../src/TimedQueue.vala"
	return hash_timed_queue_construct (TYPE_HASH_TIMED_QUEUE, g_type, g_dup_func, g_destroy_func, hold_msec, callback, callback_target, hash_func, hash_func_target, hash_func_target_destroy_notify, equal_func, equal_func_target, equal_func_target_destroy_notify, priority);
#line 480 "TimedQueue.c"
}

guint
hash_timed_queue_get_dequeue_spacing_msec (HashTimedQueue* self)
{
	guint result;
#line 77 "../src/TimedQueue.vala"
	g_return_val_if_fail (IS_HASH_TIMED_QUEUE (self), 0U);
#line 78 "../src/TimedQueue.vala"
	result = self->priv->dequeue_spacing_msec;
#line 78 "../src/TimedQueue.vala"
	return result;
#line 493 "TimedQueue.c"
}

void
hash_timed_queue_set_dequeue_spacing_msec (HashTimedQueue* self,
                                           guint msec)
{
#line 81 "../src/TimedQueue.vala"
	g_return_if_fail (IS_HASH_TIMED_QUEUE (self));
#line 82 "../src/TimedQueue.vala"
	if (msec == self->priv->dequeue_spacing_msec) {
#line 83 "../src/TimedQueue.vala"
		return;
#line 506 "TimedQueue.c"
	}
#line 85 "../src/TimedQueue.vala"
	if (self->priv->timer_id != ((guint) 0)) {
#line 86 "../src/TimedQueue.vala"
		g_source_remove (self->priv->timer_id);
#line 512 "TimedQueue.c"
	}
#line 88 "../src/TimedQueue.vala"
	self->priv->dequeue_spacing_msec = msec;
#line 90 "../src/TimedQueue.vala"
	self->priv->timer_id = g_timeout_add_full (self->priv->priority, hash_timed_queue_get_heartbeat_timeout (self), _hash_timed_queue_on_heartbeat_gsource_func, hash_timed_queue_ref (self), hash_timed_queue_unref);
#line 518 "TimedQueue.c"
}

static guint
hash_timed_queue_get_heartbeat_timeout (HashTimedQueue* self)
{
	guint _tmp0_ = 0U;
	guint result;
#line 93 "../src/TimedQueue.vala"
	g_return_val_if_fail (IS_HASH_TIMED_QUEUE (self), 0U);
#line 94 "../src/TimedQueue.vala"
	if (self->priv->dequeue_spacing_msec == ((guint) 0)) {
#line 95 "../src/TimedQueue.vala"
		_tmp0_ = self->priv->hold_msec / 10;
#line 532 "TimedQueue.c"
	} else {
#line 96 "../src/TimedQueue.vala"
		_tmp0_ = self->priv->dequeue_spacing_msec / 2;
#line 536 "TimedQueue.c"
	}
#line 94 "../src/TimedQueue.vala"
	result = CLAMP (_tmp0_, (guint) 10, G_MAXUINT);
#line 94 "../src/TimedQueue.vala"
	return result;
#line 542 "TimedQueue.c"
}

gboolean
hash_timed_queue_is_paused (HashTimedQueue* self)
{
	gboolean result;
#line 99 "../src/TimedQueue.vala"
	g_return_val_if_fail (IS_HASH_TIMED_QUEUE (self), FALSE);
#line 100 "../src/TimedQueue.vala"
	result = self->priv->paused_state;
#line 100 "../src/TimedQueue.vala"
	return result;
#line 555 "TimedQueue.c"
}

void
hash_timed_queue_pause (HashTimedQueue* self)
{
#line 103 "../src/TimedQueue.vala"
	g_return_if_fail (IS_HASH_TIMED_QUEUE (self));
#line 104 "../src/TimedQueue.vala"
	if (self->priv->paused_state) {
#line 105 "../src/TimedQueue.vala"
		return;
#line 567 "TimedQueue.c"
	}
#line 107 "../src/TimedQueue.vala"
	self->priv->paused_state = TRUE;
#line 109 "../src/TimedQueue.vala"
	g_signal_emit (self, hash_timed_queue_signals[HASH_TIMED_QUEUE_PAUSED_SIGNAL], 0, TRUE);
#line 573 "TimedQueue.c"
}

void
hash_timed_queue_unpause (HashTimedQueue* self)
{
#line 112 "../src/TimedQueue.vala"
	g_return_if_fail (IS_HASH_TIMED_QUEUE (self));
#line 113 "../src/TimedQueue.vala"
	if (!self->priv->paused_state) {
#line 114 "../src/TimedQueue.vala"
		return;
#line 585 "TimedQueue.c"
	}
#line 116 "../src/TimedQueue.vala"
	self->priv->paused_state = FALSE;
#line 118 "../src/TimedQueue.vala"
	g_signal_emit (self, hash_timed_queue_signals[HASH_TIMED_QUEUE_PAUSED_SIGNAL], 0, FALSE);
#line 591 "TimedQueue.c"
}

void
hash_timed_queue_clear (HashTimedQueue* self)
{
	GError* _inner_error0_ = NULL;
#line 121 "../src/TimedQueue.vala"
	g_return_if_fail (IS_HASH_TIMED_QUEUE (self));
#line 600 "TimedQueue.c"
	{
		SortedList* _tmp0_;
#line 122 "../src/TimedQueue.vala"
		_tmp0_ = self->priv->queue;
#line 122 "../src/TimedQueue.vala"
		g_rec_mutex_lock (&self->priv->__lock_queue);
#line 607 "TimedQueue.c"
		{
			GeeHashMap* _tmp1_;
			SortedList* _tmp2_;
#line 123 "../src/TimedQueue.vala"
			_tmp1_ = self->priv->item_count;
#line 123 "../src/TimedQueue.vala"
			gee_abstract_map_clear (G_TYPE_CHECK_INSTANCE_CAST (_tmp1_, GEE_TYPE_ABSTRACT_MAP, GeeAbstractMap));
#line 124 "../src/TimedQueue.vala"
			_tmp2_ = self->priv->queue;
#line 124 "../src/TimedQueue.vala"
			gee_collection_clear (G_TYPE_CHECK_INSTANCE_CAST (_tmp2_, GEE_TYPE_COLLECTION, GeeCollection));
#line 619 "TimedQueue.c"
		}
		__finally0:
		{
			SortedList* _tmp3_;
#line 122 "../src/TimedQueue.vala"
			_tmp3_ = self->priv->queue;
#line 122 "../src/TimedQueue.vala"
			g_rec_mutex_unlock (&self->priv->__lock_queue);
#line 628 "TimedQueue.c"
		}
#line 122 "../src/TimedQueue.vala"
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 122 "../src/TimedQueue.vala"
			g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 122 "../src/TimedQueue.vala"
			g_clear_error (&_inner_error0_);
#line 122 "../src/TimedQueue.vala"
			return;
#line 638 "TimedQueue.c"
		}
	}
}

gboolean
hash_timed_queue_contains (HashTimedQueue* self,
                           gconstpointer item)
{
	GError* _inner_error0_ = NULL;
	gboolean result;
#line 128 "../src/TimedQueue.vala"
	g_return_val_if_fail (IS_HASH_TIMED_QUEUE (self), FALSE);
#line 651 "TimedQueue.c"
	{
		SortedList* _tmp0_;
		gboolean _tmp4_ = FALSE;
#line 129 "../src/TimedQueue.vala"
		_tmp0_ = self->priv->queue;
#line 129 "../src/TimedQueue.vala"
		g_rec_mutex_lock (&self->priv->__lock_queue);
#line 659 "TimedQueue.c"
		{
			GeeHashMap* _tmp1_;
#line 130 "../src/TimedQueue.vala"
			_tmp1_ = self->priv->item_count;
#line 130 "../src/TimedQueue.vala"
			result = gee_abstract_map_has_key (G_TYPE_CHECK_INSTANCE_CAST (_tmp1_, GEE_TYPE_ABSTRACT_MAP, GeeAbstractMap), item);
#line 666 "TimedQueue.c"
			{
				SortedList* _tmp2_;
#line 129 "../src/TimedQueue.vala"
				_tmp2_ = self->priv->queue;
#line 129 "../src/TimedQueue.vala"
				g_rec_mutex_unlock (&self->priv->__lock_queue);
#line 673 "TimedQueue.c"
			}
#line 130 "../src/TimedQueue.vala"
			return result;
#line 677 "TimedQueue.c"
		}
		__finally0:
		{
			SortedList* _tmp3_;
#line 129 "../src/TimedQueue.vala"
			_tmp3_ = self->priv->queue;
#line 129 "../src/TimedQueue.vala"
			g_rec_mutex_unlock (&self->priv->__lock_queue);
#line 686 "TimedQueue.c"
		}
#line 129 "../src/TimedQueue.vala"
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 129 "../src/TimedQueue.vala"
		g_clear_error (&_inner_error0_);
#line 129 "../src/TimedQueue.vala"
		return _tmp4_;
#line 694 "TimedQueue.c"
	}
}

gboolean
hash_timed_queue_enqueue (HashTimedQueue* self,
                          gconstpointer item)
{
	GError* _inner_error0_ = NULL;
	gboolean result;
#line 134 "../src/TimedQueue.vala"
	g_return_val_if_fail (IS_HASH_TIMED_QUEUE (self), FALSE);
#line 706 "TimedQueue.c"
	{
		SortedList* _tmp0_;
		gboolean _tmp13_ = FALSE;
#line 135 "../src/TimedQueue.vala"
		_tmp0_ = self->priv->queue;
#line 135 "../src/TimedQueue.vala"
		g_rec_mutex_lock (&self->priv->__lock_queue);
#line 714 "TimedQueue.c"
		{
			SortedList* _tmp1_;
			HashTimedQueueElement* _tmp2_;
			HashTimedQueueElement* _tmp3_;
			gboolean _tmp4_;
			gint _tmp6_ = 0;
			GeeHashMap* _tmp7_;
			GeeHashMap* _tmp10_;
#line 136 "../src/TimedQueue.vala"
			_tmp1_ = self->priv->queue;
#line 136 "../src/TimedQueue.vala"
			_tmp2_ = hash_timed_queue_element_new (self->priv->g_type, (GBoxedCopyFunc) self->priv->g_dup_func, (GDestroyNotify) self->priv->g_destroy_func, item, hash_timed_queue_calc_ready_time (self));
#line 136 "../src/TimedQueue.vala"
			_tmp3_ = _tmp2_;
#line 136 "../src/TimedQueue.vala"
			_tmp4_ = !gee_collection_add (G_TYPE_CHECK_INSTANCE_CAST (_tmp1_, GEE_TYPE_COLLECTION, GeeCollection), _tmp3_);
#line 136 "../src/TimedQueue.vala"
			_hash_timed_queue_element_unref0 (_tmp3_);
#line 136 "../src/TimedQueue.vala"
			if (_tmp4_) {
#line 137 "../src/TimedQueue.vala"
				result = FALSE;
#line 737 "TimedQueue.c"
				{
					SortedList* _tmp5_;
#line 135 "../src/TimedQueue.vala"
					_tmp5_ = self->priv->queue;
#line 135 "../src/TimedQueue.vala"
					g_rec_mutex_unlock (&self->priv->__lock_queue);
#line 744 "TimedQueue.c"
				}
#line 137 "../src/TimedQueue.vala"
				return result;
#line 748 "TimedQueue.c"
			}
#line 139 "../src/TimedQueue.vala"
			_tmp7_ = self->priv->item_count;
#line 139 "../src/TimedQueue.vala"
			if (gee_abstract_map_has_key (G_TYPE_CHECK_INSTANCE_CAST (_tmp7_, GEE_TYPE_ABSTRACT_MAP, GeeAbstractMap), item)) {
#line 754 "TimedQueue.c"
				GeeHashMap* _tmp8_;
				gpointer _tmp9_;
#line 139 "../src/TimedQueue.vala"
				_tmp8_ = self->priv->item_count;
#line 139 "../src/TimedQueue.vala"
				_tmp9_ = gee_abstract_map_get (G_TYPE_CHECK_INSTANCE_CAST (_tmp8_, GEE_TYPE_ABSTRACT_MAP, GeeAbstractMap), item);
#line 139 "../src/TimedQueue.vala"
				_tmp6_ = ((gint) ((gintptr) _tmp9_)) + 1;
#line 763 "TimedQueue.c"
			} else {
#line 139 "../src/TimedQueue.vala"
				_tmp6_ = 1;
#line 767 "TimedQueue.c"
			}
#line 139 "../src/TimedQueue.vala"
			_tmp10_ = self->priv->item_count;
#line 139 "../src/TimedQueue.vala"
			gee_abstract_map_set (G_TYPE_CHECK_INSTANCE_CAST (_tmp10_, GEE_TYPE_ABSTRACT_MAP, GeeAbstractMap), item, (gpointer) ((gintptr) _tmp6_));
#line 141 "../src/TimedQueue.vala"
			result = TRUE;
#line 775 "TimedQueue.c"
			{
				SortedList* _tmp11_;
#line 135 "../src/TimedQueue.vala"
				_tmp11_ = self->priv->queue;
#line 135 "../src/TimedQueue.vala"
				g_rec_mutex_unlock (&self->priv->__lock_queue);
#line 782 "TimedQueue.c"
			}
#line 141 "../src/TimedQueue.vala"
			return result;
#line 786 "TimedQueue.c"
		}
		__finally0:
		{
			SortedList* _tmp12_;
#line 135 "../src/TimedQueue.vala"
			_tmp12_ = self->priv->queue;
#line 135 "../src/TimedQueue.vala"
			g_rec_mutex_unlock (&self->priv->__lock_queue);
#line 795 "TimedQueue.c"
		}
#line 135 "../src/TimedQueue.vala"
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 135 "../src/TimedQueue.vala"
		g_clear_error (&_inner_error0_);
#line 135 "../src/TimedQueue.vala"
		return _tmp13_;
#line 803 "TimedQueue.c"
	}
}

gboolean
hash_timed_queue_enqueue_many (HashTimedQueue* self,
                               GeeCollection* items)
{
	gulong ready_time = 0UL;
	GeeArrayList* elements = NULL;
	GeeArrayList* _tmp0_;
	GError* _inner_error0_ = NULL;
	gboolean result;
#line 145 "../src/TimedQueue.vala"
	g_return_val_if_fail (IS_HASH_TIMED_QUEUE (self), FALSE);
#line 145 "../src/TimedQueue.vala"
	g_return_val_if_fail (G_TYPE_CHECK_INSTANCE_TYPE (items, GEE_TYPE_COLLECTION), FALSE);
#line 146 "../src/TimedQueue.vala"
	ready_time = hash_timed_queue_calc_ready_time (self);
#line 148 "../src/TimedQueue.vala"
	_tmp0_ = gee_array_list_new (HASH_TIMED_QUEUE_TYPE_ELEMENT, (GBoxedCopyFunc) hash_timed_queue_element_ref, (GDestroyNotify) hash_timed_queue_element_unref, NULL, NULL, NULL);
#line 148 "../src/TimedQueue.vala"
	elements = _tmp0_;
#line 826 "TimedQueue.c"
	{
		GeeIterator* _item_it = NULL;
		GeeIterator* _tmp1_;
#line 149 "../src/TimedQueue.vala"
		_tmp1_ = gee_iterable_iterator (G_TYPE_CHECK_INSTANCE_CAST (items, GEE_TYPE_ITERABLE, GeeIterable));
#line 149 "../src/TimedQueue.vala"
		_item_it = _tmp1_;
#line 149 "../src/TimedQueue.vala"
		while (TRUE) {
#line 836 "TimedQueue.c"
			GeeIterator* _tmp2_;
			gpointer item = NULL;
			GeeIterator* _tmp3_;
			gpointer _tmp4_;
			GeeArrayList* _tmp5_;
			gconstpointer _tmp6_;
			HashTimedQueueElement* _tmp7_;
			HashTimedQueueElement* _tmp8_;
#line 149 "../src/TimedQueue.vala"
			_tmp2_ = _item_it;
#line 149 "../src/TimedQueue.vala"
			if (!gee_iterator_next (_tmp2_)) {
#line 149 "../src/TimedQueue.vala"
				break;
#line 851 "TimedQueue.c"
			}
#line 149 "../src/TimedQueue.vala"
			_tmp3_ = _item_it;
#line 149 "../src/TimedQueue.vala"
			_tmp4_ = gee_iterator_get (_tmp3_);
#line 149 "../src/TimedQueue.vala"
			item = _tmp4_;
#line 150 "../src/TimedQueue.vala"
			_tmp5_ = elements;
#line 150 "../src/TimedQueue.vala"
			_tmp6_ = item;
#line 150 "../src/TimedQueue.vala"
			_tmp7_ = hash_timed_queue_element_new (self->priv->g_type, (GBoxedCopyFunc) self->priv->g_dup_func, (GDestroyNotify) self->priv->g_destroy_func, _tmp6_, ready_time);
#line 150 "../src/TimedQueue.vala"
			_tmp8_ = _tmp7_;
#line 150 "../src/TimedQueue.vala"
			gee_abstract_collection_add (G_TYPE_CHECK_INSTANCE_CAST (_tmp5_, GEE_TYPE_ABSTRACT_COLLECTION, GeeAbstractCollection), _tmp8_);
#line 150 "../src/TimedQueue.vala"
			_hash_timed_queue_element_unref0 (_tmp8_);
#line 149 "../src/TimedQueue.vala"
			((item == NULL) || (self->priv->g_destroy_func == NULL)) ? NULL : (item = (self->priv->g_destroy_func (item), NULL));
#line 873 "TimedQueue.c"
		}
#line 149 "../src/TimedQueue.vala"
		_g_object_unref0 (_item_it);
#line 877 "TimedQueue.c"
	}
	{
		SortedList* _tmp9_;
#line 152 "../src/TimedQueue.vala"
		_tmp9_ = self->priv->queue;
#line 152 "../src/TimedQueue.vala"
		g_rec_mutex_lock (&self->priv->__lock_queue);
#line 885 "TimedQueue.c"
		{
			SortedList* _tmp10_;
			GeeArrayList* _tmp11_;
#line 153 "../src/TimedQueue.vala"
			_tmp10_ = self->priv->queue;
#line 153 "../src/TimedQueue.vala"
			_tmp11_ = elements;
#line 153 "../src/TimedQueue.vala"
			if (!sorted_list_add_list (_tmp10_, G_TYPE_CHECK_INSTANCE_CAST (_tmp11_, GEE_TYPE_LIST, GeeList))) {
#line 154 "../src/TimedQueue.vala"
				result = FALSE;
#line 897 "TimedQueue.c"
				{
					SortedList* _tmp12_;
#line 152 "../src/TimedQueue.vala"
					_tmp12_ = self->priv->queue;
#line 152 "../src/TimedQueue.vala"
					g_rec_mutex_unlock (&self->priv->__lock_queue);
#line 904 "TimedQueue.c"
				}
#line 154 "../src/TimedQueue.vala"
				_g_object_unref0 (elements);
#line 154 "../src/TimedQueue.vala"
				return result;
#line 910 "TimedQueue.c"
			}
			{
				GeeIterator* _item_it = NULL;
				GeeIterator* _tmp13_;
#line 157 "../src/TimedQueue.vala"
				_tmp13_ = gee_iterable_iterator (G_TYPE_CHECK_INSTANCE_CAST (items, GEE_TYPE_ITERABLE, GeeIterable));
#line 157 "../src/TimedQueue.vala"
				_item_it = _tmp13_;
#line 157 "../src/TimedQueue.vala"
				while (TRUE) {
#line 921 "TimedQueue.c"
					GeeIterator* _tmp14_;
					gpointer item = NULL;
					GeeIterator* _tmp15_;
					gpointer _tmp16_;
					gint _tmp17_ = 0;
					GeeHashMap* _tmp18_;
					gconstpointer _tmp19_;
					GeeHashMap* _tmp23_;
					gconstpointer _tmp24_;
#line 157 "../src/TimedQueue.vala"
					_tmp14_ = _item_it;
#line 157 "../src/TimedQueue.vala"
					if (!gee_iterator_next (_tmp14_)) {
#line 157 "../src/TimedQueue.vala"
						break;
#line 937 "TimedQueue.c"
					}
#line 157 "../src/TimedQueue.vala"
					_tmp15_ = _item_it;
#line 157 "../src/TimedQueue.vala"
					_tmp16_ = gee_iterator_get (_tmp15_);
#line 157 "../src/TimedQueue.vala"
					item = _tmp16_;
#line 158 "../src/TimedQueue.vala"
					_tmp18_ = self->priv->item_count;
#line 158 "../src/TimedQueue.vala"
					_tmp19_ = item;
#line 158 "../src/TimedQueue.vala"
					if (gee_abstract_map_has_key (G_TYPE_CHECK_INSTANCE_CAST (_tmp18_, GEE_TYPE_ABSTRACT_MAP, GeeAbstractMap), _tmp19_)) {
#line 951 "TimedQueue.c"
						GeeHashMap* _tmp20_;
						gconstpointer _tmp21_;
						gpointer _tmp22_;
#line 158 "../src/TimedQueue.vala"
						_tmp20_ = self->priv->item_count;
#line 158 "../src/TimedQueue.vala"
						_tmp21_ = item;
#line 158 "../src/TimedQueue.vala"
						_tmp22_ = gee_abstract_map_get (G_TYPE_CHECK_INSTANCE_CAST (_tmp20_, GEE_TYPE_ABSTRACT_MAP, GeeAbstractMap), _tmp21_);
#line 158 "../src/TimedQueue.vala"
						_tmp17_ = ((gint) ((gintptr) _tmp22_)) + 1;
#line 963 "TimedQueue.c"
					} else {
#line 158 "../src/TimedQueue.vala"
						_tmp17_ = 1;
#line 967 "TimedQueue.c"
					}
#line 158 "../src/TimedQueue.vala"
					_tmp23_ = self->priv->item_count;
#line 158 "../src/TimedQueue.vala"
					_tmp24_ = item;
#line 158 "../src/TimedQueue.vala"
					gee_abstract_map_set (G_TYPE_CHECK_INSTANCE_CAST (_tmp23_, GEE_TYPE_ABSTRACT_MAP, GeeAbstractMap), _tmp24_, (gpointer) ((gintptr) _tmp17_));
#line 157 "../src/TimedQueue.vala"
					((item == NULL) || (self->priv->g_destroy_func == NULL)) ? NULL : (item = (self->priv->g_destroy_func (item), NULL));
#line 977 "TimedQueue.c"
				}
#line 157 "../src/TimedQueue.vala"
				_g_object_unref0 (_item_it);
#line 981 "TimedQueue.c"
			}
		}
		__finally0:
		{
			SortedList* _tmp25_;
#line 152 "../src/TimedQueue.vala"
			_tmp25_ = self->priv->queue;
#line 152 "../src/TimedQueue.vala"
			g_rec_mutex_unlock (&self->priv->__lock_queue);
#line 991 "TimedQueue.c"
		}
#line 152 "../src/TimedQueue.vala"
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 995 "TimedQueue.c"
			gboolean _tmp26_ = FALSE;
#line 152 "../src/TimedQueue.vala"
			_g_object_unref0 (elements);
#line 152 "../src/TimedQueue.vala"
			g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 152 "../src/TimedQueue.vala"
			g_clear_error (&_inner_error0_);
#line 152 "../src/TimedQueue.vala"
			return _tmp26_;
#line 1005 "TimedQueue.c"
		}
	}
#line 162 "../src/TimedQueue.vala"
	result = TRUE;
#line 162 "../src/TimedQueue.vala"
	_g_object_unref0 (elements);
#line 162 "../src/TimedQueue.vala"
	return result;
#line 1014 "TimedQueue.c"
}

gboolean
hash_timed_queue_remove_first (HashTimedQueue* self,
                               gconstpointer item)
{
	GError* _inner_error0_ = NULL;
	gboolean result;
#line 166 "../src/TimedQueue.vala"
	g_return_val_if_fail (IS_HASH_TIMED_QUEUE (self), FALSE);
#line 1025 "TimedQueue.c"
	{
		SortedList* _tmp0_;
#line 167 "../src/TimedQueue.vala"
		_tmp0_ = self->priv->queue;
#line 167 "../src/TimedQueue.vala"
		g_rec_mutex_lock (&self->priv->__lock_queue);
#line 1032 "TimedQueue.c"
		{
			gboolean item_removed = FALSE;
			GeeIterator* iter = NULL;
			SortedList* _tmp1_;
			GeeIterator* _tmp2_;
#line 168 "../src/TimedQueue.vala"
			item_removed = FALSE;
#line 169 "../src/TimedQueue.vala"
			_tmp1_ = self->priv->queue;
#line 169 "../src/TimedQueue.vala"
			_tmp2_ = gee_iterable_iterator (G_TYPE_CHECK_INSTANCE_CAST (_tmp1_, GEE_TYPE_ITERABLE, GeeIterable));
#line 169 "../src/TimedQueue.vala"
			iter = _tmp2_;
#line 170 "../src/TimedQueue.vala"
			while (TRUE) {
#line 1048 "TimedQueue.c"
				GeeIterator* _tmp3_;
				HashTimedQueueElement* e = NULL;
				GeeIterator* _tmp4_;
				gpointer _tmp5_;
				GeeEqualDataFunc _tmp6_;
				gpointer _tmp6__target;
				HashTimedQueueElement* _tmp7_;
				gconstpointer _tmp8_;
#line 170 "../src/TimedQueue.vala"
				_tmp3_ = iter;
#line 170 "../src/TimedQueue.vala"
				if (!gee_iterator_next (_tmp3_)) {
#line 170 "../src/TimedQueue.vala"
					break;
#line 1063 "TimedQueue.c"
				}
#line 171 "../src/TimedQueue.vala"
				_tmp4_ = iter;
#line 171 "../src/TimedQueue.vala"
				_tmp5_ = gee_iterator_get (_tmp4_);
#line 171 "../src/TimedQueue.vala"
				e = (HashTimedQueueElement*) _tmp5_;
#line 172 "../src/TimedQueue.vala"
				_tmp6_ = self->priv->equal_func;
#line 172 "../src/TimedQueue.vala"
				_tmp6__target = self->priv->equal_func_target;
#line 172 "../src/TimedQueue.vala"
				_tmp7_ = e;
#line 172 "../src/TimedQueue.vala"
				_tmp8_ = _tmp7_->item;
#line 172 "../src/TimedQueue.vala"
				if (_tmp6_ (item, _tmp8_, _tmp6__target)) {
#line 1081 "TimedQueue.c"
					GeeIterator* _tmp9_;
#line 173 "../src/TimedQueue.vala"
					_tmp9_ = iter;
#line 173 "../src/TimedQueue.vala"
					gee_iterator_remove (_tmp9_);
#line 175 "../src/TimedQueue.vala"
					item_removed = TRUE;
#line 176 "../src/TimedQueue.vala"
					_hash_timed_queue_element_unref0 (e);
#line 176 "../src/TimedQueue.vala"
					break;
#line 1093 "TimedQueue.c"
				}
#line 170 "../src/TimedQueue.vala"
				_hash_timed_queue_element_unref0 (e);
#line 1097 "TimedQueue.c"
			}
#line 180 "../src/TimedQueue.vala"
			if (!item_removed) {
#line 181 "../src/TimedQueue.vala"
				result = FALSE;
#line 181 "../src/TimedQueue.vala"
				_g_object_unref0 (iter);
#line 1105 "TimedQueue.c"
				{
					SortedList* _tmp10_;
#line 167 "../src/TimedQueue.vala"
					_tmp10_ = self->priv->queue;
#line 167 "../src/TimedQueue.vala"
					g_rec_mutex_unlock (&self->priv->__lock_queue);
#line 1112 "TimedQueue.c"
				}
#line 181 "../src/TimedQueue.vala"
				return result;
#line 1116 "TimedQueue.c"
			}
#line 184 "../src/TimedQueue.vala"
			hash_timed_queue_removed (self, item);
#line 167 "../src/TimedQueue.vala"
			_g_object_unref0 (iter);
#line 1122 "TimedQueue.c"
		}
		__finally0:
		{
			SortedList* _tmp11_;
#line 167 "../src/TimedQueue.vala"
			_tmp11_ = self->priv->queue;
#line 167 "../src/TimedQueue.vala"
			g_rec_mutex_unlock (&self->priv->__lock_queue);
#line 1131 "TimedQueue.c"
		}
#line 167 "../src/TimedQueue.vala"
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 1135 "TimedQueue.c"
			gboolean _tmp12_ = FALSE;
#line 167 "../src/TimedQueue.vala"
			g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 167 "../src/TimedQueue.vala"
			g_clear_error (&_inner_error0_);
#line 167 "../src/TimedQueue.vala"
			return _tmp12_;
#line 1143 "TimedQueue.c"
		}
	}
#line 187 "../src/TimedQueue.vala"
	result = TRUE;
#line 187 "../src/TimedQueue.vala"
	return result;
#line 1150 "TimedQueue.c"
}

static gulong
hash_timed_queue_calc_ready_time (HashTimedQueue* self)
{
	gulong result;
#line 198 "../src/TimedQueue.vala"
	g_return_val_if_fail (IS_HASH_TIMED_QUEUE (self), 0UL);
#line 199 "../src/TimedQueue.vala"
	result = now_ms () + ((gulong) self->priv->hold_msec);
#line 199 "../src/TimedQueue.vala"
	return result;
#line 1163 "TimedQueue.c"
}

static gboolean
hash_timed_queue_on_heartbeat (HashTimedQueue* self)
{
	gulong now = 0UL;
	GError* _inner_error0_ = NULL;
	gboolean result;
#line 202 "../src/TimedQueue.vala"
	g_return_val_if_fail (IS_HASH_TIMED_QUEUE (self), FALSE);
#line 203 "../src/TimedQueue.vala"
	if (self->priv->paused_state) {
#line 204 "../src/TimedQueue.vala"
		result = TRUE;
#line 204 "../src/TimedQueue.vala"
		return result;
#line 1180 "TimedQueue.c"
	}
#line 206 "../src/TimedQueue.vala"
	now = (gulong) 0;
#line 1184 "TimedQueue.c"
	{
		gboolean _tmp0_ = FALSE;
#line 208 "../src/TimedQueue.vala"
		_tmp0_ = TRUE;
#line 208 "../src/TimedQueue.vala"
		while (TRUE) {
#line 1191 "TimedQueue.c"
			SortedList* _tmp1_;
			gint _tmp2_;
			gint _tmp3_;
			gpointer item = NULL;
			DequeuedCallback _tmp23_;
			gpointer _tmp23__target;
			gconstpointer _tmp24_;
#line 208 "../src/TimedQueue.vala"
			if (!_tmp0_) {
#line 1201 "TimedQueue.c"
			}
#line 208 "../src/TimedQueue.vala"
			_tmp0_ = FALSE;
#line 209 "../src/TimedQueue.vala"
			_tmp1_ = self->priv->queue;
#line 209 "../src/TimedQueue.vala"
			_tmp2_ = gee_collection_get_size (G_TYPE_CHECK_INSTANCE_CAST (_tmp1_, GEE_TYPE_COLLECTION, GeeCollection));
#line 209 "../src/TimedQueue.vala"
			_tmp3_ = _tmp2_;
#line 209 "../src/TimedQueue.vala"
			if (_tmp3_ == 0) {
#line 210 "../src/TimedQueue.vala"
				break;
#line 1215 "TimedQueue.c"
			}
#line 212 "../src/TimedQueue.vala"
			item = NULL;
#line 1219 "TimedQueue.c"
			{
				SortedList* _tmp4_;
#line 213 "../src/TimedQueue.vala"
				_tmp4_ = self->priv->queue;
#line 213 "../src/TimedQueue.vala"
				g_rec_mutex_lock (&self->priv->__lock_queue);
#line 1226 "TimedQueue.c"
				{
					HashTimedQueueElement* head = NULL;
					SortedList* _tmp5_;
					gpointer _tmp6_;
					HashTimedQueueElement* _tmp7_;
					HashTimedQueueElement* _tmp8_;
					gboolean _tmp10_ = FALSE;
					HashTimedQueueElement* h = NULL;
					SortedList* _tmp12_;
					gpointer _tmp13_;
					HashTimedQueueElement* _tmp14_;
					HashTimedQueueElement* _tmp15_;
					HashTimedQueueElement* _tmp16_;
					gconstpointer _tmp17_;
					HashTimedQueueElement* _tmp18_;
					gconstpointer _tmp19_;
					gpointer _tmp20_;
#line 214 "../src/TimedQueue.vala"
					_tmp5_ = self->priv->queue;
#line 214 "../src/TimedQueue.vala"
					_tmp6_ = sorted_list_get_at (_tmp5_, 0);
#line 214 "../src/TimedQueue.vala"
					head = (HashTimedQueueElement*) _tmp6_;
#line 215 "../src/TimedQueue.vala"
					_tmp7_ = head;
#line 215 "../src/TimedQueue.vala"
					_vala_assert (_tmp7_ != NULL, "head != null");
#line 217 "../src/TimedQueue.vala"
					if (now == ((gulong) 0)) {
#line 218 "../src/TimedQueue.vala"
						now = now_ms ();
#line 1258 "TimedQueue.c"
					}
#line 220 "../src/TimedQueue.vala"
					_tmp8_ = head;
#line 220 "../src/TimedQueue.vala"
					if (_tmp8_->ready > now) {
#line 221 "../src/TimedQueue.vala"
						_hash_timed_queue_element_unref0 (head);
#line 1266 "TimedQueue.c"
						{
							SortedList* _tmp9_;
#line 213 "../src/TimedQueue.vala"
							_tmp9_ = self->priv->queue;
#line 213 "../src/TimedQueue.vala"
							g_rec_mutex_unlock (&self->priv->__lock_queue);
#line 1273 "TimedQueue.c"
						}
#line 221 "../src/TimedQueue.vala"
						((item == NULL) || (self->priv->g_destroy_func == NULL)) ? NULL : (item = (self->priv->g_destroy_func (item), NULL));
#line 221 "../src/TimedQueue.vala"
						break;
#line 1279 "TimedQueue.c"
					}
#line 224 "../src/TimedQueue.vala"
					if (self->priv->dequeue_spacing_msec != ((guint) 0)) {
#line 224 "../src/TimedQueue.vala"
						_tmp10_ = (now - self->priv->last_dequeue) < ((gulong) self->priv->dequeue_spacing_msec);
#line 1285 "TimedQueue.c"
					} else {
#line 224 "../src/TimedQueue.vala"
						_tmp10_ = FALSE;
#line 1289 "TimedQueue.c"
					}
#line 224 "../src/TimedQueue.vala"
					if (_tmp10_) {
#line 225 "../src/TimedQueue.vala"
						_hash_timed_queue_element_unref0 (head);
#line 1295 "TimedQueue.c"
						{
							SortedList* _tmp11_;
#line 213 "../src/TimedQueue.vala"
							_tmp11_ = self->priv->queue;
#line 213 "../src/TimedQueue.vala"
							g_rec_mutex_unlock (&self->priv->__lock_queue);
#line 1302 "TimedQueue.c"
						}
#line 225 "../src/TimedQueue.vala"
						((item == NULL) || (self->priv->g_destroy_func == NULL)) ? NULL : (item = (self->priv->g_destroy_func (item), NULL));
#line 225 "../src/TimedQueue.vala"
						break;
#line 1308 "TimedQueue.c"
					}
#line 227 "../src/TimedQueue.vala"
					_tmp12_ = self->priv->queue;
#line 227 "../src/TimedQueue.vala"
					_tmp13_ = sorted_list_remove_at (_tmp12_, 0);
#line 227 "../src/TimedQueue.vala"
					h = (HashTimedQueueElement*) _tmp13_;
#line 228 "../src/TimedQueue.vala"
					_tmp14_ = head;
#line 228 "../src/TimedQueue.vala"
					_tmp15_ = h;
#line 228 "../src/TimedQueue.vala"
					_vala_assert (_tmp14_ == _tmp15_, "head == h");
#line 230 "../src/TimedQueue.vala"
					_tmp16_ = head;
#line 230 "../src/TimedQueue.vala"
					_tmp17_ = _tmp16_->item;
#line 230 "../src/TimedQueue.vala"
					hash_timed_queue_removed (self, _tmp17_);
#line 231 "../src/TimedQueue.vala"
					_tmp18_ = head;
#line 231 "../src/TimedQueue.vala"
					_tmp19_ = _tmp18_->item;
#line 231 "../src/TimedQueue.vala"
					_tmp20_ = ((_tmp19_ != NULL) && (self->priv->g_dup_func != NULL)) ? self->priv->g_dup_func ((gpointer) _tmp19_) : ((gpointer) _tmp19_);
#line 231 "../src/TimedQueue.vala"
					((item == NULL) || (self->priv->g_destroy_func == NULL)) ? NULL : (item = (self->priv->g_destroy_func (item), NULL));
#line 231 "../src/TimedQueue.vala"
					item = _tmp20_;
#line 213 "../src/TimedQueue.vala"
					_hash_timed_queue_element_unref0 (h);
#line 213 "../src/TimedQueue.vala"
					_hash_timed_queue_element_unref0 (head);
#line 1342 "TimedQueue.c"
				}
				__finally0:
				{
					SortedList* _tmp21_;
#line 213 "../src/TimedQueue.vala"
					_tmp21_ = self->priv->queue;
#line 213 "../src/TimedQueue.vala"
					g_rec_mutex_unlock (&self->priv->__lock_queue);
#line 1351 "TimedQueue.c"
				}
#line 213 "../src/TimedQueue.vala"
				if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 1355 "TimedQueue.c"
					gboolean _tmp22_ = FALSE;
#line 213 "../src/TimedQueue.vala"
					((item == NULL) || (self->priv->g_destroy_func == NULL)) ? NULL : (item = (self->priv->g_destroy_func (item), NULL));
#line 213 "../src/TimedQueue.vala"
					g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 213 "../src/TimedQueue.vala"
					g_clear_error (&_inner_error0_);
#line 213 "../src/TimedQueue.vala"
					return _tmp22_;
#line 1365 "TimedQueue.c"
				}
			}
#line 233 "../src/TimedQueue.vala"
			_tmp23_ = self->priv->callback;
#line 233 "../src/TimedQueue.vala"
			_tmp23__target = self->priv->callback_target;
#line 233 "../src/TimedQueue.vala"
			_tmp24_ = item;
#line 233 "../src/TimedQueue.vala"
			_tmp23_ (_tmp24_, _tmp23__target);
#line 234 "../src/TimedQueue.vala"
			self->priv->last_dequeue = now;
#line 238 "../src/TimedQueue.vala"
			if (self->priv->dequeue_spacing_msec != ((guint) 0)) {
#line 239 "../src/TimedQueue.vala"
				((item == NULL) || (self->priv->g_destroy_func == NULL)) ? NULL : (item = (self->priv->g_destroy_func (item), NULL));
#line 239 "../src/TimedQueue.vala"
				break;
#line 1384 "TimedQueue.c"
			}
#line 208 "../src/TimedQueue.vala"
			((item == NULL) || (self->priv->g_destroy_func == NULL)) ? NULL : (item = (self->priv->g_destroy_func (item), NULL));
#line 1388 "TimedQueue.c"
		}
	}
#line 242 "../src/TimedQueue.vala"
	result = TRUE;
#line 242 "../src/TimedQueue.vala"
	return result;
#line 1395 "TimedQueue.c"
}

static void
hash_timed_queue_removed (HashTimedQueue* self,
                          gconstpointer item)
{
	GeeHashMap* _tmp0_;
	gint count = 0;
	GeeHashMap* _tmp1_;
	gpointer _tmp2_;
	gint _tmp3_;
#line 246 "../src/TimedQueue.vala"
	g_return_if_fail (IS_HASH_TIMED_QUEUE (self));
#line 249 "../src/TimedQueue.vala"
	_tmp0_ = self->priv->item_count;
#line 249 "../src/TimedQueue.vala"
	if (!gee_abstract_map_has_key (G_TYPE_CHECK_INSTANCE_CAST (_tmp0_, GEE_TYPE_ABSTRACT_MAP, GeeAbstractMap), item)) {
#line 250 "../src/TimedQueue.vala"
		return;
#line 1415 "TimedQueue.c"
	}
#line 252 "../src/TimedQueue.vala"
	_tmp1_ = self->priv->item_count;
#line 252 "../src/TimedQueue.vala"
	_tmp2_ = gee_abstract_map_get (G_TYPE_CHECK_INSTANCE_CAST (_tmp1_, GEE_TYPE_ABSTRACT_MAP, GeeAbstractMap), item);
#line 252 "../src/TimedQueue.vala"
	count = (gint) ((gintptr) _tmp2_);
#line 253 "../src/TimedQueue.vala"
	_vala_assert (count > 0, "count > 0");
#line 255 "../src/TimedQueue.vala"
	count = count - 1;
#line 255 "../src/TimedQueue.vala"
	_tmp3_ = count;
#line 255 "../src/TimedQueue.vala"
	if (_tmp3_ == 0) {
#line 1431 "TimedQueue.c"
		GeeHashMap* _tmp4_;
#line 256 "../src/TimedQueue.vala"
		_tmp4_ = self->priv->item_count;
#line 256 "../src/TimedQueue.vala"
		gee_abstract_map_unset (G_TYPE_CHECK_INSTANCE_CAST (_tmp4_, GEE_TYPE_ABSTRACT_MAP, GeeAbstractMap), item, NULL);
#line 1437 "TimedQueue.c"
	} else {
		GeeHashMap* _tmp5_;
#line 258 "../src/TimedQueue.vala"
		_tmp5_ = self->priv->item_count;
#line 258 "../src/TimedQueue.vala"
		gee_abstract_map_set (G_TYPE_CHECK_INSTANCE_CAST (_tmp5_, GEE_TYPE_ABSTRACT_MAP, GeeAbstractMap), item, (gpointer) ((gintptr) count));
#line 1444 "TimedQueue.c"
	}
}

gint
hash_timed_queue_get_size (HashTimedQueue* self)
{
	gint result;
	GError* _inner_error0_ = NULL;
#line 191 "../src/TimedQueue.vala"
	g_return_val_if_fail (IS_HASH_TIMED_QUEUE (self), 0);
#line 1455 "TimedQueue.c"
	{
		SortedList* _tmp0_;
		gint _tmp6_ = -1;
#line 192 "../src/TimedQueue.vala"
		_tmp0_ = self->priv->queue;
#line 192 "../src/TimedQueue.vala"
		g_rec_mutex_lock (&self->priv->__lock_queue);
#line 1463 "TimedQueue.c"
		{
			SortedList* _tmp1_;
			gint _tmp2_;
			gint _tmp3_;
#line 193 "../src/TimedQueue.vala"
			_tmp1_ = self->priv->queue;
#line 193 "../src/TimedQueue.vala"
			_tmp2_ = gee_collection_get_size (G_TYPE_CHECK_INSTANCE_CAST (_tmp1_, GEE_TYPE_COLLECTION, GeeCollection));
#line 193 "../src/TimedQueue.vala"
			_tmp3_ = _tmp2_;
#line 193 "../src/TimedQueue.vala"
			result = _tmp3_;
#line 1476 "TimedQueue.c"
			{
				SortedList* _tmp4_;
#line 192 "../src/TimedQueue.vala"
				_tmp4_ = self->priv->queue;
#line 192 "../src/TimedQueue.vala"
				g_rec_mutex_unlock (&self->priv->__lock_queue);
#line 1483 "TimedQueue.c"
			}
#line 193 "../src/TimedQueue.vala"
			return result;
#line 1487 "TimedQueue.c"
		}
		__finally0:
		{
			SortedList* _tmp5_;
#line 192 "../src/TimedQueue.vala"
			_tmp5_ = self->priv->queue;
#line 192 "../src/TimedQueue.vala"
			g_rec_mutex_unlock (&self->priv->__lock_queue);
#line 1496 "TimedQueue.c"
		}
#line 192 "../src/TimedQueue.vala"
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 192 "../src/TimedQueue.vala"
		g_clear_error (&_inner_error0_);
#line 192 "../src/TimedQueue.vala"
		return _tmp6_;
#line 1504 "TimedQueue.c"
	}
}

static void
hash_timed_queue_real_paused (HashTimedQueue* self,
                              gboolean is_paused)
{
}

static inline gpointer
hash_timed_queue_element_get_instance_private (HashTimedQueueElement* self)
{
	return G_STRUCT_MEMBER_P (self, HashTimedQueueElement_private_offset);
}

static HashTimedQueueElement*
hash_timed_queue_element_construct (GType object_type,
                                    GType g_type,
                                    GBoxedCopyFunc g_dup_func,
                                    GDestroyNotify g_destroy_func,
                                    gconstpointer item,
                                    gulong ready)
{
	HashTimedQueueElement* self = NULL;
	gpointer _tmp0_;
#line 26 "../src/TimedQueue.vala"
	self = (HashTimedQueueElement*) g_type_create_instance (object_type);
#line 26 "../src/TimedQueue.vala"
	self->priv->g_type = g_type;
#line 26 "../src/TimedQueue.vala"
	self->priv->g_dup_func = g_dup_func;
#line 26 "../src/TimedQueue.vala"
	self->priv->g_destroy_func = g_destroy_func;
#line 27 "../src/TimedQueue.vala"
	_tmp0_ = ((item != NULL) && (g_dup_func != NULL)) ? g_dup_func ((gpointer) item) : ((gpointer) item);
#line 27 "../src/TimedQueue.vala"
	((self->item == NULL) || (g_destroy_func == NULL)) ? NULL : (self->item = (g_destroy_func (self->item), NULL));
#line 27 "../src/TimedQueue.vala"
	self->item = _tmp0_;
#line 28 "../src/TimedQueue.vala"
	self->ready = ready;
#line 26 "../src/TimedQueue.vala"
	return self;
#line 1548 "TimedQueue.c"
}

static HashTimedQueueElement*
hash_timed_queue_element_new (GType g_type,
                              GBoxedCopyFunc g_dup_func,
                              GDestroyNotify g_destroy_func,
                              gconstpointer item,
                              gulong ready)
{
#line 26 "../src/TimedQueue.vala"
	return hash_timed_queue_element_construct (HASH_TIMED_QUEUE_TYPE_ELEMENT, g_type, g_dup_func, g_destroy_func, item, ready);
#line 1560 "TimedQueue.c"
}

static gint64
hash_timed_queue_element_comparator (void* a,
                                     void* b)
{
	gint64 result;
#line 32 "../src/TimedQueue.vala"
	result = ((gint64) G_TYPE_CHECK_INSTANCE_CAST ((HashTimedQueueElement*) a, HASH_TIMED_QUEUE_TYPE_ELEMENT, HashTimedQueueElement)->ready) - ((gint64) G_TYPE_CHECK_INSTANCE_CAST ((HashTimedQueueElement*) b, HASH_TIMED_QUEUE_TYPE_ELEMENT, HashTimedQueueElement)->ready);
#line 32 "../src/TimedQueue.vala"
	return result;
#line 1572 "TimedQueue.c"
}

static void
hash_timed_queue_value_element_init (GValue* value)
{
#line 22 "../src/TimedQueue.vala"
	value->data[0].v_pointer = NULL;
#line 1580 "TimedQueue.c"
}

static void
hash_timed_queue_value_element_free_value (GValue* value)
{
#line 22 "../src/TimedQueue.vala"
	if (value->data[0].v_pointer) {
#line 22 "../src/TimedQueue.vala"
		hash_timed_queue_element_unref (value->data[0].v_pointer);
#line 1590 "TimedQueue.c"
	}
}

static void
hash_timed_queue_value_element_copy_value (const GValue* src_value,
                                           GValue* dest_value)
{
#line 22 "../src/TimedQueue.vala"
	if (src_value->data[0].v_pointer) {
#line 22 "../src/TimedQueue.vala"
		dest_value->data[0].v_pointer = hash_timed_queue_element_ref (src_value->data[0].v_pointer);
#line 1602 "TimedQueue.c"
	} else {
#line 22 "../src/TimedQueue.vala"
		dest_value->data[0].v_pointer = NULL;
#line 1606 "TimedQueue.c"
	}
}

static gpointer
hash_timed_queue_value_element_peek_pointer (const GValue* value)
{
#line 22 "../src/TimedQueue.vala"
	return value->data[0].v_pointer;
#line 1615 "TimedQueue.c"
}

static gchar*
hash_timed_queue_value_element_collect_value (GValue* value,
                                              guint n_collect_values,
                                              GTypeCValue* collect_values,
                                              guint collect_flags)
{
#line 22 "../src/TimedQueue.vala"
	if (collect_values[0].v_pointer) {
#line 1626 "TimedQueue.c"
		HashTimedQueueElement * object;
		object = collect_values[0].v_pointer;
#line 22 "../src/TimedQueue.vala"
		if (object->parent_instance.g_class == NULL) {
#line 22 "../src/TimedQueue.vala"
			return g_strconcat ("invalid unclassed object pointer for value type `", G_VALUE_TYPE_NAME (value), "'", NULL);
#line 1633 "TimedQueue.c"
		} else if (!g_value_type_compatible (G_TYPE_FROM_INSTANCE (object), G_VALUE_TYPE (value))) {
#line 22 "../src/TimedQueue.vala"
			return g_strconcat ("invalid object type `", g_type_name (G_TYPE_FROM_INSTANCE (object)), "' for value type `", G_VALUE_TYPE_NAME (value), "'", NULL);
#line 1637 "TimedQueue.c"
		}
#line 22 "../src/TimedQueue.vala"
		value->data[0].v_pointer = hash_timed_queue_element_ref (object);
#line 1641 "TimedQueue.c"
	} else {
#line 22 "../src/TimedQueue.vala"
		value->data[0].v_pointer = NULL;
#line 1645 "TimedQueue.c"
	}
#line 22 "../src/TimedQueue.vala"
	return NULL;
#line 1649 "TimedQueue.c"
}

static gchar*
hash_timed_queue_value_element_lcopy_value (const GValue* value,
                                            guint n_collect_values,
                                            GTypeCValue* collect_values,
                                            guint collect_flags)
{
	HashTimedQueueElement ** object_p;
	object_p = collect_values[0].v_pointer;
#line 22 "../src/TimedQueue.vala"
	if (!object_p) {
#line 22 "../src/TimedQueue.vala"
		return g_strdup_printf ("value location for `%s' passed as NULL", G_VALUE_TYPE_NAME (value));
#line 1664 "TimedQueue.c"
	}
#line 22 "../src/TimedQueue.vala"
	if (!value->data[0].v_pointer) {
#line 22 "../src/TimedQueue.vala"
		*object_p = NULL;
#line 1670 "TimedQueue.c"
	} else if (collect_flags & G_VALUE_NOCOPY_CONTENTS) {
#line 22 "../src/TimedQueue.vala"
		*object_p = value->data[0].v_pointer;
#line 1674 "TimedQueue.c"
	} else {
#line 22 "../src/TimedQueue.vala"
		*object_p = hash_timed_queue_element_ref (value->data[0].v_pointer);
#line 1678 "TimedQueue.c"
	}
#line 22 "../src/TimedQueue.vala"
	return NULL;
#line 1682 "TimedQueue.c"
}

static GParamSpec*
hash_timed_queue_param_spec_element (const gchar* name,
                                     const gchar* nick,
                                     const gchar* blurb,
                                     GType object_type,
                                     GParamFlags flags)
{
	HashTimedQueueParamSpecElement* spec;
#line 22 "../src/TimedQueue.vala"
	g_return_val_if_fail (g_type_is_a (object_type, HASH_TIMED_QUEUE_TYPE_ELEMENT), NULL);
#line 22 "../src/TimedQueue.vala"
	spec = g_param_spec_internal (G_TYPE_PARAM_OBJECT, name, nick, blurb, flags);
#line 22 "../src/TimedQueue.vala"
	G_PARAM_SPEC (spec)->value_type = object_type;
#line 22 "../src/TimedQueue.vala"
	return G_PARAM_SPEC (spec);
#line 1701 "TimedQueue.c"
}

static gpointer
hash_timed_queue_value_get_element (const GValue* value)
{
#line 22 "../src/TimedQueue.vala"
	g_return_val_if_fail (G_TYPE_CHECK_VALUE_TYPE (value, HASH_TIMED_QUEUE_TYPE_ELEMENT), NULL);
#line 22 "../src/TimedQueue.vala"
	return value->data[0].v_pointer;
#line 1711 "TimedQueue.c"
}

static void
hash_timed_queue_value_set_element (GValue* value,
                                    gpointer v_object)
{
	HashTimedQueueElement * old;
#line 22 "../src/TimedQueue.vala"
	g_return_if_fail (G_TYPE_CHECK_VALUE_TYPE (value, HASH_TIMED_QUEUE_TYPE_ELEMENT));
#line 22 "../src/TimedQueue.vala"
	old = value->data[0].v_pointer;
#line 22 "../src/TimedQueue.vala"
	if (v_object) {
#line 22 "../src/TimedQueue.vala"
		g_return_if_fail (G_TYPE_CHECK_INSTANCE_TYPE (v_object, HASH_TIMED_QUEUE_TYPE_ELEMENT));
#line 22 "../src/TimedQueue.vala"
		g_return_if_fail (g_value_type_compatible (G_TYPE_FROM_INSTANCE (v_object), G_VALUE_TYPE (value)));
#line 22 "../src/TimedQueue.vala"
		value->data[0].v_pointer = v_object;
#line 22 "../src/TimedQueue.vala"
		hash_timed_queue_element_ref (value->data[0].v_pointer);
#line 1733 "TimedQueue.c"
	} else {
#line 22 "../src/TimedQueue.vala"
		value->data[0].v_pointer = NULL;
#line 1737 "TimedQueue.c"
	}
#line 22 "../src/TimedQueue.vala"
	if (old) {
#line 22 "../src/TimedQueue.vala"
		hash_timed_queue_element_unref (old);
#line 1743 "TimedQueue.c"
	}
}

static void
hash_timed_queue_value_take_element (GValue* value,
                                     gpointer v_object)
{
	HashTimedQueueElement * old;
#line 22 "../src/TimedQueue.vala"
	g_return_if_fail (G_TYPE_CHECK_VALUE_TYPE (value, HASH_TIMED_QUEUE_TYPE_ELEMENT));
#line 22 "../src/TimedQueue.vala"
	old = value->data[0].v_pointer;
#line 22 "../src/TimedQueue.vala"
	if (v_object) {
#line 22 "../src/TimedQueue.vala"
		g_return_if_fail (G_TYPE_CHECK_INSTANCE_TYPE (v_object, HASH_TIMED_QUEUE_TYPE_ELEMENT));
#line 22 "../src/TimedQueue.vala"
		g_return_if_fail (g_value_type_compatible (G_TYPE_FROM_INSTANCE (v_object), G_VALUE_TYPE (value)));
#line 22 "../src/TimedQueue.vala"
		value->data[0].v_pointer = v_object;
#line 1764 "TimedQueue.c"
	} else {
#line 22 "../src/TimedQueue.vala"
		value->data[0].v_pointer = NULL;
#line 1768 "TimedQueue.c"
	}
#line 22 "../src/TimedQueue.vala"
	if (old) {
#line 22 "../src/TimedQueue.vala"
		hash_timed_queue_element_unref (old);
#line 1774 "TimedQueue.c"
	}
}

static void
hash_timed_queue_element_class_init (HashTimedQueueElementClass * klass,
                                     gpointer klass_data)
{
#line 22 "../src/TimedQueue.vala"
	hash_timed_queue_element_parent_class = g_type_class_peek_parent (klass);
#line 22 "../src/TimedQueue.vala"
	((HashTimedQueueElementClass *) klass)->finalize = hash_timed_queue_element_finalize;
#line 22 "../src/TimedQueue.vala"
	g_type_class_adjust_private_offset (klass, &HashTimedQueueElement_private_offset);
#line 1788 "TimedQueue.c"
}

static void
hash_timed_queue_element_instance_init (HashTimedQueueElement * self,
                                        gpointer klass)
{
#line 22 "../src/TimedQueue.vala"
	self->priv = hash_timed_queue_element_get_instance_private (self);
#line 22 "../src/TimedQueue.vala"
	self->ref_count = 1;
#line 1799 "TimedQueue.c"
}

static void
hash_timed_queue_element_finalize (HashTimedQueueElement * obj)
{
	HashTimedQueueElement * self;
#line 22 "../src/TimedQueue.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, HASH_TIMED_QUEUE_TYPE_ELEMENT, HashTimedQueueElement);
#line 22 "../src/TimedQueue.vala"
	g_signal_handlers_destroy (self);
#line 23 "../src/TimedQueue.vala"
	((self->item == NULL) || (self->priv->g_destroy_func == NULL)) ? NULL : (self->item = (self->priv->g_destroy_func (self->item), NULL));
#line 1812 "TimedQueue.c"
}

static GType
hash_timed_queue_element_get_type_once (void)
{
	static const GTypeValueTable g_define_type_value_table = { hash_timed_queue_value_element_init, hash_timed_queue_value_element_free_value, hash_timed_queue_value_element_copy_value, hash_timed_queue_value_element_peek_pointer, "p", hash_timed_queue_value_element_collect_value, "p", hash_timed_queue_value_element_lcopy_value };
	static const GTypeInfo g_define_type_info = { sizeof (HashTimedQueueElementClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) hash_timed_queue_element_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (HashTimedQueueElement), 0, (GInstanceInitFunc) hash_timed_queue_element_instance_init, &g_define_type_value_table };
	static const GTypeFundamentalInfo g_define_type_fundamental_info = { (G_TYPE_FLAG_CLASSED | G_TYPE_FLAG_INSTANTIATABLE | G_TYPE_FLAG_DERIVABLE | G_TYPE_FLAG_DEEP_DERIVABLE) };
	GType hash_timed_queue_element_type_id;
	hash_timed_queue_element_type_id = g_type_register_fundamental (g_type_fundamental_next (), "HashTimedQueueElement", &g_define_type_info, &g_define_type_fundamental_info, 0);
	HashTimedQueueElement_private_offset = g_type_add_instance_private (hash_timed_queue_element_type_id, sizeof (HashTimedQueueElementPrivate));
	return hash_timed_queue_element_type_id;
}

static GType
hash_timed_queue_element_get_type (void)
{
	static volatile gsize hash_timed_queue_element_type_id__once = 0;
	if (g_once_init_enter (&hash_timed_queue_element_type_id__once)) {
		GType hash_timed_queue_element_type_id;
		hash_timed_queue_element_type_id = hash_timed_queue_element_get_type_once ();
		g_once_init_leave (&hash_timed_queue_element_type_id__once, hash_timed_queue_element_type_id);
	}
	return hash_timed_queue_element_type_id__once;
}

static gpointer
hash_timed_queue_element_ref (gpointer instance)
{
	HashTimedQueueElement * self;
	self = instance;
#line 22 "../src/TimedQueue.vala"
	g_atomic_int_inc (&self->ref_count);
#line 22 "../src/TimedQueue.vala"
	return instance;
#line 1848 "TimedQueue.c"
}

static void
hash_timed_queue_element_unref (gpointer instance)
{
	HashTimedQueueElement * self;
	self = instance;
#line 22 "../src/TimedQueue.vala"
	if (g_atomic_int_dec_and_test (&self->ref_count)) {
#line 22 "../src/TimedQueue.vala"
		HASH_TIMED_QUEUE_ELEMENT_GET_CLASS (self)->finalize (self);
#line 22 "../src/TimedQueue.vala"
		g_type_free_instance ((GTypeInstance *) self);
#line 1862 "TimedQueue.c"
	}
}

static void
value_hash_timed_queue_init (GValue* value)
{
#line 21 "../src/TimedQueue.vala"
	value->data[0].v_pointer = NULL;
#line 1871 "TimedQueue.c"
}

static void
value_hash_timed_queue_free_value (GValue* value)
{
#line 21 "../src/TimedQueue.vala"
	if (value->data[0].v_pointer) {
#line 21 "../src/TimedQueue.vala"
		hash_timed_queue_unref (value->data[0].v_pointer);
#line 1881 "TimedQueue.c"
	}
}

static void
value_hash_timed_queue_copy_value (const GValue* src_value,
                                   GValue* dest_value)
{
#line 21 "../src/TimedQueue.vala"
	if (src_value->data[0].v_pointer) {
#line 21 "../src/TimedQueue.vala"
		dest_value->data[0].v_pointer = hash_timed_queue_ref (src_value->data[0].v_pointer);
#line 1893 "TimedQueue.c"
	} else {
#line 21 "../src/TimedQueue.vala"
		dest_value->data[0].v_pointer = NULL;
#line 1897 "TimedQueue.c"
	}
}

static gpointer
value_hash_timed_queue_peek_pointer (const GValue* value)
{
#line 21 "../src/TimedQueue.vala"
	return value->data[0].v_pointer;
#line 1906 "TimedQueue.c"
}

static gchar*
value_hash_timed_queue_collect_value (GValue* value,
                                      guint n_collect_values,
                                      GTypeCValue* collect_values,
                                      guint collect_flags)
{
#line 21 "../src/TimedQueue.vala"
	if (collect_values[0].v_pointer) {
#line 1917 "TimedQueue.c"
		HashTimedQueue * object;
		object = collect_values[0].v_pointer;
#line 21 "../src/TimedQueue.vala"
		if (object->parent_instance.g_class == NULL) {
#line 21 "../src/TimedQueue.vala"
			return g_strconcat ("invalid unclassed object pointer for value type `", G_VALUE_TYPE_NAME (value), "'", NULL);
#line 1924 "TimedQueue.c"
		} else if (!g_value_type_compatible (G_TYPE_FROM_INSTANCE (object), G_VALUE_TYPE (value))) {
#line 21 "../src/TimedQueue.vala"
			return g_strconcat ("invalid object type `", g_type_name (G_TYPE_FROM_INSTANCE (object)), "' for value type `", G_VALUE_TYPE_NAME (value), "'", NULL);
#line 1928 "TimedQueue.c"
		}
#line 21 "../src/TimedQueue.vala"
		value->data[0].v_pointer = hash_timed_queue_ref (object);
#line 1932 "TimedQueue.c"
	} else {
#line 21 "../src/TimedQueue.vala"
		value->data[0].v_pointer = NULL;
#line 1936 "TimedQueue.c"
	}
#line 21 "../src/TimedQueue.vala"
	return NULL;
#line 1940 "TimedQueue.c"
}

static gchar*
value_hash_timed_queue_lcopy_value (const GValue* value,
                                    guint n_collect_values,
                                    GTypeCValue* collect_values,
                                    guint collect_flags)
{
	HashTimedQueue ** object_p;
	object_p = collect_values[0].v_pointer;
#line 21 "../src/TimedQueue.vala"
	if (!object_p) {
#line 21 "../src/TimedQueue.vala"
		return g_strdup_printf ("value location for `%s' passed as NULL", G_VALUE_TYPE_NAME (value));
#line 1955 "TimedQueue.c"
	}
#line 21 "../src/TimedQueue.vala"
	if (!value->data[0].v_pointer) {
#line 21 "../src/TimedQueue.vala"
		*object_p = NULL;
#line 1961 "TimedQueue.c"
	} else if (collect_flags & G_VALUE_NOCOPY_CONTENTS) {
#line 21 "../src/TimedQueue.vala"
		*object_p = value->data[0].v_pointer;
#line 1965 "TimedQueue.c"
	} else {
#line 21 "../src/TimedQueue.vala"
		*object_p = hash_timed_queue_ref (value->data[0].v_pointer);
#line 1969 "TimedQueue.c"
	}
#line 21 "../src/TimedQueue.vala"
	return NULL;
#line 1973 "TimedQueue.c"
}

GParamSpec*
param_spec_hash_timed_queue (const gchar* name,
                             const gchar* nick,
                             const gchar* blurb,
                             GType object_type,
                             GParamFlags flags)
{
	ParamSpecHashTimedQueue* spec;
#line 21 "../src/TimedQueue.vala"
	g_return_val_if_fail (g_type_is_a (object_type, TYPE_HASH_TIMED_QUEUE), NULL);
#line 21 "../src/TimedQueue.vala"
	spec = g_param_spec_internal (G_TYPE_PARAM_OBJECT, name, nick, blurb, flags);
#line 21 "../src/TimedQueue.vala"
	G_PARAM_SPEC (spec)->value_type = object_type;
#line 21 "../src/TimedQueue.vala"
	return G_PARAM_SPEC (spec);
#line 1992 "TimedQueue.c"
}

gpointer
value_get_hash_timed_queue (const GValue* value)
{
#line 21 "../src/TimedQueue.vala"
	g_return_val_if_fail (G_TYPE_CHECK_VALUE_TYPE (value, TYPE_HASH_TIMED_QUEUE), NULL);
#line 21 "../src/TimedQueue.vala"
	return value->data[0].v_pointer;
#line 2002 "TimedQueue.c"
}

void
value_set_hash_timed_queue (GValue* value,
                            gpointer v_object)
{
	HashTimedQueue * old;
#line 21 "../src/TimedQueue.vala"
	g_return_if_fail (G_TYPE_CHECK_VALUE_TYPE (value, TYPE_HASH_TIMED_QUEUE));
#line 21 "../src/TimedQueue.vala"
	old = value->data[0].v_pointer;
#line 21 "../src/TimedQueue.vala"
	if (v_object) {
#line 21 "../src/TimedQueue.vala"
		g_return_if_fail (G_TYPE_CHECK_INSTANCE_TYPE (v_object, TYPE_HASH_TIMED_QUEUE));
#line 21 "../src/TimedQueue.vala"
		g_return_if_fail (g_value_type_compatible (G_TYPE_FROM_INSTANCE (v_object), G_VALUE_TYPE (value)));
#line 21 "../src/TimedQueue.vala"
		value->data[0].v_pointer = v_object;
#line 21 "../src/TimedQueue.vala"
		hash_timed_queue_ref (value->data[0].v_pointer);
#line 2024 "TimedQueue.c"
	} else {
#line 21 "../src/TimedQueue.vala"
		value->data[0].v_pointer = NULL;
#line 2028 "TimedQueue.c"
	}
#line 21 "../src/TimedQueue.vala"
	if (old) {
#line 21 "../src/TimedQueue.vala"
		hash_timed_queue_unref (old);
#line 2034 "TimedQueue.c"
	}
}

void
value_take_hash_timed_queue (GValue* value,
                             gpointer v_object)
{
	HashTimedQueue * old;
#line 21 "../src/TimedQueue.vala"
	g_return_if_fail (G_TYPE_CHECK_VALUE_TYPE (value, TYPE_HASH_TIMED_QUEUE));
#line 21 "../src/TimedQueue.vala"
	old = value->data[0].v_pointer;
#line 21 "../src/TimedQueue.vala"
	if (v_object) {
#line 21 "../src/TimedQueue.vala"
		g_return_if_fail (G_TYPE_CHECK_INSTANCE_TYPE (v_object, TYPE_HASH_TIMED_QUEUE));
#line 21 "../src/TimedQueue.vala"
		g_return_if_fail (g_value_type_compatible (G_TYPE_FROM_INSTANCE (v_object), G_VALUE_TYPE (value)));
#line 21 "../src/TimedQueue.vala"
		value->data[0].v_pointer = v_object;
#line 2055 "TimedQueue.c"
	} else {
#line 21 "../src/TimedQueue.vala"
		value->data[0].v_pointer = NULL;
#line 2059 "TimedQueue.c"
	}
#line 21 "../src/TimedQueue.vala"
	if (old) {
#line 21 "../src/TimedQueue.vala"
		hash_timed_queue_unref (old);
#line 2065 "TimedQueue.c"
	}
}

static void
hash_timed_queue_class_init (HashTimedQueueClass * klass,
                             gpointer klass_data)
{
#line 21 "../src/TimedQueue.vala"
	hash_timed_queue_parent_class = g_type_class_peek_parent (klass);
#line 21 "../src/TimedQueue.vala"
	((HashTimedQueueClass *) klass)->finalize = hash_timed_queue_finalize;
#line 21 "../src/TimedQueue.vala"
	g_type_class_adjust_private_offset (klass, &HashTimedQueue_private_offset);
#line 21 "../src/TimedQueue.vala"
	((HashTimedQueueClass *) klass)->paused = hash_timed_queue_real_paused;
#line 21 "../src/TimedQueue.vala"
	hash_timed_queue_signals[HASH_TIMED_QUEUE_PAUSED_SIGNAL] = g_signal_new ("paused", TYPE_HASH_TIMED_QUEUE, G_SIGNAL_RUN_LAST, G_STRUCT_OFFSET (HashTimedQueueClass, paused), NULL, NULL, g_cclosure_marshal_VOID__BOOLEAN, G_TYPE_NONE, 1, G_TYPE_BOOLEAN);
#line 2083 "TimedQueue.c"
}

static void
hash_timed_queue_instance_init (HashTimedQueue * self,
                                gpointer klass)
{
#line 21 "../src/TimedQueue.vala"
	self->priv = hash_timed_queue_get_instance_private (self);
#line 40 "../src/TimedQueue.vala"
	self->priv->timer_id = (guint) 0;
#line 41 "../src/TimedQueue.vala"
	g_rec_mutex_init (&self->priv->__lock_queue);
#line 42 "../src/TimedQueue.vala"
	self->priv->dequeue_spacing_msec = (guint) 0;
#line 43 "../src/TimedQueue.vala"
	self->priv->last_dequeue = (gulong) 0;
#line 44 "../src/TimedQueue.vala"
	self->priv->paused_state = FALSE;
#line 21 "../src/TimedQueue.vala"
	self->ref_count = 1;
#line 2104 "TimedQueue.c"
}

static void
hash_timed_queue_finalize (HashTimedQueue * obj)
{
	HashTimedQueue * self;
#line 21 "../src/TimedQueue.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, TYPE_HASH_TIMED_QUEUE, HashTimedQueue);
#line 21 "../src/TimedQueue.vala"
	g_signal_handlers_destroy (self);
#line 73 "../src/TimedQueue.vala"
	if (self->priv->timer_id != ((guint) 0)) {
#line 74 "../src/TimedQueue.vala"
		g_source_remove (self->priv->timer_id);
#line 2119 "TimedQueue.c"
	}
#line 38 "../src/TimedQueue.vala"
	(self->priv->equal_func_target_destroy_notify == NULL) ? NULL : (self->priv->equal_func_target_destroy_notify (self->priv->equal_func_target), NULL);
#line 38 "../src/TimedQueue.vala"
	self->priv->equal_func = NULL;
#line 38 "../src/TimedQueue.vala"
	self->priv->equal_func_target = NULL;
#line 38 "../src/TimedQueue.vala"
	self->priv->equal_func_target_destroy_notify = NULL;
#line 41 "../src/TimedQueue.vala"
	g_rec_mutex_clear (&self->priv->__lock_queue);
#line 41 "../src/TimedQueue.vala"
	_g_object_unref0 (self->priv->queue);
#line 45 "../src/TimedQueue.vala"
	_g_object_unref0 (self->priv->item_count);
#line 2135 "TimedQueue.c"
}

static GType
hash_timed_queue_get_type_once (void)
{
	static const GTypeValueTable g_define_type_value_table = { value_hash_timed_queue_init, value_hash_timed_queue_free_value, value_hash_timed_queue_copy_value, value_hash_timed_queue_peek_pointer, "p", value_hash_timed_queue_collect_value, "p", value_hash_timed_queue_lcopy_value };
	static const GTypeInfo g_define_type_info = { sizeof (HashTimedQueueClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) hash_timed_queue_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (HashTimedQueue), 0, (GInstanceInitFunc) hash_timed_queue_instance_init, &g_define_type_value_table };
	static const GTypeFundamentalInfo g_define_type_fundamental_info = { (G_TYPE_FLAG_CLASSED | G_TYPE_FLAG_INSTANTIATABLE | G_TYPE_FLAG_DERIVABLE | G_TYPE_FLAG_DEEP_DERIVABLE) };
	GType hash_timed_queue_type_id;
	hash_timed_queue_type_id = g_type_register_fundamental (g_type_fundamental_next (), "HashTimedQueue", &g_define_type_info, &g_define_type_fundamental_info, 0);
	HashTimedQueue_private_offset = g_type_add_instance_private (hash_timed_queue_type_id, sizeof (HashTimedQueuePrivate));
	return hash_timed_queue_type_id;
}

GType
hash_timed_queue_get_type (void)
{
	static volatile gsize hash_timed_queue_type_id__once = 0;
	if (g_once_init_enter (&hash_timed_queue_type_id__once)) {
		GType hash_timed_queue_type_id;
		hash_timed_queue_type_id = hash_timed_queue_get_type_once ();
		g_once_init_leave (&hash_timed_queue_type_id__once, hash_timed_queue_type_id);
	}
	return hash_timed_queue_type_id__once;
}

gpointer
hash_timed_queue_ref (gpointer instance)
{
	HashTimedQueue * self;
	self = instance;
#line 21 "../src/TimedQueue.vala"
	g_atomic_int_inc (&self->ref_count);
#line 21 "../src/TimedQueue.vala"
	return instance;
#line 2171 "TimedQueue.c"
}

void
hash_timed_queue_unref (gpointer instance)
{
	HashTimedQueue * self;
	self = instance;
#line 21 "../src/TimedQueue.vala"
	if (g_atomic_int_dec_and_test (&self->ref_count)) {
#line 21 "../src/TimedQueue.vala"
		HASH_TIMED_QUEUE_GET_CLASS (self)->finalize (self);
#line 21 "../src/TimedQueue.vala"
		g_type_free_instance ((GTypeInstance *) self);
#line 2185 "TimedQueue.c"
	}
}

static inline gpointer
_vala_memdup2 (gconstpointer mem,
               gsize byte_size)
{
	gpointer new_mem;
	if (mem && byte_size != 0) {
		new_mem = g_malloc (byte_size);
		memcpy (new_mem, mem, byte_size);
	} else {
		new_mem = NULL;
	}
	return new_mem;
}

