/* Photo.c generated by valac 0.56.17, the Vala compiler
 * generated from Photo.vala, do not modify */

/* Copyright 2016 Software Freedom Conservancy Inc.
 *
 * This software is licensed under the GNU LGPL (version 2.1 or later).
 * See the COPYING file in this distribution.
 */
/* Specifies how pixel data is fetched from the backing file on disk.  MASTER is the original*/
/* backing photo of any supported photo file format; SOURCE is either the master or the editable*/
/* file, that is, the appropriate reference file for user display; BASELINE is an appropriate*/
/* file with the proviso that it may be a suitable substitute for the master and/or the editable.*/
/* UNMODIFIED represents the photo with no edits, i.e. the head of the pipeline.*/
/**/
/* In general, callers want to use the BASELINE unless requirements are specific.*/

#include <glib-object.h>
#include <gio/gio.h>
#include <glib.h>
#include <stdlib.h>
#include <string.h>
#include <gee.h>
#include <gobject/gvaluecollector.h>
#include <gdk-pixbuf/gdk-pixbuf.h>
#include "metadata.h"
#include <float.h>
#include <math.h>
#include "shotwell-graphics-processor.h"
#include <glib/gstdio.h>
#include <gdk/gdk.h>
#include <config.h>
#include <glib/gi18n-lib.h>
#include <cairo-gobject.h>

#define PHOTO_TYPENAME "thumb"
#define PHOTO_SCALING_FUDGE 64
#define PHOTO_SOURCE_PIXBUF_TIME_TO_LIVE_SEC 10
#define PHOTO_SOURCE_PIXBUF_MIN_LRU_COUNT 1
#define PHOTO_SOURCE_PIXBUF_MAX_LRU_COUNT 3
#define PHOTO_MIN_EMBEDDED_SIZE 1024
#define DATA_OBJECT_INVALID_OBJECT_ID ((gint64) -1)
#define BACKING_PHOTO_ID_INVALID ((gint64) -1)
#define UTIL_FILE_ATTRIBUTES "standard::*,time::*,id::file,id::filesystem,etag::value"
#define DIRECTORY_MONITOR_SUPPLIED_ATTRIBUTES UTIL_FILE_ATTRIBUTES
#define PHOTO_ID_INVALID ((gint64) -1)
#define EVENT_ID_INVALID ((gint64) -1)
#define RESOURCES_APP_TITLE "Shotwell"
#define RESOURCES_APP_VERSION _VERSION
#define LIBRARY_PHOTO_FLAG_HIDDEN ((guint64) 0x0000000000000001)
#define LIBRARY_PHOTO_FLAG_FAVORITE ((guint64) 0x0000000000000002)
#define LIBRARY_PHOTO_FLAG_TRASH ((guint64) 0x0000000000000004)
#define LIBRARY_PHOTO_FLAG_OFFLINE ((guint64) 0x0000000000000008)
#define LIBRARY_PHOTO_FLAG_FLAGGED ((guint64) 0x0000000000000010)
#if !defined(VALA_STRICT_C)
#if !defined(__clang__) && defined(__GNUC__) && (__GNUC__ >= 14)
#pragma GCC diagnostic warning "-Wincompatible-pointer-types"
#elif defined(__clang__) && (__clang_major__ >= 16)
#pragma clang diagnostic ignored "-Wincompatible-function-pointer-types"
#pragma clang diagnostic ignored "-Wincompatible-pointer-types"
#endif
#endif
#if !defined(VALA_EXTERN)
#if defined(_MSC_VER)
#define VALA_EXTERN __declspec(dllexport) extern
#elif __GNUC__ >= 4
#define VALA_EXTERN __attribute__((visibility("default"))) extern
#else
#define VALA_EXTERN extern
#endif
#endif

typedef enum  {
	BACKING_FETCH_MODE_SOURCE,
	BACKING_FETCH_MODE_BASELINE,
	BACKING_FETCH_MODE_MASTER,
	BACKING_FETCH_MODE_UNMODIFIED
} BackingFetchMode;

#define TYPE_BACKING_FETCH_MODE (backing_fetch_mode_get_type ())

#define TYPE_PHOTO_IMPORT_PARAMS (photo_import_params_get_type ())
#define PHOTO_IMPORT_PARAMS(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_PHOTO_IMPORT_PARAMS, PhotoImportParams))
#define PHOTO_IMPORT_PARAMS_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_PHOTO_IMPORT_PARAMS, PhotoImportParamsClass))
#define IS_PHOTO_IMPORT_PARAMS(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_PHOTO_IMPORT_PARAMS))
#define IS_PHOTO_IMPORT_PARAMS_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_PHOTO_IMPORT_PARAMS))
#define PHOTO_IMPORT_PARAMS_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_PHOTO_IMPORT_PARAMS, PhotoImportParamsClass))

typedef struct _PhotoImportParams PhotoImportParams;
typedef struct _PhotoImportParamsClass PhotoImportParamsClass;
typedef struct _PhotoImportParamsPrivate PhotoImportParamsPrivate;

#define TYPE_IMPORT_ID (import_id_get_type ())
typedef struct _ImportID ImportID;
typedef enum  {
	PHOTO_FILE_SNIFFER_OPTIONS_GET_ALL = 0x00000000,
	PHOTO_FILE_SNIFFER_OPTIONS_NO_MD5 = 0x00000001
} PhotoFileSnifferOptions;

#define PHOTO_FILE_SNIFFER_TYPE_OPTIONS (photo_file_sniffer_options_get_type ())

#define TYPE_THUMBNAILS (thumbnails_get_type ())
#define THUMBNAILS(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_THUMBNAILS, Thumbnails))
#define THUMBNAILS_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_THUMBNAILS, ThumbnailsClass))
#define IS_THUMBNAILS(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_THUMBNAILS))
#define IS_THUMBNAILS_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_THUMBNAILS))
#define THUMBNAILS_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_THUMBNAILS, ThumbnailsClass))

typedef struct _Thumbnails Thumbnails;
typedef struct _ThumbnailsClass ThumbnailsClass;

#define TYPE_PHOTO_ROW (photo_row_get_type ())
#define PHOTO_ROW(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_PHOTO_ROW, PhotoRow))
#define PHOTO_ROW_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_PHOTO_ROW, PhotoRowClass))
#define IS_PHOTO_ROW(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_PHOTO_ROW))
#define IS_PHOTO_ROW_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_PHOTO_ROW))
#define PHOTO_ROW_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_PHOTO_ROW, PhotoRowClass))

typedef struct _PhotoRow PhotoRow;
typedef struct _PhotoRowClass PhotoRowClass;
#define _g_object_unref0(var) ((var == NULL) ? NULL : (var = (g_object_unref (var), NULL)))
#define _g_free0(var) (var = (g_free (var), NULL))
#define _thumbnails_unref0(var) ((var == NULL) ? NULL : (var = (thumbnails_unref (var), NULL)))
#define _photo_row_unref0(var) ((var == NULL) ? NULL : (var = (photo_row_unref (var), NULL)))
typedef struct _ParamSpecPhotoImportParams ParamSpecPhotoImportParams;

#define TYPE_PHOTO_TRANSFORMATION_STATE (photo_transformation_state_get_type ())
#define PHOTO_TRANSFORMATION_STATE(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_PHOTO_TRANSFORMATION_STATE, PhotoTransformationState))
#define PHOTO_TRANSFORMATION_STATE_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_PHOTO_TRANSFORMATION_STATE, PhotoTransformationStateClass))
#define IS_PHOTO_TRANSFORMATION_STATE(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_PHOTO_TRANSFORMATION_STATE))
#define IS_PHOTO_TRANSFORMATION_STATE_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_PHOTO_TRANSFORMATION_STATE))
#define PHOTO_TRANSFORMATION_STATE_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_PHOTO_TRANSFORMATION_STATE, PhotoTransformationStateClass))

typedef struct _PhotoTransformationState PhotoTransformationState;
typedef struct _PhotoTransformationStateClass PhotoTransformationStateClass;
typedef struct _PhotoTransformationStatePrivate PhotoTransformationStatePrivate;
enum  {
	PHOTO_TRANSFORMATION_STATE_0_PROPERTY,
	PHOTO_TRANSFORMATION_STATE_NUM_PROPERTIES
};
static GParamSpec* photo_transformation_state_properties[PHOTO_TRANSFORMATION_STATE_NUM_PROPERTIES];
enum  {
	PHOTO_TRANSFORMATION_STATE_BROKEN_SIGNAL,
	PHOTO_TRANSFORMATION_STATE_NUM_SIGNALS
};
static guint photo_transformation_state_signals[PHOTO_TRANSFORMATION_STATE_NUM_SIGNALS] = {0};
typedef enum  {
	RATING_REJECTED = -1,
	RATING_UNRATED = 0,
	RATING_ONE = 1,
	RATING_TWO = 2,
	RATING_THREE = 3,
	RATING_FOUR = 4,
	RATING_FIVE = 5
} Rating;

#define TYPE_RATING (rating_get_type ())

#define TYPE_DATA_OBJECT (data_object_get_type ())
#define DATA_OBJECT(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_DATA_OBJECT, DataObject))
#define DATA_OBJECT_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_DATA_OBJECT, DataObjectClass))
#define IS_DATA_OBJECT(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_DATA_OBJECT))
#define IS_DATA_OBJECT_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_DATA_OBJECT))
#define DATA_OBJECT_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_DATA_OBJECT, DataObjectClass))

typedef struct _DataObject DataObject;
typedef struct _DataObjectClass DataObjectClass;
typedef struct _DataObjectPrivate DataObjectPrivate;

#define TYPE_ALTERATION (alteration_get_type ())
#define ALTERATION(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_ALTERATION, Alteration))
#define ALTERATION_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_ALTERATION, AlterationClass))
#define IS_ALTERATION(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_ALTERATION))
#define IS_ALTERATION_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_ALTERATION))
#define ALTERATION_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_ALTERATION, AlterationClass))

typedef struct _Alteration Alteration;
typedef struct _AlterationClass AlterationClass;

#define TYPE_DATA_COLLECTION (data_collection_get_type ())
#define DATA_COLLECTION(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_DATA_COLLECTION, DataCollection))
#define DATA_COLLECTION_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_DATA_COLLECTION, DataCollectionClass))
#define IS_DATA_COLLECTION(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_DATA_COLLECTION))
#define IS_DATA_COLLECTION_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_DATA_COLLECTION))
#define DATA_COLLECTION_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_DATA_COLLECTION, DataCollectionClass))

typedef struct _DataCollection DataCollection;
typedef struct _DataCollectionClass DataCollectionClass;

#define TYPE_DATA_SOURCE (data_source_get_type ())
#define DATA_SOURCE(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_DATA_SOURCE, DataSource))
#define DATA_SOURCE_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_DATA_SOURCE, DataSourceClass))
#define IS_DATA_SOURCE(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_DATA_SOURCE))
#define IS_DATA_SOURCE_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_DATA_SOURCE))
#define DATA_SOURCE_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_DATA_SOURCE, DataSourceClass))

typedef struct _DataSource DataSource;
typedef struct _DataSourceClass DataSourceClass;
typedef struct _DataSourcePrivate DataSourcePrivate;

#define TYPE_SOURCE_HOLDING_TANK (source_holding_tank_get_type ())
#define SOURCE_HOLDING_TANK(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_SOURCE_HOLDING_TANK, SourceHoldingTank))
#define SOURCE_HOLDING_TANK_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_SOURCE_HOLDING_TANK, SourceHoldingTankClass))
#define IS_SOURCE_HOLDING_TANK(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_SOURCE_HOLDING_TANK))
#define IS_SOURCE_HOLDING_TANK_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_SOURCE_HOLDING_TANK))
#define SOURCE_HOLDING_TANK_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_SOURCE_HOLDING_TANK, SourceHoldingTankClass))

typedef struct _SourceHoldingTank SourceHoldingTank;
typedef struct _SourceHoldingTankClass SourceHoldingTankClass;

#define TYPE_SOURCE_COLLECTION (source_collection_get_type ())
#define SOURCE_COLLECTION(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_SOURCE_COLLECTION, SourceCollection))
#define SOURCE_COLLECTION_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_SOURCE_COLLECTION, SourceCollectionClass))
#define IS_SOURCE_COLLECTION(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_SOURCE_COLLECTION))
#define IS_SOURCE_COLLECTION_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_SOURCE_COLLECTION))
#define SOURCE_COLLECTION_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_SOURCE_COLLECTION, SourceCollectionClass))

typedef struct _SourceCollection SourceCollection;
typedef struct _SourceCollectionClass SourceCollectionClass;

#define TYPE_SOURCE_SNAPSHOT (source_snapshot_get_type ())
#define SOURCE_SNAPSHOT(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_SOURCE_SNAPSHOT, SourceSnapshot))
#define SOURCE_SNAPSHOT_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_SOURCE_SNAPSHOT, SourceSnapshotClass))
#define IS_SOURCE_SNAPSHOT(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_SOURCE_SNAPSHOT))
#define IS_SOURCE_SNAPSHOT_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_SOURCE_SNAPSHOT))
#define SOURCE_SNAPSHOT_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_SOURCE_SNAPSHOT, SourceSnapshotClass))

typedef struct _SourceSnapshot SourceSnapshot;
typedef struct _SourceSnapshotClass SourceSnapshotClass;

#define TYPE_THUMBNAIL_SOURCE (thumbnail_source_get_type ())
#define THUMBNAIL_SOURCE(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_THUMBNAIL_SOURCE, ThumbnailSource))
#define THUMBNAIL_SOURCE_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_THUMBNAIL_SOURCE, ThumbnailSourceClass))
#define IS_THUMBNAIL_SOURCE(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_THUMBNAIL_SOURCE))
#define IS_THUMBNAIL_SOURCE_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_THUMBNAIL_SOURCE))
#define THUMBNAIL_SOURCE_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_THUMBNAIL_SOURCE, ThumbnailSourceClass))

typedef struct _ThumbnailSource ThumbnailSource;
typedef struct _ThumbnailSourceClass ThumbnailSourceClass;
typedef struct _ThumbnailSourcePrivate ThumbnailSourcePrivate;
typedef enum  {
	PHOTO_FILE_FORMAT_JFIF,
	PHOTO_FILE_FORMAT_RAW,
	PHOTO_FILE_FORMAT_PNG,
	PHOTO_FILE_FORMAT_TIFF,
	PHOTO_FILE_FORMAT_BMP,
	PHOTO_FILE_FORMAT_GIF,
	PHOTO_FILE_FORMAT_WEBP,
	PHOTO_FILE_FORMAT_AVIF,
	PHOTO_FILE_FORMAT_HEIF,
	PHOTO_FILE_FORMAT_JPEGXL,
	PHOTO_FILE_FORMAT_UNKNOWN
} PhotoFileFormat;

#define TYPE_PHOTO_FILE_FORMAT (photo_file_format_get_type ())

#define TYPE_INDEXABLE (indexable_get_type ())
#define INDEXABLE(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_INDEXABLE, Indexable))
#define IS_INDEXABLE(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_INDEXABLE))
#define INDEXABLE_GET_INTERFACE(obj) (G_TYPE_INSTANCE_GET_INTERFACE ((obj), TYPE_INDEXABLE, IndexableIface))

typedef struct _Indexable Indexable;
typedef struct _IndexableIface IndexableIface;

#define TYPE_MEDIA_SOURCE (media_source_get_type ())
#define MEDIA_SOURCE(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_MEDIA_SOURCE, MediaSource))
#define MEDIA_SOURCE_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_MEDIA_SOURCE, MediaSourceClass))
#define IS_MEDIA_SOURCE(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_MEDIA_SOURCE))
#define IS_MEDIA_SOURCE_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_MEDIA_SOURCE))
#define MEDIA_SOURCE_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_MEDIA_SOURCE, MediaSourceClass))

typedef struct _MediaSource MediaSource;
typedef struct _MediaSourceClass MediaSourceClass;
typedef struct _MediaSourcePrivate MediaSourcePrivate;

#define TYPE_EVENT_ID (event_id_get_type ())
typedef struct _EventID EventID;

#define TYPE_BACKING_FILE_STATE (backing_file_state_get_type ())
#define BACKING_FILE_STATE(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_BACKING_FILE_STATE, BackingFileState))
#define BACKING_FILE_STATE_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_BACKING_FILE_STATE, BackingFileStateClass))
#define IS_BACKING_FILE_STATE(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_BACKING_FILE_STATE))
#define IS_BACKING_FILE_STATE_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_BACKING_FILE_STATE))
#define BACKING_FILE_STATE_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_BACKING_FILE_STATE, BackingFileStateClass))

typedef struct _BackingFileState BackingFileState;
typedef struct _BackingFileStateClass BackingFileStateClass;
typedef enum  {
	PHOTO_EXCEPTION_NONE = 0,
	PHOTO_EXCEPTION_ORIENTATION = 1 << 0,
	PHOTO_EXCEPTION_CROP = 1 << 1,
	PHOTO_EXCEPTION_REDEYE = 1 << 2,
	PHOTO_EXCEPTION_ADJUST = 1 << 3,
	PHOTO_EXCEPTION_STRAIGHTEN = 1 << 4,
	PHOTO_EXCEPTION_ALL = 0xFFFFFFFFLL
} PhotoException;

#define PHOTO_TYPE_EXCEPTION (photo_exception_get_type ())

#define TYPE_DIMENSIONS (dimensions_get_type ())
typedef struct _Dimensions Dimensions;

#define TYPE_SCALING (scaling_get_type ())
typedef struct _Scaling Scaling;
typedef enum  {
	SCALE_CONSTRAINT_ORIGINAL,
	SCALE_CONSTRAINT_DIMENSIONS,
	SCALE_CONSTRAINT_WIDTH,
	SCALE_CONSTRAINT_HEIGHT,
	SCALE_CONSTRAINT_FILL_VIEWPORT
} ScaleConstraint;

#define TYPE_SCALE_CONSTRAINT (scale_constraint_get_type ())

#define TYPE_PHOTO_SOURCE (photo_source_get_type ())
#define PHOTO_SOURCE(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_PHOTO_SOURCE, PhotoSource))
#define PHOTO_SOURCE_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_PHOTO_SOURCE, PhotoSourceClass))
#define IS_PHOTO_SOURCE(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_PHOTO_SOURCE))
#define IS_PHOTO_SOURCE_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_PHOTO_SOURCE))
#define PHOTO_SOURCE_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_PHOTO_SOURCE, PhotoSourceClass))

typedef struct _PhotoSource PhotoSource;
typedef struct _PhotoSourceClass PhotoSourceClass;
typedef struct _PhotoSourcePrivate PhotoSourcePrivate;

#define TYPE_PHOTO_METADATA (photo_metadata_get_type ())
#define PHOTO_METADATA(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_PHOTO_METADATA, PhotoMetadata))
#define PHOTO_METADATA_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_PHOTO_METADATA, PhotoMetadataClass))
#define IS_PHOTO_METADATA(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_PHOTO_METADATA))
#define IS_PHOTO_METADATA_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_PHOTO_METADATA))
#define PHOTO_METADATA_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_PHOTO_METADATA, PhotoMetadataClass))

typedef struct _PhotoMetadata PhotoMetadata;
typedef struct _PhotoMetadataClass PhotoMetadataClass;

#define TYPE_DATEABLE (dateable_get_type ())
#define DATEABLE(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_DATEABLE, Dateable))
#define IS_DATEABLE(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_DATEABLE))
#define DATEABLE_GET_INTERFACE(obj) (G_TYPE_INSTANCE_GET_INTERFACE ((obj), TYPE_DATEABLE, DateableIface))

typedef struct _Dateable Dateable;
typedef struct _DateableIface DateableIface;

#define TYPE_POSITIONABLE (positionable_get_type ())
#define POSITIONABLE(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_POSITIONABLE, Positionable))
#define IS_POSITIONABLE(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_POSITIONABLE))
#define POSITIONABLE_GET_INTERFACE(obj) (G_TYPE_INSTANCE_GET_INTERFACE ((obj), TYPE_POSITIONABLE, PositionableIface))

typedef struct _Positionable Positionable;
typedef struct _PositionableIface PositionableIface;

#define TYPE_GPS_COORDS (gps_coords_get_type ())
typedef struct _GpsCoords GpsCoords;

#define TYPE_PHOTO (photo_get_type ())
#define PHOTO(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_PHOTO, Photo))
#define PHOTO_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_PHOTO, PhotoClass))
#define IS_PHOTO(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_PHOTO))
#define IS_PHOTO_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_PHOTO))
#define PHOTO_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_PHOTO, PhotoClass))

typedef struct _Photo Photo;
typedef struct _PhotoClass PhotoClass;
typedef struct _PhotoPrivate PhotoPrivate;
typedef enum  {
	ROTATION_CLOCKWISE,
	ROTATION_COUNTERCLOCKWISE,
	ROTATION_MIRROR,
	ROTATION_UPSIDE_DOWN
} Rotation;

#define TYPE_ROTATION (rotation_get_type ())

#define TYPE_BACKING_PHOTO_ROW (backing_photo_row_get_type ())
#define BACKING_PHOTO_ROW(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_BACKING_PHOTO_ROW, BackingPhotoRow))
#define BACKING_PHOTO_ROW_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_BACKING_PHOTO_ROW, BackingPhotoRowClass))
#define IS_BACKING_PHOTO_ROW(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_BACKING_PHOTO_ROW))
#define IS_BACKING_PHOTO_ROW_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_BACKING_PHOTO_ROW))
#define BACKING_PHOTO_ROW_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_BACKING_PHOTO_ROW, BackingPhotoRowClass))

typedef struct _BackingPhotoRow BackingPhotoRow;
typedef struct _BackingPhotoRowClass BackingPhotoRowClass;

#define PHOTO_TYPE_BACKING_READERS (photo_backing_readers_get_type ())
#define PHOTO_BACKING_READERS(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), PHOTO_TYPE_BACKING_READERS, PhotoBackingReaders))
#define PHOTO_BACKING_READERS_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), PHOTO_TYPE_BACKING_READERS, PhotoBackingReadersClass))
#define PHOTO_IS_BACKING_READERS(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), PHOTO_TYPE_BACKING_READERS))
#define PHOTO_IS_BACKING_READERS_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), PHOTO_TYPE_BACKING_READERS))
#define PHOTO_BACKING_READERS_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), PHOTO_TYPE_BACKING_READERS, PhotoBackingReadersClass))

typedef struct _PhotoBackingReaders PhotoBackingReaders;
typedef struct _PhotoBackingReadersClass PhotoBackingReadersClass;

#define TYPE_ONE_SHOT_SCHEDULER (one_shot_scheduler_get_type ())
#define ONE_SHOT_SCHEDULER(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_ONE_SHOT_SCHEDULER, OneShotScheduler))
#define ONE_SHOT_SCHEDULER_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_ONE_SHOT_SCHEDULER, OneShotSchedulerClass))
#define IS_ONE_SHOT_SCHEDULER(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_ONE_SHOT_SCHEDULER))
#define IS_ONE_SHOT_SCHEDULER_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_ONE_SHOT_SCHEDULER))
#define ONE_SHOT_SCHEDULER_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_ONE_SHOT_SCHEDULER, OneShotSchedulerClass))

typedef struct _OneShotScheduler OneShotScheduler;
typedef struct _OneShotSchedulerClass OneShotSchedulerClass;
typedef enum  {
	RAW_DEVELOPER_SHOTWELL = 0,
	RAW_DEVELOPER_CAMERA,
	RAW_DEVELOPER_EMBEDDED
} RawDeveloper;

#define TYPE_RAW_DEVELOPER (raw_developer_get_type ())
enum  {
	PHOTO_0_PROPERTY,
	PHOTO_NUM_PROPERTIES
};
static GParamSpec* photo_properties[PHOTO_NUM_PROPERTIES];
#define _g_date_time_unref0(var) ((var == NULL) ? NULL : (var = (g_date_time_unref (var), NULL)))

#define PHOTO_TYPE_CACHED_PIXBUF (photo_cached_pixbuf_get_type ())
#define PHOTO_CACHED_PIXBUF(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), PHOTO_TYPE_CACHED_PIXBUF, PhotoCachedPixbuf))
#define PHOTO_CACHED_PIXBUF_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), PHOTO_TYPE_CACHED_PIXBUF, PhotoCachedPixbufClass))
#define PHOTO_IS_CACHED_PIXBUF(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), PHOTO_TYPE_CACHED_PIXBUF))
#define PHOTO_IS_CACHED_PIXBUF_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), PHOTO_TYPE_CACHED_PIXBUF))
#define PHOTO_CACHED_PIXBUF_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), PHOTO_TYPE_CACHED_PIXBUF, PhotoCachedPixbufClass))

typedef struct _PhotoCachedPixbuf PhotoCachedPixbuf;
typedef struct _PhotoCachedPixbufClass PhotoCachedPixbufClass;
#define _backing_photo_row_unref0(var) ((var == NULL) ? NULL : (var = (backing_photo_row_unref (var), NULL)))
#define _photo_backing_readers_unref0(var) ((var == NULL) ? NULL : (var = (photo_backing_readers_unref (var), NULL)))
#define _pixel_transformer_unref0(var) ((var == NULL) ? NULL : (var = (pixel_transformer_unref (var), NULL)))
#define _pixel_transformation_bundle_unref0(var) ((var == NULL) ? NULL : (var = (pixel_transformation_bundle_unref (var), NULL)))
#define _one_shot_scheduler_unref0(var) ((var == NULL) ? NULL : (var = (one_shot_scheduler_unref (var), NULL)))
typedef struct _PhotoRowPrivate PhotoRowPrivate;

#define TYPE_PHOTO_ID (photo_id_get_type ())
typedef struct _PhotoID PhotoID;
typedef enum  {
	ORIENTATION_MIN = 1,
	ORIENTATION_TOP_LEFT = 1,
	ORIENTATION_TOP_RIGHT = 2,
	ORIENTATION_BOTTOM_RIGHT = 3,
	ORIENTATION_BOTTOM_LEFT = 4,
	ORIENTATION_LEFT_TOP = 5,
	ORIENTATION_RIGHT_TOP = 6,
	ORIENTATION_RIGHT_BOTTOM = 7,
	ORIENTATION_LEFT_BOTTOM = 8,
	ORIENTATION_MAX = 8
} Orientation;

#define TYPE_ORIENTATION (orientation_get_type ())

#define TYPE_BACKING_PHOTO_ID (backing_photo_id_get_type ())
typedef struct _BackingPhotoID BackingPhotoID;
typedef struct _BackingPhotoRowPrivate BackingPhotoRowPrivate;

#define TYPE_PHOTO_FILE_ADAPTER (photo_file_adapter_get_type ())
#define PHOTO_FILE_ADAPTER(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_PHOTO_FILE_ADAPTER, PhotoFileAdapter))
#define PHOTO_FILE_ADAPTER_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_PHOTO_FILE_ADAPTER, PhotoFileAdapterClass))
#define IS_PHOTO_FILE_ADAPTER(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_PHOTO_FILE_ADAPTER))
#define IS_PHOTO_FILE_ADAPTER_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_PHOTO_FILE_ADAPTER))
#define PHOTO_FILE_ADAPTER_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_PHOTO_FILE_ADAPTER, PhotoFileAdapterClass))

typedef struct _PhotoFileAdapter PhotoFileAdapter;
typedef struct _PhotoFileAdapterClass PhotoFileAdapterClass;

#define TYPE_PHOTO_FILE_READER (photo_file_reader_get_type ())
#define PHOTO_FILE_READER(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_PHOTO_FILE_READER, PhotoFileReader))
#define PHOTO_FILE_READER_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_PHOTO_FILE_READER, PhotoFileReaderClass))
#define IS_PHOTO_FILE_READER(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_PHOTO_FILE_READER))
#define IS_PHOTO_FILE_READER_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_PHOTO_FILE_READER))
#define PHOTO_FILE_READER_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_PHOTO_FILE_READER, PhotoFileReaderClass))

typedef struct _PhotoFileReader PhotoFileReader;
typedef struct _PhotoFileReaderClass PhotoFileReaderClass;
typedef struct _PhotoBackingReadersPrivate PhotoBackingReadersPrivate;
#define _photo_file_adapter_unref0(var) ((var == NULL) ? NULL : (var = (photo_file_adapter_unref (var), NULL)))

#define TYPE_DATABASE_TABLE (database_table_get_type ())
#define DATABASE_TABLE(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_DATABASE_TABLE, DatabaseTable))
#define DATABASE_TABLE_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_DATABASE_TABLE, DatabaseTableClass))
#define IS_DATABASE_TABLE(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_DATABASE_TABLE))
#define IS_DATABASE_TABLE_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_DATABASE_TABLE))
#define DATABASE_TABLE_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_DATABASE_TABLE, DatabaseTableClass))

typedef struct _DatabaseTable DatabaseTable;
typedef struct _DatabaseTableClass DatabaseTableClass;

#define TYPE_PHOTO_TABLE (photo_table_get_type ())
#define PHOTO_TABLE(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_PHOTO_TABLE, PhotoTable))
#define PHOTO_TABLE_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_PHOTO_TABLE, PhotoTableClass))
#define IS_PHOTO_TABLE(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_PHOTO_TABLE))
#define IS_PHOTO_TABLE_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_PHOTO_TABLE))
#define PHOTO_TABLE_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_PHOTO_TABLE, PhotoTableClass))

typedef struct _PhotoTable PhotoTable;
typedef struct _PhotoTableClass PhotoTableClass;

#define TYPE_DATABASE_ERROR (database_error_get_type ())
#define _database_table_unref0(var) ((var == NULL) ? NULL : (var = (database_table_unref (var), NULL)))
#define _g_error_free0(var) ((var == NULL) ? NULL : (var = (g_error_free (var), NULL)))

#define TYPE_BACKING_PHOTO_TABLE (backing_photo_table_get_type ())
#define BACKING_PHOTO_TABLE(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_BACKING_PHOTO_TABLE, BackingPhotoTable))
#define BACKING_PHOTO_TABLE_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_BACKING_PHOTO_TABLE, BackingPhotoTableClass))
#define IS_BACKING_PHOTO_TABLE(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_BACKING_PHOTO_TABLE))
#define IS_BACKING_PHOTO_TABLE_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_BACKING_PHOTO_TABLE))
#define BACKING_PHOTO_TABLE_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_BACKING_PHOTO_TABLE, BackingPhotoTableClass))

typedef struct _BackingPhotoTable BackingPhotoTable;
typedef struct _BackingPhotoTableClass BackingPhotoTableClass;

#define TYPE_PHOTO_PREVIEW (photo_preview_get_type ())
#define PHOTO_PREVIEW(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_PHOTO_PREVIEW, PhotoPreview))
#define PHOTO_PREVIEW_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_PHOTO_PREVIEW, PhotoPreviewClass))
#define IS_PHOTO_PREVIEW(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_PHOTO_PREVIEW))
#define IS_PHOTO_PREVIEW_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_PHOTO_PREVIEW))
#define PHOTO_PREVIEW_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_PHOTO_PREVIEW, PhotoPreviewClass))

typedef struct _PhotoPreview PhotoPreview;
typedef struct _PhotoPreviewClass PhotoPreviewClass;
#define _photo_preview_unref0(var) ((var == NULL) ? NULL : (var = (photo_preview_unref (var), NULL)))
#define _media_metadata_unref0(var) ((var == NULL) ? NULL : (var = (media_metadata_unref (var), NULL)))
#define _alteration_unref0(var) ((var == NULL) ? NULL : (var = (alteration_unref (var), NULL)))

#define TYPE_PHOTO_FILE_INTERROGATOR (photo_file_interrogator_get_type ())
#define PHOTO_FILE_INTERROGATOR(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_PHOTO_FILE_INTERROGATOR, PhotoFileInterrogator))
#define PHOTO_FILE_INTERROGATOR_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_PHOTO_FILE_INTERROGATOR, PhotoFileInterrogatorClass))
#define IS_PHOTO_FILE_INTERROGATOR(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_PHOTO_FILE_INTERROGATOR))
#define IS_PHOTO_FILE_INTERROGATOR_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_PHOTO_FILE_INTERROGATOR))
#define PHOTO_FILE_INTERROGATOR_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_PHOTO_FILE_INTERROGATOR, PhotoFileInterrogatorClass))

typedef struct _PhotoFileInterrogator PhotoFileInterrogator;
typedef struct _PhotoFileInterrogatorClass PhotoFileInterrogatorClass;
#define _photo_file_interrogator_unref0(var) ((var == NULL) ? NULL : (var = (photo_file_interrogator_unref (var), NULL)))

#define TYPE_DETECTED_PHOTO_INFORMATION (detected_photo_information_get_type ())
#define DETECTED_PHOTO_INFORMATION(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_DETECTED_PHOTO_INFORMATION, DetectedPhotoInformation))
#define DETECTED_PHOTO_INFORMATION_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_DETECTED_PHOTO_INFORMATION, DetectedPhotoInformationClass))
#define IS_DETECTED_PHOTO_INFORMATION(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_DETECTED_PHOTO_INFORMATION))
#define IS_DETECTED_PHOTO_INFORMATION_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_DETECTED_PHOTO_INFORMATION))
#define DETECTED_PHOTO_INFORMATION_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_DETECTED_PHOTO_INFORMATION, DetectedPhotoInformationClass))

typedef struct _DetectedPhotoInformation DetectedPhotoInformation;
typedef struct _DetectedPhotoInformationClass DetectedPhotoInformationClass;
#define _detected_photo_information_unref0(var) ((var == NULL) ? NULL : (var = (detected_photo_information_unref (var), NULL)))
typedef struct _DetectedPhotoInformationPrivate DetectedPhotoInformationPrivate;

#define TYPE_PHOTO_FILE_WRITER (photo_file_writer_get_type ())
#define PHOTO_FILE_WRITER(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_PHOTO_FILE_WRITER, PhotoFileWriter))
#define PHOTO_FILE_WRITER_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_PHOTO_FILE_WRITER, PhotoFileWriterClass))
#define IS_PHOTO_FILE_WRITER(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_PHOTO_FILE_WRITER))
#define IS_PHOTO_FILE_WRITER_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_PHOTO_FILE_WRITER))
#define PHOTO_FILE_WRITER_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_PHOTO_FILE_WRITER, PhotoFileWriterClass))

typedef struct _PhotoFileWriter PhotoFileWriter;
typedef struct _PhotoFileWriterClass PhotoFileWriterClass;

#define TYPE_PHOTO_FORMAT_ERROR (photo_format_error_get_type ())
typedef enum  {
	JPEG_QUALITY_LOW = 50,
	JPEG_QUALITY_MEDIUM = 75,
	JPEG_QUALITY_HIGH = 90,
	JPEG_QUALITY_MAXIMUM = 100
} JpegQuality;

#define JPEG_TYPE_QUALITY (jpeg_quality_get_type ())

#define TYPE_PHOTO_FILE_METADATA_WRITER (photo_file_metadata_writer_get_type ())
#define PHOTO_FILE_METADATA_WRITER(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_PHOTO_FILE_METADATA_WRITER, PhotoFileMetadataWriter))
#define PHOTO_FILE_METADATA_WRITER_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_PHOTO_FILE_METADATA_WRITER, PhotoFileMetadataWriterClass))
#define IS_PHOTO_FILE_METADATA_WRITER(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_PHOTO_FILE_METADATA_WRITER))
#define IS_PHOTO_FILE_METADATA_WRITER_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_PHOTO_FILE_METADATA_WRITER))
#define PHOTO_FILE_METADATA_WRITER_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_PHOTO_FILE_METADATA_WRITER, PhotoFileMetadataWriterClass))

typedef struct _PhotoFileMetadataWriter PhotoFileMetadataWriter;
typedef struct _PhotoFileMetadataWriterClass PhotoFileMetadataWriterClass;
#define _g_bytes_unref0(var) ((var == NULL) ? NULL : (var = (g_bytes_unref (var), NULL)))

#define TYPE_EXPORT_FORMAT_PARAMETERS (export_format_parameters_get_type ())
typedef struct _ExportFormatParameters ExportFormatParameters;
typedef enum  {
	EXPORT_FORMAT_MODE_UNMODIFIED,
	EXPORT_FORMAT_MODE_CURRENT,
	EXPORT_FORMAT_MODE_SPECIFIED,
	EXPORT_FORMAT_MODE_LAST
} ExportFormatMode;

#define TYPE_EXPORT_FORMAT_MODE (export_format_mode_get_type ())
typedef enum  {
	IMPORT_RESULT_SUCCESS,
	IMPORT_RESULT_FILE_ERROR,
	IMPORT_RESULT_DECODE_ERROR,
	IMPORT_RESULT_DATABASE_ERROR,
	IMPORT_RESULT_USER_ABORT,
	IMPORT_RESULT_NOT_A_FILE,
	IMPORT_RESULT_PHOTO_EXISTS,
	IMPORT_RESULT_UNSUPPORTED_FORMAT,
	IMPORT_RESULT_NOT_AN_IMAGE,
	IMPORT_RESULT_DISK_FAILURE,
	IMPORT_RESULT_DISK_FULL,
	IMPORT_RESULT_CAMERA_ERROR,
	IMPORT_RESULT_FILE_WRITE_ERROR,
	IMPORT_RESULT_PIXBUF_CORRUPT_IMAGE
} ImportResult;

#define TYPE_IMPORT_RESULT (import_result_get_type ())
#define _metadata_date_time_unref0(var) ((var == NULL) ? NULL : (var = (metadata_date_time_unref (var), NULL)))
typedef enum  {
	PHOTO_FILE_READER_ROLE_DEFAULT,
	PHOTO_FILE_READER_ROLE_THUMBNAIL
} PhotoFileReaderRole;

#define PHOTO_FILE_READER_TYPE_ROLE (photo_file_reader_role_get_type ())

#define PHOTO_TYPE_REIMPORT_MASTER_STATE (photo_reimport_master_state_get_type ())
#define PHOTO_REIMPORT_MASTER_STATE(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), PHOTO_TYPE_REIMPORT_MASTER_STATE, PhotoReimportMasterState))
#define PHOTO_REIMPORT_MASTER_STATE_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), PHOTO_TYPE_REIMPORT_MASTER_STATE, PhotoReimportMasterStateClass))
#define PHOTO_IS_REIMPORT_MASTER_STATE(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), PHOTO_TYPE_REIMPORT_MASTER_STATE))
#define PHOTO_IS_REIMPORT_MASTER_STATE_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), PHOTO_TYPE_REIMPORT_MASTER_STATE))
#define PHOTO_REIMPORT_MASTER_STATE_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), PHOTO_TYPE_REIMPORT_MASTER_STATE, PhotoReimportMasterStateClass))

typedef struct _PhotoReimportMasterState PhotoReimportMasterState;
typedef struct _PhotoReimportMasterStateClass PhotoReimportMasterStateClass;
#define _photo_reimport_master_state_unref0(var) ((var == NULL) ? NULL : (var = (photo_reimport_master_state_unref (var), NULL)))

#define PHOTO_TYPE_REIMPORT_MASTER_STATE_IMPL (photo_reimport_master_state_impl_get_type ())
#define PHOTO_REIMPORT_MASTER_STATE_IMPL(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), PHOTO_TYPE_REIMPORT_MASTER_STATE_IMPL, PhotoReimportMasterStateImpl))
#define PHOTO_REIMPORT_MASTER_STATE_IMPL_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), PHOTO_TYPE_REIMPORT_MASTER_STATE_IMPL, PhotoReimportMasterStateImplClass))
#define PHOTO_IS_REIMPORT_MASTER_STATE_IMPL(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), PHOTO_TYPE_REIMPORT_MASTER_STATE_IMPL))
#define PHOTO_IS_REIMPORT_MASTER_STATE_IMPL_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), PHOTO_TYPE_REIMPORT_MASTER_STATE_IMPL))
#define PHOTO_REIMPORT_MASTER_STATE_IMPL_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), PHOTO_TYPE_REIMPORT_MASTER_STATE_IMPL, PhotoReimportMasterStateImplClass))

typedef struct _PhotoReimportMasterStateImpl PhotoReimportMasterStateImpl;
typedef struct _PhotoReimportMasterStateImplClass PhotoReimportMasterStateImplClass;
typedef struct _PhotoReimportMasterStatePrivate PhotoReimportMasterStatePrivate;
typedef struct _PhotoReimportMasterStateImplPrivate PhotoReimportMasterStateImplPrivate;

#define PHOTO_TYPE_REIMPORT_EDITABLE_STATE (photo_reimport_editable_state_get_type ())
#define PHOTO_REIMPORT_EDITABLE_STATE(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), PHOTO_TYPE_REIMPORT_EDITABLE_STATE, PhotoReimportEditableState))
#define PHOTO_REIMPORT_EDITABLE_STATE_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), PHOTO_TYPE_REIMPORT_EDITABLE_STATE, PhotoReimportEditableStateClass))
#define PHOTO_IS_REIMPORT_EDITABLE_STATE(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), PHOTO_TYPE_REIMPORT_EDITABLE_STATE))
#define PHOTO_IS_REIMPORT_EDITABLE_STATE_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), PHOTO_TYPE_REIMPORT_EDITABLE_STATE))
#define PHOTO_REIMPORT_EDITABLE_STATE_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), PHOTO_TYPE_REIMPORT_EDITABLE_STATE, PhotoReimportEditableStateClass))

typedef struct _PhotoReimportEditableState PhotoReimportEditableState;
typedef struct _PhotoReimportEditableStateClass PhotoReimportEditableStateClass;
#define _photo_reimport_editable_state_unref0(var) ((var == NULL) ? NULL : (var = (photo_reimport_editable_state_unref (var), NULL)))

#define PHOTO_TYPE_REIMPORT_EDITABLE_STATE_IMPL (photo_reimport_editable_state_impl_get_type ())
#define PHOTO_REIMPORT_EDITABLE_STATE_IMPL(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), PHOTO_TYPE_REIMPORT_EDITABLE_STATE_IMPL, PhotoReimportEditableStateImpl))
#define PHOTO_REIMPORT_EDITABLE_STATE_IMPL_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), PHOTO_TYPE_REIMPORT_EDITABLE_STATE_IMPL, PhotoReimportEditableStateImplClass))
#define PHOTO_IS_REIMPORT_EDITABLE_STATE_IMPL(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), PHOTO_TYPE_REIMPORT_EDITABLE_STATE_IMPL))
#define PHOTO_IS_REIMPORT_EDITABLE_STATE_IMPL_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), PHOTO_TYPE_REIMPORT_EDITABLE_STATE_IMPL))
#define PHOTO_REIMPORT_EDITABLE_STATE_IMPL_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), PHOTO_TYPE_REIMPORT_EDITABLE_STATE_IMPL, PhotoReimportEditableStateImplClass))

typedef struct _PhotoReimportEditableStateImpl PhotoReimportEditableStateImpl;
typedef struct _PhotoReimportEditableStateImplClass PhotoReimportEditableStateImplClass;
typedef struct _PhotoReimportEditableStatePrivate PhotoReimportEditableStatePrivate;
typedef struct _PhotoReimportEditableStateImplPrivate PhotoReimportEditableStateImplPrivate;

#define PHOTO_TYPE_REIMPORT_RAW_DEVELOPMENT_STATE (photo_reimport_raw_development_state_get_type ())
#define PHOTO_REIMPORT_RAW_DEVELOPMENT_STATE(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), PHOTO_TYPE_REIMPORT_RAW_DEVELOPMENT_STATE, PhotoReimportRawDevelopmentState))
#define PHOTO_REIMPORT_RAW_DEVELOPMENT_STATE_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), PHOTO_TYPE_REIMPORT_RAW_DEVELOPMENT_STATE, PhotoReimportRawDevelopmentStateClass))
#define PHOTO_IS_REIMPORT_RAW_DEVELOPMENT_STATE(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), PHOTO_TYPE_REIMPORT_RAW_DEVELOPMENT_STATE))
#define PHOTO_IS_REIMPORT_RAW_DEVELOPMENT_STATE_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), PHOTO_TYPE_REIMPORT_RAW_DEVELOPMENT_STATE))
#define PHOTO_REIMPORT_RAW_DEVELOPMENT_STATE_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), PHOTO_TYPE_REIMPORT_RAW_DEVELOPMENT_STATE, PhotoReimportRawDevelopmentStateClass))

typedef struct _PhotoReimportRawDevelopmentState PhotoReimportRawDevelopmentState;
typedef struct _PhotoReimportRawDevelopmentStateClass PhotoReimportRawDevelopmentStateClass;
#define _photo_reimport_raw_development_state_unref0(var) ((var == NULL) ? NULL : (var = (photo_reimport_raw_development_state_unref (var), NULL)))

#define PHOTO_TYPE_REIMPORT_RAW_DEVELOPMENT_STATE_IMPL (photo_reimport_raw_development_state_impl_get_type ())
#define PHOTO_REIMPORT_RAW_DEVELOPMENT_STATE_IMPL(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), PHOTO_TYPE_REIMPORT_RAW_DEVELOPMENT_STATE_IMPL, PhotoReimportRawDevelopmentStateImpl))
#define PHOTO_REIMPORT_RAW_DEVELOPMENT_STATE_IMPL_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), PHOTO_TYPE_REIMPORT_RAW_DEVELOPMENT_STATE_IMPL, PhotoReimportRawDevelopmentStateImplClass))
#define PHOTO_IS_REIMPORT_RAW_DEVELOPMENT_STATE_IMPL(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), PHOTO_TYPE_REIMPORT_RAW_DEVELOPMENT_STATE_IMPL))
#define PHOTO_IS_REIMPORT_RAW_DEVELOPMENT_STATE_IMPL_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), PHOTO_TYPE_REIMPORT_RAW_DEVELOPMENT_STATE_IMPL))
#define PHOTO_REIMPORT_RAW_DEVELOPMENT_STATE_IMPL_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), PHOTO_TYPE_REIMPORT_RAW_DEVELOPMENT_STATE_IMPL, PhotoReimportRawDevelopmentStateImplClass))

typedef struct _PhotoReimportRawDevelopmentStateImpl PhotoReimportRawDevelopmentStateImpl;
typedef struct _PhotoReimportRawDevelopmentStateImplClass PhotoReimportRawDevelopmentStateImplClass;

#define PHOTO_REIMPORT_RAW_DEVELOPMENT_STATE_IMPL_TYPE_DEV_TO_REIMPORT (photo_reimport_raw_development_state_impl_dev_to_reimport_get_type ())
#define PHOTO_REIMPORT_RAW_DEVELOPMENT_STATE_IMPL_DEV_TO_REIMPORT(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), PHOTO_REIMPORT_RAW_DEVELOPMENT_STATE_IMPL_TYPE_DEV_TO_REIMPORT, PhotoReimportRawDevelopmentStateImplDevToReimport))
#define PHOTO_REIMPORT_RAW_DEVELOPMENT_STATE_IMPL_DEV_TO_REIMPORT_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), PHOTO_REIMPORT_RAW_DEVELOPMENT_STATE_IMPL_TYPE_DEV_TO_REIMPORT, PhotoReimportRawDevelopmentStateImplDevToReimportClass))
#define PHOTO_REIMPORT_RAW_DEVELOPMENT_STATE_IMPL_IS_DEV_TO_REIMPORT(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), PHOTO_REIMPORT_RAW_DEVELOPMENT_STATE_IMPL_TYPE_DEV_TO_REIMPORT))
#define PHOTO_REIMPORT_RAW_DEVELOPMENT_STATE_IMPL_IS_DEV_TO_REIMPORT_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), PHOTO_REIMPORT_RAW_DEVELOPMENT_STATE_IMPL_TYPE_DEV_TO_REIMPORT))
#define PHOTO_REIMPORT_RAW_DEVELOPMENT_STATE_IMPL_DEV_TO_REIMPORT_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), PHOTO_REIMPORT_RAW_DEVELOPMENT_STATE_IMPL_TYPE_DEV_TO_REIMPORT, PhotoReimportRawDevelopmentStateImplDevToReimportClass))

typedef struct _PhotoReimportRawDevelopmentStateImplDevToReimport PhotoReimportRawDevelopmentStateImplDevToReimport;
typedef struct _PhotoReimportRawDevelopmentStateImplDevToReimportClass PhotoReimportRawDevelopmentStateImplDevToReimportClass;
typedef struct _PhotoReimportRawDevelopmentStatePrivate PhotoReimportRawDevelopmentStatePrivate;
typedef struct _PhotoReimportRawDevelopmentStateImplPrivate PhotoReimportRawDevelopmentStateImplPrivate;
typedef struct _PhotoReimportRawDevelopmentStateImplDevToReimportPrivate PhotoReimportRawDevelopmentStateImplDevToReimportPrivate;
#define _photo_reimport_raw_development_state_impl_dev_to_reimport_unref0(var) ((var == NULL) ? NULL : (var = (photo_reimport_raw_development_state_impl_dev_to_reimport_unref (var), NULL)))

#define TYPE_LIBRARY_PHOTO (library_photo_get_type ())
#define LIBRARY_PHOTO(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_LIBRARY_PHOTO, LibraryPhoto))
#define LIBRARY_PHOTO_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_LIBRARY_PHOTO, LibraryPhotoClass))
#define IS_LIBRARY_PHOTO(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_LIBRARY_PHOTO))
#define IS_LIBRARY_PHOTO_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_LIBRARY_PHOTO))
#define LIBRARY_PHOTO_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_LIBRARY_PHOTO, LibraryPhotoClass))

typedef struct _LibraryPhoto LibraryPhoto;
typedef struct _LibraryPhotoClass LibraryPhotoClass;
typedef enum  {
	PHOTO_METADATA_SET_OPTION_ALL_DOMAINS,
	PHOTO_METADATA_SET_OPTION_ONLY_IF_DOMAIN_PRESENT,
	PHOTO_METADATA_SET_OPTION_AT_LEAST_DEFAULT_DOMAIN
} PhotoMetadataSetOption;

#define PHOTO_METADATA_TYPE_SET_OPTION (photo_metadata_set_option_get_type ())

#define TYPE_BOX (box_get_type ())
typedef struct _Box Box;
#define _key_value_map_unref0(var) ((var == NULL) ? NULL : (var = (key_value_map_unref (var), NULL)))
#define _pixel_transformation_unref0(var) ((var == NULL) ? NULL : (var = (pixel_transformation_unref (var), NULL)))

#define PHOTO_TYPE_PHOTO_TRANSFORMATION_STATE_IMPL (photo_photo_transformation_state_impl_get_type ())
#define PHOTO_PHOTO_TRANSFORMATION_STATE_IMPL(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), PHOTO_TYPE_PHOTO_TRANSFORMATION_STATE_IMPL, PhotoPhotoTransformationStateImpl))
#define PHOTO_PHOTO_TRANSFORMATION_STATE_IMPL_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), PHOTO_TYPE_PHOTO_TRANSFORMATION_STATE_IMPL, PhotoPhotoTransformationStateImplClass))
#define PHOTO_IS_PHOTO_TRANSFORMATION_STATE_IMPL(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), PHOTO_TYPE_PHOTO_TRANSFORMATION_STATE_IMPL))
#define PHOTO_IS_PHOTO_TRANSFORMATION_STATE_IMPL_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), PHOTO_TYPE_PHOTO_TRANSFORMATION_STATE_IMPL))
#define PHOTO_PHOTO_TRANSFORMATION_STATE_IMPL_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), PHOTO_TYPE_PHOTO_TRANSFORMATION_STATE_IMPL, PhotoPhotoTransformationStateImplClass))

typedef struct _PhotoPhotoTransformationStateImpl PhotoPhotoTransformationStateImpl;
typedef struct _PhotoPhotoTransformationStateImplClass PhotoPhotoTransformationStateImplClass;

#define EDITING_TOOLS_TYPE_REDEYE_INSTANCE (editing_tools_redeye_instance_get_type ())
typedef struct _EditingToolsRedeyeInstance EditingToolsRedeyeInstance;
typedef struct _PhotoCachedPixbufPrivate PhotoCachedPixbufPrivate;
#define _photo_cached_pixbuf_unref0(var) ((var == NULL) ? NULL : (var = (photo_cached_pixbuf_unref (var), NULL)))

#define TYPE_PHOTO_FILE_FORMAT_PROPERTIES (photo_file_format_properties_get_type ())
#define PHOTO_FILE_FORMAT_PROPERTIES(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_PHOTO_FILE_FORMAT_PROPERTIES, PhotoFileFormatProperties))
#define PHOTO_FILE_FORMAT_PROPERTIES_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_PHOTO_FILE_FORMAT_PROPERTIES, PhotoFileFormatPropertiesClass))
#define IS_PHOTO_FILE_FORMAT_PROPERTIES(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_PHOTO_FILE_FORMAT_PROPERTIES))
#define IS_PHOTO_FILE_FORMAT_PROPERTIES_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_PHOTO_FILE_FORMAT_PROPERTIES))
#define PHOTO_FILE_FORMAT_PROPERTIES_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_PHOTO_FILE_FORMAT_PROPERTIES, PhotoFileFormatPropertiesClass))

typedef struct _PhotoFileFormatProperties PhotoFileFormatProperties;
typedef struct _PhotoFileFormatPropertiesClass PhotoFileFormatPropertiesClass;
#define _photo_file_format_properties_unref0(var) ((var == NULL) ? NULL : (var = (photo_file_format_properties_unref (var), NULL)))

#define TYPE_CONFIGURATION_FACADE (configuration_facade_get_type ())
#define CONFIGURATION_FACADE(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_CONFIGURATION_FACADE, ConfigurationFacade))
#define CONFIGURATION_FACADE_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_CONFIGURATION_FACADE, ConfigurationFacadeClass))
#define IS_CONFIGURATION_FACADE(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_CONFIGURATION_FACADE))
#define IS_CONFIGURATION_FACADE_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_CONFIGURATION_FACADE))
#define CONFIGURATION_FACADE_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_CONFIGURATION_FACADE, ConfigurationFacadeClass))

typedef struct _ConfigurationFacade ConfigurationFacade;
typedef struct _ConfigurationFacadeClass ConfigurationFacadeClass;

#define CONFIG_TYPE_FACADE (config_facade_get_type ())
#define CONFIG_FACADE(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), CONFIG_TYPE_FACADE, ConfigFacade))
#define CONFIG_FACADE_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), CONFIG_TYPE_FACADE, ConfigFacadeClass))
#define CONFIG_IS_FACADE(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), CONFIG_TYPE_FACADE))
#define CONFIG_IS_FACADE_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), CONFIG_TYPE_FACADE))
#define CONFIG_FACADE_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), CONFIG_TYPE_FACADE, ConfigFacadeClass))

typedef struct _ConfigFacade ConfigFacade;
typedef struct _ConfigFacadeClass ConfigFacadeClass;
typedef void (*OneShotCallback) (gpointer user_data);
typedef struct _PhotoPhotoTransformationStateImplPrivate PhotoPhotoTransformationStateImplPrivate;
enum  {
	PHOTO_PHOTO_TRANSFORMATION_STATE_IMPL_0_PROPERTY,
	PHOTO_PHOTO_TRANSFORMATION_STATE_IMPL_NUM_PROPERTIES
};
static GParamSpec* photo_photo_transformation_state_impl_properties[PHOTO_PHOTO_TRANSFORMATION_STATE_IMPL_NUM_PROPERTIES];
typedef struct _PhotoParamSpecBackingReaders PhotoParamSpecBackingReaders;
#define _g_timer_destroy0(var) ((var == NULL) ? NULL : (var = (g_timer_destroy (var), NULL)))
typedef struct _PhotoParamSpecCachedPixbuf PhotoParamSpecCachedPixbuf;
typedef struct _PhotoParamSpecReimportMasterState PhotoParamSpecReimportMasterState;
typedef struct _PhotoParamSpecReimportEditableState PhotoParamSpecReimportEditableState;
typedef struct _PhotoParamSpecReimportRawDevelopmentState PhotoParamSpecReimportRawDevelopmentState;
typedef struct _PhotoReimportRawDevelopmentStateImplParamSpecDevToReimport PhotoReimportRawDevelopmentStateImplParamSpecDevToReimport;
enum  {
	PHOTO_EDITABLE_REPLACED_SIGNAL,
	PHOTO_RAW_DEVELOPMENT_MODIFIED_SIGNAL,
	PHOTO_BASELINE_REPLACED_SIGNAL,
	PHOTO_MASTER_REIMPORTED_SIGNAL,
	PHOTO_EDITABLE_REIMPORTED_SIGNAL,
	PHOTO_BASELINE_REIMPORTED_SIGNAL,
	PHOTO_SOURCE_REIMPORTED_SIGNAL,
	PHOTO_NUM_SIGNALS
};
static guint photo_signals[PHOTO_NUM_SIGNALS] = {0};
typedef struct _DataCollectionPrivate DataCollectionPrivate;
typedef gint64 (*Comparator) (void* a, void* b, gpointer user_data);
typedef gboolean (*ComparatorPredicate) (DataObject* object, Alteration* alteration, gpointer user_data);
typedef gboolean (*ProgressMonitor) (guint64 current, guint64 total, gboolean do_event_loop, gpointer user_data);

#define TYPE_MARKER (marker_get_type ())
#define MARKER(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_MARKER, Marker))
#define IS_MARKER(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_MARKER))
#define MARKER_GET_INTERFACE(obj) (G_TYPE_INSTANCE_GET_INTERFACE ((obj), TYPE_MARKER, MarkerIface))

typedef struct _Marker Marker;
typedef struct _MarkerIface MarkerIface;
typedef struct _SourceCollectionPrivate SourceCollectionPrivate;

#define TYPE_SOURCE_BACKLINK (source_backlink_get_type ())
#define SOURCE_BACKLINK(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_SOURCE_BACKLINK, SourceBacklink))
#define SOURCE_BACKLINK_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_SOURCE_BACKLINK, SourceBacklinkClass))
#define IS_SOURCE_BACKLINK(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_SOURCE_BACKLINK))
#define IS_SOURCE_BACKLINK_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_SOURCE_BACKLINK))
#define SOURCE_BACKLINK_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_SOURCE_BACKLINK, SourceBacklinkClass))

typedef struct _SourceBacklink SourceBacklink;
typedef struct _SourceBacklinkClass SourceBacklinkClass;

#define TYPE_DATABASE_SOURCE_COLLECTION (database_source_collection_get_type ())
#define DATABASE_SOURCE_COLLECTION(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_DATABASE_SOURCE_COLLECTION, DatabaseSourceCollection))
#define DATABASE_SOURCE_COLLECTION_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_DATABASE_SOURCE_COLLECTION, DatabaseSourceCollectionClass))
#define IS_DATABASE_SOURCE_COLLECTION(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_DATABASE_SOURCE_COLLECTION))
#define IS_DATABASE_SOURCE_COLLECTION_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_DATABASE_SOURCE_COLLECTION))
#define DATABASE_SOURCE_COLLECTION_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_DATABASE_SOURCE_COLLECTION, DatabaseSourceCollectionClass))

typedef struct _DatabaseSourceCollection DatabaseSourceCollection;
typedef struct _DatabaseSourceCollectionClass DatabaseSourceCollectionClass;
typedef struct _DatabaseSourceCollectionPrivate DatabaseSourceCollectionPrivate;

#define TYPE_MEDIA_SOURCE_COLLECTION (media_source_collection_get_type ())
#define MEDIA_SOURCE_COLLECTION(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_MEDIA_SOURCE_COLLECTION, MediaSourceCollection))
#define MEDIA_SOURCE_COLLECTION_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_MEDIA_SOURCE_COLLECTION, MediaSourceCollectionClass))
#define IS_MEDIA_SOURCE_COLLECTION(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_MEDIA_SOURCE_COLLECTION))
#define IS_MEDIA_SOURCE_COLLECTION_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_MEDIA_SOURCE_COLLECTION))
#define MEDIA_SOURCE_COLLECTION_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_MEDIA_SOURCE_COLLECTION, MediaSourceCollectionClass))

typedef struct _MediaSourceCollection MediaSourceCollection;
typedef struct _MediaSourceCollectionClass MediaSourceCollectionClass;
typedef struct _MediaSourceCollectionPrivate MediaSourceCollectionPrivate;

#define TYPE_DATABASE_SOURCE_HOLDING_TANK (database_source_holding_tank_get_type ())
#define DATABASE_SOURCE_HOLDING_TANK(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_DATABASE_SOURCE_HOLDING_TANK, DatabaseSourceHoldingTank))
#define DATABASE_SOURCE_HOLDING_TANK_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_DATABASE_SOURCE_HOLDING_TANK, DatabaseSourceHoldingTankClass))
#define IS_DATABASE_SOURCE_HOLDING_TANK(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_DATABASE_SOURCE_HOLDING_TANK))
#define IS_DATABASE_SOURCE_HOLDING_TANK_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_DATABASE_SOURCE_HOLDING_TANK))
#define DATABASE_SOURCE_HOLDING_TANK_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_DATABASE_SOURCE_HOLDING_TANK, DatabaseSourceHoldingTankClass))

typedef struct _DatabaseSourceHoldingTank DatabaseSourceHoldingTank;
typedef struct _DatabaseSourceHoldingTankClass DatabaseSourceHoldingTankClass;

#define TYPE_MEDIA_SOURCE_HOLDING_TANK (media_source_holding_tank_get_type ())
#define MEDIA_SOURCE_HOLDING_TANK(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_MEDIA_SOURCE_HOLDING_TANK, MediaSourceHoldingTank))
#define MEDIA_SOURCE_HOLDING_TANK_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_MEDIA_SOURCE_HOLDING_TANK, MediaSourceHoldingTankClass))
#define IS_MEDIA_SOURCE_HOLDING_TANK(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_MEDIA_SOURCE_HOLDING_TANK))
#define IS_MEDIA_SOURCE_HOLDING_TANK_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_MEDIA_SOURCE_HOLDING_TANK))
#define MEDIA_SOURCE_HOLDING_TANK_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_MEDIA_SOURCE_HOLDING_TANK, MediaSourceHoldingTankClass))

typedef struct _MediaSourceHoldingTank MediaSourceHoldingTank;
typedef struct _MediaSourceHoldingTankClass MediaSourceHoldingTankClass;

#define TYPE_WORKERS (workers_get_type ())
#define WORKERS(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_WORKERS, Workers))
#define WORKERS_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_WORKERS, WorkersClass))
#define IS_WORKERS(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_WORKERS))
#define IS_WORKERS_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_WORKERS))
#define WORKERS_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_WORKERS, WorkersClass))

typedef struct _Workers Workers;
typedef struct _WorkersClass WorkersClass;

#define TYPE_MEDIA_MONITOR (media_monitor_get_type ())
#define MEDIA_MONITOR(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_MEDIA_MONITOR, MediaMonitor))
#define MEDIA_MONITOR_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_MEDIA_MONITOR, MediaMonitorClass))
#define IS_MEDIA_MONITOR(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_MEDIA_MONITOR))
#define IS_MEDIA_MONITOR_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_MEDIA_MONITOR))
#define MEDIA_MONITOR_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_MEDIA_MONITOR, MediaMonitorClass))

typedef struct _MediaMonitor MediaMonitor;
typedef struct _MediaMonitorClass MediaMonitorClass;

#define TYPE_TRANSACTION_CONTROLLER (transaction_controller_get_type ())
#define TRANSACTION_CONTROLLER(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_TRANSACTION_CONTROLLER, TransactionController))
#define TRANSACTION_CONTROLLER_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_TRANSACTION_CONTROLLER, TransactionControllerClass))
#define IS_TRANSACTION_CONTROLLER(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_TRANSACTION_CONTROLLER))
#define IS_TRANSACTION_CONTROLLER_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_TRANSACTION_CONTROLLER))
#define TRANSACTION_CONTROLLER_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_TRANSACTION_CONTROLLER, TransactionControllerClass))

typedef struct _TransactionController TransactionController;
typedef struct _TransactionControllerClass TransactionControllerClass;

#define TYPE_LIBRARY_PHOTO_SOURCE_COLLECTION (library_photo_source_collection_get_type ())
#define LIBRARY_PHOTO_SOURCE_COLLECTION(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_LIBRARY_PHOTO_SOURCE_COLLECTION, LibraryPhotoSourceCollection))
#define LIBRARY_PHOTO_SOURCE_COLLECTION_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_LIBRARY_PHOTO_SOURCE_COLLECTION, LibraryPhotoSourceCollectionClass))
#define IS_LIBRARY_PHOTO_SOURCE_COLLECTION(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_LIBRARY_PHOTO_SOURCE_COLLECTION))
#define IS_LIBRARY_PHOTO_SOURCE_COLLECTION_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_LIBRARY_PHOTO_SOURCE_COLLECTION))
#define LIBRARY_PHOTO_SOURCE_COLLECTION_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_LIBRARY_PHOTO_SOURCE_COLLECTION, LibraryPhotoSourceCollectionClass))

typedef struct _LibraryPhotoSourceCollection LibraryPhotoSourceCollection;
typedef struct _LibraryPhotoSourceCollectionClass LibraryPhotoSourceCollectionClass;
typedef struct _LibraryPhotoSourceCollectionPrivate LibraryPhotoSourceCollectionPrivate;
typedef enum  {
	LIBRARY_PHOTO_SOURCE_COLLECTION_STATE_UNKNOWN,
	LIBRARY_PHOTO_SOURCE_COLLECTION_STATE_ONLINE,
	LIBRARY_PHOTO_SOURCE_COLLECTION_STATE_OFFLINE,
	LIBRARY_PHOTO_SOURCE_COLLECTION_STATE_TRASH,
	LIBRARY_PHOTO_SOURCE_COLLECTION_STATE_EDITABLE,
	LIBRARY_PHOTO_SOURCE_COLLECTION_STATE_DEVELOPER
} LibraryPhotoSourceCollectionState;

#define LIBRARY_PHOTO_SOURCE_COLLECTION_TYPE_STATE (library_photo_source_collection_state_get_type ())
#define _transaction_controller_unref0(var) ((var == NULL) ? NULL : (var = (transaction_controller_unref (var), NULL)))
typedef gint64 (*GetSourceDatabaseKey) (DataSource* source, gpointer user_data);
#define _source_holding_tank_unref0(var) ((var == NULL) ? NULL : (var = (source_holding_tank_unref (var), NULL)))
typedef gboolean (*SourceHoldingTankCheckToKeep) (DataSource* source, Alteration* alteration, gpointer user_data);

#define TYPE_LIBRARY_PHOTO_SOURCE_HOLDING_TANK (library_photo_source_holding_tank_get_type ())
#define LIBRARY_PHOTO_SOURCE_HOLDING_TANK(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_LIBRARY_PHOTO_SOURCE_HOLDING_TANK, LibraryPhotoSourceHoldingTank))
#define LIBRARY_PHOTO_SOURCE_HOLDING_TANK_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_LIBRARY_PHOTO_SOURCE_HOLDING_TANK, LibraryPhotoSourceHoldingTankClass))
#define IS_LIBRARY_PHOTO_SOURCE_HOLDING_TANK(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_LIBRARY_PHOTO_SOURCE_HOLDING_TANK))
#define IS_LIBRARY_PHOTO_SOURCE_HOLDING_TANK_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_LIBRARY_PHOTO_SOURCE_HOLDING_TANK))
#define LIBRARY_PHOTO_SOURCE_HOLDING_TANK_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_LIBRARY_PHOTO_SOURCE_HOLDING_TANK, LibraryPhotoSourceHoldingTankClass))

typedef struct _LibraryPhotoSourceHoldingTank LibraryPhotoSourceHoldingTank;
typedef struct _LibraryPhotoSourceHoldingTankClass LibraryPhotoSourceHoldingTankClass;

#define TYPE_PHOTO_MONITOR (photo_monitor_get_type ())
#define PHOTO_MONITOR(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_PHOTO_MONITOR, PhotoMonitor))
#define PHOTO_MONITOR_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_PHOTO_MONITOR, PhotoMonitorClass))
#define IS_PHOTO_MONITOR(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_PHOTO_MONITOR))
#define IS_PHOTO_MONITOR_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_PHOTO_MONITOR))
#define PHOTO_MONITOR_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_PHOTO_MONITOR, PhotoMonitorClass))

typedef struct _PhotoMonitor PhotoMonitor;
typedef struct _PhotoMonitorClass PhotoMonitorClass;

#define TYPE_TAG (tag_get_type ())
#define TAG(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_TAG, Tag))
#define TAG_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_TAG, TagClass))
#define IS_TAG(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_TAG))
#define IS_TAG_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_TAG))
#define TAG_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_TAG, TagClass))

typedef struct _Tag Tag;
typedef struct _TagClass TagClass;

#define TYPE_HIERARCHICAL_TAG_INDEX (hierarchical_tag_index_get_type ())
#define HIERARCHICAL_TAG_INDEX(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_HIERARCHICAL_TAG_INDEX, HierarchicalTagIndex))
#define HIERARCHICAL_TAG_INDEX_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_HIERARCHICAL_TAG_INDEX, HierarchicalTagIndexClass))
#define IS_HIERARCHICAL_TAG_INDEX(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_HIERARCHICAL_TAG_INDEX))
#define IS_HIERARCHICAL_TAG_INDEX_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_HIERARCHICAL_TAG_INDEX))
#define HIERARCHICAL_TAG_INDEX_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_HIERARCHICAL_TAG_INDEX, HierarchicalTagIndexClass))

typedef struct _HierarchicalTagIndex HierarchicalTagIndex;
typedef struct _HierarchicalTagIndexClass HierarchicalTagIndexClass;
#define _hierarchical_tag_index_unref0(var) ((var == NULL) ? NULL : (var = (hierarchical_tag_index_unref (var), NULL)))

#define TYPE_MEDIA_SOURCE_TRANSACTION_CONTROLLER (media_source_transaction_controller_get_type ())
#define MEDIA_SOURCE_TRANSACTION_CONTROLLER(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_MEDIA_SOURCE_TRANSACTION_CONTROLLER, MediaSourceTransactionController))
#define MEDIA_SOURCE_TRANSACTION_CONTROLLER_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_MEDIA_SOURCE_TRANSACTION_CONTROLLER, MediaSourceTransactionControllerClass))
#define IS_MEDIA_SOURCE_TRANSACTION_CONTROLLER(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_MEDIA_SOURCE_TRANSACTION_CONTROLLER))
#define IS_MEDIA_SOURCE_TRANSACTION_CONTROLLER_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_MEDIA_SOURCE_TRANSACTION_CONTROLLER))
#define MEDIA_SOURCE_TRANSACTION_CONTROLLER_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_MEDIA_SOURCE_TRANSACTION_CONTROLLER, MediaSourceTransactionControllerClass))

typedef struct _MediaSourceTransactionController MediaSourceTransactionController;
typedef struct _MediaSourceTransactionControllerClass MediaSourceTransactionControllerClass;
enum  {
	LIBRARY_PHOTO_SOURCE_COLLECTION_MASTER_REIMPORTED_SIGNAL,
	LIBRARY_PHOTO_SOURCE_COLLECTION_EDITABLE_REIMPORTED_SIGNAL,
	LIBRARY_PHOTO_SOURCE_COLLECTION_BASELINE_REIMPORTED_SIGNAL,
	LIBRARY_PHOTO_SOURCE_COLLECTION_SOURCE_REIMPORTED_SIGNAL,
	LIBRARY_PHOTO_SOURCE_COLLECTION_NUM_SIGNALS
};
static guint library_photo_source_collection_signals[LIBRARY_PHOTO_SOURCE_COLLECTION_NUM_SIGNALS] = {0};

#define TYPE_FLAGGABLE (flaggable_get_type ())
#define FLAGGABLE(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_FLAGGABLE, Flaggable))
#define IS_FLAGGABLE(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_FLAGGABLE))
#define FLAGGABLE_GET_INTERFACE(obj) (G_TYPE_INSTANCE_GET_INTERFACE ((obj), TYPE_FLAGGABLE, FlaggableIface))

typedef struct _Flaggable Flaggable;
typedef struct _FlaggableIface FlaggableIface;

#define TYPE_MONITORABLE (monitorable_get_type ())
#define MONITORABLE(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_MONITORABLE, Monitorable))
#define IS_MONITORABLE(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_MONITORABLE))
#define MONITORABLE_GET_INTERFACE(obj) (G_TYPE_INSTANCE_GET_INTERFACE ((obj), TYPE_MONITORABLE, MonitorableIface))

typedef struct _Monitorable Monitorable;
typedef struct _MonitorableIface MonitorableIface;
typedef struct _LibraryPhotoPrivate LibraryPhotoPrivate;
enum  {
	LIBRARY_PHOTO_0_PROPERTY,
	LIBRARY_PHOTO_NUM_PROPERTIES
};
static GParamSpec* library_photo_properties[LIBRARY_PHOTO_NUM_PROPERTIES];
#define _data_collection_unref0(var) ((var == NULL) ? NULL : (var = (data_collection_unref (var), NULL)))
typedef enum  {
	THUMBNAIL_CACHE_SIZE_LARGEST = 512,
	THUMBNAIL_CACHE_SIZE_LARGE = 512,
	THUMBNAIL_CACHE_SIZE_BIG = 360,
	THUMBNAIL_CACHE_SIZE_MEDIUM = 128,
	THUMBNAIL_CACHE_SIZE_SMALLEST = 128
} ThumbnailCacheSize;

#define THUMBNAIL_CACHE_TYPE_SIZE (thumbnail_cache_size_get_type ())

#define TYPE_EVENT_SOURCE (event_source_get_type ())
#define EVENT_SOURCE(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_EVENT_SOURCE, EventSource))
#define EVENT_SOURCE_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_EVENT_SOURCE, EventSourceClass))
#define IS_EVENT_SOURCE(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_EVENT_SOURCE))
#define IS_EVENT_SOURCE_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_EVENT_SOURCE))
#define EVENT_SOURCE_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_EVENT_SOURCE, EventSourceClass))

typedef struct _EventSource EventSource;
typedef struct _EventSourceClass EventSourceClass;

#define TYPE_EVENT (event_get_type ())
#define EVENT(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_EVENT, Event))
#define EVENT_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_EVENT, EventClass))
#define IS_EVENT(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_EVENT))
#define IS_EVENT_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_EVENT))
#define EVENT_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_EVENT, EventClass))

typedef struct _Event Event;
typedef struct _EventClass EventClass;

#define TYPE_CONTAINER_SOURCE_COLLECTION (container_source_collection_get_type ())
#define CONTAINER_SOURCE_COLLECTION(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_CONTAINER_SOURCE_COLLECTION, ContainerSourceCollection))
#define CONTAINER_SOURCE_COLLECTION_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_CONTAINER_SOURCE_COLLECTION, ContainerSourceCollectionClass))
#define IS_CONTAINER_SOURCE_COLLECTION(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_CONTAINER_SOURCE_COLLECTION))
#define IS_CONTAINER_SOURCE_COLLECTION_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_CONTAINER_SOURCE_COLLECTION))
#define CONTAINER_SOURCE_COLLECTION_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_CONTAINER_SOURCE_COLLECTION, ContainerSourceCollectionClass))

typedef struct _ContainerSourceCollection ContainerSourceCollection;
typedef struct _ContainerSourceCollectionClass ContainerSourceCollectionClass;

#define TYPE_TAG_SOURCE_COLLECTION (tag_source_collection_get_type ())
#define TAG_SOURCE_COLLECTION(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_TAG_SOURCE_COLLECTION, TagSourceCollection))
#define TAG_SOURCE_COLLECTION_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_TAG_SOURCE_COLLECTION, TagSourceCollectionClass))
#define IS_TAG_SOURCE_COLLECTION(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_TAG_SOURCE_COLLECTION))
#define IS_TAG_SOURCE_COLLECTION_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_TAG_SOURCE_COLLECTION))
#define TAG_SOURCE_COLLECTION_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_TAG_SOURCE_COLLECTION, TagSourceCollectionClass))

typedef struct _TagSourceCollection TagSourceCollection;
typedef struct _TagSourceCollectionClass TagSourceCollectionClass;

#define TYPE_FACE (face_get_type ())
#define FACE(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_FACE, Face))
#define FACE_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_FACE, FaceClass))
#define IS_FACE(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_FACE))
#define IS_FACE_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_FACE))
#define FACE_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_FACE, FaceClass))

typedef struct _Face Face;
typedef struct _FaceClass FaceClass;

#define TYPE_FACE_SOURCE_COLLECTION (face_source_collection_get_type ())
#define FACE_SOURCE_COLLECTION(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_FACE_SOURCE_COLLECTION, FaceSourceCollection))
#define FACE_SOURCE_COLLECTION_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_FACE_SOURCE_COLLECTION, FaceSourceCollectionClass))
#define IS_FACE_SOURCE_COLLECTION(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_FACE_SOURCE_COLLECTION))
#define IS_FACE_SOURCE_COLLECTION_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_FACE_SOURCE_COLLECTION))
#define FACE_SOURCE_COLLECTION_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_FACE_SOURCE_COLLECTION, FaceSourceCollectionClass))

typedef struct _FaceSourceCollection FaceSourceCollection;
typedef struct _FaceSourceCollectionClass FaceSourceCollectionClass;

#define TYPE_FACE_LOCATION (face_location_get_type ())
#define FACE_LOCATION(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_FACE_LOCATION, FaceLocation))
#define FACE_LOCATION_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_FACE_LOCATION, FaceLocationClass))
#define IS_FACE_LOCATION(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_FACE_LOCATION))
#define IS_FACE_LOCATION_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_FACE_LOCATION))
#define FACE_LOCATION_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_FACE_LOCATION, FaceLocationClass))

typedef struct _FaceLocation FaceLocation;
typedef struct _FaceLocationClass FaceLocationClass;

#define TYPE_FACE_ID (face_id_get_type ())
typedef struct _FaceID FaceID;

#define TYPE_FACE_LOCATION_DATA (face_location_data_get_type ())
typedef struct _FaceLocationData FaceLocationData;
typedef struct _SourceHoldingTankPrivate SourceHoldingTankPrivate;
typedef struct _DatabaseSourceHoldingTankPrivate DatabaseSourceHoldingTankPrivate;
typedef struct _MediaSourceHoldingTankPrivate MediaSourceHoldingTankPrivate;
typedef struct _LibraryPhotoSourceHoldingTankPrivate LibraryPhotoSourceHoldingTankPrivate;
#define _vala_assert(expr, msg) if G_LIKELY (expr) ; else g_assertion_message_expr (G_LOG_DOMAIN, __FILE__, __LINE__, G_STRFUNC, msg);
#define _vala_return_if_fail(expr, msg) if G_LIKELY (expr) ; else { g_return_if_fail_warning (G_LOG_DOMAIN, G_STRFUNC, msg); return; }
#define _vala_return_val_if_fail(expr, msg, val) if G_LIKELY (expr) ; else { g_return_if_fail_warning (G_LOG_DOMAIN, G_STRFUNC, msg); return val; }
#define _vala_warn_if_fail(expr, msg) if G_LIKELY (expr) ; else g_warn_message (G_LOG_DOMAIN, __FILE__, __LINE__, G_STRFUNC, msg);

struct _ImportID {
	gint64 id;
};

struct _PhotoImportParams {
	GTypeInstance parent_instance;
	volatile int ref_count;
	PhotoImportParamsPrivate * priv;
	GFile* file;
	GFile* final_associated_file;
	ImportID import_id;
	PhotoFileSnifferOptions sniffer_options;
	gchar* exif_md5;
	gchar* thumbnail_md5;
	gchar* full_md5;
	Thumbnails* thumbnails;
	PhotoRow* row;
	GeeCollection* keywords;
};

struct _PhotoImportParamsClass {
	GTypeClass parent_class;
	void (*finalize) (PhotoImportParams *self);
};

struct _ParamSpecPhotoImportParams {
	GParamSpec parent_instance;
};

struct _PhotoTransformationState {
	GObject parent_instance;
	PhotoTransformationStatePrivate * priv;
};

struct _PhotoTransformationStateClass {
	GObjectClass parent_class;
	void (*broken) (PhotoTransformationState* self);
};

struct _PhotoTransformationStatePrivate {
	gboolean is_broke;
};

struct _DataObject {
	GObject parent_instance;
	DataObjectPrivate * priv;
};

struct _DataObjectClass {
	GObjectClass parent_class;
	void (*notify_altered) (DataObject* self, Alteration* alteration);
	void (*notify_membership_changed) (DataObject* self, DataCollection* collection);
	void (*notify_collection_property_set) (DataObject* self, const gchar* name, GValue* old, GValue* val);
	void (*notify_collection_property_cleared) (DataObject* self, const gchar* name);
	gchar* (*get_name) (DataObject* self);
	gchar* (*to_string) (DataObject* self);
};

struct _DataSource {
	DataObject parent_instance;
	DataSourcePrivate * priv;
};

struct _DataSourceClass {
	DataObjectClass parent_class;
	void (*notify_held_in_tank) (DataSource* self, SourceHoldingTank* holding_tank);
	void (*notify_unlinking) (DataSource* self, SourceCollection* collection);
	void (*notify_unlinked) (DataSource* self);
	void (*notify_relinking) (DataSource* self, SourceCollection* collection);
	void (*notify_relinked) (DataSource* self);
	gchar* (*get_typename) (DataSource* self);
	gint64 (*get_instance_id) (DataSource* self);
	gchar* (*get_source_id) (DataSource* self);
	void (*commit_backlinks) (DataSource* self, SourceCollection* sources, const gchar* dehydrated);
	SourceSnapshot* (*save_snapshot) (DataSource* self);
	gboolean (*internal_delete_backing) (DataSource* self, GError** error);
	gboolean (*equals) (DataSource* self, DataSource* source);
	void (*destroy) (DataSource* self);
	void (*unlinked) (DataSource* self, SourceCollection* sources);
	void (*relinked) (DataSource* self, SourceCollection* sources);
	void (*destroyed) (DataSource* self);
};

struct _ThumbnailSource {
	DataSource parent_instance;
	ThumbnailSourcePrivate * priv;
};

struct _ThumbnailSourceClass {
	DataSourceClass parent_class;
	void (*notify_thumbnail_altered) (ThumbnailSource* self);
	GdkPixbuf* (*get_thumbnail) (ThumbnailSource* self, gint scale, GError** error);
	GdkPixbuf* (*create_thumbnail) (ThumbnailSource* self, gint scale, GError** error);
	gchar* (*get_representative_id) (ThumbnailSource* self);
	PhotoFileFormat (*get_preferred_thumbnail_format) (ThumbnailSource* self);
	void (*thumbnail_altered) (ThumbnailSource* self);
};

struct _IndexableIface {
	GTypeInterface parent_iface;
	const gchar* (*get_indexable_keywords) (Indexable* self);
};

struct _EventID {
	gint64 id;
};

struct _Dimensions {
	gint width;
	gint height;
};

struct _Scaling {
	ScaleConstraint constraint;
	gint scale;
	Dimensions viewport;
	gboolean scale_up;
};

struct _MediaSource {
	ThumbnailSource parent_instance;
	MediaSourcePrivate * priv;
};

struct _MediaSourceClass {
	ThumbnailSourceClass parent_class;
	void (*notify_master_replaced) (MediaSource* self, GFile* old_file, GFile* new_file);
	gboolean (*set_event_id) (MediaSource* self, EventID* id);
	gchar* (*get_basename) (MediaSource* self);
	GFile* (*get_file) (MediaSource* self);
	GFile* (*get_master_file) (MediaSource* self);
	guint64 (*get_master_filesize) (MediaSource* self);
	guint64 (*get_filesize) (MediaSource* self);
	GDateTime* (*get_timestamp) (MediaSource* self);
	BackingFileState** (*get_backing_files_state) (MediaSource* self, gint* result_length1);
	gchar* (*get_title) (MediaSource* self);
	gchar* (*get_comment) (MediaSource* self);
	void (*set_title) (MediaSource* self, const gchar* title);
	gboolean (*set_comment) (MediaSource* self, const gchar* comment);
	Rating (*get_rating) (MediaSource* self);
	void (*set_rating) (MediaSource* self, Rating rating);
	void (*increase_rating) (MediaSource* self);
	void (*decrease_rating) (MediaSource* self);
	void (*get_dimensions) (MediaSource* self, PhotoException disallowed_steps, Dimensions* result);
	GdkPixbuf* (*get_preview_pixbuf) (MediaSource* self, Scaling* scaling, GError** error);
	gboolean (*is_trashed) (MediaSource* self);
	void (*trash) (MediaSource* self);
	void (*untrash) (MediaSource* self);
	gboolean (*is_offline) (MediaSource* self);
	void (*mark_offline) (MediaSource* self);
	void (*mark_online) (MediaSource* self);
	gchar* (*get_master_md5) (MediaSource* self);
	void (*get_event_id) (MediaSource* self, EventID* result);
	GDateTime* (*get_exposure_time) (MediaSource* self);
	void (*get_import_id) (MediaSource* self, ImportID* result);
	void (*master_replaced) (MediaSource* self, GFile* old_file, GFile* new_file);
};

struct _PhotoSource {
	MediaSource parent_instance;
	PhotoSourcePrivate * priv;
};

struct _PhotoSourceClass {
	MediaSourceClass parent_class;
	PhotoMetadata* (*get_metadata) (PhotoSource* self);
	GdkPixbuf* (*get_pixbuf) (PhotoSource* self, Scaling* scaling, GError** error);
};

struct _DateableIface {
	GTypeInterface parent_iface;
	void (*set_exposure_time) (Dateable* self, GDateTime* target_time);
	GDateTime* (*get_exposure_time) (Dateable* self);
};

struct _GpsCoords {
	gint has_gps;
	gdouble latitude;
	gdouble longitude;
};

struct _PositionableIface {
	GTypeInterface parent_iface;
	void (*get_gps_coords) (Positionable* self, GpsCoords* result);
	void (*set_gps_coords) (Positionable* self, GpsCoords* gps_coords);
};

struct _Photo {
	PhotoSource parent_instance;
	PhotoPrivate * priv;
	PhotoRow* row;
	gboolean can_rotate_now;
	BackingPhotoRow* backing_photo_row;
};

struct _PhotoClass {
	PhotoSourceClass parent_class;
	void (*notify_editable_replaced) (Photo* self, GFile* old_file, GFile* new_file);
	void (*notify_raw_development_modified) (Photo* self);
	void (*notify_baseline_replaced) (Photo* self);
	void (*notify_master_reimported) (Photo* self, PhotoMetadata* metadata);
	void (*notify_editable_reimported) (Photo* self, PhotoMetadata* metadata);
	void (*notify_source_reimported) (Photo* self, PhotoMetadata* metadata);
	void (*notify_baseline_reimported) (Photo* self, PhotoMetadata* metadata);
	void (*apply_user_metadata_for_reimport) (Photo* self, PhotoMetadata* metadata);
	void (*rotate) (Photo* self, Rotation rotation);
	gboolean (*has_user_generated_metadata) (Photo* self);
	void (*set_user_metadata_for_export) (Photo* self, PhotoMetadata* metadata);
	void (*editable_replaced) (Photo* self, GFile* old_file, GFile* new_file);
	void (*raw_development_modified) (Photo* self);
	void (*baseline_replaced) (Photo* self);
	void (*master_reimported) (Photo* self, PhotoMetadata* metadata);
	void (*editable_reimported) (Photo* self, PhotoMetadata* metadata);
	void (*baseline_reimported) (Photo* self, PhotoMetadata* metadata);
	void (*source_reimported) (Photo* self, PhotoMetadata* metadata);
};

struct _PhotoPrivate {
	GDateTime* cached_exposure_time;
	GRecMutex __lock_row;
	BackingPhotoRow* editable;
	PhotoBackingReaders* readers;
	GRecMutex __lock_readers;
	PixelTransformer* transformer;
	PixelTransformationBundle* adjustments;
	gchar* file_title;
	GFileMonitor* editable_monitor;
	OneShotScheduler* reimport_editable_scheduler;
	OneShotScheduler* update_editable_attributes_scheduler;
	OneShotScheduler* remove_editable_scheduler;
	GeeHashMap* developments;
	GRecMutex __lock_developments;
};

struct _PhotoID {
	gint64 id;
};

struct _BackingPhotoID {
	gint64 id;
};

struct _PhotoRow {
	GTypeInstance parent_instance;
	volatile int ref_count;
	PhotoRowPrivate * priv;
	PhotoID photo_id;
	BackingPhotoRow* master;
	GDateTime* exposure_time;
	ImportID import_id;
	EventID event_id;
	Orientation orientation;
	GeeHashMap* transformations;
	gchar* md5;
	gchar* thumbnail_md5;
	gchar* exif_md5;
	gint64 time_created;
	guint64 flags;
	Rating rating;
	gchar* title;
	GpsCoords gps_coords;
	gchar* comment;
	gchar* backlinks;
	gint64 time_reimported;
	BackingPhotoID editable_id;
	gboolean metadata_dirty;
	RawDeveloper developer;
	BackingPhotoID* development_ids;
	gint development_ids_length1;
};

struct _PhotoRowClass {
	GTypeClass parent_class;
	void (*finalize) (PhotoRow *self);
};

struct _BackingPhotoRow {
	GTypeInstance parent_instance;
	volatile int ref_count;
	BackingPhotoRowPrivate * priv;
	BackingPhotoID id;
	gint64 time_created;
	gchar* filepath;
	gint64 filesize;
	GDateTime* timestamp;
	PhotoFileFormat file_format;
	Dimensions dim;
	Orientation original_orientation;
};

struct _BackingPhotoRowClass {
	GTypeClass parent_class;
	void (*finalize) (BackingPhotoRow *self);
};

struct _PhotoBackingReaders {
	GTypeInstance parent_instance;
	volatile int ref_count;
	PhotoBackingReadersPrivate * priv;
	PhotoFileReader* master;
	PhotoFileReader* developer;
	PhotoFileReader* editable;
};

struct _PhotoBackingReadersClass {
	GTypeClass parent_class;
	void (*finalize) (PhotoBackingReaders *self);
};

typedef enum  {
	DATABASE_ERROR_ERROR,
	DATABASE_ERROR_BACKING,
	DATABASE_ERROR_MEMORY,
	DATABASE_ERROR_ABORT,
	DATABASE_ERROR_LIMITS,
	DATABASE_ERROR_TYPESPEC
} DatabaseError;
#define DATABASE_ERROR database_error_quark ()

struct _DetectedPhotoInformation {
	GTypeInstance parent_instance;
	volatile int ref_count;
	DetectedPhotoInformationPrivate * priv;
	PhotoFileFormat file_format;
	PhotoMetadata* metadata;
	gchar* md5;
	gchar* exif_md5;
	gchar* thumbnail_md5;
	gchar* format_name;
	Dimensions image_dim;
	GdkColorspace colorspace;
	gint channels;
	gint bits_per_channel;
};

struct _DetectedPhotoInformationClass {
	GTypeClass parent_class;
	void (*finalize) (DetectedPhotoInformation *self);
};

typedef enum  {
	PHOTO_FORMAT_ERROR_READ_ONLY
} PhotoFormatError;
#define PHOTO_FORMAT_ERROR photo_format_error_quark ()

struct _ExportFormatParameters {
	ExportFormatMode mode;
	PhotoFileFormat specified_format;
	JpegQuality quality;
	gboolean export_metadata;
};

struct _PhotoReimportMasterState {
	GTypeInstance parent_instance;
	volatile int ref_count;
	PhotoReimportMasterStatePrivate * priv;
};

struct _PhotoReimportMasterStateClass {
	GTypeClass parent_class;
	void (*finalize) (PhotoReimportMasterState *self);
};

struct _PhotoReimportMasterStateImpl {
	PhotoReimportMasterState parent_instance;
	PhotoReimportMasterStateImplPrivate * priv;
	PhotoRow* row;
	PhotoMetadata* metadata;
	gchar** alterations;
	gint alterations_length1;
	gint _alterations_size_;
	gboolean metadata_only;
};

struct _PhotoReimportMasterStateImplClass {
	PhotoReimportMasterStateClass parent_class;
};

struct _PhotoReimportEditableState {
	GTypeInstance parent_instance;
	volatile int ref_count;
	PhotoReimportEditableStatePrivate * priv;
};

struct _PhotoReimportEditableStateClass {
	GTypeClass parent_class;
	void (*finalize) (PhotoReimportEditableState *self);
};

struct _PhotoReimportEditableStateImpl {
	PhotoReimportEditableState parent_instance;
	PhotoReimportEditableStateImplPrivate * priv;
	BackingPhotoRow* backing_state;
	PhotoMetadata* metadata;
	gboolean metadata_only;
};

struct _PhotoReimportEditableStateImplClass {
	PhotoReimportEditableStateClass parent_class;
};

struct _PhotoReimportRawDevelopmentState {
	GTypeInstance parent_instance;
	volatile int ref_count;
	PhotoReimportRawDevelopmentStatePrivate * priv;
};

struct _PhotoReimportRawDevelopmentStateClass {
	GTypeClass parent_class;
	void (*finalize) (PhotoReimportRawDevelopmentState *self);
};

struct _PhotoReimportRawDevelopmentStateImpl {
	PhotoReimportRawDevelopmentState parent_instance;
	PhotoReimportRawDevelopmentStateImplPrivate * priv;
	GeeCollection* list;
	gboolean metadata_only;
};

struct _PhotoReimportRawDevelopmentStateImplClass {
	PhotoReimportRawDevelopmentStateClass parent_class;
};

struct _PhotoReimportRawDevelopmentStateImplDevToReimport {
	GTypeInstance parent_instance;
	volatile int ref_count;
	PhotoReimportRawDevelopmentStateImplDevToReimportPrivate * priv;
	BackingPhotoRow* backing;
	PhotoMetadata* metadata;
};

struct _PhotoReimportRawDevelopmentStateImplDevToReimportClass {
	GTypeClass parent_class;
	void (*finalize) (PhotoReimportRawDevelopmentStateImplDevToReimport *self);
};

struct _Box {
	gint left;
	gint top;
	gint right;
	gint bottom;
};

struct _EditingToolsRedeyeInstance {
	GdkPoint center;
	gint radius;
};

struct _PhotoCachedPixbuf {
	GTypeInstance parent_instance;
	volatile int ref_count;
	PhotoCachedPixbufPrivate * priv;
	Photo* photo;
	GdkPixbuf* pixbuf;
	GTimer* last_touched;
};

struct _PhotoCachedPixbufClass {
	GTypeClass parent_class;
	void (*finalize) (PhotoCachedPixbuf *self);
};

struct _PhotoPhotoTransformationStateImpl {
	PhotoTransformationState parent_instance;
	PhotoPhotoTransformationStateImplPrivate * priv;
};

struct _PhotoPhotoTransformationStateImplClass {
	PhotoTransformationStateClass parent_class;
};

struct _PhotoPhotoTransformationStateImplPrivate {
	Photo* photo;
	Orientation orientation;
	GeeHashMap* transformations;
	PixelTransformer* transformer;
	PixelTransformationBundle* adjustments;
};

struct _PhotoParamSpecBackingReaders {
	GParamSpec parent_instance;
};

struct _PhotoParamSpecCachedPixbuf {
	GParamSpec parent_instance;
};

struct _PhotoParamSpecReimportMasterState {
	GParamSpec parent_instance;
};

struct _PhotoParamSpecReimportEditableState {
	GParamSpec parent_instance;
};

struct _PhotoParamSpecReimportRawDevelopmentState {
	GParamSpec parent_instance;
};

struct _PhotoReimportRawDevelopmentStateImplParamSpecDevToReimport {
	GParamSpec parent_instance;
};

struct _MarkerIface {
	GTypeInterface parent_iface;
	void (*mark) (Marker* self, DataObject* object);
	void (*unmark) (Marker* self, DataObject* object);
	gboolean (*toggle) (Marker* self, DataObject* object);
	void (*mark_many) (Marker* self, GeeCollection* list);
	void (*unmark_many) (Marker* self, GeeCollection* list);
	void (*mark_all) (Marker* self);
	gint (*get_count) (Marker* self);
	GeeCollection* (*get_all) (Marker* self);
};

struct _DataCollection {
	GTypeInstance parent_instance;
	volatile int ref_count;
	DataCollectionPrivate * priv;
};

struct _DataCollectionClass {
	GTypeClass parent_class;
	void (*finalize) (DataCollection *self);
	gchar* (*to_string) (DataCollection* self);
	void (*notify_items_added) (DataCollection* self, GeeIterable* added);
	void (*notify_items_removed) (DataCollection* self, GeeIterable* removed);
	void (*notify_contents_altered) (DataCollection* self, GeeIterable* added, GeeIterable* removed);
	void (*notify_items_altered) (DataCollection* self, GeeMap* items);
	void (*notify_ordering_changed) (DataCollection* self);
	void (*notify_property_set) (DataCollection* self, const gchar* name, GValue* old, GValue* val);
	void (*notify_property_cleared) (DataCollection* self, const gchar* name);
	gboolean (*valid_type) (DataCollection* self, DataObject* object);
	void (*set_comparator) (DataCollection* self, Comparator comparator, gpointer comparator_target, ComparatorPredicate predicate, gpointer predicate_target);
	void (*reset_comparator) (DataCollection* self);
	GeeCollection* (*get_all) (DataCollection* self);
	gint (*get_count) (DataCollection* self);
	DataObject* (*get_at) (DataCollection* self, gint index);
	gint (*index_of) (DataCollection* self, DataObject* object);
	gboolean (*contains) (DataCollection* self, DataObject* object);
	gboolean (*add) (DataCollection* self, DataObject* object);
	GeeCollection* (*add_many) (DataCollection* self, GeeCollection* objects, ProgressMonitor monitor, gpointer monitor_target);
	void (*remove_marked) (DataCollection* self, Marker* m);
	void (*clear) (DataCollection* self);
	void (*close) (DataCollection* self);
	void (*notify_frozen) (DataCollection* self);
	void (*notify_thawed) (DataCollection* self);
	void (*items_added) (DataCollection* self, GeeIterable* added);
	void (*items_removed) (DataCollection* self, GeeIterable* removed);
	void (*contents_altered) (DataCollection* self, GeeIterable* added, GeeIterable* removed);
	void (*items_altered) (DataCollection* self, GeeMap* items);
	void (*ordering_changed) (DataCollection* self);
	void (*property_set) (DataCollection* self, const gchar* name, GValue* old, GValue* val);
	void (*property_cleared) (DataCollection* self, const gchar* name);
	void (*frozen) (DataCollection* self);
	void (*thawed) (DataCollection* self);
};

struct _SourceCollection {
	DataCollection parent_instance;
	SourceCollectionPrivate * priv;
};

struct _SourceCollectionClass {
	DataCollectionClass parent_class;
	gboolean (*holds_type_of_source) (SourceCollection* self, DataSource* source);
	void (*notify_items_unlinking) (SourceCollection* self, GeeCollection* unlinking);
	void (*notify_items_relinked) (SourceCollection* self, GeeCollection* relinked);
	void (*notify_item_destroyed) (SourceCollection* self, DataSource* source);
	void (*notify_items_destroyed) (SourceCollection* self, GeeCollection* destroyed);
	void (*notify_unlinked_destroyed) (SourceCollection* self, DataSource* unlinked);
	void (*notify_backlink_removed) (SourceCollection* self, SourceBacklink* backlink, GeeCollection* sources);
	gboolean (*has_backlink) (SourceCollection* self, SourceBacklink* backlink);
	void (*remove_backlink) (SourceCollection* self, SourceBacklink* backlink);
	void (*items_unlinking) (SourceCollection* self, GeeCollection* unlinking);
	void (*items_relinked) (SourceCollection* self, GeeCollection* relinked);
	void (*item_destroyed) (SourceCollection* self, DataSource* source);
	void (*items_destroyed) (SourceCollection* self, GeeCollection* destroyed);
	void (*unlinked_destroyed) (SourceCollection* self, DataSource* source);
	void (*backlink_removed) (SourceCollection* self, SourceBacklink* backlink, GeeCollection* sources);
};

struct _DatabaseSourceCollection {
	SourceCollection parent_instance;
	DatabaseSourceCollectionPrivate * priv;
};

struct _DatabaseSourceCollectionClass {
	SourceCollectionClass parent_class;
};

struct _MediaSourceCollection {
	DatabaseSourceCollection parent_instance;
	MediaSourceCollectionPrivate * priv;
};

struct _MediaSourceCollectionClass {
	DatabaseSourceCollectionClass parent_class;
	MediaSourceHoldingTank* (*create_trashcan) (MediaSourceCollection* self);
	MediaSourceHoldingTank* (*create_offline_bin) (MediaSourceCollection* self);
	MediaMonitor* (*create_media_monitor) (MediaSourceCollection* self, Workers* workers, GCancellable* cancellable);
	gchar* (*get_typename) (MediaSourceCollection* self);
	gboolean (*is_file_recognized) (MediaSourceCollection* self, GFile* file);
	MediaSource* (*fetch_by_numeric_id) (MediaSourceCollection* self, gint64 numeric_id);
	void (*notify_import_roll_altered) (MediaSourceCollection* self);
	void (*notify_flagged_contents_altered) (MediaSourceCollection* self);
	void (*notify_media_import_starting) (MediaSourceCollection* self, GeeCollection* media);
	void (*notify_media_import_completed) (MediaSourceCollection* self, GeeCollection* media);
	MediaSource* (*fetch_by_source_id) (MediaSourceCollection* self, const gchar* source_id);
	GeeCollection* (*get_event_source_ids) (MediaSourceCollection* self, EventID* event_id);
	void (*import_many) (MediaSourceCollection* self, GeeCollection* media);
	void (*postprocess_imported_media) (MediaSourceCollection* self, GeeCollection* media);
	void (*media_import_starting) (MediaSourceCollection* self, GeeCollection* media);
	void (*media_import_completed) (MediaSourceCollection* self, GeeCollection* media);
	void (*master_file_replaced) (MediaSourceCollection* self, MediaSource* media, GFile* old_file, GFile* new_file);
	void (*trashcan_contents_altered) (MediaSourceCollection* self, GeeCollection* added, GeeCollection* removed);
	void (*import_roll_altered) (MediaSourceCollection* self);
	void (*offline_contents_altered) (MediaSourceCollection* self, GeeCollection* added, GeeCollection* removed);
	void (*flagged_contents_altered) (MediaSourceCollection* self);
	TransactionController* (*get_transaction_controller) (MediaSourceCollection* self);
};

struct _LibraryPhotoSourceCollection {
	MediaSourceCollection parent_instance;
	LibraryPhotoSourceCollectionPrivate * priv;
};

struct _LibraryPhotoSourceCollectionClass {
	MediaSourceCollectionClass parent_class;
	void (*notify_master_reimported) (LibraryPhotoSourceCollection* self, LibraryPhoto* photo, PhotoMetadata* metadata);
	void (*notify_editable_reimported) (LibraryPhotoSourceCollection* self, LibraryPhoto* photo, PhotoMetadata* metadata);
	void (*notify_source_reimported) (LibraryPhotoSourceCollection* self, LibraryPhoto* photo, PhotoMetadata* metadata);
	void (*notify_baseline_reimported) (LibraryPhotoSourceCollection* self, LibraryPhoto* photo, PhotoMetadata* metadata);
	void (*master_reimported) (LibraryPhotoSourceCollection* self, LibraryPhoto* photo, PhotoMetadata* metadata);
	void (*editable_reimported) (LibraryPhotoSourceCollection* self, LibraryPhoto* photo, PhotoMetadata* metadata);
	void (*baseline_reimported) (LibraryPhotoSourceCollection* self, LibraryPhoto* photo, PhotoMetadata* metadata);
	void (*source_reimported) (LibraryPhotoSourceCollection* self, LibraryPhoto* photo, PhotoMetadata* metadata);
};

struct _LibraryPhotoSourceCollectionPrivate {
	TransactionController* _transaction_controller;
	GeeHashMap* by_editable_file;
	GeeHashMap* by_raw_development_file;
	GeeMultiMap* filesize_to_photo;
	GeeHashMap* photo_to_master_filesize;
	GeeHashMap* photo_to_editable_filesize;
	GeeMultiMap* photo_to_raw_development_filesize;
};

struct _FlaggableIface {
	GTypeInterface parent_iface;
	gboolean (*is_flagged) (Flaggable* self);
	void (*mark_flagged) (Flaggable* self);
	void (*mark_unflagged) (Flaggable* self);
};

struct _MonitorableIface {
	GTypeInterface parent_iface;
	gboolean (*is_offline) (Monitorable* self);
	void (*mark_online) (Monitorable* self);
	void (*mark_offline) (Monitorable* self);
	void (*set_master_file) (Monitorable* self, GFile* file);
	void (*set_master_timestamp) (Monitorable* self, GFileInfo* info);
};

struct _LibraryPhoto {
	Photo parent_instance;
	LibraryPhotoPrivate * priv;
};

struct _LibraryPhotoClass {
	PhotoClass parent_class;
};

struct _LibraryPhotoPrivate {
	gboolean block_thumbnail_generation;
	OneShotScheduler* thumbnail_scheduler;
	GeeCollection* import_keywords;
};

struct _FaceID {
	gint64 id;
};

struct _FaceLocationData {
	gchar* geometry;
	gchar* vec;
};

struct _SourceHoldingTank {
	GTypeInstance parent_instance;
	volatile int ref_count;
	SourceHoldingTankPrivate * priv;
};

struct _SourceHoldingTankClass {
	GTypeClass parent_class;
	void (*finalize) (SourceHoldingTank *self);
	void (*notify_contents_altered) (SourceHoldingTank* self, GeeCollection* added, GeeCollection* removed);
	void (*contents_altered) (SourceHoldingTank* self, GeeCollection* added, GeeCollection* removed);
};

struct _DatabaseSourceHoldingTank {
	SourceHoldingTank parent_instance;
	DatabaseSourceHoldingTankPrivate * priv;
};

struct _DatabaseSourceHoldingTankClass {
	SourceHoldingTankClass parent_class;
};

struct _MediaSourceHoldingTank {
	DatabaseSourceHoldingTank parent_instance;
	MediaSourceHoldingTankPrivate * priv;
};

struct _MediaSourceHoldingTankClass {
	DatabaseSourceHoldingTankClass parent_class;
};

struct _LibraryPhotoSourceHoldingTank {
	MediaSourceHoldingTank parent_instance;
	LibraryPhotoSourceHoldingTankPrivate * priv;
};

struct _LibraryPhotoSourceHoldingTankClass {
	MediaSourceHoldingTankClass parent_class;
};

struct _LibraryPhotoSourceHoldingTankPrivate {
	GeeHashMap* editable_file_map;
	GeeHashMap* development_file_map;
	GeeMultiMap* reverse_editable_file_map;
	GeeMultiMap* reverse_development_file_map;
};

static gpointer photo_import_params_parent_class = NULL;
static gint PhotoTransformationState_private_offset;
static gpointer photo_transformation_state_parent_class = NULL;
static gint Photo_private_offset;
static gpointer photo_parent_class = NULL;
static GeeLinkedList* photo_source_pixbuf_cache;
static GRecMutex __lock_photo_photo_source_pixbuf_cache = {0};
static GeeLinkedList* photo_source_pixbuf_cache = NULL;
static guint photo_discard_source_id;
static guint photo_discard_source_id = (guint) 0;
static gboolean photo__develop_raw_photos_to_files;
static gboolean photo__develop_raw_photos_to_files = FALSE;
static gint PhotoPhotoTransformationStateImpl_private_offset;
static gpointer photo_photo_transformation_state_impl_parent_class = NULL;
static gpointer photo_backing_readers_parent_class = NULL;
static gpointer photo_cached_pixbuf_parent_class = NULL;
static gpointer photo_reimport_master_state_parent_class = NULL;
static gpointer photo_reimport_master_state_impl_parent_class = NULL;
static gpointer photo_reimport_editable_state_parent_class = NULL;
static gpointer photo_reimport_editable_state_impl_parent_class = NULL;
static gpointer photo_reimport_raw_development_state_parent_class = NULL;
static gpointer photo_reimport_raw_development_state_impl_parent_class = NULL;
static gpointer photo_reimport_raw_development_state_impl_dev_to_reimport_parent_class = NULL;
static DateableIface * photo_dateable_parent_iface = NULL;
static PositionableIface * photo_positionable_parent_iface = NULL;
static gint LibraryPhotoSourceCollection_private_offset;
static gpointer library_photo_source_collection_parent_class = NULL;
static gint LibraryPhoto_private_offset;
static gpointer library_photo_parent_class = NULL;
VALA_EXTERN LibraryPhotoSourceCollection* library_photo_global;
LibraryPhotoSourceCollection* library_photo_global = NULL;
VALA_EXTERN TagSourceCollection* tag_global;
VALA_EXTERN FaceSourceCollection* face_global;
static FlaggableIface * library_photo_flaggable_parent_iface = NULL;
static MonitorableIface * library_photo_monitorable_parent_iface = NULL;
static gint LibraryPhotoSourceHoldingTank_private_offset;
static gpointer library_photo_source_holding_tank_parent_class = NULL;

VALA_EXTERN GType backing_fetch_mode_get_type (void) G_GNUC_CONST ;
VALA_EXTERN gpointer photo_import_params_ref (gpointer instance);
VALA_EXTERN void photo_import_params_unref (gpointer instance);
VALA_EXTERN GParamSpec* param_spec_photo_import_params (const gchar* name,
                                            const gchar* nick,
                                            const gchar* blurb,
                                            GType object_type,
                                            GParamFlags flags);
VALA_EXTERN void value_set_photo_import_params (GValue* value,
                                    gpointer v_object);
VALA_EXTERN void value_take_photo_import_params (GValue* value,
                                     gpointer v_object);
VALA_EXTERN gpointer value_get_photo_import_params (const GValue* value);
VALA_EXTERN GType photo_import_params_get_type (void) G_GNUC_CONST ;
G_DEFINE_AUTOPTR_CLEANUP_FUNC (PhotoImportParams, photo_import_params_unref)
VALA_EXTERN GType import_id_get_type (void) G_GNUC_CONST ;
VALA_EXTERN ImportID* import_id_dup (const ImportID* self);
VALA_EXTERN void import_id_free (ImportID* self);
VALA_EXTERN GType photo_file_sniffer_options_get_type (void) G_GNUC_CONST ;
VALA_EXTERN gpointer thumbnails_ref (gpointer instance);
VALA_EXTERN void thumbnails_unref (gpointer instance);
VALA_EXTERN GParamSpec* param_spec_thumbnails (const gchar* name,
                                   const gchar* nick,
                                   const gchar* blurb,
                                   GType object_type,
                                   GParamFlags flags);
VALA_EXTERN void value_set_thumbnails (GValue* value,
                           gpointer v_object);
VALA_EXTERN void value_take_thumbnails (GValue* value,
                            gpointer v_object);
VALA_EXTERN gpointer value_get_thumbnails (const GValue* value);
VALA_EXTERN GType thumbnails_get_type (void) G_GNUC_CONST ;
G_DEFINE_AUTOPTR_CLEANUP_FUNC (Thumbnails, thumbnails_unref)
VALA_EXTERN gpointer photo_row_ref (gpointer instance);
VALA_EXTERN void photo_row_unref (gpointer instance);
VALA_EXTERN GParamSpec* param_spec_photo_row (const gchar* name,
                                  const gchar* nick,
                                  const gchar* blurb,
                                  GType object_type,
                                  GParamFlags flags);
VALA_EXTERN void value_set_photo_row (GValue* value,
                          gpointer v_object);
VALA_EXTERN void value_take_photo_row (GValue* value,
                           gpointer v_object);
VALA_EXTERN gpointer value_get_photo_row (const GValue* value);
VALA_EXTERN GType photo_row_get_type (void) G_GNUC_CONST ;
G_DEFINE_AUTOPTR_CLEANUP_FUNC (PhotoRow, photo_row_unref)
VALA_EXTERN PhotoRow* photo_row_new (void);
VALA_EXTERN PhotoRow* photo_row_construct (GType object_type);
VALA_EXTERN PhotoImportParams* photo_import_params_new (GFile* file,
                                            GFile* final_associated_file,
                                            ImportID* import_id,
                                            PhotoFileSnifferOptions sniffer_options,
                                            const gchar* exif_md5,
                                            const gchar* thumbnail_md5,
                                            const gchar* full_md5,
                                            Thumbnails* thumbnails);
VALA_EXTERN PhotoImportParams* photo_import_params_construct (GType object_type,
                                                  GFile* file,
                                                  GFile* final_associated_file,
                                                  ImportID* import_id,
                                                  PhotoFileSnifferOptions sniffer_options,
                                                  const gchar* exif_md5,
                                                  const gchar* thumbnail_md5,
                                                  const gchar* full_md5,
                                                  Thumbnails* thumbnails);
VALA_EXTERN PhotoImportParams* photo_import_params_new_create_placeholder (GFile* file,
                                                               ImportID* import_id);
VALA_EXTERN PhotoImportParams* photo_import_params_construct_create_placeholder (GType object_type,
                                                                     GFile* file,
                                                                     ImportID* import_id);
static void photo_import_params_finalize (PhotoImportParams * obj);
static GType photo_import_params_get_type_once (void);
VALA_EXTERN GType photo_transformation_state_get_type (void) G_GNUC_CONST ;
G_DEFINE_AUTOPTR_CLEANUP_FUNC (PhotoTransformationState, g_object_unref)
VALA_EXTERN gboolean photo_transformation_state_is_broken (PhotoTransformationState* self);
VALA_EXTERN PhotoTransformationState* photo_transformation_state_construct (GType object_type);
static void photo_transformation_state_real_broken (PhotoTransformationState* self);
static void photo_transformation_state_finalize (GObject * obj);
static GType photo_transformation_state_get_type_once (void);
VALA_EXTERN GType rating_get_type (void) G_GNUC_CONST ;
VALA_EXTERN gboolean rating_can_increase (Rating self);
VALA_EXTERN gboolean rating_can_decrease (Rating self);
VALA_EXTERN gboolean rating_is_valid (Rating self);
VALA_EXTERN Rating rating_increase (Rating self);
VALA_EXTERN Rating rating_decrease (Rating self);
VALA_EXTERN gint rating_serialize (Rating self);
VALA_EXTERN Rating rating_unserialize (gint value);
VALA_EXTERN GType data_object_get_type (void) G_GNUC_CONST ;
G_DEFINE_AUTOPTR_CLEANUP_FUNC (DataObject, g_object_unref)
VALA_EXTERN gpointer alteration_ref (gpointer instance);
VALA_EXTERN void alteration_unref (gpointer instance);
VALA_EXTERN GParamSpec* param_spec_alteration (const gchar* name,
                                   const gchar* nick,
                                   const gchar* blurb,
                                   GType object_type,
                                   GParamFlags flags);
VALA_EXTERN void value_set_alteration (GValue* value,
                           gpointer v_object);
VALA_EXTERN void value_take_alteration (GValue* value,
                            gpointer v_object);
VALA_EXTERN gpointer value_get_alteration (const GValue* value);
VALA_EXTERN GType alteration_get_type (void) G_GNUC_CONST ;
G_DEFINE_AUTOPTR_CLEANUP_FUNC (Alteration, alteration_unref)
VALA_EXTERN gpointer data_collection_ref (gpointer instance);
VALA_EXTERN void data_collection_unref (gpointer instance);
VALA_EXTERN GParamSpec* param_spec_data_collection (const gchar* name,
                                        const gchar* nick,
                                        const gchar* blurb,
                                        GType object_type,
                                        GParamFlags flags);
VALA_EXTERN void value_set_data_collection (GValue* value,
                                gpointer v_object);
VALA_EXTERN void value_take_data_collection (GValue* value,
                                 gpointer v_object);
VALA_EXTERN gpointer value_get_data_collection (const GValue* value);
VALA_EXTERN GType data_collection_get_type (void) G_GNUC_CONST ;
G_DEFINE_AUTOPTR_CLEANUP_FUNC (DataCollection, data_collection_unref)
VALA_EXTERN GType data_source_get_type (void) G_GNUC_CONST ;
G_DEFINE_AUTOPTR_CLEANUP_FUNC (DataSource, g_object_unref)
VALA_EXTERN gpointer source_holding_tank_ref (gpointer instance);
VALA_EXTERN void source_holding_tank_unref (gpointer instance);
VALA_EXTERN GParamSpec* param_spec_source_holding_tank (const gchar* name,
                                            const gchar* nick,
                                            const gchar* blurb,
                                            GType object_type,
                                            GParamFlags flags);
VALA_EXTERN void value_set_source_holding_tank (GValue* value,
                                    gpointer v_object);
VALA_EXTERN void value_take_source_holding_tank (GValue* value,
                                     gpointer v_object);
VALA_EXTERN gpointer value_get_source_holding_tank (const GValue* value);
VALA_EXTERN GType source_holding_tank_get_type (void) G_GNUC_CONST ;
G_DEFINE_AUTOPTR_CLEANUP_FUNC (SourceHoldingTank, source_holding_tank_unref)
VALA_EXTERN GType source_collection_get_type (void) G_GNUC_CONST ;
G_DEFINE_AUTOPTR_CLEANUP_FUNC (SourceCollection, data_collection_unref)
VALA_EXTERN gpointer source_snapshot_ref (gpointer instance);
VALA_EXTERN void source_snapshot_unref (gpointer instance);
VALA_EXTERN GParamSpec* param_spec_source_snapshot (const gchar* name,
                                        const gchar* nick,
                                        const gchar* blurb,
                                        GType object_type,
                                        GParamFlags flags);
VALA_EXTERN void value_set_source_snapshot (GValue* value,
                                gpointer v_object);
VALA_EXTERN void value_take_source_snapshot (GValue* value,
                                 gpointer v_object);
VALA_EXTERN gpointer value_get_source_snapshot (const GValue* value);
VALA_EXTERN GType source_snapshot_get_type (void) G_GNUC_CONST ;
G_DEFINE_AUTOPTR_CLEANUP_FUNC (SourceSnapshot, source_snapshot_unref)
VALA_EXTERN GType thumbnail_source_get_type (void) G_GNUC_CONST ;
G_DEFINE_AUTOPTR_CLEANUP_FUNC (ThumbnailSource, g_object_unref)
VALA_EXTERN GType photo_file_format_get_type (void) G_GNUC_CONST ;
VALA_EXTERN GType indexable_get_type (void) G_GNUC_CONST ;
G_DEFINE_AUTOPTR_CLEANUP_FUNC (Indexable, g_object_unref)
VALA_EXTERN GType media_source_get_type (void) G_GNUC_CONST ;
G_DEFINE_AUTOPTR_CLEANUP_FUNC (MediaSource, g_object_unref)
VALA_EXTERN GType event_id_get_type (void) G_GNUC_CONST ;
VALA_EXTERN EventID* event_id_dup (const EventID* self);
VALA_EXTERN void event_id_free (EventID* self);
VALA_EXTERN gpointer backing_file_state_ref (gpointer instance);
VALA_EXTERN void backing_file_state_unref (gpointer instance);
VALA_EXTERN GParamSpec* param_spec_backing_file_state (const gchar* name,
                                           const gchar* nick,
                                           const gchar* blurb,
                                           GType object_type,
                                           GParamFlags flags);
VALA_EXTERN void value_set_backing_file_state (GValue* value,
                                   gpointer v_object);
VALA_EXTERN void value_take_backing_file_state (GValue* value,
                                    gpointer v_object);
VALA_EXTERN gpointer value_get_backing_file_state (const GValue* value);
VALA_EXTERN GType backing_file_state_get_type (void) G_GNUC_CONST ;
G_DEFINE_AUTOPTR_CLEANUP_FUNC (BackingFileState, backing_file_state_unref)
VALA_EXTERN GType photo_exception_get_type (void) G_GNUC_CONST ;
VALA_EXTERN GType dimensions_get_type (void) G_GNUC_CONST ;
VALA_EXTERN Dimensions* dimensions_dup (const Dimensions* self);
VALA_EXTERN void dimensions_free (Dimensions* self);
VALA_EXTERN GType scaling_get_type (void) G_GNUC_CONST ;
VALA_EXTERN GType scale_constraint_get_type (void) G_GNUC_CONST ;
VALA_EXTERN Scaling* scaling_dup (const Scaling* self);
VALA_EXTERN void scaling_free (Scaling* self);
VALA_EXTERN GType photo_source_get_type (void) G_GNUC_CONST ;
G_DEFINE_AUTOPTR_CLEANUP_FUNC (PhotoSource, g_object_unref)
VALA_EXTERN GType photo_metadata_get_type (void) G_GNUC_CONST ;
G_DEFINE_AUTOPTR_CLEANUP_FUNC (PhotoMetadata, media_metadata_unref)
VALA_EXTERN GType dateable_get_type (void) G_GNUC_CONST ;
G_DEFINE_AUTOPTR_CLEANUP_FUNC (Dateable, g_object_unref)
VALA_EXTERN GType gps_coords_get_type (void) G_GNUC_CONST ;
VALA_EXTERN GpsCoords* gps_coords_dup (const GpsCoords* self);
VALA_EXTERN void gps_coords_free (GpsCoords* self);
VALA_EXTERN GType positionable_get_type (void) G_GNUC_CONST ;
G_DEFINE_AUTOPTR_CLEANUP_FUNC (Positionable, g_object_unref)
VALA_EXTERN GType photo_get_type (void) G_GNUC_CONST ;
G_DEFINE_AUTOPTR_CLEANUP_FUNC (Photo, g_object_unref)
VALA_EXTERN GType rotation_get_type (void) G_GNUC_CONST ;
VALA_EXTERN gpointer backing_photo_row_ref (gpointer instance);
VALA_EXTERN void backing_photo_row_unref (gpointer instance);
VALA_EXTERN GParamSpec* param_spec_backing_photo_row (const gchar* name,
                                          const gchar* nick,
                                          const gchar* blurb,
                                          GType object_type,
                                          GParamFlags flags);
VALA_EXTERN void value_set_backing_photo_row (GValue* value,
                                  gpointer v_object);
VALA_EXTERN void value_take_backing_photo_row (GValue* value,
                                   gpointer v_object);
VALA_EXTERN gpointer value_get_backing_photo_row (const GValue* value);
VALA_EXTERN GType backing_photo_row_get_type (void) G_GNUC_CONST ;
G_DEFINE_AUTOPTR_CLEANUP_FUNC (BackingPhotoRow, backing_photo_row_unref)
static gpointer photo_backing_readers_ref (gpointer instance);
static void photo_backing_readers_unref (gpointer instance);
static GParamSpec* photo_param_spec_backing_readers (const gchar* name,
                                              const gchar* nick,
                                              const gchar* blurb,
                                              GType object_type,
                                              GParamFlags flags) G_GNUC_UNUSED ;
static void photo_value_set_backing_readers (GValue* value,
                                      gpointer v_object) G_GNUC_UNUSED ;
static void photo_value_take_backing_readers (GValue* value,
                                       gpointer v_object) G_GNUC_UNUSED ;
static gpointer photo_value_get_backing_readers (const GValue* value) G_GNUC_UNUSED ;
static GType photo_backing_readers_get_type (void) G_GNUC_CONST  G_GNUC_UNUSED ;
G_DEFINE_AUTOPTR_CLEANUP_FUNC (PhotoBackingReaders, photo_backing_readers_unref)
VALA_EXTERN gpointer one_shot_scheduler_ref (gpointer instance);
VALA_EXTERN void one_shot_scheduler_unref (gpointer instance);
VALA_EXTERN GParamSpec* param_spec_one_shot_scheduler (const gchar* name,
                                           const gchar* nick,
                                           const gchar* blurb,
                                           GType object_type,
                                           GParamFlags flags);
VALA_EXTERN void value_set_one_shot_scheduler (GValue* value,
                                   gpointer v_object);
VALA_EXTERN void value_take_one_shot_scheduler (GValue* value,
                                    gpointer v_object);
VALA_EXTERN gpointer value_get_one_shot_scheduler (const GValue* value);
VALA_EXTERN GType one_shot_scheduler_get_type (void) G_GNUC_CONST ;
G_DEFINE_AUTOPTR_CLEANUP_FUNC (OneShotScheduler, one_shot_scheduler_unref)
VALA_EXTERN GType raw_developer_get_type (void) G_GNUC_CONST ;
VALA_EXTERN void photo_notify_editable_replaced (Photo* self,
                                     GFile* old_file,
                                     GFile* new_file);
VALA_EXTERN void photo_notify_raw_development_modified (Photo* self);
VALA_EXTERN void photo_notify_baseline_replaced (Photo* self);
VALA_EXTERN void photo_notify_master_reimported (Photo* self,
                                     PhotoMetadata* metadata);
VALA_EXTERN void photo_notify_editable_reimported (Photo* self,
                                       PhotoMetadata* metadata);
VALA_EXTERN void photo_notify_source_reimported (Photo* self,
                                     PhotoMetadata* metadata);
VALA_EXTERN void photo_notify_baseline_reimported (Photo* self,
                                       PhotoMetadata* metadata);
VALA_EXTERN gboolean data_source_internal_delete_backing (DataSource* self,
                                              GError** error);
VALA_EXTERN BackingFileState** media_source_get_backing_files_state (MediaSource* self,
                                                         gint* result_length1);
VALA_EXTERN void photo_apply_user_metadata_for_reimport (Photo* self,
                                             PhotoMetadata* metadata);
VALA_EXTERN gchar* data_source_get_typename (DataSource* self);
VALA_EXTERN gint64 data_source_get_instance_id (DataSource* self);
VALA_EXTERN gchar* data_source_get_source_id (DataSource* self);
VALA_EXTERN PhotoFileFormat thumbnail_source_get_preferred_thumbnail_format (ThumbnailSource* self);
VALA_EXTERN GdkPixbuf* thumbnail_source_create_thumbnail (ThumbnailSource* self,
                                              gint scale,
                                              GError** error);
VALA_EXTERN GFile* media_source_get_file (MediaSource* self);
VALA_EXTERN GFile* media_source_get_master_file (MediaSource* self);
VALA_EXTERN GDateTime* media_source_get_timestamp (MediaSource* self);
VALA_EXTERN void media_source_get_event_id (MediaSource* self,
                                EventID* result);
VALA_EXTERN void media_source_get_import_id (MediaSource* self,
                                 ImportID* result);
VALA_EXTERN gchar* media_source_get_master_md5 (MediaSource* self);
VALA_EXTERN Rating media_source_get_rating (MediaSource* self);
VALA_EXTERN void media_source_set_rating (MediaSource* self,
                              Rating rating);
VALA_EXTERN void media_source_increase_rating (MediaSource* self);
VALA_EXTERN void media_source_decrease_rating (MediaSource* self);
VALA_EXTERN void data_source_commit_backlinks (DataSource* self,
                                   SourceCollection* sources,
                                   const gchar* dehydrated);
VALA_EXTERN gboolean media_source_set_event_id (MediaSource* self,
                                    EventID* id);
VALA_EXTERN gchar* data_object_to_string (DataObject* self);
VALA_EXTERN gboolean data_source_equals (DataSource* self,
                             DataSource* source);
VALA_EXTERN guint64 media_source_get_filesize (MediaSource* self);
VALA_EXTERN guint64 media_source_get_master_filesize (MediaSource* self);
VALA_EXTERN GDateTime* media_source_get_exposure_time (MediaSource* self);
VALA_EXTERN gchar* media_source_get_basename (MediaSource* self);
VALA_EXTERN gchar* media_source_get_title (MediaSource* self);
VALA_EXTERN gchar* media_source_get_comment (MediaSource* self);
VALA_EXTERN void media_source_set_title (MediaSource* self,
                             const gchar* title);
VALA_EXTERN gboolean media_source_set_comment (MediaSource* self,
                                   const gchar* comment);
VALA_EXTERN void media_source_get_dimensions (MediaSource* self,
                                  PhotoException disallowed_steps,
                                  Dimensions* result);
VALA_EXTERN PhotoMetadata* photo_source_get_metadata (PhotoSource* self);
VALA_EXTERN void photo_rotate (Photo* self,
                   Rotation rotation);
VALA_EXTERN GdkPixbuf* photo_source_get_pixbuf (PhotoSource* self,
                                    Scaling* scaling,
                                    GError** error);
VALA_EXTERN gboolean photo_has_user_generated_metadata (Photo* self);
VALA_EXTERN void photo_set_user_metadata_for_export (Photo* self,
                                         PhotoMetadata* metadata);
VALA_EXTERN gboolean photo_exception_prohibits (PhotoException self,
                                    PhotoException exception);
VALA_EXTERN gboolean photo_exception_allows (PhotoException self,
                                 PhotoException exception);
static gpointer photo_cached_pixbuf_ref (gpointer instance);
static void photo_cached_pixbuf_unref (gpointer instance);
static GParamSpec* photo_param_spec_cached_pixbuf (const gchar* name,
                                            const gchar* nick,
                                            const gchar* blurb,
                                            GType object_type,
                                            GParamFlags flags) G_GNUC_UNUSED ;
static void photo_value_set_cached_pixbuf (GValue* value,
                                    gpointer v_object) G_GNUC_UNUSED ;
static void photo_value_take_cached_pixbuf (GValue* value,
                                     gpointer v_object) G_GNUC_UNUSED ;
static gpointer photo_value_get_cached_pixbuf (const GValue* value) G_GNUC_UNUSED ;
static GType photo_cached_pixbuf_get_type (void) G_GNUC_CONST  G_GNUC_UNUSED ;
G_DEFINE_AUTOPTR_CLEANUP_FUNC (PhotoCachedPixbuf, photo_cached_pixbuf_unref)
VALA_EXTERN BackingPhotoRow* backing_photo_row_new (void);
VALA_EXTERN BackingPhotoRow* backing_photo_row_construct (GType object_type);
static PhotoBackingReaders* photo_backing_readers_new (void);
static PhotoBackingReaders* photo_backing_readers_construct (GType object_type);
VALA_EXTERN Photo* photo_construct (GType object_type,
                        PhotoRow* row);
VALA_EXTERN PhotoSource* photo_source_construct (GType object_type,
                                     gint64 object_id);
VALA_EXTERN gchar* media_source_prep_title (const gchar* title);
VALA_EXTERN GType photo_id_get_type (void) G_GNUC_CONST ;
VALA_EXTERN PhotoID* photo_id_dup (const PhotoID* self);
VALA_EXTERN void photo_id_free (PhotoID* self);
VALA_EXTERN GType orientation_get_type (void) G_GNUC_CONST ;
VALA_EXTERN GType backing_photo_id_get_type (void) G_GNUC_CONST ;
VALA_EXTERN BackingPhotoID* backing_photo_id_dup (const BackingPhotoID* self);
VALA_EXTERN void backing_photo_id_free (BackingPhotoID* self);
VALA_EXTERN gchar* media_source_prep_comment (const gchar* comment);
VALA_EXTERN gpointer photo_file_adapter_ref (gpointer instance);
VALA_EXTERN void photo_file_adapter_unref (gpointer instance);
VALA_EXTERN GParamSpec* param_spec_photo_file_adapter (const gchar* name,
                                           const gchar* nick,
                                           const gchar* blurb,
                                           GType object_type,
                                           GParamFlags flags);
VALA_EXTERN void value_set_photo_file_adapter (GValue* value,
                                   gpointer v_object);
VALA_EXTERN void value_take_photo_file_adapter (GValue* value,
                                    gpointer v_object);
VALA_EXTERN gpointer value_get_photo_file_adapter (const GValue* value);
VALA_EXTERN GType photo_file_adapter_get_type (void) G_GNUC_CONST ;
G_DEFINE_AUTOPTR_CLEANUP_FUNC (PhotoFileAdapter, photo_file_adapter_unref)
VALA_EXTERN GType photo_file_reader_get_type (void) G_GNUC_CONST ;
G_DEFINE_AUTOPTR_CLEANUP_FUNC (PhotoFileReader, photo_file_adapter_unref)
VALA_EXTERN PhotoFileReader* photo_file_format_create_reader (PhotoFileFormat self,
                                                  const gchar* filepath);
VALA_EXTERN gboolean is_string_empty (const gchar* s);
static BackingPhotoRow* photo_get_backing_row (Photo* self,
                                        BackingPhotoID* id);
VALA_EXTERN gpointer database_table_ref (gpointer instance);
VALA_EXTERN void database_table_unref (gpointer instance);
VALA_EXTERN GParamSpec* param_spec_database_table (const gchar* name,
                                       const gchar* nick,
                                       const gchar* blurb,
                                       GType object_type,
                                       GParamFlags flags);
VALA_EXTERN void value_set_database_table (GValue* value,
                               gpointer v_object);
VALA_EXTERN void value_take_database_table (GValue* value,
                                gpointer v_object);
VALA_EXTERN gpointer value_get_database_table (const GValue* value);
VALA_EXTERN GType database_table_get_type (void) G_GNUC_CONST ;
G_DEFINE_AUTOPTR_CLEANUP_FUNC (DatabaseTable, database_table_unref)
VALA_EXTERN GType photo_table_get_type (void) G_GNUC_CONST ;
G_DEFINE_AUTOPTR_CLEANUP_FUNC (PhotoTable, database_table_unref)
VALA_EXTERN PhotoTable* photo_table_get_instance (void);
VALA_EXTERN GQuark database_error_quark (void);
VALA_EXTERN GType database_error_get_type (void) G_GNUC_CONST ;
VALA_EXTERN void photo_table_detach_editable (PhotoTable* self,
                                  PhotoRow* row,
                                  GError** error);
VALA_EXTERN void photo_remove_all_transformations (Photo* self,
                                       gboolean notify);
VALA_EXTERN RawDeveloper* raw_developer_as_array (gint* result_length1);
VALA_EXTERN void photo_init_photo (void);
VALA_EXTERN void photo_terminate_photo (void);
static void photo_real_notify_editable_replaced (Photo* self,
                                          GFile* old_file,
                                          GFile* new_file);
static void photo_real_notify_raw_development_modified (Photo* self);
static void photo_real_notify_baseline_replaced (Photo* self);
static void photo_real_notify_master_reimported (Photo* self,
                                          PhotoMetadata* metadata);
static void photo_real_notify_editable_reimported (Photo* self,
                                            PhotoMetadata* metadata);
static void photo_real_notify_source_reimported (Photo* self,
                                          PhotoMetadata* metadata);
static void photo_real_notify_baseline_reimported (Photo* self,
                                            PhotoMetadata* metadata);
static gboolean photo_real_internal_delete_backing (DataSource* base,
                                             GError** error);
VALA_EXTERN GFile* photo_file_adapter_get_file (PhotoFileAdapter* self);
static void photo_detach_editable (Photo* self,
                            gboolean delete_editable,
                            gboolean remove_transformations,
                            gboolean notify);
VALA_EXTERN PhotoFileFormat photo_get_master_file_format (Photo* self);
static gboolean photo_delete_raw_development (Photo* self,
                                       RawDeveloper d);
VALA_EXTERN GType backing_photo_table_get_type (void) G_GNUC_CONST ;
G_DEFINE_AUTOPTR_CLEANUP_FUNC (BackingPhotoTable, database_table_unref)
VALA_EXTERN BackingPhotoTable* backing_photo_table_get_instance (void);
VALA_EXTERN BackingPhotoRow* backing_photo_table_fetch (BackingPhotoTable* self,
                                            BackingPhotoID* id,
                                            GError** error);
VALA_EXTERN void backing_photo_table_remove (BackingPhotoTable* self,
                                 BackingPhotoID* backing_id,
                                 GError** error);
VALA_EXTERN gboolean photo_is_raw_developer_complete (Photo* self,
                                          RawDeveloper d);
VALA_EXTERN gboolean photo_is_raw_developer_available (Photo* self,
                                           RawDeveloper d);
VALA_EXTERN PhotoMetadata* photo_get_master_metadata (Photo* self,
                                          GError** error);
VALA_EXTERN guint photo_metadata_get_preview_count (PhotoMetadata* self);
VALA_EXTERN gpointer photo_preview_ref (gpointer instance);
VALA_EXTERN void photo_preview_unref (gpointer instance);
VALA_EXTERN GParamSpec* param_spec_photo_preview (const gchar* name,
                                      const gchar* nick,
                                      const gchar* blurb,
                                      GType object_type,
                                      GParamFlags flags);
VALA_EXTERN void value_set_photo_preview (GValue* value,
                              gpointer v_object);
VALA_EXTERN void value_take_photo_preview (GValue* value,
                               gpointer v_object);
VALA_EXTERN gpointer value_get_photo_preview (const GValue* value);
VALA_EXTERN GType photo_preview_get_type (void) G_GNUC_CONST ;
G_DEFINE_AUTOPTR_CLEANUP_FUNC (PhotoPreview, photo_preview_unref)
VALA_EXTERN PhotoPreview* photo_metadata_get_preview (PhotoMetadata* self,
                                          guint number);
VALA_EXTERN void photo_preview_get_pixel_dimensions (PhotoPreview* self,
                                         Dimensions* result);
VALA_EXTERN void photo_add_backing_photo_for_development (Photo* self,
                                              RawDeveloper d,
                                              BackingPhotoRow* bpr,
                                              gboolean notify,
                                              GError** error);
VALA_EXTERN void photo_import_developed_backing_photo (PhotoRow* row,
                                           RawDeveloper d,
                                           BackingPhotoRow* bpr,
                                           GError** error);
VALA_EXTERN void data_object_notify_altered (DataObject* self,
                                 Alteration* alteration);
VALA_EXTERN Alteration* alteration_new (const gchar* subject,
                            const gchar* detail);
VALA_EXTERN Alteration* alteration_construct (GType object_type,
                                  const gchar* subject,
                                  const gchar* detail);
VALA_EXTERN GDateTime* coarsify_date_time (GDateTime* dt);
VALA_EXTERN gpointer photo_file_interrogator_ref (gpointer instance);
VALA_EXTERN void photo_file_interrogator_unref (gpointer instance);
VALA_EXTERN GParamSpec* param_spec_photo_file_interrogator (const gchar* name,
                                                const gchar* nick,
                                                const gchar* blurb,
                                                GType object_type,
                                                GParamFlags flags);
VALA_EXTERN void value_set_photo_file_interrogator (GValue* value,
                                        gpointer v_object);
VALA_EXTERN void value_take_photo_file_interrogator (GValue* value,
                                         gpointer v_object);
VALA_EXTERN gpointer value_get_photo_file_interrogator (const GValue* value);
VALA_EXTERN GType photo_file_interrogator_get_type (void) G_GNUC_CONST ;
G_DEFINE_AUTOPTR_CLEANUP_FUNC (PhotoFileInterrogator, photo_file_interrogator_unref)
VALA_EXTERN PhotoFileInterrogator* photo_file_interrogator_new (GFile* file,
                                                    PhotoFileSnifferOptions options);
VALA_EXTERN PhotoFileInterrogator* photo_file_interrogator_construct (GType object_type,
                                                          GFile* file,
                                                          PhotoFileSnifferOptions options);
VALA_EXTERN void photo_file_interrogator_interrogate (PhotoFileInterrogator* self,
                                          GError** error);
VALA_EXTERN gpointer detected_photo_information_ref (gpointer instance);
VALA_EXTERN void detected_photo_information_unref (gpointer instance);
VALA_EXTERN GParamSpec* param_spec_detected_photo_information (const gchar* name,
                                                   const gchar* nick,
                                                   const gchar* blurb,
                                                   GType object_type,
                                                   GParamFlags flags);
VALA_EXTERN void value_set_detected_photo_information (GValue* value,
                                           gpointer v_object);
VALA_EXTERN void value_take_detected_photo_information (GValue* value,
                                            gpointer v_object);
VALA_EXTERN gpointer value_get_detected_photo_information (const GValue* value);
VALA_EXTERN GType detected_photo_information_get_type (void) G_GNUC_CONST ;
G_DEFINE_AUTOPTR_CLEANUP_FUNC (DetectedPhotoInformation, detected_photo_information_unref)
VALA_EXTERN DetectedPhotoInformation* photo_file_interrogator_get_detected_photo_information (PhotoFileInterrogator* self);
VALA_EXTERN gboolean photo_file_interrogator_get_is_photo_corrupted (PhotoFileInterrogator* self);
VALA_EXTERN Orientation photo_metadata_get_orientation (PhotoMetadata* self);
VALA_EXTERN void backing_photo_table_add (BackingPhotoTable* self,
                              BackingPhotoRow* state,
                              GError** error);
VALA_EXTERN void photo_table_update_raw_development (PhotoTable* self,
                                         PhotoRow* row,
                                         RawDeveloper rd,
                                         BackingPhotoID* backing_photo_id,
                                         GError** error);
static void photo_develop_photo (Photo* self,
                          RawDeveloper d,
                          gboolean notify);
VALA_EXTERN BackingPhotoRow* raw_developer_create_backing_row_for_development (RawDeveloper self,
                                                                   const gchar* raw_filepath,
                                                                   const gchar* camera_development_filename,
                                                                   GError** error);
VALA_EXTERN GdkPixbuf* photo_get_master_pixbuf (Photo* self,
                                    Scaling* scaling,
                                    gboolean rotate,
                                    GError** error);
VALA_EXTERN void scaling_for_original (Scaling* result);
VALA_EXTERN GType photo_file_writer_get_type (void) G_GNUC_CONST ;
G_DEFINE_AUTOPTR_CLEANUP_FUNC (PhotoFileWriter, photo_file_adapter_unref)
VALA_EXTERN GQuark photo_format_error_quark (void);
VALA_EXTERN GType photo_format_error_get_type (void) G_GNUC_CONST ;
VALA_EXTERN PhotoFileWriter* photo_file_format_create_writer (PhotoFileFormat self,
                                                  const gchar* filepath,
                                                  GError** error);
VALA_EXTERN GType jpeg_quality_get_type (void) G_GNUC_CONST ;
VALA_EXTERN void photo_file_writer_write (PhotoFileWriter* self,
                              GdkPixbuf* pixbuf,
                              JpegQuality quality,
                              GError** error);
VALA_EXTERN GType photo_file_metadata_writer_get_type (void) G_GNUC_CONST ;
G_DEFINE_AUTOPTR_CLEANUP_FUNC (PhotoFileMetadataWriter, photo_file_adapter_unref)
VALA_EXTERN PhotoFileMetadataWriter* photo_file_format_create_metadata_writer (PhotoFileFormat self,
                                                                   const gchar* filepath,
                                                                   GError** error);
VALA_EXTERN void photo_file_metadata_writer_write_metadata (PhotoFileMetadataWriter* self,
                                                PhotoMetadata* metadata,
                                                GError** error);
VALA_EXTERN GBytes* photo_preview_flatten (PhotoPreview* self,
                               GError** error);
VALA_EXTERN gboolean jpeg_is_jpeg_bytes (GBytes* bytes,
                             GError** error);
VALA_EXTERN GdkPixbuf* photo_preview_get_pixbuf (PhotoPreview* self,
                                     GError** error);
VALA_EXTERN void photo_set_default_raw_developer (Photo* self,
                                      RawDeveloper d);
VALA_EXTERN void photo_set_raw_developer (Photo* self,
                              RawDeveloper d,
                              gboolean notify);
VALA_EXTERN void photo_revert_to_master (Photo* self,
                             gboolean notify);
VALA_EXTERN GdkPixbuf* photo_get_prefetched_copy (Photo* self,
                                      GError** error);
VALA_EXTERN gboolean photo_set_orientation (Photo* self,
                                Orientation orientation);
VALA_EXTERN void photo_discard_prefetched (Photo* self);
VALA_EXTERN RawDeveloper photo_get_raw_developer (Photo* self);
VALA_EXTERN gchar* raw_developer_to_string (RawDeveloper self);
VALA_EXTERN void photo_table_remove_development (PhotoTable* self,
                                     PhotoRow* row,
                                     RawDeveloper rd,
                                     GError** error);
VALA_EXTERN void photo_redevelop_raw (Photo* self,
                          RawDeveloper d);
static BackingFileState** photo_real_get_backing_files_state (MediaSource* base,
                                                       gint* result_length1);
VALA_EXTERN BackingFileState* backing_file_state_new_from_photo_row (BackingPhotoRow* photo_row,
                                                         const gchar* md5);
VALA_EXTERN BackingFileState* backing_file_state_construct_from_photo_row (GType object_type,
                                                               BackingPhotoRow* photo_row,
                                                               const gchar* md5);
static void _vala_array_add83 (BackingFileState** * array,
                        gint* length,
                        gint* size,
                        BackingFileState* value);
VALA_EXTERN gboolean photo_has_editable (Photo* self);
static void _vala_array_add84 (BackingFileState** * array,
                        gint* length,
                        gint* size,
                        BackingFileState* value);
VALA_EXTERN gboolean photo_is_developed (Photo* self);
VALA_EXTERN GeeCollection* photo_get_raw_development_photo_rows (Photo* self);
static void _vala_array_add85 (BackingFileState** * array,
                        gint* length,
                        gint* size,
                        BackingFileState* value);
static PhotoFileReader* photo_get_backing_reader (Photo* self,
                                           BackingFetchMode mode);
static PhotoFileReader* photo_get_master_reader (Photo* self);
static PhotoFileReader* photo_get_baseline_reader (Photo* self);
static PhotoFileReader* photo_get_source_reader (Photo* self);
static PhotoFileReader* photo_get_raw_developer_reader (Photo* self);
VALA_EXTERN PhotoFileReader* photo_get_editable_reader (Photo* self);
VALA_EXTERN gboolean photo_does_master_exist (Photo* self);
VALA_EXTERN gboolean photo_file_adapter_file_exists (PhotoFileAdapter* self);
VALA_EXTERN gboolean photo_does_editable_exist (Photo* self);
VALA_EXTERN gboolean photo_is_master_baseline (Photo* self);
VALA_EXTERN gboolean photo_is_master_source (Photo* self);
VALA_EXTERN gboolean photo_is_editable_baseline (Photo* self);
VALA_EXTERN gboolean photo_is_editable_source (Photo* self);
VALA_EXTERN BackingPhotoRow* photo_get_master_photo_row (Photo* self);
VALA_EXTERN BackingPhotoRow* photo_get_editable_photo_row (Photo* self);
VALA_EXTERN gboolean backing_photo_id_is_valid (BackingPhotoID *self);
VALA_EXTERN BackingPhotoRow* photo_get_raw_development_photo_row (Photo* self,
                                                      RawDeveloper d);
VALA_EXTERN PhotoFileFormat* photo_get_editable_file_format (Photo* self);
VALA_EXTERN PhotoFileFormat photo_file_adapter_get_file_format (PhotoFileAdapter* self);
static PhotoFileFormat* _photo_file_format_dup (PhotoFileFormat* self);
VALA_EXTERN GType export_format_parameters_get_type (void) G_GNUC_CONST ;
VALA_EXTERN GType export_format_mode_get_type (void) G_GNUC_CONST ;
VALA_EXTERN ExportFormatParameters* export_format_parameters_dup (const ExportFormatParameters* self);
VALA_EXTERN void export_format_parameters_free (ExportFormatParameters* self);
VALA_EXTERN PhotoFileFormat photo_get_export_format_for_parameters (Photo* self,
                                                        ExportFormatParameters* params);
VALA_EXTERN PhotoFileFormat photo_file_format_get_system_default_format (void);
VALA_EXTERN PhotoFileFormat photo_get_best_export_file_format (Photo* self);
VALA_EXTERN gchar* photo_get_export_basename_for_parameters (Photo* self,
                                                 ExportFormatParameters* params);
VALA_EXTERN gchar* photo_get_export_basename (Photo* self,
                                  PhotoFileFormat* file_format);
VALA_EXTERN GType import_result_get_type (void) G_GNUC_CONST ;
VALA_EXTERN ImportResult photo_prepare_for_import (PhotoImportParams* params);
VALA_EXTERN gboolean photo_is_file_image (GFile* file);
VALA_EXTERN gboolean photo_file_format_is_file_supported (GFile* file);
VALA_EXTERN MetadataDateTime* photo_metadata_get_exposure_date_time (PhotoMetadata* self);
VALA_EXTERN void photo_metadata_get_gps_coords (PhotoMetadata* self,
                                    GpsCoords* result);
VALA_EXTERN GeeSet* photo_metadata_get_keywords (PhotoMetadata* self,
                                     GCompareDataFunc compare_func,
                                     gpointer compare_func_target,
                                     GDestroyNotify compare_func_target_destroy_notify);
VALA_EXTERN Rating photo_metadata_get_rating (PhotoMetadata* self);
VALA_EXTERN void photo_id_init (PhotoID *self,
                    gint64 id);
VALA_EXTERN void event_id_init (EventID *self,
                    gint64 id);
VALA_EXTERN GType photo_file_reader_role_get_type (void) G_GNUC_CONST ;
VALA_EXTERN void photo_file_reader_set_role (PhotoFileReader* self,
                                 PhotoFileReaderRole role);
VALA_EXTERN void thumbnail_cache_generate_for_photo (Thumbnails* thumbnails,
                                         PhotoFileReader* reader,
                                         Orientation orientation,
                                         Dimensions* original_dim,
                                         GError** error);
VALA_EXTERN ImportResult import_result_convert_error (GError* err,
                                          ImportResult default_result);
VALA_EXTERN void photo_create_pre_import (PhotoImportParams* params);
VALA_EXTERN void dimensions_init (Dimensions *self,
                      gint width,
                      gint height);
VALA_EXTERN BackingPhotoRow* photo_query_backing_photo_row (Photo* self,
                                                GFile* file,
                                                PhotoFileSnifferOptions options,
                                                DetectedPhotoInformation** detected,
                                                GError** error);
VALA_EXTERN gpointer photo_reimport_master_state_ref (gpointer instance);
VALA_EXTERN void photo_reimport_master_state_unref (gpointer instance);
VALA_EXTERN GParamSpec* photo_param_spec_reimport_master_state (const gchar* name,
                                                    const gchar* nick,
                                                    const gchar* blurb,
                                                    GType object_type,
                                                    GParamFlags flags);
VALA_EXTERN void photo_value_set_reimport_master_state (GValue* value,
                                            gpointer v_object);
VALA_EXTERN void photo_value_take_reimport_master_state (GValue* value,
                                             gpointer v_object);
VALA_EXTERN gpointer photo_value_get_reimport_master_state (const GValue* value);
VALA_EXTERN GType photo_reimport_master_state_get_type (void) G_GNUC_CONST ;
G_DEFINE_AUTOPTR_CLEANUP_FUNC (PhotoReimportMasterState, photo_reimport_master_state_unref)
VALA_EXTERN gboolean photo_prepare_for_reimport_master (Photo* self,
                                            PhotoReimportMasterState** reimport_state,
                                            GError** error);
static void _vala_array_add86 (gchar** * array,
                        gint* length,
                        gint* size,
                        gchar* value);
static void _vala_array_add87 (gchar** * array,
                        gint* length,
                        gint* size,
                        gchar* value);
static void _vala_array_add88 (gchar** * array,
                        gint* length,
                        gint* size,
                        gchar* value);
static void _vala_array_add89 (gchar** * array,
                        gint* length,
                        gint* size,
                        gchar* value);
static gboolean _gps_coords_equal (const GpsCoords * s1,
                            const GpsCoords * s2);
static void _vala_array_add90 (gchar** * array,
                        gint* length,
                        gint* size,
                        gchar* value);
static void _vala_array_add91 (gchar** * array,
                        gint* length,
                        gint* size,
                        gchar* value);
static void _vala_array_add92 (gchar** * array,
                        gint* length,
                        gint* size,
                        gchar* value);
static PhotoReimportMasterStateImpl* photo_reimport_master_state_impl_new (PhotoRow* row,
                                                                    PhotoMetadata* metadata,
                                                                    gchar** alterations,
                                                                    gint alterations_length1);
static PhotoReimportMasterStateImpl* photo_reimport_master_state_impl_construct (GType object_type,
                                                                          PhotoRow* row,
                                                                          PhotoMetadata* metadata,
                                                                          gchar** alterations,
                                                                          gint alterations_length1);
static GType photo_reimport_master_state_impl_get_type (void) G_GNUC_CONST  G_GNUC_UNUSED ;
G_DEFINE_AUTOPTR_CLEANUP_FUNC (PhotoReimportMasterStateImpl, photo_reimport_master_state_unref)
static void photo_real_apply_user_metadata_for_reimport (Photo* self,
                                                  PhotoMetadata* metadata);
VALA_EXTERN void photo_finish_reimport_master (Photo* self,
                                   PhotoReimportMasterState* state,
                                   GError** error);
VALA_EXTERN void photo_table_reimport (PhotoTable* self,
                           PhotoRow* row,
                           GError** error);
VALA_EXTERN void backing_photo_row_copy_from (BackingPhotoRow* self,
                                  BackingPhotoRow* from);
static void _vala_array_add93 (gchar** * array,
                        gint* length,
                        gint* size,
                        gchar* value);
static void _vala_array_add94 (gchar** * array,
                        gint* length,
                        gint* size,
                        gchar* value);
VALA_EXTERN Alteration* alteration_new_from_array (gchar** array,
                                       gint array_length1);
VALA_EXTERN Alteration* alteration_construct_from_array (GType object_type,
                                             gchar** array,
                                             gint array_length1);
static gboolean photo_verify_file_for_reimport (Photo* self,
                                         GFile* file,
                                         BackingPhotoRow** backing,
                                         DetectedPhotoInformation** detected,
                                         GError** error);
VALA_EXTERN gpointer photo_reimport_editable_state_ref (gpointer instance);
VALA_EXTERN void photo_reimport_editable_state_unref (gpointer instance);
VALA_EXTERN GParamSpec* photo_param_spec_reimport_editable_state (const gchar* name,
                                                      const gchar* nick,
                                                      const gchar* blurb,
                                                      GType object_type,
                                                      GParamFlags flags);
VALA_EXTERN void photo_value_set_reimport_editable_state (GValue* value,
                                              gpointer v_object);
VALA_EXTERN void photo_value_take_reimport_editable_state (GValue* value,
                                               gpointer v_object);
VALA_EXTERN gpointer photo_value_get_reimport_editable_state (const GValue* value);
VALA_EXTERN GType photo_reimport_editable_state_get_type (void) G_GNUC_CONST ;
G_DEFINE_AUTOPTR_CLEANUP_FUNC (PhotoReimportEditableState, photo_reimport_editable_state_unref)
VALA_EXTERN gboolean photo_prepare_for_reimport_editable (Photo* self,
                                              PhotoReimportEditableState** state,
                                              GError** error);
VALA_EXTERN GFile* photo_get_editable_file (Photo* self);
static PhotoReimportEditableStateImpl* photo_reimport_editable_state_impl_new (BackingPhotoRow* backing_state,
                                                                        PhotoMetadata* metadata);
static PhotoReimportEditableStateImpl* photo_reimport_editable_state_impl_construct (GType object_type,
                                                                              BackingPhotoRow* backing_state,
                                                                              PhotoMetadata* metadata);
static GType photo_reimport_editable_state_impl_get_type (void) G_GNUC_CONST  G_GNUC_UNUSED ;
G_DEFINE_AUTOPTR_CLEANUP_FUNC (PhotoReimportEditableStateImpl, photo_reimport_editable_state_unref)
VALA_EXTERN void photo_finish_reimport_editable (Photo* self,
                                     PhotoReimportEditableState* state,
                                     GError** error);
VALA_EXTERN void photo_get_editable_id (Photo* self,
                            BackingPhotoID* result);
VALA_EXTERN gboolean backing_photo_id_is_invalid (BackingPhotoID *self);
VALA_EXTERN void backing_photo_table_update (BackingPhotoTable* self,
                                 BackingPhotoRow* row,
                                 GError** error);
VALA_EXTERN void positionable_set_gps_coords (Positionable* self,
                                  GpsCoords* gps_coords);
VALA_EXTERN Alteration* alteration_new_from_list (const gchar* list);
VALA_EXTERN Alteration* alteration_construct_from_list (GType object_type,
                                            const gchar* list);
VALA_EXTERN gpointer photo_reimport_raw_development_state_ref (gpointer instance);
VALA_EXTERN void photo_reimport_raw_development_state_unref (gpointer instance);
VALA_EXTERN GParamSpec* photo_param_spec_reimport_raw_development_state (const gchar* name,
                                                             const gchar* nick,
                                                             const gchar* blurb,
                                                             GType object_type,
                                                             GParamFlags flags);
VALA_EXTERN void photo_value_set_reimport_raw_development_state (GValue* value,
                                                     gpointer v_object);
VALA_EXTERN void photo_value_take_reimport_raw_development_state (GValue* value,
                                                      gpointer v_object);
VALA_EXTERN gpointer photo_value_get_reimport_raw_development_state (const GValue* value);
VALA_EXTERN GType photo_reimport_raw_development_state_get_type (void) G_GNUC_CONST ;
G_DEFINE_AUTOPTR_CLEANUP_FUNC (PhotoReimportRawDevelopmentState, photo_reimport_raw_development_state_unref)
VALA_EXTERN gboolean photo_prepare_for_reimport_raw_development (Photo* self,
                                                     PhotoReimportRawDevelopmentState** state,
                                                     GError** error);
VALA_EXTERN GeeCollection* photo_get_raw_developer_files (Photo* self);
static GType photo_reimport_raw_development_state_impl_get_type (void) G_GNUC_CONST  G_GNUC_UNUSED ;
G_DEFINE_AUTOPTR_CLEANUP_FUNC (PhotoReimportRawDevelopmentStateImpl, photo_reimport_raw_development_state_unref)
static PhotoReimportRawDevelopmentStateImpl* photo_reimport_raw_development_state_impl_new (void);
static PhotoReimportRawDevelopmentStateImpl* photo_reimport_raw_development_state_impl_construct (GType object_type);
static void photo_reimport_raw_development_state_impl_add (PhotoReimportRawDevelopmentStateImpl* self,
                                                    BackingPhotoRow* backing,
                                                    PhotoMetadata* metadata);
static gint photo_reimport_raw_development_state_impl_get_size (PhotoReimportRawDevelopmentStateImpl* self);
VALA_EXTERN void photo_finish_reimport_raw_development (Photo* self,
                                            PhotoReimportRawDevelopmentState* state,
                                            GError** error);
static gpointer photo_reimport_raw_development_state_impl_dev_to_reimport_ref (gpointer instance);
static void photo_reimport_raw_development_state_impl_dev_to_reimport_unref (gpointer instance);
static GParamSpec* photo_reimport_raw_development_state_impl_param_spec_dev_to_reimport (const gchar* name,
                                                                                  const gchar* nick,
                                                                                  const gchar* blurb,
                                                                                  GType object_type,
                                                                                  GParamFlags flags) G_GNUC_UNUSED ;
static void photo_reimport_raw_development_state_impl_value_set_dev_to_reimport (GValue* value,
                                                                          gpointer v_object) G_GNUC_UNUSED ;
static void photo_reimport_raw_development_state_impl_value_take_dev_to_reimport (GValue* value,
                                                                           gpointer v_object) G_GNUC_UNUSED ;
static gpointer photo_reimport_raw_development_state_impl_value_get_dev_to_reimport (const GValue* value) G_GNUC_UNUSED ;
VALA_EXTERN GType photo_reimport_raw_development_state_impl_dev_to_reimport_get_type (void) G_GNUC_CONST ;
G_DEFINE_AUTOPTR_CLEANUP_FUNC (PhotoReimportRawDevelopmentStateImplDevToReimport, photo_reimport_raw_development_state_impl_dev_to_reimport_unref)
static gchar* photo_real_get_typename (DataSource* base);
static gint64 photo_real_get_instance_id (DataSource* base);
VALA_EXTERN void photo_get_photo_id (Photo* self,
                         PhotoID* result);
static gchar* photo_real_get_source_id (DataSource* base);
VALA_EXTERN void photo_set_master_timestamp (Photo* self,
                                 GFileInfo* info);
VALA_EXTERN void photo_table_update_timestamp (PhotoTable* self,
                                   PhotoID* photo_id,
                                   GDateTime* timestamp,
                                   GError** error);
VALA_EXTERN void app_window_database_error (GError* err);
VALA_EXTERN void photo_update_editable_modification_time (Photo* self,
                                              GFileInfo* info,
                                              GError** error);
VALA_EXTERN void backing_photo_table_update_timestamp (BackingPhotoTable* self,
                                           BackingPhotoID* id,
                                           GDateTime* timestamp,
                                           GError** error);
VALA_EXTERN void photo_update_many_editable_timestamps (GeeMap* map,
                                            GError** error);
VALA_EXTERN void database_table_begin_transaction (void);
VALA_EXTERN void database_table_commit_transaction (GError** error);
static PhotoFileFormat photo_real_get_preferred_thumbnail_format (ThumbnailSource* base);
VALA_EXTERN PhotoFileFormat photo_get_file_format (Photo* self);
VALA_EXTERN gboolean photo_file_format_can_write_image (PhotoFileFormat self);
static GdkPixbuf* photo_real_create_thumbnail (ThumbnailSource* base,
                                        gint scale,
                                        GError** error);
VALA_EXTERN void scaling_for_best_fit (gint pixels,
                           gboolean scale_up,
                           Scaling* result);
static gboolean photo_is_extension_found (const gchar* basename,
                                   gchar** extensions,
                                   gint extensions_length1);
VALA_EXTERN void disassemble_filename (const gchar* basename,
                           gchar** name,
                           gchar** ext);
VALA_EXTERN gboolean photo_is_duplicate (GFile* file,
                             const gchar* thumbnail_md5,
                             const gchar* full_md5,
                             PhotoFileFormat file_format);
VALA_EXTERN gboolean photo_table_has_duplicate (PhotoTable* self,
                                    GFile* file,
                                    const gchar* thumbnail_md5,
                                    const gchar* md5,
                                    PhotoFileFormat file_format);
VALA_EXTERN PhotoID* photo_get_duplicate_ids (GFile* file,
                                  const gchar* thumbnail_md5,
                                  const gchar* full_md5,
                                  PhotoFileFormat file_format,
                                  gint* result_length1);
VALA_EXTERN PhotoID* photo_table_get_duplicate_ids (PhotoTable* self,
                                        GFile* file,
                                        const gchar* thumbnail_md5,
                                        const gchar* md5,
                                        PhotoFileFormat file_format,
                                        gint* result_length1);
VALA_EXTERN gint64 photo_get_photo_key (DataSource* source);
VALA_EXTERN GType library_photo_get_type (void) G_GNUC_CONST ;
G_DEFINE_AUTOPTR_CLEANUP_FUNC (LibraryPhoto, g_object_unref)
static GFile* photo_real_get_file (MediaSource* base);
VALA_EXTERN void photo_set_master_file (Photo* self,
                            GFile* file);
VALA_EXTERN void photo_table_set_filepath (PhotoTable* self,
                               PhotoID* photo_id,
                               const gchar* filepath,
                               GError** error);
VALA_EXTERN void media_source_notify_master_replaced (MediaSource* self,
                                          GFile* old_file,
                                          GFile* new_file);
static void _vala_array_add95 (gchar** * array,
                        gint* length,
                        gint* size,
                        gchar* value);
static void _vala_array_add96 (gchar** * array,
                        gint* length,
                        gint* size,
                        gchar* value);
static void _vala_array_add97 (gchar** * array,
                        gint* length,
                        gint* size,
                        gchar* value);
static void _vala_array_add98 (gchar** * array,
                        gint* length,
                        gint* size,
                        gchar* value);
VALA_EXTERN void photo_set_editable_file (Photo* self,
                              GFile* file);
VALA_EXTERN void backing_photo_table_set_filepath (BackingPhotoTable* self,
                                       BackingPhotoID* id,
                                       const gchar* filepath,
                                       GError** error);
static void _vala_array_add99 (gchar** * array,
                        gint* length,
                        gint* size,
                        gchar* value);
static void _vala_array_add100 (gchar** * array,
                         gint* length,
                         gint* size,
                         gchar* value);
static void _vala_array_add101 (gchar** * array,
                         gint* length,
                         gint* size,
                         gchar* value);
VALA_EXTERN void photo_set_many_editable_file (GeeMap* map,
                                   GError** error);
VALA_EXTERN GFile* photo_get_actual_file (Photo* self);
static GFile* photo_real_get_master_file (MediaSource* base);
VALA_EXTERN GFile* photo_get_source_file (Photo* self);
VALA_EXTERN gboolean photo_file_format_can_write (PhotoFileFormat self);
static GDateTime* photo_real_get_timestamp (MediaSource* base);
static inline void photo_real_get_event_id (MediaSource* base,
                              EventID* result);
VALA_EXTERN gint64 photo_get_raw_event_id (Photo* self);
static void photo_real_get_import_id (MediaSource* base,
                               ImportID* result);
static gchar* photo_real_get_master_md5 (MediaSource* base);
VALA_EXTERN guint64 photo_get_flags (Photo* self);
static void photo_notify_flags_altered (Photo* self,
                                 Alteration* additional_alteration);
VALA_EXTERN Alteration* alteration_compress (Alteration* self,
                                 Alteration* other);
VALA_EXTERN guint64 photo_replace_flags (Photo* self,
                             guint64 flags,
                             Alteration* additional_alteration);
VALA_EXTERN gboolean photo_table_replace_flags (PhotoTable* self,
                                    PhotoID* photo_id,
                                    guint64 flags);
VALA_EXTERN gboolean photo_is_flag_set (Photo* self,
                            guint64 mask);
VALA_EXTERN gboolean media_source_internal_is_flag_set (guint64 flags,
                                            guint64 selector);
VALA_EXTERN guint64 photo_add_flags (Photo* self,
                         guint64 mask,
                         Alteration* additional_alteration);
VALA_EXTERN guint64 media_source_internal_add_flags (guint64 flags,
                                         guint64 selector);
VALA_EXTERN guint64 photo_remove_flags (Photo* self,
                            guint64 mask,
                            Alteration* additional_alteration);
VALA_EXTERN guint64 media_source_internal_remove_flags (guint64 flags,
                                            guint64 selector);
VALA_EXTERN guint64 photo_add_remove_flags (Photo* self,
                                guint64 add,
                                guint64 remove,
                                Alteration* additional_alteration);
VALA_EXTERN void photo_add_remove_many_flags (GeeCollection* add,
                                  guint64 add_mask,
                                  Alteration* additional_add_alteration,
                                  GeeCollection* remove,
                                  guint64 remove_mask,
                                  Alteration* additional_remove_alteration,
                                  GError** error);
VALA_EXTERN guint64 photo_toggle_flags (Photo* self,
                            guint64 mask,
                            Alteration* additional_alteration);
VALA_EXTERN gboolean photo_is_master_metadata_dirty (Photo* self);
VALA_EXTERN void photo_set_master_metadata_dirty (Photo* self,
                                      gboolean dirty,
                                      GError** error);
VALA_EXTERN void photo_table_set_metadata_dirty (PhotoTable* self,
                                     PhotoID* photo_id,
                                     gboolean dirty,
                                     GError** error);
static Rating photo_real_get_rating (MediaSource* base);
static void photo_real_set_rating (MediaSource* base,
                            Rating rating);
VALA_EXTERN gboolean photo_table_set_rating (PhotoTable* self,
                                 PhotoID* photo_id,
                                 Rating rating);
static void photo_real_increase_rating (MediaSource* base);
static void photo_real_decrease_rating (MediaSource* base);
static void photo_real_commit_backlinks (DataSource* base,
                                  SourceCollection* sources,
                                  const gchar* backlinks);
VALA_EXTERN void photo_table_update_backlinks (PhotoTable* self,
                                   PhotoID* photo_id,
                                   const gchar* backlinks,
                                   GError** error);
static gboolean photo_real_set_event_id (MediaSource* base,
                                  EventID* event_id);
VALA_EXTERN gboolean photo_table_set_event (PhotoTable* self,
                                PhotoID* photo_id,
                                EventID* event_id);
static gchar* photo_real_to_string (DataObject* base);
VALA_EXTERN gchar* photo_file_adapter_get_filepath (PhotoFileAdapter* self);
static gboolean photo_real_equals (DataSource* base,
                            DataSource* source);
static void photo_file_exif_updated (Photo* self);
VALA_EXTERN gboolean photo_table_master_exif_updated (PhotoTable* self,
                                          PhotoID* photoID,
                                          gint64 filesize,
                                          GDateTime* timestamp,
                                          const gchar* md5,
                                          const gchar* exif_md5,
                                          const gchar* thumbnail_md5,
                                          PhotoRow* row);
static guint64 photo_real_get_filesize (MediaSource* base);
static guint64 photo_real_get_master_filesize (MediaSource* base);
VALA_EXTERN guint64 photo_get_editable_filesize (Photo* self);
static GDateTime* photo_real_get_exposure_time (Dateable* base);
static gchar* photo_real_get_basename (MediaSource* base);
static gchar* photo_real_get_title (MediaSource* base);
static gchar* photo_real_get_comment (MediaSource* base);
static void photo_real_set_title (MediaSource* base,
                           const gchar* title);
VALA_EXTERN gboolean photo_table_set_title (PhotoTable* self,
                                PhotoID* photo_id,
                                const gchar* new_title);
static void photo_real_get_gps_coords (Positionable* base,
                                GpsCoords* result);
static void photo_real_set_gps_coords (Positionable* base,
                                GpsCoords* gps_coords);
VALA_EXTERN void photo_table_set_gps_coords (PhotoTable* self,
                                 PhotoID* photo_id,
                                 GpsCoords* new_gps_coords,
                                 GError** error);
static gboolean photo_real_set_comment (MediaSource* base,
                                 const gchar* comment);
VALA_EXTERN gboolean photo_table_set_comment (PhotoTable* self,
                                  PhotoID* photo_id,
                                  const gchar* new_comment);
VALA_EXTERN void photo_set_import_id (Photo* self,
                          ImportID* import_id);
VALA_EXTERN void photo_table_set_import_id (PhotoTable* self,
                                PhotoID* photo_id,
                                ImportID* import_id,
                                GError** error);
VALA_EXTERN void photo_set_title_persistent (Photo* self,
                                 const gchar* title,
                                 GError** error);
VALA_EXTERN gboolean photo_file_format_can_write_metadata (PhotoFileFormat self);
VALA_EXTERN PhotoMetadata* photo_file_reader_read_metadata (PhotoFileReader* self,
                                                GError** error);
VALA_EXTERN GType photo_metadata_set_option_get_type (void) G_GNUC_CONST ;
VALA_EXTERN void photo_metadata_set_title (PhotoMetadata* self,
                               const gchar* title,
                               PhotoMetadataSetOption option);
VALA_EXTERN PhotoFileMetadataWriter* photo_file_reader_create_metadata_writer (PhotoFileReader* self,
                                                                   GError** error);
VALA_EXTERN void library_monitor_blacklist_file (GFile* file,
                                     const gchar* reason);
VALA_EXTERN void library_monitor_unblacklist_file (GFile* file);
VALA_EXTERN void photo_set_comment_persistent (Photo* self,
                                   const gchar* comment,
                                   GError** error);
VALA_EXTERN void photo_metadata_set_comment (PhotoMetadata* self,
                                 const gchar* comment,
                                 PhotoMetadataSetOption option);
static void photo_real_set_exposure_time (Dateable* base,
                                   GDateTime* time);
VALA_EXTERN gboolean photo_table_set_exposure_time (PhotoTable* self,
                                        PhotoID* photo_id,
                                        GDateTime* time);
VALA_EXTERN void photo_set_exposure_time_persistent (Photo* self,
                                         GDateTime* time,
                                         GError** error);
VALA_EXTERN void dateable_set_exposure_time (Dateable* self,
                                 GDateTime* target_time);
VALA_EXTERN void photo_metadata_set_exposure_date_time (PhotoMetadata* self,
                                            MetadataDateTime* date_time,
                                            PhotoMetadataSetOption option);
static void photo_real_get_dimensions (MediaSource* base,
                                PhotoException disallowed_steps,
                                Dimensions* result);
VALA_EXTERN void photo_get_raw_dimensions (Photo* self,
                               Dimensions* result);
VALA_EXTERN Orientation photo_get_orientation (Photo* self);
VALA_EXTERN gboolean photo_get_straighten (Photo* self,
                               gdouble* theta);
VALA_EXTERN void compute_arb_rotated_size (gdouble src_width,
                               gdouble src_height,
                               gdouble angle,
                               gdouble* dest_width,
                               gdouble* dest_height);
VALA_EXTERN GType box_get_type (void) G_GNUC_CONST ;
VALA_EXTERN Box* box_dup (const Box* self);
VALA_EXTERN void box_free (Box* self);
VALA_EXTERN gboolean photo_get_crop (Photo* self,
                         Box* crop,
                         PhotoException exceptions);
VALA_EXTERN void box_get_dimensions (Box *self,
                         Dimensions* result);
static void photo_locked_create_adjustments_from_data (Photo* self);
static KeyValueMap* photo_get_transformation (Photo* self,
                                       const gchar* name);
VALA_EXTERN PixelTransformationBundle* photo_get_color_adjustments (Photo* self);
VALA_EXTERN PixelTransformer* photo_get_pixel_transformer (Photo* self);
VALA_EXTERN gboolean photo_has_color_adjustments (Photo* self);
static gboolean photo_has_transformation (Photo* self,
                                   const gchar* name);
VALA_EXTERN PixelTransformation* photo_get_color_adjustment (Photo* self,
                                                 PixelTransformationType type);
VALA_EXTERN void photo_set_color_adjustments (Photo* self,
                                  PixelTransformationBundle* new_adjustments);
static gboolean photo_remove_transformation (Photo* self,
                                      const gchar* name);
static gboolean photo_set_transformation (Photo* self,
                                   KeyValueMap* trans);
static PhotoMetadata* photo_real_get_metadata (PhotoSource* base);
VALA_EXTERN PhotoMetadata* photo_get_editable_metadata (Photo* self,
                                            GError** error);
VALA_EXTERN gboolean photo_persist_master_metadata (Photo* self,
                                        PhotoMetadata* metadata,
                                        PhotoReimportMasterState** state,
                                        GError** error);
VALA_EXTERN void photo_finish_update_master_metadata (Photo* self,
                                          PhotoReimportMasterState* state,
                                          GError** error);
VALA_EXTERN gboolean photo_persist_editable_metadata (Photo* self,
                                          PhotoMetadata* metadata,
                                          PhotoReimportEditableState** state,
                                          GError** error);
VALA_EXTERN void photo_finish_update_editable_metadata (Photo* self,
                                            PhotoReimportEditableState* state,
                                            GError** error);
VALA_EXTERN gboolean photo_has_transformations (Photo* self);
VALA_EXTERN gboolean photo_only_metadata_changed (Photo* self);
VALA_EXTERN gboolean photo_has_alterations (Photo* self);
VALA_EXTERN gint64 nullsafe_date_time_comperator (GDateTime* time_a,
                                      GDateTime* time_b);
VALA_EXTERN PhotoTransformationState* photo_save_transformation_state (Photo* self);
static PhotoPhotoTransformationStateImpl* photo_photo_transformation_state_impl_new (Photo* photo,
                                                                              Orientation orientation,
                                                                              GeeHashMap* transformations,
                                                                              PixelTransformer* transformer,
                                                                              PixelTransformationBundle* adjustments);
static PhotoPhotoTransformationStateImpl* photo_photo_transformation_state_impl_construct (GType object_type,
                                                                                    Photo* photo,
                                                                                    Orientation orientation,
                                                                                    GeeHashMap* transformations,
                                                                                    PixelTransformer* transformer,
                                                                                    PixelTransformationBundle* adjustments);
static GType photo_photo_transformation_state_impl_get_type (void) G_GNUC_CONST  G_GNUC_UNUSED ;
G_DEFINE_AUTOPTR_CLEANUP_FUNC (PhotoPhotoTransformationStateImpl, g_object_unref)
VALA_EXTERN gboolean photo_load_transformation_state (Photo* self,
                                          PhotoTransformationState* state);
static Orientation photo_photo_transformation_state_impl_get_orientation (PhotoPhotoTransformationStateImpl* self);
static GeeHashMap* photo_photo_transformation_state_impl_get_transformations (PhotoPhotoTransformationStateImpl* self);
static PixelTransformer* photo_photo_transformation_state_impl_get_transformer (PhotoPhotoTransformationStateImpl* self);
static PixelTransformationBundle* photo_photo_transformation_state_impl_get_color_adjustments (PhotoPhotoTransformationStateImpl* self);
VALA_EXTERN gboolean photo_table_set_transformation_state (PhotoTable* self,
                                               PhotoID* photo_id,
                                               Orientation orientation,
                                               GeeHashMap* transformations);
VALA_EXTERN gboolean photo_table_remove_all_transformations (PhotoTable* self,
                                                 PhotoID* photo_id);
VALA_EXTERN gboolean photo_table_set_orientation (PhotoTable* self,
                                      PhotoID* photo_id,
                                      Orientation orientation);
VALA_EXTERN Orientation photo_get_original_orientation (Photo* self);
VALA_EXTERN gboolean photo_check_can_rotate (Photo* self);
static void photo_real_rotate (Photo* self,
                        Rotation rotation);
VALA_EXTERN Orientation orientation_perform (Orientation self,
                                 Rotation rotation);
VALA_EXTERN gboolean photo_table_set_transformation (PhotoTable* self,
                                         PhotoID* photo_id,
                                         KeyValueMap* map);
VALA_EXTERN gboolean photo_table_remove_transformation (PhotoTable* self,
                                            PhotoID* photo_id,
                                            const gchar* object);
VALA_EXTERN gboolean photo_has_crop (Photo* self);
VALA_EXTERN gboolean photo_get_raw_crop (Photo* self,
                             Box* crop);
VALA_EXTERN void box_init (Box *self,
               gint left,
               gint top,
               gint right,
               gint bottom);
static void photo_set_raw_crop (Photo* self,
                         Box* crop);
static gboolean photo_get_raw_straighten (Photo* self,
                                   gdouble* angle);
static void photo_set_raw_straighten (Photo* self,
                               gdouble theta);
VALA_EXTERN GType editing_tools_redeye_instance_get_type (void) G_GNUC_CONST ;
VALA_EXTERN EditingToolsRedeyeInstance* editing_tools_redeye_instance_dup (const EditingToolsRedeyeInstance* self);
VALA_EXTERN void editing_tools_redeye_instance_free (EditingToolsRedeyeInstance* self);
static EditingToolsRedeyeInstance* photo_get_raw_redeye_instances (Photo* self,
                                                            gint* result_length1);
VALA_EXTERN gboolean photo_has_redeye_transformations (Photo* self);
VALA_EXTERN void photo_add_redeye_instance (Photo* self,
                                EditingToolsRedeyeInstance* redeye);
static gboolean photo_calculate_pixbuf_dimensions (Photo* self,
                                            Scaling* scaling,
                                            PhotoException exceptions,
                                            Dimensions* scaled_image,
                                            Dimensions* scaled_to_viewport);
static gboolean photo_locked_calculate_pixbuf_dimensions (Photo* self,
                                                   Scaling* scaling,
                                                   PhotoException exceptions,
                                                   Dimensions* scaled_image,
                                                   Dimensions* scaled_to_viewport);
VALA_EXTERN gboolean scaling_is_unscaled (Scaling *self);
VALA_EXTERN void orientation_rotate_box (Orientation self,
                             Dimensions* space,
                             Box* box,
                             Box* result);
VALA_EXTERN void orientation_rotate_dimensions (Orientation self,
                                    Dimensions* dim,
                                    Dimensions* result);
VALA_EXTERN void box_get_scaled (Box *self,
                     Dimensions* scaled,
                     Box* result);
VALA_EXTERN void scaling_get_scaled_dimensions (Scaling *self,
                                    Dimensions* original,
                                    Dimensions* result);
VALA_EXTERN gint box_get_width (Box *self);
VALA_EXTERN gint box_get_height (Box *self);
VALA_EXTERN void dimensions_get_scaled_similar (Dimensions *self,
                                    Dimensions* original,
                                    Dimensions* scaled,
                                    Dimensions* result);
VALA_EXTERN void orientation_derotate_dimensions (Orientation self,
                                      Dimensions* dim,
                                      Dimensions* result);
VALA_EXTERN gboolean dimensions_has_area (Dimensions *self);
static GdkPixbuf* photo_load_raw_pixbuf (Photo* self,
                                  Scaling* scaling,
                                  PhotoException exceptions,
                                  BackingFetchMode fetch_mode,
                                  GError** error);
VALA_EXTERN GdkPixbuf* photo_file_reader_unscaled_read (PhotoFileReader* self,
                                            GError** error);
VALA_EXTERN GdkPixbuf* photo_file_reader_scaled_read (PhotoFileReader* self,
                                          Dimensions* full,
                                          Dimensions* scaled,
                                          GError** error);
VALA_EXTERN gboolean dimensions_approx_equals (Dimensions *self,
                                   Dimensions* dim,
                                   gint fudge);
VALA_EXTERN void dimensions_for_pixbuf (GdkPixbuf* pixbuf,
                            Dimensions* result);
static GdkPixbuf* photo_get_untransformed_pixbuf (Photo* self,
                                           Scaling* scaling,
                                           gboolean rotate,
                                           BackingFetchMode fetch_mode,
                                           GError** error);
VALA_EXTERN GdkPixbuf* photo_get_unmodified_pixbuf (Photo* self,
                                        Scaling* scaling,
                                        gboolean rotate,
                                        GError** error);
VALA_EXTERN GdkPixbuf* orientation_rotate_pixbuf (Orientation self,
                                      GdkPixbuf* pixbuf);
static GdkPixbuf* photo_real_get_pixbuf (PhotoSource* base,
                                  Scaling* scaling,
                                  GError** error);
VALA_EXTERN GdkPixbuf* photo_get_pixbuf_with_options (Photo* self,
                                          Scaling* scaling,
                                          PhotoException exceptions,
                                          BackingFetchMode fetch_mode,
                                          GError** error);
static GdkPixbuf* photo_run_source_pixbuf_cache (Photo* locate,
                                          gboolean keep,
                                          GError** error);
static PhotoCachedPixbuf* photo_cached_pixbuf_new (Photo* photo,
                                            GdkPixbuf* pixbuf);
static PhotoCachedPixbuf* photo_cached_pixbuf_construct (GType object_type,
                                                  Photo* photo,
                                                  GdkPixbuf* pixbuf);
static gboolean photo_trim_source_pixbuf_cache (void);
static gboolean _photo_trim_source_pixbuf_cache_gsource_func (gpointer self);
VALA_EXTERN gboolean photo_get_develop_raw_photos_to_files (void);
VALA_EXTERN gboolean dimensions_equals (Dimensions *self,
                            Dimensions* dim);
static GdkPixbuf* photo_do_redeye (Photo* self,
                            GdkPixbuf* pixbuf,
                            EditingToolsRedeyeInstance* inst);
VALA_EXTERN GdkPixbuf* rotate_arb (GdkPixbuf* source_pixbuf,
                       gdouble angle);
static gboolean photo_real_has_user_generated_metadata (Photo* self);
static void photo_real_set_user_metadata_for_export (Photo* self,
                                              PhotoMetadata* metadata);
VALA_EXTERN gpointer photo_file_format_properties_ref (gpointer instance);
VALA_EXTERN void photo_file_format_properties_unref (gpointer instance);
VALA_EXTERN GParamSpec* param_spec_photo_file_format_properties (const gchar* name,
                                                     const gchar* nick,
                                                     const gchar* blurb,
                                                     GType object_type,
                                                     GParamFlags flags);
VALA_EXTERN void value_set_photo_file_format_properties (GValue* value,
                                             gpointer v_object);
VALA_EXTERN void value_take_photo_file_format_properties (GValue* value,
                                              gpointer v_object);
VALA_EXTERN gpointer value_get_photo_file_format_properties (const GValue* value);
VALA_EXTERN GType photo_file_format_properties_get_type (void) G_GNUC_CONST ;
G_DEFINE_AUTOPTR_CLEANUP_FUNC (PhotoFileFormatProperties, photo_file_format_properties_unref)
VALA_EXTERN PhotoFileFormatProperties* photo_file_format_get_properties (PhotoFileFormat self);
VALA_EXTERN GFile* photo_file_format_properties_convert_file_extension (PhotoFileFormatProperties* self,
                                                            GFile* file);
static gboolean photo_export_fullsized_backing (Photo* self,
                                         GFile* file,
                                         gboolean export_metadata,
                                         GError** error);
VALA_EXTERN PhotoMetadata* photo_file_format_create_metadata (PhotoFileFormat self);
VALA_EXTERN void photo_metadata_set_pixel_dimensions (PhotoMetadata* self,
                                          Dimensions* dim,
                                          PhotoMetadataSetOption option);
VALA_EXTERN void photo_metadata_set_orientation (PhotoMetadata* self,
                                     Orientation orientation);
VALA_EXTERN void photo_metadata_set_software (PhotoMetadata* self,
                                  const gchar* software,
                                  const gchar* version);
VALA_EXTERN void photo_metadata_remove_exif_thumbnail (PhotoMetadata* self);
VALA_EXTERN void photo_metadata_clear (PhotoMetadata* self);
VALA_EXTERN gboolean photo_is_export_required (Photo* self,
                                   Scaling* scaling,
                                   PhotoFileFormat export_format);
VALA_EXTERN void photo_export (Photo* self,
                   GFile* dest_file,
                   Scaling* scaling,
                   JpegQuality quality,
                   PhotoFileFormat export_format,
                   gboolean direct_copy_unmodified,
                   gboolean export_metadata,
                   GError** error);
VALA_EXTERN void photo_metadata_remove_tag (PhotoMetadata* self,
                                const gchar* tag);
static GFile* photo_generate_new_editable_file (Photo* self,
                                         PhotoFileFormat* file_format,
                                         GError** error);
VALA_EXTERN gboolean photo_file_format_properties_is_recognized_extension (PhotoFileFormatProperties* self,
                                                               const gchar* ext);
VALA_EXTERN gchar* photo_file_format_properties_get_default_extension (PhotoFileFormatProperties* self);
VALA_EXTERN GFile* generate_unique_file (GFile* dir,
                             const gchar* basename,
                             gboolean* collision,
                             GeeCollection* used,
                             GError** error);
static gboolean photo_launch_editor (GFile* file,
                              PhotoFileFormat file_format,
                              GError** error);
VALA_EXTERN GType configuration_facade_get_type (void) G_GNUC_CONST ;
G_DEFINE_AUTOPTR_CLEANUP_FUNC (ConfigurationFacade, g_object_unref)
VALA_EXTERN GType config_facade_get_type (void) G_GNUC_CONST ;
G_DEFINE_AUTOPTR_CLEANUP_FUNC (ConfigFacade, g_object_unref)
VALA_EXTERN ConfigFacade* config_facade_get_instance (void);
VALA_EXTERN gchar* configuration_facade_get_external_raw_app (ConfigurationFacade* self);
VALA_EXTERN gchar* configuration_facade_get_external_photo_app (ConfigurationFacade* self);
static void _g_object_unref0_ (gpointer var);
static inline void _g_list_free__g_object_unref0_ (GList* self);
VALA_EXTERN void photo_open_with_raw_external_editor (Photo* self,
                                          GError** error);
VALA_EXTERN void photo_open_with_external_editor (Photo* self,
                                      GError** error);
static void photo_halt_monitoring_editable (Photo* self);
static void photo_attach_editable (Photo* self,
                            PhotoFileFormat file_format,
                            GFile* file,
                            GError** error);
static void photo_start_monitoring_editable (Photo* self,
                                      GFile* file,
                                      GError** error);
static void photo_on_editable_file_changed (Photo* self,
                                     GFile* file,
                                     GFile* other_file,
                                     GFileMonitorEvent event);
static void _photo_on_editable_file_changed_g_file_monitor_changed (GFileMonitor* _sender,
                                                             GFile* file,
                                                             GFile* other_file,
                                                             GFileMonitorEvent event_type,
                                                             gpointer self);
static void photo_update_editable (Photo* self,
                            gboolean only_attributes,
                            PhotoFileReader* new_reader,
                            GError** error);
static void photo_update_editable_attributes (Photo* self,
                                       GError** error);
VALA_EXTERN void photo_reimport_editable (Photo* self,
                              GError** error);
VALA_EXTERN void photo_table_attach_editable (PhotoTable* self,
                                  PhotoRow* row,
                                  BackingPhotoID* editable_id,
                                  GError** error);
VALA_EXTERN void backing_photo_table_update_attributes (BackingPhotoTable* self,
                                            BackingPhotoID* id,
                                            GDateTime* timestamp,
                                            gint64 filesize,
                                            GError** error);
static void _vala_array_add102 (gchar** * array,
                         gint* length,
                         gint* size,
                         gchar* value);
static void _vala_array_add103 (gchar** * array,
                         gint* length,
                         gint* size,
                         gchar* value);
static void _vala_array_add104 (gchar** * array,
                         gint* length,
                         gint* size,
                         gchar* value);
static void _vala_array_add105 (gchar** * array,
                         gint* length,
                         gint* size,
                         gchar* value);
static void _vala_array_add106 (gchar** * array,
                         gint* length,
                         gint* size,
                         gchar* value);
static void _vala_array_add107 (gchar** * array,
                         gint* length,
                         gint* size,
                         gchar* value);
VALA_EXTERN void backing_photo_id_init (BackingPhotoID *self,
                            gint64 id);
static void photo_on_reimport_editable (Photo* self);
static void _photo_on_reimport_editable_one_shot_callback (gpointer self);
VALA_EXTERN OneShotScheduler* one_shot_scheduler_new (const gchar* name,
                                          OneShotCallback callback,
                                          gpointer callback_target);
VALA_EXTERN OneShotScheduler* one_shot_scheduler_construct (GType object_type,
                                                const gchar* name,
                                                OneShotCallback callback,
                                                gpointer callback_target);
VALA_EXTERN void one_shot_scheduler_after_timeout (OneShotScheduler* self,
                                       guint msec,
                                       gboolean reschedule);
static void photo_on_update_editable_attributes (Photo* self);
static void _photo_on_update_editable_attributes_one_shot_callback (gpointer self);
static void photo_on_remove_editable (Photo* self);
static void _photo_on_remove_editable_one_shot_callback (gpointer self);
VALA_EXTERN void photo_get_original_dimensions (Photo* self,
                                    Dimensions* result);
VALA_EXTERN void photo_get_master_dimensions (Photo* self,
                                  Dimensions* result);
VALA_EXTERN void photo_set_crop (Photo* self,
                     Box* crop);
VALA_EXTERN void orientation_derotate_box (Orientation self,
                               Dimensions* space,
                               Box* box,
                               Box* result);
VALA_EXTERN void photo_set_straighten (Photo* self,
                           gdouble theta);
static GdkPixbuf* photo_red_reduce_pixel (Photo* self,
                                   GdkPixbuf* pixbuf,
                                   gint x,
                                   gint y);
VALA_EXTERN void photo_unscaled_to_raw_point (Photo* self,
                                  GdkPoint* unscaled_point,
                                  GdkPoint* result);
VALA_EXTERN void orientation_derotate_point (Orientation self,
                                 Dimensions* space,
                                 GdkPoint* point,
                                 GdkPoint* result);
VALA_EXTERN void photo_unscaled_to_raw_rect (Photo* self,
                                 GdkRectangle* unscaled_rect,
                                 GdkRectangle* result);
VALA_EXTERN PixelTransformationBundle* photo_get_enhance_transformations (Photo* self);
VALA_EXTERN gboolean photo_enhance (Photo* self);
VALA_EXTERN void photo_set_develop_raw_photos_to_files (gboolean value);
static void photo_real_editable_replaced (Photo* self,
                                   GFile* old_file,
                                   GFile* new_file);
static void g_cclosure_user_marshal_VOID__OBJECT_OBJECT (GClosure * closure,
                                                  GValue * return_value,
                                                  guint n_param_values,
                                                  const GValue * param_values,
                                                  gpointer invocation_hint,
                                                  gpointer marshal_data);
static void photo_real_raw_development_modified (Photo* self);
static void photo_real_baseline_replaced (Photo* self);
static void photo_real_master_reimported (Photo* self,
                                   PhotoMetadata* metadata);
static void g_cclosure_user_marshal_VOID__MEDIA_METADATA (GClosure * closure,
                                                   GValue * return_value,
                                                   guint n_param_values,
                                                   const GValue * param_values,
                                                   gpointer invocation_hint,
                                                   gpointer marshal_data);
static void photo_real_editable_reimported (Photo* self,
                                     PhotoMetadata* metadata);
static void photo_real_baseline_reimported (Photo* self,
                                     PhotoMetadata* metadata);
static void photo_real_source_reimported (Photo* self,
                                   PhotoMetadata* metadata);
static void photo_photo_transformation_state_impl_on_photo_baseline_replaced (PhotoPhotoTransformationStateImpl* self);
static void _photo_photo_transformation_state_impl_on_photo_baseline_replaced_photo_baseline_replaced (Photo* _sender,
                                                                                                gpointer self);
static GeeHashMap* photo_photo_transformation_state_impl_copy_transformations (GeeHashMap* original);
static void photo_photo_transformation_state_impl_finalize (GObject * obj);
static GType photo_photo_transformation_state_impl_get_type_once (void);
static void photo_backing_readers_finalize (PhotoBackingReaders * obj);
static GType photo_backing_readers_get_type_once (void);
static void photo_cached_pixbuf_finalize (PhotoCachedPixbuf * obj);
static GType photo_cached_pixbuf_get_type_once (void);
VALA_EXTERN PhotoReimportMasterState* photo_reimport_master_state_construct (GType object_type);
static void photo_reimport_master_state_finalize (PhotoReimportMasterState * obj);
static GType photo_reimport_master_state_get_type_once (void);
static gchar** _vala_array_dup33 (gchar** self,
                           gssize length);
static void photo_reimport_master_state_impl_finalize (PhotoReimportMasterState * obj);
static GType photo_reimport_master_state_impl_get_type_once (void);
VALA_EXTERN PhotoReimportEditableState* photo_reimport_editable_state_construct (GType object_type);
static void photo_reimport_editable_state_finalize (PhotoReimportEditableState * obj);
static GType photo_reimport_editable_state_get_type_once (void);
static void photo_reimport_editable_state_impl_finalize (PhotoReimportEditableState * obj);
static GType photo_reimport_editable_state_impl_get_type_once (void);
VALA_EXTERN PhotoReimportRawDevelopmentState* photo_reimport_raw_development_state_construct (GType object_type);
static void photo_reimport_raw_development_state_finalize (PhotoReimportRawDevelopmentState * obj);
static GType photo_reimport_raw_development_state_get_type_once (void);
static PhotoReimportRawDevelopmentStateImplDevToReimport* photo_reimport_raw_development_state_impl_dev_to_reimport_new (BackingPhotoRow* backing,
                                                                                                                  PhotoMetadata* metadata);
static PhotoReimportRawDevelopmentStateImplDevToReimport* photo_reimport_raw_development_state_impl_dev_to_reimport_construct (GType object_type,
                                                                                                                        BackingPhotoRow* backing,
                                                                                                                        PhotoMetadata* metadata);
static void photo_reimport_raw_development_state_impl_dev_to_reimport_finalize (PhotoReimportRawDevelopmentStateImplDevToReimport * obj);
static GType photo_reimport_raw_development_state_impl_dev_to_reimport_get_type_once (void);
static void photo_reimport_raw_development_state_impl_finalize (PhotoReimportRawDevelopmentState * obj);
static GType photo_reimport_raw_development_state_impl_get_type_once (void);
VALA_EXTERN GDateTime* dateable_get_exposure_time (Dateable* self);
VALA_EXTERN void positionable_get_gps_coords (Positionable* self,
                                  GpsCoords* result);
static void photo_finalize (GObject * obj);
static GType photo_get_type_once (void);
static void _vala_photo_get_property (GObject * object,
                               guint property_id,
                               GValue * value,
                               GParamSpec * pspec);
static void _vala_photo_set_property (GObject * object,
                               guint property_id,
                               const GValue * value,
                               GParamSpec * pspec);
VALA_EXTERN GType marker_get_type (void) G_GNUC_CONST ;
G_DEFINE_AUTOPTR_CLEANUP_FUNC (Marker, g_object_unref)
VALA_EXTERN gpointer source_backlink_ref (gpointer instance);
VALA_EXTERN void source_backlink_unref (gpointer instance);
VALA_EXTERN GParamSpec* param_spec_source_backlink (const gchar* name,
                                        const gchar* nick,
                                        const gchar* blurb,
                                        GType object_type,
                                        GParamFlags flags);
VALA_EXTERN void value_set_source_backlink (GValue* value,
                                gpointer v_object);
VALA_EXTERN void value_take_source_backlink (GValue* value,
                                 gpointer v_object);
VALA_EXTERN gpointer value_get_source_backlink (const GValue* value);
VALA_EXTERN GType source_backlink_get_type (void) G_GNUC_CONST ;
G_DEFINE_AUTOPTR_CLEANUP_FUNC (SourceBacklink, source_backlink_unref)
VALA_EXTERN GType database_source_collection_get_type (void) G_GNUC_CONST ;
G_DEFINE_AUTOPTR_CLEANUP_FUNC (DatabaseSourceCollection, data_collection_unref)
VALA_EXTERN GType media_source_collection_get_type (void) G_GNUC_CONST ;
G_DEFINE_AUTOPTR_CLEANUP_FUNC (MediaSourceCollection, data_collection_unref)
VALA_EXTERN GType database_source_holding_tank_get_type (void) G_GNUC_CONST ;
G_DEFINE_AUTOPTR_CLEANUP_FUNC (DatabaseSourceHoldingTank, source_holding_tank_unref)
VALA_EXTERN GType media_source_holding_tank_get_type (void) G_GNUC_CONST ;
G_DEFINE_AUTOPTR_CLEANUP_FUNC (MediaSourceHoldingTank, source_holding_tank_unref)
VALA_EXTERN gpointer workers_ref (gpointer instance);
VALA_EXTERN void workers_unref (gpointer instance);
VALA_EXTERN GParamSpec* param_spec_workers (const gchar* name,
                                const gchar* nick,
                                const gchar* blurb,
                                GType object_type,
                                GParamFlags flags);
VALA_EXTERN void value_set_workers (GValue* value,
                        gpointer v_object);
VALA_EXTERN void value_take_workers (GValue* value,
                         gpointer v_object);
VALA_EXTERN gpointer value_get_workers (const GValue* value);
VALA_EXTERN GType workers_get_type (void) G_GNUC_CONST ;
G_DEFINE_AUTOPTR_CLEANUP_FUNC (Workers, workers_unref)
VALA_EXTERN GType media_monitor_get_type (void) G_GNUC_CONST ;
G_DEFINE_AUTOPTR_CLEANUP_FUNC (MediaMonitor, g_object_unref)
VALA_EXTERN gpointer transaction_controller_ref (gpointer instance);
VALA_EXTERN void transaction_controller_unref (gpointer instance);
VALA_EXTERN GParamSpec* param_spec_transaction_controller (const gchar* name,
                                               const gchar* nick,
                                               const gchar* blurb,
                                               GType object_type,
                                               GParamFlags flags);
VALA_EXTERN void value_set_transaction_controller (GValue* value,
                                       gpointer v_object);
VALA_EXTERN void value_take_transaction_controller (GValue* value,
                                        gpointer v_object);
VALA_EXTERN gpointer value_get_transaction_controller (const GValue* value);
VALA_EXTERN GType transaction_controller_get_type (void) G_GNUC_CONST ;
G_DEFINE_AUTOPTR_CLEANUP_FUNC (TransactionController, transaction_controller_unref)
VALA_EXTERN GType library_photo_source_collection_get_type (void) G_GNUC_CONST ;
G_DEFINE_AUTOPTR_CLEANUP_FUNC (LibraryPhotoSourceCollection, data_collection_unref)
VALA_EXTERN MediaSourceHoldingTank* media_source_collection_create_trashcan (MediaSourceCollection* self);
VALA_EXTERN MediaSourceHoldingTank* media_source_collection_create_offline_bin (MediaSourceCollection* self);
VALA_EXTERN MediaMonitor* media_source_collection_create_media_monitor (MediaSourceCollection* self,
                                                            Workers* workers,
                                                            GCancellable* cancellable);
VALA_EXTERN gboolean source_collection_holds_type_of_source (SourceCollection* self,
                                                 DataSource* source);
VALA_EXTERN gchar* media_source_collection_get_typename (MediaSourceCollection* self);
VALA_EXTERN gboolean media_source_collection_is_file_recognized (MediaSourceCollection* self,
                                                     GFile* file);
VALA_EXTERN void data_collection_notify_contents_altered (DataCollection* self,
                                              GeeIterable* added,
                                              GeeIterable* removed);
VALA_EXTERN void data_collection_items_altered (DataCollection* self,
                                    GeeMap* items);
VALA_EXTERN void media_source_collection_postprocess_imported_media (MediaSourceCollection* self,
                                                         GeeCollection* media);
VALA_EXTERN void library_photo_source_collection_notify_master_reimported (LibraryPhotoSourceCollection* self,
                                                               LibraryPhoto* photo,
                                                               PhotoMetadata* metadata);
VALA_EXTERN void library_photo_source_collection_notify_editable_reimported (LibraryPhotoSourceCollection* self,
                                                                 LibraryPhoto* photo,
                                                                 PhotoMetadata* metadata);
VALA_EXTERN void library_photo_source_collection_notify_source_reimported (LibraryPhotoSourceCollection* self,
                                                               LibraryPhoto* photo,
                                                               PhotoMetadata* metadata);
VALA_EXTERN void library_photo_source_collection_notify_baseline_reimported (LibraryPhotoSourceCollection* self,
                                                                 LibraryPhoto* photo,
                                                                 PhotoMetadata* metadata);
VALA_EXTERN MediaSource* media_source_collection_fetch_by_numeric_id (MediaSourceCollection* self,
                                                          gint64 numeric_id);
VALA_EXTERN MediaSource* media_source_collection_fetch_by_source_id (MediaSourceCollection* self,
                                                         const gchar* source_id);
VALA_EXTERN GeeCollection* media_source_collection_get_event_source_ids (MediaSourceCollection* self,
                                                             EventID* event_id);
VALA_EXTERN gboolean source_collection_has_backlink (SourceCollection* self,
                                         SourceBacklink* backlink);
VALA_EXTERN void source_collection_remove_backlink (SourceCollection* self,
                                        SourceBacklink* backlink);
VALA_EXTERN TransactionController* media_source_collection_get_transaction_controller (MediaSourceCollection* self);
VALA_EXTERN GType library_photo_source_collection_state_get_type (void) G_GNUC_CONST ;
VALA_EXTERN guint file_hash (GFile* file);
static guint _file_hash_gee_hash_data_func (gconstpointer v,
                                     gpointer self);
VALA_EXTERN gboolean file_equal (GFile* a,
                     GFile* b);
static gboolean _file_equal_gee_equal_data_func (gconstpointer a,
                                          gconstpointer b,
                                          gpointer self);
VALA_EXTERN gint int64_compare (gint64* a,
                    gint64* b);
static gint _int64_compare_gcompare_data_func (gconstpointer a,
                                        gconstpointer b,
                                        gpointer self);
static gint64* _int64_dup (gint64* self);
VALA_EXTERN gboolean int64_equal (gint64* a,
                      gint64* b);
static gboolean _int64_equal_gee_equal_data_func (gconstpointer a,
                                           gconstpointer b,
                                           gpointer self);
VALA_EXTERN LibraryPhotoSourceCollection* library_photo_source_collection_new (void);
VALA_EXTERN LibraryPhotoSourceCollection* library_photo_source_collection_construct (GType object_type);
static gint64 _photo_get_photo_key_get_source_database_key (DataSource* source,
                                                     gpointer self);
VALA_EXTERN MediaSourceCollection* media_source_collection_construct (GType object_type,
                                                          const gchar* name,
                                                          GetSourceDatabaseKey source_key_func,
                                                          gpointer source_key_func_target);
VALA_EXTERN MediaSourceHoldingTank* media_source_collection_get_trashcan (MediaSourceCollection* self);
static void library_photo_source_collection_on_trashcan_contents_altered (LibraryPhotoSourceCollection* self,
                                                                   GeeCollection* added,
                                                                   GeeCollection* removed);
static void _library_photo_source_collection_on_trashcan_contents_altered_source_holding_tank_contents_altered (SourceHoldingTank* _sender,
                                                                                                         GeeCollection* added,
                                                                                                         GeeCollection* removed,
                                                                                                         gpointer self);
VALA_EXTERN MediaSourceHoldingTank* media_source_collection_get_offline_bin (MediaSourceCollection* self);
static void library_photo_source_collection_on_offline_contents_altered (LibraryPhotoSourceCollection* self,
                                                                  GeeCollection* added,
                                                                  GeeCollection* removed);
static void _library_photo_source_collection_on_offline_contents_altered_source_holding_tank_contents_altered (SourceHoldingTank* _sender,
                                                                                                        GeeCollection* added,
                                                                                                        GeeCollection* removed,
                                                                                                        gpointer self);
static MediaSourceHoldingTank* library_photo_source_collection_real_create_trashcan (MediaSourceCollection* base);
static gboolean library_photo_source_collection_check_if_trashed_photo (LibraryPhotoSourceCollection* self,
                                                                 DataSource* source,
                                                                 Alteration* alteration);
static gboolean _library_photo_source_collection_check_if_trashed_photo_source_holding_tank_check_to_keep (DataSource* source,
                                                                                                    Alteration* alteration,
                                                                                                    gpointer self);
VALA_EXTERN LibraryPhotoSourceHoldingTank* library_photo_source_holding_tank_new (LibraryPhotoSourceCollection* sources,
                                                                      SourceHoldingTankCheckToKeep check_to_keep,
                                                                      gpointer check_to_keep_target,
                                                                      GetSourceDatabaseKey get_key,
                                                                      gpointer get_key_target);
VALA_EXTERN LibraryPhotoSourceHoldingTank* library_photo_source_holding_tank_construct (GType object_type,
                                                                            LibraryPhotoSourceCollection* sources,
                                                                            SourceHoldingTankCheckToKeep check_to_keep,
                                                                            gpointer check_to_keep_target,
                                                                            GetSourceDatabaseKey get_key,
                                                                            gpointer get_key_target);
VALA_EXTERN GType library_photo_source_holding_tank_get_type (void) G_GNUC_CONST ;
G_DEFINE_AUTOPTR_CLEANUP_FUNC (LibraryPhotoSourceHoldingTank, source_holding_tank_unref)
static MediaSourceHoldingTank* library_photo_source_collection_real_create_offline_bin (MediaSourceCollection* base);
static gboolean library_photo_source_collection_check_if_offline_photo (LibraryPhotoSourceCollection* self,
                                                                 DataSource* source,
                                                                 Alteration* alteration);
static gboolean _library_photo_source_collection_check_if_offline_photo_source_holding_tank_check_to_keep (DataSource* source,
                                                                                                    Alteration* alteration,
                                                                                                    gpointer self);
static MediaMonitor* library_photo_source_collection_real_create_media_monitor (MediaSourceCollection* base,
                                                                         Workers* workers,
                                                                         GCancellable* cancellable);
VALA_EXTERN PhotoMonitor* photo_monitor_new (Workers* workers,
                                 GCancellable* cancellable);
VALA_EXTERN PhotoMonitor* photo_monitor_construct (GType object_type,
                                       Workers* workers,
                                       GCancellable* cancellable);
VALA_EXTERN GType photo_monitor_get_type (void) G_GNUC_CONST ;
G_DEFINE_AUTOPTR_CLEANUP_FUNC (PhotoMonitor, g_object_unref)
static gboolean library_photo_source_collection_real_holds_type_of_source (SourceCollection* base,
                                                                    DataSource* source);
static gchar* library_photo_source_collection_real_get_typename (MediaSourceCollection* base);
static gboolean library_photo_source_collection_real_is_file_recognized (MediaSourceCollection* base,
                                                                  GFile* file);
static void library_photo_source_collection_real_notify_contents_altered (DataCollection* base,
                                                                   GeeIterable* added,
                                                                   GeeIterable* removed);
static void library_photo_source_collection_on_editable_replaced (LibraryPhotoSourceCollection* self,
                                                           Photo* photo,
                                                           GFile* old_file,
                                                           GFile* new_file);
static void _library_photo_source_collection_on_editable_replaced_photo_editable_replaced (Photo* _sender,
                                                                                    GFile* old_file,
                                                                                    GFile* new_file,
                                                                                    gpointer self);
static void library_photo_source_collection_on_raw_development_modified (LibraryPhotoSourceCollection* self,
                                                                  Photo* _photo);
static void _library_photo_source_collection_on_raw_development_modified_photo_raw_development_modified (Photo* _sender,
                                                                                                  gpointer self);
static void library_photo_source_collection_real_items_altered (DataCollection* base,
                                                         GeeMap* items);
VALA_EXTERN gboolean alteration_has_detail (Alteration* self,
                                const gchar* subject,
                                const gchar* detail);
static void library_photo_source_collection_real_postprocess_imported_media (MediaSourceCollection* base,
                                                                      GeeCollection* media_sources);
VALA_EXTERN GType tag_get_type (void) G_GNUC_CONST ;
G_DEFINE_AUTOPTR_CLEANUP_FUNC (Tag, g_object_unref)
VALA_EXTERN gpointer hierarchical_tag_index_ref (gpointer instance);
VALA_EXTERN void hierarchical_tag_index_unref (gpointer instance);
VALA_EXTERN GParamSpec* param_spec_hierarchical_tag_index (const gchar* name,
                                               const gchar* nick,
                                               const gchar* blurb,
                                               GType object_type,
                                               GParamFlags flags);
VALA_EXTERN void value_set_hierarchical_tag_index (GValue* value,
                                       gpointer v_object);
VALA_EXTERN void value_take_hierarchical_tag_index (GValue* value,
                                        gpointer v_object);
VALA_EXTERN gpointer value_get_hierarchical_tag_index (const GValue* value);
VALA_EXTERN GType hierarchical_tag_index_get_type (void) G_GNUC_CONST ;
G_DEFINE_AUTOPTR_CLEANUP_FUNC (HierarchicalTagIndex, hierarchical_tag_index_unref)
VALA_EXTERN HierarchicalTagIndex* hierarchical_tag_index_get_global_index (void);
VALA_EXTERN gboolean photo_metadata_has_hierarchical_keywords (PhotoMetadata* self);
VALA_EXTERN HierarchicalTagIndex* hierarchical_tag_utilities_process_hierarchical_import_keywords (GeeCollection* h_keywords);
VALA_EXTERN GeeSet* photo_metadata_get_hierarchical_keywords (PhotoMetadata* self);
VALA_EXTERN GeeCollection* library_photo_get_import_keywords (LibraryPhoto* self);
VALA_EXTERN gboolean hierarchical_tag_index_is_tag_in_index (HierarchicalTagIndex* self,
                                                 const gchar* tag);
VALA_EXTERN gchar* tag_prep_tag_name (const gchar* name);
VALA_EXTERN gchar* hierarchical_tag_index_get_path_for_name (HierarchicalTagIndex* self,
                                                 const gchar* name);
VALA_EXTERN Tag* tag_for_path (const gchar* name);
VALA_EXTERN GeeCollection* hierarchical_tag_index_get_all_paths (HierarchicalTagIndex* self);
VALA_EXTERN void library_photo_clear_import_keywords (LibraryPhoto* self);
VALA_EXTERN void tag_attach_many (Tag* self,
                      GeeCollection* sources);
static void library_photo_source_collection_real_notify_master_reimported (LibraryPhotoSourceCollection* self,
                                                                    LibraryPhoto* photo,
                                                                    PhotoMetadata* metadata);
static void library_photo_source_collection_real_notify_editable_reimported (LibraryPhotoSourceCollection* self,
                                                                      LibraryPhoto* photo,
                                                                      PhotoMetadata* metadata);
static void library_photo_source_collection_real_notify_source_reimported (LibraryPhotoSourceCollection* self,
                                                                    LibraryPhoto* photo,
                                                                    PhotoMetadata* metadata);
static void library_photo_source_collection_real_notify_baseline_reimported (LibraryPhotoSourceCollection* self,
                                                                      LibraryPhoto* photo,
                                                                      PhotoMetadata* metadata);
static MediaSource* library_photo_source_collection_real_fetch_by_numeric_id (MediaSourceCollection* base,
                                                                       gint64 numeric_id);
VALA_EXTERN LibraryPhoto* library_photo_source_collection_fetch (LibraryPhotoSourceCollection* self,
                                                     PhotoID* photo_id);
VALA_EXTERN gboolean media_source_is_trashed (MediaSource* self);
VALA_EXTERN gboolean media_source_is_offline (MediaSource* self);
static MediaSource* library_photo_source_collection_real_fetch_by_source_id (MediaSourceCollection* base,
                                                                      const gchar* source_id);
static GeeCollection* library_photo_source_collection_real_get_event_source_ids (MediaSourceCollection* base,
                                                                          EventID* event_id);
VALA_EXTERN GeeArrayList* photo_table_get_event_source_ids (PhotoTable* self,
                                                EventID* event_id);
VALA_EXTERN DataSource* database_source_collection_fetch_by_key (DatabaseSourceCollection* self,
                                                     gint64 key);
VALA_EXTERN LibraryPhoto* library_photo_source_collection_fetch_by_editable_file (LibraryPhotoSourceCollection* self,
                                                                      GFile* file);
VALA_EXTERN LibraryPhoto* library_photo_source_collection_fetch_by_raw_development_file (LibraryPhotoSourceCollection* self,
                                                                             GFile* file);
static void library_photo_source_collection_compare_backing (LibraryPhotoSourceCollection* self,
                                                      LibraryPhoto* photo,
                                                      GFileInfo* info,
                                                      GeeCollection* matches_master,
                                                      GeeCollection* matches_editable,
                                                      GeeCollection* matches_development);
VALA_EXTERN gboolean backing_photo_row_matches_file_info (BackingPhotoRow* self,
                                              GFileInfo* info);
VALA_EXTERN void library_photo_source_collection_fetch_by_matching_backing (LibraryPhotoSourceCollection* self,
                                                                GFileInfo* info,
                                                                GeeCollection* matches_master,
                                                                GeeCollection* matches_editable,
                                                                GeeCollection* matched_development);
VALA_EXTERN GeeCollection* media_source_collection_get_offline_bin_contents (MediaSourceCollection* self);
VALA_EXTERN void library_photo_source_collection_get_basename_filesize_duplicate (LibraryPhotoSourceCollection* self,
                                                                      const gchar* basename,
                                                                      gint64 filesize,
                                                                      PhotoID* result);
VALA_EXTERN gint utf8_ci_compare (const gchar* a,
                      const gchar* b);
VALA_EXTERN gboolean library_photo_source_collection_has_basename_filesize_duplicate (LibraryPhotoSourceCollection* self,
                                                                          const gchar* basename,
                                                                          gint64 filesize);
VALA_EXTERN gboolean photo_id_is_valid (PhotoID *self);
VALA_EXTERN LibraryPhoto* library_photo_source_collection_get_trashed_by_file (LibraryPhotoSourceCollection* self,
                                                                   GFile* file);
VALA_EXTERN MediaSource* media_source_holding_tank_fetch_by_master_file (MediaSourceHoldingTank* self,
                                                             GFile* file);
VALA_EXTERN LibraryPhoto* library_photo_source_holding_tank_fetch_by_backing_file (LibraryPhotoSourceHoldingTank* self,
                                                                       GFile* file);
VALA_EXTERN LibraryPhoto* library_photo_source_collection_get_trashed_by_md5 (LibraryPhotoSourceCollection* self,
                                                                  const gchar* md5);
VALA_EXTERN MediaSource* media_source_holding_tank_fetch_by_md5 (MediaSourceHoldingTank* self,
                                                     const gchar* md5);
VALA_EXTERN LibraryPhoto* library_photo_source_collection_get_offline_by_file (LibraryPhotoSourceCollection* self,
                                                                   GFile* file);
VALA_EXTERN LibraryPhoto* library_photo_source_collection_get_offline_by_md5 (LibraryPhotoSourceCollection* self,
                                                                  const gchar* md5);
VALA_EXTERN gint library_photo_source_collection_get_offline_count (LibraryPhotoSourceCollection* self);
VALA_EXTERN gint source_holding_tank_get_count (SourceHoldingTank* self);
VALA_EXTERN LibraryPhoto* library_photo_source_collection_get_state_by_file (LibraryPhotoSourceCollection* self,
                                                                 GFile* file,
                                                                 LibraryPhotoSourceCollectionState* state);
VALA_EXTERN MediaSource* media_source_collection_fetch_by_master_file (MediaSourceCollection* self,
                                                           GFile* file);
static gboolean library_photo_source_collection_real_has_backlink (SourceCollection* base,
                                                            SourceBacklink* backlink);
VALA_EXTERN gboolean source_holding_tank_has_backlink (SourceHoldingTank* self,
                                           SourceBacklink* backlink);
static void library_photo_source_collection_real_remove_backlink (SourceCollection* base,
                                                           SourceBacklink* backlink);
VALA_EXTERN void source_holding_tank_remove_backlink (SourceHoldingTank* self,
                                          SourceBacklink* backlink);
VALA_EXTERN MediaSourceTransactionController* media_source_transaction_controller_new (MediaSourceCollection* sources);
VALA_EXTERN MediaSourceTransactionController* media_source_transaction_controller_construct (GType object_type,
                                                                                 MediaSourceCollection* sources);
VALA_EXTERN GType media_source_transaction_controller_get_type (void) G_GNUC_CONST ;
G_DEFINE_AUTOPTR_CLEANUP_FUNC (MediaSourceTransactionController, transaction_controller_unref)
static void library_photo_source_collection_real_master_reimported (LibraryPhotoSourceCollection* self,
                                                             LibraryPhoto* photo,
                                                             PhotoMetadata* metadata);
static void g_cclosure_user_marshal_VOID__OBJECT_MEDIA_METADATA (GClosure * closure,
                                                          GValue * return_value,
                                                          guint n_param_values,
                                                          const GValue * param_values,
                                                          gpointer invocation_hint,
                                                          gpointer marshal_data);
static void library_photo_source_collection_real_editable_reimported (LibraryPhotoSourceCollection* self,
                                                               LibraryPhoto* photo,
                                                               PhotoMetadata* metadata);
static void library_photo_source_collection_real_baseline_reimported (LibraryPhotoSourceCollection* self,
                                                               LibraryPhoto* photo,
                                                               PhotoMetadata* metadata);
static void library_photo_source_collection_real_source_reimported (LibraryPhotoSourceCollection* self,
                                                             LibraryPhoto* photo,
                                                             PhotoMetadata* metadata);
static void library_photo_source_collection_finalize (DataCollection * obj);
static GType library_photo_source_collection_get_type_once (void);
VALA_EXTERN GType flaggable_get_type (void) G_GNUC_CONST ;
G_DEFINE_AUTOPTR_CLEANUP_FUNC (Flaggable, g_object_unref)
VALA_EXTERN GType monitorable_get_type (void) G_GNUC_CONST ;
G_DEFINE_AUTOPTR_CLEANUP_FUNC (Monitorable, g_object_unref)
VALA_EXTERN GdkPixbuf* media_source_get_preview_pixbuf (MediaSource* self,
                                            Scaling* scaling,
                                            GError** error);
VALA_EXTERN GdkPixbuf* thumbnail_source_get_thumbnail (ThumbnailSource* self,
                                           gint scale,
                                           GError** error);
VALA_EXTERN void media_source_trash (MediaSource* self);
VALA_EXTERN void media_source_untrash (MediaSource* self);
VALA_EXTERN void media_source_mark_offline (MediaSource* self);
VALA_EXTERN void media_source_mark_online (MediaSource* self);
VALA_EXTERN void data_source_destroy (DataSource* self);
static LibraryPhoto* library_photo_new (PhotoRow* row);
static LibraryPhoto* library_photo_construct (GType object_type,
                                       PhotoRow* row);
static void library_photo_generate_thumbnails (LibraryPhoto* self);
static void _library_photo_generate_thumbnails_one_shot_callback (gpointer self);
static void library_photo_import_gps_metadata (LibraryPhoto* self);
static void _library_photo_import_gps_metadata_one_shot_callback (gpointer self);
VALA_EXTERN void one_shot_scheduler_at_priority_idle (OneShotScheduler* self,
                                          gint priority);
VALA_EXTERN void data_source_rehydrate_backlinks (DataSource* self,
                                      SourceCollection* unlinked_from,
                                      const gchar* dehydrated);
static void library_photo_upgrade_rating_flags (LibraryPhoto* self,
                                         guint64 flags);
static LibraryPhoto* library_photo_new_from_import_params (PhotoImportParams* import_params);
static LibraryPhoto* library_photo_construct_from_import_params (GType object_type,
                                                          PhotoImportParams* import_params);
VALA_EXTERN void library_photo_init (ProgressMonitor monitor,
                         gpointer monitor_target);
VALA_EXTERN GeeArrayList* photo_table_get_all (PhotoTable* self);
VALA_EXTERN GeeCollection* data_collection_add_many (DataCollection* self,
                                         GeeCollection* objects,
                                         ProgressMonitor monitor,
                                         gpointer monitor_target);
VALA_EXTERN void media_source_collection_add_many_to_trash (MediaSourceCollection* self,
                                                GeeCollection* sources);
VALA_EXTERN void media_source_collection_add_many_to_offline (MediaSourceCollection* self,
                                                  GeeCollection* sources);
VALA_EXTERN void library_photo_terminate (void);
VALA_EXTERN ImportResult library_photo_import_create (PhotoImportParams* params,
                                          LibraryPhoto** photo);
VALA_EXTERN void photo_table_add (PhotoTable* self,
                      PhotoRow* photo_row,
                      PhotoID* result);
VALA_EXTERN gboolean photo_id_is_invalid (PhotoID *self);
VALA_EXTERN void library_photo_import_failed (LibraryPhoto* photo);
VALA_EXTERN void photo_table_remove (PhotoTable* self,
                         PhotoID* photo_id,
                         GError** error);
static void library_photo_real_notify_master_reimported (Photo* base,
                                                  PhotoMetadata* metadata);
static void library_photo_real_notify_editable_reimported (Photo* base,
                                                    PhotoMetadata* metadata);
static void library_photo_real_notify_source_reimported (Photo* base,
                                                  PhotoMetadata* metadata);
static void library_photo_real_notify_baseline_reimported (Photo* base,
                                                    PhotoMetadata* metadata);
VALA_EXTERN void thumbnail_cache_import_from_source (ThumbnailSource* source,
                                         gboolean force,
                                         GError** error);
VALA_EXTERN void thumbnail_source_notify_thumbnail_altered (ThumbnailSource* self);
static void library_photo_real_notify_altered (DataObject* base,
                                        Alteration* alteration);
VALA_EXTERN gboolean alteration_has_subject (Alteration* self,
                                 const gchar* subject);
static GdkPixbuf* library_photo_real_get_preview_pixbuf (MediaSource* base,
                                                  Scaling* scaling,
                                                  GError** error);
VALA_EXTERN GType thumbnail_cache_size_get_type (void) G_GNUC_CONST ;
VALA_EXTERN GdkPixbuf* scaling_perform_on_pixbuf (Scaling *self,
                                      GdkPixbuf* pixbuf,
                                      GdkInterpType interp,
                                      gboolean scale_up);
static void library_photo_real_rotate (Photo* base,
                                Rotation rotation);
VALA_EXTERN void thumbnail_cache_rotate (ThumbnailSource* source,
                             Rotation rotation,
                             GError** error);
static GdkPixbuf* library_photo_real_get_thumbnail (ThumbnailSource* base,
                                             gint scale,
                                             GError** error);
VALA_EXTERN GdkPixbuf* thumbnail_cache_fetch (ThumbnailSource* source,
                                  gint scale,
                                  GError** error);
static void library_photo_duplicate_backing_photo (LibraryPhoto* self,
                                            BackingPhotoRow* backing,
                                            BackingPhotoID* result,
                                            GError** error);
VALA_EXTERN GFile* library_files_duplicate (GFile* src,
                                GFileProgressCallback progress_callback,
                                gpointer progress_callback_target,
                                gboolean blacklist,
                                GError** error);
static void library_photo_on_duplicate_progress (LibraryPhoto* self,
                                          gint64 current,
                                          gint64 total);
static void _library_photo_on_duplicate_progress_gfile_progress_callback (gint64 current_num_bytes,
                                                                   gint64 total_num_bytes,
                                                                   gpointer self);
VALA_EXTERN LibraryPhoto* library_photo_duplicate (LibraryPhoto* self,
                                       GError** error);
VALA_EXTERN void photo_table_duplicate (PhotoTable* self,
                            PhotoID* photo_id,
                            const gchar* new_filename,
                            BackingPhotoID* editable_id,
                            BackingPhotoID* develop_shotwell,
                            BackingPhotoID* develop_camera_id,
                            BackingPhotoID* develop_embedded_id,
                            PhotoID* result);
VALA_EXTERN PhotoRow* photo_table_get_row (PhotoTable* self,
                               PhotoID* photo_id);
VALA_EXTERN void thumbnail_cache_duplicate (ThumbnailSource* src_source,
                                ThumbnailSource* dest_source);
VALA_EXTERN gboolean data_collection_add (DataCollection* self,
                              DataObject* object);
VALA_EXTERN GType event_source_get_type (void) G_GNUC_CONST ;
G_DEFINE_AUTOPTR_CLEANUP_FUNC (EventSource, g_object_unref)
VALA_EXTERN GType event_get_type (void) G_GNUC_CONST ;
G_DEFINE_AUTOPTR_CLEANUP_FUNC (Event, g_object_unref)
VALA_EXTERN Event* media_source_get_event (MediaSource* self);
VALA_EXTERN void event_attach (Event* self,
                   MediaSource* source);
VALA_EXTERN GType container_source_collection_get_type (void) G_GNUC_CONST ;
G_DEFINE_AUTOPTR_CLEANUP_FUNC (ContainerSourceCollection, data_collection_unref)
VALA_EXTERN GType tag_source_collection_get_type (void) G_GNUC_CONST ;
G_DEFINE_AUTOPTR_CLEANUP_FUNC (TagSourceCollection, data_collection_unref)
VALA_EXTERN GeeList* tag_source_collection_fetch_for_source (TagSourceCollection* self,
                                                 MediaSource* source);
VALA_EXTERN void tag_attach (Tag* self,
                 MediaSource* source);
VALA_EXTERN GType face_get_type (void) G_GNUC_CONST ;
G_DEFINE_AUTOPTR_CLEANUP_FUNC (Face, g_object_unref)
VALA_EXTERN GType face_source_collection_get_type (void) G_GNUC_CONST ;
G_DEFINE_AUTOPTR_CLEANUP_FUNC (FaceSourceCollection, data_collection_unref)
VALA_EXTERN GeeList* face_source_collection_fetch_for_source (FaceSourceCollection* self,
                                                  MediaSource* source);
VALA_EXTERN GType face_location_get_type (void) G_GNUC_CONST ;
G_DEFINE_AUTOPTR_CLEANUP_FUNC (FaceLocation, g_object_unref)
VALA_EXTERN GType face_id_get_type (void) G_GNUC_CONST ;
VALA_EXTERN FaceID* face_id_dup (const FaceID* self);
VALA_EXTERN void face_id_free (FaceID* self);
VALA_EXTERN FaceLocation* face_location_get_face_location (FaceID* face_id,
                                               PhotoID* photo_id);
VALA_EXTERN void face_get_face_id (Face* self,
                       FaceID* result);
VALA_EXTERN void face_attach (Face* self,
                  MediaSource* source);
VALA_EXTERN GType face_location_data_get_type (void) G_GNUC_CONST ;
VALA_EXTERN FaceLocationData* face_location_data_dup (const FaceLocationData* self);
VALA_EXTERN void face_location_data_free (FaceLocationData* self);
VALA_EXTERN void face_location_data_copy (const FaceLocationData* self,
                              FaceLocationData* dest);
VALA_EXTERN void face_location_data_destroy (FaceLocationData* self);
G_DEFINE_AUTO_CLEANUP_CLEAR_FUNC (FaceLocationData, face_location_data_destroy)
VALA_EXTERN FaceLocation* face_location_create (FaceID* face_id,
                                    PhotoID* photo_id,
                                    FaceLocationData* face_data);
VALA_EXTERN void face_location_get_face_data (FaceLocation* self,
                                  FaceLocationData* result);
VALA_EXTERN void spin_event_loop (void);
static gboolean library_photo_real_is_trashed (MediaSource* base);
static void library_photo_real_trash (MediaSource* base);
static void library_photo_real_untrash (MediaSource* base);
static gboolean library_photo_real_is_offline (Monitorable* base);
static void library_photo_real_mark_offline (Monitorable* base);
static void library_photo_real_mark_online (Monitorable* base);
static gboolean library_photo_real_is_flagged (Flaggable* base);
static void library_photo_real_mark_flagged (Flaggable* base);
static void library_photo_real_mark_unflagged (Flaggable* base);
static gboolean library_photo_real_internal_delete_backing (DataSource* base,
                                                     GError** error);
VALA_EXTERN gboolean media_source_delete_original_file (MediaSource* self);
static void library_photo_real_destroy (DataSource* base);
VALA_EXTERN void thumbnail_cache_remove (ThumbnailSource* source);
VALA_EXTERN gboolean library_photo_has_nontrash_duplicate (GFile* file,
                                               const gchar* thumbnail_md5,
                                               const gchar* full_md5,
                                               PhotoFileFormat file_format);
VALA_EXTERN void library_photo_get_nontrash_duplicate (GFile* file,
                                           const gchar* thumbnail_md5,
                                           const gchar* full_md5,
                                           PhotoFileFormat file_format,
                                           PhotoID* result);
static gboolean library_photo_real_has_user_generated_metadata (Photo* base);
VALA_EXTERN gboolean gps_coords_equals (GpsCoords *self,
                            GpsCoords* gps);
VALA_EXTERN gchar* data_object_get_name (DataObject* self);
static void library_photo_real_set_user_metadata_for_export (Photo* base,
                                                      PhotoMetadata* metadata);
VALA_EXTERN void photo_metadata_set_keywords (PhotoMetadata* self,
                                  GeeCollection* keywords,
                                  PhotoMetadataSetOption option);
VALA_EXTERN void photo_metadata_set_rating (PhotoMetadata* self,
                                Rating rating);
VALA_EXTERN void photo_metadata_set_gps_coords (PhotoMetadata* self,
                                    GpsCoords* gps_coords);
static void library_photo_real_apply_user_metadata_for_reimport (Photo* base,
                                                          PhotoMetadata* metadata);
VALA_EXTERN gchar* hierarchical_tag_utilities_make_flat_tag_safe (const gchar* in_tag);
VALA_EXTERN gchar* hierarchical_tag_utilities_flat_to_hierarchical (const gchar* name);
VALA_EXTERN gboolean tag_source_collection_exists (TagSourceCollection* self,
                                       const gchar* name,
                                       gboolean treat_htags_as_root);
VALA_EXTERN gboolean flaggable_is_flagged (Flaggable* self);
VALA_EXTERN void flaggable_mark_flagged (Flaggable* self);
VALA_EXTERN void flaggable_mark_unflagged (Flaggable* self);
VALA_EXTERN gboolean monitorable_is_offline (Monitorable* self);
VALA_EXTERN void monitorable_mark_offline (Monitorable* self);
VALA_EXTERN void monitorable_mark_online (Monitorable* self);
static void library_photo_finalize (GObject * obj);
static GType library_photo_get_type_once (void);
VALA_EXTERN void source_holding_tank_notify_contents_altered (SourceHoldingTank* self,
                                                  GeeCollection* added,
                                                  GeeCollection* removed);
VALA_EXTERN MediaSourceHoldingTank* media_source_holding_tank_new (MediaSourceCollection* sources,
                                                       SourceHoldingTankCheckToKeep check_to_keep,
                                                       gpointer check_to_keep_target,
                                                       GetSourceDatabaseKey get_key,
                                                       gpointer get_key_target);
VALA_EXTERN MediaSourceHoldingTank* media_source_holding_tank_construct (GType object_type,
                                                             MediaSourceCollection* sources,
                                                             SourceHoldingTankCheckToKeep check_to_keep,
                                                             gpointer check_to_keep_target,
                                                             GetSourceDatabaseKey get_key,
                                                             gpointer get_key_target);
static void library_photo_source_holding_tank_real_notify_contents_altered (SourceHoldingTank* base,
                                                                     GeeCollection* added,
                                                                     GeeCollection* removed);
static void library_photo_source_holding_tank_on_editable_replaced (LibraryPhotoSourceHoldingTank* self,
                                                             Photo* _photo,
                                                             GFile* old_file,
                                                             GFile* new_file);
static void _library_photo_source_holding_tank_on_editable_replaced_photo_editable_replaced (Photo* _sender,
                                                                                      GFile* old_file,
                                                                                      GFile* new_file,
                                                                                      gpointer self);
static void library_photo_source_holding_tank_on_raw_development_modified (LibraryPhotoSourceHoldingTank* self,
                                                                    Photo* _photo);
static void _library_photo_source_holding_tank_on_raw_development_modified_photo_raw_development_modified (Photo* _sender,
                                                                                                    gpointer self);
static void library_photo_source_holding_tank_finalize (SourceHoldingTank * obj);
static GType library_photo_source_holding_tank_get_type_once (void);
static void _vala_array_destroy (gpointer array,
                          gssize array_length,
                          GDestroyNotify destroy_func);
static void _vala_array_free (gpointer array,
                       gssize array_length,
                       GDestroyNotify destroy_func);
static inline gpointer _vala_memdup2 (gconstpointer mem,
                        gsize byte_size);

static const gchar* PHOTO_IMAGE_EXTENSIONS[70] = {"jpg", "jpeg", "jpe", "tiff", "tif", "png", "gif", "bmp", "ppm", "pgm", "pbm", "pnm", "thm", "tga", "ilbm", "pcx", "ecw", "img", "sid", "cd5", "fits", "pgf", "cgm", "svg", "odg", "eps", "pdf", "swf", "wmf", "emf", "xps", "pns", "jps", "mpo", "3fr", "arw", "srf", "sr2", "bay", "crw", "cr2", "cr3", "cap", "iiq", "eip", "dcs", "dcr", "drf", "k25", "kdc", "dng", "erf", "fff", "mef", "mos", "mrw", "nef", "nrw", "orf", "ptx", "pef", "pxn", "r3d", "raf", "raw", "rw2", "rwl", "rwz", "x3f", "srw"};

static GType
backing_fetch_mode_get_type_once (void)
{
	static const GEnumValue values[] = {{BACKING_FETCH_MODE_SOURCE, "BACKING_FETCH_MODE_SOURCE", "source"}, {BACKING_FETCH_MODE_BASELINE, "BACKING_FETCH_MODE_BASELINE", "baseline"}, {BACKING_FETCH_MODE_MASTER, "BACKING_FETCH_MODE_MASTER", "master"}, {BACKING_FETCH_MODE_UNMODIFIED, "BACKING_FETCH_MODE_UNMODIFIED", "unmodified"}, {0, NULL, NULL}};
	GType backing_fetch_mode_type_id;
	backing_fetch_mode_type_id = g_enum_register_static ("BackingFetchMode", values);
	return backing_fetch_mode_type_id;
}

GType
backing_fetch_mode_get_type (void)
{
	static volatile gsize backing_fetch_mode_type_id__once = 0;
	if (g_once_init_enter (&backing_fetch_mode_type_id__once)) {
		GType backing_fetch_mode_type_id;
		backing_fetch_mode_type_id = backing_fetch_mode_get_type_once ();
		g_once_init_leave (&backing_fetch_mode_type_id__once, backing_fetch_mode_type_id);
	}
	return backing_fetch_mode_type_id__once;
}

static gpointer
_g_object_ref0 (gpointer self)
{
#line 41 "../src/Photo.vala"
	return self ? g_object_ref (self) : NULL;
#line 4035 "Photo.c"
}

static gpointer
_thumbnails_ref0 (gpointer self)
{
#line 48 "../src/Photo.vala"
	return self ? thumbnails_ref (self) : NULL;
#line 4043 "Photo.c"
}

PhotoImportParams*
photo_import_params_construct (GType object_type,
                               GFile* file,
                               GFile* final_associated_file,
                               ImportID* import_id,
                               PhotoFileSnifferOptions sniffer_options,
                               const gchar* exif_md5,
                               const gchar* thumbnail_md5,
                               const gchar* full_md5,
                               Thumbnails* thumbnails)
{
	PhotoImportParams* self = NULL;
	GFile* _tmp0_;
	GFile* _tmp1_;
	ImportID _tmp2_;
	gchar* _tmp3_;
	gchar* _tmp4_;
	gchar* _tmp5_;
	Thumbnails* _tmp6_;
#line 38 "../src/Photo.vala"
	g_return_val_if_fail (G_TYPE_CHECK_INSTANCE_TYPE (file, g_file_get_type ()), NULL);
#line 38 "../src/Photo.vala"
	g_return_val_if_fail ((final_associated_file == NULL) || G_TYPE_CHECK_INSTANCE_TYPE (final_associated_file, g_file_get_type ()), NULL);
#line 38 "../src/Photo.vala"
	g_return_val_if_fail (import_id != NULL, NULL);
#line 38 "../src/Photo.vala"
	g_return_val_if_fail ((thumbnails == NULL) || IS_THUMBNAILS (thumbnails), NULL);
#line 38 "../src/Photo.vala"
	self = (PhotoImportParams*) g_type_create_instance (object_type);
#line 41 "../src/Photo.vala"
	_tmp0_ = _g_object_ref0 (file);
#line 41 "../src/Photo.vala"
	_g_object_unref0 (self->file);
#line 41 "../src/Photo.vala"
	self->file = _tmp0_;
#line 42 "../src/Photo.vala"
	_tmp1_ = _g_object_ref0 (final_associated_file);
#line 42 "../src/Photo.vala"
	_g_object_unref0 (self->final_associated_file);
#line 42 "../src/Photo.vala"
	self->final_associated_file = _tmp1_;
#line 43 "../src/Photo.vala"
	_tmp2_ = *import_id;
#line 43 "../src/Photo.vala"
	self->import_id = _tmp2_;
#line 44 "../src/Photo.vala"
	self->sniffer_options = sniffer_options;
#line 45 "../src/Photo.vala"
	_tmp3_ = g_strdup (exif_md5);
#line 45 "../src/Photo.vala"
	_g_free0 (self->exif_md5);
#line 45 "../src/Photo.vala"
	self->exif_md5 = _tmp3_;
#line 46 "../src/Photo.vala"
	_tmp4_ = g_strdup (thumbnail_md5);
#line 46 "../src/Photo.vala"
	_g_free0 (self->thumbnail_md5);
#line 46 "../src/Photo.vala"
	self->thumbnail_md5 = _tmp4_;
#line 47 "../src/Photo.vala"
	_tmp5_ = g_strdup (full_md5);
#line 47 "../src/Photo.vala"
	_g_free0 (self->full_md5);
#line 47 "../src/Photo.vala"
	self->full_md5 = _tmp5_;
#line 48 "../src/Photo.vala"
	_tmp6_ = _thumbnails_ref0 (thumbnails);
#line 48 "../src/Photo.vala"
	_thumbnails_unref0 (self->thumbnails);
#line 48 "../src/Photo.vala"
	self->thumbnails = _tmp6_;
#line 38 "../src/Photo.vala"
	return self;
#line 4119 "Photo.c"
}

PhotoImportParams*
photo_import_params_new (GFile* file,
                         GFile* final_associated_file,
                         ImportID* import_id,
                         PhotoFileSnifferOptions sniffer_options,
                         const gchar* exif_md5,
                         const gchar* thumbnail_md5,
                         const gchar* full_md5,
                         Thumbnails* thumbnails)
{
#line 38 "../src/Photo.vala"
	return photo_import_params_construct (TYPE_PHOTO_IMPORT_PARAMS, file, final_associated_file, import_id, sniffer_options, exif_md5, thumbnail_md5, full_md5, thumbnails);
#line 4134 "Photo.c"
}

PhotoImportParams*
photo_import_params_construct_create_placeholder (GType object_type,
                                                  GFile* file,
                                                  ImportID* import_id)
{
	PhotoImportParams* self = NULL;
	GFile* _tmp0_;
	ImportID _tmp1_;
#line 52 "../src/Photo.vala"
	g_return_val_if_fail (G_TYPE_CHECK_INSTANCE_TYPE (file, g_file_get_type ()), NULL);
#line 52 "../src/Photo.vala"
	g_return_val_if_fail (import_id != NULL, NULL);
#line 52 "../src/Photo.vala"
	self = (PhotoImportParams*) g_type_create_instance (object_type);
#line 53 "../src/Photo.vala"
	_tmp0_ = _g_object_ref0 (file);
#line 53 "../src/Photo.vala"
	_g_object_unref0 (self->file);
#line 53 "../src/Photo.vala"
	self->file = _tmp0_;
#line 54 "../src/Photo.vala"
	_tmp1_ = *import_id;
#line 54 "../src/Photo.vala"
	self->import_id = _tmp1_;
#line 55 "../src/Photo.vala"
	self->sniffer_options = PHOTO_FILE_SNIFFER_OPTIONS_NO_MD5;
#line 56 "../src/Photo.vala"
	_g_free0 (self->exif_md5);
#line 56 "../src/Photo.vala"
	self->exif_md5 = NULL;
#line 57 "../src/Photo.vala"
	_g_free0 (self->thumbnail_md5);
#line 57 "../src/Photo.vala"
	self->thumbnail_md5 = NULL;
#line 58 "../src/Photo.vala"
	_g_free0 (self->full_md5);
#line 58 "../src/Photo.vala"
	self->full_md5 = NULL;
#line 59 "../src/Photo.vala"
	_thumbnails_unref0 (self->thumbnails);
#line 59 "../src/Photo.vala"
	self->thumbnails = NULL;
#line 52 "../src/Photo.vala"
	return self;
#line 4181 "Photo.c"
}

PhotoImportParams*
photo_import_params_new_create_placeholder (GFile* file,
                                            ImportID* import_id)
{
#line 52 "../src/Photo.vala"
	return photo_import_params_construct_create_placeholder (TYPE_PHOTO_IMPORT_PARAMS, file, import_id);
#line 4190 "Photo.c"
}

static void
value_photo_import_params_init (GValue* value)
{
#line 21 "../src/Photo.vala"
	value->data[0].v_pointer = NULL;
#line 4198 "Photo.c"
}

static void
value_photo_import_params_free_value (GValue* value)
{
#line 21 "../src/Photo.vala"
	if (value->data[0].v_pointer) {
#line 21 "../src/Photo.vala"
		photo_import_params_unref (value->data[0].v_pointer);
#line 4208 "Photo.c"
	}
}

static void
value_photo_import_params_copy_value (const GValue* src_value,
                                      GValue* dest_value)
{
#line 21 "../src/Photo.vala"
	if (src_value->data[0].v_pointer) {
#line 21 "../src/Photo.vala"
		dest_value->data[0].v_pointer = photo_import_params_ref (src_value->data[0].v_pointer);
#line 4220 "Photo.c"
	} else {
#line 21 "../src/Photo.vala"
		dest_value->data[0].v_pointer = NULL;
#line 4224 "Photo.c"
	}
}

static gpointer
value_photo_import_params_peek_pointer (const GValue* value)
{
#line 21 "../src/Photo.vala"
	return value->data[0].v_pointer;
#line 4233 "Photo.c"
}

static gchar*
value_photo_import_params_collect_value (GValue* value,
                                         guint n_collect_values,
                                         GTypeCValue* collect_values,
                                         guint collect_flags)
{
#line 21 "../src/Photo.vala"
	if (collect_values[0].v_pointer) {
#line 4244 "Photo.c"
		PhotoImportParams * object;
		object = collect_values[0].v_pointer;
#line 21 "../src/Photo.vala"
		if (object->parent_instance.g_class == NULL) {
#line 21 "../src/Photo.vala"
			return g_strconcat ("invalid unclassed object pointer for value type `", G_VALUE_TYPE_NAME (value), "'", NULL);
#line 4251 "Photo.c"
		} else if (!g_value_type_compatible (G_TYPE_FROM_INSTANCE (object), G_VALUE_TYPE (value))) {
#line 21 "../src/Photo.vala"
			return g_strconcat ("invalid object type `", g_type_name (G_TYPE_FROM_INSTANCE (object)), "' for value type `", G_VALUE_TYPE_NAME (value), "'", NULL);
#line 4255 "Photo.c"
		}
#line 21 "../src/Photo.vala"
		value->data[0].v_pointer = photo_import_params_ref (object);
#line 4259 "Photo.c"
	} else {
#line 21 "../src/Photo.vala"
		value->data[0].v_pointer = NULL;
#line 4263 "Photo.c"
	}
#line 21 "../src/Photo.vala"
	return NULL;
#line 4267 "Photo.c"
}

static gchar*
value_photo_import_params_lcopy_value (const GValue* value,
                                       guint n_collect_values,
                                       GTypeCValue* collect_values,
                                       guint collect_flags)
{
	PhotoImportParams ** object_p;
	object_p = collect_values[0].v_pointer;
#line 21 "../src/Photo.vala"
	if (!object_p) {
#line 21 "../src/Photo.vala"
		return g_strdup_printf ("value location for `%s' passed as NULL", G_VALUE_TYPE_NAME (value));
#line 4282 "Photo.c"
	}
#line 21 "../src/Photo.vala"
	if (!value->data[0].v_pointer) {
#line 21 "../src/Photo.vala"
		*object_p = NULL;
#line 4288 "Photo.c"
	} else if (collect_flags & G_VALUE_NOCOPY_CONTENTS) {
#line 21 "../src/Photo.vala"
		*object_p = value->data[0].v_pointer;
#line 4292 "Photo.c"
	} else {
#line 21 "../src/Photo.vala"
		*object_p = photo_import_params_ref (value->data[0].v_pointer);
#line 4296 "Photo.c"
	}
#line 21 "../src/Photo.vala"
	return NULL;
#line 4300 "Photo.c"
}

GParamSpec*
param_spec_photo_import_params (const gchar* name,
                                const gchar* nick,
                                const gchar* blurb,
                                GType object_type,
                                GParamFlags flags)
{
	ParamSpecPhotoImportParams* spec;
#line 21 "../src/Photo.vala"
	g_return_val_if_fail (g_type_is_a (object_type, TYPE_PHOTO_IMPORT_PARAMS), NULL);
#line 21 "../src/Photo.vala"
	spec = g_param_spec_internal (G_TYPE_PARAM_OBJECT, name, nick, blurb, flags);
#line 21 "../src/Photo.vala"
	G_PARAM_SPEC (spec)->value_type = object_type;
#line 21 "../src/Photo.vala"
	return G_PARAM_SPEC (spec);
#line 4319 "Photo.c"
}

gpointer
value_get_photo_import_params (const GValue* value)
{
#line 21 "../src/Photo.vala"
	g_return_val_if_fail (G_TYPE_CHECK_VALUE_TYPE (value, TYPE_PHOTO_IMPORT_PARAMS), NULL);
#line 21 "../src/Photo.vala"
	return value->data[0].v_pointer;
#line 4329 "Photo.c"
}

void
value_set_photo_import_params (GValue* value,
                               gpointer v_object)
{
	PhotoImportParams * old;
#line 21 "../src/Photo.vala"
	g_return_if_fail (G_TYPE_CHECK_VALUE_TYPE (value, TYPE_PHOTO_IMPORT_PARAMS));
#line 21 "../src/Photo.vala"
	old = value->data[0].v_pointer;
#line 21 "../src/Photo.vala"
	if (v_object) {
#line 21 "../src/Photo.vala"
		g_return_if_fail (G_TYPE_CHECK_INSTANCE_TYPE (v_object, TYPE_PHOTO_IMPORT_PARAMS));
#line 21 "../src/Photo.vala"
		g_return_if_fail (g_value_type_compatible (G_TYPE_FROM_INSTANCE (v_object), G_VALUE_TYPE (value)));
#line 21 "../src/Photo.vala"
		value->data[0].v_pointer = v_object;
#line 21 "../src/Photo.vala"
		photo_import_params_ref (value->data[0].v_pointer);
#line 4351 "Photo.c"
	} else {
#line 21 "../src/Photo.vala"
		value->data[0].v_pointer = NULL;
#line 4355 "Photo.c"
	}
#line 21 "../src/Photo.vala"
	if (old) {
#line 21 "../src/Photo.vala"
		photo_import_params_unref (old);
#line 4361 "Photo.c"
	}
}

void
value_take_photo_import_params (GValue* value,
                                gpointer v_object)
{
	PhotoImportParams * old;
#line 21 "../src/Photo.vala"
	g_return_if_fail (G_TYPE_CHECK_VALUE_TYPE (value, TYPE_PHOTO_IMPORT_PARAMS));
#line 21 "../src/Photo.vala"
	old = value->data[0].v_pointer;
#line 21 "../src/Photo.vala"
	if (v_object) {
#line 21 "../src/Photo.vala"
		g_return_if_fail (G_TYPE_CHECK_INSTANCE_TYPE (v_object, TYPE_PHOTO_IMPORT_PARAMS));
#line 21 "../src/Photo.vala"
		g_return_if_fail (g_value_type_compatible (G_TYPE_FROM_INSTANCE (v_object), G_VALUE_TYPE (value)));
#line 21 "../src/Photo.vala"
		value->data[0].v_pointer = v_object;
#line 4382 "Photo.c"
	} else {
#line 21 "../src/Photo.vala"
		value->data[0].v_pointer = NULL;
#line 4386 "Photo.c"
	}
#line 21 "../src/Photo.vala"
	if (old) {
#line 21 "../src/Photo.vala"
		photo_import_params_unref (old);
#line 4392 "Photo.c"
	}
}

static void
photo_import_params_class_init (PhotoImportParamsClass * klass,
                                gpointer klass_data)
{
#line 21 "../src/Photo.vala"
	photo_import_params_parent_class = g_type_class_peek_parent (klass);
#line 21 "../src/Photo.vala"
	((PhotoImportParamsClass *) klass)->finalize = photo_import_params_finalize;
#line 4404 "Photo.c"
}

static void
photo_import_params_instance_init (PhotoImportParams * self,
                                   gpointer klass)
{
	PhotoRow* _tmp0_;
#line 24 "../src/Photo.vala"
	self->final_associated_file = NULL;
#line 35 "../src/Photo.vala"
	_tmp0_ = photo_row_new ();
#line 35 "../src/Photo.vala"
	self->row = _tmp0_;
#line 36 "../src/Photo.vala"
	self->keywords = NULL;
#line 21 "../src/Photo.vala"
	self->ref_count = 1;
#line 4422 "Photo.c"
}

static void
photo_import_params_finalize (PhotoImportParams * obj)
{
	PhotoImportParams * self;
#line 21 "../src/Photo.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, TYPE_PHOTO_IMPORT_PARAMS, PhotoImportParams);
#line 21 "../src/Photo.vala"
	g_signal_handlers_destroy (self);
#line 23 "../src/Photo.vala"
	_g_object_unref0 (self->file);
#line 24 "../src/Photo.vala"
	_g_object_unref0 (self->final_associated_file);
#line 27 "../src/Photo.vala"
	_g_free0 (self->exif_md5);
#line 28 "../src/Photo.vala"
	_g_free0 (self->thumbnail_md5);
#line 29 "../src/Photo.vala"
	_g_free0 (self->full_md5);
#line 32 "../src/Photo.vala"
	_thumbnails_unref0 (self->thumbnails);
#line 35 "../src/Photo.vala"
	_photo_row_unref0 (self->row);
#line 36 "../src/Photo.vala"
	_g_object_unref0 (self->keywords);
#line 4449 "Photo.c"
}

static GType
photo_import_params_get_type_once (void)
{
	static const GTypeValueTable g_define_type_value_table = { value_photo_import_params_init, value_photo_import_params_free_value, value_photo_import_params_copy_value, value_photo_import_params_peek_pointer, "p", value_photo_import_params_collect_value, "p", value_photo_import_params_lcopy_value };
	static const GTypeInfo g_define_type_info = { sizeof (PhotoImportParamsClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) photo_import_params_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (PhotoImportParams), 0, (GInstanceInitFunc) photo_import_params_instance_init, &g_define_type_value_table };
	static const GTypeFundamentalInfo g_define_type_fundamental_info = { (G_TYPE_FLAG_CLASSED | G_TYPE_FLAG_INSTANTIATABLE | G_TYPE_FLAG_DERIVABLE | G_TYPE_FLAG_DEEP_DERIVABLE) };
	GType photo_import_params_type_id;
	photo_import_params_type_id = g_type_register_fundamental (g_type_fundamental_next (), "PhotoImportParams", &g_define_type_info, &g_define_type_fundamental_info, 0);
	return photo_import_params_type_id;
}

GType
photo_import_params_get_type (void)
{
	static volatile gsize photo_import_params_type_id__once = 0;
	if (g_once_init_enter (&photo_import_params_type_id__once)) {
		GType photo_import_params_type_id;
		photo_import_params_type_id = photo_import_params_get_type_once ();
		g_once_init_leave (&photo_import_params_type_id__once, photo_import_params_type_id);
	}
	return photo_import_params_type_id__once;
}

gpointer
photo_import_params_ref (gpointer instance)
{
	PhotoImportParams * self;
	self = instance;
#line 21 "../src/Photo.vala"
	g_atomic_int_inc (&self->ref_count);
#line 21 "../src/Photo.vala"
	return instance;
#line 4484 "Photo.c"
}

void
photo_import_params_unref (gpointer instance)
{
	PhotoImportParams * self;
	self = instance;
#line 21 "../src/Photo.vala"
	if (g_atomic_int_dec_and_test (&self->ref_count)) {
#line 21 "../src/Photo.vala"
		PHOTO_IMPORT_PARAMS_GET_CLASS (self)->finalize (self);
#line 21 "../src/Photo.vala"
		g_type_free_instance ((GTypeInstance *) self);
#line 4498 "Photo.c"
	}
}

static inline gpointer
photo_transformation_state_get_instance_private (PhotoTransformationState* self)
{
	return G_STRUCT_MEMBER_P (self, PhotoTransformationState_private_offset);
}

gboolean
photo_transformation_state_is_broken (PhotoTransformationState* self)
{
	gboolean result;
#line 72 "../src/Photo.vala"
	g_return_val_if_fail (IS_PHOTO_TRANSFORMATION_STATE (self), FALSE);
#line 73 "../src/Photo.vala"
	result = self->priv->is_broke;
#line 73 "../src/Photo.vala"
	return result;
#line 4518 "Photo.c"
}

PhotoTransformationState*
photo_transformation_state_construct (GType object_type)
{
	PhotoTransformationState * self = NULL;
#line 63 "../src/Photo.vala"
	self = (PhotoTransformationState*) g_object_new (object_type, NULL);
#line 63 "../src/Photo.vala"
	return self;
#line 4529 "Photo.c"
}

static void
photo_transformation_state_real_broken (PhotoTransformationState* self)
{
#line 69 "../src/Photo.vala"
	self->priv->is_broke = TRUE;
#line 4537 "Photo.c"
}

static void
photo_transformation_state_class_init (PhotoTransformationStateClass * klass,
                                       gpointer klass_data)
{
#line 63 "../src/Photo.vala"
	photo_transformation_state_parent_class = g_type_class_peek_parent (klass);
#line 63 "../src/Photo.vala"
	g_type_class_adjust_private_offset (klass, &PhotoTransformationState_private_offset);
#line 63 "../src/Photo.vala"
	((PhotoTransformationStateClass *) klass)->broken = photo_transformation_state_real_broken;
#line 63 "../src/Photo.vala"
	G_OBJECT_CLASS (klass)->finalize = photo_transformation_state_finalize;
#line 63 "../src/Photo.vala"
	photo_transformation_state_signals[PHOTO_TRANSFORMATION_STATE_BROKEN_SIGNAL] = g_signal_new ("broken", TYPE_PHOTO_TRANSFORMATION_STATE, G_SIGNAL_RUN_LAST, G_STRUCT_OFFSET (PhotoTransformationStateClass, broken), NULL, NULL, g_cclosure_marshal_VOID__VOID, G_TYPE_NONE, 0);
#line 4554 "Photo.c"
}

static void
photo_transformation_state_instance_init (PhotoTransformationState * self,
                                          gpointer klass)
{
#line 63 "../src/Photo.vala"
	self->priv = photo_transformation_state_get_instance_private (self);
#line 64 "../src/Photo.vala"
	self->priv->is_broke = FALSE;
#line 4565 "Photo.c"
}

static void
photo_transformation_state_finalize (GObject * obj)
{
	PhotoTransformationState * self;
#line 63 "../src/Photo.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, TYPE_PHOTO_TRANSFORMATION_STATE, PhotoTransformationState);
#line 63 "../src/Photo.vala"
	G_OBJECT_CLASS (photo_transformation_state_parent_class)->finalize (obj);
#line 4576 "Photo.c"
}

static GType
photo_transformation_state_get_type_once (void)
{
	static const GTypeInfo g_define_type_info = { sizeof (PhotoTransformationStateClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) photo_transformation_state_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (PhotoTransformationState), 0, (GInstanceInitFunc) photo_transformation_state_instance_init, NULL };
	GType photo_transformation_state_type_id;
	photo_transformation_state_type_id = g_type_register_static (G_TYPE_OBJECT, "PhotoTransformationState", &g_define_type_info, G_TYPE_FLAG_ABSTRACT);
	PhotoTransformationState_private_offset = g_type_add_instance_private (photo_transformation_state_type_id, sizeof (PhotoTransformationStatePrivate));
	return photo_transformation_state_type_id;
}

GType
photo_transformation_state_get_type (void)
{
	static volatile gsize photo_transformation_state_type_id__once = 0;
	if (g_once_init_enter (&photo_transformation_state_type_id__once)) {
		GType photo_transformation_state_type_id;
		photo_transformation_state_type_id = photo_transformation_state_get_type_once ();
		g_once_init_leave (&photo_transformation_state_type_id__once, photo_transformation_state_type_id);
	}
	return photo_transformation_state_type_id__once;
}

gboolean
rating_can_increase (Rating self)
{
	gboolean result;
#line 87 "../src/Photo.vala"
	result = self < RATING_FIVE;
#line 87 "../src/Photo.vala"
	return result;
#line 4609 "Photo.c"
}

gboolean
rating_can_decrease (Rating self)
{
	gboolean result;
#line 91 "../src/Photo.vala"
	result = self > RATING_REJECTED;
#line 91 "../src/Photo.vala"
	return result;
#line 4620 "Photo.c"
}

gboolean
rating_is_valid (Rating self)
{
	gboolean _tmp0_ = FALSE;
	gboolean result;
#line 95 "../src/Photo.vala"
	if (self >= RATING_REJECTED) {
#line 95 "../src/Photo.vala"
		_tmp0_ = self <= RATING_FIVE;
#line 4632 "Photo.c"
	} else {
#line 95 "../src/Photo.vala"
		_tmp0_ = FALSE;
#line 4636 "Photo.c"
	}
#line 95 "../src/Photo.vala"
	result = _tmp0_;
#line 95 "../src/Photo.vala"
	return result;
#line 4642 "Photo.c"
}

Rating
rating_increase (Rating self)
{
	Rating _tmp0_ = 0;
	Rating result;
#line 99 "../src/Photo.vala"
	if (rating_can_increase (self)) {
#line 99 "../src/Photo.vala"
		_tmp0_ = self + 1;
#line 4654 "Photo.c"
	} else {
#line 99 "../src/Photo.vala"
		_tmp0_ = self;
#line 4658 "Photo.c"
	}
#line 99 "../src/Photo.vala"
	result = _tmp0_;
#line 99 "../src/Photo.vala"
	return result;
#line 4664 "Photo.c"
}

Rating
rating_decrease (Rating self)
{
	Rating _tmp0_ = 0;
	Rating result;
#line 103 "../src/Photo.vala"
	if (rating_can_decrease (self)) {
#line 103 "../src/Photo.vala"
		_tmp0_ = self - 1;
#line 4676 "Photo.c"
	} else {
#line 103 "../src/Photo.vala"
		_tmp0_ = self;
#line 4680 "Photo.c"
	}
#line 103 "../src/Photo.vala"
	result = _tmp0_;
#line 103 "../src/Photo.vala"
	return result;
#line 4686 "Photo.c"
}

gint
rating_serialize (Rating self)
{
	gint result;
#line 107 "../src/Photo.vala"
	switch (self) {
#line 107 "../src/Photo.vala"
		case RATING_REJECTED:
#line 4697 "Photo.c"
		{
#line 109 "../src/Photo.vala"
			result = -1;
#line 109 "../src/Photo.vala"
			return result;
#line 4703 "Photo.c"
		}
#line 107 "../src/Photo.vala"
		case RATING_UNRATED:
#line 4707 "Photo.c"
		{
#line 111 "../src/Photo.vala"
			result = 0;
#line 111 "../src/Photo.vala"
			return result;
#line 4713 "Photo.c"
		}
#line 107 "../src/Photo.vala"
		case RATING_ONE:
#line 4717 "Photo.c"
		{
#line 113 "../src/Photo.vala"
			result = 1;
#line 113 "../src/Photo.vala"
			return result;
#line 4723 "Photo.c"
		}
#line 107 "../src/Photo.vala"
		case RATING_TWO:
#line 4727 "Photo.c"
		{
#line 115 "../src/Photo.vala"
			result = 2;
#line 115 "../src/Photo.vala"
			return result;
#line 4733 "Photo.c"
		}
#line 107 "../src/Photo.vala"
		case RATING_THREE:
#line 4737 "Photo.c"
		{
#line 117 "../src/Photo.vala"
			result = 3;
#line 117 "../src/Photo.vala"
			return result;
#line 4743 "Photo.c"
		}
#line 107 "../src/Photo.vala"
		case RATING_FOUR:
#line 4747 "Photo.c"
		{
#line 119 "../src/Photo.vala"
			result = 4;
#line 119 "../src/Photo.vala"
			return result;
#line 4753 "Photo.c"
		}
#line 107 "../src/Photo.vala"
		case RATING_FIVE:
#line 4757 "Photo.c"
		{
#line 121 "../src/Photo.vala"
			result = 5;
#line 121 "../src/Photo.vala"
			return result;
#line 4763 "Photo.c"
		}
		default:
		{
#line 123 "../src/Photo.vala"
			result = 0;
#line 123 "../src/Photo.vala"
			return result;
#line 4771 "Photo.c"
		}
	}
}

Rating
rating_unserialize (gint value)
{
	Rating result;
#line 128 "../src/Photo.vala"
	if (value > ((gint) RATING_FIVE)) {
#line 129 "../src/Photo.vala"
		result = RATING_FIVE;
#line 129 "../src/Photo.vala"
		return result;
#line 4786 "Photo.c"
	} else {
#line 130 "../src/Photo.vala"
		if (value < ((gint) RATING_REJECTED)) {
#line 131 "../src/Photo.vala"
			result = RATING_REJECTED;
#line 131 "../src/Photo.vala"
			return result;
#line 4794 "Photo.c"
		}
	}
#line 133 "../src/Photo.vala"
	switch (value) {
#line 133 "../src/Photo.vala"
		case -1:
#line 4801 "Photo.c"
		{
#line 135 "../src/Photo.vala"
			result = RATING_REJECTED;
#line 135 "../src/Photo.vala"
			return result;
#line 4807 "Photo.c"
		}
#line 133 "../src/Photo.vala"
		case 0:
#line 4811 "Photo.c"
		{
#line 137 "../src/Photo.vala"
			result = RATING_UNRATED;
#line 137 "../src/Photo.vala"
			return result;
#line 4817 "Photo.c"
		}
#line 133 "../src/Photo.vala"
		case 1:
#line 4821 "Photo.c"
		{
#line 139 "../src/Photo.vala"
			result = RATING_ONE;
#line 139 "../src/Photo.vala"
			return result;
#line 4827 "Photo.c"
		}
#line 133 "../src/Photo.vala"
		case 2:
#line 4831 "Photo.c"
		{
#line 141 "../src/Photo.vala"
			result = RATING_TWO;
#line 141 "../src/Photo.vala"
			return result;
#line 4837 "Photo.c"
		}
#line 133 "../src/Photo.vala"
		case 3:
#line 4841 "Photo.c"
		{
#line 143 "../src/Photo.vala"
			result = RATING_THREE;
#line 143 "../src/Photo.vala"
			return result;
#line 4847 "Photo.c"
		}
#line 133 "../src/Photo.vala"
		case 4:
#line 4851 "Photo.c"
		{
#line 145 "../src/Photo.vala"
			result = RATING_FOUR;
#line 145 "../src/Photo.vala"
			return result;
#line 4857 "Photo.c"
		}
#line 133 "../src/Photo.vala"
		case 5:
#line 4861 "Photo.c"
		{
#line 147 "../src/Photo.vala"
			result = RATING_FIVE;
#line 147 "../src/Photo.vala"
			return result;
#line 4867 "Photo.c"
		}
		default:
		{
#line 149 "../src/Photo.vala"
			result = RATING_UNRATED;
#line 149 "../src/Photo.vala"
			return result;
#line 4875 "Photo.c"
		}
	}
}

static GType
rating_get_type_once (void)
{
	static const GEnumValue values[] = {{RATING_REJECTED, "RATING_REJECTED", "rejected"}, {RATING_UNRATED, "RATING_UNRATED", "unrated"}, {RATING_ONE, "RATING_ONE", "one"}, {RATING_TWO, "RATING_TWO", "two"}, {RATING_THREE, "RATING_THREE", "three"}, {RATING_FOUR, "RATING_FOUR", "four"}, {RATING_FIVE, "RATING_FIVE", "five"}, {0, NULL, NULL}};
	GType rating_type_id;
	rating_type_id = g_enum_register_static ("Rating", values);
	return rating_type_id;
}

GType
rating_get_type (void)
{
	static volatile gsize rating_type_id__once = 0;
	if (g_once_init_enter (&rating_type_id__once)) {
		GType rating_type_id;
		rating_type_id = rating_get_type_once ();
		g_once_init_leave (&rating_type_id__once, rating_type_id);
	}
	return rating_type_id__once;
}

static inline gpointer
photo_get_instance_private (Photo* self)
{
	return G_STRUCT_MEMBER_P (self, Photo_private_offset);
}

gboolean
photo_exception_prohibits (PhotoException self,
                           PhotoException exception)
{
	gboolean result;
#line 225 "../src/Photo.vala"
	result = (self & exception) != 0;
#line 225 "../src/Photo.vala"
	return result;
#line 4916 "Photo.c"
}

gboolean
photo_exception_allows (PhotoException self,
                        PhotoException exception)
{
	gboolean result;
#line 229 "../src/Photo.vala"
	result = (self & exception) == 0;
#line 229 "../src/Photo.vala"
	return result;
#line 4928 "Photo.c"
}

static GType
photo_exception_get_type_once (void)
{
	static const GEnumValue values[] = {{PHOTO_EXCEPTION_NONE, "PHOTO_EXCEPTION_NONE", "none"}, {PHOTO_EXCEPTION_ORIENTATION, "PHOTO_EXCEPTION_ORIENTATION", "orientation"}, {PHOTO_EXCEPTION_CROP, "PHOTO_EXCEPTION_CROP", "crop"}, {PHOTO_EXCEPTION_REDEYE, "PHOTO_EXCEPTION_REDEYE", "redeye"}, {PHOTO_EXCEPTION_ADJUST, "PHOTO_EXCEPTION_ADJUST", "adjust"}, {PHOTO_EXCEPTION_STRAIGHTEN, "PHOTO_EXCEPTION_STRAIGHTEN", "straighten"}, {PHOTO_EXCEPTION_ALL, "PHOTO_EXCEPTION_ALL", "all"}, {0, NULL, NULL}};
	GType photo_exception_type_id;
	photo_exception_type_id = g_enum_register_static ("PhotoException", values);
	return photo_exception_type_id;
}

GType
photo_exception_get_type (void)
{
	static volatile gsize photo_exception_type_id__once = 0;
	if (g_once_init_enter (&photo_exception_type_id__once)) {
		GType photo_exception_type_id;
		photo_exception_type_id = photo_exception_get_type_once ();
		g_once_init_leave (&photo_exception_type_id__once, photo_exception_type_id);
	}
	return photo_exception_type_id__once;
}

static gpointer
_photo_row_ref0 (gpointer self)
{
#line 397 "../src/Photo.vala"
	return self ? photo_row_ref (self) : NULL;
#line 4957 "Photo.c"
}

static gpointer
_backing_photo_row_ref0 (gpointer self)
{
#line 416 "../src/Photo.vala"
	return self ? backing_photo_row_ref (self) : NULL;
#line 4965 "Photo.c"
}

static gpointer
_g_date_time_ref0 (gpointer self)
{
#line 466 "../src/Photo.vala"
	return self ? g_date_time_ref (self) : NULL;
#line 4973 "Photo.c"
}

Photo*
photo_construct (GType object_type,
                 PhotoRow* row)
{
	Photo * self = NULL;
	PhotoRow* _tmp0_;
	PhotoRow* _tmp1_;
	PhotoRow* _tmp2_;
	const gchar* _tmp3_;
	gchar* _tmp4_;
	PhotoRow* _tmp5_;
	PhotoRow* _tmp6_;
	const gchar* _tmp7_;
	gchar* _tmp8_;
	PhotoBackingReaders* _tmp9_;
	BackingPhotoRow* _tmp10_;
	BackingPhotoRow* _tmp11_;
	const gchar* _tmp12_;
	PhotoFileReader* _tmp13_;
	BackingPhotoRow* _tmp14_;
	const gchar* _tmp15_;
	gchar* _tmp16_;
	const gchar* _tmp17_;
	BackingPhotoID _tmp21_;
	BackingPhotoRow* _tmp35_;
	gboolean _tmp47_ = FALSE;
	BackingPhotoRow* _tmp48_;
	PhotoBackingReaders* _tmp57_;
	PhotoFileReader* _tmp58_;
	PhotoRow* _tmp71_;
	GDateTime* _tmp72_;
	GDateTime* _tmp73_;
	GError* _inner_error0_ = NULL;
#line 396 "../src/Photo.vala"
	g_return_val_if_fail (IS_PHOTO_ROW (row), NULL);
#line 396 "../src/Photo.vala"
	self = (Photo*) photo_source_construct (object_type, DATA_OBJECT_INVALID_OBJECT_ID);
#line 397 "../src/Photo.vala"
	_tmp0_ = _photo_row_ref0 (row);
#line 397 "../src/Photo.vala"
	_photo_row_unref0 (self->row);
#line 397 "../src/Photo.vala"
	self->row = _tmp0_;
#line 400 "../src/Photo.vala"
	_tmp1_ = self->row;
#line 400 "../src/Photo.vala"
	_tmp2_ = self->row;
#line 400 "../src/Photo.vala"
	_tmp3_ = _tmp2_->title;
#line 400 "../src/Photo.vala"
	_tmp4_ = media_source_prep_title (_tmp3_);
#line 400 "../src/Photo.vala"
	_g_free0 (_tmp1_->title);
#line 400 "../src/Photo.vala"
	_tmp1_->title = _tmp4_;
#line 401 "../src/Photo.vala"
	_tmp5_ = self->row;
#line 401 "../src/Photo.vala"
	_tmp6_ = self->row;
#line 401 "../src/Photo.vala"
	_tmp7_ = _tmp6_->comment;
#line 401 "../src/Photo.vala"
	_tmp8_ = media_source_prep_comment (_tmp7_);
#line 401 "../src/Photo.vala"
	_g_free0 (_tmp5_->comment);
#line 401 "../src/Photo.vala"
	_tmp5_->comment = _tmp8_;
#line 405 "../src/Photo.vala"
	_tmp9_ = self->priv->readers;
#line 405 "../src/Photo.vala"
	_tmp10_ = row->master;
#line 405 "../src/Photo.vala"
	_tmp11_ = row->master;
#line 405 "../src/Photo.vala"
	_tmp12_ = _tmp11_->filepath;
#line 405 "../src/Photo.vala"
	_tmp13_ = photo_file_format_create_reader (_tmp10_->file_format, _tmp12_);
#line 405 "../src/Photo.vala"
	_photo_file_adapter_unref0 (_tmp9_->master);
#line 405 "../src/Photo.vala"
	_tmp9_->master = _tmp13_;
#line 408 "../src/Photo.vala"
	_tmp14_ = row->master;
#line 408 "../src/Photo.vala"
	_tmp15_ = _tmp14_->filepath;
#line 408 "../src/Photo.vala"
	_tmp16_ = g_path_get_basename (_tmp15_);
#line 408 "../src/Photo.vala"
	_g_free0 (self->priv->file_title);
#line 408 "../src/Photo.vala"
	self->priv->file_title = _tmp16_;
#line 410 "../src/Photo.vala"
	_tmp17_ = self->priv->file_title;
#line 410 "../src/Photo.vala"
	if (is_string_empty (_tmp17_)) {
#line 5071 "Photo.c"
		BackingPhotoRow* _tmp18_;
		const gchar* _tmp19_;
		gchar* _tmp20_;
#line 411 "../src/Photo.vala"
		_tmp18_ = row->master;
#line 411 "../src/Photo.vala"
		_tmp19_ = _tmp18_->filepath;
#line 411 "../src/Photo.vala"
		_tmp20_ = g_strdup (_tmp19_);
#line 411 "../src/Photo.vala"
		_g_free0 (self->priv->file_title);
#line 411 "../src/Photo.vala"
		self->priv->file_title = _tmp20_;
#line 5085 "Photo.c"
	}
#line 413 "../src/Photo.vala"
	_tmp21_ = row->editable_id;
#line 413 "../src/Photo.vala"
	if (_tmp21_.id != BACKING_PHOTO_ID_INVALID) {
#line 5091 "Photo.c"
		BackingPhotoRow* e = NULL;
		BackingPhotoID _tmp22_;
		BackingPhotoRow* _tmp23_;
		BackingPhotoRow* _tmp24_;
#line 414 "../src/Photo.vala"
		_tmp22_ = row->editable_id;
#line 414 "../src/Photo.vala"
		_tmp23_ = photo_get_backing_row (self, &_tmp22_);
#line 414 "../src/Photo.vala"
		e = _tmp23_;
#line 415 "../src/Photo.vala"
		_tmp24_ = e;
#line 415 "../src/Photo.vala"
		if (_tmp24_ != NULL) {
#line 5106 "Photo.c"
			BackingPhotoRow* _tmp25_;
			BackingPhotoRow* _tmp26_;
			PhotoBackingReaders* _tmp27_;
			BackingPhotoRow* _tmp28_;
			BackingPhotoRow* _tmp29_;
			const gchar* _tmp30_;
			PhotoFileReader* _tmp31_;
#line 416 "../src/Photo.vala"
			_tmp25_ = e;
#line 416 "../src/Photo.vala"
			_tmp26_ = _backing_photo_row_ref0 (_tmp25_);
#line 416 "../src/Photo.vala"
			_backing_photo_row_unref0 (self->priv->editable);
#line 416 "../src/Photo.vala"
			self->priv->editable = _tmp26_;
#line 417 "../src/Photo.vala"
			_tmp27_ = self->priv->readers;
#line 417 "../src/Photo.vala"
			_tmp28_ = self->priv->editable;
#line 417 "../src/Photo.vala"
			_tmp29_ = self->priv->editable;
#line 417 "../src/Photo.vala"
			_tmp30_ = _tmp29_->filepath;
#line 417 "../src/Photo.vala"
			_tmp31_ = photo_file_format_create_reader (_tmp28_->file_format, _tmp30_);
#line 417 "../src/Photo.vala"
			_photo_file_adapter_unref0 (_tmp27_->editable);
#line 417 "../src/Photo.vala"
			_tmp27_->editable = _tmp31_;
#line 5136 "Photo.c"
		} else {
			{
				PhotoTable* _tmp32_;
				PhotoTable* _tmp33_;
				PhotoRow* _tmp34_;
#line 420 "../src/Photo.vala"
				_tmp32_ = photo_table_get_instance ();
#line 420 "../src/Photo.vala"
				_tmp33_ = _tmp32_;
#line 420 "../src/Photo.vala"
				_tmp34_ = self->row;
#line 420 "../src/Photo.vala"
				photo_table_detach_editable (_tmp33_, _tmp34_, &_inner_error0_);
#line 420 "../src/Photo.vala"
				_database_table_unref0 (_tmp33_);
#line 420 "../src/Photo.vala"
				if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 420 "../src/Photo.vala"
					if (_inner_error0_->domain == DATABASE_ERROR) {
#line 5156 "Photo.c"
						goto __catch0_database_error;
					}
#line 420 "../src/Photo.vala"
					_backing_photo_row_unref0 (e);
#line 420 "../src/Photo.vala"
					g_critical ("file %s: line %d: unexpected error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 420 "../src/Photo.vala"
					g_clear_error (&_inner_error0_);
#line 420 "../src/Photo.vala"
					return NULL;
#line 5167 "Photo.c"
				}
			}
			goto __finally0;
			__catch0_database_error:
			{
#line 419 "../src/Photo.vala"
				g_clear_error (&_inner_error0_);
#line 5175 "Photo.c"
			}
			__finally0:
#line 419 "../src/Photo.vala"
			if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 419 "../src/Photo.vala"
				_backing_photo_row_unref0 (e);
#line 419 "../src/Photo.vala"
				g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 419 "../src/Photo.vala"
				g_clear_error (&_inner_error0_);
#line 419 "../src/Photo.vala"
				return NULL;
#line 5188 "Photo.c"
			}
#line 427 "../src/Photo.vala"
			photo_remove_all_transformations (self, FALSE);
#line 5192 "Photo.c"
		}
#line 413 "../src/Photo.vala"
		_backing_photo_row_unref0 (e);
#line 5196 "Photo.c"
	}
#line 431 "../src/Photo.vala"
	_tmp35_ = row->master;
#line 431 "../src/Photo.vala"
	if (_tmp35_->file_format == PHOTO_FILE_FORMAT_RAW) {
#line 5202 "Photo.c"
		GeeHashMap* _tmp36_;
		gint _tmp37_ = 0;
		RawDeveloper* _tmp38_;
#line 433 "../src/Photo.vala"
		_tmp36_ = gee_hash_map_new (TYPE_RAW_DEVELOPER, NULL, NULL, TYPE_BACKING_PHOTO_ROW, (GBoxedCopyFunc) backing_photo_row_ref, (GDestroyNotify) backing_photo_row_unref, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL);
#line 433 "../src/Photo.vala"
		_g_object_unref0 (self->priv->developments);
#line 433 "../src/Photo.vala"
		self->priv->developments = _tmp36_;
#line 434 "../src/Photo.vala"
		_tmp38_ = raw_developer_as_array (&_tmp37_);
#line 5214 "Photo.c"
		{
			RawDeveloper* d_collection = NULL;
			gint d_collection_length1 = 0;
			gint _d_collection_size_ = 0;
			gint d_it = 0;
#line 434 "../src/Photo.vala"
			d_collection = _tmp38_;
#line 434 "../src/Photo.vala"
			d_collection_length1 = _tmp37_;
#line 434 "../src/Photo.vala"
			for (d_it = 0; d_it < d_collection_length1; d_it = d_it + 1) {
#line 5226 "Photo.c"
				RawDeveloper d = 0;
#line 434 "../src/Photo.vala"
				d = d_collection[d_it];
#line 5230 "Photo.c"
				{
					BackingPhotoID id = {0};
					BackingPhotoID* _tmp39_;
					gint _tmp39__length1;
					BackingPhotoID _tmp40_;
					BackingPhotoID _tmp41_;
#line 435 "../src/Photo.vala"
					_tmp39_ = row->development_ids;
#line 435 "../src/Photo.vala"
					_tmp39__length1 = row->development_ids_length1;
#line 435 "../src/Photo.vala"
					_tmp40_ = _tmp39_[d];
#line 435 "../src/Photo.vala"
					id = _tmp40_;
#line 436 "../src/Photo.vala"
					_tmp41_ = id;
#line 436 "../src/Photo.vala"
					if (_tmp41_.id != BACKING_PHOTO_ID_INVALID) {
#line 5249 "Photo.c"
						BackingPhotoRow* bpr = NULL;
						BackingPhotoID _tmp42_;
						BackingPhotoRow* _tmp43_;
						BackingPhotoRow* _tmp44_;
#line 437 "../src/Photo.vala"
						_tmp42_ = id;
#line 437 "../src/Photo.vala"
						_tmp43_ = photo_get_backing_row (self, &_tmp42_);
#line 437 "../src/Photo.vala"
						bpr = _tmp43_;
#line 438 "../src/Photo.vala"
						_tmp44_ = bpr;
#line 438 "../src/Photo.vala"
						if (_tmp44_ != NULL) {
#line 5264 "Photo.c"
							GeeHashMap* _tmp45_;
							BackingPhotoRow* _tmp46_;
#line 439 "../src/Photo.vala"
							_tmp45_ = self->priv->developments;
#line 439 "../src/Photo.vala"
							_tmp46_ = bpr;
#line 439 "../src/Photo.vala"
							gee_abstract_map_set (G_TYPE_CHECK_INSTANCE_CAST (_tmp45_, GEE_TYPE_ABSTRACT_MAP, GeeAbstractMap), (gpointer) ((gintptr) d), _tmp46_);
#line 5273 "Photo.c"
						}
#line 436 "../src/Photo.vala"
						_backing_photo_row_unref0 (bpr);
#line 5277 "Photo.c"
					}
				}
			}
#line 434 "../src/Photo.vala"
			d_collection = (g_free (d_collection), NULL);
#line 5283 "Photo.c"
		}
	}
#line 445 "../src/Photo.vala"
	_tmp48_ = row->master;
#line 445 "../src/Photo.vala"
	if (_tmp48_->file_format == PHOTO_FILE_FORMAT_RAW) {
#line 5290 "Photo.c"
		GeeHashMap* _tmp49_;
#line 445 "../src/Photo.vala"
		_tmp49_ = self->priv->developments;
#line 445 "../src/Photo.vala"
		_tmp47_ = gee_abstract_map_has_key (G_TYPE_CHECK_INSTANCE_CAST (_tmp49_, GEE_TYPE_ABSTRACT_MAP, GeeAbstractMap), (gpointer) ((gintptr) row->developer));
#line 5296 "Photo.c"
	} else {
#line 445 "../src/Photo.vala"
		_tmp47_ = FALSE;
#line 5300 "Photo.c"
	}
#line 445 "../src/Photo.vala"
	if (_tmp47_) {
#line 5304 "Photo.c"
		BackingPhotoRow* r = NULL;
		GeeHashMap* _tmp50_;
		gpointer _tmp51_;
		PhotoBackingReaders* _tmp52_;
		BackingPhotoRow* _tmp53_;
		BackingPhotoRow* _tmp54_;
		const gchar* _tmp55_;
		PhotoFileReader* _tmp56_;
#line 446 "../src/Photo.vala"
		_tmp50_ = self->priv->developments;
#line 446 "../src/Photo.vala"
		_tmp51_ = gee_abstract_map_get (G_TYPE_CHECK_INSTANCE_CAST (_tmp50_, GEE_TYPE_ABSTRACT_MAP, GeeAbstractMap), (gpointer) ((gintptr) row->developer));
#line 446 "../src/Photo.vala"
		r = (BackingPhotoRow*) _tmp51_;
#line 447 "../src/Photo.vala"
		_tmp52_ = self->priv->readers;
#line 447 "../src/Photo.vala"
		_tmp53_ = r;
#line 447 "../src/Photo.vala"
		_tmp54_ = r;
#line 447 "../src/Photo.vala"
		_tmp55_ = _tmp54_->filepath;
#line 447 "../src/Photo.vala"
		_tmp56_ = photo_file_format_create_reader (_tmp53_->file_format, _tmp55_);
#line 447 "../src/Photo.vala"
		_photo_file_adapter_unref0 (_tmp52_->developer);
#line 447 "../src/Photo.vala"
		_tmp52_->developer = _tmp56_;
#line 445 "../src/Photo.vala"
		_backing_photo_row_unref0 (r);
#line 5335 "Photo.c"
	}
#line 451 "../src/Photo.vala"
	_tmp57_ = self->priv->readers;
#line 451 "../src/Photo.vala"
	_tmp58_ = _tmp57_->editable;
#line 451 "../src/Photo.vala"
	if (_tmp58_ != NULL) {
#line 5343 "Photo.c"
		BackingPhotoRow* _tmp59_;
		BackingPhotoRow* _tmp60_;
#line 452 "../src/Photo.vala"
		_tmp59_ = self->priv->editable;
#line 452 "../src/Photo.vala"
		_tmp60_ = _backing_photo_row_ref0 (_tmp59_);
#line 452 "../src/Photo.vala"
		_backing_photo_row_unref0 (self->backing_photo_row);
#line 452 "../src/Photo.vala"
		self->backing_photo_row = _tmp60_;
#line 5354 "Photo.c"
	} else {
		BackingPhotoRow* _tmp61_;
#line 453 "../src/Photo.vala"
		_tmp61_ = row->master;
#line 453 "../src/Photo.vala"
		if (_tmp61_->file_format != PHOTO_FILE_FORMAT_RAW) {
#line 5361 "Photo.c"
			PhotoRow* _tmp62_;
			BackingPhotoRow* _tmp63_;
			BackingPhotoRow* _tmp64_;
#line 454 "../src/Photo.vala"
			_tmp62_ = self->row;
#line 454 "../src/Photo.vala"
			_tmp63_ = _tmp62_->master;
#line 454 "../src/Photo.vala"
			_tmp64_ = _backing_photo_row_ref0 (_tmp63_);
#line 454 "../src/Photo.vala"
			_backing_photo_row_unref0 (self->backing_photo_row);
#line 454 "../src/Photo.vala"
			self->backing_photo_row = _tmp64_;
#line 5375 "Photo.c"
		} else {
			GeeHashMap* _tmp65_;
#line 458 "../src/Photo.vala"
			_tmp65_ = self->priv->developments;
#line 458 "../src/Photo.vala"
			if (gee_abstract_map_has_key (G_TYPE_CHECK_INSTANCE_CAST (_tmp65_, GEE_TYPE_ABSTRACT_MAP, GeeAbstractMap), (gpointer) ((gintptr) row->developer))) {
#line 5382 "Photo.c"
				GeeHashMap* _tmp66_;
				gpointer _tmp67_;
#line 459 "../src/Photo.vala"
				_tmp66_ = self->priv->developments;
#line 459 "../src/Photo.vala"
				_tmp67_ = gee_abstract_map_get (G_TYPE_CHECK_INSTANCE_CAST (_tmp66_, GEE_TYPE_ABSTRACT_MAP, GeeAbstractMap), (gpointer) ((gintptr) row->developer));
#line 459 "../src/Photo.vala"
				_backing_photo_row_unref0 (self->backing_photo_row);
#line 459 "../src/Photo.vala"
				self->backing_photo_row = (BackingPhotoRow*) _tmp67_;
#line 5393 "Photo.c"
			} else {
				PhotoRow* _tmp68_;
				BackingPhotoRow* _tmp69_;
				BackingPhotoRow* _tmp70_;
#line 462 "../src/Photo.vala"
				_tmp68_ = self->row;
#line 462 "../src/Photo.vala"
				_tmp69_ = _tmp68_->master;
#line 462 "../src/Photo.vala"
				_tmp70_ = _backing_photo_row_ref0 (_tmp69_);
#line 462 "../src/Photo.vala"
				_backing_photo_row_unref0 (self->backing_photo_row);
#line 462 "../src/Photo.vala"
				self->backing_photo_row = _tmp70_;
#line 5408 "Photo.c"
			}
		}
	}
#line 466 "../src/Photo.vala"
	_tmp71_ = self->row;
#line 466 "../src/Photo.vala"
	_tmp72_ = _tmp71_->exposure_time;
#line 466 "../src/Photo.vala"
	_tmp73_ = _g_date_time_ref0 (_tmp72_);
#line 466 "../src/Photo.vala"
	_g_date_time_unref0 (self->priv->cached_exposure_time);
#line 466 "../src/Photo.vala"
	self->priv->cached_exposure_time = _tmp73_;
#line 396 "../src/Photo.vala"
	return self;
#line 5424 "Photo.c"
}

void
photo_init_photo (void)
{
	GeeLinkedList* _tmp0_;
#line 470 "../src/Photo.vala"
	_tmp0_ = gee_linked_list_new (PHOTO_TYPE_CACHED_PIXBUF, (GBoxedCopyFunc) photo_cached_pixbuf_ref, (GDestroyNotify) photo_cached_pixbuf_unref, NULL, NULL, NULL);
#line 470 "../src/Photo.vala"
	_g_object_unref0 (photo_source_pixbuf_cache);
#line 470 "../src/Photo.vala"
	photo_source_pixbuf_cache = _tmp0_;
#line 5437 "Photo.c"
}

void
photo_terminate_photo (void)
{
#line 474 "../src/Photo.vala"
	_g_object_unref0 (photo_source_pixbuf_cache);
#line 474 "../src/Photo.vala"
	photo_source_pixbuf_cache = NULL;
#line 476 "../src/Photo.vala"
	if (photo_discard_source_id != ((guint) 0)) {
#line 477 "../src/Photo.vala"
		g_source_remove (photo_discard_source_id);
#line 478 "../src/Photo.vala"
		photo_discard_source_id = (guint) 0;
#line 5453 "Photo.c"
	}
}

static void
photo_real_notify_editable_replaced (Photo* self,
                                     GFile* old_file,
                                     GFile* new_file)
{
#line 482 "../src/Photo.vala"
	g_return_if_fail ((old_file == NULL) || G_TYPE_CHECK_INSTANCE_TYPE (old_file, g_file_get_type ()));
#line 482 "../src/Photo.vala"
	g_return_if_fail ((new_file == NULL) || G_TYPE_CHECK_INSTANCE_TYPE (new_file, g_file_get_type ()));
#line 483 "../src/Photo.vala"
	g_signal_emit (self, photo_signals[PHOTO_EDITABLE_REPLACED_SIGNAL], 0, old_file, new_file);
#line 5468 "Photo.c"
}

void
photo_notify_editable_replaced (Photo* self,
                                GFile* old_file,
                                GFile* new_file)
{
	PhotoClass* _klass_;
#line 482 "../src/Photo.vala"
	g_return_if_fail (IS_PHOTO (self));
#line 482 "../src/Photo.vala"
	_klass_ = PHOTO_GET_CLASS (self);
#line 482 "../src/Photo.vala"
	if (_klass_->notify_editable_replaced) {
#line 482 "../src/Photo.vala"
		_klass_->notify_editable_replaced (self, old_file, new_file);
#line 5485 "Photo.c"
	}
}

static void
photo_real_notify_raw_development_modified (Photo* self)
{
#line 487 "../src/Photo.vala"
	g_signal_emit (self, photo_signals[PHOTO_RAW_DEVELOPMENT_MODIFIED_SIGNAL], 0);
#line 5494 "Photo.c"
}

void
photo_notify_raw_development_modified (Photo* self)
{
	PhotoClass* _klass_;
#line 486 "../src/Photo.vala"
	g_return_if_fail (IS_PHOTO (self));
#line 486 "../src/Photo.vala"
	_klass_ = PHOTO_GET_CLASS (self);
#line 486 "../src/Photo.vala"
	if (_klass_->notify_raw_development_modified) {
#line 486 "../src/Photo.vala"
		_klass_->notify_raw_development_modified (self);
#line 5509 "Photo.c"
	}
}

static void
photo_real_notify_baseline_replaced (Photo* self)
{
#line 491 "../src/Photo.vala"
	g_signal_emit (self, photo_signals[PHOTO_BASELINE_REPLACED_SIGNAL], 0);
#line 5518 "Photo.c"
}

void
photo_notify_baseline_replaced (Photo* self)
{
	PhotoClass* _klass_;
#line 490 "../src/Photo.vala"
	g_return_if_fail (IS_PHOTO (self));
#line 490 "../src/Photo.vala"
	_klass_ = PHOTO_GET_CLASS (self);
#line 490 "../src/Photo.vala"
	if (_klass_->notify_baseline_replaced) {
#line 490 "../src/Photo.vala"
		_klass_->notify_baseline_replaced (self);
#line 5533 "Photo.c"
	}
}

static void
photo_real_notify_master_reimported (Photo* self,
                                     PhotoMetadata* metadata)
{
#line 494 "../src/Photo.vala"
	g_return_if_fail ((metadata == NULL) || IS_PHOTO_METADATA (metadata));
#line 495 "../src/Photo.vala"
	g_signal_emit (self, photo_signals[PHOTO_MASTER_REIMPORTED_SIGNAL], 0, metadata);
#line 5545 "Photo.c"
}

void
photo_notify_master_reimported (Photo* self,
                                PhotoMetadata* metadata)
{
	PhotoClass* _klass_;
#line 494 "../src/Photo.vala"
	g_return_if_fail (IS_PHOTO (self));
#line 494 "../src/Photo.vala"
	_klass_ = PHOTO_GET_CLASS (self);
#line 494 "../src/Photo.vala"
	if (_klass_->notify_master_reimported) {
#line 494 "../src/Photo.vala"
		_klass_->notify_master_reimported (self, metadata);
#line 5561 "Photo.c"
	}
}

static void
photo_real_notify_editable_reimported (Photo* self,
                                       PhotoMetadata* metadata)
{
#line 498 "../src/Photo.vala"
	g_return_if_fail ((metadata == NULL) || IS_PHOTO_METADATA (metadata));
#line 499 "../src/Photo.vala"
	g_signal_emit (self, photo_signals[PHOTO_EDITABLE_REIMPORTED_SIGNAL], 0, metadata);
#line 5573 "Photo.c"
}

void
photo_notify_editable_reimported (Photo* self,
                                  PhotoMetadata* metadata)
{
	PhotoClass* _klass_;
#line 498 "../src/Photo.vala"
	g_return_if_fail (IS_PHOTO (self));
#line 498 "../src/Photo.vala"
	_klass_ = PHOTO_GET_CLASS (self);
#line 498 "../src/Photo.vala"
	if (_klass_->notify_editable_reimported) {
#line 498 "../src/Photo.vala"
		_klass_->notify_editable_reimported (self, metadata);
#line 5589 "Photo.c"
	}
}

static void
photo_real_notify_source_reimported (Photo* self,
                                     PhotoMetadata* metadata)
{
#line 502 "../src/Photo.vala"
	g_return_if_fail ((metadata == NULL) || IS_PHOTO_METADATA (metadata));
#line 503 "../src/Photo.vala"
	g_signal_emit (self, photo_signals[PHOTO_SOURCE_REIMPORTED_SIGNAL], 0, metadata);
#line 5601 "Photo.c"
}

void
photo_notify_source_reimported (Photo* self,
                                PhotoMetadata* metadata)
{
	PhotoClass* _klass_;
#line 502 "../src/Photo.vala"
	g_return_if_fail (IS_PHOTO (self));
#line 502 "../src/Photo.vala"
	_klass_ = PHOTO_GET_CLASS (self);
#line 502 "../src/Photo.vala"
	if (_klass_->notify_source_reimported) {
#line 502 "../src/Photo.vala"
		_klass_->notify_source_reimported (self, metadata);
#line 5617 "Photo.c"
	}
}

static void
photo_real_notify_baseline_reimported (Photo* self,
                                       PhotoMetadata* metadata)
{
#line 506 "../src/Photo.vala"
	g_return_if_fail ((metadata == NULL) || IS_PHOTO_METADATA (metadata));
#line 507 "../src/Photo.vala"
	g_signal_emit (self, photo_signals[PHOTO_BASELINE_REIMPORTED_SIGNAL], 0, metadata);
#line 5629 "Photo.c"
}

void
photo_notify_baseline_reimported (Photo* self,
                                  PhotoMetadata* metadata)
{
	PhotoClass* _klass_;
#line 506 "../src/Photo.vala"
	g_return_if_fail (IS_PHOTO (self));
#line 506 "../src/Photo.vala"
	_klass_ = PHOTO_GET_CLASS (self);
#line 506 "../src/Photo.vala"
	if (_klass_->notify_baseline_reimported) {
#line 506 "../src/Photo.vala"
		_klass_->notify_baseline_reimported (self, metadata);
#line 5645 "Photo.c"
	}
}

static gboolean
photo_real_internal_delete_backing (DataSource* base,
                                    GError** error)
{
	Photo * self;
	gboolean ret = FALSE;
	GFile* file = NULL;
	GFile* _tmp10_;
	gboolean _tmp21_ = FALSE;
	gboolean _tmp22_ = FALSE;
	GError* _inner_error0_ = NULL;
	gboolean result;
#line 510 "../src/Photo.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (base, TYPE_PHOTO, Photo);
#line 511 "../src/Photo.vala"
	ret = TRUE;
#line 512 "../src/Photo.vala"
	file = NULL;
#line 5667 "Photo.c"
	{
		PhotoBackingReaders* _tmp0_;
#line 513 "../src/Photo.vala"
		_tmp0_ = self->priv->readers;
#line 513 "../src/Photo.vala"
		g_rec_mutex_lock (&self->priv->__lock_readers);
#line 5674 "Photo.c"
		{
			PhotoBackingReaders* _tmp1_;
			PhotoFileReader* _tmp2_;
#line 514 "../src/Photo.vala"
			_tmp1_ = self->priv->readers;
#line 514 "../src/Photo.vala"
			_tmp2_ = _tmp1_->editable;
#line 514 "../src/Photo.vala"
			if (_tmp2_ != NULL) {
#line 5684 "Photo.c"
				PhotoBackingReaders* _tmp3_;
				PhotoFileReader* _tmp4_;
				GFile* _tmp5_;
#line 515 "../src/Photo.vala"
				_tmp3_ = self->priv->readers;
#line 515 "../src/Photo.vala"
				_tmp4_ = _tmp3_->editable;
#line 515 "../src/Photo.vala"
				_tmp5_ = photo_file_adapter_get_file (G_TYPE_CHECK_INSTANCE_CAST (_tmp4_, TYPE_PHOTO_FILE_ADAPTER, PhotoFileAdapter));
#line 515 "../src/Photo.vala"
				_g_object_unref0 (file);
#line 515 "../src/Photo.vala"
				file = _tmp5_;
#line 5698 "Photo.c"
			}
		}
		__finally0:
		{
			PhotoBackingReaders* _tmp6_;
#line 513 "../src/Photo.vala"
			_tmp6_ = self->priv->readers;
#line 513 "../src/Photo.vala"
			g_rec_mutex_unlock (&self->priv->__lock_readers);
#line 5708 "Photo.c"
		}
#line 513 "../src/Photo.vala"
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 5712 "Photo.c"
			gboolean _tmp7_ = FALSE;
#line 513 "../src/Photo.vala"
			g_propagate_error (error, _inner_error0_);
#line 513 "../src/Photo.vala"
			_g_object_unref0 (file);
#line 513 "../src/Photo.vala"
			return _tmp7_;
#line 5720 "Photo.c"
		}
	}
#line 518 "../src/Photo.vala"
	photo_detach_editable (self, TRUE, FALSE, TRUE);
#line 520 "../src/Photo.vala"
	if (photo_get_master_file_format (self) == PHOTO_FILE_FORMAT_RAW) {
#line 5727 "Photo.c"
		gint _tmp8_ = 0;
		RawDeveloper* _tmp9_;
#line 521 "../src/Photo.vala"
		_tmp9_ = raw_developer_as_array (&_tmp8_);
#line 5732 "Photo.c"
		{
			RawDeveloper* d_collection = NULL;
			gint d_collection_length1 = 0;
			gint _d_collection_size_ = 0;
			gint d_it = 0;
#line 521 "../src/Photo.vala"
			d_collection = _tmp9_;
#line 521 "../src/Photo.vala"
			d_collection_length1 = _tmp8_;
#line 521 "../src/Photo.vala"
			for (d_it = 0; d_it < d_collection_length1; d_it = d_it + 1) {
#line 5744 "Photo.c"
				RawDeveloper d = 0;
#line 521 "../src/Photo.vala"
				d = d_collection[d_it];
#line 5748 "Photo.c"
				{
#line 522 "../src/Photo.vala"
					photo_delete_raw_development (self, d);
#line 5752 "Photo.c"
				}
			}
#line 521 "../src/Photo.vala"
			d_collection = (g_free (d_collection), NULL);
#line 5757 "Photo.c"
		}
	}
#line 526 "../src/Photo.vala"
	_tmp10_ = file;
#line 526 "../src/Photo.vala"
	if (_tmp10_ != NULL) {
#line 5764 "Photo.c"
		{
			gboolean _tmp11_ = FALSE;
			GFile* _tmp12_;
#line 528 "../src/Photo.vala"
			_tmp12_ = file;
#line 528 "../src/Photo.vala"
			_tmp11_ = g_file_trash (_tmp12_, NULL, &_inner_error0_);
#line 528 "../src/Photo.vala"
			if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 5774 "Photo.c"
				goto __catch1_g_error;
			}
#line 528 "../src/Photo.vala"
			ret = _tmp11_;
#line 5779 "Photo.c"
		}
		goto __finally1;
		__catch1_g_error:
		{
			GError* err = NULL;
			GFile* _tmp13_;
			gchar* _tmp14_;
			gchar* _tmp15_;
			gchar* _tmp16_;
			gchar* _tmp17_;
			GError* _tmp18_;
			const gchar* _tmp19_;
#line 527 "../src/Photo.vala"
			err = _inner_error0_;
#line 527 "../src/Photo.vala"
			_inner_error0_ = NULL;
#line 530 "../src/Photo.vala"
			ret = FALSE;
#line 531 "../src/Photo.vala"
			_tmp13_ = file;
#line 531 "../src/Photo.vala"
			_tmp14_ = g_file_get_path (_tmp13_);
#line 531 "../src/Photo.vala"
			_tmp15_ = _tmp14_;
#line 531 "../src/Photo.vala"
			_tmp16_ = data_object_to_string (G_TYPE_CHECK_INSTANCE_CAST (self, TYPE_DATA_OBJECT, DataObject));
#line 531 "../src/Photo.vala"
			_tmp17_ = _tmp16_;
#line 531 "../src/Photo.vala"
			_tmp18_ = err;
#line 531 "../src/Photo.vala"
			_tmp19_ = _tmp18_->message;
#line 531 "../src/Photo.vala"
			g_message ("Photo.vala:531: Unable to move editable %s for %s to trash: %s", _tmp15_, _tmp17_, _tmp19_);
#line 531 "../src/Photo.vala"
			_g_free0 (_tmp17_);
#line 531 "../src/Photo.vala"
			_g_free0 (_tmp15_);
#line 527 "../src/Photo.vala"
			_g_error_free0 (err);
#line 5820 "Photo.c"
		}
		__finally1:
#line 527 "../src/Photo.vala"
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 5825 "Photo.c"
			gboolean _tmp20_ = FALSE;
#line 527 "../src/Photo.vala"
			g_propagate_error (error, _inner_error0_);
#line 527 "../src/Photo.vala"
			_g_object_unref0 (file);
#line 527 "../src/Photo.vala"
			return _tmp20_;
#line 5833 "Photo.c"
		}
	}
#line 537 "../src/Photo.vala"
	_tmp22_ = DATA_SOURCE_CLASS (photo_parent_class)->internal_delete_backing (G_TYPE_CHECK_INSTANCE_CAST (G_TYPE_CHECK_INSTANCE_CAST (self, TYPE_PHOTO_SOURCE, PhotoSource), TYPE_DATA_SOURCE, DataSource), &_inner_error0_);
#line 537 "../src/Photo.vala"
	if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 5840 "Photo.c"
		gboolean _tmp23_ = FALSE;
#line 537 "../src/Photo.vala"
		g_propagate_error (error, _inner_error0_);
#line 537 "../src/Photo.vala"
		_g_object_unref0 (file);
#line 537 "../src/Photo.vala"
		return _tmp23_;
#line 5848 "Photo.c"
	}
#line 537 "../src/Photo.vala"
	if (_tmp22_) {
#line 537 "../src/Photo.vala"
		_tmp21_ = ret;
#line 5854 "Photo.c"
	} else {
#line 537 "../src/Photo.vala"
		_tmp21_ = FALSE;
#line 5858 "Photo.c"
	}
#line 537 "../src/Photo.vala"
	result = _tmp21_;
#line 537 "../src/Photo.vala"
	_g_object_unref0 (file);
#line 537 "../src/Photo.vala"
	return result;
#line 5866 "Photo.c"
}

static BackingPhotoRow*
photo_get_backing_row (Photo* self,
                       BackingPhotoID* id)
{
	BackingPhotoID _tmp0_;
	BackingPhotoRow* backing_row = NULL;
	BackingPhotoRow* _tmp12_;
	GError* _inner_error0_ = NULL;
	BackingPhotoRow* result;
#line 542 "../src/Photo.vala"
	g_return_val_if_fail (IS_PHOTO (self), NULL);
#line 542 "../src/Photo.vala"
	g_return_val_if_fail (id != NULL, NULL);
#line 543 "../src/Photo.vala"
	_tmp0_ = *id;
#line 543 "../src/Photo.vala"
	if (_tmp0_.id == BACKING_PHOTO_ID_INVALID) {
#line 544 "../src/Photo.vala"
		result = NULL;
#line 544 "../src/Photo.vala"
		return result;
#line 5890 "Photo.c"
	}
#line 546 "../src/Photo.vala"
	backing_row = NULL;
#line 5894 "Photo.c"
	{
		BackingPhotoRow* _tmp1_ = NULL;
		BackingPhotoTable* _tmp2_;
		BackingPhotoTable* _tmp3_;
		BackingPhotoID _tmp4_;
		BackingPhotoRow* _tmp5_;
		BackingPhotoRow* _tmp6_;
		BackingPhotoRow* _tmp7_;
#line 548 "../src/Photo.vala"
		_tmp2_ = backing_photo_table_get_instance ();
#line 548 "../src/Photo.vala"
		_tmp3_ = _tmp2_;
#line 548 "../src/Photo.vala"
		_tmp4_ = *id;
#line 548 "../src/Photo.vala"
		_tmp5_ = backing_photo_table_fetch (_tmp3_, &_tmp4_, &_inner_error0_);
#line 548 "../src/Photo.vala"
		_tmp6_ = _tmp5_;
#line 548 "../src/Photo.vala"
		_database_table_unref0 (_tmp3_);
#line 548 "../src/Photo.vala"
		_tmp1_ = _tmp6_;
#line 548 "../src/Photo.vala"
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 548 "../src/Photo.vala"
			if (_inner_error0_->domain == DATABASE_ERROR) {
#line 5921 "Photo.c"
				goto __catch0_database_error;
			}
#line 548 "../src/Photo.vala"
			_backing_photo_row_unref0 (backing_row);
#line 548 "../src/Photo.vala"
			g_critical ("file %s: line %d: unexpected error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 548 "../src/Photo.vala"
			g_clear_error (&_inner_error0_);
#line 548 "../src/Photo.vala"
			return NULL;
#line 5932 "Photo.c"
		}
#line 548 "../src/Photo.vala"
		_tmp7_ = _tmp1_;
#line 548 "../src/Photo.vala"
		_tmp1_ = NULL;
#line 548 "../src/Photo.vala"
		_backing_photo_row_unref0 (backing_row);
#line 548 "../src/Photo.vala"
		backing_row = _tmp7_;
#line 547 "../src/Photo.vala"
		_backing_photo_row_unref0 (_tmp1_);
#line 5944 "Photo.c"
	}
	goto __finally0;
	__catch0_database_error:
	{
		GError* err = NULL;
		gchar* _tmp8_;
		gchar* _tmp9_;
		GError* _tmp10_;
		const gchar* _tmp11_;
#line 547 "../src/Photo.vala"
		err = _inner_error0_;
#line 547 "../src/Photo.vala"
		_inner_error0_ = NULL;
#line 550 "../src/Photo.vala"
		_tmp8_ = data_object_to_string (G_TYPE_CHECK_INSTANCE_CAST (self, TYPE_DATA_OBJECT, DataObject));
#line 550 "../src/Photo.vala"
		_tmp9_ = _tmp8_;
#line 550 "../src/Photo.vala"
		_tmp10_ = err;
#line 550 "../src/Photo.vala"
		_tmp11_ = _tmp10_->message;
#line 550 "../src/Photo.vala"
		g_warning ("Photo.vala:550: Unable to fetch backing state for %s: %s", _tmp9_, _tmp11_);
#line 550 "../src/Photo.vala"
		_g_free0 (_tmp9_);
#line 547 "../src/Photo.vala"
		_g_error_free0 (err);
#line 5972 "Photo.c"
	}
	__finally0:
#line 547 "../src/Photo.vala"
	if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 547 "../src/Photo.vala"
		_backing_photo_row_unref0 (backing_row);
#line 547 "../src/Photo.vala"
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 547 "../src/Photo.vala"
		g_clear_error (&_inner_error0_);
#line 547 "../src/Photo.vala"
		return NULL;
#line 5985 "Photo.c"
	}
#line 553 "../src/Photo.vala"
	_tmp12_ = backing_row;
#line 553 "../src/Photo.vala"
	if (_tmp12_ == NULL) {
#line 5991 "Photo.c"
		{
			BackingPhotoTable* _tmp13_;
			BackingPhotoTable* _tmp14_;
			BackingPhotoID _tmp15_;
#line 555 "../src/Photo.vala"
			_tmp13_ = backing_photo_table_get_instance ();
#line 555 "../src/Photo.vala"
			_tmp14_ = _tmp13_;
#line 555 "../src/Photo.vala"
			_tmp15_ = *id;
#line 555 "../src/Photo.vala"
			backing_photo_table_remove (_tmp14_, &_tmp15_, &_inner_error0_);
#line 555 "../src/Photo.vala"
			_database_table_unref0 (_tmp14_);
#line 555 "../src/Photo.vala"
			if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 555 "../src/Photo.vala"
				if (_inner_error0_->domain == DATABASE_ERROR) {
#line 6010 "Photo.c"
					goto __catch1_database_error;
				}
#line 555 "../src/Photo.vala"
				_backing_photo_row_unref0 (backing_row);
#line 555 "../src/Photo.vala"
				g_critical ("file %s: line %d: unexpected error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 555 "../src/Photo.vala"
				g_clear_error (&_inner_error0_);
#line 555 "../src/Photo.vala"
				return NULL;
#line 6021 "Photo.c"
			}
		}
		goto __finally1;
		__catch1_database_error:
		{
#line 554 "../src/Photo.vala"
			g_clear_error (&_inner_error0_);
#line 6029 "Photo.c"
		}
		__finally1:
#line 554 "../src/Photo.vala"
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 554 "../src/Photo.vala"
			_backing_photo_row_unref0 (backing_row);
#line 554 "../src/Photo.vala"
			g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 554 "../src/Photo.vala"
			g_clear_error (&_inner_error0_);
#line 554 "../src/Photo.vala"
			return NULL;
#line 6042 "Photo.c"
		}
#line 559 "../src/Photo.vala"
		result = NULL;
#line 559 "../src/Photo.vala"
		_backing_photo_row_unref0 (backing_row);
#line 559 "../src/Photo.vala"
		return result;
#line 6050 "Photo.c"
	}
#line 562 "../src/Photo.vala"
	result = backing_row;
#line 562 "../src/Photo.vala"
	return result;
#line 6056 "Photo.c"
}

gboolean
photo_is_raw_developer_complete (Photo* self,
                                 RawDeveloper d)
{
	GError* _inner_error0_ = NULL;
	gboolean result;
#line 567 "../src/Photo.vala"
	g_return_val_if_fail (IS_PHOTO (self), FALSE);
#line 6067 "Photo.c"
	{
		GeeHashMap* _tmp0_;
		gboolean _tmp9_ = FALSE;
#line 568 "../src/Photo.vala"
		_tmp0_ = self->priv->developments;
#line 568 "../src/Photo.vala"
		g_rec_mutex_lock (&self->priv->__lock_developments);
#line 6075 "Photo.c"
		{
			gboolean _tmp1_ = FALSE;
			GeeHashMap* _tmp2_;
#line 569 "../src/Photo.vala"
			_tmp2_ = self->priv->developments;
#line 569 "../src/Photo.vala"
			if (gee_abstract_map_has_key (G_TYPE_CHECK_INSTANCE_CAST (_tmp2_, GEE_TYPE_ABSTRACT_MAP, GeeAbstractMap), (gpointer) ((gintptr) d))) {
#line 6083 "Photo.c"
				GeeHashMap* _tmp3_;
				gpointer _tmp4_;
				BackingPhotoRow* _tmp5_;
				const gchar* _tmp6_;
#line 570 "../src/Photo.vala"
				_tmp3_ = self->priv->developments;
#line 570 "../src/Photo.vala"
				_tmp4_ = gee_abstract_map_get (G_TYPE_CHECK_INSTANCE_CAST (_tmp3_, GEE_TYPE_ABSTRACT_MAP, GeeAbstractMap), (gpointer) ((gintptr) d));
#line 570 "../src/Photo.vala"
				_tmp5_ = (BackingPhotoRow*) _tmp4_;
#line 570 "../src/Photo.vala"
				_tmp6_ = _tmp5_->filepath;
#line 570 "../src/Photo.vala"
				_tmp1_ = g_file_test (_tmp6_, G_FILE_TEST_EXISTS);
#line 570 "../src/Photo.vala"
				_backing_photo_row_unref0 (_tmp5_);
#line 6100 "Photo.c"
			} else {
#line 569 "../src/Photo.vala"
				_tmp1_ = FALSE;
#line 6104 "Photo.c"
			}
#line 569 "../src/Photo.vala"
			result = _tmp1_;
#line 6108 "Photo.c"
			{
				GeeHashMap* _tmp7_;
#line 568 "../src/Photo.vala"
				_tmp7_ = self->priv->developments;
#line 568 "../src/Photo.vala"
				g_rec_mutex_unlock (&self->priv->__lock_developments);
#line 6115 "Photo.c"
			}
#line 569 "../src/Photo.vala"
			return result;
#line 6119 "Photo.c"
		}
		__finally0:
		{
			GeeHashMap* _tmp8_;
#line 568 "../src/Photo.vala"
			_tmp8_ = self->priv->developments;
#line 568 "../src/Photo.vala"
			g_rec_mutex_unlock (&self->priv->__lock_developments);
#line 6128 "Photo.c"
		}
#line 568 "../src/Photo.vala"
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 568 "../src/Photo.vala"
		g_clear_error (&_inner_error0_);
#line 568 "../src/Photo.vala"
		return _tmp9_;
#line 6136 "Photo.c"
	}
}

gboolean
photo_is_raw_developer_available (Photo* self,
                                  RawDeveloper d)
{
	GError* _inner_error0_ = NULL;
	gboolean result;
#line 575 "../src/Photo.vala"
	g_return_val_if_fail (IS_PHOTO (self), FALSE);
#line 6148 "Photo.c"
	{
		GeeHashMap* _tmp0_;
#line 576 "../src/Photo.vala"
		_tmp0_ = self->priv->developments;
#line 576 "../src/Photo.vala"
		g_rec_mutex_lock (&self->priv->__lock_developments);
#line 6155 "Photo.c"
		{
			GeeHashMap* _tmp1_;
#line 577 "../src/Photo.vala"
			_tmp1_ = self->priv->developments;
#line 577 "../src/Photo.vala"
			if (gee_abstract_map_has_key (G_TYPE_CHECK_INSTANCE_CAST (_tmp1_, GEE_TYPE_ABSTRACT_MAP, GeeAbstractMap), (gpointer) ((gintptr) d))) {
#line 578 "../src/Photo.vala"
				result = TRUE;
#line 6164 "Photo.c"
				{
					GeeHashMap* _tmp2_;
#line 576 "../src/Photo.vala"
					_tmp2_ = self->priv->developments;
#line 576 "../src/Photo.vala"
					g_rec_mutex_unlock (&self->priv->__lock_developments);
#line 6171 "Photo.c"
				}
#line 578 "../src/Photo.vala"
				return result;
#line 6175 "Photo.c"
			}
		}
		__finally0:
		{
			GeeHashMap* _tmp3_;
#line 576 "../src/Photo.vala"
			_tmp3_ = self->priv->developments;
#line 576 "../src/Photo.vala"
			g_rec_mutex_unlock (&self->priv->__lock_developments);
#line 6185 "Photo.c"
		}
#line 576 "../src/Photo.vala"
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 6189 "Photo.c"
			gboolean _tmp4_ = FALSE;
#line 576 "../src/Photo.vala"
			g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 576 "../src/Photo.vala"
			g_clear_error (&_inner_error0_);
#line 576 "../src/Photo.vala"
			return _tmp4_;
#line 6197 "Photo.c"
		}
	}
#line 581 "../src/Photo.vala"
	switch (d) {
#line 581 "../src/Photo.vala"
		case RAW_DEVELOPER_SHOTWELL:
#line 6204 "Photo.c"
		{
#line 583 "../src/Photo.vala"
			result = TRUE;
#line 583 "../src/Photo.vala"
			return result;
#line 6210 "Photo.c"
		}
#line 581 "../src/Photo.vala"
		case RAW_DEVELOPER_CAMERA:
#line 6214 "Photo.c"
		{
#line 586 "../src/Photo.vala"
			result = FALSE;
#line 586 "../src/Photo.vala"
			return result;
#line 6220 "Photo.c"
		}
#line 581 "../src/Photo.vala"
		case RAW_DEVELOPER_EMBEDDED:
#line 6224 "Photo.c"
		{
			{
				PhotoMetadata* meta = NULL;
				PhotoMetadata* _tmp5_;
				guint num_previews = 0U;
				PhotoMetadata* _tmp6_;
#line 590 "../src/Photo.vala"
				_tmp5_ = photo_get_master_metadata (self, &_inner_error0_);
#line 590 "../src/Photo.vala"
				meta = _tmp5_;
#line 590 "../src/Photo.vala"
				if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 6237 "Photo.c"
					goto __catch1_g_error;
				}
#line 591 "../src/Photo.vala"
				_tmp6_ = meta;
#line 591 "../src/Photo.vala"
				num_previews = photo_metadata_get_preview_count (_tmp6_);
#line 593 "../src/Photo.vala"
				if (num_previews > ((guint) 0)) {
#line 6246 "Photo.c"
					PhotoPreview* prev = NULL;
					PhotoMetadata* _tmp7_;
					PhotoPreview* _tmp8_;
					PhotoPreview* _tmp9_;
					Dimensions dims = {0};
					PhotoPreview* _tmp10_;
					Dimensions _tmp11_ = {0};
					gint _tmp12_ = 0;
					Dimensions _tmp13_;
					Dimensions _tmp14_;
					gint preview_major_axis = 0;
#line 594 "../src/Photo.vala"
					_tmp7_ = meta;
#line 594 "../src/Photo.vala"
					_tmp8_ = photo_metadata_get_preview (_tmp7_, num_previews - 1);
#line 594 "../src/Photo.vala"
					prev = _tmp8_;
#line 597 "../src/Photo.vala"
					_tmp9_ = prev;
#line 597 "../src/Photo.vala"
					if (_tmp9_ == NULL) {
#line 598 "../src/Photo.vala"
						result = FALSE;
#line 598 "../src/Photo.vala"
						_photo_preview_unref0 (prev);
#line 598 "../src/Photo.vala"
						_media_metadata_unref0 (meta);
#line 598 "../src/Photo.vala"
						return result;
#line 6276 "Photo.c"
					}
#line 600 "../src/Photo.vala"
					_tmp10_ = prev;
#line 600 "../src/Photo.vala"
					photo_preview_get_pixel_dimensions (_tmp10_, &_tmp11_);
#line 600 "../src/Photo.vala"
					dims = _tmp11_;
#line 603 "../src/Photo.vala"
					_tmp13_ = dims;
#line 603 "../src/Photo.vala"
					_tmp14_ = dims;
#line 603 "../src/Photo.vala"
					if (_tmp13_.width > _tmp14_.height) {
#line 6290 "Photo.c"
						Dimensions _tmp15_;
#line 603 "../src/Photo.vala"
						_tmp15_ = dims;
#line 603 "../src/Photo.vala"
						_tmp12_ = _tmp15_.width;
#line 6296 "Photo.c"
					} else {
						Dimensions _tmp16_;
#line 603 "../src/Photo.vala"
						_tmp16_ = dims;
#line 603 "../src/Photo.vala"
						_tmp12_ = _tmp16_.height;
#line 6303 "Photo.c"
					}
#line 603 "../src/Photo.vala"
					preview_major_axis = _tmp12_;
#line 604 "../src/Photo.vala"
					if (preview_major_axis < PHOTO_MIN_EMBEDDED_SIZE) {
#line 605 "../src/Photo.vala"
						result = FALSE;
#line 605 "../src/Photo.vala"
						_photo_preview_unref0 (prev);
#line 605 "../src/Photo.vala"
						_media_metadata_unref0 (meta);
#line 605 "../src/Photo.vala"
						return result;
#line 6317 "Photo.c"
					}
#line 608 "../src/Photo.vala"
					result = TRUE;
#line 608 "../src/Photo.vala"
					_photo_preview_unref0 (prev);
#line 608 "../src/Photo.vala"
					_media_metadata_unref0 (meta);
#line 608 "../src/Photo.vala"
					return result;
#line 6327 "Photo.c"
				}
#line 612 "../src/Photo.vala"
				result = FALSE;
#line 612 "../src/Photo.vala"
				_media_metadata_unref0 (meta);
#line 612 "../src/Photo.vala"
				return result;
#line 6335 "Photo.c"
			}
			goto __finally1;
			__catch1_g_error:
			{
				GError* e = NULL;
				GError* _tmp17_;
				const gchar* _tmp18_;
#line 589 "../src/Photo.vala"
				e = _inner_error0_;
#line 589 "../src/Photo.vala"
				_inner_error0_ = NULL;
#line 614 "../src/Photo.vala"
				_tmp17_ = e;
#line 614 "../src/Photo.vala"
				_tmp18_ = _tmp17_->message;
#line 614 "../src/Photo.vala"
				g_debug ("Photo.vala:614: Error accessing embedded preview. Message: %s", _tmp18_);
#line 589 "../src/Photo.vala"
				_g_error_free0 (e);
#line 6355 "Photo.c"
			}
			__finally1:
#line 589 "../src/Photo.vala"
			if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 6360 "Photo.c"
				gboolean _tmp19_ = FALSE;
#line 589 "../src/Photo.vala"
				g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 589 "../src/Photo.vala"
				g_clear_error (&_inner_error0_);
#line 589 "../src/Photo.vala"
				return _tmp19_;
#line 6368 "Photo.c"
			}
#line 616 "../src/Photo.vala"
			result = FALSE;
#line 616 "../src/Photo.vala"
			return result;
#line 6374 "Photo.c"
		}
		default:
		{
#line 619 "../src/Photo.vala"
			g_assert_not_reached ();
#line 6380 "Photo.c"
		}
	}
}

void
photo_add_backing_photo_for_development (Photo* self,
                                         RawDeveloper d,
                                         BackingPhotoRow* bpr,
                                         gboolean notify,
                                         GError** error)
{
	PhotoRow* _tmp0_;
	GError* _inner_error0_ = NULL;
#line 626 "../src/Photo.vala"
	g_return_if_fail (IS_PHOTO (self));
#line 626 "../src/Photo.vala"
	g_return_if_fail (IS_BACKING_PHOTO_ROW (bpr));
#line 627 "../src/Photo.vala"
	_tmp0_ = self->row;
#line 627 "../src/Photo.vala"
	photo_import_developed_backing_photo (_tmp0_, d, bpr, &_inner_error0_);
#line 627 "../src/Photo.vala"
	if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 627 "../src/Photo.vala"
		g_propagate_error (error, _inner_error0_);
#line 627 "../src/Photo.vala"
		return;
#line 6408 "Photo.c"
	}
	{
		GeeHashMap* _tmp1_;
#line 628 "../src/Photo.vala"
		_tmp1_ = self->priv->developments;
#line 628 "../src/Photo.vala"
		g_rec_mutex_lock (&self->priv->__lock_developments);
#line 6416 "Photo.c"
		{
			GeeHashMap* _tmp2_;
#line 629 "../src/Photo.vala"
			_tmp2_ = self->priv->developments;
#line 629 "../src/Photo.vala"
			gee_abstract_map_set (G_TYPE_CHECK_INSTANCE_CAST (_tmp2_, GEE_TYPE_ABSTRACT_MAP, GeeAbstractMap), (gpointer) ((gintptr) d), bpr);
#line 6423 "Photo.c"
		}
		__finally0:
		{
			GeeHashMap* _tmp3_;
#line 628 "../src/Photo.vala"
			_tmp3_ = self->priv->developments;
#line 628 "../src/Photo.vala"
			g_rec_mutex_unlock (&self->priv->__lock_developments);
#line 6432 "Photo.c"
		}
#line 628 "../src/Photo.vala"
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 628 "../src/Photo.vala"
			g_propagate_error (error, _inner_error0_);
#line 628 "../src/Photo.vala"
			return;
#line 6440 "Photo.c"
		}
	}
#line 632 "../src/Photo.vala"
	if (notify) {
#line 6445 "Photo.c"
		Alteration* _tmp4_;
		Alteration* _tmp5_;
#line 633 "../src/Photo.vala"
		_tmp4_ = alteration_new ("image", "developer");
#line 633 "../src/Photo.vala"
		_tmp5_ = _tmp4_;
#line 633 "../src/Photo.vala"
		data_object_notify_altered (G_TYPE_CHECK_INSTANCE_CAST (self, TYPE_DATA_OBJECT, DataObject), _tmp5_);
#line 633 "../src/Photo.vala"
		_alteration_unref0 (_tmp5_);
#line 6456 "Photo.c"
	}
}

void
photo_import_developed_backing_photo (PhotoRow* row,
                                      RawDeveloper d,
                                      BackingPhotoRow* bpr,
                                      GError** error)
{
	GFile* file = NULL;
	const gchar* _tmp0_;
	GFile* _tmp1_;
	GFileInfo* info = NULL;
	GFile* _tmp2_;
	GFileInfo* _tmp3_;
	GDateTime* timestamp = NULL;
	GFileInfo* _tmp4_;
	GDateTime* _tmp5_;
	GDateTime* _tmp6_;
	GDateTime* _tmp7_;
	GDateTime* _tmp8_;
	PhotoFileInterrogator* interrogator = NULL;
	GFile* _tmp9_;
	PhotoFileInterrogator* _tmp10_;
	PhotoFileInterrogator* _tmp11_;
	DetectedPhotoInformation* detected = NULL;
	PhotoFileInterrogator* _tmp12_;
	DetectedPhotoInformation* _tmp13_;
	gboolean _tmp14_ = FALSE;
	DetectedPhotoInformation* _tmp15_;
	DetectedPhotoInformation* _tmp17_;
	Dimensions _tmp18_;
	GFileInfo* _tmp19_;
	GDateTime* _tmp20_;
	GDateTime* _tmp21_;
	Orientation _tmp22_ = 0;
	DetectedPhotoInformation* _tmp23_;
	PhotoMetadata* _tmp24_;
	BackingPhotoTable* _tmp27_;
	BackingPhotoTable* _tmp28_;
	PhotoTable* _tmp29_;
	PhotoTable* _tmp30_;
	BackingPhotoID _tmp31_;
	GError* _inner_error0_ = NULL;
#line 636 "../src/Photo.vala"
	g_return_if_fail (IS_PHOTO_ROW (row));
#line 636 "../src/Photo.vala"
	g_return_if_fail (IS_BACKING_PHOTO_ROW (bpr));
#line 638 "../src/Photo.vala"
	_tmp0_ = bpr->filepath;
#line 638 "../src/Photo.vala"
	_tmp1_ = g_file_new_for_path (_tmp0_);
#line 638 "../src/Photo.vala"
	file = _tmp1_;
#line 639 "../src/Photo.vala"
	_tmp2_ = file;
#line 639 "../src/Photo.vala"
	_tmp3_ = g_file_query_info (_tmp2_, DIRECTORY_MONITOR_SUPPLIED_ATTRIBUTES, G_FILE_QUERY_INFO_NOFOLLOW_SYMLINKS, NULL, &_inner_error0_);
#line 639 "../src/Photo.vala"
	info = _tmp3_;
#line 639 "../src/Photo.vala"
	if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 639 "../src/Photo.vala"
		g_propagate_error (error, _inner_error0_);
#line 639 "../src/Photo.vala"
		_g_object_unref0 (file);
#line 639 "../src/Photo.vala"
		return;
#line 6525 "Photo.c"
	}
#line 641 "../src/Photo.vala"
	_tmp4_ = info;
#line 641 "../src/Photo.vala"
	_tmp5_ = g_file_info_get_modification_date_time (_tmp4_);
#line 641 "../src/Photo.vala"
	_tmp6_ = _tmp5_;
#line 641 "../src/Photo.vala"
	_tmp7_ = coarsify_date_time (_tmp6_);
#line 641 "../src/Photo.vala"
	_tmp8_ = _tmp7_;
#line 641 "../src/Photo.vala"
	_g_date_time_unref0 (_tmp6_);
#line 641 "../src/Photo.vala"
	timestamp = _tmp8_;
#line 643 "../src/Photo.vala"
	_tmp9_ = file;
#line 643 "../src/Photo.vala"
	_tmp10_ = photo_file_interrogator_new (_tmp9_, PHOTO_FILE_SNIFFER_OPTIONS_GET_ALL);
#line 643 "../src/Photo.vala"
	interrogator = _tmp10_;
#line 645 "../src/Photo.vala"
	_tmp11_ = interrogator;
#line 645 "../src/Photo.vala"
	photo_file_interrogator_interrogate (_tmp11_, &_inner_error0_);
#line 645 "../src/Photo.vala"
	if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 645 "../src/Photo.vala"
		g_propagate_error (error, _inner_error0_);
#line 645 "../src/Photo.vala"
		_photo_file_interrogator_unref0 (interrogator);
#line 645 "../src/Photo.vala"
		_g_date_time_unref0 (timestamp);
#line 645 "../src/Photo.vala"
		_g_object_unref0 (info);
#line 645 "../src/Photo.vala"
		_g_object_unref0 (file);
#line 645 "../src/Photo.vala"
		return;
#line 6565 "Photo.c"
	}
#line 647 "../src/Photo.vala"
	_tmp12_ = interrogator;
#line 647 "../src/Photo.vala"
	_tmp13_ = photo_file_interrogator_get_detected_photo_information (_tmp12_);
#line 647 "../src/Photo.vala"
	detected = _tmp13_;
#line 648 "../src/Photo.vala"
	_tmp15_ = detected;
#line 648 "../src/Photo.vala"
	if (_tmp15_ == NULL) {
#line 648 "../src/Photo.vala"
		_tmp14_ = TRUE;
#line 6579 "Photo.c"
	} else {
		PhotoFileInterrogator* _tmp16_;
#line 648 "../src/Photo.vala"
		_tmp16_ = interrogator;
#line 648 "../src/Photo.vala"
		_tmp14_ = photo_file_interrogator_get_is_photo_corrupted (_tmp16_);
#line 6586 "Photo.c"
	}
#line 648 "../src/Photo.vala"
	if (_tmp14_) {
#line 651 "../src/Photo.vala"
		_detected_photo_information_unref0 (detected);
#line 651 "../src/Photo.vala"
		_photo_file_interrogator_unref0 (interrogator);
#line 651 "../src/Photo.vala"
		_g_date_time_unref0 (timestamp);
#line 651 "../src/Photo.vala"
		_g_object_unref0 (info);
#line 651 "../src/Photo.vala"
		_g_object_unref0 (file);
#line 651 "../src/Photo.vala"
		return;
#line 6602 "Photo.c"
	}
#line 654 "../src/Photo.vala"
	_tmp17_ = detected;
#line 654 "../src/Photo.vala"
	_tmp18_ = _tmp17_->image_dim;
#line 654 "../src/Photo.vala"
	bpr->dim = _tmp18_;
#line 655 "../src/Photo.vala"
	_tmp19_ = info;
#line 655 "../src/Photo.vala"
	bpr->filesize = g_file_info_get_size (_tmp19_);
#line 656 "../src/Photo.vala"
	_tmp20_ = timestamp;
#line 656 "../src/Photo.vala"
	_tmp21_ = _g_date_time_ref0 (_tmp20_);
#line 656 "../src/Photo.vala"
	_g_date_time_unref0 (bpr->timestamp);
#line 656 "../src/Photo.vala"
	bpr->timestamp = _tmp21_;
#line 657 "../src/Photo.vala"
	_tmp23_ = detected;
#line 657 "../src/Photo.vala"
	_tmp24_ = _tmp23_->metadata;
#line 657 "../src/Photo.vala"
	if (_tmp24_ != NULL) {
#line 6628 "Photo.c"
		DetectedPhotoInformation* _tmp25_;
		PhotoMetadata* _tmp26_;
#line 657 "../src/Photo.vala"
		_tmp25_ = detected;
#line 657 "../src/Photo.vala"
		_tmp26_ = _tmp25_->metadata;
#line 657 "../src/Photo.vala"
		_tmp22_ = photo_metadata_get_orientation (_tmp26_);
#line 6637 "Photo.c"
	} else {
#line 658 "../src/Photo.vala"
		_tmp22_ = ORIENTATION_TOP_LEFT;
#line 6641 "Photo.c"
	}
#line 657 "../src/Photo.vala"
	bpr->original_orientation = _tmp22_;
#line 661 "../src/Photo.vala"
	_tmp27_ = backing_photo_table_get_instance ();
#line 661 "../src/Photo.vala"
	_tmp28_ = _tmp27_;
#line 661 "../src/Photo.vala"
	backing_photo_table_add (_tmp28_, bpr, &_inner_error0_);
#line 661 "../src/Photo.vala"
	_database_table_unref0 (_tmp28_);
#line 661 "../src/Photo.vala"
	if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 661 "../src/Photo.vala"
		g_propagate_error (error, _inner_error0_);
#line 661 "../src/Photo.vala"
		_detected_photo_information_unref0 (detected);
#line 661 "../src/Photo.vala"
		_photo_file_interrogator_unref0 (interrogator);
#line 661 "../src/Photo.vala"
		_g_date_time_unref0 (timestamp);
#line 661 "../src/Photo.vala"
		_g_object_unref0 (info);
#line 661 "../src/Photo.vala"
		_g_object_unref0 (file);
#line 661 "../src/Photo.vala"
		return;
#line 6669 "Photo.c"
	}
#line 662 "../src/Photo.vala"
	_tmp29_ = photo_table_get_instance ();
#line 662 "../src/Photo.vala"
	_tmp30_ = _tmp29_;
#line 662 "../src/Photo.vala"
	_tmp31_ = bpr->id;
#line 662 "../src/Photo.vala"
	photo_table_update_raw_development (_tmp30_, row, d, &_tmp31_, &_inner_error0_);
#line 662 "../src/Photo.vala"
	_database_table_unref0 (_tmp30_);
#line 662 "../src/Photo.vala"
	if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 662 "../src/Photo.vala"
		g_propagate_error (error, _inner_error0_);
#line 662 "../src/Photo.vala"
		_detected_photo_information_unref0 (detected);
#line 662 "../src/Photo.vala"
		_photo_file_interrogator_unref0 (interrogator);
#line 662 "../src/Photo.vala"
		_g_date_time_unref0 (timestamp);
#line 662 "../src/Photo.vala"
		_g_object_unref0 (info);
#line 662 "../src/Photo.vala"
		_g_object_unref0 (file);
#line 662 "../src/Photo.vala"
		return;
#line 6697 "Photo.c"
	}
#line 636 "../src/Photo.vala"
	_detected_photo_information_unref0 (detected);
#line 636 "../src/Photo.vala"
	_photo_file_interrogator_unref0 (interrogator);
#line 636 "../src/Photo.vala"
	_g_date_time_unref0 (timestamp);
#line 636 "../src/Photo.vala"
	_g_object_unref0 (info);
#line 636 "../src/Photo.vala"
	_g_object_unref0 (file);
#line 6709 "Photo.c"
}

static void
photo_develop_photo (Photo* self,
                     RawDeveloper d,
                     gboolean notify)
{
	gboolean wrote_img_to_disk = FALSE;
	BackingPhotoRow* bps = NULL;
	GError* _inner_error0_ = NULL;
#line 667 "../src/Photo.vala"
	g_return_if_fail (IS_PHOTO (self));
#line 668 "../src/Photo.vala"
	wrote_img_to_disk = FALSE;
#line 669 "../src/Photo.vala"
	bps = NULL;
#line 671 "../src/Photo.vala"
	switch (d) {
#line 671 "../src/Photo.vala"
		case RAW_DEVELOPER_SHOTWELL:
#line 6730 "Photo.c"
		{
			{
				BackingPhotoRow* _tmp0_ = NULL;
				PhotoRow* _tmp1_;
				BackingPhotoRow* _tmp2_;
				const gchar* _tmp3_;
				BackingPhotoRow* _tmp4_;
				BackingPhotoRow* _tmp5_;
				GdkPixbuf* pix = NULL;
				GdkPixbuf* _tmp13_;
				PhotoFileWriter* writer = NULL;
				BackingPhotoRow* _tmp17_;
				const gchar* _tmp18_;
				PhotoFileWriter* _tmp19_;
				PhotoFileWriter* _tmp20_;
				GdkPixbuf* _tmp21_;
				PhotoMetadata* meta = NULL;
				PhotoMetadata* _tmp22_;
				PhotoFileMetadataWriter* mwriter = NULL;
				BackingPhotoRow* _tmp23_;
				const gchar* _tmp24_;
				PhotoFileMetadataWriter* _tmp25_;
				PhotoFileMetadataWriter* _tmp26_;
				PhotoMetadata* _tmp27_;
#line 675 "../src/Photo.vala"
				_tmp1_ = self->row;
#line 675 "../src/Photo.vala"
				_tmp2_ = _tmp1_->master;
#line 675 "../src/Photo.vala"
				_tmp3_ = _tmp2_->filepath;
#line 675 "../src/Photo.vala"
				_tmp4_ = raw_developer_create_backing_row_for_development (d, _tmp3_, NULL, &_inner_error0_);
#line 675 "../src/Photo.vala"
				_tmp0_ = _tmp4_;
#line 675 "../src/Photo.vala"
				if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 6767 "Photo.c"
					goto __catch0_g_error;
				}
#line 675 "../src/Photo.vala"
				_tmp5_ = _tmp0_;
#line 675 "../src/Photo.vala"
				_tmp0_ = NULL;
#line 675 "../src/Photo.vala"
				_backing_photo_row_unref0 (bps);
#line 675 "../src/Photo.vala"
				bps = _tmp5_;
#line 676 "../src/Photo.vala"
				pix = NULL;
#line 6780 "Photo.c"
				{
					PhotoBackingReaders* _tmp6_;
#line 677 "../src/Photo.vala"
					_tmp6_ = self->priv->readers;
#line 677 "../src/Photo.vala"
					g_rec_mutex_lock (&self->priv->__lock_readers);
#line 6787 "Photo.c"
					{
						GdkPixbuf* _tmp7_ = NULL;
						Scaling _tmp8_ = {0};
						GdkPixbuf* _tmp9_;
						GdkPixbuf* _tmp10_;
#line 682 "../src/Photo.vala"
						scaling_for_original (&_tmp8_);
#line 682 "../src/Photo.vala"
						_tmp9_ = photo_get_master_pixbuf (self, &_tmp8_, FALSE, &_inner_error0_);
#line 682 "../src/Photo.vala"
						_tmp7_ = _tmp9_;
#line 682 "../src/Photo.vala"
						if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 6801 "Photo.c"
							goto __catch1_g_error;
						}
#line 682 "../src/Photo.vala"
						_tmp10_ = _tmp7_;
#line 682 "../src/Photo.vala"
						_tmp7_ = NULL;
#line 682 "../src/Photo.vala"
						_g_object_unref0 (pix);
#line 682 "../src/Photo.vala"
						pix = _tmp10_;
#line 677 "../src/Photo.vala"
						_g_object_unref0 (_tmp7_);
#line 6814 "Photo.c"
					}
					goto __finally1;
					__catch1_g_error:
					{
						GError* _lock_error_ = NULL;
						GError* _tmp11_;
#line 677 "../src/Photo.vala"
						_lock_error_ = _inner_error0_;
#line 677 "../src/Photo.vala"
						_inner_error0_ = NULL;
#line 677 "../src/Photo.vala"
						_tmp11_ = _lock_error_;
#line 677 "../src/Photo.vala"
						_lock_error_ = NULL;
#line 677 "../src/Photo.vala"
						_inner_error0_ = _tmp11_;
#line 677 "../src/Photo.vala"
						_g_error_free0 (_lock_error_);
#line 6833 "Photo.c"
						goto __finally1;
					}
					__finally1:
					{
						GError* _inner_error1_ = NULL;
						PhotoBackingReaders* _tmp12_;
#line 677 "../src/Photo.vala"
						_tmp12_ = self->priv->readers;
#line 677 "../src/Photo.vala"
						g_rec_mutex_unlock (&self->priv->__lock_readers);
#line 6844 "Photo.c"
					}
#line 677 "../src/Photo.vala"
					if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 677 "../src/Photo.vala"
						_g_object_unref0 (pix);
#line 677 "../src/Photo.vala"
						_backing_photo_row_unref0 (_tmp0_);
#line 6852 "Photo.c"
						goto __catch0_g_error;
					}
				}
#line 685 "../src/Photo.vala"
				_tmp13_ = pix;
#line 685 "../src/Photo.vala"
				if (_tmp13_ == NULL) {
#line 686 "../src/Photo.vala"
					g_debug ("Photo.vala:686: Could not get preview pixbuf");
#line 687 "../src/Photo.vala"
					_g_object_unref0 (pix);
#line 687 "../src/Photo.vala"
					_backing_photo_row_unref0 (_tmp0_);
#line 6866 "Photo.c"
					{
						GError* _inner_error0_ = NULL;
#line 711 "../src/Photo.vala"
						if (wrote_img_to_disk) {
#line 6871 "Photo.c"
							{
								BackingPhotoRow* _tmp14_;
#line 714 "../src/Photo.vala"
								_tmp14_ = bps;
#line 714 "../src/Photo.vala"
								photo_add_backing_photo_for_development (self, d, _tmp14_, notify, &_inner_error0_);
#line 714 "../src/Photo.vala"
								if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 6880 "Photo.c"
									goto __catch2_g_error;
								}
#line 716 "../src/Photo.vala"
								photo_notify_raw_development_modified (self);
#line 6885 "Photo.c"
							}
							goto __finally2;
							__catch2_g_error:
							{
								GError* e = NULL;
								GError* _tmp15_;
								const gchar* _tmp16_;
#line 712 "../src/Photo.vala"
								e = _inner_error0_;
#line 712 "../src/Photo.vala"
								_inner_error0_ = NULL;
#line 718 "../src/Photo.vala"
								_tmp15_ = e;
#line 718 "../src/Photo.vala"
								_tmp16_ = _tmp15_->message;
#line 718 "../src/Photo.vala"
								g_debug ("Photo.vala:718: Error adding backing photo as development. Message: %s", _tmp16_);
#line 712 "../src/Photo.vala"
								_g_error_free0 (e);
#line 6905 "Photo.c"
							}
							__finally2:
#line 712 "../src/Photo.vala"
							if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 6910 "Photo.c"
								goto __catch0_g_error;
							}
						}
					}
#line 687 "../src/Photo.vala"
					_backing_photo_row_unref0 (bps);
#line 687 "../src/Photo.vala"
					return;
#line 6919 "Photo.c"
				}
#line 691 "../src/Photo.vala"
				_tmp17_ = bps;
#line 691 "../src/Photo.vala"
				_tmp18_ = _tmp17_->filepath;
#line 691 "../src/Photo.vala"
				_tmp19_ = photo_file_format_create_writer (PHOTO_FILE_FORMAT_JFIF, _tmp18_, &_inner_error0_);
#line 691 "../src/Photo.vala"
				writer = _tmp19_;
#line 691 "../src/Photo.vala"
				if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 691 "../src/Photo.vala"
					_g_object_unref0 (pix);
#line 691 "../src/Photo.vala"
					_backing_photo_row_unref0 (_tmp0_);
#line 6935 "Photo.c"
					goto __catch0_g_error;
				}
#line 692 "../src/Photo.vala"
				_tmp20_ = writer;
#line 692 "../src/Photo.vala"
				_tmp21_ = pix;
#line 692 "../src/Photo.vala"
				photo_file_writer_write (_tmp20_, _tmp21_, JPEG_QUALITY_HIGH, &_inner_error0_);
#line 692 "../src/Photo.vala"
				if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 692 "../src/Photo.vala"
					_photo_file_adapter_unref0 (writer);
#line 692 "../src/Photo.vala"
					_g_object_unref0 (pix);
#line 692 "../src/Photo.vala"
					_backing_photo_row_unref0 (_tmp0_);
#line 6952 "Photo.c"
					goto __catch0_g_error;
				}
#line 700 "../src/Photo.vala"
				wrote_img_to_disk = TRUE;
#line 705 "../src/Photo.vala"
				_tmp22_ = photo_get_master_metadata (self, &_inner_error0_);
#line 705 "../src/Photo.vala"
				meta = _tmp22_;
#line 705 "../src/Photo.vala"
				if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 705 "../src/Photo.vala"
					_photo_file_adapter_unref0 (writer);
#line 705 "../src/Photo.vala"
					_g_object_unref0 (pix);
#line 705 "../src/Photo.vala"
					_backing_photo_row_unref0 (_tmp0_);
#line 6969 "Photo.c"
					goto __catch0_g_error;
				}
#line 706 "../src/Photo.vala"
				_tmp23_ = bps;
#line 706 "../src/Photo.vala"
				_tmp24_ = _tmp23_->filepath;
#line 706 "../src/Photo.vala"
				_tmp25_ = photo_file_format_create_metadata_writer (PHOTO_FILE_FORMAT_JFIF, _tmp24_, &_inner_error0_);
#line 706 "../src/Photo.vala"
				mwriter = _tmp25_;
#line 706 "../src/Photo.vala"
				if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 706 "../src/Photo.vala"
					_media_metadata_unref0 (meta);
#line 706 "../src/Photo.vala"
					_photo_file_adapter_unref0 (writer);
#line 706 "../src/Photo.vala"
					_g_object_unref0 (pix);
#line 706 "../src/Photo.vala"
					_backing_photo_row_unref0 (_tmp0_);
#line 6990 "Photo.c"
					goto __catch0_g_error;
				}
#line 707 "../src/Photo.vala"
				_tmp26_ = mwriter;
#line 707 "../src/Photo.vala"
				_tmp27_ = meta;
#line 707 "../src/Photo.vala"
				photo_file_metadata_writer_write_metadata (_tmp26_, _tmp27_, &_inner_error0_);
#line 707 "../src/Photo.vala"
				if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 707 "../src/Photo.vala"
					_photo_file_adapter_unref0 (mwriter);
#line 707 "../src/Photo.vala"
					_media_metadata_unref0 (meta);
#line 707 "../src/Photo.vala"
					_photo_file_adapter_unref0 (writer);
#line 707 "../src/Photo.vala"
					_g_object_unref0 (pix);
#line 707 "../src/Photo.vala"
					_backing_photo_row_unref0 (_tmp0_);
#line 7011 "Photo.c"
					goto __catch0_g_error;
				}
#line 673 "../src/Photo.vala"
				_photo_file_adapter_unref0 (mwriter);
#line 673 "../src/Photo.vala"
				_media_metadata_unref0 (meta);
#line 673 "../src/Photo.vala"
				_photo_file_adapter_unref0 (writer);
#line 673 "../src/Photo.vala"
				_g_object_unref0 (pix);
#line 673 "../src/Photo.vala"
				_backing_photo_row_unref0 (_tmp0_);
#line 7024 "Photo.c"
			}
			goto __finally0;
			__catch0_g_error:
			{
				GError* err = NULL;
				GError* _tmp28_;
				const gchar* _tmp29_;
#line 673 "../src/Photo.vala"
				err = _inner_error0_;
#line 673 "../src/Photo.vala"
				_inner_error0_ = NULL;
#line 709 "../src/Photo.vala"
				_tmp28_ = err;
#line 709 "../src/Photo.vala"
				_tmp29_ = _tmp28_->message;
#line 709 "../src/Photo.vala"
				g_debug ("Photo.vala:709: Error developing photo: %s", _tmp29_);
#line 673 "../src/Photo.vala"
				_g_error_free0 (err);
#line 7044 "Photo.c"
			}
			__finally0:
			{
				GError* _inner_error1_ = NULL;
#line 711 "../src/Photo.vala"
				if (wrote_img_to_disk) {
#line 7051 "Photo.c"
					{
						BackingPhotoRow* _tmp30_;
#line 714 "../src/Photo.vala"
						_tmp30_ = bps;
#line 714 "../src/Photo.vala"
						photo_add_backing_photo_for_development (self, d, _tmp30_, notify, &_inner_error1_);
#line 714 "../src/Photo.vala"
						if (G_UNLIKELY (_inner_error1_ != NULL)) {
#line 7060 "Photo.c"
							goto __catch3_g_error;
						}
#line 716 "../src/Photo.vala"
						photo_notify_raw_development_modified (self);
#line 7065 "Photo.c"
					}
					goto __finally3;
					__catch3_g_error:
					{
						GError* e = NULL;
						GError* _tmp31_;
						const gchar* _tmp32_;
#line 712 "../src/Photo.vala"
						e = _inner_error1_;
#line 712 "../src/Photo.vala"
						_inner_error1_ = NULL;
#line 718 "../src/Photo.vala"
						_tmp31_ = e;
#line 718 "../src/Photo.vala"
						_tmp32_ = _tmp31_->message;
#line 718 "../src/Photo.vala"
						g_debug ("Photo.vala:718: Error adding backing photo as development. Message: %s", _tmp32_);
#line 712 "../src/Photo.vala"
						_g_error_free0 (e);
#line 7085 "Photo.c"
					}
					__finally3:
#line 712 "../src/Photo.vala"
					if (G_UNLIKELY (_inner_error1_ != NULL)) {
#line 712 "../src/Photo.vala"
						_backing_photo_row_unref0 (bps);
#line 712 "../src/Photo.vala"
						g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error1_->message, g_quark_to_string (_inner_error1_->domain), _inner_error1_->code);
#line 712 "../src/Photo.vala"
						g_clear_error (&_inner_error1_);
#line 712 "../src/Photo.vala"
						return;
#line 7098 "Photo.c"
					}
				}
			}
#line 673 "../src/Photo.vala"
			if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 673 "../src/Photo.vala"
				_backing_photo_row_unref0 (bps);
#line 673 "../src/Photo.vala"
				g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 673 "../src/Photo.vala"
				g_clear_error (&_inner_error0_);
#line 673 "../src/Photo.vala"
				return;
#line 7112 "Photo.c"
			}
#line 724 "../src/Photo.vala"
			break;
#line 7116 "Photo.c"
		}
#line 671 "../src/Photo.vala"
		case RAW_DEVELOPER_CAMERA:
#line 7120 "Photo.c"
		{
#line 728 "../src/Photo.vala"
			break;
#line 7124 "Photo.c"
		}
#line 671 "../src/Photo.vala"
		case RAW_DEVELOPER_EMBEDDED:
#line 7128 "Photo.c"
		{
			{
				PhotoMetadata* meta = NULL;
				PhotoMetadata* _tmp33_;
				guint c = 0U;
				PhotoMetadata* _tmp34_;
				PhotoPreview* prev = NULL;
				PhotoMetadata* _tmp38_;
				PhotoPreview* _tmp39_;
				PhotoPreview* _tmp40_;
				GBytes* pix = NULL;
				PhotoPreview* _tmp44_;
				GBytes* _tmp45_;
				GBytes* _tmp46_;
				BackingPhotoRow* _tmp50_ = NULL;
				PhotoRow* _tmp51_;
				BackingPhotoRow* _tmp52_;
				const gchar* _tmp53_;
				BackingPhotoRow* _tmp54_;
				BackingPhotoRow* _tmp55_;
				gboolean _tmp56_ = FALSE;
				GBytes* _tmp57_;
				PhotoFileMetadataWriter* mwriter = NULL;
				BackingPhotoRow* _tmp76_;
				const gchar* _tmp77_;
				PhotoFileMetadataWriter* _tmp78_;
				PhotoFileMetadataWriter* _tmp79_;
				PhotoMetadata* _tmp80_;
#line 733 "../src/Photo.vala"
				_tmp33_ = photo_get_master_metadata (self, &_inner_error0_);
#line 733 "../src/Photo.vala"
				meta = _tmp33_;
#line 733 "../src/Photo.vala"
				if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 7163 "Photo.c"
					goto __catch4_g_error;
				}
#line 734 "../src/Photo.vala"
				_tmp34_ = meta;
#line 734 "../src/Photo.vala"
				c = photo_metadata_get_preview_count (_tmp34_);
#line 735 "../src/Photo.vala"
				if (c <= ((guint) 0)) {
#line 736 "../src/Photo.vala"
					_media_metadata_unref0 (meta);
#line 7174 "Photo.c"
					{
						GError* _inner_error0_ = NULL;
#line 781 "../src/Photo.vala"
						if (wrote_img_to_disk) {
#line 7179 "Photo.c"
							{
								BackingPhotoRow* _tmp35_;
#line 784 "../src/Photo.vala"
								_tmp35_ = bps;
#line 784 "../src/Photo.vala"
								photo_add_backing_photo_for_development (self, d, _tmp35_, notify, &_inner_error0_);
#line 784 "../src/Photo.vala"
								if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 7188 "Photo.c"
									goto __catch5_g_error;
								}
#line 786 "../src/Photo.vala"
								photo_notify_raw_development_modified (self);
#line 7193 "Photo.c"
							}
							goto __finally5;
							__catch5_g_error:
							{
								GError* e = NULL;
								GError* _tmp36_;
								const gchar* _tmp37_;
#line 782 "../src/Photo.vala"
								e = _inner_error0_;
#line 782 "../src/Photo.vala"
								_inner_error0_ = NULL;
#line 788 "../src/Photo.vala"
								_tmp36_ = e;
#line 788 "../src/Photo.vala"
								_tmp37_ = _tmp36_->message;
#line 788 "../src/Photo.vala"
								g_debug ("Photo.vala:788: Error adding backing photo as development. Message: %s", _tmp37_);
#line 782 "../src/Photo.vala"
								_g_error_free0 (e);
#line 7213 "Photo.c"
							}
							__finally5:
#line 782 "../src/Photo.vala"
							if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 7218 "Photo.c"
								goto __catch4_g_error;
							}
						}
					}
#line 736 "../src/Photo.vala"
					_backing_photo_row_unref0 (bps);
#line 736 "../src/Photo.vala"
					return;
#line 7227 "Photo.c"
				}
#line 737 "../src/Photo.vala"
				_tmp38_ = meta;
#line 737 "../src/Photo.vala"
				_tmp39_ = photo_metadata_get_preview (_tmp38_, c - 1);
#line 737 "../src/Photo.vala"
				prev = _tmp39_;
#line 738 "../src/Photo.vala"
				_tmp40_ = prev;
#line 738 "../src/Photo.vala"
				if (_tmp40_ == NULL) {
#line 739 "../src/Photo.vala"
					g_debug ("Photo.vala:739: Could not get preview from metadata");
#line 740 "../src/Photo.vala"
					_photo_preview_unref0 (prev);
#line 740 "../src/Photo.vala"
					_media_metadata_unref0 (meta);
#line 7245 "Photo.c"
					{
						GError* _inner_error0_ = NULL;
#line 781 "../src/Photo.vala"
						if (wrote_img_to_disk) {
#line 7250 "Photo.c"
							{
								BackingPhotoRow* _tmp41_;
#line 784 "../src/Photo.vala"
								_tmp41_ = bps;
#line 784 "../src/Photo.vala"
								photo_add_backing_photo_for_development (self, d, _tmp41_, notify, &_inner_error0_);
#line 784 "../src/Photo.vala"
								if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 7259 "Photo.c"
									goto __catch6_g_error;
								}
#line 786 "../src/Photo.vala"
								photo_notify_raw_development_modified (self);
#line 7264 "Photo.c"
							}
							goto __finally6;
							__catch6_g_error:
							{
								GError* e = NULL;
								GError* _tmp42_;
								const gchar* _tmp43_;
#line 782 "../src/Photo.vala"
								e = _inner_error0_;
#line 782 "../src/Photo.vala"
								_inner_error0_ = NULL;
#line 788 "../src/Photo.vala"
								_tmp42_ = e;
#line 788 "../src/Photo.vala"
								_tmp43_ = _tmp42_->message;
#line 788 "../src/Photo.vala"
								g_debug ("Photo.vala:788: Error adding backing photo as development. Message: %s", _tmp43_);
#line 782 "../src/Photo.vala"
								_g_error_free0 (e);
#line 7284 "Photo.c"
							}
							__finally6:
#line 782 "../src/Photo.vala"
							if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 7289 "Photo.c"
								goto __catch4_g_error;
							}
						}
					}
#line 740 "../src/Photo.vala"
					_backing_photo_row_unref0 (bps);
#line 740 "../src/Photo.vala"
					return;
#line 7298 "Photo.c"
				}
#line 743 "../src/Photo.vala"
				_tmp44_ = prev;
#line 743 "../src/Photo.vala"
				_tmp45_ = photo_preview_flatten (_tmp44_, &_inner_error0_);
#line 743 "../src/Photo.vala"
				pix = _tmp45_;
#line 743 "../src/Photo.vala"
				if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 743 "../src/Photo.vala"
					_photo_preview_unref0 (prev);
#line 743 "../src/Photo.vala"
					_media_metadata_unref0 (meta);
#line 7312 "Photo.c"
					goto __catch4_g_error;
				}
#line 744 "../src/Photo.vala"
				_tmp46_ = pix;
#line 744 "../src/Photo.vala"
				if (_tmp46_ == NULL) {
#line 745 "../src/Photo.vala"
					g_debug ("Photo.vala:745: Could not get preview pixbuf");
#line 746 "../src/Photo.vala"
					_g_bytes_unref0 (pix);
#line 746 "../src/Photo.vala"
					_photo_preview_unref0 (prev);
#line 746 "../src/Photo.vala"
					_media_metadata_unref0 (meta);
#line 7327 "Photo.c"
					{
						GError* _inner_error0_ = NULL;
#line 781 "../src/Photo.vala"
						if (wrote_img_to_disk) {
#line 7332 "Photo.c"
							{
								BackingPhotoRow* _tmp47_;
#line 784 "../src/Photo.vala"
								_tmp47_ = bps;
#line 784 "../src/Photo.vala"
								photo_add_backing_photo_for_development (self, d, _tmp47_, notify, &_inner_error0_);
#line 784 "../src/Photo.vala"
								if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 7341 "Photo.c"
									goto __catch7_g_error;
								}
#line 786 "../src/Photo.vala"
								photo_notify_raw_development_modified (self);
#line 7346 "Photo.c"
							}
							goto __finally7;
							__catch7_g_error:
							{
								GError* e = NULL;
								GError* _tmp48_;
								const gchar* _tmp49_;
#line 782 "../src/Photo.vala"
								e = _inner_error0_;
#line 782 "../src/Photo.vala"
								_inner_error0_ = NULL;
#line 788 "../src/Photo.vala"
								_tmp48_ = e;
#line 788 "../src/Photo.vala"
								_tmp49_ = _tmp48_->message;
#line 788 "../src/Photo.vala"
								g_debug ("Photo.vala:788: Error adding backing photo as development. Message: %s", _tmp49_);
#line 782 "../src/Photo.vala"
								_g_error_free0 (e);
#line 7366 "Photo.c"
							}
							__finally7:
#line 782 "../src/Photo.vala"
							if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 7371 "Photo.c"
								goto __catch4_g_error;
							}
						}
					}
#line 746 "../src/Photo.vala"
					_backing_photo_row_unref0 (bps);
#line 746 "../src/Photo.vala"
					return;
#line 7380 "Photo.c"
				}
#line 750 "../src/Photo.vala"
				_tmp51_ = self->row;
#line 750 "../src/Photo.vala"
				_tmp52_ = _tmp51_->master;
#line 750 "../src/Photo.vala"
				_tmp53_ = _tmp52_->filepath;
#line 750 "../src/Photo.vala"
				_tmp54_ = raw_developer_create_backing_row_for_development (d, _tmp53_, NULL, &_inner_error0_);
#line 750 "../src/Photo.vala"
				_tmp50_ = _tmp54_;
#line 750 "../src/Photo.vala"
				if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 750 "../src/Photo.vala"
					_g_bytes_unref0 (pix);
#line 750 "../src/Photo.vala"
					_photo_preview_unref0 (prev);
#line 750 "../src/Photo.vala"
					_media_metadata_unref0 (meta);
#line 7400 "Photo.c"
					goto __catch4_g_error;
				}
#line 750 "../src/Photo.vala"
				_tmp55_ = _tmp50_;
#line 750 "../src/Photo.vala"
				_tmp50_ = NULL;
#line 750 "../src/Photo.vala"
				_backing_photo_row_unref0 (bps);
#line 750 "../src/Photo.vala"
				bps = _tmp55_;
#line 754 "../src/Photo.vala"
				_tmp57_ = pix;
#line 754 "../src/Photo.vala"
				_tmp56_ = jpeg_is_jpeg_bytes (_tmp57_, &_inner_error0_);
#line 754 "../src/Photo.vala"
				if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 754 "../src/Photo.vala"
					_backing_photo_row_unref0 (_tmp50_);
#line 754 "../src/Photo.vala"
					_g_bytes_unref0 (pix);
#line 754 "../src/Photo.vala"
					_photo_preview_unref0 (prev);
#line 754 "../src/Photo.vala"
					_media_metadata_unref0 (meta);
#line 7425 "Photo.c"
					goto __catch4_g_error;
				}
#line 754 "../src/Photo.vala"
				if (_tmp56_) {
#line 7430 "Photo.c"
					GFile* outfile = NULL;
					BackingPhotoRow* _tmp58_;
					const gchar* _tmp59_;
					GFile* _tmp60_;
					GFile* _tmp61_;
					GBytes* _tmp62_;
					gsize _tmp63_ = 0;
					guint8* _tmp64_;
#line 755 "../src/Photo.vala"
					_tmp58_ = bps;
#line 755 "../src/Photo.vala"
					_tmp59_ = _tmp58_->filepath;
#line 755 "../src/Photo.vala"
					_tmp60_ = g_file_new_for_path (_tmp59_);
#line 755 "../src/Photo.vala"
					outfile = _tmp60_;
#line 756 "../src/Photo.vala"
					_tmp61_ = outfile;
#line 756 "../src/Photo.vala"
					_tmp62_ = pix;
#line 756 "../src/Photo.vala"
					_tmp64_ = g_bytes_get_data (_tmp62_, &_tmp63_);
#line 756 "../src/Photo.vala"
					g_file_replace_contents (_tmp61_, (const char*) _tmp64_, (gsize) _tmp63_, NULL, FALSE, G_FILE_CREATE_NONE, NULL, NULL, &_inner_error0_);
#line 756 "../src/Photo.vala"
					if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 756 "../src/Photo.vala"
						_g_object_unref0 (outfile);
#line 756 "../src/Photo.vala"
						_backing_photo_row_unref0 (_tmp50_);
#line 756 "../src/Photo.vala"
						_g_bytes_unref0 (pix);
#line 756 "../src/Photo.vala"
						_photo_preview_unref0 (prev);
#line 756 "../src/Photo.vala"
						_media_metadata_unref0 (meta);
#line 7467 "Photo.c"
						goto __catch4_g_error;
					}
#line 754 "../src/Photo.vala"
					_g_object_unref0 (outfile);
#line 7472 "Photo.c"
				} else {
					GdkPixbuf* pixbuf = NULL;
					PhotoPreview* _tmp65_;
					GdkPixbuf* _tmp66_;
					GdkPixbuf* _tmp67_;
					PhotoFileWriter* writer = NULL;
					BackingPhotoRow* _tmp71_;
					const gchar* _tmp72_;
					PhotoFileWriter* _tmp73_;
					PhotoFileWriter* _tmp74_;
					GdkPixbuf* _tmp75_;
#line 759 "../src/Photo.vala"
					_tmp65_ = prev;
#line 759 "../src/Photo.vala"
					_tmp66_ = photo_preview_get_pixbuf (_tmp65_, &_inner_error0_);
#line 759 "../src/Photo.vala"
					pixbuf = _tmp66_;
#line 759 "../src/Photo.vala"
					if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 759 "../src/Photo.vala"
						_backing_photo_row_unref0 (_tmp50_);
#line 759 "../src/Photo.vala"
						_g_bytes_unref0 (pix);
#line 759 "../src/Photo.vala"
						_photo_preview_unref0 (prev);
#line 759 "../src/Photo.vala"
						_media_metadata_unref0 (meta);
#line 7500 "Photo.c"
						goto __catch4_g_error;
					}
#line 760 "../src/Photo.vala"
					_tmp67_ = pixbuf;
#line 760 "../src/Photo.vala"
					if (_tmp67_ == NULL) {
#line 761 "../src/Photo.vala"
						g_debug ("Photo.vala:761: Could not get preview pixbuf");
#line 762 "../src/Photo.vala"
						_g_object_unref0 (pixbuf);
#line 762 "../src/Photo.vala"
						_backing_photo_row_unref0 (_tmp50_);
#line 762 "../src/Photo.vala"
						_g_bytes_unref0 (pix);
#line 762 "../src/Photo.vala"
						_photo_preview_unref0 (prev);
#line 762 "../src/Photo.vala"
						_media_metadata_unref0 (meta);
#line 7519 "Photo.c"
						{
							GError* _inner_error0_ = NULL;
#line 781 "../src/Photo.vala"
							if (wrote_img_to_disk) {
#line 7524 "Photo.c"
								{
									BackingPhotoRow* _tmp68_;
#line 784 "../src/Photo.vala"
									_tmp68_ = bps;
#line 784 "../src/Photo.vala"
									photo_add_backing_photo_for_development (self, d, _tmp68_, notify, &_inner_error0_);
#line 784 "../src/Photo.vala"
									if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 7533 "Photo.c"
										goto __catch8_g_error;
									}
#line 786 "../src/Photo.vala"
									photo_notify_raw_development_modified (self);
#line 7538 "Photo.c"
								}
								goto __finally8;
								__catch8_g_error:
								{
									GError* e = NULL;
									GError* _tmp69_;
									const gchar* _tmp70_;
#line 782 "../src/Photo.vala"
									e = _inner_error0_;
#line 782 "../src/Photo.vala"
									_inner_error0_ = NULL;
#line 788 "../src/Photo.vala"
									_tmp69_ = e;
#line 788 "../src/Photo.vala"
									_tmp70_ = _tmp69_->message;
#line 788 "../src/Photo.vala"
									g_debug ("Photo.vala:788: Error adding backing photo as development. Message: %s", _tmp70_);
#line 782 "../src/Photo.vala"
									_g_error_free0 (e);
#line 7558 "Photo.c"
								}
								__finally8:
#line 782 "../src/Photo.vala"
								if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 7563 "Photo.c"
									goto __catch4_g_error;
								}
							}
						}
#line 762 "../src/Photo.vala"
						_backing_photo_row_unref0 (bps);
#line 762 "../src/Photo.vala"
						return;
#line 7572 "Photo.c"
					}
#line 765 "../src/Photo.vala"
					_tmp71_ = bps;
#line 765 "../src/Photo.vala"
					_tmp72_ = _tmp71_->filepath;
#line 765 "../src/Photo.vala"
					_tmp73_ = photo_file_format_create_writer (PHOTO_FILE_FORMAT_JFIF, _tmp72_, &_inner_error0_);
#line 765 "../src/Photo.vala"
					writer = _tmp73_;
#line 765 "../src/Photo.vala"
					if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 765 "../src/Photo.vala"
						_g_object_unref0 (pixbuf);
#line 765 "../src/Photo.vala"
						_backing_photo_row_unref0 (_tmp50_);
#line 765 "../src/Photo.vala"
						_g_bytes_unref0 (pix);
#line 765 "../src/Photo.vala"
						_photo_preview_unref0 (prev);
#line 765 "../src/Photo.vala"
						_media_metadata_unref0 (meta);
#line 7594 "Photo.c"
						goto __catch4_g_error;
					}
#line 766 "../src/Photo.vala"
					_tmp74_ = writer;
#line 766 "../src/Photo.vala"
					_tmp75_ = pixbuf;
#line 766 "../src/Photo.vala"
					photo_file_writer_write (_tmp74_, _tmp75_, JPEG_QUALITY_HIGH, &_inner_error0_);
#line 766 "../src/Photo.vala"
					if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 766 "../src/Photo.vala"
						_photo_file_adapter_unref0 (writer);
#line 766 "../src/Photo.vala"
						_g_object_unref0 (pixbuf);
#line 766 "../src/Photo.vala"
						_backing_photo_row_unref0 (_tmp50_);
#line 766 "../src/Photo.vala"
						_g_bytes_unref0 (pix);
#line 766 "../src/Photo.vala"
						_photo_preview_unref0 (prev);
#line 766 "../src/Photo.vala"
						_media_metadata_unref0 (meta);
#line 7617 "Photo.c"
						goto __catch4_g_error;
					}
#line 754 "../src/Photo.vala"
					_photo_file_adapter_unref0 (writer);
#line 754 "../src/Photo.vala"
					_g_object_unref0 (pixbuf);
#line 7624 "Photo.c"
				}
#line 772 "../src/Photo.vala"
				wrote_img_to_disk = TRUE;
#line 775 "../src/Photo.vala"
				_tmp76_ = bps;
#line 775 "../src/Photo.vala"
				_tmp77_ = _tmp76_->filepath;
#line 775 "../src/Photo.vala"
				_tmp78_ = photo_file_format_create_metadata_writer (PHOTO_FILE_FORMAT_JFIF, _tmp77_, &_inner_error0_);
#line 775 "../src/Photo.vala"
				mwriter = _tmp78_;
#line 775 "../src/Photo.vala"
				if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 775 "../src/Photo.vala"
					_backing_photo_row_unref0 (_tmp50_);
#line 775 "../src/Photo.vala"
					_g_bytes_unref0 (pix);
#line 775 "../src/Photo.vala"
					_photo_preview_unref0 (prev);
#line 775 "../src/Photo.vala"
					_media_metadata_unref0 (meta);
#line 7646 "Photo.c"
					goto __catch4_g_error;
				}
#line 776 "../src/Photo.vala"
				_tmp79_ = mwriter;
#line 776 "../src/Photo.vala"
				_tmp80_ = meta;
#line 776 "../src/Photo.vala"
				photo_file_metadata_writer_write_metadata (_tmp79_, _tmp80_, &_inner_error0_);
#line 776 "../src/Photo.vala"
				if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 776 "../src/Photo.vala"
					_photo_file_adapter_unref0 (mwriter);
#line 776 "../src/Photo.vala"
					_backing_photo_row_unref0 (_tmp50_);
#line 776 "../src/Photo.vala"
					_g_bytes_unref0 (pix);
#line 776 "../src/Photo.vala"
					_photo_preview_unref0 (prev);
#line 776 "../src/Photo.vala"
					_media_metadata_unref0 (meta);
#line 7667 "Photo.c"
					goto __catch4_g_error;
				}
#line 731 "../src/Photo.vala"
				_photo_file_adapter_unref0 (mwriter);
#line 731 "../src/Photo.vala"
				_backing_photo_row_unref0 (_tmp50_);
#line 731 "../src/Photo.vala"
				_g_bytes_unref0 (pix);
#line 731 "../src/Photo.vala"
				_photo_preview_unref0 (prev);
#line 731 "../src/Photo.vala"
				_media_metadata_unref0 (meta);
#line 7680 "Photo.c"
			}
			goto __finally4;
			__catch4_g_error:
			{
				GError* e = NULL;
				GError* _tmp81_;
				const gchar* _tmp82_;
#line 731 "../src/Photo.vala"
				e = _inner_error0_;
#line 731 "../src/Photo.vala"
				_inner_error0_ = NULL;
#line 778 "../src/Photo.vala"
				_tmp81_ = e;
#line 778 "../src/Photo.vala"
				_tmp82_ = _tmp81_->message;
#line 778 "../src/Photo.vala"
				g_debug ("Photo.vala:778: Error accessing embedded preview. Message: %s", _tmp82_);
#line 779 "../src/Photo.vala"
				_g_error_free0 (e);
#line 7700 "Photo.c"
				{
					GError* _inner_error0_ = NULL;
#line 781 "../src/Photo.vala"
					if (wrote_img_to_disk) {
#line 7705 "Photo.c"
						{
							BackingPhotoRow* _tmp83_;
#line 784 "../src/Photo.vala"
							_tmp83_ = bps;
#line 784 "../src/Photo.vala"
							photo_add_backing_photo_for_development (self, d, _tmp83_, notify, &_inner_error0_);
#line 784 "../src/Photo.vala"
							if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 7714 "Photo.c"
								goto __catch9_g_error;
							}
#line 786 "../src/Photo.vala"
							photo_notify_raw_development_modified (self);
#line 7719 "Photo.c"
						}
						goto __finally9;
						__catch9_g_error:
						{
							GError* e = NULL;
							GError* _tmp84_;
							const gchar* _tmp85_;
#line 782 "../src/Photo.vala"
							e = _inner_error0_;
#line 782 "../src/Photo.vala"
							_inner_error0_ = NULL;
#line 788 "../src/Photo.vala"
							_tmp84_ = e;
#line 788 "../src/Photo.vala"
							_tmp85_ = _tmp84_->message;
#line 788 "../src/Photo.vala"
							g_debug ("Photo.vala:788: Error adding backing photo as development. Message: %s", _tmp85_);
#line 782 "../src/Photo.vala"
							_g_error_free0 (e);
#line 7739 "Photo.c"
						}
						__finally9:
#line 782 "../src/Photo.vala"
						if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 782 "../src/Photo.vala"
							_backing_photo_row_unref0 (bps);
#line 7746 "Photo.c"
						}
					}
				}
#line 779 "../src/Photo.vala"
				_backing_photo_row_unref0 (bps);
#line 779 "../src/Photo.vala"
				return;
#line 7754 "Photo.c"
			}
			__finally4:
			{
				GError* _inner_error1_ = NULL;
#line 781 "../src/Photo.vala"
				if (wrote_img_to_disk) {
#line 7761 "Photo.c"
					{
						BackingPhotoRow* _tmp86_;
#line 784 "../src/Photo.vala"
						_tmp86_ = bps;
#line 784 "../src/Photo.vala"
						photo_add_backing_photo_for_development (self, d, _tmp86_, notify, &_inner_error1_);
#line 784 "../src/Photo.vala"
						if (G_UNLIKELY (_inner_error1_ != NULL)) {
#line 7770 "Photo.c"
							goto __catch10_g_error;
						}
#line 786 "../src/Photo.vala"
						photo_notify_raw_development_modified (self);
#line 7775 "Photo.c"
					}
					goto __finally10;
					__catch10_g_error:
					{
						GError* e = NULL;
						GError* _tmp87_;
						const gchar* _tmp88_;
#line 782 "../src/Photo.vala"
						e = _inner_error1_;
#line 782 "../src/Photo.vala"
						_inner_error1_ = NULL;
#line 788 "../src/Photo.vala"
						_tmp87_ = e;
#line 788 "../src/Photo.vala"
						_tmp88_ = _tmp87_->message;
#line 788 "../src/Photo.vala"
						g_debug ("Photo.vala:788: Error adding backing photo as development. Message: %s", _tmp88_);
#line 782 "../src/Photo.vala"
						_g_error_free0 (e);
#line 7795 "Photo.c"
					}
					__finally10:
#line 782 "../src/Photo.vala"
					if (G_UNLIKELY (_inner_error1_ != NULL)) {
#line 782 "../src/Photo.vala"
						_backing_photo_row_unref0 (bps);
#line 782 "../src/Photo.vala"
						g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error1_->message, g_quark_to_string (_inner_error1_->domain), _inner_error1_->code);
#line 782 "../src/Photo.vala"
						g_clear_error (&_inner_error1_);
#line 782 "../src/Photo.vala"
						return;
#line 7808 "Photo.c"
					}
				}
			}
#line 731 "../src/Photo.vala"
			if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 731 "../src/Photo.vala"
				_backing_photo_row_unref0 (bps);
#line 731 "../src/Photo.vala"
				g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 731 "../src/Photo.vala"
				g_clear_error (&_inner_error0_);
#line 731 "../src/Photo.vala"
				return;
#line 7822 "Photo.c"
			}
#line 793 "../src/Photo.vala"
			break;
#line 7826 "Photo.c"
		}
		default:
		{
#line 796 "../src/Photo.vala"
			g_assert_not_reached ();
#line 7832 "Photo.c"
		}
	}
#line 667 "../src/Photo.vala"
	_backing_photo_row_unref0 (bps);
#line 7837 "Photo.c"
}

void
photo_set_default_raw_developer (Photo* self,
                                 RawDeveloper d)
{
	GError* _inner_error0_ = NULL;
#line 801 "../src/Photo.vala"
	g_return_if_fail (IS_PHOTO (self));
#line 7847 "Photo.c"
	{
		PhotoRow* _tmp0_;
#line 802 "../src/Photo.vala"
		_tmp0_ = self->row;
#line 802 "../src/Photo.vala"
		g_rec_mutex_lock (&self->priv->__lock_row);
#line 7854 "Photo.c"
		{
			PhotoRow* _tmp1_;
#line 803 "../src/Photo.vala"
			_tmp1_ = self->row;
#line 803 "../src/Photo.vala"
			_tmp1_->developer = d;
#line 7861 "Photo.c"
		}
		__finally0:
		{
			PhotoRow* _tmp2_;
#line 802 "../src/Photo.vala"
			_tmp2_ = self->row;
#line 802 "../src/Photo.vala"
			g_rec_mutex_unlock (&self->priv->__lock_row);
#line 7870 "Photo.c"
		}
#line 802 "../src/Photo.vala"
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 802 "../src/Photo.vala"
			g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 802 "../src/Photo.vala"
			g_clear_error (&_inner_error0_);
#line 802 "../src/Photo.vala"
			return;
#line 7880 "Photo.c"
		}
	}
}

void
photo_set_raw_developer (Photo* self,
                         RawDeveloper d,
                         gboolean notify)
{
	gboolean _tmp0_ = FALSE;
	gboolean _tmp1_ = FALSE;
	GError* _inner_error0_ = NULL;
#line 808 "../src/Photo.vala"
	g_return_if_fail (IS_PHOTO (self));
#line 809 "../src/Photo.vala"
	if (photo_get_master_file_format (self) != PHOTO_FILE_FORMAT_RAW) {
#line 810 "../src/Photo.vala"
		return;
#line 7899 "Photo.c"
	}
#line 815 "../src/Photo.vala"
	if (photo_is_raw_developer_available (self, RAW_DEVELOPER_CAMERA)) {
#line 815 "../src/Photo.vala"
		_tmp0_ = d == RAW_DEVELOPER_EMBEDDED;
#line 7905 "Photo.c"
	} else {
#line 815 "../src/Photo.vala"
		_tmp0_ = FALSE;
#line 7909 "Photo.c"
	}
#line 815 "../src/Photo.vala"
	if (_tmp0_) {
#line 816 "../src/Photo.vala"
		d = RAW_DEVELOPER_CAMERA;
#line 7915 "Photo.c"
	}
#line 820 "../src/Photo.vala"
	if (!photo_is_raw_developer_available (self, RAW_DEVELOPER_EMBEDDED)) {
#line 820 "../src/Photo.vala"
		_tmp1_ = d != RAW_DEVELOPER_CAMERA;
#line 7921 "Photo.c"
	} else {
#line 820 "../src/Photo.vala"
		_tmp1_ = FALSE;
#line 7925 "Photo.c"
	}
#line 820 "../src/Photo.vala"
	if (_tmp1_) {
#line 821 "../src/Photo.vala"
		d = RAW_DEVELOPER_SHOTWELL;
#line 7931 "Photo.c"
	}
	{
		GeeHashMap* _tmp2_;
#line 823 "../src/Photo.vala"
		_tmp2_ = self->priv->developments;
#line 823 "../src/Photo.vala"
		g_rec_mutex_lock (&self->priv->__lock_developments);
#line 7939 "Photo.c"
		{
			RawDeveloper stale_raw_developer = 0;
			PhotoRow* _tmp3_;
			GeeHashMap* _tmp4_;
			PhotoRow* _tmp6_;
			GeeHashMap* _tmp7_;
			gpointer _tmp8_;
			PhotoBackingReaders* _tmp9_;
			BackingPhotoRow* _tmp10_;
			BackingPhotoRow* _tmp11_;
			const gchar* _tmp12_;
			PhotoFileReader* _tmp13_;
			BackingPhotoRow* _tmp17_;
			gboolean _tmp25_ = FALSE;
#line 824 "../src/Photo.vala"
			_tmp3_ = self->row;
#line 824 "../src/Photo.vala"
			stale_raw_developer = _tmp3_->developer;
#line 827 "../src/Photo.vala"
			if (!photo_is_raw_developer_complete (self, d)) {
#line 828 "../src/Photo.vala"
				photo_develop_photo (self, d, notify);
#line 7962 "Photo.c"
			}
#line 830 "../src/Photo.vala"
			_tmp4_ = self->priv->developments;
#line 830 "../src/Photo.vala"
			if (!gee_abstract_map_has_key (G_TYPE_CHECK_INSTANCE_CAST (_tmp4_, GEE_TYPE_ABSTRACT_MAP, GeeAbstractMap), (gpointer) ((gintptr) d))) {
#line 7968 "Photo.c"
				{
					GeeHashMap* _tmp5_;
#line 823 "../src/Photo.vala"
					_tmp5_ = self->priv->developments;
#line 823 "../src/Photo.vala"
					g_rec_mutex_unlock (&self->priv->__lock_developments);
#line 7975 "Photo.c"
				}
#line 831 "../src/Photo.vala"
				return;
#line 7979 "Photo.c"
			}
#line 834 "../src/Photo.vala"
			photo_revert_to_master (self, FALSE);
#line 837 "../src/Photo.vala"
			_tmp6_ = self->row;
#line 837 "../src/Photo.vala"
			_tmp6_->developer = d;
#line 838 "../src/Photo.vala"
			_tmp7_ = self->priv->developments;
#line 838 "../src/Photo.vala"
			_tmp8_ = gee_abstract_map_get (G_TYPE_CHECK_INSTANCE_CAST (_tmp7_, GEE_TYPE_ABSTRACT_MAP, GeeAbstractMap), (gpointer) ((gintptr) d));
#line 838 "../src/Photo.vala"
			_backing_photo_row_unref0 (self->backing_photo_row);
#line 838 "../src/Photo.vala"
			self->backing_photo_row = (BackingPhotoRow*) _tmp8_;
#line 839 "../src/Photo.vala"
			_tmp9_ = self->priv->readers;
#line 839 "../src/Photo.vala"
			_tmp10_ = self->backing_photo_row;
#line 839 "../src/Photo.vala"
			_tmp11_ = self->backing_photo_row;
#line 839 "../src/Photo.vala"
			_tmp12_ = _tmp11_->filepath;
#line 839 "../src/Photo.vala"
			_tmp13_ = photo_file_format_create_reader (_tmp10_->file_format, _tmp12_);
#line 839 "../src/Photo.vala"
			_photo_file_adapter_unref0 (_tmp9_->developer);
#line 839 "../src/Photo.vala"
			_tmp9_->developer = _tmp13_;
#line 8009 "Photo.c"
			{
				GdkPixbuf* _tmp14_;
				GdkPixbuf* _tmp15_;
#line 842 "../src/Photo.vala"
				_tmp14_ = photo_get_prefetched_copy (self, &_inner_error0_);
#line 842 "../src/Photo.vala"
				_tmp15_ = _tmp14_;
#line 842 "../src/Photo.vala"
				_g_object_unref0 (_tmp15_);
#line 842 "../src/Photo.vala"
				if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 8021 "Photo.c"
					goto __catch1_g_error;
				}
			}
			goto __finally1;
			__catch1_g_error:
			{
#line 841 "../src/Photo.vala"
				g_clear_error (&_inner_error0_);
#line 8030 "Photo.c"
				{
					GeeHashMap* _tmp16_;
#line 823 "../src/Photo.vala"
					_tmp16_ = self->priv->developments;
#line 823 "../src/Photo.vala"
					g_rec_mutex_unlock (&self->priv->__lock_developments);
#line 8037 "Photo.c"
				}
#line 845 "../src/Photo.vala"
				return;
#line 8041 "Photo.c"
			}
			__finally1:
#line 841 "../src/Photo.vala"
			if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 841 "../src/Photo.vala"
				g_critical ("file %s: line %d: unexpected error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 841 "../src/Photo.vala"
				g_clear_error (&_inner_error0_);
#line 841 "../src/Photo.vala"
				return;
#line 8052 "Photo.c"
			}
#line 848 "../src/Photo.vala"
			_tmp17_ = self->backing_photo_row;
#line 848 "../src/Photo.vala"
			photo_set_orientation (self, _tmp17_->original_orientation);
#line 8058 "Photo.c"
			{
				PhotoTable* _tmp18_;
				PhotoTable* _tmp19_;
				PhotoRow* _tmp20_;
				BackingPhotoRow* _tmp21_;
				BackingPhotoID _tmp22_;
#line 851 "../src/Photo.vala"
				_tmp18_ = photo_table_get_instance ();
#line 851 "../src/Photo.vala"
				_tmp19_ = _tmp18_;
#line 851 "../src/Photo.vala"
				_tmp20_ = self->row;
#line 851 "../src/Photo.vala"
				_tmp21_ = self->backing_photo_row;
#line 851 "../src/Photo.vala"
				_tmp22_ = _tmp21_->id;
#line 851 "../src/Photo.vala"
				photo_table_update_raw_development (_tmp19_, _tmp20_, d, &_tmp22_, &_inner_error0_);
#line 851 "../src/Photo.vala"
				_database_table_unref0 (_tmp19_);
#line 851 "../src/Photo.vala"
				if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 8081 "Photo.c"
					goto __catch2_g_error;
				}
			}
			goto __finally2;
			__catch2_g_error:
			{
				GError* e = NULL;
				GError* _tmp23_;
				const gchar* _tmp24_;
#line 850 "../src/Photo.vala"
				e = _inner_error0_;
#line 850 "../src/Photo.vala"
				_inner_error0_ = NULL;
#line 853 "../src/Photo.vala"
				_tmp23_ = e;
#line 853 "../src/Photo.vala"
				_tmp24_ = _tmp23_->message;
#line 853 "../src/Photo.vala"
				g_warning ("Photo.vala:853: Error updating database: %s", _tmp24_);
#line 850 "../src/Photo.vala"
				_g_error_free0 (e);
#line 8103 "Photo.c"
			}
			__finally2:
#line 850 "../src/Photo.vala"
			if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 850 "../src/Photo.vala"
				g_critical ("file %s: line %d: unexpected error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 850 "../src/Photo.vala"
				g_clear_error (&_inner_error0_);
#line 850 "../src/Photo.vala"
				return;
#line 8114 "Photo.c"
			}
#line 860 "../src/Photo.vala"
			if (stale_raw_developer != RAW_DEVELOPER_CAMERA) {
#line 8118 "Photo.c"
				PhotoRow* _tmp26_;
#line 861 "../src/Photo.vala"
				_tmp26_ = self->row;
#line 861 "../src/Photo.vala"
				_tmp25_ = stale_raw_developer != _tmp26_->developer;
#line 8124 "Photo.c"
			} else {
#line 860 "../src/Photo.vala"
				_tmp25_ = FALSE;
#line 8128 "Photo.c"
			}
#line 860 "../src/Photo.vala"
			if (_tmp25_) {
#line 864 "../src/Photo.vala"
				photo_delete_raw_development (self, stale_raw_developer);
#line 8134 "Photo.c"
			}
		}
		__finally0:
		{
			GeeHashMap* _tmp27_;
#line 823 "../src/Photo.vala"
			_tmp27_ = self->priv->developments;
#line 823 "../src/Photo.vala"
			g_rec_mutex_unlock (&self->priv->__lock_developments);
#line 8144 "Photo.c"
		}
#line 823 "../src/Photo.vala"
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 823 "../src/Photo.vala"
			g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 823 "../src/Photo.vala"
			g_clear_error (&_inner_error0_);
#line 823 "../src/Photo.vala"
			return;
#line 8154 "Photo.c"
		}
	}
#line 871 "../src/Photo.vala"
	if (notify) {
#line 8159 "Photo.c"
		Alteration* _tmp28_;
		Alteration* _tmp29_;
#line 872 "../src/Photo.vala"
		_tmp28_ = alteration_new ("image", "developer");
#line 872 "../src/Photo.vala"
		_tmp29_ = _tmp28_;
#line 872 "../src/Photo.vala"
		data_object_notify_altered (G_TYPE_CHECK_INSTANCE_CAST (self, TYPE_DATA_OBJECT, DataObject), _tmp29_);
#line 872 "../src/Photo.vala"
		_alteration_unref0 (_tmp29_);
#line 8170 "Photo.c"
	}
#line 873 "../src/Photo.vala"
	photo_discard_prefetched (self);
#line 8174 "Photo.c"
}

RawDeveloper
photo_get_raw_developer (Photo* self)
{
	PhotoRow* _tmp0_;
	RawDeveloper result;
#line 876 "../src/Photo.vala"
	g_return_val_if_fail (IS_PHOTO (self), 0);
#line 877 "../src/Photo.vala"
	_tmp0_ = self->row;
#line 877 "../src/Photo.vala"
	result = _tmp0_->developer;
#line 877 "../src/Photo.vala"
	return result;
#line 8190 "Photo.c"
}

static gboolean
photo_delete_raw_development (Photo* self,
                              RawDeveloper d)
{
	gboolean ret = FALSE;
	GError* _inner_error0_ = NULL;
	gboolean result;
#line 882 "../src/Photo.vala"
	g_return_val_if_fail (IS_PHOTO (self), FALSE);
#line 883 "../src/Photo.vala"
	ret = FALSE;
#line 8204 "Photo.c"
	{
		GeeHashMap* _tmp0_;
#line 885 "../src/Photo.vala"
		_tmp0_ = self->priv->developments;
#line 885 "../src/Photo.vala"
		g_rec_mutex_lock (&self->priv->__lock_developments);
#line 8211 "Photo.c"
		{
			GeeHashMap* _tmp1_;
			gchar* _tmp3_;
			gchar* _tmp4_;
			gchar* _tmp5_;
			gchar* _tmp6_;
			BackingPhotoRow* bpr = NULL;
			GeeHashMap* _tmp7_;
			gpointer _tmp8_;
			BackingPhotoRow* _tmp9_;
			const gchar* _tmp10_;
			GeeHashMap* _tmp31_;
#line 886 "../src/Photo.vala"
			_tmp1_ = self->priv->developments;
#line 886 "../src/Photo.vala"
			if (!gee_abstract_map_has_key (G_TYPE_CHECK_INSTANCE_CAST (_tmp1_, GEE_TYPE_ABSTRACT_MAP, GeeAbstractMap), (gpointer) ((gintptr) d))) {
#line 887 "../src/Photo.vala"
				result = FALSE;
#line 8230 "Photo.c"
				{
					GeeHashMap* _tmp2_;
#line 885 "../src/Photo.vala"
					_tmp2_ = self->priv->developments;
#line 885 "../src/Photo.vala"
					g_rec_mutex_unlock (&self->priv->__lock_developments);
#line 8237 "Photo.c"
				}
#line 887 "../src/Photo.vala"
				return result;
#line 8241 "Photo.c"
			}
#line 891 "../src/Photo.vala"
			_tmp3_ = data_object_to_string (G_TYPE_CHECK_INSTANCE_CAST (self, TYPE_DATA_OBJECT, DataObject));
#line 891 "../src/Photo.vala"
			_tmp4_ = _tmp3_;
#line 891 "../src/Photo.vala"
			_tmp5_ = raw_developer_to_string (d);
#line 891 "../src/Photo.vala"
			_tmp6_ = _tmp5_;
#line 891 "../src/Photo.vala"
			g_debug ("Photo.vala:891: Delete raw development: %s %s", _tmp4_, _tmp6_);
#line 891 "../src/Photo.vala"
			_g_free0 (_tmp6_);
#line 891 "../src/Photo.vala"
			_g_free0 (_tmp4_);
#line 892 "../src/Photo.vala"
			_tmp7_ = self->priv->developments;
#line 892 "../src/Photo.vala"
			_tmp8_ = gee_abstract_map_get (G_TYPE_CHECK_INSTANCE_CAST (_tmp7_, GEE_TYPE_ABSTRACT_MAP, GeeAbstractMap), (gpointer) ((gintptr) d));
#line 892 "../src/Photo.vala"
			bpr = (BackingPhotoRow*) _tmp8_;
#line 893 "../src/Photo.vala"
			_tmp9_ = bpr;
#line 893 "../src/Photo.vala"
			_tmp10_ = _tmp9_->filepath;
#line 893 "../src/Photo.vala"
			if (_tmp10_ != NULL) {
#line 8269 "Photo.c"
				GFile* f = NULL;
				BackingPhotoRow* _tmp11_;
				const gchar* _tmp12_;
				GFile* _tmp13_;
#line 894 "../src/Photo.vala"
				_tmp11_ = bpr;
#line 894 "../src/Photo.vala"
				_tmp12_ = _tmp11_->filepath;
#line 894 "../src/Photo.vala"
				_tmp13_ = g_file_new_for_path (_tmp12_);
#line 894 "../src/Photo.vala"
				f = _tmp13_;
#line 8282 "Photo.c"
				{
#line 896 "../src/Photo.vala"
					if (d == RAW_DEVELOPER_CAMERA) {
#line 8286 "Photo.c"
						GFile* _tmp14_;
#line 897 "../src/Photo.vala"
						_tmp14_ = f;
#line 897 "../src/Photo.vala"
						g_file_trash (_tmp14_, NULL, &_inner_error0_);
#line 897 "../src/Photo.vala"
						if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 8294 "Photo.c"
							goto __catch1_g_error;
						}
					} else {
						GFile* _tmp15_;
#line 899 "../src/Photo.vala"
						_tmp15_ = f;
#line 899 "../src/Photo.vala"
						g_file_delete (_tmp15_, NULL, &_inner_error0_);
#line 899 "../src/Photo.vala"
						if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 8305 "Photo.c"
							goto __catch1_g_error;
						}
					}
				}
				goto __finally1;
				__catch1_g_error:
				{
					GError* e = NULL;
					BackingPhotoRow* _tmp16_;
					const gchar* _tmp17_;
					GError* _tmp18_;
					const gchar* _tmp19_;
#line 895 "../src/Photo.vala"
					e = _inner_error0_;
#line 895 "../src/Photo.vala"
					_inner_error0_ = NULL;
#line 901 "../src/Photo.vala"
					_tmp16_ = bpr;
#line 901 "../src/Photo.vala"
					_tmp17_ = _tmp16_->filepath;
#line 901 "../src/Photo.vala"
					_tmp18_ = e;
#line 901 "../src/Photo.vala"
					_tmp19_ = _tmp18_->message;
#line 901 "../src/Photo.vala"
					g_warning ("Photo.vala:901: Unable to delete RAW development: %s error: %s", _tmp17_, _tmp19_);
#line 895 "../src/Photo.vala"
					_g_error_free0 (e);
#line 8334 "Photo.c"
				}
				__finally1:
#line 895 "../src/Photo.vala"
				if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 8339 "Photo.c"
					gboolean _tmp20_ = FALSE;
#line 895 "../src/Photo.vala"
					_g_object_unref0 (f);
#line 895 "../src/Photo.vala"
					_backing_photo_row_unref0 (bpr);
#line 895 "../src/Photo.vala"
					g_critical ("file %s: line %d: unexpected error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 895 "../src/Photo.vala"
					g_clear_error (&_inner_error0_);
#line 895 "../src/Photo.vala"
					return _tmp20_;
#line 8351 "Photo.c"
				}
#line 893 "../src/Photo.vala"
				_g_object_unref0 (f);
#line 8355 "Photo.c"
			}
			{
				PhotoTable* _tmp21_;
				PhotoTable* _tmp22_;
				PhotoRow* _tmp23_;
				BackingPhotoTable* _tmp24_;
				BackingPhotoTable* _tmp25_;
				BackingPhotoRow* _tmp26_;
				BackingPhotoID _tmp27_;
#line 907 "../src/Photo.vala"
				_tmp21_ = photo_table_get_instance ();
#line 907 "../src/Photo.vala"
				_tmp22_ = _tmp21_;
#line 907 "../src/Photo.vala"
				_tmp23_ = self->row;
#line 907 "../src/Photo.vala"
				photo_table_remove_development (_tmp22_, _tmp23_, d, &_inner_error0_);
#line 907 "../src/Photo.vala"
				_database_table_unref0 (_tmp22_);
#line 907 "../src/Photo.vala"
				if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 8377 "Photo.c"
					goto __catch2_g_error;
				}
#line 908 "../src/Photo.vala"
				_tmp24_ = backing_photo_table_get_instance ();
#line 908 "../src/Photo.vala"
				_tmp25_ = _tmp24_;
#line 908 "../src/Photo.vala"
				_tmp26_ = bpr;
#line 908 "../src/Photo.vala"
				_tmp27_ = _tmp26_->id;
#line 908 "../src/Photo.vala"
				backing_photo_table_remove (_tmp25_, &_tmp27_, &_inner_error0_);
#line 908 "../src/Photo.vala"
				_database_table_unref0 (_tmp25_);
#line 908 "../src/Photo.vala"
				if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 8394 "Photo.c"
					goto __catch2_g_error;
				}
			}
			goto __finally2;
			__catch2_g_error:
			{
				GError* e = NULL;
				GError* _tmp28_;
				const gchar* _tmp29_;
#line 906 "../src/Photo.vala"
				e = _inner_error0_;
#line 906 "../src/Photo.vala"
				_inner_error0_ = NULL;
#line 910 "../src/Photo.vala"
				_tmp28_ = e;
#line 910 "../src/Photo.vala"
				_tmp29_ = _tmp28_->message;
#line 910 "../src/Photo.vala"
				g_warning ("Photo.vala:910: Database error while deleting RAW development: %s", _tmp29_);
#line 906 "../src/Photo.vala"
				_g_error_free0 (e);
#line 8416 "Photo.c"
			}
			__finally2:
#line 906 "../src/Photo.vala"
			if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 8421 "Photo.c"
				gboolean _tmp30_ = FALSE;
#line 906 "../src/Photo.vala"
				_backing_photo_row_unref0 (bpr);
#line 906 "../src/Photo.vala"
				g_critical ("file %s: line %d: unexpected error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 906 "../src/Photo.vala"
				g_clear_error (&_inner_error0_);
#line 906 "../src/Photo.vala"
				return _tmp30_;
#line 8431 "Photo.c"
			}
#line 913 "../src/Photo.vala"
			_tmp31_ = self->priv->developments;
#line 913 "../src/Photo.vala"
			ret = gee_abstract_map_unset (G_TYPE_CHECK_INSTANCE_CAST (_tmp31_, GEE_TYPE_ABSTRACT_MAP, GeeAbstractMap), (gpointer) ((gintptr) d), NULL);
#line 885 "../src/Photo.vala"
			_backing_photo_row_unref0 (bpr);
#line 8439 "Photo.c"
		}
		__finally0:
		{
			GeeHashMap* _tmp32_;
#line 885 "../src/Photo.vala"
			_tmp32_ = self->priv->developments;
#line 885 "../src/Photo.vala"
			g_rec_mutex_unlock (&self->priv->__lock_developments);
#line 8448 "Photo.c"
		}
#line 885 "../src/Photo.vala"
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 8452 "Photo.c"
			gboolean _tmp33_ = FALSE;
#line 885 "../src/Photo.vala"
			g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 885 "../src/Photo.vala"
			g_clear_error (&_inner_error0_);
#line 885 "../src/Photo.vala"
			return _tmp33_;
#line 8460 "Photo.c"
		}
	}
#line 916 "../src/Photo.vala"
	photo_notify_raw_development_modified (self);
#line 917 "../src/Photo.vala"
	result = ret;
#line 917 "../src/Photo.vala"
	return result;
#line 8469 "Photo.c"
}

void
photo_redevelop_raw (Photo* self,
                     RawDeveloper d)
{
	GError* _inner_error0_ = NULL;
#line 921 "../src/Photo.vala"
	g_return_if_fail (IS_PHOTO (self));
#line 8479 "Photo.c"
	{
		GeeHashMap* _tmp0_;
#line 922 "../src/Photo.vala"
		_tmp0_ = self->priv->developments;
#line 922 "../src/Photo.vala"
		g_rec_mutex_lock (&self->priv->__lock_developments);
#line 8486 "Photo.c"
		{
			RawDeveloper dev = 0;
#line 923 "../src/Photo.vala"
			photo_delete_raw_development (self, d);
#line 924 "../src/Photo.vala"
			dev = d;
#line 925 "../src/Photo.vala"
			if (dev == RAW_DEVELOPER_CAMERA) {
#line 926 "../src/Photo.vala"
				dev = RAW_DEVELOPER_EMBEDDED;
#line 8497 "Photo.c"
			}
#line 928 "../src/Photo.vala"
			photo_set_raw_developer (self, dev, TRUE);
#line 8501 "Photo.c"
		}
		__finally0:
		{
			GeeHashMap* _tmp1_;
#line 922 "../src/Photo.vala"
			_tmp1_ = self->priv->developments;
#line 922 "../src/Photo.vala"
			g_rec_mutex_unlock (&self->priv->__lock_developments);
#line 8510 "Photo.c"
		}
#line 922 "../src/Photo.vala"
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 922 "../src/Photo.vala"
			g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 922 "../src/Photo.vala"
			g_clear_error (&_inner_error0_);
#line 922 "../src/Photo.vala"
			return;
#line 8520 "Photo.c"
		}
	}
}

static void
_vala_array_add83 (BackingFileState** * array,
                   gint* length,
                   gint* size,
                   BackingFileState* value)
{
#line 935 "../src/Photo.vala"
	if ((*length) == (*size)) {
#line 935 "../src/Photo.vala"
		*size = (*size) ? (2 * (*size)) : 4;
#line 935 "../src/Photo.vala"
		*array = g_renew (BackingFileState*, *array, (*size) + 1);
#line 8537 "Photo.c"
	}
#line 935 "../src/Photo.vala"
	(*array)[(*length)++] = value;
#line 935 "../src/Photo.vala"
	(*array)[*length] = NULL;
#line 8543 "Photo.c"
}

static void
_vala_array_add84 (BackingFileState** * array,
                   gint* length,
                   gint* size,
                   BackingFileState* value)
{
#line 937 "../src/Photo.vala"
	if ((*length) == (*size)) {
#line 937 "../src/Photo.vala"
		*size = (*size) ? (2 * (*size)) : 4;
#line 937 "../src/Photo.vala"
		*array = g_renew (BackingFileState*, *array, (*size) + 1);
#line 8558 "Photo.c"
	}
#line 937 "../src/Photo.vala"
	(*array)[(*length)++] = value;
#line 937 "../src/Photo.vala"
	(*array)[*length] = NULL;
#line 8564 "Photo.c"
}

static void
_vala_array_add85 (BackingFileState** * array,
                   gint* length,
                   gint* size,
                   BackingFileState* value)
{
#line 944 "../src/Photo.vala"
	if ((*length) == (*size)) {
#line 944 "../src/Photo.vala"
		*size = (*size) ? (2 * (*size)) : 4;
#line 944 "../src/Photo.vala"
		*array = g_renew (BackingFileState*, *array, (*size) + 1);
#line 8579 "Photo.c"
	}
#line 944 "../src/Photo.vala"
	(*array)[(*length)++] = value;
#line 944 "../src/Photo.vala"
	(*array)[*length] = NULL;
#line 8585 "Photo.c"
}

static BackingFileState**
photo_real_get_backing_files_state (MediaSource* base,
                                    gint* result_length1)
{
	Photo * self;
	BackingFileState** backing = NULL;
	BackingFileState** _tmp0_;
	gint backing_length1;
	gint _backing_size_;
	BackingFileState** _tmp21_;
	gint _tmp21__length1;
	GError* _inner_error0_ = NULL;
	BackingFileState** result;
#line 932 "../src/Photo.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (base, TYPE_PHOTO, Photo);
#line 933 "../src/Photo.vala"
	_tmp0_ = g_new0 (BackingFileState*, 0 + 1);
#line 933 "../src/Photo.vala"
	backing = _tmp0_;
#line 933 "../src/Photo.vala"
	backing_length1 = 0;
#line 933 "../src/Photo.vala"
	_backing_size_ = backing_length1;
#line 8611 "Photo.c"
	{
		PhotoRow* _tmp1_;
#line 934 "../src/Photo.vala"
		_tmp1_ = self->row;
#line 934 "../src/Photo.vala"
		g_rec_mutex_lock (&self->priv->__lock_row);
#line 8618 "Photo.c"
		{
			PhotoRow* _tmp2_;
			BackingPhotoRow* _tmp3_;
			PhotoRow* _tmp4_;
			const gchar* _tmp5_;
			BackingFileState* _tmp6_;
#line 935 "../src/Photo.vala"
			_tmp2_ = self->row;
#line 935 "../src/Photo.vala"
			_tmp3_ = _tmp2_->master;
#line 935 "../src/Photo.vala"
			_tmp4_ = self->row;
#line 935 "../src/Photo.vala"
			_tmp5_ = _tmp4_->md5;
#line 935 "../src/Photo.vala"
			_tmp6_ = backing_file_state_new_from_photo_row (_tmp3_, _tmp5_);
#line 935 "../src/Photo.vala"
			_vala_array_add83 (&backing, &backing_length1, &_backing_size_, _tmp6_);
#line 936 "../src/Photo.vala"
			if (photo_has_editable (self)) {
#line 8639 "Photo.c"
				BackingPhotoRow* _tmp7_;
				BackingFileState* _tmp8_;
#line 937 "../src/Photo.vala"
				_tmp7_ = self->priv->editable;
#line 937 "../src/Photo.vala"
				_tmp8_ = backing_file_state_new_from_photo_row (_tmp7_, NULL);
#line 937 "../src/Photo.vala"
				_vala_array_add84 (&backing, &backing_length1, &_backing_size_, _tmp8_);
#line 8648 "Photo.c"
			}
#line 939 "../src/Photo.vala"
			if (photo_is_developed (self)) {
#line 8652 "Photo.c"
				GeeCollection* dev_rows = NULL;
				GeeCollection* _tmp9_;
				GeeCollection* _tmp10_;
#line 940 "../src/Photo.vala"
				_tmp9_ = photo_get_raw_development_photo_rows (self);
#line 940 "../src/Photo.vala"
				dev_rows = _tmp9_;
#line 941 "../src/Photo.vala"
				_tmp10_ = dev_rows;
#line 941 "../src/Photo.vala"
				if (_tmp10_ != NULL) {
#line 8664 "Photo.c"
					{
						GeeIterator* _r_it = NULL;
						GeeCollection* _tmp11_;
						GeeIterator* _tmp12_;
#line 942 "../src/Photo.vala"
						_tmp11_ = dev_rows;
#line 942 "../src/Photo.vala"
						_tmp12_ = gee_iterable_iterator (G_TYPE_CHECK_INSTANCE_CAST (_tmp11_, GEE_TYPE_ITERABLE, GeeIterable));
#line 942 "../src/Photo.vala"
						_r_it = _tmp12_;
#line 942 "../src/Photo.vala"
						while (TRUE) {
#line 8677 "Photo.c"
							GeeIterator* _tmp13_;
							BackingPhotoRow* r = NULL;
							GeeIterator* _tmp14_;
							gpointer _tmp15_;
							BackingPhotoRow* _tmp16_;
							const gchar* _tmp17_;
							BackingPhotoRow* _tmp18_;
							BackingFileState* _tmp19_;
#line 942 "../src/Photo.vala"
							_tmp13_ = _r_it;
#line 942 "../src/Photo.vala"
							if (!gee_iterator_next (_tmp13_)) {
#line 942 "../src/Photo.vala"
								break;
#line 8692 "Photo.c"
							}
#line 942 "../src/Photo.vala"
							_tmp14_ = _r_it;
#line 942 "../src/Photo.vala"
							_tmp15_ = gee_iterator_get (_tmp14_);
#line 942 "../src/Photo.vala"
							r = (BackingPhotoRow*) _tmp15_;
#line 943 "../src/Photo.vala"
							_tmp16_ = r;
#line 943 "../src/Photo.vala"
							_tmp17_ = _tmp16_->filepath;
#line 943 "../src/Photo.vala"
							g_debug ("Photo.vala:943: adding: %s", _tmp17_);
#line 944 "../src/Photo.vala"
							_tmp18_ = r;
#line 944 "../src/Photo.vala"
							_tmp19_ = backing_file_state_new_from_photo_row (_tmp18_, NULL);
#line 944 "../src/Photo.vala"
							_vala_array_add85 (&backing, &backing_length1, &_backing_size_, _tmp19_);
#line 942 "../src/Photo.vala"
							_backing_photo_row_unref0 (r);
#line 8714 "Photo.c"
						}
#line 942 "../src/Photo.vala"
						_g_object_unref0 (_r_it);
#line 8718 "Photo.c"
					}
				}
#line 939 "../src/Photo.vala"
				_g_object_unref0 (dev_rows);
#line 8723 "Photo.c"
			}
		}
		__finally0:
		{
			PhotoRow* _tmp20_;
#line 934 "../src/Photo.vala"
			_tmp20_ = self->row;
#line 934 "../src/Photo.vala"
			g_rec_mutex_unlock (&self->priv->__lock_row);
#line 8733 "Photo.c"
		}
#line 934 "../src/Photo.vala"
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 934 "../src/Photo.vala"
			backing = (_vala_array_free (backing, backing_length1, (GDestroyNotify) backing_file_state_unref), NULL);
#line 934 "../src/Photo.vala"
			g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 934 "../src/Photo.vala"
			g_clear_error (&_inner_error0_);
#line 934 "../src/Photo.vala"
			return NULL;
#line 8745 "Photo.c"
		}
	}
#line 950 "../src/Photo.vala"
	_tmp21_ = backing;
#line 950 "../src/Photo.vala"
	_tmp21__length1 = backing_length1;
#line 950 "../src/Photo.vala"
	if (result_length1) {
#line 950 "../src/Photo.vala"
		*result_length1 = _tmp21__length1;
#line 8756 "Photo.c"
	}
#line 950 "../src/Photo.vala"
	result = _tmp21_;
#line 950 "../src/Photo.vala"
	return result;
#line 8762 "Photo.c"
}

static PhotoFileReader*
photo_get_backing_reader (Photo* self,
                          BackingFetchMode mode)
{
	PhotoFileReader* result;
#line 953 "../src/Photo.vala"
	g_return_val_if_fail (IS_PHOTO (self), NULL);
#line 954 "../src/Photo.vala"
	switch (mode) {
#line 954 "../src/Photo.vala"
		case BACKING_FETCH_MODE_MASTER:
#line 8776 "Photo.c"
		{
			PhotoFileReader* _tmp0_;
#line 956 "../src/Photo.vala"
			_tmp0_ = photo_get_master_reader (self);
#line 956 "../src/Photo.vala"
			result = _tmp0_;
#line 956 "../src/Photo.vala"
			return result;
#line 8785 "Photo.c"
		}
#line 954 "../src/Photo.vala"
		case BACKING_FETCH_MODE_BASELINE:
#line 8789 "Photo.c"
		{
			PhotoFileReader* _tmp1_;
#line 959 "../src/Photo.vala"
			_tmp1_ = photo_get_baseline_reader (self);
#line 959 "../src/Photo.vala"
			result = _tmp1_;
#line 959 "../src/Photo.vala"
			return result;
#line 8798 "Photo.c"
		}
#line 954 "../src/Photo.vala"
		case BACKING_FETCH_MODE_SOURCE:
#line 8802 "Photo.c"
		{
			PhotoFileReader* _tmp2_;
#line 962 "../src/Photo.vala"
			_tmp2_ = photo_get_source_reader (self);
#line 962 "../src/Photo.vala"
			result = _tmp2_;
#line 962 "../src/Photo.vala"
			return result;
#line 8811 "Photo.c"
		}
#line 954 "../src/Photo.vala"
		case BACKING_FETCH_MODE_UNMODIFIED:
#line 8815 "Photo.c"
		{
#line 965 "../src/Photo.vala"
			if (photo_get_master_file_format (self) == PHOTO_FILE_FORMAT_RAW) {
#line 8819 "Photo.c"
				PhotoFileReader* _tmp3_;
#line 966 "../src/Photo.vala"
				_tmp3_ = photo_get_raw_developer_reader (self);
#line 966 "../src/Photo.vala"
				result = _tmp3_;
#line 966 "../src/Photo.vala"
				return result;
#line 8827 "Photo.c"
			} else {
				PhotoFileReader* _tmp4_;
#line 968 "../src/Photo.vala"
				_tmp4_ = photo_get_master_reader (self);
#line 968 "../src/Photo.vala"
				result = _tmp4_;
#line 968 "../src/Photo.vala"
				return result;
#line 8836 "Photo.c"
			}
		}
		default:
		{
			GEnumValue* _tmp5_;
#line 971 "../src/Photo.vala"
			_tmp5_ = g_enum_get_value (g_type_class_ref (TYPE_BACKING_FETCH_MODE), mode);
#line 971 "../src/Photo.vala"
			g_error ("Photo.vala:971: Unknown backing fetch mode %s", (_tmp5_ != NULL) ? _tmp5_->value_name : NULL);
#line 8846 "Photo.c"
		}
	}
}

static gpointer
_photo_file_adapter_ref0 (gpointer self)
{
#line 977 "../src/Photo.vala"
	return self ? photo_file_adapter_ref (self) : NULL;
#line 8856 "Photo.c"
}

static PhotoFileReader*
photo_get_master_reader (Photo* self)
{
	GError* _inner_error0_ = NULL;
	PhotoFileReader* result;
#line 975 "../src/Photo.vala"
	g_return_val_if_fail (IS_PHOTO (self), NULL);
#line 8866 "Photo.c"
	{
		PhotoBackingReaders* _tmp0_;
#line 976 "../src/Photo.vala"
		_tmp0_ = self->priv->readers;
#line 976 "../src/Photo.vala"
		g_rec_mutex_lock (&self->priv->__lock_readers);
#line 8873 "Photo.c"
		{
			PhotoBackingReaders* _tmp1_;
			PhotoFileReader* _tmp2_;
			PhotoFileReader* _tmp3_;
#line 977 "../src/Photo.vala"
			_tmp1_ = self->priv->readers;
#line 977 "../src/Photo.vala"
			_tmp2_ = _tmp1_->master;
#line 977 "../src/Photo.vala"
			_tmp3_ = _photo_file_adapter_ref0 (_tmp2_);
#line 977 "../src/Photo.vala"
			result = _tmp3_;
#line 8886 "Photo.c"
			{
				PhotoBackingReaders* _tmp4_;
#line 976 "../src/Photo.vala"
				_tmp4_ = self->priv->readers;
#line 976 "../src/Photo.vala"
				g_rec_mutex_unlock (&self->priv->__lock_readers);
#line 8893 "Photo.c"
			}
#line 977 "../src/Photo.vala"
			return result;
#line 8897 "Photo.c"
		}
		__finally0:
		{
			PhotoBackingReaders* _tmp5_;
#line 976 "../src/Photo.vala"
			_tmp5_ = self->priv->readers;
#line 976 "../src/Photo.vala"
			g_rec_mutex_unlock (&self->priv->__lock_readers);
#line 8906 "Photo.c"
		}
#line 976 "../src/Photo.vala"
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 976 "../src/Photo.vala"
		g_clear_error (&_inner_error0_);
#line 976 "../src/Photo.vala"
		return NULL;
#line 8914 "Photo.c"
	}
}

PhotoFileReader*
photo_get_editable_reader (Photo* self)
{
	GError* _inner_error0_ = NULL;
	PhotoFileReader* result;
#line 981 "../src/Photo.vala"
	g_return_val_if_fail (IS_PHOTO (self), NULL);
#line 8925 "Photo.c"
	{
		PhotoBackingReaders* _tmp0_;
#line 982 "../src/Photo.vala"
		_tmp0_ = self->priv->readers;
#line 982 "../src/Photo.vala"
		g_rec_mutex_lock (&self->priv->__lock_readers);
#line 8932 "Photo.c"
		{
			PhotoBackingReaders* _tmp1_;
			PhotoFileReader* _tmp2_;
			PhotoFileReader* _tmp3_;
#line 983 "../src/Photo.vala"
			_tmp1_ = self->priv->readers;
#line 983 "../src/Photo.vala"
			_tmp2_ = _tmp1_->editable;
#line 983 "../src/Photo.vala"
			_tmp3_ = _photo_file_adapter_ref0 (_tmp2_);
#line 983 "../src/Photo.vala"
			result = _tmp3_;
#line 8945 "Photo.c"
			{
				PhotoBackingReaders* _tmp4_;
#line 982 "../src/Photo.vala"
				_tmp4_ = self->priv->readers;
#line 982 "../src/Photo.vala"
				g_rec_mutex_unlock (&self->priv->__lock_readers);
#line 8952 "Photo.c"
			}
#line 983 "../src/Photo.vala"
			return result;
#line 8956 "Photo.c"
		}
		__finally0:
		{
			PhotoBackingReaders* _tmp5_;
#line 982 "../src/Photo.vala"
			_tmp5_ = self->priv->readers;
#line 982 "../src/Photo.vala"
			g_rec_mutex_unlock (&self->priv->__lock_readers);
#line 8965 "Photo.c"
		}
#line 982 "../src/Photo.vala"
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 982 "../src/Photo.vala"
		g_clear_error (&_inner_error0_);
#line 982 "../src/Photo.vala"
		return NULL;
#line 8973 "Photo.c"
	}
}

static PhotoFileReader*
photo_get_baseline_reader (Photo* self)
{
	GError* _inner_error0_ = NULL;
	PhotoFileReader* result;
#line 988 "../src/Photo.vala"
	g_return_val_if_fail (IS_PHOTO (self), NULL);
#line 8984 "Photo.c"
	{
		PhotoBackingReaders* _tmp0_;
#line 989 "../src/Photo.vala"
		_tmp0_ = self->priv->readers;
#line 989 "../src/Photo.vala"
		g_rec_mutex_lock (&self->priv->__lock_readers);
#line 8991 "Photo.c"
		{
			PhotoBackingReaders* _tmp1_;
			PhotoFileReader* _tmp2_;
			PhotoBackingReaders* _tmp7_;
			PhotoFileReader* _tmp8_;
			PhotoBackingReaders* _tmp13_;
			PhotoFileReader* _tmp14_;
			PhotoFileReader* _tmp15_;
#line 990 "../src/Photo.vala"
			_tmp1_ = self->priv->readers;
#line 990 "../src/Photo.vala"
			_tmp2_ = _tmp1_->editable;
#line 990 "../src/Photo.vala"
			if (_tmp2_ != NULL) {
#line 9006 "Photo.c"
				PhotoBackingReaders* _tmp3_;
				PhotoFileReader* _tmp4_;
				PhotoFileReader* _tmp5_;
#line 991 "../src/Photo.vala"
				_tmp3_ = self->priv->readers;
#line 991 "../src/Photo.vala"
				_tmp4_ = _tmp3_->editable;
#line 991 "../src/Photo.vala"
				_tmp5_ = _photo_file_adapter_ref0 (_tmp4_);
#line 991 "../src/Photo.vala"
				result = _tmp5_;
#line 9018 "Photo.c"
				{
					PhotoBackingReaders* _tmp6_;
#line 989 "../src/Photo.vala"
					_tmp6_ = self->priv->readers;
#line 989 "../src/Photo.vala"
					g_rec_mutex_unlock (&self->priv->__lock_readers);
#line 9025 "Photo.c"
				}
#line 991 "../src/Photo.vala"
				return result;
#line 9029 "Photo.c"
			}
#line 993 "../src/Photo.vala"
			_tmp7_ = self->priv->readers;
#line 993 "../src/Photo.vala"
			_tmp8_ = _tmp7_->developer;
#line 993 "../src/Photo.vala"
			if (_tmp8_ != NULL) {
#line 9037 "Photo.c"
				PhotoBackingReaders* _tmp9_;
				PhotoFileReader* _tmp10_;
				PhotoFileReader* _tmp11_;
#line 994 "../src/Photo.vala"
				_tmp9_ = self->priv->readers;
#line 994 "../src/Photo.vala"
				_tmp10_ = _tmp9_->developer;
#line 994 "../src/Photo.vala"
				_tmp11_ = _photo_file_adapter_ref0 (_tmp10_);
#line 994 "../src/Photo.vala"
				result = _tmp11_;
#line 9049 "Photo.c"
				{
					PhotoBackingReaders* _tmp12_;
#line 989 "../src/Photo.vala"
					_tmp12_ = self->priv->readers;
#line 989 "../src/Photo.vala"
					g_rec_mutex_unlock (&self->priv->__lock_readers);
#line 9056 "Photo.c"
				}
#line 994 "../src/Photo.vala"
				return result;
#line 9060 "Photo.c"
			}
#line 996 "../src/Photo.vala"
			_tmp13_ = self->priv->readers;
#line 996 "../src/Photo.vala"
			_tmp14_ = _tmp13_->master;
#line 996 "../src/Photo.vala"
			_tmp15_ = _photo_file_adapter_ref0 (_tmp14_);
#line 996 "../src/Photo.vala"
			result = _tmp15_;
#line 9070 "Photo.c"
			{
				PhotoBackingReaders* _tmp16_;
#line 989 "../src/Photo.vala"
				_tmp16_ = self->priv->readers;
#line 989 "../src/Photo.vala"
				g_rec_mutex_unlock (&self->priv->__lock_readers);
#line 9077 "Photo.c"
			}
#line 996 "../src/Photo.vala"
			return result;
#line 9081 "Photo.c"
		}
		__finally0:
		{
			PhotoBackingReaders* _tmp17_;
#line 989 "../src/Photo.vala"
			_tmp17_ = self->priv->readers;
#line 989 "../src/Photo.vala"
			g_rec_mutex_unlock (&self->priv->__lock_readers);
#line 9090 "Photo.c"
		}
#line 989 "../src/Photo.vala"
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 989 "../src/Photo.vala"
		g_clear_error (&_inner_error0_);
#line 989 "../src/Photo.vala"
		return NULL;
#line 9098 "Photo.c"
	}
}

static PhotoFileReader*
photo_get_source_reader (Photo* self)
{
	GError* _inner_error0_ = NULL;
	PhotoFileReader* result;
#line 1001 "../src/Photo.vala"
	g_return_val_if_fail (IS_PHOTO (self), NULL);
#line 9109 "Photo.c"
	{
		PhotoBackingReaders* _tmp0_;
#line 1002 "../src/Photo.vala"
		_tmp0_ = self->priv->readers;
#line 1002 "../src/Photo.vala"
		g_rec_mutex_lock (&self->priv->__lock_readers);
#line 9116 "Photo.c"
		{
			PhotoBackingReaders* _tmp1_;
			PhotoFileReader* _tmp2_;
			PhotoBackingReaders* _tmp7_;
			PhotoFileReader* _tmp8_;
			PhotoBackingReaders* _tmp13_;
			PhotoFileReader* _tmp14_;
			PhotoFileReader* _tmp15_;
#line 1003 "../src/Photo.vala"
			_tmp1_ = self->priv->readers;
#line 1003 "../src/Photo.vala"
			_tmp2_ = _tmp1_->editable;
#line 1003 "../src/Photo.vala"
			if (_tmp2_ != NULL) {
#line 9131 "Photo.c"
				PhotoBackingReaders* _tmp3_;
				PhotoFileReader* _tmp4_;
				PhotoFileReader* _tmp5_;
#line 1004 "../src/Photo.vala"
				_tmp3_ = self->priv->readers;
#line 1004 "../src/Photo.vala"
				_tmp4_ = _tmp3_->editable;
#line 1004 "../src/Photo.vala"
				_tmp5_ = _photo_file_adapter_ref0 (_tmp4_);
#line 1004 "../src/Photo.vala"
				result = _tmp5_;
#line 9143 "Photo.c"
				{
					PhotoBackingReaders* _tmp6_;
#line 1002 "../src/Photo.vala"
					_tmp6_ = self->priv->readers;
#line 1002 "../src/Photo.vala"
					g_rec_mutex_unlock (&self->priv->__lock_readers);
#line 9150 "Photo.c"
				}
#line 1004 "../src/Photo.vala"
				return result;
#line 9154 "Photo.c"
			}
#line 1006 "../src/Photo.vala"
			_tmp7_ = self->priv->readers;
#line 1006 "../src/Photo.vala"
			_tmp8_ = _tmp7_->developer;
#line 1006 "../src/Photo.vala"
			if (_tmp8_ != NULL) {
#line 9162 "Photo.c"
				PhotoBackingReaders* _tmp9_;
				PhotoFileReader* _tmp10_;
				PhotoFileReader* _tmp11_;
#line 1007 "../src/Photo.vala"
				_tmp9_ = self->priv->readers;
#line 1007 "../src/Photo.vala"
				_tmp10_ = _tmp9_->developer;
#line 1007 "../src/Photo.vala"
				_tmp11_ = _photo_file_adapter_ref0 (_tmp10_);
#line 1007 "../src/Photo.vala"
				result = _tmp11_;
#line 9174 "Photo.c"
				{
					PhotoBackingReaders* _tmp12_;
#line 1002 "../src/Photo.vala"
					_tmp12_ = self->priv->readers;
#line 1002 "../src/Photo.vala"
					g_rec_mutex_unlock (&self->priv->__lock_readers);
#line 9181 "Photo.c"
				}
#line 1007 "../src/Photo.vala"
				return result;
#line 9185 "Photo.c"
			}
#line 1009 "../src/Photo.vala"
			_tmp13_ = self->priv->readers;
#line 1009 "../src/Photo.vala"
			_tmp14_ = _tmp13_->master;
#line 1009 "../src/Photo.vala"
			_tmp15_ = _photo_file_adapter_ref0 (_tmp14_);
#line 1009 "../src/Photo.vala"
			result = _tmp15_;
#line 9195 "Photo.c"
			{
				PhotoBackingReaders* _tmp16_;
#line 1002 "../src/Photo.vala"
				_tmp16_ = self->priv->readers;
#line 1002 "../src/Photo.vala"
				g_rec_mutex_unlock (&self->priv->__lock_readers);
#line 9202 "Photo.c"
			}
#line 1009 "../src/Photo.vala"
			return result;
#line 9206 "Photo.c"
		}
		__finally0:
		{
			PhotoBackingReaders* _tmp17_;
#line 1002 "../src/Photo.vala"
			_tmp17_ = self->priv->readers;
#line 1002 "../src/Photo.vala"
			g_rec_mutex_unlock (&self->priv->__lock_readers);
#line 9215 "Photo.c"
		}
#line 1002 "../src/Photo.vala"
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 1002 "../src/Photo.vala"
		g_clear_error (&_inner_error0_);
#line 1002 "../src/Photo.vala"
		return NULL;
#line 9223 "Photo.c"
	}
}

static PhotoFileReader*
photo_get_raw_developer_reader (Photo* self)
{
	GError* _inner_error0_ = NULL;
	PhotoFileReader* result;
#line 1014 "../src/Photo.vala"
	g_return_val_if_fail (IS_PHOTO (self), NULL);
#line 9234 "Photo.c"
	{
		PhotoBackingReaders* _tmp0_;
#line 1015 "../src/Photo.vala"
		_tmp0_ = self->priv->readers;
#line 1015 "../src/Photo.vala"
		g_rec_mutex_lock (&self->priv->__lock_readers);
#line 9241 "Photo.c"
		{
			PhotoBackingReaders* _tmp1_;
			PhotoFileReader* _tmp2_;
			PhotoFileReader* _tmp3_;
#line 1016 "../src/Photo.vala"
			_tmp1_ = self->priv->readers;
#line 1016 "../src/Photo.vala"
			_tmp2_ = _tmp1_->developer;
#line 1016 "../src/Photo.vala"
			_tmp3_ = _photo_file_adapter_ref0 (_tmp2_);
#line 1016 "../src/Photo.vala"
			result = _tmp3_;
#line 9254 "Photo.c"
			{
				PhotoBackingReaders* _tmp4_;
#line 1015 "../src/Photo.vala"
				_tmp4_ = self->priv->readers;
#line 1015 "../src/Photo.vala"
				g_rec_mutex_unlock (&self->priv->__lock_readers);
#line 9261 "Photo.c"
			}
#line 1016 "../src/Photo.vala"
			return result;
#line 9265 "Photo.c"
		}
		__finally0:
		{
			PhotoBackingReaders* _tmp5_;
#line 1015 "../src/Photo.vala"
			_tmp5_ = self->priv->readers;
#line 1015 "../src/Photo.vala"
			g_rec_mutex_unlock (&self->priv->__lock_readers);
#line 9274 "Photo.c"
		}
#line 1015 "../src/Photo.vala"
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 1015 "../src/Photo.vala"
		g_clear_error (&_inner_error0_);
#line 1015 "../src/Photo.vala"
		return NULL;
#line 9282 "Photo.c"
	}
}

gboolean
photo_is_developed (Photo* self)
{
	GError* _inner_error0_ = NULL;
	gboolean result;
#line 1020 "../src/Photo.vala"
	g_return_val_if_fail (IS_PHOTO (self), FALSE);
#line 9293 "Photo.c"
	{
		PhotoBackingReaders* _tmp0_;
		gboolean _tmp5_ = FALSE;
#line 1021 "../src/Photo.vala"
		_tmp0_ = self->priv->readers;
#line 1021 "../src/Photo.vala"
		g_rec_mutex_lock (&self->priv->__lock_readers);
#line 9301 "Photo.c"
		{
			PhotoBackingReaders* _tmp1_;
			PhotoFileReader* _tmp2_;
#line 1022 "../src/Photo.vala"
			_tmp1_ = self->priv->readers;
#line 1022 "../src/Photo.vala"
			_tmp2_ = _tmp1_->developer;
#line 1022 "../src/Photo.vala"
			result = _tmp2_ != NULL;
#line 9311 "Photo.c"
			{
				PhotoBackingReaders* _tmp3_;
#line 1021 "../src/Photo.vala"
				_tmp3_ = self->priv->readers;
#line 1021 "../src/Photo.vala"
				g_rec_mutex_unlock (&self->priv->__lock_readers);
#line 9318 "Photo.c"
			}
#line 1022 "../src/Photo.vala"
			return result;
#line 9322 "Photo.c"
		}
		__finally0:
		{
			PhotoBackingReaders* _tmp4_;
#line 1021 "../src/Photo.vala"
			_tmp4_ = self->priv->readers;
#line 1021 "../src/Photo.vala"
			g_rec_mutex_unlock (&self->priv->__lock_readers);
#line 9331 "Photo.c"
		}
#line 1021 "../src/Photo.vala"
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 1021 "../src/Photo.vala"
		g_clear_error (&_inner_error0_);
#line 1021 "../src/Photo.vala"
		return _tmp5_;
#line 9339 "Photo.c"
	}
}

gboolean
photo_has_editable (Photo* self)
{
	GError* _inner_error0_ = NULL;
	gboolean result;
#line 1026 "../src/Photo.vala"
	g_return_val_if_fail (IS_PHOTO (self), FALSE);
#line 9350 "Photo.c"
	{
		PhotoBackingReaders* _tmp0_;
		gboolean _tmp5_ = FALSE;
#line 1027 "../src/Photo.vala"
		_tmp0_ = self->priv->readers;
#line 1027 "../src/Photo.vala"
		g_rec_mutex_lock (&self->priv->__lock_readers);
#line 9358 "Photo.c"
		{
			PhotoBackingReaders* _tmp1_;
			PhotoFileReader* _tmp2_;
#line 1028 "../src/Photo.vala"
			_tmp1_ = self->priv->readers;
#line 1028 "../src/Photo.vala"
			_tmp2_ = _tmp1_->editable;
#line 1028 "../src/Photo.vala"
			result = _tmp2_ != NULL;
#line 9368 "Photo.c"
			{
				PhotoBackingReaders* _tmp3_;
#line 1027 "../src/Photo.vala"
				_tmp3_ = self->priv->readers;
#line 1027 "../src/Photo.vala"
				g_rec_mutex_unlock (&self->priv->__lock_readers);
#line 9375 "Photo.c"
			}
#line 1028 "../src/Photo.vala"
			return result;
#line 9379 "Photo.c"
		}
		__finally0:
		{
			PhotoBackingReaders* _tmp4_;
#line 1027 "../src/Photo.vala"
			_tmp4_ = self->priv->readers;
#line 1027 "../src/Photo.vala"
			g_rec_mutex_unlock (&self->priv->__lock_readers);
#line 9388 "Photo.c"
		}
#line 1027 "../src/Photo.vala"
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 1027 "../src/Photo.vala"
		g_clear_error (&_inner_error0_);
#line 1027 "../src/Photo.vala"
		return _tmp5_;
#line 9396 "Photo.c"
	}
}

gboolean
photo_does_master_exist (Photo* self)
{
	GError* _inner_error0_ = NULL;
	gboolean result;
#line 1032 "../src/Photo.vala"
	g_return_val_if_fail (IS_PHOTO (self), FALSE);
#line 9407 "Photo.c"
	{
		PhotoBackingReaders* _tmp0_;
		gboolean _tmp5_ = FALSE;
#line 1033 "../src/Photo.vala"
		_tmp0_ = self->priv->readers;
#line 1033 "../src/Photo.vala"
		g_rec_mutex_lock (&self->priv->__lock_readers);
#line 9415 "Photo.c"
		{
			PhotoBackingReaders* _tmp1_;
			PhotoFileReader* _tmp2_;
#line 1034 "../src/Photo.vala"
			_tmp1_ = self->priv->readers;
#line 1034 "../src/Photo.vala"
			_tmp2_ = _tmp1_->master;
#line 1034 "../src/Photo.vala"
			result = photo_file_adapter_file_exists (G_TYPE_CHECK_INSTANCE_CAST (_tmp2_, TYPE_PHOTO_FILE_ADAPTER, PhotoFileAdapter));
#line 9425 "Photo.c"
			{
				PhotoBackingReaders* _tmp3_;
#line 1033 "../src/Photo.vala"
				_tmp3_ = self->priv->readers;
#line 1033 "../src/Photo.vala"
				g_rec_mutex_unlock (&self->priv->__lock_readers);
#line 9432 "Photo.c"
			}
#line 1034 "../src/Photo.vala"
			return result;
#line 9436 "Photo.c"
		}
		__finally0:
		{
			PhotoBackingReaders* _tmp4_;
#line 1033 "../src/Photo.vala"
			_tmp4_ = self->priv->readers;
#line 1033 "../src/Photo.vala"
			g_rec_mutex_unlock (&self->priv->__lock_readers);
#line 9445 "Photo.c"
		}
#line 1033 "../src/Photo.vala"
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 1033 "../src/Photo.vala"
		g_clear_error (&_inner_error0_);
#line 1033 "../src/Photo.vala"
		return _tmp5_;
#line 9453 "Photo.c"
	}
}

gboolean
photo_does_editable_exist (Photo* self)
{
	GError* _inner_error0_ = NULL;
	gboolean result;
#line 1039 "../src/Photo.vala"
	g_return_val_if_fail (IS_PHOTO (self), FALSE);
#line 9464 "Photo.c"
	{
		PhotoBackingReaders* _tmp0_;
		gboolean _tmp8_ = FALSE;
#line 1040 "../src/Photo.vala"
		_tmp0_ = self->priv->readers;
#line 1040 "../src/Photo.vala"
		g_rec_mutex_lock (&self->priv->__lock_readers);
#line 9472 "Photo.c"
		{
			gboolean _tmp1_ = FALSE;
			PhotoBackingReaders* _tmp2_;
			PhotoFileReader* _tmp3_;
#line 1041 "../src/Photo.vala"
			_tmp2_ = self->priv->readers;
#line 1041 "../src/Photo.vala"
			_tmp3_ = _tmp2_->editable;
#line 1041 "../src/Photo.vala"
			if (_tmp3_ != NULL) {
#line 9483 "Photo.c"
				PhotoBackingReaders* _tmp4_;
				PhotoFileReader* _tmp5_;
#line 1041 "../src/Photo.vala"
				_tmp4_ = self->priv->readers;
#line 1041 "../src/Photo.vala"
				_tmp5_ = _tmp4_->editable;
#line 1041 "../src/Photo.vala"
				_tmp1_ = photo_file_adapter_file_exists (G_TYPE_CHECK_INSTANCE_CAST (_tmp5_, TYPE_PHOTO_FILE_ADAPTER, PhotoFileAdapter));
#line 9492 "Photo.c"
			} else {
#line 1041 "../src/Photo.vala"
				_tmp1_ = FALSE;
#line 9496 "Photo.c"
			}
#line 1041 "../src/Photo.vala"
			result = _tmp1_;
#line 9500 "Photo.c"
			{
				PhotoBackingReaders* _tmp6_;
#line 1040 "../src/Photo.vala"
				_tmp6_ = self->priv->readers;
#line 1040 "../src/Photo.vala"
				g_rec_mutex_unlock (&self->priv->__lock_readers);
#line 9507 "Photo.c"
			}
#line 1041 "../src/Photo.vala"
			return result;
#line 9511 "Photo.c"
		}
		__finally0:
		{
			PhotoBackingReaders* _tmp7_;
#line 1040 "../src/Photo.vala"
			_tmp7_ = self->priv->readers;
#line 1040 "../src/Photo.vala"
			g_rec_mutex_unlock (&self->priv->__lock_readers);
#line 9520 "Photo.c"
		}
#line 1040 "../src/Photo.vala"
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 1040 "../src/Photo.vala"
		g_clear_error (&_inner_error0_);
#line 1040 "../src/Photo.vala"
		return _tmp8_;
#line 9528 "Photo.c"
	}
}

gboolean
photo_is_master_baseline (Photo* self)
{
	GError* _inner_error0_ = NULL;
	gboolean result;
#line 1045 "../src/Photo.vala"
	g_return_val_if_fail (IS_PHOTO (self), FALSE);
#line 9539 "Photo.c"
	{
		PhotoBackingReaders* _tmp0_;
		gboolean _tmp5_ = FALSE;
#line 1046 "../src/Photo.vala"
		_tmp0_ = self->priv->readers;
#line 1046 "../src/Photo.vala"
		g_rec_mutex_lock (&self->priv->__lock_readers);
#line 9547 "Photo.c"
		{
			PhotoBackingReaders* _tmp1_;
			PhotoFileReader* _tmp2_;
#line 1047 "../src/Photo.vala"
			_tmp1_ = self->priv->readers;
#line 1047 "../src/Photo.vala"
			_tmp2_ = _tmp1_->editable;
#line 1047 "../src/Photo.vala"
			result = _tmp2_ == NULL;
#line 9557 "Photo.c"
			{
				PhotoBackingReaders* _tmp3_;
#line 1046 "../src/Photo.vala"
				_tmp3_ = self->priv->readers;
#line 1046 "../src/Photo.vala"
				g_rec_mutex_unlock (&self->priv->__lock_readers);
#line 9564 "Photo.c"
			}
#line 1047 "../src/Photo.vala"
			return result;
#line 9568 "Photo.c"
		}
		__finally0:
		{
			PhotoBackingReaders* _tmp4_;
#line 1046 "../src/Photo.vala"
			_tmp4_ = self->priv->readers;
#line 1046 "../src/Photo.vala"
			g_rec_mutex_unlock (&self->priv->__lock_readers);
#line 9577 "Photo.c"
		}
#line 1046 "../src/Photo.vala"
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 1046 "../src/Photo.vala"
		g_clear_error (&_inner_error0_);
#line 1046 "../src/Photo.vala"
		return _tmp5_;
#line 9585 "Photo.c"
	}
}

gboolean
photo_is_master_source (Photo* self)
{
	gboolean result;
#line 1051 "../src/Photo.vala"
	g_return_val_if_fail (IS_PHOTO (self), FALSE);
#line 1052 "../src/Photo.vala"
	result = !photo_has_editable (self);
#line 1052 "../src/Photo.vala"
	return result;
#line 9599 "Photo.c"
}

gboolean
photo_is_editable_baseline (Photo* self)
{
	GError* _inner_error0_ = NULL;
	gboolean result;
#line 1055 "../src/Photo.vala"
	g_return_val_if_fail (IS_PHOTO (self), FALSE);
#line 9609 "Photo.c"
	{
		PhotoBackingReaders* _tmp0_;
		gboolean _tmp5_ = FALSE;
#line 1056 "../src/Photo.vala"
		_tmp0_ = self->priv->readers;
#line 1056 "../src/Photo.vala"
		g_rec_mutex_lock (&self->priv->__lock_readers);
#line 9617 "Photo.c"
		{
			PhotoBackingReaders* _tmp1_;
			PhotoFileReader* _tmp2_;
#line 1057 "../src/Photo.vala"
			_tmp1_ = self->priv->readers;
#line 1057 "../src/Photo.vala"
			_tmp2_ = _tmp1_->editable;
#line 1057 "../src/Photo.vala"
			result = _tmp2_ != NULL;
#line 9627 "Photo.c"
			{
				PhotoBackingReaders* _tmp3_;
#line 1056 "../src/Photo.vala"
				_tmp3_ = self->priv->readers;
#line 1056 "../src/Photo.vala"
				g_rec_mutex_unlock (&self->priv->__lock_readers);
#line 9634 "Photo.c"
			}
#line 1057 "../src/Photo.vala"
			return result;
#line 9638 "Photo.c"
		}
		__finally0:
		{
			PhotoBackingReaders* _tmp4_;
#line 1056 "../src/Photo.vala"
			_tmp4_ = self->priv->readers;
#line 1056 "../src/Photo.vala"
			g_rec_mutex_unlock (&self->priv->__lock_readers);
#line 9647 "Photo.c"
		}
#line 1056 "../src/Photo.vala"
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 1056 "../src/Photo.vala"
		g_clear_error (&_inner_error0_);
#line 1056 "../src/Photo.vala"
		return _tmp5_;
#line 9655 "Photo.c"
	}
}

gboolean
photo_is_editable_source (Photo* self)
{
	gboolean result;
#line 1061 "../src/Photo.vala"
	g_return_val_if_fail (IS_PHOTO (self), FALSE);
#line 1062 "../src/Photo.vala"
	result = photo_has_editable (self);
#line 1062 "../src/Photo.vala"
	return result;
#line 9669 "Photo.c"
}

BackingPhotoRow*
photo_get_master_photo_row (Photo* self)
{
	GError* _inner_error0_ = NULL;
	BackingPhotoRow* result;
#line 1065 "../src/Photo.vala"
	g_return_val_if_fail (IS_PHOTO (self), NULL);
#line 9679 "Photo.c"
	{
		PhotoRow* _tmp0_;
#line 1066 "../src/Photo.vala"
		_tmp0_ = self->row;
#line 1066 "../src/Photo.vala"
		g_rec_mutex_lock (&self->priv->__lock_row);
#line 9686 "Photo.c"
		{
			PhotoRow* _tmp1_;
			BackingPhotoRow* _tmp2_;
			BackingPhotoRow* _tmp3_;
#line 1067 "../src/Photo.vala"
			_tmp1_ = self->row;
#line 1067 "../src/Photo.vala"
			_tmp2_ = _tmp1_->master;
#line 1067 "../src/Photo.vala"
			_tmp3_ = _backing_photo_row_ref0 (_tmp2_);
#line 1067 "../src/Photo.vala"
			result = _tmp3_;
#line 9699 "Photo.c"
			{
				PhotoRow* _tmp4_;
#line 1066 "../src/Photo.vala"
				_tmp4_ = self->row;
#line 1066 "../src/Photo.vala"
				g_rec_mutex_unlock (&self->priv->__lock_row);
#line 9706 "Photo.c"
			}
#line 1067 "../src/Photo.vala"
			return result;
#line 9710 "Photo.c"
		}
		__finally0:
		{
			PhotoRow* _tmp5_;
#line 1066 "../src/Photo.vala"
			_tmp5_ = self->row;
#line 1066 "../src/Photo.vala"
			g_rec_mutex_unlock (&self->priv->__lock_row);
#line 9719 "Photo.c"
		}
#line 1066 "../src/Photo.vala"
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 1066 "../src/Photo.vala"
		g_clear_error (&_inner_error0_);
#line 1066 "../src/Photo.vala"
		return NULL;
#line 9727 "Photo.c"
	}
}

BackingPhotoRow*
photo_get_editable_photo_row (Photo* self)
{
	GError* _inner_error0_ = NULL;
	BackingPhotoRow* result;
#line 1071 "../src/Photo.vala"
	g_return_val_if_fail (IS_PHOTO (self), NULL);
#line 9738 "Photo.c"
	{
		PhotoRow* _tmp0_;
#line 1072 "../src/Photo.vala"
		_tmp0_ = self->row;
#line 1072 "../src/Photo.vala"
		g_rec_mutex_lock (&self->priv->__lock_row);
#line 9745 "Photo.c"
		{
			PhotoRow* _tmp1_;
#line 1074 "../src/Photo.vala"
			_tmp1_ = self->row;
#line 1074 "../src/Photo.vala"
			if (backing_photo_id_is_valid (&_tmp1_->editable_id)) {
#line 9752 "Photo.c"
				BackingPhotoRow* _tmp2_;
				BackingPhotoRow* _tmp3_;
#line 1075 "../src/Photo.vala"
				_tmp2_ = self->priv->editable;
#line 1075 "../src/Photo.vala"
				_tmp3_ = _backing_photo_row_ref0 (_tmp2_);
#line 1075 "../src/Photo.vala"
				result = _tmp3_;
#line 9761 "Photo.c"
				{
					PhotoRow* _tmp4_;
#line 1072 "../src/Photo.vala"
					_tmp4_ = self->row;
#line 1072 "../src/Photo.vala"
					g_rec_mutex_unlock (&self->priv->__lock_row);
#line 9768 "Photo.c"
				}
#line 1075 "../src/Photo.vala"
				return result;
#line 9772 "Photo.c"
			} else {
#line 1077 "../src/Photo.vala"
				result = NULL;
#line 9776 "Photo.c"
				{
					PhotoRow* _tmp5_;
#line 1072 "../src/Photo.vala"
					_tmp5_ = self->row;
#line 1072 "../src/Photo.vala"
					g_rec_mutex_unlock (&self->priv->__lock_row);
#line 9783 "Photo.c"
				}
#line 1077 "../src/Photo.vala"
				return result;
#line 9787 "Photo.c"
			}
		}
		__finally0:
		{
			PhotoRow* _tmp6_;
#line 1072 "../src/Photo.vala"
			_tmp6_ = self->row;
#line 1072 "../src/Photo.vala"
			g_rec_mutex_unlock (&self->priv->__lock_row);
#line 9797 "Photo.c"
		}
#line 1072 "../src/Photo.vala"
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 1072 "../src/Photo.vala"
		g_clear_error (&_inner_error0_);
#line 1072 "../src/Photo.vala"
		return NULL;
#line 9805 "Photo.c"
	}
}

GeeCollection*
photo_get_raw_development_photo_rows (Photo* self)
{
	GError* _inner_error0_ = NULL;
	GeeCollection* result;
#line 1081 "../src/Photo.vala"
	g_return_val_if_fail (IS_PHOTO (self), NULL);
#line 9816 "Photo.c"
	{
		PhotoRow* _tmp0_;
#line 1082 "../src/Photo.vala"
		_tmp0_ = self->row;
#line 1082 "../src/Photo.vala"
		g_rec_mutex_lock (&self->priv->__lock_row);
#line 9823 "Photo.c"
		{
			GeeCollection* _tmp1_ = NULL;
			GeeHashMap* _tmp2_;
#line 1083 "../src/Photo.vala"
			_tmp2_ = self->priv->developments;
#line 1083 "../src/Photo.vala"
			if (_tmp2_ != NULL) {
#line 9831 "Photo.c"
				GeeHashMap* _tmp3_;
				GeeCollection* _tmp4_;
				GeeCollection* _tmp5_;
#line 1083 "../src/Photo.vala"
				_tmp3_ = self->priv->developments;
#line 1083 "../src/Photo.vala"
				_tmp4_ = gee_abstract_map_get_values (G_TYPE_CHECK_INSTANCE_CAST (_tmp3_, GEE_TYPE_ABSTRACT_MAP, GeeAbstractMap));
#line 1083 "../src/Photo.vala"
				_tmp5_ = _tmp4_;
#line 1083 "../src/Photo.vala"
				_g_object_unref0 (_tmp1_);
#line 1083 "../src/Photo.vala"
				_tmp1_ = _tmp5_;
#line 9845 "Photo.c"
			} else {
#line 1083 "../src/Photo.vala"
				_g_object_unref0 (_tmp1_);
#line 1083 "../src/Photo.vala"
				_tmp1_ = NULL;
#line 9851 "Photo.c"
			}
#line 1083 "../src/Photo.vala"
			result = _tmp1_;
#line 9855 "Photo.c"
			{
				PhotoRow* _tmp6_;
#line 1082 "../src/Photo.vala"
				_tmp6_ = self->row;
#line 1082 "../src/Photo.vala"
				g_rec_mutex_unlock (&self->priv->__lock_row);
#line 9862 "Photo.c"
			}
#line 1083 "../src/Photo.vala"
			return result;
#line 9866 "Photo.c"
		}
		__finally0:
		{
			PhotoRow* _tmp7_;
#line 1082 "../src/Photo.vala"
			_tmp7_ = self->row;
#line 1082 "../src/Photo.vala"
			g_rec_mutex_unlock (&self->priv->__lock_row);
#line 9875 "Photo.c"
		}
#line 1082 "../src/Photo.vala"
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 1082 "../src/Photo.vala"
		g_clear_error (&_inner_error0_);
#line 1082 "../src/Photo.vala"
		return NULL;
#line 9883 "Photo.c"
	}
}

BackingPhotoRow*
photo_get_raw_development_photo_row (Photo* self,
                                     RawDeveloper d)
{
	GError* _inner_error0_ = NULL;
	BackingPhotoRow* result;
#line 1087 "../src/Photo.vala"
	g_return_val_if_fail (IS_PHOTO (self), NULL);
#line 9895 "Photo.c"
	{
		PhotoRow* _tmp0_;
#line 1088 "../src/Photo.vala"
		_tmp0_ = self->row;
#line 1088 "../src/Photo.vala"
		g_rec_mutex_lock (&self->priv->__lock_row);
#line 9902 "Photo.c"
		{
			BackingPhotoRow* _tmp1_ = NULL;
			GeeHashMap* _tmp2_;
#line 1089 "../src/Photo.vala"
			_tmp2_ = self->priv->developments;
#line 1089 "../src/Photo.vala"
			if (_tmp2_ != NULL) {
#line 9910 "Photo.c"
				GeeHashMap* _tmp3_;
				gpointer _tmp4_;
#line 1089 "../src/Photo.vala"
				_tmp3_ = self->priv->developments;
#line 1089 "../src/Photo.vala"
				_tmp4_ = gee_abstract_map_get (G_TYPE_CHECK_INSTANCE_CAST (_tmp3_, GEE_TYPE_ABSTRACT_MAP, GeeAbstractMap), (gpointer) ((gintptr) d));
#line 1089 "../src/Photo.vala"
				_backing_photo_row_unref0 (_tmp1_);
#line 1089 "../src/Photo.vala"
				_tmp1_ = (BackingPhotoRow*) _tmp4_;
#line 9921 "Photo.c"
			} else {
#line 1089 "../src/Photo.vala"
				_backing_photo_row_unref0 (_tmp1_);
#line 1089 "../src/Photo.vala"
				_tmp1_ = NULL;
#line 9927 "Photo.c"
			}
#line 1089 "../src/Photo.vala"
			result = _tmp1_;
#line 9931 "Photo.c"
			{
				PhotoRow* _tmp5_;
#line 1088 "../src/Photo.vala"
				_tmp5_ = self->row;
#line 1088 "../src/Photo.vala"
				g_rec_mutex_unlock (&self->priv->__lock_row);
#line 9938 "Photo.c"
			}
#line 1089 "../src/Photo.vala"
			return result;
#line 9942 "Photo.c"
		}
		__finally0:
		{
			PhotoRow* _tmp6_;
#line 1088 "../src/Photo.vala"
			_tmp6_ = self->row;
#line 1088 "../src/Photo.vala"
			g_rec_mutex_unlock (&self->priv->__lock_row);
#line 9951 "Photo.c"
		}
#line 1088 "../src/Photo.vala"
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 1088 "../src/Photo.vala"
		g_clear_error (&_inner_error0_);
#line 1088 "../src/Photo.vala"
		return NULL;
#line 9959 "Photo.c"
	}
}

static PhotoFileFormat*
_photo_file_format_dup (PhotoFileFormat* self)
{
	PhotoFileFormat* dup;
#line 1099 "../src/Photo.vala"
	dup = g_new0 (PhotoFileFormat, 1);
#line 1099 "../src/Photo.vala"
	memcpy (dup, self, sizeof (PhotoFileFormat));
#line 1099 "../src/Photo.vala"
	return dup;
#line 9973 "Photo.c"
}

static gpointer
__photo_file_format_dup0 (gpointer self)
{
#line 1099 "../src/Photo.vala"
	return self ? _photo_file_format_dup (self) : NULL;
#line 9981 "Photo.c"
}

PhotoFileFormat*
photo_get_editable_file_format (Photo* self)
{
	PhotoFileReader* reader = NULL;
	PhotoFileReader* _tmp0_;
	PhotoFileReader* _tmp1_;
	PhotoFileReader* _tmp2_;
	PhotoFileFormat _tmp3_;
	PhotoFileFormat* _tmp4_;
	PhotoFileFormat* result;
#line 1093 "../src/Photo.vala"
	g_return_val_if_fail (IS_PHOTO (self), NULL);
#line 1094 "../src/Photo.vala"
	_tmp0_ = photo_get_editable_reader (self);
#line 1094 "../src/Photo.vala"
	reader = _tmp0_;
#line 1095 "../src/Photo.vala"
	_tmp1_ = reader;
#line 1095 "../src/Photo.vala"
	if (_tmp1_ == NULL) {
#line 1096 "../src/Photo.vala"
		result = NULL;
#line 1096 "../src/Photo.vala"
		_photo_file_adapter_unref0 (reader);
#line 1096 "../src/Photo.vala"
		return result;
#line 10010 "Photo.c"
	}
#line 1099 "../src/Photo.vala"
	_tmp2_ = reader;
#line 1099 "../src/Photo.vala"
	_tmp3_ = photo_file_adapter_get_file_format (G_TYPE_CHECK_INSTANCE_CAST (_tmp2_, TYPE_PHOTO_FILE_ADAPTER, PhotoFileAdapter));
#line 1099 "../src/Photo.vala"
	_tmp4_ = __photo_file_format_dup0 (&_tmp3_);
#line 1099 "../src/Photo.vala"
	result = _tmp4_;
#line 1099 "../src/Photo.vala"
	_photo_file_adapter_unref0 (reader);
#line 1099 "../src/Photo.vala"
	return result;
#line 10024 "Photo.c"
}

PhotoFileFormat
photo_get_export_format_for_parameters (Photo* self,
                                        ExportFormatParameters* params)
{
	PhotoFileFormat _result_ = 0;
	ExportFormatParameters _tmp0_;
	PhotoFileFormat result;
#line 1102 "../src/Photo.vala"
	g_return_val_if_fail (IS_PHOTO (self), 0);
#line 1102 "../src/Photo.vala"
	g_return_val_if_fail (params != NULL, 0);
#line 1103 "../src/Photo.vala"
	_result_ = photo_file_format_get_system_default_format ();
#line 1105 "../src/Photo.vala"
	_tmp0_ = *params;
#line 1105 "../src/Photo.vala"
	switch (_tmp0_.mode) {
#line 1105 "../src/Photo.vala"
		case EXPORT_FORMAT_MODE_UNMODIFIED:
#line 10046 "Photo.c"
		{
#line 1107 "../src/Photo.vala"
			_result_ = photo_get_master_file_format (self);
#line 1108 "../src/Photo.vala"
			break;
#line 10052 "Photo.c"
		}
#line 1105 "../src/Photo.vala"
		case EXPORT_FORMAT_MODE_CURRENT:
#line 10056 "Photo.c"
		{
#line 1111 "../src/Photo.vala"
			_result_ = photo_get_best_export_file_format (self);
#line 1112 "../src/Photo.vala"
			break;
#line 10062 "Photo.c"
		}
#line 1105 "../src/Photo.vala"
		case EXPORT_FORMAT_MODE_SPECIFIED:
#line 10066 "Photo.c"
		{
			ExportFormatParameters _tmp1_;
#line 1115 "../src/Photo.vala"
			_tmp1_ = *params;
#line 1115 "../src/Photo.vala"
			_result_ = _tmp1_.specified_format;
#line 1116 "../src/Photo.vala"
			break;
#line 10075 "Photo.c"
		}
		default:
		{
#line 1119 "../src/Photo.vala"
			g_error ("Photo.vala:1119: get_export_format_for_parameters: unsupported export " \
"format mode");
#line 10081 "Photo.c"
		}
	}
#line 1122 "../src/Photo.vala"
	result = _result_;
#line 1122 "../src/Photo.vala"
	return result;
#line 10088 "Photo.c"
}

gchar*
photo_get_export_basename_for_parameters (Photo* self,
                                          ExportFormatParameters* params)
{
	gchar* _result_ = NULL;
	ExportFormatParameters _tmp0_;
	const gchar* _tmp7_;
	gchar* result;
#line 1125 "../src/Photo.vala"
	g_return_val_if_fail (IS_PHOTO (self), NULL);
#line 1125 "../src/Photo.vala"
	g_return_val_if_fail (params != NULL, NULL);
#line 1126 "../src/Photo.vala"
	_result_ = NULL;
#line 1128 "../src/Photo.vala"
	_tmp0_ = *params;
#line 1128 "../src/Photo.vala"
	switch (_tmp0_.mode) {
#line 1128 "../src/Photo.vala"
		case EXPORT_FORMAT_MODE_UNMODIFIED:
#line 10111 "Photo.c"
		{
			GFile* _tmp1_;
			GFile* _tmp2_;
			gchar* _tmp3_;
#line 1130 "../src/Photo.vala"
			_tmp1_ = media_source_get_master_file (G_TYPE_CHECK_INSTANCE_CAST (self, TYPE_MEDIA_SOURCE, MediaSource));
#line 1130 "../src/Photo.vala"
			_tmp2_ = _tmp1_;
#line 1130 "../src/Photo.vala"
			_tmp3_ = g_file_get_basename (_tmp2_);
#line 1130 "../src/Photo.vala"
			_g_free0 (_result_);
#line 1130 "../src/Photo.vala"
			_result_ = _tmp3_;
#line 1130 "../src/Photo.vala"
			_g_object_unref0 (_tmp2_);
#line 1131 "../src/Photo.vala"
			break;
#line 10130 "Photo.c"
		}
#line 1128 "../src/Photo.vala"
		case EXPORT_FORMAT_MODE_CURRENT:
#line 1128 "../src/Photo.vala"
		case EXPORT_FORMAT_MODE_SPECIFIED:
#line 10136 "Photo.c"
		{
			ExportFormatParameters _tmp4_;
			PhotoFileFormat _tmp5_;
			gchar* _tmp6_;
#line 1135 "../src/Photo.vala"
			_tmp4_ = *params;
#line 1135 "../src/Photo.vala"
			_tmp5_ = photo_get_export_format_for_parameters (self, &_tmp4_);
#line 1135 "../src/Photo.vala"
			_tmp6_ = photo_get_export_basename (self, &_tmp5_);
#line 1135 "../src/Photo.vala"
			result = _tmp6_;
#line 1135 "../src/Photo.vala"
			_g_free0 (_result_);
#line 1135 "../src/Photo.vala"
			return result;
#line 10153 "Photo.c"
		}
		default:
		{
#line 1138 "../src/Photo.vala"
			g_error ("Photo.vala:1138: get_export_basename_for_parameters: unsupported expor" \
"t format mode");
#line 10159 "Photo.c"
		}
	}
#line 1141 "../src/Photo.vala"
	_tmp7_ = _result_;
#line 1141 "../src/Photo.vala"
	_vala_assert (_tmp7_ != NULL, "result != null");
#line 1142 "../src/Photo.vala"
	result = _result_;
#line 1142 "../src/Photo.vala"
	return result;
#line 10170 "Photo.c"
}

ImportResult
photo_prepare_for_import (PhotoImportParams* params)
{
	GFile* file = NULL;
	GFile* _tmp0_;
	GFile* _tmp1_;
	GFileInfo* info = NULL;
	GFileInfo* _tmp6_;
	GFile* _tmp7_;
	GFile* _tmp11_;
	GDateTime* timestamp = NULL;
	GFileInfo* _tmp15_;
	GDateTime* _tmp16_;
	GDateTime* _tmp17_;
	GDateTime* _tmp18_;
	GDateTime* _tmp19_;
	gboolean _tmp20_ = FALSE;
	gboolean _tmp21_ = FALSE;
	const gchar* _tmp22_;
	PhotoFileInterrogator* interrogator = NULL;
	GFile* _tmp25_;
	PhotoFileInterrogator* _tmp26_;
	PhotoFileInterrogator* _tmp33_;
	DetectedPhotoInformation* detected = NULL;
	PhotoFileInterrogator* _tmp34_;
	DetectedPhotoInformation* _tmp35_;
	gboolean _tmp36_ = FALSE;
	DetectedPhotoInformation* _tmp37_;
	Orientation orientation = 0;
	GDateTime* exposure_time = NULL;
	gchar* title = NULL;
	gchar* _tmp48_;
	GpsCoords gps_coords = {0};
	gchar* comment = NULL;
	gchar* _tmp49_;
	Rating rating = 0;
	DetectedPhotoInformation* _tmp50_;
	PhotoMetadata* _tmp51_;
	gboolean _tmp74_ = FALSE;
	gboolean _tmp75_ = FALSE;
	DetectedPhotoInformation* _tmp76_;
	PhotoRow* _tmp82_;
	PhotoRow* _tmp83_;
	BackingPhotoRow* _tmp84_;
	GFile* _tmp85_;
	gchar* _tmp86_;
	PhotoRow* _tmp87_;
	BackingPhotoRow* _tmp88_;
	DetectedPhotoInformation* _tmp89_;
	Dimensions _tmp90_;
	PhotoRow* _tmp91_;
	BackingPhotoRow* _tmp92_;
	GFileInfo* _tmp93_;
	PhotoRow* _tmp94_;
	BackingPhotoRow* _tmp95_;
	GDateTime* _tmp96_;
	GDateTime* _tmp97_;
	PhotoRow* _tmp98_;
	GDateTime* _tmp99_;
	GDateTime* _tmp100_;
	PhotoRow* _tmp101_;
	PhotoRow* _tmp102_;
	BackingPhotoRow* _tmp103_;
	PhotoRow* _tmp104_;
	ImportID _tmp105_;
	PhotoRow* _tmp106_;
	PhotoRow* _tmp107_;
	PhotoRow* _tmp108_;
	DetectedPhotoInformation* _tmp109_;
	const gchar* _tmp110_;
	gchar* _tmp111_;
	PhotoRow* _tmp112_;
	DetectedPhotoInformation* _tmp113_;
	const gchar* _tmp114_;
	gchar* _tmp115_;
	PhotoRow* _tmp116_;
	DetectedPhotoInformation* _tmp117_;
	const gchar* _tmp118_;
	gchar* _tmp119_;
	PhotoRow* _tmp120_;
	PhotoRow* _tmp121_;
	PhotoRow* _tmp122_;
	BackingPhotoRow* _tmp123_;
	DetectedPhotoInformation* _tmp124_;
	PhotoRow* _tmp125_;
	const gchar* _tmp126_;
	gchar* _tmp127_;
	PhotoRow* _tmp128_;
	GpsCoords _tmp129_;
	PhotoRow* _tmp130_;
	const gchar* _tmp131_;
	gchar* _tmp132_;
	PhotoRow* _tmp133_;
	Thumbnails* _tmp134_;
	GError* _inner_error0_ = NULL;
	ImportResult result;
#line 1157 "../src/Photo.vala"
	g_return_val_if_fail (IS_PHOTO_IMPORT_PARAMS (params), 0);
#line 1161 "../src/Photo.vala"
	_tmp0_ = params->file;
#line 1161 "../src/Photo.vala"
	_tmp1_ = _g_object_ref0 (_tmp0_);
#line 1161 "../src/Photo.vala"
	file = _tmp1_;
#line 1163 "../src/Photo.vala"
	info = NULL;
#line 10279 "Photo.c"
	{
		GFileInfo* _tmp2_ = NULL;
		GFile* _tmp3_;
		GFileInfo* _tmp4_;
		GFileInfo* _tmp5_;
#line 1165 "../src/Photo.vala"
		_tmp3_ = file;
#line 1165 "../src/Photo.vala"
		_tmp4_ = g_file_query_info (_tmp3_, DIRECTORY_MONITOR_SUPPLIED_ATTRIBUTES, G_FILE_QUERY_INFO_NOFOLLOW_SYMLINKS, NULL, &_inner_error0_);
#line 1165 "../src/Photo.vala"
		_tmp2_ = _tmp4_;
#line 1165 "../src/Photo.vala"
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 10293 "Photo.c"
			goto __catch0_g_error;
		}
#line 1165 "../src/Photo.vala"
		_tmp5_ = _tmp2_;
#line 1165 "../src/Photo.vala"
		_tmp2_ = NULL;
#line 1165 "../src/Photo.vala"
		_g_object_unref0 (info);
#line 1165 "../src/Photo.vala"
		info = _tmp5_;
#line 1164 "../src/Photo.vala"
		_g_object_unref0 (_tmp2_);
#line 10306 "Photo.c"
	}
	goto __finally0;
	__catch0_g_error:
	{
#line 1164 "../src/Photo.vala"
		g_clear_error (&_inner_error0_);
#line 1168 "../src/Photo.vala"
		result = IMPORT_RESULT_FILE_ERROR;
#line 1168 "../src/Photo.vala"
		_g_object_unref0 (info);
#line 1168 "../src/Photo.vala"
		_g_object_unref0 (file);
#line 1168 "../src/Photo.vala"
		return result;
#line 10321 "Photo.c"
	}
	__finally0:
#line 1164 "../src/Photo.vala"
	if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 1164 "../src/Photo.vala"
		_g_object_unref0 (info);
#line 1164 "../src/Photo.vala"
		_g_object_unref0 (file);
#line 1164 "../src/Photo.vala"
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 1164 "../src/Photo.vala"
		g_clear_error (&_inner_error0_);
#line 1164 "../src/Photo.vala"
		return 0;
#line 10336 "Photo.c"
	}
#line 1171 "../src/Photo.vala"
	_tmp6_ = info;
#line 1171 "../src/Photo.vala"
	if (g_file_info_get_file_type (_tmp6_) != G_FILE_TYPE_REGULAR) {
#line 1172 "../src/Photo.vala"
		result = IMPORT_RESULT_NOT_A_FILE;
#line 1172 "../src/Photo.vala"
		_g_object_unref0 (info);
#line 1172 "../src/Photo.vala"
		_g_object_unref0 (file);
#line 1172 "../src/Photo.vala"
		return result;
#line 10350 "Photo.c"
	}
#line 1174 "../src/Photo.vala"
	_tmp7_ = file;
#line 1174 "../src/Photo.vala"
	if (!photo_is_file_image (_tmp7_)) {
#line 10356 "Photo.c"
		GFile* _tmp8_;
		gchar* _tmp9_;
		gchar* _tmp10_;
#line 1175 "../src/Photo.vala"
		_tmp8_ = file;
#line 1175 "../src/Photo.vala"
		_tmp9_ = g_file_get_path (_tmp8_);
#line 1175 "../src/Photo.vala"
		_tmp10_ = _tmp9_;
#line 1175 "../src/Photo.vala"
		g_message ("Photo.vala:1175: Not importing %s: Not an image file", _tmp10_);
#line 1175 "../src/Photo.vala"
		_g_free0 (_tmp10_);
#line 1177 "../src/Photo.vala"
		result = IMPORT_RESULT_NOT_AN_IMAGE;
#line 1177 "../src/Photo.vala"
		_g_object_unref0 (info);
#line 1177 "../src/Photo.vala"
		_g_object_unref0 (file);
#line 1177 "../src/Photo.vala"
		return result;
#line 10378 "Photo.c"
	}
#line 1180 "../src/Photo.vala"
	_tmp11_ = file;
#line 1180 "../src/Photo.vala"
	if (!photo_file_format_is_file_supported (_tmp11_)) {
#line 10384 "Photo.c"
		GFile* _tmp12_;
		gchar* _tmp13_;
		gchar* _tmp14_;
#line 1181 "../src/Photo.vala"
		_tmp12_ = file;
#line 1181 "../src/Photo.vala"
		_tmp13_ = g_file_get_path (_tmp12_);
#line 1181 "../src/Photo.vala"
		_tmp14_ = _tmp13_;
#line 1181 "../src/Photo.vala"
		g_message ("Photo.vala:1181: Not importing %s: Unsupported extension", _tmp14_);
#line 1181 "../src/Photo.vala"
		_g_free0 (_tmp14_);
#line 1183 "../src/Photo.vala"
		result = IMPORT_RESULT_UNSUPPORTED_FORMAT;
#line 1183 "../src/Photo.vala"
		_g_object_unref0 (info);
#line 1183 "../src/Photo.vala"
		_g_object_unref0 (file);
#line 1183 "../src/Photo.vala"
		return result;
#line 10406 "Photo.c"
	}
#line 1186 "../src/Photo.vala"
	_tmp15_ = info;
#line 1186 "../src/Photo.vala"
	_tmp16_ = g_file_info_get_modification_date_time (_tmp15_);
#line 1186 "../src/Photo.vala"
	_tmp17_ = _tmp16_;
#line 1186 "../src/Photo.vala"
	_tmp18_ = coarsify_date_time (_tmp17_);
#line 1186 "../src/Photo.vala"
	_tmp19_ = _tmp18_;
#line 1186 "../src/Photo.vala"
	_g_date_time_unref0 (_tmp17_);
#line 1186 "../src/Photo.vala"
	timestamp = _tmp19_;
#line 1189 "../src/Photo.vala"
	_tmp22_ = params->exif_md5;
#line 1189 "../src/Photo.vala"
	if (_tmp22_ != NULL) {
#line 10426 "Photo.c"
		const gchar* _tmp23_;
#line 1189 "../src/Photo.vala"
		_tmp23_ = params->thumbnail_md5;
#line 1189 "../src/Photo.vala"
		_tmp21_ = _tmp23_ != NULL;
#line 10432 "Photo.c"
	} else {
#line 1189 "../src/Photo.vala"
		_tmp21_ = FALSE;
#line 10436 "Photo.c"
	}
#line 1189 "../src/Photo.vala"
	if (_tmp21_) {
#line 10440 "Photo.c"
		const gchar* _tmp24_;
#line 1189 "../src/Photo.vala"
		_tmp24_ = params->full_md5;
#line 1189 "../src/Photo.vala"
		_tmp20_ = _tmp24_ != NULL;
#line 10446 "Photo.c"
	} else {
#line 1189 "../src/Photo.vala"
		_tmp20_ = FALSE;
#line 10450 "Photo.c"
	}
#line 1189 "../src/Photo.vala"
	if (_tmp20_) {
#line 1190 "../src/Photo.vala"
		params->sniffer_options = params->sniffer_options | PHOTO_FILE_SNIFFER_OPTIONS_NO_MD5;
#line 10456 "Photo.c"
	}
#line 1193 "../src/Photo.vala"
	_tmp25_ = file;
#line 1193 "../src/Photo.vala"
	_tmp26_ = photo_file_interrogator_new (_tmp25_, params->sniffer_options);
#line 1193 "../src/Photo.vala"
	interrogator = _tmp26_;
#line 10464 "Photo.c"
	{
		PhotoFileInterrogator* _tmp27_;
#line 1195 "../src/Photo.vala"
		_tmp27_ = interrogator;
#line 1195 "../src/Photo.vala"
		photo_file_interrogator_interrogate (_tmp27_, &_inner_error0_);
#line 1195 "../src/Photo.vala"
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 10473 "Photo.c"
			goto __catch1_g_error;
		}
	}
	goto __finally1;
	__catch1_g_error:
	{
		GError* err = NULL;
		GFile* _tmp28_;
		gchar* _tmp29_;
		gchar* _tmp30_;
		GError* _tmp31_;
		const gchar* _tmp32_;
#line 1194 "../src/Photo.vala"
		err = _inner_error0_;
#line 1194 "../src/Photo.vala"
		_inner_error0_ = NULL;
#line 1197 "../src/Photo.vala"
		_tmp28_ = file;
#line 1197 "../src/Photo.vala"
		_tmp29_ = g_file_get_path (_tmp28_);
#line 1197 "../src/Photo.vala"
		_tmp30_ = _tmp29_;
#line 1197 "../src/Photo.vala"
		_tmp31_ = err;
#line 1197 "../src/Photo.vala"
		_tmp32_ = _tmp31_->message;
#line 1197 "../src/Photo.vala"
		g_warning ("Photo.vala:1197: Unable to interrogate photo file %s: %s", _tmp30_, _tmp32_);
#line 1197 "../src/Photo.vala"
		_g_free0 (_tmp30_);
#line 1199 "../src/Photo.vala"
		result = IMPORT_RESULT_DECODE_ERROR;
#line 1199 "../src/Photo.vala"
		_g_error_free0 (err);
#line 1199 "../src/Photo.vala"
		_photo_file_interrogator_unref0 (interrogator);
#line 1199 "../src/Photo.vala"
		_g_date_time_unref0 (timestamp);
#line 1199 "../src/Photo.vala"
		_g_object_unref0 (info);
#line 1199 "../src/Photo.vala"
		_g_object_unref0 (file);
#line 1199 "../src/Photo.vala"
		return result;
#line 10518 "Photo.c"
	}
	__finally1:
#line 1194 "../src/Photo.vala"
	if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 1194 "../src/Photo.vala"
		_photo_file_interrogator_unref0 (interrogator);
#line 1194 "../src/Photo.vala"
		_g_date_time_unref0 (timestamp);
#line 1194 "../src/Photo.vala"
		_g_object_unref0 (info);
#line 1194 "../src/Photo.vala"
		_g_object_unref0 (file);
#line 1194 "../src/Photo.vala"
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 1194 "../src/Photo.vala"
		g_clear_error (&_inner_error0_);
#line 1194 "../src/Photo.vala"
		return 0;
#line 10537 "Photo.c"
	}
#line 1202 "../src/Photo.vala"
	_tmp33_ = interrogator;
#line 1202 "../src/Photo.vala"
	if (photo_file_interrogator_get_is_photo_corrupted (_tmp33_)) {
#line 1203 "../src/Photo.vala"
		result = IMPORT_RESULT_NOT_AN_IMAGE;
#line 1203 "../src/Photo.vala"
		_photo_file_interrogator_unref0 (interrogator);
#line 1203 "../src/Photo.vala"
		_g_date_time_unref0 (timestamp);
#line 1203 "../src/Photo.vala"
		_g_object_unref0 (info);
#line 1203 "../src/Photo.vala"
		_g_object_unref0 (file);
#line 1203 "../src/Photo.vala"
		return result;
#line 10555 "Photo.c"
	}
#line 1206 "../src/Photo.vala"
	_tmp34_ = interrogator;
#line 1206 "../src/Photo.vala"
	_tmp35_ = photo_file_interrogator_get_detected_photo_information (_tmp34_);
#line 1206 "../src/Photo.vala"
	detected = _tmp35_;
#line 1207 "../src/Photo.vala"
	_tmp37_ = detected;
#line 1207 "../src/Photo.vala"
	if (_tmp37_ == NULL) {
#line 1207 "../src/Photo.vala"
		_tmp36_ = TRUE;
#line 10569 "Photo.c"
	} else {
		DetectedPhotoInformation* _tmp38_;
#line 1207 "../src/Photo.vala"
		_tmp38_ = detected;
#line 1207 "../src/Photo.vala"
		_tmp36_ = _tmp38_->file_format == PHOTO_FILE_FORMAT_UNKNOWN;
#line 10576 "Photo.c"
	}
#line 1207 "../src/Photo.vala"
	if (_tmp36_) {
#line 1208 "../src/Photo.vala"
		result = IMPORT_RESULT_UNSUPPORTED_FORMAT;
#line 1208 "../src/Photo.vala"
		_detected_photo_information_unref0 (detected);
#line 1208 "../src/Photo.vala"
		_photo_file_interrogator_unref0 (interrogator);
#line 1208 "../src/Photo.vala"
		_g_date_time_unref0 (timestamp);
#line 1208 "../src/Photo.vala"
		_g_object_unref0 (info);
#line 1208 "../src/Photo.vala"
		_g_object_unref0 (file);
#line 1208 "../src/Photo.vala"
		return result;
#line 10594 "Photo.c"
	}
#line 1211 "../src/Photo.vala"
	if ((params->sniffer_options & PHOTO_FILE_SNIFFER_OPTIONS_NO_MD5) != 0) {
#line 10598 "Photo.c"
		DetectedPhotoInformation* _tmp39_;
		const gchar* _tmp40_;
		gchar* _tmp41_;
		DetectedPhotoInformation* _tmp42_;
		const gchar* _tmp43_;
		gchar* _tmp44_;
		DetectedPhotoInformation* _tmp45_;
		const gchar* _tmp46_;
		gchar* _tmp47_;
#line 1212 "../src/Photo.vala"
		_tmp39_ = detected;
#line 1212 "../src/Photo.vala"
		_tmp40_ = params->exif_md5;
#line 1212 "../src/Photo.vala"
		_tmp41_ = g_strdup (_tmp40_);
#line 1212 "../src/Photo.vala"
		_g_free0 (_tmp39_->exif_md5);
#line 1212 "../src/Photo.vala"
		_tmp39_->exif_md5 = _tmp41_;
#line 1213 "../src/Photo.vala"
		_tmp42_ = detected;
#line 1213 "../src/Photo.vala"
		_tmp43_ = params->thumbnail_md5;
#line 1213 "../src/Photo.vala"
		_tmp44_ = g_strdup (_tmp43_);
#line 1213 "../src/Photo.vala"
		_g_free0 (_tmp42_->thumbnail_md5);
#line 1213 "../src/Photo.vala"
		_tmp42_->thumbnail_md5 = _tmp44_;
#line 1214 "../src/Photo.vala"
		_tmp45_ = detected;
#line 1214 "../src/Photo.vala"
		_tmp46_ = params->full_md5;
#line 1214 "../src/Photo.vala"
		_tmp47_ = g_strdup (_tmp46_);
#line 1214 "../src/Photo.vala"
		_g_free0 (_tmp45_->md5);
#line 1214 "../src/Photo.vala"
		_tmp45_->md5 = _tmp47_;
#line 10638 "Photo.c"
	}
#line 1217 "../src/Photo.vala"
	orientation = ORIENTATION_TOP_LEFT;
#line 1218 "../src/Photo.vala"
	exposure_time = NULL;
#line 1219 "../src/Photo.vala"
	_tmp48_ = g_strdup ("");
#line 1219 "../src/Photo.vala"
	title = _tmp48_;
#line 1220 "../src/Photo.vala"
	memset (&gps_coords, 0, sizeof (GpsCoords));
#line 1221 "../src/Photo.vala"
	_tmp49_ = g_strdup ("");
#line 1221 "../src/Photo.vala"
	comment = _tmp49_;
#line 1222 "../src/Photo.vala"
	rating = RATING_UNRATED;
#line 1229 "../src/Photo.vala"
	_tmp50_ = detected;
#line 1229 "../src/Photo.vala"
	_tmp51_ = _tmp50_->metadata;
#line 1229 "../src/Photo.vala"
	if (_tmp51_ != NULL) {
#line 10662 "Photo.c"
		MetadataDateTime* date_time = NULL;
		DetectedPhotoInformation* _tmp52_;
		PhotoMetadata* _tmp53_;
		MetadataDateTime* _tmp54_;
		MetadataDateTime* _tmp55_;
		DetectedPhotoInformation* _tmp58_;
		PhotoMetadata* _tmp59_;
		DetectedPhotoInformation* _tmp60_;
		PhotoMetadata* _tmp61_;
		gchar* _tmp62_;
		DetectedPhotoInformation* _tmp63_;
		PhotoMetadata* _tmp64_;
		GpsCoords _tmp65_ = {0};
		DetectedPhotoInformation* _tmp66_;
		PhotoMetadata* _tmp67_;
		gchar* _tmp68_;
		DetectedPhotoInformation* _tmp69_;
		PhotoMetadata* _tmp70_;
		GeeSet* _tmp71_;
		DetectedPhotoInformation* _tmp72_;
		PhotoMetadata* _tmp73_;
#line 1230 "../src/Photo.vala"
		_tmp52_ = detected;
#line 1230 "../src/Photo.vala"
		_tmp53_ = _tmp52_->metadata;
#line 1230 "../src/Photo.vala"
		_tmp54_ = photo_metadata_get_exposure_date_time (_tmp53_);
#line 1230 "../src/Photo.vala"
		date_time = _tmp54_;
#line 1231 "../src/Photo.vala"
		_tmp55_ = date_time;
#line 1231 "../src/Photo.vala"
		if (_tmp55_ != NULL) {
#line 10696 "Photo.c"
			MetadataDateTime* _tmp56_;
			GDateTime* _tmp57_;
#line 1232 "../src/Photo.vala"
			_tmp56_ = date_time;
#line 1232 "../src/Photo.vala"
			_tmp57_ = metadata_date_time_get_timestamp (_tmp56_);
#line 1232 "../src/Photo.vala"
			_g_date_time_unref0 (exposure_time);
#line 1232 "../src/Photo.vala"
			exposure_time = _tmp57_;
#line 10707 "Photo.c"
		}
#line 1234 "../src/Photo.vala"
		_tmp58_ = detected;
#line 1234 "../src/Photo.vala"
		_tmp59_ = _tmp58_->metadata;
#line 1234 "../src/Photo.vala"
		orientation = photo_metadata_get_orientation (_tmp59_);
#line 1235 "../src/Photo.vala"
		_tmp60_ = detected;
#line 1235 "../src/Photo.vala"
		_tmp61_ = _tmp60_->metadata;
#line 1235 "../src/Photo.vala"
		_tmp62_ = media_metadata_get_title (G_TYPE_CHECK_INSTANCE_CAST (_tmp61_, TYPE_MEDIA_METADATA, MediaMetadata));
#line 1235 "../src/Photo.vala"
		_g_free0 (title);
#line 1235 "../src/Photo.vala"
		title = _tmp62_;
#line 1236 "../src/Photo.vala"
		_tmp63_ = detected;
#line 1236 "../src/Photo.vala"
		_tmp64_ = _tmp63_->metadata;
#line 1236 "../src/Photo.vala"
		photo_metadata_get_gps_coords (_tmp64_, &_tmp65_);
#line 1236 "../src/Photo.vala"
		gps_coords = _tmp65_;
#line 1237 "../src/Photo.vala"
		_tmp66_ = detected;
#line 1237 "../src/Photo.vala"
		_tmp67_ = _tmp66_->metadata;
#line 1237 "../src/Photo.vala"
		_tmp68_ = media_metadata_get_comment (G_TYPE_CHECK_INSTANCE_CAST (_tmp67_, TYPE_MEDIA_METADATA, MediaMetadata));
#line 1237 "../src/Photo.vala"
		_g_free0 (comment);
#line 1237 "../src/Photo.vala"
		comment = _tmp68_;
#line 1238 "../src/Photo.vala"
		_tmp69_ = detected;
#line 1238 "../src/Photo.vala"
		_tmp70_ = _tmp69_->metadata;
#line 1238 "../src/Photo.vala"
		_tmp71_ = photo_metadata_get_keywords (_tmp70_, NULL, NULL, NULL);
#line 1238 "../src/Photo.vala"
		_g_object_unref0 (params->keywords);
#line 1238 "../src/Photo.vala"
		params->keywords = G_TYPE_CHECK_INSTANCE_CAST (_tmp71_, GEE_TYPE_COLLECTION, GeeCollection);
#line 1239 "../src/Photo.vala"
		_tmp72_ = detected;
#line 1239 "../src/Photo.vala"
		_tmp73_ = _tmp72_->metadata;
#line 1239 "../src/Photo.vala"
		rating = photo_metadata_get_rating (_tmp73_);
#line 1229 "../src/Photo.vala"
		_metadata_date_time_unref0 (date_time);
#line 10761 "Photo.c"
	}
#line 1243 "../src/Photo.vala"
	_tmp76_ = detected;
#line 1243 "../src/Photo.vala"
	if (_tmp76_->colorspace != GDK_COLORSPACE_RGB) {
#line 1243 "../src/Photo.vala"
		_tmp75_ = TRUE;
#line 10769 "Photo.c"
	} else {
		DetectedPhotoInformation* _tmp77_;
#line 1244 "../src/Photo.vala"
		_tmp77_ = detected;
#line 1244 "../src/Photo.vala"
		_tmp75_ = _tmp77_->channels < 3;
#line 10776 "Photo.c"
	}
#line 1243 "../src/Photo.vala"
	if (_tmp75_) {
#line 1243 "../src/Photo.vala"
		_tmp74_ = TRUE;
#line 10782 "Photo.c"
	} else {
		DetectedPhotoInformation* _tmp78_;
#line 1245 "../src/Photo.vala"
		_tmp78_ = detected;
#line 1245 "../src/Photo.vala"
		_tmp74_ = _tmp78_->bits_per_channel != 8;
#line 10789 "Photo.c"
	}
#line 1243 "../src/Photo.vala"
	if (_tmp74_) {
#line 10793 "Photo.c"
		GFile* _tmp79_;
		gchar* _tmp80_;
		gchar* _tmp81_;
#line 1246 "../src/Photo.vala"
		_tmp79_ = file;
#line 1246 "../src/Photo.vala"
		_tmp80_ = g_file_get_path (_tmp79_);
#line 1246 "../src/Photo.vala"
		_tmp81_ = _tmp80_;
#line 1246 "../src/Photo.vala"
		g_message ("Photo.vala:1246: Not importing %s: Unsupported color format", _tmp81_);
#line 1246 "../src/Photo.vala"
		_g_free0 (_tmp81_);
#line 1248 "../src/Photo.vala"
		result = IMPORT_RESULT_UNSUPPORTED_FORMAT;
#line 1248 "../src/Photo.vala"
		_g_free0 (comment);
#line 1248 "../src/Photo.vala"
		_g_free0 (title);
#line 1248 "../src/Photo.vala"
		_g_date_time_unref0 (exposure_time);
#line 1248 "../src/Photo.vala"
		_detected_photo_information_unref0 (detected);
#line 1248 "../src/Photo.vala"
		_photo_file_interrogator_unref0 (interrogator);
#line 1248 "../src/Photo.vala"
		_g_date_time_unref0 (timestamp);
#line 1248 "../src/Photo.vala"
		_g_object_unref0 (info);
#line 1248 "../src/Photo.vala"
		_g_object_unref0 (file);
#line 1248 "../src/Photo.vala"
		return result;
#line 10827 "Photo.c"
	}
#line 1254 "../src/Photo.vala"
	_tmp82_ = params->row;
#line 1254 "../src/Photo.vala"
	photo_id_init (&_tmp82_->photo_id, PHOTO_ID_INVALID);
#line 1255 "../src/Photo.vala"
	_tmp83_ = params->row;
#line 1255 "../src/Photo.vala"
	_tmp84_ = _tmp83_->master;
#line 1255 "../src/Photo.vala"
	_tmp85_ = file;
#line 1255 "../src/Photo.vala"
	_tmp86_ = g_file_get_path (_tmp85_);
#line 1255 "../src/Photo.vala"
	_g_free0 (_tmp84_->filepath);
#line 1255 "../src/Photo.vala"
	_tmp84_->filepath = _tmp86_;
#line 1256 "../src/Photo.vala"
	_tmp87_ = params->row;
#line 1256 "../src/Photo.vala"
	_tmp88_ = _tmp87_->master;
#line 1256 "../src/Photo.vala"
	_tmp89_ = detected;
#line 1256 "../src/Photo.vala"
	_tmp90_ = _tmp89_->image_dim;
#line 1256 "../src/Photo.vala"
	_tmp88_->dim = _tmp90_;
#line 1257 "../src/Photo.vala"
	_tmp91_ = params->row;
#line 1257 "../src/Photo.vala"
	_tmp92_ = _tmp91_->master;
#line 1257 "../src/Photo.vala"
	_tmp93_ = info;
#line 1257 "../src/Photo.vala"
	_tmp92_->filesize = g_file_info_get_size (_tmp93_);
#line 1258 "../src/Photo.vala"
	_tmp94_ = params->row;
#line 1258 "../src/Photo.vala"
	_tmp95_ = _tmp94_->master;
#line 1258 "../src/Photo.vala"
	_tmp96_ = timestamp;
#line 1258 "../src/Photo.vala"
	_tmp97_ = _g_date_time_ref0 (_tmp96_);
#line 1258 "../src/Photo.vala"
	_g_date_time_unref0 (_tmp95_->timestamp);
#line 1258 "../src/Photo.vala"
	_tmp95_->timestamp = _tmp97_;
#line 1259 "../src/Photo.vala"
	_tmp98_ = params->row;
#line 1259 "../src/Photo.vala"
	_tmp99_ = exposure_time;
#line 1259 "../src/Photo.vala"
	_tmp100_ = _g_date_time_ref0 (_tmp99_);
#line 1259 "../src/Photo.vala"
	_g_date_time_unref0 (_tmp98_->exposure_time);
#line 1259 "../src/Photo.vala"
	_tmp98_->exposure_time = _tmp100_;
#line 1260 "../src/Photo.vala"
	_tmp101_ = params->row;
#line 1260 "../src/Photo.vala"
	_tmp101_->orientation = orientation;
#line 1261 "../src/Photo.vala"
	_tmp102_ = params->row;
#line 1261 "../src/Photo.vala"
	_tmp103_ = _tmp102_->master;
#line 1261 "../src/Photo.vala"
	_tmp103_->original_orientation = orientation;
#line 1262 "../src/Photo.vala"
	_tmp104_ = params->row;
#line 1262 "../src/Photo.vala"
	_tmp105_ = params->import_id;
#line 1262 "../src/Photo.vala"
	_tmp104_->import_id = _tmp105_;
#line 1263 "../src/Photo.vala"
	_tmp106_ = params->row;
#line 1263 "../src/Photo.vala"
	event_id_init (&_tmp106_->event_id, EVENT_ID_INVALID);
#line 1264 "../src/Photo.vala"
	_tmp107_ = params->row;
#line 1264 "../src/Photo.vala"
	_g_object_unref0 (_tmp107_->transformations);
#line 1264 "../src/Photo.vala"
	_tmp107_->transformations = NULL;
#line 1265 "../src/Photo.vala"
	_tmp108_ = params->row;
#line 1265 "../src/Photo.vala"
	_tmp109_ = detected;
#line 1265 "../src/Photo.vala"
	_tmp110_ = _tmp109_->md5;
#line 1265 "../src/Photo.vala"
	_tmp111_ = g_strdup (_tmp110_);
#line 1265 "../src/Photo.vala"
	_g_free0 (_tmp108_->md5);
#line 1265 "../src/Photo.vala"
	_tmp108_->md5 = _tmp111_;
#line 1266 "../src/Photo.vala"
	_tmp112_ = params->row;
#line 1266 "../src/Photo.vala"
	_tmp113_ = detected;
#line 1266 "../src/Photo.vala"
	_tmp114_ = _tmp113_->thumbnail_md5;
#line 1266 "../src/Photo.vala"
	_tmp115_ = g_strdup (_tmp114_);
#line 1266 "../src/Photo.vala"
	_g_free0 (_tmp112_->thumbnail_md5);
#line 1266 "../src/Photo.vala"
	_tmp112_->thumbnail_md5 = _tmp115_;
#line 1267 "../src/Photo.vala"
	_tmp116_ = params->row;
#line 1267 "../src/Photo.vala"
	_tmp117_ = detected;
#line 1267 "../src/Photo.vala"
	_tmp118_ = _tmp117_->exif_md5;
#line 1267 "../src/Photo.vala"
	_tmp119_ = g_strdup (_tmp118_);
#line 1267 "../src/Photo.vala"
	_g_free0 (_tmp116_->exif_md5);
#line 1267 "../src/Photo.vala"
	_tmp116_->exif_md5 = _tmp119_;
#line 1268 "../src/Photo.vala"
	_tmp120_ = params->row;
#line 1268 "../src/Photo.vala"
	_tmp120_->time_created = (gint64) 0;
#line 1269 "../src/Photo.vala"
	_tmp121_ = params->row;
#line 1269 "../src/Photo.vala"
	_tmp121_->flags = (guint64) 0;
#line 1270 "../src/Photo.vala"
	_tmp122_ = params->row;
#line 1270 "../src/Photo.vala"
	_tmp123_ = _tmp122_->master;
#line 1270 "../src/Photo.vala"
	_tmp124_ = detected;
#line 1270 "../src/Photo.vala"
	_tmp123_->file_format = _tmp124_->file_format;
#line 1271 "../src/Photo.vala"
	_tmp125_ = params->row;
#line 1271 "../src/Photo.vala"
	_tmp126_ = title;
#line 1271 "../src/Photo.vala"
	_tmp127_ = g_strdup (_tmp126_);
#line 1271 "../src/Photo.vala"
	_g_free0 (_tmp125_->title);
#line 1271 "../src/Photo.vala"
	_tmp125_->title = _tmp127_;
#line 1272 "../src/Photo.vala"
	_tmp128_ = params->row;
#line 1272 "../src/Photo.vala"
	_tmp129_ = gps_coords;
#line 1272 "../src/Photo.vala"
	_tmp128_->gps_coords = _tmp129_;
#line 1273 "../src/Photo.vala"
	_tmp130_ = params->row;
#line 1273 "../src/Photo.vala"
	_tmp131_ = comment;
#line 1273 "../src/Photo.vala"
	_tmp132_ = g_strdup (_tmp131_);
#line 1273 "../src/Photo.vala"
	_g_free0 (_tmp130_->comment);
#line 1273 "../src/Photo.vala"
	_tmp130_->comment = _tmp132_;
#line 1274 "../src/Photo.vala"
	_tmp133_ = params->row;
#line 1274 "../src/Photo.vala"
	_tmp133_->rating = rating;
#line 1276 "../src/Photo.vala"
	_tmp134_ = params->thumbnails;
#line 1276 "../src/Photo.vala"
	if (_tmp134_ != NULL) {
#line 10997 "Photo.c"
		PhotoFileReader* reader = NULL;
		PhotoRow* _tmp135_;
		BackingPhotoRow* _tmp136_;
		PhotoRow* _tmp137_;
		BackingPhotoRow* _tmp138_;
		const gchar* _tmp139_;
		PhotoFileReader* _tmp140_;
		PhotoFileReader* _tmp141_;
#line 1277 "../src/Photo.vala"
		_tmp135_ = params->row;
#line 1277 "../src/Photo.vala"
		_tmp136_ = _tmp135_->master;
#line 1277 "../src/Photo.vala"
		_tmp137_ = params->row;
#line 1277 "../src/Photo.vala"
		_tmp138_ = _tmp137_->master;
#line 1277 "../src/Photo.vala"
		_tmp139_ = _tmp138_->filepath;
#line 1277 "../src/Photo.vala"
		_tmp140_ = photo_file_format_create_reader (_tmp136_->file_format, _tmp139_);
#line 1277 "../src/Photo.vala"
		reader = _tmp140_;
#line 1279 "../src/Photo.vala"
		_tmp141_ = reader;
#line 1279 "../src/Photo.vala"
		photo_file_reader_set_role (_tmp141_, PHOTO_FILE_READER_ROLE_THUMBNAIL);
#line 11024 "Photo.c"
		{
			Thumbnails* _tmp142_;
			PhotoFileReader* _tmp143_;
			PhotoRow* _tmp144_;
			PhotoRow* _tmp145_;
			BackingPhotoRow* _tmp146_;
			Dimensions _tmp147_;
#line 1281 "../src/Photo.vala"
			_tmp142_ = params->thumbnails;
#line 1281 "../src/Photo.vala"
			_tmp143_ = reader;
#line 1281 "../src/Photo.vala"
			_tmp144_ = params->row;
#line 1281 "../src/Photo.vala"
			_tmp145_ = params->row;
#line 1281 "../src/Photo.vala"
			_tmp146_ = _tmp145_->master;
#line 1281 "../src/Photo.vala"
			_tmp147_ = _tmp146_->dim;
#line 1281 "../src/Photo.vala"
			thumbnail_cache_generate_for_photo (_tmp142_, _tmp143_, _tmp144_->orientation, &_tmp147_, &_inner_error0_);
#line 1281 "../src/Photo.vala"
			if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 11048 "Photo.c"
				goto __catch2_g_error;
			}
		}
		goto __finally2;
		__catch2_g_error:
		{
			GError* err = NULL;
			GError* _tmp148_;
#line 1280 "../src/Photo.vala"
			err = _inner_error0_;
#line 1280 "../src/Photo.vala"
			_inner_error0_ = NULL;
#line 1284 "../src/Photo.vala"
			_tmp148_ = err;
#line 1284 "../src/Photo.vala"
			result = import_result_convert_error (_tmp148_, IMPORT_RESULT_FILE_ERROR);
#line 1284 "../src/Photo.vala"
			_g_error_free0 (err);
#line 1284 "../src/Photo.vala"
			_photo_file_adapter_unref0 (reader);
#line 1284 "../src/Photo.vala"
			_g_free0 (comment);
#line 1284 "../src/Photo.vala"
			_g_free0 (title);
#line 1284 "../src/Photo.vala"
			_g_date_time_unref0 (exposure_time);
#line 1284 "../src/Photo.vala"
			_detected_photo_information_unref0 (detected);
#line 1284 "../src/Photo.vala"
			_photo_file_interrogator_unref0 (interrogator);
#line 1284 "../src/Photo.vala"
			_g_date_time_unref0 (timestamp);
#line 1284 "../src/Photo.vala"
			_g_object_unref0 (info);
#line 1284 "../src/Photo.vala"
			_g_object_unref0 (file);
#line 1284 "../src/Photo.vala"
			return result;
#line 11087 "Photo.c"
		}
		__finally2:
#line 1280 "../src/Photo.vala"
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 1280 "../src/Photo.vala"
			_photo_file_adapter_unref0 (reader);
#line 1280 "../src/Photo.vala"
			_g_free0 (comment);
#line 1280 "../src/Photo.vala"
			_g_free0 (title);
#line 1280 "../src/Photo.vala"
			_g_date_time_unref0 (exposure_time);
#line 1280 "../src/Photo.vala"
			_detected_photo_information_unref0 (detected);
#line 1280 "../src/Photo.vala"
			_photo_file_interrogator_unref0 (interrogator);
#line 1280 "../src/Photo.vala"
			_g_date_time_unref0 (timestamp);
#line 1280 "../src/Photo.vala"
			_g_object_unref0 (info);
#line 1280 "../src/Photo.vala"
			_g_object_unref0 (file);
#line 1280 "../src/Photo.vala"
			g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 1280 "../src/Photo.vala"
			g_clear_error (&_inner_error0_);
#line 1280 "../src/Photo.vala"
			return 0;
#line 11116 "Photo.c"
		}
#line 1276 "../src/Photo.vala"
		_photo_file_adapter_unref0 (reader);
#line 11120 "Photo.c"
	}
#line 1291 "../src/Photo.vala"
	result = IMPORT_RESULT_SUCCESS;
#line 1291 "../src/Photo.vala"
	_g_free0 (comment);
#line 1291 "../src/Photo.vala"
	_g_free0 (title);
#line 1291 "../src/Photo.vala"
	_g_date_time_unref0 (exposure_time);
#line 1291 "../src/Photo.vala"
	_detected_photo_information_unref0 (detected);
#line 1291 "../src/Photo.vala"
	_photo_file_interrogator_unref0 (interrogator);
#line 1291 "../src/Photo.vala"
	_g_date_time_unref0 (timestamp);
#line 1291 "../src/Photo.vala"
	_g_object_unref0 (info);
#line 1291 "../src/Photo.vala"
	_g_object_unref0 (file);
#line 1291 "../src/Photo.vala"
	return result;
#line 11142 "Photo.c"
}

void
photo_create_pre_import (PhotoImportParams* params)
{
	GFile* file = NULL;
	GFile* _tmp0_;
	GFile* _tmp1_;
	PhotoRow* _tmp2_;
	PhotoRow* _tmp3_;
	BackingPhotoRow* _tmp4_;
	gchar* _tmp5_;
	PhotoRow* _tmp6_;
	BackingPhotoRow* _tmp7_;
	PhotoRow* _tmp8_;
	BackingPhotoRow* _tmp9_;
	PhotoRow* _tmp10_;
	BackingPhotoRow* _tmp11_;
	PhotoRow* _tmp12_;
	PhotoRow* _tmp13_;
	PhotoRow* _tmp14_;
	BackingPhotoRow* _tmp15_;
	PhotoRow* _tmp16_;
	ImportID _tmp17_;
	PhotoRow* _tmp18_;
	PhotoRow* _tmp19_;
	PhotoRow* _tmp20_;
	PhotoRow* _tmp21_;
	PhotoRow* _tmp22_;
	PhotoRow* _tmp23_;
	PhotoRow* _tmp24_;
	PhotoRow* _tmp25_;
	BackingPhotoRow* _tmp26_;
	PhotoRow* _tmp27_;
	PhotoRow* _tmp28_;
	PhotoRow* _tmp29_;
	PhotoRow* _tmp30_;
	PhotoFileInterrogator* interrogator = NULL;
	GFile* _tmp31_;
	PhotoFileInterrogator* _tmp32_;
	GError* _inner_error0_ = NULL;
#line 1294 "../src/Photo.vala"
	g_return_if_fail (IS_PHOTO_IMPORT_PARAMS (params));
#line 1295 "../src/Photo.vala"
	_tmp0_ = params->file;
#line 1295 "../src/Photo.vala"
	_tmp1_ = _g_object_ref0 (_tmp0_);
#line 1295 "../src/Photo.vala"
	file = _tmp1_;
#line 1296 "../src/Photo.vala"
	_tmp2_ = params->row;
#line 1296 "../src/Photo.vala"
	photo_id_init (&_tmp2_->photo_id, PHOTO_ID_INVALID);
#line 1297 "../src/Photo.vala"
	_tmp3_ = params->row;
#line 1297 "../src/Photo.vala"
	_tmp4_ = _tmp3_->master;
#line 1297 "../src/Photo.vala"
	_tmp5_ = g_file_get_path (file);
#line 1297 "../src/Photo.vala"
	_g_free0 (_tmp4_->filepath);
#line 1297 "../src/Photo.vala"
	_tmp4_->filepath = _tmp5_;
#line 1298 "../src/Photo.vala"
	_tmp6_ = params->row;
#line 1298 "../src/Photo.vala"
	_tmp7_ = _tmp6_->master;
#line 1298 "../src/Photo.vala"
	dimensions_init (&_tmp7_->dim, 0, 0);
#line 1299 "../src/Photo.vala"
	_tmp8_ = params->row;
#line 1299 "../src/Photo.vala"
	_tmp9_ = _tmp8_->master;
#line 1299 "../src/Photo.vala"
	_tmp9_->filesize = (gint64) 0;
#line 1300 "../src/Photo.vala"
	_tmp10_ = params->row;
#line 1300 "../src/Photo.vala"
	_tmp11_ = _tmp10_->master;
#line 1300 "../src/Photo.vala"
	_g_date_time_unref0 (_tmp11_->timestamp);
#line 1300 "../src/Photo.vala"
	_tmp11_->timestamp = NULL;
#line 1301 "../src/Photo.vala"
	_tmp12_ = params->row;
#line 1301 "../src/Photo.vala"
	_g_date_time_unref0 (_tmp12_->exposure_time);
#line 1301 "../src/Photo.vala"
	_tmp12_->exposure_time = NULL;
#line 1302 "../src/Photo.vala"
	_tmp13_ = params->row;
#line 1302 "../src/Photo.vala"
	_tmp13_->orientation = ORIENTATION_TOP_LEFT;
#line 1303 "../src/Photo.vala"
	_tmp14_ = params->row;
#line 1303 "../src/Photo.vala"
	_tmp15_ = _tmp14_->master;
#line 1303 "../src/Photo.vala"
	_tmp15_->original_orientation = ORIENTATION_TOP_LEFT;
#line 1304 "../src/Photo.vala"
	_tmp16_ = params->row;
#line 1304 "../src/Photo.vala"
	_tmp17_ = params->import_id;
#line 1304 "../src/Photo.vala"
	_tmp16_->import_id = _tmp17_;
#line 1305 "../src/Photo.vala"
	_tmp18_ = params->row;
#line 1305 "../src/Photo.vala"
	event_id_init (&_tmp18_->event_id, EVENT_ID_INVALID);
#line 1306 "../src/Photo.vala"
	_tmp19_ = params->row;
#line 1306 "../src/Photo.vala"
	_g_object_unref0 (_tmp19_->transformations);
#line 1306 "../src/Photo.vala"
	_tmp19_->transformations = NULL;
#line 1307 "../src/Photo.vala"
	_tmp20_ = params->row;
#line 1307 "../src/Photo.vala"
	_g_free0 (_tmp20_->md5);
#line 1307 "../src/Photo.vala"
	_tmp20_->md5 = NULL;
#line 1308 "../src/Photo.vala"
	_tmp21_ = params->row;
#line 1308 "../src/Photo.vala"
	_g_free0 (_tmp21_->thumbnail_md5);
#line 1308 "../src/Photo.vala"
	_tmp21_->thumbnail_md5 = NULL;
#line 1309 "../src/Photo.vala"
	_tmp22_ = params->row;
#line 1309 "../src/Photo.vala"
	_g_free0 (_tmp22_->exif_md5);
#line 1309 "../src/Photo.vala"
	_tmp22_->exif_md5 = NULL;
#line 1310 "../src/Photo.vala"
	_tmp23_ = params->row;
#line 1310 "../src/Photo.vala"
	_tmp23_->time_created = (gint64) 0;
#line 1311 "../src/Photo.vala"
	_tmp24_ = params->row;
#line 1311 "../src/Photo.vala"
	_tmp24_->flags = (guint64) 0;
#line 1312 "../src/Photo.vala"
	_tmp25_ = params->row;
#line 1312 "../src/Photo.vala"
	_tmp26_ = _tmp25_->master;
#line 1312 "../src/Photo.vala"
	_tmp26_->file_format = PHOTO_FILE_FORMAT_JFIF;
#line 1313 "../src/Photo.vala"
	_tmp27_ = params->row;
#line 1313 "../src/Photo.vala"
	_g_free0 (_tmp27_->title);
#line 1313 "../src/Photo.vala"
	_tmp27_->title = NULL;
#line 1314 "../src/Photo.vala"
	_tmp28_ = params->row;
#line 1314 "../src/Photo.vala"
	memset (&_tmp28_->gps_coords, 0, sizeof (GpsCoords));
#line 1315 "../src/Photo.vala"
	_tmp29_ = params->row;
#line 1315 "../src/Photo.vala"
	_g_free0 (_tmp29_->comment);
#line 1315 "../src/Photo.vala"
	_tmp29_->comment = NULL;
#line 1316 "../src/Photo.vala"
	_tmp30_ = params->row;
#line 1316 "../src/Photo.vala"
	_tmp30_->rating = RATING_UNRATED;
#line 1318 "../src/Photo.vala"
	_tmp31_ = params->file;
#line 1318 "../src/Photo.vala"
	_tmp32_ = photo_file_interrogator_new (_tmp31_, params->sniffer_options);
#line 1318 "../src/Photo.vala"
	interrogator = _tmp32_;
#line 11316 "Photo.c"
	{
		DetectedPhotoInformation* detected = NULL;
		DetectedPhotoInformation* _tmp33_;
		gboolean _tmp34_ = FALSE;
		gboolean _tmp35_ = FALSE;
		DetectedPhotoInformation* _tmp36_;
#line 1320 "../src/Photo.vala"
		photo_file_interrogator_interrogate (interrogator, &_inner_error0_);
#line 1320 "../src/Photo.vala"
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 11327 "Photo.c"
			goto __catch0_g_error;
		}
#line 1321 "../src/Photo.vala"
		_tmp33_ = photo_file_interrogator_get_detected_photo_information (interrogator);
#line 1321 "../src/Photo.vala"
		detected = _tmp33_;
#line 1322 "../src/Photo.vala"
		_tmp36_ = detected;
#line 1322 "../src/Photo.vala"
		if (_tmp36_ != NULL) {
#line 1322 "../src/Photo.vala"
			_tmp35_ = !photo_file_interrogator_get_is_photo_corrupted (interrogator);
#line 11340 "Photo.c"
		} else {
#line 1322 "../src/Photo.vala"
			_tmp35_ = FALSE;
#line 11344 "Photo.c"
		}
#line 1322 "../src/Photo.vala"
		if (_tmp35_) {
#line 11348 "Photo.c"
			DetectedPhotoInformation* _tmp37_;
#line 1322 "../src/Photo.vala"
			_tmp37_ = detected;
#line 1322 "../src/Photo.vala"
			_tmp34_ = _tmp37_->file_format != PHOTO_FILE_FORMAT_UNKNOWN;
#line 11354 "Photo.c"
		} else {
#line 1322 "../src/Photo.vala"
			_tmp34_ = FALSE;
#line 11358 "Photo.c"
		}
#line 1322 "../src/Photo.vala"
		if (_tmp34_) {
#line 11362 "Photo.c"
			PhotoRow* _tmp38_;
			BackingPhotoRow* _tmp39_;
			DetectedPhotoInformation* _tmp40_;
#line 1323 "../src/Photo.vala"
			_tmp38_ = params->row;
#line 1323 "../src/Photo.vala"
			_tmp39_ = _tmp38_->master;
#line 1323 "../src/Photo.vala"
			_tmp40_ = detected;
#line 1323 "../src/Photo.vala"
			_tmp39_->file_format = _tmp40_->file_format;
#line 11374 "Photo.c"
		}
#line 1319 "../src/Photo.vala"
		_detected_photo_information_unref0 (detected);
#line 11378 "Photo.c"
	}
	goto __finally0;
	__catch0_g_error:
	{
		GError* err = NULL;
		gchar* _tmp41_;
		gchar* _tmp42_;
		GError* _tmp43_;
		const gchar* _tmp44_;
#line 1319 "../src/Photo.vala"
		err = _inner_error0_;
#line 1319 "../src/Photo.vala"
		_inner_error0_ = NULL;
#line 1325 "../src/Photo.vala"
		_tmp41_ = g_file_get_path (file);
#line 1325 "../src/Photo.vala"
		_tmp42_ = _tmp41_;
#line 1325 "../src/Photo.vala"
		_tmp43_ = err;
#line 1325 "../src/Photo.vala"
		_tmp44_ = _tmp43_->message;
#line 1325 "../src/Photo.vala"
		g_debug ("Photo.vala:1325: Unable to interrogate photo file %s: %s", _tmp42_, _tmp44_);
#line 1325 "../src/Photo.vala"
		_g_free0 (_tmp42_);
#line 1319 "../src/Photo.vala"
		_g_error_free0 (err);
#line 11406 "Photo.c"
	}
	__finally0:
#line 1319 "../src/Photo.vala"
	if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 1319 "../src/Photo.vala"
		_photo_file_interrogator_unref0 (interrogator);
#line 1319 "../src/Photo.vala"
		_g_object_unref0 (file);
#line 1319 "../src/Photo.vala"
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 1319 "../src/Photo.vala"
		g_clear_error (&_inner_error0_);
#line 1319 "../src/Photo.vala"
		return;
#line 11421 "Photo.c"
	}
#line 1294 "../src/Photo.vala"
	_photo_file_interrogator_unref0 (interrogator);
#line 1294 "../src/Photo.vala"
	_g_object_unref0 (file);
#line 11427 "Photo.c"
}

BackingPhotoRow*
photo_query_backing_photo_row (Photo* self,
                               GFile* file,
                               PhotoFileSnifferOptions options,
                               DetectedPhotoInformation** detected,
                               GError** error)
{
	DetectedPhotoInformation* _vala_detected = NULL;
	BackingPhotoRow* backing = NULL;
	BackingPhotoRow* _tmp0_;
	GFileInfo* info = NULL;
	PhotoFileInterrogator* interrogator = NULL;
	PhotoFileInterrogator* _tmp8_;
	PhotoFileInterrogator* _tmp9_;
	PhotoFileInterrogator* _tmp10_;
	DetectedPhotoInformation* _tmp11_;
	gboolean _tmp12_ = FALSE;
	DetectedPhotoInformation* _tmp13_;
	GDateTime* modification_time = NULL;
	GFileInfo* _tmp17_;
	GDateTime* _tmp18_;
	GDateTime* _tmp19_;
	GDateTime* _tmp20_;
	GDateTime* _tmp21_;
	BackingPhotoRow* _tmp22_;
	gchar* _tmp23_;
	BackingPhotoRow* _tmp24_;
	GDateTime* _tmp25_;
	GDateTime* _tmp26_;
	BackingPhotoRow* _tmp27_;
	GFileInfo* _tmp28_;
	BackingPhotoRow* _tmp29_;
	DetectedPhotoInformation* _tmp30_;
	BackingPhotoRow* _tmp31_;
	DetectedPhotoInformation* _tmp32_;
	Dimensions _tmp33_;
	Orientation _tmp34_ = 0;
	DetectedPhotoInformation* _tmp35_;
	PhotoMetadata* _tmp36_;
	BackingPhotoRow* _tmp39_;
	GError* _inner_error0_ = NULL;
	BackingPhotoRow* result;
#line 1329 "../src/Photo.vala"
	g_return_val_if_fail (IS_PHOTO (self), NULL);
#line 1329 "../src/Photo.vala"
	g_return_val_if_fail (G_TYPE_CHECK_INSTANCE_TYPE (file, g_file_get_type ()), NULL);
#line 1331 "../src/Photo.vala"
	_detected_photo_information_unref0 (_vala_detected);
#line 1331 "../src/Photo.vala"
	_vala_detected = NULL;
#line 1333 "../src/Photo.vala"
	_tmp0_ = backing_photo_row_new ();
#line 1333 "../src/Photo.vala"
	backing = _tmp0_;
#line 1335 "../src/Photo.vala"
	info = NULL;
#line 11486 "Photo.c"
	{
		GFileInfo* _tmp1_ = NULL;
		GFileInfo* _tmp2_;
		GFileInfo* _tmp3_;
#line 1337 "../src/Photo.vala"
		_tmp2_ = g_file_query_info (file, DIRECTORY_MONITOR_SUPPLIED_ATTRIBUTES, G_FILE_QUERY_INFO_NOFOLLOW_SYMLINKS, NULL, &_inner_error0_);
#line 1337 "../src/Photo.vala"
		_tmp1_ = _tmp2_;
#line 1337 "../src/Photo.vala"
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 11497 "Photo.c"
			goto __catch0_g_error;
		}
#line 1337 "../src/Photo.vala"
		_tmp3_ = _tmp1_;
#line 1337 "../src/Photo.vala"
		_tmp1_ = NULL;
#line 1337 "../src/Photo.vala"
		_g_object_unref0 (info);
#line 1337 "../src/Photo.vala"
		info = _tmp3_;
#line 1336 "../src/Photo.vala"
		_g_object_unref0 (_tmp1_);
#line 11510 "Photo.c"
	}
	goto __finally0;
	__catch0_g_error:
	{
		GError* err = NULL;
		gchar* _tmp4_;
		gchar* _tmp5_;
		GError* _tmp6_;
		const gchar* _tmp7_;
#line 1336 "../src/Photo.vala"
		err = _inner_error0_;
#line 1336 "../src/Photo.vala"
		_inner_error0_ = NULL;
#line 1340 "../src/Photo.vala"
		_tmp4_ = g_file_get_path (file);
#line 1340 "../src/Photo.vala"
		_tmp5_ = _tmp4_;
#line 1340 "../src/Photo.vala"
		_tmp6_ = err;
#line 1340 "../src/Photo.vala"
		_tmp7_ = _tmp6_->message;
#line 1340 "../src/Photo.vala"
		g_critical ("Photo.vala:1340: Unable to read file information for %s: %s", _tmp5_, _tmp7_);
#line 1340 "../src/Photo.vala"
		_g_free0 (_tmp5_);
#line 1342 "../src/Photo.vala"
		result = NULL;
#line 1342 "../src/Photo.vala"
		_g_error_free0 (err);
#line 1342 "../src/Photo.vala"
		_g_object_unref0 (info);
#line 1342 "../src/Photo.vala"
		_backing_photo_row_unref0 (backing);
#line 1342 "../src/Photo.vala"
		if (detected) {
#line 1342 "../src/Photo.vala"
			*detected = _vala_detected;
#line 11548 "Photo.c"
		} else {
#line 1342 "../src/Photo.vala"
			_detected_photo_information_unref0 (_vala_detected);
#line 11552 "Photo.c"
		}
#line 1342 "../src/Photo.vala"
		return result;
#line 11556 "Photo.c"
	}
	__finally0:
#line 1336 "../src/Photo.vala"
	if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 1336 "../src/Photo.vala"
		g_propagate_error (error, _inner_error0_);
#line 1336 "../src/Photo.vala"
		_g_object_unref0 (info);
#line 1336 "../src/Photo.vala"
		_backing_photo_row_unref0 (backing);
#line 1336 "../src/Photo.vala"
		_detected_photo_information_unref0 (_vala_detected);
#line 1336 "../src/Photo.vala"
		return NULL;
#line 11571 "Photo.c"
	}
#line 1346 "../src/Photo.vala"
	_tmp8_ = photo_file_interrogator_new (file, options);
#line 1346 "../src/Photo.vala"
	interrogator = _tmp8_;
#line 1347 "../src/Photo.vala"
	_tmp9_ = interrogator;
#line 1347 "../src/Photo.vala"
	photo_file_interrogator_interrogate (_tmp9_, &_inner_error0_);
#line 1347 "../src/Photo.vala"
	if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 1347 "../src/Photo.vala"
		g_propagate_error (error, _inner_error0_);
#line 1347 "../src/Photo.vala"
		_photo_file_interrogator_unref0 (interrogator);
#line 1347 "../src/Photo.vala"
		_g_object_unref0 (info);
#line 1347 "../src/Photo.vala"
		_backing_photo_row_unref0 (backing);
#line 1347 "../src/Photo.vala"
		_detected_photo_information_unref0 (_vala_detected);
#line 1347 "../src/Photo.vala"
		return NULL;
#line 11595 "Photo.c"
	}
#line 1348 "../src/Photo.vala"
	_tmp10_ = interrogator;
#line 1348 "../src/Photo.vala"
	_tmp11_ = photo_file_interrogator_get_detected_photo_information (_tmp10_);
#line 1348 "../src/Photo.vala"
	_detected_photo_information_unref0 (_vala_detected);
#line 1348 "../src/Photo.vala"
	_vala_detected = _tmp11_;
#line 1349 "../src/Photo.vala"
	_tmp13_ = _vala_detected;
#line 1349 "../src/Photo.vala"
	if (_tmp13_ == NULL) {
#line 1349 "../src/Photo.vala"
		_tmp12_ = TRUE;
#line 11611 "Photo.c"
	} else {
		PhotoFileInterrogator* _tmp14_;
#line 1349 "../src/Photo.vala"
		_tmp14_ = interrogator;
#line 1349 "../src/Photo.vala"
		_tmp12_ = photo_file_interrogator_get_is_photo_corrupted (_tmp14_);
#line 11618 "Photo.c"
	}
#line 1349 "../src/Photo.vala"
	if (_tmp12_) {
#line 11622 "Photo.c"
		gchar* _tmp15_;
		gchar* _tmp16_;
#line 1350 "../src/Photo.vala"
		_tmp15_ = data_object_to_string (G_TYPE_CHECK_INSTANCE_CAST (self, TYPE_DATA_OBJECT, DataObject));
#line 1350 "../src/Photo.vala"
		_tmp16_ = _tmp15_;
#line 1350 "../src/Photo.vala"
		g_critical ("Photo.vala:1350: Photo update: %s no longer a recognized image", _tmp16_);
#line 1350 "../src/Photo.vala"
		_g_free0 (_tmp16_);
#line 1352 "../src/Photo.vala"
		result = NULL;
#line 1352 "../src/Photo.vala"
		_photo_file_interrogator_unref0 (interrogator);
#line 1352 "../src/Photo.vala"
		_g_object_unref0 (info);
#line 1352 "../src/Photo.vala"
		_backing_photo_row_unref0 (backing);
#line 1352 "../src/Photo.vala"
		if (detected) {
#line 1352 "../src/Photo.vala"
			*detected = _vala_detected;
#line 11645 "Photo.c"
		} else {
#line 1352 "../src/Photo.vala"
			_detected_photo_information_unref0 (_vala_detected);
#line 11649 "Photo.c"
		}
#line 1352 "../src/Photo.vala"
		return result;
#line 11653 "Photo.c"
	}
#line 1355 "../src/Photo.vala"
	_tmp17_ = info;
#line 1355 "../src/Photo.vala"
	_tmp18_ = g_file_info_get_modification_date_time (_tmp17_);
#line 1355 "../src/Photo.vala"
	_tmp19_ = _tmp18_;
#line 1355 "../src/Photo.vala"
	_tmp20_ = coarsify_date_time (_tmp19_);
#line 1355 "../src/Photo.vala"
	_tmp21_ = _tmp20_;
#line 1355 "../src/Photo.vala"
	_g_date_time_unref0 (_tmp19_);
#line 1355 "../src/Photo.vala"
	modification_time = _tmp21_;
#line 1357 "../src/Photo.vala"
	_tmp22_ = backing;
#line 1357 "../src/Photo.vala"
	_tmp23_ = g_file_get_path (file);
#line 1357 "../src/Photo.vala"
	_g_free0 (_tmp22_->filepath);
#line 1357 "../src/Photo.vala"
	_tmp22_->filepath = _tmp23_;
#line 1358 "../src/Photo.vala"
	_tmp24_ = backing;
#line 1358 "../src/Photo.vala"
	_tmp25_ = modification_time;
#line 1358 "../src/Photo.vala"
	_tmp26_ = _g_date_time_ref0 (_tmp25_);
#line 1358 "../src/Photo.vala"
	_g_date_time_unref0 (_tmp24_->timestamp);
#line 1358 "../src/Photo.vala"
	_tmp24_->timestamp = _tmp26_;
#line 1359 "../src/Photo.vala"
	_tmp27_ = backing;
#line 1359 "../src/Photo.vala"
	_tmp28_ = info;
#line 1359 "../src/Photo.vala"
	_tmp27_->filesize = g_file_info_get_size (_tmp28_);
#line 1360 "../src/Photo.vala"
	_tmp29_ = backing;
#line 1360 "../src/Photo.vala"
	_tmp30_ = _vala_detected;
#line 1360 "../src/Photo.vala"
	_tmp29_->file_format = _tmp30_->file_format;
#line 1361 "../src/Photo.vala"
	_tmp31_ = backing;
#line 1361 "../src/Photo.vala"
	_tmp32_ = _vala_detected;
#line 1361 "../src/Photo.vala"
	_tmp33_ = _tmp32_->image_dim;
#line 1361 "../src/Photo.vala"
	_tmp31_->dim = _tmp33_;
#line 1362 "../src/Photo.vala"
	_tmp35_ = _vala_detected;
#line 1362 "../src/Photo.vala"
	_tmp36_ = _tmp35_->metadata;
#line 1362 "../src/Photo.vala"
	if (_tmp36_ != NULL) {
#line 11713 "Photo.c"
		DetectedPhotoInformation* _tmp37_;
		PhotoMetadata* _tmp38_;
#line 1363 "../src/Photo.vala"
		_tmp37_ = _vala_detected;
#line 1363 "../src/Photo.vala"
		_tmp38_ = _tmp37_->metadata;
#line 1363 "../src/Photo.vala"
		_tmp34_ = photo_metadata_get_orientation (_tmp38_);
#line 11722 "Photo.c"
	} else {
#line 1363 "../src/Photo.vala"
		_tmp34_ = ORIENTATION_TOP_LEFT;
#line 11726 "Photo.c"
	}
#line 1362 "../src/Photo.vala"
	_tmp39_ = backing;
#line 1362 "../src/Photo.vala"
	_tmp39_->original_orientation = _tmp34_;
#line 1365 "../src/Photo.vala"
	result = backing;
#line 1365 "../src/Photo.vala"
	_g_date_time_unref0 (modification_time);
#line 1365 "../src/Photo.vala"
	_photo_file_interrogator_unref0 (interrogator);
#line 1365 "../src/Photo.vala"
	_g_object_unref0 (info);
#line 1365 "../src/Photo.vala"
	if (detected) {
#line 1365 "../src/Photo.vala"
		*detected = _vala_detected;
#line 11744 "Photo.c"
	} else {
#line 1365 "../src/Photo.vala"
		_detected_photo_information_unref0 (_vala_detected);
#line 11748 "Photo.c"
	}
#line 1365 "../src/Photo.vala"
	return result;
#line 11752 "Photo.c"
}

static void
_vala_array_add86 (gchar** * array,
                   gint* length,
                   gint* size,
                   gchar* value)
{
#line 1461 "../src/Photo.vala"
	if ((*length) == (*size)) {
#line 1461 "../src/Photo.vala"
		*size = (*size) ? (2 * (*size)) : 4;
#line 1461 "../src/Photo.vala"
		*array = g_renew (gchar*, *array, (*size) + 1);
#line 11767 "Photo.c"
	}
#line 1461 "../src/Photo.vala"
	(*array)[(*length)++] = value;
#line 1461 "../src/Photo.vala"
	(*array)[*length] = NULL;
#line 11773 "Photo.c"
}

static void
_vala_array_add87 (gchar** * array,
                   gint* length,
                   gint* size,
                   gchar* value)
{
#line 1464 "../src/Photo.vala"
	if ((*length) == (*size)) {
#line 1464 "../src/Photo.vala"
		*size = (*size) ? (2 * (*size)) : 4;
#line 1464 "../src/Photo.vala"
		*array = g_renew (gchar*, *array, (*size) + 1);
#line 11788 "Photo.c"
	}
#line 1464 "../src/Photo.vala"
	(*array)[(*length)++] = value;
#line 1464 "../src/Photo.vala"
	(*array)[*length] = NULL;
#line 11794 "Photo.c"
}

static void
_vala_array_add88 (gchar** * array,
                   gint* length,
                   gint* size,
                   gchar* value)
{
#line 1474 "../src/Photo.vala"
	if ((*length) == (*size)) {
#line 1474 "../src/Photo.vala"
		*size = (*size) ? (2 * (*size)) : 4;
#line 1474 "../src/Photo.vala"
		*array = g_renew (gchar*, *array, (*size) + 1);
#line 11809 "Photo.c"
	}
#line 1474 "../src/Photo.vala"
	(*array)[(*length)++] = value;
#line 1474 "../src/Photo.vala"
	(*array)[*length] = NULL;
#line 11815 "Photo.c"
}

static void
_vala_array_add89 (gchar** * array,
                   gint* length,
                   gint* size,
                   gchar* value)
{
#line 1477 "../src/Photo.vala"
	if ((*length) == (*size)) {
#line 1477 "../src/Photo.vala"
		*size = (*size) ? (2 * (*size)) : 4;
#line 1477 "../src/Photo.vala"
		*array = g_renew (gchar*, *array, (*size) + 1);
#line 11830 "Photo.c"
	}
#line 1477 "../src/Photo.vala"
	(*array)[(*length)++] = value;
#line 1477 "../src/Photo.vala"
	(*array)[*length] = NULL;
#line 11836 "Photo.c"
}

static gboolean
_gps_coords_equal (const GpsCoords * s1,
                   const GpsCoords * s2)
{
#line 1480 "../src/Photo.vala"
	if (s1 == s2) {
#line 1480 "../src/Photo.vala"
		return TRUE;
#line 11847 "Photo.c"
	}
#line 1480 "../src/Photo.vala"
	if (s1 == NULL) {
#line 1480 "../src/Photo.vala"
		return FALSE;
#line 11853 "Photo.c"
	}
#line 1480 "../src/Photo.vala"
	if (s2 == NULL) {
#line 1480 "../src/Photo.vala"
		return FALSE;
#line 11859 "Photo.c"
	}
#line 1480 "../src/Photo.vala"
	if (s1->has_gps != s2->has_gps) {
#line 1480 "../src/Photo.vala"
		return FALSE;
#line 11865 "Photo.c"
	}
#line 1480 "../src/Photo.vala"
	if (s1->latitude != s2->latitude) {
#line 1480 "../src/Photo.vala"
		return FALSE;
#line 11871 "Photo.c"
	}
#line 1480 "../src/Photo.vala"
	if (s1->longitude != s2->longitude) {
#line 1480 "../src/Photo.vala"
		return FALSE;
#line 11877 "Photo.c"
	}
#line 1480 "../src/Photo.vala"
	return TRUE;
#line 11881 "Photo.c"
}

static void
_vala_array_add90 (gchar** * array,
                   gint* length,
                   gint* size,
                   gchar* value)
{
#line 1481 "../src/Photo.vala"
	if ((*length) == (*size)) {
#line 1481 "../src/Photo.vala"
		*size = (*size) ? (2 * (*size)) : 4;
#line 1481 "../src/Photo.vala"
		*array = g_renew (gchar*, *array, (*size) + 1);
#line 11896 "Photo.c"
	}
#line 1481 "../src/Photo.vala"
	(*array)[(*length)++] = value;
#line 1481 "../src/Photo.vala"
	(*array)[*length] = NULL;
#line 11902 "Photo.c"
}

static void
_vala_array_add91 (gchar** * array,
                   gint* length,
                   gint* size,
                   gchar* value)
{
#line 1485 "../src/Photo.vala"
	if ((*length) == (*size)) {
#line 1485 "../src/Photo.vala"
		*size = (*size) ? (2 * (*size)) : 4;
#line 1485 "../src/Photo.vala"
		*array = g_renew (gchar*, *array, (*size) + 1);
#line 11917 "Photo.c"
	}
#line 1485 "../src/Photo.vala"
	(*array)[(*length)++] = value;
#line 1485 "../src/Photo.vala"
	(*array)[*length] = NULL;
#line 11923 "Photo.c"
}

static void
_vala_array_add92 (gchar** * array,
                   gint* length,
                   gint* size,
                   gchar* value)
{
#line 1488 "../src/Photo.vala"
	if ((*length) == (*size)) {
#line 1488 "../src/Photo.vala"
		*size = (*size) ? (2 * (*size)) : 4;
#line 1488 "../src/Photo.vala"
		*array = g_renew (gchar*, *array, (*size) + 1);
#line 11938 "Photo.c"
	}
#line 1488 "../src/Photo.vala"
	(*array)[(*length)++] = value;
#line 1488 "../src/Photo.vala"
	(*array)[*length] = NULL;
#line 11944 "Photo.c"
}

static gpointer
_media_metadata_ref0 (gpointer self)
{
#line 1498 "../src/Photo.vala"
	return self ? media_metadata_ref (self) : NULL;
#line 11952 "Photo.c"
}

gboolean
photo_prepare_for_reimport_master (Photo* self,
                                   PhotoReimportMasterState** reimport_state,
                                   GError** error)
{
	PhotoReimportMasterState* _vala_reimport_state = NULL;
	GFile* file = NULL;
	PhotoFileReader* _tmp0_;
	PhotoFileReader* _tmp1_;
	GFile* _tmp2_;
	GFile* _tmp3_;
	DetectedPhotoInformation* detected = NULL;
	BackingPhotoRow* backing = NULL;
	GFile* _tmp4_;
	DetectedPhotoInformation* _tmp5_ = NULL;
	BackingPhotoRow* _tmp6_;
	BackingPhotoRow* _tmp8_;
	gboolean _tmp12_ = FALSE;
	gboolean _tmp13_ = FALSE;
	DetectedPhotoInformation* _tmp14_;
	PhotoRow* updated_row = NULL;
	PhotoRow* _tmp20_;
	gchar** list = NULL;
	gchar** _tmp26_;
	gint list_length1;
	gint _list_size_;
	PhotoRow* _tmp27_;
	const gchar* _tmp28_;
	DetectedPhotoInformation* _tmp29_;
	const gchar* _tmp30_;
	PhotoRow* _tmp32_;
	BackingPhotoRow* _tmp33_;
	BackingPhotoRow* _tmp34_;
	GpsCoords gps_coords = {0};
	DetectedPhotoInformation* _tmp39_;
	PhotoMetadata* _tmp40_;
	PhotoRow* _tmp82_;
	BackingPhotoRow* _tmp83_;
	BackingPhotoRow* _tmp84_;
	PhotoRow* _tmp85_;
	DetectedPhotoInformation* _tmp86_;
	const gchar* _tmp87_;
	gchar* _tmp88_;
	PhotoRow* _tmp89_;
	DetectedPhotoInformation* _tmp90_;
	const gchar* _tmp91_;
	gchar* _tmp92_;
	PhotoRow* _tmp93_;
	DetectedPhotoInformation* _tmp94_;
	const gchar* _tmp95_;
	gchar* _tmp96_;
	PhotoMetadata* metadata = NULL;
	DetectedPhotoInformation* _tmp97_;
	PhotoMetadata* _tmp98_;
	PhotoRow* _tmp122_;
	PhotoMetadata* _tmp123_;
	gchar** _tmp124_;
	gint _tmp124__length1;
	PhotoReimportMasterStateImpl* _tmp125_;
	GError* _inner_error0_ = NULL;
	gboolean result;
#line 1429 "../src/Photo.vala"
	g_return_val_if_fail (IS_PHOTO (self), FALSE);
#line 1430 "../src/Photo.vala"
	_photo_reimport_master_state_unref0 (_vala_reimport_state);
#line 1430 "../src/Photo.vala"
	_vala_reimport_state = NULL;
#line 1432 "../src/Photo.vala"
	_tmp0_ = photo_get_master_reader (self);
#line 1432 "../src/Photo.vala"
	_tmp1_ = _tmp0_;
#line 1432 "../src/Photo.vala"
	_tmp2_ = photo_file_adapter_get_file (G_TYPE_CHECK_INSTANCE_CAST (_tmp1_, TYPE_PHOTO_FILE_ADAPTER, PhotoFileAdapter));
#line 1432 "../src/Photo.vala"
	_tmp3_ = _tmp2_;
#line 1432 "../src/Photo.vala"
	_photo_file_adapter_unref0 (_tmp1_);
#line 1432 "../src/Photo.vala"
	file = _tmp3_;
#line 1435 "../src/Photo.vala"
	_tmp4_ = file;
#line 1435 "../src/Photo.vala"
	_tmp6_ = photo_query_backing_photo_row (self, _tmp4_, PHOTO_FILE_SNIFFER_OPTIONS_GET_ALL, &_tmp5_, &_inner_error0_);
#line 1435 "../src/Photo.vala"
	_detected_photo_information_unref0 (detected);
#line 1435 "../src/Photo.vala"
	detected = _tmp5_;
#line 1435 "../src/Photo.vala"
	backing = _tmp6_;
#line 1435 "../src/Photo.vala"
	if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 12046 "Photo.c"
		gboolean _tmp7_ = FALSE;
#line 1435 "../src/Photo.vala"
		g_propagate_error (error, _inner_error0_);
#line 1435 "../src/Photo.vala"
		_detected_photo_information_unref0 (detected);
#line 1435 "../src/Photo.vala"
		_g_object_unref0 (file);
#line 1435 "../src/Photo.vala"
		_photo_reimport_master_state_unref0 (_vala_reimport_state);
#line 1435 "../src/Photo.vala"
		return _tmp7_;
#line 12058 "Photo.c"
	}
#line 1437 "../src/Photo.vala"
	_tmp8_ = backing;
#line 1437 "../src/Photo.vala"
	if (_tmp8_ == NULL) {
#line 12064 "Photo.c"
		GFile* _tmp9_;
		gchar* _tmp10_;
		gchar* _tmp11_;
#line 1438 "../src/Photo.vala"
		_tmp9_ = file;
#line 1438 "../src/Photo.vala"
		_tmp10_ = g_file_get_path (_tmp9_);
#line 1438 "../src/Photo.vala"
		_tmp11_ = _tmp10_;
#line 1438 "../src/Photo.vala"
		g_warning ("Photo.vala:1438: Unable to retrieve photo state from %s for reimport", _tmp11_);
#line 1438 "../src/Photo.vala"
		_g_free0 (_tmp11_);
#line 1439 "../src/Photo.vala"
		result = FALSE;
#line 1439 "../src/Photo.vala"
		_backing_photo_row_unref0 (backing);
#line 1439 "../src/Photo.vala"
		_detected_photo_information_unref0 (detected);
#line 1439 "../src/Photo.vala"
		_g_object_unref0 (file);
#line 1439 "../src/Photo.vala"
		if (reimport_state) {
#line 1439 "../src/Photo.vala"
			*reimport_state = _vala_reimport_state;
#line 12090 "Photo.c"
		} else {
#line 1439 "../src/Photo.vala"
			_photo_reimport_master_state_unref0 (_vala_reimport_state);
#line 12094 "Photo.c"
		}
#line 1439 "../src/Photo.vala"
		return result;
#line 12098 "Photo.c"
	}
#line 1443 "../src/Photo.vala"
	_tmp14_ = detected;
#line 1443 "../src/Photo.vala"
	if (_tmp14_->colorspace != GDK_COLORSPACE_RGB) {
#line 1443 "../src/Photo.vala"
		_tmp13_ = TRUE;
#line 12106 "Photo.c"
	} else {
		DetectedPhotoInformation* _tmp15_;
#line 1444 "../src/Photo.vala"
		_tmp15_ = detected;
#line 1444 "../src/Photo.vala"
		_tmp13_ = _tmp15_->channels < 3;
#line 12113 "Photo.c"
	}
#line 1443 "../src/Photo.vala"
	if (_tmp13_) {
#line 1443 "../src/Photo.vala"
		_tmp12_ = TRUE;
#line 12119 "Photo.c"
	} else {
		DetectedPhotoInformation* _tmp16_;
#line 1445 "../src/Photo.vala"
		_tmp16_ = detected;
#line 1445 "../src/Photo.vala"
		_tmp12_ = _tmp16_->bits_per_channel != 8;
#line 12126 "Photo.c"
	}
#line 1443 "../src/Photo.vala"
	if (_tmp12_) {
#line 12130 "Photo.c"
		GFile* _tmp17_;
		gchar* _tmp18_;
		gchar* _tmp19_;
#line 1446 "../src/Photo.vala"
		_tmp17_ = file;
#line 1446 "../src/Photo.vala"
		_tmp18_ = g_file_get_path (_tmp17_);
#line 1446 "../src/Photo.vala"
		_tmp19_ = _tmp18_;
#line 1446 "../src/Photo.vala"
		g_warning ("Photo.vala:1446: Not re-importing %s: Unsupported color format", _tmp19_);
#line 1446 "../src/Photo.vala"
		_g_free0 (_tmp19_);
#line 1448 "../src/Photo.vala"
		result = FALSE;
#line 1448 "../src/Photo.vala"
		_backing_photo_row_unref0 (backing);
#line 1448 "../src/Photo.vala"
		_detected_photo_information_unref0 (detected);
#line 1448 "../src/Photo.vala"
		_g_object_unref0 (file);
#line 1448 "../src/Photo.vala"
		if (reimport_state) {
#line 1448 "../src/Photo.vala"
			*reimport_state = _vala_reimport_state;
#line 12156 "Photo.c"
		} else {
#line 1448 "../src/Photo.vala"
			_photo_reimport_master_state_unref0 (_vala_reimport_state);
#line 12160 "Photo.c"
		}
#line 1448 "../src/Photo.vala"
		return result;
#line 12164 "Photo.c"
	}
#line 1452 "../src/Photo.vala"
	_tmp20_ = photo_row_new ();
#line 1452 "../src/Photo.vala"
	updated_row = _tmp20_;
#line 12170 "Photo.c"
	{
		PhotoRow* _tmp21_;
#line 1453 "../src/Photo.vala"
		_tmp21_ = self->row;
#line 1453 "../src/Photo.vala"
		g_rec_mutex_lock (&self->priv->__lock_row);
#line 12177 "Photo.c"
		{
			PhotoRow* _tmp22_;
			PhotoRow* _tmp23_;
#line 1454 "../src/Photo.vala"
			_tmp22_ = self->row;
#line 1454 "../src/Photo.vala"
			_tmp23_ = _photo_row_ref0 (_tmp22_);
#line 1454 "../src/Photo.vala"
			_photo_row_unref0 (updated_row);
#line 1454 "../src/Photo.vala"
			updated_row = _tmp23_;
#line 12189 "Photo.c"
		}
		__finally0:
		{
			PhotoRow* _tmp24_;
#line 1453 "../src/Photo.vala"
			_tmp24_ = self->row;
#line 1453 "../src/Photo.vala"
			g_rec_mutex_unlock (&self->priv->__lock_row);
#line 12198 "Photo.c"
		}
#line 1453 "../src/Photo.vala"
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 12202 "Photo.c"
			gboolean _tmp25_ = FALSE;
#line 1453 "../src/Photo.vala"
			g_propagate_error (error, _inner_error0_);
#line 1453 "../src/Photo.vala"
			_photo_row_unref0 (updated_row);
#line 1453 "../src/Photo.vala"
			_backing_photo_row_unref0 (backing);
#line 1453 "../src/Photo.vala"
			_detected_photo_information_unref0 (detected);
#line 1453 "../src/Photo.vala"
			_g_object_unref0 (file);
#line 1453 "../src/Photo.vala"
			_photo_reimport_master_state_unref0 (_vala_reimport_state);
#line 1453 "../src/Photo.vala"
			return _tmp25_;
#line 12218 "Photo.c"
		}
	}
#line 1458 "../src/Photo.vala"
	_tmp26_ = g_new0 (gchar*, 0 + 1);
#line 1458 "../src/Photo.vala"
	list = _tmp26_;
#line 1458 "../src/Photo.vala"
	list_length1 = 0;
#line 1458 "../src/Photo.vala"
	_list_size_ = list_length1;
#line 1460 "../src/Photo.vala"
	_tmp27_ = updated_row;
#line 1460 "../src/Photo.vala"
	_tmp28_ = _tmp27_->md5;
#line 1460 "../src/Photo.vala"
	_tmp29_ = detected;
#line 1460 "../src/Photo.vala"
	_tmp30_ = _tmp29_->md5;
#line 1460 "../src/Photo.vala"
	if (g_strcmp0 (_tmp28_, _tmp30_) != 0) {
#line 12239 "Photo.c"
		gchar* _tmp31_;
#line 1461 "../src/Photo.vala"
		_tmp31_ = g_strdup ("metadata:md5");
#line 1461 "../src/Photo.vala"
		_vala_array_add86 (&list, &list_length1, &_list_size_, _tmp31_);
#line 12245 "Photo.c"
	}
#line 1463 "../src/Photo.vala"
	_tmp32_ = updated_row;
#line 1463 "../src/Photo.vala"
	_tmp33_ = _tmp32_->master;
#line 1463 "../src/Photo.vala"
	_tmp34_ = backing;
#line 1463 "../src/Photo.vala"
	if (_tmp33_->original_orientation != _tmp34_->original_orientation) {
#line 12255 "Photo.c"
		gchar* _tmp35_;
		PhotoRow* _tmp36_;
		BackingPhotoRow* _tmp37_;
		BackingPhotoRow* _tmp38_;
#line 1464 "../src/Photo.vala"
		_tmp35_ = g_strdup ("image:orientation");
#line 1464 "../src/Photo.vala"
		_vala_array_add87 (&list, &list_length1, &_list_size_, _tmp35_);
#line 1465 "../src/Photo.vala"
		_tmp36_ = updated_row;
#line 1465 "../src/Photo.vala"
		_tmp37_ = _tmp36_->master;
#line 1465 "../src/Photo.vala"
		_tmp38_ = backing;
#line 1465 "../src/Photo.vala"
		_tmp37_->original_orientation = _tmp38_->original_orientation;
#line 12272 "Photo.c"
	}
#line 1468 "../src/Photo.vala"
	memset (&gps_coords, 0, sizeof (GpsCoords));
#line 1470 "../src/Photo.vala"
	_tmp39_ = detected;
#line 1470 "../src/Photo.vala"
	_tmp40_ = _tmp39_->metadata;
#line 1470 "../src/Photo.vala"
	if (_tmp40_ != NULL) {
#line 12282 "Photo.c"
		MetadataDateTime* date_time = NULL;
		DetectedPhotoInformation* _tmp41_;
		PhotoMetadata* _tmp42_;
		MetadataDateTime* _tmp43_;
		gboolean _tmp44_ = FALSE;
		gboolean _tmp45_ = FALSE;
		MetadataDateTime* _tmp46_;
		PhotoRow* _tmp55_;
		const gchar* _tmp56_;
		DetectedPhotoInformation* _tmp57_;
		PhotoMetadata* _tmp58_;
		gchar* _tmp59_;
		gchar* _tmp60_;
		gboolean _tmp61_;
		DetectedPhotoInformation* _tmp63_;
		PhotoMetadata* _tmp64_;
		GpsCoords _tmp65_ = {0};
		PhotoRow* _tmp66_;
		GpsCoords _tmp67_;
		GpsCoords _tmp68_;
		PhotoRow* _tmp70_;
		const gchar* _tmp71_;
		DetectedPhotoInformation* _tmp72_;
		PhotoMetadata* _tmp73_;
		gchar* _tmp74_;
		gchar* _tmp75_;
		gboolean _tmp76_;
		PhotoRow* _tmp78_;
		DetectedPhotoInformation* _tmp79_;
		PhotoMetadata* _tmp80_;
#line 1471 "../src/Photo.vala"
		_tmp41_ = detected;
#line 1471 "../src/Photo.vala"
		_tmp42_ = _tmp41_->metadata;
#line 1471 "../src/Photo.vala"
		_tmp43_ = photo_metadata_get_exposure_date_time (_tmp42_);
#line 1471 "../src/Photo.vala"
		date_time = _tmp43_;
#line 1472 "../src/Photo.vala"
		_tmp46_ = date_time;
#line 1472 "../src/Photo.vala"
		if (_tmp46_ != NULL) {
#line 12325 "Photo.c"
			PhotoRow* _tmp47_;
			GDateTime* _tmp48_;
#line 1472 "../src/Photo.vala"
			_tmp47_ = updated_row;
#line 1472 "../src/Photo.vala"
			_tmp48_ = _tmp47_->exposure_time;
#line 1472 "../src/Photo.vala"
			_tmp45_ = _tmp48_ != NULL;
#line 12334 "Photo.c"
		} else {
#line 1472 "../src/Photo.vala"
			_tmp45_ = FALSE;
#line 12338 "Photo.c"
		}
#line 1472 "../src/Photo.vala"
		if (_tmp45_) {
#line 12342 "Photo.c"
			PhotoRow* _tmp49_;
			GDateTime* _tmp50_;
			MetadataDateTime* _tmp51_;
			GDateTime* _tmp52_;
			GDateTime* _tmp53_;
#line 1473 "../src/Photo.vala"
			_tmp49_ = updated_row;
#line 1473 "../src/Photo.vala"
			_tmp50_ = _tmp49_->exposure_time;
#line 1473 "../src/Photo.vala"
			_tmp51_ = date_time;
#line 1473 "../src/Photo.vala"
			_tmp52_ = metadata_date_time_get_timestamp (_tmp51_);
#line 1473 "../src/Photo.vala"
			_tmp53_ = _tmp52_;
#line 1473 "../src/Photo.vala"
			_tmp44_ = !g_date_time_equal (_tmp50_, _tmp53_);
#line 1473 "../src/Photo.vala"
			_g_date_time_unref0 (_tmp53_);
#line 12362 "Photo.c"
		} else {
#line 1472 "../src/Photo.vala"
			_tmp44_ = FALSE;
#line 12366 "Photo.c"
		}
#line 1472 "../src/Photo.vala"
		if (_tmp44_) {
#line 12370 "Photo.c"
			gchar* _tmp54_;
#line 1474 "../src/Photo.vala"
			_tmp54_ = g_strdup ("metadata:exposure-time");
#line 1474 "../src/Photo.vala"
			_vala_array_add88 (&list, &list_length1, &_list_size_, _tmp54_);
#line 12376 "Photo.c"
		}
#line 1476 "../src/Photo.vala"
		_tmp55_ = updated_row;
#line 1476 "../src/Photo.vala"
		_tmp56_ = _tmp55_->title;
#line 1476 "../src/Photo.vala"
		_tmp57_ = detected;
#line 1476 "../src/Photo.vala"
		_tmp58_ = _tmp57_->metadata;
#line 1476 "../src/Photo.vala"
		_tmp59_ = media_metadata_get_title (G_TYPE_CHECK_INSTANCE_CAST (_tmp58_, TYPE_MEDIA_METADATA, MediaMetadata));
#line 1476 "../src/Photo.vala"
		_tmp60_ = _tmp59_;
#line 1476 "../src/Photo.vala"
		_tmp61_ = g_strcmp0 (_tmp56_, _tmp60_) != 0;
#line 1476 "../src/Photo.vala"
		_g_free0 (_tmp60_);
#line 1476 "../src/Photo.vala"
		if (_tmp61_) {
#line 12396 "Photo.c"
			gchar* _tmp62_;
#line 1477 "../src/Photo.vala"
			_tmp62_ = g_strdup ("metadata:name");
#line 1477 "../src/Photo.vala"
			_vala_array_add89 (&list, &list_length1, &_list_size_, _tmp62_);
#line 12402 "Photo.c"
		}
#line 1479 "../src/Photo.vala"
		_tmp63_ = detected;
#line 1479 "../src/Photo.vala"
		_tmp64_ = _tmp63_->metadata;
#line 1479 "../src/Photo.vala"
		photo_metadata_get_gps_coords (_tmp64_, &_tmp65_);
#line 1479 "../src/Photo.vala"
		gps_coords = _tmp65_;
#line 1480 "../src/Photo.vala"
		_tmp66_ = updated_row;
#line 1480 "../src/Photo.vala"
		_tmp67_ = _tmp66_->gps_coords;
#line 1480 "../src/Photo.vala"
		_tmp68_ = gps_coords;
#line 1480 "../src/Photo.vala"
		if (_gps_coords_equal (&_tmp67_, &_tmp68_) != TRUE) {
#line 12420 "Photo.c"
			gchar* _tmp69_;
#line 1481 "../src/Photo.vala"
			_tmp69_ = g_strdup ("metadata:gps");
#line 1481 "../src/Photo.vala"
			_vala_array_add90 (&list, &list_length1, &_list_size_, _tmp69_);
#line 12426 "Photo.c"
		}
#line 1484 "../src/Photo.vala"
		_tmp70_ = updated_row;
#line 1484 "../src/Photo.vala"
		_tmp71_ = _tmp70_->comment;
#line 1484 "../src/Photo.vala"
		_tmp72_ = detected;
#line 1484 "../src/Photo.vala"
		_tmp73_ = _tmp72_->metadata;
#line 1484 "../src/Photo.vala"
		_tmp74_ = media_metadata_get_comment (G_TYPE_CHECK_INSTANCE_CAST (_tmp73_, TYPE_MEDIA_METADATA, MediaMetadata));
#line 1484 "../src/Photo.vala"
		_tmp75_ = _tmp74_;
#line 1484 "../src/Photo.vala"
		_tmp76_ = g_strcmp0 (_tmp71_, _tmp75_) != 0;
#line 1484 "../src/Photo.vala"
		_g_free0 (_tmp75_);
#line 1484 "../src/Photo.vala"
		if (_tmp76_) {
#line 12446 "Photo.c"
			gchar* _tmp77_;
#line 1485 "../src/Photo.vala"
			_tmp77_ = g_strdup ("metadata:comment");
#line 1485 "../src/Photo.vala"
			_vala_array_add91 (&list, &list_length1, &_list_size_, _tmp77_);
#line 12452 "Photo.c"
		}
#line 1487 "../src/Photo.vala"
		_tmp78_ = updated_row;
#line 1487 "../src/Photo.vala"
		_tmp79_ = detected;
#line 1487 "../src/Photo.vala"
		_tmp80_ = _tmp79_->metadata;
#line 1487 "../src/Photo.vala"
		if (_tmp78_->rating != photo_metadata_get_rating (_tmp80_)) {
#line 12462 "Photo.c"
			gchar* _tmp81_;
#line 1488 "../src/Photo.vala"
			_tmp81_ = g_strdup ("metadata:rating");
#line 1488 "../src/Photo.vala"
			_vala_array_add92 (&list, &list_length1, &_list_size_, _tmp81_);
#line 12468 "Photo.c"
		}
#line 1470 "../src/Photo.vala"
		_metadata_date_time_unref0 (date_time);
#line 12472 "Photo.c"
	}
#line 1491 "../src/Photo.vala"
	_tmp82_ = updated_row;
#line 1491 "../src/Photo.vala"
	_tmp83_ = backing;
#line 1491 "../src/Photo.vala"
	_tmp84_ = _backing_photo_row_ref0 (_tmp83_);
#line 1491 "../src/Photo.vala"
	_backing_photo_row_unref0 (_tmp82_->master);
#line 1491 "../src/Photo.vala"
	_tmp82_->master = _tmp84_;
#line 1492 "../src/Photo.vala"
	_tmp85_ = updated_row;
#line 1492 "../src/Photo.vala"
	_tmp86_ = detected;
#line 1492 "../src/Photo.vala"
	_tmp87_ = _tmp86_->md5;
#line 1492 "../src/Photo.vala"
	_tmp88_ = g_strdup (_tmp87_);
#line 1492 "../src/Photo.vala"
	_g_free0 (_tmp85_->md5);
#line 1492 "../src/Photo.vala"
	_tmp85_->md5 = _tmp88_;
#line 1493 "../src/Photo.vala"
	_tmp89_ = updated_row;
#line 1493 "../src/Photo.vala"
	_tmp90_ = detected;
#line 1493 "../src/Photo.vala"
	_tmp91_ = _tmp90_->exif_md5;
#line 1493 "../src/Photo.vala"
	_tmp92_ = g_strdup (_tmp91_);
#line 1493 "../src/Photo.vala"
	_g_free0 (_tmp89_->exif_md5);
#line 1493 "../src/Photo.vala"
	_tmp89_->exif_md5 = _tmp92_;
#line 1494 "../src/Photo.vala"
	_tmp93_ = updated_row;
#line 1494 "../src/Photo.vala"
	_tmp94_ = detected;
#line 1494 "../src/Photo.vala"
	_tmp95_ = _tmp94_->thumbnail_md5;
#line 1494 "../src/Photo.vala"
	_tmp96_ = g_strdup (_tmp95_);
#line 1494 "../src/Photo.vala"
	_g_free0 (_tmp93_->thumbnail_md5);
#line 1494 "../src/Photo.vala"
	_tmp93_->thumbnail_md5 = _tmp96_;
#line 1496 "../src/Photo.vala"
	metadata = NULL;
#line 1497 "../src/Photo.vala"
	_tmp97_ = detected;
#line 1497 "../src/Photo.vala"
	_tmp98_ = _tmp97_->metadata;
#line 1497 "../src/Photo.vala"
	if (_tmp98_ != NULL) {
#line 12528 "Photo.c"
		DetectedPhotoInformation* _tmp99_;
		PhotoMetadata* _tmp100_;
		PhotoMetadata* _tmp101_;
		MetadataDateTime* date_time = NULL;
		DetectedPhotoInformation* _tmp102_;
		PhotoMetadata* _tmp103_;
		MetadataDateTime* _tmp104_;
		MetadataDateTime* _tmp105_;
		PhotoRow* _tmp109_;
		GpsCoords _tmp110_;
		PhotoRow* _tmp111_;
		DetectedPhotoInformation* _tmp112_;
		PhotoMetadata* _tmp113_;
		gchar* _tmp114_;
		PhotoRow* _tmp115_;
		DetectedPhotoInformation* _tmp116_;
		PhotoMetadata* _tmp117_;
		gchar* _tmp118_;
		PhotoRow* _tmp119_;
		DetectedPhotoInformation* _tmp120_;
		PhotoMetadata* _tmp121_;
#line 1498 "../src/Photo.vala"
		_tmp99_ = detected;
#line 1498 "../src/Photo.vala"
		_tmp100_ = _tmp99_->metadata;
#line 1498 "../src/Photo.vala"
		_tmp101_ = _media_metadata_ref0 (_tmp100_);
#line 1498 "../src/Photo.vala"
		_media_metadata_unref0 (metadata);
#line 1498 "../src/Photo.vala"
		metadata = _tmp101_;
#line 1500 "../src/Photo.vala"
		_tmp102_ = detected;
#line 1500 "../src/Photo.vala"
		_tmp103_ = _tmp102_->metadata;
#line 1500 "../src/Photo.vala"
		_tmp104_ = photo_metadata_get_exposure_date_time (_tmp103_);
#line 1500 "../src/Photo.vala"
		date_time = _tmp104_;
#line 1501 "../src/Photo.vala"
		_tmp105_ = date_time;
#line 1501 "../src/Photo.vala"
		if (_tmp105_ != NULL) {
#line 12572 "Photo.c"
			PhotoRow* _tmp106_;
			MetadataDateTime* _tmp107_;
			GDateTime* _tmp108_;
#line 1502 "../src/Photo.vala"
			_tmp106_ = updated_row;
#line 1502 "../src/Photo.vala"
			_tmp107_ = date_time;
#line 1502 "../src/Photo.vala"
			_tmp108_ = metadata_date_time_get_timestamp (_tmp107_);
#line 1502 "../src/Photo.vala"
			_g_date_time_unref0 (_tmp106_->exposure_time);
#line 1502 "../src/Photo.vala"
			_tmp106_->exposure_time = _tmp108_;
#line 12586 "Photo.c"
		}
#line 1504 "../src/Photo.vala"
		_tmp109_ = updated_row;
#line 1504 "../src/Photo.vala"
		_tmp110_ = gps_coords;
#line 1504 "../src/Photo.vala"
		_tmp109_->gps_coords = _tmp110_;
#line 1505 "../src/Photo.vala"
		_tmp111_ = updated_row;
#line 1505 "../src/Photo.vala"
		_tmp112_ = detected;
#line 1505 "../src/Photo.vala"
		_tmp113_ = _tmp112_->metadata;
#line 1505 "../src/Photo.vala"
		_tmp114_ = media_metadata_get_title (G_TYPE_CHECK_INSTANCE_CAST (_tmp113_, TYPE_MEDIA_METADATA, MediaMetadata));
#line 1505 "../src/Photo.vala"
		_g_free0 (_tmp111_->title);
#line 1505 "../src/Photo.vala"
		_tmp111_->title = _tmp114_;
#line 1506 "../src/Photo.vala"
		_tmp115_ = updated_row;
#line 1506 "../src/Photo.vala"
		_tmp116_ = detected;
#line 1506 "../src/Photo.vala"
		_tmp117_ = _tmp116_->metadata;
#line 1506 "../src/Photo.vala"
		_tmp118_ = media_metadata_get_comment (G_TYPE_CHECK_INSTANCE_CAST (_tmp117_, TYPE_MEDIA_METADATA, MediaMetadata));
#line 1506 "../src/Photo.vala"
		_g_free0 (_tmp115_->comment);
#line 1506 "../src/Photo.vala"
		_tmp115_->comment = _tmp118_;
#line 1507 "../src/Photo.vala"
		_tmp119_ = updated_row;
#line 1507 "../src/Photo.vala"
		_tmp120_ = detected;
#line 1507 "../src/Photo.vala"
		_tmp121_ = _tmp120_->metadata;
#line 1507 "../src/Photo.vala"
		_tmp119_->rating = photo_metadata_get_rating (_tmp121_);
#line 1497 "../src/Photo.vala"
		_metadata_date_time_unref0 (date_time);
#line 12628 "Photo.c"
	}
#line 1510 "../src/Photo.vala"
	_tmp122_ = updated_row;
#line 1510 "../src/Photo.vala"
	_tmp123_ = metadata;
#line 1510 "../src/Photo.vala"
	_tmp124_ = list;
#line 1510 "../src/Photo.vala"
	_tmp124__length1 = list_length1;
#line 1510 "../src/Photo.vala"
	_tmp125_ = photo_reimport_master_state_impl_new (_tmp122_, _tmp123_, _tmp124_, _tmp124__length1);
#line 1510 "../src/Photo.vala"
	_photo_reimport_master_state_unref0 (_vala_reimport_state);
#line 1510 "../src/Photo.vala"
	_vala_reimport_state = G_TYPE_CHECK_INSTANCE_CAST (_tmp125_, PHOTO_TYPE_REIMPORT_MASTER_STATE, PhotoReimportMasterState);
#line 1512 "../src/Photo.vala"
	result = TRUE;
#line 1512 "../src/Photo.vala"
	_media_metadata_unref0 (metadata);
#line 1512 "../src/Photo.vala"
	list = (_vala_array_free (list, list_length1, (GDestroyNotify) g_free), NULL);
#line 1512 "../src/Photo.vala"
	_photo_row_unref0 (updated_row);
#line 1512 "../src/Photo.vala"
	_backing_photo_row_unref0 (backing);
#line 1512 "../src/Photo.vala"
	_detected_photo_information_unref0 (detected);
#line 1512 "../src/Photo.vala"
	_g_object_unref0 (file);
#line 1512 "../src/Photo.vala"
	if (reimport_state) {
#line 1512 "../src/Photo.vala"
		*reimport_state = _vala_reimport_state;
#line 12662 "Photo.c"
	} else {
#line 1512 "../src/Photo.vala"
		_photo_reimport_master_state_unref0 (_vala_reimport_state);
#line 12666 "Photo.c"
	}
#line 1512 "../src/Photo.vala"
	return result;
#line 12670 "Photo.c"
}

static void
photo_real_apply_user_metadata_for_reimport (Photo* self,
                                             PhotoMetadata* metadata)
{
#line 1515 "../src/Photo.vala"
	g_critical ("Type `%s' does not implement abstract method `photo_apply_user_metadata_for_reimport'", g_type_name (G_TYPE_FROM_INSTANCE (self)));
#line 1515 "../src/Photo.vala"
	return;
#line 12681 "Photo.c"
}

void
photo_apply_user_metadata_for_reimport (Photo* self,
                                        PhotoMetadata* metadata)
{
	PhotoClass* _klass_;
#line 1515 "../src/Photo.vala"
	g_return_if_fail (IS_PHOTO (self));
#line 1515 "../src/Photo.vala"
	_klass_ = PHOTO_GET_CLASS (self);
#line 1515 "../src/Photo.vala"
	if (_klass_->apply_user_metadata_for_reimport) {
#line 1515 "../src/Photo.vala"
		_klass_->apply_user_metadata_for_reimport (self, metadata);
#line 12697 "Photo.c"
	}
}

static gpointer
_photo_reimport_master_state_ref0 (gpointer self)
{
#line 1519 "../src/Photo.vala"
	return self ? photo_reimport_master_state_ref (self) : NULL;
#line 12706 "Photo.c"
}

static void
_vala_array_add93 (gchar** * array,
                   gint* length,
                   gint* size,
                   gchar* value)
{
#line 1537 "../src/Photo.vala"
	if ((*length) == (*size)) {
#line 1537 "../src/Photo.vala"
		*size = (*size) ? (2 * (*size)) : 4;
#line 1537 "../src/Photo.vala"
		*array = g_renew (gchar*, *array, (*size) + 1);
#line 12721 "Photo.c"
	}
#line 1537 "../src/Photo.vala"
	(*array)[(*length)++] = value;
#line 1537 "../src/Photo.vala"
	(*array)[*length] = NULL;
#line 12727 "Photo.c"
}

static void
_vala_array_add94 (gchar** * array,
                   gint* length,
                   gint* size,
                   gchar* value)
{
#line 1539 "../src/Photo.vala"
	if ((*length) == (*size)) {
#line 1539 "../src/Photo.vala"
		*size = (*size) ? (2 * (*size)) : 4;
#line 1539 "../src/Photo.vala"
		*array = g_renew (gchar*, *array, (*size) + 1);
#line 12742 "Photo.c"
	}
#line 1539 "../src/Photo.vala"
	(*array)[(*length)++] = value;
#line 1539 "../src/Photo.vala"
	(*array)[*length] = NULL;
#line 12748 "Photo.c"
}

void
photo_finish_reimport_master (Photo* self,
                              PhotoReimportMasterState* state,
                              GError** error)
{
	PhotoReimportMasterStateImpl* reimport_state = NULL;
	PhotoReimportMasterStateImpl* _tmp0_;
	PhotoTable* _tmp1_;
	PhotoTable* _tmp2_;
	PhotoRow* _tmp3_;
	PhotoMetadata* _tmp18_;
	gchar** _tmp22_;
	gint _tmp22__length1;
	PhotoMetadata* _tmp26_;
	GError* _inner_error0_ = NULL;
#line 1518 "../src/Photo.vala"
	g_return_if_fail (IS_PHOTO (self));
#line 1518 "../src/Photo.vala"
	g_return_if_fail (PHOTO_IS_REIMPORT_MASTER_STATE (state));
#line 1519 "../src/Photo.vala"
	_tmp0_ = _photo_reimport_master_state_ref0 (G_TYPE_CHECK_INSTANCE_CAST (state, PHOTO_TYPE_REIMPORT_MASTER_STATE_IMPL, PhotoReimportMasterStateImpl));
#line 1519 "../src/Photo.vala"
	reimport_state = _tmp0_;
#line 1521 "../src/Photo.vala"
	_tmp1_ = photo_table_get_instance ();
#line 1521 "../src/Photo.vala"
	_tmp2_ = _tmp1_;
#line 1521 "../src/Photo.vala"
	_tmp3_ = reimport_state->row;
#line 1521 "../src/Photo.vala"
	photo_table_reimport (_tmp2_, _tmp3_, &_inner_error0_);
#line 1521 "../src/Photo.vala"
	_database_table_unref0 (_tmp2_);
#line 1521 "../src/Photo.vala"
	if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 1521 "../src/Photo.vala"
		if (_inner_error0_->domain == DATABASE_ERROR) {
#line 1521 "../src/Photo.vala"
			g_propagate_error (error, _inner_error0_);
#line 1521 "../src/Photo.vala"
			_photo_reimport_master_state_unref0 (reimport_state);
#line 1521 "../src/Photo.vala"
			return;
#line 12794 "Photo.c"
		} else {
#line 1521 "../src/Photo.vala"
			_photo_reimport_master_state_unref0 (reimport_state);
#line 1521 "../src/Photo.vala"
			g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 1521 "../src/Photo.vala"
			g_clear_error (&_inner_error0_);
#line 1521 "../src/Photo.vala"
			return;
#line 12804 "Photo.c"
		}
	}
	{
		PhotoRow* _tmp4_;
#line 1523 "../src/Photo.vala"
		_tmp4_ = self->row;
#line 1523 "../src/Photo.vala"
		g_rec_mutex_lock (&self->priv->__lock_row);
#line 12813 "Photo.c"
		{
			BackingPhotoRow* original_master = NULL;
			PhotoRow* _tmp5_;
			BackingPhotoRow* _tmp6_;
			BackingPhotoRow* _tmp7_;
			PhotoRow* _tmp8_;
			PhotoRow* _tmp9_;
			PhotoRow* _tmp10_;
			BackingPhotoRow* _tmp11_;
			BackingPhotoRow* _tmp12_;
			PhotoRow* _tmp13_;
			BackingPhotoRow* _tmp14_;
			PhotoRow* _tmp15_;
			BackingPhotoRow* _tmp16_;
#line 1525 "../src/Photo.vala"
			_tmp5_ = self->row;
#line 1525 "../src/Photo.vala"
			_tmp6_ = _tmp5_->master;
#line 1525 "../src/Photo.vala"
			_tmp7_ = _backing_photo_row_ref0 (_tmp6_);
#line 1525 "../src/Photo.vala"
			original_master = _tmp7_;
#line 1526 "../src/Photo.vala"
			_tmp8_ = reimport_state->row;
#line 1526 "../src/Photo.vala"
			_tmp9_ = _photo_row_ref0 (_tmp8_);
#line 1526 "../src/Photo.vala"
			_photo_row_unref0 (self->row);
#line 1526 "../src/Photo.vala"
			self->row = _tmp9_;
#line 1527 "../src/Photo.vala"
			_tmp10_ = self->row;
#line 1527 "../src/Photo.vala"
			_tmp11_ = original_master;
#line 1527 "../src/Photo.vala"
			_tmp12_ = _backing_photo_row_ref0 (_tmp11_);
#line 1527 "../src/Photo.vala"
			_backing_photo_row_unref0 (_tmp10_->master);
#line 1527 "../src/Photo.vala"
			_tmp10_->master = _tmp12_;
#line 1528 "../src/Photo.vala"
			_tmp13_ = self->row;
#line 1528 "../src/Photo.vala"
			_tmp14_ = _tmp13_->master;
#line 1528 "../src/Photo.vala"
			_tmp15_ = reimport_state->row;
#line 1528 "../src/Photo.vala"
			_tmp16_ = _tmp15_->master;
#line 1528 "../src/Photo.vala"
			backing_photo_row_copy_from (_tmp14_, _tmp16_);
#line 1529 "../src/Photo.vala"
			if (!reimport_state->metadata_only) {
#line 1530 "../src/Photo.vala"
				photo_remove_all_transformations (self, FALSE);
#line 12868 "Photo.c"
			}
#line 1523 "../src/Photo.vala"
			_backing_photo_row_unref0 (original_master);
#line 12872 "Photo.c"
		}
		__finally0:
		{
			PhotoRow* _tmp17_;
#line 1523 "../src/Photo.vala"
			_tmp17_ = self->row;
#line 1523 "../src/Photo.vala"
			g_rec_mutex_unlock (&self->priv->__lock_row);
#line 12881 "Photo.c"
		}
#line 1523 "../src/Photo.vala"
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 1523 "../src/Photo.vala"
			if (_inner_error0_->domain == DATABASE_ERROR) {
#line 1523 "../src/Photo.vala"
				g_propagate_error (error, _inner_error0_);
#line 1523 "../src/Photo.vala"
				_photo_reimport_master_state_unref0 (reimport_state);
#line 1523 "../src/Photo.vala"
				return;
#line 12893 "Photo.c"
			} else {
#line 1523 "../src/Photo.vala"
				_photo_reimport_master_state_unref0 (reimport_state);
#line 1523 "../src/Photo.vala"
				g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 1523 "../src/Photo.vala"
				g_clear_error (&_inner_error0_);
#line 1523 "../src/Photo.vala"
				return;
#line 12903 "Photo.c"
			}
		}
	}
#line 1533 "../src/Photo.vala"
	_tmp18_ = reimport_state->metadata;
#line 1533 "../src/Photo.vala"
	if (_tmp18_ != NULL) {
#line 12911 "Photo.c"
		PhotoMetadata* _tmp19_;
#line 1534 "../src/Photo.vala"
		_tmp19_ = reimport_state->metadata;
#line 1534 "../src/Photo.vala"
		photo_apply_user_metadata_for_reimport (self, _tmp19_);
#line 12917 "Photo.c"
	}
#line 1536 "../src/Photo.vala"
	if (!reimport_state->metadata_only) {
#line 12921 "Photo.c"
		gchar* _tmp20_;
#line 1537 "../src/Photo.vala"
		_tmp20_ = g_strdup ("image:master");
#line 1537 "../src/Photo.vala"
		_vala_array_add93 (&reimport_state->alterations, &reimport_state->alterations_length1, &reimport_state->_alterations_size_, _tmp20_);
#line 1538 "../src/Photo.vala"
		if (photo_is_master_baseline (self)) {
#line 12929 "Photo.c"
			gchar* _tmp21_;
#line 1539 "../src/Photo.vala"
			_tmp21_ = g_strdup ("image:baseline");
#line 1539 "../src/Photo.vala"
			_vala_array_add94 (&reimport_state->alterations, &reimport_state->alterations_length1, &reimport_state->_alterations_size_, _tmp21_);
#line 12935 "Photo.c"
		}
	}
#line 1542 "../src/Photo.vala"
	_tmp22_ = reimport_state->alterations;
#line 1542 "../src/Photo.vala"
	_tmp22__length1 = reimport_state->alterations_length1;
#line 1542 "../src/Photo.vala"
	if (_tmp22__length1 > 0) {
#line 12944 "Photo.c"
		gchar** _tmp23_;
		gint _tmp23__length1;
		Alteration* _tmp24_;
		Alteration* _tmp25_;
#line 1543 "../src/Photo.vala"
		_tmp23_ = reimport_state->alterations;
#line 1543 "../src/Photo.vala"
		_tmp23__length1 = reimport_state->alterations_length1;
#line 1543 "../src/Photo.vala"
		_tmp24_ = alteration_new_from_array (_tmp23_, _tmp23__length1);
#line 1543 "../src/Photo.vala"
		_tmp25_ = _tmp24_;
#line 1543 "../src/Photo.vala"
		data_object_notify_altered (G_TYPE_CHECK_INSTANCE_CAST (self, TYPE_DATA_OBJECT, DataObject), _tmp25_);
#line 1543 "../src/Photo.vala"
		_alteration_unref0 (_tmp25_);
#line 12961 "Photo.c"
	}
#line 1545 "../src/Photo.vala"
	_tmp26_ = reimport_state->metadata;
#line 1545 "../src/Photo.vala"
	photo_notify_master_reimported (self, _tmp26_);
#line 1547 "../src/Photo.vala"
	if (photo_is_master_baseline (self)) {
#line 12969 "Photo.c"
		PhotoMetadata* _tmp27_;
#line 1548 "../src/Photo.vala"
		_tmp27_ = reimport_state->metadata;
#line 1548 "../src/Photo.vala"
		photo_notify_baseline_reimported (self, _tmp27_);
#line 12975 "Photo.c"
	}
#line 1550 "../src/Photo.vala"
	if (photo_is_master_source (self)) {
#line 12979 "Photo.c"
		PhotoMetadata* _tmp28_;
#line 1551 "../src/Photo.vala"
		_tmp28_ = reimport_state->metadata;
#line 1551 "../src/Photo.vala"
		photo_notify_source_reimported (self, _tmp28_);
#line 12985 "Photo.c"
	}
#line 1518 "../src/Photo.vala"
	_photo_reimport_master_state_unref0 (reimport_state);
#line 12989 "Photo.c"
}

static gboolean
photo_verify_file_for_reimport (Photo* self,
                                GFile* file,
                                BackingPhotoRow** backing,
                                DetectedPhotoInformation** detected,
                                GError** error)
{
	BackingPhotoRow* _vala_backing = NULL;
	DetectedPhotoInformation* _vala_detected = NULL;
	BackingPhotoRow* _tmp0_ = NULL;
	DetectedPhotoInformation* _tmp1_ = NULL;
	BackingPhotoRow* _tmp2_;
	BackingPhotoRow* _tmp4_;
	BackingPhotoRow* _tmp5_;
	gboolean _tmp6_ = FALSE;
	gboolean _tmp7_ = FALSE;
	DetectedPhotoInformation* _tmp8_;
	GError* _inner_error0_ = NULL;
	gboolean result;
#line 1555 "../src/Photo.vala"
	g_return_val_if_fail (IS_PHOTO (self), FALSE);
#line 1555 "../src/Photo.vala"
	g_return_val_if_fail (G_TYPE_CHECK_INSTANCE_TYPE (file, g_file_get_type ()), FALSE);
#line 1557 "../src/Photo.vala"
	_tmp2_ = photo_query_backing_photo_row (self, file, PHOTO_FILE_SNIFFER_OPTIONS_NO_MD5, &_tmp1_, &_inner_error0_);
#line 1557 "../src/Photo.vala"
	_detected_photo_information_unref0 (_vala_detected);
#line 1557 "../src/Photo.vala"
	_vala_detected = _tmp1_;
#line 1557 "../src/Photo.vala"
	_tmp0_ = _tmp2_;
#line 1557 "../src/Photo.vala"
	if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 13025 "Photo.c"
		gboolean _tmp3_ = FALSE;
#line 1557 "../src/Photo.vala"
		g_propagate_error (error, _inner_error0_);
#line 1557 "../src/Photo.vala"
		_backing_photo_row_unref0 (_vala_backing);
#line 1557 "../src/Photo.vala"
		_detected_photo_information_unref0 (_vala_detected);
#line 1557 "../src/Photo.vala"
		return _tmp3_;
#line 13035 "Photo.c"
	}
#line 1557 "../src/Photo.vala"
	_tmp4_ = _tmp0_;
#line 1557 "../src/Photo.vala"
	_tmp0_ = NULL;
#line 1557 "../src/Photo.vala"
	_backing_photo_row_unref0 (_vala_backing);
#line 1557 "../src/Photo.vala"
	_vala_backing = _tmp4_;
#line 1559 "../src/Photo.vala"
	_tmp5_ = _vala_backing;
#line 1559 "../src/Photo.vala"
	if (_tmp5_ == NULL) {
#line 1560 "../src/Photo.vala"
		result = FALSE;
#line 1560 "../src/Photo.vala"
		_backing_photo_row_unref0 (_tmp0_);
#line 1560 "../src/Photo.vala"
		if (backing) {
#line 1560 "../src/Photo.vala"
			*backing = _vala_backing;
#line 13057 "Photo.c"
		} else {
#line 1560 "../src/Photo.vala"
			_backing_photo_row_unref0 (_vala_backing);
#line 13061 "Photo.c"
		}
#line 1560 "../src/Photo.vala"
		if (detected) {
#line 1560 "../src/Photo.vala"
			*detected = _vala_detected;
#line 13067 "Photo.c"
		} else {
#line 1560 "../src/Photo.vala"
			_detected_photo_information_unref0 (_vala_detected);
#line 13071 "Photo.c"
		}
#line 1560 "../src/Photo.vala"
		return result;
#line 13075 "Photo.c"
	}
#line 1564 "../src/Photo.vala"
	_tmp8_ = _vala_detected;
#line 1564 "../src/Photo.vala"
	if (_tmp8_->colorspace != GDK_COLORSPACE_RGB) {
#line 1564 "../src/Photo.vala"
		_tmp7_ = TRUE;
#line 13083 "Photo.c"
	} else {
		DetectedPhotoInformation* _tmp9_;
#line 1565 "../src/Photo.vala"
		_tmp9_ = _vala_detected;
#line 1565 "../src/Photo.vala"
		_tmp7_ = _tmp9_->channels < 3;
#line 13090 "Photo.c"
	}
#line 1564 "../src/Photo.vala"
	if (_tmp7_) {
#line 1564 "../src/Photo.vala"
		_tmp6_ = TRUE;
#line 13096 "Photo.c"
	} else {
		DetectedPhotoInformation* _tmp10_;
#line 1566 "../src/Photo.vala"
		_tmp10_ = _vala_detected;
#line 1566 "../src/Photo.vala"
		_tmp6_ = _tmp10_->bits_per_channel != 8;
#line 13103 "Photo.c"
	}
#line 1564 "../src/Photo.vala"
	if (_tmp6_) {
#line 13107 "Photo.c"
		gchar* _tmp11_;
		gchar* _tmp12_;
#line 1567 "../src/Photo.vala"
		_tmp11_ = g_file_get_path (file);
#line 1567 "../src/Photo.vala"
		_tmp12_ = _tmp11_;
#line 1567 "../src/Photo.vala"
		g_warning ("Photo.vala:1567: Not re-importing %s: Unsupported color format", _tmp12_);
#line 1567 "../src/Photo.vala"
		_g_free0 (_tmp12_);
#line 1569 "../src/Photo.vala"
		result = FALSE;
#line 1569 "../src/Photo.vala"
		_backing_photo_row_unref0 (_tmp0_);
#line 1569 "../src/Photo.vala"
		if (backing) {
#line 1569 "../src/Photo.vala"
			*backing = _vala_backing;
#line 13126 "Photo.c"
		} else {
#line 1569 "../src/Photo.vala"
			_backing_photo_row_unref0 (_vala_backing);
#line 13130 "Photo.c"
		}
#line 1569 "../src/Photo.vala"
		if (detected) {
#line 1569 "../src/Photo.vala"
			*detected = _vala_detected;
#line 13136 "Photo.c"
		} else {
#line 1569 "../src/Photo.vala"
			_detected_photo_information_unref0 (_vala_detected);
#line 13140 "Photo.c"
		}
#line 1569 "../src/Photo.vala"
		return result;
#line 13144 "Photo.c"
	}
#line 1572 "../src/Photo.vala"
	result = TRUE;
#line 1572 "../src/Photo.vala"
	_backing_photo_row_unref0 (_tmp0_);
#line 1572 "../src/Photo.vala"
	if (backing) {
#line 1572 "../src/Photo.vala"
		*backing = _vala_backing;
#line 13154 "Photo.c"
	} else {
#line 1572 "../src/Photo.vala"
		_backing_photo_row_unref0 (_vala_backing);
#line 13158 "Photo.c"
	}
#line 1572 "../src/Photo.vala"
	if (detected) {
#line 1572 "../src/Photo.vala"
		*detected = _vala_detected;
#line 13164 "Photo.c"
	} else {
#line 1572 "../src/Photo.vala"
		_detected_photo_information_unref0 (_vala_detected);
#line 13168 "Photo.c"
	}
#line 1572 "../src/Photo.vala"
	return result;
#line 13172 "Photo.c"
}

gboolean
photo_prepare_for_reimport_editable (Photo* self,
                                     PhotoReimportEditableState** state,
                                     GError** error)
{
	PhotoReimportEditableState* _vala_state = NULL;
	GFile* file = NULL;
	GFile* _tmp0_;
	GFile* _tmp1_;
	DetectedPhotoInformation* detected = NULL;
	BackingPhotoRow* backing = NULL;
	gboolean _tmp2_ = FALSE;
	GFile* _tmp3_;
	BackingPhotoRow* _tmp4_ = NULL;
	DetectedPhotoInformation* _tmp5_ = NULL;
	gboolean _tmp6_;
	BackingPhotoRow* _tmp8_;
	DetectedPhotoInformation* _tmp9_;
	PhotoMetadata* _tmp10_;
	PhotoReimportEditableStateImpl* _tmp11_;
	GError* _inner_error0_ = NULL;
	gboolean result;
#line 1576 "../src/Photo.vala"
	g_return_val_if_fail (IS_PHOTO (self), FALSE);
#line 1577 "../src/Photo.vala"
	_photo_reimport_editable_state_unref0 (_vala_state);
#line 1577 "../src/Photo.vala"
	_vala_state = NULL;
#line 1579 "../src/Photo.vala"
	_tmp0_ = photo_get_editable_file (self);
#line 1579 "../src/Photo.vala"
	file = _tmp0_;
#line 1580 "../src/Photo.vala"
	_tmp1_ = file;
#line 1580 "../src/Photo.vala"
	if (_tmp1_ == NULL) {
#line 1581 "../src/Photo.vala"
		result = FALSE;
#line 1581 "../src/Photo.vala"
		_g_object_unref0 (file);
#line 1581 "../src/Photo.vala"
		if (state) {
#line 1581 "../src/Photo.vala"
			*state = _vala_state;
#line 13219 "Photo.c"
		} else {
#line 1581 "../src/Photo.vala"
			_photo_reimport_editable_state_unref0 (_vala_state);
#line 13223 "Photo.c"
		}
#line 1581 "../src/Photo.vala"
		return result;
#line 13227 "Photo.c"
	}
#line 1585 "../src/Photo.vala"
	_tmp3_ = file;
#line 1585 "../src/Photo.vala"
	_tmp6_ = photo_verify_file_for_reimport (self, _tmp3_, &_tmp4_, &_tmp5_, &_inner_error0_);
#line 1585 "../src/Photo.vala"
	_backing_photo_row_unref0 (backing);
#line 1585 "../src/Photo.vala"
	backing = _tmp4_;
#line 1585 "../src/Photo.vala"
	_detected_photo_information_unref0 (detected);
#line 1585 "../src/Photo.vala"
	detected = _tmp5_;
#line 1585 "../src/Photo.vala"
	_tmp2_ = _tmp6_;
#line 1585 "../src/Photo.vala"
	if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 13245 "Photo.c"
		gboolean _tmp7_ = FALSE;
#line 1585 "../src/Photo.vala"
		g_propagate_error (error, _inner_error0_);
#line 1585 "../src/Photo.vala"
		_backing_photo_row_unref0 (backing);
#line 1585 "../src/Photo.vala"
		_detected_photo_information_unref0 (detected);
#line 1585 "../src/Photo.vala"
		_g_object_unref0 (file);
#line 1585 "../src/Photo.vala"
		_photo_reimport_editable_state_unref0 (_vala_state);
#line 1585 "../src/Photo.vala"
		return _tmp7_;
#line 13259 "Photo.c"
	}
#line 1585 "../src/Photo.vala"
	if (!_tmp2_) {
#line 1586 "../src/Photo.vala"
		result = FALSE;
#line 1586 "../src/Photo.vala"
		_backing_photo_row_unref0 (backing);
#line 1586 "../src/Photo.vala"
		_detected_photo_information_unref0 (detected);
#line 1586 "../src/Photo.vala"
		_g_object_unref0 (file);
#line 1586 "../src/Photo.vala"
		if (state) {
#line 1586 "../src/Photo.vala"
			*state = _vala_state;
#line 13275 "Photo.c"
		} else {
#line 1586 "../src/Photo.vala"
			_photo_reimport_editable_state_unref0 (_vala_state);
#line 13279 "Photo.c"
		}
#line 1586 "../src/Photo.vala"
		return result;
#line 13283 "Photo.c"
	}
#line 1588 "../src/Photo.vala"
	_tmp8_ = backing;
#line 1588 "../src/Photo.vala"
	_tmp9_ = detected;
#line 1588 "../src/Photo.vala"
	_tmp10_ = _tmp9_->metadata;
#line 1588 "../src/Photo.vala"
	_tmp11_ = photo_reimport_editable_state_impl_new (_tmp8_, _tmp10_);
#line 1588 "../src/Photo.vala"
	_photo_reimport_editable_state_unref0 (_vala_state);
#line 1588 "../src/Photo.vala"
	_vala_state = G_TYPE_CHECK_INSTANCE_CAST (_tmp11_, PHOTO_TYPE_REIMPORT_EDITABLE_STATE, PhotoReimportEditableState);
#line 1590 "../src/Photo.vala"
	result = TRUE;
#line 1590 "../src/Photo.vala"
	_backing_photo_row_unref0 (backing);
#line 1590 "../src/Photo.vala"
	_detected_photo_information_unref0 (detected);
#line 1590 "../src/Photo.vala"
	_g_object_unref0 (file);
#line 1590 "../src/Photo.vala"
	if (state) {
#line 1590 "../src/Photo.vala"
		*state = _vala_state;
#line 13309 "Photo.c"
	} else {
#line 1590 "../src/Photo.vala"
		_photo_reimport_editable_state_unref0 (_vala_state);
#line 13313 "Photo.c"
	}
#line 1590 "../src/Photo.vala"
	return result;
#line 13317 "Photo.c"
}

static gpointer
_photo_reimport_editable_state_ref0 (gpointer self)
{
#line 1599 "../src/Photo.vala"
	return self ? photo_reimport_editable_state_ref (self) : NULL;
#line 13325 "Photo.c"
}

void
photo_finish_reimport_editable (Photo* self,
                                PhotoReimportEditableState* state,
                                GError** error)
{
	BackingPhotoID editable_id = {0};
	BackingPhotoID _tmp0_ = {0};
	PhotoReimportEditableStateImpl* reimport_state = NULL;
	PhotoReimportEditableStateImpl* _tmp1_;
	PhotoReimportEditableStateImpl* _tmp2_;
	PhotoReimportEditableStateImpl* _tmp16_;
	PhotoMetadata* _tmp17_;
	gchar* list = NULL;
	gchar* _tmp33_;
	PhotoReimportEditableStateImpl* _tmp34_;
	const gchar* _tmp37_;
	Alteration* _tmp38_;
	Alteration* _tmp39_;
	PhotoReimportEditableStateImpl* _tmp40_;
	PhotoMetadata* _tmp41_;
	GError* _inner_error0_ = NULL;
#line 1594 "../src/Photo.vala"
	g_return_if_fail (IS_PHOTO (self));
#line 1594 "../src/Photo.vala"
	g_return_if_fail (PHOTO_IS_REIMPORT_EDITABLE_STATE (state));
#line 1595 "../src/Photo.vala"
	photo_get_editable_id (self, &_tmp0_);
#line 1595 "../src/Photo.vala"
	editable_id = _tmp0_;
#line 1596 "../src/Photo.vala"
	if (backing_photo_id_is_invalid (&editable_id)) {
#line 1597 "../src/Photo.vala"
		return;
#line 13361 "Photo.c"
	}
#line 1599 "../src/Photo.vala"
	_tmp1_ = _photo_reimport_editable_state_ref0 (G_TYPE_CHECK_INSTANCE_CAST (state, PHOTO_TYPE_REIMPORT_EDITABLE_STATE_IMPL, PhotoReimportEditableStateImpl));
#line 1599 "../src/Photo.vala"
	reimport_state = _tmp1_;
#line 1601 "../src/Photo.vala"
	_tmp2_ = reimport_state;
#line 1601 "../src/Photo.vala"
	if (!_tmp2_->metadata_only) {
#line 13371 "Photo.c"
		BackingPhotoTable* _tmp3_;
		BackingPhotoTable* _tmp4_;
		PhotoReimportEditableStateImpl* _tmp5_;
		BackingPhotoRow* _tmp6_;
#line 1602 "../src/Photo.vala"
		_tmp3_ = backing_photo_table_get_instance ();
#line 1602 "../src/Photo.vala"
		_tmp4_ = _tmp3_;
#line 1602 "../src/Photo.vala"
		_tmp5_ = reimport_state;
#line 1602 "../src/Photo.vala"
		_tmp6_ = _tmp5_->backing_state;
#line 1602 "../src/Photo.vala"
		backing_photo_table_update (_tmp4_, _tmp6_, &_inner_error0_);
#line 1602 "../src/Photo.vala"
		_database_table_unref0 (_tmp4_);
#line 1602 "../src/Photo.vala"
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 1602 "../src/Photo.vala"
			if (_inner_error0_->domain == DATABASE_ERROR) {
#line 1602 "../src/Photo.vala"
				g_propagate_error (error, _inner_error0_);
#line 1602 "../src/Photo.vala"
				_photo_reimport_editable_state_unref0 (reimport_state);
#line 1602 "../src/Photo.vala"
				return;
#line 13398 "Photo.c"
			} else {
#line 1602 "../src/Photo.vala"
				_photo_reimport_editable_state_unref0 (reimport_state);
#line 1602 "../src/Photo.vala"
				g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 1602 "../src/Photo.vala"
				g_clear_error (&_inner_error0_);
#line 1602 "../src/Photo.vala"
				return;
#line 13408 "Photo.c"
			}
		}
		{
			PhotoRow* _tmp7_;
#line 1604 "../src/Photo.vala"
			_tmp7_ = self->row;
#line 1604 "../src/Photo.vala"
			g_rec_mutex_lock (&self->priv->__lock_row);
#line 13417 "Photo.c"
			{
				PhotoReimportEditableStateImpl* _tmp8_;
				BackingPhotoRow* _tmp9_;
				BackingPhotoRow* _tmp10_;
				PhotoReimportEditableStateImpl* _tmp11_;
				BackingPhotoRow* _tmp12_;
#line 1605 "../src/Photo.vala"
				_tmp8_ = reimport_state;
#line 1605 "../src/Photo.vala"
				_tmp9_ = _tmp8_->backing_state;
#line 1605 "../src/Photo.vala"
				_tmp10_ = _backing_photo_row_ref0 (_tmp9_);
#line 1605 "../src/Photo.vala"
				_backing_photo_row_unref0 (self->priv->editable);
#line 1605 "../src/Photo.vala"
				self->priv->editable = _tmp10_;
#line 1606 "../src/Photo.vala"
				_tmp11_ = reimport_state;
#line 1606 "../src/Photo.vala"
				_tmp12_ = _tmp11_->backing_state;
#line 1606 "../src/Photo.vala"
				photo_set_orientation (self, _tmp12_->original_orientation);
#line 1607 "../src/Photo.vala"
				photo_remove_all_transformations (self, FALSE);
#line 13442 "Photo.c"
			}
			__finally0:
			{
				PhotoRow* _tmp13_;
#line 1604 "../src/Photo.vala"
				_tmp13_ = self->row;
#line 1604 "../src/Photo.vala"
				g_rec_mutex_unlock (&self->priv->__lock_row);
#line 13451 "Photo.c"
			}
#line 1604 "../src/Photo.vala"
			if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 1604 "../src/Photo.vala"
				if (_inner_error0_->domain == DATABASE_ERROR) {
#line 1604 "../src/Photo.vala"
					g_propagate_error (error, _inner_error0_);
#line 1604 "../src/Photo.vala"
					_photo_reimport_editable_state_unref0 (reimport_state);
#line 1604 "../src/Photo.vala"
					return;
#line 13463 "Photo.c"
				} else {
#line 1604 "../src/Photo.vala"
					_photo_reimport_editable_state_unref0 (reimport_state);
#line 1604 "../src/Photo.vala"
					g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 1604 "../src/Photo.vala"
					g_clear_error (&_inner_error0_);
#line 1604 "../src/Photo.vala"
					return;
#line 13473 "Photo.c"
				}
			}
		}
	} else {
		PhotoReimportEditableStateImpl* _tmp14_;
		BackingPhotoRow* _tmp15_;
#line 1610 "../src/Photo.vala"
		_tmp14_ = reimport_state;
#line 1610 "../src/Photo.vala"
		_tmp15_ = _tmp14_->backing_state;
#line 1610 "../src/Photo.vala"
		photo_set_orientation (self, _tmp15_->original_orientation);
#line 13486 "Photo.c"
	}
#line 1613 "../src/Photo.vala"
	_tmp16_ = reimport_state;
#line 1613 "../src/Photo.vala"
	_tmp17_ = _tmp16_->metadata;
#line 1613 "../src/Photo.vala"
	if (_tmp17_ != NULL) {
#line 13494 "Photo.c"
		PhotoReimportEditableStateImpl* _tmp18_;
		PhotoMetadata* _tmp19_;
		gchar* _tmp20_;
		gchar* _tmp21_;
		PhotoReimportEditableStateImpl* _tmp22_;
		PhotoMetadata* _tmp23_;
		GpsCoords _tmp24_ = {0};
		PhotoReimportEditableStateImpl* _tmp25_;
		PhotoMetadata* _tmp26_;
		gchar* _tmp27_;
		gchar* _tmp28_;
		PhotoReimportEditableStateImpl* _tmp29_;
		PhotoMetadata* _tmp30_;
		PhotoReimportEditableStateImpl* _tmp31_;
		PhotoMetadata* _tmp32_;
#line 1614 "../src/Photo.vala"
		_tmp18_ = reimport_state;
#line 1614 "../src/Photo.vala"
		_tmp19_ = _tmp18_->metadata;
#line 1614 "../src/Photo.vala"
		_tmp20_ = media_metadata_get_title (G_TYPE_CHECK_INSTANCE_CAST (_tmp19_, TYPE_MEDIA_METADATA, MediaMetadata));
#line 1614 "../src/Photo.vala"
		_tmp21_ = _tmp20_;
#line 1614 "../src/Photo.vala"
		media_source_set_title (G_TYPE_CHECK_INSTANCE_CAST (self, TYPE_MEDIA_SOURCE, MediaSource), _tmp21_);
#line 1614 "../src/Photo.vala"
		_g_free0 (_tmp21_);
#line 1615 "../src/Photo.vala"
		_tmp22_ = reimport_state;
#line 1615 "../src/Photo.vala"
		_tmp23_ = _tmp22_->metadata;
#line 1615 "../src/Photo.vala"
		photo_metadata_get_gps_coords (_tmp23_, &_tmp24_);
#line 1615 "../src/Photo.vala"
		positionable_set_gps_coords (G_TYPE_CHECK_INSTANCE_CAST (self, TYPE_POSITIONABLE, Positionable), &_tmp24_);
#line 1616 "../src/Photo.vala"
		_tmp25_ = reimport_state;
#line 1616 "../src/Photo.vala"
		_tmp26_ = _tmp25_->metadata;
#line 1616 "../src/Photo.vala"
		_tmp27_ = media_metadata_get_comment (G_TYPE_CHECK_INSTANCE_CAST (_tmp26_, TYPE_MEDIA_METADATA, MediaMetadata));
#line 1616 "../src/Photo.vala"
		_tmp28_ = _tmp27_;
#line 1616 "../src/Photo.vala"
		media_source_set_comment (G_TYPE_CHECK_INSTANCE_CAST (self, TYPE_MEDIA_SOURCE, MediaSource), _tmp28_);
#line 1616 "../src/Photo.vala"
		_g_free0 (_tmp28_);
#line 1617 "../src/Photo.vala"
		_tmp29_ = reimport_state;
#line 1617 "../src/Photo.vala"
		_tmp30_ = _tmp29_->metadata;
#line 1617 "../src/Photo.vala"
		media_source_set_rating (G_TYPE_CHECK_INSTANCE_CAST (self, TYPE_MEDIA_SOURCE, MediaSource), photo_metadata_get_rating (_tmp30_));
#line 1618 "../src/Photo.vala"
		_tmp31_ = reimport_state;
#line 1618 "../src/Photo.vala"
		_tmp32_ = _tmp31_->metadata;
#line 1618 "../src/Photo.vala"
		photo_apply_user_metadata_for_reimport (self, _tmp32_);
#line 13554 "Photo.c"
	}
#line 1621 "../src/Photo.vala"
	_tmp33_ = g_strdup ("metadata:name,image:orientation,metadata:rating,metadata:exposure-time");
#line 1621 "../src/Photo.vala"
	list = _tmp33_;
#line 1622 "../src/Photo.vala"
	_tmp34_ = reimport_state;
#line 1622 "../src/Photo.vala"
	if (!_tmp34_->metadata_only) {
#line 13564 "Photo.c"
		const gchar* _tmp35_;
		gchar* _tmp36_;
#line 1623 "../src/Photo.vala"
		_tmp35_ = list;
#line 1623 "../src/Photo.vala"
		_tmp36_ = g_strconcat (_tmp35_, "image:editable,image:baseline", NULL);
#line 1623 "../src/Photo.vala"
		_g_free0 (list);
#line 1623 "../src/Photo.vala"
		list = _tmp36_;
#line 13575 "Photo.c"
	}
#line 1625 "../src/Photo.vala"
	_tmp37_ = list;
#line 1625 "../src/Photo.vala"
	_tmp38_ = alteration_new_from_list (_tmp37_);
#line 1625 "../src/Photo.vala"
	_tmp39_ = _tmp38_;
#line 1625 "../src/Photo.vala"
	data_object_notify_altered (G_TYPE_CHECK_INSTANCE_CAST (self, TYPE_DATA_OBJECT, DataObject), _tmp39_);
#line 1625 "../src/Photo.vala"
	_alteration_unref0 (_tmp39_);
#line 1627 "../src/Photo.vala"
	_tmp40_ = reimport_state;
#line 1627 "../src/Photo.vala"
	_tmp41_ = _tmp40_->metadata;
#line 1627 "../src/Photo.vala"
	photo_notify_editable_reimported (self, _tmp41_);
#line 1629 "../src/Photo.vala"
	if (photo_is_editable_baseline (self)) {
#line 13595 "Photo.c"
		PhotoReimportEditableStateImpl* _tmp42_;
		PhotoMetadata* _tmp43_;
#line 1630 "../src/Photo.vala"
		_tmp42_ = reimport_state;
#line 1630 "../src/Photo.vala"
		_tmp43_ = _tmp42_->metadata;
#line 1630 "../src/Photo.vala"
		photo_notify_baseline_reimported (self, _tmp43_);
#line 13604 "Photo.c"
	}
#line 1632 "../src/Photo.vala"
	if (photo_is_editable_source (self)) {
#line 13608 "Photo.c"
		PhotoReimportEditableStateImpl* _tmp44_;
		PhotoMetadata* _tmp45_;
#line 1633 "../src/Photo.vala"
		_tmp44_ = reimport_state;
#line 1633 "../src/Photo.vala"
		_tmp45_ = _tmp44_->metadata;
#line 1633 "../src/Photo.vala"
		photo_notify_source_reimported (self, _tmp45_);
#line 13617 "Photo.c"
	}
#line 1594 "../src/Photo.vala"
	_g_free0 (list);
#line 1594 "../src/Photo.vala"
	_photo_reimport_editable_state_unref0 (reimport_state);
#line 13623 "Photo.c"
}

static gpointer
_photo_reimport_raw_development_state_ref0 (gpointer self)
{
#line 1655 "../src/Photo.vala"
	return self ? photo_reimport_raw_development_state_ref (self) : NULL;
#line 13631 "Photo.c"
}

gboolean
photo_prepare_for_reimport_raw_development (Photo* self,
                                            PhotoReimportRawDevelopmentState** state,
                                            GError** error)
{
	PhotoReimportRawDevelopmentState* _vala_state = NULL;
	GeeCollection* files = NULL;
	GeeCollection* _tmp0_;
	GeeCollection* _tmp1_;
	PhotoReimportRawDevelopmentStateImpl* reimport_state = NULL;
	PhotoReimportRawDevelopmentStateImpl* _tmp2_;
	PhotoReimportRawDevelopmentStateImpl* _tmp18_;
	PhotoReimportRawDevelopmentState* _tmp19_;
	PhotoReimportRawDevelopmentStateImpl* _tmp20_;
	GError* _inner_error0_ = NULL;
	gboolean result;
#line 1637 "../src/Photo.vala"
	g_return_val_if_fail (IS_PHOTO (self), FALSE);
#line 1638 "../src/Photo.vala"
	_photo_reimport_raw_development_state_unref0 (_vala_state);
#line 1638 "../src/Photo.vala"
	_vala_state = NULL;
#line 1640 "../src/Photo.vala"
	_tmp0_ = photo_get_raw_developer_files (self);
#line 1640 "../src/Photo.vala"
	files = _tmp0_;
#line 1641 "../src/Photo.vala"
	_tmp1_ = files;
#line 1641 "../src/Photo.vala"
	if (_tmp1_ == NULL) {
#line 1642 "../src/Photo.vala"
		result = FALSE;
#line 1642 "../src/Photo.vala"
		_g_object_unref0 (files);
#line 1642 "../src/Photo.vala"
		if (state) {
#line 1642 "../src/Photo.vala"
			*state = _vala_state;
#line 13672 "Photo.c"
		} else {
#line 1642 "../src/Photo.vala"
			_photo_reimport_raw_development_state_unref0 (_vala_state);
#line 13676 "Photo.c"
		}
#line 1642 "../src/Photo.vala"
		return result;
#line 13680 "Photo.c"
	}
#line 1644 "../src/Photo.vala"
	_tmp2_ = photo_reimport_raw_development_state_impl_new ();
#line 1644 "../src/Photo.vala"
	reimport_state = _tmp2_;
#line 13686 "Photo.c"
	{
		GeeIterator* _file_it = NULL;
		GeeCollection* _tmp3_;
		GeeIterator* _tmp4_;
#line 1646 "../src/Photo.vala"
		_tmp3_ = files;
#line 1646 "../src/Photo.vala"
		_tmp4_ = gee_iterable_iterator (G_TYPE_CHECK_INSTANCE_CAST (_tmp3_, GEE_TYPE_ITERABLE, GeeIterable));
#line 1646 "../src/Photo.vala"
		_file_it = _tmp4_;
#line 1646 "../src/Photo.vala"
		while (TRUE) {
#line 13699 "Photo.c"
			GeeIterator* _tmp5_;
			GFile* file = NULL;
			GeeIterator* _tmp6_;
			gpointer _tmp7_;
			DetectedPhotoInformation* detected = NULL;
			BackingPhotoRow* backing = NULL;
			gboolean _tmp8_ = FALSE;
			GFile* _tmp9_;
			BackingPhotoRow* _tmp10_ = NULL;
			DetectedPhotoInformation* _tmp11_ = NULL;
			gboolean _tmp12_;
			PhotoReimportRawDevelopmentStateImpl* _tmp14_;
			BackingPhotoRow* _tmp15_;
			DetectedPhotoInformation* _tmp16_;
			PhotoMetadata* _tmp17_;
#line 1646 "../src/Photo.vala"
			_tmp5_ = _file_it;
#line 1646 "../src/Photo.vala"
			if (!gee_iterator_next (_tmp5_)) {
#line 1646 "../src/Photo.vala"
				break;
#line 13721 "Photo.c"
			}
#line 1646 "../src/Photo.vala"
			_tmp6_ = _file_it;
#line 1646 "../src/Photo.vala"
			_tmp7_ = gee_iterator_get (_tmp6_);
#line 1646 "../src/Photo.vala"
			file = (GFile*) _tmp7_;
#line 1649 "../src/Photo.vala"
			_tmp9_ = file;
#line 1649 "../src/Photo.vala"
			_tmp12_ = photo_verify_file_for_reimport (self, _tmp9_, &_tmp10_, &_tmp11_, &_inner_error0_);
#line 1649 "../src/Photo.vala"
			_backing_photo_row_unref0 (backing);
#line 1649 "../src/Photo.vala"
			backing = _tmp10_;
#line 1649 "../src/Photo.vala"
			_detected_photo_information_unref0 (detected);
#line 1649 "../src/Photo.vala"
			detected = _tmp11_;
#line 1649 "../src/Photo.vala"
			_tmp8_ = _tmp12_;
#line 1649 "../src/Photo.vala"
			if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 13745 "Photo.c"
				gboolean _tmp13_ = FALSE;
#line 1649 "../src/Photo.vala"
				g_propagate_error (error, _inner_error0_);
#line 1649 "../src/Photo.vala"
				_backing_photo_row_unref0 (backing);
#line 1649 "../src/Photo.vala"
				_detected_photo_information_unref0 (detected);
#line 1649 "../src/Photo.vala"
				_g_object_unref0 (file);
#line 1649 "../src/Photo.vala"
				_g_object_unref0 (_file_it);
#line 1649 "../src/Photo.vala"
				_photo_reimport_raw_development_state_unref0 (reimport_state);
#line 1649 "../src/Photo.vala"
				_g_object_unref0 (files);
#line 1649 "../src/Photo.vala"
				_photo_reimport_raw_development_state_unref0 (_vala_state);
#line 1649 "../src/Photo.vala"
				return _tmp13_;
#line 13765 "Photo.c"
			}
#line 1649 "../src/Photo.vala"
			if (!_tmp8_) {
#line 1650 "../src/Photo.vala"
				_backing_photo_row_unref0 (backing);
#line 1650 "../src/Photo.vala"
				_detected_photo_information_unref0 (detected);
#line 1650 "../src/Photo.vala"
				_g_object_unref0 (file);
#line 1650 "../src/Photo.vala"
				continue;
#line 13777 "Photo.c"
			}
#line 1652 "../src/Photo.vala"
			_tmp14_ = reimport_state;
#line 1652 "../src/Photo.vala"
			_tmp15_ = backing;
#line 1652 "../src/Photo.vala"
			_tmp16_ = detected;
#line 1652 "../src/Photo.vala"
			_tmp17_ = _tmp16_->metadata;
#line 1652 "../src/Photo.vala"
			photo_reimport_raw_development_state_impl_add (_tmp14_, _tmp15_, _tmp17_);
#line 1646 "../src/Photo.vala"
			_backing_photo_row_unref0 (backing);
#line 1646 "../src/Photo.vala"
			_detected_photo_information_unref0 (detected);
#line 1646 "../src/Photo.vala"
			_g_object_unref0 (file);
#line 13795 "Photo.c"
		}
#line 1646 "../src/Photo.vala"
		_g_object_unref0 (_file_it);
#line 13799 "Photo.c"
	}
#line 1655 "../src/Photo.vala"
	_tmp18_ = reimport_state;
#line 1655 "../src/Photo.vala"
	_tmp19_ = _photo_reimport_raw_development_state_ref0 (G_TYPE_CHECK_INSTANCE_CAST (_tmp18_, PHOTO_TYPE_REIMPORT_RAW_DEVELOPMENT_STATE, PhotoReimportRawDevelopmentState));
#line 1655 "../src/Photo.vala"
	_photo_reimport_raw_development_state_unref0 (_vala_state);
#line 1655 "../src/Photo.vala"
	_vala_state = _tmp19_;
#line 1656 "../src/Photo.vala"
	_tmp20_ = reimport_state;
#line 1656 "../src/Photo.vala"
	result = photo_reimport_raw_development_state_impl_get_size (_tmp20_) > 0;
#line 1656 "../src/Photo.vala"
	_photo_reimport_raw_development_state_unref0 (reimport_state);
#line 1656 "../src/Photo.vala"
	_g_object_unref0 (files);
#line 1656 "../src/Photo.vala"
	if (state) {
#line 1656 "../src/Photo.vala"
		*state = _vala_state;
#line 13821 "Photo.c"
	} else {
#line 1656 "../src/Photo.vala"
		_photo_reimport_raw_development_state_unref0 (_vala_state);
#line 13825 "Photo.c"
	}
#line 1656 "../src/Photo.vala"
	return result;
#line 13829 "Photo.c"
}

void
photo_finish_reimport_raw_development (Photo* self,
                                       PhotoReimportRawDevelopmentState* state,
                                       GError** error)
{
	PhotoReimportRawDevelopmentStateImpl* reimport_state = NULL;
	PhotoReimportRawDevelopmentStateImpl* _tmp0_;
	gchar* list = NULL;
	gchar* _tmp25_;
	PhotoReimportRawDevelopmentStateImpl* _tmp26_;
	const gchar* _tmp29_;
	Alteration* _tmp30_;
	Alteration* _tmp31_;
	GError* _inner_error0_ = NULL;
#line 1660 "../src/Photo.vala"
	g_return_if_fail (IS_PHOTO (self));
#line 1660 "../src/Photo.vala"
	g_return_if_fail (PHOTO_IS_REIMPORT_RAW_DEVELOPMENT_STATE (state));
#line 1661 "../src/Photo.vala"
	if (photo_get_master_file_format (self) != PHOTO_FILE_FORMAT_RAW) {
#line 1662 "../src/Photo.vala"
		return;
#line 13854 "Photo.c"
	}
#line 1664 "../src/Photo.vala"
	_tmp0_ = _photo_reimport_raw_development_state_ref0 (G_TYPE_CHECK_INSTANCE_CAST (state, PHOTO_TYPE_REIMPORT_RAW_DEVELOPMENT_STATE_IMPL, PhotoReimportRawDevelopmentStateImpl));
#line 1664 "../src/Photo.vala"
	reimport_state = _tmp0_;
#line 13860 "Photo.c"
	{
		GeeIterator* _dev_it = NULL;
		PhotoReimportRawDevelopmentStateImpl* _tmp1_;
		GeeCollection* _tmp2_;
		GeeIterator* _tmp3_;
#line 1666 "../src/Photo.vala"
		_tmp1_ = reimport_state;
#line 1666 "../src/Photo.vala"
		_tmp2_ = _tmp1_->list;
#line 1666 "../src/Photo.vala"
		_tmp3_ = gee_iterable_iterator (G_TYPE_CHECK_INSTANCE_CAST (_tmp2_, GEE_TYPE_ITERABLE, GeeIterable));
#line 1666 "../src/Photo.vala"
		_dev_it = _tmp3_;
#line 1666 "../src/Photo.vala"
		while (TRUE) {
#line 13876 "Photo.c"
			GeeIterator* _tmp4_;
			PhotoReimportRawDevelopmentStateImplDevToReimport* dev = NULL;
			GeeIterator* _tmp5_;
			gpointer _tmp6_;
			PhotoReimportRawDevelopmentStateImpl* _tmp7_;
#line 1666 "../src/Photo.vala"
			_tmp4_ = _dev_it;
#line 1666 "../src/Photo.vala"
			if (!gee_iterator_next (_tmp4_)) {
#line 1666 "../src/Photo.vala"
				break;
#line 13888 "Photo.c"
			}
#line 1666 "../src/Photo.vala"
			_tmp5_ = _dev_it;
#line 1666 "../src/Photo.vala"
			_tmp6_ = gee_iterator_get (_tmp5_);
#line 1666 "../src/Photo.vala"
			dev = (PhotoReimportRawDevelopmentStateImplDevToReimport*) _tmp6_;
#line 1667 "../src/Photo.vala"
			_tmp7_ = reimport_state;
#line 1667 "../src/Photo.vala"
			if (!_tmp7_->metadata_only) {
#line 13900 "Photo.c"
				BackingPhotoTable* _tmp8_;
				BackingPhotoTable* _tmp9_;
				PhotoReimportRawDevelopmentStateImplDevToReimport* _tmp10_;
				BackingPhotoRow* _tmp11_;
#line 1668 "../src/Photo.vala"
				_tmp8_ = backing_photo_table_get_instance ();
#line 1668 "../src/Photo.vala"
				_tmp9_ = _tmp8_;
#line 1668 "../src/Photo.vala"
				_tmp10_ = dev;
#line 1668 "../src/Photo.vala"
				_tmp11_ = _tmp10_->backing;
#line 1668 "../src/Photo.vala"
				backing_photo_table_update (_tmp9_, _tmp11_, &_inner_error0_);
#line 1668 "../src/Photo.vala"
				_database_table_unref0 (_tmp9_);
#line 1668 "../src/Photo.vala"
				if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 1668 "../src/Photo.vala"
					if (_inner_error0_->domain == DATABASE_ERROR) {
#line 1668 "../src/Photo.vala"
						g_propagate_error (error, _inner_error0_);
#line 1668 "../src/Photo.vala"
						_photo_reimport_raw_development_state_impl_dev_to_reimport_unref0 (dev);
#line 1668 "../src/Photo.vala"
						_g_object_unref0 (_dev_it);
#line 1668 "../src/Photo.vala"
						_photo_reimport_raw_development_state_unref0 (reimport_state);
#line 1668 "../src/Photo.vala"
						return;
#line 13931 "Photo.c"
					} else {
#line 1668 "../src/Photo.vala"
						_photo_reimport_raw_development_state_impl_dev_to_reimport_unref0 (dev);
#line 1668 "../src/Photo.vala"
						_g_object_unref0 (_dev_it);
#line 1668 "../src/Photo.vala"
						_photo_reimport_raw_development_state_unref0 (reimport_state);
#line 1668 "../src/Photo.vala"
						g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 1668 "../src/Photo.vala"
						g_clear_error (&_inner_error0_);
#line 1668 "../src/Photo.vala"
						return;
#line 13945 "Photo.c"
					}
				}
				{
					PhotoRow* _tmp12_;
#line 1670 "../src/Photo.vala"
					_tmp12_ = self->row;
#line 1670 "../src/Photo.vala"
					g_rec_mutex_lock (&self->priv->__lock_row);
#line 13954 "Photo.c"
					{
						gint _tmp13_ = 0;
						RawDeveloper* _tmp14_;
#line 1672 "../src/Photo.vala"
						_tmp14_ = raw_developer_as_array (&_tmp13_);
#line 13960 "Photo.c"
						{
							RawDeveloper* d_collection = NULL;
							gint d_collection_length1 = 0;
							gint _d_collection_size_ = 0;
							gint d_it = 0;
#line 1672 "../src/Photo.vala"
							d_collection = _tmp14_;
#line 1672 "../src/Photo.vala"
							d_collection_length1 = _tmp13_;
#line 1672 "../src/Photo.vala"
							for (d_it = 0; d_it < d_collection_length1; d_it = d_it + 1) {
#line 13972 "Photo.c"
								RawDeveloper d = 0;
#line 1672 "../src/Photo.vala"
								d = d_collection[d_it];
#line 13976 "Photo.c"
								{
									BackingPhotoID id = {0};
									PhotoRow* _tmp15_;
									BackingPhotoID* _tmp16_;
									gint _tmp16__length1;
									BackingPhotoID _tmp17_;
									BackingPhotoID _tmp18_;
#line 1673 "../src/Photo.vala"
									_tmp15_ = self->row;
#line 1673 "../src/Photo.vala"
									_tmp16_ = _tmp15_->development_ids;
#line 1673 "../src/Photo.vala"
									_tmp16__length1 = _tmp15_->development_ids_length1;
#line 1673 "../src/Photo.vala"
									_tmp17_ = _tmp16_[d];
#line 1673 "../src/Photo.vala"
									id = _tmp17_;
#line 1674 "../src/Photo.vala"
									_tmp18_ = id;
#line 1674 "../src/Photo.vala"
									if (_tmp18_.id != BACKING_PHOTO_ID_INVALID) {
#line 13998 "Photo.c"
										BackingPhotoRow* bpr = NULL;
										BackingPhotoID _tmp19_;
										BackingPhotoRow* _tmp20_;
										BackingPhotoRow* _tmp21_;
#line 1675 "../src/Photo.vala"
										_tmp19_ = id;
#line 1675 "../src/Photo.vala"
										_tmp20_ = photo_get_backing_row (self, &_tmp19_);
#line 1675 "../src/Photo.vala"
										bpr = _tmp20_;
#line 1676 "../src/Photo.vala"
										_tmp21_ = bpr;
#line 1676 "../src/Photo.vala"
										if (_tmp21_ != NULL) {
#line 14013 "Photo.c"
											GeeHashMap* _tmp22_;
											BackingPhotoRow* _tmp23_;
#line 1677 "../src/Photo.vala"
											_tmp22_ = self->priv->developments;
#line 1677 "../src/Photo.vala"
											_tmp23_ = bpr;
#line 1677 "../src/Photo.vala"
											gee_abstract_map_set (G_TYPE_CHECK_INSTANCE_CAST (_tmp22_, GEE_TYPE_ABSTRACT_MAP, GeeAbstractMap), (gpointer) ((gintptr) d), _tmp23_);
#line 14022 "Photo.c"
										}
#line 1674 "../src/Photo.vala"
										_backing_photo_row_unref0 (bpr);
#line 14026 "Photo.c"
									}
								}
							}
#line 1672 "../src/Photo.vala"
							d_collection = (g_free (d_collection), NULL);
#line 14032 "Photo.c"
						}
					}
					__finally0:
					{
						PhotoRow* _tmp24_;
#line 1670 "../src/Photo.vala"
						_tmp24_ = self->row;
#line 1670 "../src/Photo.vala"
						g_rec_mutex_unlock (&self->priv->__lock_row);
#line 14042 "Photo.c"
					}
#line 1670 "../src/Photo.vala"
					if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 1670 "../src/Photo.vala"
						if (_inner_error0_->domain == DATABASE_ERROR) {
#line 1670 "../src/Photo.vala"
							g_propagate_error (error, _inner_error0_);
#line 1670 "../src/Photo.vala"
							_photo_reimport_raw_development_state_impl_dev_to_reimport_unref0 (dev);
#line 1670 "../src/Photo.vala"
							_g_object_unref0 (_dev_it);
#line 1670 "../src/Photo.vala"
							_photo_reimport_raw_development_state_unref0 (reimport_state);
#line 1670 "../src/Photo.vala"
							return;
#line 14058 "Photo.c"
						} else {
#line 1670 "../src/Photo.vala"
							_photo_reimport_raw_development_state_impl_dev_to_reimport_unref0 (dev);
#line 1670 "../src/Photo.vala"
							_g_object_unref0 (_dev_it);
#line 1670 "../src/Photo.vala"
							_photo_reimport_raw_development_state_unref0 (reimport_state);
#line 1670 "../src/Photo.vala"
							g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 1670 "../src/Photo.vala"
							g_clear_error (&_inner_error0_);
#line 1670 "../src/Photo.vala"
							return;
#line 14072 "Photo.c"
						}
					}
				}
			}
#line 1666 "../src/Photo.vala"
			_photo_reimport_raw_development_state_impl_dev_to_reimport_unref0 (dev);
#line 14079 "Photo.c"
		}
#line 1666 "../src/Photo.vala"
		_g_object_unref0 (_dev_it);
#line 14083 "Photo.c"
	}
#line 1684 "../src/Photo.vala"
	_tmp25_ = g_strdup ("metadata:name,image:orientation,metadata:rating,metadata:exposure-time");
#line 1684 "../src/Photo.vala"
	list = _tmp25_;
#line 1685 "../src/Photo.vala"
	_tmp26_ = reimport_state;
#line 1685 "../src/Photo.vala"
	if (!_tmp26_->metadata_only) {
#line 14093 "Photo.c"
		const gchar* _tmp27_;
		gchar* _tmp28_;
#line 1686 "../src/Photo.vala"
		_tmp27_ = list;
#line 1686 "../src/Photo.vala"
		_tmp28_ = g_strconcat (_tmp27_, "image:editable,image:baseline", NULL);
#line 1686 "../src/Photo.vala"
		_g_free0 (list);
#line 1686 "../src/Photo.vala"
		list = _tmp28_;
#line 14104 "Photo.c"
	}
#line 1688 "../src/Photo.vala"
	_tmp29_ = list;
#line 1688 "../src/Photo.vala"
	_tmp30_ = alteration_new_from_list (_tmp29_);
#line 1688 "../src/Photo.vala"
	_tmp31_ = _tmp30_;
#line 1688 "../src/Photo.vala"
	data_object_notify_altered (G_TYPE_CHECK_INSTANCE_CAST (self, TYPE_DATA_OBJECT, DataObject), _tmp31_);
#line 1688 "../src/Photo.vala"
	_alteration_unref0 (_tmp31_);
#line 1690 "../src/Photo.vala"
	photo_notify_raw_development_modified (self);
#line 1660 "../src/Photo.vala"
	_g_free0 (list);
#line 1660 "../src/Photo.vala"
	_photo_reimport_raw_development_state_unref0 (reimport_state);
#line 14122 "Photo.c"
}

static gchar*
photo_real_get_typename (DataSource* base)
{
	Photo * self;
	gchar* _tmp0_;
	gchar* result;
#line 1693 "../src/Photo.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (base, TYPE_PHOTO, Photo);
#line 1694 "../src/Photo.vala"
	_tmp0_ = g_strdup (PHOTO_TYPENAME);
#line 1694 "../src/Photo.vala"
	result = _tmp0_;
#line 1694 "../src/Photo.vala"
	return result;
#line 14139 "Photo.c"
}

static gint64
photo_real_get_instance_id (DataSource* base)
{
	Photo * self;
	PhotoID _tmp0_ = {0};
	gint64 result;
#line 1697 "../src/Photo.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (base, TYPE_PHOTO, Photo);
#line 1698 "../src/Photo.vala"
	photo_get_photo_id (self, &_tmp0_);
#line 1698 "../src/Photo.vala"
	result = _tmp0_.id;
#line 1698 "../src/Photo.vala"
	return result;
#line 14156 "Photo.c"
}

static gchar*
photo_real_get_source_id (DataSource* base)
{
	Photo * self;
	gchar* _tmp0_;
	gchar* _tmp1_;
	gchar* _tmp2_;
	gchar* _tmp3_;
	gchar* result;
#line 1701 "../src/Photo.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (base, TYPE_PHOTO, Photo);
#line 1705 "../src/Photo.vala"
	_tmp0_ = data_source_get_typename (G_TYPE_CHECK_INSTANCE_CAST (self, TYPE_DATA_SOURCE, DataSource));
#line 1705 "../src/Photo.vala"
	_tmp1_ = _tmp0_;
#line 1705 "../src/Photo.vala"
	_tmp2_ = g_strdup_printf ("%s%016" G_GINT64_MODIFIER "x", _tmp1_, data_source_get_instance_id (G_TYPE_CHECK_INSTANCE_CAST (self, TYPE_DATA_SOURCE, DataSource)));
#line 1705 "../src/Photo.vala"
	_tmp3_ = _tmp2_;
#line 1705 "../src/Photo.vala"
	_g_free0 (_tmp1_);
#line 1705 "../src/Photo.vala"
	result = _tmp3_;
#line 1705 "../src/Photo.vala"
	return result;
#line 14184 "Photo.c"
}

void
photo_set_master_timestamp (Photo* self,
                            GFileInfo* info)
{
	GDateTime* modification = NULL;
	GDateTime* _tmp0_;
	GDateTime* _tmp1_;
	GDateTime* _tmp2_;
	GDateTime* _tmp3_;
	GError* _inner_error0_ = NULL;
#line 1709 "../src/Photo.vala"
	g_return_if_fail (IS_PHOTO (self));
#line 1709 "../src/Photo.vala"
	g_return_if_fail (G_TYPE_CHECK_INSTANCE_TYPE (info, g_file_info_get_type ()));
#line 1710 "../src/Photo.vala"
	_tmp0_ = g_file_info_get_modification_date_time (info);
#line 1710 "../src/Photo.vala"
	_tmp1_ = _tmp0_;
#line 1710 "../src/Photo.vala"
	_tmp2_ = coarsify_date_time (_tmp1_);
#line 1710 "../src/Photo.vala"
	_tmp3_ = _tmp2_;
#line 1710 "../src/Photo.vala"
	_g_date_time_unref0 (_tmp1_);
#line 1710 "../src/Photo.vala"
	modification = _tmp3_;
#line 14213 "Photo.c"
	{
		{
			PhotoRow* _tmp4_;
#line 1713 "../src/Photo.vala"
			_tmp4_ = self->row;
#line 1713 "../src/Photo.vala"
			g_rec_mutex_lock (&self->priv->__lock_row);
#line 14221 "Photo.c"
			{
				PhotoRow* _tmp5_;
				BackingPhotoRow* _tmp6_;
				GDateTime* _tmp7_;
				GDateTime* _tmp8_;
				PhotoTable* _tmp10_;
				PhotoTable* _tmp11_;
				PhotoRow* _tmp12_;
				PhotoID _tmp13_;
				GDateTime* _tmp14_;
				PhotoRow* _tmp15_;
				BackingPhotoRow* _tmp16_;
				GDateTime* _tmp17_;
				GDateTime* _tmp18_;
#line 1714 "../src/Photo.vala"
				_tmp5_ = self->row;
#line 1714 "../src/Photo.vala"
				_tmp6_ = _tmp5_->master;
#line 1714 "../src/Photo.vala"
				_tmp7_ = _tmp6_->timestamp;
#line 1714 "../src/Photo.vala"
				_tmp8_ = modification;
#line 1714 "../src/Photo.vala"
				if (g_date_time_equal (_tmp7_, _tmp8_)) {
#line 14246 "Photo.c"
					{
						GError* _inner_error0_ = NULL;
						PhotoRow* _tmp9_;
#line 1713 "../src/Photo.vala"
						_tmp9_ = self->row;
#line 1713 "../src/Photo.vala"
						g_rec_mutex_unlock (&self->priv->__lock_row);
#line 14254 "Photo.c"
					}
#line 1715 "../src/Photo.vala"
					_g_date_time_unref0 (modification);
#line 1715 "../src/Photo.vala"
					return;
#line 14260 "Photo.c"
				}
#line 1717 "../src/Photo.vala"
				_tmp10_ = photo_table_get_instance ();
#line 1717 "../src/Photo.vala"
				_tmp11_ = _tmp10_;
#line 1717 "../src/Photo.vala"
				_tmp12_ = self->row;
#line 1717 "../src/Photo.vala"
				_tmp13_ = _tmp12_->photo_id;
#line 1717 "../src/Photo.vala"
				_tmp14_ = modification;
#line 1717 "../src/Photo.vala"
				photo_table_update_timestamp (_tmp11_, &_tmp13_, _tmp14_, &_inner_error0_);
#line 1717 "../src/Photo.vala"
				_database_table_unref0 (_tmp11_);
#line 1717 "../src/Photo.vala"
				if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 14278 "Photo.c"
					goto __catch1_g_error;
				}
#line 1718 "../src/Photo.vala"
				_tmp15_ = self->row;
#line 1718 "../src/Photo.vala"
				_tmp16_ = _tmp15_->master;
#line 1718 "../src/Photo.vala"
				_tmp17_ = modification;
#line 1718 "../src/Photo.vala"
				_tmp18_ = _g_date_time_ref0 (_tmp17_);
#line 1718 "../src/Photo.vala"
				_g_date_time_unref0 (_tmp16_->timestamp);
#line 1718 "../src/Photo.vala"
				_tmp16_->timestamp = _tmp18_;
#line 14293 "Photo.c"
			}
			goto __finally1;
			__catch1_g_error:
			{
				GError* _lock_error_ = NULL;
				GError* _tmp19_;
#line 1713 "../src/Photo.vala"
				_lock_error_ = _inner_error0_;
#line 1713 "../src/Photo.vala"
				_inner_error0_ = NULL;
#line 1713 "../src/Photo.vala"
				_tmp19_ = _lock_error_;
#line 1713 "../src/Photo.vala"
				_lock_error_ = NULL;
#line 1713 "../src/Photo.vala"
				_inner_error0_ = _tmp19_;
#line 1713 "../src/Photo.vala"
				_g_error_free0 (_lock_error_);
#line 14312 "Photo.c"
				goto __finally1;
			}
			__finally1:
			{
				GError* _inner_error1_ = NULL;
				PhotoRow* _tmp20_;
#line 1713 "../src/Photo.vala"
				_tmp20_ = self->row;
#line 1713 "../src/Photo.vala"
				g_rec_mutex_unlock (&self->priv->__lock_row);
#line 14323 "Photo.c"
			}
#line 1713 "../src/Photo.vala"
			if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 14327 "Photo.c"
				goto __catch0_g_error;
			}
		}
	}
	goto __finally0;
	__catch0_g_error:
	{
		GError* err = NULL;
		GError* _tmp21_;
#line 1712 "../src/Photo.vala"
		err = _inner_error0_;
#line 1712 "../src/Photo.vala"
		_inner_error0_ = NULL;
#line 1721 "../src/Photo.vala"
		_tmp21_ = err;
#line 1721 "../src/Photo.vala"
		app_window_database_error (_tmp21_);
#line 1723 "../src/Photo.vala"
		_g_error_free0 (err);
#line 1723 "../src/Photo.vala"
		_g_date_time_unref0 (modification);
#line 1723 "../src/Photo.vala"
		return;
#line 14351 "Photo.c"
	}
	__finally0:
#line 1712 "../src/Photo.vala"
	if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 1712 "../src/Photo.vala"
		_g_date_time_unref0 (modification);
#line 1712 "../src/Photo.vala"
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 1712 "../src/Photo.vala"
		g_clear_error (&_inner_error0_);
#line 1712 "../src/Photo.vala"
		return;
#line 14364 "Photo.c"
	}
#line 1726 "../src/Photo.vala"
	if (photo_is_master_baseline (self)) {
#line 14368 "Photo.c"
		Alteration* _tmp22_;
		Alteration* _tmp23_;
#line 1727 "../src/Photo.vala"
		_tmp22_ = alteration_new_from_list ("metadata:master-timestamp,metadata:baseline-timestamp");
#line 1727 "../src/Photo.vala"
		_tmp23_ = _tmp22_;
#line 1727 "../src/Photo.vala"
		data_object_notify_altered (G_TYPE_CHECK_INSTANCE_CAST (self, TYPE_DATA_OBJECT, DataObject), _tmp23_);
#line 1727 "../src/Photo.vala"
		_alteration_unref0 (_tmp23_);
#line 14379 "Photo.c"
	} else {
		Alteration* _tmp24_;
		Alteration* _tmp25_;
#line 1729 "../src/Photo.vala"
		_tmp24_ = alteration_new ("metadata", "master-timestamp");
#line 1729 "../src/Photo.vala"
		_tmp25_ = _tmp24_;
#line 1729 "../src/Photo.vala"
		data_object_notify_altered (G_TYPE_CHECK_INSTANCE_CAST (self, TYPE_DATA_OBJECT, DataObject), _tmp25_);
#line 1729 "../src/Photo.vala"
		_alteration_unref0 (_tmp25_);
#line 14391 "Photo.c"
	}
#line 1709 "../src/Photo.vala"
	_g_date_time_unref0 (modification);
#line 14395 "Photo.c"
}

void
photo_update_editable_modification_time (Photo* self,
                                         GFileInfo* info,
                                         GError** error)
{
	GDateTime* modification = NULL;
	GDateTime* _tmp0_;
	GDateTime* _tmp1_;
	GDateTime* _tmp2_;
	GDateTime* _tmp3_;
	gboolean altered = FALSE;
	GError* _inner_error0_ = NULL;
#line 1733 "../src/Photo.vala"
	g_return_if_fail (IS_PHOTO (self));
#line 1733 "../src/Photo.vala"
	g_return_if_fail (G_TYPE_CHECK_INSTANCE_TYPE (info, g_file_info_get_type ()));
#line 1734 "../src/Photo.vala"
	_tmp0_ = g_file_info_get_modification_date_time (info);
#line 1734 "../src/Photo.vala"
	_tmp1_ = _tmp0_;
#line 1734 "../src/Photo.vala"
	_tmp2_ = coarsify_date_time (_tmp1_);
#line 1734 "../src/Photo.vala"
	_tmp3_ = _tmp2_;
#line 1734 "../src/Photo.vala"
	_g_date_time_unref0 (_tmp1_);
#line 1734 "../src/Photo.vala"
	modification = _tmp3_;
#line 1736 "../src/Photo.vala"
	altered = FALSE;
#line 14428 "Photo.c"
	{
		PhotoRow* _tmp4_;
#line 1737 "../src/Photo.vala"
		_tmp4_ = self->row;
#line 1737 "../src/Photo.vala"
		g_rec_mutex_lock (&self->priv->__lock_row);
#line 14435 "Photo.c"
		{
			gboolean _tmp5_ = FALSE;
			PhotoRow* _tmp6_;
#line 1738 "../src/Photo.vala"
			_tmp6_ = self->row;
#line 1738 "../src/Photo.vala"
			if (backing_photo_id_is_valid (&_tmp6_->editable_id)) {
#line 14443 "Photo.c"
				BackingPhotoRow* _tmp7_;
				GDateTime* _tmp8_;
				GDateTime* _tmp9_;
#line 1738 "../src/Photo.vala"
				_tmp7_ = self->priv->editable;
#line 1738 "../src/Photo.vala"
				_tmp8_ = _tmp7_->timestamp;
#line 1738 "../src/Photo.vala"
				_tmp9_ = modification;
#line 1738 "../src/Photo.vala"
				_tmp5_ = !g_date_time_equal (_tmp8_, _tmp9_);
#line 14455 "Photo.c"
			} else {
#line 1738 "../src/Photo.vala"
				_tmp5_ = FALSE;
#line 14459 "Photo.c"
			}
#line 1738 "../src/Photo.vala"
			if (_tmp5_) {
#line 14463 "Photo.c"
				BackingPhotoTable* _tmp10_;
				BackingPhotoTable* _tmp11_;
				PhotoRow* _tmp12_;
				BackingPhotoID _tmp13_;
				GDateTime* _tmp14_;
				BackingPhotoRow* _tmp15_;
				GDateTime* _tmp16_;
				GDateTime* _tmp17_;
#line 1739 "../src/Photo.vala"
				_tmp10_ = backing_photo_table_get_instance ();
#line 1739 "../src/Photo.vala"
				_tmp11_ = _tmp10_;
#line 1739 "../src/Photo.vala"
				_tmp12_ = self->row;
#line 1739 "../src/Photo.vala"
				_tmp13_ = _tmp12_->editable_id;
#line 1739 "../src/Photo.vala"
				_tmp14_ = modification;
#line 1739 "../src/Photo.vala"
				backing_photo_table_update_timestamp (_tmp11_, &_tmp13_, _tmp14_, &_inner_error0_);
#line 1739 "../src/Photo.vala"
				_database_table_unref0 (_tmp11_);
#line 1739 "../src/Photo.vala"
				if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 14488 "Photo.c"
					goto __catch0_g_error;
				}
#line 1741 "../src/Photo.vala"
				_tmp15_ = self->priv->editable;
#line 1741 "../src/Photo.vala"
				_tmp16_ = modification;
#line 1741 "../src/Photo.vala"
				_tmp17_ = _g_date_time_ref0 (_tmp16_);
#line 1741 "../src/Photo.vala"
				_g_date_time_unref0 (_tmp15_->timestamp);
#line 1741 "../src/Photo.vala"
				_tmp15_->timestamp = _tmp17_;
#line 1742 "../src/Photo.vala"
				altered = TRUE;
#line 14503 "Photo.c"
			}
		}
		goto __finally0;
		__catch0_g_error:
		{
			GError* _lock_error_ = NULL;
			GError* _tmp18_;
#line 1737 "../src/Photo.vala"
			_lock_error_ = _inner_error0_;
#line 1737 "../src/Photo.vala"
			_inner_error0_ = NULL;
#line 1737 "../src/Photo.vala"
			_tmp18_ = _lock_error_;
#line 1737 "../src/Photo.vala"
			_lock_error_ = NULL;
#line 1737 "../src/Photo.vala"
			_inner_error0_ = _tmp18_;
#line 1737 "../src/Photo.vala"
			_g_error_free0 (_lock_error_);
#line 14523 "Photo.c"
			goto __finally0;
		}
		__finally0:
		{
			GError* _inner_error1_ = NULL;
			PhotoRow* _tmp19_;
#line 1737 "../src/Photo.vala"
			_tmp19_ = self->row;
#line 1737 "../src/Photo.vala"
			g_rec_mutex_unlock (&self->priv->__lock_row);
#line 14534 "Photo.c"
		}
#line 1737 "../src/Photo.vala"
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 1737 "../src/Photo.vala"
			g_propagate_error (error, _inner_error0_);
#line 1737 "../src/Photo.vala"
			_g_date_time_unref0 (modification);
#line 1737 "../src/Photo.vala"
			return;
#line 14544 "Photo.c"
		}
	}
#line 1746 "../src/Photo.vala"
	if (altered) {
#line 14549 "Photo.c"
		Alteration* _tmp20_;
		Alteration* _tmp21_;
#line 1747 "../src/Photo.vala"
		_tmp20_ = alteration_new_from_list ("metadata:editable-timestamp,metadata:baseline-timestamp");
#line 1747 "../src/Photo.vala"
		_tmp21_ = _tmp20_;
#line 1747 "../src/Photo.vala"
		data_object_notify_altered (G_TYPE_CHECK_INSTANCE_CAST (self, TYPE_DATA_OBJECT, DataObject), _tmp21_);
#line 1747 "../src/Photo.vala"
		_alteration_unref0 (_tmp21_);
#line 14560 "Photo.c"
	}
#line 1733 "../src/Photo.vala"
	_g_date_time_unref0 (modification);
#line 14564 "Photo.c"
}

void
photo_update_many_editable_timestamps (GeeMap* map,
                                       GError** error)
{
	GError* _inner_error0_ = NULL;
#line 1751 "../src/Photo.vala"
	g_return_if_fail (G_TYPE_CHECK_INSTANCE_TYPE (map, GEE_TYPE_MAP));
#line 1753 "../src/Photo.vala"
	database_table_begin_transaction ();
#line 14576 "Photo.c"
	{
		GeeIterator* _photo_it = NULL;
		GeeSet* _tmp0_;
		GeeSet* _tmp1_;
		GeeSet* _tmp2_;
		GeeIterator* _tmp3_;
		GeeIterator* _tmp4_;
#line 1754 "../src/Photo.vala"
		_tmp0_ = gee_map_get_keys (map);
#line 1754 "../src/Photo.vala"
		_tmp1_ = _tmp0_;
#line 1754 "../src/Photo.vala"
		_tmp2_ = _tmp1_;
#line 1754 "../src/Photo.vala"
		_tmp3_ = gee_iterable_iterator (G_TYPE_CHECK_INSTANCE_CAST (_tmp2_, GEE_TYPE_ITERABLE, GeeIterable));
#line 1754 "../src/Photo.vala"
		_tmp4_ = _tmp3_;
#line 1754 "../src/Photo.vala"
		_g_object_unref0 (_tmp2_);
#line 1754 "../src/Photo.vala"
		_photo_it = _tmp4_;
#line 1754 "../src/Photo.vala"
		while (TRUE) {
#line 14600 "Photo.c"
			GeeIterator* _tmp5_;
			Photo* photo = NULL;
			GeeIterator* _tmp6_;
			gpointer _tmp7_;
#line 1754 "../src/Photo.vala"
			_tmp5_ = _photo_it;
#line 1754 "../src/Photo.vala"
			if (!gee_iterator_next (_tmp5_)) {
#line 1754 "../src/Photo.vala"
				break;
#line 14611 "Photo.c"
			}
#line 1754 "../src/Photo.vala"
			_tmp6_ = _photo_it;
#line 1754 "../src/Photo.vala"
			_tmp7_ = gee_iterator_get (_tmp6_);
#line 1754 "../src/Photo.vala"
			photo = (Photo*) _tmp7_;
#line 14619 "Photo.c"
			{
				Photo* _tmp8_;
				Photo* _tmp9_;
				gpointer _tmp10_;
				GFileInfo* _tmp11_;
#line 1756 "../src/Photo.vala"
				_tmp8_ = photo;
#line 1756 "../src/Photo.vala"
				_tmp9_ = photo;
#line 1756 "../src/Photo.vala"
				_tmp10_ = gee_map_get (map, _tmp9_);
#line 1756 "../src/Photo.vala"
				_tmp11_ = (GFileInfo*) _tmp10_;
#line 1756 "../src/Photo.vala"
				photo_update_editable_modification_time (_tmp8_, _tmp11_, &_inner_error0_);
#line 1756 "../src/Photo.vala"
				_g_object_unref0 (_tmp11_);
#line 1756 "../src/Photo.vala"
				if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 14639 "Photo.c"
					goto __catch0_g_error;
				}
			}
			goto __finally0;
			__catch0_g_error:
			{
				GError* err = NULL;
				GError* _tmp12_;
				const gchar* _tmp13_;
#line 1755 "../src/Photo.vala"
				err = _inner_error0_;
#line 1755 "../src/Photo.vala"
				_inner_error0_ = NULL;
#line 1758 "../src/Photo.vala"
				_tmp12_ = err;
#line 1758 "../src/Photo.vala"
				_tmp13_ = _tmp12_->message;
#line 1758 "../src/Photo.vala"
				g_debug ("Photo.vala:1758: Failed to update modification time: %s", _tmp13_);
#line 1755 "../src/Photo.vala"
				_g_error_free0 (err);
#line 14661 "Photo.c"
			}
			__finally0:
#line 1755 "../src/Photo.vala"
			if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 1755 "../src/Photo.vala"
				if (_inner_error0_->domain == DATABASE_ERROR) {
#line 1755 "../src/Photo.vala"
					g_propagate_error (error, _inner_error0_);
#line 1755 "../src/Photo.vala"
					_g_object_unref0 (photo);
#line 1755 "../src/Photo.vala"
					_g_object_unref0 (_photo_it);
#line 1755 "../src/Photo.vala"
					return;
#line 14676 "Photo.c"
				} else {
#line 1755 "../src/Photo.vala"
					_g_object_unref0 (photo);
#line 1755 "../src/Photo.vala"
					_g_object_unref0 (_photo_it);
#line 1755 "../src/Photo.vala"
					g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 1755 "../src/Photo.vala"
					g_clear_error (&_inner_error0_);
#line 1755 "../src/Photo.vala"
					return;
#line 14688 "Photo.c"
				}
			}
#line 1754 "../src/Photo.vala"
			_g_object_unref0 (photo);
#line 14693 "Photo.c"
		}
#line 1754 "../src/Photo.vala"
		_g_object_unref0 (_photo_it);
#line 14697 "Photo.c"
	}
#line 1761 "../src/Photo.vala"
	database_table_commit_transaction (&_inner_error0_);
#line 1761 "../src/Photo.vala"
	if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 1761 "../src/Photo.vala"
		if (_inner_error0_->domain == DATABASE_ERROR) {
#line 1761 "../src/Photo.vala"
			g_propagate_error (error, _inner_error0_);
#line 1761 "../src/Photo.vala"
			return;
#line 14709 "Photo.c"
		} else {
#line 1761 "../src/Photo.vala"
			g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 1761 "../src/Photo.vala"
			g_clear_error (&_inner_error0_);
#line 1761 "../src/Photo.vala"
			return;
#line 14717 "Photo.c"
		}
	}
}

static PhotoFileFormat
photo_real_get_preferred_thumbnail_format (ThumbnailSource* base)
{
	Photo * self;
	PhotoFileFormat _tmp0_ = 0;
	PhotoFileFormat result;
#line 1764 "../src/Photo.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (base, TYPE_PHOTO, Photo);
#line 1765 "../src/Photo.vala"
	if (photo_file_format_can_write_image (photo_get_file_format (self))) {
#line 1765 "../src/Photo.vala"
		_tmp0_ = photo_get_file_format (self);
#line 14734 "Photo.c"
	} else {
#line 1766 "../src/Photo.vala"
		_tmp0_ = photo_file_format_get_system_default_format ();
#line 14738 "Photo.c"
	}
#line 1765 "../src/Photo.vala"
	result = _tmp0_;
#line 1765 "../src/Photo.vala"
	return result;
#line 14744 "Photo.c"
}

static GdkPixbuf*
photo_real_create_thumbnail (ThumbnailSource* base,
                             gint scale,
                             GError** error)
{
	Photo * self;
	GdkPixbuf* _tmp0_ = NULL;
	Scaling _tmp1_ = {0};
	GdkPixbuf* _tmp2_;
	GdkPixbuf* _tmp3_;
	GError* _inner_error0_ = NULL;
	GdkPixbuf* result;
#line 1769 "../src/Photo.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (base, TYPE_PHOTO, Photo);
#line 1770 "../src/Photo.vala"
	scaling_for_best_fit (scale, TRUE, &_tmp1_);
#line 1770 "../src/Photo.vala"
	_tmp2_ = photo_source_get_pixbuf (G_TYPE_CHECK_INSTANCE_CAST (self, TYPE_PHOTO_SOURCE, PhotoSource), &_tmp1_, &_inner_error0_);
#line 1770 "../src/Photo.vala"
	_tmp0_ = _tmp2_;
#line 1770 "../src/Photo.vala"
	if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 1770 "../src/Photo.vala"
		g_propagate_error (error, _inner_error0_);
#line 1770 "../src/Photo.vala"
		return NULL;
#line 14773 "Photo.c"
	}
#line 1770 "../src/Photo.vala"
	_tmp3_ = _tmp0_;
#line 1770 "../src/Photo.vala"
	_tmp0_ = NULL;
#line 1770 "../src/Photo.vala"
	result = _tmp3_;
#line 1770 "../src/Photo.vala"
	_g_object_unref0 (_tmp0_);
#line 1770 "../src/Photo.vala"
	return result;
#line 14785 "Photo.c"
}

gboolean
photo_is_file_image (GFile* file)
{
	gboolean _tmp0_ = FALSE;
	gboolean result;
#line 1773 "../src/Photo.vala"
	g_return_val_if_fail (G_TYPE_CHECK_INSTANCE_TYPE (file, g_file_get_type ()), FALSE);
#line 1777 "../src/Photo.vala"
	if (photo_file_format_is_file_supported (file)) {
#line 1778 "../src/Photo.vala"
		_tmp0_ = TRUE;
#line 14799 "Photo.c"
	} else {
		gchar* _tmp1_;
		gchar* _tmp2_;
#line 1778 "../src/Photo.vala"
		_tmp1_ = g_file_get_basename (file);
#line 1778 "../src/Photo.vala"
		_tmp2_ = _tmp1_;
#line 1778 "../src/Photo.vala"
		_tmp0_ = photo_is_extension_found (_tmp2_, PHOTO_IMAGE_EXTENSIONS, (gint) G_N_ELEMENTS (PHOTO_IMAGE_EXTENSIONS));
#line 1778 "../src/Photo.vala"
		_g_free0 (_tmp2_);
#line 14811 "Photo.c"
	}
#line 1777 "../src/Photo.vala"
	result = _tmp0_;
#line 1777 "../src/Photo.vala"
	return result;
#line 14817 "Photo.c"
}

static gboolean
photo_is_extension_found (const gchar* basename,
                          gchar** extensions,
                          gint extensions_length1)
{
	gchar* name = NULL;
	gchar* ext = NULL;
	gchar* _tmp0_ = NULL;
	gchar* _tmp1_ = NULL;
	const gchar* _tmp2_;
	const gchar* _tmp3_;
	gchar* _tmp4_;
	gboolean result;
#line 1781 "../src/Photo.vala"
	g_return_val_if_fail (basename != NULL, FALSE);
#line 1783 "../src/Photo.vala"
	disassemble_filename (basename, &_tmp0_, &_tmp1_);
#line 1783 "../src/Photo.vala"
	_g_free0 (name);
#line 1783 "../src/Photo.vala"
	name = _tmp0_;
#line 1783 "../src/Photo.vala"
	_g_free0 (ext);
#line 1783 "../src/Photo.vala"
	ext = _tmp1_;
#line 1784 "../src/Photo.vala"
	_tmp2_ = ext;
#line 1784 "../src/Photo.vala"
	if (_tmp2_ == NULL) {
#line 1785 "../src/Photo.vala"
		result = FALSE;
#line 1785 "../src/Photo.vala"
		_g_free0 (ext);
#line 1785 "../src/Photo.vala"
		_g_free0 (name);
#line 1785 "../src/Photo.vala"
		return result;
#line 14857 "Photo.c"
	}
#line 1788 "../src/Photo.vala"
	_tmp3_ = ext;
#line 1788 "../src/Photo.vala"
	_tmp4_ = g_utf8_strdown (_tmp3_, (gssize) -1);
#line 1788 "../src/Photo.vala"
	_g_free0 (ext);
#line 1788 "../src/Photo.vala"
	ext = _tmp4_;
#line 14867 "Photo.c"
	{
		gchar** extension_collection = NULL;
		gint extension_collection_length1 = 0;
		gint _extension_collection_size_ = 0;
		gint extension_it = 0;
#line 1791 "../src/Photo.vala"
		extension_collection = extensions;
#line 1791 "../src/Photo.vala"
		extension_collection_length1 = extensions_length1;
#line 1791 "../src/Photo.vala"
		for (extension_it = 0; extension_it < extension_collection_length1; extension_it = extension_it + 1) {
#line 14879 "Photo.c"
			gchar* _tmp5_;
			gchar* extension = NULL;
#line 1791 "../src/Photo.vala"
			_tmp5_ = g_strdup (extension_collection[extension_it]);
#line 1791 "../src/Photo.vala"
			extension = _tmp5_;
#line 14886 "Photo.c"
			{
				const gchar* _tmp6_;
				const gchar* _tmp7_;
#line 1792 "../src/Photo.vala"
				_tmp6_ = ext;
#line 1792 "../src/Photo.vala"
				_tmp7_ = extension;
#line 1792 "../src/Photo.vala"
				if (g_strcmp0 (_tmp6_, _tmp7_) == 0) {
#line 1793 "../src/Photo.vala"
					result = TRUE;
#line 1793 "../src/Photo.vala"
					_g_free0 (extension);
#line 1793 "../src/Photo.vala"
					_g_free0 (ext);
#line 1793 "../src/Photo.vala"
					_g_free0 (name);
#line 1793 "../src/Photo.vala"
					return result;
#line 14906 "Photo.c"
				}
#line 1791 "../src/Photo.vala"
				_g_free0 (extension);
#line 14910 "Photo.c"
			}
		}
	}
#line 1796 "../src/Photo.vala"
	result = FALSE;
#line 1796 "../src/Photo.vala"
	_g_free0 (ext);
#line 1796 "../src/Photo.vala"
	_g_free0 (name);
#line 1796 "../src/Photo.vala"
	return result;
#line 14922 "Photo.c"
}

gboolean
photo_is_duplicate (GFile* file,
                    const gchar* thumbnail_md5,
                    const gchar* full_md5,
                    PhotoFileFormat file_format)
{
	PhotoTable* _tmp0_;
	PhotoTable* _tmp1_;
	gboolean _tmp2_;
	gboolean result;
#line 1802 "../src/Photo.vala"
	g_return_val_if_fail ((file == NULL) || G_TYPE_CHECK_INSTANCE_TYPE (file, g_file_get_type ()), FALSE);
#line 1805 "../src/Photo.vala"
	_tmp0_ = photo_table_get_instance ();
#line 1805 "../src/Photo.vala"
	_tmp1_ = _tmp0_;
#line 1805 "../src/Photo.vala"
	_tmp2_ = photo_table_has_duplicate (_tmp1_, file, thumbnail_md5, full_md5, file_format);
#line 1805 "../src/Photo.vala"
	_database_table_unref0 (_tmp1_);
#line 1805 "../src/Photo.vala"
	result = _tmp2_;
#line 1805 "../src/Photo.vala"
	return result;
#line 14949 "Photo.c"
}

PhotoID*
photo_get_duplicate_ids (GFile* file,
                         const gchar* thumbnail_md5,
                         const gchar* full_md5,
                         PhotoFileFormat file_format,
                         gint* result_length1)
{
	PhotoTable* _tmp0_;
	PhotoTable* _tmp1_;
	gint _tmp2_ = 0;
	PhotoID* _tmp3_;
	PhotoID* _tmp4_;
	gint _tmp4__length1;
	PhotoID* _tmp5_;
	gint _tmp5__length1;
	PhotoID* result;
#line 1811 "../src/Photo.vala"
	g_return_val_if_fail ((file == NULL) || G_TYPE_CHECK_INSTANCE_TYPE (file, g_file_get_type ()), NULL);
#line 1814 "../src/Photo.vala"
	_tmp0_ = photo_table_get_instance ();
#line 1814 "../src/Photo.vala"
	_tmp1_ = _tmp0_;
#line 1814 "../src/Photo.vala"
	_tmp3_ = photo_table_get_duplicate_ids (_tmp1_, file, thumbnail_md5, full_md5, file_format, &_tmp2_);
#line 1814 "../src/Photo.vala"
	_tmp4_ = _tmp3_;
#line 1814 "../src/Photo.vala"
	_tmp4__length1 = _tmp2_;
#line 1814 "../src/Photo.vala"
	_database_table_unref0 (_tmp1_);
#line 1814 "../src/Photo.vala"
	_tmp5_ = _tmp4_;
#line 1814 "../src/Photo.vala"
	_tmp5__length1 = _tmp4__length1;
#line 1814 "../src/Photo.vala"
	if (result_length1) {
#line 1814 "../src/Photo.vala"
		*result_length1 = _tmp5__length1;
#line 14990 "Photo.c"
	}
#line 1814 "../src/Photo.vala"
	result = _tmp5_;
#line 1814 "../src/Photo.vala"
	return result;
#line 14996 "Photo.c"
}

gint64
photo_get_photo_key (DataSource* source)
{
	PhotoID _tmp0_ = {0};
	gint64 result;
#line 1821 "../src/Photo.vala"
	g_return_val_if_fail (IS_DATA_SOURCE (source), 0LL);
#line 1822 "../src/Photo.vala"
	photo_get_photo_id (G_TYPE_CHECK_INSTANCE_CAST (G_TYPE_CHECK_INSTANCE_CAST (source, TYPE_LIBRARY_PHOTO, LibraryPhoto), TYPE_PHOTO, Photo), &_tmp0_);
#line 1822 "../src/Photo.vala"
	result = _tmp0_.id;
#line 1822 "../src/Photo.vala"
	return result;
#line 15012 "Photo.c"
}

static GFile*
photo_real_get_file (MediaSource* base)
{
	Photo * self;
	PhotoFileReader* _tmp0_;
	PhotoFileReader* _tmp1_;
	GFile* _tmp2_;
	GFile* _tmp3_;
	GFile* result;
#line 1840 "../src/Photo.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (base, TYPE_PHOTO, Photo);
#line 1841 "../src/Photo.vala"
	_tmp0_ = photo_get_source_reader (self);
#line 1841 "../src/Photo.vala"
	_tmp1_ = _tmp0_;
#line 1841 "../src/Photo.vala"
	_tmp2_ = photo_file_adapter_get_file (G_TYPE_CHECK_INSTANCE_CAST (_tmp1_, TYPE_PHOTO_FILE_ADAPTER, PhotoFileAdapter));
#line 1841 "../src/Photo.vala"
	_tmp3_ = _tmp2_;
#line 1841 "../src/Photo.vala"
	_photo_file_adapter_unref0 (_tmp1_);
#line 1841 "../src/Photo.vala"
	result = _tmp3_;
#line 1841 "../src/Photo.vala"
	return result;
#line 15040 "Photo.c"
}

static void
_vala_array_add95 (gchar** * array,
                   gint* length,
                   gint* size,
                   gchar* value)
{
#line 1884 "../src/Photo.vala"
	if ((*length) == (*size)) {
#line 1884 "../src/Photo.vala"
		*size = (*size) ? (2 * (*size)) : 4;
#line 1884 "../src/Photo.vala"
		*array = g_renew (gchar*, *array, (*size) + 1);
#line 15055 "Photo.c"
	}
#line 1884 "../src/Photo.vala"
	(*array)[(*length)++] = value;
#line 1884 "../src/Photo.vala"
	(*array)[*length] = NULL;
#line 15061 "Photo.c"
}

static void
_vala_array_add96 (gchar** * array,
                   gint* length,
                   gint* size,
                   gchar* value)
{
#line 1889 "../src/Photo.vala"
	if ((*length) == (*size)) {
#line 1889 "../src/Photo.vala"
		*size = (*size) ? (2 * (*size)) : 4;
#line 1889 "../src/Photo.vala"
		*array = g_renew (gchar*, *array, (*size) + 1);
#line 15076 "Photo.c"
	}
#line 1889 "../src/Photo.vala"
	(*array)[(*length)++] = value;
#line 1889 "../src/Photo.vala"
	(*array)[*length] = NULL;
#line 15082 "Photo.c"
}

static void
_vala_array_add97 (gchar** * array,
                   gint* length,
                   gint* size,
                   gchar* value)
{
#line 1892 "../src/Photo.vala"
	if ((*length) == (*size)) {
#line 1892 "../src/Photo.vala"
		*size = (*size) ? (2 * (*size)) : 4;
#line 1892 "../src/Photo.vala"
		*array = g_renew (gchar*, *array, (*size) + 1);
#line 15097 "Photo.c"
	}
#line 1892 "../src/Photo.vala"
	(*array)[(*length)++] = value;
#line 1892 "../src/Photo.vala"
	(*array)[*length] = NULL;
#line 15103 "Photo.c"
}

static void
_vala_array_add98 (gchar** * array,
                   gint* length,
                   gint* size,
                   gchar* value)
{
#line 1895 "../src/Photo.vala"
	if ((*length) == (*size)) {
#line 1895 "../src/Photo.vala"
		*size = (*size) ? (2 * (*size)) : 4;
#line 1895 "../src/Photo.vala"
		*array = g_renew (gchar*, *array, (*size) + 1);
#line 15118 "Photo.c"
	}
#line 1895 "../src/Photo.vala"
	(*array)[(*length)++] = value;
#line 1895 "../src/Photo.vala"
	(*array)[*length] = NULL;
#line 15124 "Photo.c"
}

void
photo_set_master_file (Photo* self,
                       GFile* file)
{
	gchar* filepath = NULL;
	gchar* _tmp0_;
	gboolean altered = FALSE;
	gboolean is_baseline = FALSE;
	gboolean is_source = FALSE;
	gboolean name_changed = FALSE;
	GFile* old_file = NULL;
	GError* _inner_error0_ = NULL;
#line 1846 "../src/Photo.vala"
	g_return_if_fail (IS_PHOTO (self));
#line 1846 "../src/Photo.vala"
	g_return_if_fail (G_TYPE_CHECK_INSTANCE_TYPE (file, g_file_get_type ()));
#line 1847 "../src/Photo.vala"
	_tmp0_ = g_file_get_path (file);
#line 1847 "../src/Photo.vala"
	filepath = _tmp0_;
#line 1849 "../src/Photo.vala"
	altered = FALSE;
#line 1850 "../src/Photo.vala"
	is_baseline = FALSE;
#line 1851 "../src/Photo.vala"
	is_source = FALSE;
#line 1852 "../src/Photo.vala"
	name_changed = FALSE;
#line 1853 "../src/Photo.vala"
	old_file = NULL;
#line 15157 "Photo.c"
	{
		{
			PhotoRow* _tmp1_;
#line 1855 "../src/Photo.vala"
			_tmp1_ = self->row;
#line 1855 "../src/Photo.vala"
			g_rec_mutex_lock (&self->priv->__lock_row);
#line 15165 "Photo.c"
			{
				{
					PhotoBackingReaders* _tmp2_;
#line 1856 "../src/Photo.vala"
					_tmp2_ = self->priv->readers;
#line 1856 "../src/Photo.vala"
					g_rec_mutex_lock (&self->priv->__lock_readers);
#line 15173 "Photo.c"
					{
						PhotoBackingReaders* _tmp3_;
						PhotoFileReader* _tmp4_;
						GFile* _tmp5_;
						GFile* _tmp6_;
#line 1857 "../src/Photo.vala"
						_tmp3_ = self->priv->readers;
#line 1857 "../src/Photo.vala"
						_tmp4_ = _tmp3_->master;
#line 1857 "../src/Photo.vala"
						_tmp5_ = photo_file_adapter_get_file (G_TYPE_CHECK_INSTANCE_CAST (_tmp4_, TYPE_PHOTO_FILE_ADAPTER, PhotoFileAdapter));
#line 1857 "../src/Photo.vala"
						_g_object_unref0 (old_file);
#line 1857 "../src/Photo.vala"
						old_file = _tmp5_;
#line 1858 "../src/Photo.vala"
						_tmp6_ = old_file;
#line 1858 "../src/Photo.vala"
						if (!g_file_equal (file, _tmp6_)) {
#line 15193 "Photo.c"
							PhotoTable* _tmp7_;
							PhotoTable* _tmp8_;
							PhotoID _tmp9_ = {0};
							const gchar* _tmp10_;
							PhotoRow* _tmp11_;
							BackingPhotoRow* _tmp12_;
							const gchar* _tmp13_;
							gchar* _tmp14_;
							gchar* _tmp15_;
							PhotoBackingReaders* _tmp16_;
							PhotoRow* _tmp17_;
							BackingPhotoRow* _tmp18_;
							const gchar* _tmp19_;
							PhotoFileReader* _tmp20_;
							gboolean _tmp21_ = FALSE;
							PhotoRow* _tmp22_;
							const gchar* _tmp23_;
#line 1859 "../src/Photo.vala"
							_tmp7_ = photo_table_get_instance ();
#line 1859 "../src/Photo.vala"
							_tmp8_ = _tmp7_;
#line 1859 "../src/Photo.vala"
							photo_get_photo_id (self, &_tmp9_);
#line 1859 "../src/Photo.vala"
							_tmp10_ = filepath;
#line 1859 "../src/Photo.vala"
							photo_table_set_filepath (_tmp8_, &_tmp9_, _tmp10_, &_inner_error0_);
#line 1859 "../src/Photo.vala"
							_database_table_unref0 (_tmp8_);
#line 1859 "../src/Photo.vala"
							if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 15225 "Photo.c"
								goto __catch2_g_error;
							}
#line 1861 "../src/Photo.vala"
							_tmp11_ = self->row;
#line 1861 "../src/Photo.vala"
							_tmp12_ = _tmp11_->master;
#line 1861 "../src/Photo.vala"
							_tmp13_ = filepath;
#line 1861 "../src/Photo.vala"
							_tmp14_ = g_strdup (_tmp13_);
#line 1861 "../src/Photo.vala"
							_g_free0 (_tmp12_->filepath);
#line 1861 "../src/Photo.vala"
							_tmp12_->filepath = _tmp14_;
#line 1862 "../src/Photo.vala"
							_tmp15_ = g_file_get_basename (file);
#line 1862 "../src/Photo.vala"
							_g_free0 (self->priv->file_title);
#line 1862 "../src/Photo.vala"
							self->priv->file_title = _tmp15_;
#line 1863 "../src/Photo.vala"
							_tmp16_ = self->priv->readers;
#line 1863 "../src/Photo.vala"
							_tmp17_ = self->row;
#line 1863 "../src/Photo.vala"
							_tmp18_ = _tmp17_->master;
#line 1863 "../src/Photo.vala"
							_tmp19_ = filepath;
#line 1863 "../src/Photo.vala"
							_tmp20_ = photo_file_format_create_reader (_tmp18_->file_format, _tmp19_);
#line 1863 "../src/Photo.vala"
							_photo_file_adapter_unref0 (_tmp16_->master);
#line 1863 "../src/Photo.vala"
							_tmp16_->master = _tmp20_;
#line 1865 "../src/Photo.vala"
							altered = TRUE;
#line 1866 "../src/Photo.vala"
							is_baseline = photo_is_master_baseline (self);
#line 1867 "../src/Photo.vala"
							is_source = photo_is_master_source (self);
#line 1868 "../src/Photo.vala"
							_tmp22_ = self->row;
#line 1868 "../src/Photo.vala"
							_tmp23_ = _tmp22_->title;
#line 1868 "../src/Photo.vala"
							if (is_string_empty (_tmp23_)) {
#line 15272 "Photo.c"
								GFile* _tmp24_;
								gchar* _tmp25_;
								gchar* _tmp26_;
								gchar* _tmp27_;
								gchar* _tmp28_;
#line 1869 "../src/Photo.vala"
								_tmp24_ = old_file;
#line 1869 "../src/Photo.vala"
								_tmp25_ = g_file_get_basename (_tmp24_);
#line 1869 "../src/Photo.vala"
								_tmp26_ = _tmp25_;
#line 1869 "../src/Photo.vala"
								_tmp27_ = g_file_get_basename (file);
#line 1869 "../src/Photo.vala"
								_tmp28_ = _tmp27_;
#line 1869 "../src/Photo.vala"
								_tmp21_ = g_strcmp0 (_tmp26_, _tmp28_) != 0;
#line 1869 "../src/Photo.vala"
								_g_free0 (_tmp28_);
#line 1869 "../src/Photo.vala"
								_g_free0 (_tmp26_);
#line 15294 "Photo.c"
							} else {
#line 1868 "../src/Photo.vala"
								_tmp21_ = FALSE;
#line 15298 "Photo.c"
							}
#line 1868 "../src/Photo.vala"
							name_changed = _tmp21_;
#line 15302 "Photo.c"
						}
					}
					goto __finally2;
					__catch2_g_error:
					{
						GError* _lock_error_ = NULL;
						GError* _tmp29_;
#line 1856 "../src/Photo.vala"
						_lock_error_ = _inner_error0_;
#line 1856 "../src/Photo.vala"
						_inner_error0_ = NULL;
#line 1856 "../src/Photo.vala"
						_tmp29_ = _lock_error_;
#line 1856 "../src/Photo.vala"
						_lock_error_ = NULL;
#line 1856 "../src/Photo.vala"
						_inner_error0_ = _tmp29_;
#line 1856 "../src/Photo.vala"
						_g_error_free0 (_lock_error_);
#line 15322 "Photo.c"
						goto __finally2;
					}
					__finally2:
					{
						GError* _inner_error1_ = NULL;
						PhotoBackingReaders* _tmp30_;
#line 1856 "../src/Photo.vala"
						_tmp30_ = self->priv->readers;
#line 1856 "../src/Photo.vala"
						g_rec_mutex_unlock (&self->priv->__lock_readers);
#line 15333 "Photo.c"
					}
#line 1856 "../src/Photo.vala"
					if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 15337 "Photo.c"
						goto __catch1_g_error;
					}
				}
			}
			goto __finally1;
			__catch1_g_error:
			{
				GError* _lock_error_ = NULL;
				GError* _tmp31_;
#line 1855 "../src/Photo.vala"
				_lock_error_ = _inner_error0_;
#line 1855 "../src/Photo.vala"
				_inner_error0_ = NULL;
#line 1855 "../src/Photo.vala"
				_tmp31_ = _lock_error_;
#line 1855 "../src/Photo.vala"
				_lock_error_ = NULL;
#line 1855 "../src/Photo.vala"
				_inner_error0_ = _tmp31_;
#line 1855 "../src/Photo.vala"
				_g_error_free0 (_lock_error_);
#line 15359 "Photo.c"
				goto __finally1;
			}
			__finally1:
			{
				GError* _inner_error1_ = NULL;
				PhotoRow* _tmp32_;
#line 1855 "../src/Photo.vala"
				_tmp32_ = self->row;
#line 1855 "../src/Photo.vala"
				g_rec_mutex_unlock (&self->priv->__lock_row);
#line 15370 "Photo.c"
			}
#line 1855 "../src/Photo.vala"
			if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 15374 "Photo.c"
				goto __catch0_g_error;
			}
		}
	}
	goto __finally0;
	__catch0_g_error:
	{
		GError* err = NULL;
		GError* _tmp33_;
#line 1854 "../src/Photo.vala"
		err = _inner_error0_;
#line 1854 "../src/Photo.vala"
		_inner_error0_ = NULL;
#line 1874 "../src/Photo.vala"
		_tmp33_ = err;
#line 1874 "../src/Photo.vala"
		app_window_database_error (_tmp33_);
#line 1854 "../src/Photo.vala"
		_g_error_free0 (err);
#line 15394 "Photo.c"
	}
	__finally0:
#line 1854 "../src/Photo.vala"
	if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 1854 "../src/Photo.vala"
		_g_object_unref0 (old_file);
#line 1854 "../src/Photo.vala"
		_g_free0 (filepath);
#line 1854 "../src/Photo.vala"
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 1854 "../src/Photo.vala"
		g_clear_error (&_inner_error0_);
#line 1854 "../src/Photo.vala"
		return;
#line 15409 "Photo.c"
	}
#line 1877 "../src/Photo.vala"
	if (altered) {
#line 15413 "Photo.c"
		GFile* _tmp34_;
		gchar** alteration_list = NULL;
		gchar** _tmp35_;
		gint alteration_list_length1;
		gint _alteration_list_size_;
		gchar* _tmp36_;
		gchar** _tmp40_;
		gint _tmp40__length1;
		Alteration* _tmp41_;
		Alteration* _tmp42_;
#line 1878 "../src/Photo.vala"
		_tmp34_ = old_file;
#line 1878 "../src/Photo.vala"
		media_source_notify_master_replaced (G_TYPE_CHECK_INSTANCE_CAST (self, TYPE_MEDIA_SOURCE, MediaSource), _tmp34_, file);
#line 1880 "../src/Photo.vala"
		if (is_baseline) {
#line 1881 "../src/Photo.vala"
			photo_notify_baseline_replaced (self);
#line 15432 "Photo.c"
		}
#line 1883 "../src/Photo.vala"
		_tmp35_ = g_new0 (gchar*, 0 + 1);
#line 1883 "../src/Photo.vala"
		alteration_list = _tmp35_;
#line 1883 "../src/Photo.vala"
		alteration_list_length1 = 0;
#line 1883 "../src/Photo.vala"
		_alteration_list_size_ = alteration_list_length1;
#line 1884 "../src/Photo.vala"
		_tmp36_ = g_strdup ("backing:master");
#line 1884 "../src/Photo.vala"
		_vala_array_add95 (&alteration_list, &alteration_list_length1, &_alteration_list_size_, _tmp36_);
#line 1888 "../src/Photo.vala"
		if (name_changed) {
#line 15448 "Photo.c"
			gchar* _tmp37_;
#line 1889 "../src/Photo.vala"
			_tmp37_ = g_strdup ("metadata:name");
#line 1889 "../src/Photo.vala"
			_vala_array_add96 (&alteration_list, &alteration_list_length1, &_alteration_list_size_, _tmp37_);
#line 15454 "Photo.c"
		}
#line 1891 "../src/Photo.vala"
		if (is_source) {
#line 15458 "Photo.c"
			gchar* _tmp38_;
#line 1892 "../src/Photo.vala"
			_tmp38_ = g_strdup ("backing:source");
#line 1892 "../src/Photo.vala"
			_vala_array_add97 (&alteration_list, &alteration_list_length1, &_alteration_list_size_, _tmp38_);
#line 15464 "Photo.c"
		}
#line 1894 "../src/Photo.vala"
		if (is_baseline) {
#line 15468 "Photo.c"
			gchar* _tmp39_;
#line 1895 "../src/Photo.vala"
			_tmp39_ = g_strdup ("backing:baseline");
#line 1895 "../src/Photo.vala"
			_vala_array_add98 (&alteration_list, &alteration_list_length1, &_alteration_list_size_, _tmp39_);
#line 15474 "Photo.c"
		}
#line 1897 "../src/Photo.vala"
		_tmp40_ = alteration_list;
#line 1897 "../src/Photo.vala"
		_tmp40__length1 = alteration_list_length1;
#line 1897 "../src/Photo.vala"
		_tmp41_ = alteration_new_from_array (_tmp40_, _tmp40__length1);
#line 1897 "../src/Photo.vala"
		_tmp42_ = _tmp41_;
#line 1897 "../src/Photo.vala"
		data_object_notify_altered (G_TYPE_CHECK_INSTANCE_CAST (self, TYPE_DATA_OBJECT, DataObject), _tmp42_);
#line 1897 "../src/Photo.vala"
		_alteration_unref0 (_tmp42_);
#line 1877 "../src/Photo.vala"
		alteration_list = (_vala_array_free (alteration_list, alteration_list_length1, (GDestroyNotify) g_free), NULL);
#line 15490 "Photo.c"
	}
#line 1846 "../src/Photo.vala"
	_g_object_unref0 (old_file);
#line 1846 "../src/Photo.vala"
	_g_free0 (filepath);
#line 15496 "Photo.c"
}

static void
_vala_array_add99 (gchar** * array,
                   gint* length,
                   gint* size,
                   gchar* value)
{
#line 1937 "../src/Photo.vala"
	if ((*length) == (*size)) {
#line 1937 "../src/Photo.vala"
		*size = (*size) ? (2 * (*size)) : 4;
#line 1937 "../src/Photo.vala"
		*array = g_renew (gchar*, *array, (*size) + 1);
#line 15511 "Photo.c"
	}
#line 1937 "../src/Photo.vala"
	(*array)[(*length)++] = value;
#line 1937 "../src/Photo.vala"
	(*array)[*length] = NULL;
#line 15517 "Photo.c"
}

static void
_vala_array_add100 (gchar** * array,
                    gint* length,
                    gint* size,
                    gchar* value)
{
#line 1940 "../src/Photo.vala"
	if ((*length) == (*size)) {
#line 1940 "../src/Photo.vala"
		*size = (*size) ? (2 * (*size)) : 4;
#line 1940 "../src/Photo.vala"
		*array = g_renew (gchar*, *array, (*size) + 1);
#line 15532 "Photo.c"
	}
#line 1940 "../src/Photo.vala"
	(*array)[(*length)++] = value;
#line 1940 "../src/Photo.vala"
	(*array)[*length] = NULL;
#line 15538 "Photo.c"
}

static void
_vala_array_add101 (gchar** * array,
                    gint* length,
                    gint* size,
                    gchar* value)
{
#line 1943 "../src/Photo.vala"
	if ((*length) == (*size)) {
#line 1943 "../src/Photo.vala"
		*size = (*size) ? (2 * (*size)) : 4;
#line 1943 "../src/Photo.vala"
		*array = g_renew (gchar*, *array, (*size) + 1);
#line 15553 "Photo.c"
	}
#line 1943 "../src/Photo.vala"
	(*array)[(*length)++] = value;
#line 1943 "../src/Photo.vala"
	(*array)[*length] = NULL;
#line 15559 "Photo.c"
}

void
photo_set_editable_file (Photo* self,
                         GFile* file)
{
	gchar* filepath = NULL;
	gchar* _tmp0_;
	gboolean altered = FALSE;
	gboolean is_baseline = FALSE;
	gboolean is_source = FALSE;
	GFile* old_file = NULL;
	GError* _inner_error0_ = NULL;
#line 1903 "../src/Photo.vala"
	g_return_if_fail (IS_PHOTO (self));
#line 1903 "../src/Photo.vala"
	g_return_if_fail (G_TYPE_CHECK_INSTANCE_TYPE (file, g_file_get_type ()));
#line 1904 "../src/Photo.vala"
	_tmp0_ = g_file_get_path (file);
#line 1904 "../src/Photo.vala"
	filepath = _tmp0_;
#line 1906 "../src/Photo.vala"
	altered = FALSE;
#line 1907 "../src/Photo.vala"
	is_baseline = FALSE;
#line 1908 "../src/Photo.vala"
	is_source = FALSE;
#line 1909 "../src/Photo.vala"
	old_file = NULL;
#line 15589 "Photo.c"
	{
		{
			PhotoRow* _tmp1_;
#line 1911 "../src/Photo.vala"
			_tmp1_ = self->row;
#line 1911 "../src/Photo.vala"
			g_rec_mutex_lock (&self->priv->__lock_row);
#line 15597 "Photo.c"
			{
				{
					PhotoBackingReaders* _tmp2_;
#line 1912 "../src/Photo.vala"
					_tmp2_ = self->priv->readers;
#line 1912 "../src/Photo.vala"
					g_rec_mutex_lock (&self->priv->__lock_readers);
#line 15605 "Photo.c"
					{
						GFile* _tmp3_ = NULL;
						PhotoBackingReaders* _tmp4_;
						PhotoFileReader* _tmp5_;
						GFile* _tmp9_;
						gboolean _tmp10_ = FALSE;
						GFile* _tmp11_;
#line 1913 "../src/Photo.vala"
						_tmp4_ = self->priv->readers;
#line 1913 "../src/Photo.vala"
						_tmp5_ = _tmp4_->editable;
#line 1913 "../src/Photo.vala"
						if (_tmp5_ != NULL) {
#line 15619 "Photo.c"
							PhotoBackingReaders* _tmp6_;
							PhotoFileReader* _tmp7_;
							GFile* _tmp8_;
#line 1913 "../src/Photo.vala"
							_tmp6_ = self->priv->readers;
#line 1913 "../src/Photo.vala"
							_tmp7_ = _tmp6_->editable;
#line 1913 "../src/Photo.vala"
							_tmp8_ = photo_file_adapter_get_file (G_TYPE_CHECK_INSTANCE_CAST (_tmp7_, TYPE_PHOTO_FILE_ADAPTER, PhotoFileAdapter));
#line 1913 "../src/Photo.vala"
							_g_object_unref0 (_tmp3_);
#line 1913 "../src/Photo.vala"
							_tmp3_ = _tmp8_;
#line 15633 "Photo.c"
						} else {
#line 1913 "../src/Photo.vala"
							_g_object_unref0 (_tmp3_);
#line 1913 "../src/Photo.vala"
							_tmp3_ = NULL;
#line 15639 "Photo.c"
						}
#line 1913 "../src/Photo.vala"
						_tmp9_ = _g_object_ref0 (_tmp3_);
#line 1913 "../src/Photo.vala"
						_g_object_unref0 (old_file);
#line 1913 "../src/Photo.vala"
						old_file = _tmp9_;
#line 1914 "../src/Photo.vala"
						_tmp11_ = old_file;
#line 1914 "../src/Photo.vala"
						if (_tmp11_ != NULL) {
#line 15651 "Photo.c"
							GFile* _tmp12_;
#line 1914 "../src/Photo.vala"
							_tmp12_ = old_file;
#line 1914 "../src/Photo.vala"
							_tmp10_ = !g_file_equal (_tmp12_, file);
#line 15657 "Photo.c"
						} else {
#line 1914 "../src/Photo.vala"
							_tmp10_ = FALSE;
#line 15661 "Photo.c"
						}
#line 1914 "../src/Photo.vala"
						if (_tmp10_) {
#line 15665 "Photo.c"
							BackingPhotoTable* _tmp13_;
							BackingPhotoTable* _tmp14_;
							PhotoRow* _tmp15_;
							BackingPhotoID _tmp16_;
							const gchar* _tmp17_;
							BackingPhotoRow* _tmp18_;
							const gchar* _tmp19_;
							gchar* _tmp20_;
							PhotoBackingReaders* _tmp21_;
							BackingPhotoRow* _tmp22_;
							const gchar* _tmp23_;
							PhotoFileReader* _tmp24_;
#line 1915 "../src/Photo.vala"
							_tmp13_ = backing_photo_table_get_instance ();
#line 1915 "../src/Photo.vala"
							_tmp14_ = _tmp13_;
#line 1915 "../src/Photo.vala"
							_tmp15_ = self->row;
#line 1915 "../src/Photo.vala"
							_tmp16_ = _tmp15_->editable_id;
#line 1915 "../src/Photo.vala"
							_tmp17_ = filepath;
#line 1915 "../src/Photo.vala"
							backing_photo_table_set_filepath (_tmp14_, &_tmp16_, _tmp17_, &_inner_error0_);
#line 1915 "../src/Photo.vala"
							_database_table_unref0 (_tmp14_);
#line 1915 "../src/Photo.vala"
							if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 1915 "../src/Photo.vala"
								_g_object_unref0 (_tmp3_);
#line 15696 "Photo.c"
								goto __catch2_g_error;
							}
#line 1917 "../src/Photo.vala"
							_tmp18_ = self->priv->editable;
#line 1917 "../src/Photo.vala"
							_tmp19_ = filepath;
#line 1917 "../src/Photo.vala"
							_tmp20_ = g_strdup (_tmp19_);
#line 1917 "../src/Photo.vala"
							_g_free0 (_tmp18_->filepath);
#line 1917 "../src/Photo.vala"
							_tmp18_->filepath = _tmp20_;
#line 1918 "../src/Photo.vala"
							_tmp21_ = self->priv->readers;
#line 1918 "../src/Photo.vala"
							_tmp22_ = self->priv->editable;
#line 1918 "../src/Photo.vala"
							_tmp23_ = filepath;
#line 1918 "../src/Photo.vala"
							_tmp24_ = photo_file_format_create_reader (_tmp22_->file_format, _tmp23_);
#line 1918 "../src/Photo.vala"
							_photo_file_adapter_unref0 (_tmp21_->editable);
#line 1918 "../src/Photo.vala"
							_tmp21_->editable = _tmp24_;
#line 1920 "../src/Photo.vala"
							altered = TRUE;
#line 1921 "../src/Photo.vala"
							is_baseline = photo_is_editable_baseline (self);
#line 1922 "../src/Photo.vala"
							is_source = photo_is_editable_source (self);
#line 15727 "Photo.c"
						}
#line 1912 "../src/Photo.vala"
						_g_object_unref0 (_tmp3_);
#line 15731 "Photo.c"
					}
					goto __finally2;
					__catch2_g_error:
					{
						GError* _lock_error_ = NULL;
						GError* _tmp25_;
#line 1912 "../src/Photo.vala"
						_lock_error_ = _inner_error0_;
#line 1912 "../src/Photo.vala"
						_inner_error0_ = NULL;
#line 1912 "../src/Photo.vala"
						_tmp25_ = _lock_error_;
#line 1912 "../src/Photo.vala"
						_lock_error_ = NULL;
#line 1912 "../src/Photo.vala"
						_inner_error0_ = _tmp25_;
#line 1912 "../src/Photo.vala"
						_g_error_free0 (_lock_error_);
#line 15750 "Photo.c"
						goto __finally2;
					}
					__finally2:
					{
						GError* _inner_error1_ = NULL;
						PhotoBackingReaders* _tmp26_;
#line 1912 "../src/Photo.vala"
						_tmp26_ = self->priv->readers;
#line 1912 "../src/Photo.vala"
						g_rec_mutex_unlock (&self->priv->__lock_readers);
#line 15761 "Photo.c"
					}
#line 1912 "../src/Photo.vala"
					if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 15765 "Photo.c"
						goto __catch1_g_error;
					}
				}
			}
			goto __finally1;
			__catch1_g_error:
			{
				GError* _lock_error_ = NULL;
				GError* _tmp27_;
#line 1911 "../src/Photo.vala"
				_lock_error_ = _inner_error0_;
#line 1911 "../src/Photo.vala"
				_inner_error0_ = NULL;
#line 1911 "../src/Photo.vala"
				_tmp27_ = _lock_error_;
#line 1911 "../src/Photo.vala"
				_lock_error_ = NULL;
#line 1911 "../src/Photo.vala"
				_inner_error0_ = _tmp27_;
#line 1911 "../src/Photo.vala"
				_g_error_free0 (_lock_error_);
#line 15787 "Photo.c"
				goto __finally1;
			}
			__finally1:
			{
				GError* _inner_error1_ = NULL;
				PhotoRow* _tmp28_;
#line 1911 "../src/Photo.vala"
				_tmp28_ = self->row;
#line 1911 "../src/Photo.vala"
				g_rec_mutex_unlock (&self->priv->__lock_row);
#line 15798 "Photo.c"
			}
#line 1911 "../src/Photo.vala"
			if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 15802 "Photo.c"
				goto __catch0_g_error;
			}
		}
	}
	goto __finally0;
	__catch0_g_error:
	{
		GError* err = NULL;
		GError* _tmp29_;
#line 1910 "../src/Photo.vala"
		err = _inner_error0_;
#line 1910 "../src/Photo.vala"
		_inner_error0_ = NULL;
#line 1927 "../src/Photo.vala"
		_tmp29_ = err;
#line 1927 "../src/Photo.vala"
		app_window_database_error (_tmp29_);
#line 1910 "../src/Photo.vala"
		_g_error_free0 (err);
#line 15822 "Photo.c"
	}
	__finally0:
#line 1910 "../src/Photo.vala"
	if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 1910 "../src/Photo.vala"
		_g_object_unref0 (old_file);
#line 1910 "../src/Photo.vala"
		_g_free0 (filepath);
#line 1910 "../src/Photo.vala"
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 1910 "../src/Photo.vala"
		g_clear_error (&_inner_error0_);
#line 1910 "../src/Photo.vala"
		return;
#line 15837 "Photo.c"
	}
#line 1930 "../src/Photo.vala"
	if (altered) {
#line 15841 "Photo.c"
		GFile* _tmp30_;
		gchar** alteration_list = NULL;
		gchar** _tmp31_;
		gint alteration_list_length1;
		gint _alteration_list_size_;
		gchar* _tmp32_;
		gchar** _tmp35_;
		gint _tmp35__length1;
		Alteration* _tmp36_;
		Alteration* _tmp37_;
#line 1931 "../src/Photo.vala"
		_tmp30_ = old_file;
#line 1931 "../src/Photo.vala"
		photo_notify_editable_replaced (self, _tmp30_, file);
#line 1933 "../src/Photo.vala"
		if (is_baseline) {
#line 1934 "../src/Photo.vala"
			photo_notify_baseline_replaced (self);
#line 15860 "Photo.c"
		}
#line 1936 "../src/Photo.vala"
		_tmp31_ = g_new0 (gchar*, 0 + 1);
#line 1936 "../src/Photo.vala"
		alteration_list = _tmp31_;
#line 1936 "../src/Photo.vala"
		alteration_list_length1 = 0;
#line 1936 "../src/Photo.vala"
		_alteration_list_size_ = alteration_list_length1;
#line 1937 "../src/Photo.vala"
		_tmp32_ = g_strdup ("backing:editable");
#line 1937 "../src/Photo.vala"
		_vala_array_add99 (&alteration_list, &alteration_list_length1, &_alteration_list_size_, _tmp32_);
#line 1939 "../src/Photo.vala"
		if (is_baseline) {
#line 15876 "Photo.c"
			gchar* _tmp33_;
#line 1940 "../src/Photo.vala"
			_tmp33_ = g_strdup ("backing:baseline");
#line 1940 "../src/Photo.vala"
			_vala_array_add100 (&alteration_list, &alteration_list_length1, &_alteration_list_size_, _tmp33_);
#line 15882 "Photo.c"
		}
#line 1942 "../src/Photo.vala"
		if (is_source) {
#line 15886 "Photo.c"
			gchar* _tmp34_;
#line 1943 "../src/Photo.vala"
			_tmp34_ = g_strdup ("backing:source");
#line 1943 "../src/Photo.vala"
			_vala_array_add101 (&alteration_list, &alteration_list_length1, &_alteration_list_size_, _tmp34_);
#line 15892 "Photo.c"
		}
#line 1945 "../src/Photo.vala"
		_tmp35_ = alteration_list;
#line 1945 "../src/Photo.vala"
		_tmp35__length1 = alteration_list_length1;
#line 1945 "../src/Photo.vala"
		_tmp36_ = alteration_new_from_array (_tmp35_, _tmp35__length1);
#line 1945 "../src/Photo.vala"
		_tmp37_ = _tmp36_;
#line 1945 "../src/Photo.vala"
		data_object_notify_altered (G_TYPE_CHECK_INSTANCE_CAST (self, TYPE_DATA_OBJECT, DataObject), _tmp37_);
#line 1945 "../src/Photo.vala"
		_alteration_unref0 (_tmp37_);
#line 1930 "../src/Photo.vala"
		alteration_list = (_vala_array_free (alteration_list, alteration_list_length1, (GDestroyNotify) g_free), NULL);
#line 15908 "Photo.c"
	}
#line 1903 "../src/Photo.vala"
	_g_object_unref0 (old_file);
#line 1903 "../src/Photo.vala"
	_g_free0 (filepath);
#line 15914 "Photo.c"
}

void
photo_set_many_editable_file (GeeMap* map,
                              GError** error)
{
	GeeMapIterator* map_iter = NULL;
	GeeMapIterator* _tmp0_;
	GError* _inner_error0_ = NULL;
#line 1950 "../src/Photo.vala"
	g_return_if_fail (G_TYPE_CHECK_INSTANCE_TYPE (map, GEE_TYPE_MAP));
#line 1951 "../src/Photo.vala"
	database_table_begin_transaction ();
#line 1953 "../src/Photo.vala"
	_tmp0_ = gee_map_map_iterator (map);
#line 1953 "../src/Photo.vala"
	map_iter = _tmp0_;
#line 1954 "../src/Photo.vala"
	while (TRUE) {
#line 15934 "Photo.c"
		GeeMapIterator* _tmp1_;
		GeeMapIterator* _tmp2_;
		gpointer _tmp3_;
		Photo* _tmp4_;
		GeeMapIterator* _tmp5_;
		gpointer _tmp6_;
		GFile* _tmp7_;
#line 1954 "../src/Photo.vala"
		_tmp1_ = map_iter;
#line 1954 "../src/Photo.vala"
		if (!gee_map_iterator_next (_tmp1_)) {
#line 1954 "../src/Photo.vala"
			break;
#line 15948 "Photo.c"
		}
#line 1955 "../src/Photo.vala"
		_tmp2_ = map_iter;
#line 1955 "../src/Photo.vala"
		_tmp3_ = gee_map_iterator_get_key (_tmp2_);
#line 1955 "../src/Photo.vala"
		_tmp4_ = (Photo*) _tmp3_;
#line 1955 "../src/Photo.vala"
		_tmp5_ = map_iter;
#line 1955 "../src/Photo.vala"
		_tmp6_ = gee_map_iterator_get_value (_tmp5_);
#line 1955 "../src/Photo.vala"
		_tmp7_ = (GFile*) _tmp6_;
#line 1955 "../src/Photo.vala"
		photo_set_editable_file (_tmp4_, _tmp7_);
#line 1955 "../src/Photo.vala"
		_g_object_unref0 (_tmp7_);
#line 1955 "../src/Photo.vala"
		_g_object_unref0 (_tmp4_);
#line 15968 "Photo.c"
	}
#line 1957 "../src/Photo.vala"
	database_table_commit_transaction (&_inner_error0_);
#line 1957 "../src/Photo.vala"
	if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 1957 "../src/Photo.vala"
		if (_inner_error0_->domain == DATABASE_ERROR) {
#line 1957 "../src/Photo.vala"
			g_propagate_error (error, _inner_error0_);
#line 1957 "../src/Photo.vala"
			_g_object_unref0 (map_iter);
#line 1957 "../src/Photo.vala"
			return;
#line 15982 "Photo.c"
		} else {
#line 1957 "../src/Photo.vala"
			_g_object_unref0 (map_iter);
#line 1957 "../src/Photo.vala"
			g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 1957 "../src/Photo.vala"
			g_clear_error (&_inner_error0_);
#line 1957 "../src/Photo.vala"
			return;
#line 15992 "Photo.c"
		}
	}
#line 1950 "../src/Photo.vala"
	_g_object_unref0 (map_iter);
#line 15997 "Photo.c"
}

GFile*
photo_get_actual_file (Photo* self)
{
	PhotoFileReader* _tmp0_;
	PhotoFileReader* _tmp1_;
	GFile* _tmp2_;
	GFile* _tmp3_;
	GFile* result;
#line 1962 "../src/Photo.vala"
	g_return_val_if_fail (IS_PHOTO (self), NULL);
#line 1963 "../src/Photo.vala"
	_tmp0_ = photo_get_baseline_reader (self);
#line 1963 "../src/Photo.vala"
	_tmp1_ = _tmp0_;
#line 1963 "../src/Photo.vala"
	_tmp2_ = photo_file_adapter_get_file (G_TYPE_CHECK_INSTANCE_CAST (_tmp1_, TYPE_PHOTO_FILE_ADAPTER, PhotoFileAdapter));
#line 1963 "../src/Photo.vala"
	_tmp3_ = _tmp2_;
#line 1963 "../src/Photo.vala"
	_photo_file_adapter_unref0 (_tmp1_);
#line 1963 "../src/Photo.vala"
	result = _tmp3_;
#line 1963 "../src/Photo.vala"
	return result;
#line 16024 "Photo.c"
}

static GFile*
photo_real_get_master_file (MediaSource* base)
{
	Photo * self;
	PhotoFileReader* _tmp0_;
	PhotoFileReader* _tmp1_;
	GFile* _tmp2_;
	GFile* _tmp3_;
	GFile* result;
#line 1966 "../src/Photo.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (base, TYPE_PHOTO, Photo);
#line 1967 "../src/Photo.vala"
	_tmp0_ = photo_get_master_reader (self);
#line 1967 "../src/Photo.vala"
	_tmp1_ = _tmp0_;
#line 1967 "../src/Photo.vala"
	_tmp2_ = photo_file_adapter_get_file (G_TYPE_CHECK_INSTANCE_CAST (_tmp1_, TYPE_PHOTO_FILE_ADAPTER, PhotoFileAdapter));
#line 1967 "../src/Photo.vala"
	_tmp3_ = _tmp2_;
#line 1967 "../src/Photo.vala"
	_photo_file_adapter_unref0 (_tmp1_);
#line 1967 "../src/Photo.vala"
	result = _tmp3_;
#line 1967 "../src/Photo.vala"
	return result;
#line 16052 "Photo.c"
}

GFile*
photo_get_editable_file (Photo* self)
{
	PhotoFileReader* reader = NULL;
	PhotoFileReader* _tmp0_;
	GFile* _tmp1_ = NULL;
	PhotoFileReader* _tmp2_;
	GFile* result;
#line 1970 "../src/Photo.vala"
	g_return_val_if_fail (IS_PHOTO (self), NULL);
#line 1971 "../src/Photo.vala"
	_tmp0_ = photo_get_editable_reader (self);
#line 1971 "../src/Photo.vala"
	reader = _tmp0_;
#line 1973 "../src/Photo.vala"
	_tmp2_ = reader;
#line 1973 "../src/Photo.vala"
	if (_tmp2_ != NULL) {
#line 16073 "Photo.c"
		PhotoFileReader* _tmp3_;
		GFile* _tmp4_;
#line 1973 "../src/Photo.vala"
		_tmp3_ = reader;
#line 1973 "../src/Photo.vala"
		_tmp4_ = photo_file_adapter_get_file (G_TYPE_CHECK_INSTANCE_CAST (_tmp3_, TYPE_PHOTO_FILE_ADAPTER, PhotoFileAdapter));
#line 1973 "../src/Photo.vala"
		_g_object_unref0 (_tmp1_);
#line 1973 "../src/Photo.vala"
		_tmp1_ = _tmp4_;
#line 16084 "Photo.c"
	} else {
#line 1973 "../src/Photo.vala"
		_g_object_unref0 (_tmp1_);
#line 1973 "../src/Photo.vala"
		_tmp1_ = NULL;
#line 16090 "Photo.c"
	}
#line 1973 "../src/Photo.vala"
	result = _tmp1_;
#line 1973 "../src/Photo.vala"
	_photo_file_adapter_unref0 (reader);
#line 1973 "../src/Photo.vala"
	return result;
#line 16098 "Photo.c"
}

GeeCollection*
photo_get_raw_developer_files (Photo* self)
{
	GeeArrayList* ret = NULL;
	GeeArrayList* _tmp0_;
	GError* _inner_error0_ = NULL;
	GeeCollection* result;
#line 1976 "../src/Photo.vala"
	g_return_val_if_fail (IS_PHOTO (self), NULL);
#line 1977 "../src/Photo.vala"
	if (photo_get_master_file_format (self) != PHOTO_FILE_FORMAT_RAW) {
#line 1978 "../src/Photo.vala"
		result = NULL;
#line 1978 "../src/Photo.vala"
		return result;
#line 16116 "Photo.c"
	}
#line 1980 "../src/Photo.vala"
	_tmp0_ = gee_array_list_new (g_file_get_type (), (GBoxedCopyFunc) g_object_ref, (GDestroyNotify) g_object_unref, NULL, NULL, NULL);
#line 1980 "../src/Photo.vala"
	ret = _tmp0_;
#line 16122 "Photo.c"
	{
		PhotoRow* _tmp1_;
#line 1981 "../src/Photo.vala"
		_tmp1_ = self->row;
#line 1981 "../src/Photo.vala"
		g_rec_mutex_lock (&self->priv->__lock_row);
#line 16129 "Photo.c"
		{
			{
				GeeIterator* _row_it = NULL;
				GeeHashMap* _tmp2_;
				GeeCollection* _tmp3_;
				GeeCollection* _tmp4_;
				GeeCollection* _tmp5_;
				GeeIterator* _tmp6_;
				GeeIterator* _tmp7_;
#line 1982 "../src/Photo.vala"
				_tmp2_ = self->priv->developments;
#line 1982 "../src/Photo.vala"
				_tmp3_ = gee_abstract_map_get_values (G_TYPE_CHECK_INSTANCE_CAST (_tmp2_, GEE_TYPE_ABSTRACT_MAP, GeeAbstractMap));
#line 1982 "../src/Photo.vala"
				_tmp4_ = _tmp3_;
#line 1982 "../src/Photo.vala"
				_tmp5_ = _tmp4_;
#line 1982 "../src/Photo.vala"
				_tmp6_ = gee_iterable_iterator (G_TYPE_CHECK_INSTANCE_CAST (_tmp5_, GEE_TYPE_ITERABLE, GeeIterable));
#line 1982 "../src/Photo.vala"
				_tmp7_ = _tmp6_;
#line 1982 "../src/Photo.vala"
				_g_object_unref0 (_tmp5_);
#line 1982 "../src/Photo.vala"
				_row_it = _tmp7_;
#line 1982 "../src/Photo.vala"
				while (TRUE) {
#line 16157 "Photo.c"
					GeeIterator* _tmp8_;
					BackingPhotoRow* row = NULL;
					GeeIterator* _tmp9_;
					gpointer _tmp10_;
					GeeArrayList* _tmp11_;
					BackingPhotoRow* _tmp12_;
					const gchar* _tmp13_;
					GFile* _tmp14_;
					GFile* _tmp15_;
#line 1982 "../src/Photo.vala"
					_tmp8_ = _row_it;
#line 1982 "../src/Photo.vala"
					if (!gee_iterator_next (_tmp8_)) {
#line 1982 "../src/Photo.vala"
						break;
#line 16173 "Photo.c"
					}
#line 1982 "../src/Photo.vala"
					_tmp9_ = _row_it;
#line 1982 "../src/Photo.vala"
					_tmp10_ = gee_iterator_get (_tmp9_);
#line 1982 "../src/Photo.vala"
					row = (BackingPhotoRow*) _tmp10_;
#line 1983 "../src/Photo.vala"
					_tmp11_ = ret;
#line 1983 "../src/Photo.vala"
					_tmp12_ = row;
#line 1983 "../src/Photo.vala"
					_tmp13_ = _tmp12_->filepath;
#line 1983 "../src/Photo.vala"
					_tmp14_ = g_file_new_for_path (_tmp13_);
#line 1983 "../src/Photo.vala"
					_tmp15_ = _tmp14_;
#line 1983 "../src/Photo.vala"
					gee_abstract_collection_add (G_TYPE_CHECK_INSTANCE_CAST (_tmp11_, GEE_TYPE_ABSTRACT_COLLECTION, GeeAbstractCollection), _tmp15_);
#line 1983 "../src/Photo.vala"
					_g_object_unref0 (_tmp15_);
#line 1982 "../src/Photo.vala"
					_backing_photo_row_unref0 (row);
#line 16197 "Photo.c"
				}
#line 1982 "../src/Photo.vala"
				_g_object_unref0 (_row_it);
#line 16201 "Photo.c"
			}
		}
		__finally0:
		{
			PhotoRow* _tmp16_;
#line 1981 "../src/Photo.vala"
			_tmp16_ = self->row;
#line 1981 "../src/Photo.vala"
			g_rec_mutex_unlock (&self->priv->__lock_row);
#line 16211 "Photo.c"
		}
#line 1981 "../src/Photo.vala"
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 1981 "../src/Photo.vala"
			_g_object_unref0 (ret);
#line 1981 "../src/Photo.vala"
			g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 1981 "../src/Photo.vala"
			g_clear_error (&_inner_error0_);
#line 1981 "../src/Photo.vala"
			return NULL;
#line 16223 "Photo.c"
		}
	}
#line 1986 "../src/Photo.vala"
	result = G_TYPE_CHECK_INSTANCE_CAST (ret, GEE_TYPE_COLLECTION, GeeCollection);
#line 1986 "../src/Photo.vala"
	return result;
#line 16230 "Photo.c"
}

GFile*
photo_get_source_file (Photo* self)
{
	PhotoFileReader* _tmp0_;
	PhotoFileReader* _tmp1_;
	GFile* _tmp2_;
	GFile* _tmp3_;
	GFile* result;
#line 1989 "../src/Photo.vala"
	g_return_val_if_fail (IS_PHOTO (self), NULL);
#line 1990 "../src/Photo.vala"
	_tmp0_ = photo_get_source_reader (self);
#line 1990 "../src/Photo.vala"
	_tmp1_ = _tmp0_;
#line 1990 "../src/Photo.vala"
	_tmp2_ = photo_file_adapter_get_file (G_TYPE_CHECK_INSTANCE_CAST (_tmp1_, TYPE_PHOTO_FILE_ADAPTER, PhotoFileAdapter));
#line 1990 "../src/Photo.vala"
	_tmp3_ = _tmp2_;
#line 1990 "../src/Photo.vala"
	_photo_file_adapter_unref0 (_tmp1_);
#line 1990 "../src/Photo.vala"
	result = _tmp3_;
#line 1990 "../src/Photo.vala"
	return result;
#line 16257 "Photo.c"
}

PhotoFileFormat
photo_get_file_format (Photo* self)
{
	GError* _inner_error0_ = NULL;
	PhotoFileFormat result;
#line 1993 "../src/Photo.vala"
	g_return_val_if_fail (IS_PHOTO (self), 0);
#line 16267 "Photo.c"
	{
		PhotoRow* _tmp0_;
#line 1994 "../src/Photo.vala"
		_tmp0_ = self->row;
#line 1994 "../src/Photo.vala"
		g_rec_mutex_lock (&self->priv->__lock_row);
#line 16274 "Photo.c"
		{
			BackingPhotoRow* _tmp1_;
#line 1995 "../src/Photo.vala"
			_tmp1_ = self->backing_photo_row;
#line 1995 "../src/Photo.vala"
			result = _tmp1_->file_format;
#line 16281 "Photo.c"
			{
				PhotoRow* _tmp2_;
#line 1994 "../src/Photo.vala"
				_tmp2_ = self->row;
#line 1994 "../src/Photo.vala"
				g_rec_mutex_unlock (&self->priv->__lock_row);
#line 16288 "Photo.c"
			}
#line 1995 "../src/Photo.vala"
			return result;
#line 16292 "Photo.c"
		}
		__finally0:
		{
			PhotoRow* _tmp3_;
#line 1994 "../src/Photo.vala"
			_tmp3_ = self->row;
#line 1994 "../src/Photo.vala"
			g_rec_mutex_unlock (&self->priv->__lock_row);
#line 16301 "Photo.c"
		}
#line 1994 "../src/Photo.vala"
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 1994 "../src/Photo.vala"
		g_clear_error (&_inner_error0_);
#line 1994 "../src/Photo.vala"
		return 0;
#line 16309 "Photo.c"
	}
}

PhotoFileFormat
photo_get_best_export_file_format (Photo* self)
{
	PhotoFileFormat file_format = 0;
	PhotoFileFormat result;
#line 1999 "../src/Photo.vala"
	g_return_val_if_fail (IS_PHOTO (self), 0);
#line 2000 "../src/Photo.vala"
	file_format = photo_get_file_format (self);
#line 2001 "../src/Photo.vala"
	if (!photo_file_format_can_write (file_format)) {
#line 2002 "../src/Photo.vala"
		file_format = photo_file_format_get_system_default_format ();
#line 16326 "Photo.c"
	}
#line 2004 "../src/Photo.vala"
	result = file_format;
#line 2004 "../src/Photo.vala"
	return result;
#line 16332 "Photo.c"
}

PhotoFileFormat
photo_get_master_file_format (Photo* self)
{
	GError* _inner_error0_ = NULL;
	PhotoFileFormat result;
#line 2007 "../src/Photo.vala"
	g_return_val_if_fail (IS_PHOTO (self), 0);
#line 16342 "Photo.c"
	{
		PhotoRow* _tmp0_;
#line 2008 "../src/Photo.vala"
		_tmp0_ = self->row;
#line 2008 "../src/Photo.vala"
		g_rec_mutex_lock (&self->priv->__lock_row);
#line 16349 "Photo.c"
		{
			PhotoBackingReaders* _tmp1_;
			PhotoFileReader* _tmp2_;
#line 2009 "../src/Photo.vala"
			_tmp1_ = self->priv->readers;
#line 2009 "../src/Photo.vala"
			_tmp2_ = _tmp1_->master;
#line 2009 "../src/Photo.vala"
			result = photo_file_adapter_get_file_format (G_TYPE_CHECK_INSTANCE_CAST (_tmp2_, TYPE_PHOTO_FILE_ADAPTER, PhotoFileAdapter));
#line 16359 "Photo.c"
			{
				PhotoRow* _tmp3_;
#line 2008 "../src/Photo.vala"
				_tmp3_ = self->row;
#line 2008 "../src/Photo.vala"
				g_rec_mutex_unlock (&self->priv->__lock_row);
#line 16366 "Photo.c"
			}
#line 2009 "../src/Photo.vala"
			return result;
#line 16370 "Photo.c"
		}
		__finally0:
		{
			PhotoRow* _tmp4_;
#line 2008 "../src/Photo.vala"
			_tmp4_ = self->row;
#line 2008 "../src/Photo.vala"
			g_rec_mutex_unlock (&self->priv->__lock_row);
#line 16379 "Photo.c"
		}
#line 2008 "../src/Photo.vala"
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 2008 "../src/Photo.vala"
		g_clear_error (&_inner_error0_);
#line 2008 "../src/Photo.vala"
		return 0;
#line 16387 "Photo.c"
	}
}

static GDateTime*
photo_real_get_timestamp (MediaSource* base)
{
	Photo * self;
	GError* _inner_error0_ = NULL;
	GDateTime* result;
#line 2013 "../src/Photo.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (base, TYPE_PHOTO, Photo);
#line 16399 "Photo.c"
	{
		PhotoRow* _tmp0_;
#line 2014 "../src/Photo.vala"
		_tmp0_ = self->row;
#line 2014 "../src/Photo.vala"
		g_rec_mutex_lock (&self->priv->__lock_row);
#line 16406 "Photo.c"
		{
			BackingPhotoRow* _tmp1_;
			GDateTime* _tmp2_;
			GDateTime* _tmp3_;
#line 2015 "../src/Photo.vala"
			_tmp1_ = self->backing_photo_row;
#line 2015 "../src/Photo.vala"
			_tmp2_ = _tmp1_->timestamp;
#line 2015 "../src/Photo.vala"
			_tmp3_ = _g_date_time_ref0 (_tmp2_);
#line 2015 "../src/Photo.vala"
			result = _tmp3_;
#line 16419 "Photo.c"
			{
				PhotoRow* _tmp4_;
#line 2014 "../src/Photo.vala"
				_tmp4_ = self->row;
#line 2014 "../src/Photo.vala"
				g_rec_mutex_unlock (&self->priv->__lock_row);
#line 16426 "Photo.c"
			}
#line 2015 "../src/Photo.vala"
			return result;
#line 16430 "Photo.c"
		}
		__finally0:
		{
			PhotoRow* _tmp5_;
#line 2014 "../src/Photo.vala"
			_tmp5_ = self->row;
#line 2014 "../src/Photo.vala"
			g_rec_mutex_unlock (&self->priv->__lock_row);
#line 16439 "Photo.c"
		}
#line 2014 "../src/Photo.vala"
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 2014 "../src/Photo.vala"
		g_clear_error (&_inner_error0_);
#line 2014 "../src/Photo.vala"
		return NULL;
#line 16447 "Photo.c"
	}
}

void
photo_get_photo_id (Photo* self,
                    PhotoID* result)
{
	GError* _inner_error0_ = NULL;
#line 2019 "../src/Photo.vala"
	g_return_if_fail (IS_PHOTO (self));
#line 16458 "Photo.c"
	{
		PhotoRow* _tmp0_;
#line 2020 "../src/Photo.vala"
		_tmp0_ = self->row;
#line 2020 "../src/Photo.vala"
		g_rec_mutex_lock (&self->priv->__lock_row);
#line 16465 "Photo.c"
		{
			PhotoRow* _tmp1_;
			PhotoID _tmp2_;
#line 2021 "../src/Photo.vala"
			_tmp1_ = self->row;
#line 2021 "../src/Photo.vala"
			_tmp2_ = _tmp1_->photo_id;
#line 2021 "../src/Photo.vala"
			*result = _tmp2_;
#line 16475 "Photo.c"
			{
				PhotoRow* _tmp3_;
#line 2020 "../src/Photo.vala"
				_tmp3_ = self->row;
#line 2020 "../src/Photo.vala"
				g_rec_mutex_unlock (&self->priv->__lock_row);
#line 16482 "Photo.c"
			}
#line 2021 "../src/Photo.vala"
			return;
#line 16486 "Photo.c"
		}
		__finally0:
		{
			PhotoRow* _tmp4_;
#line 2020 "../src/Photo.vala"
			_tmp4_ = self->row;
#line 2020 "../src/Photo.vala"
			g_rec_mutex_unlock (&self->priv->__lock_row);
#line 16495 "Photo.c"
		}
#line 2020 "../src/Photo.vala"
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 2020 "../src/Photo.vala"
		g_clear_error (&_inner_error0_);
#line 2020 "../src/Photo.vala"
		return;
#line 16503 "Photo.c"
	}
}

static inline void
photo_real_get_event_id (MediaSource* base,
                         EventID* result)
{
	Photo * self;
	PhotoRow* _tmp0_;
	EventID _tmp1_;
#line 2026 "../src/Photo.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (base, TYPE_PHOTO, Photo);
#line 2027 "../src/Photo.vala"
	_tmp0_ = self->row;
#line 2027 "../src/Photo.vala"
	_tmp1_ = _tmp0_->event_id;
#line 2027 "../src/Photo.vala"
	*result = _tmp1_;
#line 2027 "../src/Photo.vala"
	return;
#line 16524 "Photo.c"
}

inline gint64
photo_get_raw_event_id (Photo* self)
{
	PhotoRow* _tmp0_;
	EventID _tmp1_;
	gint64 result;
#line 2031 "../src/Photo.vala"
	g_return_val_if_fail (IS_PHOTO (self), 0LL);
#line 2032 "../src/Photo.vala"
	_tmp0_ = self->row;
#line 2032 "../src/Photo.vala"
	_tmp1_ = _tmp0_->event_id;
#line 2032 "../src/Photo.vala"
	result = _tmp1_.id;
#line 2032 "../src/Photo.vala"
	return result;
#line 16543 "Photo.c"
}

static void
photo_real_get_import_id (MediaSource* base,
                          ImportID* result)
{
	Photo * self;
	GError* _inner_error0_ = NULL;
#line 2035 "../src/Photo.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (base, TYPE_PHOTO, Photo);
#line 16554 "Photo.c"
	{
		PhotoRow* _tmp0_;
#line 2036 "../src/Photo.vala"
		_tmp0_ = self->row;
#line 2036 "../src/Photo.vala"
		g_rec_mutex_lock (&self->priv->__lock_row);
#line 16561 "Photo.c"
		{
			PhotoRow* _tmp1_;
			ImportID _tmp2_;
#line 2037 "../src/Photo.vala"
			_tmp1_ = self->row;
#line 2037 "../src/Photo.vala"
			_tmp2_ = _tmp1_->import_id;
#line 2037 "../src/Photo.vala"
			*result = _tmp2_;
#line 16571 "Photo.c"
			{
				PhotoRow* _tmp3_;
#line 2036 "../src/Photo.vala"
				_tmp3_ = self->row;
#line 2036 "../src/Photo.vala"
				g_rec_mutex_unlock (&self->priv->__lock_row);
#line 16578 "Photo.c"
			}
#line 2037 "../src/Photo.vala"
			return;
#line 16582 "Photo.c"
		}
		__finally0:
		{
			PhotoRow* _tmp4_;
#line 2036 "../src/Photo.vala"
			_tmp4_ = self->row;
#line 2036 "../src/Photo.vala"
			g_rec_mutex_unlock (&self->priv->__lock_row);
#line 16591 "Photo.c"
		}
#line 2036 "../src/Photo.vala"
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 2036 "../src/Photo.vala"
		g_clear_error (&_inner_error0_);
#line 2036 "../src/Photo.vala"
		return;
#line 16599 "Photo.c"
	}
}

void
photo_get_editable_id (Photo* self,
                       BackingPhotoID* result)
{
	GError* _inner_error0_ = NULL;
#line 2041 "../src/Photo.vala"
	g_return_if_fail (IS_PHOTO (self));
#line 16610 "Photo.c"
	{
		PhotoRow* _tmp0_;
#line 2042 "../src/Photo.vala"
		_tmp0_ = self->row;
#line 2042 "../src/Photo.vala"
		g_rec_mutex_lock (&self->priv->__lock_row);
#line 16617 "Photo.c"
		{
			PhotoRow* _tmp1_;
			BackingPhotoID _tmp2_;
#line 2043 "../src/Photo.vala"
			_tmp1_ = self->row;
#line 2043 "../src/Photo.vala"
			_tmp2_ = _tmp1_->editable_id;
#line 2043 "../src/Photo.vala"
			*result = _tmp2_;
#line 16627 "Photo.c"
			{
				PhotoRow* _tmp3_;
#line 2042 "../src/Photo.vala"
				_tmp3_ = self->row;
#line 2042 "../src/Photo.vala"
				g_rec_mutex_unlock (&self->priv->__lock_row);
#line 16634 "Photo.c"
			}
#line 2043 "../src/Photo.vala"
			return;
#line 16638 "Photo.c"
		}
		__finally0:
		{
			PhotoRow* _tmp4_;
#line 2042 "../src/Photo.vala"
			_tmp4_ = self->row;
#line 2042 "../src/Photo.vala"
			g_rec_mutex_unlock (&self->priv->__lock_row);
#line 16647 "Photo.c"
		}
#line 2042 "../src/Photo.vala"
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 2042 "../src/Photo.vala"
		g_clear_error (&_inner_error0_);
#line 2042 "../src/Photo.vala"
		return;
#line 16655 "Photo.c"
	}
}

static gchar*
photo_real_get_master_md5 (MediaSource* base)
{
	Photo * self;
	GError* _inner_error0_ = NULL;
	gchar* result;
#line 2047 "../src/Photo.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (base, TYPE_PHOTO, Photo);
#line 16667 "Photo.c"
	{
		PhotoRow* _tmp0_;
#line 2048 "../src/Photo.vala"
		_tmp0_ = self->row;
#line 2048 "../src/Photo.vala"
		g_rec_mutex_lock (&self->priv->__lock_row);
#line 16674 "Photo.c"
		{
			PhotoRow* _tmp1_;
			const gchar* _tmp2_;
			gchar* _tmp3_;
#line 2049 "../src/Photo.vala"
			_tmp1_ = self->row;
#line 2049 "../src/Photo.vala"
			_tmp2_ = _tmp1_->md5;
#line 2049 "../src/Photo.vala"
			_tmp3_ = g_strdup (_tmp2_);
#line 2049 "../src/Photo.vala"
			result = _tmp3_;
#line 16687 "Photo.c"
			{
				PhotoRow* _tmp4_;
#line 2048 "../src/Photo.vala"
				_tmp4_ = self->row;
#line 2048 "../src/Photo.vala"
				g_rec_mutex_unlock (&self->priv->__lock_row);
#line 16694 "Photo.c"
			}
#line 2049 "../src/Photo.vala"
			return result;
#line 16698 "Photo.c"
		}
		__finally0:
		{
			PhotoRow* _tmp5_;
#line 2048 "../src/Photo.vala"
			_tmp5_ = self->row;
#line 2048 "../src/Photo.vala"
			g_rec_mutex_unlock (&self->priv->__lock_row);
#line 16707 "Photo.c"
		}
#line 2048 "../src/Photo.vala"
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 2048 "../src/Photo.vala"
		g_clear_error (&_inner_error0_);
#line 2048 "../src/Photo.vala"
		return NULL;
#line 16715 "Photo.c"
	}
}

guint64
photo_get_flags (Photo* self)
{
	GError* _inner_error0_ = NULL;
	guint64 result;
#line 2055 "../src/Photo.vala"
	g_return_val_if_fail (IS_PHOTO (self), 0ULL);
#line 16726 "Photo.c"
	{
		PhotoRow* _tmp0_;
		guint64 _tmp4_ = 0ULL;
#line 2056 "../src/Photo.vala"
		_tmp0_ = self->row;
#line 2056 "../src/Photo.vala"
		g_rec_mutex_lock (&self->priv->__lock_row);
#line 16734 "Photo.c"
		{
			PhotoRow* _tmp1_;
#line 2057 "../src/Photo.vala"
			_tmp1_ = self->row;
#line 2057 "../src/Photo.vala"
			result = _tmp1_->flags;
#line 16741 "Photo.c"
			{
				PhotoRow* _tmp2_;
#line 2056 "../src/Photo.vala"
				_tmp2_ = self->row;
#line 2056 "../src/Photo.vala"
				g_rec_mutex_unlock (&self->priv->__lock_row);
#line 16748 "Photo.c"
			}
#line 2057 "../src/Photo.vala"
			return result;
#line 16752 "Photo.c"
		}
		__finally0:
		{
			PhotoRow* _tmp3_;
#line 2056 "../src/Photo.vala"
			_tmp3_ = self->row;
#line 2056 "../src/Photo.vala"
			g_rec_mutex_unlock (&self->priv->__lock_row);
#line 16761 "Photo.c"
		}
#line 2056 "../src/Photo.vala"
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 2056 "../src/Photo.vala"
		g_clear_error (&_inner_error0_);
#line 2056 "../src/Photo.vala"
		return _tmp4_;
#line 16769 "Photo.c"
	}
}

static void
photo_notify_flags_altered (Photo* self,
                            Alteration* additional_alteration)
{
	Alteration* alteration = NULL;
	Alteration* _tmp0_;
	Alteration* _tmp3_;
#line 2061 "../src/Photo.vala"
	g_return_if_fail (IS_PHOTO (self));
#line 2061 "../src/Photo.vala"
	g_return_if_fail ((additional_alteration == NULL) || IS_ALTERATION (additional_alteration));
#line 2062 "../src/Photo.vala"
	_tmp0_ = alteration_new ("metadata", "flags");
#line 2062 "../src/Photo.vala"
	alteration = _tmp0_;
#line 2063 "../src/Photo.vala"
	if (additional_alteration != NULL) {
#line 16790 "Photo.c"
		Alteration* _tmp1_;
		Alteration* _tmp2_;
#line 2064 "../src/Photo.vala"
		_tmp1_ = alteration;
#line 2064 "../src/Photo.vala"
		_tmp2_ = alteration_compress (_tmp1_, additional_alteration);
#line 2064 "../src/Photo.vala"
		_alteration_unref0 (alteration);
#line 2064 "../src/Photo.vala"
		alteration = _tmp2_;
#line 16801 "Photo.c"
	}
#line 2066 "../src/Photo.vala"
	_tmp3_ = alteration;
#line 2066 "../src/Photo.vala"
	data_object_notify_altered (G_TYPE_CHECK_INSTANCE_CAST (self, TYPE_DATA_OBJECT, DataObject), _tmp3_);
#line 2061 "../src/Photo.vala"
	_alteration_unref0 (alteration);
#line 16809 "Photo.c"
}

guint64
photo_replace_flags (Photo* self,
                     guint64 flags,
                     Alteration* additional_alteration)
{
	gboolean committed = FALSE;
	GError* _inner_error0_ = NULL;
	guint64 result;
#line 2069 "../src/Photo.vala"
	g_return_val_if_fail (IS_PHOTO (self), 0ULL);
#line 2069 "../src/Photo.vala"
	g_return_val_if_fail ((additional_alteration == NULL) || IS_ALTERATION (additional_alteration), 0ULL);
#line 16824 "Photo.c"
	{
		PhotoRow* _tmp0_;
#line 2071 "../src/Photo.vala"
		_tmp0_ = self->row;
#line 2071 "../src/Photo.vala"
		g_rec_mutex_lock (&self->priv->__lock_row);
#line 16831 "Photo.c"
		{
			PhotoTable* _tmp1_;
			PhotoTable* _tmp2_;
			PhotoID _tmp3_ = {0};
#line 2072 "../src/Photo.vala"
			_tmp1_ = photo_table_get_instance ();
#line 2072 "../src/Photo.vala"
			_tmp2_ = _tmp1_;
#line 2072 "../src/Photo.vala"
			photo_get_photo_id (self, &_tmp3_);
#line 2072 "../src/Photo.vala"
			committed = photo_table_replace_flags (_tmp2_, &_tmp3_, flags);
#line 2072 "../src/Photo.vala"
			_database_table_unref0 (_tmp2_);
#line 2073 "../src/Photo.vala"
			if (committed) {
#line 16848 "Photo.c"
				PhotoRow* _tmp4_;
#line 2074 "../src/Photo.vala"
				_tmp4_ = self->row;
#line 2074 "../src/Photo.vala"
				_tmp4_->flags = flags;
#line 16854 "Photo.c"
			}
		}
		__finally0:
		{
			PhotoRow* _tmp5_;
#line 2071 "../src/Photo.vala"
			_tmp5_ = self->row;
#line 2071 "../src/Photo.vala"
			g_rec_mutex_unlock (&self->priv->__lock_row);
#line 16864 "Photo.c"
		}
#line 2071 "../src/Photo.vala"
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 16868 "Photo.c"
			guint64 _tmp6_ = 0ULL;
#line 2071 "../src/Photo.vala"
			g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 2071 "../src/Photo.vala"
			g_clear_error (&_inner_error0_);
#line 2071 "../src/Photo.vala"
			return _tmp6_;
#line 16876 "Photo.c"
		}
	}
#line 2077 "../src/Photo.vala"
	if (committed) {
#line 2078 "../src/Photo.vala"
		photo_notify_flags_altered (self, additional_alteration);
#line 16883 "Photo.c"
	}
#line 2080 "../src/Photo.vala"
	result = flags;
#line 2080 "../src/Photo.vala"
	return result;
#line 16889 "Photo.c"
}

gboolean
photo_is_flag_set (Photo* self,
                   guint64 mask)
{
	GError* _inner_error0_ = NULL;
	gboolean result;
#line 2083 "../src/Photo.vala"
	g_return_val_if_fail (IS_PHOTO (self), FALSE);
#line 16900 "Photo.c"
	{
		PhotoRow* _tmp0_;
		gboolean _tmp4_ = FALSE;
#line 2084 "../src/Photo.vala"
		_tmp0_ = self->row;
#line 2084 "../src/Photo.vala"
		g_rec_mutex_lock (&self->priv->__lock_row);
#line 16908 "Photo.c"
		{
			PhotoRow* _tmp1_;
#line 2085 "../src/Photo.vala"
			_tmp1_ = self->row;
#line 2085 "../src/Photo.vala"
			result = media_source_internal_is_flag_set (_tmp1_->flags, mask);
#line 16915 "Photo.c"
			{
				PhotoRow* _tmp2_;
#line 2084 "../src/Photo.vala"
				_tmp2_ = self->row;
#line 2084 "../src/Photo.vala"
				g_rec_mutex_unlock (&self->priv->__lock_row);
#line 16922 "Photo.c"
			}
#line 2085 "../src/Photo.vala"
			return result;
#line 16926 "Photo.c"
		}
		__finally0:
		{
			PhotoRow* _tmp3_;
#line 2084 "../src/Photo.vala"
			_tmp3_ = self->row;
#line 2084 "../src/Photo.vala"
			g_rec_mutex_unlock (&self->priv->__lock_row);
#line 16935 "Photo.c"
		}
#line 2084 "../src/Photo.vala"
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 2084 "../src/Photo.vala"
		g_clear_error (&_inner_error0_);
#line 2084 "../src/Photo.vala"
		return _tmp4_;
#line 16943 "Photo.c"
	}
}

guint64
photo_add_flags (Photo* self,
                 guint64 mask,
                 Alteration* additional_alteration)
{
	guint64 flags = 0ULL;
	gboolean committed = FALSE;
	GError* _inner_error0_ = NULL;
	guint64 result;
#line 2089 "../src/Photo.vala"
	g_return_val_if_fail (IS_PHOTO (self), 0ULL);
#line 2089 "../src/Photo.vala"
	g_return_val_if_fail ((additional_alteration == NULL) || IS_ALTERATION (additional_alteration), 0ULL);
#line 2090 "../src/Photo.vala"
	flags = (guint64) 0;
#line 2092 "../src/Photo.vala"
	committed = FALSE;
#line 16964 "Photo.c"
	{
		PhotoRow* _tmp0_;
#line 2093 "../src/Photo.vala"
		_tmp0_ = self->row;
#line 2093 "../src/Photo.vala"
		g_rec_mutex_lock (&self->priv->__lock_row);
#line 16971 "Photo.c"
		{
			PhotoRow* _tmp1_;
			PhotoRow* _tmp2_;
#line 2094 "../src/Photo.vala"
			_tmp1_ = self->row;
#line 2094 "../src/Photo.vala"
			flags = media_source_internal_add_flags (_tmp1_->flags, mask);
#line 2095 "../src/Photo.vala"
			_tmp2_ = self->row;
#line 2095 "../src/Photo.vala"
			if (_tmp2_->flags != flags) {
#line 16983 "Photo.c"
				PhotoTable* _tmp3_;
				PhotoTable* _tmp4_;
				PhotoID _tmp5_ = {0};
#line 2096 "../src/Photo.vala"
				_tmp3_ = photo_table_get_instance ();
#line 2096 "../src/Photo.vala"
				_tmp4_ = _tmp3_;
#line 2096 "../src/Photo.vala"
				photo_get_photo_id (self, &_tmp5_);
#line 2096 "../src/Photo.vala"
				committed = photo_table_replace_flags (_tmp4_, &_tmp5_, flags);
#line 2096 "../src/Photo.vala"
				_database_table_unref0 (_tmp4_);
#line 2097 "../src/Photo.vala"
				if (committed) {
#line 16999 "Photo.c"
					PhotoRow* _tmp6_;
#line 2098 "../src/Photo.vala"
					_tmp6_ = self->row;
#line 2098 "../src/Photo.vala"
					_tmp6_->flags = flags;
#line 17005 "Photo.c"
				}
			}
		}
		__finally0:
		{
			PhotoRow* _tmp7_;
#line 2093 "../src/Photo.vala"
			_tmp7_ = self->row;
#line 2093 "../src/Photo.vala"
			g_rec_mutex_unlock (&self->priv->__lock_row);
#line 17016 "Photo.c"
		}
#line 2093 "../src/Photo.vala"
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 17020 "Photo.c"
			guint64 _tmp8_ = 0ULL;
#line 2093 "../src/Photo.vala"
			g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 2093 "../src/Photo.vala"
			g_clear_error (&_inner_error0_);
#line 2093 "../src/Photo.vala"
			return _tmp8_;
#line 17028 "Photo.c"
		}
	}
#line 2102 "../src/Photo.vala"
	if (committed) {
#line 2103 "../src/Photo.vala"
		photo_notify_flags_altered (self, additional_alteration);
#line 17035 "Photo.c"
	}
#line 2105 "../src/Photo.vala"
	result = flags;
#line 2105 "../src/Photo.vala"
	return result;
#line 17041 "Photo.c"
}

guint64
photo_remove_flags (Photo* self,
                    guint64 mask,
                    Alteration* additional_alteration)
{
	guint64 flags = 0ULL;
	gboolean committed = FALSE;
	GError* _inner_error0_ = NULL;
	guint64 result;
#line 2108 "../src/Photo.vala"
	g_return_val_if_fail (IS_PHOTO (self), 0ULL);
#line 2108 "../src/Photo.vala"
	g_return_val_if_fail ((additional_alteration == NULL) || IS_ALTERATION (additional_alteration), 0ULL);
#line 2109 "../src/Photo.vala"
	flags = (guint64) 0;
#line 2111 "../src/Photo.vala"
	committed = FALSE;
#line 17061 "Photo.c"
	{
		PhotoRow* _tmp0_;
#line 2112 "../src/Photo.vala"
		_tmp0_ = self->row;
#line 2112 "../src/Photo.vala"
		g_rec_mutex_lock (&self->priv->__lock_row);
#line 17068 "Photo.c"
		{
			PhotoRow* _tmp1_;
			PhotoRow* _tmp2_;
#line 2113 "../src/Photo.vala"
			_tmp1_ = self->row;
#line 2113 "../src/Photo.vala"
			flags = media_source_internal_remove_flags (_tmp1_->flags, mask);
#line 2114 "../src/Photo.vala"
			_tmp2_ = self->row;
#line 2114 "../src/Photo.vala"
			if (_tmp2_->flags != flags) {
#line 17080 "Photo.c"
				PhotoTable* _tmp3_;
				PhotoTable* _tmp4_;
				PhotoID _tmp5_ = {0};
#line 2115 "../src/Photo.vala"
				_tmp3_ = photo_table_get_instance ();
#line 2115 "../src/Photo.vala"
				_tmp4_ = _tmp3_;
#line 2115 "../src/Photo.vala"
				photo_get_photo_id (self, &_tmp5_);
#line 2115 "../src/Photo.vala"
				committed = photo_table_replace_flags (_tmp4_, &_tmp5_, flags);
#line 2115 "../src/Photo.vala"
				_database_table_unref0 (_tmp4_);
#line 2116 "../src/Photo.vala"
				if (committed) {
#line 17096 "Photo.c"
					PhotoRow* _tmp6_;
#line 2117 "../src/Photo.vala"
					_tmp6_ = self->row;
#line 2117 "../src/Photo.vala"
					_tmp6_->flags = flags;
#line 17102 "Photo.c"
				}
			}
		}
		__finally0:
		{
			PhotoRow* _tmp7_;
#line 2112 "../src/Photo.vala"
			_tmp7_ = self->row;
#line 2112 "../src/Photo.vala"
			g_rec_mutex_unlock (&self->priv->__lock_row);
#line 17113 "Photo.c"
		}
#line 2112 "../src/Photo.vala"
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 17117 "Photo.c"
			guint64 _tmp8_ = 0ULL;
#line 2112 "../src/Photo.vala"
			g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 2112 "../src/Photo.vala"
			g_clear_error (&_inner_error0_);
#line 2112 "../src/Photo.vala"
			return _tmp8_;
#line 17125 "Photo.c"
		}
	}
#line 2121 "../src/Photo.vala"
	if (committed) {
#line 2122 "../src/Photo.vala"
		photo_notify_flags_altered (self, additional_alteration);
#line 17132 "Photo.c"
	}
#line 2124 "../src/Photo.vala"
	result = flags;
#line 2124 "../src/Photo.vala"
	return result;
#line 17138 "Photo.c"
}

guint64
photo_add_remove_flags (Photo* self,
                        guint64 add,
                        guint64 remove,
                        Alteration* additional_alteration)
{
	guint64 flags = 0ULL;
	gboolean committed = FALSE;
	GError* _inner_error0_ = NULL;
	guint64 result;
#line 2127 "../src/Photo.vala"
	g_return_val_if_fail (IS_PHOTO (self), 0ULL);
#line 2127 "../src/Photo.vala"
	g_return_val_if_fail ((additional_alteration == NULL) || IS_ALTERATION (additional_alteration), 0ULL);
#line 2128 "../src/Photo.vala"
	flags = (guint64) 0;
#line 2130 "../src/Photo.vala"
	committed = FALSE;
#line 17159 "Photo.c"
	{
		PhotoRow* _tmp0_;
#line 2131 "../src/Photo.vala"
		_tmp0_ = self->row;
#line 2131 "../src/Photo.vala"
		g_rec_mutex_lock (&self->priv->__lock_row);
#line 17166 "Photo.c"
		{
			PhotoRow* _tmp1_;
			PhotoRow* _tmp2_;
#line 2132 "../src/Photo.vala"
			_tmp1_ = self->row;
#line 2132 "../src/Photo.vala"
			flags = (_tmp1_->flags | add) & (~remove);
#line 2133 "../src/Photo.vala"
			_tmp2_ = self->row;
#line 2133 "../src/Photo.vala"
			if (_tmp2_->flags != flags) {
#line 17178 "Photo.c"
				PhotoTable* _tmp3_;
				PhotoTable* _tmp4_;
				PhotoID _tmp5_ = {0};
#line 2134 "../src/Photo.vala"
				_tmp3_ = photo_table_get_instance ();
#line 2134 "../src/Photo.vala"
				_tmp4_ = _tmp3_;
#line 2134 "../src/Photo.vala"
				photo_get_photo_id (self, &_tmp5_);
#line 2134 "../src/Photo.vala"
				committed = photo_table_replace_flags (_tmp4_, &_tmp5_, flags);
#line 2134 "../src/Photo.vala"
				_database_table_unref0 (_tmp4_);
#line 2135 "../src/Photo.vala"
				if (committed) {
#line 17194 "Photo.c"
					PhotoRow* _tmp6_;
#line 2136 "../src/Photo.vala"
					_tmp6_ = self->row;
#line 2136 "../src/Photo.vala"
					_tmp6_->flags = flags;
#line 17200 "Photo.c"
				}
			}
		}
		__finally0:
		{
			PhotoRow* _tmp7_;
#line 2131 "../src/Photo.vala"
			_tmp7_ = self->row;
#line 2131 "../src/Photo.vala"
			g_rec_mutex_unlock (&self->priv->__lock_row);
#line 17211 "Photo.c"
		}
#line 2131 "../src/Photo.vala"
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 17215 "Photo.c"
			guint64 _tmp8_ = 0ULL;
#line 2131 "../src/Photo.vala"
			g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 2131 "../src/Photo.vala"
			g_clear_error (&_inner_error0_);
#line 2131 "../src/Photo.vala"
			return _tmp8_;
#line 17223 "Photo.c"
		}
	}
#line 2140 "../src/Photo.vala"
	if (committed) {
#line 2141 "../src/Photo.vala"
		photo_notify_flags_altered (self, additional_alteration);
#line 17230 "Photo.c"
	}
#line 2143 "../src/Photo.vala"
	result = flags;
#line 2143 "../src/Photo.vala"
	return result;
#line 17236 "Photo.c"
}

void
photo_add_remove_many_flags (GeeCollection* add,
                             guint64 add_mask,
                             Alteration* additional_add_alteration,
                             GeeCollection* remove,
                             guint64 remove_mask,
                             Alteration* additional_remove_alteration,
                             GError** error)
{
	GError* _inner_error0_ = NULL;
#line 2146 "../src/Photo.vala"
	g_return_if_fail ((add == NULL) || G_TYPE_CHECK_INSTANCE_TYPE (add, GEE_TYPE_COLLECTION));
#line 2146 "../src/Photo.vala"
	g_return_if_fail ((additional_add_alteration == NULL) || IS_ALTERATION (additional_add_alteration));
#line 2146 "../src/Photo.vala"
	g_return_if_fail ((remove == NULL) || G_TYPE_CHECK_INSTANCE_TYPE (remove, GEE_TYPE_COLLECTION));
#line 2146 "../src/Photo.vala"
	g_return_if_fail ((additional_remove_alteration == NULL) || IS_ALTERATION (additional_remove_alteration));
#line 2149 "../src/Photo.vala"
	database_table_begin_transaction ();
#line 2151 "../src/Photo.vala"
	if (add != NULL) {
#line 17261 "Photo.c"
		{
			GeeIterator* _photo_it = NULL;
			GeeIterator* _tmp0_;
#line 2152 "../src/Photo.vala"
			_tmp0_ = gee_iterable_iterator (G_TYPE_CHECK_INSTANCE_CAST (add, GEE_TYPE_ITERABLE, GeeIterable));
#line 2152 "../src/Photo.vala"
			_photo_it = _tmp0_;
#line 2152 "../src/Photo.vala"
			while (TRUE) {
#line 17271 "Photo.c"
				GeeIterator* _tmp1_;
				Photo* photo = NULL;
				GeeIterator* _tmp2_;
				gpointer _tmp3_;
				Photo* _tmp4_;
#line 2152 "../src/Photo.vala"
				_tmp1_ = _photo_it;
#line 2152 "../src/Photo.vala"
				if (!gee_iterator_next (_tmp1_)) {
#line 2152 "../src/Photo.vala"
					break;
#line 17283 "Photo.c"
				}
#line 2152 "../src/Photo.vala"
				_tmp2_ = _photo_it;
#line 2152 "../src/Photo.vala"
				_tmp3_ = gee_iterator_get (_tmp2_);
#line 2152 "../src/Photo.vala"
				photo = (Photo*) _tmp3_;
#line 2153 "../src/Photo.vala"
				_tmp4_ = photo;
#line 2153 "../src/Photo.vala"
				photo_add_flags (_tmp4_, add_mask, additional_add_alteration);
#line 2152 "../src/Photo.vala"
				_g_object_unref0 (photo);
#line 17297 "Photo.c"
			}
#line 2152 "../src/Photo.vala"
			_g_object_unref0 (_photo_it);
#line 17301 "Photo.c"
		}
	}
#line 2156 "../src/Photo.vala"
	if (remove != NULL) {
#line 17306 "Photo.c"
		{
			GeeIterator* _photo_it = NULL;
			GeeIterator* _tmp5_;
#line 2157 "../src/Photo.vala"
			_tmp5_ = gee_iterable_iterator (G_TYPE_CHECK_INSTANCE_CAST (remove, GEE_TYPE_ITERABLE, GeeIterable));
#line 2157 "../src/Photo.vala"
			_photo_it = _tmp5_;
#line 2157 "../src/Photo.vala"
			while (TRUE) {
#line 17316 "Photo.c"
				GeeIterator* _tmp6_;
				Photo* photo = NULL;
				GeeIterator* _tmp7_;
				gpointer _tmp8_;
				Photo* _tmp9_;
#line 2157 "../src/Photo.vala"
				_tmp6_ = _photo_it;
#line 2157 "../src/Photo.vala"
				if (!gee_iterator_next (_tmp6_)) {
#line 2157 "../src/Photo.vala"
					break;
#line 17328 "Photo.c"
				}
#line 2157 "../src/Photo.vala"
				_tmp7_ = _photo_it;
#line 2157 "../src/Photo.vala"
				_tmp8_ = gee_iterator_get (_tmp7_);
#line 2157 "../src/Photo.vala"
				photo = (Photo*) _tmp8_;
#line 2158 "../src/Photo.vala"
				_tmp9_ = photo;
#line 2158 "../src/Photo.vala"
				photo_remove_flags (_tmp9_, remove_mask, additional_remove_alteration);
#line 2157 "../src/Photo.vala"
				_g_object_unref0 (photo);
#line 17342 "Photo.c"
			}
#line 2157 "../src/Photo.vala"
			_g_object_unref0 (_photo_it);
#line 17346 "Photo.c"
		}
	}
#line 2161 "../src/Photo.vala"
	database_table_commit_transaction (&_inner_error0_);
#line 2161 "../src/Photo.vala"
	if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 2161 "../src/Photo.vala"
		if (_inner_error0_->domain == DATABASE_ERROR) {
#line 2161 "../src/Photo.vala"
			g_propagate_error (error, _inner_error0_);
#line 2161 "../src/Photo.vala"
			return;
#line 17359 "Photo.c"
		} else {
#line 2161 "../src/Photo.vala"
			g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 2161 "../src/Photo.vala"
			g_clear_error (&_inner_error0_);
#line 2161 "../src/Photo.vala"
			return;
#line 17367 "Photo.c"
		}
	}
}

guint64
photo_toggle_flags (Photo* self,
                    guint64 mask,
                    Alteration* additional_alteration)
{
	guint64 flags = 0ULL;
	gboolean committed = FALSE;
	GError* _inner_error0_ = NULL;
	guint64 result;
#line 2164 "../src/Photo.vala"
	g_return_val_if_fail (IS_PHOTO (self), 0ULL);
#line 2164 "../src/Photo.vala"
	g_return_val_if_fail ((additional_alteration == NULL) || IS_ALTERATION (additional_alteration), 0ULL);
#line 2165 "../src/Photo.vala"
	flags = (guint64) 0;
#line 2167 "../src/Photo.vala"
	committed = FALSE;
#line 17389 "Photo.c"
	{
		PhotoRow* _tmp0_;
#line 2168 "../src/Photo.vala"
		_tmp0_ = self->row;
#line 2168 "../src/Photo.vala"
		g_rec_mutex_lock (&self->priv->__lock_row);
#line 17396 "Photo.c"
		{
			PhotoRow* _tmp1_;
			PhotoRow* _tmp2_;
#line 2169 "../src/Photo.vala"
			_tmp1_ = self->row;
#line 2169 "../src/Photo.vala"
			flags = _tmp1_->flags ^ mask;
#line 2170 "../src/Photo.vala"
			_tmp2_ = self->row;
#line 2170 "../src/Photo.vala"
			if (_tmp2_->flags != flags) {
#line 17408 "Photo.c"
				PhotoTable* _tmp3_;
				PhotoTable* _tmp4_;
				PhotoID _tmp5_ = {0};
#line 2171 "../src/Photo.vala"
				_tmp3_ = photo_table_get_instance ();
#line 2171 "../src/Photo.vala"
				_tmp4_ = _tmp3_;
#line 2171 "../src/Photo.vala"
				photo_get_photo_id (self, &_tmp5_);
#line 2171 "../src/Photo.vala"
				committed = photo_table_replace_flags (_tmp4_, &_tmp5_, flags);
#line 2171 "../src/Photo.vala"
				_database_table_unref0 (_tmp4_);
#line 2172 "../src/Photo.vala"
				if (committed) {
#line 17424 "Photo.c"
					PhotoRow* _tmp6_;
#line 2173 "../src/Photo.vala"
					_tmp6_ = self->row;
#line 2173 "../src/Photo.vala"
					_tmp6_->flags = flags;
#line 17430 "Photo.c"
				}
			}
		}
		__finally0:
		{
			PhotoRow* _tmp7_;
#line 2168 "../src/Photo.vala"
			_tmp7_ = self->row;
#line 2168 "../src/Photo.vala"
			g_rec_mutex_unlock (&self->priv->__lock_row);
#line 17441 "Photo.c"
		}
#line 2168 "../src/Photo.vala"
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 17445 "Photo.c"
			guint64 _tmp8_ = 0ULL;
#line 2168 "../src/Photo.vala"
			g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 2168 "../src/Photo.vala"
			g_clear_error (&_inner_error0_);
#line 2168 "../src/Photo.vala"
			return _tmp8_;
#line 17453 "Photo.c"
		}
	}
#line 2177 "../src/Photo.vala"
	if (committed) {
#line 2178 "../src/Photo.vala"
		photo_notify_flags_altered (self, additional_alteration);
#line 17460 "Photo.c"
	}
#line 2180 "../src/Photo.vala"
	result = flags;
#line 2180 "../src/Photo.vala"
	return result;
#line 17466 "Photo.c"
}

gboolean
photo_is_master_metadata_dirty (Photo* self)
{
	GError* _inner_error0_ = NULL;
	gboolean result;
#line 2183 "../src/Photo.vala"
	g_return_val_if_fail (IS_PHOTO (self), FALSE);
#line 17476 "Photo.c"
	{
		PhotoRow* _tmp0_;
		gboolean _tmp4_ = FALSE;
#line 2184 "../src/Photo.vala"
		_tmp0_ = self->row;
#line 2184 "../src/Photo.vala"
		g_rec_mutex_lock (&self->priv->__lock_row);
#line 17484 "Photo.c"
		{
			PhotoRow* _tmp1_;
#line 2185 "../src/Photo.vala"
			_tmp1_ = self->row;
#line 2185 "../src/Photo.vala"
			result = _tmp1_->metadata_dirty;
#line 17491 "Photo.c"
			{
				PhotoRow* _tmp2_;
#line 2184 "../src/Photo.vala"
				_tmp2_ = self->row;
#line 2184 "../src/Photo.vala"
				g_rec_mutex_unlock (&self->priv->__lock_row);
#line 17498 "Photo.c"
			}
#line 2185 "../src/Photo.vala"
			return result;
#line 17502 "Photo.c"
		}
		__finally0:
		{
			PhotoRow* _tmp3_;
#line 2184 "../src/Photo.vala"
			_tmp3_ = self->row;
#line 2184 "../src/Photo.vala"
			g_rec_mutex_unlock (&self->priv->__lock_row);
#line 17511 "Photo.c"
		}
#line 2184 "../src/Photo.vala"
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 2184 "../src/Photo.vala"
		g_clear_error (&_inner_error0_);
#line 2184 "../src/Photo.vala"
		return _tmp4_;
#line 17519 "Photo.c"
	}
}

void
photo_set_master_metadata_dirty (Photo* self,
                                 gboolean dirty,
                                 GError** error)
{
	gboolean committed = FALSE;
	GError* _inner_error0_ = NULL;
#line 2189 "../src/Photo.vala"
	g_return_if_fail (IS_PHOTO (self));
#line 2190 "../src/Photo.vala"
	committed = FALSE;
#line 17534 "Photo.c"
	{
		PhotoRow* _tmp0_;
#line 2191 "../src/Photo.vala"
		_tmp0_ = self->row;
#line 2191 "../src/Photo.vala"
		g_rec_mutex_lock (&self->priv->__lock_row);
#line 17541 "Photo.c"
		{
			PhotoRow* _tmp1_;
#line 2192 "../src/Photo.vala"
			_tmp1_ = self->row;
#line 2192 "../src/Photo.vala"
			if (_tmp1_->metadata_dirty != dirty) {
#line 17548 "Photo.c"
				PhotoTable* _tmp2_;
				PhotoTable* _tmp3_;
				PhotoID _tmp4_ = {0};
				PhotoRow* _tmp5_;
#line 2193 "../src/Photo.vala"
				_tmp2_ = photo_table_get_instance ();
#line 2193 "../src/Photo.vala"
				_tmp3_ = _tmp2_;
#line 2193 "../src/Photo.vala"
				photo_get_photo_id (self, &_tmp4_);
#line 2193 "../src/Photo.vala"
				photo_table_set_metadata_dirty (_tmp3_, &_tmp4_, dirty, &_inner_error0_);
#line 2193 "../src/Photo.vala"
				_database_table_unref0 (_tmp3_);
#line 2193 "../src/Photo.vala"
				if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 17565 "Photo.c"
					goto __catch0_g_error;
				}
#line 2194 "../src/Photo.vala"
				_tmp5_ = self->row;
#line 2194 "../src/Photo.vala"
				_tmp5_->metadata_dirty = dirty;
#line 2195 "../src/Photo.vala"
				committed = TRUE;
#line 17574 "Photo.c"
			}
		}
		goto __finally0;
		__catch0_g_error:
		{
			GError* _lock_error_ = NULL;
			GError* _tmp6_;
#line 2191 "../src/Photo.vala"
			_lock_error_ = _inner_error0_;
#line 2191 "../src/Photo.vala"
			_inner_error0_ = NULL;
#line 2191 "../src/Photo.vala"
			_tmp6_ = _lock_error_;
#line 2191 "../src/Photo.vala"
			_lock_error_ = NULL;
#line 2191 "../src/Photo.vala"
			_inner_error0_ = _tmp6_;
#line 2191 "../src/Photo.vala"
			_g_error_free0 (_lock_error_);
#line 17594 "Photo.c"
			goto __finally0;
		}
		__finally0:
		{
			GError* _inner_error1_ = NULL;
			PhotoRow* _tmp7_;
#line 2191 "../src/Photo.vala"
			_tmp7_ = self->row;
#line 2191 "../src/Photo.vala"
			g_rec_mutex_unlock (&self->priv->__lock_row);
#line 17605 "Photo.c"
		}
#line 2191 "../src/Photo.vala"
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 2191 "../src/Photo.vala"
			g_propagate_error (error, _inner_error0_);
#line 2191 "../src/Photo.vala"
			return;
#line 17613 "Photo.c"
		}
	}
#line 2199 "../src/Photo.vala"
	if (committed) {
#line 17618 "Photo.c"
		Alteration* _tmp8_;
		Alteration* _tmp9_;
#line 2200 "../src/Photo.vala"
		_tmp8_ = alteration_new ("metadata", "master-dirty");
#line 2200 "../src/Photo.vala"
		_tmp9_ = _tmp8_;
#line 2200 "../src/Photo.vala"
		data_object_notify_altered (G_TYPE_CHECK_INSTANCE_CAST (self, TYPE_DATA_OBJECT, DataObject), _tmp9_);
#line 2200 "../src/Photo.vala"
		_alteration_unref0 (_tmp9_);
#line 17629 "Photo.c"
	}
}

static Rating
photo_real_get_rating (MediaSource* base)
{
	Photo * self;
	GError* _inner_error0_ = NULL;
	Rating result;
#line 2203 "../src/Photo.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (base, TYPE_PHOTO, Photo);
#line 17641 "Photo.c"
	{
		PhotoRow* _tmp0_;
#line 2204 "../src/Photo.vala"
		_tmp0_ = self->row;
#line 2204 "../src/Photo.vala"
		g_rec_mutex_lock (&self->priv->__lock_row);
#line 17648 "Photo.c"
		{
			PhotoRow* _tmp1_;
#line 2205 "../src/Photo.vala"
			_tmp1_ = self->row;
#line 2205 "../src/Photo.vala"
			result = _tmp1_->rating;
#line 17655 "Photo.c"
			{
				PhotoRow* _tmp2_;
#line 2204 "../src/Photo.vala"
				_tmp2_ = self->row;
#line 2204 "../src/Photo.vala"
				g_rec_mutex_unlock (&self->priv->__lock_row);
#line 17662 "Photo.c"
			}
#line 2205 "../src/Photo.vala"
			return result;
#line 17666 "Photo.c"
		}
		__finally0:
		{
			PhotoRow* _tmp3_;
#line 2204 "../src/Photo.vala"
			_tmp3_ = self->row;
#line 2204 "../src/Photo.vala"
			g_rec_mutex_unlock (&self->priv->__lock_row);
#line 17675 "Photo.c"
		}
#line 2204 "../src/Photo.vala"
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 2204 "../src/Photo.vala"
		g_clear_error (&_inner_error0_);
#line 2204 "../src/Photo.vala"
		return 0;
#line 17683 "Photo.c"
	}
}

static void
photo_real_set_rating (MediaSource* base,
                       Rating rating)
{
	Photo * self;
	gboolean committed = FALSE;
	GError* _inner_error0_ = NULL;
#line 2209 "../src/Photo.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (base, TYPE_PHOTO, Photo);
#line 2210 "../src/Photo.vala"
	committed = FALSE;
#line 17698 "Photo.c"
	{
		PhotoRow* _tmp0_;
#line 2212 "../src/Photo.vala"
		_tmp0_ = self->row;
#line 2212 "../src/Photo.vala"
		g_rec_mutex_lock (&self->priv->__lock_row);
#line 17705 "Photo.c"
		{
			gboolean _tmp1_ = FALSE;
			PhotoRow* _tmp2_;
#line 2213 "../src/Photo.vala"
			_tmp2_ = self->row;
#line 2213 "../src/Photo.vala"
			if (rating != _tmp2_->rating) {
#line 2213 "../src/Photo.vala"
				_tmp1_ = rating_is_valid (rating);
#line 17715 "Photo.c"
			} else {
#line 2213 "../src/Photo.vala"
				_tmp1_ = FALSE;
#line 17719 "Photo.c"
			}
#line 2213 "../src/Photo.vala"
			if (_tmp1_) {
#line 17723 "Photo.c"
				PhotoTable* _tmp3_;
				PhotoTable* _tmp4_;
				PhotoID _tmp5_ = {0};
#line 2214 "../src/Photo.vala"
				_tmp3_ = photo_table_get_instance ();
#line 2214 "../src/Photo.vala"
				_tmp4_ = _tmp3_;
#line 2214 "../src/Photo.vala"
				photo_get_photo_id (self, &_tmp5_);
#line 2214 "../src/Photo.vala"
				committed = photo_table_set_rating (_tmp4_, &_tmp5_, rating);
#line 2214 "../src/Photo.vala"
				_database_table_unref0 (_tmp4_);
#line 2215 "../src/Photo.vala"
				if (committed) {
#line 17739 "Photo.c"
					PhotoRow* _tmp6_;
#line 2216 "../src/Photo.vala"
					_tmp6_ = self->row;
#line 2216 "../src/Photo.vala"
					_tmp6_->rating = rating;
#line 17745 "Photo.c"
				}
			}
		}
		__finally0:
		{
			PhotoRow* _tmp7_;
#line 2212 "../src/Photo.vala"
			_tmp7_ = self->row;
#line 2212 "../src/Photo.vala"
			g_rec_mutex_unlock (&self->priv->__lock_row);
#line 17756 "Photo.c"
		}
#line 2212 "../src/Photo.vala"
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 2212 "../src/Photo.vala"
			g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 2212 "../src/Photo.vala"
			g_clear_error (&_inner_error0_);
#line 2212 "../src/Photo.vala"
			return;
#line 17766 "Photo.c"
		}
	}
#line 2220 "../src/Photo.vala"
	if (committed) {
#line 17771 "Photo.c"
		Alteration* _tmp8_;
		Alteration* _tmp9_;
#line 2221 "../src/Photo.vala"
		_tmp8_ = alteration_new ("metadata", "rating");
#line 2221 "../src/Photo.vala"
		_tmp9_ = _tmp8_;
#line 2221 "../src/Photo.vala"
		data_object_notify_altered (G_TYPE_CHECK_INSTANCE_CAST (self, TYPE_DATA_OBJECT, DataObject), _tmp9_);
#line 2221 "../src/Photo.vala"
		_alteration_unref0 (_tmp9_);
#line 17782 "Photo.c"
	}
}

static void
photo_real_increase_rating (MediaSource* base)
{
	Photo * self;
	GError* _inner_error0_ = NULL;
#line 2224 "../src/Photo.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (base, TYPE_PHOTO, Photo);
#line 17793 "Photo.c"
	{
		PhotoRow* _tmp0_;
#line 2225 "../src/Photo.vala"
		_tmp0_ = self->row;
#line 2225 "../src/Photo.vala"
		g_rec_mutex_lock (&self->priv->__lock_row);
#line 17800 "Photo.c"
		{
			PhotoRow* _tmp1_;
#line 2226 "../src/Photo.vala"
			_tmp1_ = self->row;
#line 2226 "../src/Photo.vala"
			media_source_set_rating (G_TYPE_CHECK_INSTANCE_CAST (self, TYPE_MEDIA_SOURCE, MediaSource), rating_increase (_tmp1_->rating));
#line 17807 "Photo.c"
		}
		__finally0:
		{
			PhotoRow* _tmp2_;
#line 2225 "../src/Photo.vala"
			_tmp2_ = self->row;
#line 2225 "../src/Photo.vala"
			g_rec_mutex_unlock (&self->priv->__lock_row);
#line 17816 "Photo.c"
		}
#line 2225 "../src/Photo.vala"
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 2225 "../src/Photo.vala"
			g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 2225 "../src/Photo.vala"
			g_clear_error (&_inner_error0_);
#line 2225 "../src/Photo.vala"
			return;
#line 17826 "Photo.c"
		}
	}
}

static void
photo_real_decrease_rating (MediaSource* base)
{
	Photo * self;
	GError* _inner_error0_ = NULL;
#line 2230 "../src/Photo.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (base, TYPE_PHOTO, Photo);
#line 17838 "Photo.c"
	{
		PhotoRow* _tmp0_;
#line 2231 "../src/Photo.vala"
		_tmp0_ = self->row;
#line 2231 "../src/Photo.vala"
		g_rec_mutex_lock (&self->priv->__lock_row);
#line 17845 "Photo.c"
		{
			PhotoRow* _tmp1_;
#line 2232 "../src/Photo.vala"
			_tmp1_ = self->row;
#line 2232 "../src/Photo.vala"
			media_source_set_rating (G_TYPE_CHECK_INSTANCE_CAST (self, TYPE_MEDIA_SOURCE, MediaSource), rating_decrease (_tmp1_->rating));
#line 17852 "Photo.c"
		}
		__finally0:
		{
			PhotoRow* _tmp2_;
#line 2231 "../src/Photo.vala"
			_tmp2_ = self->row;
#line 2231 "../src/Photo.vala"
			g_rec_mutex_unlock (&self->priv->__lock_row);
#line 17861 "Photo.c"
		}
#line 2231 "../src/Photo.vala"
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 2231 "../src/Photo.vala"
			g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 2231 "../src/Photo.vala"
			g_clear_error (&_inner_error0_);
#line 2231 "../src/Photo.vala"
			return;
#line 17871 "Photo.c"
		}
	}
}

static void
photo_real_commit_backlinks (DataSource* base,
                             SourceCollection* sources,
                             const gchar* backlinks)
{
	Photo * self;
	GError* _inner_error0_ = NULL;
#line 2236 "../src/Photo.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (base, TYPE_PHOTO, Photo);
#line 2236 "../src/Photo.vala"
	g_return_if_fail ((sources == NULL) || IS_SOURCE_COLLECTION (sources));
#line 17887 "Photo.c"
	{
		PhotoTable* _tmp0_;
		PhotoTable* _tmp1_;
		PhotoID _tmp2_ = {0};
#line 2241 "../src/Photo.vala"
		_tmp0_ = photo_table_get_instance ();
#line 2241 "../src/Photo.vala"
		_tmp1_ = _tmp0_;
#line 2241 "../src/Photo.vala"
		photo_get_photo_id (self, &_tmp2_);
#line 2241 "../src/Photo.vala"
		photo_table_update_backlinks (_tmp1_, &_tmp2_, backlinks, &_inner_error0_);
#line 2241 "../src/Photo.vala"
		_database_table_unref0 (_tmp1_);
#line 2241 "../src/Photo.vala"
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 2241 "../src/Photo.vala"
			if (_inner_error0_->domain == DATABASE_ERROR) {
#line 17906 "Photo.c"
				goto __catch0_database_error;
			}
#line 2241 "../src/Photo.vala"
			g_critical ("file %s: line %d: unexpected error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 2241 "../src/Photo.vala"
			g_clear_error (&_inner_error0_);
#line 2241 "../src/Photo.vala"
			return;
#line 17915 "Photo.c"
		}
		{
			PhotoRow* _tmp3_;
#line 2242 "../src/Photo.vala"
			_tmp3_ = self->row;
#line 2242 "../src/Photo.vala"
			g_rec_mutex_lock (&self->priv->__lock_row);
#line 17923 "Photo.c"
			{
				PhotoRow* _tmp4_;
				gchar* _tmp5_;
#line 2243 "../src/Photo.vala"
				_tmp4_ = self->row;
#line 2243 "../src/Photo.vala"
				_tmp5_ = g_strdup (backlinks);
#line 2243 "../src/Photo.vala"
				_g_free0 (_tmp4_->backlinks);
#line 2243 "../src/Photo.vala"
				_tmp4_->backlinks = _tmp5_;
#line 17935 "Photo.c"
			}
			__finally1:
			{
				PhotoRow* _tmp6_;
#line 2242 "../src/Photo.vala"
				_tmp6_ = self->row;
#line 2242 "../src/Photo.vala"
				g_rec_mutex_unlock (&self->priv->__lock_row);
#line 17944 "Photo.c"
			}
#line 2242 "../src/Photo.vala"
			if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 2242 "../src/Photo.vala"
				if (_inner_error0_->domain == DATABASE_ERROR) {
#line 17950 "Photo.c"
					goto __catch0_database_error;
				}
#line 2242 "../src/Photo.vala"
				g_critical ("file %s: line %d: unexpected error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 2242 "../src/Photo.vala"
				g_clear_error (&_inner_error0_);
#line 2242 "../src/Photo.vala"
				return;
#line 17959 "Photo.c"
			}
		}
	}
	goto __finally0;
	__catch0_database_error:
	{
		GError* err = NULL;
		gchar* _tmp7_;
		gchar* _tmp8_;
		GError* _tmp9_;
		const gchar* _tmp10_;
#line 2240 "../src/Photo.vala"
		err = _inner_error0_;
#line 2240 "../src/Photo.vala"
		_inner_error0_ = NULL;
#line 2246 "../src/Photo.vala"
		_tmp7_ = data_object_to_string (G_TYPE_CHECK_INSTANCE_CAST (self, TYPE_DATA_OBJECT, DataObject));
#line 2246 "../src/Photo.vala"
		_tmp8_ = _tmp7_;
#line 2246 "../src/Photo.vala"
		_tmp9_ = err;
#line 2246 "../src/Photo.vala"
		_tmp10_ = _tmp9_->message;
#line 2246 "../src/Photo.vala"
		g_warning ("Photo.vala:2246: Unable to update link state for %s: %s", _tmp8_, _tmp10_);
#line 2246 "../src/Photo.vala"
		_g_free0 (_tmp8_);
#line 2240 "../src/Photo.vala"
		_g_error_free0 (err);
#line 17989 "Photo.c"
	}
	__finally0:
#line 2240 "../src/Photo.vala"
	if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 2240 "../src/Photo.vala"
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 2240 "../src/Photo.vala"
		g_clear_error (&_inner_error0_);
#line 2240 "../src/Photo.vala"
		return;
#line 18000 "Photo.c"
	}
}

static gboolean
photo_real_set_event_id (MediaSource* base,
                         EventID* event_id)
{
	Photo * self;
	GError* _inner_error0_ = NULL;
	gboolean result;
#line 2254 "../src/Photo.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (base, TYPE_PHOTO, Photo);
#line 2254 "../src/Photo.vala"
	g_return_val_if_fail (event_id != NULL, FALSE);
#line 18015 "Photo.c"
	{
		PhotoRow* _tmp0_;
		gboolean _tmp11_ = FALSE;
#line 2255 "../src/Photo.vala"
		_tmp0_ = self->row;
#line 2255 "../src/Photo.vala"
		g_rec_mutex_lock (&self->priv->__lock_row);
#line 18023 "Photo.c"
		{
			gboolean committed = FALSE;
			PhotoTable* _tmp1_;
			PhotoTable* _tmp2_;
			PhotoRow* _tmp3_;
			PhotoID _tmp4_;
			EventID _tmp5_;
			gboolean _tmp6_;
#line 2256 "../src/Photo.vala"
			_tmp1_ = photo_table_get_instance ();
#line 2256 "../src/Photo.vala"
			_tmp2_ = _tmp1_;
#line 2256 "../src/Photo.vala"
			_tmp3_ = self->row;
#line 2256 "../src/Photo.vala"
			_tmp4_ = _tmp3_->photo_id;
#line 2256 "../src/Photo.vala"
			_tmp5_ = *event_id;
#line 2256 "../src/Photo.vala"
			_tmp6_ = photo_table_set_event (_tmp2_, &_tmp4_, &_tmp5_);
#line 2256 "../src/Photo.vala"
			_database_table_unref0 (_tmp2_);
#line 2256 "../src/Photo.vala"
			committed = _tmp6_;
#line 2258 "../src/Photo.vala"
			if (committed) {
#line 18050 "Photo.c"
				PhotoRow* _tmp7_;
				EventID _tmp8_;
#line 2259 "../src/Photo.vala"
				_tmp7_ = self->row;
#line 2259 "../src/Photo.vala"
				_tmp8_ = *event_id;
#line 2259 "../src/Photo.vala"
				_tmp7_->event_id = _tmp8_;
#line 18059 "Photo.c"
			}
#line 2261 "../src/Photo.vala"
			result = committed;
#line 18063 "Photo.c"
			{
				PhotoRow* _tmp9_;
#line 2255 "../src/Photo.vala"
				_tmp9_ = self->row;
#line 2255 "../src/Photo.vala"
				g_rec_mutex_unlock (&self->priv->__lock_row);
#line 18070 "Photo.c"
			}
#line 2261 "../src/Photo.vala"
			return result;
#line 18074 "Photo.c"
		}
		__finally0:
		{
			PhotoRow* _tmp10_;
#line 2255 "../src/Photo.vala"
			_tmp10_ = self->row;
#line 2255 "../src/Photo.vala"
			g_rec_mutex_unlock (&self->priv->__lock_row);
#line 18083 "Photo.c"
		}
#line 2255 "../src/Photo.vala"
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 2255 "../src/Photo.vala"
		g_clear_error (&_inner_error0_);
#line 2255 "../src/Photo.vala"
		return _tmp11_;
#line 18091 "Photo.c"
	}
}

static gchar*
photo_real_to_string (DataObject* base)
{
	Photo * self;
	gchar* _tmp0_ = NULL;
	PhotoID _tmp9_ = {0};
	gchar* _tmp10_;
	gchar* _tmp11_;
	PhotoFileReader* _tmp12_;
	PhotoFileReader* _tmp13_;
	gchar* _tmp14_;
	gchar* _tmp15_;
	gchar* _tmp16_;
	gchar* _tmp17_;
	gchar* result;
#line 2265 "../src/Photo.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (base, TYPE_PHOTO, Photo);
#line 2267 "../src/Photo.vala"
	if (!photo_is_master_baseline (self)) {
#line 18114 "Photo.c"
		GFile* _tmp1_;
		GFile* _tmp2_;
		gchar* _tmp3_;
		gchar* _tmp4_;
		gchar* _tmp5_;
		gchar* _tmp6_;
		gchar* _tmp7_;
#line 2267 "../src/Photo.vala"
		_tmp1_ = photo_get_actual_file (self);
#line 2267 "../src/Photo.vala"
		_tmp2_ = _tmp1_;
#line 2267 "../src/Photo.vala"
		_tmp3_ = g_file_get_path (_tmp2_);
#line 2267 "../src/Photo.vala"
		_tmp4_ = _tmp3_;
#line 2267 "../src/Photo.vala"
		_tmp5_ = g_strconcat (" (", _tmp4_, NULL);
#line 2267 "../src/Photo.vala"
		_tmp6_ = _tmp5_;
#line 2267 "../src/Photo.vala"
		_tmp7_ = g_strconcat (_tmp6_, ")", NULL);
#line 2267 "../src/Photo.vala"
		_g_free0 (_tmp0_);
#line 2267 "../src/Photo.vala"
		_tmp0_ = _tmp7_;
#line 2267 "../src/Photo.vala"
		_g_free0 (_tmp6_);
#line 2267 "../src/Photo.vala"
		_g_free0 (_tmp4_);
#line 2267 "../src/Photo.vala"
		_g_object_unref0 (_tmp2_);
#line 18146 "Photo.c"
	} else {
		gchar* _tmp8_;
#line 2267 "../src/Photo.vala"
		_tmp8_ = g_strdup ("");
#line 2267 "../src/Photo.vala"
		_g_free0 (_tmp0_);
#line 2267 "../src/Photo.vala"
		_tmp0_ = _tmp8_;
#line 18155 "Photo.c"
	}
#line 2266 "../src/Photo.vala"
	photo_get_photo_id (self, &_tmp9_);
#line 2266 "../src/Photo.vala"
	_tmp10_ = g_strdup_printf ("%" G_GINT64_FORMAT, _tmp9_.id);
#line 2266 "../src/Photo.vala"
	_tmp11_ = _tmp10_;
#line 2266 "../src/Photo.vala"
	_tmp12_ = photo_get_master_reader (self);
#line 2266 "../src/Photo.vala"
	_tmp13_ = _tmp12_;
#line 2266 "../src/Photo.vala"
	_tmp14_ = photo_file_adapter_get_filepath (G_TYPE_CHECK_INSTANCE_CAST (_tmp13_, TYPE_PHOTO_FILE_ADAPTER, PhotoFileAdapter));
#line 2266 "../src/Photo.vala"
	_tmp15_ = _tmp14_;
#line 2266 "../src/Photo.vala"
	_tmp16_ = g_strdup_printf ("[%s] %s%s", _tmp11_, _tmp15_, _tmp0_);
#line 2266 "../src/Photo.vala"
	_tmp17_ = _tmp16_;
#line 2266 "../src/Photo.vala"
	_g_free0 (_tmp15_);
#line 2266 "../src/Photo.vala"
	_photo_file_adapter_unref0 (_tmp13_);
#line 2266 "../src/Photo.vala"
	_g_free0 (_tmp11_);
#line 2266 "../src/Photo.vala"
	result = _tmp17_;
#line 2266 "../src/Photo.vala"
	_g_free0 (_tmp0_);
#line 2266 "../src/Photo.vala"
	return result;
#line 18187 "Photo.c"
}

static gboolean
photo_real_equals (DataSource* base,
                   DataSource* source)
{
	Photo * self;
	Photo* photo = NULL;
	Photo* _tmp0_;
	Photo* _tmp1_;
	gboolean result;
#line 2270 "../src/Photo.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (base, TYPE_PHOTO, Photo);
#line 2270 "../src/Photo.vala"
	g_return_val_if_fail ((source == NULL) || IS_DATA_SOURCE (source), FALSE);
#line 2272 "../src/Photo.vala"
	_tmp0_ = _g_object_ref0 (IS_PHOTO (source) ? ((Photo*) source) : NULL);
#line 2272 "../src/Photo.vala"
	photo = _tmp0_;
#line 2273 "../src/Photo.vala"
	_tmp1_ = photo;
#line 2273 "../src/Photo.vala"
	if (_tmp1_ != NULL) {
#line 18211 "Photo.c"
		PhotoID photo_id = {0};
		PhotoID _tmp2_ = {0};
		PhotoID other_photo_id = {0};
		Photo* _tmp3_;
		PhotoID _tmp4_ = {0};
		gboolean _tmp5_ = FALSE;
		Photo* _tmp6_;
#line 2274 "../src/Photo.vala"
		photo_get_photo_id (self, &_tmp2_);
#line 2274 "../src/Photo.vala"
		photo_id = _tmp2_;
#line 2275 "../src/Photo.vala"
		_tmp3_ = photo;
#line 2275 "../src/Photo.vala"
		photo_get_photo_id (_tmp3_, &_tmp4_);
#line 2275 "../src/Photo.vala"
		other_photo_id = _tmp4_;
#line 2277 "../src/Photo.vala"
		_tmp6_ = photo;
#line 2277 "../src/Photo.vala"
		if (self != _tmp6_) {
#line 18233 "Photo.c"
			PhotoID _tmp7_;
#line 2277 "../src/Photo.vala"
			_tmp7_ = photo_id;
#line 2277 "../src/Photo.vala"
			_tmp5_ = _tmp7_.id != PHOTO_ID_INVALID;
#line 18239 "Photo.c"
		} else {
#line 2277 "../src/Photo.vala"
			_tmp5_ = FALSE;
#line 18243 "Photo.c"
		}
#line 2277 "../src/Photo.vala"
		if (_tmp5_) {
#line 18247 "Photo.c"
			PhotoID _tmp8_;
			PhotoID _tmp9_;
#line 2278 "../src/Photo.vala"
			_tmp8_ = photo_id;
#line 2278 "../src/Photo.vala"
			_tmp9_ = other_photo_id;
#line 2278 "../src/Photo.vala"
			_vala_assert (_tmp8_.id != _tmp9_.id, "photo_id.id != other_photo_id.id");
#line 18256 "Photo.c"
		}
	}
#line 2282 "../src/Photo.vala"
	result = DATA_SOURCE_CLASS (photo_parent_class)->equals (G_TYPE_CHECK_INSTANCE_CAST (G_TYPE_CHECK_INSTANCE_CAST (self, TYPE_PHOTO_SOURCE, PhotoSource), TYPE_DATA_SOURCE, DataSource), source);
#line 2282 "../src/Photo.vala"
	_g_object_unref0 (photo);
#line 2282 "../src/Photo.vala"
	return result;
#line 18265 "Photo.c"
}

static void
photo_file_exif_updated (Photo* self)
{
	GFile* file = NULL;
	GFile* _tmp0_;
	GFileInfo* info = NULL;
	GDateTime* timestamp = NULL;
	GFileInfo* _tmp7_;
	GDateTime* _tmp8_;
	GDateTime* _tmp9_;
	GDateTime* _tmp10_;
	GDateTime* _tmp11_;
	PhotoFileInterrogator* interrogator = NULL;
	PhotoFileInterrogator* _tmp12_;
	DetectedPhotoInformation* detected = NULL;
	DetectedPhotoInformation* _tmp17_;
	gboolean _tmp18_ = FALSE;
	DetectedPhotoInformation* _tmp19_;
	gboolean success = FALSE;
	GError* _inner_error0_ = NULL;
#line 2286 "../src/Photo.vala"
	g_return_if_fail (IS_PHOTO (self));
#line 2287 "../src/Photo.vala"
	_tmp0_ = media_source_get_file (G_TYPE_CHECK_INSTANCE_CAST (self, TYPE_MEDIA_SOURCE, MediaSource));
#line 2287 "../src/Photo.vala"
	file = _tmp0_;
#line 2289 "../src/Photo.vala"
	info = NULL;
#line 18296 "Photo.c"
	{
		GFileInfo* _tmp1_ = NULL;
		GFileInfo* _tmp2_;
		GFileInfo* _tmp3_;
#line 2291 "../src/Photo.vala"
		_tmp2_ = g_file_query_info (file, DIRECTORY_MONITOR_SUPPLIED_ATTRIBUTES, G_FILE_QUERY_INFO_NOFOLLOW_SYMLINKS, NULL, &_inner_error0_);
#line 2291 "../src/Photo.vala"
		_tmp1_ = _tmp2_;
#line 2291 "../src/Photo.vala"
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 18307 "Photo.c"
			goto __catch0_g_error;
		}
#line 2291 "../src/Photo.vala"
		_tmp3_ = _tmp1_;
#line 2291 "../src/Photo.vala"
		_tmp1_ = NULL;
#line 2291 "../src/Photo.vala"
		_g_object_unref0 (info);
#line 2291 "../src/Photo.vala"
		info = _tmp3_;
#line 2290 "../src/Photo.vala"
		_g_object_unref0 (_tmp1_);
#line 18320 "Photo.c"
	}
	goto __finally0;
	__catch0_g_error:
	{
		GError* err = NULL;
		gchar* _tmp4_;
		gchar* _tmp5_;
		const gchar* _tmp6_;
#line 2290 "../src/Photo.vala"
		err = _inner_error0_;
#line 2290 "../src/Photo.vala"
		_inner_error0_ = NULL;
#line 2294 "../src/Photo.vala"
		_tmp4_ = data_object_to_string (G_TYPE_CHECK_INSTANCE_CAST (self, TYPE_DATA_OBJECT, DataObject));
#line 2294 "../src/Photo.vala"
		_tmp5_ = _tmp4_;
#line 2294 "../src/Photo.vala"
		_tmp6_ = err->message;
#line 2294 "../src/Photo.vala"
		g_error ("Photo.vala:2294: Unable to read file information for %s: %s", _tmp5_, _tmp6_);
#line 2294 "../src/Photo.vala"
		_g_free0 (_tmp5_);
#line 2290 "../src/Photo.vala"
		_g_error_free0 (err);
#line 18345 "Photo.c"
	}
	__finally0:
#line 2290 "../src/Photo.vala"
	if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 2290 "../src/Photo.vala"
		_g_object_unref0 (info);
#line 2290 "../src/Photo.vala"
		_g_object_unref0 (file);
#line 2290 "../src/Photo.vala"
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 2290 "../src/Photo.vala"
		g_clear_error (&_inner_error0_);
#line 2290 "../src/Photo.vala"
		return;
#line 18360 "Photo.c"
	}
#line 2297 "../src/Photo.vala"
	_tmp7_ = info;
#line 2297 "../src/Photo.vala"
	_tmp8_ = g_file_info_get_modification_date_time (_tmp7_);
#line 2297 "../src/Photo.vala"
	_tmp9_ = _tmp8_;
#line 2297 "../src/Photo.vala"
	_tmp10_ = coarsify_date_time (_tmp9_);
#line 2297 "../src/Photo.vala"
	_tmp11_ = _tmp10_;
#line 2297 "../src/Photo.vala"
	_g_date_time_unref0 (_tmp9_);
#line 2297 "../src/Photo.vala"
	timestamp = _tmp11_;
#line 2300 "../src/Photo.vala"
	_tmp12_ = photo_file_interrogator_new (file, PHOTO_FILE_SNIFFER_OPTIONS_GET_ALL);
#line 2300 "../src/Photo.vala"
	interrogator = _tmp12_;
#line 18380 "Photo.c"
	{
#line 2302 "../src/Photo.vala"
		photo_file_interrogator_interrogate (interrogator, &_inner_error0_);
#line 2302 "../src/Photo.vala"
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 18386 "Photo.c"
			goto __catch1_g_error;
		}
	}
	goto __finally1;
	__catch1_g_error:
	{
		GError* err = NULL;
		gchar* _tmp13_;
		gchar* _tmp14_;
		GError* _tmp15_;
		const gchar* _tmp16_;
#line 2301 "../src/Photo.vala"
		err = _inner_error0_;
#line 2301 "../src/Photo.vala"
		_inner_error0_ = NULL;
#line 2304 "../src/Photo.vala"
		_tmp13_ = g_file_get_path (file);
#line 2304 "../src/Photo.vala"
		_tmp14_ = _tmp13_;
#line 2304 "../src/Photo.vala"
		_tmp15_ = err;
#line 2304 "../src/Photo.vala"
		_tmp16_ = _tmp15_->message;
#line 2304 "../src/Photo.vala"
		g_warning ("Photo.vala:2304: Unable to interrogate photo file %s: %s", _tmp14_, _tmp16_);
#line 2304 "../src/Photo.vala"
		_g_free0 (_tmp14_);
#line 2301 "../src/Photo.vala"
		_g_error_free0 (err);
#line 18416 "Photo.c"
	}
	__finally1:
#line 2301 "../src/Photo.vala"
	if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 2301 "../src/Photo.vala"
		_photo_file_interrogator_unref0 (interrogator);
#line 2301 "../src/Photo.vala"
		_g_date_time_unref0 (timestamp);
#line 2301 "../src/Photo.vala"
		_g_object_unref0 (info);
#line 2301 "../src/Photo.vala"
		_g_object_unref0 (file);
#line 2301 "../src/Photo.vala"
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 2301 "../src/Photo.vala"
		g_clear_error (&_inner_error0_);
#line 2301 "../src/Photo.vala"
		return;
#line 18435 "Photo.c"
	}
#line 2307 "../src/Photo.vala"
	_tmp17_ = photo_file_interrogator_get_detected_photo_information (interrogator);
#line 2307 "../src/Photo.vala"
	detected = _tmp17_;
#line 2308 "../src/Photo.vala"
	_tmp19_ = detected;
#line 2308 "../src/Photo.vala"
	if (_tmp19_ == NULL) {
#line 2308 "../src/Photo.vala"
		_tmp18_ = TRUE;
#line 18447 "Photo.c"
	} else {
#line 2308 "../src/Photo.vala"
		_tmp18_ = photo_file_interrogator_get_is_photo_corrupted (interrogator);
#line 18451 "Photo.c"
	}
#line 2308 "../src/Photo.vala"
	if (_tmp18_) {
#line 18455 "Photo.c"
		gchar* _tmp20_;
		gchar* _tmp21_;
#line 2309 "../src/Photo.vala"
		_tmp20_ = data_object_to_string (G_TYPE_CHECK_INSTANCE_CAST (self, TYPE_DATA_OBJECT, DataObject));
#line 2309 "../src/Photo.vala"
		_tmp21_ = _tmp20_;
#line 2309 "../src/Photo.vala"
		g_critical ("Photo.vala:2309: file_exif_updated: %s no longer an image", _tmp21_);
#line 2309 "../src/Photo.vala"
		_g_free0 (_tmp21_);
#line 2311 "../src/Photo.vala"
		_detected_photo_information_unref0 (detected);
#line 2311 "../src/Photo.vala"
		_photo_file_interrogator_unref0 (interrogator);
#line 2311 "../src/Photo.vala"
		_g_date_time_unref0 (timestamp);
#line 2311 "../src/Photo.vala"
		_g_object_unref0 (info);
#line 2311 "../src/Photo.vala"
		_g_object_unref0 (file);
#line 2311 "../src/Photo.vala"
		return;
#line 18478 "Photo.c"
	}
	{
		PhotoRow* _tmp22_;
#line 2315 "../src/Photo.vala"
		_tmp22_ = self->row;
#line 2315 "../src/Photo.vala"
		g_rec_mutex_lock (&self->priv->__lock_row);
#line 18486 "Photo.c"
		{
			PhotoTable* _tmp23_;
			PhotoTable* _tmp24_;
			PhotoID _tmp25_ = {0};
			GFileInfo* _tmp26_;
			DetectedPhotoInformation* _tmp27_;
			const gchar* _tmp28_;
			DetectedPhotoInformation* _tmp29_;
			const gchar* _tmp30_;
			DetectedPhotoInformation* _tmp31_;
			const gchar* _tmp32_;
			PhotoRow* _tmp33_;
#line 2316 "../src/Photo.vala"
			_tmp23_ = photo_table_get_instance ();
#line 2316 "../src/Photo.vala"
			_tmp24_ = _tmp23_;
#line 2316 "../src/Photo.vala"
			photo_get_photo_id (self, &_tmp25_);
#line 2316 "../src/Photo.vala"
			_tmp26_ = info;
#line 2316 "../src/Photo.vala"
			_tmp27_ = detected;
#line 2316 "../src/Photo.vala"
			_tmp28_ = _tmp27_->md5;
#line 2316 "../src/Photo.vala"
			_tmp29_ = detected;
#line 2316 "../src/Photo.vala"
			_tmp30_ = _tmp29_->exif_md5;
#line 2316 "../src/Photo.vala"
			_tmp31_ = detected;
#line 2316 "../src/Photo.vala"
			_tmp32_ = _tmp31_->thumbnail_md5;
#line 2316 "../src/Photo.vala"
			_tmp33_ = self->row;
#line 2316 "../src/Photo.vala"
			success = photo_table_master_exif_updated (_tmp24_, &_tmp25_, g_file_info_get_size (_tmp26_), timestamp, _tmp28_, _tmp30_, _tmp32_, _tmp33_);
#line 2316 "../src/Photo.vala"
			_database_table_unref0 (_tmp24_);
#line 18525 "Photo.c"
		}
		__finally2:
		{
			PhotoRow* _tmp34_;
#line 2315 "../src/Photo.vala"
			_tmp34_ = self->row;
#line 2315 "../src/Photo.vala"
			g_rec_mutex_unlock (&self->priv->__lock_row);
#line 18534 "Photo.c"
		}
#line 2315 "../src/Photo.vala"
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 2315 "../src/Photo.vala"
			_detected_photo_information_unref0 (detected);
#line 2315 "../src/Photo.vala"
			_photo_file_interrogator_unref0 (interrogator);
#line 2315 "../src/Photo.vala"
			_g_date_time_unref0 (timestamp);
#line 2315 "../src/Photo.vala"
			_g_object_unref0 (info);
#line 2315 "../src/Photo.vala"
			_g_object_unref0 (file);
#line 2315 "../src/Photo.vala"
			g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 2315 "../src/Photo.vala"
			g_clear_error (&_inner_error0_);
#line 2315 "../src/Photo.vala"
			return;
#line 18554 "Photo.c"
		}
	}
#line 2320 "../src/Photo.vala"
	if (success) {
#line 18559 "Photo.c"
		Alteration* _tmp35_;
		Alteration* _tmp36_;
#line 2321 "../src/Photo.vala"
		_tmp35_ = alteration_new_from_list ("metadata:exif,metadata:md5");
#line 2321 "../src/Photo.vala"
		_tmp36_ = _tmp35_;
#line 2321 "../src/Photo.vala"
		data_object_notify_altered (G_TYPE_CHECK_INSTANCE_CAST (self, TYPE_DATA_OBJECT, DataObject), _tmp36_);
#line 2321 "../src/Photo.vala"
		_alteration_unref0 (_tmp36_);
#line 18570 "Photo.c"
	}
#line 2286 "../src/Photo.vala"
	_detected_photo_information_unref0 (detected);
#line 2286 "../src/Photo.vala"
	_photo_file_interrogator_unref0 (interrogator);
#line 2286 "../src/Photo.vala"
	_g_date_time_unref0 (timestamp);
#line 2286 "../src/Photo.vala"
	_g_object_unref0 (info);
#line 2286 "../src/Photo.vala"
	_g_object_unref0 (file);
#line 18582 "Photo.c"
}

static guint64
photo_real_get_filesize (MediaSource* base)
{
	Photo * self;
	GError* _inner_error0_ = NULL;
	guint64 result;
#line 2326 "../src/Photo.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (base, TYPE_PHOTO, Photo);
#line 18593 "Photo.c"
	{
		PhotoRow* _tmp0_;
		guint64 _tmp4_ = 0ULL;
#line 2327 "../src/Photo.vala"
		_tmp0_ = self->row;
#line 2327 "../src/Photo.vala"
		g_rec_mutex_lock (&self->priv->__lock_row);
#line 18601 "Photo.c"
		{
			BackingPhotoRow* _tmp1_;
#line 2328 "../src/Photo.vala"
			_tmp1_ = self->backing_photo_row;
#line 2328 "../src/Photo.vala"
			result = (guint64) _tmp1_->filesize;
#line 18608 "Photo.c"
			{
				PhotoRow* _tmp2_;
#line 2327 "../src/Photo.vala"
				_tmp2_ = self->row;
#line 2327 "../src/Photo.vala"
				g_rec_mutex_unlock (&self->priv->__lock_row);
#line 18615 "Photo.c"
			}
#line 2328 "../src/Photo.vala"
			return result;
#line 18619 "Photo.c"
		}
		__finally0:
		{
			PhotoRow* _tmp3_;
#line 2327 "../src/Photo.vala"
			_tmp3_ = self->row;
#line 2327 "../src/Photo.vala"
			g_rec_mutex_unlock (&self->priv->__lock_row);
#line 18628 "Photo.c"
		}
#line 2327 "../src/Photo.vala"
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 2327 "../src/Photo.vala"
		g_clear_error (&_inner_error0_);
#line 2327 "../src/Photo.vala"
		return _tmp4_;
#line 18636 "Photo.c"
	}
}

static guint64
photo_real_get_master_filesize (MediaSource* base)
{
	Photo * self;
	GError* _inner_error0_ = NULL;
	guint64 result;
#line 2332 "../src/Photo.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (base, TYPE_PHOTO, Photo);
#line 18648 "Photo.c"
	{
		PhotoRow* _tmp0_;
		guint64 _tmp5_ = 0ULL;
#line 2333 "../src/Photo.vala"
		_tmp0_ = self->row;
#line 2333 "../src/Photo.vala"
		g_rec_mutex_lock (&self->priv->__lock_row);
#line 18656 "Photo.c"
		{
			PhotoRow* _tmp1_;
			BackingPhotoRow* _tmp2_;
#line 2334 "../src/Photo.vala"
			_tmp1_ = self->row;
#line 2334 "../src/Photo.vala"
			_tmp2_ = _tmp1_->master;
#line 2334 "../src/Photo.vala"
			result = (guint64) _tmp2_->filesize;
#line 18666 "Photo.c"
			{
				PhotoRow* _tmp3_;
#line 2333 "../src/Photo.vala"
				_tmp3_ = self->row;
#line 2333 "../src/Photo.vala"
				g_rec_mutex_unlock (&self->priv->__lock_row);
#line 18673 "Photo.c"
			}
#line 2334 "../src/Photo.vala"
			return result;
#line 18677 "Photo.c"
		}
		__finally0:
		{
			PhotoRow* _tmp4_;
#line 2333 "../src/Photo.vala"
			_tmp4_ = self->row;
#line 2333 "../src/Photo.vala"
			g_rec_mutex_unlock (&self->priv->__lock_row);
#line 18686 "Photo.c"
		}
#line 2333 "../src/Photo.vala"
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 2333 "../src/Photo.vala"
		g_clear_error (&_inner_error0_);
#line 2333 "../src/Photo.vala"
		return _tmp5_;
#line 18694 "Photo.c"
	}
}

guint64
photo_get_editable_filesize (Photo* self)
{
	GError* _inner_error0_ = NULL;
	guint64 result;
#line 2338 "../src/Photo.vala"
	g_return_val_if_fail (IS_PHOTO (self), 0ULL);
#line 18705 "Photo.c"
	{
		PhotoRow* _tmp0_;
		guint64 _tmp4_ = 0ULL;
#line 2339 "../src/Photo.vala"
		_tmp0_ = self->row;
#line 2339 "../src/Photo.vala"
		g_rec_mutex_lock (&self->priv->__lock_row);
#line 18713 "Photo.c"
		{
			BackingPhotoRow* _tmp1_;
#line 2340 "../src/Photo.vala"
			_tmp1_ = self->priv->editable;
#line 2340 "../src/Photo.vala"
			result = (guint64) _tmp1_->filesize;
#line 18720 "Photo.c"
			{
				PhotoRow* _tmp2_;
#line 2339 "../src/Photo.vala"
				_tmp2_ = self->row;
#line 2339 "../src/Photo.vala"
				g_rec_mutex_unlock (&self->priv->__lock_row);
#line 18727 "Photo.c"
			}
#line 2340 "../src/Photo.vala"
			return result;
#line 18731 "Photo.c"
		}
		__finally0:
		{
			PhotoRow* _tmp3_;
#line 2339 "../src/Photo.vala"
			_tmp3_ = self->row;
#line 2339 "../src/Photo.vala"
			g_rec_mutex_unlock (&self->priv->__lock_row);
#line 18740 "Photo.c"
		}
#line 2339 "../src/Photo.vala"
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 2339 "../src/Photo.vala"
		g_clear_error (&_inner_error0_);
#line 2339 "../src/Photo.vala"
		return _tmp4_;
#line 18748 "Photo.c"
	}
}

static GDateTime*
photo_real_get_exposure_time (Dateable* base)
{
	Photo * self;
	GDateTime* _tmp0_;
	GDateTime* _tmp1_;
	GDateTime* result;
#line 2344 "../src/Photo.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (base, TYPE_PHOTO, Photo);
#line 2345 "../src/Photo.vala"
	_tmp0_ = self->priv->cached_exposure_time;
#line 2345 "../src/Photo.vala"
	_tmp1_ = _g_date_time_ref0 (_tmp0_);
#line 2345 "../src/Photo.vala"
	result = _tmp1_;
#line 2345 "../src/Photo.vala"
	return result;
#line 18769 "Photo.c"
}

static gchar*
photo_real_get_basename (MediaSource* base)
{
	Photo * self;
	GError* _inner_error0_ = NULL;
	gchar* result;
#line 2348 "../src/Photo.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (base, TYPE_PHOTO, Photo);
#line 18780 "Photo.c"
	{
		PhotoRow* _tmp0_;
#line 2349 "../src/Photo.vala"
		_tmp0_ = self->row;
#line 2349 "../src/Photo.vala"
		g_rec_mutex_lock (&self->priv->__lock_row);
#line 18787 "Photo.c"
		{
			const gchar* _tmp1_;
			gchar* _tmp2_;
#line 2350 "../src/Photo.vala"
			_tmp1_ = self->priv->file_title;
#line 2350 "../src/Photo.vala"
			_tmp2_ = g_strdup (_tmp1_);
#line 2350 "../src/Photo.vala"
			result = _tmp2_;
#line 18797 "Photo.c"
			{
				PhotoRow* _tmp3_;
#line 2349 "../src/Photo.vala"
				_tmp3_ = self->row;
#line 2349 "../src/Photo.vala"
				g_rec_mutex_unlock (&self->priv->__lock_row);
#line 18804 "Photo.c"
			}
#line 2350 "../src/Photo.vala"
			return result;
#line 18808 "Photo.c"
		}
		__finally0:
		{
			PhotoRow* _tmp4_;
#line 2349 "../src/Photo.vala"
			_tmp4_ = self->row;
#line 2349 "../src/Photo.vala"
			g_rec_mutex_unlock (&self->priv->__lock_row);
#line 18817 "Photo.c"
		}
#line 2349 "../src/Photo.vala"
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 2349 "../src/Photo.vala"
		g_clear_error (&_inner_error0_);
#line 2349 "../src/Photo.vala"
		return NULL;
#line 18825 "Photo.c"
	}
}

static gchar*
photo_real_get_title (MediaSource* base)
{
	Photo * self;
	GError* _inner_error0_ = NULL;
	gchar* result;
#line 2354 "../src/Photo.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (base, TYPE_PHOTO, Photo);
#line 18837 "Photo.c"
	{
		PhotoRow* _tmp0_;
#line 2355 "../src/Photo.vala"
		_tmp0_ = self->row;
#line 2355 "../src/Photo.vala"
		g_rec_mutex_lock (&self->priv->__lock_row);
#line 18844 "Photo.c"
		{
			PhotoRow* _tmp1_;
			const gchar* _tmp2_;
			gchar* _tmp3_;
#line 2356 "../src/Photo.vala"
			_tmp1_ = self->row;
#line 2356 "../src/Photo.vala"
			_tmp2_ = _tmp1_->title;
#line 2356 "../src/Photo.vala"
			_tmp3_ = g_strdup (_tmp2_);
#line 2356 "../src/Photo.vala"
			result = _tmp3_;
#line 18857 "Photo.c"
			{
				PhotoRow* _tmp4_;
#line 2355 "../src/Photo.vala"
				_tmp4_ = self->row;
#line 2355 "../src/Photo.vala"
				g_rec_mutex_unlock (&self->priv->__lock_row);
#line 18864 "Photo.c"
			}
#line 2356 "../src/Photo.vala"
			return result;
#line 18868 "Photo.c"
		}
		__finally0:
		{
			PhotoRow* _tmp5_;
#line 2355 "../src/Photo.vala"
			_tmp5_ = self->row;
#line 2355 "../src/Photo.vala"
			g_rec_mutex_unlock (&self->priv->__lock_row);
#line 18877 "Photo.c"
		}
#line 2355 "../src/Photo.vala"
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 2355 "../src/Photo.vala"
		g_clear_error (&_inner_error0_);
#line 2355 "../src/Photo.vala"
		return NULL;
#line 18885 "Photo.c"
	}
}

static gchar*
photo_real_get_comment (MediaSource* base)
{
	Photo * self;
	GError* _inner_error0_ = NULL;
	gchar* result;
#line 2360 "../src/Photo.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (base, TYPE_PHOTO, Photo);
#line 18897 "Photo.c"
	{
		PhotoRow* _tmp0_;
#line 2361 "../src/Photo.vala"
		_tmp0_ = self->row;
#line 2361 "../src/Photo.vala"
		g_rec_mutex_lock (&self->priv->__lock_row);
#line 18904 "Photo.c"
		{
			PhotoRow* _tmp1_;
			const gchar* _tmp2_;
			gchar* _tmp3_;
#line 2362 "../src/Photo.vala"
			_tmp1_ = self->row;
#line 2362 "../src/Photo.vala"
			_tmp2_ = _tmp1_->comment;
#line 2362 "../src/Photo.vala"
			_tmp3_ = g_strdup (_tmp2_);
#line 2362 "../src/Photo.vala"
			result = _tmp3_;
#line 18917 "Photo.c"
			{
				PhotoRow* _tmp4_;
#line 2361 "../src/Photo.vala"
				_tmp4_ = self->row;
#line 2361 "../src/Photo.vala"
				g_rec_mutex_unlock (&self->priv->__lock_row);
#line 18924 "Photo.c"
			}
#line 2362 "../src/Photo.vala"
			return result;
#line 18928 "Photo.c"
		}
		__finally0:
		{
			PhotoRow* _tmp5_;
#line 2361 "../src/Photo.vala"
			_tmp5_ = self->row;
#line 2361 "../src/Photo.vala"
			g_rec_mutex_unlock (&self->priv->__lock_row);
#line 18937 "Photo.c"
		}
#line 2361 "../src/Photo.vala"
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 2361 "../src/Photo.vala"
		g_clear_error (&_inner_error0_);
#line 2361 "../src/Photo.vala"
		return NULL;
#line 18945 "Photo.c"
	}
}

static void
photo_real_set_title (MediaSource* base,
                      const gchar* title)
{
	Photo * self;
	gchar* new_title = NULL;
	gchar* _tmp0_;
	gboolean committed = FALSE;
	GError* _inner_error0_ = NULL;
#line 2366 "../src/Photo.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (base, TYPE_PHOTO, Photo);
#line 2367 "../src/Photo.vala"
	_tmp0_ = media_source_prep_title (title);
#line 2367 "../src/Photo.vala"
	new_title = _tmp0_;
#line 2369 "../src/Photo.vala"
	committed = FALSE;
#line 18966 "Photo.c"
	{
		PhotoRow* _tmp1_;
#line 2370 "../src/Photo.vala"
		_tmp1_ = self->row;
#line 2370 "../src/Photo.vala"
		g_rec_mutex_lock (&self->priv->__lock_row);
#line 18973 "Photo.c"
		{
			const gchar* _tmp2_;
			PhotoRow* _tmp3_;
			const gchar* _tmp4_;
			PhotoTable* _tmp6_;
			PhotoTable* _tmp7_;
			PhotoRow* _tmp8_;
			PhotoID _tmp9_;
			const gchar* _tmp10_;
#line 2371 "../src/Photo.vala"
			_tmp2_ = new_title;
#line 2371 "../src/Photo.vala"
			_tmp3_ = self->row;
#line 2371 "../src/Photo.vala"
			_tmp4_ = _tmp3_->title;
#line 2371 "../src/Photo.vala"
			if (g_strcmp0 (_tmp2_, _tmp4_) == 0) {
#line 18991 "Photo.c"
				{
					PhotoRow* _tmp5_;
#line 2370 "../src/Photo.vala"
					_tmp5_ = self->row;
#line 2370 "../src/Photo.vala"
					g_rec_mutex_unlock (&self->priv->__lock_row);
#line 18998 "Photo.c"
				}
#line 2372 "../src/Photo.vala"
				_g_free0 (new_title);
#line 2372 "../src/Photo.vala"
				return;
#line 19004 "Photo.c"
			}
#line 2374 "../src/Photo.vala"
			_tmp6_ = photo_table_get_instance ();
#line 2374 "../src/Photo.vala"
			_tmp7_ = _tmp6_;
#line 2374 "../src/Photo.vala"
			_tmp8_ = self->row;
#line 2374 "../src/Photo.vala"
			_tmp9_ = _tmp8_->photo_id;
#line 2374 "../src/Photo.vala"
			_tmp10_ = new_title;
#line 2374 "../src/Photo.vala"
			committed = photo_table_set_title (_tmp7_, &_tmp9_, _tmp10_);
#line 2374 "../src/Photo.vala"
			_database_table_unref0 (_tmp7_);
#line 2375 "../src/Photo.vala"
			if (committed) {
#line 19022 "Photo.c"
				PhotoRow* _tmp11_;
				const gchar* _tmp12_;
				gchar* _tmp13_;
#line 2376 "../src/Photo.vala"
				_tmp11_ = self->row;
#line 2376 "../src/Photo.vala"
				_tmp12_ = new_title;
#line 2376 "../src/Photo.vala"
				_tmp13_ = g_strdup (_tmp12_);
#line 2376 "../src/Photo.vala"
				_g_free0 (_tmp11_->title);
#line 2376 "../src/Photo.vala"
				_tmp11_->title = _tmp13_;
#line 19036 "Photo.c"
			}
		}
		__finally0:
		{
			PhotoRow* _tmp14_;
#line 2370 "../src/Photo.vala"
			_tmp14_ = self->row;
#line 2370 "../src/Photo.vala"
			g_rec_mutex_unlock (&self->priv->__lock_row);
#line 19046 "Photo.c"
		}
#line 2370 "../src/Photo.vala"
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 2370 "../src/Photo.vala"
			_g_free0 (new_title);
#line 2370 "../src/Photo.vala"
			g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 2370 "../src/Photo.vala"
			g_clear_error (&_inner_error0_);
#line 2370 "../src/Photo.vala"
			return;
#line 19058 "Photo.c"
		}
	}
#line 2379 "../src/Photo.vala"
	if (committed) {
#line 19063 "Photo.c"
		Alteration* _tmp15_;
		Alteration* _tmp16_;
#line 2380 "../src/Photo.vala"
		_tmp15_ = alteration_new ("metadata", "name");
#line 2380 "../src/Photo.vala"
		_tmp16_ = _tmp15_;
#line 2380 "../src/Photo.vala"
		data_object_notify_altered (G_TYPE_CHECK_INSTANCE_CAST (self, TYPE_DATA_OBJECT, DataObject), _tmp16_);
#line 2380 "../src/Photo.vala"
		_alteration_unref0 (_tmp16_);
#line 19074 "Photo.c"
	}
#line 2366 "../src/Photo.vala"
	_g_free0 (new_title);
#line 19078 "Photo.c"
}

static void
photo_real_get_gps_coords (Positionable* base,
                           GpsCoords* result)
{
	Photo * self;
	GError* _inner_error0_ = NULL;
#line 2383 "../src/Photo.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (base, TYPE_PHOTO, Photo);
#line 19089 "Photo.c"
	{
		PhotoRow* _tmp0_;
#line 2384 "../src/Photo.vala"
		_tmp0_ = self->row;
#line 2384 "../src/Photo.vala"
		g_rec_mutex_lock (&self->priv->__lock_row);
#line 19096 "Photo.c"
		{
			PhotoRow* _tmp1_;
			GpsCoords _tmp2_;
#line 2385 "../src/Photo.vala"
			_tmp1_ = self->row;
#line 2385 "../src/Photo.vala"
			_tmp2_ = _tmp1_->gps_coords;
#line 2385 "../src/Photo.vala"
			*result = _tmp2_;
#line 19106 "Photo.c"
			{
				PhotoRow* _tmp3_;
#line 2384 "../src/Photo.vala"
				_tmp3_ = self->row;
#line 2384 "../src/Photo.vala"
				g_rec_mutex_unlock (&self->priv->__lock_row);
#line 19113 "Photo.c"
			}
#line 2385 "../src/Photo.vala"
			return;
#line 19117 "Photo.c"
		}
		__finally0:
		{
			PhotoRow* _tmp4_;
#line 2384 "../src/Photo.vala"
			_tmp4_ = self->row;
#line 2384 "../src/Photo.vala"
			g_rec_mutex_unlock (&self->priv->__lock_row);
#line 19126 "Photo.c"
		}
#line 2384 "../src/Photo.vala"
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 2384 "../src/Photo.vala"
		g_clear_error (&_inner_error0_);
#line 2384 "../src/Photo.vala"
		return;
#line 19134 "Photo.c"
	}
}

static gpointer
_g_error_copy0 (gpointer self)
{
#line 2396 "../src/Photo.vala"
	return self ? g_error_copy (self) : NULL;
#line 19143 "Photo.c"
}

static void
photo_real_set_gps_coords (Positionable* base,
                           GpsCoords* gps_coords)
{
	Photo * self;
	GError* dberr = NULL;
	GError* _tmp12_;
	GError* _inner_error0_ = NULL;
#line 2389 "../src/Photo.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (base, TYPE_PHOTO, Photo);
#line 2389 "../src/Photo.vala"
	g_return_if_fail (gps_coords != NULL);
#line 2390 "../src/Photo.vala"
	dberr = NULL;
#line 19160 "Photo.c"
	{
		PhotoRow* _tmp0_;
#line 2391 "../src/Photo.vala"
		_tmp0_ = self->row;
#line 2391 "../src/Photo.vala"
		g_rec_mutex_lock (&self->priv->__lock_row);
#line 19167 "Photo.c"
		{
			{
				PhotoTable* _tmp1_;
				PhotoTable* _tmp2_;
				PhotoRow* _tmp3_;
				PhotoID _tmp4_;
				GpsCoords _tmp5_;
				PhotoRow* _tmp7_;
				GpsCoords _tmp8_;
#line 2393 "../src/Photo.vala"
				_tmp1_ = photo_table_get_instance ();
#line 2393 "../src/Photo.vala"
				_tmp2_ = _tmp1_;
#line 2393 "../src/Photo.vala"
				_tmp3_ = self->row;
#line 2393 "../src/Photo.vala"
				_tmp4_ = _tmp3_->photo_id;
#line 2393 "../src/Photo.vala"
				_tmp5_ = *gps_coords;
#line 2393 "../src/Photo.vala"
				photo_table_set_gps_coords (_tmp2_, &_tmp4_, &_tmp5_, &_inner_error0_);
#line 2393 "../src/Photo.vala"
				_database_table_unref0 (_tmp2_);
#line 2393 "../src/Photo.vala"
				if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 2393 "../src/Photo.vala"
					if (_inner_error0_->domain == DATABASE_ERROR) {
#line 19195 "Photo.c"
						goto __catch1_database_error;
					}
					{
						PhotoRow* _tmp6_;
#line 2391 "../src/Photo.vala"
						_tmp6_ = self->row;
#line 2391 "../src/Photo.vala"
						g_rec_mutex_unlock (&self->priv->__lock_row);
#line 19204 "Photo.c"
					}
#line 2393 "../src/Photo.vala"
					_g_error_free0 (dberr);
#line 2393 "../src/Photo.vala"
					g_critical ("file %s: line %d: unexpected error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 2393 "../src/Photo.vala"
					g_clear_error (&_inner_error0_);
#line 2393 "../src/Photo.vala"
					return;
#line 19214 "Photo.c"
				}
#line 2394 "../src/Photo.vala"
				_tmp7_ = self->row;
#line 2394 "../src/Photo.vala"
				_tmp8_ = *gps_coords;
#line 2394 "../src/Photo.vala"
				_tmp7_->gps_coords = _tmp8_;
#line 19222 "Photo.c"
			}
			goto __finally1;
			__catch1_database_error:
			{
				GError* err = NULL;
				GError* _tmp9_;
				GError* _tmp10_;
#line 2392 "../src/Photo.vala"
				err = _inner_error0_;
#line 2392 "../src/Photo.vala"
				_inner_error0_ = NULL;
#line 2396 "../src/Photo.vala"
				_tmp9_ = err;
#line 2396 "../src/Photo.vala"
				_tmp10_ = _g_error_copy0 (_tmp9_);
#line 2396 "../src/Photo.vala"
				_g_error_free0 (dberr);
#line 2396 "../src/Photo.vala"
				dberr = _tmp10_;
#line 2392 "../src/Photo.vala"
				_g_error_free0 (err);
#line 19244 "Photo.c"
			}
			__finally1:
#line 2392 "../src/Photo.vala"
			if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 2392 "../src/Photo.vala"
				_g_error_free0 (dberr);
#line 2392 "../src/Photo.vala"
				g_critical ("file %s: line %d: unexpected error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 2392 "../src/Photo.vala"
				g_clear_error (&_inner_error0_);
#line 2392 "../src/Photo.vala"
				return;
#line 19257 "Photo.c"
			}
		}
		__finally0:
		{
			PhotoRow* _tmp11_;
#line 2391 "../src/Photo.vala"
			_tmp11_ = self->row;
#line 2391 "../src/Photo.vala"
			g_rec_mutex_unlock (&self->priv->__lock_row);
#line 19267 "Photo.c"
		}
#line 2391 "../src/Photo.vala"
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 2391 "../src/Photo.vala"
			_g_error_free0 (dberr);
#line 2391 "../src/Photo.vala"
			g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 2391 "../src/Photo.vala"
			g_clear_error (&_inner_error0_);
#line 2391 "../src/Photo.vala"
			return;
#line 19279 "Photo.c"
		}
	}
#line 2399 "../src/Photo.vala"
	_tmp12_ = dberr;
#line 2399 "../src/Photo.vala"
	if (_tmp12_ == NULL) {
#line 19286 "Photo.c"
		Alteration* _tmp13_;
		Alteration* _tmp14_;
#line 2400 "../src/Photo.vala"
		_tmp13_ = alteration_new ("metadata", "gps");
#line 2400 "../src/Photo.vala"
		_tmp14_ = _tmp13_;
#line 2400 "../src/Photo.vala"
		data_object_notify_altered (G_TYPE_CHECK_INSTANCE_CAST (self, TYPE_DATA_OBJECT, DataObject), _tmp14_);
#line 2400 "../src/Photo.vala"
		_alteration_unref0 (_tmp14_);
#line 19297 "Photo.c"
	} else {
		gchar* _tmp15_;
		gchar* _tmp16_;
		GError* _tmp17_;
		const gchar* _tmp18_;
#line 2402 "../src/Photo.vala"
		_tmp15_ = data_object_to_string (G_TYPE_CHECK_INSTANCE_CAST (self, TYPE_DATA_OBJECT, DataObject));
#line 2402 "../src/Photo.vala"
		_tmp16_ = _tmp15_;
#line 2402 "../src/Photo.vala"
		_tmp17_ = dberr;
#line 2402 "../src/Photo.vala"
		_tmp18_ = _tmp17_->message;
#line 2402 "../src/Photo.vala"
		g_warning ("Photo.vala:2402: Unable to write gps coordinates for %s: %s", _tmp16_, _tmp18_);
#line 2402 "../src/Photo.vala"
		_g_free0 (_tmp16_);
#line 19315 "Photo.c"
	}
#line 2389 "../src/Photo.vala"
	_g_error_free0 (dberr);
#line 19319 "Photo.c"
}

static gboolean
photo_real_set_comment (MediaSource* base,
                        const gchar* comment)
{
	Photo * self;
	gchar* new_comment = NULL;
	gchar* _tmp0_;
	gboolean committed = FALSE;
	GError* _inner_error0_ = NULL;
	gboolean result;
#line 2406 "../src/Photo.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (base, TYPE_PHOTO, Photo);
#line 2407 "../src/Photo.vala"
	_tmp0_ = media_source_prep_comment (comment);
#line 2407 "../src/Photo.vala"
	new_comment = _tmp0_;
#line 2409 "../src/Photo.vala"
	committed = FALSE;
#line 19340 "Photo.c"
	{
		PhotoRow* _tmp1_;
#line 2410 "../src/Photo.vala"
		_tmp1_ = self->row;
#line 2410 "../src/Photo.vala"
		g_rec_mutex_lock (&self->priv->__lock_row);
#line 19347 "Photo.c"
		{
			const gchar* _tmp2_;
			PhotoRow* _tmp3_;
			const gchar* _tmp4_;
			PhotoTable* _tmp6_;
			PhotoTable* _tmp7_;
			PhotoRow* _tmp8_;
			PhotoID _tmp9_;
			const gchar* _tmp10_;
#line 2411 "../src/Photo.vala"
			_tmp2_ = new_comment;
#line 2411 "../src/Photo.vala"
			_tmp3_ = self->row;
#line 2411 "../src/Photo.vala"
			_tmp4_ = _tmp3_->comment;
#line 2411 "../src/Photo.vala"
			if (g_strcmp0 (_tmp2_, _tmp4_) == 0) {
#line 2412 "../src/Photo.vala"
				result = TRUE;
#line 19367 "Photo.c"
				{
					PhotoRow* _tmp5_;
#line 2410 "../src/Photo.vala"
					_tmp5_ = self->row;
#line 2410 "../src/Photo.vala"
					g_rec_mutex_unlock (&self->priv->__lock_row);
#line 19374 "Photo.c"
				}
#line 2412 "../src/Photo.vala"
				_g_free0 (new_comment);
#line 2412 "../src/Photo.vala"
				return result;
#line 19380 "Photo.c"
			}
#line 2414 "../src/Photo.vala"
			_tmp6_ = photo_table_get_instance ();
#line 2414 "../src/Photo.vala"
			_tmp7_ = _tmp6_;
#line 2414 "../src/Photo.vala"
			_tmp8_ = self->row;
#line 2414 "../src/Photo.vala"
			_tmp9_ = _tmp8_->photo_id;
#line 2414 "../src/Photo.vala"
			_tmp10_ = new_comment;
#line 2414 "../src/Photo.vala"
			committed = photo_table_set_comment (_tmp7_, &_tmp9_, _tmp10_);
#line 2414 "../src/Photo.vala"
			_database_table_unref0 (_tmp7_);
#line 2415 "../src/Photo.vala"
			if (committed) {
#line 19398 "Photo.c"
				PhotoRow* _tmp11_;
				const gchar* _tmp12_;
				gchar* _tmp13_;
#line 2416 "../src/Photo.vala"
				_tmp11_ = self->row;
#line 2416 "../src/Photo.vala"
				_tmp12_ = new_comment;
#line 2416 "../src/Photo.vala"
				_tmp13_ = g_strdup (_tmp12_);
#line 2416 "../src/Photo.vala"
				_g_free0 (_tmp11_->comment);
#line 2416 "../src/Photo.vala"
				_tmp11_->comment = _tmp13_;
#line 19412 "Photo.c"
			}
		}
		__finally0:
		{
			PhotoRow* _tmp14_;
#line 2410 "../src/Photo.vala"
			_tmp14_ = self->row;
#line 2410 "../src/Photo.vala"
			g_rec_mutex_unlock (&self->priv->__lock_row);
#line 19422 "Photo.c"
		}
#line 2410 "../src/Photo.vala"
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 19426 "Photo.c"
			gboolean _tmp15_ = FALSE;
#line 2410 "../src/Photo.vala"
			_g_free0 (new_comment);
#line 2410 "../src/Photo.vala"
			g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 2410 "../src/Photo.vala"
			g_clear_error (&_inner_error0_);
#line 2410 "../src/Photo.vala"
			return _tmp15_;
#line 19436 "Photo.c"
		}
	}
#line 2419 "../src/Photo.vala"
	if (committed) {
#line 19441 "Photo.c"
		Alteration* _tmp16_;
		Alteration* _tmp17_;
#line 2420 "../src/Photo.vala"
		_tmp16_ = alteration_new ("metadata", "comment");
#line 2420 "../src/Photo.vala"
		_tmp17_ = _tmp16_;
#line 2420 "../src/Photo.vala"
		data_object_notify_altered (G_TYPE_CHECK_INSTANCE_CAST (self, TYPE_DATA_OBJECT, DataObject), _tmp17_);
#line 2420 "../src/Photo.vala"
		_alteration_unref0 (_tmp17_);
#line 19452 "Photo.c"
	}
#line 2422 "../src/Photo.vala"
	result = committed;
#line 2422 "../src/Photo.vala"
	_g_free0 (new_comment);
#line 2422 "../src/Photo.vala"
	return result;
#line 19460 "Photo.c"
}

void
photo_set_import_id (Photo* self,
                     ImportID* import_id)
{
	GError* dberr = NULL;
	GError* _tmp12_;
	GError* _inner_error0_ = NULL;
#line 2425 "../src/Photo.vala"
	g_return_if_fail (IS_PHOTO (self));
#line 2425 "../src/Photo.vala"
	g_return_if_fail (import_id != NULL);
#line 2426 "../src/Photo.vala"
	dberr = NULL;
#line 19476 "Photo.c"
	{
		PhotoRow* _tmp0_;
#line 2427 "../src/Photo.vala"
		_tmp0_ = self->row;
#line 2427 "../src/Photo.vala"
		g_rec_mutex_lock (&self->priv->__lock_row);
#line 19483 "Photo.c"
		{
			{
				PhotoTable* _tmp1_;
				PhotoTable* _tmp2_;
				PhotoRow* _tmp3_;
				PhotoID _tmp4_;
				ImportID _tmp5_;
				PhotoRow* _tmp7_;
				ImportID _tmp8_;
#line 2429 "../src/Photo.vala"
				_tmp1_ = photo_table_get_instance ();
#line 2429 "../src/Photo.vala"
				_tmp2_ = _tmp1_;
#line 2429 "../src/Photo.vala"
				_tmp3_ = self->row;
#line 2429 "../src/Photo.vala"
				_tmp4_ = _tmp3_->photo_id;
#line 2429 "../src/Photo.vala"
				_tmp5_ = *import_id;
#line 2429 "../src/Photo.vala"
				photo_table_set_import_id (_tmp2_, &_tmp4_, &_tmp5_, &_inner_error0_);
#line 2429 "../src/Photo.vala"
				_database_table_unref0 (_tmp2_);
#line 2429 "../src/Photo.vala"
				if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 2429 "../src/Photo.vala"
					if (_inner_error0_->domain == DATABASE_ERROR) {
#line 19511 "Photo.c"
						goto __catch1_database_error;
					}
					{
						PhotoRow* _tmp6_;
#line 2427 "../src/Photo.vala"
						_tmp6_ = self->row;
#line 2427 "../src/Photo.vala"
						g_rec_mutex_unlock (&self->priv->__lock_row);
#line 19520 "Photo.c"
					}
#line 2429 "../src/Photo.vala"
					_g_error_free0 (dberr);
#line 2429 "../src/Photo.vala"
					g_critical ("file %s: line %d: unexpected error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 2429 "../src/Photo.vala"
					g_clear_error (&_inner_error0_);
#line 2429 "../src/Photo.vala"
					return;
#line 19530 "Photo.c"
				}
#line 2430 "../src/Photo.vala"
				_tmp7_ = self->row;
#line 2430 "../src/Photo.vala"
				_tmp8_ = *import_id;
#line 2430 "../src/Photo.vala"
				_tmp7_->import_id = _tmp8_;
#line 19538 "Photo.c"
			}
			goto __finally1;
			__catch1_database_error:
			{
				GError* err = NULL;
				GError* _tmp9_;
				GError* _tmp10_;
#line 2428 "../src/Photo.vala"
				err = _inner_error0_;
#line 2428 "../src/Photo.vala"
				_inner_error0_ = NULL;
#line 2432 "../src/Photo.vala"
				_tmp9_ = err;
#line 2432 "../src/Photo.vala"
				_tmp10_ = _g_error_copy0 (_tmp9_);
#line 2432 "../src/Photo.vala"
				_g_error_free0 (dberr);
#line 2432 "../src/Photo.vala"
				dberr = _tmp10_;
#line 2428 "../src/Photo.vala"
				_g_error_free0 (err);
#line 19560 "Photo.c"
			}
			__finally1:
#line 2428 "../src/Photo.vala"
			if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 2428 "../src/Photo.vala"
				_g_error_free0 (dberr);
#line 2428 "../src/Photo.vala"
				g_critical ("file %s: line %d: unexpected error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 2428 "../src/Photo.vala"
				g_clear_error (&_inner_error0_);
#line 2428 "../src/Photo.vala"
				return;
#line 19573 "Photo.c"
			}
		}
		__finally0:
		{
			PhotoRow* _tmp11_;
#line 2427 "../src/Photo.vala"
			_tmp11_ = self->row;
#line 2427 "../src/Photo.vala"
			g_rec_mutex_unlock (&self->priv->__lock_row);
#line 19583 "Photo.c"
		}
#line 2427 "../src/Photo.vala"
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 2427 "../src/Photo.vala"
			_g_error_free0 (dberr);
#line 2427 "../src/Photo.vala"
			g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 2427 "../src/Photo.vala"
			g_clear_error (&_inner_error0_);
#line 2427 "../src/Photo.vala"
			return;
#line 19595 "Photo.c"
		}
	}
#line 2436 "../src/Photo.vala"
	_tmp12_ = dberr;
#line 2436 "../src/Photo.vala"
	if (_tmp12_ == NULL) {
#line 19602 "Photo.c"
		Alteration* _tmp13_;
		Alteration* _tmp14_;
#line 2437 "../src/Photo.vala"
		_tmp13_ = alteration_new ("metadata", "import-id");
#line 2437 "../src/Photo.vala"
		_tmp14_ = _tmp13_;
#line 2437 "../src/Photo.vala"
		data_object_notify_altered (G_TYPE_CHECK_INSTANCE_CAST (self, TYPE_DATA_OBJECT, DataObject), _tmp14_);
#line 2437 "../src/Photo.vala"
		_alteration_unref0 (_tmp14_);
#line 19613 "Photo.c"
	} else {
		gchar* _tmp15_;
		gchar* _tmp16_;
		GError* _tmp17_;
		const gchar* _tmp18_;
#line 2439 "../src/Photo.vala"
		_tmp15_ = data_object_to_string (G_TYPE_CHECK_INSTANCE_CAST (self, TYPE_DATA_OBJECT, DataObject));
#line 2439 "../src/Photo.vala"
		_tmp16_ = _tmp15_;
#line 2439 "../src/Photo.vala"
		_tmp17_ = dberr;
#line 2439 "../src/Photo.vala"
		_tmp18_ = _tmp17_->message;
#line 2439 "../src/Photo.vala"
		g_warning ("Photo.vala:2439: Unable to write import ID for %s: %s", _tmp16_, _tmp18_);
#line 2439 "../src/Photo.vala"
		_g_free0 (_tmp16_);
#line 19631 "Photo.c"
	}
#line 2425 "../src/Photo.vala"
	_g_error_free0 (dberr);
#line 19635 "Photo.c"
}

void
photo_set_title_persistent (Photo* self,
                            const gchar* title,
                            GError** error)
{
	PhotoFileReader* source = NULL;
	PhotoFileReader* _tmp0_;
	PhotoFileReader* _tmp1_;
	PhotoMetadata* metadata = NULL;
	PhotoFileReader* _tmp5_;
	PhotoMetadata* _tmp6_;
	PhotoMetadata* _tmp7_;
	PhotoFileMetadataWriter* writer = NULL;
	PhotoFileReader* _tmp8_;
	PhotoFileMetadataWriter* _tmp9_;
	PhotoFileReader* _tmp10_;
	GFile* _tmp11_;
	GFile* _tmp12_;
	GError* _inner_error0_ = NULL;
#line 2442 "../src/Photo.vala"
	g_return_if_fail (IS_PHOTO (self));
#line 2443 "../src/Photo.vala"
	_tmp0_ = photo_get_source_reader (self);
#line 2443 "../src/Photo.vala"
	source = _tmp0_;
#line 2446 "../src/Photo.vala"
	_tmp1_ = source;
#line 2446 "../src/Photo.vala"
	if (!photo_file_format_can_write_metadata (photo_file_adapter_get_file_format (G_TYPE_CHECK_INSTANCE_CAST (_tmp1_, TYPE_PHOTO_FILE_ADAPTER, PhotoFileAdapter)))) {
#line 19667 "Photo.c"
		PhotoFileReader* _tmp2_;
		gchar* _tmp3_;
		gchar* _tmp4_;
#line 2447 "../src/Photo.vala"
		_tmp2_ = source;
#line 2447 "../src/Photo.vala"
		_tmp3_ = photo_file_adapter_get_filepath (G_TYPE_CHECK_INSTANCE_CAST (_tmp2_, TYPE_PHOTO_FILE_ADAPTER, PhotoFileAdapter));
#line 2447 "../src/Photo.vala"
		_tmp4_ = _tmp3_;
#line 2447 "../src/Photo.vala"
		g_warning ("Photo.vala:2447: No photo file writer available for %s", _tmp4_);
#line 2447 "../src/Photo.vala"
		_g_free0 (_tmp4_);
#line 2449 "../src/Photo.vala"
		media_source_set_title (G_TYPE_CHECK_INSTANCE_CAST (self, TYPE_MEDIA_SOURCE, MediaSource), title);
#line 2451 "../src/Photo.vala"
		_photo_file_adapter_unref0 (source);
#line 2451 "../src/Photo.vala"
		return;
#line 19687 "Photo.c"
	}
#line 2454 "../src/Photo.vala"
	_tmp5_ = source;
#line 2454 "../src/Photo.vala"
	_tmp6_ = photo_file_reader_read_metadata (_tmp5_, &_inner_error0_);
#line 2454 "../src/Photo.vala"
	metadata = _tmp6_;
#line 2454 "../src/Photo.vala"
	if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 2454 "../src/Photo.vala"
		g_propagate_error (error, _inner_error0_);
#line 2454 "../src/Photo.vala"
		_photo_file_adapter_unref0 (source);
#line 2454 "../src/Photo.vala"
		return;
#line 19703 "Photo.c"
	}
#line 2455 "../src/Photo.vala"
	_tmp7_ = metadata;
#line 2455 "../src/Photo.vala"
	photo_metadata_set_title (_tmp7_, title, PHOTO_METADATA_SET_OPTION_ALL_DOMAINS);
#line 2457 "../src/Photo.vala"
	_tmp8_ = source;
#line 2457 "../src/Photo.vala"
	_tmp9_ = photo_file_reader_create_metadata_writer (_tmp8_, &_inner_error0_);
#line 2457 "../src/Photo.vala"
	writer = _tmp9_;
#line 2457 "../src/Photo.vala"
	if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 2457 "../src/Photo.vala"
		g_propagate_error (error, _inner_error0_);
#line 2457 "../src/Photo.vala"
		_media_metadata_unref0 (metadata);
#line 2457 "../src/Photo.vala"
		_photo_file_adapter_unref0 (source);
#line 2457 "../src/Photo.vala"
		return;
#line 19725 "Photo.c"
	}
#line 2458 "../src/Photo.vala"
	_tmp10_ = source;
#line 2458 "../src/Photo.vala"
	_tmp11_ = photo_file_adapter_get_file (G_TYPE_CHECK_INSTANCE_CAST (_tmp10_, TYPE_PHOTO_FILE_ADAPTER, PhotoFileAdapter));
#line 2458 "../src/Photo.vala"
	_tmp12_ = _tmp11_;
#line 2458 "../src/Photo.vala"
	library_monitor_blacklist_file (_tmp12_, "Photo.set_persistent_title");
#line 2458 "../src/Photo.vala"
	_g_object_unref0 (_tmp12_);
#line 19737 "Photo.c"
	{
		PhotoFileMetadataWriter* _tmp13_;
		PhotoMetadata* _tmp14_;
#line 2460 "../src/Photo.vala"
		_tmp13_ = writer;
#line 2460 "../src/Photo.vala"
		_tmp14_ = metadata;
#line 2460 "../src/Photo.vala"
		photo_file_metadata_writer_write_metadata (_tmp13_, _tmp14_, &_inner_error0_);
#line 2460 "../src/Photo.vala"
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 19749 "Photo.c"
			goto __finally0;
		}
	}
	__finally0:
	{
		GError* _inner_error1_ = NULL;
		PhotoFileReader* _tmp15_;
		GFile* _tmp16_;
		GFile* _tmp17_;
#line 2462 "../src/Photo.vala"
		_tmp15_ = source;
#line 2462 "../src/Photo.vala"
		_tmp16_ = photo_file_adapter_get_file (G_TYPE_CHECK_INSTANCE_CAST (_tmp15_, TYPE_PHOTO_FILE_ADAPTER, PhotoFileAdapter));
#line 2462 "../src/Photo.vala"
		_tmp17_ = _tmp16_;
#line 2462 "../src/Photo.vala"
		library_monitor_unblacklist_file (_tmp17_);
#line 2462 "../src/Photo.vala"
		_g_object_unref0 (_tmp17_);
#line 19769 "Photo.c"
	}
#line 2459 "../src/Photo.vala"
	if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 2459 "../src/Photo.vala"
		g_propagate_error (error, _inner_error0_);
#line 2459 "../src/Photo.vala"
		_photo_file_adapter_unref0 (writer);
#line 2459 "../src/Photo.vala"
		_media_metadata_unref0 (metadata);
#line 2459 "../src/Photo.vala"
		_photo_file_adapter_unref0 (source);
#line 2459 "../src/Photo.vala"
		return;
#line 19783 "Photo.c"
	}
#line 2465 "../src/Photo.vala"
	media_source_set_title (G_TYPE_CHECK_INSTANCE_CAST (self, TYPE_MEDIA_SOURCE, MediaSource), title);
#line 2467 "../src/Photo.vala"
	photo_file_exif_updated (self);
#line 2442 "../src/Photo.vala"
	_photo_file_adapter_unref0 (writer);
#line 2442 "../src/Photo.vala"
	_media_metadata_unref0 (metadata);
#line 2442 "../src/Photo.vala"
	_photo_file_adapter_unref0 (source);
#line 19795 "Photo.c"
}

void
photo_set_comment_persistent (Photo* self,
                              const gchar* comment,
                              GError** error)
{
	PhotoFileReader* source = NULL;
	PhotoFileReader* _tmp0_;
	PhotoFileReader* _tmp1_;
	PhotoMetadata* metadata = NULL;
	PhotoFileReader* _tmp5_;
	PhotoMetadata* _tmp6_;
	PhotoMetadata* _tmp7_;
	PhotoFileMetadataWriter* writer = NULL;
	PhotoFileReader* _tmp8_;
	PhotoFileMetadataWriter* _tmp9_;
	PhotoFileReader* _tmp10_;
	GFile* _tmp11_;
	GFile* _tmp12_;
	GError* _inner_error0_ = NULL;
#line 2470 "../src/Photo.vala"
	g_return_if_fail (IS_PHOTO (self));
#line 2471 "../src/Photo.vala"
	_tmp0_ = photo_get_source_reader (self);
#line 2471 "../src/Photo.vala"
	source = _tmp0_;
#line 2474 "../src/Photo.vala"
	_tmp1_ = source;
#line 2474 "../src/Photo.vala"
	if (!photo_file_format_can_write_metadata (photo_file_adapter_get_file_format (G_TYPE_CHECK_INSTANCE_CAST (_tmp1_, TYPE_PHOTO_FILE_ADAPTER, PhotoFileAdapter)))) {
#line 19827 "Photo.c"
		PhotoFileReader* _tmp2_;
		gchar* _tmp3_;
		gchar* _tmp4_;
#line 2475 "../src/Photo.vala"
		_tmp2_ = source;
#line 2475 "../src/Photo.vala"
		_tmp3_ = photo_file_adapter_get_filepath (G_TYPE_CHECK_INSTANCE_CAST (_tmp2_, TYPE_PHOTO_FILE_ADAPTER, PhotoFileAdapter));
#line 2475 "../src/Photo.vala"
		_tmp4_ = _tmp3_;
#line 2475 "../src/Photo.vala"
		g_warning ("Photo.vala:2475: No photo file writer available for %s", _tmp4_);
#line 2475 "../src/Photo.vala"
		_g_free0 (_tmp4_);
#line 2477 "../src/Photo.vala"
		media_source_set_comment (G_TYPE_CHECK_INSTANCE_CAST (self, TYPE_MEDIA_SOURCE, MediaSource), comment);
#line 2479 "../src/Photo.vala"
		_photo_file_adapter_unref0 (source);
#line 2479 "../src/Photo.vala"
		return;
#line 19847 "Photo.c"
	}
#line 2482 "../src/Photo.vala"
	_tmp5_ = source;
#line 2482 "../src/Photo.vala"
	_tmp6_ = photo_file_reader_read_metadata (_tmp5_, &_inner_error0_);
#line 2482 "../src/Photo.vala"
	metadata = _tmp6_;
#line 2482 "../src/Photo.vala"
	if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 2482 "../src/Photo.vala"
		g_propagate_error (error, _inner_error0_);
#line 2482 "../src/Photo.vala"
		_photo_file_adapter_unref0 (source);
#line 2482 "../src/Photo.vala"
		return;
#line 19863 "Photo.c"
	}
#line 2483 "../src/Photo.vala"
	_tmp7_ = metadata;
#line 2483 "../src/Photo.vala"
	photo_metadata_set_comment (_tmp7_, comment, PHOTO_METADATA_SET_OPTION_ALL_DOMAINS);
#line 2485 "../src/Photo.vala"
	_tmp8_ = source;
#line 2485 "../src/Photo.vala"
	_tmp9_ = photo_file_reader_create_metadata_writer (_tmp8_, &_inner_error0_);
#line 2485 "../src/Photo.vala"
	writer = _tmp9_;
#line 2485 "../src/Photo.vala"
	if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 2485 "../src/Photo.vala"
		g_propagate_error (error, _inner_error0_);
#line 2485 "../src/Photo.vala"
		_media_metadata_unref0 (metadata);
#line 2485 "../src/Photo.vala"
		_photo_file_adapter_unref0 (source);
#line 2485 "../src/Photo.vala"
		return;
#line 19885 "Photo.c"
	}
#line 2486 "../src/Photo.vala"
	_tmp10_ = source;
#line 2486 "../src/Photo.vala"
	_tmp11_ = photo_file_adapter_get_file (G_TYPE_CHECK_INSTANCE_CAST (_tmp10_, TYPE_PHOTO_FILE_ADAPTER, PhotoFileAdapter));
#line 2486 "../src/Photo.vala"
	_tmp12_ = _tmp11_;
#line 2486 "../src/Photo.vala"
	library_monitor_blacklist_file (_tmp12_, "Photo.set_persistent_comment");
#line 2486 "../src/Photo.vala"
	_g_object_unref0 (_tmp12_);
#line 19897 "Photo.c"
	{
		PhotoFileMetadataWriter* _tmp13_;
		PhotoMetadata* _tmp14_;
#line 2488 "../src/Photo.vala"
		_tmp13_ = writer;
#line 2488 "../src/Photo.vala"
		_tmp14_ = metadata;
#line 2488 "../src/Photo.vala"
		photo_file_metadata_writer_write_metadata (_tmp13_, _tmp14_, &_inner_error0_);
#line 2488 "../src/Photo.vala"
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 19909 "Photo.c"
			goto __finally0;
		}
	}
	__finally0:
	{
		GError* _inner_error1_ = NULL;
		PhotoFileReader* _tmp15_;
		GFile* _tmp16_;
		GFile* _tmp17_;
#line 2490 "../src/Photo.vala"
		_tmp15_ = source;
#line 2490 "../src/Photo.vala"
		_tmp16_ = photo_file_adapter_get_file (G_TYPE_CHECK_INSTANCE_CAST (_tmp15_, TYPE_PHOTO_FILE_ADAPTER, PhotoFileAdapter));
#line 2490 "../src/Photo.vala"
		_tmp17_ = _tmp16_;
#line 2490 "../src/Photo.vala"
		library_monitor_unblacklist_file (_tmp17_);
#line 2490 "../src/Photo.vala"
		_g_object_unref0 (_tmp17_);
#line 19929 "Photo.c"
	}
#line 2487 "../src/Photo.vala"
	if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 2487 "../src/Photo.vala"
		g_propagate_error (error, _inner_error0_);
#line 2487 "../src/Photo.vala"
		_photo_file_adapter_unref0 (writer);
#line 2487 "../src/Photo.vala"
		_media_metadata_unref0 (metadata);
#line 2487 "../src/Photo.vala"
		_photo_file_adapter_unref0 (source);
#line 2487 "../src/Photo.vala"
		return;
#line 19943 "Photo.c"
	}
#line 2493 "../src/Photo.vala"
	media_source_set_comment (G_TYPE_CHECK_INSTANCE_CAST (self, TYPE_MEDIA_SOURCE, MediaSource), comment);
#line 2495 "../src/Photo.vala"
	photo_file_exif_updated (self);
#line 2470 "../src/Photo.vala"
	_photo_file_adapter_unref0 (writer);
#line 2470 "../src/Photo.vala"
	_media_metadata_unref0 (metadata);
#line 2470 "../src/Photo.vala"
	_photo_file_adapter_unref0 (source);
#line 19955 "Photo.c"
}

static void
photo_real_set_exposure_time (Dateable* base,
                              GDateTime* time)
{
	Photo * self;
	gboolean committed = FALSE;
	GError* _inner_error0_ = NULL;
#line 2498 "../src/Photo.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (base, TYPE_PHOTO, Photo);
#line 2498 "../src/Photo.vala"
	g_return_if_fail (time != NULL);
#line 19969 "Photo.c"
	{
		PhotoRow* _tmp0_;
#line 2500 "../src/Photo.vala"
		_tmp0_ = self->row;
#line 2500 "../src/Photo.vala"
		g_rec_mutex_lock (&self->priv->__lock_row);
#line 19976 "Photo.c"
		{
			PhotoTable* _tmp1_;
			PhotoTable* _tmp2_;
			PhotoRow* _tmp3_;
			PhotoID _tmp4_;
#line 2501 "../src/Photo.vala"
			_tmp1_ = photo_table_get_instance ();
#line 2501 "../src/Photo.vala"
			_tmp2_ = _tmp1_;
#line 2501 "../src/Photo.vala"
			_tmp3_ = self->row;
#line 2501 "../src/Photo.vala"
			_tmp4_ = _tmp3_->photo_id;
#line 2501 "../src/Photo.vala"
			committed = photo_table_set_exposure_time (_tmp2_, &_tmp4_, time);
#line 2501 "../src/Photo.vala"
			_database_table_unref0 (_tmp2_);
#line 2502 "../src/Photo.vala"
			if (committed) {
#line 19996 "Photo.c"
				PhotoRow* _tmp5_;
				GDateTime* _tmp6_;
				GDateTime* _tmp7_;
#line 2503 "../src/Photo.vala"
				_tmp5_ = self->row;
#line 2503 "../src/Photo.vala"
				_tmp6_ = _g_date_time_ref0 (time);
#line 2503 "../src/Photo.vala"
				_g_date_time_unref0 (_tmp5_->exposure_time);
#line 2503 "../src/Photo.vala"
				_tmp5_->exposure_time = _tmp6_;
#line 2504 "../src/Photo.vala"
				_tmp7_ = _g_date_time_ref0 (time);
#line 2504 "../src/Photo.vala"
				_g_date_time_unref0 (self->priv->cached_exposure_time);
#line 2504 "../src/Photo.vala"
				self->priv->cached_exposure_time = _tmp7_;
#line 20014 "Photo.c"
			}
		}
		__finally0:
		{
			PhotoRow* _tmp8_;
#line 2500 "../src/Photo.vala"
			_tmp8_ = self->row;
#line 2500 "../src/Photo.vala"
			g_rec_mutex_unlock (&self->priv->__lock_row);
#line 20024 "Photo.c"
		}
#line 2500 "../src/Photo.vala"
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 2500 "../src/Photo.vala"
			g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 2500 "../src/Photo.vala"
			g_clear_error (&_inner_error0_);
#line 2500 "../src/Photo.vala"
			return;
#line 20034 "Photo.c"
		}
	}
#line 2508 "../src/Photo.vala"
	if (committed) {
#line 20039 "Photo.c"
		Alteration* _tmp9_;
		Alteration* _tmp10_;
#line 2509 "../src/Photo.vala"
		_tmp9_ = alteration_new ("metadata", "exposure-time");
#line 2509 "../src/Photo.vala"
		_tmp10_ = _tmp9_;
#line 2509 "../src/Photo.vala"
		data_object_notify_altered (G_TYPE_CHECK_INSTANCE_CAST (self, TYPE_DATA_OBJECT, DataObject), _tmp10_);
#line 2509 "../src/Photo.vala"
		_alteration_unref0 (_tmp10_);
#line 20050 "Photo.c"
	}
}

void
photo_set_exposure_time_persistent (Photo* self,
                                    GDateTime* time,
                                    GError** error)
{
	PhotoFileReader* source = NULL;
	PhotoFileReader* _tmp0_;
	PhotoFileReader* _tmp1_;
	PhotoMetadata* metadata = NULL;
	PhotoFileReader* _tmp5_;
	PhotoMetadata* _tmp6_;
	PhotoMetadata* _tmp7_;
	MetadataDateTime* _tmp8_;
	MetadataDateTime* _tmp9_;
	PhotoFileMetadataWriter* writer = NULL;
	PhotoFileReader* _tmp10_;
	PhotoFileMetadataWriter* _tmp11_;
	PhotoFileReader* _tmp12_;
	GFile* _tmp13_;
	GFile* _tmp14_;
	GError* _inner_error0_ = NULL;
#line 2512 "../src/Photo.vala"
	g_return_if_fail (IS_PHOTO (self));
#line 2512 "../src/Photo.vala"
	g_return_if_fail (time != NULL);
#line 2513 "../src/Photo.vala"
	_tmp0_ = photo_get_source_reader (self);
#line 2513 "../src/Photo.vala"
	source = _tmp0_;
#line 2516 "../src/Photo.vala"
	_tmp1_ = source;
#line 2516 "../src/Photo.vala"
	if (!photo_file_format_can_write_metadata (photo_file_adapter_get_file_format (G_TYPE_CHECK_INSTANCE_CAST (_tmp1_, TYPE_PHOTO_FILE_ADAPTER, PhotoFileAdapter)))) {
#line 20087 "Photo.c"
		PhotoFileReader* _tmp2_;
		gchar* _tmp3_;
		gchar* _tmp4_;
#line 2517 "../src/Photo.vala"
		_tmp2_ = source;
#line 2517 "../src/Photo.vala"
		_tmp3_ = photo_file_adapter_get_filepath (G_TYPE_CHECK_INSTANCE_CAST (_tmp2_, TYPE_PHOTO_FILE_ADAPTER, PhotoFileAdapter));
#line 2517 "../src/Photo.vala"
		_tmp4_ = _tmp3_;
#line 2517 "../src/Photo.vala"
		g_warning ("Photo.vala:2517: No photo file writer available for %s", _tmp4_);
#line 2517 "../src/Photo.vala"
		_g_free0 (_tmp4_);
#line 2519 "../src/Photo.vala"
		dateable_set_exposure_time (G_TYPE_CHECK_INSTANCE_CAST (self, TYPE_DATEABLE, Dateable), time);
#line 2521 "../src/Photo.vala"
		_photo_file_adapter_unref0 (source);
#line 2521 "../src/Photo.vala"
		return;
#line 20107 "Photo.c"
	}
#line 2524 "../src/Photo.vala"
	_tmp5_ = source;
#line 2524 "../src/Photo.vala"
	_tmp6_ = photo_file_reader_read_metadata (_tmp5_, &_inner_error0_);
#line 2524 "../src/Photo.vala"
	metadata = _tmp6_;
#line 2524 "../src/Photo.vala"
	if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 2524 "../src/Photo.vala"
		g_propagate_error (error, _inner_error0_);
#line 2524 "../src/Photo.vala"
		_photo_file_adapter_unref0 (source);
#line 2524 "../src/Photo.vala"
		return;
#line 20123 "Photo.c"
	}
#line 2525 "../src/Photo.vala"
	_tmp7_ = metadata;
#line 2525 "../src/Photo.vala"
	_tmp8_ = metadata_date_time_new (time);
#line 2525 "../src/Photo.vala"
	_tmp9_ = _tmp8_;
#line 2525 "../src/Photo.vala"
	photo_metadata_set_exposure_date_time (_tmp7_, _tmp9_, PHOTO_METADATA_SET_OPTION_ALL_DOMAINS);
#line 2525 "../src/Photo.vala"
	_metadata_date_time_unref0 (_tmp9_);
#line 2527 "../src/Photo.vala"
	_tmp10_ = source;
#line 2527 "../src/Photo.vala"
	_tmp11_ = photo_file_reader_create_metadata_writer (_tmp10_, &_inner_error0_);
#line 2527 "../src/Photo.vala"
	writer = _tmp11_;
#line 2527 "../src/Photo.vala"
	if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 2527 "../src/Photo.vala"
		g_propagate_error (error, _inner_error0_);
#line 2527 "../src/Photo.vala"
		_media_metadata_unref0 (metadata);
#line 2527 "../src/Photo.vala"
		_photo_file_adapter_unref0 (source);
#line 2527 "../src/Photo.vala"
		return;
#line 20151 "Photo.c"
	}
#line 2528 "../src/Photo.vala"
	_tmp12_ = source;
#line 2528 "../src/Photo.vala"
	_tmp13_ = photo_file_adapter_get_file (G_TYPE_CHECK_INSTANCE_CAST (_tmp12_, TYPE_PHOTO_FILE_ADAPTER, PhotoFileAdapter));
#line 2528 "../src/Photo.vala"
	_tmp14_ = _tmp13_;
#line 2528 "../src/Photo.vala"
	library_monitor_blacklist_file (_tmp14_, "Photo.set_exposure_time_persistent");
#line 2528 "../src/Photo.vala"
	_g_object_unref0 (_tmp14_);
#line 20163 "Photo.c"
	{
		PhotoFileMetadataWriter* _tmp15_;
		PhotoMetadata* _tmp16_;
#line 2530 "../src/Photo.vala"
		_tmp15_ = writer;
#line 2530 "../src/Photo.vala"
		_tmp16_ = metadata;
#line 2530 "../src/Photo.vala"
		photo_file_metadata_writer_write_metadata (_tmp15_, _tmp16_, &_inner_error0_);
#line 2530 "../src/Photo.vala"
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 20175 "Photo.c"
			goto __finally0;
		}
	}
	__finally0:
	{
		GError* _inner_error1_ = NULL;
		PhotoFileReader* _tmp17_;
		GFile* _tmp18_;
		GFile* _tmp19_;
#line 2532 "../src/Photo.vala"
		_tmp17_ = source;
#line 2532 "../src/Photo.vala"
		_tmp18_ = photo_file_adapter_get_file (G_TYPE_CHECK_INSTANCE_CAST (_tmp17_, TYPE_PHOTO_FILE_ADAPTER, PhotoFileAdapter));
#line 2532 "../src/Photo.vala"
		_tmp19_ = _tmp18_;
#line 2532 "../src/Photo.vala"
		library_monitor_unblacklist_file (_tmp19_);
#line 2532 "../src/Photo.vala"
		_g_object_unref0 (_tmp19_);
#line 20195 "Photo.c"
	}
#line 2529 "../src/Photo.vala"
	if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 2529 "../src/Photo.vala"
		g_propagate_error (error, _inner_error0_);
#line 2529 "../src/Photo.vala"
		_photo_file_adapter_unref0 (writer);
#line 2529 "../src/Photo.vala"
		_media_metadata_unref0 (metadata);
#line 2529 "../src/Photo.vala"
		_photo_file_adapter_unref0 (source);
#line 2529 "../src/Photo.vala"
		return;
#line 20209 "Photo.c"
	}
#line 2535 "../src/Photo.vala"
	dateable_set_exposure_time (G_TYPE_CHECK_INSTANCE_CAST (self, TYPE_DATEABLE, Dateable), time);
#line 2537 "../src/Photo.vala"
	photo_file_exif_updated (self);
#line 2512 "../src/Photo.vala"
	_photo_file_adapter_unref0 (writer);
#line 2512 "../src/Photo.vala"
	_media_metadata_unref0 (metadata);
#line 2512 "../src/Photo.vala"
	_photo_file_adapter_unref0 (source);
#line 20221 "Photo.c"
}

/**
     * @brief Returns the width and height of the Photo after various
     * arbitrary stages of the pipeline have been applied in
     * the same order they're applied in get_pixbuf_with_options.
     * With no argument passed, it works exactly like the
     * previous incarnation did.
     *
     * @param disallowed_steps Which pipeline steps should NOT
     *      be taken into account when computing image dimensions
     *      (matching the convention set by get_pixbuf_with_options()).
     *      Pipeline steps that do not affect the image geometry are
     *      ignored.
     */
static void
photo_real_get_dimensions (MediaSource* base,
                           PhotoException disallowed_steps,
                           Dimensions* result)
{
	Photo * self;
	Dimensions returned_dims = {0};
	Dimensions _tmp0_ = {0};
#line 2553 "../src/Photo.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (base, TYPE_PHOTO, Photo);
#line 2555 "../src/Photo.vala"
	photo_get_raw_dimensions (self, &_tmp0_);
#line 2555 "../src/Photo.vala"
	returned_dims = _tmp0_;
#line 2558 "../src/Photo.vala"
	if (photo_exception_allows (disallowed_steps, PHOTO_EXCEPTION_ORIENTATION)) {
#line 20253 "Photo.c"
		Orientation ori_tmp = 0;
#line 2559 "../src/Photo.vala"
		ori_tmp = photo_get_orientation (self);
#line 2562 "../src/Photo.vala"
		switch (ori_tmp) {
#line 2562 "../src/Photo.vala"
			case ORIENTATION_LEFT_TOP:
#line 2562 "../src/Photo.vala"
			case ORIENTATION_RIGHT_TOP:
#line 2562 "../src/Photo.vala"
			case ORIENTATION_LEFT_BOTTOM:
#line 2562 "../src/Photo.vala"
			case ORIENTATION_RIGHT_BOTTOM:
#line 20267 "Photo.c"
			{
				gint width_tmp = 0;
				Dimensions _tmp1_;
				Dimensions _tmp2_;
#line 2568 "../src/Photo.vala"
				_tmp1_ = returned_dims;
#line 2568 "../src/Photo.vala"
				width_tmp = _tmp1_.width;
#line 2570 "../src/Photo.vala"
				_tmp2_ = returned_dims;
#line 2570 "../src/Photo.vala"
				returned_dims.width = _tmp2_.height;
#line 2571 "../src/Photo.vala"
				returned_dims.height = width_tmp;
#line 2572 "../src/Photo.vala"
				break;
#line 20284 "Photo.c"
			}
			default:
			{
#line 2576 "../src/Photo.vala"
				break;
#line 20290 "Photo.c"
			}
		}
	}
#line 2581 "../src/Photo.vala"
	if (photo_exception_allows (disallowed_steps, PHOTO_EXCEPTION_STRAIGHTEN)) {
#line 20296 "Photo.c"
		gdouble x_size = 0.0;
		gdouble y_size = 0.0;
		gdouble angle = 0.0;
		gdouble _tmp3_ = 0.0;
		Dimensions _tmp4_;
		Dimensions _tmp5_;
		gdouble _tmp6_ = 0.0;
		gdouble _tmp7_ = 0.0;
#line 2583 "../src/Photo.vala"
		angle = 0.0;
#line 2585 "../src/Photo.vala"
		photo_get_straighten (self, &_tmp3_);
#line 2585 "../src/Photo.vala"
		angle = _tmp3_;
#line 2587 "../src/Photo.vala"
		_tmp4_ = returned_dims;
#line 2587 "../src/Photo.vala"
		_tmp5_ = returned_dims;
#line 2587 "../src/Photo.vala"
		compute_arb_rotated_size ((gdouble) _tmp4_.width, (gdouble) _tmp5_.height, angle, &_tmp6_, &_tmp7_);
#line 2587 "../src/Photo.vala"
		x_size = _tmp6_;
#line 2587 "../src/Photo.vala"
		y_size = _tmp7_;
#line 2589 "../src/Photo.vala"
		returned_dims.width = (gint) x_size;
#line 2590 "../src/Photo.vala"
		returned_dims.height = (gint) y_size;
#line 20325 "Photo.c"
	}
#line 2594 "../src/Photo.vala"
	if (photo_exception_allows (disallowed_steps, PHOTO_EXCEPTION_CROP)) {
#line 20329 "Photo.c"
		Box crop = {0};
		Box _tmp8_ = {0};
		gboolean _tmp9_;
#line 2596 "../src/Photo.vala"
		_tmp9_ = photo_get_crop (self, &_tmp8_, disallowed_steps);
#line 2596 "../src/Photo.vala"
		crop = _tmp8_;
#line 2596 "../src/Photo.vala"
		if (_tmp9_) {
#line 20339 "Photo.c"
			Dimensions _tmp10_ = {0};
#line 2597 "../src/Photo.vala"
			box_get_dimensions (&crop, &_tmp10_);
#line 2597 "../src/Photo.vala"
			returned_dims = _tmp10_;
#line 20345 "Photo.c"
		}
	}
#line 2600 "../src/Photo.vala"
	*result = returned_dims;
#line 2600 "../src/Photo.vala"
	return;
#line 20352 "Photo.c"
}

static void
photo_locked_create_adjustments_from_data (Photo* self)
{
	PixelTransformationBundle* _tmp0_;
	KeyValueMap* map = NULL;
	KeyValueMap* _tmp1_;
	KeyValueMap* _tmp2_;
	PixelTransformationBundle* _tmp6_;
	PixelTransformer* _tmp7_;
#line 2604 "../src/Photo.vala"
	g_return_if_fail (IS_PHOTO (self));
#line 2605 "../src/Photo.vala"
	_tmp0_ = pixel_transformation_bundle_new ();
#line 2605 "../src/Photo.vala"
	_pixel_transformation_bundle_unref0 (self->priv->adjustments);
#line 2605 "../src/Photo.vala"
	self->priv->adjustments = _tmp0_;
#line 2607 "../src/Photo.vala"
	_tmp1_ = photo_get_transformation (self, "adjustments");
#line 2607 "../src/Photo.vala"
	map = _tmp1_;
#line 2608 "../src/Photo.vala"
	_tmp2_ = map;
#line 2608 "../src/Photo.vala"
	if (_tmp2_ == NULL) {
#line 20380 "Photo.c"
		PixelTransformationBundle* _tmp3_;
#line 2609 "../src/Photo.vala"
		_tmp3_ = self->priv->adjustments;
#line 2609 "../src/Photo.vala"
		pixel_transformation_bundle_set_to_identity (_tmp3_);
#line 20386 "Photo.c"
	} else {
		PixelTransformationBundle* _tmp4_;
		KeyValueMap* _tmp5_;
#line 2611 "../src/Photo.vala"
		_tmp4_ = self->priv->adjustments;
#line 2611 "../src/Photo.vala"
		_tmp5_ = map;
#line 2611 "../src/Photo.vala"
		pixel_transformation_bundle_load (_tmp4_, _tmp5_);
#line 20396 "Photo.c"
	}
#line 2613 "../src/Photo.vala"
	_tmp6_ = self->priv->adjustments;
#line 2613 "../src/Photo.vala"
	_tmp7_ = pixel_transformation_bundle_generate_transformer (_tmp6_);
#line 2613 "../src/Photo.vala"
	_pixel_transformer_unref0 (self->priv->transformer);
#line 2613 "../src/Photo.vala"
	self->priv->transformer = _tmp7_;
#line 2604 "../src/Photo.vala"
	_key_value_map_unref0 (map);
#line 20408 "Photo.c"
}

PixelTransformationBundle*
photo_get_color_adjustments (Photo* self)
{
	GError* _inner_error0_ = NULL;
	PixelTransformationBundle* result;
#line 2617 "../src/Photo.vala"
	g_return_val_if_fail (IS_PHOTO (self), NULL);
#line 20418 "Photo.c"
	{
		PhotoRow* _tmp0_;
#line 2618 "../src/Photo.vala"
		_tmp0_ = self->row;
#line 2618 "../src/Photo.vala"
		g_rec_mutex_lock (&self->priv->__lock_row);
#line 20425 "Photo.c"
		{
			PixelTransformationBundle* _tmp1_;
			PixelTransformationBundle* _tmp2_;
			PixelTransformationBundle* _tmp3_;
#line 2619 "../src/Photo.vala"
			_tmp1_ = self->priv->adjustments;
#line 2619 "../src/Photo.vala"
			if (_tmp1_ == NULL) {
#line 2620 "../src/Photo.vala"
				photo_locked_create_adjustments_from_data (self);
#line 20436 "Photo.c"
			}
#line 2622 "../src/Photo.vala"
			_tmp2_ = self->priv->adjustments;
#line 2622 "../src/Photo.vala"
			_tmp3_ = pixel_transformation_bundle_copy (_tmp2_);
#line 2622 "../src/Photo.vala"
			result = _tmp3_;
#line 20444 "Photo.c"
			{
				PhotoRow* _tmp4_;
#line 2618 "../src/Photo.vala"
				_tmp4_ = self->row;
#line 2618 "../src/Photo.vala"
				g_rec_mutex_unlock (&self->priv->__lock_row);
#line 20451 "Photo.c"
			}
#line 2622 "../src/Photo.vala"
			return result;
#line 20455 "Photo.c"
		}
		__finally0:
		{
			PhotoRow* _tmp5_;
#line 2618 "../src/Photo.vala"
			_tmp5_ = self->row;
#line 2618 "../src/Photo.vala"
			g_rec_mutex_unlock (&self->priv->__lock_row);
#line 20464 "Photo.c"
		}
#line 2618 "../src/Photo.vala"
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 2618 "../src/Photo.vala"
		g_clear_error (&_inner_error0_);
#line 2618 "../src/Photo.vala"
		return NULL;
#line 20472 "Photo.c"
	}
}

PixelTransformer*
photo_get_pixel_transformer (Photo* self)
{
	GError* _inner_error0_ = NULL;
	PixelTransformer* result;
#line 2626 "../src/Photo.vala"
	g_return_val_if_fail (IS_PHOTO (self), NULL);
#line 20483 "Photo.c"
	{
		PhotoRow* _tmp0_;
#line 2627 "../src/Photo.vala"
		_tmp0_ = self->row;
#line 2627 "../src/Photo.vala"
		g_rec_mutex_lock (&self->priv->__lock_row);
#line 20490 "Photo.c"
		{
			PixelTransformer* _tmp1_;
			PixelTransformer* _tmp2_;
			PixelTransformer* _tmp3_;
#line 2628 "../src/Photo.vala"
			_tmp1_ = self->priv->transformer;
#line 2628 "../src/Photo.vala"
			if (_tmp1_ == NULL) {
#line 2629 "../src/Photo.vala"
				photo_locked_create_adjustments_from_data (self);
#line 20501 "Photo.c"
			}
#line 2631 "../src/Photo.vala"
			_tmp2_ = self->priv->transformer;
#line 2631 "../src/Photo.vala"
			_tmp3_ = pixel_transformer_copy (_tmp2_);
#line 2631 "../src/Photo.vala"
			result = _tmp3_;
#line 20509 "Photo.c"
			{
				PhotoRow* _tmp4_;
#line 2627 "../src/Photo.vala"
				_tmp4_ = self->row;
#line 2627 "../src/Photo.vala"
				g_rec_mutex_unlock (&self->priv->__lock_row);
#line 20516 "Photo.c"
			}
#line 2631 "../src/Photo.vala"
			return result;
#line 20520 "Photo.c"
		}
		__finally0:
		{
			PhotoRow* _tmp5_;
#line 2627 "../src/Photo.vala"
			_tmp5_ = self->row;
#line 2627 "../src/Photo.vala"
			g_rec_mutex_unlock (&self->priv->__lock_row);
#line 20529 "Photo.c"
		}
#line 2627 "../src/Photo.vala"
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 2627 "../src/Photo.vala"
		g_clear_error (&_inner_error0_);
#line 2627 "../src/Photo.vala"
		return NULL;
#line 20537 "Photo.c"
	}
}

gboolean
photo_has_color_adjustments (Photo* self)
{
	gboolean result;
#line 2635 "../src/Photo.vala"
	g_return_val_if_fail (IS_PHOTO (self), FALSE);
#line 2636 "../src/Photo.vala"
	result = photo_has_transformation (self, "adjustments");
#line 2636 "../src/Photo.vala"
	return result;
#line 20551 "Photo.c"
}

PixelTransformation*
photo_get_color_adjustment (Photo* self,
                            PixelTransformationType type)
{
	PixelTransformationBundle* _tmp0_;
	PixelTransformationBundle* _tmp1_;
	PixelTransformation* _tmp2_;
	PixelTransformation* _tmp3_;
	PixelTransformation* result;
#line 2639 "../src/Photo.vala"
	g_return_val_if_fail (IS_PHOTO (self), NULL);
#line 2640 "../src/Photo.vala"
	_tmp0_ = photo_get_color_adjustments (self);
#line 2640 "../src/Photo.vala"
	_tmp1_ = _tmp0_;
#line 2640 "../src/Photo.vala"
	_tmp2_ = pixel_transformation_bundle_get_transformation (_tmp1_, type);
#line 2640 "../src/Photo.vala"
	_tmp3_ = _tmp2_;
#line 2640 "../src/Photo.vala"
	_pixel_transformation_bundle_unref0 (_tmp1_);
#line 2640 "../src/Photo.vala"
	result = _tmp3_;
#line 2640 "../src/Photo.vala"
	return result;
#line 20579 "Photo.c"
}

void
photo_set_color_adjustments (Photo* self,
                             PixelTransformationBundle* new_adjustments)
{
	KeyValueMap* map = NULL;
	KeyValueMap* _tmp4_;
	gboolean committed = FALSE;
	GError* _inner_error0_ = NULL;
#line 2643 "../src/Photo.vala"
	g_return_if_fail (IS_PHOTO (self));
#line 2643 "../src/Photo.vala"
	g_return_if_fail (G_TYPE_CHECK_INSTANCE_TYPE (new_adjustments, TYPE_PIXEL_TRANSFORMATION_BUNDLE));
#line 2646 "../src/Photo.vala"
	if (pixel_transformation_bundle_is_identity (new_adjustments)) {
#line 20596 "Photo.c"
		gboolean _result_ = FALSE;
		{
			PhotoRow* _tmp0_;
#line 2648 "../src/Photo.vala"
			_tmp0_ = self->row;
#line 2648 "../src/Photo.vala"
			g_rec_mutex_lock (&self->priv->__lock_row);
#line 20604 "Photo.c"
			{
#line 2649 "../src/Photo.vala"
				_result_ = photo_remove_transformation (self, "adjustments");
#line 2650 "../src/Photo.vala"
				_pixel_transformation_bundle_unref0 (self->priv->adjustments);
#line 2650 "../src/Photo.vala"
				self->priv->adjustments = NULL;
#line 2651 "../src/Photo.vala"
				_pixel_transformer_unref0 (self->priv->transformer);
#line 2651 "../src/Photo.vala"
				self->priv->transformer = NULL;
#line 20616 "Photo.c"
			}
			__finally0:
			{
				PhotoRow* _tmp1_;
#line 2648 "../src/Photo.vala"
				_tmp1_ = self->row;
#line 2648 "../src/Photo.vala"
				g_rec_mutex_unlock (&self->priv->__lock_row);
#line 20625 "Photo.c"
			}
#line 2648 "../src/Photo.vala"
			if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 2648 "../src/Photo.vala"
				g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 2648 "../src/Photo.vala"
				g_clear_error (&_inner_error0_);
#line 2648 "../src/Photo.vala"
				return;
#line 20635 "Photo.c"
			}
		}
#line 2654 "../src/Photo.vala"
		if (_result_) {
#line 20640 "Photo.c"
			Alteration* _tmp2_;
			Alteration* _tmp3_;
#line 2655 "../src/Photo.vala"
			_tmp2_ = alteration_new ("image", "color-adjustments");
#line 2655 "../src/Photo.vala"
			_tmp3_ = _tmp2_;
#line 2655 "../src/Photo.vala"
			data_object_notify_altered (G_TYPE_CHECK_INSTANCE_CAST (self, TYPE_DATA_OBJECT, DataObject), _tmp3_);
#line 2655 "../src/Photo.vala"
			_alteration_unref0 (_tmp3_);
#line 20651 "Photo.c"
		}
#line 2657 "../src/Photo.vala"
		return;
#line 20655 "Photo.c"
	}
#line 2661 "../src/Photo.vala"
	_tmp4_ = pixel_transformation_bundle_save (new_adjustments, "adjustments");
#line 2661 "../src/Photo.vala"
	map = _tmp4_;
#line 20661 "Photo.c"
	{
		PhotoRow* _tmp5_;
#line 2664 "../src/Photo.vala"
		_tmp5_ = self->row;
#line 2664 "../src/Photo.vala"
		g_rec_mutex_lock (&self->priv->__lock_row);
#line 20668 "Photo.c"
		{
			gboolean _tmp6_ = FALSE;
			PixelTransformer* _tmp7_;
			KeyValueMap* _tmp25_;
#line 2665 "../src/Photo.vala"
			_tmp7_ = self->priv->transformer;
#line 2665 "../src/Photo.vala"
			if (_tmp7_ == NULL) {
#line 2665 "../src/Photo.vala"
				_tmp6_ = TRUE;
#line 20679 "Photo.c"
			} else {
				PixelTransformationBundle* _tmp8_;
#line 2665 "../src/Photo.vala"
				_tmp8_ = self->priv->adjustments;
#line 2665 "../src/Photo.vala"
				_tmp6_ = _tmp8_ == NULL;
#line 20686 "Photo.c"
			}
#line 2665 "../src/Photo.vala"
			if (_tmp6_) {
#line 20690 "Photo.c"
				PixelTransformationBundle* _tmp9_;
				PixelTransformer* _tmp10_;
#line 2667 "../src/Photo.vala"
				_tmp9_ = pixel_transformation_bundle_copy (new_adjustments);
#line 2667 "../src/Photo.vala"
				_pixel_transformation_bundle_unref0 (self->priv->adjustments);
#line 2667 "../src/Photo.vala"
				self->priv->adjustments = _tmp9_;
#line 2668 "../src/Photo.vala"
				_tmp10_ = pixel_transformation_bundle_generate_transformer (new_adjustments);
#line 2668 "../src/Photo.vala"
				_pixel_transformer_unref0 (self->priv->transformer);
#line 2668 "../src/Photo.vala"
				self->priv->transformer = _tmp10_;
#line 20705 "Photo.c"
			} else {
				PixelTransformationBundle* _tmp24_;
				{
					GeeIterator* _transformation_it = NULL;
					GeeIterable* _tmp11_;
					GeeIterable* _tmp12_;
					GeeIterator* _tmp13_;
					GeeIterator* _tmp14_;
#line 2671 "../src/Photo.vala"
					_tmp11_ = pixel_transformation_bundle_get_transformations (new_adjustments);
#line 2671 "../src/Photo.vala"
					_tmp12_ = _tmp11_;
#line 2671 "../src/Photo.vala"
					_tmp13_ = gee_iterable_iterator (_tmp12_);
#line 2671 "../src/Photo.vala"
					_tmp14_ = _tmp13_;
#line 2671 "../src/Photo.vala"
					_g_object_unref0 (_tmp12_);
#line 2671 "../src/Photo.vala"
					_transformation_it = _tmp14_;
#line 2671 "../src/Photo.vala"
					while (TRUE) {
#line 20728 "Photo.c"
						GeeIterator* _tmp15_;
						PixelTransformation* transformation = NULL;
						GeeIterator* _tmp16_;
						gpointer _tmp17_;
						PixelTransformer* _tmp18_;
						PixelTransformationBundle* _tmp19_;
						PixelTransformation* _tmp20_;
						PixelTransformation* _tmp21_;
						PixelTransformation* _tmp22_;
						PixelTransformation* _tmp23_;
#line 2671 "../src/Photo.vala"
						_tmp15_ = _transformation_it;
#line 2671 "../src/Photo.vala"
						if (!gee_iterator_next (_tmp15_)) {
#line 2671 "../src/Photo.vala"
							break;
#line 20745 "Photo.c"
						}
#line 2671 "../src/Photo.vala"
						_tmp16_ = _transformation_it;
#line 2671 "../src/Photo.vala"
						_tmp17_ = gee_iterator_get (_tmp16_);
#line 2671 "../src/Photo.vala"
						transformation = (PixelTransformation*) _tmp17_;
#line 2672 "../src/Photo.vala"
						_tmp18_ = self->priv->transformer;
#line 2672 "../src/Photo.vala"
						_tmp19_ = self->priv->adjustments;
#line 2672 "../src/Photo.vala"
						_tmp20_ = transformation;
#line 2672 "../src/Photo.vala"
						_tmp21_ = pixel_transformation_bundle_get_transformation (_tmp19_, pixel_transformation_get_transformation_type (_tmp20_));
#line 2672 "../src/Photo.vala"
						_tmp22_ = _tmp21_;
#line 2672 "../src/Photo.vala"
						_tmp23_ = transformation;
#line 2672 "../src/Photo.vala"
						pixel_transformer_replace_transformation (_tmp18_, _tmp22_, _tmp23_);
#line 2672 "../src/Photo.vala"
						_pixel_transformation_unref0 (_tmp22_);
#line 2671 "../src/Photo.vala"
						_pixel_transformation_unref0 (transformation);
#line 20771 "Photo.c"
					}
#line 2671 "../src/Photo.vala"
					_g_object_unref0 (_transformation_it);
#line 20775 "Photo.c"
				}
#line 2677 "../src/Photo.vala"
				_tmp24_ = pixel_transformation_bundle_copy (new_adjustments);
#line 2677 "../src/Photo.vala"
				_pixel_transformation_bundle_unref0 (self->priv->adjustments);
#line 2677 "../src/Photo.vala"
				self->priv->adjustments = _tmp24_;
#line 20783 "Photo.c"
			}
#line 2680 "../src/Photo.vala"
			_tmp25_ = map;
#line 2680 "../src/Photo.vala"
			committed = photo_set_transformation (self, _tmp25_);
#line 20789 "Photo.c"
		}
		__finally1:
		{
			PhotoRow* _tmp26_;
#line 2664 "../src/Photo.vala"
			_tmp26_ = self->row;
#line 2664 "../src/Photo.vala"
			g_rec_mutex_unlock (&self->priv->__lock_row);
#line 20798 "Photo.c"
		}
#line 2664 "../src/Photo.vala"
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 2664 "../src/Photo.vala"
			_key_value_map_unref0 (map);
#line 2664 "../src/Photo.vala"
			g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 2664 "../src/Photo.vala"
			g_clear_error (&_inner_error0_);
#line 2664 "../src/Photo.vala"
			return;
#line 20810 "Photo.c"
		}
	}
#line 2683 "../src/Photo.vala"
	if (committed) {
#line 20815 "Photo.c"
		Alteration* _tmp27_;
		Alteration* _tmp28_;
#line 2684 "../src/Photo.vala"
		_tmp27_ = alteration_new ("image", "color-adjustments");
#line 2684 "../src/Photo.vala"
		_tmp28_ = _tmp27_;
#line 2684 "../src/Photo.vala"
		data_object_notify_altered (G_TYPE_CHECK_INSTANCE_CAST (self, TYPE_DATA_OBJECT, DataObject), _tmp28_);
#line 2684 "../src/Photo.vala"
		_alteration_unref0 (_tmp28_);
#line 20826 "Photo.c"
	}
#line 2643 "../src/Photo.vala"
	_key_value_map_unref0 (map);
#line 20830 "Photo.c"
}

static PhotoMetadata*
photo_real_get_metadata (PhotoSource* base)
{
	Photo * self;
	GError* _inner_error0_ = NULL;
	PhotoMetadata* result;
#line 2688 "../src/Photo.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (base, TYPE_PHOTO, Photo);
#line 20841 "Photo.c"
	{
		PhotoMetadata* _tmp0_ = NULL;
		PhotoFileReader* _tmp1_;
		PhotoFileReader* _tmp2_;
		PhotoMetadata* _tmp3_;
		PhotoMetadata* _tmp4_;
		PhotoMetadata* _tmp5_;
#line 2690 "../src/Photo.vala"
		_tmp1_ = photo_get_source_reader (self);
#line 2690 "../src/Photo.vala"
		_tmp2_ = _tmp1_;
#line 2690 "../src/Photo.vala"
		_tmp3_ = photo_file_reader_read_metadata (_tmp2_, &_inner_error0_);
#line 2690 "../src/Photo.vala"
		_tmp4_ = _tmp3_;
#line 2690 "../src/Photo.vala"
		_photo_file_adapter_unref0 (_tmp2_);
#line 2690 "../src/Photo.vala"
		_tmp0_ = _tmp4_;
#line 2690 "../src/Photo.vala"
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 20863 "Photo.c"
			goto __catch0_g_error;
		}
#line 2690 "../src/Photo.vala"
		_tmp5_ = _tmp0_;
#line 2690 "../src/Photo.vala"
		_tmp0_ = NULL;
#line 2690 "../src/Photo.vala"
		result = _tmp5_;
#line 2690 "../src/Photo.vala"
		_media_metadata_unref0 (_tmp0_);
#line 2690 "../src/Photo.vala"
		return result;
#line 20876 "Photo.c"
	}
	goto __finally0;
	__catch0_g_error:
	{
		GError* err = NULL;
		GError* _tmp6_;
		const gchar* _tmp7_;
#line 2689 "../src/Photo.vala"
		err = _inner_error0_;
#line 2689 "../src/Photo.vala"
		_inner_error0_ = NULL;
#line 2692 "../src/Photo.vala"
		_tmp6_ = err;
#line 2692 "../src/Photo.vala"
		_tmp7_ = _tmp6_->message;
#line 2692 "../src/Photo.vala"
		g_warning ("Photo.vala:2692: Unable to load metadata: %s", _tmp7_);
#line 2694 "../src/Photo.vala"
		result = NULL;
#line 2694 "../src/Photo.vala"
		_g_error_free0 (err);
#line 2694 "../src/Photo.vala"
		return result;
#line 20900 "Photo.c"
	}
	__finally0:
#line 2689 "../src/Photo.vala"
	g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 2689 "../src/Photo.vala"
	g_clear_error (&_inner_error0_);
#line 2689 "../src/Photo.vala"
	return NULL;
#line 20909 "Photo.c"
}

PhotoMetadata*
photo_get_master_metadata (Photo* self,
                           GError** error)
{
	PhotoMetadata* _tmp0_ = NULL;
	PhotoFileReader* _tmp1_;
	PhotoFileReader* _tmp2_;
	PhotoMetadata* _tmp3_;
	PhotoMetadata* _tmp4_;
	PhotoMetadata* _tmp5_;
	GError* _inner_error0_ = NULL;
	PhotoMetadata* result;
#line 2698 "../src/Photo.vala"
	g_return_val_if_fail (IS_PHOTO (self), NULL);
#line 2699 "../src/Photo.vala"
	_tmp1_ = photo_get_master_reader (self);
#line 2699 "../src/Photo.vala"
	_tmp2_ = _tmp1_;
#line 2699 "../src/Photo.vala"
	_tmp3_ = photo_file_reader_read_metadata (_tmp2_, &_inner_error0_);
#line 2699 "../src/Photo.vala"
	_tmp4_ = _tmp3_;
#line 2699 "../src/Photo.vala"
	_photo_file_adapter_unref0 (_tmp2_);
#line 2699 "../src/Photo.vala"
	_tmp0_ = _tmp4_;
#line 2699 "../src/Photo.vala"
	if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 2699 "../src/Photo.vala"
		g_propagate_error (error, _inner_error0_);
#line 2699 "../src/Photo.vala"
		return NULL;
#line 20944 "Photo.c"
	}
#line 2699 "../src/Photo.vala"
	_tmp5_ = _tmp0_;
#line 2699 "../src/Photo.vala"
	_tmp0_ = NULL;
#line 2699 "../src/Photo.vala"
	result = _tmp5_;
#line 2699 "../src/Photo.vala"
	_media_metadata_unref0 (_tmp0_);
#line 2699 "../src/Photo.vala"
	return result;
#line 20956 "Photo.c"
}

PhotoMetadata*
photo_get_editable_metadata (Photo* self,
                             GError** error)
{
	PhotoFileReader* reader = NULL;
	PhotoFileReader* _tmp0_;
	PhotoMetadata* _tmp1_ = NULL;
	PhotoFileReader* _tmp2_;
	GError* _inner_error0_ = NULL;
	PhotoMetadata* result;
#line 2702 "../src/Photo.vala"
	g_return_val_if_fail (IS_PHOTO (self), NULL);
#line 2703 "../src/Photo.vala"
	_tmp0_ = photo_get_editable_reader (self);
#line 2703 "../src/Photo.vala"
	reader = _tmp0_;
#line 2705 "../src/Photo.vala"
	_tmp2_ = reader;
#line 2705 "../src/Photo.vala"
	if (_tmp2_ != NULL) {
#line 20979 "Photo.c"
		PhotoFileReader* _tmp3_;
		PhotoMetadata* _tmp4_;
#line 2705 "../src/Photo.vala"
		_tmp3_ = reader;
#line 2705 "../src/Photo.vala"
		_tmp4_ = photo_file_reader_read_metadata (_tmp3_, &_inner_error0_);
#line 2705 "../src/Photo.vala"
		_media_metadata_unref0 (_tmp1_);
#line 2705 "../src/Photo.vala"
		_tmp1_ = _tmp4_;
#line 2705 "../src/Photo.vala"
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 2705 "../src/Photo.vala"
			g_propagate_error (error, _inner_error0_);
#line 2705 "../src/Photo.vala"
			_media_metadata_unref0 (_tmp1_);
#line 2705 "../src/Photo.vala"
			_photo_file_adapter_unref0 (reader);
#line 2705 "../src/Photo.vala"
			return NULL;
#line 21000 "Photo.c"
		}
	} else {
#line 2705 "../src/Photo.vala"
		_media_metadata_unref0 (_tmp1_);
#line 2705 "../src/Photo.vala"
		_tmp1_ = NULL;
#line 21007 "Photo.c"
	}
#line 2705 "../src/Photo.vala"
	result = _tmp1_;
#line 2705 "../src/Photo.vala"
	_photo_file_adapter_unref0 (reader);
#line 2705 "../src/Photo.vala"
	return result;
#line 21015 "Photo.c"
}

gboolean
photo_persist_master_metadata (Photo* self,
                               PhotoMetadata* metadata,
                               PhotoReimportMasterState** state,
                               GError** error)
{
	PhotoReimportMasterState* _vala_state = NULL;
	PhotoFileReader* master_reader = NULL;
	PhotoFileReader* _tmp0_;
	PhotoFileReader* _tmp1_;
	PhotoFileMetadataWriter* _tmp2_ = NULL;
	PhotoFileReader* _tmp3_;
	PhotoFileMetadataWriter* _tmp4_;
	gboolean _tmp7_ = FALSE;
	PhotoReimportMasterState* _tmp8_ = NULL;
	gboolean _tmp9_;
	PhotoReimportMasterState* _tmp11_;
	GError* _inner_error0_ = NULL;
	gboolean result;
#line 2711 "../src/Photo.vala"
	g_return_val_if_fail (IS_PHOTO (self), FALSE);
#line 2711 "../src/Photo.vala"
	g_return_val_if_fail (IS_PHOTO_METADATA (metadata), FALSE);
#line 2713 "../src/Photo.vala"
	_photo_reimport_master_state_unref0 (_vala_state);
#line 2713 "../src/Photo.vala"
	_vala_state = NULL;
#line 2715 "../src/Photo.vala"
	_tmp0_ = photo_get_master_reader (self);
#line 2715 "../src/Photo.vala"
	master_reader = _tmp0_;
#line 2717 "../src/Photo.vala"
	_tmp1_ = master_reader;
#line 2717 "../src/Photo.vala"
	if (!photo_file_format_can_write_metadata (photo_file_adapter_get_file_format (G_TYPE_CHECK_INSTANCE_CAST (_tmp1_, TYPE_PHOTO_FILE_ADAPTER, PhotoFileAdapter)))) {
#line 2718 "../src/Photo.vala"
		result = FALSE;
#line 2718 "../src/Photo.vala"
		_photo_file_adapter_unref0 (master_reader);
#line 2718 "../src/Photo.vala"
		if (state) {
#line 2718 "../src/Photo.vala"
			*state = _vala_state;
#line 21061 "Photo.c"
		} else {
#line 2718 "../src/Photo.vala"
			_photo_reimport_master_state_unref0 (_vala_state);
#line 21065 "Photo.c"
		}
#line 2718 "../src/Photo.vala"
		return result;
#line 21069 "Photo.c"
	}
#line 2720 "../src/Photo.vala"
	_tmp3_ = master_reader;
#line 2720 "../src/Photo.vala"
	_tmp4_ = photo_file_reader_create_metadata_writer (_tmp3_, &_inner_error0_);
#line 2720 "../src/Photo.vala"
	_tmp2_ = _tmp4_;
#line 2720 "../src/Photo.vala"
	if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 21079 "Photo.c"
		gboolean _tmp5_ = FALSE;
#line 2720 "../src/Photo.vala"
		g_propagate_error (error, _inner_error0_);
#line 2720 "../src/Photo.vala"
		_photo_file_adapter_unref0 (master_reader);
#line 2720 "../src/Photo.vala"
		_photo_reimport_master_state_unref0 (_vala_state);
#line 2720 "../src/Photo.vala"
		return _tmp5_;
#line 21089 "Photo.c"
	}
#line 2720 "../src/Photo.vala"
	photo_file_metadata_writer_write_metadata (_tmp2_, metadata, &_inner_error0_);
#line 2720 "../src/Photo.vala"
	if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 21095 "Photo.c"
		gboolean _tmp6_ = FALSE;
#line 2720 "../src/Photo.vala"
		g_propagate_error (error, _inner_error0_);
#line 2720 "../src/Photo.vala"
		_photo_file_adapter_unref0 (_tmp2_);
#line 2720 "../src/Photo.vala"
		_photo_file_adapter_unref0 (master_reader);
#line 2720 "../src/Photo.vala"
		_photo_reimport_master_state_unref0 (_vala_state);
#line 2720 "../src/Photo.vala"
		return _tmp6_;
#line 21107 "Photo.c"
	}
#line 2722 "../src/Photo.vala"
	_tmp9_ = photo_prepare_for_reimport_master (self, &_tmp8_, &_inner_error0_);
#line 2722 "../src/Photo.vala"
	_photo_reimport_master_state_unref0 (_vala_state);
#line 2722 "../src/Photo.vala"
	_vala_state = _tmp8_;
#line 2722 "../src/Photo.vala"
	_tmp7_ = _tmp9_;
#line 2722 "../src/Photo.vala"
	if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 21119 "Photo.c"
		gboolean _tmp10_ = FALSE;
#line 2722 "../src/Photo.vala"
		g_propagate_error (error, _inner_error0_);
#line 2722 "../src/Photo.vala"
		_photo_file_adapter_unref0 (_tmp2_);
#line 2722 "../src/Photo.vala"
		_photo_file_adapter_unref0 (master_reader);
#line 2722 "../src/Photo.vala"
		_photo_reimport_master_state_unref0 (_vala_state);
#line 2722 "../src/Photo.vala"
		return _tmp10_;
#line 21131 "Photo.c"
	}
#line 2722 "../src/Photo.vala"
	if (!_tmp7_) {
#line 2723 "../src/Photo.vala"
		result = FALSE;
#line 2723 "../src/Photo.vala"
		_photo_file_adapter_unref0 (_tmp2_);
#line 2723 "../src/Photo.vala"
		_photo_file_adapter_unref0 (master_reader);
#line 2723 "../src/Photo.vala"
		if (state) {
#line 2723 "../src/Photo.vala"
			*state = _vala_state;
#line 21145 "Photo.c"
		} else {
#line 2723 "../src/Photo.vala"
			_photo_reimport_master_state_unref0 (_vala_state);
#line 21149 "Photo.c"
		}
#line 2723 "../src/Photo.vala"
		return result;
#line 21153 "Photo.c"
	}
#line 2725 "../src/Photo.vala"
	_tmp11_ = _vala_state;
#line 2725 "../src/Photo.vala"
	G_TYPE_CHECK_INSTANCE_CAST (_tmp11_, PHOTO_TYPE_REIMPORT_MASTER_STATE_IMPL, PhotoReimportMasterStateImpl)->metadata_only = TRUE;
#line 2727 "../src/Photo.vala"
	result = TRUE;
#line 2727 "../src/Photo.vala"
	_photo_file_adapter_unref0 (_tmp2_);
#line 2727 "../src/Photo.vala"
	_photo_file_adapter_unref0 (master_reader);
#line 2727 "../src/Photo.vala"
	if (state) {
#line 2727 "../src/Photo.vala"
		*state = _vala_state;
#line 21169 "Photo.c"
	} else {
#line 2727 "../src/Photo.vala"
		_photo_reimport_master_state_unref0 (_vala_state);
#line 21173 "Photo.c"
	}
#line 2727 "../src/Photo.vala"
	return result;
#line 21177 "Photo.c"
}

void
photo_finish_update_master_metadata (Photo* self,
                                     PhotoReimportMasterState* state,
                                     GError** error)
{
	GError* _inner_error0_ = NULL;
#line 2730 "../src/Photo.vala"
	g_return_if_fail (IS_PHOTO (self));
#line 2730 "../src/Photo.vala"
	g_return_if_fail (PHOTO_IS_REIMPORT_MASTER_STATE (state));
#line 2731 "../src/Photo.vala"
	photo_finish_reimport_master (self, state, &_inner_error0_);
#line 2731 "../src/Photo.vala"
	if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 2731 "../src/Photo.vala"
		if (_inner_error0_->domain == DATABASE_ERROR) {
#line 2731 "../src/Photo.vala"
			g_propagate_error (error, _inner_error0_);
#line 2731 "../src/Photo.vala"
			return;
#line 21200 "Photo.c"
		} else {
#line 2731 "../src/Photo.vala"
			g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 2731 "../src/Photo.vala"
			g_clear_error (&_inner_error0_);
#line 2731 "../src/Photo.vala"
			return;
#line 21208 "Photo.c"
		}
	}
}

gboolean
photo_persist_editable_metadata (Photo* self,
                                 PhotoMetadata* metadata,
                                 PhotoReimportEditableState** state,
                                 GError** error)
{
	PhotoReimportEditableState* _vala_state = NULL;
	PhotoFileReader* editable_reader = NULL;
	PhotoFileReader* _tmp0_;
	PhotoFileReader* _tmp1_;
	PhotoFileReader* _tmp2_;
	PhotoFileMetadataWriter* _tmp3_ = NULL;
	PhotoFileReader* _tmp4_;
	PhotoFileMetadataWriter* _tmp5_;
	gboolean _tmp8_ = FALSE;
	PhotoReimportEditableState* _tmp9_ = NULL;
	gboolean _tmp10_;
	PhotoReimportEditableState* _tmp12_;
	GError* _inner_error0_ = NULL;
	gboolean result;
#line 2734 "../src/Photo.vala"
	g_return_val_if_fail (IS_PHOTO (self), FALSE);
#line 2734 "../src/Photo.vala"
	g_return_val_if_fail (IS_PHOTO_METADATA (metadata), FALSE);
#line 2736 "../src/Photo.vala"
	_photo_reimport_editable_state_unref0 (_vala_state);
#line 2736 "../src/Photo.vala"
	_vala_state = NULL;
#line 2738 "../src/Photo.vala"
	_tmp0_ = photo_get_editable_reader (self);
#line 2738 "../src/Photo.vala"
	editable_reader = _tmp0_;
#line 2739 "../src/Photo.vala"
	_tmp1_ = editable_reader;
#line 2739 "../src/Photo.vala"
	if (_tmp1_ == NULL) {
#line 2740 "../src/Photo.vala"
		result = FALSE;
#line 2740 "../src/Photo.vala"
		_photo_file_adapter_unref0 (editable_reader);
#line 2740 "../src/Photo.vala"
		if (state) {
#line 2740 "../src/Photo.vala"
			*state = _vala_state;
#line 21257 "Photo.c"
		} else {
#line 2740 "../src/Photo.vala"
			_photo_reimport_editable_state_unref0 (_vala_state);
#line 21261 "Photo.c"
		}
#line 2740 "../src/Photo.vala"
		return result;
#line 21265 "Photo.c"
	}
#line 2742 "../src/Photo.vala"
	_tmp2_ = editable_reader;
#line 2742 "../src/Photo.vala"
	if (!photo_file_format_can_write_metadata (photo_file_adapter_get_file_format (G_TYPE_CHECK_INSTANCE_CAST (_tmp2_, TYPE_PHOTO_FILE_ADAPTER, PhotoFileAdapter)))) {
#line 2743 "../src/Photo.vala"
		result = FALSE;
#line 2743 "../src/Photo.vala"
		_photo_file_adapter_unref0 (editable_reader);
#line 2743 "../src/Photo.vala"
		if (state) {
#line 2743 "../src/Photo.vala"
			*state = _vala_state;
#line 21279 "Photo.c"
		} else {
#line 2743 "../src/Photo.vala"
			_photo_reimport_editable_state_unref0 (_vala_state);
#line 21283 "Photo.c"
		}
#line 2743 "../src/Photo.vala"
		return result;
#line 21287 "Photo.c"
	}
#line 2745 "../src/Photo.vala"
	_tmp4_ = editable_reader;
#line 2745 "../src/Photo.vala"
	_tmp5_ = photo_file_reader_create_metadata_writer (_tmp4_, &_inner_error0_);
#line 2745 "../src/Photo.vala"
	_tmp3_ = _tmp5_;
#line 2745 "../src/Photo.vala"
	if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 21297 "Photo.c"
		gboolean _tmp6_ = FALSE;
#line 2745 "../src/Photo.vala"
		g_propagate_error (error, _inner_error0_);
#line 2745 "../src/Photo.vala"
		_photo_file_adapter_unref0 (editable_reader);
#line 2745 "../src/Photo.vala"
		_photo_reimport_editable_state_unref0 (_vala_state);
#line 2745 "../src/Photo.vala"
		return _tmp6_;
#line 21307 "Photo.c"
	}
#line 2745 "../src/Photo.vala"
	photo_file_metadata_writer_write_metadata (_tmp3_, metadata, &_inner_error0_);
#line 2745 "../src/Photo.vala"
	if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 21313 "Photo.c"
		gboolean _tmp7_ = FALSE;
#line 2745 "../src/Photo.vala"
		g_propagate_error (error, _inner_error0_);
#line 2745 "../src/Photo.vala"
		_photo_file_adapter_unref0 (_tmp3_);
#line 2745 "../src/Photo.vala"
		_photo_file_adapter_unref0 (editable_reader);
#line 2745 "../src/Photo.vala"
		_photo_reimport_editable_state_unref0 (_vala_state);
#line 2745 "../src/Photo.vala"
		return _tmp7_;
#line 21325 "Photo.c"
	}
#line 2747 "../src/Photo.vala"
	_tmp10_ = photo_prepare_for_reimport_editable (self, &_tmp9_, &_inner_error0_);
#line 2747 "../src/Photo.vala"
	_photo_reimport_editable_state_unref0 (_vala_state);
#line 2747 "../src/Photo.vala"
	_vala_state = _tmp9_;
#line 2747 "../src/Photo.vala"
	_tmp8_ = _tmp10_;
#line 2747 "../src/Photo.vala"
	if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 21337 "Photo.c"
		gboolean _tmp11_ = FALSE;
#line 2747 "../src/Photo.vala"
		g_propagate_error (error, _inner_error0_);
#line 2747 "../src/Photo.vala"
		_photo_file_adapter_unref0 (_tmp3_);
#line 2747 "../src/Photo.vala"
		_photo_file_adapter_unref0 (editable_reader);
#line 2747 "../src/Photo.vala"
		_photo_reimport_editable_state_unref0 (_vala_state);
#line 2747 "../src/Photo.vala"
		return _tmp11_;
#line 21349 "Photo.c"
	}
#line 2747 "../src/Photo.vala"
	if (!_tmp8_) {
#line 2748 "../src/Photo.vala"
		result = FALSE;
#line 2748 "../src/Photo.vala"
		_photo_file_adapter_unref0 (_tmp3_);
#line 2748 "../src/Photo.vala"
		_photo_file_adapter_unref0 (editable_reader);
#line 2748 "../src/Photo.vala"
		if (state) {
#line 2748 "../src/Photo.vala"
			*state = _vala_state;
#line 21363 "Photo.c"
		} else {
#line 2748 "../src/Photo.vala"
			_photo_reimport_editable_state_unref0 (_vala_state);
#line 21367 "Photo.c"
		}
#line 2748 "../src/Photo.vala"
		return result;
#line 21371 "Photo.c"
	}
#line 2750 "../src/Photo.vala"
	_tmp12_ = _vala_state;
#line 2750 "../src/Photo.vala"
	G_TYPE_CHECK_INSTANCE_CAST (_tmp12_, PHOTO_TYPE_REIMPORT_EDITABLE_STATE_IMPL, PhotoReimportEditableStateImpl)->metadata_only = TRUE;
#line 2752 "../src/Photo.vala"
	result = TRUE;
#line 2752 "../src/Photo.vala"
	_photo_file_adapter_unref0 (_tmp3_);
#line 2752 "../src/Photo.vala"
	_photo_file_adapter_unref0 (editable_reader);
#line 2752 "../src/Photo.vala"
	if (state) {
#line 2752 "../src/Photo.vala"
		*state = _vala_state;
#line 21387 "Photo.c"
	} else {
#line 2752 "../src/Photo.vala"
		_photo_reimport_editable_state_unref0 (_vala_state);
#line 21391 "Photo.c"
	}
#line 2752 "../src/Photo.vala"
	return result;
#line 21395 "Photo.c"
}

void
photo_finish_update_editable_metadata (Photo* self,
                                       PhotoReimportEditableState* state,
                                       GError** error)
{
	GError* _inner_error0_ = NULL;
#line 2755 "../src/Photo.vala"
	g_return_if_fail (IS_PHOTO (self));
#line 2755 "../src/Photo.vala"
	g_return_if_fail (PHOTO_IS_REIMPORT_EDITABLE_STATE (state));
#line 2756 "../src/Photo.vala"
	photo_finish_reimport_editable (self, state, &_inner_error0_);
#line 2756 "../src/Photo.vala"
	if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 2756 "../src/Photo.vala"
		if (_inner_error0_->domain == DATABASE_ERROR) {
#line 2756 "../src/Photo.vala"
			g_propagate_error (error, _inner_error0_);
#line 2756 "../src/Photo.vala"
			return;
#line 21418 "Photo.c"
		} else {
#line 2756 "../src/Photo.vala"
			g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 2756 "../src/Photo.vala"
			g_clear_error (&_inner_error0_);
#line 2756 "../src/Photo.vala"
			return;
#line 21426 "Photo.c"
		}
	}
}

void
photo_get_raw_dimensions (Photo* self,
                          Dimensions* result)
{
	GError* _inner_error0_ = NULL;
#line 2761 "../src/Photo.vala"
	g_return_if_fail (IS_PHOTO (self));
#line 21438 "Photo.c"
	{
		PhotoRow* _tmp0_;
#line 2762 "../src/Photo.vala"
		_tmp0_ = self->row;
#line 2762 "../src/Photo.vala"
		g_rec_mutex_lock (&self->priv->__lock_row);
#line 21445 "Photo.c"
		{
			BackingPhotoRow* _tmp1_;
			Dimensions _tmp2_;
#line 2763 "../src/Photo.vala"
			_tmp1_ = self->backing_photo_row;
#line 2763 "../src/Photo.vala"
			_tmp2_ = _tmp1_->dim;
#line 2763 "../src/Photo.vala"
			*result = _tmp2_;
#line 21455 "Photo.c"
			{
				PhotoRow* _tmp3_;
#line 2762 "../src/Photo.vala"
				_tmp3_ = self->row;
#line 2762 "../src/Photo.vala"
				g_rec_mutex_unlock (&self->priv->__lock_row);
#line 21462 "Photo.c"
			}
#line 2763 "../src/Photo.vala"
			return;
#line 21466 "Photo.c"
		}
		__finally0:
		{
			PhotoRow* _tmp4_;
#line 2762 "../src/Photo.vala"
			_tmp4_ = self->row;
#line 2762 "../src/Photo.vala"
			g_rec_mutex_unlock (&self->priv->__lock_row);
#line 21475 "Photo.c"
		}
#line 2762 "../src/Photo.vala"
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 2762 "../src/Photo.vala"
		g_clear_error (&_inner_error0_);
#line 2762 "../src/Photo.vala"
		return;
#line 21483 "Photo.c"
	}
}

gboolean
photo_has_transformations (Photo* self)
{
	GError* _inner_error0_ = NULL;
	gboolean result;
#line 2767 "../src/Photo.vala"
	g_return_val_if_fail (IS_PHOTO (self), FALSE);
#line 21494 "Photo.c"
	{
		PhotoRow* _tmp0_;
		gboolean _tmp8_ = FALSE;
#line 2768 "../src/Photo.vala"
		_tmp0_ = self->row;
#line 2768 "../src/Photo.vala"
		g_rec_mutex_lock (&self->priv->__lock_row);
#line 21502 "Photo.c"
		{
			gboolean _tmp1_ = FALSE;
			PhotoRow* _tmp2_;
			BackingPhotoRow* _tmp3_;
#line 2769 "../src/Photo.vala"
			_tmp2_ = self->row;
#line 2769 "../src/Photo.vala"
			_tmp3_ = self->backing_photo_row;
#line 2769 "../src/Photo.vala"
			if (_tmp2_->orientation != _tmp3_->original_orientation) {
#line 2770 "../src/Photo.vala"
				_tmp1_ = TRUE;
#line 21515 "Photo.c"
			} else {
				PhotoRow* _tmp4_;
				GeeHashMap* _tmp5_;
#line 2771 "../src/Photo.vala"
				_tmp4_ = self->row;
#line 2771 "../src/Photo.vala"
				_tmp5_ = _tmp4_->transformations;
#line 2771 "../src/Photo.vala"
				_tmp1_ = _tmp5_ != NULL;
#line 21525 "Photo.c"
			}
#line 2769 "../src/Photo.vala"
			result = _tmp1_;
#line 21529 "Photo.c"
			{
				PhotoRow* _tmp6_;
#line 2768 "../src/Photo.vala"
				_tmp6_ = self->row;
#line 2768 "../src/Photo.vala"
				g_rec_mutex_unlock (&self->priv->__lock_row);
#line 21536 "Photo.c"
			}
#line 2769 "../src/Photo.vala"
			return result;
#line 21540 "Photo.c"
		}
		__finally0:
		{
			PhotoRow* _tmp7_;
#line 2768 "../src/Photo.vala"
			_tmp7_ = self->row;
#line 2768 "../src/Photo.vala"
			g_rec_mutex_unlock (&self->priv->__lock_row);
#line 21549 "Photo.c"
		}
#line 2768 "../src/Photo.vala"
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 2768 "../src/Photo.vala"
		g_clear_error (&_inner_error0_);
#line 2768 "../src/Photo.vala"
		return _tmp8_;
#line 21557 "Photo.c"
	}
}

gboolean
photo_only_metadata_changed (Photo* self)
{
	MetadataDateTime* date_time = NULL;
	PhotoMetadata* metadata = NULL;
	PhotoMetadata* _tmp0_;
	PhotoMetadata* _tmp1_;
	GError* _inner_error0_ = NULL;
	gboolean result;
#line 2775 "../src/Photo.vala"
	g_return_val_if_fail (IS_PHOTO (self), FALSE);
#line 2776 "../src/Photo.vala"
	date_time = NULL;
#line 2778 "../src/Photo.vala"
	_tmp0_ = photo_source_get_metadata (G_TYPE_CHECK_INSTANCE_CAST (self, TYPE_PHOTO_SOURCE, PhotoSource));
#line 2778 "../src/Photo.vala"
	metadata = _tmp0_;
#line 2779 "../src/Photo.vala"
	_tmp1_ = metadata;
#line 2779 "../src/Photo.vala"
	if (_tmp1_ != NULL) {
#line 21582 "Photo.c"
		PhotoMetadata* _tmp2_;
		MetadataDateTime* _tmp3_;
#line 2780 "../src/Photo.vala"
		_tmp2_ = metadata;
#line 2780 "../src/Photo.vala"
		_tmp3_ = photo_metadata_get_exposure_date_time (_tmp2_);
#line 2780 "../src/Photo.vala"
		_metadata_date_time_unref0 (date_time);
#line 2780 "../src/Photo.vala"
		date_time = _tmp3_;
#line 21593 "Photo.c"
	}
	{
		PhotoRow* _tmp4_;
		gboolean _tmp23_ = FALSE;
#line 2782 "../src/Photo.vala"
		_tmp4_ = self->row;
#line 2782 "../src/Photo.vala"
		g_rec_mutex_lock (&self->priv->__lock_row);
#line 21602 "Photo.c"
		{
			gboolean _tmp5_ = FALSE;
			PhotoRow* _tmp6_;
			GeeHashMap* _tmp7_;
#line 2783 "../src/Photo.vala"
			_tmp6_ = self->row;
#line 2783 "../src/Photo.vala"
			_tmp7_ = _tmp6_->transformations;
#line 2783 "../src/Photo.vala"
			if (_tmp7_ == NULL) {
#line 21613 "Photo.c"
				gboolean _tmp8_ = FALSE;
				PhotoRow* _tmp9_;
				BackingPhotoRow* _tmp10_;
#line 2784 "../src/Photo.vala"
				_tmp9_ = self->row;
#line 2784 "../src/Photo.vala"
				_tmp10_ = self->backing_photo_row;
#line 2784 "../src/Photo.vala"
				if (_tmp9_->orientation != _tmp10_->original_orientation) {
#line 2784 "../src/Photo.vala"
					_tmp8_ = TRUE;
#line 21625 "Photo.c"
				} else {
					gboolean _tmp11_ = FALSE;
					gboolean _tmp12_ = FALSE;
					MetadataDateTime* _tmp13_;
#line 2785 "../src/Photo.vala"
					_tmp13_ = date_time;
#line 2785 "../src/Photo.vala"
					if (_tmp13_ != NULL) {
#line 21634 "Photo.c"
						PhotoRow* _tmp14_;
						GDateTime* _tmp15_;
#line 2785 "../src/Photo.vala"
						_tmp14_ = self->row;
#line 2785 "../src/Photo.vala"
						_tmp15_ = _tmp14_->exposure_time;
#line 2785 "../src/Photo.vala"
						_tmp12_ = _tmp15_ != NULL;
#line 21643 "Photo.c"
					} else {
#line 2785 "../src/Photo.vala"
						_tmp12_ = FALSE;
#line 21647 "Photo.c"
					}
#line 2785 "../src/Photo.vala"
					if (_tmp12_) {
#line 21651 "Photo.c"
						PhotoRow* _tmp16_;
						GDateTime* _tmp17_;
						MetadataDateTime* _tmp18_;
						GDateTime* _tmp19_;
						GDateTime* _tmp20_;
#line 2786 "../src/Photo.vala"
						_tmp16_ = self->row;
#line 2786 "../src/Photo.vala"
						_tmp17_ = _tmp16_->exposure_time;
#line 2786 "../src/Photo.vala"
						_tmp18_ = date_time;
#line 2786 "../src/Photo.vala"
						_tmp19_ = metadata_date_time_get_timestamp (_tmp18_);
#line 2786 "../src/Photo.vala"
						_tmp20_ = _tmp19_;
#line 2786 "../src/Photo.vala"
						_tmp11_ = !g_date_time_equal (_tmp17_, _tmp20_);
#line 2786 "../src/Photo.vala"
						_g_date_time_unref0 (_tmp20_);
#line 21671 "Photo.c"
					} else {
#line 2785 "../src/Photo.vala"
						_tmp11_ = FALSE;
#line 21675 "Photo.c"
					}
#line 2785 "../src/Photo.vala"
					_tmp8_ = _tmp11_;
#line 21679 "Photo.c"
				}
#line 2784 "../src/Photo.vala"
				_tmp5_ = _tmp8_;
#line 21683 "Photo.c"
			} else {
#line 2783 "../src/Photo.vala"
				_tmp5_ = FALSE;
#line 21687 "Photo.c"
			}
#line 2783 "../src/Photo.vala"
			result = _tmp5_;
#line 21691 "Photo.c"
			{
				PhotoRow* _tmp21_;
#line 2782 "../src/Photo.vala"
				_tmp21_ = self->row;
#line 2782 "../src/Photo.vala"
				g_rec_mutex_unlock (&self->priv->__lock_row);
#line 21698 "Photo.c"
			}
#line 2783 "../src/Photo.vala"
			_media_metadata_unref0 (metadata);
#line 2783 "../src/Photo.vala"
			_metadata_date_time_unref0 (date_time);
#line 2783 "../src/Photo.vala"
			return result;
#line 21706 "Photo.c"
		}
		__finally0:
		{
			PhotoRow* _tmp22_;
#line 2782 "../src/Photo.vala"
			_tmp22_ = self->row;
#line 2782 "../src/Photo.vala"
			g_rec_mutex_unlock (&self->priv->__lock_row);
#line 21715 "Photo.c"
		}
#line 2782 "../src/Photo.vala"
		_media_metadata_unref0 (metadata);
#line 2782 "../src/Photo.vala"
		_metadata_date_time_unref0 (date_time);
#line 2782 "../src/Photo.vala"
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 2782 "../src/Photo.vala"
		g_clear_error (&_inner_error0_);
#line 2782 "../src/Photo.vala"
		return _tmp23_;
#line 21727 "Photo.c"
	}
}

gboolean
photo_has_alterations (Photo* self)
{
	MetadataDateTime* date_time = NULL;
	gchar* title = NULL;
	gchar* comment = NULL;
	PhotoMetadata* metadata = NULL;
	PhotoMetadata* _tmp0_;
	PhotoMetadata* _tmp1_;
	MetadataDateTime* _tmp8_;
	GError* _inner_error0_ = NULL;
	gboolean result;
#line 2790 "../src/Photo.vala"
	g_return_val_if_fail (IS_PHOTO (self), FALSE);
#line 2791 "../src/Photo.vala"
	date_time = NULL;
#line 2792 "../src/Photo.vala"
	title = NULL;
#line 2793 "../src/Photo.vala"
	comment = NULL;
#line 2795 "../src/Photo.vala"
	_tmp0_ = photo_source_get_metadata (G_TYPE_CHECK_INSTANCE_CAST (self, TYPE_PHOTO_SOURCE, PhotoSource));
#line 2795 "../src/Photo.vala"
	metadata = _tmp0_;
#line 2796 "../src/Photo.vala"
	_tmp1_ = metadata;
#line 2796 "../src/Photo.vala"
	if (_tmp1_ != NULL) {
#line 21759 "Photo.c"
		PhotoMetadata* _tmp2_;
		MetadataDateTime* _tmp3_;
		PhotoMetadata* _tmp4_;
		gchar* _tmp5_;
		PhotoMetadata* _tmp6_;
		gchar* _tmp7_;
#line 2797 "../src/Photo.vala"
		_tmp2_ = metadata;
#line 2797 "../src/Photo.vala"
		_tmp3_ = photo_metadata_get_exposure_date_time (_tmp2_);
#line 2797 "../src/Photo.vala"
		_metadata_date_time_unref0 (date_time);
#line 2797 "../src/Photo.vala"
		date_time = _tmp3_;
#line 2798 "../src/Photo.vala"
		_tmp4_ = metadata;
#line 2798 "../src/Photo.vala"
		_tmp5_ = media_metadata_get_title (G_TYPE_CHECK_INSTANCE_CAST (_tmp4_, TYPE_MEDIA_METADATA, MediaMetadata));
#line 2798 "../src/Photo.vala"
		_g_free0 (title);
#line 2798 "../src/Photo.vala"
		title = _tmp5_;
#line 2799 "../src/Photo.vala"
		_tmp6_ = metadata;
#line 2799 "../src/Photo.vala"
		_tmp7_ = media_metadata_get_comment (G_TYPE_CHECK_INSTANCE_CAST (_tmp6_, TYPE_MEDIA_METADATA, MediaMetadata));
#line 2799 "../src/Photo.vala"
		_g_free0 (comment);
#line 2799 "../src/Photo.vala"
		comment = _tmp7_;
#line 21790 "Photo.c"
	}
#line 2803 "../src/Photo.vala"
	_tmp8_ = date_time;
#line 2803 "../src/Photo.vala"
	if (_tmp8_ == NULL) {
#line 21796 "Photo.c"
		{
			PhotoRow* _tmp9_;
#line 2805 "../src/Photo.vala"
			_tmp9_ = self->row;
#line 2805 "../src/Photo.vala"
			g_rec_mutex_lock (&self->priv->__lock_row);
#line 21803 "Photo.c"
			{
				BackingPhotoRow* _tmp10_;
				GDateTime* _tmp11_;
				PhotoRow* _tmp12_;
				GDateTime* _tmp13_;
#line 2807 "../src/Photo.vala"
				_tmp10_ = self->backing_photo_row;
#line 2807 "../src/Photo.vala"
				_tmp11_ = _tmp10_->timestamp;
#line 2807 "../src/Photo.vala"
				_tmp12_ = self->row;
#line 2807 "../src/Photo.vala"
				_tmp13_ = _tmp12_->exposure_time;
#line 2807 "../src/Photo.vala"
				if (nullsafe_date_time_comperator (_tmp11_, _tmp13_) != ((gint64) 0)) {
#line 2809 "../src/Photo.vala"
					result = TRUE;
#line 21821 "Photo.c"
					{
						PhotoRow* _tmp14_;
#line 2805 "../src/Photo.vala"
						_tmp14_ = self->row;
#line 2805 "../src/Photo.vala"
						g_rec_mutex_unlock (&self->priv->__lock_row);
#line 21828 "Photo.c"
					}
#line 2809 "../src/Photo.vala"
					_media_metadata_unref0 (metadata);
#line 2809 "../src/Photo.vala"
					_g_free0 (comment);
#line 2809 "../src/Photo.vala"
					_g_free0 (title);
#line 2809 "../src/Photo.vala"
					_metadata_date_time_unref0 (date_time);
#line 2809 "../src/Photo.vala"
					return result;
#line 21840 "Photo.c"
				}
			}
			__finally0:
			{
				PhotoRow* _tmp15_;
#line 2805 "../src/Photo.vala"
				_tmp15_ = self->row;
#line 2805 "../src/Photo.vala"
				g_rec_mutex_unlock (&self->priv->__lock_row);
#line 21850 "Photo.c"
			}
#line 2805 "../src/Photo.vala"
			if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 21854 "Photo.c"
				gboolean _tmp16_ = FALSE;
#line 2805 "../src/Photo.vala"
				_media_metadata_unref0 (metadata);
#line 2805 "../src/Photo.vala"
				_g_free0 (comment);
#line 2805 "../src/Photo.vala"
				_g_free0 (title);
#line 2805 "../src/Photo.vala"
				_metadata_date_time_unref0 (date_time);
#line 2805 "../src/Photo.vala"
				g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 2805 "../src/Photo.vala"
				g_clear_error (&_inner_error0_);
#line 2805 "../src/Photo.vala"
				return _tmp16_;
#line 21870 "Photo.c"
			}
		}
	}
	{
		PhotoRow* _tmp17_;
		gboolean _tmp41_ = FALSE;
#line 2814 "../src/Photo.vala"
		_tmp17_ = self->row;
#line 2814 "../src/Photo.vala"
		g_rec_mutex_lock (&self->priv->__lock_row);
#line 21881 "Photo.c"
		{
			gboolean _tmp18_ = FALSE;
			gboolean _tmp19_ = FALSE;
			gboolean _tmp20_ = FALSE;
			gboolean _tmp21_ = FALSE;
			PhotoRow* _tmp22_;
			GeeHashMap* _tmp23_;
#line 2815 "../src/Photo.vala"
			_tmp22_ = self->row;
#line 2815 "../src/Photo.vala"
			_tmp23_ = _tmp22_->transformations;
#line 2815 "../src/Photo.vala"
			if (_tmp23_ != NULL) {
#line 2815 "../src/Photo.vala"
				_tmp21_ = TRUE;
#line 21897 "Photo.c"
			} else {
				PhotoRow* _tmp24_;
				BackingPhotoRow* _tmp25_;
#line 2816 "../src/Photo.vala"
				_tmp24_ = self->row;
#line 2816 "../src/Photo.vala"
				_tmp25_ = self->backing_photo_row;
#line 2816 "../src/Photo.vala"
				_tmp21_ = _tmp24_->orientation != _tmp25_->original_orientation;
#line 21907 "Photo.c"
			}
#line 2815 "../src/Photo.vala"
			if (_tmp21_) {
#line 2815 "../src/Photo.vala"
				_tmp20_ = TRUE;
#line 21913 "Photo.c"
			} else {
				gboolean _tmp26_ = FALSE;
				MetadataDateTime* _tmp27_;
#line 2817 "../src/Photo.vala"
				_tmp27_ = date_time;
#line 2817 "../src/Photo.vala"
				if (_tmp27_ != NULL) {
#line 21921 "Photo.c"
					PhotoRow* _tmp28_;
					GDateTime* _tmp29_;
					MetadataDateTime* _tmp30_;
					GDateTime* _tmp31_;
					GDateTime* _tmp32_;
#line 2817 "../src/Photo.vala"
					_tmp28_ = self->row;
#line 2817 "../src/Photo.vala"
					_tmp29_ = _tmp28_->exposure_time;
#line 2817 "../src/Photo.vala"
					_tmp30_ = date_time;
#line 2817 "../src/Photo.vala"
					_tmp31_ = metadata_date_time_get_timestamp (_tmp30_);
#line 2817 "../src/Photo.vala"
					_tmp32_ = _tmp31_;
#line 2817 "../src/Photo.vala"
					_tmp26_ = nullsafe_date_time_comperator (_tmp29_, _tmp32_) != ((gint64) 0);
#line 2817 "../src/Photo.vala"
					_g_date_time_unref0 (_tmp32_);
#line 21941 "Photo.c"
				} else {
#line 2817 "../src/Photo.vala"
					_tmp26_ = FALSE;
#line 21945 "Photo.c"
				}
#line 2817 "../src/Photo.vala"
				_tmp20_ = _tmp26_;
#line 21949 "Photo.c"
			}
#line 2815 "../src/Photo.vala"
			if (_tmp20_) {
#line 2815 "../src/Photo.vala"
				_tmp19_ = TRUE;
#line 21955 "Photo.c"
			} else {
				gchar* _tmp33_;
				gchar* _tmp34_;
				const gchar* _tmp35_;
#line 2818 "../src/Photo.vala"
				_tmp33_ = media_source_get_comment (G_TYPE_CHECK_INSTANCE_CAST (self, TYPE_MEDIA_SOURCE, MediaSource));
#line 2818 "../src/Photo.vala"
				_tmp34_ = _tmp33_;
#line 2818 "../src/Photo.vala"
				_tmp35_ = comment;
#line 2818 "../src/Photo.vala"
				_tmp19_ = g_strcmp0 (_tmp34_, _tmp35_) != 0;
#line 2818 "../src/Photo.vala"
				_g_free0 (_tmp34_);
#line 21970 "Photo.c"
			}
#line 2815 "../src/Photo.vala"
			if (_tmp19_) {
#line 2815 "../src/Photo.vala"
				_tmp18_ = TRUE;
#line 21976 "Photo.c"
			} else {
				gchar* _tmp36_;
				gchar* _tmp37_;
				const gchar* _tmp38_;
#line 2819 "../src/Photo.vala"
				_tmp36_ = media_source_get_title (G_TYPE_CHECK_INSTANCE_CAST (self, TYPE_MEDIA_SOURCE, MediaSource));
#line 2819 "../src/Photo.vala"
				_tmp37_ = _tmp36_;
#line 2819 "../src/Photo.vala"
				_tmp38_ = title;
#line 2819 "../src/Photo.vala"
				_tmp18_ = g_strcmp0 (_tmp37_, _tmp38_) != 0;
#line 2819 "../src/Photo.vala"
				_g_free0 (_tmp37_);
#line 21991 "Photo.c"
			}
#line 2815 "../src/Photo.vala"
			result = _tmp18_;
#line 21995 "Photo.c"
			{
				PhotoRow* _tmp39_;
#line 2814 "../src/Photo.vala"
				_tmp39_ = self->row;
#line 2814 "../src/Photo.vala"
				g_rec_mutex_unlock (&self->priv->__lock_row);
#line 22002 "Photo.c"
			}
#line 2815 "../src/Photo.vala"
			_media_metadata_unref0 (metadata);
#line 2815 "../src/Photo.vala"
			_g_free0 (comment);
#line 2815 "../src/Photo.vala"
			_g_free0 (title);
#line 2815 "../src/Photo.vala"
			_metadata_date_time_unref0 (date_time);
#line 2815 "../src/Photo.vala"
			return result;
#line 22014 "Photo.c"
		}
		__finally1:
		{
			PhotoRow* _tmp40_;
#line 2814 "../src/Photo.vala"
			_tmp40_ = self->row;
#line 2814 "../src/Photo.vala"
			g_rec_mutex_unlock (&self->priv->__lock_row);
#line 22023 "Photo.c"
		}
#line 2814 "../src/Photo.vala"
		_media_metadata_unref0 (metadata);
#line 2814 "../src/Photo.vala"
		_g_free0 (comment);
#line 2814 "../src/Photo.vala"
		_g_free0 (title);
#line 2814 "../src/Photo.vala"
		_metadata_date_time_unref0 (date_time);
#line 2814 "../src/Photo.vala"
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 2814 "../src/Photo.vala"
		g_clear_error (&_inner_error0_);
#line 2814 "../src/Photo.vala"
		return _tmp41_;
#line 22039 "Photo.c"
	}
}

PhotoTransformationState*
photo_save_transformation_state (Photo* self)
{
	GError* _inner_error0_ = NULL;
	PhotoTransformationState* result;
#line 2824 "../src/Photo.vala"
	g_return_val_if_fail (IS_PHOTO (self), NULL);
#line 22050 "Photo.c"
	{
		PhotoRow* _tmp0_;
#line 2825 "../src/Photo.vala"
		_tmp0_ = self->row;
#line 2825 "../src/Photo.vala"
		g_rec_mutex_lock (&self->priv->__lock_row);
#line 22057 "Photo.c"
		{
			PixelTransformer* _tmp1_ = NULL;
			PixelTransformer* _tmp2_;
			PixelTransformationBundle* _tmp5_ = NULL;
			PixelTransformationBundle* _tmp6_;
			PhotoRow* _tmp9_;
			PhotoRow* _tmp10_;
			GeeHashMap* _tmp11_;
			PhotoPhotoTransformationStateImpl* _tmp12_;
#line 2828 "../src/Photo.vala"
			_tmp2_ = self->priv->transformer;
#line 2828 "../src/Photo.vala"
			if (_tmp2_ != NULL) {
#line 22071 "Photo.c"
				PixelTransformer* _tmp3_;
				PixelTransformer* _tmp4_;
#line 2828 "../src/Photo.vala"
				_tmp3_ = self->priv->transformer;
#line 2828 "../src/Photo.vala"
				_tmp4_ = pixel_transformer_copy (_tmp3_);
#line 2828 "../src/Photo.vala"
				_pixel_transformer_unref0 (_tmp1_);
#line 2828 "../src/Photo.vala"
				_tmp1_ = _tmp4_;
#line 22082 "Photo.c"
			} else {
#line 2828 "../src/Photo.vala"
				_pixel_transformer_unref0 (_tmp1_);
#line 2828 "../src/Photo.vala"
				_tmp1_ = NULL;
#line 22088 "Photo.c"
			}
#line 2829 "../src/Photo.vala"
			_tmp6_ = self->priv->adjustments;
#line 2829 "../src/Photo.vala"
			if (_tmp6_ != NULL) {
#line 22094 "Photo.c"
				PixelTransformationBundle* _tmp7_;
				PixelTransformationBundle* _tmp8_;
#line 2829 "../src/Photo.vala"
				_tmp7_ = self->priv->adjustments;
#line 2829 "../src/Photo.vala"
				_tmp8_ = pixel_transformation_bundle_copy (_tmp7_);
#line 2829 "../src/Photo.vala"
				_pixel_transformation_bundle_unref0 (_tmp5_);
#line 2829 "../src/Photo.vala"
				_tmp5_ = _tmp8_;
#line 22105 "Photo.c"
			} else {
#line 2829 "../src/Photo.vala"
				_pixel_transformation_bundle_unref0 (_tmp5_);
#line 2829 "../src/Photo.vala"
				_tmp5_ = NULL;
#line 22111 "Photo.c"
			}
#line 2826 "../src/Photo.vala"
			_tmp9_ = self->row;
#line 2826 "../src/Photo.vala"
			_tmp10_ = self->row;
#line 2826 "../src/Photo.vala"
			_tmp11_ = _tmp10_->transformations;
#line 2826 "../src/Photo.vala"
			_tmp12_ = photo_photo_transformation_state_impl_new (self, _tmp9_->orientation, _tmp11_, _tmp1_, _tmp5_);
#line 2826 "../src/Photo.vala"
			result = G_TYPE_CHECK_INSTANCE_CAST (_tmp12_, TYPE_PHOTO_TRANSFORMATION_STATE, PhotoTransformationState);
#line 2826 "../src/Photo.vala"
			_pixel_transformation_bundle_unref0 (_tmp5_);
#line 2826 "../src/Photo.vala"
			_pixel_transformer_unref0 (_tmp1_);
#line 22127 "Photo.c"
			{
				PhotoRow* _tmp13_;
#line 2825 "../src/Photo.vala"
				_tmp13_ = self->row;
#line 2825 "../src/Photo.vala"
				g_rec_mutex_unlock (&self->priv->__lock_row);
#line 22134 "Photo.c"
			}
#line 2826 "../src/Photo.vala"
			return result;
#line 22138 "Photo.c"
		}
		__finally0:
		{
			PhotoRow* _tmp14_;
#line 2825 "../src/Photo.vala"
			_tmp14_ = self->row;
#line 2825 "../src/Photo.vala"
			g_rec_mutex_unlock (&self->priv->__lock_row);
#line 22147 "Photo.c"
		}
#line 2825 "../src/Photo.vala"
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 2825 "../src/Photo.vala"
		g_clear_error (&_inner_error0_);
#line 2825 "../src/Photo.vala"
		return NULL;
#line 22155 "Photo.c"
	}
}

static gpointer
_pixel_transformer_ref0 (gpointer self)
{
#line 2850 "../src/Photo.vala"
	return self ? pixel_transformer_ref (self) : NULL;
#line 22164 "Photo.c"
}

static gpointer
_pixel_transformation_bundle_ref0 (gpointer self)
{
#line 2851 "../src/Photo.vala"
	return self ? pixel_transformation_bundle_ref (self) : NULL;
#line 22172 "Photo.c"
}

gboolean
photo_load_transformation_state (Photo* self,
                                 PhotoTransformationState* state)
{
	PhotoPhotoTransformationStateImpl* state_impl = NULL;
	PhotoPhotoTransformationStateImpl* _tmp0_;
	PhotoPhotoTransformationStateImpl* _tmp1_;
	Orientation saved_orientation = 0;
	PhotoPhotoTransformationStateImpl* _tmp2_;
	GeeHashMap* saved_transformations = NULL;
	PhotoPhotoTransformationStateImpl* _tmp3_;
	GeeHashMap* _tmp4_;
	PixelTransformer* saved_transformer = NULL;
	PhotoPhotoTransformationStateImpl* _tmp5_;
	PixelTransformer* _tmp6_;
	PixelTransformationBundle* saved_adjustments = NULL;
	PhotoPhotoTransformationStateImpl* _tmp7_;
	PixelTransformationBundle* _tmp8_;
	gboolean committed = FALSE;
	GError* _inner_error0_ = NULL;
	gboolean result;
#line 2833 "../src/Photo.vala"
	g_return_val_if_fail (IS_PHOTO (self), FALSE);
#line 2833 "../src/Photo.vala"
	g_return_val_if_fail (IS_PHOTO_TRANSFORMATION_STATE (state), FALSE);
#line 2834 "../src/Photo.vala"
	_tmp0_ = _g_object_ref0 (PHOTO_IS_PHOTO_TRANSFORMATION_STATE_IMPL (state) ? ((PhotoPhotoTransformationStateImpl*) state) : NULL);
#line 2834 "../src/Photo.vala"
	state_impl = _tmp0_;
#line 2835 "../src/Photo.vala"
	_tmp1_ = state_impl;
#line 2835 "../src/Photo.vala"
	if (_tmp1_ == NULL) {
#line 2836 "../src/Photo.vala"
		result = FALSE;
#line 2836 "../src/Photo.vala"
		_g_object_unref0 (state_impl);
#line 2836 "../src/Photo.vala"
		return result;
#line 22214 "Photo.c"
	}
#line 2838 "../src/Photo.vala"
	_tmp2_ = state_impl;
#line 2838 "../src/Photo.vala"
	saved_orientation = photo_photo_transformation_state_impl_get_orientation (_tmp2_);
#line 2839 "../src/Photo.vala"
	_tmp3_ = state_impl;
#line 2839 "../src/Photo.vala"
	_tmp4_ = photo_photo_transformation_state_impl_get_transformations (_tmp3_);
#line 2839 "../src/Photo.vala"
	saved_transformations = _tmp4_;
#line 2840 "../src/Photo.vala"
	_tmp5_ = state_impl;
#line 2840 "../src/Photo.vala"
	_tmp6_ = photo_photo_transformation_state_impl_get_transformer (_tmp5_);
#line 2840 "../src/Photo.vala"
	saved_transformer = _tmp6_;
#line 2841 "../src/Photo.vala"
	_tmp7_ = state_impl;
#line 2841 "../src/Photo.vala"
	_tmp8_ = photo_photo_transformation_state_impl_get_color_adjustments (_tmp7_);
#line 2841 "../src/Photo.vala"
	saved_adjustments = _tmp8_;
#line 22238 "Photo.c"
	{
		PhotoRow* _tmp9_;
#line 2844 "../src/Photo.vala"
		_tmp9_ = self->row;
#line 2844 "../src/Photo.vala"
		g_rec_mutex_lock (&self->priv->__lock_row);
#line 22245 "Photo.c"
		{
			PhotoTable* _tmp10_;
			PhotoTable* _tmp11_;
			PhotoRow* _tmp12_;
			PhotoID _tmp13_;
			GeeHashMap* _tmp14_;
#line 2845 "../src/Photo.vala"
			_tmp10_ = photo_table_get_instance ();
#line 2845 "../src/Photo.vala"
			_tmp11_ = _tmp10_;
#line 2845 "../src/Photo.vala"
			_tmp12_ = self->row;
#line 2845 "../src/Photo.vala"
			_tmp13_ = _tmp12_->photo_id;
#line 2845 "../src/Photo.vala"
			_tmp14_ = saved_transformations;
#line 2845 "../src/Photo.vala"
			committed = photo_table_set_transformation_state (_tmp11_, &_tmp13_, saved_orientation, _tmp14_);
#line 2845 "../src/Photo.vala"
			_database_table_unref0 (_tmp11_);
#line 2847 "../src/Photo.vala"
			if (committed) {
#line 22268 "Photo.c"
				PhotoRow* _tmp15_;
				PhotoRow* _tmp16_;
				GeeHashMap* _tmp17_;
				GeeHashMap* _tmp18_;
				PixelTransformer* _tmp19_;
				PixelTransformer* _tmp20_;
				PixelTransformationBundle* _tmp21_;
				PixelTransformationBundle* _tmp22_;
#line 2848 "../src/Photo.vala"
				_tmp15_ = self->row;
#line 2848 "../src/Photo.vala"
				_tmp15_->orientation = saved_orientation;
#line 2849 "../src/Photo.vala"
				_tmp16_ = self->row;
#line 2849 "../src/Photo.vala"
				_tmp17_ = saved_transformations;
#line 2849 "../src/Photo.vala"
				_tmp18_ = _g_object_ref0 (_tmp17_);
#line 2849 "../src/Photo.vala"
				_g_object_unref0 (_tmp16_->transformations);
#line 2849 "../src/Photo.vala"
				_tmp16_->transformations = _tmp18_;
#line 2850 "../src/Photo.vala"
				_tmp19_ = saved_transformer;
#line 2850 "../src/Photo.vala"
				_tmp20_ = _pixel_transformer_ref0 (_tmp19_);
#line 2850 "../src/Photo.vala"
				_pixel_transformer_unref0 (self->priv->transformer);
#line 2850 "../src/Photo.vala"
				self->priv->transformer = _tmp20_;
#line 2851 "../src/Photo.vala"
				_tmp21_ = saved_adjustments;
#line 2851 "../src/Photo.vala"
				_tmp22_ = _pixel_transformation_bundle_ref0 (_tmp21_);
#line 2851 "../src/Photo.vala"
				_pixel_transformation_bundle_unref0 (self->priv->adjustments);
#line 2851 "../src/Photo.vala"
				self->priv->adjustments = _tmp22_;
#line 22307 "Photo.c"
			}
		}
		__finally0:
		{
			PhotoRow* _tmp23_;
#line 2844 "../src/Photo.vala"
			_tmp23_ = self->row;
#line 2844 "../src/Photo.vala"
			g_rec_mutex_unlock (&self->priv->__lock_row);
#line 22317 "Photo.c"
		}
#line 2844 "../src/Photo.vala"
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 22321 "Photo.c"
			gboolean _tmp24_ = FALSE;
#line 2844 "../src/Photo.vala"
			_pixel_transformation_bundle_unref0 (saved_adjustments);
#line 2844 "../src/Photo.vala"
			_pixel_transformer_unref0 (saved_transformer);
#line 2844 "../src/Photo.vala"
			_g_object_unref0 (saved_transformations);
#line 2844 "../src/Photo.vala"
			_g_object_unref0 (state_impl);
#line 2844 "../src/Photo.vala"
			g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 2844 "../src/Photo.vala"
			g_clear_error (&_inner_error0_);
#line 2844 "../src/Photo.vala"
			return _tmp24_;
#line 22337 "Photo.c"
		}
	}
#line 2855 "../src/Photo.vala"
	if (committed) {
#line 22342 "Photo.c"
		Alteration* _tmp25_;
		Alteration* _tmp26_;
#line 2856 "../src/Photo.vala"
		_tmp25_ = alteration_new ("image", "transformation-state");
#line 2856 "../src/Photo.vala"
		_tmp26_ = _tmp25_;
#line 2856 "../src/Photo.vala"
		data_object_notify_altered (G_TYPE_CHECK_INSTANCE_CAST (self, TYPE_DATA_OBJECT, DataObject), _tmp26_);
#line 2856 "../src/Photo.vala"
		_alteration_unref0 (_tmp26_);
#line 22353 "Photo.c"
	}
#line 2858 "../src/Photo.vala"
	result = committed;
#line 2858 "../src/Photo.vala"
	_pixel_transformation_bundle_unref0 (saved_adjustments);
#line 2858 "../src/Photo.vala"
	_pixel_transformer_unref0 (saved_transformer);
#line 2858 "../src/Photo.vala"
	_g_object_unref0 (saved_transformations);
#line 2858 "../src/Photo.vala"
	_g_object_unref0 (state_impl);
#line 2858 "../src/Photo.vala"
	return result;
#line 22367 "Photo.c"
}

void
photo_remove_all_transformations (Photo* self,
                                  gboolean notify)
{
	gboolean is_altered = FALSE;
	gboolean _tmp16_ = FALSE;
	GError* _inner_error0_ = NULL;
#line 2861 "../src/Photo.vala"
	g_return_if_fail (IS_PHOTO (self));
#line 2862 "../src/Photo.vala"
	is_altered = FALSE;
#line 22381 "Photo.c"
	{
		PhotoRow* _tmp0_;
#line 2863 "../src/Photo.vala"
		_tmp0_ = self->row;
#line 2863 "../src/Photo.vala"
		g_rec_mutex_lock (&self->priv->__lock_row);
#line 22388 "Photo.c"
		{
			PhotoTable* _tmp1_;
			PhotoTable* _tmp2_;
			PhotoRow* _tmp3_;
			PhotoID _tmp4_;
			PhotoRow* _tmp5_;
			PhotoRow* _tmp6_;
			BackingPhotoRow* _tmp7_;
#line 2864 "../src/Photo.vala"
			_tmp1_ = photo_table_get_instance ();
#line 2864 "../src/Photo.vala"
			_tmp2_ = _tmp1_;
#line 2864 "../src/Photo.vala"
			_tmp3_ = self->row;
#line 2864 "../src/Photo.vala"
			_tmp4_ = _tmp3_->photo_id;
#line 2864 "../src/Photo.vala"
			is_altered = photo_table_remove_all_transformations (_tmp2_, &_tmp4_);
#line 2864 "../src/Photo.vala"
			_database_table_unref0 (_tmp2_);
#line 2865 "../src/Photo.vala"
			_tmp5_ = self->row;
#line 2865 "../src/Photo.vala"
			_g_object_unref0 (_tmp5_->transformations);
#line 2865 "../src/Photo.vala"
			_tmp5_->transformations = NULL;
#line 2867 "../src/Photo.vala"
			_pixel_transformer_unref0 (self->priv->transformer);
#line 2867 "../src/Photo.vala"
			self->priv->transformer = NULL;
#line 2868 "../src/Photo.vala"
			_pixel_transformation_bundle_unref0 (self->priv->adjustments);
#line 2868 "../src/Photo.vala"
			self->priv->adjustments = NULL;
#line 2870 "../src/Photo.vala"
			_tmp6_ = self->row;
#line 2870 "../src/Photo.vala"
			_tmp7_ = self->backing_photo_row;
#line 2870 "../src/Photo.vala"
			if (_tmp6_->orientation != _tmp7_->original_orientation) {
#line 22429 "Photo.c"
				PhotoTable* _tmp8_;
				PhotoTable* _tmp9_;
				PhotoRow* _tmp10_;
				PhotoID _tmp11_;
				BackingPhotoRow* _tmp12_;
				PhotoRow* _tmp13_;
				BackingPhotoRow* _tmp14_;
#line 2871 "../src/Photo.vala"
				_tmp8_ = photo_table_get_instance ();
#line 2871 "../src/Photo.vala"
				_tmp9_ = _tmp8_;
#line 2871 "../src/Photo.vala"
				_tmp10_ = self->row;
#line 2871 "../src/Photo.vala"
				_tmp11_ = _tmp10_->photo_id;
#line 2871 "../src/Photo.vala"
				_tmp12_ = self->backing_photo_row;
#line 2871 "../src/Photo.vala"
				photo_table_set_orientation (_tmp9_, &_tmp11_, _tmp12_->original_orientation);
#line 2871 "../src/Photo.vala"
				_database_table_unref0 (_tmp9_);
#line 2873 "../src/Photo.vala"
				_tmp13_ = self->row;
#line 2873 "../src/Photo.vala"
				_tmp14_ = self->backing_photo_row;
#line 2873 "../src/Photo.vala"
				_tmp13_->orientation = _tmp14_->original_orientation;
#line 2874 "../src/Photo.vala"
				is_altered = TRUE;
#line 22459 "Photo.c"
			}
		}
		__finally0:
		{
			PhotoRow* _tmp15_;
#line 2863 "../src/Photo.vala"
			_tmp15_ = self->row;
#line 2863 "../src/Photo.vala"
			g_rec_mutex_unlock (&self->priv->__lock_row);
#line 22469 "Photo.c"
		}
#line 2863 "../src/Photo.vala"
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 2863 "../src/Photo.vala"
			g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 2863 "../src/Photo.vala"
			g_clear_error (&_inner_error0_);
#line 2863 "../src/Photo.vala"
			return;
#line 22479 "Photo.c"
		}
	}
#line 2878 "../src/Photo.vala"
	if (is_altered) {
#line 2878 "../src/Photo.vala"
		_tmp16_ = notify;
#line 22486 "Photo.c"
	} else {
#line 2878 "../src/Photo.vala"
		_tmp16_ = FALSE;
#line 22490 "Photo.c"
	}
#line 2878 "../src/Photo.vala"
	if (_tmp16_) {
#line 22494 "Photo.c"
		Alteration* _tmp17_;
		Alteration* _tmp18_;
#line 2879 "../src/Photo.vala"
		_tmp17_ = alteration_new ("image", "revert");
#line 2879 "../src/Photo.vala"
		_tmp18_ = _tmp17_;
#line 2879 "../src/Photo.vala"
		data_object_notify_altered (G_TYPE_CHECK_INSTANCE_CAST (self, TYPE_DATA_OBJECT, DataObject), _tmp18_);
#line 2879 "../src/Photo.vala"
		_alteration_unref0 (_tmp18_);
#line 22505 "Photo.c"
	}
}

Orientation
photo_get_original_orientation (Photo* self)
{
	GError* _inner_error0_ = NULL;
	Orientation result;
#line 2882 "../src/Photo.vala"
	g_return_val_if_fail (IS_PHOTO (self), 0);
#line 22516 "Photo.c"
	{
		PhotoRow* _tmp0_;
#line 2883 "../src/Photo.vala"
		_tmp0_ = self->row;
#line 2883 "../src/Photo.vala"
		g_rec_mutex_lock (&self->priv->__lock_row);
#line 22523 "Photo.c"
		{
			BackingPhotoRow* _tmp1_;
#line 2884 "../src/Photo.vala"
			_tmp1_ = self->backing_photo_row;
#line 2884 "../src/Photo.vala"
			result = _tmp1_->original_orientation;
#line 22530 "Photo.c"
			{
				PhotoRow* _tmp2_;
#line 2883 "../src/Photo.vala"
				_tmp2_ = self->row;
#line 2883 "../src/Photo.vala"
				g_rec_mutex_unlock (&self->priv->__lock_row);
#line 22537 "Photo.c"
			}
#line 2884 "../src/Photo.vala"
			return result;
#line 22541 "Photo.c"
		}
		__finally0:
		{
			PhotoRow* _tmp3_;
#line 2883 "../src/Photo.vala"
			_tmp3_ = self->row;
#line 2883 "../src/Photo.vala"
			g_rec_mutex_unlock (&self->priv->__lock_row);
#line 22550 "Photo.c"
		}
#line 2883 "../src/Photo.vala"
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 2883 "../src/Photo.vala"
		g_clear_error (&_inner_error0_);
#line 2883 "../src/Photo.vala"
		return 0;
#line 22558 "Photo.c"
	}
}

Orientation
photo_get_orientation (Photo* self)
{
	GError* _inner_error0_ = NULL;
	Orientation result;
#line 2888 "../src/Photo.vala"
	g_return_val_if_fail (IS_PHOTO (self), 0);
#line 22569 "Photo.c"
	{
		PhotoRow* _tmp0_;
#line 2889 "../src/Photo.vala"
		_tmp0_ = self->row;
#line 2889 "../src/Photo.vala"
		g_rec_mutex_lock (&self->priv->__lock_row);
#line 22576 "Photo.c"
		{
			PhotoRow* _tmp1_;
#line 2890 "../src/Photo.vala"
			_tmp1_ = self->row;
#line 2890 "../src/Photo.vala"
			result = _tmp1_->orientation;
#line 22583 "Photo.c"
			{
				PhotoRow* _tmp2_;
#line 2889 "../src/Photo.vala"
				_tmp2_ = self->row;
#line 2889 "../src/Photo.vala"
				g_rec_mutex_unlock (&self->priv->__lock_row);
#line 22590 "Photo.c"
			}
#line 2890 "../src/Photo.vala"
			return result;
#line 22594 "Photo.c"
		}
		__finally0:
		{
			PhotoRow* _tmp3_;
#line 2889 "../src/Photo.vala"
			_tmp3_ = self->row;
#line 2889 "../src/Photo.vala"
			g_rec_mutex_unlock (&self->priv->__lock_row);
#line 22603 "Photo.c"
		}
#line 2889 "../src/Photo.vala"
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 2889 "../src/Photo.vala"
		g_clear_error (&_inner_error0_);
#line 2889 "../src/Photo.vala"
		return 0;
#line 22611 "Photo.c"
	}
}

gboolean
photo_set_orientation (Photo* self,
                       Orientation orientation)
{
	gboolean committed = FALSE;
	GError* _inner_error0_ = NULL;
	gboolean result;
#line 2894 "../src/Photo.vala"
	g_return_val_if_fail (IS_PHOTO (self), FALSE);
#line 2895 "../src/Photo.vala"
	committed = FALSE;
#line 22626 "Photo.c"
	{
		PhotoRow* _tmp0_;
#line 2896 "../src/Photo.vala"
		_tmp0_ = self->row;
#line 2896 "../src/Photo.vala"
		g_rec_mutex_lock (&self->priv->__lock_row);
#line 22633 "Photo.c"
		{
			PhotoRow* _tmp1_;
#line 2897 "../src/Photo.vala"
			_tmp1_ = self->row;
#line 2897 "../src/Photo.vala"
			if (_tmp1_->orientation != orientation) {
#line 22640 "Photo.c"
				PhotoTable* _tmp2_;
				PhotoTable* _tmp3_;
				PhotoRow* _tmp4_;
				PhotoID _tmp5_;
#line 2898 "../src/Photo.vala"
				_tmp2_ = photo_table_get_instance ();
#line 2898 "../src/Photo.vala"
				_tmp3_ = _tmp2_;
#line 2898 "../src/Photo.vala"
				_tmp4_ = self->row;
#line 2898 "../src/Photo.vala"
				_tmp5_ = _tmp4_->photo_id;
#line 2898 "../src/Photo.vala"
				committed = photo_table_set_orientation (_tmp3_, &_tmp5_, orientation);
#line 2898 "../src/Photo.vala"
				_database_table_unref0 (_tmp3_);
#line 2899 "../src/Photo.vala"
				if (committed) {
#line 22659 "Photo.c"
					PhotoRow* _tmp6_;
#line 2900 "../src/Photo.vala"
					_tmp6_ = self->row;
#line 2900 "../src/Photo.vala"
					_tmp6_->orientation = orientation;
#line 22665 "Photo.c"
				}
			}
		}
		__finally0:
		{
			PhotoRow* _tmp7_;
#line 2896 "../src/Photo.vala"
			_tmp7_ = self->row;
#line 2896 "../src/Photo.vala"
			g_rec_mutex_unlock (&self->priv->__lock_row);
#line 22676 "Photo.c"
		}
#line 2896 "../src/Photo.vala"
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 22680 "Photo.c"
			gboolean _tmp8_ = FALSE;
#line 2896 "../src/Photo.vala"
			g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 2896 "../src/Photo.vala"
			g_clear_error (&_inner_error0_);
#line 2896 "../src/Photo.vala"
			return _tmp8_;
#line 22688 "Photo.c"
		}
	}
#line 2904 "../src/Photo.vala"
	if (committed) {
#line 22693 "Photo.c"
		Alteration* _tmp9_;
		Alteration* _tmp10_;
#line 2905 "../src/Photo.vala"
		_tmp9_ = alteration_new ("image", "orientation");
#line 2905 "../src/Photo.vala"
		_tmp10_ = _tmp9_;
#line 2905 "../src/Photo.vala"
		data_object_notify_altered (G_TYPE_CHECK_INSTANCE_CAST (self, TYPE_DATA_OBJECT, DataObject), _tmp10_);
#line 2905 "../src/Photo.vala"
		_alteration_unref0 (_tmp10_);
#line 22704 "Photo.c"
	}
#line 2907 "../src/Photo.vala"
	result = committed;
#line 2907 "../src/Photo.vala"
	return result;
#line 22710 "Photo.c"
}

gboolean
photo_check_can_rotate (Photo* self)
{
	gboolean result;
#line 2910 "../src/Photo.vala"
	g_return_val_if_fail (IS_PHOTO (self), FALSE);
#line 2911 "../src/Photo.vala"
	result = self->can_rotate_now;
#line 2911 "../src/Photo.vala"
	return result;
#line 22723 "Photo.c"
}

static void
photo_real_rotate (Photo* self,
                   Rotation rotation)
{
	GError* _inner_error0_ = NULL;
	{
		PhotoRow* _tmp0_;
#line 2915 "../src/Photo.vala"
		_tmp0_ = self->row;
#line 2915 "../src/Photo.vala"
		g_rec_mutex_lock (&self->priv->__lock_row);
#line 22737 "Photo.c"
		{
#line 2916 "../src/Photo.vala"
			photo_set_orientation (self, orientation_perform (photo_get_orientation (self), rotation));
#line 22741 "Photo.c"
		}
		__finally0:
		{
			PhotoRow* _tmp1_;
#line 2915 "../src/Photo.vala"
			_tmp1_ = self->row;
#line 2915 "../src/Photo.vala"
			g_rec_mutex_unlock (&self->priv->__lock_row);
#line 22750 "Photo.c"
		}
#line 2915 "../src/Photo.vala"
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 2915 "../src/Photo.vala"
			g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 2915 "../src/Photo.vala"
			g_clear_error (&_inner_error0_);
#line 2915 "../src/Photo.vala"
			return;
#line 22760 "Photo.c"
		}
	}
}

void
photo_rotate (Photo* self,
              Rotation rotation)
{
	PhotoClass* _klass_;
#line 2914 "../src/Photo.vala"
	g_return_if_fail (IS_PHOTO (self));
#line 2914 "../src/Photo.vala"
	_klass_ = PHOTO_GET_CLASS (self);
#line 2914 "../src/Photo.vala"
	if (_klass_->rotate) {
#line 2914 "../src/Photo.vala"
		_klass_->rotate (self, rotation);
#line 22778 "Photo.c"
	}
}

static gboolean
photo_has_transformation (Photo* self,
                          const gchar* name)
{
	GError* _inner_error0_ = NULL;
	gboolean result;
#line 2920 "../src/Photo.vala"
	g_return_val_if_fail (IS_PHOTO (self), FALSE);
#line 2920 "../src/Photo.vala"
	g_return_val_if_fail (name != NULL, FALSE);
#line 22792 "Photo.c"
	{
		PhotoRow* _tmp0_;
		gboolean _tmp8_ = FALSE;
#line 2921 "../src/Photo.vala"
		_tmp0_ = self->row;
#line 2921 "../src/Photo.vala"
		g_rec_mutex_lock (&self->priv->__lock_row);
#line 22800 "Photo.c"
		{
			gboolean _tmp1_ = FALSE;
			PhotoRow* _tmp2_;
			GeeHashMap* _tmp3_;
#line 2922 "../src/Photo.vala"
			_tmp2_ = self->row;
#line 2922 "../src/Photo.vala"
			_tmp3_ = _tmp2_->transformations;
#line 2922 "../src/Photo.vala"
			if (_tmp3_ != NULL) {
#line 22811 "Photo.c"
				PhotoRow* _tmp4_;
				GeeHashMap* _tmp5_;
#line 2922 "../src/Photo.vala"
				_tmp4_ = self->row;
#line 2922 "../src/Photo.vala"
				_tmp5_ = _tmp4_->transformations;
#line 2922 "../src/Photo.vala"
				_tmp1_ = gee_abstract_map_has_key (G_TYPE_CHECK_INSTANCE_CAST (_tmp5_, GEE_TYPE_ABSTRACT_MAP, GeeAbstractMap), name);
#line 22820 "Photo.c"
			} else {
#line 2922 "../src/Photo.vala"
				_tmp1_ = FALSE;
#line 22824 "Photo.c"
			}
#line 2922 "../src/Photo.vala"
			result = _tmp1_;
#line 22828 "Photo.c"
			{
				PhotoRow* _tmp6_;
#line 2921 "../src/Photo.vala"
				_tmp6_ = self->row;
#line 2921 "../src/Photo.vala"
				g_rec_mutex_unlock (&self->priv->__lock_row);
#line 22835 "Photo.c"
			}
#line 2922 "../src/Photo.vala"
			return result;
#line 22839 "Photo.c"
		}
		__finally0:
		{
			PhotoRow* _tmp7_;
#line 2921 "../src/Photo.vala"
			_tmp7_ = self->row;
#line 2921 "../src/Photo.vala"
			g_rec_mutex_unlock (&self->priv->__lock_row);
#line 22848 "Photo.c"
		}
#line 2921 "../src/Photo.vala"
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 2921 "../src/Photo.vala"
		g_clear_error (&_inner_error0_);
#line 2921 "../src/Photo.vala"
		return _tmp8_;
#line 22856 "Photo.c"
	}
}

static KeyValueMap*
photo_get_transformation (Photo* self,
                          const gchar* name)
{
	KeyValueMap* map = NULL;
	GError* _inner_error0_ = NULL;
	KeyValueMap* result;
#line 2929 "../src/Photo.vala"
	g_return_val_if_fail (IS_PHOTO (self), NULL);
#line 2929 "../src/Photo.vala"
	g_return_val_if_fail (name != NULL, NULL);
#line 2930 "../src/Photo.vala"
	map = NULL;
#line 22873 "Photo.c"
	{
		PhotoRow* _tmp0_;
#line 2931 "../src/Photo.vala"
		_tmp0_ = self->row;
#line 2931 "../src/Photo.vala"
		g_rec_mutex_lock (&self->priv->__lock_row);
#line 22880 "Photo.c"
		{
			PhotoRow* _tmp1_;
			GeeHashMap* _tmp2_;
#line 2932 "../src/Photo.vala"
			_tmp1_ = self->row;
#line 2932 "../src/Photo.vala"
			_tmp2_ = _tmp1_->transformations;
#line 2932 "../src/Photo.vala"
			if (_tmp2_ != NULL) {
#line 22890 "Photo.c"
				PhotoRow* _tmp3_;
				GeeHashMap* _tmp4_;
				gpointer _tmp5_;
				KeyValueMap* _tmp6_;
#line 2933 "../src/Photo.vala"
				_tmp3_ = self->row;
#line 2933 "../src/Photo.vala"
				_tmp4_ = _tmp3_->transformations;
#line 2933 "../src/Photo.vala"
				_tmp5_ = gee_abstract_map_get (G_TYPE_CHECK_INSTANCE_CAST (_tmp4_, GEE_TYPE_ABSTRACT_MAP, GeeAbstractMap), name);
#line 2933 "../src/Photo.vala"
				_key_value_map_unref0 (map);
#line 2933 "../src/Photo.vala"
				map = (KeyValueMap*) _tmp5_;
#line 2934 "../src/Photo.vala"
				_tmp6_ = map;
#line 2934 "../src/Photo.vala"
				if (_tmp6_ != NULL) {
#line 22909 "Photo.c"
					KeyValueMap* _tmp7_;
					KeyValueMap* _tmp8_;
#line 2935 "../src/Photo.vala"
					_tmp7_ = map;
#line 2935 "../src/Photo.vala"
					_tmp8_ = key_value_map_copy (_tmp7_);
#line 2935 "../src/Photo.vala"
					_key_value_map_unref0 (map);
#line 2935 "../src/Photo.vala"
					map = _tmp8_;
#line 22920 "Photo.c"
				}
			}
		}
		__finally0:
		{
			PhotoRow* _tmp9_;
#line 2931 "../src/Photo.vala"
			_tmp9_ = self->row;
#line 2931 "../src/Photo.vala"
			g_rec_mutex_unlock (&self->priv->__lock_row);
#line 22931 "Photo.c"
		}
#line 2931 "../src/Photo.vala"
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 2931 "../src/Photo.vala"
			_key_value_map_unref0 (map);
#line 2931 "../src/Photo.vala"
			g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 2931 "../src/Photo.vala"
			g_clear_error (&_inner_error0_);
#line 2931 "../src/Photo.vala"
			return NULL;
#line 22943 "Photo.c"
		}
	}
#line 2939 "../src/Photo.vala"
	result = map;
#line 2939 "../src/Photo.vala"
	return result;
#line 22950 "Photo.c"
}

static gboolean
photo_set_transformation (Photo* self,
                          KeyValueMap* trans)
{
	GError* _inner_error0_ = NULL;
	gboolean result;
#line 2942 "../src/Photo.vala"
	g_return_val_if_fail (IS_PHOTO (self), FALSE);
#line 2942 "../src/Photo.vala"
	g_return_val_if_fail (G_TYPE_CHECK_INSTANCE_TYPE (trans, TYPE_KEY_VALUE_MAP), FALSE);
#line 22963 "Photo.c"
	{
		PhotoRow* _tmp0_;
		gboolean _tmp16_ = FALSE;
#line 2943 "../src/Photo.vala"
		_tmp0_ = self->row;
#line 2943 "../src/Photo.vala"
		g_rec_mutex_lock (&self->priv->__lock_row);
#line 22971 "Photo.c"
		{
			PhotoRow* _tmp1_;
			GeeHashMap* _tmp2_;
			PhotoRow* _tmp5_;
			GeeHashMap* _tmp6_;
			gchar* _tmp7_;
			gchar* _tmp8_;
			PhotoTable* _tmp9_;
			PhotoTable* _tmp10_;
			PhotoRow* _tmp11_;
			PhotoID _tmp12_;
			gboolean _tmp13_;
#line 2944 "../src/Photo.vala"
			_tmp1_ = self->row;
#line 2944 "../src/Photo.vala"
			_tmp2_ = _tmp1_->transformations;
#line 2944 "../src/Photo.vala"
			if (_tmp2_ == NULL) {
#line 22990 "Photo.c"
				PhotoRow* _tmp3_;
				GeeHashMap* _tmp4_;
#line 2945 "../src/Photo.vala"
				_tmp3_ = self->row;
#line 2945 "../src/Photo.vala"
				_tmp4_ = gee_hash_map_new (G_TYPE_STRING, (GBoxedCopyFunc) g_strdup, (GDestroyNotify) g_free, TYPE_KEY_VALUE_MAP, (GBoxedCopyFunc) key_value_map_ref, (GDestroyNotify) key_value_map_unref, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL);
#line 2945 "../src/Photo.vala"
				_g_object_unref0 (_tmp3_->transformations);
#line 2945 "../src/Photo.vala"
				_tmp3_->transformations = _tmp4_;
#line 23001 "Photo.c"
			}
#line 2947 "../src/Photo.vala"
			_tmp5_ = self->row;
#line 2947 "../src/Photo.vala"
			_tmp6_ = _tmp5_->transformations;
#line 2947 "../src/Photo.vala"
			_tmp7_ = key_value_map_get_group (trans);
#line 2947 "../src/Photo.vala"
			_tmp8_ = _tmp7_;
#line 2947 "../src/Photo.vala"
			gee_abstract_map_set (G_TYPE_CHECK_INSTANCE_CAST (_tmp6_, GEE_TYPE_ABSTRACT_MAP, GeeAbstractMap), _tmp8_, trans);
#line 2947 "../src/Photo.vala"
			_g_free0 (_tmp8_);
#line 2949 "../src/Photo.vala"
			_tmp9_ = photo_table_get_instance ();
#line 2949 "../src/Photo.vala"
			_tmp10_ = _tmp9_;
#line 2949 "../src/Photo.vala"
			_tmp11_ = self->row;
#line 2949 "../src/Photo.vala"
			_tmp12_ = _tmp11_->photo_id;
#line 2949 "../src/Photo.vala"
			_tmp13_ = photo_table_set_transformation (_tmp10_, &_tmp12_, trans);
#line 2949 "../src/Photo.vala"
			_database_table_unref0 (_tmp10_);
#line 2949 "../src/Photo.vala"
			result = _tmp13_;
#line 23029 "Photo.c"
			{
				PhotoRow* _tmp14_;
#line 2943 "../src/Photo.vala"
				_tmp14_ = self->row;
#line 2943 "../src/Photo.vala"
				g_rec_mutex_unlock (&self->priv->__lock_row);
#line 23036 "Photo.c"
			}
#line 2949 "../src/Photo.vala"
			return result;
#line 23040 "Photo.c"
		}
		__finally0:
		{
			PhotoRow* _tmp15_;
#line 2943 "../src/Photo.vala"
			_tmp15_ = self->row;
#line 2943 "../src/Photo.vala"
			g_rec_mutex_unlock (&self->priv->__lock_row);
#line 23049 "Photo.c"
		}
#line 2943 "../src/Photo.vala"
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 2943 "../src/Photo.vala"
		g_clear_error (&_inner_error0_);
#line 2943 "../src/Photo.vala"
		return _tmp16_;
#line 23057 "Photo.c"
	}
}

static gboolean
photo_remove_transformation (Photo* self,
                             const gchar* name)
{
	gboolean altered_cache = FALSE;
	gboolean altered_persistent = FALSE;
	gboolean _tmp16_ = FALSE;
	GError* _inner_error0_ = NULL;
	gboolean result;
#line 2953 "../src/Photo.vala"
	g_return_val_if_fail (IS_PHOTO (self), FALSE);
#line 2953 "../src/Photo.vala"
	g_return_val_if_fail (name != NULL, FALSE);
#line 23074 "Photo.c"
	{
		PhotoRow* _tmp0_;
#line 2955 "../src/Photo.vala"
		_tmp0_ = self->row;
#line 2955 "../src/Photo.vala"
		g_rec_mutex_lock (&self->priv->__lock_row);
#line 23081 "Photo.c"
		{
			PhotoRow* _tmp1_;
			GeeHashMap* _tmp2_;
			PhotoTable* _tmp10_;
			PhotoTable* _tmp11_;
			PhotoRow* _tmp12_;
			PhotoID _tmp13_;
#line 2956 "../src/Photo.vala"
			_tmp1_ = self->row;
#line 2956 "../src/Photo.vala"
			_tmp2_ = _tmp1_->transformations;
#line 2956 "../src/Photo.vala"
			if (_tmp2_ != NULL) {
#line 23095 "Photo.c"
				PhotoRow* _tmp3_;
				GeeHashMap* _tmp4_;
				PhotoRow* _tmp5_;
				GeeHashMap* _tmp6_;
				gint _tmp7_;
				gint _tmp8_;
#line 2957 "../src/Photo.vala"
				_tmp3_ = self->row;
#line 2957 "../src/Photo.vala"
				_tmp4_ = _tmp3_->transformations;
#line 2957 "../src/Photo.vala"
				altered_cache = gee_abstract_map_unset (G_TYPE_CHECK_INSTANCE_CAST (_tmp4_, GEE_TYPE_ABSTRACT_MAP, GeeAbstractMap), name, NULL);
#line 2958 "../src/Photo.vala"
				_tmp5_ = self->row;
#line 2958 "../src/Photo.vala"
				_tmp6_ = _tmp5_->transformations;
#line 2958 "../src/Photo.vala"
				_tmp7_ = gee_abstract_map_get_size (G_TYPE_CHECK_INSTANCE_CAST (_tmp6_, GEE_TYPE_ABSTRACT_MAP, GeeAbstractMap));
#line 2958 "../src/Photo.vala"
				_tmp8_ = _tmp7_;
#line 2958 "../src/Photo.vala"
				if (_tmp8_ == 0) {
#line 23118 "Photo.c"
					PhotoRow* _tmp9_;
#line 2959 "../src/Photo.vala"
					_tmp9_ = self->row;
#line 2959 "../src/Photo.vala"
					_g_object_unref0 (_tmp9_->transformations);
#line 2959 "../src/Photo.vala"
					_tmp9_->transformations = NULL;
#line 23126 "Photo.c"
				}
			} else {
#line 2961 "../src/Photo.vala"
				altered_cache = FALSE;
#line 23131 "Photo.c"
			}
#line 2964 "../src/Photo.vala"
			_tmp10_ = photo_table_get_instance ();
#line 2964 "../src/Photo.vala"
			_tmp11_ = _tmp10_;
#line 2964 "../src/Photo.vala"
			_tmp12_ = self->row;
#line 2964 "../src/Photo.vala"
			_tmp13_ = _tmp12_->photo_id;
#line 2964 "../src/Photo.vala"
			altered_persistent = photo_table_remove_transformation (_tmp11_, &_tmp13_, name);
#line 2964 "../src/Photo.vala"
			_database_table_unref0 (_tmp11_);
#line 23145 "Photo.c"
		}
		__finally0:
		{
			PhotoRow* _tmp14_;
#line 2955 "../src/Photo.vala"
			_tmp14_ = self->row;
#line 2955 "../src/Photo.vala"
			g_rec_mutex_unlock (&self->priv->__lock_row);
#line 23154 "Photo.c"
		}
#line 2955 "../src/Photo.vala"
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 23158 "Photo.c"
			gboolean _tmp15_ = FALSE;
#line 2955 "../src/Photo.vala"
			g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 2955 "../src/Photo.vala"
			g_clear_error (&_inner_error0_);
#line 2955 "../src/Photo.vala"
			return _tmp15_;
#line 23166 "Photo.c"
		}
	}
#line 2968 "../src/Photo.vala"
	if (altered_cache) {
#line 2968 "../src/Photo.vala"
		_tmp16_ = TRUE;
#line 23173 "Photo.c"
	} else {
#line 2968 "../src/Photo.vala"
		_tmp16_ = altered_persistent;
#line 23177 "Photo.c"
	}
#line 2968 "../src/Photo.vala"
	result = _tmp16_;
#line 2968 "../src/Photo.vala"
	return result;
#line 23183 "Photo.c"
}

gboolean
photo_has_crop (Photo* self)
{
	gboolean result;
#line 2971 "../src/Photo.vala"
	g_return_val_if_fail (IS_PHOTO (self), FALSE);
#line 2972 "../src/Photo.vala"
	result = photo_has_transformation (self, "crop");
#line 2972 "../src/Photo.vala"
	return result;
#line 23196 "Photo.c"
}

gboolean
photo_get_raw_crop (Photo* self,
                    Box* crop)
{
	Box _vala_crop = {0};
	KeyValueMap* map = NULL;
	KeyValueMap* _tmp0_;
	KeyValueMap* _tmp1_;
	gint left = 0;
	KeyValueMap* _tmp2_;
	gint top = 0;
	KeyValueMap* _tmp3_;
	gint right = 0;
	KeyValueMap* _tmp4_;
	gint bottom = 0;
	KeyValueMap* _tmp5_;
	gboolean _tmp6_ = FALSE;
	gboolean _tmp7_ = FALSE;
	gboolean _tmp8_ = FALSE;
	gboolean result;
#line 2976 "../src/Photo.vala"
	g_return_val_if_fail (IS_PHOTO (self), FALSE);
#line 2977 "../src/Photo.vala"
	box_init (&_vala_crop, 0, 0, 0, 0);
#line 2979 "../src/Photo.vala"
	_tmp0_ = photo_get_transformation (self, "crop");
#line 2979 "../src/Photo.vala"
	map = _tmp0_;
#line 2980 "../src/Photo.vala"
	_tmp1_ = map;
#line 2980 "../src/Photo.vala"
	if (_tmp1_ == NULL) {
#line 2981 "../src/Photo.vala"
		result = FALSE;
#line 2981 "../src/Photo.vala"
		_key_value_map_unref0 (map);
#line 2981 "../src/Photo.vala"
		if (crop) {
#line 2981 "../src/Photo.vala"
			*crop = _vala_crop;
#line 23239 "Photo.c"
		}
#line 2981 "../src/Photo.vala"
		return result;
#line 23243 "Photo.c"
	}
#line 2983 "../src/Photo.vala"
	_tmp2_ = map;
#line 2983 "../src/Photo.vala"
	left = key_value_map_get_int (_tmp2_, "left", -1);
#line 2984 "../src/Photo.vala"
	_tmp3_ = map;
#line 2984 "../src/Photo.vala"
	top = key_value_map_get_int (_tmp3_, "top", -1);
#line 2985 "../src/Photo.vala"
	_tmp4_ = map;
#line 2985 "../src/Photo.vala"
	right = key_value_map_get_int (_tmp4_, "right", -1);
#line 2986 "../src/Photo.vala"
	_tmp5_ = map;
#line 2986 "../src/Photo.vala"
	bottom = key_value_map_get_int (_tmp5_, "bottom", -1);
#line 2988 "../src/Photo.vala"
	if (left == -1) {
#line 2988 "../src/Photo.vala"
		_tmp8_ = TRUE;
#line 23265 "Photo.c"
	} else {
#line 2988 "../src/Photo.vala"
		_tmp8_ = top == -1;
#line 23269 "Photo.c"
	}
#line 2988 "../src/Photo.vala"
	if (_tmp8_) {
#line 2988 "../src/Photo.vala"
		_tmp7_ = TRUE;
#line 23275 "Photo.c"
	} else {
#line 2988 "../src/Photo.vala"
		_tmp7_ = right == -1;
#line 23279 "Photo.c"
	}
#line 2988 "../src/Photo.vala"
	if (_tmp7_) {
#line 2988 "../src/Photo.vala"
		_tmp6_ = TRUE;
#line 23285 "Photo.c"
	} else {
#line 2988 "../src/Photo.vala"
		_tmp6_ = bottom == -1;
#line 23289 "Photo.c"
	}
#line 2988 "../src/Photo.vala"
	if (_tmp6_) {
#line 2989 "../src/Photo.vala"
		result = FALSE;
#line 2989 "../src/Photo.vala"
		_key_value_map_unref0 (map);
#line 2989 "../src/Photo.vala"
		if (crop) {
#line 2989 "../src/Photo.vala"
			*crop = _vala_crop;
#line 23301 "Photo.c"
		}
#line 2989 "../src/Photo.vala"
		return result;
#line 23305 "Photo.c"
	}
#line 2991 "../src/Photo.vala"
	box_init (&_vala_crop, left, top, right, bottom);
#line 2993 "../src/Photo.vala"
	result = TRUE;
#line 2993 "../src/Photo.vala"
	_key_value_map_unref0 (map);
#line 2993 "../src/Photo.vala"
	if (crop) {
#line 2993 "../src/Photo.vala"
		*crop = _vala_crop;
#line 23317 "Photo.c"
	}
#line 2993 "../src/Photo.vala"
	return result;
#line 23321 "Photo.c"
}

static void
photo_set_raw_crop (Photo* self,
                    Box* crop)
{
	KeyValueMap* map = NULL;
	KeyValueMap* _tmp0_;
	KeyValueMap* _tmp1_;
	Box _tmp2_;
	KeyValueMap* _tmp3_;
	Box _tmp4_;
	KeyValueMap* _tmp5_;
	Box _tmp6_;
	KeyValueMap* _tmp7_;
	Box _tmp8_;
	KeyValueMap* _tmp9_;
#line 2997 "../src/Photo.vala"
	g_return_if_fail (IS_PHOTO (self));
#line 2997 "../src/Photo.vala"
	g_return_if_fail (crop != NULL);
#line 2998 "../src/Photo.vala"
	_tmp0_ = key_value_map_new ("crop");
#line 2998 "../src/Photo.vala"
	map = _tmp0_;
#line 2999 "../src/Photo.vala"
	_tmp1_ = map;
#line 2999 "../src/Photo.vala"
	_tmp2_ = *crop;
#line 2999 "../src/Photo.vala"
	key_value_map_set_int (_tmp1_, "left", _tmp2_.left);
#line 3000 "../src/Photo.vala"
	_tmp3_ = map;
#line 3000 "../src/Photo.vala"
	_tmp4_ = *crop;
#line 3000 "../src/Photo.vala"
	key_value_map_set_int (_tmp3_, "top", _tmp4_.top);
#line 3001 "../src/Photo.vala"
	_tmp5_ = map;
#line 3001 "../src/Photo.vala"
	_tmp6_ = *crop;
#line 3001 "../src/Photo.vala"
	key_value_map_set_int (_tmp5_, "right", _tmp6_.right);
#line 3002 "../src/Photo.vala"
	_tmp7_ = map;
#line 3002 "../src/Photo.vala"
	_tmp8_ = *crop;
#line 3002 "../src/Photo.vala"
	key_value_map_set_int (_tmp7_, "bottom", _tmp8_.bottom);
#line 3004 "../src/Photo.vala"
	_tmp9_ = map;
#line 3004 "../src/Photo.vala"
	if (photo_set_transformation (self, _tmp9_)) {
#line 23375 "Photo.c"
		Alteration* _tmp10_;
		Alteration* _tmp11_;
#line 3005 "../src/Photo.vala"
		_tmp10_ = alteration_new ("image", "crop");
#line 3005 "../src/Photo.vala"
		_tmp11_ = _tmp10_;
#line 3005 "../src/Photo.vala"
		data_object_notify_altered (G_TYPE_CHECK_INSTANCE_CAST (self, TYPE_DATA_OBJECT, DataObject), _tmp11_);
#line 3005 "../src/Photo.vala"
		_alteration_unref0 (_tmp11_);
#line 23386 "Photo.c"
	}
#line 2997 "../src/Photo.vala"
	_key_value_map_unref0 (map);
#line 23390 "Photo.c"
}

static gboolean
photo_get_raw_straighten (Photo* self,
                          gdouble* angle)
{
	gdouble _vala_angle = 0.0;
	KeyValueMap* map = NULL;
	KeyValueMap* _tmp0_;
	KeyValueMap* _tmp1_;
	KeyValueMap* _tmp2_;
	gboolean result;
#line 3008 "../src/Photo.vala"
	g_return_val_if_fail (IS_PHOTO (self), FALSE);
#line 3009 "../src/Photo.vala"
	_tmp0_ = photo_get_transformation (self, "straighten");
#line 3009 "../src/Photo.vala"
	map = _tmp0_;
#line 3010 "../src/Photo.vala"
	_tmp1_ = map;
#line 3010 "../src/Photo.vala"
	if (_tmp1_ == NULL) {
#line 3011 "../src/Photo.vala"
		_vala_angle = 0.0;
#line 3013 "../src/Photo.vala"
		result = FALSE;
#line 3013 "../src/Photo.vala"
		_key_value_map_unref0 (map);
#line 3013 "../src/Photo.vala"
		if (angle) {
#line 3013 "../src/Photo.vala"
			*angle = _vala_angle;
#line 23423 "Photo.c"
		}
#line 3013 "../src/Photo.vala"
		return result;
#line 23427 "Photo.c"
	}
#line 3016 "../src/Photo.vala"
	_tmp2_ = map;
#line 3016 "../src/Photo.vala"
	_vala_angle = key_value_map_get_double (_tmp2_, "angle", 0.0);
#line 3018 "../src/Photo.vala"
	result = TRUE;
#line 3018 "../src/Photo.vala"
	_key_value_map_unref0 (map);
#line 3018 "../src/Photo.vala"
	if (angle) {
#line 3018 "../src/Photo.vala"
		*angle = _vala_angle;
#line 23441 "Photo.c"
	}
#line 3018 "../src/Photo.vala"
	return result;
#line 23445 "Photo.c"
}

static void
photo_set_raw_straighten (Photo* self,
                          gdouble theta)
{
	KeyValueMap* map = NULL;
	KeyValueMap* _tmp0_;
	KeyValueMap* _tmp1_;
	KeyValueMap* _tmp2_;
#line 3021 "../src/Photo.vala"
	g_return_if_fail (IS_PHOTO (self));
#line 3022 "../src/Photo.vala"
	_tmp0_ = key_value_map_new ("straighten");
#line 3022 "../src/Photo.vala"
	map = _tmp0_;
#line 3023 "../src/Photo.vala"
	_tmp1_ = map;
#line 3023 "../src/Photo.vala"
	key_value_map_set_double (_tmp1_, "angle", theta);
#line 3025 "../src/Photo.vala"
	_tmp2_ = map;
#line 3025 "../src/Photo.vala"
	if (photo_set_transformation (self, _tmp2_)) {
#line 23470 "Photo.c"
		Alteration* _tmp3_;
		Alteration* _tmp4_;
#line 3026 "../src/Photo.vala"
		_tmp3_ = alteration_new ("image", "straighten");
#line 3026 "../src/Photo.vala"
		_tmp4_ = _tmp3_;
#line 3026 "../src/Photo.vala"
		data_object_notify_altered (G_TYPE_CHECK_INSTANCE_CAST (self, TYPE_DATA_OBJECT, DataObject), _tmp4_);
#line 3026 "../src/Photo.vala"
		_alteration_unref0 (_tmp4_);
#line 23481 "Photo.c"
	}
#line 3021 "../src/Photo.vala"
	_key_value_map_unref0 (map);
#line 23485 "Photo.c"
}

static EditingToolsRedeyeInstance*
photo_get_raw_redeye_instances (Photo* self,
                                gint* result_length1)
{
	KeyValueMap* map = NULL;
	KeyValueMap* _tmp0_;
	KeyValueMap* _tmp1_;
	gint num_points = 0;
	KeyValueMap* _tmp4_;
	EditingToolsRedeyeInstance* res = NULL;
	EditingToolsRedeyeInstance* _tmp5_;
	gint res_length1;
	gint _res_size_;
	GdkPoint default_point = {0};
	GdkPoint _tmp6_ = {0};
	EditingToolsRedeyeInstance* _tmp29_;
	gint _tmp29__length1;
	EditingToolsRedeyeInstance* result;
#line 3031 "../src/Photo.vala"
	g_return_val_if_fail (IS_PHOTO (self), NULL);
#line 3032 "../src/Photo.vala"
	_tmp0_ = photo_get_transformation (self, "redeye");
#line 3032 "../src/Photo.vala"
	map = _tmp0_;
#line 3033 "../src/Photo.vala"
	_tmp1_ = map;
#line 3033 "../src/Photo.vala"
	if (_tmp1_ == NULL) {
#line 23516 "Photo.c"
		EditingToolsRedeyeInstance* _tmp2_;
		EditingToolsRedeyeInstance* _tmp3_;
		gint _tmp3__length1;
#line 3034 "../src/Photo.vala"
		_tmp2_ = g_new0 (EditingToolsRedeyeInstance, 0);
#line 3034 "../src/Photo.vala"
		_tmp3_ = _tmp2_;
#line 3034 "../src/Photo.vala"
		_tmp3__length1 = 0;
#line 3034 "../src/Photo.vala"
		if (result_length1) {
#line 3034 "../src/Photo.vala"
			*result_length1 = _tmp3__length1;
#line 23530 "Photo.c"
		}
#line 3034 "../src/Photo.vala"
		result = _tmp3_;
#line 3034 "../src/Photo.vala"
		_key_value_map_unref0 (map);
#line 3034 "../src/Photo.vala"
		return result;
#line 23538 "Photo.c"
	}
#line 3036 "../src/Photo.vala"
	_tmp4_ = map;
#line 3036 "../src/Photo.vala"
	num_points = key_value_map_get_int (_tmp4_, "num_points", -1);
#line 3037 "../src/Photo.vala"
	_vala_assert (num_points > 0, "num_points > 0");
#line 3039 "../src/Photo.vala"
	_tmp5_ = g_new0 (EditingToolsRedeyeInstance, num_points);
#line 3039 "../src/Photo.vala"
	res = _tmp5_;
#line 3039 "../src/Photo.vala"
	res_length1 = num_points;
#line 3039 "../src/Photo.vala"
	_res_size_ = res_length1;
#line 3041 "../src/Photo.vala"
	_tmp6_.x = 0;
#line 3041 "../src/Photo.vala"
	default_point = _tmp6_;
#line 3042 "../src/Photo.vala"
	default_point.x = -1;
#line 3043 "../src/Photo.vala"
	default_point.y = -1;
#line 23562 "Photo.c"
	{
		gint i = 0;
#line 3045 "../src/Photo.vala"
		i = 0;
#line 23567 "Photo.c"
		{
			gboolean _tmp7_ = FALSE;
#line 3045 "../src/Photo.vala"
			_tmp7_ = TRUE;
#line 3045 "../src/Photo.vala"
			while (TRUE) {
#line 23574 "Photo.c"
				gchar* center_key = NULL;
				gchar* _tmp9_;
				gchar* radius_key = NULL;
				gchar* _tmp10_;
				EditingToolsRedeyeInstance* _tmp11_;
				gint _tmp11__length1;
				KeyValueMap* _tmp12_;
				const gchar* _tmp13_;
				GdkPoint _tmp14_;
				GdkPoint _tmp15_ = {0};
				EditingToolsRedeyeInstance* _tmp16_;
				gint _tmp16__length1;
				EditingToolsRedeyeInstance _tmp17_;
				GdkPoint _tmp18_;
				GdkPoint _tmp19_;
				EditingToolsRedeyeInstance* _tmp20_;
				gint _tmp20__length1;
				EditingToolsRedeyeInstance _tmp21_;
				GdkPoint _tmp22_;
				GdkPoint _tmp23_;
				EditingToolsRedeyeInstance* _tmp24_;
				gint _tmp24__length1;
				KeyValueMap* _tmp25_;
				const gchar* _tmp26_;
				EditingToolsRedeyeInstance* _tmp27_;
				gint _tmp27__length1;
				EditingToolsRedeyeInstance _tmp28_;
#line 3045 "../src/Photo.vala"
				if (!_tmp7_) {
#line 23604 "Photo.c"
					gint _tmp8_;
#line 3045 "../src/Photo.vala"
					_tmp8_ = i;
#line 3045 "../src/Photo.vala"
					i = _tmp8_ + 1;
#line 23610 "Photo.c"
				}
#line 3045 "../src/Photo.vala"
				_tmp7_ = FALSE;
#line 3045 "../src/Photo.vala"
				if (!(i < num_points)) {
#line 3045 "../src/Photo.vala"
					break;
#line 23618 "Photo.c"
				}
#line 3046 "../src/Photo.vala"
				_tmp9_ = g_strdup_printf ("center%d", i);
#line 3046 "../src/Photo.vala"
				center_key = _tmp9_;
#line 3047 "../src/Photo.vala"
				_tmp10_ = g_strdup_printf ("radius%d", i);
#line 3047 "../src/Photo.vala"
				radius_key = _tmp10_;
#line 3049 "../src/Photo.vala"
				_tmp11_ = res;
#line 3049 "../src/Photo.vala"
				_tmp11__length1 = res_length1;
#line 3049 "../src/Photo.vala"
				_tmp12_ = map;
#line 3049 "../src/Photo.vala"
				_tmp13_ = center_key;
#line 3049 "../src/Photo.vala"
				_tmp14_ = default_point;
#line 3049 "../src/Photo.vala"
				key_value_map_get_point (_tmp12_, _tmp13_, &_tmp14_, &_tmp15_);
#line 3049 "../src/Photo.vala"
				_tmp11_[i].center = _tmp15_;
#line 3050 "../src/Photo.vala"
				_tmp16_ = res;
#line 3050 "../src/Photo.vala"
				_tmp16__length1 = res_length1;
#line 3050 "../src/Photo.vala"
				_tmp17_ = _tmp16_[i];
#line 3050 "../src/Photo.vala"
				_tmp18_ = _tmp17_.center;
#line 3050 "../src/Photo.vala"
				_tmp19_ = default_point;
#line 3050 "../src/Photo.vala"
				_vala_assert (_tmp18_.x != _tmp19_.x, "res[i].center.x != default_point.x");
#line 3051 "../src/Photo.vala"
				_tmp20_ = res;
#line 3051 "../src/Photo.vala"
				_tmp20__length1 = res_length1;
#line 3051 "../src/Photo.vala"
				_tmp21_ = _tmp20_[i];
#line 3051 "../src/Photo.vala"
				_tmp22_ = _tmp21_.center;
#line 3051 "../src/Photo.vala"
				_tmp23_ = default_point;
#line 3051 "../src/Photo.vala"
				_vala_assert (_tmp22_.y != _tmp23_.y, "res[i].center.y != default_point.y");
#line 3053 "../src/Photo.vala"
				_tmp24_ = res;
#line 3053 "../src/Photo.vala"
				_tmp24__length1 = res_length1;
#line 3053 "../src/Photo.vala"
				_tmp25_ = map;
#line 3053 "../src/Photo.vala"
				_tmp26_ = radius_key;
#line 3053 "../src/Photo.vala"
				_tmp24_[i].radius = key_value_map_get_int (_tmp25_, _tmp26_, -1);
#line 3054 "../src/Photo.vala"
				_tmp27_ = res;
#line 3054 "../src/Photo.vala"
				_tmp27__length1 = res_length1;
#line 3054 "../src/Photo.vala"
				_tmp28_ = _tmp27_[i];
#line 3054 "../src/Photo.vala"
				_vala_assert (_tmp28_.radius != -1, "res[i].radius != -1");
#line 3045 "../src/Photo.vala"
				_g_free0 (radius_key);
#line 3045 "../src/Photo.vala"
				_g_free0 (center_key);
#line 23688 "Photo.c"
			}
		}
	}
#line 3057 "../src/Photo.vala"
	_tmp29_ = res;
#line 3057 "../src/Photo.vala"
	_tmp29__length1 = res_length1;
#line 3057 "../src/Photo.vala"
	if (result_length1) {
#line 3057 "../src/Photo.vala"
		*result_length1 = _tmp29__length1;
#line 23700 "Photo.c"
	}
#line 3057 "../src/Photo.vala"
	result = _tmp29_;
#line 3057 "../src/Photo.vala"
	_key_value_map_unref0 (map);
#line 3057 "../src/Photo.vala"
	return result;
#line 23708 "Photo.c"
}

gboolean
photo_has_redeye_transformations (Photo* self)
{
	gboolean result;
#line 3060 "../src/Photo.vala"
	g_return_val_if_fail (IS_PHOTO (self), FALSE);
#line 3061 "../src/Photo.vala"
	result = photo_has_transformation (self, "redeye");
#line 3061 "../src/Photo.vala"
	return result;
#line 23721 "Photo.c"
}

void
photo_add_redeye_instance (Photo* self,
                           EditingToolsRedeyeInstance* redeye)
{
	KeyValueMap* map = NULL;
	KeyValueMap* _tmp0_;
	KeyValueMap* _tmp1_;
	gint num_points = 0;
	KeyValueMap* _tmp4_;
	gint _tmp5_;
	gchar* radius_key = NULL;
	gchar* _tmp6_;
	gchar* center_key = NULL;
	gchar* _tmp7_;
	KeyValueMap* _tmp8_;
	const gchar* _tmp9_;
	EditingToolsRedeyeInstance _tmp10_;
	KeyValueMap* _tmp11_;
	const gchar* _tmp12_;
	EditingToolsRedeyeInstance _tmp13_;
	GdkPoint _tmp14_;
	KeyValueMap* _tmp15_;
	KeyValueMap* _tmp16_;
#line 3065 "../src/Photo.vala"
	g_return_if_fail (IS_PHOTO (self));
#line 3065 "../src/Photo.vala"
	g_return_if_fail (redeye != NULL);
#line 3066 "../src/Photo.vala"
	_tmp0_ = photo_get_transformation (self, "redeye");
#line 3066 "../src/Photo.vala"
	map = _tmp0_;
#line 3067 "../src/Photo.vala"
	_tmp1_ = map;
#line 3067 "../src/Photo.vala"
	if (_tmp1_ == NULL) {
#line 23759 "Photo.c"
		KeyValueMap* _tmp2_;
		KeyValueMap* _tmp3_;
#line 3068 "../src/Photo.vala"
		_tmp2_ = key_value_map_new ("redeye");
#line 3068 "../src/Photo.vala"
		_key_value_map_unref0 (map);
#line 3068 "../src/Photo.vala"
		map = _tmp2_;
#line 3069 "../src/Photo.vala"
		_tmp3_ = map;
#line 3069 "../src/Photo.vala"
		key_value_map_set_int (_tmp3_, "num_points", 0);
#line 23772 "Photo.c"
	}
#line 3072 "../src/Photo.vala"
	_tmp4_ = map;
#line 3072 "../src/Photo.vala"
	num_points = key_value_map_get_int (_tmp4_, "num_points", -1);
#line 3073 "../src/Photo.vala"
	_vala_assert (num_points >= 0, "num_points >= 0");
#line 3075 "../src/Photo.vala"
	_tmp5_ = num_points;
#line 3075 "../src/Photo.vala"
	num_points = _tmp5_ + 1;
#line 3077 "../src/Photo.vala"
	_tmp6_ = g_strdup_printf ("radius%d", num_points - 1);
#line 3077 "../src/Photo.vala"
	radius_key = _tmp6_;
#line 3078 "../src/Photo.vala"
	_tmp7_ = g_strdup_printf ("center%d", num_points - 1);
#line 3078 "../src/Photo.vala"
	center_key = _tmp7_;
#line 3080 "../src/Photo.vala"
	_tmp8_ = map;
#line 3080 "../src/Photo.vala"
	_tmp9_ = radius_key;
#line 3080 "../src/Photo.vala"
	_tmp10_ = *redeye;
#line 3080 "../src/Photo.vala"
	key_value_map_set_int (_tmp8_, _tmp9_, _tmp10_.radius);
#line 3081 "../src/Photo.vala"
	_tmp11_ = map;
#line 3081 "../src/Photo.vala"
	_tmp12_ = center_key;
#line 3081 "../src/Photo.vala"
	_tmp13_ = *redeye;
#line 3081 "../src/Photo.vala"
	_tmp14_ = _tmp13_.center;
#line 3081 "../src/Photo.vala"
	key_value_map_set_point (_tmp11_, _tmp12_, &_tmp14_);
#line 3083 "../src/Photo.vala"
	_tmp15_ = map;
#line 3083 "../src/Photo.vala"
	key_value_map_set_int (_tmp15_, "num_points", num_points);
#line 3085 "../src/Photo.vala"
	_tmp16_ = map;
#line 3085 "../src/Photo.vala"
	if (photo_set_transformation (self, _tmp16_)) {
#line 23818 "Photo.c"
		Alteration* _tmp17_;
		Alteration* _tmp18_;
#line 3086 "../src/Photo.vala"
		_tmp17_ = alteration_new ("image", "redeye");
#line 3086 "../src/Photo.vala"
		_tmp18_ = _tmp17_;
#line 3086 "../src/Photo.vala"
		data_object_notify_altered (G_TYPE_CHECK_INSTANCE_CAST (self, TYPE_DATA_OBJECT, DataObject), _tmp18_);
#line 3086 "../src/Photo.vala"
		_alteration_unref0 (_tmp18_);
#line 23829 "Photo.c"
	}
#line 3065 "../src/Photo.vala"
	_g_free0 (center_key);
#line 3065 "../src/Photo.vala"
	_g_free0 (radius_key);
#line 3065 "../src/Photo.vala"
	_key_value_map_unref0 (map);
#line 23837 "Photo.c"
}

static gboolean
photo_calculate_pixbuf_dimensions (Photo* self,
                                   Scaling* scaling,
                                   PhotoException exceptions,
                                   Dimensions* scaled_image,
                                   Dimensions* scaled_to_viewport)
{
	Dimensions _vala_scaled_image = {0};
	Dimensions _vala_scaled_to_viewport = {0};
	GError* _inner_error0_ = NULL;
	gboolean result;
#line 3100 "../src/Photo.vala"
	g_return_val_if_fail (IS_PHOTO (self), FALSE);
#line 3100 "../src/Photo.vala"
	g_return_val_if_fail (scaling != NULL, FALSE);
#line 23855 "Photo.c"
	{
		PhotoRow* _tmp0_;
		gboolean _tmp7_ = FALSE;
#line 3102 "../src/Photo.vala"
		_tmp0_ = self->row;
#line 3102 "../src/Photo.vala"
		g_rec_mutex_lock (&self->priv->__lock_row);
#line 23863 "Photo.c"
		{
			Scaling _tmp1_;
			Dimensions _tmp2_ = {0};
			Dimensions _tmp3_ = {0};
			gboolean _tmp4_;
#line 3104 "../src/Photo.vala"
			_tmp1_ = *scaling;
#line 3104 "../src/Photo.vala"
			_tmp4_ = photo_locked_calculate_pixbuf_dimensions (self, &_tmp1_, exceptions, &_tmp2_, &_tmp3_);
#line 3104 "../src/Photo.vala"
			_vala_scaled_image = _tmp2_;
#line 3104 "../src/Photo.vala"
			_vala_scaled_to_viewport = _tmp3_;
#line 3104 "../src/Photo.vala"
			result = _tmp4_;
#line 23879 "Photo.c"
			{
				PhotoRow* _tmp5_;
#line 3102 "../src/Photo.vala"
				_tmp5_ = self->row;
#line 3102 "../src/Photo.vala"
				g_rec_mutex_unlock (&self->priv->__lock_row);
#line 23886 "Photo.c"
			}
#line 3104 "../src/Photo.vala"
			if (scaled_image) {
#line 3104 "../src/Photo.vala"
				*scaled_image = _vala_scaled_image;
#line 23892 "Photo.c"
			}
#line 3104 "../src/Photo.vala"
			if (scaled_to_viewport) {
#line 3104 "../src/Photo.vala"
				*scaled_to_viewport = _vala_scaled_to_viewport;
#line 23898 "Photo.c"
			}
#line 3104 "../src/Photo.vala"
			return result;
#line 23902 "Photo.c"
		}
		__finally0:
		{
			PhotoRow* _tmp6_;
#line 3102 "../src/Photo.vala"
			_tmp6_ = self->row;
#line 3102 "../src/Photo.vala"
			g_rec_mutex_unlock (&self->priv->__lock_row);
#line 23911 "Photo.c"
		}
#line 3102 "../src/Photo.vala"
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 3102 "../src/Photo.vala"
		g_clear_error (&_inner_error0_);
#line 3102 "../src/Photo.vala"
		return _tmp7_;
#line 23919 "Photo.c"
	}
}

static gboolean
photo_locked_calculate_pixbuf_dimensions (Photo* self,
                                          Scaling* scaling,
                                          PhotoException exceptions,
                                          Dimensions* scaled_image,
                                          Dimensions* scaled_to_viewport)
{
	Dimensions _vala_scaled_image = {0};
	Dimensions _vala_scaled_to_viewport = {0};
	Dimensions raw = {0};
	Dimensions _tmp0_ = {0};
	Orientation orientation = 0;
	gboolean _tmp31_ = FALSE;
	Dimensions _tmp32_;
	Dimensions _tmp33_;
	gboolean result;
#line 3110 "../src/Photo.vala"
	g_return_val_if_fail (IS_PHOTO (self), FALSE);
#line 3110 "../src/Photo.vala"
	g_return_val_if_fail (scaling != NULL, FALSE);
#line 3112 "../src/Photo.vala"
	photo_get_raw_dimensions (self, &_tmp0_);
#line 3112 "../src/Photo.vala"
	raw = _tmp0_;
#line 3114 "../src/Photo.vala"
	if (scaling_is_unscaled (scaling)) {
#line 23949 "Photo.c"
		Dimensions _tmp1_;
		Dimensions _tmp2_;
#line 3115 "../src/Photo.vala"
		_tmp1_ = raw;
#line 3115 "../src/Photo.vala"
		_vala_scaled_image = _tmp1_;
#line 3116 "../src/Photo.vala"
		_tmp2_ = raw;
#line 3116 "../src/Photo.vala"
		_vala_scaled_to_viewport = _tmp2_;
#line 3118 "../src/Photo.vala"
		result = FALSE;
#line 3118 "../src/Photo.vala"
		if (scaled_image) {
#line 3118 "../src/Photo.vala"
			*scaled_image = _vala_scaled_image;
#line 23966 "Photo.c"
		}
#line 3118 "../src/Photo.vala"
		if (scaled_to_viewport) {
#line 3118 "../src/Photo.vala"
			*scaled_to_viewport = _vala_scaled_to_viewport;
#line 23972 "Photo.c"
		}
#line 3118 "../src/Photo.vala"
		return result;
#line 23976 "Photo.c"
	}
#line 3121 "../src/Photo.vala"
	orientation = photo_get_orientation (self);
#line 3126 "../src/Photo.vala"
	dimensions_init (&_vala_scaled_image, 0, 0);
#line 3127 "../src/Photo.vala"
	dimensions_init (&_vala_scaled_to_viewport, 0, 0);
#line 3129 "../src/Photo.vala"
	if (photo_exception_allows (exceptions, PHOTO_EXCEPTION_CROP)) {
#line 23986 "Photo.c"
		Box crop = {0};
		Box _tmp3_ = {0};
		gboolean _tmp4_;
#line 3131 "../src/Photo.vala"
		_tmp4_ = photo_get_raw_crop (self, &_tmp3_);
#line 3131 "../src/Photo.vala"
		crop = _tmp3_;
#line 3131 "../src/Photo.vala"
		if (_tmp4_) {
#line 23996 "Photo.c"
			Dimensions rotated_raw = {0};
			Dimensions _tmp5_;
			Box scaled_crop = {0};
			Dimensions _tmp11_ = {0};
			Dimensions _tmp12_ = {0};
			Box _tmp13_ = {0};
			Dimensions _tmp14_ = {0};
			gboolean _tmp15_ = FALSE;
			Dimensions _tmp18_ = {0};
			Dimensions _tmp19_ = {0};
			Dimensions _tmp20_ = {0};
#line 3134 "../src/Photo.vala"
			_tmp5_ = raw;
#line 3134 "../src/Photo.vala"
			rotated_raw = _tmp5_;
#line 3135 "../src/Photo.vala"
			if (photo_exception_allows (exceptions, PHOTO_EXCEPTION_ORIENTATION)) {
#line 24014 "Photo.c"
				Dimensions _tmp6_;
				Box _tmp7_;
				Box _tmp8_ = {0};
				Dimensions _tmp9_;
				Dimensions _tmp10_ = {0};
#line 3136 "../src/Photo.vala"
				_tmp6_ = raw;
#line 3136 "../src/Photo.vala"
				_tmp7_ = crop;
#line 3136 "../src/Photo.vala"
				orientation_rotate_box (orientation, &_tmp6_, &_tmp7_, &_tmp8_);
#line 3136 "../src/Photo.vala"
				crop = _tmp8_;
#line 3137 "../src/Photo.vala"
				_tmp9_ = raw;
#line 3137 "../src/Photo.vala"
				orientation_rotate_dimensions (orientation, &_tmp9_, &_tmp10_);
#line 3137 "../src/Photo.vala"
				rotated_raw = _tmp10_;
#line 24034 "Photo.c"
			}
#line 3141 "../src/Photo.vala"
			box_get_dimensions (&crop, &_tmp11_);
#line 3141 "../src/Photo.vala"
			scaling_get_scaled_dimensions (scaling, &_tmp11_, &_tmp12_);
#line 3141 "../src/Photo.vala"
			box_get_scaled (&crop, &_tmp12_, &_tmp13_);
#line 3141 "../src/Photo.vala"
			scaled_crop = _tmp13_;
#line 3144 "../src/Photo.vala"
			box_get_dimensions (&scaled_crop, &_tmp14_);
#line 3144 "../src/Photo.vala"
			_vala_scaled_to_viewport = _tmp14_;
#line 3147 "../src/Photo.vala"
			if (box_get_width (&crop) <= box_get_width (&scaled_crop)) {
#line 3148 "../src/Photo.vala"
				_tmp15_ = box_get_height (&crop) <= box_get_height (&scaled_crop);
#line 24052 "Photo.c"
			} else {
#line 3147 "../src/Photo.vala"
				_tmp15_ = FALSE;
#line 24056 "Photo.c"
			}
#line 3147 "../src/Photo.vala"
			if (_tmp15_) {
#line 24060 "Photo.c"
				Dimensions _tmp16_;
				Dimensions _tmp17_ = {0};
#line 3149 "../src/Photo.vala"
				_tmp16_ = raw;
#line 3149 "../src/Photo.vala"
				_vala_scaled_image = _tmp16_;
#line 3150 "../src/Photo.vala"
				box_get_dimensions (&crop, &_tmp17_);
#line 3150 "../src/Photo.vala"
				_vala_scaled_to_viewport = _tmp17_;
#line 3152 "../src/Photo.vala"
				result = FALSE;
#line 3152 "../src/Photo.vala"
				if (scaled_image) {
#line 3152 "../src/Photo.vala"
					*scaled_image = _vala_scaled_image;
#line 24077 "Photo.c"
				}
#line 3152 "../src/Photo.vala"
				if (scaled_to_viewport) {
#line 3152 "../src/Photo.vala"
					*scaled_to_viewport = _vala_scaled_to_viewport;
#line 24083 "Photo.c"
				}
#line 3152 "../src/Photo.vala"
				return result;
#line 24087 "Photo.c"
			}
#line 3157 "../src/Photo.vala"
			box_get_dimensions (&crop, &_tmp18_);
#line 3157 "../src/Photo.vala"
			box_get_dimensions (&scaled_crop, &_tmp19_);
#line 3157 "../src/Photo.vala"
			dimensions_get_scaled_similar (&rotated_raw, &_tmp18_, &_tmp19_, &_tmp20_);
#line 3157 "../src/Photo.vala"
			_vala_scaled_image = _tmp20_;
#line 3161 "../src/Photo.vala"
			if (photo_exception_allows (exceptions, PHOTO_EXCEPTION_ORIENTATION)) {
#line 24099 "Photo.c"
				Dimensions _tmp21_;
				Dimensions _tmp22_ = {0};
#line 3162 "../src/Photo.vala"
				_tmp21_ = _vala_scaled_image;
#line 3162 "../src/Photo.vala"
				orientation_derotate_dimensions (orientation, &_tmp21_, &_tmp22_);
#line 3162 "../src/Photo.vala"
				_vala_scaled_image = _tmp22_;
#line 24108 "Photo.c"
			}
		}
	}
#line 3167 "../src/Photo.vala"
	if (!dimensions_has_area (&_vala_scaled_image)) {
#line 24114 "Photo.c"
		Dimensions rotated_raw = {0};
		Dimensions _tmp23_;
		Dimensions _tmp26_;
		Dimensions _tmp27_ = {0};
		Dimensions _tmp28_;
#line 3169 "../src/Photo.vala"
		_tmp23_ = raw;
#line 3169 "../src/Photo.vala"
		rotated_raw = _tmp23_;
#line 3170 "../src/Photo.vala"
		if (photo_exception_allows (exceptions, PHOTO_EXCEPTION_ORIENTATION)) {
#line 24126 "Photo.c"
			Dimensions _tmp24_;
			Dimensions _tmp25_ = {0};
#line 3171 "../src/Photo.vala"
			_tmp24_ = raw;
#line 3171 "../src/Photo.vala"
			orientation_rotate_dimensions (orientation, &_tmp24_, &_tmp25_);
#line 3171 "../src/Photo.vala"
			rotated_raw = _tmp25_;
#line 24135 "Photo.c"
		}
#line 3173 "../src/Photo.vala"
		_tmp26_ = rotated_raw;
#line 3173 "../src/Photo.vala"
		scaling_get_scaled_dimensions (scaling, &_tmp26_, &_tmp27_);
#line 3173 "../src/Photo.vala"
		_vala_scaled_image = _tmp27_;
#line 3174 "../src/Photo.vala"
		_tmp28_ = _vala_scaled_image;
#line 3174 "../src/Photo.vala"
		_vala_scaled_to_viewport = _tmp28_;
#line 3177 "../src/Photo.vala"
		if (photo_exception_allows (exceptions, PHOTO_EXCEPTION_ORIENTATION)) {
#line 24149 "Photo.c"
			Dimensions _tmp29_;
			Dimensions _tmp30_ = {0};
#line 3178 "../src/Photo.vala"
			_tmp29_ = _vala_scaled_image;
#line 3178 "../src/Photo.vala"
			orientation_derotate_dimensions (orientation, &_tmp29_, &_tmp30_);
#line 3178 "../src/Photo.vala"
			_vala_scaled_image = _tmp30_;
#line 24158 "Photo.c"
		}
	}
#line 3182 "../src/Photo.vala"
	_tmp32_ = _vala_scaled_image;
#line 3182 "../src/Photo.vala"
	_tmp33_ = raw;
#line 3182 "../src/Photo.vala"
	if (_tmp32_.width >= _tmp33_.width) {
#line 24167 "Photo.c"
		Dimensions _tmp34_;
		Dimensions _tmp35_;
#line 3182 "../src/Photo.vala"
		_tmp34_ = _vala_scaled_image;
#line 3182 "../src/Photo.vala"
		_tmp35_ = raw;
#line 3182 "../src/Photo.vala"
		_tmp31_ = _tmp34_.height >= _tmp35_.height;
#line 24176 "Photo.c"
	} else {
#line 3182 "../src/Photo.vala"
		_tmp31_ = FALSE;
#line 24180 "Photo.c"
	}
#line 3182 "../src/Photo.vala"
	if (_tmp31_) {
#line 24184 "Photo.c"
		Dimensions _tmp36_;
#line 3183 "../src/Photo.vala"
		_tmp36_ = raw;
#line 3183 "../src/Photo.vala"
		_vala_scaled_image = _tmp36_;
#line 3185 "../src/Photo.vala"
		result = FALSE;
#line 3185 "../src/Photo.vala"
		if (scaled_image) {
#line 3185 "../src/Photo.vala"
			*scaled_image = _vala_scaled_image;
#line 24196 "Photo.c"
		}
#line 3185 "../src/Photo.vala"
		if (scaled_to_viewport) {
#line 3185 "../src/Photo.vala"
			*scaled_to_viewport = _vala_scaled_to_viewport;
#line 24202 "Photo.c"
		}
#line 3185 "../src/Photo.vala"
		return result;
#line 24206 "Photo.c"
	}
#line 3188 "../src/Photo.vala"
	_vala_assert (dimensions_has_area (&_vala_scaled_image), "scaled_image.has_area()");
#line 3189 "../src/Photo.vala"
	_vala_assert (dimensions_has_area (&_vala_scaled_to_viewport), "scaled_to_viewport.has_area()");
#line 3191 "../src/Photo.vala"
	result = TRUE;
#line 3191 "../src/Photo.vala"
	if (scaled_image) {
#line 3191 "../src/Photo.vala"
		*scaled_image = _vala_scaled_image;
#line 24218 "Photo.c"
	}
#line 3191 "../src/Photo.vala"
	if (scaled_to_viewport) {
#line 3191 "../src/Photo.vala"
		*scaled_to_viewport = _vala_scaled_to_viewport;
#line 24224 "Photo.c"
	}
#line 3191 "../src/Photo.vala"
	return result;
#line 24228 "Photo.c"
}

static GdkPixbuf*
photo_load_raw_pixbuf (Photo* self,
                       Scaling* scaling,
                       PhotoException exceptions,
                       BackingFetchMode fetch_mode,
                       GError** error)
{
	PhotoFileReader* loader = NULL;
	PhotoFileReader* _tmp0_;
	Dimensions scaled_image = {0};
	Dimensions scaled_to_viewport = {0};
	gboolean is_scaled = FALSE;
	Scaling _tmp5_;
	Dimensions _tmp6_ = {0};
	Dimensions _tmp7_ = {0};
	gboolean _tmp8_;
	GdkPixbuf* pixbuf = NULL;
	PhotoFileReader* _tmp13_;
	Dimensions _tmp14_ = {0};
	Dimensions _tmp15_;
	GdkPixbuf* _tmp16_;
	GdkPixbuf* _tmp17_;
	Dimensions _tmp18_ = {0};
	GError* _inner_error0_ = NULL;
	GdkPixbuf* result;
#line 3197 "../src/Photo.vala"
	g_return_val_if_fail (IS_PHOTO (self), NULL);
#line 3197 "../src/Photo.vala"
	g_return_val_if_fail (scaling != NULL, NULL);
#line 3200 "../src/Photo.vala"
	_tmp0_ = photo_get_backing_reader (self, fetch_mode);
#line 3200 "../src/Photo.vala"
	loader = _tmp0_;
#line 3203 "../src/Photo.vala"
	if (scaling_is_unscaled (scaling)) {
#line 24266 "Photo.c"
		GdkPixbuf* _tmp1_ = NULL;
		PhotoFileReader* _tmp2_;
		GdkPixbuf* _tmp3_;
		GdkPixbuf* _tmp4_;
#line 3208 "../src/Photo.vala"
		_tmp2_ = loader;
#line 3208 "../src/Photo.vala"
		_tmp3_ = photo_file_reader_unscaled_read (_tmp2_, &_inner_error0_);
#line 3208 "../src/Photo.vala"
		_tmp1_ = _tmp3_;
#line 3208 "../src/Photo.vala"
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 3208 "../src/Photo.vala"
			g_propagate_error (error, _inner_error0_);
#line 3208 "../src/Photo.vala"
			_photo_file_adapter_unref0 (loader);
#line 3208 "../src/Photo.vala"
			return NULL;
#line 24285 "Photo.c"
		}
#line 3208 "../src/Photo.vala"
		_tmp4_ = _tmp1_;
#line 3208 "../src/Photo.vala"
		_tmp1_ = NULL;
#line 3208 "../src/Photo.vala"
		result = _tmp4_;
#line 3208 "../src/Photo.vala"
		_g_object_unref0 (_tmp1_);
#line 3208 "../src/Photo.vala"
		_photo_file_adapter_unref0 (loader);
#line 3208 "../src/Photo.vala"
		return result;
#line 24299 "Photo.c"
	}
#line 3213 "../src/Photo.vala"
	_tmp5_ = *scaling;
#line 3213 "../src/Photo.vala"
	_tmp8_ = photo_calculate_pixbuf_dimensions (self, &_tmp5_, exceptions, &_tmp6_, &_tmp7_);
#line 3213 "../src/Photo.vala"
	scaled_image = _tmp6_;
#line 3213 "../src/Photo.vala"
	scaled_to_viewport = _tmp7_;
#line 3213 "../src/Photo.vala"
	is_scaled = _tmp8_;
#line 3215 "../src/Photo.vala"
	if (!is_scaled) {
#line 24313 "Photo.c"
		GdkPixbuf* _tmp9_ = NULL;
		PhotoFileReader* _tmp10_;
		GdkPixbuf* _tmp11_;
		GdkPixbuf* _tmp12_;
#line 3220 "../src/Photo.vala"
		_tmp10_ = loader;
#line 3220 "../src/Photo.vala"
		_tmp11_ = photo_file_reader_unscaled_read (_tmp10_, &_inner_error0_);
#line 3220 "../src/Photo.vala"
		_tmp9_ = _tmp11_;
#line 3220 "../src/Photo.vala"
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 3220 "../src/Photo.vala"
			g_propagate_error (error, _inner_error0_);
#line 3220 "../src/Photo.vala"
			_photo_file_adapter_unref0 (loader);
#line 3220 "../src/Photo.vala"
			return NULL;
#line 24332 "Photo.c"
		}
#line 3220 "../src/Photo.vala"
		_tmp12_ = _tmp9_;
#line 3220 "../src/Photo.vala"
		_tmp9_ = NULL;
#line 3220 "../src/Photo.vala"
		result = _tmp12_;
#line 3220 "../src/Photo.vala"
		_g_object_unref0 (_tmp9_);
#line 3220 "../src/Photo.vala"
		_photo_file_adapter_unref0 (loader);
#line 3220 "../src/Photo.vala"
		return result;
#line 24346 "Photo.c"
	}
#line 3223 "../src/Photo.vala"
	_tmp13_ = loader;
#line 3223 "../src/Photo.vala"
	photo_get_raw_dimensions (self, &_tmp14_);
#line 3223 "../src/Photo.vala"
	_tmp15_ = scaled_image;
#line 3223 "../src/Photo.vala"
	_tmp16_ = photo_file_reader_scaled_read (_tmp13_, &_tmp14_, &_tmp15_, &_inner_error0_);
#line 3223 "../src/Photo.vala"
	pixbuf = _tmp16_;
#line 3223 "../src/Photo.vala"
	if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 3223 "../src/Photo.vala"
		g_propagate_error (error, _inner_error0_);
#line 3223 "../src/Photo.vala"
		_photo_file_adapter_unref0 (loader);
#line 3223 "../src/Photo.vala"
		return NULL;
#line 24366 "Photo.c"
	}
#line 3231 "../src/Photo.vala"
	_tmp17_ = pixbuf;
#line 3231 "../src/Photo.vala"
	dimensions_for_pixbuf (_tmp17_, &_tmp18_);
#line 3231 "../src/Photo.vala"
	_vala_assert (dimensions_approx_equals (&scaled_image, &_tmp18_, PHOTO_SCALING_FUDGE), "scaled_image.approx_equals(Dimensions.for_pixbuf(pixbuf), SCALING_FUDGE)");
#line 3233 "../src/Photo.vala"
	result = pixbuf;
#line 3233 "../src/Photo.vala"
	_photo_file_adapter_unref0 (loader);
#line 3233 "../src/Photo.vala"
	return result;
#line 24380 "Photo.c"
}

GdkPixbuf*
photo_get_master_pixbuf (Photo* self,
                         Scaling* scaling,
                         gboolean rotate,
                         GError** error)
{
	GdkPixbuf* _tmp0_ = NULL;
	Scaling _tmp1_;
	GdkPixbuf* _tmp2_;
	GdkPixbuf* _tmp3_;
	GError* _inner_error0_ = NULL;
	GdkPixbuf* result;
#line 3238 "../src/Photo.vala"
	g_return_val_if_fail (IS_PHOTO (self), NULL);
#line 3238 "../src/Photo.vala"
	g_return_val_if_fail (scaling != NULL, NULL);
#line 3239 "../src/Photo.vala"
	_tmp1_ = *scaling;
#line 3239 "../src/Photo.vala"
	_tmp2_ = photo_get_untransformed_pixbuf (self, &_tmp1_, rotate, BACKING_FETCH_MODE_MASTER, &_inner_error0_);
#line 3239 "../src/Photo.vala"
	_tmp0_ = _tmp2_;
#line 3239 "../src/Photo.vala"
	if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 3239 "../src/Photo.vala"
		g_propagate_error (error, _inner_error0_);
#line 3239 "../src/Photo.vala"
		return NULL;
#line 24411 "Photo.c"
	}
#line 3239 "../src/Photo.vala"
	_tmp3_ = _tmp0_;
#line 3239 "../src/Photo.vala"
	_tmp0_ = NULL;
#line 3239 "../src/Photo.vala"
	result = _tmp3_;
#line 3239 "../src/Photo.vala"
	_g_object_unref0 (_tmp0_);
#line 3239 "../src/Photo.vala"
	return result;
#line 24423 "Photo.c"
}

GdkPixbuf*
photo_get_unmodified_pixbuf (Photo* self,
                             Scaling* scaling,
                             gboolean rotate,
                             GError** error)
{
	GdkPixbuf* _tmp0_ = NULL;
	Scaling _tmp1_;
	GdkPixbuf* _tmp2_;
	GdkPixbuf* _tmp3_;
	GError* _inner_error0_ = NULL;
	GdkPixbuf* result;
#line 3243 "../src/Photo.vala"
	g_return_val_if_fail (IS_PHOTO (self), NULL);
#line 3243 "../src/Photo.vala"
	g_return_val_if_fail (scaling != NULL, NULL);
#line 3244 "../src/Photo.vala"
	_tmp1_ = *scaling;
#line 3244 "../src/Photo.vala"
	_tmp2_ = photo_get_untransformed_pixbuf (self, &_tmp1_, rotate, BACKING_FETCH_MODE_UNMODIFIED, &_inner_error0_);
#line 3244 "../src/Photo.vala"
	_tmp0_ = _tmp2_;
#line 3244 "../src/Photo.vala"
	if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 3244 "../src/Photo.vala"
		g_propagate_error (error, _inner_error0_);
#line 3244 "../src/Photo.vala"
		return NULL;
#line 24454 "Photo.c"
	}
#line 3244 "../src/Photo.vala"
	_tmp3_ = _tmp0_;
#line 3244 "../src/Photo.vala"
	_tmp0_ = NULL;
#line 3244 "../src/Photo.vala"
	result = _tmp3_;
#line 3244 "../src/Photo.vala"
	_g_object_unref0 (_tmp0_);
#line 3244 "../src/Photo.vala"
	return result;
#line 24466 "Photo.c"
}

static GdkPixbuf*
photo_get_untransformed_pixbuf (Photo* self,
                                Scaling* scaling,
                                gboolean rotate,
                                BackingFetchMode fetch_mode,
                                GError** error)
{
	Dimensions scaled_image = {0};
	Dimensions scaled_to_viewport = {0};
	Orientation original_orientation = 0;
	GdkPixbuf* pixbuf = NULL;
	Scaling _tmp5_;
	GdkPixbuf* _tmp6_;
	GError* _inner_error0_ = NULL;
	GdkPixbuf* result;
#line 3248 "../src/Photo.vala"
	g_return_val_if_fail (IS_PHOTO (self), NULL);
#line 3248 "../src/Photo.vala"
	g_return_val_if_fail (scaling != NULL, NULL);
#line 24488 "Photo.c"
	{
		PhotoRow* _tmp0_;
#line 3263 "../src/Photo.vala"
		_tmp0_ = self->row;
#line 3263 "../src/Photo.vala"
		g_rec_mutex_lock (&self->priv->__lock_row);
#line 24495 "Photo.c"
		{
			Scaling _tmp1_;
			Dimensions _tmp2_ = {0};
			Dimensions _tmp3_ = {0};
#line 3264 "../src/Photo.vala"
			_tmp1_ = *scaling;
#line 3264 "../src/Photo.vala"
			photo_calculate_pixbuf_dimensions (self, &_tmp1_, PHOTO_EXCEPTION_NONE, &_tmp2_, &_tmp3_);
#line 3264 "../src/Photo.vala"
			scaled_image = _tmp2_;
#line 3264 "../src/Photo.vala"
			scaled_to_viewport = _tmp3_;
#line 3266 "../src/Photo.vala"
			original_orientation = photo_get_original_orientation (self);
#line 24510 "Photo.c"
		}
		__finally0:
		{
			PhotoRow* _tmp4_;
#line 3263 "../src/Photo.vala"
			_tmp4_ = self->row;
#line 3263 "../src/Photo.vala"
			g_rec_mutex_unlock (&self->priv->__lock_row);
#line 24519 "Photo.c"
		}
#line 3263 "../src/Photo.vala"
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 3263 "../src/Photo.vala"
			g_propagate_error (error, _inner_error0_);
#line 3263 "../src/Photo.vala"
			return NULL;
#line 24527 "Photo.c"
		}
	}
#line 3270 "../src/Photo.vala"
	_tmp5_ = *scaling;
#line 3270 "../src/Photo.vala"
	_tmp6_ = photo_load_raw_pixbuf (self, &_tmp5_, PHOTO_EXCEPTION_NONE, fetch_mode, &_inner_error0_);
#line 3270 "../src/Photo.vala"
	pixbuf = _tmp6_;
#line 3270 "../src/Photo.vala"
	if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 3270 "../src/Photo.vala"
		g_propagate_error (error, _inner_error0_);
#line 3270 "../src/Photo.vala"
		return NULL;
#line 24542 "Photo.c"
	}
#line 3276 "../src/Photo.vala"
	if (rotate) {
#line 24546 "Photo.c"
		GdkPixbuf* _tmp7_;
		GdkPixbuf* _tmp8_;
#line 3277 "../src/Photo.vala"
		_tmp7_ = pixbuf;
#line 3277 "../src/Photo.vala"
		_tmp8_ = orientation_rotate_pixbuf (original_orientation, _tmp7_);
#line 3277 "../src/Photo.vala"
		_g_object_unref0 (pixbuf);
#line 3277 "../src/Photo.vala"
		pixbuf = _tmp8_;
#line 24557 "Photo.c"
	}
#line 3286 "../src/Photo.vala"
	result = pixbuf;
#line 3286 "../src/Photo.vala"
	return result;
#line 24563 "Photo.c"
}

static GdkPixbuf*
photo_real_get_pixbuf (PhotoSource* base,
                       Scaling* scaling,
                       GError** error)
{
	Photo * self;
	GdkPixbuf* _tmp0_ = NULL;
	Scaling _tmp1_;
	GdkPixbuf* _tmp2_;
	GdkPixbuf* _tmp3_;
	GError* _inner_error0_ = NULL;
	GdkPixbuf* result;
#line 3289 "../src/Photo.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (base, TYPE_PHOTO, Photo);
#line 3289 "../src/Photo.vala"
	g_return_val_if_fail (scaling != NULL, NULL);
#line 3290 "../src/Photo.vala"
	_tmp1_ = *scaling;
#line 3290 "../src/Photo.vala"
	_tmp2_ = photo_get_pixbuf_with_options (self, &_tmp1_, PHOTO_EXCEPTION_NONE, BACKING_FETCH_MODE_BASELINE, &_inner_error0_);
#line 3290 "../src/Photo.vala"
	_tmp0_ = _tmp2_;
#line 3290 "../src/Photo.vala"
	if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 3290 "../src/Photo.vala"
		g_propagate_error (error, _inner_error0_);
#line 3290 "../src/Photo.vala"
		return NULL;
#line 24594 "Photo.c"
	}
#line 3290 "../src/Photo.vala"
	_tmp3_ = _tmp0_;
#line 3290 "../src/Photo.vala"
	_tmp0_ = NULL;
#line 3290 "../src/Photo.vala"
	result = _tmp3_;
#line 3290 "../src/Photo.vala"
	_g_object_unref0 (_tmp0_);
#line 3290 "../src/Photo.vala"
	return result;
#line 24606 "Photo.c"
}

/**
     * One-stop shopping for the source pixbuf cache.
     *
     * The source pixbuf cache holds untransformed, unscaled (full-sized) pixbufs of Photo objects.
     * These can be rather large and shouldn't be held in memory for too long, nor should many be
     * allowed to stack up.
     *
     * If locate is non-null, a source pixbuf is returned for the Photo.  If keep is true, the
     * pixbuf is stored in the cache.  (Thus, passing a Photo w/ keep == false will drop the cached
     * pixbuf.)  If Photo is non-null but keep is false, null is returned.
     *
     * Whether locate is null or not, the cache is walked in its entirety, dropping expired pixbufs
     * and dropping excessive pixbufs from the LRU.  Locating a Photo "touches" the pixbuf, i.e.
     * it moves to the head of the LRU.
     */
static gpointer
_photo_cached_pixbuf_ref0 (gpointer self)
{
#line 3325 "../src/Photo.vala"
	return self ? photo_cached_pixbuf_ref (self) : NULL;
#line 24629 "Photo.c"
}

static gboolean
_photo_trim_source_pixbuf_cache_gsource_func (gpointer self)
{
	gboolean result;
	result = photo_trim_source_pixbuf_cache ();
#line 3377 "../src/Photo.vala"
	return result;
#line 24639 "Photo.c"
}

static GdkPixbuf*
photo_run_source_pixbuf_cache (Photo* locate,
                               gboolean keep,
                               GError** error)
{
	GError* _inner_error0_ = NULL;
	GdkPixbuf* result;
#line 3308 "../src/Photo.vala"
	g_return_val_if_fail ((locate == NULL) || IS_PHOTO (locate), NULL);
#line 24651 "Photo.c"
	{
		GeeLinkedList* _tmp0_;
#line 3309 "../src/Photo.vala"
		_tmp0_ = photo_source_pixbuf_cache;
#line 3309 "../src/Photo.vala"
		g_rec_mutex_lock (&__lock_photo_photo_source_pixbuf_cache);
#line 24658 "Photo.c"
		{
			PhotoCachedPixbuf* found = NULL;
			gdouble min_elapsed = 0.0;
			gint count = 0;
			GeeIterator* iter = NULL;
			GeeLinkedList* _tmp1_;
			GeeIterator* _tmp2_;
			gboolean _tmp18_ = FALSE;
			gboolean _tmp19_ = FALSE;
			PhotoCachedPixbuf* _tmp20_;
			gboolean _tmp28_ = FALSE;
			PhotoCachedPixbuf* _tmp29_;
			GeeLinkedList* _tmp40_;
			gint _tmp41_;
			gint _tmp42_;
			GdkPixbuf* _tmp43_ = NULL;
			PhotoCachedPixbuf* _tmp44_;
			GdkPixbuf* _tmp47_;
#line 3310 "../src/Photo.vala"
			found = NULL;
#line 3314 "../src/Photo.vala"
			min_elapsed = DBL_MAX;
#line 3315 "../src/Photo.vala"
			count = 0;
#line 3316 "../src/Photo.vala"
			_tmp1_ = photo_source_pixbuf_cache;
#line 3316 "../src/Photo.vala"
			_tmp2_ = gee_abstract_collection_iterator (G_TYPE_CHECK_INSTANCE_CAST (_tmp1_, GEE_TYPE_ABSTRACT_COLLECTION, GeeAbstractCollection));
#line 3316 "../src/Photo.vala"
			iter = _tmp2_;
#line 3317 "../src/Photo.vala"
			while (TRUE) {
#line 24691 "Photo.c"
				GeeIterator* _tmp3_;
				PhotoCachedPixbuf* cached_pixbuf = NULL;
				GeeIterator* _tmp4_;
				gpointer _tmp5_;
				gdouble elapsed = 0.0;
				PhotoCachedPixbuf* _tmp6_;
				GTimer* _tmp7_;
				gboolean _tmp8_ = FALSE;
#line 3317 "../src/Photo.vala"
				_tmp3_ = iter;
#line 3317 "../src/Photo.vala"
				if (!gee_iterator_next (_tmp3_)) {
#line 3317 "../src/Photo.vala"
					break;
#line 24706 "Photo.c"
				}
#line 3318 "../src/Photo.vala"
				_tmp4_ = iter;
#line 3318 "../src/Photo.vala"
				_tmp5_ = gee_iterator_get (_tmp4_);
#line 3318 "../src/Photo.vala"
				cached_pixbuf = (PhotoCachedPixbuf*) _tmp5_;
#line 3320 "../src/Photo.vala"
				_tmp6_ = cached_pixbuf;
#line 3320 "../src/Photo.vala"
				_tmp7_ = _tmp6_->last_touched;
#line 3320 "../src/Photo.vala"
				elapsed = trunc (g_timer_elapsed (_tmp7_, NULL)) + 1;
#line 3322 "../src/Photo.vala"
				if (locate != NULL) {
#line 24722 "Photo.c"
					PhotoCachedPixbuf* _tmp9_;
					Photo* _tmp10_;
#line 3322 "../src/Photo.vala"
					_tmp9_ = cached_pixbuf;
#line 3322 "../src/Photo.vala"
					_tmp10_ = _tmp9_->photo;
#line 3322 "../src/Photo.vala"
					_tmp8_ = data_source_equals (G_TYPE_CHECK_INSTANCE_CAST (_tmp10_, TYPE_DATA_SOURCE, DataSource), G_TYPE_CHECK_INSTANCE_CAST (locate, TYPE_DATA_SOURCE, DataSource));
#line 24731 "Photo.c"
				} else {
#line 3322 "../src/Photo.vala"
					_tmp8_ = FALSE;
#line 24735 "Photo.c"
				}
#line 3322 "../src/Photo.vala"
				if (_tmp8_) {
#line 24739 "Photo.c"
					GeeIterator* _tmp11_;
					PhotoCachedPixbuf* _tmp12_;
					PhotoCachedPixbuf* _tmp13_;
					gint _tmp14_;
#line 3324 "../src/Photo.vala"
					_tmp11_ = iter;
#line 3324 "../src/Photo.vala"
					gee_iterator_remove (_tmp11_);
#line 3325 "../src/Photo.vala"
					_tmp12_ = cached_pixbuf;
#line 3325 "../src/Photo.vala"
					_tmp13_ = _photo_cached_pixbuf_ref0 (_tmp12_);
#line 3325 "../src/Photo.vala"
					_photo_cached_pixbuf_unref0 (found);
#line 3325 "../src/Photo.vala"
					found = _tmp13_;
#line 3328 "../src/Photo.vala"
					_tmp14_ = count;
#line 3328 "../src/Photo.vala"
					count = _tmp14_ + 1;
#line 24760 "Photo.c"
				} else {
#line 3329 "../src/Photo.vala"
					if (elapsed >= ((gdouble) PHOTO_SOURCE_PIXBUF_TIME_TO_LIVE_SEC)) {
#line 24764 "Photo.c"
						GeeIterator* _tmp15_;
#line 3330 "../src/Photo.vala"
						_tmp15_ = iter;
#line 3330 "../src/Photo.vala"
						gee_iterator_remove (_tmp15_);
#line 24770 "Photo.c"
					} else {
#line 3331 "../src/Photo.vala"
						if (count >= PHOTO_SOURCE_PIXBUF_MAX_LRU_COUNT) {
#line 24774 "Photo.c"
							GeeIterator* _tmp16_;
#line 3332 "../src/Photo.vala"
							_tmp16_ = iter;
#line 3332 "../src/Photo.vala"
							gee_iterator_remove (_tmp16_);
#line 24780 "Photo.c"
						} else {
							gint _tmp17_;
#line 3336 "../src/Photo.vala"
							min_elapsed = MIN (elapsed, min_elapsed);
#line 3337 "../src/Photo.vala"
							_tmp17_ = count;
#line 3337 "../src/Photo.vala"
							count = _tmp17_ + 1;
#line 24789 "Photo.c"
						}
					}
				}
#line 3317 "../src/Photo.vala"
				_photo_cached_pixbuf_unref0 (cached_pixbuf);
#line 24795 "Photo.c"
			}
#line 3342 "../src/Photo.vala"
			_tmp20_ = found;
#line 3342 "../src/Photo.vala"
			if (_tmp20_ == NULL) {
#line 3342 "../src/Photo.vala"
				_tmp19_ = locate != NULL;
#line 24803 "Photo.c"
			} else {
#line 3342 "../src/Photo.vala"
				_tmp19_ = FALSE;
#line 24807 "Photo.c"
			}
#line 3342 "../src/Photo.vala"
			if (_tmp19_) {
#line 3342 "../src/Photo.vala"
				_tmp18_ = keep;
#line 24813 "Photo.c"
			} else {
#line 3342 "../src/Photo.vala"
				_tmp18_ = FALSE;
#line 24817 "Photo.c"
			}
#line 3342 "../src/Photo.vala"
			if (_tmp18_) {
#line 24821 "Photo.c"
				GdkPixbuf* _tmp21_ = NULL;
				Scaling _tmp22_ = {0};
				GdkPixbuf* _tmp23_;
				PhotoCachedPixbuf* _tmp24_;
#line 3344 "../src/Photo.vala"
				scaling_for_original (&_tmp22_);
#line 3344 "../src/Photo.vala"
				_tmp23_ = photo_load_raw_pixbuf (locate, &_tmp22_, PHOTO_EXCEPTION_ALL, BACKING_FETCH_MODE_SOURCE, &_inner_error0_);
#line 3344 "../src/Photo.vala"
				_tmp21_ = _tmp23_;
#line 3344 "../src/Photo.vala"
				if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 3344 "../src/Photo.vala"
					_g_object_unref0 (iter);
#line 3344 "../src/Photo.vala"
					_photo_cached_pixbuf_unref0 (found);
#line 24838 "Photo.c"
					goto __catch0_g_error;
				}
#line 3343 "../src/Photo.vala"
				_tmp24_ = photo_cached_pixbuf_new (locate, _tmp21_);
#line 3343 "../src/Photo.vala"
				_photo_cached_pixbuf_unref0 (found);
#line 3343 "../src/Photo.vala"
				found = _tmp24_;
#line 3342 "../src/Photo.vala"
				_g_object_unref0 (_tmp21_);
#line 24849 "Photo.c"
			} else {
				PhotoCachedPixbuf* _tmp25_;
#line 3345 "../src/Photo.vala"
				_tmp25_ = found;
#line 3345 "../src/Photo.vala"
				if (_tmp25_ != NULL) {
#line 24856 "Photo.c"
					PhotoCachedPixbuf* _tmp26_;
					GTimer* _tmp27_;
#line 3347 "../src/Photo.vala"
					_tmp26_ = found;
#line 3347 "../src/Photo.vala"
					_tmp27_ = _tmp26_->last_touched;
#line 3347 "../src/Photo.vala"
					g_timer_start (_tmp27_);
#line 24865 "Photo.c"
				}
			}
#line 3351 "../src/Photo.vala"
			_tmp29_ = found;
#line 3351 "../src/Photo.vala"
			if (_tmp29_ != NULL) {
#line 3351 "../src/Photo.vala"
				_tmp28_ = keep;
#line 24874 "Photo.c"
			} else {
#line 3351 "../src/Photo.vala"
				_tmp28_ = FALSE;
#line 24878 "Photo.c"
			}
#line 3351 "../src/Photo.vala"
			if (_tmp28_) {
#line 24882 "Photo.c"
				GeeLinkedList* _tmp30_;
				PhotoCachedPixbuf* _tmp31_;
				PhotoCachedPixbuf* _tmp32_;
				GTimer* _tmp33_;
#line 3352 "../src/Photo.vala"
				_tmp30_ = photo_source_pixbuf_cache;
#line 3352 "../src/Photo.vala"
				_tmp31_ = found;
#line 3352 "../src/Photo.vala"
				gee_abstract_list_insert (G_TYPE_CHECK_INSTANCE_CAST (_tmp30_, GEE_TYPE_ABSTRACT_LIST, GeeAbstractList), 0, _tmp31_);
#line 3357 "../src/Photo.vala"
				_tmp32_ = found;
#line 3357 "../src/Photo.vala"
				_tmp33_ = _tmp32_->last_touched;
#line 3357 "../src/Photo.vala"
				min_elapsed = MIN (g_timer_elapsed (_tmp33_, NULL), min_elapsed);
#line 3361 "../src/Photo.vala"
				while (TRUE) {
#line 24901 "Photo.c"
					GeeLinkedList* _tmp34_;
					gint _tmp35_;
					gint _tmp36_;
					GeeLinkedList* _tmp37_;
					gpointer _tmp38_;
					PhotoCachedPixbuf* _tmp39_;
#line 3361 "../src/Photo.vala"
					_tmp34_ = photo_source_pixbuf_cache;
#line 3361 "../src/Photo.vala"
					_tmp35_ = gee_abstract_collection_get_size (G_TYPE_CHECK_INSTANCE_CAST (_tmp34_, GEE_TYPE_ABSTRACT_COLLECTION, GeeAbstractCollection));
#line 3361 "../src/Photo.vala"
					_tmp36_ = _tmp35_;
#line 3361 "../src/Photo.vala"
					if (!(_tmp36_ > PHOTO_SOURCE_PIXBUF_MAX_LRU_COUNT)) {
#line 3361 "../src/Photo.vala"
						break;
#line 24918 "Photo.c"
					}
#line 3362 "../src/Photo.vala"
					_tmp37_ = photo_source_pixbuf_cache;
#line 3362 "../src/Photo.vala"
					_tmp38_ = gee_deque_poll_tail (G_TYPE_CHECK_INSTANCE_CAST (_tmp37_, GEE_TYPE_DEQUE, GeeDeque));
#line 3362 "../src/Photo.vala"
					_tmp39_ = (PhotoCachedPixbuf*) _tmp38_;
#line 3362 "../src/Photo.vala"
					_photo_cached_pixbuf_unref0 (_tmp39_);
#line 24928 "Photo.c"
				}
			}
#line 3366 "../src/Photo.vala"
			if (photo_discard_source_id != ((guint) 0)) {
#line 3367 "../src/Photo.vala"
				g_source_remove (photo_discard_source_id);
#line 3368 "../src/Photo.vala"
				photo_discard_source_id = (guint) 0;
#line 24937 "Photo.c"
			}
#line 3372 "../src/Photo.vala"
			_tmp40_ = photo_source_pixbuf_cache;
#line 3372 "../src/Photo.vala"
			_tmp41_ = gee_abstract_collection_get_size (G_TYPE_CHECK_INSTANCE_CAST (_tmp40_, GEE_TYPE_ABSTRACT_COLLECTION, GeeAbstractCollection));
#line 3372 "../src/Photo.vala"
			_tmp42_ = _tmp41_;
#line 3372 "../src/Photo.vala"
			if (_tmp42_ > PHOTO_SOURCE_PIXBUF_MIN_LRU_COUNT) {
#line 24947 "Photo.c"
				guint retry_sec = 0U;
#line 3373 "../src/Photo.vala"
				_vala_assert (min_elapsed >= 0.0, "min_elapsed >= 0.0");
#line 3376 "../src/Photo.vala"
				retry_sec = PHOTO_SOURCE_PIXBUF_TIME_TO_LIVE_SEC - ((guint) trunc (min_elapsed));
#line 3377 "../src/Photo.vala"
				photo_discard_source_id = g_timeout_add_seconds_full (G_PRIORITY_LOW, retry_sec, _photo_trim_source_pixbuf_cache_gsource_func, NULL, NULL);
#line 24955 "Photo.c"
			}
#line 3380 "../src/Photo.vala"
			_tmp44_ = found;
#line 3380 "../src/Photo.vala"
			if (_tmp44_ != NULL) {
#line 24961 "Photo.c"
				PhotoCachedPixbuf* _tmp45_;
				GdkPixbuf* _tmp46_;
#line 3380 "../src/Photo.vala"
				_tmp45_ = found;
#line 3380 "../src/Photo.vala"
				_tmp46_ = _tmp45_->pixbuf;
#line 3380 "../src/Photo.vala"
				_tmp43_ = _tmp46_;
#line 24970 "Photo.c"
			} else {
#line 3380 "../src/Photo.vala"
				_tmp43_ = NULL;
#line 24974 "Photo.c"
			}
#line 3380 "../src/Photo.vala"
			_tmp47_ = _g_object_ref0 (_tmp43_);
#line 3380 "../src/Photo.vala"
			result = _tmp47_;
#line 3380 "../src/Photo.vala"
			_g_object_unref0 (iter);
#line 3380 "../src/Photo.vala"
			_photo_cached_pixbuf_unref0 (found);
#line 24984 "Photo.c"
			{
				GError* _inner_error0_ = NULL;
				GeeLinkedList* _tmp48_;
#line 3309 "../src/Photo.vala"
				_tmp48_ = photo_source_pixbuf_cache;
#line 3309 "../src/Photo.vala"
				g_rec_mutex_unlock (&__lock_photo_photo_source_pixbuf_cache);
#line 24992 "Photo.c"
			}
#line 3380 "../src/Photo.vala"
			return result;
#line 24996 "Photo.c"
		}
		goto __finally0;
		__catch0_g_error:
		{
			GError* _lock_error_ = NULL;
			GError* _tmp49_;
#line 3309 "../src/Photo.vala"
			_lock_error_ = _inner_error0_;
#line 3309 "../src/Photo.vala"
			_inner_error0_ = NULL;
#line 3309 "../src/Photo.vala"
			_tmp49_ = _lock_error_;
#line 3309 "../src/Photo.vala"
			_lock_error_ = NULL;
#line 3309 "../src/Photo.vala"
			_inner_error0_ = _tmp49_;
#line 3309 "../src/Photo.vala"
			_g_error_free0 (_lock_error_);
#line 25015 "Photo.c"
			goto __finally0;
		}
		__finally0:
		{
			GError* _inner_error1_ = NULL;
			GeeLinkedList* _tmp50_;
#line 3309 "../src/Photo.vala"
			_tmp50_ = photo_source_pixbuf_cache;
#line 3309 "../src/Photo.vala"
			g_rec_mutex_unlock (&__lock_photo_photo_source_pixbuf_cache);
#line 25026 "Photo.c"
		}
#line 3309 "../src/Photo.vala"
		g_propagate_error (error, _inner_error0_);
#line 3309 "../src/Photo.vala"
		return NULL;
#line 25032 "Photo.c"
	}
}

static gboolean
photo_trim_source_pixbuf_cache (void)
{
	GError* _inner_error0_ = NULL;
	gboolean result;
	{
		GdkPixbuf* _tmp0_;
		GdkPixbuf* _tmp1_;
#line 3386 "../src/Photo.vala"
		_tmp0_ = photo_run_source_pixbuf_cache (NULL, FALSE, &_inner_error0_);
#line 3386 "../src/Photo.vala"
		_tmp1_ = _tmp0_;
#line 3386 "../src/Photo.vala"
		_g_object_unref0 (_tmp1_);
#line 3386 "../src/Photo.vala"
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 25052 "Photo.c"
			goto __catch0_g_error;
		}
	}
	goto __finally0;
	__catch0_g_error:
	{
#line 3385 "../src/Photo.vala"
		g_clear_error (&_inner_error0_);
#line 25061 "Photo.c"
	}
	__finally0:
#line 3385 "../src/Photo.vala"
	if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 25066 "Photo.c"
		gboolean _tmp2_ = FALSE;
#line 3385 "../src/Photo.vala"
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 3385 "../src/Photo.vala"
		g_clear_error (&_inner_error0_);
#line 3385 "../src/Photo.vala"
		return _tmp2_;
#line 25074 "Photo.c"
	}
#line 3390 "../src/Photo.vala"
	result = FALSE;
#line 3390 "../src/Photo.vala"
	return result;
#line 25080 "Photo.c"
}

/**
     * @brief Get a copy of what's in the cache.
     *
     * @return A copy of the Pixbuf with the image data from unmodified_precached.
     */
GdkPixbuf*
photo_get_prefetched_copy (Photo* self,
                           GError** error)
{
	GdkPixbuf* _tmp0_ = NULL;
	GdkPixbuf* _tmp1_;
	GdkPixbuf* _tmp2_;
	GError* _inner_error0_ = NULL;
	GdkPixbuf* result;
#line 3398 "../src/Photo.vala"
	g_return_val_if_fail (IS_PHOTO (self), NULL);
#line 3399 "../src/Photo.vala"
	_tmp1_ = photo_run_source_pixbuf_cache (self, TRUE, &_inner_error0_);
#line 3399 "../src/Photo.vala"
	_tmp0_ = _tmp1_;
#line 3399 "../src/Photo.vala"
	if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 3399 "../src/Photo.vala"
		g_propagate_error (error, _inner_error0_);
#line 3399 "../src/Photo.vala"
		return NULL;
#line 25109 "Photo.c"
	}
#line 3399 "../src/Photo.vala"
	_tmp2_ = gdk_pixbuf_copy (_tmp0_);
#line 3399 "../src/Photo.vala"
	result = _tmp2_;
#line 3399 "../src/Photo.vala"
	_g_object_unref0 (_tmp0_);
#line 3399 "../src/Photo.vala"
	return result;
#line 25119 "Photo.c"
}

/**
     * @brief Discards the cached version of the unmodified image.
     */
void
photo_discard_prefetched (Photo* self)
{
	GError* _inner_error0_ = NULL;
#line 3405 "../src/Photo.vala"
	g_return_if_fail (IS_PHOTO (self));
#line 25131 "Photo.c"
	{
		GdkPixbuf* _tmp0_;
		GdkPixbuf* _tmp1_;
#line 3407 "../src/Photo.vala"
		_tmp0_ = photo_run_source_pixbuf_cache (self, FALSE, &_inner_error0_);
#line 3407 "../src/Photo.vala"
		_tmp1_ = _tmp0_;
#line 3407 "../src/Photo.vala"
		_g_object_unref0 (_tmp1_);
#line 3407 "../src/Photo.vala"
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 25143 "Photo.c"
			goto __catch0_g_error;
		}
	}
	goto __finally0;
	__catch0_g_error:
	{
#line 3406 "../src/Photo.vala"
		g_clear_error (&_inner_error0_);
#line 25152 "Photo.c"
	}
	__finally0:
#line 3406 "../src/Photo.vala"
	if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 3406 "../src/Photo.vala"
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 3406 "../src/Photo.vala"
		g_clear_error (&_inner_error0_);
#line 3406 "../src/Photo.vala"
		return;
#line 25163 "Photo.c"
	}
}

/**
     * @brief Returns a fully transformed and scaled pixbuf.  Transformations may be excluded via
     * the mask. If the image is smaller than the scaling, it will be returned in its actual size.
     * The caller is responsible for scaling thereafter.
     *
     * @param scaling A scaling object that describes the size the output pixbuf should be.
     * @param exceptions The parts of the pipeline that should be skipped; defaults to NONE if
     *      left unset.
     * @param fetch_mode The fetch mode; if left unset, defaults to BASELINE so that
     *      we get the image exactly as it is in the file.
     */
GdkPixbuf*
photo_get_pixbuf_with_options (Photo* self,
                               Scaling* scaling,
                               PhotoException exceptions,
                               BackingFetchMode fetch_mode,
                               GError** error)
{
	gboolean _tmp0_ = FALSE;
	gboolean _tmp1_ = FALSE;
	gboolean _tmp2_ = FALSE;
	gboolean _tmp3_;
	gboolean _tmp4_;
	gboolean is_scaled = FALSE;
	gboolean is_cropped = FALSE;
	gboolean is_straightened = FALSE;
	Dimensions scaled_to_viewport = {0};
	Dimensions original = {0};
	Dimensions scaled = {0};
	EditingToolsRedeyeInstance* redeye_instances = NULL;
	gint redeye_instances_length1;
	gint _redeye_instances_size_;
	Box crop = {0};
	gdouble straightening_angle = 0.0;
	PixelTransformer* transformer = NULL;
	Orientation orientation = 0;
	GdkPixbuf* pixbuf = NULL;
	GdkPixbuf* _tmp22_;
	gboolean _tmp60_ = FALSE;
	GError* _inner_error0_ = NULL;
	GdkPixbuf* result;
#line 3423 "../src/Photo.vala"
	g_return_val_if_fail (IS_PHOTO (self), NULL);
#line 3423 "../src/Photo.vala"
	g_return_val_if_fail (scaling != NULL, NULL);
#line 3436 "../src/Photo.vala"
	_tmp3_ = photo_get_develop_raw_photos_to_files ();
#line 3436 "../src/Photo.vala"
	_tmp4_ = _tmp3_;
#line 3436 "../src/Photo.vala"
	if (_tmp4_) {
#line 3437 "../src/Photo.vala"
		_tmp2_ = photo_get_master_file_format (self) == PHOTO_FILE_FORMAT_RAW;
#line 25220 "Photo.c"
	} else {
#line 3436 "../src/Photo.vala"
		_tmp2_ = FALSE;
#line 25224 "Photo.c"
	}
#line 3436 "../src/Photo.vala"
	if (_tmp2_) {
#line 25228 "Photo.c"
		gboolean _tmp5_ = FALSE;
		gboolean _tmp6_ = FALSE;
#line 3438 "../src/Photo.vala"
		if (fetch_mode == BACKING_FETCH_MODE_BASELINE) {
#line 3438 "../src/Photo.vala"
			_tmp6_ = TRUE;
#line 25235 "Photo.c"
		} else {
#line 3438 "../src/Photo.vala"
			_tmp6_ = fetch_mode == BACKING_FETCH_MODE_UNMODIFIED;
#line 25239 "Photo.c"
		}
#line 3438 "../src/Photo.vala"
		if (_tmp6_) {
#line 3438 "../src/Photo.vala"
			_tmp5_ = TRUE;
#line 25245 "Photo.c"
		} else {
#line 3439 "../src/Photo.vala"
			_tmp5_ = fetch_mode == BACKING_FETCH_MODE_SOURCE;
#line 25249 "Photo.c"
		}
#line 3438 "../src/Photo.vala"
		_tmp1_ = _tmp5_;
#line 25253 "Photo.c"
	} else {
#line 3436 "../src/Photo.vala"
		_tmp1_ = FALSE;
#line 25257 "Photo.c"
	}
#line 3436 "../src/Photo.vala"
	if (_tmp1_) {
#line 3440 "../src/Photo.vala"
		_tmp0_ = !photo_is_raw_developer_complete (self, photo_get_raw_developer (self));
#line 25263 "Photo.c"
	} else {
#line 3436 "../src/Photo.vala"
		_tmp0_ = FALSE;
#line 25267 "Photo.c"
	}
#line 3436 "../src/Photo.vala"
	if (_tmp0_) {
#line 3441 "../src/Photo.vala"
		photo_set_raw_developer (self, photo_get_raw_developer (self), TRUE);
#line 25273 "Photo.c"
	}
#line 3446 "../src/Photo.vala"
	dimensions_init (&original, 0, 0);
#line 3447 "../src/Photo.vala"
	dimensions_init (&scaled, 0, 0);
#line 3448 "../src/Photo.vala"
	redeye_instances = NULL;
#line 3448 "../src/Photo.vala"
	redeye_instances_length1 = 0;
#line 3448 "../src/Photo.vala"
	_redeye_instances_size_ = redeye_instances_length1;
#line 3451 "../src/Photo.vala"
	transformer = NULL;
#line 25287 "Photo.c"
	{
		PhotoRow* _tmp7_;
#line 3454 "../src/Photo.vala"
		_tmp7_ = self->row;
#line 3454 "../src/Photo.vala"
		g_rec_mutex_lock (&self->priv->__lock_row);
#line 25294 "Photo.c"
		{
			Dimensions _tmp8_ = {0};
			Dimensions _tmp9_ = {0};
			Dimensions _tmp10_ = {0};
			Dimensions _tmp11_;
			Dimensions _tmp12_ = {0};
			Dimensions _tmp13_;
			gint _tmp14_ = 0;
			EditingToolsRedeyeInstance* _tmp15_;
			Box _tmp16_ = {0};
			gboolean _tmp17_;
			gdouble _tmp18_ = 0.0;
			gboolean _tmp19_;
#line 3455 "../src/Photo.vala"
			media_source_get_dimensions (G_TYPE_CHECK_INSTANCE_CAST (self, TYPE_MEDIA_SOURCE, MediaSource), PHOTO_EXCEPTION_ALL, &_tmp8_);
#line 3455 "../src/Photo.vala"
			original = _tmp8_;
#line 3456 "../src/Photo.vala"
			media_source_get_dimensions (G_TYPE_CHECK_INSTANCE_CAST (self, TYPE_MEDIA_SOURCE, MediaSource), exceptions, &_tmp9_);
#line 3456 "../src/Photo.vala"
			scaling_get_scaled_dimensions (scaling, &_tmp9_, &_tmp10_);
#line 3456 "../src/Photo.vala"
			scaled = _tmp10_;
#line 3457 "../src/Photo.vala"
			_tmp11_ = scaled;
#line 3457 "../src/Photo.vala"
			scaled_to_viewport = _tmp11_;
#line 3459 "../src/Photo.vala"
			media_source_get_dimensions (G_TYPE_CHECK_INSTANCE_CAST (self, TYPE_MEDIA_SOURCE, MediaSource), PHOTO_EXCEPTION_NONE, &_tmp12_);
#line 3459 "../src/Photo.vala"
			_tmp13_ = scaled;
#line 3459 "../src/Photo.vala"
			is_scaled = !dimensions_equals (&_tmp12_, &_tmp13_);
#line 3461 "../src/Photo.vala"
			_tmp15_ = photo_get_raw_redeye_instances (self, &_tmp14_);
#line 3461 "../src/Photo.vala"
			redeye_instances = (g_free (redeye_instances), NULL);
#line 3461 "../src/Photo.vala"
			redeye_instances = _tmp15_;
#line 3461 "../src/Photo.vala"
			redeye_instances_length1 = _tmp14_;
#line 3461 "../src/Photo.vala"
			_redeye_instances_size_ = redeye_instances_length1;
#line 3463 "../src/Photo.vala"
			_tmp17_ = photo_get_raw_crop (self, &_tmp16_);
#line 3463 "../src/Photo.vala"
			crop = _tmp16_;
#line 3463 "../src/Photo.vala"
			is_cropped = _tmp17_;
#line 3465 "../src/Photo.vala"
			_tmp19_ = photo_get_raw_straighten (self, &_tmp18_);
#line 3465 "../src/Photo.vala"
			straightening_angle = _tmp18_;
#line 3465 "../src/Photo.vala"
			is_straightened = _tmp19_;
#line 3467 "../src/Photo.vala"
			if (photo_has_color_adjustments (self)) {
#line 25352 "Photo.c"
				PixelTransformer* _tmp20_;
#line 3468 "../src/Photo.vala"
				_tmp20_ = photo_get_pixel_transformer (self);
#line 3468 "../src/Photo.vala"
				_pixel_transformer_unref0 (transformer);
#line 3468 "../src/Photo.vala"
				transformer = _tmp20_;
#line 25360 "Photo.c"
			}
#line 3470 "../src/Photo.vala"
			orientation = photo_get_orientation (self);
#line 25364 "Photo.c"
		}
		__finally0:
		{
			PhotoRow* _tmp21_;
#line 3454 "../src/Photo.vala"
			_tmp21_ = self->row;
#line 3454 "../src/Photo.vala"
			g_rec_mutex_unlock (&self->priv->__lock_row);
#line 25373 "Photo.c"
		}
#line 3454 "../src/Photo.vala"
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 3454 "../src/Photo.vala"
			g_propagate_error (error, _inner_error0_);
#line 3454 "../src/Photo.vala"
			_pixel_transformer_unref0 (transformer);
#line 3454 "../src/Photo.vala"
			redeye_instances = (g_free (redeye_instances), NULL);
#line 3454 "../src/Photo.vala"
			return NULL;
#line 25385 "Photo.c"
		}
	}
#line 3477 "../src/Photo.vala"
	_tmp22_ = photo_get_prefetched_copy (self, &_inner_error0_);
#line 3477 "../src/Photo.vala"
	pixbuf = _tmp22_;
#line 3477 "../src/Photo.vala"
	if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 3477 "../src/Photo.vala"
		g_propagate_error (error, _inner_error0_);
#line 3477 "../src/Photo.vala"
		_pixel_transformer_unref0 (transformer);
#line 3477 "../src/Photo.vala"
		redeye_instances = (g_free (redeye_instances), NULL);
#line 3477 "../src/Photo.vala"
		return NULL;
#line 25402 "Photo.c"
	}
#line 3484 "../src/Photo.vala"
	if (photo_exception_allows (exceptions, PHOTO_EXCEPTION_REDEYE)) {
#line 25406 "Photo.c"
		EditingToolsRedeyeInstance* _tmp23_;
		gint _tmp23__length1;
#line 3489 "../src/Photo.vala"
		_tmp23_ = redeye_instances;
#line 3489 "../src/Photo.vala"
		_tmp23__length1 = redeye_instances_length1;
#line 25413 "Photo.c"
		{
			EditingToolsRedeyeInstance* instance_collection = NULL;
			gint instance_collection_length1 = 0;
			gint _instance_collection_size_ = 0;
			gint instance_it = 0;
#line 3489 "../src/Photo.vala"
			instance_collection = _tmp23_;
#line 3489 "../src/Photo.vala"
			instance_collection_length1 = _tmp23__length1;
#line 3489 "../src/Photo.vala"
			for (instance_it = 0; instance_it < instance_collection_length1; instance_it = instance_it + 1) {
#line 25425 "Photo.c"
				EditingToolsRedeyeInstance instance = {0};
#line 3489 "../src/Photo.vala"
				instance = instance_collection[instance_it];
#line 25429 "Photo.c"
				{
					GdkPixbuf* _tmp24_;
					EditingToolsRedeyeInstance _tmp25_;
					GdkPixbuf* _tmp26_;
#line 3490 "../src/Photo.vala"
					_tmp24_ = pixbuf;
#line 3490 "../src/Photo.vala"
					_tmp25_ = instance;
#line 3490 "../src/Photo.vala"
					_tmp26_ = photo_do_redeye (self, _tmp24_, &_tmp25_);
#line 3490 "../src/Photo.vala"
					_g_object_unref0 (pixbuf);
#line 3490 "../src/Photo.vala"
					pixbuf = _tmp26_;
#line 25444 "Photo.c"
				}
			}
		}
	}
#line 3498 "../src/Photo.vala"
	if (photo_exception_allows (exceptions, PHOTO_EXCEPTION_STRAIGHTEN)) {
#line 3502 "../src/Photo.vala"
		if (is_straightened) {
#line 25453 "Photo.c"
			GdkPixbuf* _tmp27_;
			GdkPixbuf* _tmp28_;
#line 3503 "../src/Photo.vala"
			_tmp27_ = pixbuf;
#line 3503 "../src/Photo.vala"
			_tmp28_ = rotate_arb (_tmp27_, straightening_angle);
#line 3503 "../src/Photo.vala"
			_g_object_unref0 (pixbuf);
#line 3503 "../src/Photo.vala"
			pixbuf = _tmp28_;
#line 25464 "Photo.c"
		}
	}
#line 3512 "../src/Photo.vala"
	if (photo_exception_allows (exceptions, PHOTO_EXCEPTION_CROP)) {
#line 3516 "../src/Photo.vala"
		if (is_cropped) {
#line 25471 "Photo.c"
			Box _tmp29_;
			GdkPixbuf* _tmp30_;
			gint _tmp31_;
			gint _tmp32_;
			Box _tmp33_;
			GdkPixbuf* _tmp34_;
			gint _tmp35_;
			gint _tmp36_;
			Box _tmp37_;
			Box _tmp38_;
			GdkPixbuf* _tmp39_;
			gint _tmp40_;
			gint _tmp41_;
			Box _tmp42_;
			Box _tmp43_;
			GdkPixbuf* _tmp44_;
			gint _tmp45_;
			gint _tmp46_;
			GdkPixbuf* _tmp47_;
			Box _tmp48_;
			Box _tmp49_;
			GdkPixbuf* _tmp50_;
#line 3521 "../src/Photo.vala"
			_tmp29_ = crop;
#line 3521 "../src/Photo.vala"
			_tmp30_ = pixbuf;
#line 3521 "../src/Photo.vala"
			_tmp31_ = gdk_pixbuf_get_width (_tmp30_);
#line 3521 "../src/Photo.vala"
			_tmp32_ = _tmp31_;
#line 3521 "../src/Photo.vala"
			crop.left = CLAMP (_tmp29_.left, 0, _tmp32_ - 2);
#line 3522 "../src/Photo.vala"
			_tmp33_ = crop;
#line 3522 "../src/Photo.vala"
			_tmp34_ = pixbuf;
#line 3522 "../src/Photo.vala"
			_tmp35_ = gdk_pixbuf_get_height (_tmp34_);
#line 3522 "../src/Photo.vala"
			_tmp36_ = _tmp35_;
#line 3522 "../src/Photo.vala"
			crop.top = CLAMP (_tmp33_.top, 0, _tmp36_ - 2);
#line 3524 "../src/Photo.vala"
			_tmp37_ = crop;
#line 3524 "../src/Photo.vala"
			_tmp38_ = crop;
#line 3524 "../src/Photo.vala"
			_tmp39_ = pixbuf;
#line 3524 "../src/Photo.vala"
			_tmp40_ = gdk_pixbuf_get_width (_tmp39_);
#line 3524 "../src/Photo.vala"
			_tmp41_ = _tmp40_;
#line 3524 "../src/Photo.vala"
			crop.right = CLAMP (_tmp37_.right, _tmp38_.left + 1, _tmp41_ - 1);
#line 3525 "../src/Photo.vala"
			_tmp42_ = crop;
#line 3525 "../src/Photo.vala"
			_tmp43_ = crop;
#line 3525 "../src/Photo.vala"
			_tmp44_ = pixbuf;
#line 3525 "../src/Photo.vala"
			_tmp45_ = gdk_pixbuf_get_height (_tmp44_);
#line 3525 "../src/Photo.vala"
			_tmp46_ = _tmp45_;
#line 3525 "../src/Photo.vala"
			crop.bottom = CLAMP (_tmp42_.bottom, _tmp43_.top + 1, _tmp46_ - 1);
#line 3527 "../src/Photo.vala"
			_tmp47_ = pixbuf;
#line 3527 "../src/Photo.vala"
			_tmp48_ = crop;
#line 3527 "../src/Photo.vala"
			_tmp49_ = crop;
#line 3527 "../src/Photo.vala"
			_tmp50_ = gdk_pixbuf_new_subpixbuf (_tmp47_, _tmp48_.left, _tmp49_.top, box_get_width (&crop), box_get_height (&crop));
#line 3527 "../src/Photo.vala"
			_g_object_unref0 (pixbuf);
#line 3527 "../src/Photo.vala"
			pixbuf = _tmp50_;
#line 25550 "Photo.c"
		}
	}
#line 3537 "../src/Photo.vala"
	if (photo_exception_allows (exceptions, PHOTO_EXCEPTION_ORIENTATION)) {
#line 25555 "Photo.c"
		GdkPixbuf* _tmp51_;
		GdkPixbuf* _tmp52_;
#line 3541 "../src/Photo.vala"
		_tmp51_ = pixbuf;
#line 3541 "../src/Photo.vala"
		_tmp52_ = orientation_rotate_pixbuf (orientation, _tmp51_);
#line 3541 "../src/Photo.vala"
		_g_object_unref0 (pixbuf);
#line 3541 "../src/Photo.vala"
		pixbuf = _tmp52_;
#line 25566 "Photo.c"
	}
#line 3548 "../src/Photo.vala"
	if (is_scaled) {
#line 25570 "Photo.c"
		GdkPixbuf* _tmp53_;
		Dimensions _tmp54_;
		Dimensions _tmp55_;
		GdkPixbuf* _tmp56_;
#line 3552 "../src/Photo.vala"
		_tmp53_ = pixbuf;
#line 3552 "../src/Photo.vala"
		_tmp54_ = scaled_to_viewport;
#line 3552 "../src/Photo.vala"
		_tmp55_ = scaled_to_viewport;
#line 3552 "../src/Photo.vala"
		_tmp56_ = gdk_pixbuf_scale_simple (_tmp53_, _tmp54_.width, _tmp55_.height, GDK_INTERP_BILINEAR);
#line 3552 "../src/Photo.vala"
		_g_object_unref0 (pixbuf);
#line 3552 "../src/Photo.vala"
		pixbuf = _tmp56_;
#line 25587 "Photo.c"
	}
#line 3560 "../src/Photo.vala"
	if (photo_exception_allows (exceptions, PHOTO_EXCEPTION_ADJUST)) {
#line 25591 "Photo.c"
		PixelTransformer* _tmp57_;
#line 3564 "../src/Photo.vala"
		_tmp57_ = transformer;
#line 3564 "../src/Photo.vala"
		if (_tmp57_ != NULL) {
#line 25597 "Photo.c"
			PixelTransformer* _tmp58_;
			GdkPixbuf* _tmp59_;
#line 3565 "../src/Photo.vala"
			_tmp58_ = transformer;
#line 3565 "../src/Photo.vala"
			_tmp59_ = pixbuf;
#line 3565 "../src/Photo.vala"
			pixel_transformer_transform_pixbuf (_tmp58_, _tmp59_, NULL);
#line 25606 "Photo.c"
		}
	}
#line 3574 "../src/Photo.vala"
	if (is_scaled) {
#line 3574 "../src/Photo.vala"
		_tmp60_ = !is_straightened;
#line 25613 "Photo.c"
	} else {
#line 3574 "../src/Photo.vala"
		_tmp60_ = FALSE;
#line 25617 "Photo.c"
	}
#line 3574 "../src/Photo.vala"
	if (_tmp60_) {
#line 25621 "Photo.c"
		GdkPixbuf* _tmp61_;
		Dimensions _tmp62_ = {0};
#line 3575 "../src/Photo.vala"
		_tmp61_ = pixbuf;
#line 3575 "../src/Photo.vala"
		dimensions_for_pixbuf (_tmp61_, &_tmp62_);
#line 3575 "../src/Photo.vala"
		_vala_assert (dimensions_approx_equals (&scaled_to_viewport, &_tmp62_, PHOTO_SCALING_FUDGE), "scaled_to_viewport.approx_equals(Dimensions.for_pixbuf(pixbuf), SCALING_FUDGE)");
#line 25630 "Photo.c"
	}
#line 3583 "../src/Photo.vala"
	result = pixbuf;
#line 3583 "../src/Photo.vala"
	_pixel_transformer_unref0 (transformer);
#line 3583 "../src/Photo.vala"
	redeye_instances = (g_free (redeye_instances), NULL);
#line 3583 "../src/Photo.vala"
	return result;
#line 25640 "Photo.c"
}

static gboolean
photo_real_has_user_generated_metadata (Photo* self)
{
	gboolean _tmp0_ = FALSE;
#line 3591 "../src/Photo.vala"
	g_critical ("Type `%s' does not implement abstract method `photo_has_user_generated_metadata'", g_type_name (G_TYPE_FROM_INSTANCE (self)));
#line 3591 "../src/Photo.vala"
	return _tmp0_;
#line 25651 "Photo.c"
}

gboolean
photo_has_user_generated_metadata (Photo* self)
{
	PhotoClass* _klass_;
#line 3591 "../src/Photo.vala"
	g_return_val_if_fail (IS_PHOTO (self), FALSE);
#line 3591 "../src/Photo.vala"
	_klass_ = PHOTO_GET_CLASS (self);
#line 3591 "../src/Photo.vala"
	if (_klass_->has_user_generated_metadata) {
#line 3591 "../src/Photo.vala"
		return _klass_->has_user_generated_metadata (self);
#line 25666 "Photo.c"
	}
#line 3591 "../src/Photo.vala"
	return FALSE;
#line 25670 "Photo.c"
}

static void
photo_real_set_user_metadata_for_export (Photo* self,
                                         PhotoMetadata* metadata)
{
#line 3595 "../src/Photo.vala"
	g_critical ("Type `%s' does not implement abstract method `photo_set_user_metadata_for_export'", g_type_name (G_TYPE_FROM_INSTANCE (self)));
#line 3595 "../src/Photo.vala"
	return;
#line 25681 "Photo.c"
}

void
photo_set_user_metadata_for_export (Photo* self,
                                    PhotoMetadata* metadata)
{
	PhotoClass* _klass_;
#line 3595 "../src/Photo.vala"
	g_return_if_fail (IS_PHOTO (self));
#line 3595 "../src/Photo.vala"
	_klass_ = PHOTO_GET_CLASS (self);
#line 3595 "../src/Photo.vala"
	if (_klass_->set_user_metadata_for_export) {
#line 3595 "../src/Photo.vala"
		_klass_->set_user_metadata_for_export (self, metadata);
#line 25697 "Photo.c"
	}
}

gchar*
photo_get_export_basename (Photo* self,
                           PhotoFileFormat* file_format)
{
	gchar* result;
#line 3602 "../src/Photo.vala"
	g_return_val_if_fail (IS_PHOTO (self), NULL);
#line 3603 "../src/Photo.vala"
	if (file_format != NULL) {
#line 25710 "Photo.c"
		PhotoFileFormatProperties* _tmp0_;
		PhotoFileFormatProperties* _tmp1_;
		GFile* _tmp2_;
		GFile* _tmp3_;
		GFile* _tmp4_;
		GFile* _tmp5_;
		gchar* _tmp6_;
		gchar* _tmp7_;
#line 3604 "../src/Photo.vala"
		_tmp0_ = photo_file_format_get_properties (*file_format);
#line 3604 "../src/Photo.vala"
		_tmp1_ = _tmp0_;
#line 3604 "../src/Photo.vala"
		_tmp2_ = media_source_get_master_file (G_TYPE_CHECK_INSTANCE_CAST (self, TYPE_MEDIA_SOURCE, MediaSource));
#line 3604 "../src/Photo.vala"
		_tmp3_ = _tmp2_;
#line 3604 "../src/Photo.vala"
		_tmp4_ = photo_file_format_properties_convert_file_extension (_tmp1_, _tmp3_);
#line 3604 "../src/Photo.vala"
		_tmp5_ = _tmp4_;
#line 3604 "../src/Photo.vala"
		_tmp6_ = g_file_get_basename (_tmp5_);
#line 3604 "../src/Photo.vala"
		_tmp7_ = _tmp6_;
#line 3604 "../src/Photo.vala"
		_g_object_unref0 (_tmp5_);
#line 3604 "../src/Photo.vala"
		_g_object_unref0 (_tmp3_);
#line 3604 "../src/Photo.vala"
		_photo_file_format_properties_unref0 (_tmp1_);
#line 3604 "../src/Photo.vala"
		result = _tmp7_;
#line 3604 "../src/Photo.vala"
		return result;
#line 25745 "Photo.c"
	} else {
#line 3606 "../src/Photo.vala"
		if (photo_file_format_can_write (photo_get_file_format (self))) {
#line 25749 "Photo.c"
			PhotoFileFormatProperties* _tmp8_;
			PhotoFileFormatProperties* _tmp9_;
			GFile* _tmp10_;
			GFile* _tmp11_;
			GFile* _tmp12_;
			GFile* _tmp13_;
			gchar* _tmp14_;
			gchar* _tmp15_;
#line 3607 "../src/Photo.vala"
			_tmp8_ = photo_file_format_get_properties (photo_get_file_format (self));
#line 3607 "../src/Photo.vala"
			_tmp9_ = _tmp8_;
#line 3607 "../src/Photo.vala"
			_tmp10_ = media_source_get_master_file (G_TYPE_CHECK_INSTANCE_CAST (self, TYPE_MEDIA_SOURCE, MediaSource));
#line 3607 "../src/Photo.vala"
			_tmp11_ = _tmp10_;
#line 3607 "../src/Photo.vala"
			_tmp12_ = photo_file_format_properties_convert_file_extension (_tmp9_, _tmp11_);
#line 3607 "../src/Photo.vala"
			_tmp13_ = _tmp12_;
#line 3607 "../src/Photo.vala"
			_tmp14_ = g_file_get_basename (_tmp13_);
#line 3607 "../src/Photo.vala"
			_tmp15_ = _tmp14_;
#line 3607 "../src/Photo.vala"
			_g_object_unref0 (_tmp13_);
#line 3607 "../src/Photo.vala"
			_g_object_unref0 (_tmp11_);
#line 3607 "../src/Photo.vala"
			_photo_file_format_properties_unref0 (_tmp9_);
#line 3607 "../src/Photo.vala"
			result = _tmp15_;
#line 3607 "../src/Photo.vala"
			return result;
#line 25784 "Photo.c"
		} else {
			PhotoFileFormatProperties* _tmp16_;
			PhotoFileFormatProperties* _tmp17_;
			GFile* _tmp18_;
			GFile* _tmp19_;
			GFile* _tmp20_;
			GFile* _tmp21_;
			gchar* _tmp22_;
			gchar* _tmp23_;
#line 3610 "../src/Photo.vala"
			_tmp16_ = photo_file_format_get_properties (photo_file_format_get_system_default_format ());
#line 3610 "../src/Photo.vala"
			_tmp17_ = _tmp16_;
#line 3610 "../src/Photo.vala"
			_tmp18_ = media_source_get_master_file (G_TYPE_CHECK_INSTANCE_CAST (self, TYPE_MEDIA_SOURCE, MediaSource));
#line 3610 "../src/Photo.vala"
			_tmp19_ = _tmp18_;
#line 3610 "../src/Photo.vala"
			_tmp20_ = photo_file_format_properties_convert_file_extension (_tmp17_, _tmp19_);
#line 3610 "../src/Photo.vala"
			_tmp21_ = _tmp20_;
#line 3610 "../src/Photo.vala"
			_tmp22_ = g_file_get_basename (_tmp21_);
#line 3610 "../src/Photo.vala"
			_tmp23_ = _tmp22_;
#line 3610 "../src/Photo.vala"
			_g_object_unref0 (_tmp21_);
#line 3610 "../src/Photo.vala"
			_g_object_unref0 (_tmp19_);
#line 3610 "../src/Photo.vala"
			_photo_file_format_properties_unref0 (_tmp17_);
#line 3610 "../src/Photo.vala"
			result = _tmp23_;
#line 3610 "../src/Photo.vala"
			return result;
#line 25820 "Photo.c"
		}
	}
}

static gboolean
photo_export_fullsized_backing (Photo* self,
                                GFile* file,
                                gboolean export_metadata,
                                GError** error)
{
	PhotoFileReader* export_reader = NULL;
	gboolean is_master = FALSE;
	PhotoFileReader* _tmp24_;
	PhotoFileFormatProperties* format_properties = NULL;
	PhotoFileReader* _tmp25_;
	PhotoFileFormatProperties* _tmp26_;
	GFile* dest_file = NULL;
	PhotoFileFormatProperties* _tmp27_;
	GFile* _tmp28_;
	PhotoFileMetadataWriter* writer = NULL;
	PhotoFileReader* _tmp29_;
	GFile* _tmp30_;
	gchar* _tmp31_;
	gchar* _tmp32_;
	PhotoFileMetadataWriter* _tmp33_;
	PhotoFileMetadataWriter* _tmp34_;
	gchar* _tmp36_;
	gchar* _tmp37_;
	PhotoFileMetadataWriter* _tmp38_;
	gchar* _tmp39_;
	gchar* _tmp40_;
	PhotoFileReader* _tmp41_;
	GFile* _tmp42_;
	GFile* _tmp43_;
	GFile* _tmp44_;
	gboolean _tmp46_ = FALSE;
	gboolean _tmp47_ = FALSE;
	gboolean _tmp48_ = FALSE;
	gboolean _tmp49_ = FALSE;
	gboolean _tmp50_ = FALSE;
	PhotoMetadata* metadata = NULL;
	PhotoFileReader* _tmp55_;
	PhotoMetadata* _tmp56_;
	PhotoMetadata* _tmp58_;
	PhotoFileMetadataWriter* _tmp61_;
	gchar* _tmp62_;
	gchar* _tmp63_;
	GDateTime* _tmp64_;
	GDateTime* _tmp65_;
	gboolean _tmp66_;
	PhotoFileMetadataWriter* _tmp86_;
	PhotoMetadata* _tmp87_;
	GError* _inner_error0_ = NULL;
	gboolean result;
#line 3616 "../src/Photo.vala"
	g_return_val_if_fail (IS_PHOTO (self), FALSE);
#line 3616 "../src/Photo.vala"
	g_return_val_if_fail (G_TYPE_CHECK_INSTANCE_TYPE (file, g_file_get_type ()), FALSE);
#line 3619 "../src/Photo.vala"
	export_reader = NULL;
#line 3620 "../src/Photo.vala"
	is_master = TRUE;
#line 25883 "Photo.c"
	{
		PhotoBackingReaders* _tmp0_;
#line 3621 "../src/Photo.vala"
		_tmp0_ = self->priv->readers;
#line 3621 "../src/Photo.vala"
		g_rec_mutex_lock (&self->priv->__lock_readers);
#line 25890 "Photo.c"
		{
			gboolean _tmp1_ = FALSE;
			PhotoBackingReaders* _tmp2_;
			PhotoFileReader* _tmp3_;
#line 3622 "../src/Photo.vala"
			_tmp2_ = self->priv->readers;
#line 3622 "../src/Photo.vala"
			_tmp3_ = _tmp2_->editable;
#line 3622 "../src/Photo.vala"
			if (_tmp3_ != NULL) {
#line 25901 "Photo.c"
				PhotoBackingReaders* _tmp4_;
				PhotoFileReader* _tmp5_;
#line 3622 "../src/Photo.vala"
				_tmp4_ = self->priv->readers;
#line 3622 "../src/Photo.vala"
				_tmp5_ = _tmp4_->editable;
#line 3622 "../src/Photo.vala"
				_tmp1_ = photo_file_format_can_write_metadata (photo_file_adapter_get_file_format (G_TYPE_CHECK_INSTANCE_CAST (_tmp5_, TYPE_PHOTO_FILE_ADAPTER, PhotoFileAdapter)));
#line 25910 "Photo.c"
			} else {
#line 3622 "../src/Photo.vala"
				_tmp1_ = FALSE;
#line 25914 "Photo.c"
			}
#line 3622 "../src/Photo.vala"
			if (_tmp1_) {
#line 25918 "Photo.c"
				PhotoBackingReaders* _tmp6_;
				PhotoFileReader* _tmp7_;
				PhotoFileReader* _tmp8_;
#line 3623 "../src/Photo.vala"
				_tmp6_ = self->priv->readers;
#line 3623 "../src/Photo.vala"
				_tmp7_ = _tmp6_->editable;
#line 3623 "../src/Photo.vala"
				_tmp8_ = _photo_file_adapter_ref0 (_tmp7_);
#line 3623 "../src/Photo.vala"
				_photo_file_adapter_unref0 (export_reader);
#line 3623 "../src/Photo.vala"
				export_reader = _tmp8_;
#line 3624 "../src/Photo.vala"
				is_master = FALSE;
#line 25934 "Photo.c"
			} else {
				gboolean _tmp9_ = FALSE;
				PhotoBackingReaders* _tmp10_;
				PhotoFileReader* _tmp11_;
#line 3625 "../src/Photo.vala"
				_tmp10_ = self->priv->readers;
#line 3625 "../src/Photo.vala"
				_tmp11_ = _tmp10_->developer;
#line 3625 "../src/Photo.vala"
				if (_tmp11_ != NULL) {
#line 25945 "Photo.c"
					PhotoBackingReaders* _tmp12_;
					PhotoFileReader* _tmp13_;
#line 3625 "../src/Photo.vala"
					_tmp12_ = self->priv->readers;
#line 3625 "../src/Photo.vala"
					_tmp13_ = _tmp12_->developer;
#line 3625 "../src/Photo.vala"
					_tmp9_ = photo_file_format_can_write_metadata (photo_file_adapter_get_file_format (G_TYPE_CHECK_INSTANCE_CAST (_tmp13_, TYPE_PHOTO_FILE_ADAPTER, PhotoFileAdapter)));
#line 25954 "Photo.c"
				} else {
#line 3625 "../src/Photo.vala"
					_tmp9_ = FALSE;
#line 25958 "Photo.c"
				}
#line 3625 "../src/Photo.vala"
				if (_tmp9_) {
#line 25962 "Photo.c"
					PhotoBackingReaders* _tmp14_;
					PhotoFileReader* _tmp15_;
					PhotoFileReader* _tmp16_;
#line 3626 "../src/Photo.vala"
					_tmp14_ = self->priv->readers;
#line 3626 "../src/Photo.vala"
					_tmp15_ = _tmp14_->developer;
#line 3626 "../src/Photo.vala"
					_tmp16_ = _photo_file_adapter_ref0 (_tmp15_);
#line 3626 "../src/Photo.vala"
					_photo_file_adapter_unref0 (export_reader);
#line 3626 "../src/Photo.vala"
					export_reader = _tmp16_;
#line 3627 "../src/Photo.vala"
					is_master = FALSE;
#line 25978 "Photo.c"
				} else {
					PhotoBackingReaders* _tmp17_;
					PhotoFileReader* _tmp18_;
#line 3628 "../src/Photo.vala"
					_tmp17_ = self->priv->readers;
#line 3628 "../src/Photo.vala"
					_tmp18_ = _tmp17_->master;
#line 3628 "../src/Photo.vala"
					if (photo_file_format_can_write_metadata (photo_file_adapter_get_file_format (G_TYPE_CHECK_INSTANCE_CAST (_tmp18_, TYPE_PHOTO_FILE_ADAPTER, PhotoFileAdapter)))) {
#line 25988 "Photo.c"
						PhotoBackingReaders* _tmp19_;
						PhotoFileReader* _tmp20_;
						PhotoFileReader* _tmp21_;
#line 3629 "../src/Photo.vala"
						_tmp19_ = self->priv->readers;
#line 3629 "../src/Photo.vala"
						_tmp20_ = _tmp19_->master;
#line 3629 "../src/Photo.vala"
						_tmp21_ = _photo_file_adapter_ref0 (_tmp20_);
#line 3629 "../src/Photo.vala"
						_photo_file_adapter_unref0 (export_reader);
#line 3629 "../src/Photo.vala"
						export_reader = _tmp21_;
#line 26002 "Photo.c"
					}
				}
			}
		}
		__finally0:
		{
			PhotoBackingReaders* _tmp22_;
#line 3621 "../src/Photo.vala"
			_tmp22_ = self->priv->readers;
#line 3621 "../src/Photo.vala"
			g_rec_mutex_unlock (&self->priv->__lock_readers);
#line 26014 "Photo.c"
		}
#line 3621 "../src/Photo.vala"
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 26018 "Photo.c"
			gboolean _tmp23_ = FALSE;
#line 3621 "../src/Photo.vala"
			g_propagate_error (error, _inner_error0_);
#line 3621 "../src/Photo.vala"
			_photo_file_adapter_unref0 (export_reader);
#line 3621 "../src/Photo.vala"
			return _tmp23_;
#line 26026 "Photo.c"
		}
	}
#line 3633 "../src/Photo.vala"
	_tmp24_ = export_reader;
#line 3633 "../src/Photo.vala"
	if (_tmp24_ == NULL) {
#line 3634 "../src/Photo.vala"
		result = FALSE;
#line 3634 "../src/Photo.vala"
		_photo_file_adapter_unref0 (export_reader);
#line 3634 "../src/Photo.vala"
		return result;
#line 26039 "Photo.c"
	}
#line 3636 "../src/Photo.vala"
	_tmp25_ = export_reader;
#line 3636 "../src/Photo.vala"
	_tmp26_ = photo_file_format_get_properties (photo_file_adapter_get_file_format (G_TYPE_CHECK_INSTANCE_CAST (_tmp25_, TYPE_PHOTO_FILE_ADAPTER, PhotoFileAdapter)));
#line 3636 "../src/Photo.vala"
	format_properties = _tmp26_;
#line 3639 "../src/Photo.vala"
	_tmp27_ = format_properties;
#line 3639 "../src/Photo.vala"
	_tmp28_ = photo_file_format_properties_convert_file_extension (_tmp27_, file);
#line 3639 "../src/Photo.vala"
	dest_file = _tmp28_;
#line 3642 "../src/Photo.vala"
	_tmp29_ = export_reader;
#line 3642 "../src/Photo.vala"
	_tmp30_ = dest_file;
#line 3642 "../src/Photo.vala"
	_tmp31_ = g_file_get_path (_tmp30_);
#line 3642 "../src/Photo.vala"
	_tmp32_ = _tmp31_;
#line 3642 "../src/Photo.vala"
	_tmp33_ = photo_file_format_create_metadata_writer (photo_file_adapter_get_file_format (G_TYPE_CHECK_INSTANCE_CAST (_tmp29_, TYPE_PHOTO_FILE_ADAPTER, PhotoFileAdapter)), _tmp32_, &_inner_error0_);
#line 3642 "../src/Photo.vala"
	_tmp34_ = _tmp33_;
#line 3642 "../src/Photo.vala"
	_g_free0 (_tmp32_);
#line 3642 "../src/Photo.vala"
	writer = _tmp34_;
#line 3642 "../src/Photo.vala"
	if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 26071 "Photo.c"
		gboolean _tmp35_ = FALSE;
#line 3642 "../src/Photo.vala"
		g_propagate_error (error, _inner_error0_);
#line 3642 "../src/Photo.vala"
		_g_object_unref0 (dest_file);
#line 3642 "../src/Photo.vala"
		_photo_file_format_properties_unref0 (format_properties);
#line 3642 "../src/Photo.vala"
		_photo_file_adapter_unref0 (export_reader);
#line 3642 "../src/Photo.vala"
		return _tmp35_;
#line 26083 "Photo.c"
	}
#line 3645 "../src/Photo.vala"
	_tmp36_ = data_object_to_string (G_TYPE_CHECK_INSTANCE_CAST (self, TYPE_DATA_OBJECT, DataObject));
#line 3645 "../src/Photo.vala"
	_tmp37_ = _tmp36_;
#line 3645 "../src/Photo.vala"
	_tmp38_ = writer;
#line 3645 "../src/Photo.vala"
	_tmp39_ = photo_file_adapter_get_filepath (G_TYPE_CHECK_INSTANCE_CAST (_tmp38_, TYPE_PHOTO_FILE_ADAPTER, PhotoFileAdapter));
#line 3645 "../src/Photo.vala"
	_tmp40_ = _tmp39_;
#line 3645 "../src/Photo.vala"
	g_debug ("Photo.vala:3645: Exporting full-sized copy of %s to %s", _tmp37_, _tmp40_);
#line 3645 "../src/Photo.vala"
	_g_free0 (_tmp40_);
#line 3645 "../src/Photo.vala"
	_g_free0 (_tmp37_);
#line 3647 "../src/Photo.vala"
	_tmp41_ = export_reader;
#line 3647 "../src/Photo.vala"
	_tmp42_ = photo_file_adapter_get_file (G_TYPE_CHECK_INSTANCE_CAST (_tmp41_, TYPE_PHOTO_FILE_ADAPTER, PhotoFileAdapter));
#line 3647 "../src/Photo.vala"
	_tmp43_ = _tmp42_;
#line 3647 "../src/Photo.vala"
	_tmp44_ = dest_file;
#line 3647 "../src/Photo.vala"
	g_file_copy (_tmp43_, _tmp44_, G_FILE_COPY_OVERWRITE | G_FILE_COPY_TARGET_DEFAULT_PERMS, NULL, NULL, NULL, &_inner_error0_);
#line 3647 "../src/Photo.vala"
	_g_object_unref0 (_tmp43_);
#line 3647 "../src/Photo.vala"
	if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 26115 "Photo.c"
		gboolean _tmp45_ = FALSE;
#line 3647 "../src/Photo.vala"
		g_propagate_error (error, _inner_error0_);
#line 3647 "../src/Photo.vala"
		_photo_file_adapter_unref0 (writer);
#line 3647 "../src/Photo.vala"
		_g_object_unref0 (dest_file);
#line 3647 "../src/Photo.vala"
		_photo_file_format_properties_unref0 (format_properties);
#line 3647 "../src/Photo.vala"
		_photo_file_adapter_unref0 (export_reader);
#line 3647 "../src/Photo.vala"
		return _tmp45_;
#line 26129 "Photo.c"
	}
#line 3652 "../src/Photo.vala"
	if (!photo_has_alterations (self)) {
#line 3652 "../src/Photo.vala"
		_tmp50_ = is_master;
#line 26135 "Photo.c"
	} else {
#line 3652 "../src/Photo.vala"
		_tmp50_ = FALSE;
#line 26139 "Photo.c"
	}
#line 3652 "../src/Photo.vala"
	if (_tmp50_) {
#line 3652 "../src/Photo.vala"
		_tmp49_ = !photo_has_user_generated_metadata (self);
#line 26145 "Photo.c"
	} else {
#line 3652 "../src/Photo.vala"
		_tmp49_ = FALSE;
#line 26149 "Photo.c"
	}
#line 3652 "../src/Photo.vala"
	if (_tmp49_) {
#line 26153 "Photo.c"
		gchar* _tmp51_;
		gchar* _tmp52_;
#line 3653 "../src/Photo.vala"
		_tmp51_ = media_source_get_title (G_TYPE_CHECK_INSTANCE_CAST (self, TYPE_MEDIA_SOURCE, MediaSource));
#line 3653 "../src/Photo.vala"
		_tmp52_ = _tmp51_;
#line 3653 "../src/Photo.vala"
		_tmp48_ = _tmp52_ == NULL;
#line 3653 "../src/Photo.vala"
		_g_free0 (_tmp52_);
#line 26164 "Photo.c"
	} else {
#line 3652 "../src/Photo.vala"
		_tmp48_ = FALSE;
#line 26168 "Photo.c"
	}
#line 3652 "../src/Photo.vala"
	if (_tmp48_) {
#line 26172 "Photo.c"
		gchar* _tmp53_;
		gchar* _tmp54_;
#line 3653 "../src/Photo.vala"
		_tmp53_ = media_source_get_comment (G_TYPE_CHECK_INSTANCE_CAST (self, TYPE_MEDIA_SOURCE, MediaSource));
#line 3653 "../src/Photo.vala"
		_tmp54_ = _tmp53_;
#line 3653 "../src/Photo.vala"
		_tmp47_ = _tmp54_ == NULL;
#line 3653 "../src/Photo.vala"
		_g_free0 (_tmp54_);
#line 26183 "Photo.c"
	} else {
#line 3652 "../src/Photo.vala"
		_tmp47_ = FALSE;
#line 26187 "Photo.c"
	}
#line 3652 "../src/Photo.vala"
	if (_tmp47_) {
#line 3653 "../src/Photo.vala"
		_tmp46_ = export_metadata;
#line 26193 "Photo.c"
	} else {
#line 3652 "../src/Photo.vala"
		_tmp46_ = FALSE;
#line 26197 "Photo.c"
	}
#line 3652 "../src/Photo.vala"
	if (_tmp46_) {
#line 3654 "../src/Photo.vala"
		result = TRUE;
#line 3654 "../src/Photo.vala"
		_photo_file_adapter_unref0 (writer);
#line 3654 "../src/Photo.vala"
		_g_object_unref0 (dest_file);
#line 3654 "../src/Photo.vala"
		_photo_file_format_properties_unref0 (format_properties);
#line 3654 "../src/Photo.vala"
		_photo_file_adapter_unref0 (export_reader);
#line 3654 "../src/Photo.vala"
		return result;
#line 26213 "Photo.c"
	}
#line 3657 "../src/Photo.vala"
	_tmp55_ = export_reader;
#line 3657 "../src/Photo.vala"
	_tmp56_ = photo_file_reader_read_metadata (_tmp55_, &_inner_error0_);
#line 3657 "../src/Photo.vala"
	metadata = _tmp56_;
#line 3657 "../src/Photo.vala"
	if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 26223 "Photo.c"
		gboolean _tmp57_ = FALSE;
#line 3657 "../src/Photo.vala"
		g_propagate_error (error, _inner_error0_);
#line 3657 "../src/Photo.vala"
		_photo_file_adapter_unref0 (writer);
#line 3657 "../src/Photo.vala"
		_g_object_unref0 (dest_file);
#line 3657 "../src/Photo.vala"
		_photo_file_format_properties_unref0 (format_properties);
#line 3657 "../src/Photo.vala"
		_photo_file_adapter_unref0 (export_reader);
#line 3657 "../src/Photo.vala"
		return _tmp57_;
#line 26237 "Photo.c"
	}
#line 3658 "../src/Photo.vala"
	_tmp58_ = metadata;
#line 3658 "../src/Photo.vala"
	if (_tmp58_ == NULL) {
#line 26243 "Photo.c"
		PhotoFileReader* _tmp59_;
		PhotoMetadata* _tmp60_;
#line 3659 "../src/Photo.vala"
		_tmp59_ = export_reader;
#line 3659 "../src/Photo.vala"
		_tmp60_ = photo_file_format_create_metadata (photo_file_adapter_get_file_format (G_TYPE_CHECK_INSTANCE_CAST (_tmp59_, TYPE_PHOTO_FILE_ADAPTER, PhotoFileAdapter)));
#line 3659 "../src/Photo.vala"
		_media_metadata_unref0 (metadata);
#line 3659 "../src/Photo.vala"
		metadata = _tmp60_;
#line 26254 "Photo.c"
	}
#line 3661 "../src/Photo.vala"
	_tmp61_ = writer;
#line 3661 "../src/Photo.vala"
	_tmp62_ = photo_file_adapter_get_filepath (G_TYPE_CHECK_INSTANCE_CAST (_tmp61_, TYPE_PHOTO_FILE_ADAPTER, PhotoFileAdapter));
#line 3661 "../src/Photo.vala"
	_tmp63_ = _tmp62_;
#line 3661 "../src/Photo.vala"
	g_debug ("Photo.vala:3661: Updating metadata of %s", _tmp63_);
#line 3661 "../src/Photo.vala"
	_g_free0 (_tmp63_);
#line 3663 "../src/Photo.vala"
	_tmp64_ = media_source_get_exposure_time (G_TYPE_CHECK_INSTANCE_CAST (self, TYPE_MEDIA_SOURCE, MediaSource));
#line 3663 "../src/Photo.vala"
	_tmp65_ = _tmp64_;
#line 3663 "../src/Photo.vala"
	_tmp66_ = _tmp65_ != NULL;
#line 3663 "../src/Photo.vala"
	_g_date_time_unref0 (_tmp65_);
#line 3663 "../src/Photo.vala"
	if (_tmp66_) {
#line 26276 "Photo.c"
		PhotoMetadata* _tmp67_;
		GDateTime* _tmp68_;
		GDateTime* _tmp69_;
		MetadataDateTime* _tmp70_;
		MetadataDateTime* _tmp71_;
#line 3664 "../src/Photo.vala"
		_tmp67_ = metadata;
#line 3664 "../src/Photo.vala"
		_tmp68_ = media_source_get_exposure_time (G_TYPE_CHECK_INSTANCE_CAST (self, TYPE_MEDIA_SOURCE, MediaSource));
#line 3664 "../src/Photo.vala"
		_tmp69_ = _tmp68_;
#line 3664 "../src/Photo.vala"
		_tmp70_ = metadata_date_time_new (_tmp69_);
#line 3664 "../src/Photo.vala"
		_tmp71_ = _tmp70_;
#line 3664 "../src/Photo.vala"
		photo_metadata_set_exposure_date_time (_tmp67_, _tmp71_, PHOTO_METADATA_SET_OPTION_ALL_DOMAINS);
#line 3664 "../src/Photo.vala"
		_metadata_date_time_unref0 (_tmp71_);
#line 3664 "../src/Photo.vala"
		_g_date_time_unref0 (_tmp69_);
#line 26298 "Photo.c"
	} else {
		PhotoMetadata* _tmp72_;
#line 3666 "../src/Photo.vala"
		_tmp72_ = metadata;
#line 3666 "../src/Photo.vala"
		photo_metadata_set_exposure_date_time (_tmp72_, NULL, PHOTO_METADATA_SET_OPTION_ALL_DOMAINS);
#line 26305 "Photo.c"
	}
#line 3668 "../src/Photo.vala"
	if (export_metadata) {
#line 26309 "Photo.c"
		PhotoMetadata* _tmp73_;
		gchar* _tmp74_;
		gchar* _tmp75_;
		PhotoMetadata* _tmp76_;
		gchar* _tmp77_;
		gchar* _tmp78_;
		PhotoMetadata* _tmp79_;
		Dimensions _tmp80_ = {0};
		PhotoMetadata* _tmp81_;
		PhotoMetadata* _tmp82_;
		PhotoMetadata* _tmp84_;
#line 3670 "../src/Photo.vala"
		_tmp73_ = metadata;
#line 3670 "../src/Photo.vala"
		_tmp74_ = media_source_get_title (G_TYPE_CHECK_INSTANCE_CAST (self, TYPE_MEDIA_SOURCE, MediaSource));
#line 3670 "../src/Photo.vala"
		_tmp75_ = _tmp74_;
#line 3670 "../src/Photo.vala"
		photo_metadata_set_title (_tmp73_, _tmp75_, PHOTO_METADATA_SET_OPTION_ALL_DOMAINS);
#line 3670 "../src/Photo.vala"
		_g_free0 (_tmp75_);
#line 3671 "../src/Photo.vala"
		_tmp76_ = metadata;
#line 3671 "../src/Photo.vala"
		_tmp77_ = media_source_get_comment (G_TYPE_CHECK_INSTANCE_CAST (self, TYPE_MEDIA_SOURCE, MediaSource));
#line 3671 "../src/Photo.vala"
		_tmp78_ = _tmp77_;
#line 3671 "../src/Photo.vala"
		photo_metadata_set_comment (_tmp76_, _tmp78_, PHOTO_METADATA_SET_OPTION_ALL_DOMAINS);
#line 3671 "../src/Photo.vala"
		_g_free0 (_tmp78_);
#line 3672 "../src/Photo.vala"
		_tmp79_ = metadata;
#line 3672 "../src/Photo.vala"
		media_source_get_dimensions (G_TYPE_CHECK_INSTANCE_CAST (self, TYPE_MEDIA_SOURCE, MediaSource), PHOTO_EXCEPTION_NONE, &_tmp80_);
#line 3672 "../src/Photo.vala"
		photo_metadata_set_pixel_dimensions (_tmp79_, &_tmp80_, PHOTO_METADATA_SET_OPTION_ALL_DOMAINS);
#line 3673 "../src/Photo.vala"
		_tmp81_ = metadata;
#line 3673 "../src/Photo.vala"
		photo_metadata_set_orientation (_tmp81_, photo_get_orientation (self));
#line 3674 "../src/Photo.vala"
		_tmp82_ = metadata;
#line 3674 "../src/Photo.vala"
		photo_metadata_set_software (_tmp82_, RESOURCES_APP_TITLE, RESOURCES_APP_VERSION);
#line 3676 "../src/Photo.vala"
		if (photo_get_orientation (self) != photo_get_original_orientation (self)) {
#line 26357 "Photo.c"
			PhotoMetadata* _tmp83_;
#line 3677 "../src/Photo.vala"
			_tmp83_ = metadata;
#line 3677 "../src/Photo.vala"
			photo_metadata_remove_exif_thumbnail (_tmp83_);
#line 26363 "Photo.c"
		}
#line 3679 "../src/Photo.vala"
		_tmp84_ = metadata;
#line 3679 "../src/Photo.vala"
		photo_set_user_metadata_for_export (self, _tmp84_);
#line 26369 "Photo.c"
	} else {
		PhotoMetadata* _tmp85_;
#line 3683 "../src/Photo.vala"
		_tmp85_ = metadata;
#line 3683 "../src/Photo.vala"
		photo_metadata_clear (_tmp85_);
#line 26376 "Photo.c"
	}
#line 3685 "../src/Photo.vala"
	_tmp86_ = writer;
#line 3685 "../src/Photo.vala"
	_tmp87_ = metadata;
#line 3685 "../src/Photo.vala"
	photo_file_metadata_writer_write_metadata (_tmp86_, _tmp87_, &_inner_error0_);
#line 3685 "../src/Photo.vala"
	if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 26386 "Photo.c"
		gboolean _tmp88_ = FALSE;
#line 3685 "../src/Photo.vala"
		g_propagate_error (error, _inner_error0_);
#line 3685 "../src/Photo.vala"
		_media_metadata_unref0 (metadata);
#line 3685 "../src/Photo.vala"
		_photo_file_adapter_unref0 (writer);
#line 3685 "../src/Photo.vala"
		_g_object_unref0 (dest_file);
#line 3685 "../src/Photo.vala"
		_photo_file_format_properties_unref0 (format_properties);
#line 3685 "../src/Photo.vala"
		_photo_file_adapter_unref0 (export_reader);
#line 3685 "../src/Photo.vala"
		return _tmp88_;
#line 26402 "Photo.c"
	}
#line 3687 "../src/Photo.vala"
	result = TRUE;
#line 3687 "../src/Photo.vala"
	_media_metadata_unref0 (metadata);
#line 3687 "../src/Photo.vala"
	_photo_file_adapter_unref0 (writer);
#line 3687 "../src/Photo.vala"
	_g_object_unref0 (dest_file);
#line 3687 "../src/Photo.vala"
	_photo_file_format_properties_unref0 (format_properties);
#line 3687 "../src/Photo.vala"
	_photo_file_adapter_unref0 (export_reader);
#line 3687 "../src/Photo.vala"
	return result;
#line 26418 "Photo.c"
}

gboolean
photo_is_export_required (Photo* self,
                          Scaling* scaling,
                          PhotoFileFormat export_format)
{
	gboolean _tmp0_ = FALSE;
	gboolean _tmp1_ = FALSE;
	gboolean _tmp2_ = FALSE;
	gboolean result;
#line 3693 "../src/Photo.vala"
	g_return_val_if_fail (IS_PHOTO (self), FALSE);
#line 3693 "../src/Photo.vala"
	g_return_val_if_fail (scaling != NULL, FALSE);
#line 3694 "../src/Photo.vala"
	if (!scaling_is_unscaled (scaling)) {
#line 3694 "../src/Photo.vala"
		_tmp2_ = TRUE;
#line 26438 "Photo.c"
	} else {
#line 3694 "../src/Photo.vala"
		_tmp2_ = photo_has_alterations (self);
#line 26442 "Photo.c"
	}
#line 3694 "../src/Photo.vala"
	if (_tmp2_) {
#line 3694 "../src/Photo.vala"
		_tmp1_ = TRUE;
#line 26448 "Photo.c"
	} else {
#line 3694 "../src/Photo.vala"
		_tmp1_ = photo_has_user_generated_metadata (self);
#line 26452 "Photo.c"
	}
#line 3694 "../src/Photo.vala"
	if (_tmp1_) {
#line 3694 "../src/Photo.vala"
		_tmp0_ = TRUE;
#line 26458 "Photo.c"
	} else {
#line 3695 "../src/Photo.vala"
		_tmp0_ = export_format != photo_get_file_format (self);
#line 26462 "Photo.c"
	}
#line 3694 "../src/Photo.vala"
	result = _tmp0_;
#line 3694 "../src/Photo.vala"
	return result;
#line 26468 "Photo.c"
}

void
photo_export (Photo* self,
              GFile* dest_file,
              Scaling* scaling,
              JpegQuality quality,
              PhotoFileFormat export_format,
              gboolean direct_copy_unmodified,
              gboolean export_metadata,
              GError** error)
{
	gboolean _tmp2_ = FALSE;
	gboolean _tmp3_ = FALSE;
	gboolean _tmp4_ = FALSE;
	PhotoMetadata* metadata = NULL;
	PhotoMetadata* _tmp7_;
	PhotoMetadata* _tmp8_;
	PhotoFileWriter* writer = NULL;
	gchar* _tmp10_;
	gchar* _tmp11_;
	PhotoFileWriter* _tmp12_;
	PhotoFileWriter* _tmp13_;
	gchar* _tmp14_;
	gchar* _tmp15_;
	PhotoFileWriter* _tmp16_;
	gchar* _tmp17_;
	gchar* _tmp18_;
	GEnumValue* _tmp19_;
	GdkPixbuf* pixbuf = NULL;
	gboolean _tmp20_ = FALSE;
	PhotoFileWriter* _tmp29_;
	GdkPixbuf* _tmp30_;
	PhotoFileWriter* _tmp31_;
	gchar* _tmp32_;
	gchar* _tmp33_;
	gboolean _tmp55_ = FALSE;
	PhotoFileMetadataWriter* _tmp63_ = NULL;
	gchar* _tmp64_;
	gchar* _tmp65_;
	PhotoFileMetadataWriter* _tmp66_;
	PhotoFileMetadataWriter* _tmp67_;
	PhotoMetadata* _tmp68_;
	GError* _inner_error0_ = NULL;
#line 3701 "../src/Photo.vala"
	g_return_if_fail (IS_PHOTO (self));
#line 3701 "../src/Photo.vala"
	g_return_if_fail (G_TYPE_CHECK_INSTANCE_TYPE (dest_file, g_file_get_type ()));
#line 3701 "../src/Photo.vala"
	g_return_if_fail (scaling != NULL);
#line 3703 "../src/Photo.vala"
	if (direct_copy_unmodified) {
#line 26521 "Photo.c"
		GFile* _tmp0_;
		GFile* _tmp1_;
#line 3704 "../src/Photo.vala"
		_tmp0_ = media_source_get_master_file (G_TYPE_CHECK_INSTANCE_CAST (self, TYPE_MEDIA_SOURCE, MediaSource));
#line 3704 "../src/Photo.vala"
		_tmp1_ = _tmp0_;
#line 3704 "../src/Photo.vala"
		g_file_copy (_tmp1_, dest_file, G_FILE_COPY_OVERWRITE | G_FILE_COPY_TARGET_DEFAULT_PERMS, NULL, NULL, NULL, &_inner_error0_);
#line 3704 "../src/Photo.vala"
		_g_object_unref0 (_tmp1_);
#line 3704 "../src/Photo.vala"
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 3704 "../src/Photo.vala"
			g_propagate_error (error, _inner_error0_);
#line 3704 "../src/Photo.vala"
			return;
#line 26538 "Photo.c"
		}
#line 3706 "../src/Photo.vala"
		return;
#line 26542 "Photo.c"
	}
#line 3713 "../src/Photo.vala"
	if (scaling_is_unscaled (scaling)) {
#line 26546 "Photo.c"
		gboolean _tmp5_ = FALSE;
#line 3713 "../src/Photo.vala"
		if (!photo_has_alterations (self)) {
#line 3713 "../src/Photo.vala"
			_tmp5_ = TRUE;
#line 26552 "Photo.c"
		} else {
#line 3713 "../src/Photo.vala"
			_tmp5_ = photo_only_metadata_changed (self);
#line 26556 "Photo.c"
		}
#line 3713 "../src/Photo.vala"
		_tmp4_ = _tmp5_;
#line 26560 "Photo.c"
	} else {
#line 3713 "../src/Photo.vala"
		_tmp4_ = FALSE;
#line 26564 "Photo.c"
	}
#line 3713 "../src/Photo.vala"
	if (_tmp4_) {
#line 3714 "../src/Photo.vala"
		_tmp3_ = export_format == photo_get_file_format (self);
#line 26570 "Photo.c"
	} else {
#line 3713 "../src/Photo.vala"
		_tmp3_ = FALSE;
#line 26574 "Photo.c"
	}
#line 3713 "../src/Photo.vala"
	if (_tmp3_) {
#line 3714 "../src/Photo.vala"
		_tmp2_ = photo_get_file_format (self) == PHOTO_FILE_FORMAT_JFIF;
#line 26580 "Photo.c"
	} else {
#line 3713 "../src/Photo.vala"
		_tmp2_ = FALSE;
#line 26584 "Photo.c"
	}
#line 3713 "../src/Photo.vala"
	if (_tmp2_) {
#line 26588 "Photo.c"
		gboolean _tmp6_ = FALSE;
#line 3715 "../src/Photo.vala"
		_tmp6_ = photo_export_fullsized_backing (self, dest_file, export_metadata, &_inner_error0_);
#line 3715 "../src/Photo.vala"
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 3715 "../src/Photo.vala"
			g_propagate_error (error, _inner_error0_);
#line 3715 "../src/Photo.vala"
			return;
#line 26598 "Photo.c"
		}
#line 3715 "../src/Photo.vala"
		if (_tmp6_) {
#line 3716 "../src/Photo.vala"
			return;
#line 26604 "Photo.c"
		}
	}
#line 3722 "../src/Photo.vala"
	_tmp7_ = photo_source_get_metadata (G_TYPE_CHECK_INSTANCE_CAST (self, TYPE_PHOTO_SOURCE, PhotoSource));
#line 3722 "../src/Photo.vala"
	metadata = _tmp7_;
#line 3723 "../src/Photo.vala"
	_tmp8_ = metadata;
#line 3723 "../src/Photo.vala"
	if (_tmp8_ == NULL) {
#line 26615 "Photo.c"
		PhotoMetadata* _tmp9_;
#line 3724 "../src/Photo.vala"
		_tmp9_ = photo_file_format_create_metadata (export_format);
#line 3724 "../src/Photo.vala"
		_media_metadata_unref0 (metadata);
#line 3724 "../src/Photo.vala"
		metadata = _tmp9_;
#line 26623 "Photo.c"
	}
#line 3726 "../src/Photo.vala"
	if (!photo_file_format_can_write (export_format)) {
#line 3727 "../src/Photo.vala"
		export_format = photo_file_format_get_system_default_format ();
#line 26629 "Photo.c"
	}
#line 3729 "../src/Photo.vala"
	_tmp10_ = g_file_get_path (dest_file);
#line 3729 "../src/Photo.vala"
	_tmp11_ = _tmp10_;
#line 3729 "../src/Photo.vala"
	_tmp12_ = photo_file_format_create_writer (export_format, _tmp11_, &_inner_error0_);
#line 3729 "../src/Photo.vala"
	_tmp13_ = _tmp12_;
#line 3729 "../src/Photo.vala"
	_g_free0 (_tmp11_);
#line 3729 "../src/Photo.vala"
	writer = _tmp13_;
#line 3729 "../src/Photo.vala"
	if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 3729 "../src/Photo.vala"
		g_propagate_error (error, _inner_error0_);
#line 3729 "../src/Photo.vala"
		_media_metadata_unref0 (metadata);
#line 3729 "../src/Photo.vala"
		return;
#line 26651 "Photo.c"
	}
#line 3731 "../src/Photo.vala"
	_tmp14_ = data_object_to_string (G_TYPE_CHECK_INSTANCE_CAST (self, TYPE_DATA_OBJECT, DataObject));
#line 3731 "../src/Photo.vala"
	_tmp15_ = _tmp14_;
#line 3731 "../src/Photo.vala"
	_tmp16_ = writer;
#line 3731 "../src/Photo.vala"
	_tmp17_ = photo_file_adapter_get_filepath (G_TYPE_CHECK_INSTANCE_CAST (_tmp16_, TYPE_PHOTO_FILE_ADAPTER, PhotoFileAdapter));
#line 3731 "../src/Photo.vala"
	_tmp18_ = _tmp17_;
#line 3732 "../src/Photo.vala"
	_tmp19_ = g_enum_get_value (g_type_class_ref (TYPE_PHOTO_FILE_FORMAT), export_format);
#line 3731 "../src/Photo.vala"
	g_debug ("Photo.vala:3731: Saving transformed version of %s to %s in file format" \
" %s", _tmp15_, _tmp18_, (_tmp19_ != NULL) ? _tmp19_->value_name : NULL);
#line 3731 "../src/Photo.vala"
	_g_free0 (_tmp18_);
#line 3731 "../src/Photo.vala"
	_g_free0 (_tmp15_);
#line 3738 "../src/Photo.vala"
	if (photo_get_file_format (self) == PHOTO_FILE_FORMAT_JFIF) {
#line 3738 "../src/Photo.vala"
		_tmp20_ = TRUE;
#line 26675 "Photo.c"
	} else {
#line 3739 "../src/Photo.vala"
		_tmp20_ = photo_get_file_format (self) == PHOTO_FILE_FORMAT_RAW;
#line 26679 "Photo.c"
	}
#line 3738 "../src/Photo.vala"
	if (_tmp20_) {
#line 26683 "Photo.c"
		GdkPixbuf* _tmp21_ = NULL;
		Scaling _tmp22_;
		GdkPixbuf* _tmp23_;
		GdkPixbuf* _tmp24_;
#line 3740 "../src/Photo.vala"
		_tmp22_ = *scaling;
#line 3740 "../src/Photo.vala"
		_tmp23_ = photo_get_pixbuf_with_options (self, &_tmp22_, PHOTO_EXCEPTION_ORIENTATION, BACKING_FETCH_MODE_SOURCE, &_inner_error0_);
#line 3740 "../src/Photo.vala"
		_tmp21_ = _tmp23_;
#line 3740 "../src/Photo.vala"
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 3740 "../src/Photo.vala"
			g_propagate_error (error, _inner_error0_);
#line 3740 "../src/Photo.vala"
			_g_object_unref0 (pixbuf);
#line 3740 "../src/Photo.vala"
			_photo_file_adapter_unref0 (writer);
#line 3740 "../src/Photo.vala"
			_media_metadata_unref0 (metadata);
#line 3740 "../src/Photo.vala"
			return;
#line 26706 "Photo.c"
		}
#line 3740 "../src/Photo.vala"
		_tmp24_ = _tmp21_;
#line 3740 "../src/Photo.vala"
		_tmp21_ = NULL;
#line 3740 "../src/Photo.vala"
		_g_object_unref0 (pixbuf);
#line 3740 "../src/Photo.vala"
		pixbuf = _tmp24_;
#line 3738 "../src/Photo.vala"
		_g_object_unref0 (_tmp21_);
#line 26718 "Photo.c"
	} else {
		GdkPixbuf* _tmp25_ = NULL;
		Scaling _tmp26_;
		GdkPixbuf* _tmp27_;
		GdkPixbuf* _tmp28_;
#line 3744 "../src/Photo.vala"
		_tmp26_ = *scaling;
#line 3744 "../src/Photo.vala"
		_tmp27_ = photo_get_pixbuf_with_options (self, &_tmp26_, PHOTO_EXCEPTION_NONE, BACKING_FETCH_MODE_SOURCE, &_inner_error0_);
#line 3744 "../src/Photo.vala"
		_tmp25_ = _tmp27_;
#line 3744 "../src/Photo.vala"
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 3744 "../src/Photo.vala"
			g_propagate_error (error, _inner_error0_);
#line 3744 "../src/Photo.vala"
			_g_object_unref0 (pixbuf);
#line 3744 "../src/Photo.vala"
			_photo_file_adapter_unref0 (writer);
#line 3744 "../src/Photo.vala"
			_media_metadata_unref0 (metadata);
#line 3744 "../src/Photo.vala"
			return;
#line 26742 "Photo.c"
		}
#line 3744 "../src/Photo.vala"
		_tmp28_ = _tmp25_;
#line 3744 "../src/Photo.vala"
		_tmp25_ = NULL;
#line 3744 "../src/Photo.vala"
		_g_object_unref0 (pixbuf);
#line 3744 "../src/Photo.vala"
		pixbuf = _tmp28_;
#line 3738 "../src/Photo.vala"
		_g_object_unref0 (_tmp25_);
#line 26754 "Photo.c"
	}
#line 3748 "../src/Photo.vala"
	_tmp29_ = writer;
#line 3748 "../src/Photo.vala"
	_tmp30_ = pixbuf;
#line 3748 "../src/Photo.vala"
	photo_file_writer_write (_tmp29_, _tmp30_, quality, &_inner_error0_);
#line 3748 "../src/Photo.vala"
	if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 3748 "../src/Photo.vala"
		g_propagate_error (error, _inner_error0_);
#line 3748 "../src/Photo.vala"
		_g_object_unref0 (pixbuf);
#line 3748 "../src/Photo.vala"
		_photo_file_adapter_unref0 (writer);
#line 3748 "../src/Photo.vala"
		_media_metadata_unref0 (metadata);
#line 3748 "../src/Photo.vala"
		return;
#line 26774 "Photo.c"
	}
#line 3750 "../src/Photo.vala"
	_tmp31_ = writer;
#line 3750 "../src/Photo.vala"
	_tmp32_ = photo_file_adapter_get_filepath (G_TYPE_CHECK_INSTANCE_CAST (_tmp31_, TYPE_PHOTO_FILE_ADAPTER, PhotoFileAdapter));
#line 3750 "../src/Photo.vala"
	_tmp33_ = _tmp32_;
#line 3750 "../src/Photo.vala"
	g_debug ("Photo.vala:3750: Setting EXIF for %s", _tmp33_);
#line 3750 "../src/Photo.vala"
	_g_free0 (_tmp33_);
#line 3753 "../src/Photo.vala"
	if (export_metadata) {
#line 26788 "Photo.c"
		PhotoMetadata* _tmp34_;
		gchar* _tmp35_;
		gchar* _tmp36_;
		PhotoMetadata* _tmp37_;
		gchar* _tmp38_;
		gchar* _tmp39_;
		PhotoMetadata* _tmp40_;
		GDateTime* _tmp41_;
		GDateTime* _tmp42_;
		gboolean _tmp43_;
		PhotoMetadata* _tmp50_;
		PhotoMetadata* _tmp51_;
		PhotoMetadata* _tmp52_;
#line 3755 "../src/Photo.vala"
		_tmp34_ = metadata;
#line 3755 "../src/Photo.vala"
		_tmp35_ = media_source_get_title (G_TYPE_CHECK_INSTANCE_CAST (self, TYPE_MEDIA_SOURCE, MediaSource));
#line 3755 "../src/Photo.vala"
		_tmp36_ = _tmp35_;
#line 3755 "../src/Photo.vala"
		photo_metadata_set_title (_tmp34_, _tmp36_, PHOTO_METADATA_SET_OPTION_ALL_DOMAINS);
#line 3755 "../src/Photo.vala"
		_g_free0 (_tmp36_);
#line 3756 "../src/Photo.vala"
		_tmp37_ = metadata;
#line 3756 "../src/Photo.vala"
		_tmp38_ = media_source_get_comment (G_TYPE_CHECK_INSTANCE_CAST (self, TYPE_MEDIA_SOURCE, MediaSource));
#line 3756 "../src/Photo.vala"
		_tmp39_ = _tmp38_;
#line 3756 "../src/Photo.vala"
		photo_metadata_set_comment (_tmp37_, _tmp39_, PHOTO_METADATA_SET_OPTION_ALL_DOMAINS);
#line 3756 "../src/Photo.vala"
		_g_free0 (_tmp39_);
#line 3757 "../src/Photo.vala"
		_tmp40_ = metadata;
#line 3757 "../src/Photo.vala"
		photo_metadata_set_software (_tmp40_, RESOURCES_APP_TITLE, RESOURCES_APP_VERSION);
#line 3759 "../src/Photo.vala"
		_tmp41_ = media_source_get_exposure_time (G_TYPE_CHECK_INSTANCE_CAST (self, TYPE_MEDIA_SOURCE, MediaSource));
#line 3759 "../src/Photo.vala"
		_tmp42_ = _tmp41_;
#line 3759 "../src/Photo.vala"
		_tmp43_ = _tmp42_ != NULL;
#line 3759 "../src/Photo.vala"
		_g_date_time_unref0 (_tmp42_);
#line 3759 "../src/Photo.vala"
		if (_tmp43_) {
#line 26836 "Photo.c"
			PhotoMetadata* _tmp44_;
			GDateTime* _tmp45_;
			GDateTime* _tmp46_;
			MetadataDateTime* _tmp47_;
			MetadataDateTime* _tmp48_;
#line 3760 "../src/Photo.vala"
			_tmp44_ = metadata;
#line 3760 "../src/Photo.vala"
			_tmp45_ = media_source_get_exposure_time (G_TYPE_CHECK_INSTANCE_CAST (self, TYPE_MEDIA_SOURCE, MediaSource));
#line 3760 "../src/Photo.vala"
			_tmp46_ = _tmp45_;
#line 3760 "../src/Photo.vala"
			_tmp47_ = metadata_date_time_new (_tmp46_);
#line 3760 "../src/Photo.vala"
			_tmp48_ = _tmp47_;
#line 3760 "../src/Photo.vala"
			photo_metadata_set_exposure_date_time (_tmp44_, _tmp48_, PHOTO_METADATA_SET_OPTION_ALL_DOMAINS);
#line 3760 "../src/Photo.vala"
			_metadata_date_time_unref0 (_tmp48_);
#line 3760 "../src/Photo.vala"
			_g_date_time_unref0 (_tmp46_);
#line 26858 "Photo.c"
		} else {
			PhotoMetadata* _tmp49_;
#line 3762 "../src/Photo.vala"
			_tmp49_ = metadata;
#line 3762 "../src/Photo.vala"
			photo_metadata_set_exposure_date_time (_tmp49_, NULL, PHOTO_METADATA_SET_OPTION_ALL_DOMAINS);
#line 26865 "Photo.c"
		}
#line 3764 "../src/Photo.vala"
		_tmp50_ = metadata;
#line 3764 "../src/Photo.vala"
		photo_metadata_remove_tag (_tmp50_, "Exif.Iop.RelatedImageWidth");
#line 3765 "../src/Photo.vala"
		_tmp51_ = metadata;
#line 3765 "../src/Photo.vala"
		photo_metadata_remove_tag (_tmp51_, "Exif.Iop.RelatedImageHeight");
#line 3766 "../src/Photo.vala"
		_tmp52_ = metadata;
#line 3766 "../src/Photo.vala"
		photo_metadata_remove_exif_thumbnail (_tmp52_);
#line 3768 "../src/Photo.vala"
		if (photo_has_user_generated_metadata (self)) {
#line 26881 "Photo.c"
			PhotoMetadata* _tmp53_;
#line 3769 "../src/Photo.vala"
			_tmp53_ = metadata;
#line 3769 "../src/Photo.vala"
			photo_set_user_metadata_for_export (self, _tmp53_);
#line 26887 "Photo.c"
		}
	} else {
		PhotoMetadata* _tmp54_;
#line 3773 "../src/Photo.vala"
		_tmp54_ = metadata;
#line 3773 "../src/Photo.vala"
		photo_metadata_clear (_tmp54_);
#line 26895 "Photo.c"
	}
#line 3780 "../src/Photo.vala"
	if (photo_get_file_format (self) == PHOTO_FILE_FORMAT_JFIF) {
#line 3780 "../src/Photo.vala"
		_tmp55_ = TRUE;
#line 26901 "Photo.c"
	} else {
#line 3781 "../src/Photo.vala"
		_tmp55_ = photo_get_file_format (self) == PHOTO_FILE_FORMAT_RAW;
#line 26905 "Photo.c"
	}
#line 3780 "../src/Photo.vala"
	if (_tmp55_) {
#line 26909 "Photo.c"
		PhotoMetadata* _tmp56_;
		Dimensions _tmp57_ = {0};
		PhotoMetadata* _tmp58_;
#line 3782 "../src/Photo.vala"
		_tmp56_ = metadata;
#line 3782 "../src/Photo.vala"
		media_source_get_dimensions (G_TYPE_CHECK_INSTANCE_CAST (self, TYPE_MEDIA_SOURCE, MediaSource), PHOTO_EXCEPTION_ORIENTATION, &_tmp57_);
#line 3782 "../src/Photo.vala"
		photo_metadata_set_pixel_dimensions (_tmp56_, &_tmp57_, PHOTO_METADATA_SET_OPTION_ALL_DOMAINS);
#line 3783 "../src/Photo.vala"
		_tmp58_ = metadata;
#line 3783 "../src/Photo.vala"
		photo_metadata_set_orientation (_tmp58_, photo_get_orientation (self));
#line 26923 "Photo.c"
	} else {
		PhotoMetadata* _tmp59_;
		GdkPixbuf* _tmp60_;
		Dimensions _tmp61_ = {0};
		PhotoMetadata* _tmp62_;
#line 3786 "../src/Photo.vala"
		_tmp59_ = metadata;
#line 3786 "../src/Photo.vala"
		_tmp60_ = pixbuf;
#line 3786 "../src/Photo.vala"
		dimensions_for_pixbuf (_tmp60_, &_tmp61_);
#line 3786 "../src/Photo.vala"
		photo_metadata_set_pixel_dimensions (_tmp59_, &_tmp61_, PHOTO_METADATA_SET_OPTION_ALL_DOMAINS);
#line 3787 "../src/Photo.vala"
		_tmp62_ = metadata;
#line 3787 "../src/Photo.vala"
		photo_metadata_set_orientation (_tmp62_, ORIENTATION_TOP_LEFT);
#line 26941 "Photo.c"
	}
#line 3790 "../src/Photo.vala"
	_tmp64_ = g_file_get_path (dest_file);
#line 3790 "../src/Photo.vala"
	_tmp65_ = _tmp64_;
#line 3790 "../src/Photo.vala"
	_tmp66_ = photo_file_format_create_metadata_writer (export_format, _tmp65_, &_inner_error0_);
#line 3790 "../src/Photo.vala"
	_tmp67_ = _tmp66_;
#line 3790 "../src/Photo.vala"
	_g_free0 (_tmp65_);
#line 3790 "../src/Photo.vala"
	_tmp63_ = _tmp67_;
#line 3790 "../src/Photo.vala"
	if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 3790 "../src/Photo.vala"
		g_propagate_error (error, _inner_error0_);
#line 3790 "../src/Photo.vala"
		_g_object_unref0 (pixbuf);
#line 3790 "../src/Photo.vala"
		_photo_file_adapter_unref0 (writer);
#line 3790 "../src/Photo.vala"
		_media_metadata_unref0 (metadata);
#line 3790 "../src/Photo.vala"
		return;
#line 26967 "Photo.c"
	}
#line 3790 "../src/Photo.vala"
	_tmp68_ = metadata;
#line 3790 "../src/Photo.vala"
	photo_file_metadata_writer_write_metadata (_tmp63_, _tmp68_, &_inner_error0_);
#line 3790 "../src/Photo.vala"
	if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 3790 "../src/Photo.vala"
		g_propagate_error (error, _inner_error0_);
#line 3790 "../src/Photo.vala"
		_photo_file_adapter_unref0 (_tmp63_);
#line 3790 "../src/Photo.vala"
		_g_object_unref0 (pixbuf);
#line 3790 "../src/Photo.vala"
		_photo_file_adapter_unref0 (writer);
#line 3790 "../src/Photo.vala"
		_media_metadata_unref0 (metadata);
#line 3790 "../src/Photo.vala"
		return;
#line 26987 "Photo.c"
	}
#line 3701 "../src/Photo.vala"
	_photo_file_adapter_unref0 (_tmp63_);
#line 3701 "../src/Photo.vala"
	_g_object_unref0 (pixbuf);
#line 3701 "../src/Photo.vala"
	_photo_file_adapter_unref0 (writer);
#line 3701 "../src/Photo.vala"
	_media_metadata_unref0 (metadata);
#line 26997 "Photo.c"
}

static GFile*
photo_generate_new_editable_file (Photo* self,
                                  PhotoFileFormat* file_format,
                                  GError** error)
{
	PhotoFileFormat _vala_file_format = 0;
	GFile* backing = NULL;
	gchar* name = NULL;
	gchar* ext = NULL;
	gchar* _tmp3_;
	gchar* _tmp4_;
	gchar* _tmp5_ = NULL;
	gchar* _tmp6_ = NULL;
	gboolean _tmp7_ = FALSE;
	const gchar* _tmp8_;
	gchar* editable_basename = NULL;
	const gchar* _tmp15_;
	const gchar* _tmp16_;
	gchar* _tmp17_;
	gboolean collision = FALSE;
	GFile* _tmp18_ = NULL;
	GFile* _tmp19_;
	GFile* _tmp20_;
	gboolean _tmp21_ = FALSE;
	GFile* _tmp22_;
	GFile* _tmp23_;
	GFile* _tmp24_;
	GError* _inner_error0_ = NULL;
	GFile* result;
#line 3793 "../src/Photo.vala"
	g_return_val_if_fail (IS_PHOTO (self), NULL);
#line 27031 "Photo.c"
	{
		PhotoRow* _tmp0_;
#line 3795 "../src/Photo.vala"
		_tmp0_ = self->row;
#line 3795 "../src/Photo.vala"
		g_rec_mutex_lock (&self->priv->__lock_row);
#line 27038 "Photo.c"
		{
			GFile* _tmp1_;
#line 3796 "../src/Photo.vala"
			_vala_file_format = photo_get_file_format (self);
#line 3797 "../src/Photo.vala"
			_tmp1_ = media_source_get_file (G_TYPE_CHECK_INSTANCE_CAST (self, TYPE_MEDIA_SOURCE, MediaSource));
#line 3797 "../src/Photo.vala"
			_g_object_unref0 (backing);
#line 3797 "../src/Photo.vala"
			backing = _tmp1_;
#line 27049 "Photo.c"
		}
		__finally0:
		{
			PhotoRow* _tmp2_;
#line 3795 "../src/Photo.vala"
			_tmp2_ = self->row;
#line 3795 "../src/Photo.vala"
			g_rec_mutex_unlock (&self->priv->__lock_row);
#line 27058 "Photo.c"
		}
#line 3795 "../src/Photo.vala"
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 3795 "../src/Photo.vala"
			g_propagate_error (error, _inner_error0_);
#line 3795 "../src/Photo.vala"
			_g_object_unref0 (backing);
#line 3795 "../src/Photo.vala"
			return NULL;
#line 27068 "Photo.c"
		}
	}
#line 3800 "../src/Photo.vala"
	if (!photo_file_format_can_write (_vala_file_format)) {
#line 3801 "../src/Photo.vala"
		_vala_file_format = photo_file_format_get_system_default_format ();
#line 27075 "Photo.c"
	}
#line 3804 "../src/Photo.vala"
	_tmp3_ = g_file_get_basename (backing);
#line 3804 "../src/Photo.vala"
	_tmp4_ = _tmp3_;
#line 3804 "../src/Photo.vala"
	disassemble_filename (_tmp4_, &_tmp5_, &_tmp6_);
#line 3804 "../src/Photo.vala"
	_g_free0 (name);
#line 3804 "../src/Photo.vala"
	name = _tmp5_;
#line 3804 "../src/Photo.vala"
	_g_free0 (ext);
#line 3804 "../src/Photo.vala"
	ext = _tmp6_;
#line 3804 "../src/Photo.vala"
	_g_free0 (_tmp4_);
#line 3806 "../src/Photo.vala"
	_tmp8_ = ext;
#line 3806 "../src/Photo.vala"
	if (_tmp8_ == NULL) {
#line 3806 "../src/Photo.vala"
		_tmp7_ = TRUE;
#line 27099 "Photo.c"
	} else {
		PhotoFileFormatProperties* _tmp9_;
		PhotoFileFormatProperties* _tmp10_;
		const gchar* _tmp11_;
#line 3806 "../src/Photo.vala"
		_tmp9_ = photo_file_format_get_properties (_vala_file_format);
#line 3806 "../src/Photo.vala"
		_tmp10_ = _tmp9_;
#line 3806 "../src/Photo.vala"
		_tmp11_ = ext;
#line 3806 "../src/Photo.vala"
		_tmp7_ = !photo_file_format_properties_is_recognized_extension (_tmp10_, _tmp11_);
#line 3806 "../src/Photo.vala"
		_photo_file_format_properties_unref0 (_tmp10_);
#line 27114 "Photo.c"
	}
#line 3806 "../src/Photo.vala"
	if (_tmp7_) {
#line 27118 "Photo.c"
		PhotoFileFormatProperties* _tmp12_;
		PhotoFileFormatProperties* _tmp13_;
		gchar* _tmp14_;
#line 3807 "../src/Photo.vala"
		_tmp12_ = photo_file_format_get_properties (_vala_file_format);
#line 3807 "../src/Photo.vala"
		_tmp13_ = _tmp12_;
#line 3807 "../src/Photo.vala"
		_tmp14_ = photo_file_format_properties_get_default_extension (_tmp13_);
#line 3807 "../src/Photo.vala"
		_g_free0 (ext);
#line 3807 "../src/Photo.vala"
		ext = _tmp14_;
#line 3807 "../src/Photo.vala"
		_photo_file_format_properties_unref0 (_tmp13_);
#line 27134 "Photo.c"
	}
#line 3810 "../src/Photo.vala"
	_tmp15_ = name;
#line 3810 "../src/Photo.vala"
	_tmp16_ = ext;
#line 3810 "../src/Photo.vala"
	_tmp17_ = g_strdup_printf ("%s_%s.%s", _tmp15_, _ ("modified"), _tmp16_);
#line 3810 "../src/Photo.vala"
	editable_basename = _tmp17_;
#line 3813 "../src/Photo.vala"
	_tmp19_ = g_file_get_parent (backing);
#line 3813 "../src/Photo.vala"
	_tmp20_ = _tmp19_;
#line 3813 "../src/Photo.vala"
	_tmp22_ = generate_unique_file (_tmp20_, editable_basename, &_tmp21_, NULL, &_inner_error0_);
#line 3813 "../src/Photo.vala"
	collision = _tmp21_;
#line 3813 "../src/Photo.vala"
	_tmp23_ = _tmp22_;
#line 3813 "../src/Photo.vala"
	_g_object_unref0 (_tmp20_);
#line 3813 "../src/Photo.vala"
	_tmp18_ = _tmp23_;
#line 3813 "../src/Photo.vala"
	if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 3813 "../src/Photo.vala"
		g_propagate_error (error, _inner_error0_);
#line 3813 "../src/Photo.vala"
		_g_free0 (editable_basename);
#line 3813 "../src/Photo.vala"
		_g_free0 (ext);
#line 3813 "../src/Photo.vala"
		_g_free0 (name);
#line 3813 "../src/Photo.vala"
		_g_object_unref0 (backing);
#line 3813 "../src/Photo.vala"
		return NULL;
#line 27172 "Photo.c"
	}
#line 3813 "../src/Photo.vala"
	_tmp24_ = _tmp18_;
#line 3813 "../src/Photo.vala"
	_tmp18_ = NULL;
#line 3813 "../src/Photo.vala"
	result = _tmp24_;
#line 3813 "../src/Photo.vala"
	_g_object_unref0 (_tmp18_);
#line 3813 "../src/Photo.vala"
	_g_free0 (editable_basename);
#line 3813 "../src/Photo.vala"
	_g_free0 (ext);
#line 3813 "../src/Photo.vala"
	_g_free0 (name);
#line 3813 "../src/Photo.vala"
	_g_object_unref0 (backing);
#line 3813 "../src/Photo.vala"
	if (file_format) {
#line 3813 "../src/Photo.vala"
		*file_format = _vala_file_format;
#line 27194 "Photo.c"
	}
#line 3813 "../src/Photo.vala"
	return result;
#line 27198 "Photo.c"
}

static void
_g_object_unref0_ (gpointer var)
{
#line 3835 "../src/Photo.vala"
	(var == NULL) ? NULL : (var = (g_object_unref (var), NULL));
#line 27206 "Photo.c"
}

static inline void
_g_list_free__g_object_unref0_ (GList* self)
{
#line 3835 "../src/Photo.vala"
	g_list_free_full (self, (GDestroyNotify) _g_object_unref0_);
#line 27214 "Photo.c"
}

static gboolean
photo_launch_editor (GFile* file,
                     PhotoFileFormat file_format,
                     GError** error)
{
	gchar* _tmp0_ = NULL;
	gchar* commandline = NULL;
	gchar* _tmp7_;
	const gchar* _tmp8_;
	GAppInfo* app = NULL;
	GList* files = NULL;
	GFile* _tmp14_;
	GAppInfo* _tmp15_;
	gchar** argv = NULL;
	gchar** _tmp20_;
	gint argv_length1;
	gint _argv_size_;
	gchar** _tmp21_;
	gint _tmp21__length1;
	const gchar* _tmp22_;
	gchar* _tmp23_;
	gchar** _tmp24_;
	gint _tmp24__length1;
	gchar* _tmp25_;
	GPid child_pid = 0;
	gboolean _tmp26_ = FALSE;
	gchar** _tmp27_;
	gint _tmp27__length1;
	GPid _tmp28_ = 0;
	gboolean _tmp29_;
	GError* _inner_error0_ = NULL;
	gboolean result;
#line 3816 "../src/Photo.vala"
	g_return_val_if_fail (G_TYPE_CHECK_INSTANCE_TYPE (file, g_file_get_type ()), FALSE);
#line 3817 "../src/Photo.vala"
	if (file_format == PHOTO_FILE_FORMAT_RAW) {
#line 27253 "Photo.c"
		ConfigFacade* _tmp1_;
		ConfigFacade* _tmp2_;
		gchar* _tmp3_;
#line 3817 "../src/Photo.vala"
		_tmp1_ = config_facade_get_instance ();
#line 3817 "../src/Photo.vala"
		_tmp2_ = _tmp1_;
#line 3817 "../src/Photo.vala"
		_tmp3_ = configuration_facade_get_external_raw_app (G_TYPE_CHECK_INSTANCE_CAST (_tmp2_, TYPE_CONFIGURATION_FACADE, ConfigurationFacade));
#line 3817 "../src/Photo.vala"
		_g_free0 (_tmp0_);
#line 3817 "../src/Photo.vala"
		_tmp0_ = _tmp3_;
#line 3817 "../src/Photo.vala"
		_g_object_unref0 (_tmp2_);
#line 27269 "Photo.c"
	} else {
		ConfigFacade* _tmp4_;
		ConfigFacade* _tmp5_;
		gchar* _tmp6_;
#line 3818 "../src/Photo.vala"
		_tmp4_ = config_facade_get_instance ();
#line 3818 "../src/Photo.vala"
		_tmp5_ = _tmp4_;
#line 3818 "../src/Photo.vala"
		_tmp6_ = configuration_facade_get_external_photo_app (G_TYPE_CHECK_INSTANCE_CAST (_tmp5_, TYPE_CONFIGURATION_FACADE, ConfigurationFacade));
#line 3818 "../src/Photo.vala"
		_g_free0 (_tmp0_);
#line 3818 "../src/Photo.vala"
		_tmp0_ = _tmp6_;
#line 3818 "../src/Photo.vala"
		_g_object_unref0 (_tmp5_);
#line 27286 "Photo.c"
	}
#line 3817 "../src/Photo.vala"
	_tmp7_ = g_strdup (_tmp0_);
#line 3817 "../src/Photo.vala"
	commandline = _tmp7_;
#line 3820 "../src/Photo.vala"
	_tmp8_ = commandline;
#line 3820 "../src/Photo.vala"
	if (is_string_empty (_tmp8_)) {
#line 3821 "../src/Photo.vala"
		result = FALSE;
#line 3821 "../src/Photo.vala"
		_g_free0 (commandline);
#line 3821 "../src/Photo.vala"
		_g_free0 (_tmp0_);
#line 3821 "../src/Photo.vala"
		return result;
#line 27304 "Photo.c"
	}
	{
		GAppInfo* _tmp9_ = NULL;
		const gchar* _tmp10_;
		GAppInfo* _tmp11_;
		GAppInfo* _tmp12_;
#line 3825 "../src/Photo.vala"
		_tmp10_ = commandline;
#line 3825 "../src/Photo.vala"
		_tmp11_ = g_app_info_create_from_commandline (_tmp10_, "", G_APP_INFO_CREATE_NONE, &_inner_error0_);
#line 3825 "../src/Photo.vala"
		_tmp9_ = _tmp11_;
#line 3825 "../src/Photo.vala"
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 27319 "Photo.c"
			goto __catch0_g_error;
		}
#line 3825 "../src/Photo.vala"
		_tmp12_ = _tmp9_;
#line 3825 "../src/Photo.vala"
		_tmp9_ = NULL;
#line 3825 "../src/Photo.vala"
		_g_object_unref0 (app);
#line 3825 "../src/Photo.vala"
		app = _tmp12_;
#line 3824 "../src/Photo.vala"
		_g_object_unref0 (_tmp9_);
#line 27332 "Photo.c"
	}
	goto __finally0;
	__catch0_g_error:
	{
#line 3824 "../src/Photo.vala"
		g_clear_error (&_inner_error0_);
#line 3828 "../src/Photo.vala"
		_g_object_unref0 (app);
#line 3828 "../src/Photo.vala"
		app = NULL;
#line 27343 "Photo.c"
	}
	__finally0:
#line 3824 "../src/Photo.vala"
	if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 27348 "Photo.c"
		gboolean _tmp13_ = FALSE;
#line 3824 "../src/Photo.vala"
		g_propagate_error (error, _inner_error0_);
#line 3824 "../src/Photo.vala"
		_g_object_unref0 (app);
#line 3824 "../src/Photo.vala"
		_g_free0 (commandline);
#line 3824 "../src/Photo.vala"
		_g_free0 (_tmp0_);
#line 3824 "../src/Photo.vala"
		return _tmp13_;
#line 27360 "Photo.c"
	}
#line 3831 "../src/Photo.vala"
	files = NULL;
#line 3832 "../src/Photo.vala"
	_tmp14_ = _g_object_ref0 (file);
#line 3832 "../src/Photo.vala"
	files = g_list_insert (files, _tmp14_, -1);
#line 3834 "../src/Photo.vala"
	_tmp15_ = app;
#line 3834 "../src/Photo.vala"
	if (_tmp15_ != NULL) {
#line 27372 "Photo.c"
		gboolean _tmp16_ = FALSE;
		GAppInfo* _tmp17_;
		GList* _tmp18_;
#line 3835 "../src/Photo.vala"
		_tmp17_ = app;
#line 3835 "../src/Photo.vala"
		_tmp18_ = files;
#line 3835 "../src/Photo.vala"
		_tmp16_ = g_app_info_launch (_tmp17_, _tmp18_, NULL, &_inner_error0_);
#line 3835 "../src/Photo.vala"
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 27384 "Photo.c"
			gboolean _tmp19_ = FALSE;
#line 3835 "../src/Photo.vala"
			g_propagate_error (error, _inner_error0_);
#line 3835 "../src/Photo.vala"
			(files == NULL) ? NULL : (files = (_g_list_free__g_object_unref0_ (files), NULL));
#line 3835 "../src/Photo.vala"
			_g_object_unref0 (app);
#line 3835 "../src/Photo.vala"
			_g_free0 (commandline);
#line 3835 "../src/Photo.vala"
			_g_free0 (_tmp0_);
#line 3835 "../src/Photo.vala"
			return _tmp19_;
#line 27398 "Photo.c"
		}
#line 3835 "../src/Photo.vala"
		result = _tmp16_;
#line 3835 "../src/Photo.vala"
		(files == NULL) ? NULL : (files = (_g_list_free__g_object_unref0_ (files), NULL));
#line 3835 "../src/Photo.vala"
		_g_object_unref0 (app);
#line 3835 "../src/Photo.vala"
		_g_free0 (commandline);
#line 3835 "../src/Photo.vala"
		_g_free0 (_tmp0_);
#line 3835 "../src/Photo.vala"
		return result;
#line 27412 "Photo.c"
	}
#line 3837 "../src/Photo.vala"
	_tmp20_ = g_new0 (gchar*, 2 + 1);
#line 3837 "../src/Photo.vala"
	argv = _tmp20_;
#line 3837 "../src/Photo.vala"
	argv_length1 = 2;
#line 3837 "../src/Photo.vala"
	_argv_size_ = argv_length1;
#line 3838 "../src/Photo.vala"
	_tmp21_ = argv;
#line 3838 "../src/Photo.vala"
	_tmp21__length1 = argv_length1;
#line 3838 "../src/Photo.vala"
	_tmp22_ = commandline;
#line 3838 "../src/Photo.vala"
	_tmp23_ = g_strdup (_tmp22_);
#line 3838 "../src/Photo.vala"
	_g_free0 (_tmp21_[0]);
#line 3838 "../src/Photo.vala"
	_tmp21_[0] = _tmp23_;
#line 3839 "../src/Photo.vala"
	_tmp24_ = argv;
#line 3839 "../src/Photo.vala"
	_tmp24__length1 = argv_length1;
#line 3839 "../src/Photo.vala"
	_tmp25_ = g_file_get_path (file);
#line 3839 "../src/Photo.vala"
	_g_free0 (_tmp24_[1]);
#line 3839 "../src/Photo.vala"
	_tmp24_[1] = _tmp25_;
#line 3843 "../src/Photo.vala"
	_tmp27_ = argv;
#line 3843 "../src/Photo.vala"
	_tmp27__length1 = argv_length1;
#line 3843 "../src/Photo.vala"
	_tmp29_ = g_spawn_async ("/", _tmp27_, NULL, G_SPAWN_SEARCH_PATH, NULL, NULL, &_tmp28_, &_inner_error0_);
#line 3843 "../src/Photo.vala"
	child_pid = _tmp28_;
#line 3843 "../src/Photo.vala"
	_tmp26_ = _tmp29_;
#line 3843 "../src/Photo.vala"
	if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 27456 "Photo.c"
		gboolean _tmp30_ = FALSE;
#line 3843 "../src/Photo.vala"
		g_propagate_error (error, _inner_error0_);
#line 3843 "../src/Photo.vala"
		argv = (_vala_array_free (argv, argv_length1, (GDestroyNotify) g_free), NULL);
#line 3843 "../src/Photo.vala"
		(files == NULL) ? NULL : (files = (_g_list_free__g_object_unref0_ (files), NULL));
#line 3843 "../src/Photo.vala"
		_g_object_unref0 (app);
#line 3843 "../src/Photo.vala"
		_g_free0 (commandline);
#line 3843 "../src/Photo.vala"
		_g_free0 (_tmp0_);
#line 3843 "../src/Photo.vala"
		return _tmp30_;
#line 27472 "Photo.c"
	}
#line 3843 "../src/Photo.vala"
	result = _tmp26_;
#line 3843 "../src/Photo.vala"
	argv = (_vala_array_free (argv, argv_length1, (GDestroyNotify) g_free), NULL);
#line 3843 "../src/Photo.vala"
	(files == NULL) ? NULL : (files = (_g_list_free__g_object_unref0_ (files), NULL));
#line 3843 "../src/Photo.vala"
	_g_object_unref0 (app);
#line 3843 "../src/Photo.vala"
	_g_free0 (commandline);
#line 3843 "../src/Photo.vala"
	_g_free0 (_tmp0_);
#line 3843 "../src/Photo.vala"
	return result;
#line 27488 "Photo.c"
}

void
photo_open_with_raw_external_editor (Photo* self,
                                     GError** error)
{
	GFile* _tmp0_;
	GFile* _tmp1_;
	GError* _inner_error0_ = NULL;
#line 3853 "../src/Photo.vala"
	g_return_if_fail (IS_PHOTO (self));
#line 3854 "../src/Photo.vala"
	_tmp0_ = media_source_get_master_file (G_TYPE_CHECK_INSTANCE_CAST (self, TYPE_MEDIA_SOURCE, MediaSource));
#line 3854 "../src/Photo.vala"
	_tmp1_ = _tmp0_;
#line 3854 "../src/Photo.vala"
	photo_launch_editor (_tmp1_, photo_get_master_file_format (self), &_inner_error0_);
#line 3854 "../src/Photo.vala"
	_g_object_unref0 (_tmp1_);
#line 3854 "../src/Photo.vala"
	if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 3854 "../src/Photo.vala"
		g_propagate_error (error, _inner_error0_);
#line 3854 "../src/Photo.vala"
		return;
#line 27514 "Photo.c"
	}
}

void
photo_open_with_external_editor (Photo* self,
                                 GError** error)
{
	GFile* current_editable_file = NULL;
	GFile* create_editable_file = NULL;
	PhotoFileFormat editable_file_format = 0;
	gboolean _tmp15_ = FALSE;
	gboolean _tmp16_ = FALSE;
	GFile* _tmp17_;
	gboolean _tmp23_ = FALSE;
	GFile* _tmp24_;
	GFile* _tmp38_;
	GFileMonitor* _tmp39_;
	GFile* _tmp41_;
	GError* _inner_error0_ = NULL;
#line 3858 "../src/Photo.vala"
	g_return_if_fail (IS_PHOTO (self));
#line 3859 "../src/Photo.vala"
	current_editable_file = NULL;
#line 3860 "../src/Photo.vala"
	create_editable_file = NULL;
#line 27540 "Photo.c"
	{
		PhotoBackingReaders* _tmp0_;
#line 3862 "../src/Photo.vala"
		_tmp0_ = self->priv->readers;
#line 3862 "../src/Photo.vala"
		g_rec_mutex_lock (&self->priv->__lock_readers);
#line 27547 "Photo.c"
		{
			PhotoBackingReaders* _tmp1_;
			PhotoFileReader* _tmp2_;
			GFile* _tmp6_;
#line 3863 "../src/Photo.vala"
			_tmp1_ = self->priv->readers;
#line 3863 "../src/Photo.vala"
			_tmp2_ = _tmp1_->editable;
#line 3863 "../src/Photo.vala"
			if (_tmp2_ != NULL) {
#line 27558 "Photo.c"
				PhotoBackingReaders* _tmp3_;
				PhotoFileReader* _tmp4_;
				GFile* _tmp5_;
#line 3864 "../src/Photo.vala"
				_tmp3_ = self->priv->readers;
#line 3864 "../src/Photo.vala"
				_tmp4_ = _tmp3_->editable;
#line 3864 "../src/Photo.vala"
				_tmp5_ = photo_file_adapter_get_file (G_TYPE_CHECK_INSTANCE_CAST (_tmp4_, TYPE_PHOTO_FILE_ADAPTER, PhotoFileAdapter));
#line 3864 "../src/Photo.vala"
				_g_object_unref0 (current_editable_file);
#line 3864 "../src/Photo.vala"
				current_editable_file = _tmp5_;
#line 27572 "Photo.c"
			}
#line 3866 "../src/Photo.vala"
			_tmp6_ = current_editable_file;
#line 3866 "../src/Photo.vala"
			if (_tmp6_ == NULL) {
#line 27578 "Photo.c"
				GFile* _tmp7_ = NULL;
				PhotoFileFormat _tmp8_ = 0;
				GFile* _tmp9_;
				GFile* _tmp10_;
#line 3867 "../src/Photo.vala"
				_tmp9_ = photo_generate_new_editable_file (self, &_tmp8_, &_inner_error0_);
#line 3867 "../src/Photo.vala"
				editable_file_format = _tmp8_;
#line 3867 "../src/Photo.vala"
				_tmp7_ = _tmp9_;
#line 3867 "../src/Photo.vala"
				if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 27591 "Photo.c"
					goto __catch0_g_error;
				}
#line 3867 "../src/Photo.vala"
				_tmp10_ = _tmp7_;
#line 3867 "../src/Photo.vala"
				_tmp7_ = NULL;
#line 3867 "../src/Photo.vala"
				_g_object_unref0 (create_editable_file);
#line 3867 "../src/Photo.vala"
				create_editable_file = _tmp10_;
#line 3866 "../src/Photo.vala"
				_g_object_unref0 (_tmp7_);
#line 27604 "Photo.c"
			} else {
				PhotoBackingReaders* _tmp11_;
				PhotoFileReader* _tmp12_;
#line 3869 "../src/Photo.vala"
				_tmp11_ = self->priv->readers;
#line 3869 "../src/Photo.vala"
				_tmp12_ = _tmp11_->editable;
#line 3869 "../src/Photo.vala"
				editable_file_format = photo_file_adapter_get_file_format (G_TYPE_CHECK_INSTANCE_CAST (_tmp12_, TYPE_PHOTO_FILE_ADAPTER, PhotoFileAdapter));
#line 27614 "Photo.c"
			}
		}
		goto __finally0;
		__catch0_g_error:
		{
			GError* _lock_error_ = NULL;
			GError* _tmp13_;
#line 3862 "../src/Photo.vala"
			_lock_error_ = _inner_error0_;
#line 3862 "../src/Photo.vala"
			_inner_error0_ = NULL;
#line 3862 "../src/Photo.vala"
			_tmp13_ = _lock_error_;
#line 3862 "../src/Photo.vala"
			_lock_error_ = NULL;
#line 3862 "../src/Photo.vala"
			_inner_error0_ = _tmp13_;
#line 3862 "../src/Photo.vala"
			_g_error_free0 (_lock_error_);
#line 27634 "Photo.c"
			goto __finally0;
		}
		__finally0:
		{
			GError* _inner_error1_ = NULL;
			PhotoBackingReaders* _tmp14_;
#line 3862 "../src/Photo.vala"
			_tmp14_ = self->priv->readers;
#line 3862 "../src/Photo.vala"
			g_rec_mutex_unlock (&self->priv->__lock_readers);
#line 27645 "Photo.c"
		}
#line 3862 "../src/Photo.vala"
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 3862 "../src/Photo.vala"
			g_propagate_error (error, _inner_error0_);
#line 3862 "../src/Photo.vala"
			_g_object_unref0 (create_editable_file);
#line 3862 "../src/Photo.vala"
			_g_object_unref0 (current_editable_file);
#line 3862 "../src/Photo.vala"
			return;
#line 27657 "Photo.c"
		}
	}
#line 3874 "../src/Photo.vala"
	_tmp17_ = create_editable_file;
#line 3874 "../src/Photo.vala"
	if (_tmp17_ == NULL) {
#line 27664 "Photo.c"
		GFile* _tmp18_;
#line 3874 "../src/Photo.vala"
		_tmp18_ = current_editable_file;
#line 3874 "../src/Photo.vala"
		_tmp16_ = _tmp18_ != NULL;
#line 27670 "Photo.c"
	} else {
#line 3874 "../src/Photo.vala"
		_tmp16_ = FALSE;
#line 27674 "Photo.c"
	}
#line 3874 "../src/Photo.vala"
	if (_tmp16_) {
#line 27678 "Photo.c"
		gboolean _tmp19_ = FALSE;
		GFile* _tmp20_;
#line 3875 "../src/Photo.vala"
		_tmp20_ = current_editable_file;
#line 3875 "../src/Photo.vala"
		if (!g_file_query_exists (_tmp20_, NULL)) {
#line 3875 "../src/Photo.vala"
			_tmp19_ = TRUE;
#line 27687 "Photo.c"
		} else {
#line 3875 "../src/Photo.vala"
			_tmp19_ = photo_has_transformations (self);
#line 27691 "Photo.c"
		}
#line 3875 "../src/Photo.vala"
		_tmp15_ = _tmp19_;
#line 27695 "Photo.c"
	} else {
#line 3874 "../src/Photo.vala"
		_tmp15_ = FALSE;
#line 27699 "Photo.c"
	}
#line 3874 "../src/Photo.vala"
	if (_tmp15_) {
#line 27703 "Photo.c"
		GFile* _tmp21_;
		GFile* _tmp22_;
#line 3876 "../src/Photo.vala"
		_tmp21_ = current_editable_file;
#line 3876 "../src/Photo.vala"
		_tmp22_ = _g_object_ref0 (_tmp21_);
#line 3876 "../src/Photo.vala"
		_g_object_unref0 (create_editable_file);
#line 3876 "../src/Photo.vala"
		create_editable_file = _tmp22_;
#line 27714 "Photo.c"
	}
#line 3879 "../src/Photo.vala"
	_tmp24_ = create_editable_file;
#line 3879 "../src/Photo.vala"
	if (_tmp24_ != NULL) {
#line 3879 "../src/Photo.vala"
		_tmp23_ = photo_file_format_can_write (editable_file_format);
#line 27722 "Photo.c"
	} else {
#line 3879 "../src/Photo.vala"
		_tmp23_ = FALSE;
#line 27726 "Photo.c"
	}
#line 3879 "../src/Photo.vala"
	if (_tmp23_) {
#line 27730 "Photo.c"
		GFile* _tmp35_;
		GFile* _tmp36_;
		GFile* _tmp37_;
#line 3880 "../src/Photo.vala"
		photo_halt_monitoring_editable (self);
#line 27736 "Photo.c"
		{
			GFile* _tmp25_;
			Scaling _tmp26_ = {0};
#line 3883 "../src/Photo.vala"
			_tmp25_ = create_editable_file;
#line 3883 "../src/Photo.vala"
			scaling_for_original (&_tmp26_);
#line 3883 "../src/Photo.vala"
			photo_export (self, _tmp25_, &_tmp26_, JPEG_QUALITY_MAXIMUM, editable_file_format, FALSE, TRUE, &_inner_error0_);
#line 3883 "../src/Photo.vala"
			if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 27748 "Photo.c"
				goto __catch1_g_error;
			}
		}
		goto __finally1;
		__catch1_g_error:
		{
			GError* err = NULL;
			GError* _tmp33_;
			GError* _tmp34_;
#line 3882 "../src/Photo.vala"
			err = _inner_error0_;
#line 3882 "../src/Photo.vala"
			_inner_error0_ = NULL;
#line 27762 "Photo.c"
			{
				GFile* _tmp27_;
#line 3888 "../src/Photo.vala"
				_tmp27_ = create_editable_file;
#line 3888 "../src/Photo.vala"
				g_file_delete (_tmp27_, NULL, &_inner_error0_);
#line 3888 "../src/Photo.vala"
				if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 27771 "Photo.c"
					goto __catch2_g_error;
				}
			}
			goto __finally2;
			__catch2_g_error:
			{
				GError* delete_err = NULL;
				GFile* _tmp28_;
				gchar* _tmp29_;
				gchar* _tmp30_;
				GError* _tmp31_;
				const gchar* _tmp32_;
#line 3887 "../src/Photo.vala"
				delete_err = _inner_error0_;
#line 3887 "../src/Photo.vala"
				_inner_error0_ = NULL;
#line 3891 "../src/Photo.vala"
				_tmp28_ = create_editable_file;
#line 3891 "../src/Photo.vala"
				_tmp29_ = g_file_get_path (_tmp28_);
#line 3891 "../src/Photo.vala"
				_tmp30_ = _tmp29_;
#line 3891 "../src/Photo.vala"
				_tmp31_ = delete_err;
#line 3891 "../src/Photo.vala"
				_tmp32_ = _tmp31_->message;
#line 3891 "../src/Photo.vala"
				g_warning ("Photo.vala:3891: Unable to delete editable file %s after export error:" \
" %s", _tmp30_, _tmp32_);
#line 3891 "../src/Photo.vala"
				_g_free0 (_tmp30_);
#line 3887 "../src/Photo.vala"
				_g_error_free0 (delete_err);
#line 27804 "Photo.c"
			}
			__finally2:
#line 3887 "../src/Photo.vala"
			if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 3887 "../src/Photo.vala"
				_g_error_free0 (err);
#line 3887 "../src/Photo.vala"
				_g_object_unref0 (create_editable_file);
#line 3887 "../src/Photo.vala"
				_g_object_unref0 (current_editable_file);
#line 3887 "../src/Photo.vala"
				g_critical ("file %s: line %d: unexpected error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 3887 "../src/Photo.vala"
				g_clear_error (&_inner_error0_);
#line 3887 "../src/Photo.vala"
				return;
#line 27821 "Photo.c"
			}
#line 3895 "../src/Photo.vala"
			_tmp33_ = err;
#line 3895 "../src/Photo.vala"
			_tmp34_ = _g_error_copy0 (_tmp33_);
#line 3895 "../src/Photo.vala"
			_inner_error0_ = _tmp34_;
#line 3895 "../src/Photo.vala"
			_g_error_free0 (err);
#line 27831 "Photo.c"
			goto __finally1;
		}
		__finally1:
#line 3882 "../src/Photo.vala"
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 3882 "../src/Photo.vala"
			g_propagate_error (error, _inner_error0_);
#line 3882 "../src/Photo.vala"
			_g_object_unref0 (create_editable_file);
#line 3882 "../src/Photo.vala"
			_g_object_unref0 (current_editable_file);
#line 3882 "../src/Photo.vala"
			return;
#line 27845 "Photo.c"
		}
#line 3899 "../src/Photo.vala"
		_tmp35_ = create_editable_file;
#line 3899 "../src/Photo.vala"
		photo_attach_editable (self, editable_file_format, _tmp35_, &_inner_error0_);
#line 3899 "../src/Photo.vala"
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 3899 "../src/Photo.vala"
			g_propagate_error (error, _inner_error0_);
#line 3899 "../src/Photo.vala"
			_g_object_unref0 (create_editable_file);
#line 3899 "../src/Photo.vala"
			_g_object_unref0 (current_editable_file);
#line 3899 "../src/Photo.vala"
			return;
#line 27861 "Photo.c"
		}
#line 3901 "../src/Photo.vala"
		_tmp36_ = create_editable_file;
#line 3901 "../src/Photo.vala"
		_tmp37_ = _g_object_ref0 (_tmp36_);
#line 3901 "../src/Photo.vala"
		_g_object_unref0 (current_editable_file);
#line 3901 "../src/Photo.vala"
		current_editable_file = _tmp37_;
#line 27871 "Photo.c"
	}
#line 3904 "../src/Photo.vala"
	_tmp38_ = current_editable_file;
#line 3904 "../src/Photo.vala"
	_vala_assert (_tmp38_ != NULL, "current_editable_file != null");
#line 3907 "../src/Photo.vala"
	_tmp39_ = self->priv->editable_monitor;
#line 3907 "../src/Photo.vala"
	if (_tmp39_ == NULL) {
#line 27881 "Photo.c"
		GFile* _tmp40_;
#line 3908 "../src/Photo.vala"
		_tmp40_ = current_editable_file;
#line 3908 "../src/Photo.vala"
		photo_start_monitoring_editable (self, _tmp40_, &_inner_error0_);
#line 3908 "../src/Photo.vala"
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 3908 "../src/Photo.vala"
			g_propagate_error (error, _inner_error0_);
#line 3908 "../src/Photo.vala"
			_g_object_unref0 (create_editable_file);
#line 3908 "../src/Photo.vala"
			_g_object_unref0 (current_editable_file);
#line 3908 "../src/Photo.vala"
			return;
#line 27897 "Photo.c"
		}
	}
#line 3910 "../src/Photo.vala"
	_tmp41_ = current_editable_file;
#line 3910 "../src/Photo.vala"
	photo_launch_editor (_tmp41_, photo_get_file_format (self), &_inner_error0_);
#line 3910 "../src/Photo.vala"
	if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 3910 "../src/Photo.vala"
		g_propagate_error (error, _inner_error0_);
#line 3910 "../src/Photo.vala"
		_g_object_unref0 (create_editable_file);
#line 3910 "../src/Photo.vala"
		_g_object_unref0 (current_editable_file);
#line 3910 "../src/Photo.vala"
		return;
#line 27914 "Photo.c"
	}
#line 3858 "../src/Photo.vala"
	_g_object_unref0 (create_editable_file);
#line 3858 "../src/Photo.vala"
	_g_object_unref0 (current_editable_file);
#line 27920 "Photo.c"
}

void
photo_revert_to_master (Photo* self,
                        gboolean notify)
{
#line 3913 "../src/Photo.vala"
	g_return_if_fail (IS_PHOTO (self));
#line 3914 "../src/Photo.vala"
	photo_detach_editable (self, TRUE, TRUE, notify);
#line 27931 "Photo.c"
}

static void
_photo_on_editable_file_changed_g_file_monitor_changed (GFileMonitor* _sender,
                                                        GFile* file,
                                                        GFile* other_file,
                                                        GFileMonitorEvent event_type,
                                                        gpointer self)
{
#line 3924 "../src/Photo.vala"
	photo_on_editable_file_changed ((Photo*) self, file, other_file, event_type);
#line 27943 "Photo.c"
}

static void
photo_start_monitoring_editable (Photo* self,
                                 GFile* file,
                                 GError** error)
{
	GFileMonitor* _tmp0_ = NULL;
	GFileMonitor* _tmp1_;
	GFileMonitor* _tmp2_;
	GFileMonitor* _tmp3_;
	GError* _inner_error0_ = NULL;
#line 3917 "../src/Photo.vala"
	g_return_if_fail (IS_PHOTO (self));
#line 3917 "../src/Photo.vala"
	g_return_if_fail (G_TYPE_CHECK_INSTANCE_TYPE (file, g_file_get_type ()));
#line 3918 "../src/Photo.vala"
	photo_halt_monitoring_editable (self);
#line 3921 "../src/Photo.vala"
	library_monitor_blacklist_file (file, "Photo.start_monitoring_editable");
#line 3923 "../src/Photo.vala"
	_tmp1_ = g_file_monitor (file, G_FILE_MONITOR_NONE, NULL, &_inner_error0_);
#line 3923 "../src/Photo.vala"
	_tmp0_ = _tmp1_;
#line 3923 "../src/Photo.vala"
	if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 3923 "../src/Photo.vala"
		g_propagate_error (error, _inner_error0_);
#line 3923 "../src/Photo.vala"
		return;
#line 27974 "Photo.c"
	}
#line 3923 "../src/Photo.vala"
	_tmp2_ = _tmp0_;
#line 3923 "../src/Photo.vala"
	_tmp0_ = NULL;
#line 3923 "../src/Photo.vala"
	_g_object_unref0 (self->priv->editable_monitor);
#line 3923 "../src/Photo.vala"
	self->priv->editable_monitor = _tmp2_;
#line 3924 "../src/Photo.vala"
	_tmp3_ = self->priv->editable_monitor;
#line 3924 "../src/Photo.vala"
	g_signal_connect_object (_tmp3_, "changed", (GCallback) _photo_on_editable_file_changed_g_file_monitor_changed, self, 0);
#line 3917 "../src/Photo.vala"
	_g_object_unref0 (_tmp0_);
#line 27990 "Photo.c"
}

static void
photo_halt_monitoring_editable (Photo* self)
{
	GFileMonitor* _tmp0_;
	GFile* file = NULL;
	GFile* _tmp1_;
	GFile* _tmp2_;
	GFileMonitor* _tmp4_;
	guint _tmp5_;
	GFileMonitor* _tmp6_;
#line 3927 "../src/Photo.vala"
	g_return_if_fail (IS_PHOTO (self));
#line 3928 "../src/Photo.vala"
	_tmp0_ = self->priv->editable_monitor;
#line 3928 "../src/Photo.vala"
	if (_tmp0_ == NULL) {
#line 3929 "../src/Photo.vala"
		return;
#line 28011 "Photo.c"
	}
#line 3932 "../src/Photo.vala"
	_tmp1_ = photo_get_editable_file (self);
#line 3932 "../src/Photo.vala"
	file = _tmp1_;
#line 3933 "../src/Photo.vala"
	_tmp2_ = file;
#line 3933 "../src/Photo.vala"
	if (_tmp2_ != NULL) {
#line 28021 "Photo.c"
		GFile* _tmp3_;
#line 3934 "../src/Photo.vala"
		_tmp3_ = file;
#line 3934 "../src/Photo.vala"
		library_monitor_unblacklist_file (_tmp3_);
#line 28027 "Photo.c"
	}
#line 3936 "../src/Photo.vala"
	_tmp4_ = self->priv->editable_monitor;
#line 3936 "../src/Photo.vala"
	g_signal_parse_name ("changed", g_file_monitor_get_type (), &_tmp5_, NULL, FALSE);
#line 3936 "../src/Photo.vala"
	g_signal_handlers_disconnect_matched (_tmp4_, G_SIGNAL_MATCH_ID | G_SIGNAL_MATCH_FUNC | G_SIGNAL_MATCH_DATA, _tmp5_, 0, NULL, (GCallback) _photo_on_editable_file_changed_g_file_monitor_changed, self);
#line 3937 "../src/Photo.vala"
	_tmp6_ = self->priv->editable_monitor;
#line 3937 "../src/Photo.vala"
	g_file_monitor_cancel (_tmp6_);
#line 3938 "../src/Photo.vala"
	_g_object_unref0 (self->priv->editable_monitor);
#line 3938 "../src/Photo.vala"
	self->priv->editable_monitor = NULL;
#line 3927 "../src/Photo.vala"
	_g_object_unref0 (file);
#line 28045 "Photo.c"
}

static void
photo_attach_editable (Photo* self,
                       PhotoFileFormat file_format,
                       GFile* file,
                       GError** error)
{
	gchar* _tmp0_;
	gchar* _tmp1_;
	PhotoFileReader* _tmp2_;
	PhotoFileReader* _tmp3_;
	GError* _inner_error0_ = NULL;
#line 3941 "../src/Photo.vala"
	g_return_if_fail (IS_PHOTO (self));
#line 3941 "../src/Photo.vala"
	g_return_if_fail (G_TYPE_CHECK_INSTANCE_TYPE (file, g_file_get_type ()));
#line 3946 "../src/Photo.vala"
	photo_remove_all_transformations (self, FALSE);
#line 3947 "../src/Photo.vala"
	_tmp0_ = g_file_get_path (file);
#line 3947 "../src/Photo.vala"
	_tmp1_ = _tmp0_;
#line 3947 "../src/Photo.vala"
	_tmp2_ = photo_file_format_create_reader (file_format, _tmp1_);
#line 3947 "../src/Photo.vala"
	_tmp3_ = _tmp2_;
#line 3947 "../src/Photo.vala"
	photo_update_editable (self, FALSE, _tmp3_, &_inner_error0_);
#line 3947 "../src/Photo.vala"
	_photo_file_adapter_unref0 (_tmp3_);
#line 3947 "../src/Photo.vala"
	_g_free0 (_tmp1_);
#line 3947 "../src/Photo.vala"
	if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 3947 "../src/Photo.vala"
		g_propagate_error (error, _inner_error0_);
#line 3947 "../src/Photo.vala"
		return;
#line 28085 "Photo.c"
	}
}

static void
photo_update_editable_attributes (Photo* self,
                                  GError** error)
{
	GError* _inner_error0_ = NULL;
#line 3950 "../src/Photo.vala"
	g_return_if_fail (IS_PHOTO (self));
#line 3951 "../src/Photo.vala"
	photo_update_editable (self, TRUE, NULL, &_inner_error0_);
#line 3951 "../src/Photo.vala"
	if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 3951 "../src/Photo.vala"
		g_propagate_error (error, _inner_error0_);
#line 3951 "../src/Photo.vala"
		return;
#line 28104 "Photo.c"
	}
}

void
photo_reimport_editable (Photo* self,
                         GError** error)
{
	GError* _inner_error0_ = NULL;
#line 3954 "../src/Photo.vala"
	g_return_if_fail (IS_PHOTO (self));
#line 3955 "../src/Photo.vala"
	photo_update_editable (self, FALSE, NULL, &_inner_error0_);
#line 3955 "../src/Photo.vala"
	if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 3955 "../src/Photo.vala"
		g_propagate_error (error, _inner_error0_);
#line 3955 "../src/Photo.vala"
		return;
#line 28123 "Photo.c"
	}
}

static void
_vala_array_add102 (gchar** * array,
                    gint* length,
                    gint* size,
                    gchar* value)
{
#line 4062 "../src/Photo.vala"
	if ((*length) == (*size)) {
#line 4062 "../src/Photo.vala"
		*size = (*size) ? (2 * (*size)) : 4;
#line 4062 "../src/Photo.vala"
		*array = g_renew (gchar*, *array, (*size) + 1);
#line 28139 "Photo.c"
	}
#line 4062 "../src/Photo.vala"
	(*array)[(*length)++] = value;
#line 4062 "../src/Photo.vala"
	(*array)[*length] = NULL;
#line 28145 "Photo.c"
}

static void
_vala_array_add103 (gchar** * array,
                    gint* length,
                    gint* size,
                    gchar* value)
{
#line 4063 "../src/Photo.vala"
	if ((*length) == (*size)) {
#line 4063 "../src/Photo.vala"
		*size = (*size) ? (2 * (*size)) : 4;
#line 4063 "../src/Photo.vala"
		*array = g_renew (gchar*, *array, (*size) + 1);
#line 28160 "Photo.c"
	}
#line 4063 "../src/Photo.vala"
	(*array)[(*length)++] = value;
#line 4063 "../src/Photo.vala"
	(*array)[*length] = NULL;
#line 28166 "Photo.c"
}

static void
_vala_array_add104 (gchar** * array,
                    gint* length,
                    gint* size,
                    gchar* value)
{
#line 4066 "../src/Photo.vala"
	if ((*length) == (*size)) {
#line 4066 "../src/Photo.vala"
		*size = (*size) ? (2 * (*size)) : 4;
#line 4066 "../src/Photo.vala"
		*array = g_renew (gchar*, *array, (*size) + 1);
#line 28181 "Photo.c"
	}
#line 4066 "../src/Photo.vala"
	(*array)[(*length)++] = value;
#line 4066 "../src/Photo.vala"
	(*array)[*length] = NULL;
#line 28187 "Photo.c"
}

static void
_vala_array_add105 (gchar** * array,
                    gint* length,
                    gint* size,
                    gchar* value)
{
#line 4070 "../src/Photo.vala"
	if ((*length) == (*size)) {
#line 4070 "../src/Photo.vala"
		*size = (*size) ? (2 * (*size)) : 4;
#line 4070 "../src/Photo.vala"
		*array = g_renew (gchar*, *array, (*size) + 1);
#line 28202 "Photo.c"
	}
#line 4070 "../src/Photo.vala"
	(*array)[(*length)++] = value;
#line 4070 "../src/Photo.vala"
	(*array)[*length] = NULL;
#line 28208 "Photo.c"
}

static void
_vala_array_add106 (gchar** * array,
                    gint* length,
                    gint* size,
                    gchar* value)
{
#line 4071 "../src/Photo.vala"
	if ((*length) == (*size)) {
#line 4071 "../src/Photo.vala"
		*size = (*size) ? (2 * (*size)) : 4;
#line 4071 "../src/Photo.vala"
		*array = g_renew (gchar*, *array, (*size) + 1);
#line 28223 "Photo.c"
	}
#line 4071 "../src/Photo.vala"
	(*array)[(*length)++] = value;
#line 4071 "../src/Photo.vala"
	(*array)[*length] = NULL;
#line 28229 "Photo.c"
}

static void
_vala_array_add107 (gchar** * array,
                    gint* length,
                    gint* size,
                    gchar* value)
{
#line 4074 "../src/Photo.vala"
	if ((*length) == (*size)) {
#line 4074 "../src/Photo.vala"
		*size = (*size) ? (2 * (*size)) : 4;
#line 4074 "../src/Photo.vala"
		*array = g_renew (gchar*, *array, (*size) + 1);
#line 28244 "Photo.c"
	}
#line 4074 "../src/Photo.vala"
	(*array)[(*length)++] = value;
#line 4074 "../src/Photo.vala"
	(*array)[*length] = NULL;
#line 28250 "Photo.c"
}

static void
photo_update_editable (Photo* self,
                       gboolean only_attributes,
                       PhotoFileReader* new_reader,
                       GError** error)
{
	gboolean _tmp0_ = FALSE;
	gboolean _tmp1_ = FALSE;
	PhotoFileReader* old_reader = NULL;
	PhotoFileReader* _tmp2_;
	PhotoFileReader* _tmp3_ = NULL;
	PhotoFileReader* reader = NULL;
	PhotoFileReader* _tmp5_;
	PhotoFileReader* _tmp6_;
	gboolean timestamp_changed = FALSE;
	gboolean filesize_changed = FALSE;
	gboolean is_new_editable = FALSE;
	BackingPhotoID editable_id = {0};
	BackingPhotoID _tmp7_ = {0};
	GFile* file = NULL;
	PhotoFileReader* _tmp8_;
	GFile* _tmp9_;
	DetectedPhotoInformation* detected = NULL;
	BackingPhotoRow* backing = NULL;
	GFile* _tmp10_;
	DetectedPhotoInformation* _tmp11_ = NULL;
	BackingPhotoRow* _tmp12_;
	gboolean _tmp83_ = FALSE;
	gchar** alteration_list = NULL;
	gchar** _tmp92_;
	gint alteration_list_length1;
	gint _alteration_list_size_;
	gboolean _tmp96_ = FALSE;
	gchar** _tmp100_;
	gint _tmp100__length1;
	GError* _inner_error0_ = NULL;
#line 3960 "../src/Photo.vala"
	g_return_if_fail (IS_PHOTO (self));
#line 3960 "../src/Photo.vala"
	g_return_if_fail ((new_reader == NULL) || IS_PHOTO_FILE_READER (new_reader));
#line 3962 "../src/Photo.vala"
	if (only_attributes) {
#line 3962 "../src/Photo.vala"
		_tmp1_ = new_reader == NULL;
#line 28297 "Photo.c"
	} else {
#line 3962 "../src/Photo.vala"
		_tmp1_ = FALSE;
#line 28301 "Photo.c"
	}
#line 3962 "../src/Photo.vala"
	if (_tmp1_) {
#line 3962 "../src/Photo.vala"
		_tmp0_ = TRUE;
#line 28307 "Photo.c"
	} else {
#line 3962 "../src/Photo.vala"
		_tmp0_ = !only_attributes;
#line 28311 "Photo.c"
	}
#line 3962 "../src/Photo.vala"
	_vala_assert (_tmp0_, "(only_attributes && new_reader == null) || (!only_attributes)");
#line 3964 "../src/Photo.vala"
	_tmp2_ = photo_get_editable_reader (self);
#line 3964 "../src/Photo.vala"
	old_reader = _tmp2_;
#line 3966 "../src/Photo.vala"
	_tmp3_ = new_reader;
#line 3966 "../src/Photo.vala"
	if (_tmp3_ == NULL) {
#line 28323 "Photo.c"
		PhotoFileReader* _tmp4_;
#line 3966 "../src/Photo.vala"
		_tmp4_ = old_reader;
#line 3966 "../src/Photo.vala"
		_tmp3_ = _tmp4_;
#line 28329 "Photo.c"
	}
#line 3966 "../src/Photo.vala"
	_tmp5_ = _photo_file_adapter_ref0 (_tmp3_);
#line 3966 "../src/Photo.vala"
	reader = _tmp5_;
#line 3967 "../src/Photo.vala"
	_tmp6_ = reader;
#line 3967 "../src/Photo.vala"
	if (_tmp6_ == NULL) {
#line 3968 "../src/Photo.vala"
		photo_detach_editable (self, FALSE, TRUE, TRUE);
#line 3970 "../src/Photo.vala"
		_photo_file_adapter_unref0 (reader);
#line 3970 "../src/Photo.vala"
		_photo_file_adapter_unref0 (old_reader);
#line 3970 "../src/Photo.vala"
		return;
#line 28347 "Photo.c"
	}
#line 3973 "../src/Photo.vala"
	timestamp_changed = FALSE;
#line 3974 "../src/Photo.vala"
	filesize_changed = FALSE;
#line 3975 "../src/Photo.vala"
	is_new_editable = FALSE;
#line 3977 "../src/Photo.vala"
	photo_get_editable_id (self, &_tmp7_);
#line 3977 "../src/Photo.vala"
	editable_id = _tmp7_;
#line 3978 "../src/Photo.vala"
	_tmp8_ = reader;
#line 3978 "../src/Photo.vala"
	_tmp9_ = photo_file_adapter_get_file (G_TYPE_CHECK_INSTANCE_CAST (_tmp8_, TYPE_PHOTO_FILE_ADAPTER, PhotoFileAdapter));
#line 3978 "../src/Photo.vala"
	file = _tmp9_;
#line 3981 "../src/Photo.vala"
	_tmp10_ = file;
#line 3981 "../src/Photo.vala"
	_tmp12_ = photo_query_backing_photo_row (self, _tmp10_, PHOTO_FILE_SNIFFER_OPTIONS_NO_MD5, &_tmp11_, &_inner_error0_);
#line 3981 "../src/Photo.vala"
	_detected_photo_information_unref0 (detected);
#line 3981 "../src/Photo.vala"
	detected = _tmp11_;
#line 3981 "../src/Photo.vala"
	backing = _tmp12_;
#line 3981 "../src/Photo.vala"
	if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 3981 "../src/Photo.vala"
		g_propagate_error (error, _inner_error0_);
#line 3981 "../src/Photo.vala"
		_detected_photo_information_unref0 (detected);
#line 3981 "../src/Photo.vala"
		_g_object_unref0 (file);
#line 3981 "../src/Photo.vala"
		_photo_file_adapter_unref0 (reader);
#line 3981 "../src/Photo.vala"
		_photo_file_adapter_unref0 (old_reader);
#line 3981 "../src/Photo.vala"
		return;
#line 28389 "Photo.c"
	}
#line 3985 "../src/Photo.vala"
	if (backing_photo_id_is_invalid (&editable_id)) {
#line 28393 "Photo.c"
		BackingPhotoRow* _tmp13_;
#line 3987 "../src/Photo.vala"
		_tmp13_ = backing;
#line 3987 "../src/Photo.vala"
		if (_tmp13_ != NULL) {
#line 28399 "Photo.c"
			BackingPhotoTable* _tmp14_;
			BackingPhotoTable* _tmp15_;
			BackingPhotoRow* _tmp16_;
#line 3988 "../src/Photo.vala"
			_tmp14_ = backing_photo_table_get_instance ();
#line 3988 "../src/Photo.vala"
			_tmp15_ = _tmp14_;
#line 3988 "../src/Photo.vala"
			_tmp16_ = backing;
#line 3988 "../src/Photo.vala"
			backing_photo_table_add (_tmp15_, _tmp16_, &_inner_error0_);
#line 3988 "../src/Photo.vala"
			_database_table_unref0 (_tmp15_);
#line 3988 "../src/Photo.vala"
			if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 3988 "../src/Photo.vala"
				g_propagate_error (error, _inner_error0_);
#line 3988 "../src/Photo.vala"
				_backing_photo_row_unref0 (backing);
#line 3988 "../src/Photo.vala"
				_detected_photo_information_unref0 (detected);
#line 3988 "../src/Photo.vala"
				_g_object_unref0 (file);
#line 3988 "../src/Photo.vala"
				_photo_file_adapter_unref0 (reader);
#line 3988 "../src/Photo.vala"
				_photo_file_adapter_unref0 (old_reader);
#line 3988 "../src/Photo.vala"
				return;
#line 28429 "Photo.c"
			}
			{
				PhotoRow* _tmp17_;
#line 3989 "../src/Photo.vala"
				_tmp17_ = self->row;
#line 3989 "../src/Photo.vala"
				g_rec_mutex_lock (&self->priv->__lock_row);
#line 28437 "Photo.c"
				{
					PhotoTable* _tmp18_;
					PhotoTable* _tmp19_;
					PhotoRow* _tmp20_;
					BackingPhotoRow* _tmp21_;
					BackingPhotoID _tmp22_;
					BackingPhotoRow* _tmp23_;
					BackingPhotoRow* _tmp24_;
					BackingPhotoRow* _tmp25_;
					BackingPhotoRow* _tmp26_;
					BackingPhotoRow* _tmp27_;
#line 3990 "../src/Photo.vala"
					timestamp_changed = TRUE;
#line 3991 "../src/Photo.vala"
					filesize_changed = TRUE;
#line 3993 "../src/Photo.vala"
					_tmp18_ = photo_table_get_instance ();
#line 3993 "../src/Photo.vala"
					_tmp19_ = _tmp18_;
#line 3993 "../src/Photo.vala"
					_tmp20_ = self->row;
#line 3993 "../src/Photo.vala"
					_tmp21_ = backing;
#line 3993 "../src/Photo.vala"
					_tmp22_ = _tmp21_->id;
#line 3993 "../src/Photo.vala"
					photo_table_attach_editable (_tmp19_, _tmp20_, &_tmp22_, &_inner_error0_);
#line 3993 "../src/Photo.vala"
					_database_table_unref0 (_tmp19_);
#line 3993 "../src/Photo.vala"
					if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 28469 "Photo.c"
						goto __catch0_g_error;
					}
#line 3994 "../src/Photo.vala"
					_tmp23_ = backing;
#line 3994 "../src/Photo.vala"
					_tmp24_ = _backing_photo_row_ref0 (_tmp23_);
#line 3994 "../src/Photo.vala"
					_backing_photo_row_unref0 (self->priv->editable);
#line 3994 "../src/Photo.vala"
					self->priv->editable = _tmp24_;
#line 3995 "../src/Photo.vala"
					_tmp25_ = self->priv->editable;
#line 3995 "../src/Photo.vala"
					_tmp26_ = _backing_photo_row_ref0 (_tmp25_);
#line 3995 "../src/Photo.vala"
					_backing_photo_row_unref0 (self->backing_photo_row);
#line 3995 "../src/Photo.vala"
					self->backing_photo_row = _tmp26_;
#line 3996 "../src/Photo.vala"
					_tmp27_ = self->backing_photo_row;
#line 3996 "../src/Photo.vala"
					photo_set_orientation (self, _tmp27_->original_orientation);
#line 28492 "Photo.c"
				}
				goto __finally0;
				__catch0_g_error:
				{
					GError* _lock_error_ = NULL;
					GError* _tmp28_;
#line 3989 "../src/Photo.vala"
					_lock_error_ = _inner_error0_;
#line 3989 "../src/Photo.vala"
					_inner_error0_ = NULL;
#line 3989 "../src/Photo.vala"
					_tmp28_ = _lock_error_;
#line 3989 "../src/Photo.vala"
					_lock_error_ = NULL;
#line 3989 "../src/Photo.vala"
					_inner_error0_ = _tmp28_;
#line 3989 "../src/Photo.vala"
					_g_error_free0 (_lock_error_);
#line 28511 "Photo.c"
					goto __finally0;
				}
				__finally0:
				{
					GError* _inner_error1_ = NULL;
					PhotoRow* _tmp29_;
#line 3989 "../src/Photo.vala"
					_tmp29_ = self->row;
#line 3989 "../src/Photo.vala"
					g_rec_mutex_unlock (&self->priv->__lock_row);
#line 28522 "Photo.c"
				}
#line 3989 "../src/Photo.vala"
				if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 3989 "../src/Photo.vala"
					g_propagate_error (error, _inner_error0_);
#line 3989 "../src/Photo.vala"
					_backing_photo_row_unref0 (backing);
#line 3989 "../src/Photo.vala"
					_detected_photo_information_unref0 (detected);
#line 3989 "../src/Photo.vala"
					_g_object_unref0 (file);
#line 3989 "../src/Photo.vala"
					_photo_file_adapter_unref0 (reader);
#line 3989 "../src/Photo.vala"
					_photo_file_adapter_unref0 (old_reader);
#line 3989 "../src/Photo.vala"
					return;
#line 28540 "Photo.c"
				}
			}
		}
#line 3999 "../src/Photo.vala"
		is_new_editable = TRUE;
#line 28546 "Photo.c"
	}
#line 4002 "../src/Photo.vala"
	if (only_attributes) {
#line 28550 "Photo.c"
		GFileInfo* info = NULL;
		GDateTime* timestamp = NULL;
		GFileInfo* _tmp38_;
		GDateTime* _tmp39_;
		GDateTime* _tmp40_;
		GDateTime* _tmp41_;
		GDateTime* _tmp42_;
		BackingPhotoTable* _tmp43_;
		BackingPhotoTable* _tmp44_;
		BackingPhotoID _tmp45_;
		GDateTime* _tmp46_;
		GFileInfo* _tmp47_;
#line 4004 "../src/Photo.vala"
		_vala_assert (backing_photo_id_is_valid (&editable_id), "editable_id.is_valid()");
#line 28565 "Photo.c"
		{
			GFileInfo* _tmp30_ = NULL;
			GFile* _tmp31_;
			GFileInfo* _tmp32_;
			GFileInfo* _tmp33_;
#line 4008 "../src/Photo.vala"
			_tmp31_ = file;
#line 4008 "../src/Photo.vala"
			_tmp32_ = g_file_query_filesystem_info (_tmp31_, DIRECTORY_MONITOR_SUPPLIED_ATTRIBUTES, NULL, &_inner_error0_);
#line 4008 "../src/Photo.vala"
			_tmp30_ = _tmp32_;
#line 4008 "../src/Photo.vala"
			if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 28579 "Photo.c"
				goto __catch1_g_error;
			}
#line 4008 "../src/Photo.vala"
			_tmp33_ = _tmp30_;
#line 4008 "../src/Photo.vala"
			_tmp30_ = NULL;
#line 4008 "../src/Photo.vala"
			_g_object_unref0 (info);
#line 4008 "../src/Photo.vala"
			info = _tmp33_;
#line 4007 "../src/Photo.vala"
			_g_object_unref0 (_tmp30_);
#line 28592 "Photo.c"
		}
		goto __finally1;
		__catch1_g_error:
		{
			GError* err = NULL;
			gchar* _tmp34_;
			gchar* _tmp35_;
			GError* _tmp36_;
			const gchar* _tmp37_;
#line 4007 "../src/Photo.vala"
			err = _inner_error0_;
#line 4007 "../src/Photo.vala"
			_inner_error0_ = NULL;
#line 4010 "../src/Photo.vala"
			_tmp34_ = data_object_to_string (G_TYPE_CHECK_INSTANCE_CAST (self, TYPE_DATA_OBJECT, DataObject));
#line 4010 "../src/Photo.vala"
			_tmp35_ = _tmp34_;
#line 4010 "../src/Photo.vala"
			_tmp36_ = err;
#line 4010 "../src/Photo.vala"
			_tmp37_ = _tmp36_->message;
#line 4010 "../src/Photo.vala"
			g_warning ("Photo.vala:4010: Unable to read editable filesystem info for %s: %s", _tmp35_, _tmp37_);
#line 4010 "../src/Photo.vala"
			_g_free0 (_tmp35_);
#line 4011 "../src/Photo.vala"
			photo_detach_editable (self, FALSE, TRUE, TRUE);
#line 4013 "../src/Photo.vala"
			_g_error_free0 (err);
#line 4013 "../src/Photo.vala"
			_g_object_unref0 (info);
#line 4013 "../src/Photo.vala"
			_backing_photo_row_unref0 (backing);
#line 4013 "../src/Photo.vala"
			_detected_photo_information_unref0 (detected);
#line 4013 "../src/Photo.vala"
			_g_object_unref0 (file);
#line 4013 "../src/Photo.vala"
			_photo_file_adapter_unref0 (reader);
#line 4013 "../src/Photo.vala"
			_photo_file_adapter_unref0 (old_reader);
#line 4013 "../src/Photo.vala"
			return;
#line 28636 "Photo.c"
		}
		__finally1:
#line 4007 "../src/Photo.vala"
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 4007 "../src/Photo.vala"
			g_propagate_error (error, _inner_error0_);
#line 4007 "../src/Photo.vala"
			_g_object_unref0 (info);
#line 4007 "../src/Photo.vala"
			_backing_photo_row_unref0 (backing);
#line 4007 "../src/Photo.vala"
			_detected_photo_information_unref0 (detected);
#line 4007 "../src/Photo.vala"
			_g_object_unref0 (file);
#line 4007 "../src/Photo.vala"
			_photo_file_adapter_unref0 (reader);
#line 4007 "../src/Photo.vala"
			_photo_file_adapter_unref0 (old_reader);
#line 4007 "../src/Photo.vala"
			return;
#line 28657 "Photo.c"
		}
#line 4016 "../src/Photo.vala"
		_tmp38_ = info;
#line 4016 "../src/Photo.vala"
		_tmp39_ = g_file_info_get_modification_date_time (_tmp38_);
#line 4016 "../src/Photo.vala"
		_tmp40_ = _tmp39_;
#line 4016 "../src/Photo.vala"
		_tmp41_ = coarsify_date_time (_tmp40_);
#line 4016 "../src/Photo.vala"
		_tmp42_ = _tmp41_;
#line 4016 "../src/Photo.vala"
		_g_date_time_unref0 (_tmp40_);
#line 4016 "../src/Photo.vala"
		timestamp = _tmp42_;
#line 4018 "../src/Photo.vala"
		_tmp43_ = backing_photo_table_get_instance ();
#line 4018 "../src/Photo.vala"
		_tmp44_ = _tmp43_;
#line 4018 "../src/Photo.vala"
		_tmp45_ = editable_id;
#line 4018 "../src/Photo.vala"
		_tmp46_ = timestamp;
#line 4018 "../src/Photo.vala"
		_tmp47_ = info;
#line 4018 "../src/Photo.vala"
		backing_photo_table_update_attributes (_tmp44_, &_tmp45_, _tmp46_, g_file_info_get_size (_tmp47_), &_inner_error0_);
#line 4018 "../src/Photo.vala"
		_database_table_unref0 (_tmp44_);
#line 4018 "../src/Photo.vala"
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 4018 "../src/Photo.vala"
			g_propagate_error (error, _inner_error0_);
#line 4018 "../src/Photo.vala"
			_g_date_time_unref0 (timestamp);
#line 4018 "../src/Photo.vala"
			_g_object_unref0 (info);
#line 4018 "../src/Photo.vala"
			_backing_photo_row_unref0 (backing);
#line 4018 "../src/Photo.vala"
			_detected_photo_information_unref0 (detected);
#line 4018 "../src/Photo.vala"
			_g_object_unref0 (file);
#line 4018 "../src/Photo.vala"
			_photo_file_adapter_unref0 (reader);
#line 4018 "../src/Photo.vala"
			_photo_file_adapter_unref0 (old_reader);
#line 4018 "../src/Photo.vala"
			return;
#line 28707 "Photo.c"
		}
		{
			PhotoRow* _tmp48_;
#line 4020 "../src/Photo.vala"
			_tmp48_ = self->row;
#line 4020 "../src/Photo.vala"
			g_rec_mutex_lock (&self->priv->__lock_row);
#line 28715 "Photo.c"
			{
				BackingPhotoRow* _tmp49_;
				GDateTime* _tmp50_;
				GDateTime* _tmp51_;
				BackingPhotoRow* _tmp52_;
				GFileInfo* _tmp53_;
				BackingPhotoRow* _tmp54_;
				GDateTime* _tmp55_;
				GDateTime* _tmp56_;
				BackingPhotoRow* _tmp57_;
				GFileInfo* _tmp58_;
#line 4021 "../src/Photo.vala"
				_tmp49_ = self->priv->editable;
#line 4021 "../src/Photo.vala"
				_tmp50_ = _tmp49_->timestamp;
#line 4021 "../src/Photo.vala"
				_tmp51_ = timestamp;
#line 4021 "../src/Photo.vala"
				timestamp_changed = !g_date_time_equal (_tmp50_, _tmp51_);
#line 4022 "../src/Photo.vala"
				_tmp52_ = self->priv->editable;
#line 4022 "../src/Photo.vala"
				_tmp53_ = info;
#line 4022 "../src/Photo.vala"
				filesize_changed = _tmp52_->filesize != g_file_info_get_size (_tmp53_);
#line 4024 "../src/Photo.vala"
				_tmp54_ = self->priv->editable;
#line 4024 "../src/Photo.vala"
				_tmp55_ = timestamp;
#line 4024 "../src/Photo.vala"
				_tmp56_ = _g_date_time_ref0 (_tmp55_);
#line 4024 "../src/Photo.vala"
				_g_date_time_unref0 (_tmp54_->timestamp);
#line 4024 "../src/Photo.vala"
				_tmp54_->timestamp = _tmp56_;
#line 4025 "../src/Photo.vala"
				_tmp57_ = self->priv->editable;
#line 4025 "../src/Photo.vala"
				_tmp58_ = info;
#line 4025 "../src/Photo.vala"
				_tmp57_->filesize = g_file_info_get_size (_tmp58_);
#line 28757 "Photo.c"
			}
			__finally2:
			{
				PhotoRow* _tmp59_;
#line 4020 "../src/Photo.vala"
				_tmp59_ = self->row;
#line 4020 "../src/Photo.vala"
				g_rec_mutex_unlock (&self->priv->__lock_row);
#line 28766 "Photo.c"
			}
#line 4020 "../src/Photo.vala"
			if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 4020 "../src/Photo.vala"
				g_propagate_error (error, _inner_error0_);
#line 4020 "../src/Photo.vala"
				_g_date_time_unref0 (timestamp);
#line 4020 "../src/Photo.vala"
				_g_object_unref0 (info);
#line 4020 "../src/Photo.vala"
				_backing_photo_row_unref0 (backing);
#line 4020 "../src/Photo.vala"
				_detected_photo_information_unref0 (detected);
#line 4020 "../src/Photo.vala"
				_g_object_unref0 (file);
#line 4020 "../src/Photo.vala"
				_photo_file_adapter_unref0 (reader);
#line 4020 "../src/Photo.vala"
				_photo_file_adapter_unref0 (old_reader);
#line 4020 "../src/Photo.vala"
				return;
#line 28788 "Photo.c"
			}
		}
#line 4002 "../src/Photo.vala"
		_g_date_time_unref0 (timestamp);
#line 4002 "../src/Photo.vala"
		_g_object_unref0 (info);
#line 28795 "Photo.c"
	} else {
		gboolean _tmp60_ = FALSE;
#line 4029 "../src/Photo.vala"
		if (backing_photo_id_is_valid (&editable_id)) {
#line 4029 "../src/Photo.vala"
			_tmp60_ = !is_new_editable;
#line 28802 "Photo.c"
		} else {
#line 4029 "../src/Photo.vala"
			_tmp60_ = FALSE;
#line 28806 "Photo.c"
		}
#line 4029 "../src/Photo.vala"
		if (_tmp60_) {
#line 28810 "Photo.c"
			BackingPhotoRow* _tmp61_;
			BackingPhotoID _tmp62_;
			BackingPhotoTable* _tmp63_;
			BackingPhotoTable* _tmp64_;
			BackingPhotoRow* _tmp65_;
#line 4034 "../src/Photo.vala"
			_tmp61_ = backing;
#line 4034 "../src/Photo.vala"
			_tmp62_ = editable_id;
#line 4034 "../src/Photo.vala"
			_tmp61_->id = _tmp62_;
#line 4035 "../src/Photo.vala"
			_tmp63_ = backing_photo_table_get_instance ();
#line 4035 "../src/Photo.vala"
			_tmp64_ = _tmp63_;
#line 4035 "../src/Photo.vala"
			_tmp65_ = backing;
#line 4035 "../src/Photo.vala"
			backing_photo_table_update (_tmp64_, _tmp65_, &_inner_error0_);
#line 4035 "../src/Photo.vala"
			_database_table_unref0 (_tmp64_);
#line 4035 "../src/Photo.vala"
			if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 4035 "../src/Photo.vala"
				g_propagate_error (error, _inner_error0_);
#line 4035 "../src/Photo.vala"
				_backing_photo_row_unref0 (backing);
#line 4035 "../src/Photo.vala"
				_detected_photo_information_unref0 (detected);
#line 4035 "../src/Photo.vala"
				_g_object_unref0 (file);
#line 4035 "../src/Photo.vala"
				_photo_file_adapter_unref0 (reader);
#line 4035 "../src/Photo.vala"
				_photo_file_adapter_unref0 (old_reader);
#line 4035 "../src/Photo.vala"
				return;
#line 28848 "Photo.c"
			}
			{
				PhotoRow* _tmp66_;
#line 4036 "../src/Photo.vala"
				_tmp66_ = self->row;
#line 4036 "../src/Photo.vala"
				g_rec_mutex_lock (&self->priv->__lock_row);
#line 28856 "Photo.c"
				{
					BackingPhotoRow* _tmp67_;
					GDateTime* _tmp68_;
					BackingPhotoRow* _tmp69_;
					GDateTime* _tmp70_;
					BackingPhotoRow* _tmp71_;
					BackingPhotoRow* _tmp72_;
					BackingPhotoRow* _tmp73_;
					BackingPhotoRow* _tmp74_;
					BackingPhotoRow* _tmp75_;
					BackingPhotoRow* _tmp76_;
					BackingPhotoRow* _tmp77_;
#line 4037 "../src/Photo.vala"
					_tmp67_ = self->priv->editable;
#line 4037 "../src/Photo.vala"
					_tmp68_ = _tmp67_->timestamp;
#line 4037 "../src/Photo.vala"
					_tmp69_ = backing;
#line 4037 "../src/Photo.vala"
					_tmp70_ = _tmp69_->timestamp;
#line 4037 "../src/Photo.vala"
					timestamp_changed = _tmp68_ != _tmp70_;
#line 4038 "../src/Photo.vala"
					_tmp71_ = self->priv->editable;
#line 4038 "../src/Photo.vala"
					_tmp72_ = backing;
#line 4038 "../src/Photo.vala"
					filesize_changed = _tmp71_->filesize != _tmp72_->filesize;
#line 4040 "../src/Photo.vala"
					_tmp73_ = backing;
#line 4040 "../src/Photo.vala"
					_tmp74_ = _backing_photo_row_ref0 (_tmp73_);
#line 4040 "../src/Photo.vala"
					_backing_photo_row_unref0 (self->priv->editable);
#line 4040 "../src/Photo.vala"
					self->priv->editable = _tmp74_;
#line 4041 "../src/Photo.vala"
					_tmp75_ = self->priv->editable;
#line 4041 "../src/Photo.vala"
					_tmp76_ = _backing_photo_row_ref0 (_tmp75_);
#line 4041 "../src/Photo.vala"
					_backing_photo_row_unref0 (self->backing_photo_row);
#line 4041 "../src/Photo.vala"
					self->backing_photo_row = _tmp76_;
#line 4042 "../src/Photo.vala"
					_tmp77_ = self->backing_photo_row;
#line 4042 "../src/Photo.vala"
					photo_set_orientation (self, _tmp77_->original_orientation);
#line 28905 "Photo.c"
				}
				__finally3:
				{
					PhotoRow* _tmp78_;
#line 4036 "../src/Photo.vala"
					_tmp78_ = self->row;
#line 4036 "../src/Photo.vala"
					g_rec_mutex_unlock (&self->priv->__lock_row);
#line 28914 "Photo.c"
				}
#line 4036 "../src/Photo.vala"
				if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 4036 "../src/Photo.vala"
					g_propagate_error (error, _inner_error0_);
#line 4036 "../src/Photo.vala"
					_backing_photo_row_unref0 (backing);
#line 4036 "../src/Photo.vala"
					_detected_photo_information_unref0 (detected);
#line 4036 "../src/Photo.vala"
					_g_object_unref0 (file);
#line 4036 "../src/Photo.vala"
					_photo_file_adapter_unref0 (reader);
#line 4036 "../src/Photo.vala"
					_photo_file_adapter_unref0 (old_reader);
#line 4036 "../src/Photo.vala"
					return;
#line 28932 "Photo.c"
				}
			}
		}
	}
#line 4048 "../src/Photo.vala"
	if (new_reader != NULL) {
#line 28939 "Photo.c"
		{
			PhotoBackingReaders* _tmp79_;
#line 4049 "../src/Photo.vala"
			_tmp79_ = self->priv->readers;
#line 4049 "../src/Photo.vala"
			g_rec_mutex_lock (&self->priv->__lock_readers);
#line 28946 "Photo.c"
			{
				PhotoBackingReaders* _tmp80_;
				PhotoFileReader* _tmp81_;
#line 4050 "../src/Photo.vala"
				_tmp80_ = self->priv->readers;
#line 4050 "../src/Photo.vala"
				_tmp81_ = _photo_file_adapter_ref0 (new_reader);
#line 4050 "../src/Photo.vala"
				_photo_file_adapter_unref0 (_tmp80_->editable);
#line 4050 "../src/Photo.vala"
				_tmp80_->editable = _tmp81_;
#line 28958 "Photo.c"
			}
			__finally4:
			{
				PhotoBackingReaders* _tmp82_;
#line 4049 "../src/Photo.vala"
				_tmp82_ = self->priv->readers;
#line 4049 "../src/Photo.vala"
				g_rec_mutex_unlock (&self->priv->__lock_readers);
#line 28967 "Photo.c"
			}
#line 4049 "../src/Photo.vala"
			if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 4049 "../src/Photo.vala"
				g_propagate_error (error, _inner_error0_);
#line 4049 "../src/Photo.vala"
				_backing_photo_row_unref0 (backing);
#line 4049 "../src/Photo.vala"
				_detected_photo_information_unref0 (detected);
#line 4049 "../src/Photo.vala"
				_g_object_unref0 (file);
#line 4049 "../src/Photo.vala"
				_photo_file_adapter_unref0 (reader);
#line 4049 "../src/Photo.vala"
				_photo_file_adapter_unref0 (old_reader);
#line 4049 "../src/Photo.vala"
				return;
#line 28985 "Photo.c"
			}
		}
	}
#line 4054 "../src/Photo.vala"
	if (!only_attributes) {
#line 28991 "Photo.c"
		PhotoFileReader* _tmp84_;
		PhotoFileReader* _tmp85_;
#line 4054 "../src/Photo.vala"
		_tmp84_ = reader;
#line 4054 "../src/Photo.vala"
		_tmp85_ = old_reader;
#line 4054 "../src/Photo.vala"
		_tmp83_ = _tmp84_ != _tmp85_;
#line 29000 "Photo.c"
	} else {
#line 4054 "../src/Photo.vala"
		_tmp83_ = FALSE;
#line 29004 "Photo.c"
	}
#line 4054 "../src/Photo.vala"
	if (_tmp83_) {
#line 29008 "Photo.c"
		GFile* _tmp86_ = NULL;
		PhotoFileReader* _tmp87_;
		GFile* _tmp90_ = NULL;
#line 4055 "../src/Photo.vala"
		photo_notify_baseline_replaced (self);
#line 4056 "../src/Photo.vala"
		_tmp87_ = old_reader;
#line 4056 "../src/Photo.vala"
		if (_tmp87_ != NULL) {
#line 29018 "Photo.c"
			PhotoFileReader* _tmp88_;
			GFile* _tmp89_;
#line 4056 "../src/Photo.vala"
			_tmp88_ = old_reader;
#line 4056 "../src/Photo.vala"
			_tmp89_ = photo_file_adapter_get_file (G_TYPE_CHECK_INSTANCE_CAST (_tmp88_, TYPE_PHOTO_FILE_ADAPTER, PhotoFileAdapter));
#line 4056 "../src/Photo.vala"
			_g_object_unref0 (_tmp86_);
#line 4056 "../src/Photo.vala"
			_tmp86_ = _tmp89_;
#line 29029 "Photo.c"
		} else {
#line 4056 "../src/Photo.vala"
			_g_object_unref0 (_tmp86_);
#line 4056 "../src/Photo.vala"
			_tmp86_ = NULL;
#line 29035 "Photo.c"
		}
#line 4057 "../src/Photo.vala"
		if (new_reader != NULL) {
#line 29039 "Photo.c"
			GFile* _tmp91_;
#line 4057 "../src/Photo.vala"
			_tmp91_ = photo_file_adapter_get_file (G_TYPE_CHECK_INSTANCE_CAST (new_reader, TYPE_PHOTO_FILE_ADAPTER, PhotoFileAdapter));
#line 4057 "../src/Photo.vala"
			_g_object_unref0 (_tmp90_);
#line 4057 "../src/Photo.vala"
			_tmp90_ = _tmp91_;
#line 29047 "Photo.c"
		} else {
#line 4057 "../src/Photo.vala"
			_g_object_unref0 (_tmp90_);
#line 4057 "../src/Photo.vala"
			_tmp90_ = NULL;
#line 29053 "Photo.c"
		}
#line 4056 "../src/Photo.vala"
		photo_notify_editable_replaced (self, _tmp86_, _tmp90_);
#line 4054 "../src/Photo.vala"
		_g_object_unref0 (_tmp90_);
#line 4054 "../src/Photo.vala"
		_g_object_unref0 (_tmp86_);
#line 29061 "Photo.c"
	}
#line 4060 "../src/Photo.vala"
	_tmp92_ = g_new0 (gchar*, 0 + 1);
#line 4060 "../src/Photo.vala"
	alteration_list = _tmp92_;
#line 4060 "../src/Photo.vala"
	alteration_list_length1 = 0;
#line 4060 "../src/Photo.vala"
	_alteration_list_size_ = alteration_list_length1;
#line 4061 "../src/Photo.vala"
	if (timestamp_changed) {
#line 29073 "Photo.c"
		gchar* _tmp93_;
		gchar* _tmp94_;
#line 4062 "../src/Photo.vala"
		_tmp93_ = g_strdup ("metadata:editable-timestamp");
#line 4062 "../src/Photo.vala"
		_vala_array_add102 (&alteration_list, &alteration_list_length1, &_alteration_list_size_, _tmp93_);
#line 4063 "../src/Photo.vala"
		_tmp94_ = g_strdup ("metadata:baseline-timestamp");
#line 4063 "../src/Photo.vala"
		_vala_array_add103 (&alteration_list, &alteration_list_length1, &_alteration_list_size_, _tmp94_);
#line 4065 "../src/Photo.vala"
		if (photo_is_editable_source (self)) {
#line 29086 "Photo.c"
			gchar* _tmp95_;
#line 4066 "../src/Photo.vala"
			_tmp95_ = g_strdup ("metadata:source-timestamp");
#line 4066 "../src/Photo.vala"
			_vala_array_add104 (&alteration_list, &alteration_list_length1, &_alteration_list_size_, _tmp95_);
#line 29092 "Photo.c"
		}
	}
#line 4069 "../src/Photo.vala"
	if (filesize_changed) {
#line 4069 "../src/Photo.vala"
		_tmp96_ = TRUE;
#line 29099 "Photo.c"
	} else {
#line 4069 "../src/Photo.vala"
		_tmp96_ = new_reader != NULL;
#line 29103 "Photo.c"
	}
#line 4069 "../src/Photo.vala"
	if (_tmp96_) {
#line 29107 "Photo.c"
		gchar* _tmp97_;
		gchar* _tmp98_;
#line 4070 "../src/Photo.vala"
		_tmp97_ = g_strdup ("image:editable");
#line 4070 "../src/Photo.vala"
		_vala_array_add105 (&alteration_list, &alteration_list_length1, &_alteration_list_size_, _tmp97_);
#line 4071 "../src/Photo.vala"
		_tmp98_ = g_strdup ("image:baseline");
#line 4071 "../src/Photo.vala"
		_vala_array_add106 (&alteration_list, &alteration_list_length1, &_alteration_list_size_, _tmp98_);
#line 4073 "../src/Photo.vala"
		if (photo_is_editable_source (self)) {
#line 29120 "Photo.c"
			gchar* _tmp99_;
#line 4074 "../src/Photo.vala"
			_tmp99_ = g_strdup ("image:source");
#line 4074 "../src/Photo.vala"
			_vala_array_add107 (&alteration_list, &alteration_list_length1, &_alteration_list_size_, _tmp99_);
#line 29126 "Photo.c"
		}
	}
#line 4077 "../src/Photo.vala"
	_tmp100_ = alteration_list;
#line 4077 "../src/Photo.vala"
	_tmp100__length1 = alteration_list_length1;
#line 4077 "../src/Photo.vala"
	if (_tmp100__length1 > 0) {
#line 29135 "Photo.c"
		gchar** _tmp101_;
		gint _tmp101__length1;
		Alteration* _tmp102_;
		Alteration* _tmp103_;
#line 4078 "../src/Photo.vala"
		_tmp101_ = alteration_list;
#line 4078 "../src/Photo.vala"
		_tmp101__length1 = alteration_list_length1;
#line 4078 "../src/Photo.vala"
		_tmp102_ = alteration_new_from_array (_tmp101_, _tmp101__length1);
#line 4078 "../src/Photo.vala"
		_tmp103_ = _tmp102_;
#line 4078 "../src/Photo.vala"
		data_object_notify_altered (G_TYPE_CHECK_INSTANCE_CAST (self, TYPE_DATA_OBJECT, DataObject), _tmp103_);
#line 4078 "../src/Photo.vala"
		_alteration_unref0 (_tmp103_);
#line 29152 "Photo.c"
	}
#line 3960 "../src/Photo.vala"
	alteration_list = (_vala_array_free (alteration_list, alteration_list_length1, (GDestroyNotify) g_free), NULL);
#line 3960 "../src/Photo.vala"
	_backing_photo_row_unref0 (backing);
#line 3960 "../src/Photo.vala"
	_detected_photo_information_unref0 (detected);
#line 3960 "../src/Photo.vala"
	_g_object_unref0 (file);
#line 3960 "../src/Photo.vala"
	_photo_file_adapter_unref0 (reader);
#line 3960 "../src/Photo.vala"
	_photo_file_adapter_unref0 (old_reader);
#line 29166 "Photo.c"
}

static void
photo_detach_editable (Photo* self,
                       gboolean delete_editable,
                       gboolean remove_transformations,
                       gboolean notify)
{
	gboolean has_editable = FALSE;
	GFile* editable_file = NULL;
	gboolean _tmp27_ = FALSE;
	gboolean _tmp37_ = FALSE;
	gboolean _tmp38_ = FALSE;
	GError* _inner_error0_ = NULL;
#line 4081 "../src/Photo.vala"
	g_return_if_fail (IS_PHOTO (self));
#line 4082 "../src/Photo.vala"
	photo_halt_monitoring_editable (self);
#line 4084 "../src/Photo.vala"
	has_editable = FALSE;
#line 4085 "../src/Photo.vala"
	editable_file = NULL;
#line 29189 "Photo.c"
	{
		PhotoBackingReaders* _tmp0_;
#line 4086 "../src/Photo.vala"
		_tmp0_ = self->priv->readers;
#line 4086 "../src/Photo.vala"
		g_rec_mutex_lock (&self->priv->__lock_readers);
#line 29196 "Photo.c"
		{
			PhotoBackingReaders* _tmp1_;
			PhotoFileReader* _tmp2_;
#line 4087 "../src/Photo.vala"
			_tmp1_ = self->priv->readers;
#line 4087 "../src/Photo.vala"
			_tmp2_ = _tmp1_->editable;
#line 4087 "../src/Photo.vala"
			if (_tmp2_ != NULL) {
#line 29206 "Photo.c"
				PhotoBackingReaders* _tmp3_;
				PhotoFileReader* _tmp4_;
				GFile* _tmp5_;
				PhotoBackingReaders* _tmp6_;
#line 4088 "../src/Photo.vala"
				_tmp3_ = self->priv->readers;
#line 4088 "../src/Photo.vala"
				_tmp4_ = _tmp3_->editable;
#line 4088 "../src/Photo.vala"
				_tmp5_ = photo_file_adapter_get_file (G_TYPE_CHECK_INSTANCE_CAST (_tmp4_, TYPE_PHOTO_FILE_ADAPTER, PhotoFileAdapter));
#line 4088 "../src/Photo.vala"
				_g_object_unref0 (editable_file);
#line 4088 "../src/Photo.vala"
				editable_file = _tmp5_;
#line 4089 "../src/Photo.vala"
				_tmp6_ = self->priv->readers;
#line 4089 "../src/Photo.vala"
				_photo_file_adapter_unref0 (_tmp6_->editable);
#line 4089 "../src/Photo.vala"
				_tmp6_->editable = NULL;
#line 4090 "../src/Photo.vala"
				has_editable = TRUE;
#line 29229 "Photo.c"
			}
		}
		__finally0:
		{
			PhotoBackingReaders* _tmp7_;
#line 4086 "../src/Photo.vala"
			_tmp7_ = self->priv->readers;
#line 4086 "../src/Photo.vala"
			g_rec_mutex_unlock (&self->priv->__lock_readers);
#line 29239 "Photo.c"
		}
#line 4086 "../src/Photo.vala"
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 4086 "../src/Photo.vala"
			_g_object_unref0 (editable_file);
#line 4086 "../src/Photo.vala"
			g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 4086 "../src/Photo.vala"
			g_clear_error (&_inner_error0_);
#line 4086 "../src/Photo.vala"
			return;
#line 29251 "Photo.c"
		}
	}
#line 4094 "../src/Photo.vala"
	if (has_editable) {
#line 29256 "Photo.c"
		BackingPhotoID editable_id = {0};
#line 4095 "../src/Photo.vala"
		backing_photo_id_init (&editable_id, BACKING_PHOTO_ID_INVALID);
#line 29260 "Photo.c"
		{
			{
				PhotoRow* _tmp8_;
#line 4097 "../src/Photo.vala"
				_tmp8_ = self->row;
#line 4097 "../src/Photo.vala"
				g_rec_mutex_lock (&self->priv->__lock_row);
#line 29268 "Photo.c"
				{
					PhotoRow* _tmp9_;
					BackingPhotoID _tmp10_;
					PhotoRow* _tmp14_;
					BackingPhotoRow* _tmp15_;
					BackingPhotoRow* _tmp16_;
#line 4098 "../src/Photo.vala"
					_tmp9_ = self->row;
#line 4098 "../src/Photo.vala"
					_tmp10_ = _tmp9_->editable_id;
#line 4098 "../src/Photo.vala"
					editable_id = _tmp10_;
#line 4099 "../src/Photo.vala"
					if (backing_photo_id_is_valid (&editable_id)) {
#line 29283 "Photo.c"
						PhotoTable* _tmp11_;
						PhotoTable* _tmp12_;
						PhotoRow* _tmp13_;
#line 4100 "../src/Photo.vala"
						_tmp11_ = photo_table_get_instance ();
#line 4100 "../src/Photo.vala"
						_tmp12_ = _tmp11_;
#line 4100 "../src/Photo.vala"
						_tmp13_ = self->row;
#line 4100 "../src/Photo.vala"
						photo_table_detach_editable (_tmp12_, _tmp13_, &_inner_error0_);
#line 4100 "../src/Photo.vala"
						_database_table_unref0 (_tmp12_);
#line 4100 "../src/Photo.vala"
						if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 29299 "Photo.c"
							goto __catch2_g_error;
						}
					}
#line 4101 "../src/Photo.vala"
					_tmp14_ = self->row;
#line 4101 "../src/Photo.vala"
					_tmp15_ = _tmp14_->master;
#line 4101 "../src/Photo.vala"
					_tmp16_ = _backing_photo_row_ref0 (_tmp15_);
#line 4101 "../src/Photo.vala"
					_backing_photo_row_unref0 (self->backing_photo_row);
#line 4101 "../src/Photo.vala"
					self->backing_photo_row = _tmp16_;
#line 29313 "Photo.c"
				}
				goto __finally2;
				__catch2_g_error:
				{
					GError* _lock_error_ = NULL;
					GError* _tmp17_;
#line 4097 "../src/Photo.vala"
					_lock_error_ = _inner_error0_;
#line 4097 "../src/Photo.vala"
					_inner_error0_ = NULL;
#line 4097 "../src/Photo.vala"
					_tmp17_ = _lock_error_;
#line 4097 "../src/Photo.vala"
					_lock_error_ = NULL;
#line 4097 "../src/Photo.vala"
					_inner_error0_ = _tmp17_;
#line 4097 "../src/Photo.vala"
					_g_error_free0 (_lock_error_);
#line 29332 "Photo.c"
					goto __finally2;
				}
				__finally2:
				{
					GError* _inner_error1_ = NULL;
					PhotoRow* _tmp18_;
#line 4097 "../src/Photo.vala"
					_tmp18_ = self->row;
#line 4097 "../src/Photo.vala"
					g_rec_mutex_unlock (&self->priv->__lock_row);
#line 29343 "Photo.c"
				}
#line 4097 "../src/Photo.vala"
				if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 29347 "Photo.c"
					goto __catch1_g_error;
				}
			}
		}
		goto __finally1;
		__catch1_g_error:
		{
			GError* err = NULL;
			GError* _tmp19_;
			const gchar* _tmp20_;
#line 4096 "../src/Photo.vala"
			err = _inner_error0_;
#line 4096 "../src/Photo.vala"
			_inner_error0_ = NULL;
#line 4104 "../src/Photo.vala"
			_tmp19_ = err;
#line 4104 "../src/Photo.vala"
			_tmp20_ = _tmp19_->message;
#line 4104 "../src/Photo.vala"
			g_warning ("Photo.vala:4104: Unable to remove editable from PhotoTable: %s", _tmp20_);
#line 4096 "../src/Photo.vala"
			_g_error_free0 (err);
#line 29370 "Photo.c"
		}
		__finally1:
#line 4096 "../src/Photo.vala"
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 4096 "../src/Photo.vala"
			_g_object_unref0 (editable_file);
#line 4096 "../src/Photo.vala"
			g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 4096 "../src/Photo.vala"
			g_clear_error (&_inner_error0_);
#line 4096 "../src/Photo.vala"
			return;
#line 29383 "Photo.c"
		}
		{
#line 4108 "../src/Photo.vala"
			if (backing_photo_id_is_valid (&editable_id)) {
#line 29388 "Photo.c"
				BackingPhotoTable* _tmp21_;
				BackingPhotoTable* _tmp22_;
				BackingPhotoID _tmp23_;
#line 4109 "../src/Photo.vala"
				_tmp21_ = backing_photo_table_get_instance ();
#line 4109 "../src/Photo.vala"
				_tmp22_ = _tmp21_;
#line 4109 "../src/Photo.vala"
				_tmp23_ = editable_id;
#line 4109 "../src/Photo.vala"
				backing_photo_table_remove (_tmp22_, &_tmp23_, &_inner_error0_);
#line 4109 "../src/Photo.vala"
				_database_table_unref0 (_tmp22_);
#line 4109 "../src/Photo.vala"
				if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 4109 "../src/Photo.vala"
					if (_inner_error0_->domain == DATABASE_ERROR) {
#line 29406 "Photo.c"
						goto __catch3_database_error;
					}
#line 4109 "../src/Photo.vala"
					_g_object_unref0 (editable_file);
#line 4109 "../src/Photo.vala"
					g_critical ("file %s: line %d: unexpected error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 4109 "../src/Photo.vala"
					g_clear_error (&_inner_error0_);
#line 4109 "../src/Photo.vala"
					return;
#line 29417 "Photo.c"
				}
			}
		}
		goto __finally3;
		__catch3_database_error:
		{
			GError* err = NULL;
			GError* _tmp24_;
			const gchar* _tmp25_;
#line 4107 "../src/Photo.vala"
			err = _inner_error0_;
#line 4107 "../src/Photo.vala"
			_inner_error0_ = NULL;
#line 4111 "../src/Photo.vala"
			_tmp24_ = err;
#line 4111 "../src/Photo.vala"
			_tmp25_ = _tmp24_->message;
#line 4111 "../src/Photo.vala"
			g_warning ("Photo.vala:4111: Unable to remove editable from BackingPhotoTable: %s", _tmp25_);
#line 4107 "../src/Photo.vala"
			_g_error_free0 (err);
#line 29439 "Photo.c"
		}
		__finally3:
#line 4107 "../src/Photo.vala"
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 4107 "../src/Photo.vala"
			_g_object_unref0 (editable_file);
#line 4107 "../src/Photo.vala"
			g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 4107 "../src/Photo.vala"
			g_clear_error (&_inner_error0_);
#line 4107 "../src/Photo.vala"
			return;
#line 29452 "Photo.c"
		}
	}
#line 4115 "../src/Photo.vala"
	if (remove_transformations) {
#line 4116 "../src/Photo.vala"
		photo_remove_all_transformations (self, FALSE);
#line 29459 "Photo.c"
	}
#line 4118 "../src/Photo.vala"
	if (has_editable) {
#line 29463 "Photo.c"
		GFile* _tmp26_;
#line 4119 "../src/Photo.vala"
		photo_notify_baseline_replaced (self);
#line 4120 "../src/Photo.vala"
		_tmp26_ = editable_file;
#line 4120 "../src/Photo.vala"
		photo_notify_editable_replaced (self, _tmp26_, NULL);
#line 29471 "Photo.c"
	}
#line 4123 "../src/Photo.vala"
	if (delete_editable) {
#line 29475 "Photo.c"
		GFile* _tmp28_;
#line 4123 "../src/Photo.vala"
		_tmp28_ = editable_file;
#line 4123 "../src/Photo.vala"
		_tmp27_ = _tmp28_ != NULL;
#line 29481 "Photo.c"
	} else {
#line 4123 "../src/Photo.vala"
		_tmp27_ = FALSE;
#line 29485 "Photo.c"
	}
#line 4123 "../src/Photo.vala"
	if (_tmp27_) {
#line 29489 "Photo.c"
		{
			GFile* _tmp29_;
#line 4125 "../src/Photo.vala"
			_tmp29_ = editable_file;
#line 4125 "../src/Photo.vala"
			g_file_trash (_tmp29_, NULL, &_inner_error0_);
#line 4125 "../src/Photo.vala"
			if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 29498 "Photo.c"
				goto __catch4_g_error;
			}
		}
		goto __finally4;
		__catch4_g_error:
		{
			GError* err = NULL;
			GFile* _tmp30_;
			gchar* _tmp31_;
			gchar* _tmp32_;
			gchar* _tmp33_;
			gchar* _tmp34_;
			GError* _tmp35_;
			const gchar* _tmp36_;
#line 4124 "../src/Photo.vala"
			err = _inner_error0_;
#line 4124 "../src/Photo.vala"
			_inner_error0_ = NULL;
#line 4127 "../src/Photo.vala"
			_tmp30_ = editable_file;
#line 4127 "../src/Photo.vala"
			_tmp31_ = g_file_get_path (_tmp30_);
#line 4127 "../src/Photo.vala"
			_tmp32_ = _tmp31_;
#line 4127 "../src/Photo.vala"
			_tmp33_ = data_object_to_string (G_TYPE_CHECK_INSTANCE_CAST (self, TYPE_DATA_OBJECT, DataObject));
#line 4127 "../src/Photo.vala"
			_tmp34_ = _tmp33_;
#line 4127 "../src/Photo.vala"
			_tmp35_ = err;
#line 4127 "../src/Photo.vala"
			_tmp36_ = _tmp35_->message;
#line 4127 "../src/Photo.vala"
			g_warning ("Photo.vala:4127: Unable to trash editable %s for %s: %s", _tmp32_, _tmp34_, _tmp36_);
#line 4127 "../src/Photo.vala"
			_g_free0 (_tmp34_);
#line 4127 "../src/Photo.vala"
			_g_free0 (_tmp32_);
#line 4124 "../src/Photo.vala"
			_g_error_free0 (err);
#line 29539 "Photo.c"
		}
		__finally4:
#line 4124 "../src/Photo.vala"
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 4124 "../src/Photo.vala"
			_g_object_unref0 (editable_file);
#line 4124 "../src/Photo.vala"
			g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 4124 "../src/Photo.vala"
			g_clear_error (&_inner_error0_);
#line 4124 "../src/Photo.vala"
			return;
#line 29552 "Photo.c"
		}
	}
#line 4132 "../src/Photo.vala"
	if (has_editable) {
#line 4132 "../src/Photo.vala"
		_tmp38_ = TRUE;
#line 29559 "Photo.c"
	} else {
#line 4132 "../src/Photo.vala"
		_tmp38_ = remove_transformations;
#line 29563 "Photo.c"
	}
#line 4132 "../src/Photo.vala"
	if (_tmp38_) {
#line 4132 "../src/Photo.vala"
		_tmp37_ = notify;
#line 29569 "Photo.c"
	} else {
#line 4132 "../src/Photo.vala"
		_tmp37_ = FALSE;
#line 29573 "Photo.c"
	}
#line 4132 "../src/Photo.vala"
	if (_tmp37_) {
#line 29577 "Photo.c"
		Alteration* _tmp39_;
		Alteration* _tmp40_;
#line 4133 "../src/Photo.vala"
		_tmp39_ = alteration_new ("image", "revert");
#line 4133 "../src/Photo.vala"
		_tmp40_ = _tmp39_;
#line 4133 "../src/Photo.vala"
		data_object_notify_altered (G_TYPE_CHECK_INSTANCE_CAST (self, TYPE_DATA_OBJECT, DataObject), _tmp40_);
#line 4133 "../src/Photo.vala"
		_alteration_unref0 (_tmp40_);
#line 29588 "Photo.c"
	}
#line 4081 "../src/Photo.vala"
	_g_object_unref0 (editable_file);
#line 29592 "Photo.c"
}

static void
_photo_on_reimport_editable_one_shot_callback (gpointer self)
{
#line 4155 "../src/Photo.vala"
	photo_on_reimport_editable ((Photo*) self);
#line 29600 "Photo.c"
}

static void
_photo_on_update_editable_attributes_one_shot_callback (gpointer self)
{
#line 4164 "../src/Photo.vala"
	photo_on_update_editable_attributes ((Photo*) self);
#line 29608 "Photo.c"
}

static void
_photo_on_remove_editable_one_shot_callback (gpointer self)
{
#line 4173 "../src/Photo.vala"
	photo_on_remove_editable ((Photo*) self);
#line 29616 "Photo.c"
}

static void
photo_on_editable_file_changed (Photo* self,
                                GFile* file,
                                GFile* other_file,
                                GFileMonitorEvent event)
{
	GEnumValue* _tmp10_;
	gchar* _tmp11_;
	gchar* _tmp12_;
	GError* _inner_error0_ = NULL;
#line 4136 "../src/Photo.vala"
	g_return_if_fail (IS_PHOTO (self));
#line 4136 "../src/Photo.vala"
	g_return_if_fail (G_TYPE_CHECK_INSTANCE_TYPE (file, g_file_get_type ()));
#line 4136 "../src/Photo.vala"
	g_return_if_fail ((other_file == NULL) || G_TYPE_CHECK_INSTANCE_TYPE (other_file, g_file_get_type ()));
#line 29635 "Photo.c"
	{
		PhotoBackingReaders* _tmp0_;
#line 4138 "../src/Photo.vala"
		_tmp0_ = self->priv->readers;
#line 4138 "../src/Photo.vala"
		g_rec_mutex_lock (&self->priv->__lock_readers);
#line 29642 "Photo.c"
		{
			PhotoBackingReaders* _tmp1_;
			PhotoFileReader* _tmp2_;
			PhotoBackingReaders* _tmp3_;
			PhotoFileReader* _tmp4_;
			GFile* _tmp5_;
			GFile* _tmp6_;
			gboolean _tmp7_;
#line 4139 "../src/Photo.vala"
			_tmp1_ = self->priv->readers;
#line 4139 "../src/Photo.vala"
			_tmp2_ = _tmp1_->editable;
#line 4139 "../src/Photo.vala"
			_vala_assert (_tmp2_ != NULL, "readers.editable != null");
#line 4141 "../src/Photo.vala"
			_tmp3_ = self->priv->readers;
#line 4141 "../src/Photo.vala"
			_tmp4_ = _tmp3_->editable;
#line 4141 "../src/Photo.vala"
			_tmp5_ = photo_file_adapter_get_file (G_TYPE_CHECK_INSTANCE_CAST (_tmp4_, TYPE_PHOTO_FILE_ADAPTER, PhotoFileAdapter));
#line 4141 "../src/Photo.vala"
			_tmp6_ = _tmp5_;
#line 4141 "../src/Photo.vala"
			_tmp7_ = !g_file_equal (file, _tmp6_);
#line 4141 "../src/Photo.vala"
			_g_object_unref0 (_tmp6_);
#line 4141 "../src/Photo.vala"
			if (_tmp7_) {
#line 29671 "Photo.c"
				{
					PhotoBackingReaders* _tmp8_;
#line 4138 "../src/Photo.vala"
					_tmp8_ = self->priv->readers;
#line 4138 "../src/Photo.vala"
					g_rec_mutex_unlock (&self->priv->__lock_readers);
#line 29678 "Photo.c"
				}
#line 4145 "../src/Photo.vala"
				return;
#line 29682 "Photo.c"
			}
		}
		__finally0:
		{
			PhotoBackingReaders* _tmp9_;
#line 4138 "../src/Photo.vala"
			_tmp9_ = self->priv->readers;
#line 4138 "../src/Photo.vala"
			g_rec_mutex_unlock (&self->priv->__lock_readers);
#line 29692 "Photo.c"
		}
#line 4138 "../src/Photo.vala"
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 4138 "../src/Photo.vala"
			g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 4138 "../src/Photo.vala"
			g_clear_error (&_inner_error0_);
#line 4138 "../src/Photo.vala"
			return;
#line 29702 "Photo.c"
		}
	}
#line 4149 "../src/Photo.vala"
	_tmp10_ = g_enum_get_value (g_type_class_ref (g_file_monitor_event_get_type ()), event);
#line 4149 "../src/Photo.vala"
	_tmp11_ = g_file_get_path (file);
#line 4149 "../src/Photo.vala"
	_tmp12_ = _tmp11_;
#line 4149 "../src/Photo.vala"
	g_debug ("Photo.vala:4149: EDITABLE %s: %s", (_tmp10_ != NULL) ? _tmp10_->value_name : NULL, _tmp12_);
#line 4149 "../src/Photo.vala"
	_g_free0 (_tmp12_);
#line 4151 "../src/Photo.vala"
	switch (event) {
#line 4151 "../src/Photo.vala"
		case G_FILE_MONITOR_EVENT_CHANGED:
#line 4151 "../src/Photo.vala"
		case G_FILE_MONITOR_EVENT_CREATED:
#line 29721 "Photo.c"
		{
			OneShotScheduler* _tmp13_;
			OneShotScheduler* _tmp15_;
#line 4154 "../src/Photo.vala"
			_tmp13_ = self->priv->reimport_editable_scheduler;
#line 4154 "../src/Photo.vala"
			if (_tmp13_ == NULL) {
#line 29729 "Photo.c"
				OneShotScheduler* _tmp14_;
#line 4155 "../src/Photo.vala"
				_tmp14_ = one_shot_scheduler_new ("Photo.reimport_editable", _photo_on_reimport_editable_one_shot_callback, self);
#line 4155 "../src/Photo.vala"
				_one_shot_scheduler_unref0 (self->priv->reimport_editable_scheduler);
#line 4155 "../src/Photo.vala"
				self->priv->reimport_editable_scheduler = _tmp14_;
#line 29737 "Photo.c"
			}
#line 4159 "../src/Photo.vala"
			_tmp15_ = self->priv->reimport_editable_scheduler;
#line 4159 "../src/Photo.vala"
			one_shot_scheduler_after_timeout (_tmp15_, (guint) 1000, TRUE);
#line 4160 "../src/Photo.vala"
			break;
#line 29745 "Photo.c"
		}
#line 4151 "../src/Photo.vala"
		case G_FILE_MONITOR_EVENT_ATTRIBUTE_CHANGED:
#line 29749 "Photo.c"
		{
			OneShotScheduler* _tmp16_;
			OneShotScheduler* _tmp18_;
#line 4163 "../src/Photo.vala"
			_tmp16_ = self->priv->update_editable_attributes_scheduler;
#line 4163 "../src/Photo.vala"
			if (_tmp16_ == NULL) {
#line 29757 "Photo.c"
				OneShotScheduler* _tmp17_;
#line 4164 "../src/Photo.vala"
				_tmp17_ = one_shot_scheduler_new ("Photo.update_editable_attributes", _photo_on_update_editable_attributes_one_shot_callback, self);
#line 4164 "../src/Photo.vala"
				_one_shot_scheduler_unref0 (self->priv->update_editable_attributes_scheduler);
#line 4164 "../src/Photo.vala"
				self->priv->update_editable_attributes_scheduler = _tmp17_;
#line 29765 "Photo.c"
			}
#line 4168 "../src/Photo.vala"
			_tmp18_ = self->priv->update_editable_attributes_scheduler;
#line 4168 "../src/Photo.vala"
			one_shot_scheduler_after_timeout (_tmp18_, (guint) 1000, TRUE);
#line 4169 "../src/Photo.vala"
			break;
#line 29773 "Photo.c"
		}
#line 4151 "../src/Photo.vala"
		case G_FILE_MONITOR_EVENT_DELETED:
#line 29777 "Photo.c"
		{
			OneShotScheduler* _tmp19_;
			OneShotScheduler* _tmp21_;
#line 4172 "../src/Photo.vala"
			_tmp19_ = self->priv->remove_editable_scheduler;
#line 4172 "../src/Photo.vala"
			if (_tmp19_ == NULL) {
#line 29785 "Photo.c"
				OneShotScheduler* _tmp20_;
#line 4173 "../src/Photo.vala"
				_tmp20_ = one_shot_scheduler_new ("Photo.remove_editable", _photo_on_remove_editable_one_shot_callback, self);
#line 4173 "../src/Photo.vala"
				_one_shot_scheduler_unref0 (self->priv->remove_editable_scheduler);
#line 4173 "../src/Photo.vala"
				self->priv->remove_editable_scheduler = _tmp20_;
#line 29793 "Photo.c"
			}
#line 4177 "../src/Photo.vala"
			_tmp21_ = self->priv->remove_editable_scheduler;
#line 4177 "../src/Photo.vala"
			one_shot_scheduler_after_timeout (_tmp21_, (guint) 3000, TRUE);
#line 4178 "../src/Photo.vala"
			break;
#line 29801 "Photo.c"
		}
		default:
#line 4151 "../src/Photo.vala"
		case G_FILE_MONITOR_EVENT_CHANGES_DONE_HINT:
#line 29806 "Photo.c"
		{
#line 4183 "../src/Photo.vala"
			break;
#line 29810 "Photo.c"
		}
	}
#line 4188 "../src/Photo.vala"
	photo_discard_prefetched (self);
#line 29815 "Photo.c"
}

static void
photo_on_reimport_editable (Photo* self)
{
	gchar* _tmp0_;
	gchar* _tmp1_;
	GError* _inner_error0_ = NULL;
#line 4191 "../src/Photo.vala"
	g_return_if_fail (IS_PHOTO (self));
#line 4193 "../src/Photo.vala"
	photo_discard_prefetched (self);
#line 4195 "../src/Photo.vala"
	_tmp0_ = data_object_to_string (G_TYPE_CHECK_INSTANCE_CAST (self, TYPE_DATA_OBJECT, DataObject));
#line 4195 "../src/Photo.vala"
	_tmp1_ = _tmp0_;
#line 4195 "../src/Photo.vala"
	g_debug ("Photo.vala:4195: Reimporting editable for %s", _tmp1_);
#line 4195 "../src/Photo.vala"
	_g_free0 (_tmp1_);
#line 29836 "Photo.c"
	{
#line 4197 "../src/Photo.vala"
		photo_reimport_editable (self, &_inner_error0_);
#line 4197 "../src/Photo.vala"
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 29842 "Photo.c"
			goto __catch0_g_error;
		}
	}
	goto __finally0;
	__catch0_g_error:
	{
		GError* err = NULL;
		gchar* _tmp2_;
		gchar* _tmp3_;
		GError* _tmp4_;
		const gchar* _tmp5_;
#line 4196 "../src/Photo.vala"
		err = _inner_error0_;
#line 4196 "../src/Photo.vala"
		_inner_error0_ = NULL;
#line 4199 "../src/Photo.vala"
		_tmp2_ = data_object_to_string (G_TYPE_CHECK_INSTANCE_CAST (self, TYPE_DATA_OBJECT, DataObject));
#line 4199 "../src/Photo.vala"
		_tmp3_ = _tmp2_;
#line 4199 "../src/Photo.vala"
		_tmp4_ = err;
#line 4199 "../src/Photo.vala"
		_tmp5_ = _tmp4_->message;
#line 4199 "../src/Photo.vala"
		g_warning ("Photo.vala:4199: Unable to reimport photo %s changed by external edito" \
"r: %s", _tmp3_, _tmp5_);
#line 4199 "../src/Photo.vala"
		_g_free0 (_tmp3_);
#line 4196 "../src/Photo.vala"
		_g_error_free0 (err);
#line 29872 "Photo.c"
	}
	__finally0:
#line 4196 "../src/Photo.vala"
	if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 4196 "../src/Photo.vala"
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 4196 "../src/Photo.vala"
		g_clear_error (&_inner_error0_);
#line 4196 "../src/Photo.vala"
		return;
#line 29883 "Photo.c"
	}
}

static void
photo_on_update_editable_attributes (Photo* self)
{
	gchar* _tmp0_;
	gchar* _tmp1_;
	GError* _inner_error0_ = NULL;
#line 4204 "../src/Photo.vala"
	g_return_if_fail (IS_PHOTO (self));
#line 4205 "../src/Photo.vala"
	_tmp0_ = data_object_to_string (G_TYPE_CHECK_INSTANCE_CAST (self, TYPE_DATA_OBJECT, DataObject));
#line 4205 "../src/Photo.vala"
	_tmp1_ = _tmp0_;
#line 4205 "../src/Photo.vala"
	g_debug ("Photo.vala:4205: Updating editable attributes for %s", _tmp1_);
#line 4205 "../src/Photo.vala"
	_g_free0 (_tmp1_);
#line 29903 "Photo.c"
	{
#line 4207 "../src/Photo.vala"
		photo_update_editable_attributes (self, &_inner_error0_);
#line 4207 "../src/Photo.vala"
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 29909 "Photo.c"
			goto __catch0_g_error;
		}
	}
	goto __finally0;
	__catch0_g_error:
	{
		GError* err = NULL;
		GError* _tmp2_;
		const gchar* _tmp3_;
#line 4206 "../src/Photo.vala"
		err = _inner_error0_;
#line 4206 "../src/Photo.vala"
		_inner_error0_ = NULL;
#line 4209 "../src/Photo.vala"
		_tmp2_ = err;
#line 4209 "../src/Photo.vala"
		_tmp3_ = _tmp2_->message;
#line 4209 "../src/Photo.vala"
		g_warning ("Photo.vala:4209: Unable to update editable attributes: %s", _tmp3_);
#line 4206 "../src/Photo.vala"
		_g_error_free0 (err);
#line 29931 "Photo.c"
	}
	__finally0:
#line 4206 "../src/Photo.vala"
	if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 4206 "../src/Photo.vala"
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 4206 "../src/Photo.vala"
		g_clear_error (&_inner_error0_);
#line 4206 "../src/Photo.vala"
		return;
#line 29942 "Photo.c"
	}
}

static void
photo_on_remove_editable (Photo* self)
{
	PhotoFileReader* reader = NULL;
	PhotoFileReader* _tmp0_;
	PhotoFileReader* _tmp1_;
	GFile* file = NULL;
	PhotoFileReader* _tmp2_;
	GFile* _tmp3_;
	GFile* _tmp4_;
	gchar* _tmp7_;
	gchar* _tmp8_;
#line 4213 "../src/Photo.vala"
	g_return_if_fail (IS_PHOTO (self));
#line 4214 "../src/Photo.vala"
	_tmp0_ = photo_get_editable_reader (self);
#line 4214 "../src/Photo.vala"
	reader = _tmp0_;
#line 4215 "../src/Photo.vala"
	_tmp1_ = reader;
#line 4215 "../src/Photo.vala"
	if (_tmp1_ == NULL) {
#line 4216 "../src/Photo.vala"
		_photo_file_adapter_unref0 (reader);
#line 4216 "../src/Photo.vala"
		return;
#line 29972 "Photo.c"
	}
#line 4218 "../src/Photo.vala"
	_tmp2_ = reader;
#line 4218 "../src/Photo.vala"
	_tmp3_ = photo_file_adapter_get_file (G_TYPE_CHECK_INSTANCE_CAST (_tmp2_, TYPE_PHOTO_FILE_ADAPTER, PhotoFileAdapter));
#line 4218 "../src/Photo.vala"
	file = _tmp3_;
#line 4219 "../src/Photo.vala"
	_tmp4_ = file;
#line 4219 "../src/Photo.vala"
	if (g_file_query_exists (_tmp4_, NULL)) {
#line 29984 "Photo.c"
		gchar* _tmp5_;
		gchar* _tmp6_;
#line 4220 "../src/Photo.vala"
		_tmp5_ = data_object_to_string (G_TYPE_CHECK_INSTANCE_CAST (self, TYPE_DATA_OBJECT, DataObject));
#line 4220 "../src/Photo.vala"
		_tmp6_ = _tmp5_;
#line 4220 "../src/Photo.vala"
		g_debug ("Photo.vala:4220: Not removing editable for %s: file exists", _tmp6_);
#line 4220 "../src/Photo.vala"
		_g_free0 (_tmp6_);
#line 4222 "../src/Photo.vala"
		_g_object_unref0 (file);
#line 4222 "../src/Photo.vala"
		_photo_file_adapter_unref0 (reader);
#line 4222 "../src/Photo.vala"
		return;
#line 30001 "Photo.c"
	}
#line 4225 "../src/Photo.vala"
	_tmp7_ = data_object_to_string (G_TYPE_CHECK_INSTANCE_CAST (self, TYPE_DATA_OBJECT, DataObject));
#line 4225 "../src/Photo.vala"
	_tmp8_ = _tmp7_;
#line 4225 "../src/Photo.vala"
	g_debug ("Photo.vala:4225: Removing editable for %s: file no longer exists", _tmp8_);
#line 4225 "../src/Photo.vala"
	_g_free0 (_tmp8_);
#line 4226 "../src/Photo.vala"
	photo_detach_editable (self, FALSE, TRUE, TRUE);
#line 4213 "../src/Photo.vala"
	_g_object_unref0 (file);
#line 4213 "../src/Photo.vala"
	_photo_file_adapter_unref0 (reader);
#line 30017 "Photo.c"
}

void
photo_get_original_dimensions (Photo* self,
                               Dimensions* result)
{
	Dimensions dim = {0};
	Dimensions _tmp0_ = {0};
	Orientation orientation = 0;
	Dimensions _tmp1_;
	Dimensions _tmp2_ = {0};
#line 4234 "../src/Photo.vala"
	g_return_if_fail (IS_PHOTO (self));
#line 4235 "../src/Photo.vala"
	photo_get_raw_dimensions (self, &_tmp0_);
#line 4235 "../src/Photo.vala"
	dim = _tmp0_;
#line 4236 "../src/Photo.vala"
	orientation = photo_get_orientation (self);
#line 4238 "../src/Photo.vala"
	_tmp1_ = dim;
#line 4238 "../src/Photo.vala"
	orientation_rotate_dimensions (orientation, &_tmp1_, &_tmp2_);
#line 4238 "../src/Photo.vala"
	*result = _tmp2_;
#line 4238 "../src/Photo.vala"
	return;
#line 30045 "Photo.c"
}

void
photo_get_master_dimensions (Photo* self,
                             Dimensions* result)
{
	Dimensions _tmp0_ = {0};
	Dimensions _tmp1_ = {0};
#line 4242 "../src/Photo.vala"
	g_return_if_fail (IS_PHOTO (self));
#line 4243 "../src/Photo.vala"
	photo_get_raw_dimensions (self, &_tmp0_);
#line 4243 "../src/Photo.vala"
	orientation_rotate_dimensions (photo_get_original_orientation (self), &_tmp0_, &_tmp1_);
#line 4243 "../src/Photo.vala"
	*result = _tmp1_;
#line 4243 "../src/Photo.vala"
	return;
#line 30064 "Photo.c"
}

gboolean
photo_get_crop (Photo* self,
                Box* crop,
                PhotoException exceptions)
{
	Box _vala_crop = {0};
	Box raw = {0};
	Box _tmp0_ = {0};
	gboolean _tmp1_;
	Dimensions dim = {0};
	Dimensions _tmp2_ = {0};
	Orientation orientation = 0;
	gboolean result;
#line 4247 "../src/Photo.vala"
	g_return_val_if_fail (IS_PHOTO (self), FALSE);
#line 4249 "../src/Photo.vala"
	_tmp1_ = photo_get_raw_crop (self, &_tmp0_);
#line 4249 "../src/Photo.vala"
	raw = _tmp0_;
#line 4249 "../src/Photo.vala"
	if (!_tmp1_) {
#line 4250 "../src/Photo.vala"
		box_init (&_vala_crop, 0, 0, 0, 0);
#line 4252 "../src/Photo.vala"
		result = FALSE;
#line 4252 "../src/Photo.vala"
		if (crop) {
#line 4252 "../src/Photo.vala"
			*crop = _vala_crop;
#line 30096 "Photo.c"
		}
#line 4252 "../src/Photo.vala"
		return result;
#line 30100 "Photo.c"
	}
#line 4255 "../src/Photo.vala"
	media_source_get_dimensions (G_TYPE_CHECK_INSTANCE_CAST (self, TYPE_MEDIA_SOURCE, MediaSource), PHOTO_EXCEPTION_CROP | PHOTO_EXCEPTION_ORIENTATION, &_tmp2_);
#line 4255 "../src/Photo.vala"
	dim = _tmp2_;
#line 4256 "../src/Photo.vala"
	orientation = photo_get_orientation (self);
#line 4258 "../src/Photo.vala"
	if (photo_exception_allows (exceptions, PHOTO_EXCEPTION_ORIENTATION)) {
#line 30110 "Photo.c"
		Dimensions _tmp3_;
		Box _tmp4_;
		Box _tmp5_ = {0};
#line 4259 "../src/Photo.vala"
		_tmp3_ = dim;
#line 4259 "../src/Photo.vala"
		_tmp4_ = raw;
#line 4259 "../src/Photo.vala"
		orientation_rotate_box (orientation, &_tmp3_, &_tmp4_, &_tmp5_);
#line 4259 "../src/Photo.vala"
		_vala_crop = _tmp5_;
#line 30122 "Photo.c"
	} else {
		Box _tmp6_;
#line 4261 "../src/Photo.vala"
		_tmp6_ = raw;
#line 4261 "../src/Photo.vala"
		_vala_crop = _tmp6_;
#line 30129 "Photo.c"
	}
#line 4263 "../src/Photo.vala"
	result = TRUE;
#line 4263 "../src/Photo.vala"
	if (crop) {
#line 4263 "../src/Photo.vala"
		*crop = _vala_crop;
#line 30137 "Photo.c"
	}
#line 4263 "../src/Photo.vala"
	return result;
#line 30141 "Photo.c"
}

void
photo_set_crop (Photo* self,
                Box* crop)
{
	Dimensions dim = {0};
	Dimensions _tmp0_ = {0};
	Orientation orientation = 0;
	Box derotated = {0};
	Dimensions _tmp1_;
	Box _tmp2_;
	Box _tmp3_ = {0};
	Box _tmp4_;
	Dimensions _tmp5_;
	Box _tmp6_;
	Box _tmp7_;
	Dimensions _tmp8_;
	Box _tmp9_;
	Dimensions _tmp10_;
	Box _tmp11_;
	Box _tmp12_;
	Dimensions _tmp13_;
	Box _tmp14_;
#line 4267 "../src/Photo.vala"
	g_return_if_fail (IS_PHOTO (self));
#line 4267 "../src/Photo.vala"
	g_return_if_fail (crop != NULL);
#line 4268 "../src/Photo.vala"
	media_source_get_dimensions (G_TYPE_CHECK_INSTANCE_CAST (self, TYPE_MEDIA_SOURCE, MediaSource), PHOTO_EXCEPTION_CROP | PHOTO_EXCEPTION_ORIENTATION, &_tmp0_);
#line 4268 "../src/Photo.vala"
	dim = _tmp0_;
#line 4269 "../src/Photo.vala"
	orientation = photo_get_orientation (self);
#line 4271 "../src/Photo.vala"
	_tmp1_ = dim;
#line 4271 "../src/Photo.vala"
	_tmp2_ = *crop;
#line 4271 "../src/Photo.vala"
	orientation_derotate_box (orientation, &_tmp1_, &_tmp2_, &_tmp3_);
#line 4271 "../src/Photo.vala"
	derotated = _tmp3_;
#line 4273 "../src/Photo.vala"
	_tmp4_ = derotated;
#line 4273 "../src/Photo.vala"
	_tmp5_ = dim;
#line 4273 "../src/Photo.vala"
	derotated.left = CLAMP (_tmp4_.left, 0, _tmp5_.width - 2);
#line 4274 "../src/Photo.vala"
	_tmp6_ = derotated;
#line 4274 "../src/Photo.vala"
	_tmp7_ = derotated;
#line 4274 "../src/Photo.vala"
	_tmp8_ = dim;
#line 4274 "../src/Photo.vala"
	derotated.right = CLAMP (_tmp6_.right, _tmp7_.left, _tmp8_.width - 1);
#line 4276 "../src/Photo.vala"
	_tmp9_ = derotated;
#line 4276 "../src/Photo.vala"
	_tmp10_ = dim;
#line 4276 "../src/Photo.vala"
	derotated.top = CLAMP (_tmp9_.top, 0, _tmp10_.height - 2);
#line 4277 "../src/Photo.vala"
	_tmp11_ = derotated;
#line 4277 "../src/Photo.vala"
	_tmp12_ = derotated;
#line 4277 "../src/Photo.vala"
	_tmp13_ = dim;
#line 4277 "../src/Photo.vala"
	derotated.bottom = CLAMP (_tmp11_.bottom, _tmp12_.top, _tmp13_.height - 1);
#line 4279 "../src/Photo.vala"
	_tmp14_ = derotated;
#line 4279 "../src/Photo.vala"
	photo_set_raw_crop (self, &_tmp14_);
#line 30216 "Photo.c"
}

gboolean
photo_get_straighten (Photo* self,
                      gdouble* theta)
{
	gdouble _vala_theta = 0.0;
	gdouble _tmp0_ = 0.0;
	gboolean _tmp1_;
	gboolean result;
#line 4282 "../src/Photo.vala"
	g_return_val_if_fail (IS_PHOTO (self), FALSE);
#line 4283 "../src/Photo.vala"
	_tmp1_ = photo_get_raw_straighten (self, &_tmp0_);
#line 4283 "../src/Photo.vala"
	_vala_theta = _tmp0_;
#line 4283 "../src/Photo.vala"
	if (!_tmp1_) {
#line 4284 "../src/Photo.vala"
		result = FALSE;
#line 4284 "../src/Photo.vala"
		if (theta) {
#line 4284 "../src/Photo.vala"
			*theta = _vala_theta;
#line 30241 "Photo.c"
		}
#line 4284 "../src/Photo.vala"
		return result;
#line 30245 "Photo.c"
	}
#line 4286 "../src/Photo.vala"
	result = TRUE;
#line 4286 "../src/Photo.vala"
	if (theta) {
#line 4286 "../src/Photo.vala"
		*theta = _vala_theta;
#line 30253 "Photo.c"
	}
#line 4286 "../src/Photo.vala"
	return result;
#line 30257 "Photo.c"
}

void
photo_set_straighten (Photo* self,
                      gdouble theta)
{
#line 4289 "../src/Photo.vala"
	g_return_if_fail (IS_PHOTO (self));
#line 4290 "../src/Photo.vala"
	photo_set_raw_straighten (self, theta);
#line 30268 "Photo.c"
}

static GdkPixbuf*
photo_do_redeye (Photo* self,
                 GdkPixbuf* pixbuf,
                 EditingToolsRedeyeInstance* inst)
{
	gdouble r = 0.0;
	EditingToolsRedeyeInstance _tmp0_;
	gint* x_insets_first_quadrant = NULL;
	EditingToolsRedeyeInstance _tmp1_;
	gint* _tmp2_;
	gint x_insets_first_quadrant_length1;
	gint _x_insets_first_quadrant_size_;
	gint i = 0;
	gint x_bounds_min = 0;
	EditingToolsRedeyeInstance _tmp7_;
	GdkPoint _tmp8_;
	EditingToolsRedeyeInstance _tmp9_;
	gint x_bounds_max = 0;
	EditingToolsRedeyeInstance _tmp10_;
	GdkPoint _tmp11_;
	EditingToolsRedeyeInstance _tmp12_;
	gint ymin = 0;
	EditingToolsRedeyeInstance _tmp13_;
	GdkPoint _tmp14_;
	EditingToolsRedeyeInstance _tmp15_;
	gint _tmp16_ = 0;
	gint ymax = 0;
	EditingToolsRedeyeInstance _tmp17_;
	GdkPoint _tmp18_;
	gint _tmp19_ = 0;
	gint _tmp20_;
	gint _tmp21_;
	gint inset_index = 0;
	EditingToolsRedeyeInstance _tmp41_;
	GdkPoint _tmp42_;
	EditingToolsRedeyeInstance _tmp43_;
	GdkPoint _tmp44_;
	EditingToolsRedeyeInstance _tmp45_;
	gint* _tmp46_;
	gint _tmp46__length1;
	GdkPixbuf* _tmp64_;
	GdkPixbuf* result;
#line 4293 "../src/Photo.vala"
	g_return_val_if_fail (IS_PHOTO (self), NULL);
#line 4293 "../src/Photo.vala"
	g_return_val_if_fail (G_TYPE_CHECK_INSTANCE_TYPE (pixbuf, gdk_pixbuf_get_type ()), NULL);
#line 4293 "../src/Photo.vala"
	g_return_val_if_fail (inst != NULL, NULL);
#line 4303 "../src/Photo.vala"
	_tmp0_ = *inst;
#line 4303 "../src/Photo.vala"
	r = (gdouble) _tmp0_.radius;
#line 4304 "../src/Photo.vala"
	_tmp1_ = *inst;
#line 4304 "../src/Photo.vala"
	_tmp2_ = g_new0 (gint, _tmp1_.radius + 1);
#line 4304 "../src/Photo.vala"
	x_insets_first_quadrant = _tmp2_;
#line 4304 "../src/Photo.vala"
	x_insets_first_quadrant_length1 = _tmp1_.radius + 1;
#line 4304 "../src/Photo.vala"
	_x_insets_first_quadrant_size_ = x_insets_first_quadrant_length1;
#line 4306 "../src/Photo.vala"
	i = 0;
#line 30335 "Photo.c"
	{
		gdouble y = 0.0;
#line 4307 "../src/Photo.vala"
		y = r;
#line 30340 "Photo.c"
		{
			gboolean _tmp3_ = FALSE;
#line 4307 "../src/Photo.vala"
			_tmp3_ = TRUE;
#line 4307 "../src/Photo.vala"
			while (TRUE) {
#line 30347 "Photo.c"
				gdouble theta = 0.0;
				gint x = 0;
				gint* _tmp4_;
				gint _tmp4__length1;
				EditingToolsRedeyeInstance _tmp5_;
				gint _tmp6_;
#line 4307 "../src/Photo.vala"
				if (!_tmp3_) {
#line 4307 "../src/Photo.vala"
					y -= 1.0;
#line 30358 "Photo.c"
				}
#line 4307 "../src/Photo.vala"
				_tmp3_ = FALSE;
#line 4307 "../src/Photo.vala"
				if (!(y >= 0.0)) {
#line 4307 "../src/Photo.vala"
					break;
#line 30366 "Photo.c"
				}
#line 4308 "../src/Photo.vala"
				theta = asin (y / r);
#line 4309 "../src/Photo.vala"
				x = (gint) ((r * cos (theta)) + 0.5);
#line 4310 "../src/Photo.vala"
				_tmp4_ = x_insets_first_quadrant;
#line 4310 "../src/Photo.vala"
				_tmp4__length1 = x_insets_first_quadrant_length1;
#line 4310 "../src/Photo.vala"
				_tmp5_ = *inst;
#line 4310 "../src/Photo.vala"
				_tmp4_[i] = _tmp5_.radius - x;
#line 4312 "../src/Photo.vala"
				_tmp6_ = i;
#line 4312 "../src/Photo.vala"
				i = _tmp6_ + 1;
#line 30384 "Photo.c"
			}
		}
	}
#line 4315 "../src/Photo.vala"
	_tmp7_ = *inst;
#line 4315 "../src/Photo.vala"
	_tmp8_ = _tmp7_.center;
#line 4315 "../src/Photo.vala"
	_tmp9_ = *inst;
#line 4315 "../src/Photo.vala"
	x_bounds_min = _tmp8_.x - _tmp9_.radius;
#line 4316 "../src/Photo.vala"
	_tmp10_ = *inst;
#line 4316 "../src/Photo.vala"
	_tmp11_ = _tmp10_.center;
#line 4316 "../src/Photo.vala"
	_tmp12_ = *inst;
#line 4316 "../src/Photo.vala"
	x_bounds_max = _tmp11_.x + _tmp12_.radius;
#line 4317 "../src/Photo.vala"
	_tmp13_ = *inst;
#line 4317 "../src/Photo.vala"
	_tmp14_ = _tmp13_.center;
#line 4317 "../src/Photo.vala"
	_tmp15_ = *inst;
#line 4317 "../src/Photo.vala"
	ymin = _tmp14_.y - _tmp15_.radius;
#line 4318 "../src/Photo.vala"
	if (ymin < 0) {
#line 4318 "../src/Photo.vala"
		_tmp16_ = 0;
#line 30416 "Photo.c"
	} else {
#line 4318 "../src/Photo.vala"
		_tmp16_ = ymin;
#line 30420 "Photo.c"
	}
#line 4318 "../src/Photo.vala"
	ymin = _tmp16_;
#line 4319 "../src/Photo.vala"
	_tmp17_ = *inst;
#line 4319 "../src/Photo.vala"
	_tmp18_ = _tmp17_.center;
#line 4319 "../src/Photo.vala"
	ymax = _tmp18_.y;
#line 4320 "../src/Photo.vala"
	_tmp20_ = gdk_pixbuf_get_height (pixbuf);
#line 4320 "../src/Photo.vala"
	_tmp21_ = _tmp20_;
#line 4320 "../src/Photo.vala"
	if (ymax > (_tmp21_ - 1)) {
#line 30436 "Photo.c"
		gint _tmp22_;
		gint _tmp23_;
#line 4320 "../src/Photo.vala"
		_tmp22_ = gdk_pixbuf_get_height (pixbuf);
#line 4320 "../src/Photo.vala"
		_tmp23_ = _tmp22_;
#line 4320 "../src/Photo.vala"
		_tmp19_ = _tmp23_ - 1;
#line 30445 "Photo.c"
	} else {
#line 4320 "../src/Photo.vala"
		_tmp19_ = ymax;
#line 30449 "Photo.c"
	}
#line 4320 "../src/Photo.vala"
	ymax = _tmp19_;
#line 4324 "../src/Photo.vala"
	inset_index = 0;
#line 30455 "Photo.c"
	{
		gint y_it = 0;
#line 4325 "../src/Photo.vala"
		y_it = ymin;
#line 30460 "Photo.c"
		{
			gboolean _tmp24_ = FALSE;
#line 4325 "../src/Photo.vala"
			_tmp24_ = TRUE;
#line 4325 "../src/Photo.vala"
			while (TRUE) {
#line 30467 "Photo.c"
				gint xmin = 0;
				gint* _tmp26_;
				gint _tmp26__length1;
				gint _tmp27_;
				gint _tmp28_ = 0;
				gint xmax = 0;
				gint* _tmp29_;
				gint _tmp29__length1;
				gint _tmp30_;
				gint _tmp31_ = 0;
				gint _tmp32_;
				gint _tmp33_;
				gint _tmp40_;
#line 4325 "../src/Photo.vala"
				if (!_tmp24_) {
#line 30483 "Photo.c"
					gint _tmp25_;
#line 4325 "../src/Photo.vala"
					_tmp25_ = y_it;
#line 4325 "../src/Photo.vala"
					y_it = _tmp25_ + 1;
#line 30489 "Photo.c"
				}
#line 4325 "../src/Photo.vala"
				_tmp24_ = FALSE;
#line 4325 "../src/Photo.vala"
				if (!(y_it <= ymax)) {
#line 4325 "../src/Photo.vala"
					break;
#line 30497 "Photo.c"
				}
#line 4326 "../src/Photo.vala"
				_tmp26_ = x_insets_first_quadrant;
#line 4326 "../src/Photo.vala"
				_tmp26__length1 = x_insets_first_quadrant_length1;
#line 4326 "../src/Photo.vala"
				_tmp27_ = _tmp26_[inset_index];
#line 4326 "../src/Photo.vala"
				xmin = x_bounds_min + _tmp27_;
#line 4327 "../src/Photo.vala"
				if (xmin < 0) {
#line 4327 "../src/Photo.vala"
					_tmp28_ = 0;
#line 30511 "Photo.c"
				} else {
#line 4327 "../src/Photo.vala"
					_tmp28_ = xmin;
#line 30515 "Photo.c"
				}
#line 4327 "../src/Photo.vala"
				xmin = _tmp28_;
#line 4328 "../src/Photo.vala"
				_tmp29_ = x_insets_first_quadrant;
#line 4328 "../src/Photo.vala"
				_tmp29__length1 = x_insets_first_quadrant_length1;
#line 4328 "../src/Photo.vala"
				_tmp30_ = _tmp29_[inset_index];
#line 4328 "../src/Photo.vala"
				xmax = x_bounds_max - _tmp30_;
#line 4329 "../src/Photo.vala"
				_tmp32_ = gdk_pixbuf_get_width (pixbuf);
#line 4329 "../src/Photo.vala"
				_tmp33_ = _tmp32_;
#line 4329 "../src/Photo.vala"
				if (xmax > (_tmp33_ - 1)) {
#line 30533 "Photo.c"
					gint _tmp34_;
					gint _tmp35_;
#line 4329 "../src/Photo.vala"
					_tmp34_ = gdk_pixbuf_get_width (pixbuf);
#line 4329 "../src/Photo.vala"
					_tmp35_ = _tmp34_;
#line 4329 "../src/Photo.vala"
					_tmp31_ = _tmp35_ - 1;
#line 30542 "Photo.c"
				} else {
#line 4329 "../src/Photo.vala"
					_tmp31_ = xmax;
#line 30546 "Photo.c"
				}
#line 4329 "../src/Photo.vala"
				xmax = _tmp31_;
#line 30550 "Photo.c"
				{
					gint x_it = 0;
#line 4331 "../src/Photo.vala"
					x_it = xmin;
#line 30555 "Photo.c"
					{
						gboolean _tmp36_ = FALSE;
#line 4331 "../src/Photo.vala"
						_tmp36_ = TRUE;
#line 4331 "../src/Photo.vala"
						while (TRUE) {
#line 30562 "Photo.c"
							GdkPixbuf* _tmp38_;
							GdkPixbuf* _tmp39_;
#line 4331 "../src/Photo.vala"
							if (!_tmp36_) {
#line 30567 "Photo.c"
								gint _tmp37_;
#line 4331 "../src/Photo.vala"
								_tmp37_ = x_it;
#line 4331 "../src/Photo.vala"
								x_it = _tmp37_ + 1;
#line 30573 "Photo.c"
							}
#line 4331 "../src/Photo.vala"
							_tmp36_ = FALSE;
#line 4331 "../src/Photo.vala"
							if (!(x_it <= xmax)) {
#line 4331 "../src/Photo.vala"
								break;
#line 30581 "Photo.c"
							}
#line 4332 "../src/Photo.vala"
							_tmp38_ = photo_red_reduce_pixel (self, pixbuf, x_it, y_it);
#line 4332 "../src/Photo.vala"
							_tmp39_ = _tmp38_;
#line 4332 "../src/Photo.vala"
							_g_object_unref0 (_tmp39_);
#line 30589 "Photo.c"
						}
					}
				}
#line 4334 "../src/Photo.vala"
				_tmp40_ = inset_index;
#line 4334 "../src/Photo.vala"
				inset_index = _tmp40_ + 1;
#line 30597 "Photo.c"
			}
		}
	}
#line 4339 "../src/Photo.vala"
	_tmp41_ = *inst;
#line 4339 "../src/Photo.vala"
	_tmp42_ = _tmp41_.center;
#line 4339 "../src/Photo.vala"
	ymin = _tmp42_.y;
#line 4340 "../src/Photo.vala"
	_tmp43_ = *inst;
#line 4340 "../src/Photo.vala"
	_tmp44_ = _tmp43_.center;
#line 4340 "../src/Photo.vala"
	_tmp45_ = *inst;
#line 4340 "../src/Photo.vala"
	ymax = _tmp44_.y + _tmp45_.radius;
#line 4341 "../src/Photo.vala"
	_tmp46_ = x_insets_first_quadrant;
#line 4341 "../src/Photo.vala"
	_tmp46__length1 = x_insets_first_quadrant_length1;
#line 4341 "../src/Photo.vala"
	inset_index = _tmp46__length1 - 1;
#line 30621 "Photo.c"
	{
		gint y_it = 0;
#line 4342 "../src/Photo.vala"
		y_it = ymin;
#line 30626 "Photo.c"
		{
			gboolean _tmp47_ = FALSE;
#line 4342 "../src/Photo.vala"
			_tmp47_ = TRUE;
#line 4342 "../src/Photo.vala"
			while (TRUE) {
#line 30633 "Photo.c"
				gint xmin = 0;
				gint* _tmp49_;
				gint _tmp49__length1;
				gint _tmp50_;
				gint _tmp51_ = 0;
				gint xmax = 0;
				gint* _tmp52_;
				gint _tmp52__length1;
				gint _tmp53_;
				gint _tmp54_ = 0;
				gint _tmp55_;
				gint _tmp56_;
				gint _tmp63_;
#line 4342 "../src/Photo.vala"
				if (!_tmp47_) {
#line 30649 "Photo.c"
					gint _tmp48_;
#line 4342 "../src/Photo.vala"
					_tmp48_ = y_it;
#line 4342 "../src/Photo.vala"
					y_it = _tmp48_ + 1;
#line 30655 "Photo.c"
				}
#line 4342 "../src/Photo.vala"
				_tmp47_ = FALSE;
#line 4342 "../src/Photo.vala"
				if (!(y_it <= ymax)) {
#line 4342 "../src/Photo.vala"
					break;
#line 30663 "Photo.c"
				}
#line 4343 "../src/Photo.vala"
				_tmp49_ = x_insets_first_quadrant;
#line 4343 "../src/Photo.vala"
				_tmp49__length1 = x_insets_first_quadrant_length1;
#line 4343 "../src/Photo.vala"
				_tmp50_ = _tmp49_[inset_index];
#line 4343 "../src/Photo.vala"
				xmin = x_bounds_min + _tmp50_;
#line 4344 "../src/Photo.vala"
				if (xmin < 0) {
#line 4344 "../src/Photo.vala"
					_tmp51_ = 0;
#line 30677 "Photo.c"
				} else {
#line 4344 "../src/Photo.vala"
					_tmp51_ = xmin;
#line 30681 "Photo.c"
				}
#line 4344 "../src/Photo.vala"
				xmin = _tmp51_;
#line 4345 "../src/Photo.vala"
				_tmp52_ = x_insets_first_quadrant;
#line 4345 "../src/Photo.vala"
				_tmp52__length1 = x_insets_first_quadrant_length1;
#line 4345 "../src/Photo.vala"
				_tmp53_ = _tmp52_[inset_index];
#line 4345 "../src/Photo.vala"
				xmax = x_bounds_max - _tmp53_;
#line 4346 "../src/Photo.vala"
				_tmp55_ = gdk_pixbuf_get_width (pixbuf);
#line 4346 "../src/Photo.vala"
				_tmp56_ = _tmp55_;
#line 4346 "../src/Photo.vala"
				if (xmax > (_tmp56_ - 1)) {
#line 30699 "Photo.c"
					gint _tmp57_;
					gint _tmp58_;
#line 4346 "../src/Photo.vala"
					_tmp57_ = gdk_pixbuf_get_width (pixbuf);
#line 4346 "../src/Photo.vala"
					_tmp58_ = _tmp57_;
#line 4346 "../src/Photo.vala"
					_tmp54_ = _tmp58_ - 1;
#line 30708 "Photo.c"
				} else {
#line 4346 "../src/Photo.vala"
					_tmp54_ = xmax;
#line 30712 "Photo.c"
				}
#line 4346 "../src/Photo.vala"
				xmax = _tmp54_;
#line 30716 "Photo.c"
				{
					gint x_it = 0;
#line 4348 "../src/Photo.vala"
					x_it = xmin;
#line 30721 "Photo.c"
					{
						gboolean _tmp59_ = FALSE;
#line 4348 "../src/Photo.vala"
						_tmp59_ = TRUE;
#line 4348 "../src/Photo.vala"
						while (TRUE) {
#line 30728 "Photo.c"
							GdkPixbuf* _tmp61_;
							GdkPixbuf* _tmp62_;
#line 4348 "../src/Photo.vala"
							if (!_tmp59_) {
#line 30733 "Photo.c"
								gint _tmp60_;
#line 4348 "../src/Photo.vala"
								_tmp60_ = x_it;
#line 4348 "../src/Photo.vala"
								x_it = _tmp60_ + 1;
#line 30739 "Photo.c"
							}
#line 4348 "../src/Photo.vala"
							_tmp59_ = FALSE;
#line 4348 "../src/Photo.vala"
							if (!(x_it <= xmax)) {
#line 4348 "../src/Photo.vala"
								break;
#line 30747 "Photo.c"
							}
#line 4349 "../src/Photo.vala"
							_tmp61_ = photo_red_reduce_pixel (self, pixbuf, x_it, y_it);
#line 4349 "../src/Photo.vala"
							_tmp62_ = _tmp61_;
#line 4349 "../src/Photo.vala"
							_g_object_unref0 (_tmp62_);
#line 30755 "Photo.c"
						}
					}
				}
#line 4351 "../src/Photo.vala"
				_tmp63_ = inset_index;
#line 4351 "../src/Photo.vala"
				inset_index = _tmp63_ - 1;
#line 30763 "Photo.c"
			}
		}
	}
#line 4354 "../src/Photo.vala"
	_tmp64_ = _g_object_ref0 (pixbuf);
#line 4354 "../src/Photo.vala"
	result = _tmp64_;
#line 4354 "../src/Photo.vala"
	x_insets_first_quadrant = (g_free (x_insets_first_quadrant), NULL);
#line 4354 "../src/Photo.vala"
	return result;
#line 30775 "Photo.c"
}

static GdkPixbuf*
photo_red_reduce_pixel (Photo* self,
                        GdkPixbuf* pixbuf,
                        gint x,
                        gint y)
{
	gint px_start_byte_offset = 0;
	gboolean _tmp0_ = FALSE;
	gboolean _tmp1_ = FALSE;
	gboolean _tmp2_ = FALSE;
	GdkPixbuf* _tmp13_;
	GdkPixbuf* result;
#line 4357 "../src/Photo.vala"
	g_return_val_if_fail (IS_PHOTO (self), NULL);
#line 4357 "../src/Photo.vala"
	g_return_val_if_fail (G_TYPE_CHECK_INSTANCE_TYPE (pixbuf, gdk_pixbuf_get_type ()), NULL);
#line 4358 "../src/Photo.vala"
	px_start_byte_offset = (y * gdk_pixbuf_get_rowstride (pixbuf)) + (x * gdk_pixbuf_get_n_channels (pixbuf));
#line 4365 "../src/Photo.vala"
	if (x >= 0) {
#line 4365 "../src/Photo.vala"
		_tmp2_ = y >= 0;
#line 30800 "Photo.c"
	} else {
#line 4365 "../src/Photo.vala"
		_tmp2_ = FALSE;
#line 30804 "Photo.c"
	}
#line 4365 "../src/Photo.vala"
	if (_tmp2_) {
#line 30808 "Photo.c"
		gint _tmp3_;
		gint _tmp4_;
#line 4365 "../src/Photo.vala"
		_tmp3_ = gdk_pixbuf_get_width (pixbuf);
#line 4365 "../src/Photo.vala"
		_tmp4_ = _tmp3_;
#line 4365 "../src/Photo.vala"
		_tmp1_ = x < _tmp4_;
#line 30817 "Photo.c"
	} else {
#line 4365 "../src/Photo.vala"
		_tmp1_ = FALSE;
#line 30821 "Photo.c"
	}
#line 4365 "../src/Photo.vala"
	if (_tmp1_) {
#line 30825 "Photo.c"
		gint _tmp5_;
		gint _tmp6_;
#line 4365 "../src/Photo.vala"
		_tmp5_ = gdk_pixbuf_get_height (pixbuf);
#line 4365 "../src/Photo.vala"
		_tmp6_ = _tmp5_;
#line 4365 "../src/Photo.vala"
		_tmp0_ = y < _tmp6_;
#line 30834 "Photo.c"
	} else {
#line 4365 "../src/Photo.vala"
		_tmp0_ = FALSE;
#line 30838 "Photo.c"
	}
#line 4365 "../src/Photo.vala"
	if (_tmp0_) {
#line 30842 "Photo.c"
		guchar* pixel_data = NULL;
		guint8* _tmp7_;
		gint pixel_data_length1;
		gint _pixel_data_size_;
		guchar g = '\0';
		guchar* _tmp8_;
		gint _tmp8__length1;
		guchar _tmp9_;
		guchar b = '\0';
		guchar* _tmp10_;
		gint _tmp10__length1;
		guchar _tmp11_;
		guchar r = '\0';
		guchar* _tmp12_;
		gint _tmp12__length1;
#line 4366 "../src/Photo.vala"
		_tmp7_ = gdk_pixbuf_get_pixels (pixbuf);
#line 4366 "../src/Photo.vala"
		pixel_data = _tmp7_;
#line 4366 "../src/Photo.vala"
		pixel_data_length1 = -1;
#line 4366 "../src/Photo.vala"
		_pixel_data_size_ = pixel_data_length1;
#line 4376 "../src/Photo.vala"
		_tmp8_ = pixel_data;
#line 4376 "../src/Photo.vala"
		_tmp8__length1 = pixel_data_length1;
#line 4376 "../src/Photo.vala"
		_tmp9_ = _tmp8_[px_start_byte_offset + 1];
#line 4376 "../src/Photo.vala"
		g = _tmp9_;
#line 4377 "../src/Photo.vala"
		_tmp10_ = pixel_data;
#line 4377 "../src/Photo.vala"
		_tmp10__length1 = pixel_data_length1;
#line 4377 "../src/Photo.vala"
		_tmp11_ = _tmp10_[px_start_byte_offset + 2];
#line 4377 "../src/Photo.vala"
		b = _tmp11_;
#line 4379 "../src/Photo.vala"
		r = (guchar) ((g + b) / 2);
#line 4381 "../src/Photo.vala"
		_tmp12_ = pixel_data;
#line 4381 "../src/Photo.vala"
		_tmp12__length1 = pixel_data_length1;
#line 4381 "../src/Photo.vala"
		_tmp12_[px_start_byte_offset] = r;
#line 30890 "Photo.c"
	}
#line 4384 "../src/Photo.vala"
	_tmp13_ = _g_object_ref0 (pixbuf);
#line 4384 "../src/Photo.vala"
	result = _tmp13_;
#line 4384 "../src/Photo.vala"
	return result;
#line 30898 "Photo.c"
}

void
photo_unscaled_to_raw_point (Photo* self,
                             GdkPoint* unscaled_point,
                             GdkPoint* result)
{
	Orientation unscaled_orientation = 0;
	Dimensions unscaled_dims = {0};
	Dimensions _tmp0_ = {0};
	Dimensions _tmp1_ = {0};
	gint unscaled_x_offset_raw = 0;
	gint unscaled_y_offset_raw = 0;
	Box crop_box = {0};
	Box _tmp2_ = {0};
	gboolean _tmp3_;
	GdkPoint derotated_point = {0};
	Dimensions _tmp6_;
	GdkPoint _tmp7_;
	GdkPoint _tmp8_ = {0};
#line 4387 "../src/Photo.vala"
	g_return_if_fail (IS_PHOTO (self));
#line 4387 "../src/Photo.vala"
	g_return_if_fail (unscaled_point != NULL);
#line 4388 "../src/Photo.vala"
	unscaled_orientation = photo_get_orientation (self);
#line 4390 "../src/Photo.vala"
	media_source_get_dimensions (G_TYPE_CHECK_INSTANCE_CAST (self, TYPE_MEDIA_SOURCE, MediaSource), PHOTO_EXCEPTION_NONE, &_tmp0_);
#line 4390 "../src/Photo.vala"
	orientation_rotate_dimensions (unscaled_orientation, &_tmp0_, &_tmp1_);
#line 4390 "../src/Photo.vala"
	unscaled_dims = _tmp1_;
#line 4393 "../src/Photo.vala"
	unscaled_x_offset_raw = 0;
#line 4394 "../src/Photo.vala"
	unscaled_y_offset_raw = 0;
#line 4397 "../src/Photo.vala"
	_tmp3_ = photo_get_raw_crop (self, &_tmp2_);
#line 4397 "../src/Photo.vala"
	crop_box = _tmp2_;
#line 4397 "../src/Photo.vala"
	if (_tmp3_) {
#line 30941 "Photo.c"
		Box _tmp4_;
		Box _tmp5_;
#line 4398 "../src/Photo.vala"
		_tmp4_ = crop_box;
#line 4398 "../src/Photo.vala"
		unscaled_x_offset_raw = _tmp4_.left;
#line 4399 "../src/Photo.vala"
		_tmp5_ = crop_box;
#line 4399 "../src/Photo.vala"
		unscaled_y_offset_raw = _tmp5_.top;
#line 30952 "Photo.c"
	}
#line 4402 "../src/Photo.vala"
	_tmp6_ = unscaled_dims;
#line 4402 "../src/Photo.vala"
	_tmp7_ = *unscaled_point;
#line 4402 "../src/Photo.vala"
	orientation_derotate_point (unscaled_orientation, &_tmp6_, &_tmp7_, &_tmp8_);
#line 4402 "../src/Photo.vala"
	derotated_point = _tmp8_;
#line 4406 "../src/Photo.vala"
	derotated_point.x = derotated_point.x + unscaled_x_offset_raw;
#line 4407 "../src/Photo.vala"
	derotated_point.y = derotated_point.y + unscaled_y_offset_raw;
#line 4409 "../src/Photo.vala"
	*result = derotated_point;
#line 4409 "../src/Photo.vala"
	return;
#line 30970 "Photo.c"
}

void
photo_unscaled_to_raw_rect (Photo* self,
                            GdkRectangle* unscaled_rect,
                            GdkRectangle* result)
{
	GdkPoint upper_left = {0};
	GdkPoint _tmp0_ = {0};
	GdkPoint lower_right = {0};
	GdkPoint _tmp1_ = {0};
	GdkRectangle _tmp2_;
	GdkRectangle _tmp3_;
	GdkPoint _tmp4_;
	GdkRectangle _tmp5_;
	GdkPoint _tmp6_;
	GdkRectangle _tmp7_;
	GdkPoint _tmp8_;
	GdkPoint _tmp9_ = {0};
	GdkPoint _tmp10_;
	GdkPoint _tmp11_ = {0};
	GdkPoint _tmp12_;
	GdkPoint _tmp13_;
	GdkPoint _tmp16_;
	GdkPoint _tmp17_;
	GdkRectangle raw_rect = {0};
	GdkPoint _tmp20_;
	GdkPoint _tmp21_;
	GdkPoint _tmp22_;
	GdkPoint _tmp23_;
	GdkPoint _tmp24_;
	GdkPoint _tmp25_;
#line 4412 "../src/Photo.vala"
	g_return_if_fail (IS_PHOTO (self));
#line 4412 "../src/Photo.vala"
	g_return_if_fail (unscaled_rect != NULL);
#line 4413 "../src/Photo.vala"
	_tmp0_.x = 0;
#line 4413 "../src/Photo.vala"
	upper_left = _tmp0_;
#line 4414 "../src/Photo.vala"
	_tmp1_.x = 0;
#line 4414 "../src/Photo.vala"
	lower_right = _tmp1_;
#line 4415 "../src/Photo.vala"
	_tmp2_ = *unscaled_rect;
#line 4415 "../src/Photo.vala"
	upper_left.x = _tmp2_.x;
#line 4416 "../src/Photo.vala"
	_tmp3_ = *unscaled_rect;
#line 4416 "../src/Photo.vala"
	upper_left.y = _tmp3_.y;
#line 4417 "../src/Photo.vala"
	_tmp4_ = upper_left;
#line 4417 "../src/Photo.vala"
	_tmp5_ = *unscaled_rect;
#line 4417 "../src/Photo.vala"
	lower_right.x = _tmp4_.x + _tmp5_.width;
#line 4418 "../src/Photo.vala"
	_tmp6_ = upper_left;
#line 4418 "../src/Photo.vala"
	_tmp7_ = *unscaled_rect;
#line 4418 "../src/Photo.vala"
	lower_right.y = _tmp6_.y + _tmp7_.height;
#line 4420 "../src/Photo.vala"
	_tmp8_ = upper_left;
#line 4420 "../src/Photo.vala"
	photo_unscaled_to_raw_point (self, &_tmp8_, &_tmp9_);
#line 4420 "../src/Photo.vala"
	upper_left = _tmp9_;
#line 4421 "../src/Photo.vala"
	_tmp10_ = lower_right;
#line 4421 "../src/Photo.vala"
	photo_unscaled_to_raw_point (self, &_tmp10_, &_tmp11_);
#line 4421 "../src/Photo.vala"
	lower_right = _tmp11_;
#line 4423 "../src/Photo.vala"
	_tmp12_ = upper_left;
#line 4423 "../src/Photo.vala"
	_tmp13_ = lower_right;
#line 4423 "../src/Photo.vala"
	if (_tmp12_.x > _tmp13_.x) {
#line 31053 "Photo.c"
		gint temp = 0;
		GdkPoint _tmp14_;
		GdkPoint _tmp15_;
#line 4424 "../src/Photo.vala"
		_tmp14_ = upper_left;
#line 4424 "../src/Photo.vala"
		temp = _tmp14_.x;
#line 4425 "../src/Photo.vala"
		_tmp15_ = lower_right;
#line 4425 "../src/Photo.vala"
		upper_left.x = _tmp15_.x;
#line 4426 "../src/Photo.vala"
		lower_right.x = temp;
#line 31067 "Photo.c"
	}
#line 4428 "../src/Photo.vala"
	_tmp16_ = upper_left;
#line 4428 "../src/Photo.vala"
	_tmp17_ = lower_right;
#line 4428 "../src/Photo.vala"
	if (_tmp16_.y > _tmp17_.y) {
#line 31075 "Photo.c"
		gint temp = 0;
		GdkPoint _tmp18_;
		GdkPoint _tmp19_;
#line 4429 "../src/Photo.vala"
		_tmp18_ = upper_left;
#line 4429 "../src/Photo.vala"
		temp = _tmp18_.y;
#line 4430 "../src/Photo.vala"
		_tmp19_ = lower_right;
#line 4430 "../src/Photo.vala"
		upper_left.y = _tmp19_.y;
#line 4431 "../src/Photo.vala"
		lower_right.y = temp;
#line 31089 "Photo.c"
	}
#line 4434 "../src/Photo.vala"
	memset (&raw_rect, 0, sizeof (GdkRectangle));
#line 4435 "../src/Photo.vala"
	_tmp20_ = upper_left;
#line 4435 "../src/Photo.vala"
	raw_rect.x = _tmp20_.x;
#line 4436 "../src/Photo.vala"
	_tmp21_ = upper_left;
#line 4436 "../src/Photo.vala"
	raw_rect.y = _tmp21_.y;
#line 4437 "../src/Photo.vala"
	_tmp22_ = lower_right;
#line 4437 "../src/Photo.vala"
	_tmp23_ = upper_left;
#line 4437 "../src/Photo.vala"
	raw_rect.width = _tmp22_.x - _tmp23_.x;
#line 4438 "../src/Photo.vala"
	_tmp24_ = lower_right;
#line 4438 "../src/Photo.vala"
	_tmp25_ = upper_left;
#line 4438 "../src/Photo.vala"
	raw_rect.height = _tmp24_.y - _tmp25_.y;
#line 4440 "../src/Photo.vala"
	*result = raw_rect;
#line 4440 "../src/Photo.vala"
	return;
#line 31117 "Photo.c"
}

PixelTransformationBundle*
photo_get_enhance_transformations (Photo* self)
{
	GdkPixbuf* pixbuf = NULL;
	PixelTransformationBundle* transformations = NULL;
	GdkPixbuf* _tmp4_;
	PixelTransformationBundle* _tmp5_;
	GError* _inner_error0_ = NULL;
	PixelTransformationBundle* result;
#line 4443 "../src/Photo.vala"
	g_return_val_if_fail (IS_PHOTO (self), NULL);
#line 4444 "../src/Photo.vala"
	pixbuf = NULL;
#line 31133 "Photo.c"
	{
		GdkPixbuf* _tmp0_ = NULL;
		Scaling _tmp1_ = {0};
		GdkPixbuf* _tmp2_;
		GdkPixbuf* _tmp3_;
#line 4451 "../src/Photo.vala"
		scaling_for_best_fit (360, FALSE, &_tmp1_);
#line 4451 "../src/Photo.vala"
		_tmp2_ = photo_get_pixbuf_with_options (self, &_tmp1_, PHOTO_EXCEPTION_ALL, BACKING_FETCH_MODE_BASELINE, &_inner_error0_);
#line 4451 "../src/Photo.vala"
		_tmp0_ = _tmp2_;
#line 4451 "../src/Photo.vala"
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 31147 "Photo.c"
			goto __catch0_g_error;
		}
#line 4451 "../src/Photo.vala"
		_tmp3_ = _tmp0_;
#line 4451 "../src/Photo.vala"
		_tmp0_ = NULL;
#line 4451 "../src/Photo.vala"
		_g_object_unref0 (pixbuf);
#line 4451 "../src/Photo.vala"
		pixbuf = _tmp3_;
#line 4450 "../src/Photo.vala"
		_g_object_unref0 (_tmp0_);
#line 31160 "Photo.c"
	}
	goto __finally0;
	__catch0_g_error:
	{
#line 4450 "../src/Photo.vala"
		g_clear_error (&_inner_error0_);
#line 4458 "../src/Photo.vala"
		g_warning ("Photo.vala:4458: %s", "Photo: get_enhance_transformations: couldn't obtain pixbuf to build " "transform histogram");
#line 4460 "../src/Photo.vala"
		result = NULL;
#line 4460 "../src/Photo.vala"
		_g_object_unref0 (pixbuf);
#line 4460 "../src/Photo.vala"
		return result;
#line 31175 "Photo.c"
	}
	__finally0:
#line 4450 "../src/Photo.vala"
	if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 4450 "../src/Photo.vala"
		_g_object_unref0 (pixbuf);
#line 4450 "../src/Photo.vala"
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 4450 "../src/Photo.vala"
		g_clear_error (&_inner_error0_);
#line 4450 "../src/Photo.vala"
		return NULL;
#line 31188 "Photo.c"
	}
#line 4467 "../src/Photo.vala"
	_tmp4_ = pixbuf;
#line 4467 "../src/Photo.vala"
	_tmp5_ = auto_enhance_create_auto_enhance_adjustments (_tmp4_);
#line 4467 "../src/Photo.vala"
	transformations = _tmp5_;
#line 4475 "../src/Photo.vala"
	result = transformations;
#line 4475 "../src/Photo.vala"
	_g_object_unref0 (pixbuf);
#line 4475 "../src/Photo.vala"
	return result;
#line 31202 "Photo.c"
}

gboolean
photo_enhance (Photo* self)
{
	PixelTransformationBundle* transformations = NULL;
	PixelTransformationBundle* _tmp0_;
	PixelTransformationBundle* _tmp1_;
	GError* _inner_error0_ = NULL;
	gboolean result;
#line 4478 "../src/Photo.vala"
	g_return_val_if_fail (IS_PHOTO (self), FALSE);
#line 4479 "../src/Photo.vala"
	_tmp0_ = photo_get_enhance_transformations (self);
#line 4479 "../src/Photo.vala"
	transformations = _tmp0_;
#line 4481 "../src/Photo.vala"
	_tmp1_ = transformations;
#line 4481 "../src/Photo.vala"
	if (_tmp1_ == NULL) {
#line 4482 "../src/Photo.vala"
		result = FALSE;
#line 4482 "../src/Photo.vala"
		_pixel_transformation_bundle_unref0 (transformations);
#line 4482 "../src/Photo.vala"
		return result;
#line 31229 "Photo.c"
	}
	{
		PhotoRow* _tmp2_;
#line 4487 "../src/Photo.vala"
		_tmp2_ = self->row;
#line 4487 "../src/Photo.vala"
		g_rec_mutex_lock (&self->priv->__lock_row);
#line 31237 "Photo.c"
		{
			PixelTransformationBundle* _tmp3_;
#line 4488 "../src/Photo.vala"
			_tmp3_ = transformations;
#line 4488 "../src/Photo.vala"
			photo_set_color_adjustments (self, _tmp3_);
#line 31244 "Photo.c"
		}
		__finally0:
		{
			PhotoRow* _tmp4_;
#line 4487 "../src/Photo.vala"
			_tmp4_ = self->row;
#line 4487 "../src/Photo.vala"
			g_rec_mutex_unlock (&self->priv->__lock_row);
#line 31253 "Photo.c"
		}
#line 4487 "../src/Photo.vala"
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 31257 "Photo.c"
			gboolean _tmp5_ = FALSE;
#line 4487 "../src/Photo.vala"
			_pixel_transformation_bundle_unref0 (transformations);
#line 4487 "../src/Photo.vala"
			g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 4487 "../src/Photo.vala"
			g_clear_error (&_inner_error0_);
#line 4487 "../src/Photo.vala"
			return _tmp5_;
#line 31267 "Photo.c"
		}
	}
#line 4495 "../src/Photo.vala"
	result = TRUE;
#line 4495 "../src/Photo.vala"
	_pixel_transformation_bundle_unref0 (transformations);
#line 4495 "../src/Photo.vala"
	return result;
#line 31276 "Photo.c"
}

gboolean
photo_get_develop_raw_photos_to_files (void)
{
	gboolean result;
#line 346 "../src/Photo.vala"
	result = photo__develop_raw_photos_to_files;
#line 346 "../src/Photo.vala"
	return result;
#line 31287 "Photo.c"
}

void
photo_set_develop_raw_photos_to_files (gboolean value)
{
#line 346 "../src/Photo.vala"
	photo__develop_raw_photos_to_files = value;
#line 31295 "Photo.c"
}

static void
photo_real_editable_replaced (Photo* self,
                              GFile* old_file,
                              GFile* new_file)
{
#line 355 "../src/Photo.vala"
	g_return_if_fail ((old_file == NULL) || G_TYPE_CHECK_INSTANCE_TYPE (old_file, g_file_get_type ()));
#line 355 "../src/Photo.vala"
	g_return_if_fail ((new_file == NULL) || G_TYPE_CHECK_INSTANCE_TYPE (new_file, g_file_get_type ()));
#line 31307 "Photo.c"
}

static void
g_cclosure_user_marshal_VOID__OBJECT_OBJECT (GClosure * closure,
                                             GValue * return_value,
                                             guint n_param_values,
                                             const GValue * param_values,
                                             gpointer invocation_hint,
                                             gpointer marshal_data)
{
	typedef void (*GMarshalFunc_VOID__OBJECT_OBJECT) (gpointer data1, gpointer arg_1, gpointer arg_2, gpointer data2);
	register GMarshalFunc_VOID__OBJECT_OBJECT callback;
	register GCClosure * cc;
	register gpointer data1;
	register gpointer data2;
	cc = (GCClosure *) closure;
#line 158 "../src/Photo.vala"
	g_return_if_fail (n_param_values == 3);
#line 158 "../src/Photo.vala"
	if (G_CCLOSURE_SWAP_DATA (closure)) {
#line 158 "../src/Photo.vala"
		data1 = closure->data;
#line 158 "../src/Photo.vala"
		data2 = param_values->data[0].v_pointer;
#line 31332 "Photo.c"
	} else {
#line 158 "../src/Photo.vala"
		data1 = param_values->data[0].v_pointer;
#line 158 "../src/Photo.vala"
		data2 = closure->data;
#line 31338 "Photo.c"
	}
#line 158 "../src/Photo.vala"
	callback = (GMarshalFunc_VOID__OBJECT_OBJECT) (marshal_data ? marshal_data : cc->callback);
#line 158 "../src/Photo.vala"
	callback (data1, g_value_get_object (param_values + 1), g_value_get_object (param_values + 2), data2);
#line 31344 "Photo.c"
}

static void
photo_real_raw_development_modified (Photo* self)
{
}

static void
photo_real_baseline_replaced (Photo* self)
{
}

static void
photo_real_master_reimported (Photo* self,
                              PhotoMetadata* metadata)
{
#line 373 "../src/Photo.vala"
	g_return_if_fail ((metadata == NULL) || IS_PHOTO_METADATA (metadata));
#line 31363 "Photo.c"
}

static void
g_cclosure_user_marshal_VOID__MEDIA_METADATA (GClosure * closure,
                                              GValue * return_value,
                                              guint n_param_values,
                                              const GValue * param_values,
                                              gpointer invocation_hint,
                                              gpointer marshal_data)
{
	typedef void (*GMarshalFunc_VOID__MEDIA_METADATA) (gpointer data1, gpointer arg_1, gpointer data2);
	register GMarshalFunc_VOID__MEDIA_METADATA callback;
	register GCClosure * cc;
	register gpointer data1;
	register gpointer data2;
	cc = (GCClosure *) closure;
#line 158 "../src/Photo.vala"
	g_return_if_fail (n_param_values == 2);
#line 158 "../src/Photo.vala"
	if (G_CCLOSURE_SWAP_DATA (closure)) {
#line 158 "../src/Photo.vala"
		data1 = closure->data;
#line 158 "../src/Photo.vala"
		data2 = param_values->data[0].v_pointer;
#line 31388 "Photo.c"
	} else {
#line 158 "../src/Photo.vala"
		data1 = param_values->data[0].v_pointer;
#line 158 "../src/Photo.vala"
		data2 = closure->data;
#line 31394 "Photo.c"
	}
#line 158 "../src/Photo.vala"
	callback = (GMarshalFunc_VOID__MEDIA_METADATA) (marshal_data ? marshal_data : cc->callback);
#line 158 "../src/Photo.vala"
	callback (data1, value_get_media_metadata (param_values + 1), data2);
#line 31400 "Photo.c"
}

static void
photo_real_editable_reimported (Photo* self,
                                PhotoMetadata* metadata)
{
#line 377 "../src/Photo.vala"
	g_return_if_fail ((metadata == NULL) || IS_PHOTO_METADATA (metadata));
#line 31409 "Photo.c"
}

static void
photo_real_baseline_reimported (Photo* self,
                                PhotoMetadata* metadata)
{
#line 384 "../src/Photo.vala"
	g_return_if_fail ((metadata == NULL) || IS_PHOTO_METADATA (metadata));
#line 31418 "Photo.c"
}

static void
photo_real_source_reimported (Photo* self,
                              PhotoMetadata* metadata)
{
#line 391 "../src/Photo.vala"
	g_return_if_fail ((metadata == NULL) || IS_PHOTO_METADATA (metadata));
#line 31427 "Photo.c"
}

static inline gpointer
photo_photo_transformation_state_impl_get_instance_private (PhotoPhotoTransformationStateImpl* self)
{
	return G_STRUCT_MEMBER_P (self, PhotoPhotoTransformationStateImpl_private_offset);
}

static void
_photo_photo_transformation_state_impl_on_photo_baseline_replaced_photo_baseline_replaced (Photo* _sender,
                                                                                           gpointer self)
{
#line 254 "../src/Photo.vala"
	photo_photo_transformation_state_impl_on_photo_baseline_replaced ((PhotoPhotoTransformationStateImpl*) self);
#line 31442 "Photo.c"
}

static PhotoPhotoTransformationStateImpl*
photo_photo_transformation_state_impl_construct (GType object_type,
                                                 Photo* photo,
                                                 Orientation orientation,
                                                 GeeHashMap* transformations,
                                                 PixelTransformer* transformer,
                                                 PixelTransformationBundle* adjustments)
{
	PhotoPhotoTransformationStateImpl * self = NULL;
	Photo* _tmp0_;
	GeeHashMap* _tmp1_;
	PixelTransformer* _tmp2_;
	PixelTransformationBundle* _tmp3_;
#line 241 "../src/Photo.vala"
	g_return_val_if_fail (IS_PHOTO (photo), NULL);
#line 241 "../src/Photo.vala"
	g_return_val_if_fail ((transformations == NULL) || G_TYPE_CHECK_INSTANCE_TYPE (transformations, GEE_TYPE_HASH_MAP), NULL);
#line 241 "../src/Photo.vala"
	g_return_val_if_fail ((transformer == NULL) || G_TYPE_CHECK_INSTANCE_TYPE (transformer, TYPE_PIXEL_TRANSFORMER), NULL);
#line 241 "../src/Photo.vala"
	g_return_val_if_fail ((adjustments == NULL) || G_TYPE_CHECK_INSTANCE_TYPE (adjustments, TYPE_PIXEL_TRANSFORMATION_BUNDLE), NULL);
#line 241 "../src/Photo.vala"
	self = (PhotoPhotoTransformationStateImpl*) photo_transformation_state_construct (object_type);
#line 244 "../src/Photo.vala"
	_tmp0_ = _g_object_ref0 (photo);
#line 244 "../src/Photo.vala"
	_g_object_unref0 (self->priv->photo);
#line 244 "../src/Photo.vala"
	self->priv->photo = _tmp0_;
#line 245 "../src/Photo.vala"
	self->priv->orientation = orientation;
#line 246 "../src/Photo.vala"
	_tmp1_ = photo_photo_transformation_state_impl_copy_transformations (transformations);
#line 246 "../src/Photo.vala"
	_g_object_unref0 (self->priv->transformations);
#line 246 "../src/Photo.vala"
	self->priv->transformations = _tmp1_;
#line 247 "../src/Photo.vala"
	_tmp2_ = _pixel_transformer_ref0 (transformer);
#line 247 "../src/Photo.vala"
	_pixel_transformer_unref0 (self->priv->transformer);
#line 247 "../src/Photo.vala"
	self->priv->transformer = _tmp2_;
#line 248 "../src/Photo.vala"
	_tmp3_ = _pixel_transformation_bundle_ref0 (adjustments);
#line 248 "../src/Photo.vala"
	_pixel_transformation_bundle_unref0 (self->priv->adjustments);
#line 248 "../src/Photo.vala"
	self->priv->adjustments = _tmp3_;
#line 250 "../src/Photo.vala"
	g_signal_connect_object (photo, "baseline-replaced", (GCallback) _photo_photo_transformation_state_impl_on_photo_baseline_replaced_photo_baseline_replaced, self, 0);
#line 241 "../src/Photo.vala"
	return self;
#line 31498 "Photo.c"
}

static PhotoPhotoTransformationStateImpl*
photo_photo_transformation_state_impl_new (Photo* photo,
                                           Orientation orientation,
                                           GeeHashMap* transformations,
                                           PixelTransformer* transformer,
                                           PixelTransformationBundle* adjustments)
{
#line 241 "../src/Photo.vala"
	return photo_photo_transformation_state_impl_construct (PHOTO_TYPE_PHOTO_TRANSFORMATION_STATE_IMPL, photo, orientation, transformations, transformer, adjustments);
#line 31510 "Photo.c"
}

static Orientation
photo_photo_transformation_state_impl_get_orientation (PhotoPhotoTransformationStateImpl* self)
{
	Orientation result;
#line 257 "../src/Photo.vala"
	g_return_val_if_fail (PHOTO_IS_PHOTO_TRANSFORMATION_STATE_IMPL (self), 0);
#line 258 "../src/Photo.vala"
	result = self->priv->orientation;
#line 258 "../src/Photo.vala"
	return result;
#line 31523 "Photo.c"
}

static GeeHashMap*
photo_photo_transformation_state_impl_get_transformations (PhotoPhotoTransformationStateImpl* self)
{
	GeeHashMap* _tmp0_;
	GeeHashMap* _tmp1_;
	GeeHashMap* result;
#line 261 "../src/Photo.vala"
	g_return_val_if_fail (PHOTO_IS_PHOTO_TRANSFORMATION_STATE_IMPL (self), NULL);
#line 262 "../src/Photo.vala"
	_tmp0_ = self->priv->transformations;
#line 262 "../src/Photo.vala"
	_tmp1_ = photo_photo_transformation_state_impl_copy_transformations (_tmp0_);
#line 262 "../src/Photo.vala"
	result = _tmp1_;
#line 262 "../src/Photo.vala"
	return result;
#line 31542 "Photo.c"
}

static PixelTransformer*
photo_photo_transformation_state_impl_get_transformer (PhotoPhotoTransformationStateImpl* self)
{
	PixelTransformer* _tmp0_ = NULL;
	PixelTransformer* _tmp1_;
	PixelTransformer* result;
#line 265 "../src/Photo.vala"
	g_return_val_if_fail (PHOTO_IS_PHOTO_TRANSFORMATION_STATE_IMPL (self), NULL);
#line 266 "../src/Photo.vala"
	_tmp1_ = self->priv->transformer;
#line 266 "../src/Photo.vala"
	if (_tmp1_ != NULL) {
#line 31557 "Photo.c"
		PixelTransformer* _tmp2_;
		PixelTransformer* _tmp3_;
#line 266 "../src/Photo.vala"
		_tmp2_ = self->priv->transformer;
#line 266 "../src/Photo.vala"
		_tmp3_ = pixel_transformer_copy (_tmp2_);
#line 266 "../src/Photo.vala"
		_pixel_transformer_unref0 (_tmp0_);
#line 266 "../src/Photo.vala"
		_tmp0_ = _tmp3_;
#line 31568 "Photo.c"
	} else {
#line 266 "../src/Photo.vala"
		_pixel_transformer_unref0 (_tmp0_);
#line 266 "../src/Photo.vala"
		_tmp0_ = NULL;
#line 31574 "Photo.c"
	}
#line 266 "../src/Photo.vala"
	result = _tmp0_;
#line 266 "../src/Photo.vala"
	return result;
#line 31580 "Photo.c"
}

static PixelTransformationBundle*
photo_photo_transformation_state_impl_get_color_adjustments (PhotoPhotoTransformationStateImpl* self)
{
	PixelTransformationBundle* _tmp0_ = NULL;
	PixelTransformationBundle* _tmp1_;
	PixelTransformationBundle* result;
#line 269 "../src/Photo.vala"
	g_return_val_if_fail (PHOTO_IS_PHOTO_TRANSFORMATION_STATE_IMPL (self), NULL);
#line 270 "../src/Photo.vala"
	_tmp1_ = self->priv->adjustments;
#line 270 "../src/Photo.vala"
	if (_tmp1_ != NULL) {
#line 31595 "Photo.c"
		PixelTransformationBundle* _tmp2_;
		PixelTransformationBundle* _tmp3_;
#line 270 "../src/Photo.vala"
		_tmp2_ = self->priv->adjustments;
#line 270 "../src/Photo.vala"
		_tmp3_ = pixel_transformation_bundle_copy (_tmp2_);
#line 270 "../src/Photo.vala"
		_pixel_transformation_bundle_unref0 (_tmp0_);
#line 270 "../src/Photo.vala"
		_tmp0_ = _tmp3_;
#line 31606 "Photo.c"
	} else {
#line 270 "../src/Photo.vala"
		_pixel_transformation_bundle_unref0 (_tmp0_);
#line 270 "../src/Photo.vala"
		_tmp0_ = NULL;
#line 31612 "Photo.c"
	}
#line 270 "../src/Photo.vala"
	result = _tmp0_;
#line 270 "../src/Photo.vala"
	return result;
#line 31618 "Photo.c"
}

static GeeHashMap*
photo_photo_transformation_state_impl_copy_transformations (GeeHashMap* original)
{
	GeeHashMap* clone = NULL;
	GeeHashMap* _tmp0_;
	GeeHashMap* result;
#line 273 "../src/Photo.vala"
	g_return_val_if_fail ((original == NULL) || G_TYPE_CHECK_INSTANCE_TYPE (original, GEE_TYPE_HASH_MAP), NULL);
#line 275 "../src/Photo.vala"
	if (original == NULL) {
#line 276 "../src/Photo.vala"
		result = NULL;
#line 276 "../src/Photo.vala"
		return result;
#line 31635 "Photo.c"
	}
#line 278 "../src/Photo.vala"
	_tmp0_ = gee_hash_map_new (G_TYPE_STRING, (GBoxedCopyFunc) g_strdup, (GDestroyNotify) g_free, TYPE_KEY_VALUE_MAP, (GBoxedCopyFunc) key_value_map_ref, (GDestroyNotify) key_value_map_unref, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL);
#line 278 "../src/Photo.vala"
	clone = _tmp0_;
#line 31641 "Photo.c"
	{
		GeeIterator* _object_it = NULL;
		GeeSet* _tmp1_;
		GeeSet* _tmp2_;
		GeeSet* _tmp3_;
		GeeIterator* _tmp4_;
		GeeIterator* _tmp5_;
#line 279 "../src/Photo.vala"
		_tmp1_ = gee_abstract_map_get_keys (G_TYPE_CHECK_INSTANCE_CAST (original, GEE_TYPE_ABSTRACT_MAP, GeeAbstractMap));
#line 279 "../src/Photo.vala"
		_tmp2_ = _tmp1_;
#line 279 "../src/Photo.vala"
		_tmp3_ = _tmp2_;
#line 279 "../src/Photo.vala"
		_tmp4_ = gee_iterable_iterator (G_TYPE_CHECK_INSTANCE_CAST (_tmp3_, GEE_TYPE_ITERABLE, GeeIterable));
#line 279 "../src/Photo.vala"
		_tmp5_ = _tmp4_;
#line 279 "../src/Photo.vala"
		_g_object_unref0 (_tmp3_);
#line 279 "../src/Photo.vala"
		_object_it = _tmp5_;
#line 279 "../src/Photo.vala"
		while (TRUE) {
#line 31665 "Photo.c"
			GeeIterator* _tmp6_;
			gchar* object = NULL;
			GeeIterator* _tmp7_;
			gpointer _tmp8_;
			GeeHashMap* _tmp9_;
			const gchar* _tmp10_;
			const gchar* _tmp11_;
			gpointer _tmp12_;
			KeyValueMap* _tmp13_;
			KeyValueMap* _tmp14_;
			KeyValueMap* _tmp15_;
#line 279 "../src/Photo.vala"
			_tmp6_ = _object_it;
#line 279 "../src/Photo.vala"
			if (!gee_iterator_next (_tmp6_)) {
#line 279 "../src/Photo.vala"
				break;
#line 31683 "Photo.c"
			}
#line 279 "../src/Photo.vala"
			_tmp7_ = _object_it;
#line 279 "../src/Photo.vala"
			_tmp8_ = gee_iterator_get (_tmp7_);
#line 279 "../src/Photo.vala"
			object = (gchar*) _tmp8_;
#line 280 "../src/Photo.vala"
			_tmp9_ = clone;
#line 280 "../src/Photo.vala"
			_tmp10_ = object;
#line 280 "../src/Photo.vala"
			_tmp11_ = object;
#line 280 "../src/Photo.vala"
			_tmp12_ = gee_abstract_map_get (G_TYPE_CHECK_INSTANCE_CAST (original, GEE_TYPE_ABSTRACT_MAP, GeeAbstractMap), _tmp11_);
#line 280 "../src/Photo.vala"
			_tmp13_ = (KeyValueMap*) _tmp12_;
#line 280 "../src/Photo.vala"
			_tmp14_ = key_value_map_copy (_tmp13_);
#line 280 "../src/Photo.vala"
			_tmp15_ = _tmp14_;
#line 280 "../src/Photo.vala"
			gee_abstract_map_set (G_TYPE_CHECK_INSTANCE_CAST (_tmp9_, GEE_TYPE_ABSTRACT_MAP, GeeAbstractMap), _tmp10_, _tmp15_);
#line 280 "../src/Photo.vala"
			_key_value_map_unref0 (_tmp15_);
#line 280 "../src/Photo.vala"
			_key_value_map_unref0 (_tmp13_);
#line 279 "../src/Photo.vala"
			_g_free0 (object);
#line 31713 "Photo.c"
		}
#line 279 "../src/Photo.vala"
		_g_object_unref0 (_object_it);
#line 31717 "Photo.c"
	}
#line 282 "../src/Photo.vala"
	result = clone;
#line 282 "../src/Photo.vala"
	return result;
#line 31723 "Photo.c"
}

static void
photo_photo_transformation_state_impl_on_photo_baseline_replaced (PhotoPhotoTransformationStateImpl* self)
{
#line 285 "../src/Photo.vala"
	g_return_if_fail (PHOTO_IS_PHOTO_TRANSFORMATION_STATE_IMPL (self));
#line 286 "../src/Photo.vala"
	if (!photo_transformation_state_is_broken (G_TYPE_CHECK_INSTANCE_CAST (self, TYPE_PHOTO_TRANSFORMATION_STATE, PhotoTransformationState))) {
#line 287 "../src/Photo.vala"
		g_signal_emit (G_TYPE_CHECK_INSTANCE_CAST (self, TYPE_PHOTO_TRANSFORMATION_STATE, PhotoTransformationState), photo_transformation_state_signals[PHOTO_TRANSFORMATION_STATE_BROKEN_SIGNAL], 0);
#line 31735 "Photo.c"
	}
}

static void
photo_photo_transformation_state_impl_class_init (PhotoPhotoTransformationStateImplClass * klass,
                                                  gpointer klass_data)
{
#line 234 "../src/Photo.vala"
	photo_photo_transformation_state_impl_parent_class = g_type_class_peek_parent (klass);
#line 234 "../src/Photo.vala"
	g_type_class_adjust_private_offset (klass, &PhotoPhotoTransformationStateImpl_private_offset);
#line 234 "../src/Photo.vala"
	G_OBJECT_CLASS (klass)->finalize = photo_photo_transformation_state_impl_finalize;
#line 31749 "Photo.c"
}

static void
photo_photo_transformation_state_impl_instance_init (PhotoPhotoTransformationStateImpl * self,
                                                     gpointer klass)
{
#line 234 "../src/Photo.vala"
	self->priv = photo_photo_transformation_state_impl_get_instance_private (self);
#line 31758 "Photo.c"
}

static void
photo_photo_transformation_state_impl_finalize (GObject * obj)
{
	PhotoPhotoTransformationStateImpl * self;
	Photo* _tmp0_;
	guint _tmp1_;
#line 234 "../src/Photo.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, PHOTO_TYPE_PHOTO_TRANSFORMATION_STATE_IMPL, PhotoPhotoTransformationStateImpl);
#line 254 "../src/Photo.vala"
	_tmp0_ = self->priv->photo;
#line 254 "../src/Photo.vala"
	g_signal_parse_name ("baseline-replaced", TYPE_PHOTO, &_tmp1_, NULL, FALSE);
#line 254 "../src/Photo.vala"
	g_signal_handlers_disconnect_matched (_tmp0_, G_SIGNAL_MATCH_ID | G_SIGNAL_MATCH_FUNC | G_SIGNAL_MATCH_DATA, _tmp1_, 0, NULL, (GCallback) _photo_photo_transformation_state_impl_on_photo_baseline_replaced_photo_baseline_replaced, self);
#line 235 "../src/Photo.vala"
	_g_object_unref0 (self->priv->photo);
#line 237 "../src/Photo.vala"
	_g_object_unref0 (self->priv->transformations);
#line 238 "../src/Photo.vala"
	_pixel_transformer_unref0 (self->priv->transformer);
#line 239 "../src/Photo.vala"
	_pixel_transformation_bundle_unref0 (self->priv->adjustments);
#line 234 "../src/Photo.vala"
	G_OBJECT_CLASS (photo_photo_transformation_state_impl_parent_class)->finalize (obj);
#line 31785 "Photo.c"
}

static GType
photo_photo_transformation_state_impl_get_type_once (void)
{
	static const GTypeInfo g_define_type_info = { sizeof (PhotoPhotoTransformationStateImplClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) photo_photo_transformation_state_impl_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (PhotoPhotoTransformationStateImpl), 0, (GInstanceInitFunc) photo_photo_transformation_state_impl_instance_init, NULL };
	GType photo_photo_transformation_state_impl_type_id;
	photo_photo_transformation_state_impl_type_id = g_type_register_static (TYPE_PHOTO_TRANSFORMATION_STATE, "PhotoPhotoTransformationStateImpl", &g_define_type_info, 0);
	PhotoPhotoTransformationStateImpl_private_offset = g_type_add_instance_private (photo_photo_transformation_state_impl_type_id, sizeof (PhotoPhotoTransformationStateImplPrivate));
	return photo_photo_transformation_state_impl_type_id;
}

static GType
photo_photo_transformation_state_impl_get_type (void)
{
	static volatile gsize photo_photo_transformation_state_impl_type_id__once = 0;
	if (g_once_init_enter (&photo_photo_transformation_state_impl_type_id__once)) {
		GType photo_photo_transformation_state_impl_type_id;
		photo_photo_transformation_state_impl_type_id = photo_photo_transformation_state_impl_get_type_once ();
		g_once_init_leave (&photo_photo_transformation_state_impl_type_id__once, photo_photo_transformation_state_impl_type_id);
	}
	return photo_photo_transformation_state_impl_type_id__once;
}

static PhotoBackingReaders*
photo_backing_readers_construct (GType object_type)
{
	PhotoBackingReaders* self = NULL;
#line 291 "../src/Photo.vala"
	self = (PhotoBackingReaders*) g_type_create_instance (object_type);
#line 291 "../src/Photo.vala"
	return self;
#line 31818 "Photo.c"
}

static PhotoBackingReaders*
photo_backing_readers_new (void)
{
#line 291 "../src/Photo.vala"
	return photo_backing_readers_construct (PHOTO_TYPE_BACKING_READERS);
#line 31826 "Photo.c"
}

static void
photo_value_backing_readers_init (GValue* value)
{
#line 291 "../src/Photo.vala"
	value->data[0].v_pointer = NULL;
#line 31834 "Photo.c"
}

static void
photo_value_backing_readers_free_value (GValue* value)
{
#line 291 "../src/Photo.vala"
	if (value->data[0].v_pointer) {
#line 291 "../src/Photo.vala"
		photo_backing_readers_unref (value->data[0].v_pointer);
#line 31844 "Photo.c"
	}
}

static void
photo_value_backing_readers_copy_value (const GValue* src_value,
                                        GValue* dest_value)
{
#line 291 "../src/Photo.vala"
	if (src_value->data[0].v_pointer) {
#line 291 "../src/Photo.vala"
		dest_value->data[0].v_pointer = photo_backing_readers_ref (src_value->data[0].v_pointer);
#line 31856 "Photo.c"
	} else {
#line 291 "../src/Photo.vala"
		dest_value->data[0].v_pointer = NULL;
#line 31860 "Photo.c"
	}
}

static gpointer
photo_value_backing_readers_peek_pointer (const GValue* value)
{
#line 291 "../src/Photo.vala"
	return value->data[0].v_pointer;
#line 31869 "Photo.c"
}

static gchar*
photo_value_backing_readers_collect_value (GValue* value,
                                           guint n_collect_values,
                                           GTypeCValue* collect_values,
                                           guint collect_flags)
{
#line 291 "../src/Photo.vala"
	if (collect_values[0].v_pointer) {
#line 31880 "Photo.c"
		PhotoBackingReaders * object;
		object = collect_values[0].v_pointer;
#line 291 "../src/Photo.vala"
		if (object->parent_instance.g_class == NULL) {
#line 291 "../src/Photo.vala"
			return g_strconcat ("invalid unclassed object pointer for value type `", G_VALUE_TYPE_NAME (value), "'", NULL);
#line 31887 "Photo.c"
		} else if (!g_value_type_compatible (G_TYPE_FROM_INSTANCE (object), G_VALUE_TYPE (value))) {
#line 291 "../src/Photo.vala"
			return g_strconcat ("invalid object type `", g_type_name (G_TYPE_FROM_INSTANCE (object)), "' for value type `", G_VALUE_TYPE_NAME (value), "'", NULL);
#line 31891 "Photo.c"
		}
#line 291 "../src/Photo.vala"
		value->data[0].v_pointer = photo_backing_readers_ref (object);
#line 31895 "Photo.c"
	} else {
#line 291 "../src/Photo.vala"
		value->data[0].v_pointer = NULL;
#line 31899 "Photo.c"
	}
#line 291 "../src/Photo.vala"
	return NULL;
#line 31903 "Photo.c"
}

static gchar*
photo_value_backing_readers_lcopy_value (const GValue* value,
                                         guint n_collect_values,
                                         GTypeCValue* collect_values,
                                         guint collect_flags)
{
	PhotoBackingReaders ** object_p;
	object_p = collect_values[0].v_pointer;
#line 291 "../src/Photo.vala"
	if (!object_p) {
#line 291 "../src/Photo.vala"
		return g_strdup_printf ("value location for `%s' passed as NULL", G_VALUE_TYPE_NAME (value));
#line 31918 "Photo.c"
	}
#line 291 "../src/Photo.vala"
	if (!value->data[0].v_pointer) {
#line 291 "../src/Photo.vala"
		*object_p = NULL;
#line 31924 "Photo.c"
	} else if (collect_flags & G_VALUE_NOCOPY_CONTENTS) {
#line 291 "../src/Photo.vala"
		*object_p = value->data[0].v_pointer;
#line 31928 "Photo.c"
	} else {
#line 291 "../src/Photo.vala"
		*object_p = photo_backing_readers_ref (value->data[0].v_pointer);
#line 31932 "Photo.c"
	}
#line 291 "../src/Photo.vala"
	return NULL;
#line 31936 "Photo.c"
}

static GParamSpec*
photo_param_spec_backing_readers (const gchar* name,
                                  const gchar* nick,
                                  const gchar* blurb,
                                  GType object_type,
                                  GParamFlags flags)
{
	PhotoParamSpecBackingReaders* spec;
#line 291 "../src/Photo.vala"
	g_return_val_if_fail (g_type_is_a (object_type, PHOTO_TYPE_BACKING_READERS), NULL);
#line 291 "../src/Photo.vala"
	spec = g_param_spec_internal (G_TYPE_PARAM_OBJECT, name, nick, blurb, flags);
#line 291 "../src/Photo.vala"
	G_PARAM_SPEC (spec)->value_type = object_type;
#line 291 "../src/Photo.vala"
	return G_PARAM_SPEC (spec);
#line 31955 "Photo.c"
}

static gpointer
photo_value_get_backing_readers (const GValue* value)
{
#line 291 "../src/Photo.vala"
	g_return_val_if_fail (G_TYPE_CHECK_VALUE_TYPE (value, PHOTO_TYPE_BACKING_READERS), NULL);
#line 291 "../src/Photo.vala"
	return value->data[0].v_pointer;
#line 31965 "Photo.c"
}

static void
photo_value_set_backing_readers (GValue* value,
                                 gpointer v_object)
{
	PhotoBackingReaders * old;
#line 291 "../src/Photo.vala"
	g_return_if_fail (G_TYPE_CHECK_VALUE_TYPE (value, PHOTO_TYPE_BACKING_READERS));
#line 291 "../src/Photo.vala"
	old = value->data[0].v_pointer;
#line 291 "../src/Photo.vala"
	if (v_object) {
#line 291 "../src/Photo.vala"
		g_return_if_fail (G_TYPE_CHECK_INSTANCE_TYPE (v_object, PHOTO_TYPE_BACKING_READERS));
#line 291 "../src/Photo.vala"
		g_return_if_fail (g_value_type_compatible (G_TYPE_FROM_INSTANCE (v_object), G_VALUE_TYPE (value)));
#line 291 "../src/Photo.vala"
		value->data[0].v_pointer = v_object;
#line 291 "../src/Photo.vala"
		photo_backing_readers_ref (value->data[0].v_pointer);
#line 31987 "Photo.c"
	} else {
#line 291 "../src/Photo.vala"
		value->data[0].v_pointer = NULL;
#line 31991 "Photo.c"
	}
#line 291 "../src/Photo.vala"
	if (old) {
#line 291 "../src/Photo.vala"
		photo_backing_readers_unref (old);
#line 31997 "Photo.c"
	}
}

static void
photo_value_take_backing_readers (GValue* value,
                                  gpointer v_object)
{
	PhotoBackingReaders * old;
#line 291 "../src/Photo.vala"
	g_return_if_fail (G_TYPE_CHECK_VALUE_TYPE (value, PHOTO_TYPE_BACKING_READERS));
#line 291 "../src/Photo.vala"
	old = value->data[0].v_pointer;
#line 291 "../src/Photo.vala"
	if (v_object) {
#line 291 "../src/Photo.vala"
		g_return_if_fail (G_TYPE_CHECK_INSTANCE_TYPE (v_object, PHOTO_TYPE_BACKING_READERS));
#line 291 "../src/Photo.vala"
		g_return_if_fail (g_value_type_compatible (G_TYPE_FROM_INSTANCE (v_object), G_VALUE_TYPE (value)));
#line 291 "../src/Photo.vala"
		value->data[0].v_pointer = v_object;
#line 32018 "Photo.c"
	} else {
#line 291 "../src/Photo.vala"
		value->data[0].v_pointer = NULL;
#line 32022 "Photo.c"
	}
#line 291 "../src/Photo.vala"
	if (old) {
#line 291 "../src/Photo.vala"
		photo_backing_readers_unref (old);
#line 32028 "Photo.c"
	}
}

static void
photo_backing_readers_class_init (PhotoBackingReadersClass * klass,
                                  gpointer klass_data)
{
#line 291 "../src/Photo.vala"
	photo_backing_readers_parent_class = g_type_class_peek_parent (klass);
#line 291 "../src/Photo.vala"
	((PhotoBackingReadersClass *) klass)->finalize = photo_backing_readers_finalize;
#line 32040 "Photo.c"
}

static void
photo_backing_readers_instance_init (PhotoBackingReaders * self,
                                     gpointer klass)
{
#line 291 "../src/Photo.vala"
	self->ref_count = 1;
#line 32049 "Photo.c"
}

static void
photo_backing_readers_finalize (PhotoBackingReaders * obj)
{
	PhotoBackingReaders * self;
#line 291 "../src/Photo.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, PHOTO_TYPE_BACKING_READERS, PhotoBackingReaders);
#line 291 "../src/Photo.vala"
	g_signal_handlers_destroy (self);
#line 292 "../src/Photo.vala"
	_photo_file_adapter_unref0 (self->master);
#line 293 "../src/Photo.vala"
	_photo_file_adapter_unref0 (self->developer);
#line 294 "../src/Photo.vala"
	_photo_file_adapter_unref0 (self->editable);
#line 32066 "Photo.c"
}

static GType
photo_backing_readers_get_type_once (void)
{
	static const GTypeValueTable g_define_type_value_table = { photo_value_backing_readers_init, photo_value_backing_readers_free_value, photo_value_backing_readers_copy_value, photo_value_backing_readers_peek_pointer, "p", photo_value_backing_readers_collect_value, "p", photo_value_backing_readers_lcopy_value };
	static const GTypeInfo g_define_type_info = { sizeof (PhotoBackingReadersClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) photo_backing_readers_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (PhotoBackingReaders), 0, (GInstanceInitFunc) photo_backing_readers_instance_init, &g_define_type_value_table };
	static const GTypeFundamentalInfo g_define_type_fundamental_info = { (G_TYPE_FLAG_CLASSED | G_TYPE_FLAG_INSTANTIATABLE | G_TYPE_FLAG_DERIVABLE | G_TYPE_FLAG_DEEP_DERIVABLE) };
	GType photo_backing_readers_type_id;
	photo_backing_readers_type_id = g_type_register_fundamental (g_type_fundamental_next (), "PhotoBackingReaders", &g_define_type_info, &g_define_type_fundamental_info, 0);
	return photo_backing_readers_type_id;
}

static GType
photo_backing_readers_get_type (void)
{
	static volatile gsize photo_backing_readers_type_id__once = 0;
	if (g_once_init_enter (&photo_backing_readers_type_id__once)) {
		GType photo_backing_readers_type_id;
		photo_backing_readers_type_id = photo_backing_readers_get_type_once ();
		g_once_init_leave (&photo_backing_readers_type_id__once, photo_backing_readers_type_id);
	}
	return photo_backing_readers_type_id__once;
}

static gpointer
photo_backing_readers_ref (gpointer instance)
{
	PhotoBackingReaders * self;
	self = instance;
#line 291 "../src/Photo.vala"
	g_atomic_int_inc (&self->ref_count);
#line 291 "../src/Photo.vala"
	return instance;
#line 32101 "Photo.c"
}

static void
photo_backing_readers_unref (gpointer instance)
{
	PhotoBackingReaders * self;
	self = instance;
#line 291 "../src/Photo.vala"
	if (g_atomic_int_dec_and_test (&self->ref_count)) {
#line 291 "../src/Photo.vala"
		PHOTO_BACKING_READERS_GET_CLASS (self)->finalize (self);
#line 291 "../src/Photo.vala"
		g_type_free_instance ((GTypeInstance *) self);
#line 32115 "Photo.c"
	}
}

static PhotoCachedPixbuf*
photo_cached_pixbuf_construct (GType object_type,
                               Photo* photo,
                               GdkPixbuf* pixbuf)
{
	PhotoCachedPixbuf* self = NULL;
	Photo* _tmp0_;
	GdkPixbuf* _tmp1_;
#line 302 "../src/Photo.vala"
	g_return_val_if_fail (IS_PHOTO (photo), NULL);
#line 302 "../src/Photo.vala"
	g_return_val_if_fail (G_TYPE_CHECK_INSTANCE_TYPE (pixbuf, gdk_pixbuf_get_type ()), NULL);
#line 302 "../src/Photo.vala"
	self = (PhotoCachedPixbuf*) g_type_create_instance (object_type);
#line 303 "../src/Photo.vala"
	_tmp0_ = _g_object_ref0 (photo);
#line 303 "../src/Photo.vala"
	_g_object_unref0 (self->photo);
#line 303 "../src/Photo.vala"
	self->photo = _tmp0_;
#line 304 "../src/Photo.vala"
	_tmp1_ = _g_object_ref0 (pixbuf);
#line 304 "../src/Photo.vala"
	_g_object_unref0 (self->pixbuf);
#line 304 "../src/Photo.vala"
	self->pixbuf = _tmp1_;
#line 302 "../src/Photo.vala"
	return self;
#line 32147 "Photo.c"
}

static PhotoCachedPixbuf*
photo_cached_pixbuf_new (Photo* photo,
                         GdkPixbuf* pixbuf)
{
#line 302 "../src/Photo.vala"
	return photo_cached_pixbuf_construct (PHOTO_TYPE_CACHED_PIXBUF, photo, pixbuf);
#line 32156 "Photo.c"
}

static void
photo_value_cached_pixbuf_init (GValue* value)
{
#line 297 "../src/Photo.vala"
	value->data[0].v_pointer = NULL;
#line 32164 "Photo.c"
}

static void
photo_value_cached_pixbuf_free_value (GValue* value)
{
#line 297 "../src/Photo.vala"
	if (value->data[0].v_pointer) {
#line 297 "../src/Photo.vala"
		photo_cached_pixbuf_unref (value->data[0].v_pointer);
#line 32174 "Photo.c"
	}
}

static void
photo_value_cached_pixbuf_copy_value (const GValue* src_value,
                                      GValue* dest_value)
{
#line 297 "../src/Photo.vala"
	if (src_value->data[0].v_pointer) {
#line 297 "../src/Photo.vala"
		dest_value->data[0].v_pointer = photo_cached_pixbuf_ref (src_value->data[0].v_pointer);
#line 32186 "Photo.c"
	} else {
#line 297 "../src/Photo.vala"
		dest_value->data[0].v_pointer = NULL;
#line 32190 "Photo.c"
	}
}

static gpointer
photo_value_cached_pixbuf_peek_pointer (const GValue* value)
{
#line 297 "../src/Photo.vala"
	return value->data[0].v_pointer;
#line 32199 "Photo.c"
}

static gchar*
photo_value_cached_pixbuf_collect_value (GValue* value,
                                         guint n_collect_values,
                                         GTypeCValue* collect_values,
                                         guint collect_flags)
{
#line 297 "../src/Photo.vala"
	if (collect_values[0].v_pointer) {
#line 32210 "Photo.c"
		PhotoCachedPixbuf * object;
		object = collect_values[0].v_pointer;
#line 297 "../src/Photo.vala"
		if (object->parent_instance.g_class == NULL) {
#line 297 "../src/Photo.vala"
			return g_strconcat ("invalid unclassed object pointer for value type `", G_VALUE_TYPE_NAME (value), "'", NULL);
#line 32217 "Photo.c"
		} else if (!g_value_type_compatible (G_TYPE_FROM_INSTANCE (object), G_VALUE_TYPE (value))) {
#line 297 "../src/Photo.vala"
			return g_strconcat ("invalid object type `", g_type_name (G_TYPE_FROM_INSTANCE (object)), "' for value type `", G_VALUE_TYPE_NAME (value), "'", NULL);
#line 32221 "Photo.c"
		}
#line 297 "../src/Photo.vala"
		value->data[0].v_pointer = photo_cached_pixbuf_ref (object);
#line 32225 "Photo.c"
	} else {
#line 297 "../src/Photo.vala"
		value->data[0].v_pointer = NULL;
#line 32229 "Photo.c"
	}
#line 297 "../src/Photo.vala"
	return NULL;
#line 32233 "Photo.c"
}

static gchar*
photo_value_cached_pixbuf_lcopy_value (const GValue* value,
                                       guint n_collect_values,
                                       GTypeCValue* collect_values,
                                       guint collect_flags)
{
	PhotoCachedPixbuf ** object_p;
	object_p = collect_values[0].v_pointer;
#line 297 "../src/Photo.vala"
	if (!object_p) {
#line 297 "../src/Photo.vala"
		return g_strdup_printf ("value location for `%s' passed as NULL", G_VALUE_TYPE_NAME (value));
#line 32248 "Photo.c"
	}
#line 297 "../src/Photo.vala"
	if (!value->data[0].v_pointer) {
#line 297 "../src/Photo.vala"
		*object_p = NULL;
#line 32254 "Photo.c"
	} else if (collect_flags & G_VALUE_NOCOPY_CONTENTS) {
#line 297 "../src/Photo.vala"
		*object_p = value->data[0].v_pointer;
#line 32258 "Photo.c"
	} else {
#line 297 "../src/Photo.vala"
		*object_p = photo_cached_pixbuf_ref (value->data[0].v_pointer);
#line 32262 "Photo.c"
	}
#line 297 "../src/Photo.vala"
	return NULL;
#line 32266 "Photo.c"
}

static GParamSpec*
photo_param_spec_cached_pixbuf (const gchar* name,
                                const gchar* nick,
                                const gchar* blurb,
                                GType object_type,
                                GParamFlags flags)
{
	PhotoParamSpecCachedPixbuf* spec;
#line 297 "../src/Photo.vala"
	g_return_val_if_fail (g_type_is_a (object_type, PHOTO_TYPE_CACHED_PIXBUF), NULL);
#line 297 "../src/Photo.vala"
	spec = g_param_spec_internal (G_TYPE_PARAM_OBJECT, name, nick, blurb, flags);
#line 297 "../src/Photo.vala"
	G_PARAM_SPEC (spec)->value_type = object_type;
#line 297 "../src/Photo.vala"
	return G_PARAM_SPEC (spec);
#line 32285 "Photo.c"
}

static gpointer
photo_value_get_cached_pixbuf (const GValue* value)
{
#line 297 "../src/Photo.vala"
	g_return_val_if_fail (G_TYPE_CHECK_VALUE_TYPE (value, PHOTO_TYPE_CACHED_PIXBUF), NULL);
#line 297 "../src/Photo.vala"
	return value->data[0].v_pointer;
#line 32295 "Photo.c"
}

static void
photo_value_set_cached_pixbuf (GValue* value,
                               gpointer v_object)
{
	PhotoCachedPixbuf * old;
#line 297 "../src/Photo.vala"
	g_return_if_fail (G_TYPE_CHECK_VALUE_TYPE (value, PHOTO_TYPE_CACHED_PIXBUF));
#line 297 "../src/Photo.vala"
	old = value->data[0].v_pointer;
#line 297 "../src/Photo.vala"
	if (v_object) {
#line 297 "../src/Photo.vala"
		g_return_if_fail (G_TYPE_CHECK_INSTANCE_TYPE (v_object, PHOTO_TYPE_CACHED_PIXBUF));
#line 297 "../src/Photo.vala"
		g_return_if_fail (g_value_type_compatible (G_TYPE_FROM_INSTANCE (v_object), G_VALUE_TYPE (value)));
#line 297 "../src/Photo.vala"
		value->data[0].v_pointer = v_object;
#line 297 "../src/Photo.vala"
		photo_cached_pixbuf_ref (value->data[0].v_pointer);
#line 32317 "Photo.c"
	} else {
#line 297 "../src/Photo.vala"
		value->data[0].v_pointer = NULL;
#line 32321 "Photo.c"
	}
#line 297 "../src/Photo.vala"
	if (old) {
#line 297 "../src/Photo.vala"
		photo_cached_pixbuf_unref (old);
#line 32327 "Photo.c"
	}
}

static void
photo_value_take_cached_pixbuf (GValue* value,
                                gpointer v_object)
{
	PhotoCachedPixbuf * old;
#line 297 "../src/Photo.vala"
	g_return_if_fail (G_TYPE_CHECK_VALUE_TYPE (value, PHOTO_TYPE_CACHED_PIXBUF));
#line 297 "../src/Photo.vala"
	old = value->data[0].v_pointer;
#line 297 "../src/Photo.vala"
	if (v_object) {
#line 297 "../src/Photo.vala"
		g_return_if_fail (G_TYPE_CHECK_INSTANCE_TYPE (v_object, PHOTO_TYPE_CACHED_PIXBUF));
#line 297 "../src/Photo.vala"
		g_return_if_fail (g_value_type_compatible (G_TYPE_FROM_INSTANCE (v_object), G_VALUE_TYPE (value)));
#line 297 "../src/Photo.vala"
		value->data[0].v_pointer = v_object;
#line 32348 "Photo.c"
	} else {
#line 297 "../src/Photo.vala"
		value->data[0].v_pointer = NULL;
#line 32352 "Photo.c"
	}
#line 297 "../src/Photo.vala"
	if (old) {
#line 297 "../src/Photo.vala"
		photo_cached_pixbuf_unref (old);
#line 32358 "Photo.c"
	}
}

static void
photo_cached_pixbuf_class_init (PhotoCachedPixbufClass * klass,
                                gpointer klass_data)
{
#line 297 "../src/Photo.vala"
	photo_cached_pixbuf_parent_class = g_type_class_peek_parent (klass);
#line 297 "../src/Photo.vala"
	((PhotoCachedPixbufClass *) klass)->finalize = photo_cached_pixbuf_finalize;
#line 32370 "Photo.c"
}

static void
photo_cached_pixbuf_instance_init (PhotoCachedPixbuf * self,
                                   gpointer klass)
{
	GTimer* _tmp0_;
#line 300 "../src/Photo.vala"
	_tmp0_ = g_timer_new ();
#line 300 "../src/Photo.vala"
	self->last_touched = _tmp0_;
#line 297 "../src/Photo.vala"
	self->ref_count = 1;
#line 32384 "Photo.c"
}

static void
photo_cached_pixbuf_finalize (PhotoCachedPixbuf * obj)
{
	PhotoCachedPixbuf * self;
#line 297 "../src/Photo.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, PHOTO_TYPE_CACHED_PIXBUF, PhotoCachedPixbuf);
#line 297 "../src/Photo.vala"
	g_signal_handlers_destroy (self);
#line 298 "../src/Photo.vala"
	_g_object_unref0 (self->photo);
#line 299 "../src/Photo.vala"
	_g_object_unref0 (self->pixbuf);
#line 300 "../src/Photo.vala"
	_g_timer_destroy0 (self->last_touched);
#line 32401 "Photo.c"
}

static GType
photo_cached_pixbuf_get_type_once (void)
{
	static const GTypeValueTable g_define_type_value_table = { photo_value_cached_pixbuf_init, photo_value_cached_pixbuf_free_value, photo_value_cached_pixbuf_copy_value, photo_value_cached_pixbuf_peek_pointer, "p", photo_value_cached_pixbuf_collect_value, "p", photo_value_cached_pixbuf_lcopy_value };
	static const GTypeInfo g_define_type_info = { sizeof (PhotoCachedPixbufClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) photo_cached_pixbuf_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (PhotoCachedPixbuf), 0, (GInstanceInitFunc) photo_cached_pixbuf_instance_init, &g_define_type_value_table };
	static const GTypeFundamentalInfo g_define_type_fundamental_info = { (G_TYPE_FLAG_CLASSED | G_TYPE_FLAG_INSTANTIATABLE | G_TYPE_FLAG_DERIVABLE | G_TYPE_FLAG_DEEP_DERIVABLE) };
	GType photo_cached_pixbuf_type_id;
	photo_cached_pixbuf_type_id = g_type_register_fundamental (g_type_fundamental_next (), "PhotoCachedPixbuf", &g_define_type_info, &g_define_type_fundamental_info, 0);
	return photo_cached_pixbuf_type_id;
}

static GType
photo_cached_pixbuf_get_type (void)
{
	static volatile gsize photo_cached_pixbuf_type_id__once = 0;
	if (g_once_init_enter (&photo_cached_pixbuf_type_id__once)) {
		GType photo_cached_pixbuf_type_id;
		photo_cached_pixbuf_type_id = photo_cached_pixbuf_get_type_once ();
		g_once_init_leave (&photo_cached_pixbuf_type_id__once, photo_cached_pixbuf_type_id);
	}
	return photo_cached_pixbuf_type_id__once;
}

static gpointer
photo_cached_pixbuf_ref (gpointer instance)
{
	PhotoCachedPixbuf * self;
	self = instance;
#line 297 "../src/Photo.vala"
	g_atomic_int_inc (&self->ref_count);
#line 297 "../src/Photo.vala"
	return instance;
#line 32436 "Photo.c"
}

static void
photo_cached_pixbuf_unref (gpointer instance)
{
	PhotoCachedPixbuf * self;
	self = instance;
#line 297 "../src/Photo.vala"
	if (g_atomic_int_dec_and_test (&self->ref_count)) {
#line 297 "../src/Photo.vala"
		PHOTO_CACHED_PIXBUF_GET_CLASS (self)->finalize (self);
#line 297 "../src/Photo.vala"
		g_type_free_instance ((GTypeInstance *) self);
#line 32450 "Photo.c"
	}
}

PhotoReimportMasterState*
photo_reimport_master_state_construct (GType object_type)
{
	PhotoReimportMasterState* self = NULL;
#line 1368 "../src/Photo.vala"
	self = (PhotoReimportMasterState*) g_type_create_instance (object_type);
#line 1368 "../src/Photo.vala"
	return self;
#line 32462 "Photo.c"
}

static void
photo_value_reimport_master_state_init (GValue* value)
{
#line 1368 "../src/Photo.vala"
	value->data[0].v_pointer = NULL;
#line 32470 "Photo.c"
}

static void
photo_value_reimport_master_state_free_value (GValue* value)
{
#line 1368 "../src/Photo.vala"
	if (value->data[0].v_pointer) {
#line 1368 "../src/Photo.vala"
		photo_reimport_master_state_unref (value->data[0].v_pointer);
#line 32480 "Photo.c"
	}
}

static void
photo_value_reimport_master_state_copy_value (const GValue* src_value,
                                              GValue* dest_value)
{
#line 1368 "../src/Photo.vala"
	if (src_value->data[0].v_pointer) {
#line 1368 "../src/Photo.vala"
		dest_value->data[0].v_pointer = photo_reimport_master_state_ref (src_value->data[0].v_pointer);
#line 32492 "Photo.c"
	} else {
#line 1368 "../src/Photo.vala"
		dest_value->data[0].v_pointer = NULL;
#line 32496 "Photo.c"
	}
}

static gpointer
photo_value_reimport_master_state_peek_pointer (const GValue* value)
{
#line 1368 "../src/Photo.vala"
	return value->data[0].v_pointer;
#line 32505 "Photo.c"
}

static gchar*
photo_value_reimport_master_state_collect_value (GValue* value,
                                                 guint n_collect_values,
                                                 GTypeCValue* collect_values,
                                                 guint collect_flags)
{
#line 1368 "../src/Photo.vala"
	if (collect_values[0].v_pointer) {
#line 32516 "Photo.c"
		PhotoReimportMasterState * object;
		object = collect_values[0].v_pointer;
#line 1368 "../src/Photo.vala"
		if (object->parent_instance.g_class == NULL) {
#line 1368 "../src/Photo.vala"
			return g_strconcat ("invalid unclassed object pointer for value type `", G_VALUE_TYPE_NAME (value), "'", NULL);
#line 32523 "Photo.c"
		} else if (!g_value_type_compatible (G_TYPE_FROM_INSTANCE (object), G_VALUE_TYPE (value))) {
#line 1368 "../src/Photo.vala"
			return g_strconcat ("invalid object type `", g_type_name (G_TYPE_FROM_INSTANCE (object)), "' for value type `", G_VALUE_TYPE_NAME (value), "'", NULL);
#line 32527 "Photo.c"
		}
#line 1368 "../src/Photo.vala"
		value->data[0].v_pointer = photo_reimport_master_state_ref (object);
#line 32531 "Photo.c"
	} else {
#line 1368 "../src/Photo.vala"
		value->data[0].v_pointer = NULL;
#line 32535 "Photo.c"
	}
#line 1368 "../src/Photo.vala"
	return NULL;
#line 32539 "Photo.c"
}

static gchar*
photo_value_reimport_master_state_lcopy_value (const GValue* value,
                                               guint n_collect_values,
                                               GTypeCValue* collect_values,
                                               guint collect_flags)
{
	PhotoReimportMasterState ** object_p;
	object_p = collect_values[0].v_pointer;
#line 1368 "../src/Photo.vala"
	if (!object_p) {
#line 1368 "../src/Photo.vala"
		return g_strdup_printf ("value location for `%s' passed as NULL", G_VALUE_TYPE_NAME (value));
#line 32554 "Photo.c"
	}
#line 1368 "../src/Photo.vala"
	if (!value->data[0].v_pointer) {
#line 1368 "../src/Photo.vala"
		*object_p = NULL;
#line 32560 "Photo.c"
	} else if (collect_flags & G_VALUE_NOCOPY_CONTENTS) {
#line 1368 "../src/Photo.vala"
		*object_p = value->data[0].v_pointer;
#line 32564 "Photo.c"
	} else {
#line 1368 "../src/Photo.vala"
		*object_p = photo_reimport_master_state_ref (value->data[0].v_pointer);
#line 32568 "Photo.c"
	}
#line 1368 "../src/Photo.vala"
	return NULL;
#line 32572 "Photo.c"
}

GParamSpec*
photo_param_spec_reimport_master_state (const gchar* name,
                                        const gchar* nick,
                                        const gchar* blurb,
                                        GType object_type,
                                        GParamFlags flags)
{
	PhotoParamSpecReimportMasterState* spec;
#line 1368 "../src/Photo.vala"
	g_return_val_if_fail (g_type_is_a (object_type, PHOTO_TYPE_REIMPORT_MASTER_STATE), NULL);
#line 1368 "../src/Photo.vala"
	spec = g_param_spec_internal (G_TYPE_PARAM_OBJECT, name, nick, blurb, flags);
#line 1368 "../src/Photo.vala"
	G_PARAM_SPEC (spec)->value_type = object_type;
#line 1368 "../src/Photo.vala"
	return G_PARAM_SPEC (spec);
#line 32591 "Photo.c"
}

gpointer
photo_value_get_reimport_master_state (const GValue* value)
{
#line 1368 "../src/Photo.vala"
	g_return_val_if_fail (G_TYPE_CHECK_VALUE_TYPE (value, PHOTO_TYPE_REIMPORT_MASTER_STATE), NULL);
#line 1368 "../src/Photo.vala"
	return value->data[0].v_pointer;
#line 32601 "Photo.c"
}

void
photo_value_set_reimport_master_state (GValue* value,
                                       gpointer v_object)
{
	PhotoReimportMasterState * old;
#line 1368 "../src/Photo.vala"
	g_return_if_fail (G_TYPE_CHECK_VALUE_TYPE (value, PHOTO_TYPE_REIMPORT_MASTER_STATE));
#line 1368 "../src/Photo.vala"
	old = value->data[0].v_pointer;
#line 1368 "../src/Photo.vala"
	if (v_object) {
#line 1368 "../src/Photo.vala"
		g_return_if_fail (G_TYPE_CHECK_INSTANCE_TYPE (v_object, PHOTO_TYPE_REIMPORT_MASTER_STATE));
#line 1368 "../src/Photo.vala"
		g_return_if_fail (g_value_type_compatible (G_TYPE_FROM_INSTANCE (v_object), G_VALUE_TYPE (value)));
#line 1368 "../src/Photo.vala"
		value->data[0].v_pointer = v_object;
#line 1368 "../src/Photo.vala"
		photo_reimport_master_state_ref (value->data[0].v_pointer);
#line 32623 "Photo.c"
	} else {
#line 1368 "../src/Photo.vala"
		value->data[0].v_pointer = NULL;
#line 32627 "Photo.c"
	}
#line 1368 "../src/Photo.vala"
	if (old) {
#line 1368 "../src/Photo.vala"
		photo_reimport_master_state_unref (old);
#line 32633 "Photo.c"
	}
}

void
photo_value_take_reimport_master_state (GValue* value,
                                        gpointer v_object)
{
	PhotoReimportMasterState * old;
#line 1368 "../src/Photo.vala"
	g_return_if_fail (G_TYPE_CHECK_VALUE_TYPE (value, PHOTO_TYPE_REIMPORT_MASTER_STATE));
#line 1368 "../src/Photo.vala"
	old = value->data[0].v_pointer;
#line 1368 "../src/Photo.vala"
	if (v_object) {
#line 1368 "../src/Photo.vala"
		g_return_if_fail (G_TYPE_CHECK_INSTANCE_TYPE (v_object, PHOTO_TYPE_REIMPORT_MASTER_STATE));
#line 1368 "../src/Photo.vala"
		g_return_if_fail (g_value_type_compatible (G_TYPE_FROM_INSTANCE (v_object), G_VALUE_TYPE (value)));
#line 1368 "../src/Photo.vala"
		value->data[0].v_pointer = v_object;
#line 32654 "Photo.c"
	} else {
#line 1368 "../src/Photo.vala"
		value->data[0].v_pointer = NULL;
#line 32658 "Photo.c"
	}
#line 1368 "../src/Photo.vala"
	if (old) {
#line 1368 "../src/Photo.vala"
		photo_reimport_master_state_unref (old);
#line 32664 "Photo.c"
	}
}

static void
photo_reimport_master_state_class_init (PhotoReimportMasterStateClass * klass,
                                        gpointer klass_data)
{
#line 1368 "../src/Photo.vala"
	photo_reimport_master_state_parent_class = g_type_class_peek_parent (klass);
#line 1368 "../src/Photo.vala"
	((PhotoReimportMasterStateClass *) klass)->finalize = photo_reimport_master_state_finalize;
#line 32676 "Photo.c"
}

static void
photo_reimport_master_state_instance_init (PhotoReimportMasterState * self,
                                           gpointer klass)
{
#line 1368 "../src/Photo.vala"
	self->ref_count = 1;
#line 32685 "Photo.c"
}

static void
photo_reimport_master_state_finalize (PhotoReimportMasterState * obj)
{
	PhotoReimportMasterState * self;
#line 1368 "../src/Photo.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, PHOTO_TYPE_REIMPORT_MASTER_STATE, PhotoReimportMasterState);
#line 1368 "../src/Photo.vala"
	g_signal_handlers_destroy (self);
#line 32696 "Photo.c"
}

static GType
photo_reimport_master_state_get_type_once (void)
{
	static const GTypeValueTable g_define_type_value_table = { photo_value_reimport_master_state_init, photo_value_reimport_master_state_free_value, photo_value_reimport_master_state_copy_value, photo_value_reimport_master_state_peek_pointer, "p", photo_value_reimport_master_state_collect_value, "p", photo_value_reimport_master_state_lcopy_value };
	static const GTypeInfo g_define_type_info = { sizeof (PhotoReimportMasterStateClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) photo_reimport_master_state_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (PhotoReimportMasterState), 0, (GInstanceInitFunc) photo_reimport_master_state_instance_init, &g_define_type_value_table };
	static const GTypeFundamentalInfo g_define_type_fundamental_info = { (G_TYPE_FLAG_CLASSED | G_TYPE_FLAG_INSTANTIATABLE | G_TYPE_FLAG_DERIVABLE | G_TYPE_FLAG_DEEP_DERIVABLE) };
	GType photo_reimport_master_state_type_id;
	photo_reimport_master_state_type_id = g_type_register_fundamental (g_type_fundamental_next (), "PhotoReimportMasterState", &g_define_type_info, &g_define_type_fundamental_info, G_TYPE_FLAG_ABSTRACT);
	return photo_reimport_master_state_type_id;
}

GType
photo_reimport_master_state_get_type (void)
{
	static volatile gsize photo_reimport_master_state_type_id__once = 0;
	if (g_once_init_enter (&photo_reimport_master_state_type_id__once)) {
		GType photo_reimport_master_state_type_id;
		photo_reimport_master_state_type_id = photo_reimport_master_state_get_type_once ();
		g_once_init_leave (&photo_reimport_master_state_type_id__once, photo_reimport_master_state_type_id);
	}
	return photo_reimport_master_state_type_id__once;
}

gpointer
photo_reimport_master_state_ref (gpointer instance)
{
	PhotoReimportMasterState * self;
	self = instance;
#line 1368 "../src/Photo.vala"
	g_atomic_int_inc (&self->ref_count);
#line 1368 "../src/Photo.vala"
	return instance;
#line 32731 "Photo.c"
}

void
photo_reimport_master_state_unref (gpointer instance)
{
	PhotoReimportMasterState * self;
	self = instance;
#line 1368 "../src/Photo.vala"
	if (g_atomic_int_dec_and_test (&self->ref_count)) {
#line 1368 "../src/Photo.vala"
		PHOTO_REIMPORT_MASTER_STATE_GET_CLASS (self)->finalize (self);
#line 1368 "../src/Photo.vala"
		g_type_free_instance ((GTypeInstance *) self);
#line 32745 "Photo.c"
	}
}

static gchar**
_vala_array_dup33 (gchar** self,
                   gssize length)
{
#line 1380 "../src/Photo.vala"
	if (length >= 0) {
#line 32755 "Photo.c"
		gchar** result;
		gssize i;
#line 1380 "../src/Photo.vala"
		result = g_new0 (gchar*, length + 1);
#line 1380 "../src/Photo.vala"
		for (i = 0; i < length; i++) {
#line 32762 "Photo.c"
			gchar* _tmp0_;
#line 1380 "../src/Photo.vala"
			_tmp0_ = g_strdup (self[i]);
#line 1380 "../src/Photo.vala"
			result[i] = _tmp0_;
#line 32768 "Photo.c"
		}
#line 1380 "../src/Photo.vala"
		return result;
#line 32772 "Photo.c"
	}
#line 1380 "../src/Photo.vala"
	return NULL;
#line 32776 "Photo.c"
}

static PhotoReimportMasterStateImpl*
photo_reimport_master_state_impl_construct (GType object_type,
                                            PhotoRow* row,
                                            PhotoMetadata* metadata,
                                            gchar** alterations,
                                            gint alterations_length1)
{
	PhotoReimportMasterStateImpl* self = NULL;
	PhotoRow* _tmp0_;
	PhotoMetadata* _tmp1_;
	gchar** _tmp2_;
	gint _tmp2__length1;
#line 1377 "../src/Photo.vala"
	g_return_val_if_fail (IS_PHOTO_ROW (row), NULL);
#line 1377 "../src/Photo.vala"
	g_return_val_if_fail ((metadata == NULL) || IS_PHOTO_METADATA (metadata), NULL);
#line 1377 "../src/Photo.vala"
	self = (PhotoReimportMasterStateImpl*) photo_reimport_master_state_construct (object_type);
#line 1378 "../src/Photo.vala"
	_tmp0_ = _photo_row_ref0 (row);
#line 1378 "../src/Photo.vala"
	_photo_row_unref0 (self->row);
#line 1378 "../src/Photo.vala"
	self->row = _tmp0_;
#line 1379 "../src/Photo.vala"
	_tmp1_ = _media_metadata_ref0 (metadata);
#line 1379 "../src/Photo.vala"
	_media_metadata_unref0 (self->metadata);
#line 1379 "../src/Photo.vala"
	self->metadata = _tmp1_;
#line 1380 "../src/Photo.vala"
	_tmp2_ = (alterations != NULL) ? _vala_array_dup33 (alterations, alterations_length1) : alterations;
#line 1380 "../src/Photo.vala"
	_tmp2__length1 = alterations_length1;
#line 1380 "../src/Photo.vala"
	self->alterations = (_vala_array_free (self->alterations, self->alterations_length1, (GDestroyNotify) g_free), NULL);
#line 1380 "../src/Photo.vala"
	self->alterations = _tmp2_;
#line 1380 "../src/Photo.vala"
	self->alterations_length1 = _tmp2__length1;
#line 1380 "../src/Photo.vala"
	self->_alterations_size_ = self->alterations_length1;
#line 1377 "../src/Photo.vala"
	return self;
#line 32823 "Photo.c"
}

static PhotoReimportMasterStateImpl*
photo_reimport_master_state_impl_new (PhotoRow* row,
                                      PhotoMetadata* metadata,
                                      gchar** alterations,
                                      gint alterations_length1)
{
#line 1377 "../src/Photo.vala"
	return photo_reimport_master_state_impl_construct (PHOTO_TYPE_REIMPORT_MASTER_STATE_IMPL, row, metadata, alterations, alterations_length1);
#line 32834 "Photo.c"
}

static void
photo_reimport_master_state_impl_class_init (PhotoReimportMasterStateImplClass * klass,
                                             gpointer klass_data)
{
#line 1371 "../src/Photo.vala"
	photo_reimport_master_state_impl_parent_class = g_type_class_peek_parent (klass);
#line 1371 "../src/Photo.vala"
	((PhotoReimportMasterStateClass *) klass)->finalize = photo_reimport_master_state_impl_finalize;
#line 32845 "Photo.c"
}

static void
photo_reimport_master_state_impl_instance_init (PhotoReimportMasterStateImpl * self,
                                                gpointer klass)
{
	PhotoRow* _tmp0_;
#line 1372 "../src/Photo.vala"
	_tmp0_ = photo_row_new ();
#line 1372 "../src/Photo.vala"
	self->row = _tmp0_;
#line 1375 "../src/Photo.vala"
	self->metadata_only = FALSE;
#line 32859 "Photo.c"
}

static void
photo_reimport_master_state_impl_finalize (PhotoReimportMasterState * obj)
{
	PhotoReimportMasterStateImpl * self;
#line 1371 "../src/Photo.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, PHOTO_TYPE_REIMPORT_MASTER_STATE_IMPL, PhotoReimportMasterStateImpl);
#line 1372 "../src/Photo.vala"
	_photo_row_unref0 (self->row);
#line 1373 "../src/Photo.vala"
	_media_metadata_unref0 (self->metadata);
#line 1374 "../src/Photo.vala"
	self->alterations = (_vala_array_free (self->alterations, self->alterations_length1, (GDestroyNotify) g_free), NULL);
#line 1371 "../src/Photo.vala"
	PHOTO_REIMPORT_MASTER_STATE_CLASS (photo_reimport_master_state_impl_parent_class)->finalize (obj);
#line 32876 "Photo.c"
}

static GType
photo_reimport_master_state_impl_get_type_once (void)
{
	static const GTypeInfo g_define_type_info = { sizeof (PhotoReimportMasterStateImplClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) photo_reimport_master_state_impl_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (PhotoReimportMasterStateImpl), 0, (GInstanceInitFunc) photo_reimport_master_state_impl_instance_init, NULL };
	GType photo_reimport_master_state_impl_type_id;
	photo_reimport_master_state_impl_type_id = g_type_register_static (PHOTO_TYPE_REIMPORT_MASTER_STATE, "PhotoReimportMasterStateImpl", &g_define_type_info, 0);
	return photo_reimport_master_state_impl_type_id;
}

static GType
photo_reimport_master_state_impl_get_type (void)
{
	static volatile gsize photo_reimport_master_state_impl_type_id__once = 0;
	if (g_once_init_enter (&photo_reimport_master_state_impl_type_id__once)) {
		GType photo_reimport_master_state_impl_type_id;
		photo_reimport_master_state_impl_type_id = photo_reimport_master_state_impl_get_type_once ();
		g_once_init_leave (&photo_reimport_master_state_impl_type_id__once, photo_reimport_master_state_impl_type_id);
	}
	return photo_reimport_master_state_impl_type_id__once;
}

PhotoReimportEditableState*
photo_reimport_editable_state_construct (GType object_type)
{
	PhotoReimportEditableState* self = NULL;
#line 1384 "../src/Photo.vala"
	self = (PhotoReimportEditableState*) g_type_create_instance (object_type);
#line 1384 "../src/Photo.vala"
	return self;
#line 32908 "Photo.c"
}

static void
photo_value_reimport_editable_state_init (GValue* value)
{
#line 1384 "../src/Photo.vala"
	value->data[0].v_pointer = NULL;
#line 32916 "Photo.c"
}

static void
photo_value_reimport_editable_state_free_value (GValue* value)
{
#line 1384 "../src/Photo.vala"
	if (value->data[0].v_pointer) {
#line 1384 "../src/Photo.vala"
		photo_reimport_editable_state_unref (value->data[0].v_pointer);
#line 32926 "Photo.c"
	}
}

static void
photo_value_reimport_editable_state_copy_value (const GValue* src_value,
                                                GValue* dest_value)
{
#line 1384 "../src/Photo.vala"
	if (src_value->data[0].v_pointer) {
#line 1384 "../src/Photo.vala"
		dest_value->data[0].v_pointer = photo_reimport_editable_state_ref (src_value->data[0].v_pointer);
#line 32938 "Photo.c"
	} else {
#line 1384 "../src/Photo.vala"
		dest_value->data[0].v_pointer = NULL;
#line 32942 "Photo.c"
	}
}

static gpointer
photo_value_reimport_editable_state_peek_pointer (const GValue* value)
{
#line 1384 "../src/Photo.vala"
	return value->data[0].v_pointer;
#line 32951 "Photo.c"
}

static gchar*
photo_value_reimport_editable_state_collect_value (GValue* value,
                                                   guint n_collect_values,
                                                   GTypeCValue* collect_values,
                                                   guint collect_flags)
{
#line 1384 "../src/Photo.vala"
	if (collect_values[0].v_pointer) {
#line 32962 "Photo.c"
		PhotoReimportEditableState * object;
		object = collect_values[0].v_pointer;
#line 1384 "../src/Photo.vala"
		if (object->parent_instance.g_class == NULL) {
#line 1384 "../src/Photo.vala"
			return g_strconcat ("invalid unclassed object pointer for value type `", G_VALUE_TYPE_NAME (value), "'", NULL);
#line 32969 "Photo.c"
		} else if (!g_value_type_compatible (G_TYPE_FROM_INSTANCE (object), G_VALUE_TYPE (value))) {
#line 1384 "../src/Photo.vala"
			return g_strconcat ("invalid object type `", g_type_name (G_TYPE_FROM_INSTANCE (object)), "' for value type `", G_VALUE_TYPE_NAME (value), "'", NULL);
#line 32973 "Photo.c"
		}
#line 1384 "../src/Photo.vala"
		value->data[0].v_pointer = photo_reimport_editable_state_ref (object);
#line 32977 "Photo.c"
	} else {
#line 1384 "../src/Photo.vala"
		value->data[0].v_pointer = NULL;
#line 32981 "Photo.c"
	}
#line 1384 "../src/Photo.vala"
	return NULL;
#line 32985 "Photo.c"
}

static gchar*
photo_value_reimport_editable_state_lcopy_value (const GValue* value,
                                                 guint n_collect_values,
                                                 GTypeCValue* collect_values,
                                                 guint collect_flags)
{
	PhotoReimportEditableState ** object_p;
	object_p = collect_values[0].v_pointer;
#line 1384 "../src/Photo.vala"
	if (!object_p) {
#line 1384 "../src/Photo.vala"
		return g_strdup_printf ("value location for `%s' passed as NULL", G_VALUE_TYPE_NAME (value));
#line 33000 "Photo.c"
	}
#line 1384 "../src/Photo.vala"
	if (!value->data[0].v_pointer) {
#line 1384 "../src/Photo.vala"
		*object_p = NULL;
#line 33006 "Photo.c"
	} else if (collect_flags & G_VALUE_NOCOPY_CONTENTS) {
#line 1384 "../src/Photo.vala"
		*object_p = value->data[0].v_pointer;
#line 33010 "Photo.c"
	} else {
#line 1384 "../src/Photo.vala"
		*object_p = photo_reimport_editable_state_ref (value->data[0].v_pointer);
#line 33014 "Photo.c"
	}
#line 1384 "../src/Photo.vala"
	return NULL;
#line 33018 "Photo.c"
}

GParamSpec*
photo_param_spec_reimport_editable_state (const gchar* name,
                                          const gchar* nick,
                                          const gchar* blurb,
                                          GType object_type,
                                          GParamFlags flags)
{
	PhotoParamSpecReimportEditableState* spec;
#line 1384 "../src/Photo.vala"
	g_return_val_if_fail (g_type_is_a (object_type, PHOTO_TYPE_REIMPORT_EDITABLE_STATE), NULL);
#line 1384 "../src/Photo.vala"
	spec = g_param_spec_internal (G_TYPE_PARAM_OBJECT, name, nick, blurb, flags);
#line 1384 "../src/Photo.vala"
	G_PARAM_SPEC (spec)->value_type = object_type;
#line 1384 "../src/Photo.vala"
	return G_PARAM_SPEC (spec);
#line 33037 "Photo.c"
}

gpointer
photo_value_get_reimport_editable_state (const GValue* value)
{
#line 1384 "../src/Photo.vala"
	g_return_val_if_fail (G_TYPE_CHECK_VALUE_TYPE (value, PHOTO_TYPE_REIMPORT_EDITABLE_STATE), NULL);
#line 1384 "../src/Photo.vala"
	return value->data[0].v_pointer;
#line 33047 "Photo.c"
}

void
photo_value_set_reimport_editable_state (GValue* value,
                                         gpointer v_object)
{
	PhotoReimportEditableState * old;
#line 1384 "../src/Photo.vala"
	g_return_if_fail (G_TYPE_CHECK_VALUE_TYPE (value, PHOTO_TYPE_REIMPORT_EDITABLE_STATE));
#line 1384 "../src/Photo.vala"
	old = value->data[0].v_pointer;
#line 1384 "../src/Photo.vala"
	if (v_object) {
#line 1384 "../src/Photo.vala"
		g_return_if_fail (G_TYPE_CHECK_INSTANCE_TYPE (v_object, PHOTO_TYPE_REIMPORT_EDITABLE_STATE));
#line 1384 "../src/Photo.vala"
		g_return_if_fail (g_value_type_compatible (G_TYPE_FROM_INSTANCE (v_object), G_VALUE_TYPE (value)));
#line 1384 "../src/Photo.vala"
		value->data[0].v_pointer = v_object;
#line 1384 "../src/Photo.vala"
		photo_reimport_editable_state_ref (value->data[0].v_pointer);
#line 33069 "Photo.c"
	} else {
#line 1384 "../src/Photo.vala"
		value->data[0].v_pointer = NULL;
#line 33073 "Photo.c"
	}
#line 1384 "../src/Photo.vala"
	if (old) {
#line 1384 "../src/Photo.vala"
		photo_reimport_editable_state_unref (old);
#line 33079 "Photo.c"
	}
}

void
photo_value_take_reimport_editable_state (GValue* value,
                                          gpointer v_object)
{
	PhotoReimportEditableState * old;
#line 1384 "../src/Photo.vala"
	g_return_if_fail (G_TYPE_CHECK_VALUE_TYPE (value, PHOTO_TYPE_REIMPORT_EDITABLE_STATE));
#line 1384 "../src/Photo.vala"
	old = value->data[0].v_pointer;
#line 1384 "../src/Photo.vala"
	if (v_object) {
#line 1384 "../src/Photo.vala"
		g_return_if_fail (G_TYPE_CHECK_INSTANCE_TYPE (v_object, PHOTO_TYPE_REIMPORT_EDITABLE_STATE));
#line 1384 "../src/Photo.vala"
		g_return_if_fail (g_value_type_compatible (G_TYPE_FROM_INSTANCE (v_object), G_VALUE_TYPE (value)));
#line 1384 "../src/Photo.vala"
		value->data[0].v_pointer = v_object;
#line 33100 "Photo.c"
	} else {
#line 1384 "../src/Photo.vala"
		value->data[0].v_pointer = NULL;
#line 33104 "Photo.c"
	}
#line 1384 "../src/Photo.vala"
	if (old) {
#line 1384 "../src/Photo.vala"
		photo_reimport_editable_state_unref (old);
#line 33110 "Photo.c"
	}
}

static void
photo_reimport_editable_state_class_init (PhotoReimportEditableStateClass * klass,
                                          gpointer klass_data)
{
#line 1384 "../src/Photo.vala"
	photo_reimport_editable_state_parent_class = g_type_class_peek_parent (klass);
#line 1384 "../src/Photo.vala"
	((PhotoReimportEditableStateClass *) klass)->finalize = photo_reimport_editable_state_finalize;
#line 33122 "Photo.c"
}

static void
photo_reimport_editable_state_instance_init (PhotoReimportEditableState * self,
                                             gpointer klass)
{
#line 1384 "../src/Photo.vala"
	self->ref_count = 1;
#line 33131 "Photo.c"
}

static void
photo_reimport_editable_state_finalize (PhotoReimportEditableState * obj)
{
	PhotoReimportEditableState * self;
#line 1384 "../src/Photo.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, PHOTO_TYPE_REIMPORT_EDITABLE_STATE, PhotoReimportEditableState);
#line 1384 "../src/Photo.vala"
	g_signal_handlers_destroy (self);
#line 33142 "Photo.c"
}

static GType
photo_reimport_editable_state_get_type_once (void)
{
	static const GTypeValueTable g_define_type_value_table = { photo_value_reimport_editable_state_init, photo_value_reimport_editable_state_free_value, photo_value_reimport_editable_state_copy_value, photo_value_reimport_editable_state_peek_pointer, "p", photo_value_reimport_editable_state_collect_value, "p", photo_value_reimport_editable_state_lcopy_value };
	static const GTypeInfo g_define_type_info = { sizeof (PhotoReimportEditableStateClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) photo_reimport_editable_state_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (PhotoReimportEditableState), 0, (GInstanceInitFunc) photo_reimport_editable_state_instance_init, &g_define_type_value_table };
	static const GTypeFundamentalInfo g_define_type_fundamental_info = { (G_TYPE_FLAG_CLASSED | G_TYPE_FLAG_INSTANTIATABLE | G_TYPE_FLAG_DERIVABLE | G_TYPE_FLAG_DEEP_DERIVABLE) };
	GType photo_reimport_editable_state_type_id;
	photo_reimport_editable_state_type_id = g_type_register_fundamental (g_type_fundamental_next (), "PhotoReimportEditableState", &g_define_type_info, &g_define_type_fundamental_info, G_TYPE_FLAG_ABSTRACT);
	return photo_reimport_editable_state_type_id;
}

GType
photo_reimport_editable_state_get_type (void)
{
	static volatile gsize photo_reimport_editable_state_type_id__once = 0;
	if (g_once_init_enter (&photo_reimport_editable_state_type_id__once)) {
		GType photo_reimport_editable_state_type_id;
		photo_reimport_editable_state_type_id = photo_reimport_editable_state_get_type_once ();
		g_once_init_leave (&photo_reimport_editable_state_type_id__once, photo_reimport_editable_state_type_id);
	}
	return photo_reimport_editable_state_type_id__once;
}

gpointer
photo_reimport_editable_state_ref (gpointer instance)
{
	PhotoReimportEditableState * self;
	self = instance;
#line 1384 "../src/Photo.vala"
	g_atomic_int_inc (&self->ref_count);
#line 1384 "../src/Photo.vala"
	return instance;
#line 33177 "Photo.c"
}

void
photo_reimport_editable_state_unref (gpointer instance)
{
	PhotoReimportEditableState * self;
	self = instance;
#line 1384 "../src/Photo.vala"
	if (g_atomic_int_dec_and_test (&self->ref_count)) {
#line 1384 "../src/Photo.vala"
		PHOTO_REIMPORT_EDITABLE_STATE_GET_CLASS (self)->finalize (self);
#line 1384 "../src/Photo.vala"
		g_type_free_instance ((GTypeInstance *) self);
#line 33191 "Photo.c"
	}
}

static PhotoReimportEditableStateImpl*
photo_reimport_editable_state_impl_construct (GType object_type,
                                              BackingPhotoRow* backing_state,
                                              PhotoMetadata* metadata)
{
	PhotoReimportEditableStateImpl* self = NULL;
	BackingPhotoRow* _tmp0_;
	PhotoMetadata* _tmp1_;
#line 1392 "../src/Photo.vala"
	g_return_val_if_fail (IS_BACKING_PHOTO_ROW (backing_state), NULL);
#line 1392 "../src/Photo.vala"
	g_return_val_if_fail ((metadata == NULL) || IS_PHOTO_METADATA (metadata), NULL);
#line 1392 "../src/Photo.vala"
	self = (PhotoReimportEditableStateImpl*) photo_reimport_editable_state_construct (object_type);
#line 1393 "../src/Photo.vala"
	_tmp0_ = _backing_photo_row_ref0 (backing_state);
#line 1393 "../src/Photo.vala"
	_backing_photo_row_unref0 (self->backing_state);
#line 1393 "../src/Photo.vala"
	self->backing_state = _tmp0_;
#line 1394 "../src/Photo.vala"
	_tmp1_ = _media_metadata_ref0 (metadata);
#line 1394 "../src/Photo.vala"
	_media_metadata_unref0 (self->metadata);
#line 1394 "../src/Photo.vala"
	self->metadata = _tmp1_;
#line 1392 "../src/Photo.vala"
	return self;
#line 33223 "Photo.c"
}

static PhotoReimportEditableStateImpl*
photo_reimport_editable_state_impl_new (BackingPhotoRow* backing_state,
                                        PhotoMetadata* metadata)
{
#line 1392 "../src/Photo.vala"
	return photo_reimport_editable_state_impl_construct (PHOTO_TYPE_REIMPORT_EDITABLE_STATE_IMPL, backing_state, metadata);
#line 33232 "Photo.c"
}

static void
photo_reimport_editable_state_impl_class_init (PhotoReimportEditableStateImplClass * klass,
                                               gpointer klass_data)
{
#line 1387 "../src/Photo.vala"
	photo_reimport_editable_state_impl_parent_class = g_type_class_peek_parent (klass);
#line 1387 "../src/Photo.vala"
	((PhotoReimportEditableStateClass *) klass)->finalize = photo_reimport_editable_state_impl_finalize;
#line 33243 "Photo.c"
}

static void
photo_reimport_editable_state_impl_instance_init (PhotoReimportEditableStateImpl * self,
                                                  gpointer klass)
{
	BackingPhotoRow* _tmp0_;
#line 1388 "../src/Photo.vala"
	_tmp0_ = backing_photo_row_new ();
#line 1388 "../src/Photo.vala"
	self->backing_state = _tmp0_;
#line 1390 "../src/Photo.vala"
	self->metadata_only = FALSE;
#line 33257 "Photo.c"
}

static void
photo_reimport_editable_state_impl_finalize (PhotoReimportEditableState * obj)
{
	PhotoReimportEditableStateImpl * self;
#line 1387 "../src/Photo.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, PHOTO_TYPE_REIMPORT_EDITABLE_STATE_IMPL, PhotoReimportEditableStateImpl);
#line 1388 "../src/Photo.vala"
	_backing_photo_row_unref0 (self->backing_state);
#line 1389 "../src/Photo.vala"
	_media_metadata_unref0 (self->metadata);
#line 1387 "../src/Photo.vala"
	PHOTO_REIMPORT_EDITABLE_STATE_CLASS (photo_reimport_editable_state_impl_parent_class)->finalize (obj);
#line 33272 "Photo.c"
}

static GType
photo_reimport_editable_state_impl_get_type_once (void)
{
	static const GTypeInfo g_define_type_info = { sizeof (PhotoReimportEditableStateImplClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) photo_reimport_editable_state_impl_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (PhotoReimportEditableStateImpl), 0, (GInstanceInitFunc) photo_reimport_editable_state_impl_instance_init, NULL };
	GType photo_reimport_editable_state_impl_type_id;
	photo_reimport_editable_state_impl_type_id = g_type_register_static (PHOTO_TYPE_REIMPORT_EDITABLE_STATE, "PhotoReimportEditableStateImpl", &g_define_type_info, 0);
	return photo_reimport_editable_state_impl_type_id;
}

static GType
photo_reimport_editable_state_impl_get_type (void)
{
	static volatile gsize photo_reimport_editable_state_impl_type_id__once = 0;
	if (g_once_init_enter (&photo_reimport_editable_state_impl_type_id__once)) {
		GType photo_reimport_editable_state_impl_type_id;
		photo_reimport_editable_state_impl_type_id = photo_reimport_editable_state_impl_get_type_once ();
		g_once_init_leave (&photo_reimport_editable_state_impl_type_id__once, photo_reimport_editable_state_impl_type_id);
	}
	return photo_reimport_editable_state_impl_type_id__once;
}

PhotoReimportRawDevelopmentState*
photo_reimport_raw_development_state_construct (GType object_type)
{
	PhotoReimportRawDevelopmentState* self = NULL;
#line 1398 "../src/Photo.vala"
	self = (PhotoReimportRawDevelopmentState*) g_type_create_instance (object_type);
#line 1398 "../src/Photo.vala"
	return self;
#line 33304 "Photo.c"
}

static void
photo_value_reimport_raw_development_state_init (GValue* value)
{
#line 1398 "../src/Photo.vala"
	value->data[0].v_pointer = NULL;
#line 33312 "Photo.c"
}

static void
photo_value_reimport_raw_development_state_free_value (GValue* value)
{
#line 1398 "../src/Photo.vala"
	if (value->data[0].v_pointer) {
#line 1398 "../src/Photo.vala"
		photo_reimport_raw_development_state_unref (value->data[0].v_pointer);
#line 33322 "Photo.c"
	}
}

static void
photo_value_reimport_raw_development_state_copy_value (const GValue* src_value,
                                                       GValue* dest_value)
{
#line 1398 "../src/Photo.vala"
	if (src_value->data[0].v_pointer) {
#line 1398 "../src/Photo.vala"
		dest_value->data[0].v_pointer = photo_reimport_raw_development_state_ref (src_value->data[0].v_pointer);
#line 33334 "Photo.c"
	} else {
#line 1398 "../src/Photo.vala"
		dest_value->data[0].v_pointer = NULL;
#line 33338 "Photo.c"
	}
}

static gpointer
photo_value_reimport_raw_development_state_peek_pointer (const GValue* value)
{
#line 1398 "../src/Photo.vala"
	return value->data[0].v_pointer;
#line 33347 "Photo.c"
}

static gchar*
photo_value_reimport_raw_development_state_collect_value (GValue* value,
                                                          guint n_collect_values,
                                                          GTypeCValue* collect_values,
                                                          guint collect_flags)
{
#line 1398 "../src/Photo.vala"
	if (collect_values[0].v_pointer) {
#line 33358 "Photo.c"
		PhotoReimportRawDevelopmentState * object;
		object = collect_values[0].v_pointer;
#line 1398 "../src/Photo.vala"
		if (object->parent_instance.g_class == NULL) {
#line 1398 "../src/Photo.vala"
			return g_strconcat ("invalid unclassed object pointer for value type `", G_VALUE_TYPE_NAME (value), "'", NULL);
#line 33365 "Photo.c"
		} else if (!g_value_type_compatible (G_TYPE_FROM_INSTANCE (object), G_VALUE_TYPE (value))) {
#line 1398 "../src/Photo.vala"
			return g_strconcat ("invalid object type `", g_type_name (G_TYPE_FROM_INSTANCE (object)), "' for value type `", G_VALUE_TYPE_NAME (value), "'", NULL);
#line 33369 "Photo.c"
		}
#line 1398 "../src/Photo.vala"
		value->data[0].v_pointer = photo_reimport_raw_development_state_ref (object);
#line 33373 "Photo.c"
	} else {
#line 1398 "../src/Photo.vala"
		value->data[0].v_pointer = NULL;
#line 33377 "Photo.c"
	}
#line 1398 "../src/Photo.vala"
	return NULL;
#line 33381 "Photo.c"
}

static gchar*
photo_value_reimport_raw_development_state_lcopy_value (const GValue* value,
                                                        guint n_collect_values,
                                                        GTypeCValue* collect_values,
                                                        guint collect_flags)
{
	PhotoReimportRawDevelopmentState ** object_p;
	object_p = collect_values[0].v_pointer;
#line 1398 "../src/Photo.vala"
	if (!object_p) {
#line 1398 "../src/Photo.vala"
		return g_strdup_printf ("value location for `%s' passed as NULL", G_VALUE_TYPE_NAME (value));
#line 33396 "Photo.c"
	}
#line 1398 "../src/Photo.vala"
	if (!value->data[0].v_pointer) {
#line 1398 "../src/Photo.vala"
		*object_p = NULL;
#line 33402 "Photo.c"
	} else if (collect_flags & G_VALUE_NOCOPY_CONTENTS) {
#line 1398 "../src/Photo.vala"
		*object_p = value->data[0].v_pointer;
#line 33406 "Photo.c"
	} else {
#line 1398 "../src/Photo.vala"
		*object_p = photo_reimport_raw_development_state_ref (value->data[0].v_pointer);
#line 33410 "Photo.c"
	}
#line 1398 "../src/Photo.vala"
	return NULL;
#line 33414 "Photo.c"
}

GParamSpec*
photo_param_spec_reimport_raw_development_state (const gchar* name,
                                                 const gchar* nick,
                                                 const gchar* blurb,
                                                 GType object_type,
                                                 GParamFlags flags)
{
	PhotoParamSpecReimportRawDevelopmentState* spec;
#line 1398 "../src/Photo.vala"
	g_return_val_if_fail (g_type_is_a (object_type, PHOTO_TYPE_REIMPORT_RAW_DEVELOPMENT_STATE), NULL);
#line 1398 "../src/Photo.vala"
	spec = g_param_spec_internal (G_TYPE_PARAM_OBJECT, name, nick, blurb, flags);
#line 1398 "../src/Photo.vala"
	G_PARAM_SPEC (spec)->value_type = object_type;
#line 1398 "../src/Photo.vala"
	return G_PARAM_SPEC (spec);
#line 33433 "Photo.c"
}

gpointer
photo_value_get_reimport_raw_development_state (const GValue* value)
{
#line 1398 "../src/Photo.vala"
	g_return_val_if_fail (G_TYPE_CHECK_VALUE_TYPE (value, PHOTO_TYPE_REIMPORT_RAW_DEVELOPMENT_STATE), NULL);
#line 1398 "../src/Photo.vala"
	return value->data[0].v_pointer;
#line 33443 "Photo.c"
}

void
photo_value_set_reimport_raw_development_state (GValue* value,
                                                gpointer v_object)
{
	PhotoReimportRawDevelopmentState * old;
#line 1398 "../src/Photo.vala"
	g_return_if_fail (G_TYPE_CHECK_VALUE_TYPE (value, PHOTO_TYPE_REIMPORT_RAW_DEVELOPMENT_STATE));
#line 1398 "../src/Photo.vala"
	old = value->data[0].v_pointer;
#line 1398 "../src/Photo.vala"
	if (v_object) {
#line 1398 "../src/Photo.vala"
		g_return_if_fail (G_TYPE_CHECK_INSTANCE_TYPE (v_object, PHOTO_TYPE_REIMPORT_RAW_DEVELOPMENT_STATE));
#line 1398 "../src/Photo.vala"
		g_return_if_fail (g_value_type_compatible (G_TYPE_FROM_INSTANCE (v_object), G_VALUE_TYPE (value)));
#line 1398 "../src/Photo.vala"
		value->data[0].v_pointer = v_object;
#line 1398 "../src/Photo.vala"
		photo_reimport_raw_development_state_ref (value->data[0].v_pointer);
#line 33465 "Photo.c"
	} else {
#line 1398 "../src/Photo.vala"
		value->data[0].v_pointer = NULL;
#line 33469 "Photo.c"
	}
#line 1398 "../src/Photo.vala"
	if (old) {
#line 1398 "../src/Photo.vala"
		photo_reimport_raw_development_state_unref (old);
#line 33475 "Photo.c"
	}
}

void
photo_value_take_reimport_raw_development_state (GValue* value,
                                                 gpointer v_object)
{
	PhotoReimportRawDevelopmentState * old;
#line 1398 "../src/Photo.vala"
	g_return_if_fail (G_TYPE_CHECK_VALUE_TYPE (value, PHOTO_TYPE_REIMPORT_RAW_DEVELOPMENT_STATE));
#line 1398 "../src/Photo.vala"
	old = value->data[0].v_pointer;
#line 1398 "../src/Photo.vala"
	if (v_object) {
#line 1398 "../src/Photo.vala"
		g_return_if_fail (G_TYPE_CHECK_INSTANCE_TYPE (v_object, PHOTO_TYPE_REIMPORT_RAW_DEVELOPMENT_STATE));
#line 1398 "../src/Photo.vala"
		g_return_if_fail (g_value_type_compatible (G_TYPE_FROM_INSTANCE (v_object), G_VALUE_TYPE (value)));
#line 1398 "../src/Photo.vala"
		value->data[0].v_pointer = v_object;
#line 33496 "Photo.c"
	} else {
#line 1398 "../src/Photo.vala"
		value->data[0].v_pointer = NULL;
#line 33500 "Photo.c"
	}
#line 1398 "../src/Photo.vala"
	if (old) {
#line 1398 "../src/Photo.vala"
		photo_reimport_raw_development_state_unref (old);
#line 33506 "Photo.c"
	}
}

static void
photo_reimport_raw_development_state_class_init (PhotoReimportRawDevelopmentStateClass * klass,
                                                 gpointer klass_data)
{
#line 1398 "../src/Photo.vala"
	photo_reimport_raw_development_state_parent_class = g_type_class_peek_parent (klass);
#line 1398 "../src/Photo.vala"
	((PhotoReimportRawDevelopmentStateClass *) klass)->finalize = photo_reimport_raw_development_state_finalize;
#line 33518 "Photo.c"
}

static void
photo_reimport_raw_development_state_instance_init (PhotoReimportRawDevelopmentState * self,
                                                    gpointer klass)
{
#line 1398 "../src/Photo.vala"
	self->ref_count = 1;
#line 33527 "Photo.c"
}

static void
photo_reimport_raw_development_state_finalize (PhotoReimportRawDevelopmentState * obj)
{
	PhotoReimportRawDevelopmentState * self;
#line 1398 "../src/Photo.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, PHOTO_TYPE_REIMPORT_RAW_DEVELOPMENT_STATE, PhotoReimportRawDevelopmentState);
#line 1398 "../src/Photo.vala"
	g_signal_handlers_destroy (self);
#line 33538 "Photo.c"
}

static GType
photo_reimport_raw_development_state_get_type_once (void)
{
	static const GTypeValueTable g_define_type_value_table = { photo_value_reimport_raw_development_state_init, photo_value_reimport_raw_development_state_free_value, photo_value_reimport_raw_development_state_copy_value, photo_value_reimport_raw_development_state_peek_pointer, "p", photo_value_reimport_raw_development_state_collect_value, "p", photo_value_reimport_raw_development_state_lcopy_value };
	static const GTypeInfo g_define_type_info = { sizeof (PhotoReimportRawDevelopmentStateClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) photo_reimport_raw_development_state_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (PhotoReimportRawDevelopmentState), 0, (GInstanceInitFunc) photo_reimport_raw_development_state_instance_init, &g_define_type_value_table };
	static const GTypeFundamentalInfo g_define_type_fundamental_info = { (G_TYPE_FLAG_CLASSED | G_TYPE_FLAG_INSTANTIATABLE | G_TYPE_FLAG_DERIVABLE | G_TYPE_FLAG_DEEP_DERIVABLE) };
	GType photo_reimport_raw_development_state_type_id;
	photo_reimport_raw_development_state_type_id = g_type_register_fundamental (g_type_fundamental_next (), "PhotoReimportRawDevelopmentState", &g_define_type_info, &g_define_type_fundamental_info, G_TYPE_FLAG_ABSTRACT);
	return photo_reimport_raw_development_state_type_id;
}

GType
photo_reimport_raw_development_state_get_type (void)
{
	static volatile gsize photo_reimport_raw_development_state_type_id__once = 0;
	if (g_once_init_enter (&photo_reimport_raw_development_state_type_id__once)) {
		GType photo_reimport_raw_development_state_type_id;
		photo_reimport_raw_development_state_type_id = photo_reimport_raw_development_state_get_type_once ();
		g_once_init_leave (&photo_reimport_raw_development_state_type_id__once, photo_reimport_raw_development_state_type_id);
	}
	return photo_reimport_raw_development_state_type_id__once;
}

gpointer
photo_reimport_raw_development_state_ref (gpointer instance)
{
	PhotoReimportRawDevelopmentState * self;
	self = instance;
#line 1398 "../src/Photo.vala"
	g_atomic_int_inc (&self->ref_count);
#line 1398 "../src/Photo.vala"
	return instance;
#line 33573 "Photo.c"
}

void
photo_reimport_raw_development_state_unref (gpointer instance)
{
	PhotoReimportRawDevelopmentState * self;
	self = instance;
#line 1398 "../src/Photo.vala"
	if (g_atomic_int_dec_and_test (&self->ref_count)) {
#line 1398 "../src/Photo.vala"
		PHOTO_REIMPORT_RAW_DEVELOPMENT_STATE_GET_CLASS (self)->finalize (self);
#line 1398 "../src/Photo.vala"
		g_type_free_instance ((GTypeInstance *) self);
#line 33587 "Photo.c"
	}
}

static PhotoReimportRawDevelopmentStateImpl*
photo_reimport_raw_development_state_impl_construct (GType object_type)
{
	PhotoReimportRawDevelopmentStateImpl* self = NULL;
#line 1415 "../src/Photo.vala"
	self = (PhotoReimportRawDevelopmentStateImpl*) photo_reimport_raw_development_state_construct (object_type);
#line 1415 "../src/Photo.vala"
	return self;
#line 33599 "Photo.c"
}

static PhotoReimportRawDevelopmentStateImpl*
photo_reimport_raw_development_state_impl_new (void)
{
#line 1415 "../src/Photo.vala"
	return photo_reimport_raw_development_state_impl_construct (PHOTO_TYPE_REIMPORT_RAW_DEVELOPMENT_STATE_IMPL);
#line 33607 "Photo.c"
}

static void
photo_reimport_raw_development_state_impl_add (PhotoReimportRawDevelopmentStateImpl* self,
                                               BackingPhotoRow* backing,
                                               PhotoMetadata* metadata)
{
	GeeCollection* _tmp0_;
	PhotoReimportRawDevelopmentStateImplDevToReimport* _tmp1_;
	PhotoReimportRawDevelopmentStateImplDevToReimport* _tmp2_;
#line 1418 "../src/Photo.vala"
	g_return_if_fail (PHOTO_IS_REIMPORT_RAW_DEVELOPMENT_STATE_IMPL (self));
#line 1418 "../src/Photo.vala"
	g_return_if_fail (IS_BACKING_PHOTO_ROW (backing));
#line 1418 "../src/Photo.vala"
	g_return_if_fail ((metadata == NULL) || IS_PHOTO_METADATA (metadata));
#line 1419 "../src/Photo.vala"
	_tmp0_ = self->list;
#line 1419 "../src/Photo.vala"
	_tmp1_ = photo_reimport_raw_development_state_impl_dev_to_reimport_new (backing, metadata);
#line 1419 "../src/Photo.vala"
	_tmp2_ = _tmp1_;
#line 1419 "../src/Photo.vala"
	gee_collection_add (_tmp0_, _tmp2_);
#line 1419 "../src/Photo.vala"
	_photo_reimport_raw_development_state_impl_dev_to_reimport_unref0 (_tmp2_);
#line 33634 "Photo.c"
}

static gint
photo_reimport_raw_development_state_impl_get_size (PhotoReimportRawDevelopmentStateImpl* self)
{
	GeeCollection* _tmp0_;
	gint _tmp1_;
	gint _tmp2_;
	gint result;
#line 1422 "../src/Photo.vala"
	g_return_val_if_fail (PHOTO_IS_REIMPORT_RAW_DEVELOPMENT_STATE_IMPL (self), 0);
#line 1423 "../src/Photo.vala"
	_tmp0_ = self->list;
#line 1423 "../src/Photo.vala"
	_tmp1_ = gee_collection_get_size (_tmp0_);
#line 1423 "../src/Photo.vala"
	_tmp2_ = _tmp1_;
#line 1423 "../src/Photo.vala"
	result = _tmp2_;
#line 1423 "../src/Photo.vala"
	return result;
#line 33656 "Photo.c"
}

static PhotoReimportRawDevelopmentStateImplDevToReimport*
photo_reimport_raw_development_state_impl_dev_to_reimport_construct (GType object_type,
                                                                     BackingPhotoRow* backing,
                                                                     PhotoMetadata* metadata)
{
	PhotoReimportRawDevelopmentStateImplDevToReimport* self = NULL;
	BackingPhotoRow* _tmp0_;
	PhotoMetadata* _tmp1_;
#line 1406 "../src/Photo.vala"
	g_return_val_if_fail (IS_BACKING_PHOTO_ROW (backing), NULL);
#line 1406 "../src/Photo.vala"
	g_return_val_if_fail ((metadata == NULL) || IS_PHOTO_METADATA (metadata), NULL);
#line 1406 "../src/Photo.vala"
	self = (PhotoReimportRawDevelopmentStateImplDevToReimport*) g_type_create_instance (object_type);
#line 1407 "../src/Photo.vala"
	_tmp0_ = _backing_photo_row_ref0 (backing);
#line 1407 "../src/Photo.vala"
	_backing_photo_row_unref0 (self->backing);
#line 1407 "../src/Photo.vala"
	self->backing = _tmp0_;
#line 1408 "../src/Photo.vala"
	_tmp1_ = _media_metadata_ref0 (metadata);
#line 1408 "../src/Photo.vala"
	_media_metadata_unref0 (self->metadata);
#line 1408 "../src/Photo.vala"
	self->metadata = _tmp1_;
#line 1406 "../src/Photo.vala"
	return self;
#line 33687 "Photo.c"
}

static PhotoReimportRawDevelopmentStateImplDevToReimport*
photo_reimport_raw_development_state_impl_dev_to_reimport_new (BackingPhotoRow* backing,
                                                               PhotoMetadata* metadata)
{
#line 1406 "../src/Photo.vala"
	return photo_reimport_raw_development_state_impl_dev_to_reimport_construct (PHOTO_REIMPORT_RAW_DEVELOPMENT_STATE_IMPL_TYPE_DEV_TO_REIMPORT, backing, metadata);
#line 33696 "Photo.c"
}

static void
photo_reimport_raw_development_state_impl_value_dev_to_reimport_init (GValue* value)
{
#line 1402 "../src/Photo.vala"
	value->data[0].v_pointer = NULL;
#line 33704 "Photo.c"
}

static void
photo_reimport_raw_development_state_impl_value_dev_to_reimport_free_value (GValue* value)
{
#line 1402 "../src/Photo.vala"
	if (value->data[0].v_pointer) {
#line 1402 "../src/Photo.vala"
		photo_reimport_raw_development_state_impl_dev_to_reimport_unref (value->data[0].v_pointer);
#line 33714 "Photo.c"
	}
}

static void
photo_reimport_raw_development_state_impl_value_dev_to_reimport_copy_value (const GValue* src_value,
                                                                            GValue* dest_value)
{
#line 1402 "../src/Photo.vala"
	if (src_value->data[0].v_pointer) {
#line 1402 "../src/Photo.vala"
		dest_value->data[0].v_pointer = photo_reimport_raw_development_state_impl_dev_to_reimport_ref (src_value->data[0].v_pointer);
#line 33726 "Photo.c"
	} else {
#line 1402 "../src/Photo.vala"
		dest_value->data[0].v_pointer = NULL;
#line 33730 "Photo.c"
	}
}

static gpointer
photo_reimport_raw_development_state_impl_value_dev_to_reimport_peek_pointer (const GValue* value)
{
#line 1402 "../src/Photo.vala"
	return value->data[0].v_pointer;
#line 33739 "Photo.c"
}

static gchar*
photo_reimport_raw_development_state_impl_value_dev_to_reimport_collect_value (GValue* value,
                                                                               guint n_collect_values,
                                                                               GTypeCValue* collect_values,
                                                                               guint collect_flags)
{
#line 1402 "../src/Photo.vala"
	if (collect_values[0].v_pointer) {
#line 33750 "Photo.c"
		PhotoReimportRawDevelopmentStateImplDevToReimport * object;
		object = collect_values[0].v_pointer;
#line 1402 "../src/Photo.vala"
		if (object->parent_instance.g_class == NULL) {
#line 1402 "../src/Photo.vala"
			return g_strconcat ("invalid unclassed object pointer for value type `", G_VALUE_TYPE_NAME (value), "'", NULL);
#line 33757 "Photo.c"
		} else if (!g_value_type_compatible (G_TYPE_FROM_INSTANCE (object), G_VALUE_TYPE (value))) {
#line 1402 "../src/Photo.vala"
			return g_strconcat ("invalid object type `", g_type_name (G_TYPE_FROM_INSTANCE (object)), "' for value type `", G_VALUE_TYPE_NAME (value), "'", NULL);
#line 33761 "Photo.c"
		}
#line 1402 "../src/Photo.vala"
		value->data[0].v_pointer = photo_reimport_raw_development_state_impl_dev_to_reimport_ref (object);
#line 33765 "Photo.c"
	} else {
#line 1402 "../src/Photo.vala"
		value->data[0].v_pointer = NULL;
#line 33769 "Photo.c"
	}
#line 1402 "../src/Photo.vala"
	return NULL;
#line 33773 "Photo.c"
}

static gchar*
photo_reimport_raw_development_state_impl_value_dev_to_reimport_lcopy_value (const GValue* value,
                                                                             guint n_collect_values,
                                                                             GTypeCValue* collect_values,
                                                                             guint collect_flags)
{
	PhotoReimportRawDevelopmentStateImplDevToReimport ** object_p;
	object_p = collect_values[0].v_pointer;
#line 1402 "../src/Photo.vala"
	if (!object_p) {
#line 1402 "../src/Photo.vala"
		return g_strdup_printf ("value location for `%s' passed as NULL", G_VALUE_TYPE_NAME (value));
#line 33788 "Photo.c"
	}
#line 1402 "../src/Photo.vala"
	if (!value->data[0].v_pointer) {
#line 1402 "../src/Photo.vala"
		*object_p = NULL;
#line 33794 "Photo.c"
	} else if (collect_flags & G_VALUE_NOCOPY_CONTENTS) {
#line 1402 "../src/Photo.vala"
		*object_p = value->data[0].v_pointer;
#line 33798 "Photo.c"
	} else {
#line 1402 "../src/Photo.vala"
		*object_p = photo_reimport_raw_development_state_impl_dev_to_reimport_ref (value->data[0].v_pointer);
#line 33802 "Photo.c"
	}
#line 1402 "../src/Photo.vala"
	return NULL;
#line 33806 "Photo.c"
}

static GParamSpec*
photo_reimport_raw_development_state_impl_param_spec_dev_to_reimport (const gchar* name,
                                                                      const gchar* nick,
                                                                      const gchar* blurb,
                                                                      GType object_type,
                                                                      GParamFlags flags)
{
	PhotoReimportRawDevelopmentStateImplParamSpecDevToReimport* spec;
#line 1402 "../src/Photo.vala"
	g_return_val_if_fail (g_type_is_a (object_type, PHOTO_REIMPORT_RAW_DEVELOPMENT_STATE_IMPL_TYPE_DEV_TO_REIMPORT), NULL);
#line 1402 "../src/Photo.vala"
	spec = g_param_spec_internal (G_TYPE_PARAM_OBJECT, name, nick, blurb, flags);
#line 1402 "../src/Photo.vala"
	G_PARAM_SPEC (spec)->value_type = object_type;
#line 1402 "../src/Photo.vala"
	return G_PARAM_SPEC (spec);
#line 33825 "Photo.c"
}

static gpointer
photo_reimport_raw_development_state_impl_value_get_dev_to_reimport (const GValue* value)
{
#line 1402 "../src/Photo.vala"
	g_return_val_if_fail (G_TYPE_CHECK_VALUE_TYPE (value, PHOTO_REIMPORT_RAW_DEVELOPMENT_STATE_IMPL_TYPE_DEV_TO_REIMPORT), NULL);
#line 1402 "../src/Photo.vala"
	return value->data[0].v_pointer;
#line 33835 "Photo.c"
}

static void
photo_reimport_raw_development_state_impl_value_set_dev_to_reimport (GValue* value,
                                                                     gpointer v_object)
{
	PhotoReimportRawDevelopmentStateImplDevToReimport * old;
#line 1402 "../src/Photo.vala"
	g_return_if_fail (G_TYPE_CHECK_VALUE_TYPE (value, PHOTO_REIMPORT_RAW_DEVELOPMENT_STATE_IMPL_TYPE_DEV_TO_REIMPORT));
#line 1402 "../src/Photo.vala"
	old = value->data[0].v_pointer;
#line 1402 "../src/Photo.vala"
	if (v_object) {
#line 1402 "../src/Photo.vala"
		g_return_if_fail (G_TYPE_CHECK_INSTANCE_TYPE (v_object, PHOTO_REIMPORT_RAW_DEVELOPMENT_STATE_IMPL_TYPE_DEV_TO_REIMPORT));
#line 1402 "../src/Photo.vala"
		g_return_if_fail (g_value_type_compatible (G_TYPE_FROM_INSTANCE (v_object), G_VALUE_TYPE (value)));
#line 1402 "../src/Photo.vala"
		value->data[0].v_pointer = v_object;
#line 1402 "../src/Photo.vala"
		photo_reimport_raw_development_state_impl_dev_to_reimport_ref (value->data[0].v_pointer);
#line 33857 "Photo.c"
	} else {
#line 1402 "../src/Photo.vala"
		value->data[0].v_pointer = NULL;
#line 33861 "Photo.c"
	}
#line 1402 "../src/Photo.vala"
	if (old) {
#line 1402 "../src/Photo.vala"
		photo_reimport_raw_development_state_impl_dev_to_reimport_unref (old);
#line 33867 "Photo.c"
	}
}

static void
photo_reimport_raw_development_state_impl_value_take_dev_to_reimport (GValue* value,
                                                                      gpointer v_object)
{
	PhotoReimportRawDevelopmentStateImplDevToReimport * old;
#line 1402 "../src/Photo.vala"
	g_return_if_fail (G_TYPE_CHECK_VALUE_TYPE (value, PHOTO_REIMPORT_RAW_DEVELOPMENT_STATE_IMPL_TYPE_DEV_TO_REIMPORT));
#line 1402 "../src/Photo.vala"
	old = value->data[0].v_pointer;
#line 1402 "../src/Photo.vala"
	if (v_object) {
#line 1402 "../src/Photo.vala"
		g_return_if_fail (G_TYPE_CHECK_INSTANCE_TYPE (v_object, PHOTO_REIMPORT_RAW_DEVELOPMENT_STATE_IMPL_TYPE_DEV_TO_REIMPORT));
#line 1402 "../src/Photo.vala"
		g_return_if_fail (g_value_type_compatible (G_TYPE_FROM_INSTANCE (v_object), G_VALUE_TYPE (value)));
#line 1402 "../src/Photo.vala"
		value->data[0].v_pointer = v_object;
#line 33888 "Photo.c"
	} else {
#line 1402 "../src/Photo.vala"
		value->data[0].v_pointer = NULL;
#line 33892 "Photo.c"
	}
#line 1402 "../src/Photo.vala"
	if (old) {
#line 1402 "../src/Photo.vala"
		photo_reimport_raw_development_state_impl_dev_to_reimport_unref (old);
#line 33898 "Photo.c"
	}
}

static void
photo_reimport_raw_development_state_impl_dev_to_reimport_class_init (PhotoReimportRawDevelopmentStateImplDevToReimportClass * klass,
                                                                      gpointer klass_data)
{
#line 1402 "../src/Photo.vala"
	photo_reimport_raw_development_state_impl_dev_to_reimport_parent_class = g_type_class_peek_parent (klass);
#line 1402 "../src/Photo.vala"
	((PhotoReimportRawDevelopmentStateImplDevToReimportClass *) klass)->finalize = photo_reimport_raw_development_state_impl_dev_to_reimport_finalize;
#line 33910 "Photo.c"
}

static void
photo_reimport_raw_development_state_impl_dev_to_reimport_instance_init (PhotoReimportRawDevelopmentStateImplDevToReimport * self,
                                                                         gpointer klass)
{
	BackingPhotoRow* _tmp0_;
#line 1403 "../src/Photo.vala"
	_tmp0_ = backing_photo_row_new ();
#line 1403 "../src/Photo.vala"
	self->backing = _tmp0_;
#line 1402 "../src/Photo.vala"
	self->ref_count = 1;
#line 33924 "Photo.c"
}

static void
photo_reimport_raw_development_state_impl_dev_to_reimport_finalize (PhotoReimportRawDevelopmentStateImplDevToReimport * obj)
{
	PhotoReimportRawDevelopmentStateImplDevToReimport * self;
#line 1402 "../src/Photo.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, PHOTO_REIMPORT_RAW_DEVELOPMENT_STATE_IMPL_TYPE_DEV_TO_REIMPORT, PhotoReimportRawDevelopmentStateImplDevToReimport);
#line 1402 "../src/Photo.vala"
	g_signal_handlers_destroy (self);
#line 1403 "../src/Photo.vala"
	_backing_photo_row_unref0 (self->backing);
#line 1404 "../src/Photo.vala"
	_media_metadata_unref0 (self->metadata);
#line 33939 "Photo.c"
}

static GType
photo_reimport_raw_development_state_impl_dev_to_reimport_get_type_once (void)
{
	static const GTypeValueTable g_define_type_value_table = { photo_reimport_raw_development_state_impl_value_dev_to_reimport_init, photo_reimport_raw_development_state_impl_value_dev_to_reimport_free_value, photo_reimport_raw_development_state_impl_value_dev_to_reimport_copy_value, photo_reimport_raw_development_state_impl_value_dev_to_reimport_peek_pointer, "p", photo_reimport_raw_development_state_impl_value_dev_to_reimport_collect_value, "p", photo_reimport_raw_development_state_impl_value_dev_to_reimport_lcopy_value };
	static const GTypeInfo g_define_type_info = { sizeof (PhotoReimportRawDevelopmentStateImplDevToReimportClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) photo_reimport_raw_development_state_impl_dev_to_reimport_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (PhotoReimportRawDevelopmentStateImplDevToReimport), 0, (GInstanceInitFunc) photo_reimport_raw_development_state_impl_dev_to_reimport_instance_init, &g_define_type_value_table };
	static const GTypeFundamentalInfo g_define_type_fundamental_info = { (G_TYPE_FLAG_CLASSED | G_TYPE_FLAG_INSTANTIATABLE | G_TYPE_FLAG_DERIVABLE | G_TYPE_FLAG_DEEP_DERIVABLE) };
	GType photo_reimport_raw_development_state_impl_dev_to_reimport_type_id;
	photo_reimport_raw_development_state_impl_dev_to_reimport_type_id = g_type_register_fundamental (g_type_fundamental_next (), "PhotoReimportRawDevelopmentStateImplDevToReimport", &g_define_type_info, &g_define_type_fundamental_info, 0);
	return photo_reimport_raw_development_state_impl_dev_to_reimport_type_id;
}

GType
photo_reimport_raw_development_state_impl_dev_to_reimport_get_type (void)
{
	static volatile gsize photo_reimport_raw_development_state_impl_dev_to_reimport_type_id__once = 0;
	if (g_once_init_enter (&photo_reimport_raw_development_state_impl_dev_to_reimport_type_id__once)) {
		GType photo_reimport_raw_development_state_impl_dev_to_reimport_type_id;
		photo_reimport_raw_development_state_impl_dev_to_reimport_type_id = photo_reimport_raw_development_state_impl_dev_to_reimport_get_type_once ();
		g_once_init_leave (&photo_reimport_raw_development_state_impl_dev_to_reimport_type_id__once, photo_reimport_raw_development_state_impl_dev_to_reimport_type_id);
	}
	return photo_reimport_raw_development_state_impl_dev_to_reimport_type_id__once;
}

static gpointer
photo_reimport_raw_development_state_impl_dev_to_reimport_ref (gpointer instance)
{
	PhotoReimportRawDevelopmentStateImplDevToReimport * self;
	self = instance;
#line 1402 "../src/Photo.vala"
	g_atomic_int_inc (&self->ref_count);
#line 1402 "../src/Photo.vala"
	return instance;
#line 33974 "Photo.c"
}

static void
photo_reimport_raw_development_state_impl_dev_to_reimport_unref (gpointer instance)
{
	PhotoReimportRawDevelopmentStateImplDevToReimport * self;
	self = instance;
#line 1402 "../src/Photo.vala"
	if (g_atomic_int_dec_and_test (&self->ref_count)) {
#line 1402 "../src/Photo.vala"
		PHOTO_REIMPORT_RAW_DEVELOPMENT_STATE_IMPL_DEV_TO_REIMPORT_GET_CLASS (self)->finalize (self);
#line 1402 "../src/Photo.vala"
		g_type_free_instance ((GTypeInstance *) self);
#line 33988 "Photo.c"
	}
}

static void
photo_reimport_raw_development_state_impl_class_init (PhotoReimportRawDevelopmentStateImplClass * klass,
                                                      gpointer klass_data)
{
#line 1401 "../src/Photo.vala"
	photo_reimport_raw_development_state_impl_parent_class = g_type_class_peek_parent (klass);
#line 1401 "../src/Photo.vala"
	((PhotoReimportRawDevelopmentStateClass *) klass)->finalize = photo_reimport_raw_development_state_impl_finalize;
#line 34000 "Photo.c"
}

static void
photo_reimport_raw_development_state_impl_instance_init (PhotoReimportRawDevelopmentStateImpl * self,
                                                         gpointer klass)
{
	GeeArrayList* _tmp0_;
#line 1412 "../src/Photo.vala"
	_tmp0_ = gee_array_list_new (PHOTO_REIMPORT_RAW_DEVELOPMENT_STATE_IMPL_TYPE_DEV_TO_REIMPORT, (GBoxedCopyFunc) photo_reimport_raw_development_state_impl_dev_to_reimport_ref, (GDestroyNotify) photo_reimport_raw_development_state_impl_dev_to_reimport_unref, NULL, NULL, NULL);
#line 1412 "../src/Photo.vala"
	self->list = G_TYPE_CHECK_INSTANCE_CAST (_tmp0_, GEE_TYPE_COLLECTION, GeeCollection);
#line 1413 "../src/Photo.vala"
	self->metadata_only = FALSE;
#line 34014 "Photo.c"
}

static void
photo_reimport_raw_development_state_impl_finalize (PhotoReimportRawDevelopmentState * obj)
{
	PhotoReimportRawDevelopmentStateImpl * self;
#line 1401 "../src/Photo.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, PHOTO_TYPE_REIMPORT_RAW_DEVELOPMENT_STATE_IMPL, PhotoReimportRawDevelopmentStateImpl);
#line 1412 "../src/Photo.vala"
	_g_object_unref0 (self->list);
#line 1401 "../src/Photo.vala"
	PHOTO_REIMPORT_RAW_DEVELOPMENT_STATE_CLASS (photo_reimport_raw_development_state_impl_parent_class)->finalize (obj);
#line 34027 "Photo.c"
}

static GType
photo_reimport_raw_development_state_impl_get_type_once (void)
{
	static const GTypeInfo g_define_type_info = { sizeof (PhotoReimportRawDevelopmentStateImplClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) photo_reimport_raw_development_state_impl_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (PhotoReimportRawDevelopmentStateImpl), 0, (GInstanceInitFunc) photo_reimport_raw_development_state_impl_instance_init, NULL };
	GType photo_reimport_raw_development_state_impl_type_id;
	photo_reimport_raw_development_state_impl_type_id = g_type_register_static (PHOTO_TYPE_REIMPORT_RAW_DEVELOPMENT_STATE, "PhotoReimportRawDevelopmentStateImpl", &g_define_type_info, 0);
	return photo_reimport_raw_development_state_impl_type_id;
}

static GType
photo_reimport_raw_development_state_impl_get_type (void)
{
	static volatile gsize photo_reimport_raw_development_state_impl_type_id__once = 0;
	if (g_once_init_enter (&photo_reimport_raw_development_state_impl_type_id__once)) {
		GType photo_reimport_raw_development_state_impl_type_id;
		photo_reimport_raw_development_state_impl_type_id = photo_reimport_raw_development_state_impl_get_type_once ();
		g_once_init_leave (&photo_reimport_raw_development_state_impl_type_id__once, photo_reimport_raw_development_state_impl_type_id);
	}
	return photo_reimport_raw_development_state_impl_type_id__once;
}

static void
photo_class_init (PhotoClass * klass,
                  gpointer klass_data)
{
#line 158 "../src/Photo.vala"
	photo_parent_class = g_type_class_peek_parent (klass);
#line 158 "../src/Photo.vala"
	g_type_class_adjust_private_offset (klass, &Photo_private_offset);
#line 158 "../src/Photo.vala"
	((PhotoClass *) klass)->notify_editable_replaced = (void (*) (Photo*, GFile*, GFile*)) photo_real_notify_editable_replaced;
#line 158 "../src/Photo.vala"
	((PhotoClass *) klass)->notify_raw_development_modified = (void (*) (Photo*)) photo_real_notify_raw_development_modified;
#line 158 "../src/Photo.vala"
	((PhotoClass *) klass)->notify_baseline_replaced = (void (*) (Photo*)) photo_real_notify_baseline_replaced;
#line 158 "../src/Photo.vala"
	((PhotoClass *) klass)->notify_master_reimported = (void (*) (Photo*, PhotoMetadata*)) photo_real_notify_master_reimported;
#line 158 "../src/Photo.vala"
	((PhotoClass *) klass)->notify_editable_reimported = (void (*) (Photo*, PhotoMetadata*)) photo_real_notify_editable_reimported;
#line 158 "../src/Photo.vala"
	((PhotoClass *) klass)->notify_source_reimported = (void (*) (Photo*, PhotoMetadata*)) photo_real_notify_source_reimported;
#line 158 "../src/Photo.vala"
	((PhotoClass *) klass)->notify_baseline_reimported = (void (*) (Photo*, PhotoMetadata*)) photo_real_notify_baseline_reimported;
#line 158 "../src/Photo.vala"
	((DataSourceClass *) klass)->internal_delete_backing = (gboolean (*) (DataSource*, GError**)) photo_real_internal_delete_backing;
#line 158 "../src/Photo.vala"
	((MediaSourceClass *) klass)->get_backing_files_state = (BackingFileState** (*) (MediaSource*, gint*)) photo_real_get_backing_files_state;
#line 158 "../src/Photo.vala"
	((PhotoClass *) klass)->apply_user_metadata_for_reimport = (void (*) (Photo*, PhotoMetadata*)) photo_real_apply_user_metadata_for_reimport;
#line 158 "../src/Photo.vala"
	((DataSourceClass *) klass)->get_typename = (gchar* (*) (DataSource*)) photo_real_get_typename;
#line 158 "../src/Photo.vala"
	((DataSourceClass *) klass)->get_instance_id = (gint64 (*) (DataSource*)) photo_real_get_instance_id;
#line 158 "../src/Photo.vala"
	((DataSourceClass *) klass)->get_source_id = (gchar* (*) (DataSource*)) photo_real_get_source_id;
#line 158 "../src/Photo.vala"
	((ThumbnailSourceClass *) klass)->get_preferred_thumbnail_format = (PhotoFileFormat (*) (ThumbnailSource*)) photo_real_get_preferred_thumbnail_format;
#line 158 "../src/Photo.vala"
	((ThumbnailSourceClass *) klass)->create_thumbnail = (GdkPixbuf* (*) (ThumbnailSource*, gint, GError**)) photo_real_create_thumbnail;
#line 158 "../src/Photo.vala"
	((MediaSourceClass *) klass)->get_file = (GFile* (*) (MediaSource*)) photo_real_get_file;
#line 158 "../src/Photo.vala"
	((MediaSourceClass *) klass)->get_master_file = (GFile* (*) (MediaSource*)) photo_real_get_master_file;
#line 158 "../src/Photo.vala"
	((MediaSourceClass *) klass)->get_timestamp = (GDateTime* (*) (MediaSource*)) photo_real_get_timestamp;
#line 158 "../src/Photo.vala"
	((MediaSourceClass *) klass)->get_event_id = (void (*) (MediaSource*, EventID*)) photo_real_get_event_id;
#line 158 "../src/Photo.vala"
	((MediaSourceClass *) klass)->get_import_id = (void (*) (MediaSource*, ImportID*)) photo_real_get_import_id;
#line 158 "../src/Photo.vala"
	((MediaSourceClass *) klass)->get_master_md5 = (gchar* (*) (MediaSource*)) photo_real_get_master_md5;
#line 158 "../src/Photo.vala"
	((MediaSourceClass *) klass)->get_rating = (Rating (*) (MediaSource*)) photo_real_get_rating;
#line 158 "../src/Photo.vala"
	((MediaSourceClass *) klass)->set_rating = (void (*) (MediaSource*, Rating)) photo_real_set_rating;
#line 158 "../src/Photo.vala"
	((MediaSourceClass *) klass)->increase_rating = (void (*) (MediaSource*)) photo_real_increase_rating;
#line 158 "../src/Photo.vala"
	((MediaSourceClass *) klass)->decrease_rating = (void (*) (MediaSource*)) photo_real_decrease_rating;
#line 158 "../src/Photo.vala"
	((DataSourceClass *) klass)->commit_backlinks = (void (*) (DataSource*, SourceCollection*, const gchar*)) photo_real_commit_backlinks;
#line 158 "../src/Photo.vala"
	((MediaSourceClass *) klass)->set_event_id = (gboolean (*) (MediaSource*, EventID*)) photo_real_set_event_id;
#line 158 "../src/Photo.vala"
	((DataObjectClass *) klass)->to_string = (gchar* (*) (DataObject*)) photo_real_to_string;
#line 158 "../src/Photo.vala"
	((DataSourceClass *) klass)->equals = (gboolean (*) (DataSource*, DataSource*)) photo_real_equals;
#line 158 "../src/Photo.vala"
	((MediaSourceClass *) klass)->get_filesize = (guint64 (*) (MediaSource*)) photo_real_get_filesize;
#line 158 "../src/Photo.vala"
	((MediaSourceClass *) klass)->get_master_filesize = (guint64 (*) (MediaSource*)) photo_real_get_master_filesize;
#line 158 "../src/Photo.vala"
	((MediaSourceClass *) klass)->get_exposure_time = (GDateTime* (*) (MediaSource*)) photo_real_get_exposure_time;
#line 158 "../src/Photo.vala"
	((MediaSourceClass *) klass)->get_basename = (gchar* (*) (MediaSource*)) photo_real_get_basename;
#line 158 "../src/Photo.vala"
	((MediaSourceClass *) klass)->get_title = (gchar* (*) (MediaSource*)) photo_real_get_title;
#line 158 "../src/Photo.vala"
	((MediaSourceClass *) klass)->get_comment = (gchar* (*) (MediaSource*)) photo_real_get_comment;
#line 158 "../src/Photo.vala"
	((MediaSourceClass *) klass)->set_title = (void (*) (MediaSource*, const gchar*)) photo_real_set_title;
#line 158 "../src/Photo.vala"
	((MediaSourceClass *) klass)->set_comment = (gboolean (*) (MediaSource*, const gchar*)) photo_real_set_comment;
#line 158 "../src/Photo.vala"
	((MediaSourceClass *) klass)->get_dimensions = (void (*) (MediaSource*, PhotoException, Dimensions*)) photo_real_get_dimensions;
#line 158 "../src/Photo.vala"
	((PhotoSourceClass *) klass)->get_metadata = (PhotoMetadata* (*) (PhotoSource*)) photo_real_get_metadata;
#line 158 "../src/Photo.vala"
	((PhotoClass *) klass)->rotate = (void (*) (Photo*, Rotation)) photo_real_rotate;
#line 158 "../src/Photo.vala"
	((PhotoSourceClass *) klass)->get_pixbuf = (GdkPixbuf* (*) (PhotoSource*, Scaling*, GError**)) photo_real_get_pixbuf;
#line 158 "../src/Photo.vala"
	((PhotoClass *) klass)->has_user_generated_metadata = (gboolean (*) (Photo*)) photo_real_has_user_generated_metadata;
#line 158 "../src/Photo.vala"
	((PhotoClass *) klass)->set_user_metadata_for_export = (void (*) (Photo*, PhotoMetadata*)) photo_real_set_user_metadata_for_export;
#line 158 "../src/Photo.vala"
	((PhotoClass *) klass)->editable_replaced = photo_real_editable_replaced;
#line 158 "../src/Photo.vala"
	((PhotoClass *) klass)->raw_development_modified = photo_real_raw_development_modified;
#line 158 "../src/Photo.vala"
	((PhotoClass *) klass)->baseline_replaced = photo_real_baseline_replaced;
#line 158 "../src/Photo.vala"
	((PhotoClass *) klass)->master_reimported = photo_real_master_reimported;
#line 158 "../src/Photo.vala"
	((PhotoClass *) klass)->editable_reimported = photo_real_editable_reimported;
#line 158 "../src/Photo.vala"
	((PhotoClass *) klass)->baseline_reimported = photo_real_baseline_reimported;
#line 158 "../src/Photo.vala"
	((PhotoClass *) klass)->source_reimported = photo_real_source_reimported;
#line 158 "../src/Photo.vala"
	G_OBJECT_CLASS (klass)->get_property = _vala_photo_get_property;
#line 158 "../src/Photo.vala"
	G_OBJECT_CLASS (klass)->set_property = _vala_photo_set_property;
#line 158 "../src/Photo.vala"
	G_OBJECT_CLASS (klass)->finalize = photo_finalize;
#line 158 "../src/Photo.vala"
	photo_signals[PHOTO_EDITABLE_REPLACED_SIGNAL] = g_signal_new ("editable-replaced", TYPE_PHOTO, G_SIGNAL_RUN_LAST, G_STRUCT_OFFSET (PhotoClass, editable_replaced), NULL, NULL, g_cclosure_user_marshal_VOID__OBJECT_OBJECT, G_TYPE_NONE, 2, g_file_get_type (), g_file_get_type ());
#line 158 "../src/Photo.vala"
	photo_signals[PHOTO_RAW_DEVELOPMENT_MODIFIED_SIGNAL] = g_signal_new ("raw-development-modified", TYPE_PHOTO, G_SIGNAL_RUN_LAST, G_STRUCT_OFFSET (PhotoClass, raw_development_modified), NULL, NULL, g_cclosure_marshal_VOID__VOID, G_TYPE_NONE, 0);
#line 158 "../src/Photo.vala"
	photo_signals[PHOTO_BASELINE_REPLACED_SIGNAL] = g_signal_new ("baseline-replaced", TYPE_PHOTO, G_SIGNAL_RUN_LAST, G_STRUCT_OFFSET (PhotoClass, baseline_replaced), NULL, NULL, g_cclosure_marshal_VOID__VOID, G_TYPE_NONE, 0);
#line 158 "../src/Photo.vala"
	photo_signals[PHOTO_MASTER_REIMPORTED_SIGNAL] = g_signal_new ("master-reimported", TYPE_PHOTO, G_SIGNAL_RUN_LAST, G_STRUCT_OFFSET (PhotoClass, master_reimported), NULL, NULL, g_cclosure_user_marshal_VOID__MEDIA_METADATA, G_TYPE_NONE, 1, TYPE_PHOTO_METADATA);
#line 158 "../src/Photo.vala"
	photo_signals[PHOTO_EDITABLE_REIMPORTED_SIGNAL] = g_signal_new ("editable-reimported", TYPE_PHOTO, G_SIGNAL_RUN_LAST, G_STRUCT_OFFSET (PhotoClass, editable_reimported), NULL, NULL, g_cclosure_user_marshal_VOID__MEDIA_METADATA, G_TYPE_NONE, 1, TYPE_PHOTO_METADATA);
#line 158 "../src/Photo.vala"
	photo_signals[PHOTO_BASELINE_REIMPORTED_SIGNAL] = g_signal_new ("baseline-reimported", TYPE_PHOTO, G_SIGNAL_RUN_LAST, G_STRUCT_OFFSET (PhotoClass, baseline_reimported), NULL, NULL, g_cclosure_user_marshal_VOID__MEDIA_METADATA, G_TYPE_NONE, 1, TYPE_PHOTO_METADATA);
#line 158 "../src/Photo.vala"
	photo_signals[PHOTO_SOURCE_REIMPORTED_SIGNAL] = g_signal_new ("source-reimported", TYPE_PHOTO, G_SIGNAL_RUN_LAST, G_STRUCT_OFFSET (PhotoClass, source_reimported), NULL, NULL, g_cclosure_user_marshal_VOID__MEDIA_METADATA, G_TYPE_NONE, 1, TYPE_PHOTO_METADATA);
#line 323 "../src/Photo.vala"
	g_rec_mutex_init (&__lock_photo_photo_source_pixbuf_cache);
#line 34181 "Photo.c"
}

static void
photo_dateable_interface_init (DateableIface * iface,
                               gpointer iface_data)
{
#line 158 "../src/Photo.vala"
	photo_dateable_parent_iface = g_type_interface_peek_parent (iface);
#line 158 "../src/Photo.vala"
	iface->get_exposure_time = (GDateTime* (*) (Dateable*)) photo_real_get_exposure_time;
#line 158 "../src/Photo.vala"
	iface->set_exposure_time = (void (*) (Dateable*, GDateTime*)) photo_real_set_exposure_time;
#line 34194 "Photo.c"
}

static void
photo_positionable_interface_init (PositionableIface * iface,
                                   gpointer iface_data)
{
#line 158 "../src/Photo.vala"
	photo_positionable_parent_iface = g_type_interface_peek_parent (iface);
#line 158 "../src/Photo.vala"
	iface->get_gps_coords = (void (*) (Positionable*, GpsCoords*)) photo_real_get_gps_coords;
#line 158 "../src/Photo.vala"
	iface->set_gps_coords = (void (*) (Positionable*, GpsCoords*)) photo_real_set_gps_coords;
#line 34207 "Photo.c"
}

static void
photo_instance_init (Photo * self,
                     gpointer klass)
{
	BackingPhotoRow* _tmp0_;
	PhotoBackingReaders* _tmp1_;
#line 158 "../src/Photo.vala"
	self->priv = photo_get_instance_private (self);
#line 328 "../src/Photo.vala"
	g_rec_mutex_init (&self->priv->__lock_row);
#line 329 "../src/Photo.vala"
	_tmp0_ = backing_photo_row_new ();
#line 329 "../src/Photo.vala"
	self->priv->editable = _tmp0_;
#line 330 "../src/Photo.vala"
	g_rec_mutex_init (&self->priv->__lock_readers);
#line 330 "../src/Photo.vala"
	_tmp1_ = photo_backing_readers_new ();
#line 330 "../src/Photo.vala"
	self->priv->readers = _tmp1_;
#line 331 "../src/Photo.vala"
	self->priv->transformer = NULL;
#line 332 "../src/Photo.vala"
	self->priv->adjustments = NULL;
#line 334 "../src/Photo.vala"
	self->priv->file_title = NULL;
#line 335 "../src/Photo.vala"
	self->priv->editable_monitor = NULL;
#line 336 "../src/Photo.vala"
	self->priv->reimport_editable_scheduler = NULL;
#line 337 "../src/Photo.vala"
	self->priv->update_editable_attributes_scheduler = NULL;
#line 338 "../src/Photo.vala"
	self->priv->remove_editable_scheduler = NULL;
#line 340 "../src/Photo.vala"
	self->can_rotate_now = TRUE;
#line 343 "../src/Photo.vala"
	g_rec_mutex_init (&self->priv->__lock_developments);
#line 343 "../src/Photo.vala"
	self->priv->developments = NULL;
#line 350 "../src/Photo.vala"
	self->backing_photo_row = NULL;
#line 34252 "Photo.c"
}

static void
photo_finalize (GObject * obj)
{
	Photo * self;
#line 158 "../src/Photo.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, TYPE_PHOTO, Photo);
#line 213 "../src/Photo.vala"
	_g_date_time_unref0 (self->priv->cached_exposure_time);
#line 328 "../src/Photo.vala"
	g_rec_mutex_clear (&self->priv->__lock_row);
#line 328 "../src/Photo.vala"
	_photo_row_unref0 (self->row);
#line 329 "../src/Photo.vala"
	_backing_photo_row_unref0 (self->priv->editable);
#line 330 "../src/Photo.vala"
	g_rec_mutex_clear (&self->priv->__lock_readers);
#line 330 "../src/Photo.vala"
	_photo_backing_readers_unref0 (self->priv->readers);
#line 331 "../src/Photo.vala"
	_pixel_transformer_unref0 (self->priv->transformer);
#line 332 "../src/Photo.vala"
	_pixel_transformation_bundle_unref0 (self->priv->adjustments);
#line 334 "../src/Photo.vala"
	_g_free0 (self->priv->file_title);
#line 335 "../src/Photo.vala"
	_g_object_unref0 (self->priv->editable_monitor);
#line 336 "../src/Photo.vala"
	_one_shot_scheduler_unref0 (self->priv->reimport_editable_scheduler);
#line 337 "../src/Photo.vala"
	_one_shot_scheduler_unref0 (self->priv->update_editable_attributes_scheduler);
#line 338 "../src/Photo.vala"
	_one_shot_scheduler_unref0 (self->priv->remove_editable_scheduler);
#line 343 "../src/Photo.vala"
	g_rec_mutex_clear (&self->priv->__lock_developments);
#line 343 "../src/Photo.vala"
	_g_object_unref0 (self->priv->developments);
#line 350 "../src/Photo.vala"
	_backing_photo_row_unref0 (self->backing_photo_row);
#line 158 "../src/Photo.vala"
	G_OBJECT_CLASS (photo_parent_class)->finalize (obj);
#line 34295 "Photo.c"
}

static GType
photo_get_type_once (void)
{
	static const GTypeInfo g_define_type_info = { sizeof (PhotoClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) photo_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (Photo), 0, (GInstanceInitFunc) photo_instance_init, NULL };
	static const GInterfaceInfo dateable_info = { (GInterfaceInitFunc) photo_dateable_interface_init, (GInterfaceFinalizeFunc) NULL, NULL};
	static const GInterfaceInfo positionable_info = { (GInterfaceInitFunc) photo_positionable_interface_init, (GInterfaceFinalizeFunc) NULL, NULL};
	GType photo_type_id;
	photo_type_id = g_type_register_static (TYPE_PHOTO_SOURCE, "Photo", &g_define_type_info, G_TYPE_FLAG_ABSTRACT);
	g_type_add_interface_static (photo_type_id, TYPE_DATEABLE, &dateable_info);
	g_type_add_interface_static (photo_type_id, TYPE_POSITIONABLE, &positionable_info);
	Photo_private_offset = g_type_add_instance_private (photo_type_id, sizeof (PhotoPrivate));
	return photo_type_id;
}

GType
photo_get_type (void)
{
	static volatile gsize photo_type_id__once = 0;
	if (g_once_init_enter (&photo_type_id__once)) {
		GType photo_type_id;
		photo_type_id = photo_get_type_once ();
		g_once_init_leave (&photo_type_id__once, photo_type_id);
	}
	return photo_type_id__once;
}

static void
_vala_photo_get_property (GObject * object,
                          guint property_id,
                          GValue * value,
                          GParamSpec * pspec)
{
	Photo * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (object, TYPE_PHOTO, Photo);
#line 158 "../src/Photo.vala"
	switch (property_id) {
#line 34334 "Photo.c"
		default:
#line 158 "../src/Photo.vala"
		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
#line 158 "../src/Photo.vala"
		break;
#line 34340 "Photo.c"
	}
}

static void
_vala_photo_set_property (GObject * object,
                          guint property_id,
                          const GValue * value,
                          GParamSpec * pspec)
{
	Photo * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (object, TYPE_PHOTO, Photo);
#line 158 "../src/Photo.vala"
	switch (property_id) {
#line 34354 "Photo.c"
		default:
#line 158 "../src/Photo.vala"
		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
#line 158 "../src/Photo.vala"
		break;
#line 34360 "Photo.c"
	}
}

static inline gpointer
library_photo_source_collection_get_instance_private (LibraryPhotoSourceCollection* self)
{
	return G_STRUCT_MEMBER_P (self, LibraryPhotoSourceCollection_private_offset);
}

static GType
library_photo_source_collection_state_get_type_once (void)
{
	static const GEnumValue values[] = {{LIBRARY_PHOTO_SOURCE_COLLECTION_STATE_UNKNOWN, "LIBRARY_PHOTO_SOURCE_COLLECTION_STATE_UNKNOWN", "unknown"}, {LIBRARY_PHOTO_SOURCE_COLLECTION_STATE_ONLINE, "LIBRARY_PHOTO_SOURCE_COLLECTION_STATE_ONLINE", "online"}, {LIBRARY_PHOTO_SOURCE_COLLECTION_STATE_OFFLINE, "LIBRARY_PHOTO_SOURCE_COLLECTION_STATE_OFFLINE", "offline"}, {LIBRARY_PHOTO_SOURCE_COLLECTION_STATE_TRASH, "LIBRARY_PHOTO_SOURCE_COLLECTION_STATE_TRASH", "trash"}, {LIBRARY_PHOTO_SOURCE_COLLECTION_STATE_EDITABLE, "LIBRARY_PHOTO_SOURCE_COLLECTION_STATE_EDITABLE", "editable"}, {LIBRARY_PHOTO_SOURCE_COLLECTION_STATE_DEVELOPER, "LIBRARY_PHOTO_SOURCE_COLLECTION_STATE_DEVELOPER", "developer"}, {0, NULL, NULL}};
	GType library_photo_source_collection_state_type_id;
	library_photo_source_collection_state_type_id = g_enum_register_static ("LibraryPhotoSourceCollectionState", values);
	return library_photo_source_collection_state_type_id;
}

GType
library_photo_source_collection_state_get_type (void)
{
	static volatile gsize library_photo_source_collection_state_type_id__once = 0;
	if (g_once_init_enter (&library_photo_source_collection_state_type_id__once)) {
		GType library_photo_source_collection_state_type_id;
		library_photo_source_collection_state_type_id = library_photo_source_collection_state_get_type_once ();
		g_once_init_leave (&library_photo_source_collection_state_type_id__once, library_photo_source_collection_state_type_id);
	}
	return library_photo_source_collection_state_type_id__once;
}

static guint
_file_hash_gee_hash_data_func (gconstpointer v,
                               gpointer self)
{
	guint result;
	result = file_hash ((GFile*) v);
#line 4519 "../src/Photo.vala"
	return result;
#line 34399 "Photo.c"
}

static gboolean
_file_equal_gee_equal_data_func (gconstpointer a,
                                 gconstpointer b,
                                 gpointer self)
{
	gboolean result;
	result = file_equal ((GFile*) a, (GFile*) b);
#line 4519 "../src/Photo.vala"
	return result;
#line 34411 "Photo.c"
}

static gint
_int64_compare_gcompare_data_func (gconstpointer a,
                                   gconstpointer b,
                                   gpointer self)
{
	gint result;
	result = int64_compare ((gint64*) a, (gint64*) b);
#line 4523 "../src/Photo.vala"
	return result;
#line 34423 "Photo.c"
}

static gint64*
_int64_dup (gint64* self)
{
	gint64* dup;
#line 4523 "../src/Photo.vala"
	dup = g_new0 (gint64, 1);
#line 4523 "../src/Photo.vala"
	memcpy (dup, self, sizeof (gint64));
#line 4523 "../src/Photo.vala"
	return dup;
#line 34436 "Photo.c"
}

static gboolean
_int64_equal_gee_equal_data_func (gconstpointer a,
                                  gconstpointer b,
                                  gpointer self)
{
	gboolean result;
	result = int64_equal ((gint64*) a, (gint64*) b);
#line 4525 "../src/Photo.vala"
	return result;
#line 34448 "Photo.c"
}

static gint64
_photo_get_photo_key_get_source_database_key (DataSource* source,
                                              gpointer self)
{
	gint64 result;
	result = photo_get_photo_key (source);
#line 4545 "../src/Photo.vala"
	return result;
#line 34459 "Photo.c"
}

static void
_library_photo_source_collection_on_trashcan_contents_altered_source_holding_tank_contents_altered (SourceHoldingTank* _sender,
                                                                                                    GeeCollection* added,
                                                                                                    GeeCollection* removed,
                                                                                                    gpointer self)
{
#line 4547 "../src/Photo.vala"
	library_photo_source_collection_on_trashcan_contents_altered ((LibraryPhotoSourceCollection*) self, added, removed);
#line 34470 "Photo.c"
}

static void
_library_photo_source_collection_on_offline_contents_altered_source_holding_tank_contents_altered (SourceHoldingTank* _sender,
                                                                                                   GeeCollection* added,
                                                                                                   GeeCollection* removed,
                                                                                                   gpointer self)
{
#line 4548 "../src/Photo.vala"
	library_photo_source_collection_on_offline_contents_altered ((LibraryPhotoSourceCollection*) self, added, removed);
#line 34481 "Photo.c"
}

LibraryPhotoSourceCollection*
library_photo_source_collection_construct (GType object_type)
{
	LibraryPhotoSourceCollection* self = NULL;
	MediaSourceHoldingTank* _tmp0_;
	MediaSourceHoldingTank* _tmp1_;
	MediaSourceHoldingTank* _tmp2_;
	MediaSourceHoldingTank* _tmp3_;
#line 4545 "../src/Photo.vala"
	self = (LibraryPhotoSourceCollection*) media_source_collection_construct (object_type, "LibraryPhotoSourceCollection", _photo_get_photo_key_get_source_database_key, NULL);
#line 4547 "../src/Photo.vala"
	_tmp0_ = media_source_collection_get_trashcan (G_TYPE_CHECK_INSTANCE_CAST (self, TYPE_MEDIA_SOURCE_COLLECTION, MediaSourceCollection));
#line 4547 "../src/Photo.vala"
	_tmp1_ = _tmp0_;
#line 4547 "../src/Photo.vala"
	g_signal_connect (G_TYPE_CHECK_INSTANCE_CAST (_tmp1_, TYPE_SOURCE_HOLDING_TANK, SourceHoldingTank), "contents-altered", (GCallback) _library_photo_source_collection_on_trashcan_contents_altered_source_holding_tank_contents_altered, self);
#line 4547 "../src/Photo.vala"
	_source_holding_tank_unref0 (_tmp1_);
#line 4548 "../src/Photo.vala"
	_tmp2_ = media_source_collection_get_offline_bin (G_TYPE_CHECK_INSTANCE_CAST (self, TYPE_MEDIA_SOURCE_COLLECTION, MediaSourceCollection));
#line 4548 "../src/Photo.vala"
	_tmp3_ = _tmp2_;
#line 4548 "../src/Photo.vala"
	g_signal_connect (G_TYPE_CHECK_INSTANCE_CAST (_tmp3_, TYPE_SOURCE_HOLDING_TANK, SourceHoldingTank), "contents-altered", (GCallback) _library_photo_source_collection_on_offline_contents_altered_source_holding_tank_contents_altered, self);
#line 4548 "../src/Photo.vala"
	_source_holding_tank_unref0 (_tmp3_);
#line 4544 "../src/Photo.vala"
	return self;
#line 34512 "Photo.c"
}

LibraryPhotoSourceCollection*
library_photo_source_collection_new (void)
{
#line 4544 "../src/Photo.vala"
	return library_photo_source_collection_construct (TYPE_LIBRARY_PHOTO_SOURCE_COLLECTION);
#line 34520 "Photo.c"
}

static gboolean
_library_photo_source_collection_check_if_trashed_photo_source_holding_tank_check_to_keep (DataSource* source,
                                                                                           Alteration* alteration,
                                                                                           gpointer self)
{
	gboolean result;
	result = library_photo_source_collection_check_if_trashed_photo ((LibraryPhotoSourceCollection*) self, source, alteration);
#line 4552 "../src/Photo.vala"
	return result;
#line 34532 "Photo.c"
}

static MediaSourceHoldingTank*
library_photo_source_collection_real_create_trashcan (MediaSourceCollection* base)
{
	LibraryPhotoSourceCollection * self;
	LibraryPhotoSourceHoldingTank* _tmp0_;
	MediaSourceHoldingTank* result;
#line 4551 "../src/Photo.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (base, TYPE_LIBRARY_PHOTO_SOURCE_COLLECTION, LibraryPhotoSourceCollection);
#line 4552 "../src/Photo.vala"
	_tmp0_ = library_photo_source_holding_tank_new (self, _library_photo_source_collection_check_if_trashed_photo_source_holding_tank_check_to_keep, self, _photo_get_photo_key_get_source_database_key, NULL);
#line 4552 "../src/Photo.vala"
	result = G_TYPE_CHECK_INSTANCE_CAST (_tmp0_, TYPE_MEDIA_SOURCE_HOLDING_TANK, MediaSourceHoldingTank);
#line 4552 "../src/Photo.vala"
	return result;
#line 34549 "Photo.c"
}

static gboolean
_library_photo_source_collection_check_if_offline_photo_source_holding_tank_check_to_keep (DataSource* source,
                                                                                           Alteration* alteration,
                                                                                           gpointer self)
{
	gboolean result;
	result = library_photo_source_collection_check_if_offline_photo ((LibraryPhotoSourceCollection*) self, source, alteration);
#line 4556 "../src/Photo.vala"
	return result;
#line 34561 "Photo.c"
}

static MediaSourceHoldingTank*
library_photo_source_collection_real_create_offline_bin (MediaSourceCollection* base)
{
	LibraryPhotoSourceCollection * self;
	LibraryPhotoSourceHoldingTank* _tmp0_;
	MediaSourceHoldingTank* result;
#line 4555 "../src/Photo.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (base, TYPE_LIBRARY_PHOTO_SOURCE_COLLECTION, LibraryPhotoSourceCollection);
#line 4556 "../src/Photo.vala"
	_tmp0_ = library_photo_source_holding_tank_new (self, _library_photo_source_collection_check_if_offline_photo_source_holding_tank_check_to_keep, self, _photo_get_photo_key_get_source_database_key, NULL);
#line 4556 "../src/Photo.vala"
	result = G_TYPE_CHECK_INSTANCE_CAST (_tmp0_, TYPE_MEDIA_SOURCE_HOLDING_TANK, MediaSourceHoldingTank);
#line 4556 "../src/Photo.vala"
	return result;
#line 34578 "Photo.c"
}

static MediaMonitor*
library_photo_source_collection_real_create_media_monitor (MediaSourceCollection* base,
                                                           Workers* workers,
                                                           GCancellable* cancellable)
{
	LibraryPhotoSourceCollection * self;
	PhotoMonitor* _tmp0_;
	MediaMonitor* result;
#line 4559 "../src/Photo.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (base, TYPE_LIBRARY_PHOTO_SOURCE_COLLECTION, LibraryPhotoSourceCollection);
#line 4559 "../src/Photo.vala"
	g_return_val_if_fail (IS_WORKERS (workers), NULL);
#line 4559 "../src/Photo.vala"
	g_return_val_if_fail (G_TYPE_CHECK_INSTANCE_TYPE (cancellable, g_cancellable_get_type ()), NULL);
#line 4560 "../src/Photo.vala"
	_tmp0_ = photo_monitor_new (workers, cancellable);
#line 4560 "../src/Photo.vala"
	result = G_TYPE_CHECK_INSTANCE_CAST (_tmp0_, TYPE_MEDIA_MONITOR, MediaMonitor);
#line 4560 "../src/Photo.vala"
	return result;
#line 34601 "Photo.c"
}

static gboolean
library_photo_source_collection_real_holds_type_of_source (SourceCollection* base,
                                                           DataSource* source)
{
	LibraryPhotoSourceCollection * self;
	gboolean result;
#line 4563 "../src/Photo.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (base, TYPE_LIBRARY_PHOTO_SOURCE_COLLECTION, LibraryPhotoSourceCollection);
#line 4563 "../src/Photo.vala"
	g_return_val_if_fail (IS_DATA_SOURCE (source), FALSE);
#line 4564 "../src/Photo.vala"
	result = IS_LIBRARY_PHOTO (source);
#line 4564 "../src/Photo.vala"
	return result;
#line 34618 "Photo.c"
}

static gchar*
library_photo_source_collection_real_get_typename (MediaSourceCollection* base)
{
	LibraryPhotoSourceCollection * self;
	gchar* _tmp0_;
	gchar* result;
#line 4567 "../src/Photo.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (base, TYPE_LIBRARY_PHOTO_SOURCE_COLLECTION, LibraryPhotoSourceCollection);
#line 4568 "../src/Photo.vala"
	_tmp0_ = g_strdup (PHOTO_TYPENAME);
#line 4568 "../src/Photo.vala"
	result = _tmp0_;
#line 4568 "../src/Photo.vala"
	return result;
#line 34635 "Photo.c"
}

static gboolean
library_photo_source_collection_real_is_file_recognized (MediaSourceCollection* base,
                                                         GFile* file)
{
	LibraryPhotoSourceCollection * self;
	gboolean result;
#line 4571 "../src/Photo.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (base, TYPE_LIBRARY_PHOTO_SOURCE_COLLECTION, LibraryPhotoSourceCollection);
#line 4571 "../src/Photo.vala"
	g_return_val_if_fail (G_TYPE_CHECK_INSTANCE_TYPE (file, g_file_get_type ()), FALSE);
#line 4572 "../src/Photo.vala"
	result = photo_file_format_is_file_supported (file);
#line 4572 "../src/Photo.vala"
	return result;
#line 34652 "Photo.c"
}

static void
_library_photo_source_collection_on_editable_replaced_photo_editable_replaced (Photo* _sender,
                                                                               GFile* old_file,
                                                                               GFile* new_file,
                                                                               gpointer self)
{
#line 4584 "../src/Photo.vala"
	library_photo_source_collection_on_editable_replaced ((LibraryPhotoSourceCollection*) self, _sender, old_file, new_file);
#line 34663 "Photo.c"
}

static void
_library_photo_source_collection_on_raw_development_modified_photo_raw_development_modified (Photo* _sender,
                                                                                             gpointer self)
{
#line 4590 "../src/Photo.vala"
	library_photo_source_collection_on_raw_development_modified ((LibraryPhotoSourceCollection*) self, _sender);
#line 34672 "Photo.c"
}

static void
library_photo_source_collection_real_notify_contents_altered (DataCollection* base,
                                                              GeeIterable* added,
                                                              GeeIterable* removed)
{
	LibraryPhotoSourceCollection * self;
#line 4575 "../src/Photo.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (base, TYPE_LIBRARY_PHOTO_SOURCE_COLLECTION, LibraryPhotoSourceCollection);
#line 4575 "../src/Photo.vala"
	g_return_if_fail ((added == NULL) || G_TYPE_CHECK_INSTANCE_TYPE (added, GEE_TYPE_ITERABLE));
#line 4575 "../src/Photo.vala"
	g_return_if_fail ((removed == NULL) || G_TYPE_CHECK_INSTANCE_TYPE (removed, GEE_TYPE_ITERABLE));
#line 4577 "../src/Photo.vala"
	if (added != NULL) {
#line 34689 "Photo.c"
		{
			GeeIterator* _object_it = NULL;
			GeeIterator* _tmp0_;
#line 4578 "../src/Photo.vala"
			_tmp0_ = gee_iterable_iterator (added);
#line 4578 "../src/Photo.vala"
			_object_it = _tmp0_;
#line 4578 "../src/Photo.vala"
			while (TRUE) {
#line 34699 "Photo.c"
				GeeIterator* _tmp1_;
				DataObject* object = NULL;
				GeeIterator* _tmp2_;
				gpointer _tmp3_;
				LibraryPhoto* photo = NULL;
				DataObject* _tmp4_;
				LibraryPhoto* _tmp5_;
				GFile* editable = NULL;
				LibraryPhoto* _tmp6_;
				GFile* _tmp7_;
				GFile* _tmp8_;
				LibraryPhoto* _tmp12_;
				GeeCollection* raw_list = NULL;
				LibraryPhoto* _tmp13_;
				GeeCollection* _tmp14_;
				GeeCollection* _tmp15_;
				LibraryPhoto* _tmp24_;
				gint64 master_filesize = 0LL;
				LibraryPhoto* _tmp25_;
				BackingPhotoRow* _tmp26_;
				BackingPhotoRow* _tmp27_;
				gint64 _tmp28_;
				gint64 _tmp29_ = 0LL;
				LibraryPhoto* _tmp30_;
				BackingPhotoRow* _tmp31_;
				BackingPhotoRow* _tmp32_;
				gboolean _tmp33_;
				gint64 editable_filesize = 0LL;
				GeeMultiMap* _tmp37_;
				LibraryPhoto* _tmp38_;
				GeeHashMap* _tmp39_;
				LibraryPhoto* _tmp40_;
				GeeCollection* raw_rows = NULL;
				LibraryPhoto* _tmp45_;
				GeeCollection* _tmp46_;
				GeeCollection* _tmp47_;
#line 4578 "../src/Photo.vala"
				_tmp1_ = _object_it;
#line 4578 "../src/Photo.vala"
				if (!gee_iterator_next (_tmp1_)) {
#line 4578 "../src/Photo.vala"
					break;
#line 34742 "Photo.c"
				}
#line 4578 "../src/Photo.vala"
				_tmp2_ = _object_it;
#line 4578 "../src/Photo.vala"
				_tmp3_ = gee_iterator_get (_tmp2_);
#line 4578 "../src/Photo.vala"
				object = (DataObject*) _tmp3_;
#line 4579 "../src/Photo.vala"
				_tmp4_ = object;
#line 4579 "../src/Photo.vala"
				_tmp5_ = _g_object_ref0 (G_TYPE_CHECK_INSTANCE_CAST (_tmp4_, TYPE_LIBRARY_PHOTO, LibraryPhoto));
#line 4579 "../src/Photo.vala"
				photo = _tmp5_;
#line 4581 "../src/Photo.vala"
				_tmp6_ = photo;
#line 4581 "../src/Photo.vala"
				_tmp7_ = photo_get_editable_file (G_TYPE_CHECK_INSTANCE_CAST (_tmp6_, TYPE_PHOTO, Photo));
#line 4581 "../src/Photo.vala"
				editable = _tmp7_;
#line 4582 "../src/Photo.vala"
				_tmp8_ = editable;
#line 4582 "../src/Photo.vala"
				if (_tmp8_ != NULL) {
#line 34766 "Photo.c"
					GeeHashMap* _tmp9_;
					GFile* _tmp10_;
					LibraryPhoto* _tmp11_;
#line 4583 "../src/Photo.vala"
					_tmp9_ = self->priv->by_editable_file;
#line 4583 "../src/Photo.vala"
					_tmp10_ = editable;
#line 4583 "../src/Photo.vala"
					_tmp11_ = photo;
#line 4583 "../src/Photo.vala"
					gee_abstract_map_set (G_TYPE_CHECK_INSTANCE_CAST (_tmp9_, GEE_TYPE_ABSTRACT_MAP, GeeAbstractMap), _tmp10_, _tmp11_);
#line 34778 "Photo.c"
				}
#line 4584 "../src/Photo.vala"
				_tmp12_ = photo;
#line 4584 "../src/Photo.vala"
				g_signal_connect (G_TYPE_CHECK_INSTANCE_CAST (_tmp12_, TYPE_PHOTO, Photo), "editable-replaced", (GCallback) _library_photo_source_collection_on_editable_replaced_photo_editable_replaced, self);
#line 4586 "../src/Photo.vala"
				_tmp13_ = photo;
#line 4586 "../src/Photo.vala"
				_tmp14_ = photo_get_raw_developer_files (G_TYPE_CHECK_INSTANCE_CAST (_tmp13_, TYPE_PHOTO, Photo));
#line 4586 "../src/Photo.vala"
				raw_list = _tmp14_;
#line 4587 "../src/Photo.vala"
				_tmp15_ = raw_list;
#line 4587 "../src/Photo.vala"
				if (_tmp15_ != NULL) {
#line 34794 "Photo.c"
					{
						GeeIterator* _f_it = NULL;
						GeeCollection* _tmp16_;
						GeeIterator* _tmp17_;
#line 4588 "../src/Photo.vala"
						_tmp16_ = raw_list;
#line 4588 "../src/Photo.vala"
						_tmp17_ = gee_iterable_iterator (G_TYPE_CHECK_INSTANCE_CAST (_tmp16_, GEE_TYPE_ITERABLE, GeeIterable));
#line 4588 "../src/Photo.vala"
						_f_it = _tmp17_;
#line 4588 "../src/Photo.vala"
						while (TRUE) {
#line 34807 "Photo.c"
							GeeIterator* _tmp18_;
							GFile* f = NULL;
							GeeIterator* _tmp19_;
							gpointer _tmp20_;
							GeeHashMap* _tmp21_;
							GFile* _tmp22_;
							LibraryPhoto* _tmp23_;
#line 4588 "../src/Photo.vala"
							_tmp18_ = _f_it;
#line 4588 "../src/Photo.vala"
							if (!gee_iterator_next (_tmp18_)) {
#line 4588 "../src/Photo.vala"
								break;
#line 34821 "Photo.c"
							}
#line 4588 "../src/Photo.vala"
							_tmp19_ = _f_it;
#line 4588 "../src/Photo.vala"
							_tmp20_ = gee_iterator_get (_tmp19_);
#line 4588 "../src/Photo.vala"
							f = (GFile*) _tmp20_;
#line 4589 "../src/Photo.vala"
							_tmp21_ = self->priv->by_raw_development_file;
#line 4589 "../src/Photo.vala"
							_tmp22_ = f;
#line 4589 "../src/Photo.vala"
							_tmp23_ = photo;
#line 4589 "../src/Photo.vala"
							gee_abstract_map_set (G_TYPE_CHECK_INSTANCE_CAST (_tmp21_, GEE_TYPE_ABSTRACT_MAP, GeeAbstractMap), _tmp22_, _tmp23_);
#line 4588 "../src/Photo.vala"
							_g_object_unref0 (f);
#line 34839 "Photo.c"
						}
#line 4588 "../src/Photo.vala"
						_g_object_unref0 (_f_it);
#line 34843 "Photo.c"
					}
				}
#line 4590 "../src/Photo.vala"
				_tmp24_ = photo;
#line 4590 "../src/Photo.vala"
				g_signal_connect (G_TYPE_CHECK_INSTANCE_CAST (_tmp24_, TYPE_PHOTO, Photo), "raw-development-modified", (GCallback) _library_photo_source_collection_on_raw_development_modified_photo_raw_development_modified, self);
#line 4592 "../src/Photo.vala"
				_tmp25_ = photo;
#line 4592 "../src/Photo.vala"
				_tmp26_ = photo_get_master_photo_row (G_TYPE_CHECK_INSTANCE_CAST (_tmp25_, TYPE_PHOTO, Photo));
#line 4592 "../src/Photo.vala"
				_tmp27_ = _tmp26_;
#line 4592 "../src/Photo.vala"
				_tmp28_ = _tmp27_->filesize;
#line 4592 "../src/Photo.vala"
				_backing_photo_row_unref0 (_tmp27_);
#line 4592 "../src/Photo.vala"
				master_filesize = _tmp28_;
#line 4593 "../src/Photo.vala"
				_tmp30_ = photo;
#line 4593 "../src/Photo.vala"
				_tmp31_ = photo_get_editable_photo_row (G_TYPE_CHECK_INSTANCE_CAST (_tmp30_, TYPE_PHOTO, Photo));
#line 4593 "../src/Photo.vala"
				_tmp32_ = _tmp31_;
#line 4593 "../src/Photo.vala"
				_tmp33_ = _tmp32_ != NULL;
#line 4593 "../src/Photo.vala"
				_backing_photo_row_unref0 (_tmp32_);
#line 4593 "../src/Photo.vala"
				if (_tmp33_) {
#line 34874 "Photo.c"
					LibraryPhoto* _tmp34_;
					BackingPhotoRow* _tmp35_;
					BackingPhotoRow* _tmp36_;
#line 4594 "../src/Photo.vala"
					_tmp34_ = photo;
#line 4594 "../src/Photo.vala"
					_tmp35_ = photo_get_editable_photo_row (G_TYPE_CHECK_INSTANCE_CAST (_tmp34_, TYPE_PHOTO, Photo));
#line 4594 "../src/Photo.vala"
					_tmp36_ = _tmp35_;
#line 4594 "../src/Photo.vala"
					_tmp29_ = _tmp36_->filesize;
#line 4594 "../src/Photo.vala"
					_backing_photo_row_unref0 (_tmp36_);
#line 34888 "Photo.c"
				} else {
#line 4595 "../src/Photo.vala"
					_tmp29_ = (gint64) -1;
#line 34892 "Photo.c"
				}
#line 4593 "../src/Photo.vala"
				editable_filesize = _tmp29_;
#line 4596 "../src/Photo.vala"
				_tmp37_ = self->priv->filesize_to_photo;
#line 4596 "../src/Photo.vala"
				_tmp38_ = photo;
#line 4596 "../src/Photo.vala"
				gee_multi_map_set (_tmp37_, &master_filesize, _tmp38_);
#line 4597 "../src/Photo.vala"
				_tmp39_ = self->priv->photo_to_master_filesize;
#line 4597 "../src/Photo.vala"
				_tmp40_ = photo;
#line 4597 "../src/Photo.vala"
				gee_abstract_map_set (G_TYPE_CHECK_INSTANCE_CAST (_tmp39_, GEE_TYPE_ABSTRACT_MAP, GeeAbstractMap), _tmp40_, &master_filesize);
#line 4598 "../src/Photo.vala"
				if (editable_filesize >= ((gint64) 0)) {
#line 34910 "Photo.c"
					GeeMultiMap* _tmp41_;
					LibraryPhoto* _tmp42_;
					GeeHashMap* _tmp43_;
					LibraryPhoto* _tmp44_;
#line 4599 "../src/Photo.vala"
					_tmp41_ = self->priv->filesize_to_photo;
#line 4599 "../src/Photo.vala"
					_tmp42_ = photo;
#line 4599 "../src/Photo.vala"
					gee_multi_map_set (_tmp41_, &editable_filesize, _tmp42_);
#line 4600 "../src/Photo.vala"
					_tmp43_ = self->priv->photo_to_editable_filesize;
#line 4600 "../src/Photo.vala"
					_tmp44_ = photo;
#line 4600 "../src/Photo.vala"
					gee_abstract_map_set (G_TYPE_CHECK_INSTANCE_CAST (_tmp43_, GEE_TYPE_ABSTRACT_MAP, GeeAbstractMap), _tmp44_, &editable_filesize);
#line 34927 "Photo.c"
				}
#line 4603 "../src/Photo.vala"
				_tmp45_ = photo;
#line 4603 "../src/Photo.vala"
				_tmp46_ = photo_get_raw_development_photo_rows (G_TYPE_CHECK_INSTANCE_CAST (_tmp45_, TYPE_PHOTO, Photo));
#line 4603 "../src/Photo.vala"
				raw_rows = _tmp46_;
#line 4604 "../src/Photo.vala"
				_tmp47_ = raw_rows;
#line 4604 "../src/Photo.vala"
				if (_tmp47_ != NULL) {
#line 34939 "Photo.c"
					{
						GeeIterator* _row_it = NULL;
						GeeCollection* _tmp48_;
						GeeIterator* _tmp49_;
#line 4605 "../src/Photo.vala"
						_tmp48_ = raw_rows;
#line 4605 "../src/Photo.vala"
						_tmp49_ = gee_iterable_iterator (G_TYPE_CHECK_INSTANCE_CAST (_tmp48_, GEE_TYPE_ITERABLE, GeeIterable));
#line 4605 "../src/Photo.vala"
						_row_it = _tmp49_;
#line 4605 "../src/Photo.vala"
						while (TRUE) {
#line 34952 "Photo.c"
							GeeIterator* _tmp50_;
							BackingPhotoRow* row = NULL;
							GeeIterator* _tmp51_;
							gpointer _tmp52_;
							BackingPhotoRow* _tmp53_;
#line 4605 "../src/Photo.vala"
							_tmp50_ = _row_it;
#line 4605 "../src/Photo.vala"
							if (!gee_iterator_next (_tmp50_)) {
#line 4605 "../src/Photo.vala"
								break;
#line 34964 "Photo.c"
							}
#line 4605 "../src/Photo.vala"
							_tmp51_ = _row_it;
#line 4605 "../src/Photo.vala"
							_tmp52_ = gee_iterator_get (_tmp51_);
#line 4605 "../src/Photo.vala"
							row = (BackingPhotoRow*) _tmp52_;
#line 4606 "../src/Photo.vala"
							_tmp53_ = row;
#line 4606 "../src/Photo.vala"
							if (_tmp53_->filesize >= ((gint64) 0)) {
#line 34976 "Photo.c"
								GeeMultiMap* _tmp54_;
								BackingPhotoRow* _tmp55_;
								LibraryPhoto* _tmp56_;
								GeeMultiMap* _tmp57_;
								LibraryPhoto* _tmp58_;
								BackingPhotoRow* _tmp59_;
#line 4607 "../src/Photo.vala"
								_tmp54_ = self->priv->filesize_to_photo;
#line 4607 "../src/Photo.vala"
								_tmp55_ = row;
#line 4607 "../src/Photo.vala"
								_tmp56_ = photo;
#line 4607 "../src/Photo.vala"
								gee_multi_map_set (_tmp54_, &_tmp55_->filesize, _tmp56_);
#line 4608 "../src/Photo.vala"
								_tmp57_ = self->priv->photo_to_raw_development_filesize;
#line 4608 "../src/Photo.vala"
								_tmp58_ = photo;
#line 4608 "../src/Photo.vala"
								_tmp59_ = row;
#line 4608 "../src/Photo.vala"
								gee_multi_map_set (_tmp57_, _tmp58_, &_tmp59_->filesize);
#line 34999 "Photo.c"
							}
#line 4605 "../src/Photo.vala"
							_backing_photo_row_unref0 (row);
#line 35003 "Photo.c"
						}
#line 4605 "../src/Photo.vala"
						_g_object_unref0 (_row_it);
#line 35007 "Photo.c"
					}
				}
#line 4578 "../src/Photo.vala"
				_g_object_unref0 (raw_rows);
#line 4578 "../src/Photo.vala"
				_g_object_unref0 (raw_list);
#line 4578 "../src/Photo.vala"
				_g_object_unref0 (editable);
#line 4578 "../src/Photo.vala"
				_g_object_unref0 (photo);
#line 4578 "../src/Photo.vala"
				_g_object_unref0 (object);
#line 35020 "Photo.c"
			}
#line 4578 "../src/Photo.vala"
			_g_object_unref0 (_object_it);
#line 35024 "Photo.c"
		}
	}
#line 4615 "../src/Photo.vala"
	if (removed != NULL) {
#line 35029 "Photo.c"
		{
			GeeIterator* _object_it = NULL;
			GeeIterator* _tmp60_;
#line 4616 "../src/Photo.vala"
			_tmp60_ = gee_iterable_iterator (removed);
#line 4616 "../src/Photo.vala"
			_object_it = _tmp60_;
#line 4616 "../src/Photo.vala"
			while (TRUE) {
#line 35039 "Photo.c"
				GeeIterator* _tmp61_;
				DataObject* object = NULL;
				GeeIterator* _tmp62_;
				gpointer _tmp63_;
				LibraryPhoto* photo = NULL;
				DataObject* _tmp64_;
				LibraryPhoto* _tmp65_;
				GFile* editable = NULL;
				LibraryPhoto* _tmp66_;
				GFile* _tmp67_;
				GFile* _tmp68_;
				LibraryPhoto* _tmp74_;
				guint _tmp75_;
				GeeCollection* raw_list = NULL;
				LibraryPhoto* _tmp76_;
				GeeCollection* _tmp77_;
				GeeCollection* _tmp78_;
				LibraryPhoto* _tmp86_;
				guint _tmp87_;
				gint64 master_filesize = 0LL;
				LibraryPhoto* _tmp88_;
				BackingPhotoRow* _tmp89_;
				BackingPhotoRow* _tmp90_;
				gint64 _tmp91_;
				gint64 _tmp92_ = 0LL;
				LibraryPhoto* _tmp93_;
				BackingPhotoRow* _tmp94_;
				BackingPhotoRow* _tmp95_;
				gboolean _tmp96_;
				gint64 editable_filesize = 0LL;
				GeeMultiMap* _tmp100_;
				LibraryPhoto* _tmp101_;
				GeeHashMap* _tmp102_;
				LibraryPhoto* _tmp103_;
				GeeCollection* raw_rows = NULL;
				LibraryPhoto* _tmp108_;
				GeeCollection* _tmp109_;
				GeeCollection* _tmp110_;
#line 4616 "../src/Photo.vala"
				_tmp61_ = _object_it;
#line 4616 "../src/Photo.vala"
				if (!gee_iterator_next (_tmp61_)) {
#line 4616 "../src/Photo.vala"
					break;
#line 35084 "Photo.c"
				}
#line 4616 "../src/Photo.vala"
				_tmp62_ = _object_it;
#line 4616 "../src/Photo.vala"
				_tmp63_ = gee_iterator_get (_tmp62_);
#line 4616 "../src/Photo.vala"
				object = (DataObject*) _tmp63_;
#line 4617 "../src/Photo.vala"
				_tmp64_ = object;
#line 4617 "../src/Photo.vala"
				_tmp65_ = _g_object_ref0 (G_TYPE_CHECK_INSTANCE_CAST (_tmp64_, TYPE_LIBRARY_PHOTO, LibraryPhoto));
#line 4617 "../src/Photo.vala"
				photo = _tmp65_;
#line 4619 "../src/Photo.vala"
				_tmp66_ = photo;
#line 4619 "../src/Photo.vala"
				_tmp67_ = photo_get_editable_file (G_TYPE_CHECK_INSTANCE_CAST (_tmp66_, TYPE_PHOTO, Photo));
#line 4619 "../src/Photo.vala"
				editable = _tmp67_;
#line 4620 "../src/Photo.vala"
				_tmp68_ = editable;
#line 4620 "../src/Photo.vala"
				if (_tmp68_ != NULL) {
#line 35108 "Photo.c"
					gboolean is_removed = FALSE;
					GeeHashMap* _tmp69_;
					LibraryPhoto* _tmp70_;
					GFile* _tmp71_;
					GFile* _tmp72_;
					gboolean _tmp73_;
#line 4621 "../src/Photo.vala"
					_tmp69_ = self->priv->by_editable_file;
#line 4621 "../src/Photo.vala"
					_tmp70_ = photo;
#line 4621 "../src/Photo.vala"
					_tmp71_ = photo_get_editable_file (G_TYPE_CHECK_INSTANCE_CAST (_tmp70_, TYPE_PHOTO, Photo));
#line 4621 "../src/Photo.vala"
					_tmp72_ = _tmp71_;
#line 4621 "../src/Photo.vala"
					_tmp73_ = gee_abstract_map_unset (G_TYPE_CHECK_INSTANCE_CAST (_tmp69_, GEE_TYPE_ABSTRACT_MAP, GeeAbstractMap), _tmp72_, NULL);
#line 4621 "../src/Photo.vala"
					_g_object_unref0 (_tmp72_);
#line 4621 "../src/Photo.vala"
					is_removed = _tmp73_;
#line 4622 "../src/Photo.vala"
					_vala_assert (is_removed, "is_removed");
#line 35131 "Photo.c"
				}
#line 4624 "../src/Photo.vala"
				_tmp74_ = photo;
#line 4624 "../src/Photo.vala"
				g_signal_parse_name ("editable-replaced", TYPE_PHOTO, &_tmp75_, NULL, FALSE);
#line 4624 "../src/Photo.vala"
				g_signal_handlers_disconnect_matched (G_TYPE_CHECK_INSTANCE_CAST (_tmp74_, TYPE_PHOTO, Photo), G_SIGNAL_MATCH_ID | G_SIGNAL_MATCH_FUNC | G_SIGNAL_MATCH_DATA, _tmp75_, 0, NULL, (GCallback) _library_photo_source_collection_on_editable_replaced_photo_editable_replaced, self);
#line 4626 "../src/Photo.vala"
				_tmp76_ = photo;
#line 4626 "../src/Photo.vala"
				_tmp77_ = photo_get_raw_developer_files (G_TYPE_CHECK_INSTANCE_CAST (_tmp76_, TYPE_PHOTO, Photo));
#line 4626 "../src/Photo.vala"
				raw_list = _tmp77_;
#line 4627 "../src/Photo.vala"
				_tmp78_ = raw_list;
#line 4627 "../src/Photo.vala"
				if (_tmp78_ != NULL) {
#line 35149 "Photo.c"
					{
						GeeIterator* _f_it = NULL;
						GeeCollection* _tmp79_;
						GeeIterator* _tmp80_;
#line 4628 "../src/Photo.vala"
						_tmp79_ = raw_list;
#line 4628 "../src/Photo.vala"
						_tmp80_ = gee_iterable_iterator (G_TYPE_CHECK_INSTANCE_CAST (_tmp79_, GEE_TYPE_ITERABLE, GeeIterable));
#line 4628 "../src/Photo.vala"
						_f_it = _tmp80_;
#line 4628 "../src/Photo.vala"
						while (TRUE) {
#line 35162 "Photo.c"
							GeeIterator* _tmp81_;
							GFile* f = NULL;
							GeeIterator* _tmp82_;
							gpointer _tmp83_;
							GeeHashMap* _tmp84_;
							GFile* _tmp85_;
#line 4628 "../src/Photo.vala"
							_tmp81_ = _f_it;
#line 4628 "../src/Photo.vala"
							if (!gee_iterator_next (_tmp81_)) {
#line 4628 "../src/Photo.vala"
								break;
#line 35175 "Photo.c"
							}
#line 4628 "../src/Photo.vala"
							_tmp82_ = _f_it;
#line 4628 "../src/Photo.vala"
							_tmp83_ = gee_iterator_get (_tmp82_);
#line 4628 "../src/Photo.vala"
							f = (GFile*) _tmp83_;
#line 4629 "../src/Photo.vala"
							_tmp84_ = self->priv->by_raw_development_file;
#line 4629 "../src/Photo.vala"
							_tmp85_ = f;
#line 4629 "../src/Photo.vala"
							gee_abstract_map_unset (G_TYPE_CHECK_INSTANCE_CAST (_tmp84_, GEE_TYPE_ABSTRACT_MAP, GeeAbstractMap), _tmp85_, NULL);
#line 4628 "../src/Photo.vala"
							_g_object_unref0 (f);
#line 35191 "Photo.c"
						}
#line 4628 "../src/Photo.vala"
						_g_object_unref0 (_f_it);
#line 35195 "Photo.c"
					}
				}
#line 4630 "../src/Photo.vala"
				_tmp86_ = photo;
#line 4630 "../src/Photo.vala"
				g_signal_parse_name ("raw-development-modified", TYPE_PHOTO, &_tmp87_, NULL, FALSE);
#line 4630 "../src/Photo.vala"
				g_signal_handlers_disconnect_matched (G_TYPE_CHECK_INSTANCE_CAST (_tmp86_, TYPE_PHOTO, Photo), G_SIGNAL_MATCH_ID | G_SIGNAL_MATCH_FUNC | G_SIGNAL_MATCH_DATA, _tmp87_, 0, NULL, (GCallback) _library_photo_source_collection_on_raw_development_modified_photo_raw_development_modified, self);
#line 4632 "../src/Photo.vala"
				_tmp88_ = photo;
#line 4632 "../src/Photo.vala"
				_tmp89_ = photo_get_master_photo_row (G_TYPE_CHECK_INSTANCE_CAST (_tmp88_, TYPE_PHOTO, Photo));
#line 4632 "../src/Photo.vala"
				_tmp90_ = _tmp89_;
#line 4632 "../src/Photo.vala"
				_tmp91_ = _tmp90_->filesize;
#line 4632 "../src/Photo.vala"
				_backing_photo_row_unref0 (_tmp90_);
#line 4632 "../src/Photo.vala"
				master_filesize = _tmp91_;
#line 4633 "../src/Photo.vala"
				_tmp93_ = photo;
#line 4633 "../src/Photo.vala"
				_tmp94_ = photo_get_editable_photo_row (G_TYPE_CHECK_INSTANCE_CAST (_tmp93_, TYPE_PHOTO, Photo));
#line 4633 "../src/Photo.vala"
				_tmp95_ = _tmp94_;
#line 4633 "../src/Photo.vala"
				_tmp96_ = _tmp95_ != NULL;
#line 4633 "../src/Photo.vala"
				_backing_photo_row_unref0 (_tmp95_);
#line 4633 "../src/Photo.vala"
				if (_tmp96_) {
#line 35228 "Photo.c"
					LibraryPhoto* _tmp97_;
					BackingPhotoRow* _tmp98_;
					BackingPhotoRow* _tmp99_;
#line 4634 "../src/Photo.vala"
					_tmp97_ = photo;
#line 4634 "../src/Photo.vala"
					_tmp98_ = photo_get_editable_photo_row (G_TYPE_CHECK_INSTANCE_CAST (_tmp97_, TYPE_PHOTO, Photo));
#line 4634 "../src/Photo.vala"
					_tmp99_ = _tmp98_;
#line 4634 "../src/Photo.vala"
					_tmp92_ = _tmp99_->filesize;
#line 4634 "../src/Photo.vala"
					_backing_photo_row_unref0 (_tmp99_);
#line 35242 "Photo.c"
				} else {
#line 4635 "../src/Photo.vala"
					_tmp92_ = (gint64) -1;
#line 35246 "Photo.c"
				}
#line 4633 "../src/Photo.vala"
				editable_filesize = _tmp92_;
#line 4636 "../src/Photo.vala"
				_tmp100_ = self->priv->filesize_to_photo;
#line 4636 "../src/Photo.vala"
				_tmp101_ = photo;
#line 4636 "../src/Photo.vala"
				gee_multi_map_remove (_tmp100_, &master_filesize, _tmp101_);
#line 4637 "../src/Photo.vala"
				_tmp102_ = self->priv->photo_to_master_filesize;
#line 4637 "../src/Photo.vala"
				_tmp103_ = photo;
#line 4637 "../src/Photo.vala"
				gee_abstract_map_unset (G_TYPE_CHECK_INSTANCE_CAST (_tmp102_, GEE_TYPE_ABSTRACT_MAP, GeeAbstractMap), _tmp103_, NULL);
#line 4638 "../src/Photo.vala"
				if (editable_filesize >= ((gint64) 0)) {
#line 35264 "Photo.c"
					GeeMultiMap* _tmp104_;
					LibraryPhoto* _tmp105_;
					GeeHashMap* _tmp106_;
					LibraryPhoto* _tmp107_;
#line 4639 "../src/Photo.vala"
					_tmp104_ = self->priv->filesize_to_photo;
#line 4639 "../src/Photo.vala"
					_tmp105_ = photo;
#line 4639 "../src/Photo.vala"
					gee_multi_map_remove (_tmp104_, &editable_filesize, _tmp105_);
#line 4640 "../src/Photo.vala"
					_tmp106_ = self->priv->photo_to_editable_filesize;
#line 4640 "../src/Photo.vala"
					_tmp107_ = photo;
#line 4640 "../src/Photo.vala"
					gee_abstract_map_unset (G_TYPE_CHECK_INSTANCE_CAST (_tmp106_, GEE_TYPE_ABSTRACT_MAP, GeeAbstractMap), _tmp107_, NULL);
#line 35281 "Photo.c"
				}
#line 4643 "../src/Photo.vala"
				_tmp108_ = photo;
#line 4643 "../src/Photo.vala"
				_tmp109_ = photo_get_raw_development_photo_rows (G_TYPE_CHECK_INSTANCE_CAST (_tmp108_, TYPE_PHOTO, Photo));
#line 4643 "../src/Photo.vala"
				raw_rows = _tmp109_;
#line 4644 "../src/Photo.vala"
				_tmp110_ = raw_rows;
#line 4644 "../src/Photo.vala"
				if (_tmp110_ != NULL) {
#line 35293 "Photo.c"
					{
						GeeIterator* _row_it = NULL;
						GeeCollection* _tmp111_;
						GeeIterator* _tmp112_;
#line 4645 "../src/Photo.vala"
						_tmp111_ = raw_rows;
#line 4645 "../src/Photo.vala"
						_tmp112_ = gee_iterable_iterator (G_TYPE_CHECK_INSTANCE_CAST (_tmp111_, GEE_TYPE_ITERABLE, GeeIterable));
#line 4645 "../src/Photo.vala"
						_row_it = _tmp112_;
#line 4645 "../src/Photo.vala"
						while (TRUE) {
#line 35306 "Photo.c"
							GeeIterator* _tmp113_;
							BackingPhotoRow* row = NULL;
							GeeIterator* _tmp114_;
							gpointer _tmp115_;
							BackingPhotoRow* _tmp116_;
#line 4645 "../src/Photo.vala"
							_tmp113_ = _row_it;
#line 4645 "../src/Photo.vala"
							if (!gee_iterator_next (_tmp113_)) {
#line 4645 "../src/Photo.vala"
								break;
#line 35318 "Photo.c"
							}
#line 4645 "../src/Photo.vala"
							_tmp114_ = _row_it;
#line 4645 "../src/Photo.vala"
							_tmp115_ = gee_iterator_get (_tmp114_);
#line 4645 "../src/Photo.vala"
							row = (BackingPhotoRow*) _tmp115_;
#line 4646 "../src/Photo.vala"
							_tmp116_ = row;
#line 4646 "../src/Photo.vala"
							if (_tmp116_->filesize >= ((gint64) 0)) {
#line 35330 "Photo.c"
								GeeMultiMap* _tmp117_;
								BackingPhotoRow* _tmp118_;
								LibraryPhoto* _tmp119_;
								GeeMultiMap* _tmp120_;
								LibraryPhoto* _tmp121_;
								BackingPhotoRow* _tmp122_;
#line 4647 "../src/Photo.vala"
								_tmp117_ = self->priv->filesize_to_photo;
#line 4647 "../src/Photo.vala"
								_tmp118_ = row;
#line 4647 "../src/Photo.vala"
								_tmp119_ = photo;
#line 4647 "../src/Photo.vala"
								gee_multi_map_remove (_tmp117_, &_tmp118_->filesize, _tmp119_);
#line 4648 "../src/Photo.vala"
								_tmp120_ = self->priv->photo_to_raw_development_filesize;
#line 4648 "../src/Photo.vala"
								_tmp121_ = photo;
#line 4648 "../src/Photo.vala"
								_tmp122_ = row;
#line 4648 "../src/Photo.vala"
								gee_multi_map_remove (_tmp120_, _tmp121_, &_tmp122_->filesize);
#line 35353 "Photo.c"
							}
#line 4645 "../src/Photo.vala"
							_backing_photo_row_unref0 (row);
#line 35357 "Photo.c"
						}
#line 4645 "../src/Photo.vala"
						_g_object_unref0 (_row_it);
#line 35361 "Photo.c"
					}
				}
#line 4616 "../src/Photo.vala"
				_g_object_unref0 (raw_rows);
#line 4616 "../src/Photo.vala"
				_g_object_unref0 (raw_list);
#line 4616 "../src/Photo.vala"
				_g_object_unref0 (editable);
#line 4616 "../src/Photo.vala"
				_g_object_unref0 (photo);
#line 4616 "../src/Photo.vala"
				_g_object_unref0 (object);
#line 35374 "Photo.c"
			}
#line 4616 "../src/Photo.vala"
			_g_object_unref0 (_object_it);
#line 35378 "Photo.c"
		}
	}
#line 4655 "../src/Photo.vala"
	DATA_COLLECTION_CLASS (library_photo_source_collection_parent_class)->notify_contents_altered (G_TYPE_CHECK_INSTANCE_CAST (G_TYPE_CHECK_INSTANCE_CAST (self, TYPE_MEDIA_SOURCE_COLLECTION, MediaSourceCollection), TYPE_DATA_COLLECTION, DataCollection), added, removed);
#line 35383 "Photo.c"
}

static void
library_photo_source_collection_on_editable_replaced (LibraryPhotoSourceCollection* self,
                                                      Photo* photo,
                                                      GFile* old_file,
                                                      GFile* new_file)
{
#line 4658 "../src/Photo.vala"
	g_return_if_fail (IS_LIBRARY_PHOTO_SOURCE_COLLECTION (self));
#line 4658 "../src/Photo.vala"
	g_return_if_fail (IS_PHOTO (photo));
#line 4658 "../src/Photo.vala"
	g_return_if_fail ((old_file == NULL) || G_TYPE_CHECK_INSTANCE_TYPE (old_file, g_file_get_type ()));
#line 4658 "../src/Photo.vala"
	g_return_if_fail ((new_file == NULL) || G_TYPE_CHECK_INSTANCE_TYPE (new_file, g_file_get_type ()));
#line 4659 "../src/Photo.vala"
	if (old_file != NULL) {
#line 35402 "Photo.c"
		gboolean is_removed = FALSE;
		GeeHashMap* _tmp0_;
#line 4660 "../src/Photo.vala"
		_tmp0_ = self->priv->by_editable_file;
#line 4660 "../src/Photo.vala"
		is_removed = gee_abstract_map_unset (G_TYPE_CHECK_INSTANCE_CAST (_tmp0_, GEE_TYPE_ABSTRACT_MAP, GeeAbstractMap), old_file, NULL);
#line 4661 "../src/Photo.vala"
		_vala_assert (is_removed, "is_removed");
#line 35411 "Photo.c"
	}
#line 4664 "../src/Photo.vala"
	if (new_file != NULL) {
#line 35415 "Photo.c"
		GeeHashMap* _tmp1_;
#line 4665 "../src/Photo.vala"
		_tmp1_ = self->priv->by_editable_file;
#line 4665 "../src/Photo.vala"
		gee_abstract_map_set (G_TYPE_CHECK_INSTANCE_CAST (_tmp1_, GEE_TYPE_ABSTRACT_MAP, GeeAbstractMap), new_file, G_TYPE_CHECK_INSTANCE_CAST (photo, TYPE_LIBRARY_PHOTO, LibraryPhoto));
#line 35421 "Photo.c"
	}
}

static void
library_photo_source_collection_on_raw_development_modified (LibraryPhotoSourceCollection* self,
                                                             Photo* _photo)
{
	LibraryPhoto* photo = NULL;
	LibraryPhoto* _tmp0_;
	LibraryPhoto* _tmp1_;
	GeeMultiMap* _tmp2_;
	LibraryPhoto* _tmp3_;
	GeeCollection* raw_list = NULL;
	LibraryPhoto* _tmp19_;
	GeeCollection* _tmp20_;
	GeeCollection* _tmp21_;
	GeeCollection* raw_rows = NULL;
	LibraryPhoto* _tmp30_;
	GeeCollection* _tmp31_;
	GeeCollection* _tmp32_;
#line 4668 "../src/Photo.vala"
	g_return_if_fail (IS_LIBRARY_PHOTO_SOURCE_COLLECTION (self));
#line 4668 "../src/Photo.vala"
	g_return_if_fail (IS_PHOTO (_photo));
#line 4669 "../src/Photo.vala"
	_tmp0_ = _g_object_ref0 (IS_LIBRARY_PHOTO (_photo) ? ((LibraryPhoto*) _photo) : NULL);
#line 4669 "../src/Photo.vala"
	photo = _tmp0_;
#line 4670 "../src/Photo.vala"
	_tmp1_ = photo;
#line 4670 "../src/Photo.vala"
	if (_tmp1_ == NULL) {
#line 4671 "../src/Photo.vala"
		_g_object_unref0 (photo);
#line 4671 "../src/Photo.vala"
		return;
#line 35458 "Photo.c"
	}
#line 4674 "../src/Photo.vala"
	_tmp2_ = self->priv->photo_to_raw_development_filesize;
#line 4674 "../src/Photo.vala"
	_tmp3_ = photo;
#line 4674 "../src/Photo.vala"
	if (gee_multi_map_contains (_tmp2_, _tmp3_)) {
#line 35466 "Photo.c"
		GeeMultiMap* _tmp17_;
		LibraryPhoto* _tmp18_;
		{
			GeeIterator* _s_it = NULL;
			GeeMultiMap* _tmp4_;
			LibraryPhoto* _tmp5_;
			GeeCollection* _tmp6_;
			GeeCollection* _tmp7_;
			GeeIterator* _tmp8_;
			GeeIterator* _tmp9_;
#line 4675 "../src/Photo.vala"
			_tmp4_ = self->priv->photo_to_raw_development_filesize;
#line 4675 "../src/Photo.vala"
			_tmp5_ = photo;
#line 4675 "../src/Photo.vala"
			_tmp6_ = gee_multi_map_get (_tmp4_, _tmp5_);
#line 4675 "../src/Photo.vala"
			_tmp7_ = _tmp6_;
#line 4675 "../src/Photo.vala"
			_tmp8_ = gee_iterable_iterator (G_TYPE_CHECK_INSTANCE_CAST (_tmp7_, GEE_TYPE_ITERABLE, GeeIterable));
#line 4675 "../src/Photo.vala"
			_tmp9_ = _tmp8_;
#line 4675 "../src/Photo.vala"
			_g_object_unref0 (_tmp7_);
#line 4675 "../src/Photo.vala"
			_s_it = _tmp9_;
#line 4675 "../src/Photo.vala"
			while (TRUE) {
#line 35495 "Photo.c"
				GeeIterator* _tmp10_;
				gint64 s = 0LL;
				GeeIterator* _tmp11_;
				gpointer _tmp12_;
				gint64* _tmp13_;
				gint64 _tmp14_;
				GeeMultiMap* _tmp15_;
				LibraryPhoto* _tmp16_;
#line 4675 "../src/Photo.vala"
				_tmp10_ = _s_it;
#line 4675 "../src/Photo.vala"
				if (!gee_iterator_next (_tmp10_)) {
#line 4675 "../src/Photo.vala"
					break;
#line 35510 "Photo.c"
				}
#line 4675 "../src/Photo.vala"
				_tmp11_ = _s_it;
#line 4675 "../src/Photo.vala"
				_tmp12_ = gee_iterator_get (_tmp11_);
#line 4675 "../src/Photo.vala"
				_tmp13_ = (gint64*) _tmp12_;
#line 4675 "../src/Photo.vala"
				_tmp14_ = *_tmp13_;
#line 4675 "../src/Photo.vala"
				_g_free0 (_tmp13_);
#line 4675 "../src/Photo.vala"
				s = _tmp14_;
#line 4676 "../src/Photo.vala"
				_tmp15_ = self->priv->filesize_to_photo;
#line 4676 "../src/Photo.vala"
				_tmp16_ = photo;
#line 4676 "../src/Photo.vala"
				gee_multi_map_remove (_tmp15_, &s, _tmp16_);
#line 35530 "Photo.c"
			}
#line 4675 "../src/Photo.vala"
			_g_object_unref0 (_s_it);
#line 35534 "Photo.c"
		}
#line 4677 "../src/Photo.vala"
		_tmp17_ = self->priv->photo_to_raw_development_filesize;
#line 4677 "../src/Photo.vala"
		_tmp18_ = photo;
#line 4677 "../src/Photo.vala"
		gee_multi_map_remove_all (_tmp17_, _tmp18_);
#line 35542 "Photo.c"
	}
#line 4681 "../src/Photo.vala"
	_tmp19_ = photo;
#line 4681 "../src/Photo.vala"
	_tmp20_ = photo_get_raw_developer_files (G_TYPE_CHECK_INSTANCE_CAST (_tmp19_, TYPE_PHOTO, Photo));
#line 4681 "../src/Photo.vala"
	raw_list = _tmp20_;
#line 4682 "../src/Photo.vala"
	_tmp21_ = raw_list;
#line 4682 "../src/Photo.vala"
	if (_tmp21_ != NULL) {
#line 35554 "Photo.c"
		{
			GeeIterator* _f_it = NULL;
			GeeCollection* _tmp22_;
			GeeIterator* _tmp23_;
#line 4683 "../src/Photo.vala"
			_tmp22_ = raw_list;
#line 4683 "../src/Photo.vala"
			_tmp23_ = gee_iterable_iterator (G_TYPE_CHECK_INSTANCE_CAST (_tmp22_, GEE_TYPE_ITERABLE, GeeIterable));
#line 4683 "../src/Photo.vala"
			_f_it = _tmp23_;
#line 4683 "../src/Photo.vala"
			while (TRUE) {
#line 35567 "Photo.c"
				GeeIterator* _tmp24_;
				GFile* f = NULL;
				GeeIterator* _tmp25_;
				gpointer _tmp26_;
				GeeHashMap* _tmp27_;
				GFile* _tmp28_;
				LibraryPhoto* _tmp29_;
#line 4683 "../src/Photo.vala"
				_tmp24_ = _f_it;
#line 4683 "../src/Photo.vala"
				if (!gee_iterator_next (_tmp24_)) {
#line 4683 "../src/Photo.vala"
					break;
#line 35581 "Photo.c"
				}
#line 4683 "../src/Photo.vala"
				_tmp25_ = _f_it;
#line 4683 "../src/Photo.vala"
				_tmp26_ = gee_iterator_get (_tmp25_);
#line 4683 "../src/Photo.vala"
				f = (GFile*) _tmp26_;
#line 4684 "../src/Photo.vala"
				_tmp27_ = self->priv->by_raw_development_file;
#line 4684 "../src/Photo.vala"
				_tmp28_ = f;
#line 4684 "../src/Photo.vala"
				_tmp29_ = photo;
#line 4684 "../src/Photo.vala"
				gee_abstract_map_set (G_TYPE_CHECK_INSTANCE_CAST (_tmp27_, GEE_TYPE_ABSTRACT_MAP, GeeAbstractMap), _tmp28_, _tmp29_);
#line 4683 "../src/Photo.vala"
				_g_object_unref0 (f);
#line 35599 "Photo.c"
			}
#line 4683 "../src/Photo.vala"
			_g_object_unref0 (_f_it);
#line 35603 "Photo.c"
		}
	}
#line 4686 "../src/Photo.vala"
	_tmp30_ = photo;
#line 4686 "../src/Photo.vala"
	_tmp31_ = photo_get_raw_development_photo_rows (G_TYPE_CHECK_INSTANCE_CAST (_tmp30_, TYPE_PHOTO, Photo));
#line 4686 "../src/Photo.vala"
	raw_rows = _tmp31_;
#line 4687 "../src/Photo.vala"
	_tmp32_ = raw_rows;
#line 4687 "../src/Photo.vala"
	if (_tmp32_ != NULL) {
#line 35616 "Photo.c"
		{
			GeeIterator* _row_it = NULL;
			GeeCollection* _tmp33_;
			GeeIterator* _tmp34_;
#line 4688 "../src/Photo.vala"
			_tmp33_ = raw_rows;
#line 4688 "../src/Photo.vala"
			_tmp34_ = gee_iterable_iterator (G_TYPE_CHECK_INSTANCE_CAST (_tmp33_, GEE_TYPE_ITERABLE, GeeIterable));
#line 4688 "../src/Photo.vala"
			_row_it = _tmp34_;
#line 4688 "../src/Photo.vala"
			while (TRUE) {
#line 35629 "Photo.c"
				GeeIterator* _tmp35_;
				BackingPhotoRow* row = NULL;
				GeeIterator* _tmp36_;
				gpointer _tmp37_;
				BackingPhotoRow* _tmp38_;
#line 4688 "../src/Photo.vala"
				_tmp35_ = _row_it;
#line 4688 "../src/Photo.vala"
				if (!gee_iterator_next (_tmp35_)) {
#line 4688 "../src/Photo.vala"
					break;
#line 35641 "Photo.c"
				}
#line 4688 "../src/Photo.vala"
				_tmp36_ = _row_it;
#line 4688 "../src/Photo.vala"
				_tmp37_ = gee_iterator_get (_tmp36_);
#line 4688 "../src/Photo.vala"
				row = (BackingPhotoRow*) _tmp37_;
#line 4689 "../src/Photo.vala"
				_tmp38_ = row;
#line 4689 "../src/Photo.vala"
				if (_tmp38_->filesize > ((gint64) 0)) {
#line 35653 "Photo.c"
					GeeMultiMap* _tmp39_;
					BackingPhotoRow* _tmp40_;
					LibraryPhoto* _tmp41_;
					GeeMultiMap* _tmp42_;
					LibraryPhoto* _tmp43_;
					BackingPhotoRow* _tmp44_;
#line 4690 "../src/Photo.vala"
					_tmp39_ = self->priv->filesize_to_photo;
#line 4690 "../src/Photo.vala"
					_tmp40_ = row;
#line 4690 "../src/Photo.vala"
					_tmp41_ = photo;
#line 4690 "../src/Photo.vala"
					gee_multi_map_set (_tmp39_, &_tmp40_->filesize, _tmp41_);
#line 4691 "../src/Photo.vala"
					_tmp42_ = self->priv->photo_to_raw_development_filesize;
#line 4691 "../src/Photo.vala"
					_tmp43_ = photo;
#line 4691 "../src/Photo.vala"
					_tmp44_ = row;
#line 4691 "../src/Photo.vala"
					gee_multi_map_set (_tmp42_, _tmp43_, &_tmp44_->filesize);
#line 35676 "Photo.c"
				}
#line 4688 "../src/Photo.vala"
				_backing_photo_row_unref0 (row);
#line 35680 "Photo.c"
			}
#line 4688 "../src/Photo.vala"
			_g_object_unref0 (_row_it);
#line 35684 "Photo.c"
		}
	}
#line 4668 "../src/Photo.vala"
	_g_object_unref0 (raw_rows);
#line 4668 "../src/Photo.vala"
	_g_object_unref0 (raw_list);
#line 4668 "../src/Photo.vala"
	_g_object_unref0 (photo);
#line 35693 "Photo.c"
}

static gpointer
__int64_dup0 (gpointer self)
{
#line 4707 "../src/Photo.vala"
	return self ? _int64_dup (self) : NULL;
#line 35701 "Photo.c"
}

static void
library_photo_source_collection_real_items_altered (DataCollection* base,
                                                    GeeMap* items)
{
	LibraryPhotoSourceCollection * self;
#line 4697 "../src/Photo.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (base, TYPE_LIBRARY_PHOTO_SOURCE_COLLECTION, LibraryPhotoSourceCollection);
#line 4697 "../src/Photo.vala"
	g_return_if_fail (G_TYPE_CHECK_INSTANCE_TYPE (items, GEE_TYPE_MAP));
#line 35713 "Photo.c"
	{
		GeeIterator* _object_it = NULL;
		GeeSet* _tmp0_;
		GeeSet* _tmp1_;
		GeeSet* _tmp2_;
		GeeIterator* _tmp3_;
		GeeIterator* _tmp4_;
#line 4698 "../src/Photo.vala"
		_tmp0_ = gee_map_get_keys (items);
#line 4698 "../src/Photo.vala"
		_tmp1_ = _tmp0_;
#line 4698 "../src/Photo.vala"
		_tmp2_ = _tmp1_;
#line 4698 "../src/Photo.vala"
		_tmp3_ = gee_iterable_iterator (G_TYPE_CHECK_INSTANCE_CAST (_tmp2_, GEE_TYPE_ITERABLE, GeeIterable));
#line 4698 "../src/Photo.vala"
		_tmp4_ = _tmp3_;
#line 4698 "../src/Photo.vala"
		_g_object_unref0 (_tmp2_);
#line 4698 "../src/Photo.vala"
		_object_it = _tmp4_;
#line 4698 "../src/Photo.vala"
		while (TRUE) {
#line 35737 "Photo.c"
			GeeIterator* _tmp5_;
			DataObject* object = NULL;
			GeeIterator* _tmp6_;
			gpointer _tmp7_;
			Alteration* alteration = NULL;
			DataObject* _tmp8_;
			gpointer _tmp9_;
			LibraryPhoto* photo = NULL;
			DataObject* _tmp10_;
			LibraryPhoto* _tmp11_;
			gboolean _tmp12_ = FALSE;
			Alteration* _tmp13_;
#line 4698 "../src/Photo.vala"
			_tmp5_ = _object_it;
#line 4698 "../src/Photo.vala"
			if (!gee_iterator_next (_tmp5_)) {
#line 4698 "../src/Photo.vala"
				break;
#line 35756 "Photo.c"
			}
#line 4698 "../src/Photo.vala"
			_tmp6_ = _object_it;
#line 4698 "../src/Photo.vala"
			_tmp7_ = gee_iterator_get (_tmp6_);
#line 4698 "../src/Photo.vala"
			object = (DataObject*) _tmp7_;
#line 4699 "../src/Photo.vala"
			_tmp8_ = object;
#line 4699 "../src/Photo.vala"
			_tmp9_ = gee_map_get (items, _tmp8_);
#line 4699 "../src/Photo.vala"
			alteration = (Alteration*) _tmp9_;
#line 4701 "../src/Photo.vala"
			_tmp10_ = object;
#line 4701 "../src/Photo.vala"
			_tmp11_ = _g_object_ref0 (G_TYPE_CHECK_INSTANCE_CAST (_tmp10_, TYPE_LIBRARY_PHOTO, LibraryPhoto));
#line 4701 "../src/Photo.vala"
			photo = _tmp11_;
#line 4703 "../src/Photo.vala"
			_tmp13_ = alteration;
#line 4703 "../src/Photo.vala"
			if (alteration_has_detail (_tmp13_, "image", "master")) {
#line 4703 "../src/Photo.vala"
				_tmp12_ = TRUE;
#line 35782 "Photo.c"
			} else {
				Alteration* _tmp14_;
#line 4703 "../src/Photo.vala"
				_tmp14_ = alteration;
#line 4703 "../src/Photo.vala"
				_tmp12_ = alteration_has_detail (_tmp14_, "image", "editable");
#line 35789 "Photo.c"
			}
#line 4703 "../src/Photo.vala"
			if (_tmp12_) {
#line 35793 "Photo.c"
				gint64 old_master_filesize = 0LL;
				GeeHashMap* _tmp15_;
				LibraryPhoto* _tmp16_;
				gpointer _tmp17_;
				gint64* _tmp18_;
				gint64 _tmp19_;
				gint64* _tmp20_ = NULL;
				GeeHashMap* _tmp21_;
				LibraryPhoto* _tmp22_;
				gint64 old_editable_filesize = 0LL;
				GeeHashMap* _tmp28_;
				LibraryPhoto* _tmp29_;
				GeeMultiMap* _tmp30_;
				LibraryPhoto* _tmp31_;
				gint64 master_filesize = 0LL;
				LibraryPhoto* _tmp36_;
				BackingPhotoRow* _tmp37_;
				BackingPhotoRow* _tmp38_;
				gint64 _tmp39_;
				gint64 _tmp40_ = 0LL;
				LibraryPhoto* _tmp41_;
				BackingPhotoRow* _tmp42_;
				BackingPhotoRow* _tmp43_;
				gboolean _tmp44_;
				gint64 editable_filesize = 0LL;
				GeeHashMap* _tmp48_;
				LibraryPhoto* _tmp49_;
				GeeMultiMap* _tmp50_;
				LibraryPhoto* _tmp51_;
#line 4704 "../src/Photo.vala"
				_tmp15_ = self->priv->photo_to_master_filesize;
#line 4704 "../src/Photo.vala"
				_tmp16_ = photo;
#line 4704 "../src/Photo.vala"
				_tmp17_ = gee_abstract_map_get (G_TYPE_CHECK_INSTANCE_CAST (_tmp15_, GEE_TYPE_ABSTRACT_MAP, GeeAbstractMap), _tmp16_);
#line 4704 "../src/Photo.vala"
				_tmp18_ = (gint64*) _tmp17_;
#line 4704 "../src/Photo.vala"
				_tmp19_ = *_tmp18_;
#line 4704 "../src/Photo.vala"
				_g_free0 (_tmp18_);
#line 4704 "../src/Photo.vala"
				old_master_filesize = _tmp19_;
#line 4705 "../src/Photo.vala"
				_tmp21_ = self->priv->photo_to_editable_filesize;
#line 4705 "../src/Photo.vala"
				_tmp22_ = photo;
#line 4705 "../src/Photo.vala"
				if (gee_abstract_map_has_key (G_TYPE_CHECK_INSTANCE_CAST (_tmp21_, GEE_TYPE_ABSTRACT_MAP, GeeAbstractMap), _tmp22_)) {
#line 35843 "Photo.c"
					GeeHashMap* _tmp23_;
					LibraryPhoto* _tmp24_;
					gpointer _tmp25_;
#line 4706 "../src/Photo.vala"
					_tmp23_ = self->priv->photo_to_editable_filesize;
#line 4706 "../src/Photo.vala"
					_tmp24_ = photo;
#line 4706 "../src/Photo.vala"
					_tmp25_ = gee_abstract_map_get (G_TYPE_CHECK_INSTANCE_CAST (_tmp23_, GEE_TYPE_ABSTRACT_MAP, GeeAbstractMap), _tmp24_);
#line 4706 "../src/Photo.vala"
					_g_free0 (_tmp20_);
#line 4706 "../src/Photo.vala"
					_tmp20_ = (gint64*) _tmp25_;
#line 35857 "Photo.c"
				} else {
					gint64 _tmp26_;
					gint64* _tmp27_;
#line 4707 "../src/Photo.vala"
					_tmp26_ = (gint64) -1;
#line 4707 "../src/Photo.vala"
					_tmp27_ = __int64_dup0 (&_tmp26_);
#line 4707 "../src/Photo.vala"
					_g_free0 (_tmp20_);
#line 4707 "../src/Photo.vala"
					_tmp20_ = _tmp27_;
#line 35869 "Photo.c"
				}
#line 4705 "../src/Photo.vala"
				old_editable_filesize = *_tmp20_;
#line 4709 "../src/Photo.vala"
				_tmp28_ = self->priv->photo_to_master_filesize;
#line 4709 "../src/Photo.vala"
				_tmp29_ = photo;
#line 4709 "../src/Photo.vala"
				gee_abstract_map_unset (G_TYPE_CHECK_INSTANCE_CAST (_tmp28_, GEE_TYPE_ABSTRACT_MAP, GeeAbstractMap), _tmp29_, NULL);
#line 4710 "../src/Photo.vala"
				_tmp30_ = self->priv->filesize_to_photo;
#line 4710 "../src/Photo.vala"
				_tmp31_ = photo;
#line 4710 "../src/Photo.vala"
				gee_multi_map_remove (_tmp30_, &old_master_filesize, _tmp31_);
#line 4711 "../src/Photo.vala"
				if (old_editable_filesize >= ((gint64) 0)) {
#line 35887 "Photo.c"
					GeeHashMap* _tmp32_;
					LibraryPhoto* _tmp33_;
					GeeMultiMap* _tmp34_;
					LibraryPhoto* _tmp35_;
#line 4712 "../src/Photo.vala"
					_tmp32_ = self->priv->photo_to_editable_filesize;
#line 4712 "../src/Photo.vala"
					_tmp33_ = photo;
#line 4712 "../src/Photo.vala"
					gee_abstract_map_unset (G_TYPE_CHECK_INSTANCE_CAST (_tmp32_, GEE_TYPE_ABSTRACT_MAP, GeeAbstractMap), _tmp33_, NULL);
#line 4713 "../src/Photo.vala"
					_tmp34_ = self->priv->filesize_to_photo;
#line 4713 "../src/Photo.vala"
					_tmp35_ = photo;
#line 4713 "../src/Photo.vala"
					gee_multi_map_remove (_tmp34_, &old_editable_filesize, _tmp35_);
#line 35904 "Photo.c"
				}
#line 4716 "../src/Photo.vala"
				_tmp36_ = photo;
#line 4716 "../src/Photo.vala"
				_tmp37_ = photo_get_master_photo_row (G_TYPE_CHECK_INSTANCE_CAST (_tmp36_, TYPE_PHOTO, Photo));
#line 4716 "../src/Photo.vala"
				_tmp38_ = _tmp37_;
#line 4716 "../src/Photo.vala"
				_tmp39_ = _tmp38_->filesize;
#line 4716 "../src/Photo.vala"
				_backing_photo_row_unref0 (_tmp38_);
#line 4716 "../src/Photo.vala"
				master_filesize = _tmp39_;
#line 4717 "../src/Photo.vala"
				_tmp41_ = photo;
#line 4717 "../src/Photo.vala"
				_tmp42_ = photo_get_editable_photo_row (G_TYPE_CHECK_INSTANCE_CAST (_tmp41_, TYPE_PHOTO, Photo));
#line 4717 "../src/Photo.vala"
				_tmp43_ = _tmp42_;
#line 4717 "../src/Photo.vala"
				_tmp44_ = _tmp43_ != NULL;
#line 4717 "../src/Photo.vala"
				_backing_photo_row_unref0 (_tmp43_);
#line 4717 "../src/Photo.vala"
				if (_tmp44_) {
#line 35930 "Photo.c"
					LibraryPhoto* _tmp45_;
					BackingPhotoRow* _tmp46_;
					BackingPhotoRow* _tmp47_;
#line 4718 "../src/Photo.vala"
					_tmp45_ = photo;
#line 4718 "../src/Photo.vala"
					_tmp46_ = photo_get_editable_photo_row (G_TYPE_CHECK_INSTANCE_CAST (_tmp45_, TYPE_PHOTO, Photo));
#line 4718 "../src/Photo.vala"
					_tmp47_ = _tmp46_;
#line 4718 "../src/Photo.vala"
					_tmp40_ = _tmp47_->filesize;
#line 4718 "../src/Photo.vala"
					_backing_photo_row_unref0 (_tmp47_);
#line 35944 "Photo.c"
				} else {
#line 4719 "../src/Photo.vala"
					_tmp40_ = (gint64) -1;
#line 35948 "Photo.c"
				}
#line 4717 "../src/Photo.vala"
				editable_filesize = _tmp40_;
#line 4720 "../src/Photo.vala"
				_tmp48_ = self->priv->photo_to_master_filesize;
#line 4720 "../src/Photo.vala"
				_tmp49_ = photo;
#line 4720 "../src/Photo.vala"
				gee_abstract_map_set (G_TYPE_CHECK_INSTANCE_CAST (_tmp48_, GEE_TYPE_ABSTRACT_MAP, GeeAbstractMap), _tmp49_, &master_filesize);
#line 4721 "../src/Photo.vala"
				_tmp50_ = self->priv->filesize_to_photo;
#line 4721 "../src/Photo.vala"
				_tmp51_ = photo;
#line 4721 "../src/Photo.vala"
				gee_multi_map_set (_tmp50_, &master_filesize, _tmp51_);
#line 4722 "../src/Photo.vala"
				if (editable_filesize >= ((gint64) 0)) {
#line 35966 "Photo.c"
					GeeHashMap* _tmp52_;
					LibraryPhoto* _tmp53_;
					GeeMultiMap* _tmp54_;
					LibraryPhoto* _tmp55_;
#line 4723 "../src/Photo.vala"
					_tmp52_ = self->priv->photo_to_editable_filesize;
#line 4723 "../src/Photo.vala"
					_tmp53_ = photo;
#line 4723 "../src/Photo.vala"
					gee_abstract_map_set (G_TYPE_CHECK_INSTANCE_CAST (_tmp52_, GEE_TYPE_ABSTRACT_MAP, GeeAbstractMap), _tmp53_, &editable_filesize);
#line 4724 "../src/Photo.vala"
					_tmp54_ = self->priv->filesize_to_photo;
#line 4724 "../src/Photo.vala"
					_tmp55_ = photo;
#line 4724 "../src/Photo.vala"
					gee_multi_map_set (_tmp54_, &editable_filesize, _tmp55_);
#line 35983 "Photo.c"
				}
#line 4703 "../src/Photo.vala"
				_g_free0 (_tmp20_);
#line 35987 "Photo.c"
			}
#line 4698 "../src/Photo.vala"
			_g_object_unref0 (photo);
#line 4698 "../src/Photo.vala"
			_alteration_unref0 (alteration);
#line 4698 "../src/Photo.vala"
			_g_object_unref0 (object);
#line 35995 "Photo.c"
		}
#line 4698 "../src/Photo.vala"
		_g_object_unref0 (_object_it);
#line 35999 "Photo.c"
	}
#line 4729 "../src/Photo.vala"
	DATA_COLLECTION_CLASS (library_photo_source_collection_parent_class)->items_altered (G_TYPE_CHECK_INSTANCE_CAST (G_TYPE_CHECK_INSTANCE_CAST (self, TYPE_MEDIA_SOURCE_COLLECTION, MediaSourceCollection), TYPE_DATA_COLLECTION, DataCollection), items);
#line 36003 "Photo.c"
}

static void
library_photo_source_collection_real_postprocess_imported_media (MediaSourceCollection* base,
                                                                 GeeCollection* media_sources)
{
	LibraryPhotoSourceCollection * self;
	GeeHashMultiMap* map = NULL;
	GeeHashMultiMap* _tmp0_;
#line 4733 "../src/Photo.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (base, TYPE_LIBRARY_PHOTO_SOURCE_COLLECTION, LibraryPhotoSourceCollection);
#line 4733 "../src/Photo.vala"
	g_return_if_fail (G_TYPE_CHECK_INSTANCE_TYPE (media_sources, GEE_TYPE_COLLECTION));
#line 4734 "../src/Photo.vala"
	_tmp0_ = gee_hash_multi_map_new (TYPE_TAG, (GBoxedCopyFunc) g_object_ref, (GDestroyNotify) g_object_unref, TYPE_LIBRARY_PHOTO, (GBoxedCopyFunc) g_object_ref, (GDestroyNotify) g_object_unref, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL);
#line 4734 "../src/Photo.vala"
	map = _tmp0_;
#line 36021 "Photo.c"
	{
		GeeIterator* _media_it = NULL;
		GeeIterator* _tmp1_;
#line 4735 "../src/Photo.vala"
		_tmp1_ = gee_iterable_iterator (G_TYPE_CHECK_INSTANCE_CAST (media_sources, GEE_TYPE_ITERABLE, GeeIterable));
#line 4735 "../src/Photo.vala"
		_media_it = _tmp1_;
#line 4735 "../src/Photo.vala"
		while (TRUE) {
#line 36031 "Photo.c"
			GeeIterator* _tmp2_;
			MediaSource* media = NULL;
			GeeIterator* _tmp3_;
			gpointer _tmp4_;
			LibraryPhoto* photo = NULL;
			MediaSource* _tmp5_;
			LibraryPhoto* _tmp6_;
			PhotoMetadata* metadata = NULL;
			LibraryPhoto* _tmp7_;
			PhotoMetadata* _tmp8_;
			HierarchicalTagIndex* global_index = NULL;
			HierarchicalTagIndex* _tmp9_;
			HierarchicalTagIndex* htag_index = NULL;
			gboolean _tmp10_ = FALSE;
			PhotoMetadata* _tmp11_;
			LibraryPhoto* _tmp17_;
			GeeCollection* _tmp18_;
			GeeCollection* _tmp19_;
			gboolean _tmp20_;
			gboolean _tmp51_ = FALSE;
			PhotoMetadata* _tmp52_;
#line 4735 "../src/Photo.vala"
			_tmp2_ = _media_it;
#line 4735 "../src/Photo.vala"
			if (!gee_iterator_next (_tmp2_)) {
#line 4735 "../src/Photo.vala"
				break;
#line 36059 "Photo.c"
			}
#line 4735 "../src/Photo.vala"
			_tmp3_ = _media_it;
#line 4735 "../src/Photo.vala"
			_tmp4_ = gee_iterator_get (_tmp3_);
#line 4735 "../src/Photo.vala"
			media = (MediaSource*) _tmp4_;
#line 4736 "../src/Photo.vala"
			_tmp5_ = media;
#line 4736 "../src/Photo.vala"
			_tmp6_ = _g_object_ref0 (G_TYPE_CHECK_INSTANCE_CAST (_tmp5_, TYPE_LIBRARY_PHOTO, LibraryPhoto));
#line 4736 "../src/Photo.vala"
			photo = _tmp6_;
#line 4737 "../src/Photo.vala"
			_tmp7_ = photo;
#line 4737 "../src/Photo.vala"
			_tmp8_ = photo_source_get_metadata (G_TYPE_CHECK_INSTANCE_CAST (_tmp7_, TYPE_PHOTO_SOURCE, PhotoSource));
#line 4737 "../src/Photo.vala"
			metadata = _tmp8_;
#line 4740 "../src/Photo.vala"
			_tmp9_ = hierarchical_tag_index_get_global_index ();
#line 4740 "../src/Photo.vala"
			global_index = _tmp9_;
#line 4747 "../src/Photo.vala"
			htag_index = NULL;
#line 4748 "../src/Photo.vala"
			_tmp11_ = metadata;
#line 4748 "../src/Photo.vala"
			if (_tmp11_ != NULL) {
#line 36089 "Photo.c"
				PhotoMetadata* _tmp12_;
#line 4748 "../src/Photo.vala"
				_tmp12_ = metadata;
#line 4748 "../src/Photo.vala"
				_tmp10_ = photo_metadata_has_hierarchical_keywords (_tmp12_);
#line 36095 "Photo.c"
			} else {
#line 4748 "../src/Photo.vala"
				_tmp10_ = FALSE;
#line 36099 "Photo.c"
			}
#line 4748 "../src/Photo.vala"
			if (_tmp10_) {
#line 36103 "Photo.c"
				PhotoMetadata* _tmp13_;
				GeeSet* _tmp14_;
				GeeSet* _tmp15_;
				HierarchicalTagIndex* _tmp16_;
#line 4749 "../src/Photo.vala"
				_tmp13_ = metadata;
#line 4749 "../src/Photo.vala"
				_tmp14_ = photo_metadata_get_hierarchical_keywords (_tmp13_);
#line 4749 "../src/Photo.vala"
				_tmp15_ = _tmp14_;
#line 4749 "../src/Photo.vala"
				_tmp16_ = hierarchical_tag_utilities_process_hierarchical_import_keywords (G_TYPE_CHECK_INSTANCE_CAST (_tmp15_, GEE_TYPE_COLLECTION, GeeCollection));
#line 4749 "../src/Photo.vala"
				_hierarchical_tag_index_unref0 (htag_index);
#line 4749 "../src/Photo.vala"
				htag_index = _tmp16_;
#line 4749 "../src/Photo.vala"
				_g_object_unref0 (_tmp15_);
#line 36122 "Photo.c"
			}
#line 4753 "../src/Photo.vala"
			_tmp17_ = photo;
#line 4753 "../src/Photo.vala"
			_tmp18_ = library_photo_get_import_keywords (_tmp17_);
#line 4753 "../src/Photo.vala"
			_tmp19_ = _tmp18_;
#line 4753 "../src/Photo.vala"
			_tmp20_ = _tmp19_ != NULL;
#line 4753 "../src/Photo.vala"
			_g_object_unref0 (_tmp19_);
#line 4753 "../src/Photo.vala"
			if (_tmp20_) {
#line 36136 "Photo.c"
				{
					GeeIterator* _keyword_it = NULL;
					LibraryPhoto* _tmp21_;
					GeeCollection* _tmp22_;
					GeeCollection* _tmp23_;
					GeeIterator* _tmp24_;
					GeeIterator* _tmp25_;
#line 4754 "../src/Photo.vala"
					_tmp21_ = photo;
#line 4754 "../src/Photo.vala"
					_tmp22_ = library_photo_get_import_keywords (_tmp21_);
#line 4754 "../src/Photo.vala"
					_tmp23_ = _tmp22_;
#line 4754 "../src/Photo.vala"
					_tmp24_ = gee_iterable_iterator (G_TYPE_CHECK_INSTANCE_CAST (_tmp23_, GEE_TYPE_ITERABLE, GeeIterable));
#line 4754 "../src/Photo.vala"
					_tmp25_ = _tmp24_;
#line 4754 "../src/Photo.vala"
					_g_object_unref0 (_tmp23_);
#line 4754 "../src/Photo.vala"
					_keyword_it = _tmp25_;
#line 4754 "../src/Photo.vala"
					while (TRUE) {
#line 36160 "Photo.c"
						GeeIterator* _tmp26_;
						gchar* keyword = NULL;
						GeeIterator* _tmp27_;
						gpointer _tmp28_;
						gboolean _tmp29_ = FALSE;
						HierarchicalTagIndex* _tmp30_;
						gchar* name = NULL;
						const gchar* _tmp33_;
						gchar* _tmp34_;
						HierarchicalTagIndex* _tmp35_;
						const gchar* _tmp36_;
						const gchar* _tmp45_;
#line 4754 "../src/Photo.vala"
						_tmp26_ = _keyword_it;
#line 4754 "../src/Photo.vala"
						if (!gee_iterator_next (_tmp26_)) {
#line 4754 "../src/Photo.vala"
							break;
#line 36179 "Photo.c"
						}
#line 4754 "../src/Photo.vala"
						_tmp27_ = _keyword_it;
#line 4754 "../src/Photo.vala"
						_tmp28_ = gee_iterator_get (_tmp27_);
#line 4754 "../src/Photo.vala"
						keyword = (gchar*) _tmp28_;
#line 4755 "../src/Photo.vala"
						_tmp30_ = htag_index;
#line 4755 "../src/Photo.vala"
						if (_tmp30_ != NULL) {
#line 36191 "Photo.c"
							HierarchicalTagIndex* _tmp31_;
							const gchar* _tmp32_;
#line 4755 "../src/Photo.vala"
							_tmp31_ = htag_index;
#line 4755 "../src/Photo.vala"
							_tmp32_ = keyword;
#line 4755 "../src/Photo.vala"
							_tmp29_ = hierarchical_tag_index_is_tag_in_index (_tmp31_, _tmp32_);
#line 36200 "Photo.c"
						} else {
#line 4755 "../src/Photo.vala"
							_tmp29_ = FALSE;
#line 36204 "Photo.c"
						}
#line 4755 "../src/Photo.vala"
						if (_tmp29_) {
#line 4756 "../src/Photo.vala"
							_g_free0 (keyword);
#line 4756 "../src/Photo.vala"
							continue;
#line 36212 "Photo.c"
						}
#line 4758 "../src/Photo.vala"
						_tmp33_ = keyword;
#line 4758 "../src/Photo.vala"
						_tmp34_ = tag_prep_tag_name (_tmp33_);
#line 4758 "../src/Photo.vala"
						name = _tmp34_;
#line 4760 "../src/Photo.vala"
						_tmp35_ = global_index;
#line 4760 "../src/Photo.vala"
						_tmp36_ = name;
#line 4760 "../src/Photo.vala"
						if (hierarchical_tag_index_is_tag_in_index (_tmp35_, _tmp36_)) {
#line 36226 "Photo.c"
							gchar* most_derived_path = NULL;
							HierarchicalTagIndex* _tmp37_;
							const gchar* _tmp38_;
							gchar* _tmp39_;
							GeeHashMultiMap* _tmp40_;
							const gchar* _tmp41_;
							Tag* _tmp42_;
							Tag* _tmp43_;
							LibraryPhoto* _tmp44_;
#line 4761 "../src/Photo.vala"
							_tmp37_ = global_index;
#line 4761 "../src/Photo.vala"
							_tmp38_ = name;
#line 4761 "../src/Photo.vala"
							_tmp39_ = hierarchical_tag_index_get_path_for_name (_tmp37_, _tmp38_);
#line 4761 "../src/Photo.vala"
							most_derived_path = _tmp39_;
#line 4762 "../src/Photo.vala"
							_tmp40_ = map;
#line 4762 "../src/Photo.vala"
							_tmp41_ = most_derived_path;
#line 4762 "../src/Photo.vala"
							_tmp42_ = tag_for_path (_tmp41_);
#line 4762 "../src/Photo.vala"
							_tmp43_ = _tmp42_;
#line 4762 "../src/Photo.vala"
							_tmp44_ = photo;
#line 4762 "../src/Photo.vala"
							gee_multi_map_set (G_TYPE_CHECK_INSTANCE_CAST (_tmp40_, GEE_TYPE_MULTI_MAP, GeeMultiMap), _tmp43_, _tmp44_);
#line 4762 "../src/Photo.vala"
							_g_object_unref0 (_tmp43_);
#line 4763 "../src/Photo.vala"
							_g_free0 (most_derived_path);
#line 4763 "../src/Photo.vala"
							_g_free0 (name);
#line 4763 "../src/Photo.vala"
							_g_free0 (keyword);
#line 4763 "../src/Photo.vala"
							continue;
#line 36266 "Photo.c"
						}
#line 4766 "../src/Photo.vala"
						_tmp45_ = name;
#line 4766 "../src/Photo.vala"
						if (_tmp45_ != NULL) {
#line 36272 "Photo.c"
							GeeHashMultiMap* _tmp46_;
							const gchar* _tmp47_;
							Tag* _tmp48_;
							Tag* _tmp49_;
							LibraryPhoto* _tmp50_;
#line 4767 "../src/Photo.vala"
							_tmp46_ = map;
#line 4767 "../src/Photo.vala"
							_tmp47_ = name;
#line 4767 "../src/Photo.vala"
							_tmp48_ = tag_for_path (_tmp47_);
#line 4767 "../src/Photo.vala"
							_tmp49_ = _tmp48_;
#line 4767 "../src/Photo.vala"
							_tmp50_ = photo;
#line 4767 "../src/Photo.vala"
							gee_multi_map_set (G_TYPE_CHECK_INSTANCE_CAST (_tmp46_, GEE_TYPE_MULTI_MAP, GeeMultiMap), _tmp49_, _tmp50_);
#line 4767 "../src/Photo.vala"
							_g_object_unref0 (_tmp49_);
#line 36292 "Photo.c"
						}
#line 4754 "../src/Photo.vala"
						_g_free0 (name);
#line 4754 "../src/Photo.vala"
						_g_free0 (keyword);
#line 36298 "Photo.c"
					}
#line 4754 "../src/Photo.vala"
					_g_object_unref0 (_keyword_it);
#line 36302 "Photo.c"
				}
			}
#line 4771 "../src/Photo.vala"
			_tmp52_ = metadata;
#line 4771 "../src/Photo.vala"
			if (_tmp52_ != NULL) {
#line 36309 "Photo.c"
				PhotoMetadata* _tmp53_;
#line 4771 "../src/Photo.vala"
				_tmp53_ = metadata;
#line 4771 "../src/Photo.vala"
				_tmp51_ = photo_metadata_has_hierarchical_keywords (_tmp53_);
#line 36315 "Photo.c"
			} else {
#line 4771 "../src/Photo.vala"
				_tmp51_ = FALSE;
#line 36319 "Photo.c"
			}
#line 4771 "../src/Photo.vala"
			if (_tmp51_) {
#line 36323 "Photo.c"
				{
					GeeIterator* _path_it = NULL;
					HierarchicalTagIndex* _tmp54_;
					GeeCollection* _tmp55_;
					GeeCollection* _tmp56_;
					GeeIterator* _tmp57_;
					GeeIterator* _tmp58_;
#line 4772 "../src/Photo.vala"
					_tmp54_ = htag_index;
#line 4772 "../src/Photo.vala"
					_tmp55_ = hierarchical_tag_index_get_all_paths (_tmp54_);
#line 4772 "../src/Photo.vala"
					_tmp56_ = _tmp55_;
#line 4772 "../src/Photo.vala"
					_tmp57_ = gee_iterable_iterator (G_TYPE_CHECK_INSTANCE_CAST (_tmp56_, GEE_TYPE_ITERABLE, GeeIterable));
#line 4772 "../src/Photo.vala"
					_tmp58_ = _tmp57_;
#line 4772 "../src/Photo.vala"
					_g_object_unref0 (_tmp56_);
#line 4772 "../src/Photo.vala"
					_path_it = _tmp58_;
#line 4772 "../src/Photo.vala"
					while (TRUE) {
#line 36347 "Photo.c"
						GeeIterator* _tmp59_;
						gchar* path = NULL;
						GeeIterator* _tmp60_;
						gpointer _tmp61_;
						gchar* name = NULL;
						const gchar* _tmp62_;
						gchar* _tmp63_;
						const gchar* _tmp64_;
#line 4772 "../src/Photo.vala"
						_tmp59_ = _path_it;
#line 4772 "../src/Photo.vala"
						if (!gee_iterator_next (_tmp59_)) {
#line 4772 "../src/Photo.vala"
							break;
#line 36362 "Photo.c"
						}
#line 4772 "../src/Photo.vala"
						_tmp60_ = _path_it;
#line 4772 "../src/Photo.vala"
						_tmp61_ = gee_iterator_get (_tmp60_);
#line 4772 "../src/Photo.vala"
						path = (gchar*) _tmp61_;
#line 4773 "../src/Photo.vala"
						_tmp62_ = path;
#line 4773 "../src/Photo.vala"
						_tmp63_ = tag_prep_tag_name (_tmp62_);
#line 4773 "../src/Photo.vala"
						name = _tmp63_;
#line 4774 "../src/Photo.vala"
						_tmp64_ = name;
#line 4774 "../src/Photo.vala"
						if (_tmp64_ != NULL) {
#line 36380 "Photo.c"
							GeeHashMultiMap* _tmp65_;
							const gchar* _tmp66_;
							Tag* _tmp67_;
							Tag* _tmp68_;
							LibraryPhoto* _tmp69_;
#line 4775 "../src/Photo.vala"
							_tmp65_ = map;
#line 4775 "../src/Photo.vala"
							_tmp66_ = name;
#line 4775 "../src/Photo.vala"
							_tmp67_ = tag_for_path (_tmp66_);
#line 4775 "../src/Photo.vala"
							_tmp68_ = _tmp67_;
#line 4775 "../src/Photo.vala"
							_tmp69_ = photo;
#line 4775 "../src/Photo.vala"
							gee_multi_map_set (G_TYPE_CHECK_INSTANCE_CAST (_tmp65_, GEE_TYPE_MULTI_MAP, GeeMultiMap), _tmp68_, _tmp69_);
#line 4775 "../src/Photo.vala"
							_g_object_unref0 (_tmp68_);
#line 36400 "Photo.c"
						}
#line 4772 "../src/Photo.vala"
						_g_free0 (name);
#line 4772 "../src/Photo.vala"
						_g_free0 (path);
#line 36406 "Photo.c"
					}
#line 4772 "../src/Photo.vala"
					_g_object_unref0 (_path_it);
#line 36410 "Photo.c"
				}
			}
#line 4735 "../src/Photo.vala"
			_hierarchical_tag_index_unref0 (htag_index);
#line 4735 "../src/Photo.vala"
			_hierarchical_tag_index_unref0 (global_index);
#line 4735 "../src/Photo.vala"
			_media_metadata_unref0 (metadata);
#line 4735 "../src/Photo.vala"
			_g_object_unref0 (photo);
#line 4735 "../src/Photo.vala"
			_g_object_unref0 (media);
#line 36423 "Photo.c"
		}
#line 4735 "../src/Photo.vala"
		_g_object_unref0 (_media_it);
#line 36427 "Photo.c"
	}
	{
		GeeIterator* _media_it = NULL;
		GeeIterator* _tmp70_;
#line 4780 "../src/Photo.vala"
		_tmp70_ = gee_iterable_iterator (G_TYPE_CHECK_INSTANCE_CAST (media_sources, GEE_TYPE_ITERABLE, GeeIterable));
#line 4780 "../src/Photo.vala"
		_media_it = _tmp70_;
#line 4780 "../src/Photo.vala"
		while (TRUE) {
#line 36438 "Photo.c"
			GeeIterator* _tmp71_;
			MediaSource* media = NULL;
			GeeIterator* _tmp72_;
			gpointer _tmp73_;
			LibraryPhoto* photo = NULL;
			MediaSource* _tmp74_;
			LibraryPhoto* _tmp75_;
			LibraryPhoto* _tmp76_;
#line 4780 "../src/Photo.vala"
			_tmp71_ = _media_it;
#line 4780 "../src/Photo.vala"
			if (!gee_iterator_next (_tmp71_)) {
#line 4780 "../src/Photo.vala"
				break;
#line 36453 "Photo.c"
			}
#line 4780 "../src/Photo.vala"
			_tmp72_ = _media_it;
#line 4780 "../src/Photo.vala"
			_tmp73_ = gee_iterator_get (_tmp72_);
#line 4780 "../src/Photo.vala"
			media = (MediaSource*) _tmp73_;
#line 4781 "../src/Photo.vala"
			_tmp74_ = media;
#line 4781 "../src/Photo.vala"
			_tmp75_ = _g_object_ref0 (G_TYPE_CHECK_INSTANCE_CAST (_tmp74_, TYPE_LIBRARY_PHOTO, LibraryPhoto));
#line 4781 "../src/Photo.vala"
			photo = _tmp75_;
#line 4782 "../src/Photo.vala"
			_tmp76_ = photo;
#line 4782 "../src/Photo.vala"
			library_photo_clear_import_keywords (_tmp76_);
#line 4780 "../src/Photo.vala"
			_g_object_unref0 (photo);
#line 4780 "../src/Photo.vala"
			_g_object_unref0 (media);
#line 36475 "Photo.c"
		}
#line 4780 "../src/Photo.vala"
		_g_object_unref0 (_media_it);
#line 36479 "Photo.c"
	}
	{
		GeeIterator* _tag_it = NULL;
		GeeHashMultiMap* _tmp77_;
		GeeSet* _tmp78_;
		GeeSet* _tmp79_;
		GeeIterator* _tmp80_;
		GeeIterator* _tmp81_;
#line 4785 "../src/Photo.vala"
		_tmp77_ = map;
#line 4785 "../src/Photo.vala"
		_tmp78_ = gee_multi_map_get_keys (G_TYPE_CHECK_INSTANCE_CAST (_tmp77_, GEE_TYPE_MULTI_MAP, GeeMultiMap));
#line 4785 "../src/Photo.vala"
		_tmp79_ = _tmp78_;
#line 4785 "../src/Photo.vala"
		_tmp80_ = gee_iterable_iterator (G_TYPE_CHECK_INSTANCE_CAST (_tmp79_, GEE_TYPE_ITERABLE, GeeIterable));
#line 4785 "../src/Photo.vala"
		_tmp81_ = _tmp80_;
#line 4785 "../src/Photo.vala"
		_g_object_unref0 (_tmp79_);
#line 4785 "../src/Photo.vala"
		_tag_it = _tmp81_;
#line 4785 "../src/Photo.vala"
		while (TRUE) {
#line 36504 "Photo.c"
			GeeIterator* _tmp82_;
			Tag* tag = NULL;
			GeeIterator* _tmp83_;
			gpointer _tmp84_;
			Tag* _tmp85_;
			GeeHashMultiMap* _tmp86_;
			Tag* _tmp87_;
			GeeCollection* _tmp88_;
			GeeCollection* _tmp89_;
#line 4785 "../src/Photo.vala"
			_tmp82_ = _tag_it;
#line 4785 "../src/Photo.vala"
			if (!gee_iterator_next (_tmp82_)) {
#line 4785 "../src/Photo.vala"
				break;
#line 36520 "Photo.c"
			}
#line 4785 "../src/Photo.vala"
			_tmp83_ = _tag_it;
#line 4785 "../src/Photo.vala"
			_tmp84_ = gee_iterator_get (_tmp83_);
#line 4785 "../src/Photo.vala"
			tag = (Tag*) _tmp84_;
#line 4786 "../src/Photo.vala"
			_tmp85_ = tag;
#line 4786 "../src/Photo.vala"
			_tmp86_ = map;
#line 4786 "../src/Photo.vala"
			_tmp87_ = tag;
#line 4786 "../src/Photo.vala"
			_tmp88_ = gee_multi_map_get (G_TYPE_CHECK_INSTANCE_CAST (_tmp86_, GEE_TYPE_MULTI_MAP, GeeMultiMap), _tmp87_);
#line 4786 "../src/Photo.vala"
			_tmp89_ = _tmp88_;
#line 4786 "../src/Photo.vala"
			tag_attach_many (_tmp85_, _tmp89_);
#line 4786 "../src/Photo.vala"
			_g_object_unref0 (_tmp89_);
#line 4785 "../src/Photo.vala"
			_g_object_unref0 (tag);
#line 36544 "Photo.c"
		}
#line 4785 "../src/Photo.vala"
		_g_object_unref0 (_tag_it);
#line 36548 "Photo.c"
	}
#line 4788 "../src/Photo.vala"
	MEDIA_SOURCE_COLLECTION_CLASS (library_photo_source_collection_parent_class)->postprocess_imported_media (G_TYPE_CHECK_INSTANCE_CAST (self, TYPE_MEDIA_SOURCE_COLLECTION, MediaSourceCollection), media_sources);
#line 4733 "../src/Photo.vala"
	_g_object_unref0 (map);
#line 36554 "Photo.c"
}

static void
library_photo_source_collection_real_notify_master_reimported (LibraryPhotoSourceCollection* self,
                                                               LibraryPhoto* photo,
                                                               PhotoMetadata* metadata)
{
#line 4792 "../src/Photo.vala"
	g_return_if_fail (IS_LIBRARY_PHOTO (photo));
#line 4792 "../src/Photo.vala"
	g_return_if_fail ((metadata == NULL) || IS_PHOTO_METADATA (metadata));
#line 4793 "../src/Photo.vala"
	g_signal_emit (self, library_photo_source_collection_signals[LIBRARY_PHOTO_SOURCE_COLLECTION_MASTER_REIMPORTED_SIGNAL], 0, photo, metadata);
#line 36568 "Photo.c"
}

void
library_photo_source_collection_notify_master_reimported (LibraryPhotoSourceCollection* self,
                                                          LibraryPhoto* photo,
                                                          PhotoMetadata* metadata)
{
	LibraryPhotoSourceCollectionClass* _klass_;
#line 4792 "../src/Photo.vala"
	g_return_if_fail (IS_LIBRARY_PHOTO_SOURCE_COLLECTION (self));
#line 4792 "../src/Photo.vala"
	_klass_ = LIBRARY_PHOTO_SOURCE_COLLECTION_GET_CLASS (self);
#line 4792 "../src/Photo.vala"
	if (_klass_->notify_master_reimported) {
#line 4792 "../src/Photo.vala"
		_klass_->notify_master_reimported (self, photo, metadata);
#line 36585 "Photo.c"
	}
}

static void
library_photo_source_collection_real_notify_editable_reimported (LibraryPhotoSourceCollection* self,
                                                                 LibraryPhoto* photo,
                                                                 PhotoMetadata* metadata)
{
#line 4797 "../src/Photo.vala"
	g_return_if_fail (IS_LIBRARY_PHOTO (photo));
#line 4797 "../src/Photo.vala"
	g_return_if_fail ((metadata == NULL) || IS_PHOTO_METADATA (metadata));
#line 4798 "../src/Photo.vala"
	g_signal_emit (self, library_photo_source_collection_signals[LIBRARY_PHOTO_SOURCE_COLLECTION_EDITABLE_REIMPORTED_SIGNAL], 0, photo, metadata);
#line 36600 "Photo.c"
}

void
library_photo_source_collection_notify_editable_reimported (LibraryPhotoSourceCollection* self,
                                                            LibraryPhoto* photo,
                                                            PhotoMetadata* metadata)
{
	LibraryPhotoSourceCollectionClass* _klass_;
#line 4797 "../src/Photo.vala"
	g_return_if_fail (IS_LIBRARY_PHOTO_SOURCE_COLLECTION (self));
#line 4797 "../src/Photo.vala"
	_klass_ = LIBRARY_PHOTO_SOURCE_COLLECTION_GET_CLASS (self);
#line 4797 "../src/Photo.vala"
	if (_klass_->notify_editable_reimported) {
#line 4797 "../src/Photo.vala"
		_klass_->notify_editable_reimported (self, photo, metadata);
#line 36617 "Photo.c"
	}
}

static void
library_photo_source_collection_real_notify_source_reimported (LibraryPhotoSourceCollection* self,
                                                               LibraryPhoto* photo,
                                                               PhotoMetadata* metadata)
{
#line 4802 "../src/Photo.vala"
	g_return_if_fail (IS_LIBRARY_PHOTO (photo));
#line 4802 "../src/Photo.vala"
	g_return_if_fail ((metadata == NULL) || IS_PHOTO_METADATA (metadata));
#line 4803 "../src/Photo.vala"
	g_signal_emit (self, library_photo_source_collection_signals[LIBRARY_PHOTO_SOURCE_COLLECTION_SOURCE_REIMPORTED_SIGNAL], 0, photo, metadata);
#line 36632 "Photo.c"
}

void
library_photo_source_collection_notify_source_reimported (LibraryPhotoSourceCollection* self,
                                                          LibraryPhoto* photo,
                                                          PhotoMetadata* metadata)
{
	LibraryPhotoSourceCollectionClass* _klass_;
#line 4802 "../src/Photo.vala"
	g_return_if_fail (IS_LIBRARY_PHOTO_SOURCE_COLLECTION (self));
#line 4802 "../src/Photo.vala"
	_klass_ = LIBRARY_PHOTO_SOURCE_COLLECTION_GET_CLASS (self);
#line 4802 "../src/Photo.vala"
	if (_klass_->notify_source_reimported) {
#line 4802 "../src/Photo.vala"
		_klass_->notify_source_reimported (self, photo, metadata);
#line 36649 "Photo.c"
	}
}

static void
library_photo_source_collection_real_notify_baseline_reimported (LibraryPhotoSourceCollection* self,
                                                                 LibraryPhoto* photo,
                                                                 PhotoMetadata* metadata)
{
#line 4807 "../src/Photo.vala"
	g_return_if_fail (IS_LIBRARY_PHOTO (photo));
#line 4807 "../src/Photo.vala"
	g_return_if_fail ((metadata == NULL) || IS_PHOTO_METADATA (metadata));
#line 4808 "../src/Photo.vala"
	g_signal_emit (self, library_photo_source_collection_signals[LIBRARY_PHOTO_SOURCE_COLLECTION_BASELINE_REIMPORTED_SIGNAL], 0, photo, metadata);
#line 36664 "Photo.c"
}

void
library_photo_source_collection_notify_baseline_reimported (LibraryPhotoSourceCollection* self,
                                                            LibraryPhoto* photo,
                                                            PhotoMetadata* metadata)
{
	LibraryPhotoSourceCollectionClass* _klass_;
#line 4807 "../src/Photo.vala"
	g_return_if_fail (IS_LIBRARY_PHOTO_SOURCE_COLLECTION (self));
#line 4807 "../src/Photo.vala"
	_klass_ = LIBRARY_PHOTO_SOURCE_COLLECTION_GET_CLASS (self);
#line 4807 "../src/Photo.vala"
	if (_klass_->notify_baseline_reimported) {
#line 4807 "../src/Photo.vala"
		_klass_->notify_baseline_reimported (self, photo, metadata);
#line 36681 "Photo.c"
	}
}

static MediaSource*
library_photo_source_collection_real_fetch_by_numeric_id (MediaSourceCollection* base,
                                                          gint64 numeric_id)
{
	LibraryPhotoSourceCollection * self;
	PhotoID _tmp0_ = {0};
	LibraryPhoto* _tmp1_;
	MediaSource* result;
#line 4811 "../src/Photo.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (base, TYPE_LIBRARY_PHOTO_SOURCE_COLLECTION, LibraryPhotoSourceCollection);
#line 4812 "../src/Photo.vala"
	photo_id_init (&_tmp0_, numeric_id);
#line 4812 "../src/Photo.vala"
	_tmp1_ = library_photo_source_collection_fetch (self, &_tmp0_);
#line 4812 "../src/Photo.vala"
	result = G_TYPE_CHECK_INSTANCE_CAST (_tmp1_, TYPE_MEDIA_SOURCE, MediaSource);
#line 4812 "../src/Photo.vala"
	return result;
#line 36703 "Photo.c"
}

static void
library_photo_source_collection_on_trashcan_contents_altered (LibraryPhotoSourceCollection* self,
                                                              GeeCollection* added,
                                                              GeeCollection* removed)
{
#line 4815 "../src/Photo.vala"
	g_return_if_fail (IS_LIBRARY_PHOTO_SOURCE_COLLECTION (self));
#line 4815 "../src/Photo.vala"
	g_return_if_fail ((added == NULL) || G_TYPE_CHECK_INSTANCE_TYPE (added, GEE_TYPE_COLLECTION));
#line 4815 "../src/Photo.vala"
	g_return_if_fail ((removed == NULL) || G_TYPE_CHECK_INSTANCE_TYPE (removed, GEE_TYPE_COLLECTION));
#line 4817 "../src/Photo.vala"
	g_signal_emit_by_name (G_TYPE_CHECK_INSTANCE_CAST (self, TYPE_MEDIA_SOURCE_COLLECTION, MediaSourceCollection), "trashcan-contents-altered", G_TYPE_CHECK_INSTANCE_CAST (added, GEE_TYPE_COLLECTION, GeeCollection), G_TYPE_CHECK_INSTANCE_CAST (removed, GEE_TYPE_COLLECTION, GeeCollection));
#line 36719 "Photo.c"
}

static gboolean
library_photo_source_collection_check_if_trashed_photo (LibraryPhotoSourceCollection* self,
                                                        DataSource* source,
                                                        Alteration* alteration)
{
	gboolean result;
#line 4821 "../src/Photo.vala"
	g_return_val_if_fail (IS_LIBRARY_PHOTO_SOURCE_COLLECTION (self), FALSE);
#line 4821 "../src/Photo.vala"
	g_return_val_if_fail (IS_DATA_SOURCE (source), FALSE);
#line 4821 "../src/Photo.vala"
	g_return_val_if_fail (IS_ALTERATION (alteration), FALSE);
#line 4822 "../src/Photo.vala"
	result = media_source_is_trashed (G_TYPE_CHECK_INSTANCE_CAST (G_TYPE_CHECK_INSTANCE_CAST (source, TYPE_LIBRARY_PHOTO, LibraryPhoto), TYPE_MEDIA_SOURCE, MediaSource));
#line 4822 "../src/Photo.vala"
	return result;
#line 36738 "Photo.c"
}

static void
library_photo_source_collection_on_offline_contents_altered (LibraryPhotoSourceCollection* self,
                                                             GeeCollection* added,
                                                             GeeCollection* removed)
{
#line 4825 "../src/Photo.vala"
	g_return_if_fail (IS_LIBRARY_PHOTO_SOURCE_COLLECTION (self));
#line 4825 "../src/Photo.vala"
	g_return_if_fail ((added == NULL) || G_TYPE_CHECK_INSTANCE_TYPE (added, GEE_TYPE_COLLECTION));
#line 4825 "../src/Photo.vala"
	g_return_if_fail ((removed == NULL) || G_TYPE_CHECK_INSTANCE_TYPE (removed, GEE_TYPE_COLLECTION));
#line 4827 "../src/Photo.vala"
	g_signal_emit_by_name (G_TYPE_CHECK_INSTANCE_CAST (self, TYPE_MEDIA_SOURCE_COLLECTION, MediaSourceCollection), "offline-contents-altered", G_TYPE_CHECK_INSTANCE_CAST (added, GEE_TYPE_COLLECTION, GeeCollection), G_TYPE_CHECK_INSTANCE_CAST (removed, GEE_TYPE_COLLECTION, GeeCollection));
#line 36754 "Photo.c"
}

static gboolean
library_photo_source_collection_check_if_offline_photo (LibraryPhotoSourceCollection* self,
                                                        DataSource* source,
                                                        Alteration* alteration)
{
	gboolean result;
#line 4831 "../src/Photo.vala"
	g_return_val_if_fail (IS_LIBRARY_PHOTO_SOURCE_COLLECTION (self), FALSE);
#line 4831 "../src/Photo.vala"
	g_return_val_if_fail (IS_DATA_SOURCE (source), FALSE);
#line 4831 "../src/Photo.vala"
	g_return_val_if_fail (IS_ALTERATION (alteration), FALSE);
#line 4832 "../src/Photo.vala"
	result = media_source_is_offline (G_TYPE_CHECK_INSTANCE_CAST (G_TYPE_CHECK_INSTANCE_CAST (source, TYPE_LIBRARY_PHOTO, LibraryPhoto), TYPE_MEDIA_SOURCE, MediaSource));
#line 4832 "../src/Photo.vala"
	return result;
#line 36773 "Photo.c"
}

static glong
string_strnlen (gchar* str,
                glong maxlen)
{
	gchar* end = NULL;
	gchar* _tmp0_;
	gchar* _tmp1_;
	glong result;
#line 1501 "glib-2.0.vapi"
	_tmp0_ = memchr (str, 0, (gsize) maxlen);
#line 1501 "glib-2.0.vapi"
	end = _tmp0_;
#line 1502 "glib-2.0.vapi"
	_tmp1_ = end;
#line 1502 "glib-2.0.vapi"
	if (_tmp1_ == NULL) {
#line 1503 "glib-2.0.vapi"
		result = maxlen;
#line 1503 "glib-2.0.vapi"
		return result;
#line 36796 "Photo.c"
	} else {
		gchar* _tmp2_;
#line 1505 "glib-2.0.vapi"
		_tmp2_ = end;
#line 1505 "glib-2.0.vapi"
		result = (glong) (_tmp2_ - str);
#line 1505 "glib-2.0.vapi"
		return result;
#line 36805 "Photo.c"
	}
}

static gchar*
string_substring (const gchar* self,
                  glong offset,
                  glong len)
{
	glong string_length = 0L;
	gboolean _tmp0_ = FALSE;
	gchar* _tmp3_;
	gchar* result;
#line 1512 "glib-2.0.vapi"
	g_return_val_if_fail (self != NULL, NULL);
#line 1514 "glib-2.0.vapi"
	if (offset >= ((glong) 0)) {
#line 1514 "glib-2.0.vapi"
		_tmp0_ = len >= ((glong) 0);
#line 36824 "Photo.c"
	} else {
#line 1514 "glib-2.0.vapi"
		_tmp0_ = FALSE;
#line 36828 "Photo.c"
	}
#line 1514 "glib-2.0.vapi"
	if (_tmp0_) {
#line 1516 "glib-2.0.vapi"
		string_length = string_strnlen ((gchar*) self, offset + len);
#line 36834 "Photo.c"
	} else {
		gint _tmp1_;
		gint _tmp2_;
#line 1518 "glib-2.0.vapi"
		_tmp1_ = strlen (self);
#line 1518 "glib-2.0.vapi"
		_tmp2_ = _tmp1_;
#line 1518 "glib-2.0.vapi"
		string_length = (glong) _tmp2_;
#line 36844 "Photo.c"
	}
#line 1521 "glib-2.0.vapi"
	if (offset < ((glong) 0)) {
#line 1522 "glib-2.0.vapi"
		offset = string_length + offset;
#line 1523 "glib-2.0.vapi"
		g_return_val_if_fail (offset >= ((glong) 0), NULL);
#line 36852 "Photo.c"
	} else {
#line 1525 "glib-2.0.vapi"
		g_return_val_if_fail (offset <= string_length, NULL);
#line 36856 "Photo.c"
	}
#line 1527 "glib-2.0.vapi"
	if (len < ((glong) 0)) {
#line 1528 "glib-2.0.vapi"
		len = string_length - offset;
#line 36862 "Photo.c"
	}
#line 1530 "glib-2.0.vapi"
	g_return_val_if_fail ((offset + len) <= string_length, NULL);
#line 1531 "glib-2.0.vapi"
	_tmp3_ = g_strndup (((gchar*) self) + offset, (gsize) len);
#line 1531 "glib-2.0.vapi"
	result = _tmp3_;
#line 1531 "glib-2.0.vapi"
	return result;
#line 36872 "Photo.c"
}

static gint64
int64_parse (const gchar* str,
             guint _base)
{
	gint64 result;
#line 778 "glib-2.0.vapi"
	g_return_val_if_fail (str != NULL, 0LL);
#line 779 "glib-2.0.vapi"
	result = g_ascii_strtoll (str, NULL, _base);
#line 779 "glib-2.0.vapi"
	return result;
#line 36886 "Photo.c"
}

static MediaSource*
library_photo_source_collection_real_fetch_by_source_id (MediaSourceCollection* base,
                                                         const gchar* source_id)
{
	LibraryPhotoSourceCollection * self;
	gchar* numeric_only = NULL;
	gint _tmp0_;
	gint _tmp1_;
	gchar* _tmp2_;
	MediaSource* _tmp3_;
	MediaSource* result;
#line 4835 "../src/Photo.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (base, TYPE_LIBRARY_PHOTO_SOURCE_COLLECTION, LibraryPhotoSourceCollection);
#line 4835 "../src/Photo.vala"
	g_return_val_if_fail (source_id != NULL, NULL);
#line 4836 "../src/Photo.vala"
	_vala_assert (g_str_has_prefix (source_id, PHOTO_TYPENAME), "source_id.has_prefix(Photo.TYPENAME)");
#line 4837 "../src/Photo.vala"
	_tmp0_ = strlen (PHOTO_TYPENAME);
#line 4837 "../src/Photo.vala"
	_tmp1_ = _tmp0_;
#line 4837 "../src/Photo.vala"
	_tmp2_ = string_substring (source_id, (glong) _tmp1_, (glong) -1);
#line 4837 "../src/Photo.vala"
	numeric_only = _tmp2_;
#line 4839 "../src/Photo.vala"
	_tmp3_ = media_source_collection_fetch_by_numeric_id (G_TYPE_CHECK_INSTANCE_CAST (self, TYPE_MEDIA_SOURCE_COLLECTION, MediaSourceCollection), int64_parse (numeric_only, (guint) 16));
#line 4839 "../src/Photo.vala"
	result = _tmp3_;
#line 4839 "../src/Photo.vala"
	_g_free0 (numeric_only);
#line 4839 "../src/Photo.vala"
	return result;
#line 36922 "Photo.c"
}

static GeeCollection*
library_photo_source_collection_real_get_event_source_ids (MediaSourceCollection* base,
                                                           EventID* event_id)
{
	LibraryPhotoSourceCollection * self;
	PhotoTable* _tmp0_;
	PhotoTable* _tmp1_;
	EventID _tmp2_;
	GeeArrayList* _tmp3_;
	GeeCollection* _tmp4_;
	GeeCollection* result;
#line 4842 "../src/Photo.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (base, TYPE_LIBRARY_PHOTO_SOURCE_COLLECTION, LibraryPhotoSourceCollection);
#line 4842 "../src/Photo.vala"
	g_return_val_if_fail (event_id != NULL, NULL);
#line 4843 "../src/Photo.vala"
	_tmp0_ = photo_table_get_instance ();
#line 4843 "../src/Photo.vala"
	_tmp1_ = _tmp0_;
#line 4843 "../src/Photo.vala"
	_tmp2_ = *event_id;
#line 4843 "../src/Photo.vala"
	_tmp3_ = photo_table_get_event_source_ids (_tmp1_, &_tmp2_);
#line 4843 "../src/Photo.vala"
	_tmp4_ = G_TYPE_CHECK_INSTANCE_CAST (_tmp3_, GEE_TYPE_COLLECTION, GeeCollection);
#line 4843 "../src/Photo.vala"
	_database_table_unref0 (_tmp1_);
#line 4843 "../src/Photo.vala"
	result = _tmp4_;
#line 4843 "../src/Photo.vala"
	return result;
#line 36956 "Photo.c"
}

LibraryPhoto*
library_photo_source_collection_fetch (LibraryPhotoSourceCollection* self,
                                       PhotoID* photo_id)
{
	PhotoID _tmp0_;
	DataSource* _tmp1_;
	LibraryPhoto* result;
#line 4846 "../src/Photo.vala"
	g_return_val_if_fail (IS_LIBRARY_PHOTO_SOURCE_COLLECTION (self), NULL);
#line 4846 "../src/Photo.vala"
	g_return_val_if_fail (photo_id != NULL, NULL);
#line 4847 "../src/Photo.vala"
	_tmp0_ = *photo_id;
#line 4847 "../src/Photo.vala"
	_tmp1_ = database_source_collection_fetch_by_key (G_TYPE_CHECK_INSTANCE_CAST (self, TYPE_DATABASE_SOURCE_COLLECTION, DatabaseSourceCollection), _tmp0_.id);
#line 4847 "../src/Photo.vala"
	result = G_TYPE_CHECK_INSTANCE_CAST (_tmp1_, TYPE_LIBRARY_PHOTO, LibraryPhoto);
#line 4847 "../src/Photo.vala"
	return result;
#line 36978 "Photo.c"
}

LibraryPhoto*
library_photo_source_collection_fetch_by_editable_file (LibraryPhotoSourceCollection* self,
                                                        GFile* file)
{
	GeeHashMap* _tmp0_;
	gpointer _tmp1_;
	LibraryPhoto* result;
#line 4850 "../src/Photo.vala"
	g_return_val_if_fail (IS_LIBRARY_PHOTO_SOURCE_COLLECTION (self), NULL);
#line 4850 "../src/Photo.vala"
	g_return_val_if_fail (G_TYPE_CHECK_INSTANCE_TYPE (file, g_file_get_type ()), NULL);
#line 4851 "../src/Photo.vala"
	_tmp0_ = self->priv->by_editable_file;
#line 4851 "../src/Photo.vala"
	_tmp1_ = gee_abstract_map_get (G_TYPE_CHECK_INSTANCE_CAST (_tmp0_, GEE_TYPE_ABSTRACT_MAP, GeeAbstractMap), file);
#line 4851 "../src/Photo.vala"
	result = (LibraryPhoto*) _tmp1_;
#line 4851 "../src/Photo.vala"
	return result;
#line 37000 "Photo.c"
}

LibraryPhoto*
library_photo_source_collection_fetch_by_raw_development_file (LibraryPhotoSourceCollection* self,
                                                               GFile* file)
{
	GeeHashMap* _tmp0_;
	gpointer _tmp1_;
	LibraryPhoto* result;
#line 4854 "../src/Photo.vala"
	g_return_val_if_fail (IS_LIBRARY_PHOTO_SOURCE_COLLECTION (self), NULL);
#line 4854 "../src/Photo.vala"
	g_return_val_if_fail (G_TYPE_CHECK_INSTANCE_TYPE (file, g_file_get_type ()), NULL);
#line 4855 "../src/Photo.vala"
	_tmp0_ = self->priv->by_raw_development_file;
#line 4855 "../src/Photo.vala"
	_tmp1_ = gee_abstract_map_get (G_TYPE_CHECK_INSTANCE_CAST (_tmp0_, GEE_TYPE_ABSTRACT_MAP, GeeAbstractMap), file);
#line 4855 "../src/Photo.vala"
	result = (LibraryPhoto*) _tmp1_;
#line 4855 "../src/Photo.vala"
	return result;
#line 37022 "Photo.c"
}

static void
library_photo_source_collection_compare_backing (LibraryPhotoSourceCollection* self,
                                                 LibraryPhoto* photo,
                                                 GFileInfo* info,
                                                 GeeCollection* matches_master,
                                                 GeeCollection* matches_editable,
                                                 GeeCollection* matches_development)
{
	BackingPhotoRow* _tmp0_;
	BackingPhotoRow* _tmp1_;
	gboolean _tmp2_;
	BackingPhotoRow* editable = NULL;
	BackingPhotoRow* _tmp3_;
	gboolean _tmp4_ = FALSE;
	BackingPhotoRow* _tmp5_;
	GeeCollection* development = NULL;
	GeeCollection* _tmp7_;
	GeeCollection* _tmp8_;
#line 4858 "../src/Photo.vala"
	g_return_if_fail (IS_LIBRARY_PHOTO_SOURCE_COLLECTION (self));
#line 4858 "../src/Photo.vala"
	g_return_if_fail (IS_LIBRARY_PHOTO (photo));
#line 4858 "../src/Photo.vala"
	g_return_if_fail (G_TYPE_CHECK_INSTANCE_TYPE (info, g_file_info_get_type ()));
#line 4858 "../src/Photo.vala"
	g_return_if_fail (G_TYPE_CHECK_INSTANCE_TYPE (matches_master, GEE_TYPE_COLLECTION));
#line 4858 "../src/Photo.vala"
	g_return_if_fail (G_TYPE_CHECK_INSTANCE_TYPE (matches_editable, GEE_TYPE_COLLECTION));
#line 4858 "../src/Photo.vala"
	g_return_if_fail (G_TYPE_CHECK_INSTANCE_TYPE (matches_development, GEE_TYPE_COLLECTION));
#line 4861 "../src/Photo.vala"
	_tmp0_ = photo_get_master_photo_row (G_TYPE_CHECK_INSTANCE_CAST (photo, TYPE_PHOTO, Photo));
#line 4861 "../src/Photo.vala"
	_tmp1_ = _tmp0_;
#line 4861 "../src/Photo.vala"
	_tmp2_ = backing_photo_row_matches_file_info (_tmp1_, info);
#line 4861 "../src/Photo.vala"
	_backing_photo_row_unref0 (_tmp1_);
#line 4861 "../src/Photo.vala"
	if (_tmp2_) {
#line 4862 "../src/Photo.vala"
		gee_collection_add (matches_master, photo);
#line 37067 "Photo.c"
	}
#line 4864 "../src/Photo.vala"
	_tmp3_ = photo_get_editable_photo_row (G_TYPE_CHECK_INSTANCE_CAST (photo, TYPE_PHOTO, Photo));
#line 4864 "../src/Photo.vala"
	editable = _tmp3_;
#line 4865 "../src/Photo.vala"
	_tmp5_ = editable;
#line 4865 "../src/Photo.vala"
	if (_tmp5_ != NULL) {
#line 37077 "Photo.c"
		BackingPhotoRow* _tmp6_;
#line 4865 "../src/Photo.vala"
		_tmp6_ = editable;
#line 4865 "../src/Photo.vala"
		_tmp4_ = backing_photo_row_matches_file_info (_tmp6_, info);
#line 37083 "Photo.c"
	} else {
#line 4865 "../src/Photo.vala"
		_tmp4_ = FALSE;
#line 37087 "Photo.c"
	}
#line 4865 "../src/Photo.vala"
	if (_tmp4_) {
#line 4866 "../src/Photo.vala"
		gee_collection_add (matches_editable, photo);
#line 37093 "Photo.c"
	}
#line 4868 "../src/Photo.vala"
	_tmp7_ = photo_get_raw_development_photo_rows (G_TYPE_CHECK_INSTANCE_CAST (photo, TYPE_PHOTO, Photo));
#line 4868 "../src/Photo.vala"
	development = _tmp7_;
#line 4869 "../src/Photo.vala"
	_tmp8_ = development;
#line 4869 "../src/Photo.vala"
	if (_tmp8_ != NULL) {
#line 37103 "Photo.c"
		{
			GeeIterator* _row_it = NULL;
			GeeCollection* _tmp9_;
			GeeIterator* _tmp10_;
#line 4870 "../src/Photo.vala"
			_tmp9_ = development;
#line 4870 "../src/Photo.vala"
			_tmp10_ = gee_iterable_iterator (G_TYPE_CHECK_INSTANCE_CAST (_tmp9_, GEE_TYPE_ITERABLE, GeeIterable));
#line 4870 "../src/Photo.vala"
			_row_it = _tmp10_;
#line 4870 "../src/Photo.vala"
			while (TRUE) {
#line 37116 "Photo.c"
				GeeIterator* _tmp11_;
				BackingPhotoRow* row = NULL;
				GeeIterator* _tmp12_;
				gpointer _tmp13_;
				BackingPhotoRow* _tmp14_;
#line 4870 "../src/Photo.vala"
				_tmp11_ = _row_it;
#line 4870 "../src/Photo.vala"
				if (!gee_iterator_next (_tmp11_)) {
#line 4870 "../src/Photo.vala"
					break;
#line 37128 "Photo.c"
				}
#line 4870 "../src/Photo.vala"
				_tmp12_ = _row_it;
#line 4870 "../src/Photo.vala"
				_tmp13_ = gee_iterator_get (_tmp12_);
#line 4870 "../src/Photo.vala"
				row = (BackingPhotoRow*) _tmp13_;
#line 4871 "../src/Photo.vala"
				_tmp14_ = row;
#line 4871 "../src/Photo.vala"
				if (backing_photo_row_matches_file_info (_tmp14_, info)) {
#line 4872 "../src/Photo.vala"
					gee_collection_add (matches_development, photo);
#line 4874 "../src/Photo.vala"
					_backing_photo_row_unref0 (row);
#line 4874 "../src/Photo.vala"
					break;
#line 37146 "Photo.c"
				}
#line 4870 "../src/Photo.vala"
				_backing_photo_row_unref0 (row);
#line 37150 "Photo.c"
			}
#line 4870 "../src/Photo.vala"
			_g_object_unref0 (_row_it);
#line 37154 "Photo.c"
		}
	}
#line 4858 "../src/Photo.vala"
	_g_object_unref0 (development);
#line 4858 "../src/Photo.vala"
	_backing_photo_row_unref0 (editable);
#line 37161 "Photo.c"
}

void
library_photo_source_collection_fetch_by_matching_backing (LibraryPhotoSourceCollection* self,
                                                           GFileInfo* info,
                                                           GeeCollection* matches_master,
                                                           GeeCollection* matches_editable,
                                                           GeeCollection* matched_development)
{
#line 4882 "../src/Photo.vala"
	g_return_if_fail (IS_LIBRARY_PHOTO_SOURCE_COLLECTION (self));
#line 4882 "../src/Photo.vala"
	g_return_if_fail (G_TYPE_CHECK_INSTANCE_TYPE (info, g_file_info_get_type ()));
#line 4882 "../src/Photo.vala"
	g_return_if_fail (G_TYPE_CHECK_INSTANCE_TYPE (matches_master, GEE_TYPE_COLLECTION));
#line 4882 "../src/Photo.vala"
	g_return_if_fail (G_TYPE_CHECK_INSTANCE_TYPE (matches_editable, GEE_TYPE_COLLECTION));
#line 4882 "../src/Photo.vala"
	g_return_if_fail (G_TYPE_CHECK_INSTANCE_TYPE (matched_development, GEE_TYPE_COLLECTION));
#line 37181 "Photo.c"
	{
		GeeIterator* _photo_it = NULL;
		GeeMultiMap* _tmp0_;
		gint64 _tmp1_;
		GeeCollection* _tmp2_;
		GeeCollection* _tmp3_;
		GeeIterator* _tmp4_;
		GeeIterator* _tmp5_;
#line 4884 "../src/Photo.vala"
		_tmp0_ = self->priv->filesize_to_photo;
#line 4884 "../src/Photo.vala"
		_tmp1_ = g_file_info_get_size (info);
#line 4884 "../src/Photo.vala"
		_tmp2_ = gee_multi_map_get (_tmp0_, &_tmp1_);
#line 4884 "../src/Photo.vala"
		_tmp3_ = _tmp2_;
#line 4884 "../src/Photo.vala"
		_tmp4_ = gee_iterable_iterator (G_TYPE_CHECK_INSTANCE_CAST (_tmp3_, GEE_TYPE_ITERABLE, GeeIterable));
#line 4884 "../src/Photo.vala"
		_tmp5_ = _tmp4_;
#line 4884 "../src/Photo.vala"
		_g_object_unref0 (_tmp3_);
#line 4884 "../src/Photo.vala"
		_photo_it = _tmp5_;
#line 4884 "../src/Photo.vala"
		while (TRUE) {
#line 37208 "Photo.c"
			GeeIterator* _tmp6_;
			LibraryPhoto* photo = NULL;
			GeeIterator* _tmp7_;
			gpointer _tmp8_;
			LibraryPhoto* _tmp9_;
#line 4884 "../src/Photo.vala"
			_tmp6_ = _photo_it;
#line 4884 "../src/Photo.vala"
			if (!gee_iterator_next (_tmp6_)) {
#line 4884 "../src/Photo.vala"
				break;
#line 37220 "Photo.c"
			}
#line 4884 "../src/Photo.vala"
			_tmp7_ = _photo_it;
#line 4884 "../src/Photo.vala"
			_tmp8_ = gee_iterator_get (_tmp7_);
#line 4884 "../src/Photo.vala"
			photo = (LibraryPhoto*) _tmp8_;
#line 4885 "../src/Photo.vala"
			_tmp9_ = photo;
#line 4885 "../src/Photo.vala"
			library_photo_source_collection_compare_backing (self, _tmp9_, info, matches_master, matches_editable, matched_development);
#line 4884 "../src/Photo.vala"
			_g_object_unref0 (photo);
#line 37234 "Photo.c"
		}
#line 4884 "../src/Photo.vala"
		_g_object_unref0 (_photo_it);
#line 37238 "Photo.c"
	}
	{
		GeeIterator* _media_it = NULL;
		GeeCollection* _tmp10_;
		GeeCollection* _tmp11_;
		GeeIterator* _tmp12_;
		GeeIterator* _tmp13_;
#line 4887 "../src/Photo.vala"
		_tmp10_ = media_source_collection_get_offline_bin_contents (G_TYPE_CHECK_INSTANCE_CAST (self, TYPE_MEDIA_SOURCE_COLLECTION, MediaSourceCollection));
#line 4887 "../src/Photo.vala"
		_tmp11_ = _tmp10_;
#line 4887 "../src/Photo.vala"
		_tmp12_ = gee_iterable_iterator (G_TYPE_CHECK_INSTANCE_CAST (_tmp11_, GEE_TYPE_ITERABLE, GeeIterable));
#line 4887 "../src/Photo.vala"
		_tmp13_ = _tmp12_;
#line 4887 "../src/Photo.vala"
		_g_object_unref0 (_tmp11_);
#line 4887 "../src/Photo.vala"
		_media_it = _tmp13_;
#line 4887 "../src/Photo.vala"
		while (TRUE) {
#line 37260 "Photo.c"
			GeeIterator* _tmp14_;
			MediaSource* media = NULL;
			GeeIterator* _tmp15_;
			gpointer _tmp16_;
			MediaSource* _tmp17_;
#line 4887 "../src/Photo.vala"
			_tmp14_ = _media_it;
#line 4887 "../src/Photo.vala"
			if (!gee_iterator_next (_tmp14_)) {
#line 4887 "../src/Photo.vala"
				break;
#line 37272 "Photo.c"
			}
#line 4887 "../src/Photo.vala"
			_tmp15_ = _media_it;
#line 4887 "../src/Photo.vala"
			_tmp16_ = gee_iterator_get (_tmp15_);
#line 4887 "../src/Photo.vala"
			media = (MediaSource*) _tmp16_;
#line 4888 "../src/Photo.vala"
			_tmp17_ = media;
#line 4888 "../src/Photo.vala"
			library_photo_source_collection_compare_backing (self, G_TYPE_CHECK_INSTANCE_CAST (_tmp17_, TYPE_LIBRARY_PHOTO, LibraryPhoto), info, matches_master, matches_editable, matched_development);
#line 4887 "../src/Photo.vala"
			_g_object_unref0 (media);
#line 37286 "Photo.c"
		}
#line 4887 "../src/Photo.vala"
		_g_object_unref0 (_media_it);
#line 37290 "Photo.c"
	}
}

void
library_photo_source_collection_get_basename_filesize_duplicate (LibraryPhotoSourceCollection* self,
                                                                 const gchar* basename,
                                                                 gint64 filesize,
                                                                 PhotoID* result)
{
	PhotoID _tmp16_ = {0};
#line 4891 "../src/Photo.vala"
	g_return_if_fail (IS_LIBRARY_PHOTO_SOURCE_COLLECTION (self));
#line 4891 "../src/Photo.vala"
	g_return_if_fail (basename != NULL);
#line 37305 "Photo.c"
	{
		GeeIterator* _photo_it = NULL;
		GeeMultiMap* _tmp0_;
		GeeCollection* _tmp1_;
		GeeCollection* _tmp2_;
		GeeIterator* _tmp3_;
		GeeIterator* _tmp4_;
#line 4892 "../src/Photo.vala"
		_tmp0_ = self->priv->filesize_to_photo;
#line 4892 "../src/Photo.vala"
		_tmp1_ = gee_multi_map_get (_tmp0_, &filesize);
#line 4892 "../src/Photo.vala"
		_tmp2_ = _tmp1_;
#line 4892 "../src/Photo.vala"
		_tmp3_ = gee_iterable_iterator (G_TYPE_CHECK_INSTANCE_CAST (_tmp2_, GEE_TYPE_ITERABLE, GeeIterable));
#line 4892 "../src/Photo.vala"
		_tmp4_ = _tmp3_;
#line 4892 "../src/Photo.vala"
		_g_object_unref0 (_tmp2_);
#line 4892 "../src/Photo.vala"
		_photo_it = _tmp4_;
#line 4892 "../src/Photo.vala"
		while (TRUE) {
#line 37329 "Photo.c"
			GeeIterator* _tmp5_;
			LibraryPhoto* photo = NULL;
			GeeIterator* _tmp6_;
			gpointer _tmp7_;
			LibraryPhoto* _tmp8_;
			GFile* _tmp9_;
			GFile* _tmp10_;
			gchar* _tmp11_;
			gchar* _tmp12_;
			gboolean _tmp13_;
#line 4892 "../src/Photo.vala"
			_tmp5_ = _photo_it;
#line 4892 "../src/Photo.vala"
			if (!gee_iterator_next (_tmp5_)) {
#line 4892 "../src/Photo.vala"
				break;
#line 37346 "Photo.c"
			}
#line 4892 "../src/Photo.vala"
			_tmp6_ = _photo_it;
#line 4892 "../src/Photo.vala"
			_tmp7_ = gee_iterator_get (_tmp6_);
#line 4892 "../src/Photo.vala"
			photo = (LibraryPhoto*) _tmp7_;
#line 4893 "../src/Photo.vala"
			_tmp8_ = photo;
#line 4893 "../src/Photo.vala"
			_tmp9_ = media_source_get_master_file (G_TYPE_CHECK_INSTANCE_CAST (_tmp8_, TYPE_MEDIA_SOURCE, MediaSource));
#line 4893 "../src/Photo.vala"
			_tmp10_ = _tmp9_;
#line 4893 "../src/Photo.vala"
			_tmp11_ = g_file_get_basename (_tmp10_);
#line 4893 "../src/Photo.vala"
			_tmp12_ = _tmp11_;
#line 4893 "../src/Photo.vala"
			_tmp13_ = utf8_ci_compare (_tmp12_, basename) == 0;
#line 4893 "../src/Photo.vala"
			_g_free0 (_tmp12_);
#line 4893 "../src/Photo.vala"
			_g_object_unref0 (_tmp10_);
#line 4893 "../src/Photo.vala"
			if (_tmp13_) {
#line 37372 "Photo.c"
				LibraryPhoto* _tmp14_;
				PhotoID _tmp15_ = {0};
#line 4894 "../src/Photo.vala"
				_tmp14_ = photo;
#line 4894 "../src/Photo.vala"
				photo_get_photo_id (G_TYPE_CHECK_INSTANCE_CAST (_tmp14_, TYPE_PHOTO, Photo), &_tmp15_);
#line 4894 "../src/Photo.vala"
				*result = _tmp15_;
#line 4894 "../src/Photo.vala"
				_g_object_unref0 (photo);
#line 4894 "../src/Photo.vala"
				_g_object_unref0 (_photo_it);
#line 4894 "../src/Photo.vala"
				return;
#line 37387 "Photo.c"
			}
#line 4892 "../src/Photo.vala"
			_g_object_unref0 (photo);
#line 37391 "Photo.c"
		}
#line 4892 "../src/Photo.vala"
		_g_object_unref0 (_photo_it);
#line 37395 "Photo.c"
	}
#line 4897 "../src/Photo.vala"
	photo_id_init (&_tmp16_, PHOTO_ID_INVALID);
#line 4897 "../src/Photo.vala"
	*result = _tmp16_;
#line 4897 "../src/Photo.vala"
	return;
#line 37403 "Photo.c"
}

gboolean
library_photo_source_collection_has_basename_filesize_duplicate (LibraryPhotoSourceCollection* self,
                                                                 const gchar* basename,
                                                                 gint64 filesize)
{
	PhotoID _tmp0_ = {0};
	gboolean result;
#line 4901 "../src/Photo.vala"
	g_return_val_if_fail (IS_LIBRARY_PHOTO_SOURCE_COLLECTION (self), FALSE);
#line 4901 "../src/Photo.vala"
	g_return_val_if_fail (basename != NULL, FALSE);
#line 4902 "../src/Photo.vala"
	library_photo_source_collection_get_basename_filesize_duplicate (self, basename, filesize, &_tmp0_);
#line 4902 "../src/Photo.vala"
	result = photo_id_is_valid (&_tmp0_);
#line 4902 "../src/Photo.vala"
	return result;
#line 37423 "Photo.c"
}

LibraryPhoto*
library_photo_source_collection_get_trashed_by_file (LibraryPhotoSourceCollection* self,
                                                     GFile* file)
{
	LibraryPhoto* photo = NULL;
	MediaSourceHoldingTank* _tmp0_;
	MediaSourceHoldingTank* _tmp1_;
	MediaSource* _tmp2_;
	LibraryPhoto* _tmp3_;
	LibraryPhoto* _tmp4_;
	LibraryPhoto* result;
#line 4905 "../src/Photo.vala"
	g_return_val_if_fail (IS_LIBRARY_PHOTO_SOURCE_COLLECTION (self), NULL);
#line 4905 "../src/Photo.vala"
	g_return_val_if_fail (G_TYPE_CHECK_INSTANCE_TYPE (file, g_file_get_type ()), NULL);
#line 4906 "../src/Photo.vala"
	_tmp0_ = media_source_collection_get_trashcan (G_TYPE_CHECK_INSTANCE_CAST (self, TYPE_MEDIA_SOURCE_COLLECTION, MediaSourceCollection));
#line 4906 "../src/Photo.vala"
	_tmp1_ = _tmp0_;
#line 4906 "../src/Photo.vala"
	_tmp2_ = media_source_holding_tank_fetch_by_master_file (_tmp1_, file);
#line 4906 "../src/Photo.vala"
	_tmp3_ = G_TYPE_CHECK_INSTANCE_CAST (_tmp2_, TYPE_LIBRARY_PHOTO, LibraryPhoto);
#line 4906 "../src/Photo.vala"
	_source_holding_tank_unref0 (_tmp1_);
#line 4906 "../src/Photo.vala"
	photo = _tmp3_;
#line 4907 "../src/Photo.vala"
	_tmp4_ = photo;
#line 4907 "../src/Photo.vala"
	if (_tmp4_ == NULL) {
#line 37457 "Photo.c"
		MediaSourceHoldingTank* _tmp5_;
		LibraryPhotoSourceHoldingTank* _tmp6_;
		LibraryPhoto* _tmp7_;
#line 4908 "../src/Photo.vala"
		_tmp5_ = media_source_collection_get_trashcan (G_TYPE_CHECK_INSTANCE_CAST (self, TYPE_MEDIA_SOURCE_COLLECTION, MediaSourceCollection));
#line 4908 "../src/Photo.vala"
		_tmp6_ = G_TYPE_CHECK_INSTANCE_CAST (_tmp5_, TYPE_LIBRARY_PHOTO_SOURCE_HOLDING_TANK, LibraryPhotoSourceHoldingTank);
#line 4908 "../src/Photo.vala"
		_tmp7_ = library_photo_source_holding_tank_fetch_by_backing_file (_tmp6_, file);
#line 4908 "../src/Photo.vala"
		_g_object_unref0 (photo);
#line 4908 "../src/Photo.vala"
		photo = G_TYPE_CHECK_INSTANCE_CAST (_tmp7_, TYPE_LIBRARY_PHOTO, LibraryPhoto);
#line 4908 "../src/Photo.vala"
		_source_holding_tank_unref0 (_tmp6_);
#line 37473 "Photo.c"
	}
#line 4911 "../src/Photo.vala"
	result = photo;
#line 4911 "../src/Photo.vala"
	return result;
#line 37479 "Photo.c"
}

LibraryPhoto*
library_photo_source_collection_get_trashed_by_md5 (LibraryPhotoSourceCollection* self,
                                                    const gchar* md5)
{
	MediaSourceHoldingTank* _tmp0_;
	MediaSourceHoldingTank* _tmp1_;
	MediaSource* _tmp2_;
	LibraryPhoto* _tmp3_;
	LibraryPhoto* result;
#line 4914 "../src/Photo.vala"
	g_return_val_if_fail (IS_LIBRARY_PHOTO_SOURCE_COLLECTION (self), NULL);
#line 4914 "../src/Photo.vala"
	g_return_val_if_fail (md5 != NULL, NULL);
#line 4915 "../src/Photo.vala"
	_tmp0_ = media_source_collection_get_trashcan (G_TYPE_CHECK_INSTANCE_CAST (self, TYPE_MEDIA_SOURCE_COLLECTION, MediaSourceCollection));
#line 4915 "../src/Photo.vala"
	_tmp1_ = _tmp0_;
#line 4915 "../src/Photo.vala"
	_tmp2_ = media_source_holding_tank_fetch_by_md5 (_tmp1_, md5);
#line 4915 "../src/Photo.vala"
	_tmp3_ = G_TYPE_CHECK_INSTANCE_CAST (_tmp2_, TYPE_LIBRARY_PHOTO, LibraryPhoto);
#line 4915 "../src/Photo.vala"
	_source_holding_tank_unref0 (_tmp1_);
#line 4915 "../src/Photo.vala"
	result = _tmp3_;
#line 4915 "../src/Photo.vala"
	return result;
#line 37509 "Photo.c"
}

LibraryPhoto*
library_photo_source_collection_get_offline_by_file (LibraryPhotoSourceCollection* self,
                                                     GFile* file)
{
	LibraryPhoto* photo = NULL;
	MediaSourceHoldingTank* _tmp0_;
	MediaSourceHoldingTank* _tmp1_;
	MediaSource* _tmp2_;
	LibraryPhoto* _tmp3_;
	LibraryPhoto* _tmp4_;
	LibraryPhoto* result;
#line 4918 "../src/Photo.vala"
	g_return_val_if_fail (IS_LIBRARY_PHOTO_SOURCE_COLLECTION (self), NULL);
#line 4918 "../src/Photo.vala"
	g_return_val_if_fail (G_TYPE_CHECK_INSTANCE_TYPE (file, g_file_get_type ()), NULL);
#line 4919 "../src/Photo.vala"
	_tmp0_ = media_source_collection_get_offline_bin (G_TYPE_CHECK_INSTANCE_CAST (self, TYPE_MEDIA_SOURCE_COLLECTION, MediaSourceCollection));
#line 4919 "../src/Photo.vala"
	_tmp1_ = _tmp0_;
#line 4919 "../src/Photo.vala"
	_tmp2_ = media_source_holding_tank_fetch_by_master_file (_tmp1_, file);
#line 4919 "../src/Photo.vala"
	_tmp3_ = G_TYPE_CHECK_INSTANCE_CAST (_tmp2_, TYPE_LIBRARY_PHOTO, LibraryPhoto);
#line 4919 "../src/Photo.vala"
	_source_holding_tank_unref0 (_tmp1_);
#line 4919 "../src/Photo.vala"
	photo = _tmp3_;
#line 4920 "../src/Photo.vala"
	_tmp4_ = photo;
#line 4920 "../src/Photo.vala"
	if (_tmp4_ == NULL) {
#line 37543 "Photo.c"
		MediaSourceHoldingTank* _tmp5_;
		LibraryPhotoSourceHoldingTank* _tmp6_;
		LibraryPhoto* _tmp7_;
#line 4921 "../src/Photo.vala"
		_tmp5_ = media_source_collection_get_offline_bin (G_TYPE_CHECK_INSTANCE_CAST (self, TYPE_MEDIA_SOURCE_COLLECTION, MediaSourceCollection));
#line 4921 "../src/Photo.vala"
		_tmp6_ = G_TYPE_CHECK_INSTANCE_CAST (_tmp5_, TYPE_LIBRARY_PHOTO_SOURCE_HOLDING_TANK, LibraryPhotoSourceHoldingTank);
#line 4921 "../src/Photo.vala"
		_tmp7_ = library_photo_source_holding_tank_fetch_by_backing_file (_tmp6_, file);
#line 4921 "../src/Photo.vala"
		_g_object_unref0 (photo);
#line 4921 "../src/Photo.vala"
		photo = G_TYPE_CHECK_INSTANCE_CAST (_tmp7_, TYPE_LIBRARY_PHOTO, LibraryPhoto);
#line 4921 "../src/Photo.vala"
		_source_holding_tank_unref0 (_tmp6_);
#line 37559 "Photo.c"
	}
#line 4924 "../src/Photo.vala"
	result = photo;
#line 4924 "../src/Photo.vala"
	return result;
#line 37565 "Photo.c"
}

LibraryPhoto*
library_photo_source_collection_get_offline_by_md5 (LibraryPhotoSourceCollection* self,
                                                    const gchar* md5)
{
	MediaSourceHoldingTank* _tmp0_;
	MediaSourceHoldingTank* _tmp1_;
	MediaSource* _tmp2_;
	LibraryPhoto* _tmp3_;
	LibraryPhoto* result;
#line 4927 "../src/Photo.vala"
	g_return_val_if_fail (IS_LIBRARY_PHOTO_SOURCE_COLLECTION (self), NULL);
#line 4927 "../src/Photo.vala"
	g_return_val_if_fail (md5 != NULL, NULL);
#line 4928 "../src/Photo.vala"
	_tmp0_ = media_source_collection_get_offline_bin (G_TYPE_CHECK_INSTANCE_CAST (self, TYPE_MEDIA_SOURCE_COLLECTION, MediaSourceCollection));
#line 4928 "../src/Photo.vala"
	_tmp1_ = _tmp0_;
#line 4928 "../src/Photo.vala"
	_tmp2_ = media_source_holding_tank_fetch_by_md5 (_tmp1_, md5);
#line 4928 "../src/Photo.vala"
	_tmp3_ = G_TYPE_CHECK_INSTANCE_CAST (_tmp2_, TYPE_LIBRARY_PHOTO, LibraryPhoto);
#line 4928 "../src/Photo.vala"
	_source_holding_tank_unref0 (_tmp1_);
#line 4928 "../src/Photo.vala"
	result = _tmp3_;
#line 4928 "../src/Photo.vala"
	return result;
#line 37595 "Photo.c"
}

gint
library_photo_source_collection_get_offline_count (LibraryPhotoSourceCollection* self)
{
	MediaSourceHoldingTank* _tmp0_;
	MediaSourceHoldingTank* _tmp1_;
	gint _tmp2_;
	gint result;
#line 4931 "../src/Photo.vala"
	g_return_val_if_fail (IS_LIBRARY_PHOTO_SOURCE_COLLECTION (self), 0);
#line 4932 "../src/Photo.vala"
	_tmp0_ = media_source_collection_get_offline_bin (G_TYPE_CHECK_INSTANCE_CAST (self, TYPE_MEDIA_SOURCE_COLLECTION, MediaSourceCollection));
#line 4932 "../src/Photo.vala"
	_tmp1_ = _tmp0_;
#line 4932 "../src/Photo.vala"
	_tmp2_ = source_holding_tank_get_count (G_TYPE_CHECK_INSTANCE_CAST (_tmp1_, TYPE_SOURCE_HOLDING_TANK, SourceHoldingTank));
#line 4932 "../src/Photo.vala"
	_source_holding_tank_unref0 (_tmp1_);
#line 4932 "../src/Photo.vala"
	result = _tmp2_;
#line 4932 "../src/Photo.vala"
	return result;
#line 37619 "Photo.c"
}

LibraryPhoto*
library_photo_source_collection_get_state_by_file (LibraryPhotoSourceCollection* self,
                                                   GFile* file,
                                                   LibraryPhotoSourceCollectionState* state)
{
	LibraryPhotoSourceCollectionState _vala_state = 0;
	LibraryPhoto* photo = NULL;
	MediaSource* _tmp0_;
	LibraryPhoto* _tmp1_;
	LibraryPhoto* _tmp2_;
	LibraryPhoto* _tmp3_;
	LibraryPhoto* _tmp4_;
	LibraryPhoto* _tmp5_;
	LibraryPhoto* _tmp6_;
	LibraryPhoto* _tmp7_;
	LibraryPhoto* _tmp8_;
	LibraryPhoto* _tmp9_;
	LibraryPhoto* _tmp10_;
	LibraryPhoto* _tmp11_;
	LibraryPhoto* result;
#line 4935 "../src/Photo.vala"
	g_return_val_if_fail (IS_LIBRARY_PHOTO_SOURCE_COLLECTION (self), NULL);
#line 4935 "../src/Photo.vala"
	g_return_val_if_fail (G_TYPE_CHECK_INSTANCE_TYPE (file, g_file_get_type ()), NULL);
#line 4936 "../src/Photo.vala"
	_tmp0_ = media_source_collection_fetch_by_master_file (G_TYPE_CHECK_INSTANCE_CAST (self, TYPE_MEDIA_SOURCE_COLLECTION, MediaSourceCollection), file);
#line 4936 "../src/Photo.vala"
	photo = G_TYPE_CHECK_INSTANCE_CAST (_tmp0_, TYPE_LIBRARY_PHOTO, LibraryPhoto);
#line 4937 "../src/Photo.vala"
	_tmp1_ = photo;
#line 4937 "../src/Photo.vala"
	if (_tmp1_ != NULL) {
#line 4938 "../src/Photo.vala"
		_vala_state = LIBRARY_PHOTO_SOURCE_COLLECTION_STATE_ONLINE;
#line 4940 "../src/Photo.vala"
		result = photo;
#line 4940 "../src/Photo.vala"
		if (state) {
#line 4940 "../src/Photo.vala"
			*state = _vala_state;
#line 37662 "Photo.c"
		}
#line 4940 "../src/Photo.vala"
		return result;
#line 37666 "Photo.c"
	}
#line 4943 "../src/Photo.vala"
	_tmp2_ = library_photo_source_collection_fetch_by_editable_file (self, file);
#line 4943 "../src/Photo.vala"
	_g_object_unref0 (photo);
#line 4943 "../src/Photo.vala"
	photo = _tmp2_;
#line 4944 "../src/Photo.vala"
	_tmp3_ = photo;
#line 4944 "../src/Photo.vala"
	if (_tmp3_ != NULL) {
#line 4945 "../src/Photo.vala"
		_vala_state = LIBRARY_PHOTO_SOURCE_COLLECTION_STATE_EDITABLE;
#line 4947 "../src/Photo.vala"
		result = photo;
#line 4947 "../src/Photo.vala"
		if (state) {
#line 4947 "../src/Photo.vala"
			*state = _vala_state;
#line 37686 "Photo.c"
		}
#line 4947 "../src/Photo.vala"
		return result;
#line 37690 "Photo.c"
	}
#line 4950 "../src/Photo.vala"
	_tmp4_ = library_photo_source_collection_fetch_by_raw_development_file (self, file);
#line 4950 "../src/Photo.vala"
	_g_object_unref0 (photo);
#line 4950 "../src/Photo.vala"
	photo = _tmp4_;
#line 4951 "../src/Photo.vala"
	_tmp5_ = photo;
#line 4951 "../src/Photo.vala"
	if (_tmp5_ != NULL) {
#line 4952 "../src/Photo.vala"
		_vala_state = LIBRARY_PHOTO_SOURCE_COLLECTION_STATE_DEVELOPER;
#line 4954 "../src/Photo.vala"
		result = photo;
#line 4954 "../src/Photo.vala"
		if (state) {
#line 4954 "../src/Photo.vala"
			*state = _vala_state;
#line 37710 "Photo.c"
		}
#line 4954 "../src/Photo.vala"
		return result;
#line 37714 "Photo.c"
	}
#line 4957 "../src/Photo.vala"
	_tmp6_ = library_photo_source_collection_get_trashed_by_file (self, file);
#line 4957 "../src/Photo.vala"
	_tmp7_ = IS_LIBRARY_PHOTO (_tmp6_) ? ((LibraryPhoto*) _tmp6_) : NULL;
#line 4957 "../src/Photo.vala"
	if (_tmp7_ == NULL) {
#line 4957 "../src/Photo.vala"
		_g_object_unref0 (_tmp6_);
#line 37724 "Photo.c"
	}
#line 4957 "../src/Photo.vala"
	_g_object_unref0 (photo);
#line 4957 "../src/Photo.vala"
	photo = _tmp7_;
#line 4958 "../src/Photo.vala"
	_tmp8_ = photo;
#line 4958 "../src/Photo.vala"
	if (_tmp8_ != NULL) {
#line 4959 "../src/Photo.vala"
		_vala_state = LIBRARY_PHOTO_SOURCE_COLLECTION_STATE_TRASH;
#line 4961 "../src/Photo.vala"
		result = photo;
#line 4961 "../src/Photo.vala"
		if (state) {
#line 4961 "../src/Photo.vala"
			*state = _vala_state;
#line 37742 "Photo.c"
		}
#line 4961 "../src/Photo.vala"
		return result;
#line 37746 "Photo.c"
	}
#line 4964 "../src/Photo.vala"
	_tmp9_ = library_photo_source_collection_get_offline_by_file (self, file);
#line 4964 "../src/Photo.vala"
	_tmp10_ = IS_LIBRARY_PHOTO (_tmp9_) ? ((LibraryPhoto*) _tmp9_) : NULL;
#line 4964 "../src/Photo.vala"
	if (_tmp10_ == NULL) {
#line 4964 "../src/Photo.vala"
		_g_object_unref0 (_tmp9_);
#line 37756 "Photo.c"
	}
#line 4964 "../src/Photo.vala"
	_g_object_unref0 (photo);
#line 4964 "../src/Photo.vala"
	photo = _tmp10_;
#line 4965 "../src/Photo.vala"
	_tmp11_ = photo;
#line 4965 "../src/Photo.vala"
	if (_tmp11_ != NULL) {
#line 4966 "../src/Photo.vala"
		_vala_state = LIBRARY_PHOTO_SOURCE_COLLECTION_STATE_OFFLINE;
#line 4968 "../src/Photo.vala"
		result = photo;
#line 4968 "../src/Photo.vala"
		if (state) {
#line 4968 "../src/Photo.vala"
			*state = _vala_state;
#line 37774 "Photo.c"
		}
#line 4968 "../src/Photo.vala"
		return result;
#line 37778 "Photo.c"
	}
#line 4971 "../src/Photo.vala"
	_vala_state = LIBRARY_PHOTO_SOURCE_COLLECTION_STATE_UNKNOWN;
#line 4973 "../src/Photo.vala"
	result = NULL;
#line 4973 "../src/Photo.vala"
	_g_object_unref0 (photo);
#line 4973 "../src/Photo.vala"
	if (state) {
#line 4973 "../src/Photo.vala"
		*state = _vala_state;
#line 37790 "Photo.c"
	}
#line 4973 "../src/Photo.vala"
	return result;
#line 37794 "Photo.c"
}

static gboolean
library_photo_source_collection_real_has_backlink (SourceCollection* base,
                                                   SourceBacklink* backlink)
{
	LibraryPhotoSourceCollection * self;
	MediaSourceHoldingTank* _tmp0_;
	MediaSourceHoldingTank* _tmp1_;
	gboolean _tmp2_;
	MediaSourceHoldingTank* _tmp3_;
	MediaSourceHoldingTank* _tmp4_;
	gboolean _tmp5_;
	gboolean result;
#line 4976 "../src/Photo.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (base, TYPE_LIBRARY_PHOTO_SOURCE_COLLECTION, LibraryPhotoSourceCollection);
#line 4976 "../src/Photo.vala"
	g_return_val_if_fail (IS_SOURCE_BACKLINK (backlink), FALSE);
#line 4977 "../src/Photo.vala"
	if (SOURCE_COLLECTION_CLASS (library_photo_source_collection_parent_class)->has_backlink (G_TYPE_CHECK_INSTANCE_CAST (G_TYPE_CHECK_INSTANCE_CAST (self, TYPE_MEDIA_SOURCE_COLLECTION, MediaSourceCollection), TYPE_SOURCE_COLLECTION, SourceCollection), backlink)) {
#line 4978 "../src/Photo.vala"
		result = TRUE;
#line 4978 "../src/Photo.vala"
		return result;
#line 37819 "Photo.c"
	}
#line 4980 "../src/Photo.vala"
	_tmp0_ = media_source_collection_get_trashcan (G_TYPE_CHECK_INSTANCE_CAST (self, TYPE_MEDIA_SOURCE_COLLECTION, MediaSourceCollection));
#line 4980 "../src/Photo.vala"
	_tmp1_ = _tmp0_;
#line 4980 "../src/Photo.vala"
	_tmp2_ = source_holding_tank_has_backlink (G_TYPE_CHECK_INSTANCE_CAST (_tmp1_, TYPE_SOURCE_HOLDING_TANK, SourceHoldingTank), backlink);
#line 4980 "../src/Photo.vala"
	_source_holding_tank_unref0 (_tmp1_);
#line 4980 "../src/Photo.vala"
	if (_tmp2_) {
#line 4981 "../src/Photo.vala"
		result = TRUE;
#line 4981 "../src/Photo.vala"
		return result;
#line 37835 "Photo.c"
	}
#line 4983 "../src/Photo.vala"
	_tmp3_ = media_source_collection_get_offline_bin (G_TYPE_CHECK_INSTANCE_CAST (self, TYPE_MEDIA_SOURCE_COLLECTION, MediaSourceCollection));
#line 4983 "../src/Photo.vala"
	_tmp4_ = _tmp3_;
#line 4983 "../src/Photo.vala"
	_tmp5_ = source_holding_tank_has_backlink (G_TYPE_CHECK_INSTANCE_CAST (_tmp4_, TYPE_SOURCE_HOLDING_TANK, SourceHoldingTank), backlink);
#line 4983 "../src/Photo.vala"
	_source_holding_tank_unref0 (_tmp4_);
#line 4983 "../src/Photo.vala"
	if (_tmp5_) {
#line 4984 "../src/Photo.vala"
		result = TRUE;
#line 4984 "../src/Photo.vala"
		return result;
#line 37851 "Photo.c"
	}
#line 4986 "../src/Photo.vala"
	result = FALSE;
#line 4986 "../src/Photo.vala"
	return result;
#line 37857 "Photo.c"
}

static void
library_photo_source_collection_real_remove_backlink (SourceCollection* base,
                                                      SourceBacklink* backlink)
{
	LibraryPhotoSourceCollection * self;
	MediaSourceHoldingTank* _tmp0_;
	MediaSourceHoldingTank* _tmp1_;
	MediaSourceHoldingTank* _tmp2_;
	MediaSourceHoldingTank* _tmp3_;
#line 4989 "../src/Photo.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (base, TYPE_LIBRARY_PHOTO_SOURCE_COLLECTION, LibraryPhotoSourceCollection);
#line 4989 "../src/Photo.vala"
	g_return_if_fail (IS_SOURCE_BACKLINK (backlink));
#line 4990 "../src/Photo.vala"
	_tmp0_ = media_source_collection_get_trashcan (G_TYPE_CHECK_INSTANCE_CAST (self, TYPE_MEDIA_SOURCE_COLLECTION, MediaSourceCollection));
#line 4990 "../src/Photo.vala"
	_tmp1_ = _tmp0_;
#line 4990 "../src/Photo.vala"
	source_holding_tank_remove_backlink (G_TYPE_CHECK_INSTANCE_CAST (_tmp1_, TYPE_SOURCE_HOLDING_TANK, SourceHoldingTank), backlink);
#line 4990 "../src/Photo.vala"
	_source_holding_tank_unref0 (_tmp1_);
#line 4991 "../src/Photo.vala"
	_tmp2_ = media_source_collection_get_offline_bin (G_TYPE_CHECK_INSTANCE_CAST (self, TYPE_MEDIA_SOURCE_COLLECTION, MediaSourceCollection));
#line 4991 "../src/Photo.vala"
	_tmp3_ = _tmp2_;
#line 4991 "../src/Photo.vala"
	source_holding_tank_remove_backlink (G_TYPE_CHECK_INSTANCE_CAST (_tmp3_, TYPE_SOURCE_HOLDING_TANK, SourceHoldingTank), backlink);
#line 4991 "../src/Photo.vala"
	_source_holding_tank_unref0 (_tmp3_);
#line 4993 "../src/Photo.vala"
	SOURCE_COLLECTION_CLASS (library_photo_source_collection_parent_class)->remove_backlink (G_TYPE_CHECK_INSTANCE_CAST (G_TYPE_CHECK_INSTANCE_CAST (self, TYPE_MEDIA_SOURCE_COLLECTION, MediaSourceCollection), TYPE_SOURCE_COLLECTION, SourceCollection), backlink);
#line 37891 "Photo.c"
}

static TransactionController*
library_photo_source_collection_real_get_transaction_controller (MediaSourceCollection* base)
{
	TransactionController* result;
	LibraryPhotoSourceCollection* self;
	TransactionController* _tmp0_;
	TransactionController* _tmp2_;
#line 4510 "../src/Photo.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (base, TYPE_LIBRARY_PHOTO_SOURCE_COLLECTION, LibraryPhotoSourceCollection);
#line 4511 "../src/Photo.vala"
	_tmp0_ = self->priv->_transaction_controller;
#line 4511 "../src/Photo.vala"
	if (_tmp0_ == NULL) {
#line 37907 "Photo.c"
		MediaSourceTransactionController* _tmp1_;
#line 4512 "../src/Photo.vala"
		_tmp1_ = media_source_transaction_controller_new (G_TYPE_CHECK_INSTANCE_CAST (self, TYPE_MEDIA_SOURCE_COLLECTION, MediaSourceCollection));
#line 4512 "../src/Photo.vala"
		_transaction_controller_unref0 (self->priv->_transaction_controller);
#line 4512 "../src/Photo.vala"
		self->priv->_transaction_controller = G_TYPE_CHECK_INSTANCE_CAST (_tmp1_, TYPE_TRANSACTION_CONTROLLER, TransactionController);
#line 37915 "Photo.c"
	}
#line 4514 "../src/Photo.vala"
	_tmp2_ = self->priv->_transaction_controller;
#line 4514 "../src/Photo.vala"
	result = _tmp2_;
#line 4514 "../src/Photo.vala"
	return result;
#line 37923 "Photo.c"
}

static void
library_photo_source_collection_real_master_reimported (LibraryPhotoSourceCollection* self,
                                                        LibraryPhoto* photo,
                                                        PhotoMetadata* metadata)
{
#line 4532 "../src/Photo.vala"
	g_return_if_fail (IS_LIBRARY_PHOTO (photo));
#line 4532 "../src/Photo.vala"
	g_return_if_fail ((metadata == NULL) || IS_PHOTO_METADATA (metadata));
#line 37935 "Photo.c"
}

static void
g_cclosure_user_marshal_VOID__OBJECT_MEDIA_METADATA (GClosure * closure,
                                                     GValue * return_value,
                                                     guint n_param_values,
                                                     const GValue * param_values,
                                                     gpointer invocation_hint,
                                                     gpointer marshal_data)
{
	typedef void (*GMarshalFunc_VOID__OBJECT_MEDIA_METADATA) (gpointer data1, gpointer arg_1, gpointer arg_2, gpointer data2);
	register GMarshalFunc_VOID__OBJECT_MEDIA_METADATA callback;
	register GCClosure * cc;
	register gpointer data1;
	register gpointer data2;
	cc = (GCClosure *) closure;
#line 4499 "../src/Photo.vala"
	g_return_if_fail (n_param_values == 3);
#line 4499 "../src/Photo.vala"
	if (G_CCLOSURE_SWAP_DATA (closure)) {
#line 4499 "../src/Photo.vala"
		data1 = closure->data;
#line 4499 "../src/Photo.vala"
		data2 = param_values->data[0].v_pointer;
#line 37960 "Photo.c"
	} else {
#line 4499 "../src/Photo.vala"
		data1 = param_values->data[0].v_pointer;
#line 4499 "../src/Photo.vala"
		data2 = closure->data;
#line 37966 "Photo.c"
	}
#line 4499 "../src/Photo.vala"
	callback = (GMarshalFunc_VOID__OBJECT_MEDIA_METADATA) (marshal_data ? marshal_data : cc->callback);
#line 4499 "../src/Photo.vala"
	callback (data1, g_value_get_object (param_values + 1), value_get_media_metadata (param_values + 2), data2);
#line 37972 "Photo.c"
}

static void
library_photo_source_collection_real_editable_reimported (LibraryPhotoSourceCollection* self,
                                                          LibraryPhoto* photo,
                                                          PhotoMetadata* metadata)
{
#line 4535 "../src/Photo.vala"
	g_return_if_fail (IS_LIBRARY_PHOTO (photo));
#line 4535 "../src/Photo.vala"
	g_return_if_fail ((metadata == NULL) || IS_PHOTO_METADATA (metadata));
#line 37984 "Photo.c"
}

static void
library_photo_source_collection_real_baseline_reimported (LibraryPhotoSourceCollection* self,
                                                          LibraryPhoto* photo,
                                                          PhotoMetadata* metadata)
{
#line 4538 "../src/Photo.vala"
	g_return_if_fail (IS_LIBRARY_PHOTO (photo));
#line 4538 "../src/Photo.vala"
	g_return_if_fail ((metadata == NULL) || IS_PHOTO_METADATA (metadata));
#line 37996 "Photo.c"
}

static void
library_photo_source_collection_real_source_reimported (LibraryPhotoSourceCollection* self,
                                                        LibraryPhoto* photo,
                                                        PhotoMetadata* metadata)
{
#line 4541 "../src/Photo.vala"
	g_return_if_fail (IS_LIBRARY_PHOTO (photo));
#line 4541 "../src/Photo.vala"
	g_return_if_fail ((metadata == NULL) || IS_PHOTO_METADATA (metadata));
#line 38008 "Photo.c"
}

static void
library_photo_source_collection_class_init (LibraryPhotoSourceCollectionClass * klass,
                                            gpointer klass_data)
{
#line 4499 "../src/Photo.vala"
	library_photo_source_collection_parent_class = g_type_class_peek_parent (klass);
#line 4499 "../src/Photo.vala"
	((DataCollectionClass *) klass)->finalize = library_photo_source_collection_finalize;
#line 4499 "../src/Photo.vala"
	g_type_class_adjust_private_offset (klass, &LibraryPhotoSourceCollection_private_offset);
#line 4499 "../src/Photo.vala"
	((MediaSourceCollectionClass *) klass)->create_trashcan = (MediaSourceHoldingTank* (*) (MediaSourceCollection*)) library_photo_source_collection_real_create_trashcan;
#line 4499 "../src/Photo.vala"
	((MediaSourceCollectionClass *) klass)->create_offline_bin = (MediaSourceHoldingTank* (*) (MediaSourceCollection*)) library_photo_source_collection_real_create_offline_bin;
#line 4499 "../src/Photo.vala"
	((MediaSourceCollectionClass *) klass)->create_media_monitor = (MediaMonitor* (*) (MediaSourceCollection*, Workers*, GCancellable*)) library_photo_source_collection_real_create_media_monitor;
#line 4499 "../src/Photo.vala"
	((SourceCollectionClass *) klass)->holds_type_of_source = (gboolean (*) (SourceCollection*, DataSource*)) library_photo_source_collection_real_holds_type_of_source;
#line 4499 "../src/Photo.vala"
	((MediaSourceCollectionClass *) klass)->get_typename = (gchar* (*) (MediaSourceCollection*)) library_photo_source_collection_real_get_typename;
#line 4499 "../src/Photo.vala"
	((MediaSourceCollectionClass *) klass)->is_file_recognized = (gboolean (*) (MediaSourceCollection*, GFile*)) library_photo_source_collection_real_is_file_recognized;
#line 4499 "../src/Photo.vala"
	((DataCollectionClass *) klass)->notify_contents_altered = (void (*) (DataCollection*, GeeIterable*, GeeIterable*)) library_photo_source_collection_real_notify_contents_altered;
#line 4499 "../src/Photo.vala"
	((DataCollectionClass *) klass)->items_altered = (void (*) (DataCollection*, GeeMap*)) library_photo_source_collection_real_items_altered;
#line 4499 "../src/Photo.vala"
	((MediaSourceCollectionClass *) klass)->postprocess_imported_media = (void (*) (MediaSourceCollection*, GeeCollection*)) library_photo_source_collection_real_postprocess_imported_media;
#line 4499 "../src/Photo.vala"
	((LibraryPhotoSourceCollectionClass *) klass)->notify_master_reimported = (void (*) (LibraryPhotoSourceCollection*, LibraryPhoto*, PhotoMetadata*)) library_photo_source_collection_real_notify_master_reimported;
#line 4499 "../src/Photo.vala"
	((LibraryPhotoSourceCollectionClass *) klass)->notify_editable_reimported = (void (*) (LibraryPhotoSourceCollection*, LibraryPhoto*, PhotoMetadata*)) library_photo_source_collection_real_notify_editable_reimported;
#line 4499 "../src/Photo.vala"
	((LibraryPhotoSourceCollectionClass *) klass)->notify_source_reimported = (void (*) (LibraryPhotoSourceCollection*, LibraryPhoto*, PhotoMetadata*)) library_photo_source_collection_real_notify_source_reimported;
#line 4499 "../src/Photo.vala"
	((LibraryPhotoSourceCollectionClass *) klass)->notify_baseline_reimported = (void (*) (LibraryPhotoSourceCollection*, LibraryPhoto*, PhotoMetadata*)) library_photo_source_collection_real_notify_baseline_reimported;
#line 4499 "../src/Photo.vala"
	((MediaSourceCollectionClass *) klass)->fetch_by_numeric_id = (MediaSource* (*) (MediaSourceCollection*, gint64)) library_photo_source_collection_real_fetch_by_numeric_id;
#line 4499 "../src/Photo.vala"
	((MediaSourceCollectionClass *) klass)->fetch_by_source_id = (MediaSource* (*) (MediaSourceCollection*, const gchar*)) library_photo_source_collection_real_fetch_by_source_id;
#line 4499 "../src/Photo.vala"
	((MediaSourceCollectionClass *) klass)->get_event_source_ids = (GeeCollection* (*) (MediaSourceCollection*, EventID*)) library_photo_source_collection_real_get_event_source_ids;
#line 4499 "../src/Photo.vala"
	((SourceCollectionClass *) klass)->has_backlink = (gboolean (*) (SourceCollection*, SourceBacklink*)) library_photo_source_collection_real_has_backlink;
#line 4499 "../src/Photo.vala"
	((SourceCollectionClass *) klass)->remove_backlink = (void (*) (SourceCollection*, SourceBacklink*)) library_photo_source_collection_real_remove_backlink;
#line 4499 "../src/Photo.vala"
	((LibraryPhotoSourceCollectionClass *) klass)->master_reimported = library_photo_source_collection_real_master_reimported;
#line 4499 "../src/Photo.vala"
	((LibraryPhotoSourceCollectionClass *) klass)->editable_reimported = library_photo_source_collection_real_editable_reimported;
#line 4499 "../src/Photo.vala"
	((LibraryPhotoSourceCollectionClass *) klass)->baseline_reimported = library_photo_source_collection_real_baseline_reimported;
#line 4499 "../src/Photo.vala"
	((LibraryPhotoSourceCollectionClass *) klass)->source_reimported = library_photo_source_collection_real_source_reimported;
#line 4499 "../src/Photo.vala"
	MEDIA_SOURCE_COLLECTION_CLASS (klass)->get_transaction_controller = (TransactionController* (*) (MediaSourceCollection*)) library_photo_source_collection_real_get_transaction_controller;
#line 4499 "../src/Photo.vala"
	library_photo_source_collection_signals[LIBRARY_PHOTO_SOURCE_COLLECTION_MASTER_REIMPORTED_SIGNAL] = g_signal_new ("master-reimported", TYPE_LIBRARY_PHOTO_SOURCE_COLLECTION, G_SIGNAL_RUN_LAST, G_STRUCT_OFFSET (LibraryPhotoSourceCollectionClass, master_reimported), NULL, NULL, g_cclosure_user_marshal_VOID__OBJECT_MEDIA_METADATA, G_TYPE_NONE, 2, TYPE_LIBRARY_PHOTO, TYPE_PHOTO_METADATA);
#line 4499 "../src/Photo.vala"
	library_photo_source_collection_signals[LIBRARY_PHOTO_SOURCE_COLLECTION_EDITABLE_REIMPORTED_SIGNAL] = g_signal_new ("editable-reimported", TYPE_LIBRARY_PHOTO_SOURCE_COLLECTION, G_SIGNAL_RUN_LAST, G_STRUCT_OFFSET (LibraryPhotoSourceCollectionClass, editable_reimported), NULL, NULL, g_cclosure_user_marshal_VOID__OBJECT_MEDIA_METADATA, G_TYPE_NONE, 2, TYPE_LIBRARY_PHOTO, TYPE_PHOTO_METADATA);
#line 4499 "../src/Photo.vala"
	library_photo_source_collection_signals[LIBRARY_PHOTO_SOURCE_COLLECTION_BASELINE_REIMPORTED_SIGNAL] = g_signal_new ("baseline-reimported", TYPE_LIBRARY_PHOTO_SOURCE_COLLECTION, G_SIGNAL_RUN_LAST, G_STRUCT_OFFSET (LibraryPhotoSourceCollectionClass, baseline_reimported), NULL, NULL, g_cclosure_user_marshal_VOID__OBJECT_MEDIA_METADATA, G_TYPE_NONE, 2, TYPE_LIBRARY_PHOTO, TYPE_PHOTO_METADATA);
#line 4499 "../src/Photo.vala"
	library_photo_source_collection_signals[LIBRARY_PHOTO_SOURCE_COLLECTION_SOURCE_REIMPORTED_SIGNAL] = g_signal_new ("source-reimported", TYPE_LIBRARY_PHOTO_SOURCE_COLLECTION, G_SIGNAL_RUN_LAST, G_STRUCT_OFFSET (LibraryPhotoSourceCollectionClass, source_reimported), NULL, NULL, g_cclosure_user_marshal_VOID__OBJECT_MEDIA_METADATA, G_TYPE_NONE, 2, TYPE_LIBRARY_PHOTO, TYPE_PHOTO_METADATA);
#line 38075 "Photo.c"
}

static void
library_photo_source_collection_instance_init (LibraryPhotoSourceCollection * self,
                                               gpointer klass)
{
	GeeHashMap* _tmp0_;
	GeeHashMap* _tmp1_;
	GeeTreeMultiMap* _tmp2_;
	GeeHashMap* _tmp3_;
	GeeHashMap* _tmp4_;
	GeeTreeMultiMap* _tmp5_;
#line 4499 "../src/Photo.vala"
	self->priv = library_photo_source_collection_get_instance_private (self);
#line 4518 "../src/Photo.vala"
	self->priv->_transaction_controller = NULL;
#line 4519 "../src/Photo.vala"
	_tmp0_ = gee_hash_map_new (g_file_get_type (), (GBoxedCopyFunc) g_object_ref, (GDestroyNotify) g_object_unref, TYPE_LIBRARY_PHOTO, (GBoxedCopyFunc) g_object_ref, (GDestroyNotify) g_object_unref, _file_hash_gee_hash_data_func, NULL, NULL, _file_equal_gee_equal_data_func, NULL, NULL, NULL, NULL, NULL);
#line 4519 "../src/Photo.vala"
	self->priv->by_editable_file = _tmp0_;
#line 4521 "../src/Photo.vala"
	_tmp1_ = gee_hash_map_new (g_file_get_type (), (GBoxedCopyFunc) g_object_ref, (GDestroyNotify) g_object_unref, TYPE_LIBRARY_PHOTO, (GBoxedCopyFunc) g_object_ref, (GDestroyNotify) g_object_unref, _file_hash_gee_hash_data_func, NULL, NULL, _file_equal_gee_equal_data_func, NULL, NULL, NULL, NULL, NULL);
#line 4521 "../src/Photo.vala"
	self->priv->by_raw_development_file = _tmp1_;
#line 4523 "../src/Photo.vala"
	_tmp2_ = gee_tree_multi_map_new (G_TYPE_INT64, (GBoxedCopyFunc) _int64_dup, (GDestroyNotify) g_free, TYPE_LIBRARY_PHOTO, (GBoxedCopyFunc) g_object_ref, (GDestroyNotify) g_object_unref, _int64_compare_gcompare_data_func, NULL, NULL, NULL, NULL, NULL);
#line 4523 "../src/Photo.vala"
	self->priv->filesize_to_photo = G_TYPE_CHECK_INSTANCE_CAST (_tmp2_, GEE_TYPE_MULTI_MAP, GeeMultiMap);
#line 4525 "../src/Photo.vala"
	_tmp3_ = gee_hash_map_new (TYPE_LIBRARY_PHOTO, (GBoxedCopyFunc) g_object_ref, (GDestroyNotify) g_object_unref, G_TYPE_INT64, (GBoxedCopyFunc) _int64_dup, (GDestroyNotify) g_free, NULL, NULL, NULL, NULL, NULL, NULL, _int64_equal_gee_equal_data_func, NULL, NULL);
#line 4525 "../src/Photo.vala"
	self->priv->photo_to_master_filesize = _tmp3_;
#line 4527 "../src/Photo.vala"
	_tmp4_ = gee_hash_map_new (TYPE_LIBRARY_PHOTO, (GBoxedCopyFunc) g_object_ref, (GDestroyNotify) g_object_unref, G_TYPE_INT64, (GBoxedCopyFunc) _int64_dup, (GDestroyNotify) g_free, NULL, NULL, NULL, NULL, NULL, NULL, _int64_equal_gee_equal_data_func, NULL, NULL);
#line 4527 "../src/Photo.vala"
	self->priv->photo_to_editable_filesize = _tmp4_;
#line 4529 "../src/Photo.vala"
	_tmp5_ = gee_tree_multi_map_new (TYPE_LIBRARY_PHOTO, (GBoxedCopyFunc) g_object_ref, (GDestroyNotify) g_object_unref, G_TYPE_INT64, (GBoxedCopyFunc) _int64_dup, (GDestroyNotify) g_free, NULL, NULL, NULL, NULL, NULL, NULL);
#line 4529 "../src/Photo.vala"
	self->priv->photo_to_raw_development_filesize = G_TYPE_CHECK_INSTANCE_CAST (_tmp5_, GEE_TYPE_MULTI_MAP, GeeMultiMap);
#line 38116 "Photo.c"
}

static void
library_photo_source_collection_finalize (DataCollection * obj)
{
	LibraryPhotoSourceCollection * self;
#line 4499 "../src/Photo.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, TYPE_LIBRARY_PHOTO_SOURCE_COLLECTION, LibraryPhotoSourceCollection);
#line 4518 "../src/Photo.vala"
	_transaction_controller_unref0 (self->priv->_transaction_controller);
#line 4519 "../src/Photo.vala"
	_g_object_unref0 (self->priv->by_editable_file);
#line 4521 "../src/Photo.vala"
	_g_object_unref0 (self->priv->by_raw_development_file);
#line 4523 "../src/Photo.vala"
	_g_object_unref0 (self->priv->filesize_to_photo);
#line 4525 "../src/Photo.vala"
	_g_object_unref0 (self->priv->photo_to_master_filesize);
#line 4527 "../src/Photo.vala"
	_g_object_unref0 (self->priv->photo_to_editable_filesize);
#line 4529 "../src/Photo.vala"
	_g_object_unref0 (self->priv->photo_to_raw_development_filesize);
#line 4499 "../src/Photo.vala"
	DATA_COLLECTION_CLASS (library_photo_source_collection_parent_class)->finalize (obj);
#line 38141 "Photo.c"
}

static GType
library_photo_source_collection_get_type_once (void)
{
	static const GTypeInfo g_define_type_info = { sizeof (LibraryPhotoSourceCollectionClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) library_photo_source_collection_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (LibraryPhotoSourceCollection), 0, (GInstanceInitFunc) library_photo_source_collection_instance_init, NULL };
	GType library_photo_source_collection_type_id;
	library_photo_source_collection_type_id = g_type_register_static (TYPE_MEDIA_SOURCE_COLLECTION, "LibraryPhotoSourceCollection", &g_define_type_info, 0);
	LibraryPhotoSourceCollection_private_offset = g_type_add_instance_private (library_photo_source_collection_type_id, sizeof (LibraryPhotoSourceCollectionPrivate));
	return library_photo_source_collection_type_id;
}

GType
library_photo_source_collection_get_type (void)
{
	static volatile gsize library_photo_source_collection_type_id__once = 0;
	if (g_once_init_enter (&library_photo_source_collection_type_id__once)) {
		GType library_photo_source_collection_type_id;
		library_photo_source_collection_type_id = library_photo_source_collection_get_type_once ();
		g_once_init_leave (&library_photo_source_collection_type_id__once, library_photo_source_collection_type_id);
	}
	return library_photo_source_collection_type_id__once;
}

static inline gpointer
library_photo_get_instance_private (LibraryPhoto* self)
{
	return G_STRUCT_MEMBER_P (self, LibraryPhoto_private_offset);
}

static void
_library_photo_generate_thumbnails_one_shot_callback (gpointer self)
{
#line 5021 "../src/Photo.vala"
	library_photo_generate_thumbnails ((LibraryPhoto*) self);
#line 38177 "Photo.c"
}

static void
_library_photo_import_gps_metadata_one_shot_callback (gpointer self)
{
#line 5024 "../src/Photo.vala"
	library_photo_import_gps_metadata ((LibraryPhoto*) self);
#line 38185 "Photo.c"
}

static LibraryPhoto*
library_photo_construct (GType object_type,
                         PhotoRow* row)
{
	LibraryPhoto * self = NULL;
	OneShotScheduler* _tmp0_;
	GpsCoords _tmp1_;
#line 5016 "../src/Photo.vala"
	g_return_val_if_fail (IS_PHOTO_ROW (row), NULL);
#line 5017 "../src/Photo.vala"
	self = (LibraryPhoto*) photo_construct (object_type, row);
#line 5019 "../src/Photo.vala"
	_g_object_unref0 (self->priv->import_keywords);
#line 5019 "../src/Photo.vala"
	self->priv->import_keywords = NULL;
#line 5021 "../src/Photo.vala"
	_tmp0_ = one_shot_scheduler_new ("LibraryPhoto", _library_photo_generate_thumbnails_one_shot_callback, self);
#line 5021 "../src/Photo.vala"
	_one_shot_scheduler_unref0 (self->priv->thumbnail_scheduler);
#line 5021 "../src/Photo.vala"
	self->priv->thumbnail_scheduler = _tmp0_;
#line 5023 "../src/Photo.vala"
	_tmp1_ = row->gps_coords;
#line 5023 "../src/Photo.vala"
	if (_tmp1_.has_gps == -1) {
#line 38213 "Photo.c"
		OneShotScheduler* gps_import_scheduler = NULL;
		OneShotScheduler* _tmp2_;
		OneShotScheduler* _tmp3_;
#line 5024 "../src/Photo.vala"
		_tmp2_ = one_shot_scheduler_new ("LibraryPhoto", _library_photo_import_gps_metadata_one_shot_callback, self);
#line 5024 "../src/Photo.vala"
		gps_import_scheduler = _tmp2_;
#line 5025 "../src/Photo.vala"
		_tmp3_ = gps_import_scheduler;
#line 5025 "../src/Photo.vala"
		one_shot_scheduler_at_priority_idle (_tmp3_, G_PRIORITY_LOW);
#line 5023 "../src/Photo.vala"
		_one_shot_scheduler_unref0 (gps_import_scheduler);
#line 38227 "Photo.c"
	}
#line 5029 "../src/Photo.vala"
	if ((row->flags & (LIBRARY_PHOTO_FLAG_TRASH | LIBRARY_PHOTO_FLAG_OFFLINE)) != ((guint64) 0)) {
#line 38231 "Photo.c"
		LibraryPhotoSourceCollection* _tmp4_;
		const gchar* _tmp5_;
#line 5030 "../src/Photo.vala"
		_tmp4_ = library_photo_global;
#line 5030 "../src/Photo.vala"
		_tmp5_ = row->backlinks;
#line 5030 "../src/Photo.vala"
		data_source_rehydrate_backlinks (G_TYPE_CHECK_INSTANCE_CAST (self, TYPE_DATA_SOURCE, DataSource), G_TYPE_CHECK_INSTANCE_CAST (_tmp4_, TYPE_SOURCE_COLLECTION, SourceCollection), _tmp5_);
#line 38240 "Photo.c"
	}
#line 5032 "../src/Photo.vala"
	if ((row->flags & (LIBRARY_PHOTO_FLAG_HIDDEN | LIBRARY_PHOTO_FLAG_FAVORITE)) != ((guint64) 0)) {
#line 5033 "../src/Photo.vala"
		library_photo_upgrade_rating_flags (self, row->flags);
#line 38246 "Photo.c"
	}
#line 5016 "../src/Photo.vala"
	return self;
#line 38250 "Photo.c"
}

static LibraryPhoto*
library_photo_new (PhotoRow* row)
{
#line 5016 "../src/Photo.vala"
	return library_photo_construct (TYPE_LIBRARY_PHOTO, row);
#line 38258 "Photo.c"
}

static LibraryPhoto*
library_photo_construct_from_import_params (GType object_type,
                                            PhotoImportParams* import_params)
{
	LibraryPhoto * self = NULL;
	PhotoRow* _tmp0_;
	GeeCollection* _tmp1_;
	GeeCollection* _tmp2_;
	OneShotScheduler* _tmp3_;
	PhotoRow* _tmp4_;
	PhotoRow* _tmp8_;
#line 5036 "../src/Photo.vala"
	g_return_val_if_fail (IS_PHOTO_IMPORT_PARAMS (import_params), NULL);
#line 5037 "../src/Photo.vala"
	_tmp0_ = import_params->row;
#line 5037 "../src/Photo.vala"
	self = (LibraryPhoto*) photo_construct (object_type, _tmp0_);
#line 5039 "../src/Photo.vala"
	_tmp1_ = import_params->keywords;
#line 5039 "../src/Photo.vala"
	_tmp2_ = _g_object_ref0 (_tmp1_);
#line 5039 "../src/Photo.vala"
	_g_object_unref0 (self->priv->import_keywords);
#line 5039 "../src/Photo.vala"
	self->priv->import_keywords = _tmp2_;
#line 5040 "../src/Photo.vala"
	_tmp3_ = one_shot_scheduler_new ("LibraryPhoto", _library_photo_generate_thumbnails_one_shot_callback, self);
#line 5040 "../src/Photo.vala"
	_one_shot_scheduler_unref0 (self->priv->thumbnail_scheduler);
#line 5040 "../src/Photo.vala"
	self->priv->thumbnail_scheduler = _tmp3_;
#line 5043 "../src/Photo.vala"
	_tmp4_ = import_params->row;
#line 5043 "../src/Photo.vala"
	if ((_tmp4_->flags & (LIBRARY_PHOTO_FLAG_TRASH | LIBRARY_PHOTO_FLAG_OFFLINE)) != ((guint64) 0)) {
#line 38296 "Photo.c"
		LibraryPhotoSourceCollection* _tmp5_;
		PhotoRow* _tmp6_;
		const gchar* _tmp7_;
#line 5044 "../src/Photo.vala"
		_tmp5_ = library_photo_global;
#line 5044 "../src/Photo.vala"
		_tmp6_ = import_params->row;
#line 5044 "../src/Photo.vala"
		_tmp7_ = _tmp6_->backlinks;
#line 5044 "../src/Photo.vala"
		data_source_rehydrate_backlinks (G_TYPE_CHECK_INSTANCE_CAST (self, TYPE_DATA_SOURCE, DataSource), G_TYPE_CHECK_INSTANCE_CAST (_tmp5_, TYPE_SOURCE_COLLECTION, SourceCollection), _tmp7_);
#line 38308 "Photo.c"
	}
#line 5046 "../src/Photo.vala"
	_tmp8_ = import_params->row;
#line 5046 "../src/Photo.vala"
	if ((_tmp8_->flags & (LIBRARY_PHOTO_FLAG_HIDDEN | LIBRARY_PHOTO_FLAG_FAVORITE)) != ((guint64) 0)) {
#line 38314 "Photo.c"
		PhotoRow* _tmp9_;
#line 5047 "../src/Photo.vala"
		_tmp9_ = import_params->row;
#line 5047 "../src/Photo.vala"
		library_photo_upgrade_rating_flags (self, _tmp9_->flags);
#line 38320 "Photo.c"
	}
#line 5036 "../src/Photo.vala"
	return self;
#line 38324 "Photo.c"
}

static LibraryPhoto*
library_photo_new_from_import_params (PhotoImportParams* import_params)
{
#line 5036 "../src/Photo.vala"
	return library_photo_construct_from_import_params (TYPE_LIBRARY_PHOTO, import_params);
#line 38332 "Photo.c"
}

void
library_photo_init (ProgressMonitor monitor,
                    gpointer monitor_target)
{
	LibraryPhotoSourceCollection* _tmp0_;
	GeeArrayList* all = NULL;
	PhotoTable* _tmp1_;
	PhotoTable* _tmp2_;
	GeeArrayList* _tmp3_;
	GeeArrayList* _tmp4_;
	GeeArrayList* all_photos = NULL;
	GeeArrayList* _tmp5_;
	GeeArrayList* trashed_photos = NULL;
	GeeArrayList* _tmp6_;
	GeeArrayList* offline_photos = NULL;
	GeeArrayList* _tmp7_;
	gint count = 0;
	GeeArrayList* _tmp8_;
	gint _tmp9_;
	gint _tmp10_;
	LibraryPhotoSourceCollection* _tmp24_;
	GeeArrayList* _tmp25_;
	GeeCollection* _tmp26_;
	GeeCollection* _tmp27_;
	LibraryPhotoSourceCollection* _tmp28_;
	GeeArrayList* _tmp29_;
	LibraryPhotoSourceCollection* _tmp30_;
	GeeArrayList* _tmp31_;
#line 5051 "../src/Photo.vala"
	photo_init_photo ();
#line 5053 "../src/Photo.vala"
	_tmp0_ = library_photo_source_collection_new ();
#line 5053 "../src/Photo.vala"
	_data_collection_unref0 (library_photo_global);
#line 5053 "../src/Photo.vala"
	library_photo_global = _tmp0_;
#line 5057 "../src/Photo.vala"
	_tmp1_ = photo_table_get_instance ();
#line 5057 "../src/Photo.vala"
	_tmp2_ = _tmp1_;
#line 5057 "../src/Photo.vala"
	_tmp3_ = photo_table_get_all (_tmp2_);
#line 5057 "../src/Photo.vala"
	_tmp4_ = _tmp3_;
#line 5057 "../src/Photo.vala"
	_database_table_unref0 (_tmp2_);
#line 5057 "../src/Photo.vala"
	all = _tmp4_;
#line 5058 "../src/Photo.vala"
	_tmp5_ = gee_array_list_new (TYPE_LIBRARY_PHOTO, (GBoxedCopyFunc) g_object_ref, (GDestroyNotify) g_object_unref, NULL, NULL, NULL);
#line 5058 "../src/Photo.vala"
	all_photos = _tmp5_;
#line 5059 "../src/Photo.vala"
	_tmp6_ = gee_array_list_new (TYPE_LIBRARY_PHOTO, (GBoxedCopyFunc) g_object_ref, (GDestroyNotify) g_object_unref, NULL, NULL, NULL);
#line 5059 "../src/Photo.vala"
	trashed_photos = _tmp6_;
#line 5060 "../src/Photo.vala"
	_tmp7_ = gee_array_list_new (TYPE_LIBRARY_PHOTO, (GBoxedCopyFunc) g_object_ref, (GDestroyNotify) g_object_unref, NULL, NULL, NULL);
#line 5060 "../src/Photo.vala"
	offline_photos = _tmp7_;
#line 5061 "../src/Photo.vala"
	_tmp8_ = all;
#line 5061 "../src/Photo.vala"
	_tmp9_ = gee_abstract_collection_get_size (G_TYPE_CHECK_INSTANCE_CAST (_tmp8_, GEE_TYPE_ABSTRACT_COLLECTION, GeeAbstractCollection));
#line 5061 "../src/Photo.vala"
	_tmp10_ = _tmp9_;
#line 5061 "../src/Photo.vala"
	count = _tmp10_;
#line 38403 "Photo.c"
	{
		gint ctr = 0;
#line 5062 "../src/Photo.vala"
		ctr = 0;
#line 38408 "Photo.c"
		{
			gboolean _tmp11_ = FALSE;
#line 5062 "../src/Photo.vala"
			_tmp11_ = TRUE;
#line 5062 "../src/Photo.vala"
			while (TRUE) {
#line 38415 "Photo.c"
				PhotoRow* row = NULL;
				GeeArrayList* _tmp13_;
				gpointer _tmp14_;
				LibraryPhoto* photo = NULL;
				PhotoRow* _tmp15_;
				LibraryPhoto* _tmp16_;
				guint64 flags = 0ULL;
				PhotoRow* _tmp17_;
#line 5062 "../src/Photo.vala"
				if (!_tmp11_) {
#line 38426 "Photo.c"
					gint _tmp12_;
#line 5062 "../src/Photo.vala"
					_tmp12_ = ctr;
#line 5062 "../src/Photo.vala"
					ctr = _tmp12_ + 1;
#line 38432 "Photo.c"
				}
#line 5062 "../src/Photo.vala"
				_tmp11_ = FALSE;
#line 5062 "../src/Photo.vala"
				if (!(ctr < count)) {
#line 5062 "../src/Photo.vala"
					break;
#line 38440 "Photo.c"
				}
#line 5063 "../src/Photo.vala"
				_tmp13_ = all;
#line 5063 "../src/Photo.vala"
				_tmp14_ = gee_abstract_list_get (G_TYPE_CHECK_INSTANCE_CAST (_tmp13_, GEE_TYPE_ABSTRACT_LIST, GeeAbstractList), ctr);
#line 5063 "../src/Photo.vala"
				row = (PhotoRow*) _tmp14_;
#line 5064 "../src/Photo.vala"
				_tmp15_ = row;
#line 5064 "../src/Photo.vala"
				_tmp16_ = library_photo_new (_tmp15_);
#line 5064 "../src/Photo.vala"
				photo = _tmp16_;
#line 5065 "../src/Photo.vala"
				_tmp17_ = row;
#line 5065 "../src/Photo.vala"
				flags = _tmp17_->flags;
#line 5067 "../src/Photo.vala"
				if ((flags & LIBRARY_PHOTO_FLAG_TRASH) != ((guint64) 0)) {
#line 38460 "Photo.c"
					GeeArrayList* _tmp18_;
					LibraryPhoto* _tmp19_;
#line 5068 "../src/Photo.vala"
					_tmp18_ = trashed_photos;
#line 5068 "../src/Photo.vala"
					_tmp19_ = photo;
#line 5068 "../src/Photo.vala"
					gee_abstract_collection_add (G_TYPE_CHECK_INSTANCE_CAST (_tmp18_, GEE_TYPE_ABSTRACT_COLLECTION, GeeAbstractCollection), _tmp19_);
#line 38469 "Photo.c"
				} else {
#line 5069 "../src/Photo.vala"
					if ((flags & LIBRARY_PHOTO_FLAG_OFFLINE) != ((guint64) 0)) {
#line 38473 "Photo.c"
						GeeArrayList* _tmp20_;
						LibraryPhoto* _tmp21_;
#line 5070 "../src/Photo.vala"
						_tmp20_ = offline_photos;
#line 5070 "../src/Photo.vala"
						_tmp21_ = photo;
#line 5070 "../src/Photo.vala"
						gee_abstract_collection_add (G_TYPE_CHECK_INSTANCE_CAST (_tmp20_, GEE_TYPE_ABSTRACT_COLLECTION, GeeAbstractCollection), _tmp21_);
#line 38482 "Photo.c"
					} else {
						GeeArrayList* _tmp22_;
						LibraryPhoto* _tmp23_;
#line 5072 "../src/Photo.vala"
						_tmp22_ = all_photos;
#line 5072 "../src/Photo.vala"
						_tmp23_ = photo;
#line 5072 "../src/Photo.vala"
						gee_abstract_collection_add (G_TYPE_CHECK_INSTANCE_CAST (_tmp22_, GEE_TYPE_ABSTRACT_COLLECTION, GeeAbstractCollection), _tmp23_);
#line 38492 "Photo.c"
					}
				}
#line 5074 "../src/Photo.vala"
				if (monitor != NULL) {
#line 5075 "../src/Photo.vala"
					monitor ((guint64) ctr, (guint64) count, TRUE, monitor_target);
#line 38499 "Photo.c"
				}
#line 5062 "../src/Photo.vala"
				_g_object_unref0 (photo);
#line 5062 "../src/Photo.vala"
				_photo_row_unref0 (row);
#line 38505 "Photo.c"
			}
		}
	}
#line 5078 "../src/Photo.vala"
	_tmp24_ = library_photo_global;
#line 5078 "../src/Photo.vala"
	_tmp25_ = all_photos;
#line 5078 "../src/Photo.vala"
	_tmp26_ = data_collection_add_many (G_TYPE_CHECK_INSTANCE_CAST (_tmp24_, TYPE_DATA_COLLECTION, DataCollection), G_TYPE_CHECK_INSTANCE_CAST (_tmp25_, GEE_TYPE_COLLECTION, GeeCollection), NULL, NULL);
#line 5078 "../src/Photo.vala"
	_tmp27_ = _tmp26_;
#line 5078 "../src/Photo.vala"
	_g_object_unref0 (_tmp27_);
#line 5079 "../src/Photo.vala"
	_tmp28_ = library_photo_global;
#line 5079 "../src/Photo.vala"
	_tmp29_ = trashed_photos;
#line 5079 "../src/Photo.vala"
	media_source_collection_add_many_to_trash (G_TYPE_CHECK_INSTANCE_CAST (_tmp28_, TYPE_MEDIA_SOURCE_COLLECTION, MediaSourceCollection), G_TYPE_CHECK_INSTANCE_CAST (_tmp29_, GEE_TYPE_COLLECTION, GeeCollection));
#line 5080 "../src/Photo.vala"
	_tmp30_ = library_photo_global;
#line 5080 "../src/Photo.vala"
	_tmp31_ = offline_photos;
#line 5080 "../src/Photo.vala"
	media_source_collection_add_many_to_offline (G_TYPE_CHECK_INSTANCE_CAST (_tmp30_, TYPE_MEDIA_SOURCE_COLLECTION, MediaSourceCollection), G_TYPE_CHECK_INSTANCE_CAST (_tmp31_, GEE_TYPE_COLLECTION, GeeCollection));
#line 5050 "../src/Photo.vala"
	_g_object_unref0 (offline_photos);
#line 5050 "../src/Photo.vala"
	_g_object_unref0 (trashed_photos);
#line 5050 "../src/Photo.vala"
	_g_object_unref0 (all_photos);
#line 5050 "../src/Photo.vala"
	_g_object_unref0 (all);
#line 38539 "Photo.c"
}

void
library_photo_terminate (void)
{
#line 5084 "../src/Photo.vala"
	photo_terminate_photo ();
#line 38547 "Photo.c"
}

ImportResult
library_photo_import_create (PhotoImportParams* params,
                             LibraryPhoto** photo)
{
	LibraryPhoto* _vala_photo = NULL;
	PhotoID photo_id = {0};
	PhotoTable* _tmp0_;
	PhotoTable* _tmp1_;
	PhotoRow* _tmp2_;
	PhotoID _tmp3_ = {0};
	PhotoID _tmp4_;
	LibraryPhoto* _tmp5_;
	ImportResult result;
#line 5091 "../src/Photo.vala"
	g_return_val_if_fail (IS_PHOTO_IMPORT_PARAMS (params), 0);
#line 5093 "../src/Photo.vala"
	_tmp0_ = photo_table_get_instance ();
#line 5093 "../src/Photo.vala"
	_tmp1_ = _tmp0_;
#line 5093 "../src/Photo.vala"
	_tmp2_ = params->row;
#line 5093 "../src/Photo.vala"
	photo_table_add (_tmp1_, _tmp2_, &_tmp3_);
#line 5093 "../src/Photo.vala"
	_tmp4_ = _tmp3_;
#line 5093 "../src/Photo.vala"
	_database_table_unref0 (_tmp1_);
#line 5093 "../src/Photo.vala"
	photo_id = _tmp4_;
#line 5094 "../src/Photo.vala"
	if (photo_id_is_invalid (&photo_id)) {
#line 5095 "../src/Photo.vala"
		_g_object_unref0 (_vala_photo);
#line 5095 "../src/Photo.vala"
		_vala_photo = NULL;
#line 5097 "../src/Photo.vala"
		result = IMPORT_RESULT_DATABASE_ERROR;
#line 5097 "../src/Photo.vala"
		if (photo) {
#line 5097 "../src/Photo.vala"
			*photo = _vala_photo;
#line 38591 "Photo.c"
		} else {
#line 5097 "../src/Photo.vala"
			_g_object_unref0 (_vala_photo);
#line 38595 "Photo.c"
		}
#line 5097 "../src/Photo.vala"
		return result;
#line 38599 "Photo.c"
	}
#line 5101 "../src/Photo.vala"
	_tmp5_ = library_photo_new_from_import_params (params);
#line 5101 "../src/Photo.vala"
	_g_object_unref0 (_vala_photo);
#line 5101 "../src/Photo.vala"
	_vala_photo = _tmp5_;
#line 5103 "../src/Photo.vala"
	result = IMPORT_RESULT_SUCCESS;
#line 5103 "../src/Photo.vala"
	if (photo) {
#line 5103 "../src/Photo.vala"
		*photo = _vala_photo;
#line 38613 "Photo.c"
	} else {
#line 5103 "../src/Photo.vala"
		_g_object_unref0 (_vala_photo);
#line 38617 "Photo.c"
	}
#line 5103 "../src/Photo.vala"
	return result;
#line 38621 "Photo.c"
}

void
library_photo_import_failed (LibraryPhoto* photo)
{
	GError* _inner_error0_ = NULL;
#line 5106 "../src/Photo.vala"
	g_return_if_fail (IS_LIBRARY_PHOTO (photo));
#line 38630 "Photo.c"
	{
		PhotoTable* _tmp0_;
		PhotoTable* _tmp1_;
		PhotoID _tmp2_ = {0};
#line 5108 "../src/Photo.vala"
		_tmp0_ = photo_table_get_instance ();
#line 5108 "../src/Photo.vala"
		_tmp1_ = _tmp0_;
#line 5108 "../src/Photo.vala"
		photo_get_photo_id (G_TYPE_CHECK_INSTANCE_CAST (photo, TYPE_PHOTO, Photo), &_tmp2_);
#line 5108 "../src/Photo.vala"
		photo_table_remove (_tmp1_, &_tmp2_, &_inner_error0_);
#line 5108 "../src/Photo.vala"
		_database_table_unref0 (_tmp1_);
#line 5108 "../src/Photo.vala"
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 5108 "../src/Photo.vala"
			if (_inner_error0_->domain == DATABASE_ERROR) {
#line 38649 "Photo.c"
				goto __catch0_database_error;
			}
#line 5108 "../src/Photo.vala"
			g_critical ("file %s: line %d: unexpected error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 5108 "../src/Photo.vala"
			g_clear_error (&_inner_error0_);
#line 5108 "../src/Photo.vala"
			return;
#line 38658 "Photo.c"
		}
	}
	goto __finally0;
	__catch0_database_error:
	{
		GError* err = NULL;
		GError* _tmp3_;
#line 5107 "../src/Photo.vala"
		err = _inner_error0_;
#line 5107 "../src/Photo.vala"
		_inner_error0_ = NULL;
#line 5110 "../src/Photo.vala"
		_tmp3_ = err;
#line 5110 "../src/Photo.vala"
		app_window_database_error (_tmp3_);
#line 5107 "../src/Photo.vala"
		_g_error_free0 (err);
#line 38676 "Photo.c"
	}
	__finally0:
#line 5107 "../src/Photo.vala"
	if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 5107 "../src/Photo.vala"
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 5107 "../src/Photo.vala"
		g_clear_error (&_inner_error0_);
#line 5107 "../src/Photo.vala"
		return;
#line 38687 "Photo.c"
	}
}

static void
library_photo_real_notify_master_reimported (Photo* base,
                                             PhotoMetadata* metadata)
{
	LibraryPhoto * self;
	LibraryPhotoSourceCollection* _tmp0_;
#line 5114 "../src/Photo.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (base, TYPE_LIBRARY_PHOTO, LibraryPhoto);
#line 5114 "../src/Photo.vala"
	g_return_if_fail ((metadata == NULL) || IS_PHOTO_METADATA (metadata));
#line 5115 "../src/Photo.vala"
	PHOTO_CLASS (library_photo_parent_class)->notify_master_reimported (G_TYPE_CHECK_INSTANCE_CAST (self, TYPE_PHOTO, Photo), metadata);
#line 5117 "../src/Photo.vala"
	_tmp0_ = library_photo_global;
#line 5117 "../src/Photo.vala"
	library_photo_source_collection_notify_master_reimported (_tmp0_, self, metadata);
#line 38707 "Photo.c"
}

static void
library_photo_real_notify_editable_reimported (Photo* base,
                                               PhotoMetadata* metadata)
{
	LibraryPhoto * self;
	LibraryPhotoSourceCollection* _tmp0_;
#line 5120 "../src/Photo.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (base, TYPE_LIBRARY_PHOTO, LibraryPhoto);
#line 5120 "../src/Photo.vala"
	g_return_if_fail ((metadata == NULL) || IS_PHOTO_METADATA (metadata));
#line 5121 "../src/Photo.vala"
	PHOTO_CLASS (library_photo_parent_class)->notify_editable_reimported (G_TYPE_CHECK_INSTANCE_CAST (self, TYPE_PHOTO, Photo), metadata);
#line 5123 "../src/Photo.vala"
	_tmp0_ = library_photo_global;
#line 5123 "../src/Photo.vala"
	library_photo_source_collection_notify_editable_reimported (_tmp0_, self, metadata);
#line 38726 "Photo.c"
}

static void
library_photo_real_notify_source_reimported (Photo* base,
                                             PhotoMetadata* metadata)
{
	LibraryPhoto * self;
	LibraryPhotoSourceCollection* _tmp0_;
#line 5126 "../src/Photo.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (base, TYPE_LIBRARY_PHOTO, LibraryPhoto);
#line 5126 "../src/Photo.vala"
	g_return_if_fail ((metadata == NULL) || IS_PHOTO_METADATA (metadata));
#line 5127 "../src/Photo.vala"
	PHOTO_CLASS (library_photo_parent_class)->notify_source_reimported (G_TYPE_CHECK_INSTANCE_CAST (self, TYPE_PHOTO, Photo), metadata);
#line 5129 "../src/Photo.vala"
	_tmp0_ = library_photo_global;
#line 5129 "../src/Photo.vala"
	library_photo_source_collection_notify_source_reimported (_tmp0_, self, metadata);
#line 38745 "Photo.c"
}

static void
library_photo_real_notify_baseline_reimported (Photo* base,
                                               PhotoMetadata* metadata)
{
	LibraryPhoto * self;
	LibraryPhotoSourceCollection* _tmp0_;
#line 5132 "../src/Photo.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (base, TYPE_LIBRARY_PHOTO, LibraryPhoto);
#line 5132 "../src/Photo.vala"
	g_return_if_fail ((metadata == NULL) || IS_PHOTO_METADATA (metadata));
#line 5133 "../src/Photo.vala"
	PHOTO_CLASS (library_photo_parent_class)->notify_baseline_reimported (G_TYPE_CHECK_INSTANCE_CAST (self, TYPE_PHOTO, Photo), metadata);
#line 5135 "../src/Photo.vala"
	_tmp0_ = library_photo_global;
#line 5135 "../src/Photo.vala"
	library_photo_source_collection_notify_baseline_reimported (_tmp0_, self, metadata);
#line 38764 "Photo.c"
}

static void
library_photo_generate_thumbnails (LibraryPhoto* self)
{
	GError* _inner_error0_ = NULL;
#line 5138 "../src/Photo.vala"
	g_return_if_fail (IS_LIBRARY_PHOTO (self));
#line 38773 "Photo.c"
	{
#line 5140 "../src/Photo.vala"
		thumbnail_cache_import_from_source (G_TYPE_CHECK_INSTANCE_CAST (self, TYPE_THUMBNAIL_SOURCE, ThumbnailSource), TRUE, &_inner_error0_);
#line 5140 "../src/Photo.vala"
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 38779 "Photo.c"
			goto __catch0_g_error;
		}
	}
	goto __finally0;
	__catch0_g_error:
	{
		GError* err = NULL;
		gchar* _tmp0_;
		gchar* _tmp1_;
		GError* _tmp2_;
		const gchar* _tmp3_;
#line 5139 "../src/Photo.vala"
		err = _inner_error0_;
#line 5139 "../src/Photo.vala"
		_inner_error0_ = NULL;
#line 5142 "../src/Photo.vala"
		_tmp0_ = data_object_to_string (G_TYPE_CHECK_INSTANCE_CAST (self, TYPE_DATA_OBJECT, DataObject));
#line 5142 "../src/Photo.vala"
		_tmp1_ = _tmp0_;
#line 5142 "../src/Photo.vala"
		_tmp2_ = err;
#line 5142 "../src/Photo.vala"
		_tmp3_ = _tmp2_->message;
#line 5142 "../src/Photo.vala"
		g_warning ("Photo.vala:5142: Unable to generate thumbnails for %s: %s", _tmp1_, _tmp3_);
#line 5142 "../src/Photo.vala"
		_g_free0 (_tmp1_);
#line 5139 "../src/Photo.vala"
		_g_error_free0 (err);
#line 38809 "Photo.c"
	}
	__finally0:
#line 5139 "../src/Photo.vala"
	if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 5139 "../src/Photo.vala"
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 5139 "../src/Photo.vala"
		g_clear_error (&_inner_error0_);
#line 5139 "../src/Photo.vala"
		return;
#line 38820 "Photo.c"
	}
#line 5146 "../src/Photo.vala"
	thumbnail_source_notify_thumbnail_altered (G_TYPE_CHECK_INSTANCE_CAST (self, TYPE_THUMBNAIL_SOURCE, ThumbnailSource));
#line 38824 "Photo.c"
}

static void
library_photo_import_gps_metadata (LibraryPhoto* self)
{
	GpsCoords gps_coords = {0};
	PhotoMetadata* _tmp0_;
	PhotoMetadata* _tmp1_;
	GpsCoords _tmp2_ = {0};
	GpsCoords _tmp3_;
	GpsCoords _tmp4_;
#line 5149 "../src/Photo.vala"
	g_return_if_fail (IS_LIBRARY_PHOTO (self));
#line 5150 "../src/Photo.vala"
	_tmp0_ = photo_source_get_metadata (G_TYPE_CHECK_INSTANCE_CAST (self, TYPE_PHOTO_SOURCE, PhotoSource));
#line 5150 "../src/Photo.vala"
	_tmp1_ = _tmp0_;
#line 5150 "../src/Photo.vala"
	photo_metadata_get_gps_coords (_tmp1_, &_tmp2_);
#line 5150 "../src/Photo.vala"
	_tmp3_ = _tmp2_;
#line 5150 "../src/Photo.vala"
	_media_metadata_unref0 (_tmp1_);
#line 5150 "../src/Photo.vala"
	gps_coords = _tmp3_;
#line 5151 "../src/Photo.vala"
	_tmp4_ = gps_coords;
#line 5151 "../src/Photo.vala"
	positionable_set_gps_coords (G_TYPE_CHECK_INSTANCE_CAST (self, TYPE_POSITIONABLE, Positionable), &_tmp4_);
#line 38854 "Photo.c"
}

GeeCollection*
library_photo_get_import_keywords (LibraryPhoto* self)
{
	GeeCollection* _tmp0_;
	GeeCollection* _tmp1_;
	GeeCollection* result;
#line 5155 "../src/Photo.vala"
	g_return_val_if_fail (IS_LIBRARY_PHOTO (self), NULL);
#line 5156 "../src/Photo.vala"
	_tmp0_ = self->priv->import_keywords;
#line 5156 "../src/Photo.vala"
	_tmp1_ = _g_object_ref0 (_tmp0_);
#line 5156 "../src/Photo.vala"
	result = _tmp1_;
#line 5156 "../src/Photo.vala"
	return result;
#line 38873 "Photo.c"
}

void
library_photo_clear_import_keywords (LibraryPhoto* self)
{
#line 5159 "../src/Photo.vala"
	g_return_if_fail (IS_LIBRARY_PHOTO (self));
#line 5160 "../src/Photo.vala"
	_g_object_unref0 (self->priv->import_keywords);
#line 5160 "../src/Photo.vala"
	self->priv->import_keywords = NULL;
#line 38885 "Photo.c"
}

static void
library_photo_real_notify_altered (DataObject* base,
                                   Alteration* alteration)
{
	LibraryPhoto * self;
	gboolean _tmp0_ = FALSE;
#line 5163 "../src/Photo.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (base, TYPE_LIBRARY_PHOTO, LibraryPhoto);
#line 5163 "../src/Photo.vala"
	g_return_if_fail (IS_ALTERATION (alteration));
#line 5165 "../src/Photo.vala"
	if (!self->priv->block_thumbnail_generation) {
#line 5165 "../src/Photo.vala"
		_tmp0_ = alteration_has_subject (alteration, "image");
#line 38902 "Photo.c"
	} else {
#line 5165 "../src/Photo.vala"
		_tmp0_ = FALSE;
#line 38906 "Photo.c"
	}
#line 5165 "../src/Photo.vala"
	if (_tmp0_) {
#line 38910 "Photo.c"
		OneShotScheduler* _tmp1_;
#line 5166 "../src/Photo.vala"
		_tmp1_ = self->priv->thumbnail_scheduler;
#line 5166 "../src/Photo.vala"
		one_shot_scheduler_at_priority_idle (_tmp1_, G_PRIORITY_LOW);
#line 38916 "Photo.c"
	}
#line 5168 "../src/Photo.vala"
	DATA_OBJECT_CLASS (library_photo_parent_class)->notify_altered (G_TYPE_CHECK_INSTANCE_CAST (G_TYPE_CHECK_INSTANCE_CAST (self, TYPE_PHOTO, Photo), TYPE_DATA_OBJECT, DataObject), alteration);
#line 38920 "Photo.c"
}

static GdkPixbuf*
library_photo_real_get_preview_pixbuf (MediaSource* base,
                                       Scaling* scaling,
                                       GError** error)
{
	LibraryPhoto * self;
	GdkPixbuf* pixbuf = NULL;
	GdkPixbuf* _tmp0_;
	GdkPixbuf* _tmp1_;
	GError* _inner_error0_ = NULL;
	GdkPixbuf* result;
#line 5171 "../src/Photo.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (base, TYPE_LIBRARY_PHOTO, LibraryPhoto);
#line 5171 "../src/Photo.vala"
	g_return_val_if_fail (scaling != NULL, NULL);
#line 5172 "../src/Photo.vala"
	_tmp0_ = thumbnail_source_get_thumbnail (G_TYPE_CHECK_INSTANCE_CAST (self, TYPE_THUMBNAIL_SOURCE, ThumbnailSource), (gint) THUMBNAIL_CACHE_SIZE_BIG, &_inner_error0_);
#line 5172 "../src/Photo.vala"
	pixbuf = _tmp0_;
#line 5172 "../src/Photo.vala"
	if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 5172 "../src/Photo.vala"
		g_propagate_error (error, _inner_error0_);
#line 5172 "../src/Photo.vala"
		return NULL;
#line 38948 "Photo.c"
	}
#line 5174 "../src/Photo.vala"
	_tmp1_ = scaling_perform_on_pixbuf (scaling, pixbuf, GDK_INTERP_BILINEAR, TRUE);
#line 5174 "../src/Photo.vala"
	result = _tmp1_;
#line 5174 "../src/Photo.vala"
	_g_object_unref0 (pixbuf);
#line 5174 "../src/Photo.vala"
	return result;
#line 38958 "Photo.c"
}

static void
library_photo_real_rotate (Photo* base,
                           Rotation rotation)
{
	LibraryPhoto * self;
	GError* _inner_error0_ = NULL;
#line 5177 "../src/Photo.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (base, TYPE_LIBRARY_PHOTO, LibraryPhoto);
#line 5179 "../src/Photo.vala"
	self->priv->block_thumbnail_generation = TRUE;
#line 5180 "../src/Photo.vala"
	PHOTO_CLASS (library_photo_parent_class)->rotate (G_TYPE_CHECK_INSTANCE_CAST (self, TYPE_PHOTO, Photo), rotation);
#line 5181 "../src/Photo.vala"
	self->priv->block_thumbnail_generation = FALSE;
#line 38975 "Photo.c"
	{
#line 5189 "../src/Photo.vala"
		thumbnail_cache_rotate (G_TYPE_CHECK_INSTANCE_CAST (self, TYPE_THUMBNAIL_SOURCE, ThumbnailSource), rotation, &_inner_error0_);
#line 5189 "../src/Photo.vala"
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 38981 "Photo.c"
			goto __catch0_g_error;
		}
	}
	goto __finally0;
	__catch0_g_error:
	{
		GError* err = NULL;
		gchar* _tmp0_;
		gchar* _tmp1_;
		GError* _tmp2_;
		const gchar* _tmp3_;
#line 5188 "../src/Photo.vala"
		err = _inner_error0_;
#line 5188 "../src/Photo.vala"
		_inner_error0_ = NULL;
#line 5192 "../src/Photo.vala"
		_tmp0_ = data_object_to_string (G_TYPE_CHECK_INSTANCE_CAST (self, TYPE_DATA_OBJECT, DataObject));
#line 5192 "../src/Photo.vala"
		_tmp1_ = _tmp0_;
#line 5192 "../src/Photo.vala"
		_tmp2_ = err;
#line 5192 "../src/Photo.vala"
		_tmp3_ = _tmp2_->message;
#line 5192 "../src/Photo.vala"
		g_warning ("Photo.vala:5192: Unable to update thumbnails for %s: %s", _tmp1_, _tmp3_);
#line 5192 "../src/Photo.vala"
		_g_free0 (_tmp1_);
#line 5188 "../src/Photo.vala"
		_g_error_free0 (err);
#line 39011 "Photo.c"
	}
	__finally0:
#line 5188 "../src/Photo.vala"
	if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 5188 "../src/Photo.vala"
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 5188 "../src/Photo.vala"
		g_clear_error (&_inner_error0_);
#line 5188 "../src/Photo.vala"
		return;
#line 39022 "Photo.c"
	}
#line 5195 "../src/Photo.vala"
	thumbnail_source_notify_thumbnail_altered (G_TYPE_CHECK_INSTANCE_CAST (self, TYPE_THUMBNAIL_SOURCE, ThumbnailSource));
#line 39026 "Photo.c"
}

static GdkPixbuf*
library_photo_real_get_thumbnail (ThumbnailSource* base,
                                  gint scale,
                                  GError** error)
{
	LibraryPhoto * self;
	GdkPixbuf* _tmp0_ = NULL;
	GdkPixbuf* _tmp1_;
	GdkPixbuf* _tmp2_;
	GError* _inner_error0_ = NULL;
	GdkPixbuf* result;
#line 5199 "../src/Photo.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (base, TYPE_LIBRARY_PHOTO, LibraryPhoto);
#line 5200 "../src/Photo.vala"
	_tmp1_ = thumbnail_cache_fetch (G_TYPE_CHECK_INSTANCE_CAST (self, TYPE_THUMBNAIL_SOURCE, ThumbnailSource), scale, &_inner_error0_);
#line 5200 "../src/Photo.vala"
	_tmp0_ = _tmp1_;
#line 5200 "../src/Photo.vala"
	if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 5200 "../src/Photo.vala"
		g_propagate_error (error, _inner_error0_);
#line 5200 "../src/Photo.vala"
		return NULL;
#line 39052 "Photo.c"
	}
#line 5200 "../src/Photo.vala"
	_tmp2_ = _tmp0_;
#line 5200 "../src/Photo.vala"
	_tmp0_ = NULL;
#line 5200 "../src/Photo.vala"
	result = _tmp2_;
#line 5200 "../src/Photo.vala"
	_g_object_unref0 (_tmp0_);
#line 5200 "../src/Photo.vala"
	return result;
#line 39064 "Photo.c"
}

static void
_library_photo_on_duplicate_progress_gfile_progress_callback (gint64 current_num_bytes,
                                                              gint64 total_num_bytes,
                                                              gpointer self)
{
#line 5212 "../src/Photo.vala"
	library_photo_on_duplicate_progress ((LibraryPhoto*) self, current_num_bytes, total_num_bytes);
#line 39074 "Photo.c"
}

static void
library_photo_duplicate_backing_photo (LibraryPhoto* self,
                                       BackingPhotoRow* backing,
                                       BackingPhotoID* result,
                                       GError** error)
{
	BackingPhotoID backing_id = {0};
	gboolean _tmp0_ = FALSE;
	GFile* file = NULL;
	const gchar* _tmp2_;
	GFile* _tmp3_;
	GFile* _tmp4_;
	GError* _inner_error0_ = NULL;
#line 5205 "../src/Photo.vala"
	g_return_if_fail (IS_LIBRARY_PHOTO (self));
#line 5205 "../src/Photo.vala"
	g_return_if_fail ((backing == NULL) || IS_BACKING_PHOTO_ROW (backing));
#line 5206 "../src/Photo.vala"
	backing_photo_id_init (&backing_id, BACKING_PHOTO_ID_INVALID);
#line 5207 "../src/Photo.vala"
	if (backing == NULL) {
#line 5207 "../src/Photo.vala"
		_tmp0_ = TRUE;
#line 39100 "Photo.c"
	} else {
		const gchar* _tmp1_;
#line 5207 "../src/Photo.vala"
		_tmp1_ = backing->filepath;
#line 5207 "../src/Photo.vala"
		_tmp0_ = _tmp1_ == NULL;
#line 39107 "Photo.c"
	}
#line 5207 "../src/Photo.vala"
	if (_tmp0_) {
#line 5208 "../src/Photo.vala"
		*result = backing_id;
#line 5208 "../src/Photo.vala"
		return;
#line 39115 "Photo.c"
	}
#line 5210 "../src/Photo.vala"
	_tmp2_ = backing->filepath;
#line 5210 "../src/Photo.vala"
	_tmp3_ = g_file_new_for_path (_tmp2_);
#line 5210 "../src/Photo.vala"
	file = _tmp3_;
#line 5211 "../src/Photo.vala"
	_tmp4_ = file;
#line 5211 "../src/Photo.vala"
	if (g_file_query_exists (_tmp4_, NULL)) {
#line 39127 "Photo.c"
		GFile* dupe_file = NULL;
		GFile* _tmp5_;
		GFile* _tmp6_;
		DetectedPhotoInformation* detected = NULL;
		BackingPhotoRow* state = NULL;
		GFile* _tmp7_;
		DetectedPhotoInformation* _tmp8_ = NULL;
		BackingPhotoRow* _tmp9_;
		BackingPhotoRow* _tmp10_;
#line 5212 "../src/Photo.vala"
		_tmp5_ = file;
#line 5212 "../src/Photo.vala"
		_tmp6_ = library_files_duplicate (_tmp5_, _library_photo_on_duplicate_progress_gfile_progress_callback, self, TRUE, &_inner_error0_);
#line 5212 "../src/Photo.vala"
		dupe_file = _tmp6_;
#line 5212 "../src/Photo.vala"
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 5212 "../src/Photo.vala"
			g_propagate_error (error, _inner_error0_);
#line 5212 "../src/Photo.vala"
			_g_object_unref0 (file);
#line 5212 "../src/Photo.vala"
			return;
#line 39151 "Photo.c"
		}
#line 5215 "../src/Photo.vala"
		_tmp7_ = dupe_file;
#line 5215 "../src/Photo.vala"
		_tmp9_ = photo_query_backing_photo_row (G_TYPE_CHECK_INSTANCE_CAST (self, TYPE_PHOTO, Photo), _tmp7_, PHOTO_FILE_SNIFFER_OPTIONS_NO_MD5, &_tmp8_, &_inner_error0_);
#line 5215 "../src/Photo.vala"
		_detected_photo_information_unref0 (detected);
#line 5215 "../src/Photo.vala"
		detected = _tmp8_;
#line 5215 "../src/Photo.vala"
		state = _tmp9_;
#line 5215 "../src/Photo.vala"
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 5215 "../src/Photo.vala"
			g_propagate_error (error, _inner_error0_);
#line 5215 "../src/Photo.vala"
			_detected_photo_information_unref0 (detected);
#line 5215 "../src/Photo.vala"
			_g_object_unref0 (dupe_file);
#line 5215 "../src/Photo.vala"
			_g_object_unref0 (file);
#line 5215 "../src/Photo.vala"
			return;
#line 39175 "Photo.c"
		}
#line 5217 "../src/Photo.vala"
		_tmp10_ = state;
#line 5217 "../src/Photo.vala"
		if (_tmp10_ != NULL) {
#line 39181 "Photo.c"
			BackingPhotoTable* _tmp11_;
			BackingPhotoTable* _tmp12_;
			BackingPhotoRow* _tmp13_;
			BackingPhotoRow* _tmp14_;
			BackingPhotoID _tmp15_;
#line 5218 "../src/Photo.vala"
			_tmp11_ = backing_photo_table_get_instance ();
#line 5218 "../src/Photo.vala"
			_tmp12_ = _tmp11_;
#line 5218 "../src/Photo.vala"
			_tmp13_ = state;
#line 5218 "../src/Photo.vala"
			backing_photo_table_add (_tmp12_, _tmp13_, &_inner_error0_);
#line 5218 "../src/Photo.vala"
			_database_table_unref0 (_tmp12_);
#line 5218 "../src/Photo.vala"
			if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 5218 "../src/Photo.vala"
				g_propagate_error (error, _inner_error0_);
#line 5218 "../src/Photo.vala"
				_backing_photo_row_unref0 (state);
#line 5218 "../src/Photo.vala"
				_detected_photo_information_unref0 (detected);
#line 5218 "../src/Photo.vala"
				_g_object_unref0 (dupe_file);
#line 5218 "../src/Photo.vala"
				_g_object_unref0 (file);
#line 5218 "../src/Photo.vala"
				return;
#line 39211 "Photo.c"
			}
#line 5219 "../src/Photo.vala"
			_tmp14_ = state;
#line 5219 "../src/Photo.vala"
			_tmp15_ = _tmp14_->id;
#line 5219 "../src/Photo.vala"
			backing_id = _tmp15_;
#line 39219 "Photo.c"
		}
#line 5211 "../src/Photo.vala"
		_backing_photo_row_unref0 (state);
#line 5211 "../src/Photo.vala"
		_detected_photo_information_unref0 (detected);
#line 5211 "../src/Photo.vala"
		_g_object_unref0 (dupe_file);
#line 39227 "Photo.c"
	}
#line 5223 "../src/Photo.vala"
	*result = backing_id;
#line 5223 "../src/Photo.vala"
	_g_object_unref0 (file);
#line 5223 "../src/Photo.vala"
	return;
#line 39235 "Photo.c"
}

LibraryPhoto*
library_photo_duplicate (LibraryPhoto* self,
                         GError** error)
{
	GFile* dupe_file = NULL;
	GFile* _tmp0_;
	GFile* _tmp1_;
	GFile* _tmp2_;
	GFile* _tmp3_;
	BackingPhotoID dupe_editable_id = {0};
	BackingPhotoRow* _tmp4_;
	BackingPhotoRow* _tmp5_;
	BackingPhotoID _tmp6_ = {0};
	BackingPhotoID _tmp7_;
	BackingPhotoID dupe_raw_shotwell_id = {0};
	BackingPhotoRow* _tmp8_;
	BackingPhotoRow* _tmp9_;
	BackingPhotoID _tmp10_ = {0};
	BackingPhotoID _tmp11_;
	BackingPhotoID dupe_raw_camera_id = {0};
	BackingPhotoRow* _tmp12_;
	BackingPhotoRow* _tmp13_;
	BackingPhotoID _tmp14_ = {0};
	BackingPhotoID _tmp15_;
	BackingPhotoID dupe_raw_embedded_id = {0};
	BackingPhotoRow* _tmp16_;
	BackingPhotoRow* _tmp17_;
	BackingPhotoID _tmp18_ = {0};
	BackingPhotoID _tmp19_;
	PhotoID dupe_id = {0};
	PhotoTable* _tmp20_;
	PhotoTable* _tmp21_;
	PhotoID _tmp22_ = {0};
	GFile* _tmp23_;
	gchar* _tmp24_;
	gchar* _tmp25_;
	BackingPhotoID _tmp26_;
	BackingPhotoID _tmp27_;
	BackingPhotoID _tmp28_;
	BackingPhotoID _tmp29_;
	PhotoID _tmp30_ = {0};
	PhotoID _tmp31_;
	PhotoRow* dupe_row = NULL;
	PhotoTable* _tmp32_;
	PhotoTable* _tmp33_;
	PhotoID _tmp34_;
	PhotoRow* _tmp35_;
	PhotoRow* _tmp36_;
	LibraryPhoto* dupe = NULL;
	PhotoRow* _tmp37_;
	LibraryPhoto* _tmp38_;
	LibraryPhoto* _tmp39_;
	LibraryPhotoSourceCollection* _tmp40_;
	LibraryPhoto* _tmp41_;
	LibraryPhoto* _tmp42_;
	Event* _tmp43_;
	Event* _tmp44_;
	gboolean _tmp45_;
	GeeCollection* tags = NULL;
	TagSourceCollection* _tmp50_;
	GeeList* _tmp51_;
	GeeCollection* _tmp52_;
	GeeCollection* faces = NULL;
	FaceSourceCollection* _tmp60_;
	GeeList* _tmp61_;
	GeeCollection* _tmp62_;
	GError* _inner_error0_ = NULL;
	LibraryPhoto* result;
#line 5226 "../src/Photo.vala"
	g_return_val_if_fail (IS_LIBRARY_PHOTO (self), NULL);
#line 5228 "../src/Photo.vala"
	_tmp0_ = media_source_get_master_file (G_TYPE_CHECK_INSTANCE_CAST (self, TYPE_MEDIA_SOURCE, MediaSource));
#line 5228 "../src/Photo.vala"
	_tmp1_ = _tmp0_;
#line 5228 "../src/Photo.vala"
	_tmp2_ = library_files_duplicate (_tmp1_, _library_photo_on_duplicate_progress_gfile_progress_callback, self, TRUE, &_inner_error0_);
#line 5228 "../src/Photo.vala"
	_tmp3_ = _tmp2_;
#line 5228 "../src/Photo.vala"
	_g_object_unref0 (_tmp1_);
#line 5228 "../src/Photo.vala"
	dupe_file = _tmp3_;
#line 5228 "../src/Photo.vala"
	if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 5228 "../src/Photo.vala"
		g_propagate_error (error, _inner_error0_);
#line 5228 "../src/Photo.vala"
		return NULL;
#line 39326 "Photo.c"
	}
#line 5231 "../src/Photo.vala"
	_tmp4_ = photo_get_editable_photo_row (G_TYPE_CHECK_INSTANCE_CAST (self, TYPE_PHOTO, Photo));
#line 5231 "../src/Photo.vala"
	_tmp5_ = _tmp4_;
#line 5231 "../src/Photo.vala"
	library_photo_duplicate_backing_photo (self, _tmp5_, &_tmp6_, &_inner_error0_);
#line 5231 "../src/Photo.vala"
	_tmp7_ = _tmp6_;
#line 5231 "../src/Photo.vala"
	_backing_photo_row_unref0 (_tmp5_);
#line 5231 "../src/Photo.vala"
	dupe_editable_id = _tmp7_;
#line 5231 "../src/Photo.vala"
	if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 5231 "../src/Photo.vala"
		g_propagate_error (error, _inner_error0_);
#line 5231 "../src/Photo.vala"
		_g_object_unref0 (dupe_file);
#line 5231 "../src/Photo.vala"
		return NULL;
#line 39348 "Photo.c"
	}
#line 5232 "../src/Photo.vala"
	_tmp8_ = photo_get_raw_development_photo_row (G_TYPE_CHECK_INSTANCE_CAST (self, TYPE_PHOTO, Photo), RAW_DEVELOPER_SHOTWELL);
#line 5232 "../src/Photo.vala"
	_tmp9_ = _tmp8_;
#line 5232 "../src/Photo.vala"
	library_photo_duplicate_backing_photo (self, _tmp9_, &_tmp10_, &_inner_error0_);
#line 5232 "../src/Photo.vala"
	_tmp11_ = _tmp10_;
#line 5232 "../src/Photo.vala"
	_backing_photo_row_unref0 (_tmp9_);
#line 5232 "../src/Photo.vala"
	dupe_raw_shotwell_id = _tmp11_;
#line 5232 "../src/Photo.vala"
	if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 5232 "../src/Photo.vala"
		g_propagate_error (error, _inner_error0_);
#line 5232 "../src/Photo.vala"
		_g_object_unref0 (dupe_file);
#line 5232 "../src/Photo.vala"
		return NULL;
#line 39370 "Photo.c"
	}
#line 5234 "../src/Photo.vala"
	_tmp12_ = photo_get_raw_development_photo_row (G_TYPE_CHECK_INSTANCE_CAST (self, TYPE_PHOTO, Photo), RAW_DEVELOPER_CAMERA);
#line 5234 "../src/Photo.vala"
	_tmp13_ = _tmp12_;
#line 5234 "../src/Photo.vala"
	library_photo_duplicate_backing_photo (self, _tmp13_, &_tmp14_, &_inner_error0_);
#line 5234 "../src/Photo.vala"
	_tmp15_ = _tmp14_;
#line 5234 "../src/Photo.vala"
	_backing_photo_row_unref0 (_tmp13_);
#line 5234 "../src/Photo.vala"
	dupe_raw_camera_id = _tmp15_;
#line 5234 "../src/Photo.vala"
	if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 5234 "../src/Photo.vala"
		g_propagate_error (error, _inner_error0_);
#line 5234 "../src/Photo.vala"
		_g_object_unref0 (dupe_file);
#line 5234 "../src/Photo.vala"
		return NULL;
#line 39392 "Photo.c"
	}
#line 5236 "../src/Photo.vala"
	_tmp16_ = photo_get_raw_development_photo_row (G_TYPE_CHECK_INSTANCE_CAST (self, TYPE_PHOTO, Photo), RAW_DEVELOPER_EMBEDDED);
#line 5236 "../src/Photo.vala"
	_tmp17_ = _tmp16_;
#line 5236 "../src/Photo.vala"
	library_photo_duplicate_backing_photo (self, _tmp17_, &_tmp18_, &_inner_error0_);
#line 5236 "../src/Photo.vala"
	_tmp19_ = _tmp18_;
#line 5236 "../src/Photo.vala"
	_backing_photo_row_unref0 (_tmp17_);
#line 5236 "../src/Photo.vala"
	dupe_raw_embedded_id = _tmp19_;
#line 5236 "../src/Photo.vala"
	if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 5236 "../src/Photo.vala"
		g_propagate_error (error, _inner_error0_);
#line 5236 "../src/Photo.vala"
		_g_object_unref0 (dupe_file);
#line 5236 "../src/Photo.vala"
		return NULL;
#line 39414 "Photo.c"
	}
#line 5240 "../src/Photo.vala"
	_tmp20_ = photo_table_get_instance ();
#line 5240 "../src/Photo.vala"
	_tmp21_ = _tmp20_;
#line 5240 "../src/Photo.vala"
	photo_get_photo_id (G_TYPE_CHECK_INSTANCE_CAST (self, TYPE_PHOTO, Photo), &_tmp22_);
#line 5240 "../src/Photo.vala"
	_tmp23_ = dupe_file;
#line 5240 "../src/Photo.vala"
	_tmp24_ = g_file_get_path (_tmp23_);
#line 5240 "../src/Photo.vala"
	_tmp25_ = _tmp24_;
#line 5240 "../src/Photo.vala"
	_tmp26_ = dupe_editable_id;
#line 5240 "../src/Photo.vala"
	_tmp27_ = dupe_raw_shotwell_id;
#line 5240 "../src/Photo.vala"
	_tmp28_ = dupe_raw_camera_id;
#line 5240 "../src/Photo.vala"
	_tmp29_ = dupe_raw_embedded_id;
#line 5240 "../src/Photo.vala"
	photo_table_duplicate (_tmp21_, &_tmp22_, _tmp25_, &_tmp26_, &_tmp27_, &_tmp28_, &_tmp29_, &_tmp30_);
#line 5240 "../src/Photo.vala"
	_tmp31_ = _tmp30_;
#line 5240 "../src/Photo.vala"
	_g_free0 (_tmp25_);
#line 5240 "../src/Photo.vala"
	_database_table_unref0 (_tmp21_);
#line 5240 "../src/Photo.vala"
	dupe_id = _tmp31_;
#line 5242 "../src/Photo.vala"
	_tmp32_ = photo_table_get_instance ();
#line 5242 "../src/Photo.vala"
	_tmp33_ = _tmp32_;
#line 5242 "../src/Photo.vala"
	_tmp34_ = dupe_id;
#line 5242 "../src/Photo.vala"
	_tmp35_ = photo_table_get_row (_tmp33_, &_tmp34_);
#line 5242 "../src/Photo.vala"
	_tmp36_ = _tmp35_;
#line 5242 "../src/Photo.vala"
	_database_table_unref0 (_tmp33_);
#line 5242 "../src/Photo.vala"
	dupe_row = _tmp36_;
#line 5245 "../src/Photo.vala"
	_tmp37_ = dupe_row;
#line 5245 "../src/Photo.vala"
	_tmp38_ = library_photo_new (_tmp37_);
#line 5245 "../src/Photo.vala"
	dupe = _tmp38_;
#line 5248 "../src/Photo.vala"
	_tmp39_ = dupe;
#line 5248 "../src/Photo.vala"
	thumbnail_cache_duplicate (G_TYPE_CHECK_INSTANCE_CAST (self, TYPE_THUMBNAIL_SOURCE, ThumbnailSource), G_TYPE_CHECK_INSTANCE_CAST (_tmp39_, TYPE_THUMBNAIL_SOURCE, ThumbnailSource));
#line 5251 "../src/Photo.vala"
	_tmp40_ = library_photo_global;
#line 5251 "../src/Photo.vala"
	_tmp41_ = dupe;
#line 5251 "../src/Photo.vala"
	data_collection_add (G_TYPE_CHECK_INSTANCE_CAST (_tmp40_, TYPE_DATA_COLLECTION, DataCollection), G_TYPE_CHECK_INSTANCE_CAST (_tmp41_, TYPE_DATA_OBJECT, DataObject));
#line 5254 "../src/Photo.vala"
	_tmp42_ = dupe;
#line 5254 "../src/Photo.vala"
	_tmp43_ = media_source_get_event (G_TYPE_CHECK_INSTANCE_CAST (_tmp42_, TYPE_MEDIA_SOURCE, MediaSource));
#line 5254 "../src/Photo.vala"
	_tmp44_ = _tmp43_;
#line 5254 "../src/Photo.vala"
	_tmp45_ = _tmp44_ != NULL;
#line 5254 "../src/Photo.vala"
	_g_object_unref0 (_tmp44_);
#line 5254 "../src/Photo.vala"
	if (_tmp45_) {
#line 39488 "Photo.c"
		LibraryPhoto* _tmp46_;
		Event* _tmp47_;
		Event* _tmp48_;
		LibraryPhoto* _tmp49_;
#line 5255 "../src/Photo.vala"
		_tmp46_ = dupe;
#line 5255 "../src/Photo.vala"
		_tmp47_ = media_source_get_event (G_TYPE_CHECK_INSTANCE_CAST (_tmp46_, TYPE_MEDIA_SOURCE, MediaSource));
#line 5255 "../src/Photo.vala"
		_tmp48_ = _tmp47_;
#line 5255 "../src/Photo.vala"
		_tmp49_ = dupe;
#line 5255 "../src/Photo.vala"
		event_attach (_tmp48_, G_TYPE_CHECK_INSTANCE_CAST (_tmp49_, TYPE_MEDIA_SOURCE, MediaSource));
#line 5255 "../src/Photo.vala"
		_g_object_unref0 (_tmp48_);
#line 39505 "Photo.c"
	}
#line 5258 "../src/Photo.vala"
	_tmp50_ = tag_global;
#line 5258 "../src/Photo.vala"
	_tmp51_ = tag_source_collection_fetch_for_source (_tmp50_, G_TYPE_CHECK_INSTANCE_CAST (self, TYPE_MEDIA_SOURCE, MediaSource));
#line 5258 "../src/Photo.vala"
	tags = G_TYPE_CHECK_INSTANCE_CAST (_tmp51_, GEE_TYPE_COLLECTION, GeeCollection);
#line 5259 "../src/Photo.vala"
	_tmp52_ = tags;
#line 5259 "../src/Photo.vala"
	if (_tmp52_ != NULL) {
#line 39517 "Photo.c"
		{
			GeeIterator* _tag_it = NULL;
			GeeCollection* _tmp53_;
			GeeIterator* _tmp54_;
#line 5260 "../src/Photo.vala"
			_tmp53_ = tags;
#line 5260 "../src/Photo.vala"
			_tmp54_ = gee_iterable_iterator (G_TYPE_CHECK_INSTANCE_CAST (_tmp53_, GEE_TYPE_ITERABLE, GeeIterable));
#line 5260 "../src/Photo.vala"
			_tag_it = _tmp54_;
#line 5260 "../src/Photo.vala"
			while (TRUE) {
#line 39530 "Photo.c"
				GeeIterator* _tmp55_;
				Tag* tag = NULL;
				GeeIterator* _tmp56_;
				gpointer _tmp57_;
				Tag* _tmp58_;
				LibraryPhoto* _tmp59_;
#line 5260 "../src/Photo.vala"
				_tmp55_ = _tag_it;
#line 5260 "../src/Photo.vala"
				if (!gee_iterator_next (_tmp55_)) {
#line 5260 "../src/Photo.vala"
					break;
#line 39543 "Photo.c"
				}
#line 5260 "../src/Photo.vala"
				_tmp56_ = _tag_it;
#line 5260 "../src/Photo.vala"
				_tmp57_ = gee_iterator_get (_tmp56_);
#line 5260 "../src/Photo.vala"
				tag = (Tag*) _tmp57_;
#line 5261 "../src/Photo.vala"
				_tmp58_ = tag;
#line 5261 "../src/Photo.vala"
				_tmp59_ = dupe;
#line 5261 "../src/Photo.vala"
				tag_attach (_tmp58_, G_TYPE_CHECK_INSTANCE_CAST (_tmp59_, TYPE_MEDIA_SOURCE, MediaSource));
#line 5260 "../src/Photo.vala"
				_g_object_unref0 (tag);
#line 39559 "Photo.c"
			}
#line 5260 "../src/Photo.vala"
			_g_object_unref0 (_tag_it);
#line 39563 "Photo.c"
		}
	}
#line 5266 "../src/Photo.vala"
	_tmp60_ = face_global;
#line 5266 "../src/Photo.vala"
	_tmp61_ = face_source_collection_fetch_for_source (_tmp60_, G_TYPE_CHECK_INSTANCE_CAST (self, TYPE_MEDIA_SOURCE, MediaSource));
#line 5266 "../src/Photo.vala"
	faces = G_TYPE_CHECK_INSTANCE_CAST (_tmp61_, GEE_TYPE_COLLECTION, GeeCollection);
#line 5267 "../src/Photo.vala"
	_tmp62_ = faces;
#line 5267 "../src/Photo.vala"
	if (_tmp62_ != NULL) {
#line 39576 "Photo.c"
		{
			GeeIterator* _face_it = NULL;
			GeeCollection* _tmp63_;
			GeeIterator* _tmp64_;
#line 5268 "../src/Photo.vala"
			_tmp63_ = faces;
#line 5268 "../src/Photo.vala"
			_tmp64_ = gee_iterable_iterator (G_TYPE_CHECK_INSTANCE_CAST (_tmp63_, GEE_TYPE_ITERABLE, GeeIterable));
#line 5268 "../src/Photo.vala"
			_face_it = _tmp64_;
#line 5268 "../src/Photo.vala"
			while (TRUE) {
#line 39589 "Photo.c"
				GeeIterator* _tmp65_;
				Face* face = NULL;
				GeeIterator* _tmp66_;
				gpointer _tmp67_;
				FaceLocation* location = NULL;
				Face* _tmp68_;
				FaceID _tmp69_ = {0};
				PhotoID _tmp70_ = {0};
				FaceLocation* _tmp71_;
				FaceLocation* _tmp72_;
#line 5268 "../src/Photo.vala"
				_tmp65_ = _face_it;
#line 5268 "../src/Photo.vala"
				if (!gee_iterator_next (_tmp65_)) {
#line 5268 "../src/Photo.vala"
					break;
#line 39606 "Photo.c"
				}
#line 5268 "../src/Photo.vala"
				_tmp66_ = _face_it;
#line 5268 "../src/Photo.vala"
				_tmp67_ = gee_iterator_get (_tmp66_);
#line 5268 "../src/Photo.vala"
				face = (Face*) _tmp67_;
#line 5269 "../src/Photo.vala"
				_tmp68_ = face;
#line 5269 "../src/Photo.vala"
				face_get_face_id (_tmp68_, &_tmp69_);
#line 5269 "../src/Photo.vala"
				photo_get_photo_id (G_TYPE_CHECK_INSTANCE_CAST (self, TYPE_PHOTO, Photo), &_tmp70_);
#line 5269 "../src/Photo.vala"
				_tmp71_ = face_location_get_face_location (&_tmp69_, &_tmp70_);
#line 5269 "../src/Photo.vala"
				location = _tmp71_;
#line 5271 "../src/Photo.vala"
				_tmp72_ = location;
#line 5271 "../src/Photo.vala"
				if (_tmp72_ != NULL) {
#line 39628 "Photo.c"
					Face* _tmp73_;
					LibraryPhoto* _tmp74_;
					Face* _tmp75_;
					FaceID _tmp76_ = {0};
					LibraryPhoto* _tmp77_;
					PhotoID _tmp78_ = {0};
					FaceLocation* _tmp79_;
					FaceLocationData _tmp80_ = {0};
					FaceLocationData _tmp81_;
					FaceLocation* _tmp82_;
					FaceLocation* _tmp83_;
#line 5272 "../src/Photo.vala"
					_tmp73_ = face;
#line 5272 "../src/Photo.vala"
					_tmp74_ = dupe;
#line 5272 "../src/Photo.vala"
					face_attach (_tmp73_, G_TYPE_CHECK_INSTANCE_CAST (_tmp74_, TYPE_MEDIA_SOURCE, MediaSource));
#line 5273 "../src/Photo.vala"
					_tmp75_ = face;
#line 5273 "../src/Photo.vala"
					face_get_face_id (_tmp75_, &_tmp76_);
#line 5273 "../src/Photo.vala"
					_tmp77_ = dupe;
#line 5273 "../src/Photo.vala"
					photo_get_photo_id (G_TYPE_CHECK_INSTANCE_CAST (_tmp77_, TYPE_PHOTO, Photo), &_tmp78_);
#line 5273 "../src/Photo.vala"
					_tmp79_ = location;
#line 5273 "../src/Photo.vala"
					face_location_get_face_data (_tmp79_, &_tmp80_);
#line 5273 "../src/Photo.vala"
					_tmp81_ = _tmp80_;
#line 5273 "../src/Photo.vala"
					_tmp82_ = face_location_create (&_tmp76_, &_tmp78_, &_tmp81_);
#line 5273 "../src/Photo.vala"
					_tmp83_ = _tmp82_;
#line 5273 "../src/Photo.vala"
					_g_object_unref0 (_tmp83_);
#line 5273 "../src/Photo.vala"
					face_location_data_destroy (&_tmp81_);
#line 39668 "Photo.c"
				}
#line 5268 "../src/Photo.vala"
				_g_object_unref0 (location);
#line 5268 "../src/Photo.vala"
				_g_object_unref0 (face);
#line 39674 "Photo.c"
			}
#line 5268 "../src/Photo.vala"
			_g_object_unref0 (_face_it);
#line 39678 "Photo.c"
		}
	}
#line 5279 "../src/Photo.vala"
	result = dupe;
#line 5279 "../src/Photo.vala"
	_g_object_unref0 (faces);
#line 5279 "../src/Photo.vala"
	_g_object_unref0 (tags);
#line 5279 "../src/Photo.vala"
	_photo_row_unref0 (dupe_row);
#line 5279 "../src/Photo.vala"
	_g_object_unref0 (dupe_file);
#line 5279 "../src/Photo.vala"
	return result;
#line 39693 "Photo.c"
}

static void
library_photo_on_duplicate_progress (LibraryPhoto* self,
                                     gint64 current,
                                     gint64 total)
{
#line 5282 "../src/Photo.vala"
	g_return_if_fail (IS_LIBRARY_PHOTO (self));
#line 5283 "../src/Photo.vala"
	spin_event_loop ();
#line 39705 "Photo.c"
}

static void
library_photo_upgrade_rating_flags (LibraryPhoto* self,
                                    guint64 flags)
{
#line 5286 "../src/Photo.vala"
	g_return_if_fail (IS_LIBRARY_PHOTO (self));
#line 5287 "../src/Photo.vala"
	if ((flags & LIBRARY_PHOTO_FLAG_HIDDEN) != ((guint64) 0)) {
#line 5288 "../src/Photo.vala"
		media_source_set_rating (G_TYPE_CHECK_INSTANCE_CAST (self, TYPE_MEDIA_SOURCE, MediaSource), RATING_REJECTED);
#line 5289 "../src/Photo.vala"
		photo_remove_flags (G_TYPE_CHECK_INSTANCE_CAST (self, TYPE_PHOTO, Photo), LIBRARY_PHOTO_FLAG_HIDDEN, NULL);
#line 39720 "Photo.c"
	}
#line 5292 "../src/Photo.vala"
	if ((flags & LIBRARY_PHOTO_FLAG_FAVORITE) != ((guint64) 0)) {
#line 5293 "../src/Photo.vala"
		media_source_set_rating (G_TYPE_CHECK_INSTANCE_CAST (self, TYPE_MEDIA_SOURCE, MediaSource), RATING_FIVE);
#line 5294 "../src/Photo.vala"
		photo_remove_flags (G_TYPE_CHECK_INSTANCE_CAST (self, TYPE_PHOTO, Photo), LIBRARY_PHOTO_FLAG_FAVORITE, NULL);
#line 39728 "Photo.c"
	}
}

static gboolean
library_photo_real_is_trashed (MediaSource* base)
{
	LibraryPhoto * self;
	gboolean result;
#line 5299 "../src/Photo.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (base, TYPE_LIBRARY_PHOTO, LibraryPhoto);
#line 5300 "../src/Photo.vala"
	result = photo_is_flag_set (G_TYPE_CHECK_INSTANCE_CAST (self, TYPE_PHOTO, Photo), LIBRARY_PHOTO_FLAG_TRASH);
#line 5300 "../src/Photo.vala"
	return result;
#line 39743 "Photo.c"
}

static void
library_photo_real_trash (MediaSource* base)
{
	LibraryPhoto * self;
#line 5303 "../src/Photo.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (base, TYPE_LIBRARY_PHOTO, LibraryPhoto);
#line 5304 "../src/Photo.vala"
	photo_add_flags (G_TYPE_CHECK_INSTANCE_CAST (self, TYPE_PHOTO, Photo), LIBRARY_PHOTO_FLAG_TRASH, NULL);
#line 39754 "Photo.c"
}

static void
library_photo_real_untrash (MediaSource* base)
{
	LibraryPhoto * self;
#line 5307 "../src/Photo.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (base, TYPE_LIBRARY_PHOTO, LibraryPhoto);
#line 5308 "../src/Photo.vala"
	photo_remove_flags (G_TYPE_CHECK_INSTANCE_CAST (self, TYPE_PHOTO, Photo), LIBRARY_PHOTO_FLAG_TRASH, NULL);
#line 39765 "Photo.c"
}

static gboolean
library_photo_real_is_offline (Monitorable* base)
{
	LibraryPhoto * self;
	gboolean result;
#line 5311 "../src/Photo.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (base, TYPE_LIBRARY_PHOTO, LibraryPhoto);
#line 5312 "../src/Photo.vala"
	result = photo_is_flag_set (G_TYPE_CHECK_INSTANCE_CAST (self, TYPE_PHOTO, Photo), LIBRARY_PHOTO_FLAG_OFFLINE);
#line 5312 "../src/Photo.vala"
	return result;
#line 39779 "Photo.c"
}

static void
library_photo_real_mark_offline (Monitorable* base)
{
	LibraryPhoto * self;
#line 5315 "../src/Photo.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (base, TYPE_LIBRARY_PHOTO, LibraryPhoto);
#line 5316 "../src/Photo.vala"
	photo_add_flags (G_TYPE_CHECK_INSTANCE_CAST (self, TYPE_PHOTO, Photo), LIBRARY_PHOTO_FLAG_OFFLINE, NULL);
#line 39790 "Photo.c"
}

static void
library_photo_real_mark_online (Monitorable* base)
{
	LibraryPhoto * self;
#line 5319 "../src/Photo.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (base, TYPE_LIBRARY_PHOTO, LibraryPhoto);
#line 5320 "../src/Photo.vala"
	photo_remove_flags (G_TYPE_CHECK_INSTANCE_CAST (self, TYPE_PHOTO, Photo), LIBRARY_PHOTO_FLAG_OFFLINE, NULL);
#line 39801 "Photo.c"
}

static gboolean
library_photo_real_is_flagged (Flaggable* base)
{
	LibraryPhoto * self;
	gboolean result;
#line 5323 "../src/Photo.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (base, TYPE_LIBRARY_PHOTO, LibraryPhoto);
#line 5324 "../src/Photo.vala"
	result = photo_is_flag_set (G_TYPE_CHECK_INSTANCE_CAST (self, TYPE_PHOTO, Photo), LIBRARY_PHOTO_FLAG_FLAGGED);
#line 5324 "../src/Photo.vala"
	return result;
#line 39815 "Photo.c"
}

static void
library_photo_real_mark_flagged (Flaggable* base)
{
	LibraryPhoto * self;
	Alteration* _tmp0_;
	Alteration* _tmp1_;
#line 5327 "../src/Photo.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (base, TYPE_LIBRARY_PHOTO, LibraryPhoto);
#line 5328 "../src/Photo.vala"
	_tmp0_ = alteration_new ("metadata", "flagged");
#line 5328 "../src/Photo.vala"
	_tmp1_ = _tmp0_;
#line 5328 "../src/Photo.vala"
	photo_add_flags (G_TYPE_CHECK_INSTANCE_CAST (self, TYPE_PHOTO, Photo), LIBRARY_PHOTO_FLAG_FLAGGED, _tmp1_);
#line 5328 "../src/Photo.vala"
	_alteration_unref0 (_tmp1_);
#line 39834 "Photo.c"
}

static void
library_photo_real_mark_unflagged (Flaggable* base)
{
	LibraryPhoto * self;
	Alteration* _tmp0_;
	Alteration* _tmp1_;
#line 5331 "../src/Photo.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (base, TYPE_LIBRARY_PHOTO, LibraryPhoto);
#line 5332 "../src/Photo.vala"
	_tmp0_ = alteration_new ("metadata", "flagged");
#line 5332 "../src/Photo.vala"
	_tmp1_ = _tmp0_;
#line 5332 "../src/Photo.vala"
	photo_remove_flags (G_TYPE_CHECK_INSTANCE_CAST (self, TYPE_PHOTO, Photo), LIBRARY_PHOTO_FLAG_FLAGGED, _tmp1_);
#line 5332 "../src/Photo.vala"
	_alteration_unref0 (_tmp1_);
#line 39853 "Photo.c"
}

static gboolean
library_photo_real_internal_delete_backing (DataSource* base,
                                            GError** error)
{
	LibraryPhoto * self;
	gboolean _tmp0_ = FALSE;
	GError* _inner_error0_ = NULL;
	gboolean result;
#line 5335 "../src/Photo.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (base, TYPE_LIBRARY_PHOTO, LibraryPhoto);
#line 5338 "../src/Photo.vala"
	_tmp0_ = DATA_SOURCE_CLASS (library_photo_parent_class)->internal_delete_backing (G_TYPE_CHECK_INSTANCE_CAST (G_TYPE_CHECK_INSTANCE_CAST (self, TYPE_PHOTO, Photo), TYPE_DATA_SOURCE, DataSource), &_inner_error0_);
#line 5338 "../src/Photo.vala"
	if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 39870 "Photo.c"
		gboolean _tmp1_ = FALSE;
#line 5338 "../src/Photo.vala"
		g_propagate_error (error, _inner_error0_);
#line 5338 "../src/Photo.vala"
		return _tmp1_;
#line 39876 "Photo.c"
	}
#line 5338 "../src/Photo.vala"
	if (!_tmp0_) {
#line 5339 "../src/Photo.vala"
		result = FALSE;
#line 5339 "../src/Photo.vala"
		return result;
#line 39884 "Photo.c"
	}
#line 5341 "../src/Photo.vala"
	result = media_source_delete_original_file (G_TYPE_CHECK_INSTANCE_CAST (self, TYPE_MEDIA_SOURCE, MediaSource));
#line 5341 "../src/Photo.vala"
	return result;
#line 39890 "Photo.c"
}

static void
library_photo_real_destroy (DataSource* base)
{
	LibraryPhoto * self;
	PhotoID photo_id = {0};
	PhotoID _tmp0_ = {0};
	GError* _inner_error0_ = NULL;
#line 5344 "../src/Photo.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (base, TYPE_LIBRARY_PHOTO, LibraryPhoto);
#line 5345 "../src/Photo.vala"
	photo_get_photo_id (G_TYPE_CHECK_INSTANCE_CAST (self, TYPE_PHOTO, Photo), &_tmp0_);
#line 5345 "../src/Photo.vala"
	photo_id = _tmp0_;
#line 5348 "../src/Photo.vala"
	thumbnail_cache_remove (G_TYPE_CHECK_INSTANCE_CAST (self, TYPE_THUMBNAIL_SOURCE, ThumbnailSource));
#line 39908 "Photo.c"
	{
		PhotoTable* _tmp1_;
		PhotoTable* _tmp2_;
		PhotoID _tmp3_;
#line 5354 "../src/Photo.vala"
		_tmp1_ = photo_table_get_instance ();
#line 5354 "../src/Photo.vala"
		_tmp2_ = _tmp1_;
#line 5354 "../src/Photo.vala"
		_tmp3_ = photo_id;
#line 5354 "../src/Photo.vala"
		photo_table_remove (_tmp2_, &_tmp3_, &_inner_error0_);
#line 5354 "../src/Photo.vala"
		_database_table_unref0 (_tmp2_);
#line 5354 "../src/Photo.vala"
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 5354 "../src/Photo.vala"
			if (_inner_error0_->domain == DATABASE_ERROR) {
#line 39927 "Photo.c"
				goto __catch0_database_error;
			}
#line 5354 "../src/Photo.vala"
			g_critical ("file %s: line %d: unexpected error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 5354 "../src/Photo.vala"
			g_clear_error (&_inner_error0_);
#line 5354 "../src/Photo.vala"
			return;
#line 39936 "Photo.c"
		}
	}
	goto __finally0;
	__catch0_database_error:
	{
		GError* err = NULL;
		GError* _tmp4_;
#line 5353 "../src/Photo.vala"
		err = _inner_error0_;
#line 5353 "../src/Photo.vala"
		_inner_error0_ = NULL;
#line 5356 "../src/Photo.vala"
		_tmp4_ = err;
#line 5356 "../src/Photo.vala"
		app_window_database_error (_tmp4_);
#line 5353 "../src/Photo.vala"
		_g_error_free0 (err);
#line 39954 "Photo.c"
	}
	__finally0:
#line 5353 "../src/Photo.vala"
	if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 5353 "../src/Photo.vala"
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 5353 "../src/Photo.vala"
		g_clear_error (&_inner_error0_);
#line 5353 "../src/Photo.vala"
		return;
#line 39965 "Photo.c"
	}
#line 5359 "../src/Photo.vala"
	DATA_SOURCE_CLASS (library_photo_parent_class)->destroy (G_TYPE_CHECK_INSTANCE_CAST (G_TYPE_CHECK_INSTANCE_CAST (self, TYPE_PHOTO, Photo), TYPE_DATA_SOURCE, DataSource));
#line 39969 "Photo.c"
}

gboolean
library_photo_has_nontrash_duplicate (GFile* file,
                                      const gchar* thumbnail_md5,
                                      const gchar* full_md5,
                                      PhotoFileFormat file_format)
{
	PhotoID _tmp0_ = {0};
	gboolean result;
#line 5362 "../src/Photo.vala"
	g_return_val_if_fail ((file == NULL) || G_TYPE_CHECK_INSTANCE_TYPE (file, g_file_get_type ()), FALSE);
#line 5364 "../src/Photo.vala"
	library_photo_get_nontrash_duplicate (file, thumbnail_md5, full_md5, file_format, &_tmp0_);
#line 5364 "../src/Photo.vala"
	result = photo_id_is_valid (&_tmp0_);
#line 5364 "../src/Photo.vala"
	return result;
#line 39988 "Photo.c"
}

void
library_photo_get_nontrash_duplicate (GFile* file,
                                      const gchar* thumbnail_md5,
                                      const gchar* full_md5,
                                      PhotoFileFormat file_format,
                                      PhotoID* result)
{
	PhotoID* ids = NULL;
	gint _tmp0_ = 0;
	PhotoID* _tmp1_;
	gint ids_length1;
	gint _ids_size_;
	gboolean _tmp2_ = FALSE;
	PhotoID* _tmp3_;
	gint _tmp3__length1;
	PhotoID* _tmp6_;
	gint _tmp6__length1;
	PhotoID _tmp13_ = {0};
#line 5367 "../src/Photo.vala"
	g_return_if_fail ((file == NULL) || G_TYPE_CHECK_INSTANCE_TYPE (file, g_file_get_type ()));
#line 5369 "../src/Photo.vala"
	_tmp1_ = photo_get_duplicate_ids (file, thumbnail_md5, full_md5, file_format, &_tmp0_);
#line 5369 "../src/Photo.vala"
	ids = _tmp1_;
#line 5369 "../src/Photo.vala"
	ids_length1 = _tmp0_;
#line 5369 "../src/Photo.vala"
	_ids_size_ = ids_length1;
#line 5371 "../src/Photo.vala"
	_tmp3_ = ids;
#line 5371 "../src/Photo.vala"
	_tmp3__length1 = ids_length1;
#line 5371 "../src/Photo.vala"
	if (_tmp3_ == NULL) {
#line 5371 "../src/Photo.vala"
		_tmp2_ = TRUE;
#line 40027 "Photo.c"
	} else {
		PhotoID* _tmp4_;
		gint _tmp4__length1;
#line 5371 "../src/Photo.vala"
		_tmp4_ = ids;
#line 5371 "../src/Photo.vala"
		_tmp4__length1 = ids_length1;
#line 5371 "../src/Photo.vala"
		_tmp2_ = _tmp4__length1 == 0;
#line 40037 "Photo.c"
	}
#line 5371 "../src/Photo.vala"
	if (_tmp2_) {
#line 40041 "Photo.c"
		PhotoID _tmp5_ = {0};
#line 5372 "../src/Photo.vala"
		photo_id_init (&_tmp5_, PHOTO_ID_INVALID);
#line 5372 "../src/Photo.vala"
		*result = _tmp5_;
#line 5372 "../src/Photo.vala"
		ids = (g_free (ids), NULL);
#line 5372 "../src/Photo.vala"
		return;
#line 40051 "Photo.c"
	}
#line 5374 "../src/Photo.vala"
	_tmp6_ = ids;
#line 5374 "../src/Photo.vala"
	_tmp6__length1 = ids_length1;
#line 40057 "Photo.c"
	{
		PhotoID* id_collection = NULL;
		gint id_collection_length1 = 0;
		gint _id_collection_size_ = 0;
		gint id_it = 0;
#line 5374 "../src/Photo.vala"
		id_collection = _tmp6_;
#line 5374 "../src/Photo.vala"
		id_collection_length1 = _tmp6__length1;
#line 5374 "../src/Photo.vala"
		for (id_it = 0; id_it < id_collection_length1; id_it = id_it + 1) {
#line 40069 "Photo.c"
			PhotoID id = {0};
#line 5374 "../src/Photo.vala"
			id = id_collection[id_it];
#line 40073 "Photo.c"
			{
				LibraryPhoto* photo = NULL;
				LibraryPhotoSourceCollection* _tmp7_;
				PhotoID _tmp8_;
				LibraryPhoto* _tmp9_;
				gboolean _tmp10_ = FALSE;
				LibraryPhoto* _tmp11_;
#line 5375 "../src/Photo.vala"
				_tmp7_ = library_photo_global;
#line 5375 "../src/Photo.vala"
				_tmp8_ = id;
#line 5375 "../src/Photo.vala"
				_tmp9_ = library_photo_source_collection_fetch (_tmp7_, &_tmp8_);
#line 5375 "../src/Photo.vala"
				photo = _tmp9_;
#line 5376 "../src/Photo.vala"
				_tmp11_ = photo;
#line 5376 "../src/Photo.vala"
				if (_tmp11_ != NULL) {
#line 40093 "Photo.c"
					LibraryPhoto* _tmp12_;
#line 5376 "../src/Photo.vala"
					_tmp12_ = photo;
#line 5376 "../src/Photo.vala"
					_tmp10_ = !media_source_is_trashed (G_TYPE_CHECK_INSTANCE_CAST (_tmp12_, TYPE_MEDIA_SOURCE, MediaSource));
#line 40099 "Photo.c"
				} else {
#line 5376 "../src/Photo.vala"
					_tmp10_ = FALSE;
#line 40103 "Photo.c"
				}
#line 5376 "../src/Photo.vala"
				if (_tmp10_) {
#line 5377 "../src/Photo.vala"
					*result = id;
#line 5377 "../src/Photo.vala"
					_g_object_unref0 (photo);
#line 5377 "../src/Photo.vala"
					ids = (g_free (ids), NULL);
#line 5377 "../src/Photo.vala"
					return;
#line 40115 "Photo.c"
				}
#line 5374 "../src/Photo.vala"
				_g_object_unref0 (photo);
#line 40119 "Photo.c"
			}
		}
	}
#line 5380 "../src/Photo.vala"
	photo_id_init (&_tmp13_, PHOTO_ID_INVALID);
#line 5380 "../src/Photo.vala"
	*result = _tmp13_;
#line 5380 "../src/Photo.vala"
	ids = (g_free (ids), NULL);
#line 5380 "../src/Photo.vala"
	return;
#line 40131 "Photo.c"
}

static gboolean
library_photo_real_has_user_generated_metadata (Photo* base)
{
	LibraryPhoto * self;
	GeeList* tags = NULL;
	TagSourceCollection* _tmp0_;
	GeeList* _tmp1_;
	PhotoMetadata* metadata = NULL;
	PhotoMetadata* _tmp2_;
	PhotoMetadata* _tmp3_;
	PhotoMetadata* _tmp12_;
	GpsCoords old_coords = {0};
	PhotoMetadata* _tmp13_;
	GpsCoords _tmp14_ = {0};
	GpsCoords _tmp15_ = {0};
	gboolean _tmp16_;
	GeeSet* keywords = NULL;
	PhotoMetadata* _tmp17_;
	GeeSet* _tmp18_;
	gint _tmp19_ = 0;
	GeeList* _tmp20_;
	gint tags_count = 0;
	gint _tmp24_ = 0;
	GeeSet* _tmp25_;
	gint keywords_count = 0;
	gboolean _tmp29_ = FALSE;
	GeeList* _tmp30_;
	gboolean result;
#line 5383 "../src/Photo.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (base, TYPE_LIBRARY_PHOTO, LibraryPhoto);
#line 5384 "../src/Photo.vala"
	_tmp0_ = tag_global;
#line 5384 "../src/Photo.vala"
	_tmp1_ = tag_source_collection_fetch_for_source (_tmp0_, G_TYPE_CHECK_INSTANCE_CAST (self, TYPE_MEDIA_SOURCE, MediaSource));
#line 5384 "../src/Photo.vala"
	tags = _tmp1_;
#line 5386 "../src/Photo.vala"
	_tmp2_ = photo_source_get_metadata (G_TYPE_CHECK_INSTANCE_CAST (self, TYPE_PHOTO_SOURCE, PhotoSource));
#line 5386 "../src/Photo.vala"
	metadata = _tmp2_;
#line 5387 "../src/Photo.vala"
	_tmp3_ = metadata;
#line 5387 "../src/Photo.vala"
	if (_tmp3_ == NULL) {
#line 40178 "Photo.c"
		gboolean _tmp4_ = FALSE;
		gboolean _tmp5_ = FALSE;
		gboolean _tmp6_ = FALSE;
		GeeList* _tmp7_;
#line 5388 "../src/Photo.vala"
		_tmp7_ = tags;
#line 5388 "../src/Photo.vala"
		if (_tmp7_ != NULL) {
#line 5388 "../src/Photo.vala"
			_tmp6_ = TRUE;
#line 40189 "Photo.c"
		} else {
			GeeList* _tmp8_;
			gint _tmp9_;
			gint _tmp10_;
#line 5388 "../src/Photo.vala"
			_tmp8_ = tags;
#line 5388 "../src/Photo.vala"
			_tmp9_ = gee_collection_get_size (G_TYPE_CHECK_INSTANCE_CAST (_tmp8_, GEE_TYPE_COLLECTION, GeeCollection));
#line 5388 "../src/Photo.vala"
			_tmp10_ = _tmp9_;
#line 5388 "../src/Photo.vala"
			_tmp6_ = _tmp10_ > 0;
#line 40202 "Photo.c"
		}
#line 5388 "../src/Photo.vala"
		if (_tmp6_) {
#line 5388 "../src/Photo.vala"
			_tmp5_ = TRUE;
#line 40208 "Photo.c"
		} else {
#line 5388 "../src/Photo.vala"
			_tmp5_ = media_source_get_rating (G_TYPE_CHECK_INSTANCE_CAST (self, TYPE_MEDIA_SOURCE, MediaSource)) != RATING_UNRATED;
#line 40212 "Photo.c"
		}
#line 5388 "../src/Photo.vala"
		if (_tmp5_) {
#line 5388 "../src/Photo.vala"
			_tmp4_ = TRUE;
#line 40218 "Photo.c"
		} else {
			GpsCoords _tmp11_ = {0};
#line 5388 "../src/Photo.vala"
			positionable_get_gps_coords (G_TYPE_CHECK_INSTANCE_CAST (self, TYPE_POSITIONABLE, Positionable), &_tmp11_);
#line 5388 "../src/Photo.vala"
			_tmp4_ = _tmp11_.has_gps != 0;
#line 40225 "Photo.c"
		}
#line 5388 "../src/Photo.vala"
		result = _tmp4_;
#line 5388 "../src/Photo.vala"
		_media_metadata_unref0 (metadata);
#line 5388 "../src/Photo.vala"
		_g_object_unref0 (tags);
#line 5388 "../src/Photo.vala"
		return result;
#line 40235 "Photo.c"
	}
#line 5390 "../src/Photo.vala"
	_tmp12_ = metadata;
#line 5390 "../src/Photo.vala"
	if (media_source_get_rating (G_TYPE_CHECK_INSTANCE_CAST (self, TYPE_MEDIA_SOURCE, MediaSource)) != photo_metadata_get_rating (_tmp12_)) {
#line 5391 "../src/Photo.vala"
		result = TRUE;
#line 5391 "../src/Photo.vala"
		_media_metadata_unref0 (metadata);
#line 5391 "../src/Photo.vala"
		_g_object_unref0 (tags);
#line 5391 "../src/Photo.vala"
		return result;
#line 40249 "Photo.c"
	}
#line 5393 "../src/Photo.vala"
	_tmp13_ = metadata;
#line 5393 "../src/Photo.vala"
	photo_metadata_get_gps_coords (_tmp13_, &_tmp14_);
#line 5393 "../src/Photo.vala"
	old_coords = _tmp14_;
#line 5394 "../src/Photo.vala"
	positionable_get_gps_coords (G_TYPE_CHECK_INSTANCE_CAST (self, TYPE_POSITIONABLE, Positionable), &_tmp15_);
#line 5394 "../src/Photo.vala"
	_tmp16_ = gps_coords_equals (&_tmp15_, &old_coords);
#line 5394 "../src/Photo.vala"
	if (!_tmp16_) {
#line 5395 "../src/Photo.vala"
		result = TRUE;
#line 5395 "../src/Photo.vala"
		_media_metadata_unref0 (metadata);
#line 5395 "../src/Photo.vala"
		_g_object_unref0 (tags);
#line 5395 "../src/Photo.vala"
		return result;
#line 40271 "Photo.c"
	}
#line 5397 "../src/Photo.vala"
	_tmp17_ = metadata;
#line 5397 "../src/Photo.vala"
	_tmp18_ = photo_metadata_get_keywords (_tmp17_, NULL, NULL, NULL);
#line 5397 "../src/Photo.vala"
	keywords = _tmp18_;
#line 5398 "../src/Photo.vala"
	_tmp20_ = tags;
#line 5398 "../src/Photo.vala"
	if (_tmp20_ != NULL) {
#line 40283 "Photo.c"
		GeeList* _tmp21_;
		gint _tmp22_;
		gint _tmp23_;
#line 5398 "../src/Photo.vala"
		_tmp21_ = tags;
#line 5398 "../src/Photo.vala"
		_tmp22_ = gee_collection_get_size (G_TYPE_CHECK_INSTANCE_CAST (_tmp21_, GEE_TYPE_COLLECTION, GeeCollection));
#line 5398 "../src/Photo.vala"
		_tmp23_ = _tmp22_;
#line 5398 "../src/Photo.vala"
		_tmp19_ = _tmp23_;
#line 40295 "Photo.c"
	} else {
#line 5398 "../src/Photo.vala"
		_tmp19_ = 0;
#line 40299 "Photo.c"
	}
#line 5398 "../src/Photo.vala"
	tags_count = _tmp19_;
#line 5399 "../src/Photo.vala"
	_tmp25_ = keywords;
#line 5399 "../src/Photo.vala"
	if (_tmp25_ != NULL) {
#line 40307 "Photo.c"
		GeeSet* _tmp26_;
		gint _tmp27_;
		gint _tmp28_;
#line 5399 "../src/Photo.vala"
		_tmp26_ = keywords;
#line 5399 "../src/Photo.vala"
		_tmp27_ = gee_collection_get_size (G_TYPE_CHECK_INSTANCE_CAST (_tmp26_, GEE_TYPE_COLLECTION, GeeCollection));
#line 5399 "../src/Photo.vala"
		_tmp28_ = _tmp27_;
#line 5399 "../src/Photo.vala"
		_tmp24_ = _tmp28_;
#line 40319 "Photo.c"
	} else {
#line 5399 "../src/Photo.vala"
		_tmp24_ = 0;
#line 40323 "Photo.c"
	}
#line 5399 "../src/Photo.vala"
	keywords_count = _tmp24_;
#line 5401 "../src/Photo.vala"
	if (tags_count != keywords_count) {
#line 5402 "../src/Photo.vala"
		result = TRUE;
#line 5402 "../src/Photo.vala"
		_g_object_unref0 (keywords);
#line 5402 "../src/Photo.vala"
		_media_metadata_unref0 (metadata);
#line 5402 "../src/Photo.vala"
		_g_object_unref0 (tags);
#line 5402 "../src/Photo.vala"
		return result;
#line 40339 "Photo.c"
	}
#line 5404 "../src/Photo.vala"
	_tmp30_ = tags;
#line 5404 "../src/Photo.vala"
	if (_tmp30_ != NULL) {
#line 40345 "Photo.c"
		GeeSet* _tmp31_;
#line 5404 "../src/Photo.vala"
		_tmp31_ = keywords;
#line 5404 "../src/Photo.vala"
		_tmp29_ = _tmp31_ != NULL;
#line 40351 "Photo.c"
	} else {
#line 5404 "../src/Photo.vala"
		_tmp29_ = FALSE;
#line 40355 "Photo.c"
	}
#line 5404 "../src/Photo.vala"
	if (_tmp29_) {
#line 40359 "Photo.c"
		{
			GeeList* _tag_list = NULL;
			GeeList* _tmp32_;
			gint _tag_size = 0;
			GeeList* _tmp33_;
			gint _tmp34_;
			gint _tmp35_;
			gint _tag_index = 0;
#line 5405 "../src/Photo.vala"
			_tmp32_ = tags;
#line 5405 "../src/Photo.vala"
			_tag_list = _tmp32_;
#line 5405 "../src/Photo.vala"
			_tmp33_ = _tag_list;
#line 5405 "../src/Photo.vala"
			_tmp34_ = gee_collection_get_size (G_TYPE_CHECK_INSTANCE_CAST (_tmp33_, GEE_TYPE_COLLECTION, GeeCollection));
#line 5405 "../src/Photo.vala"
			_tmp35_ = _tmp34_;
#line 5405 "../src/Photo.vala"
			_tag_size = _tmp35_;
#line 5405 "../src/Photo.vala"
			_tag_index = -1;
#line 5405 "../src/Photo.vala"
			while (TRUE) {
#line 40384 "Photo.c"
				gint _tmp36_;
				gint _tmp37_;
				Tag* tag = NULL;
				GeeList* _tmp38_;
				gpointer _tmp39_;
				GeeSet* _tmp40_;
				Tag* _tmp41_;
				gchar* _tmp42_;
				gchar* _tmp43_;
				gchar* _tmp44_;
				gchar* _tmp45_;
				gboolean _tmp46_;
#line 5405 "../src/Photo.vala"
				_tag_index = _tag_index + 1;
#line 5405 "../src/Photo.vala"
				_tmp36_ = _tag_index;
#line 5405 "../src/Photo.vala"
				_tmp37_ = _tag_size;
#line 5405 "../src/Photo.vala"
				if (!(_tmp36_ < _tmp37_)) {
#line 5405 "../src/Photo.vala"
					break;
#line 40407 "Photo.c"
				}
#line 5405 "../src/Photo.vala"
				_tmp38_ = _tag_list;
#line 5405 "../src/Photo.vala"
				_tmp39_ = gee_list_get (_tmp38_, _tag_index);
#line 5405 "../src/Photo.vala"
				tag = (Tag*) _tmp39_;
#line 5406 "../src/Photo.vala"
				_tmp40_ = keywords;
#line 5406 "../src/Photo.vala"
				_tmp41_ = tag;
#line 5406 "../src/Photo.vala"
				_tmp42_ = data_object_get_name (G_TYPE_CHECK_INSTANCE_CAST (_tmp41_, TYPE_DATA_OBJECT, DataObject));
#line 5406 "../src/Photo.vala"
				_tmp43_ = _tmp42_;
#line 5406 "../src/Photo.vala"
				_tmp44_ = g_utf8_normalize (_tmp43_, (gssize) -1, G_NORMALIZE_DEFAULT);
#line 5406 "../src/Photo.vala"
				_tmp45_ = _tmp44_;
#line 5406 "../src/Photo.vala"
				_tmp46_ = !gee_collection_contains (G_TYPE_CHECK_INSTANCE_CAST (_tmp40_, GEE_TYPE_COLLECTION, GeeCollection), _tmp45_);
#line 5406 "../src/Photo.vala"
				_g_free0 (_tmp45_);
#line 5406 "../src/Photo.vala"
				_g_free0 (_tmp43_);
#line 5406 "../src/Photo.vala"
				if (_tmp46_) {
#line 5407 "../src/Photo.vala"
					result = TRUE;
#line 5407 "../src/Photo.vala"
					_g_object_unref0 (tag);
#line 5407 "../src/Photo.vala"
					_g_object_unref0 (keywords);
#line 5407 "../src/Photo.vala"
					_media_metadata_unref0 (metadata);
#line 5407 "../src/Photo.vala"
					_g_object_unref0 (tags);
#line 5407 "../src/Photo.vala"
					return result;
#line 40447 "Photo.c"
				}
#line 5405 "../src/Photo.vala"
				_g_object_unref0 (tag);
#line 40451 "Photo.c"
			}
		}
	}
#line 5411 "../src/Photo.vala"
	result = FALSE;
#line 5411 "../src/Photo.vala"
	_g_object_unref0 (keywords);
#line 5411 "../src/Photo.vala"
	_media_metadata_unref0 (metadata);
#line 5411 "../src/Photo.vala"
	_g_object_unref0 (tags);
#line 5411 "../src/Photo.vala"
	return result;
#line 40465 "Photo.c"
}

static void
library_photo_real_set_user_metadata_for_export (Photo* base,
                                                 PhotoMetadata* metadata)
{
	LibraryPhoto * self;
	GeeList* photo_tags = NULL;
	TagSourceCollection* _tmp0_;
	GeeList* _tmp1_;
	GeeList* _tmp2_;
	GpsCoords _tmp17_ = {0};
#line 5414 "../src/Photo.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (base, TYPE_LIBRARY_PHOTO, LibraryPhoto);
#line 5414 "../src/Photo.vala"
	g_return_if_fail (IS_PHOTO_METADATA (metadata));
#line 5415 "../src/Photo.vala"
	_tmp0_ = tag_global;
#line 5415 "../src/Photo.vala"
	_tmp1_ = tag_source_collection_fetch_for_source (_tmp0_, G_TYPE_CHECK_INSTANCE_CAST (self, TYPE_MEDIA_SOURCE, MediaSource));
#line 5415 "../src/Photo.vala"
	photo_tags = _tmp1_;
#line 5416 "../src/Photo.vala"
	_tmp2_ = photo_tags;
#line 5416 "../src/Photo.vala"
	if (_tmp2_ != NULL) {
#line 40492 "Photo.c"
		GeeCollection* string_tags = NULL;
		GeeArrayList* _tmp3_;
		GeeCollection* _tmp16_;
#line 5417 "../src/Photo.vala"
		_tmp3_ = gee_array_list_new (G_TYPE_STRING, (GBoxedCopyFunc) g_strdup, (GDestroyNotify) g_free, NULL, NULL, NULL);
#line 5417 "../src/Photo.vala"
		string_tags = G_TYPE_CHECK_INSTANCE_CAST (_tmp3_, GEE_TYPE_COLLECTION, GeeCollection);
#line 40500 "Photo.c"
		{
			GeeList* _tag_list = NULL;
			GeeList* _tmp4_;
			gint _tag_size = 0;
			GeeList* _tmp5_;
			gint _tmp6_;
			gint _tmp7_;
			gint _tag_index = 0;
#line 5418 "../src/Photo.vala"
			_tmp4_ = photo_tags;
#line 5418 "../src/Photo.vala"
			_tag_list = _tmp4_;
#line 5418 "../src/Photo.vala"
			_tmp5_ = _tag_list;
#line 5418 "../src/Photo.vala"
			_tmp6_ = gee_collection_get_size (G_TYPE_CHECK_INSTANCE_CAST (_tmp5_, GEE_TYPE_COLLECTION, GeeCollection));
#line 5418 "../src/Photo.vala"
			_tmp7_ = _tmp6_;
#line 5418 "../src/Photo.vala"
			_tag_size = _tmp7_;
#line 5418 "../src/Photo.vala"
			_tag_index = -1;
#line 5418 "../src/Photo.vala"
			while (TRUE) {
#line 40525 "Photo.c"
				gint _tmp8_;
				gint _tmp9_;
				Tag* tag = NULL;
				GeeList* _tmp10_;
				gpointer _tmp11_;
				GeeCollection* _tmp12_;
				Tag* _tmp13_;
				gchar* _tmp14_;
				gchar* _tmp15_;
#line 5418 "../src/Photo.vala"
				_tag_index = _tag_index + 1;
#line 5418 "../src/Photo.vala"
				_tmp8_ = _tag_index;
#line 5418 "../src/Photo.vala"
				_tmp9_ = _tag_size;
#line 5418 "../src/Photo.vala"
				if (!(_tmp8_ < _tmp9_)) {
#line 5418 "../src/Photo.vala"
					break;
#line 40545 "Photo.c"
				}
#line 5418 "../src/Photo.vala"
				_tmp10_ = _tag_list;
#line 5418 "../src/Photo.vala"
				_tmp11_ = gee_list_get (_tmp10_, _tag_index);
#line 5418 "../src/Photo.vala"
				tag = (Tag*) _tmp11_;
#line 5419 "../src/Photo.vala"
				_tmp12_ = string_tags;
#line 5419 "../src/Photo.vala"
				_tmp13_ = tag;
#line 5419 "../src/Photo.vala"
				_tmp14_ = data_object_get_name (G_TYPE_CHECK_INSTANCE_CAST (_tmp13_, TYPE_DATA_OBJECT, DataObject));
#line 5419 "../src/Photo.vala"
				_tmp15_ = _tmp14_;
#line 5419 "../src/Photo.vala"
				gee_collection_add (_tmp12_, _tmp15_);
#line 5419 "../src/Photo.vala"
				_g_free0 (_tmp15_);
#line 5418 "../src/Photo.vala"
				_g_object_unref0 (tag);
#line 40567 "Photo.c"
			}
		}
#line 5421 "../src/Photo.vala"
		_tmp16_ = string_tags;
#line 5421 "../src/Photo.vala"
		photo_metadata_set_keywords (metadata, _tmp16_, PHOTO_METADATA_SET_OPTION_ALL_DOMAINS);
#line 5416 "../src/Photo.vala"
		_g_object_unref0 (string_tags);
#line 40576 "Photo.c"
	} else {
#line 5423 "../src/Photo.vala"
		photo_metadata_set_keywords (metadata, NULL, PHOTO_METADATA_SET_OPTION_ALL_DOMAINS);
#line 40580 "Photo.c"
	}
#line 5425 "../src/Photo.vala"
	photo_metadata_set_rating (metadata, media_source_get_rating (G_TYPE_CHECK_INSTANCE_CAST (self, TYPE_MEDIA_SOURCE, MediaSource)));
#line 5426 "../src/Photo.vala"
	positionable_get_gps_coords (G_TYPE_CHECK_INSTANCE_CAST (self, TYPE_POSITIONABLE, Positionable), &_tmp17_);
#line 5426 "../src/Photo.vala"
	photo_metadata_set_gps_coords (metadata, &_tmp17_);
#line 5414 "../src/Photo.vala"
	_g_object_unref0 (photo_tags);
#line 40590 "Photo.c"
}

static void
library_photo_real_apply_user_metadata_for_reimport (Photo* base,
                                                     PhotoMetadata* metadata)
{
	LibraryPhoto * self;
	HierarchicalTagIndex* new_htag_index = NULL;
	GeeCollection* keywords = NULL;
	GeeSet* _tmp3_;
	GeeCollection* _tmp4_;
	HierarchicalTagIndex* _tmp31_;
#line 5429 "../src/Photo.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (base, TYPE_LIBRARY_PHOTO, LibraryPhoto);
#line 5429 "../src/Photo.vala"
	g_return_if_fail (IS_PHOTO_METADATA (metadata));
#line 5430 "../src/Photo.vala"
	new_htag_index = NULL;
#line 5432 "../src/Photo.vala"
	if (photo_metadata_has_hierarchical_keywords (metadata)) {
#line 40611 "Photo.c"
		GeeSet* _tmp0_;
		GeeSet* _tmp1_;
		HierarchicalTagIndex* _tmp2_;
#line 5433 "../src/Photo.vala"
		_tmp0_ = photo_metadata_get_hierarchical_keywords (metadata);
#line 5433 "../src/Photo.vala"
		_tmp1_ = _tmp0_;
#line 5433 "../src/Photo.vala"
		_tmp2_ = hierarchical_tag_utilities_process_hierarchical_import_keywords (G_TYPE_CHECK_INSTANCE_CAST (_tmp1_, GEE_TYPE_COLLECTION, GeeCollection));
#line 5433 "../src/Photo.vala"
		_hierarchical_tag_index_unref0 (new_htag_index);
#line 5433 "../src/Photo.vala"
		new_htag_index = _tmp2_;
#line 5433 "../src/Photo.vala"
		_g_object_unref0 (_tmp1_);
#line 40627 "Photo.c"
	}
#line 5437 "../src/Photo.vala"
	_tmp3_ = photo_metadata_get_keywords (metadata, NULL, NULL, NULL);
#line 5437 "../src/Photo.vala"
	keywords = G_TYPE_CHECK_INSTANCE_CAST (_tmp3_, GEE_TYPE_COLLECTION, GeeCollection);
#line 5438 "../src/Photo.vala"
	_tmp4_ = keywords;
#line 5438 "../src/Photo.vala"
	if (_tmp4_ != NULL) {
#line 40637 "Photo.c"
		{
			GeeIterator* _keyword_it = NULL;
			GeeCollection* _tmp5_;
			GeeIterator* _tmp6_;
#line 5439 "../src/Photo.vala"
			_tmp5_ = keywords;
#line 5439 "../src/Photo.vala"
			_tmp6_ = gee_iterable_iterator (G_TYPE_CHECK_INSTANCE_CAST (_tmp5_, GEE_TYPE_ITERABLE, GeeIterable));
#line 5439 "../src/Photo.vala"
			_keyword_it = _tmp6_;
#line 5439 "../src/Photo.vala"
			while (TRUE) {
#line 40650 "Photo.c"
				GeeIterator* _tmp7_;
				gchar* keyword = NULL;
				GeeIterator* _tmp8_;
				gpointer _tmp9_;
				gboolean _tmp10_ = FALSE;
				HierarchicalTagIndex* _tmp11_;
				gchar* safe_keyword = NULL;
				const gchar* _tmp14_;
				gchar* _tmp15_;
				gchar* promoted_keyword = NULL;
				const gchar* _tmp16_;
				gchar* _tmp17_;
				TagSourceCollection* _tmp18_;
				const gchar* _tmp19_;
				TagSourceCollection* _tmp23_;
				const gchar* _tmp24_;
				const gchar* _tmp28_;
				Tag* _tmp29_;
				Tag* _tmp30_;
#line 5439 "../src/Photo.vala"
				_tmp7_ = _keyword_it;
#line 5439 "../src/Photo.vala"
				if (!gee_iterator_next (_tmp7_)) {
#line 5439 "../src/Photo.vala"
					break;
#line 40676 "Photo.c"
				}
#line 5439 "../src/Photo.vala"
				_tmp8_ = _keyword_it;
#line 5439 "../src/Photo.vala"
				_tmp9_ = gee_iterator_get (_tmp8_);
#line 5439 "../src/Photo.vala"
				keyword = (gchar*) _tmp9_;
#line 5440 "../src/Photo.vala"
				_tmp11_ = new_htag_index;
#line 5440 "../src/Photo.vala"
				if (_tmp11_ != NULL) {
#line 40688 "Photo.c"
					HierarchicalTagIndex* _tmp12_;
					const gchar* _tmp13_;
#line 5440 "../src/Photo.vala"
					_tmp12_ = new_htag_index;
#line 5440 "../src/Photo.vala"
					_tmp13_ = keyword;
#line 5440 "../src/Photo.vala"
					_tmp10_ = hierarchical_tag_index_is_tag_in_index (_tmp12_, _tmp13_);
#line 40697 "Photo.c"
				} else {
#line 5440 "../src/Photo.vala"
					_tmp10_ = FALSE;
#line 40701 "Photo.c"
				}
#line 5440 "../src/Photo.vala"
				if (_tmp10_) {
#line 5441 "../src/Photo.vala"
					_g_free0 (keyword);
#line 5441 "../src/Photo.vala"
					continue;
#line 40709 "Photo.c"
				}
#line 5443 "../src/Photo.vala"
				_tmp14_ = keyword;
#line 5443 "../src/Photo.vala"
				_tmp15_ = hierarchical_tag_utilities_make_flat_tag_safe (_tmp14_);
#line 5443 "../src/Photo.vala"
				safe_keyword = _tmp15_;
#line 5444 "../src/Photo.vala"
				_tmp16_ = safe_keyword;
#line 5444 "../src/Photo.vala"
				_tmp17_ = hierarchical_tag_utilities_flat_to_hierarchical (_tmp16_);
#line 5444 "../src/Photo.vala"
				promoted_keyword = _tmp17_;
#line 5447 "../src/Photo.vala"
				_tmp18_ = tag_global;
#line 5447 "../src/Photo.vala"
				_tmp19_ = safe_keyword;
#line 5447 "../src/Photo.vala"
				if (tag_source_collection_exists (_tmp18_, _tmp19_, FALSE)) {
#line 40729 "Photo.c"
					const gchar* _tmp20_;
					Tag* _tmp21_;
					Tag* _tmp22_;
#line 5448 "../src/Photo.vala"
					_tmp20_ = safe_keyword;
#line 5448 "../src/Photo.vala"
					_tmp21_ = tag_for_path (_tmp20_);
#line 5448 "../src/Photo.vala"
					_tmp22_ = _tmp21_;
#line 5448 "../src/Photo.vala"
					tag_attach (_tmp22_, G_TYPE_CHECK_INSTANCE_CAST (self, TYPE_MEDIA_SOURCE, MediaSource));
#line 5448 "../src/Photo.vala"
					_g_object_unref0 (_tmp22_);
#line 5449 "../src/Photo.vala"
					_g_free0 (promoted_keyword);
#line 5449 "../src/Photo.vala"
					_g_free0 (safe_keyword);
#line 5449 "../src/Photo.vala"
					_g_free0 (keyword);
#line 5449 "../src/Photo.vala"
					continue;
#line 40751 "Photo.c"
				}
#line 5452 "../src/Photo.vala"
				_tmp23_ = tag_global;
#line 5452 "../src/Photo.vala"
				_tmp24_ = promoted_keyword;
#line 5452 "../src/Photo.vala"
				if (tag_source_collection_exists (_tmp23_, _tmp24_, FALSE)) {
#line 40759 "Photo.c"
					const gchar* _tmp25_;
					Tag* _tmp26_;
					Tag* _tmp27_;
#line 5453 "../src/Photo.vala"
					_tmp25_ = promoted_keyword;
#line 5453 "../src/Photo.vala"
					_tmp26_ = tag_for_path (_tmp25_);
#line 5453 "../src/Photo.vala"
					_tmp27_ = _tmp26_;
#line 5453 "../src/Photo.vala"
					tag_attach (_tmp27_, G_TYPE_CHECK_INSTANCE_CAST (self, TYPE_MEDIA_SOURCE, MediaSource));
#line 5453 "../src/Photo.vala"
					_g_object_unref0 (_tmp27_);
#line 5454 "../src/Photo.vala"
					_g_free0 (promoted_keyword);
#line 5454 "../src/Photo.vala"
					_g_free0 (safe_keyword);
#line 5454 "../src/Photo.vala"
					_g_free0 (keyword);
#line 5454 "../src/Photo.vala"
					continue;
#line 40781 "Photo.c"
				}
#line 5457 "../src/Photo.vala"
				_tmp28_ = keyword;
#line 5457 "../src/Photo.vala"
				_tmp29_ = tag_for_path (_tmp28_);
#line 5457 "../src/Photo.vala"
				_tmp30_ = _tmp29_;
#line 5457 "../src/Photo.vala"
				tag_attach (_tmp30_, G_TYPE_CHECK_INSTANCE_CAST (self, TYPE_MEDIA_SOURCE, MediaSource));
#line 5457 "../src/Photo.vala"
				_g_object_unref0 (_tmp30_);
#line 5439 "../src/Photo.vala"
				_g_free0 (promoted_keyword);
#line 5439 "../src/Photo.vala"
				_g_free0 (safe_keyword);
#line 5439 "../src/Photo.vala"
				_g_free0 (keyword);
#line 40799 "Photo.c"
			}
#line 5439 "../src/Photo.vala"
			_g_object_unref0 (_keyword_it);
#line 40803 "Photo.c"
		}
	}
#line 5461 "../src/Photo.vala"
	_tmp31_ = new_htag_index;
#line 5461 "../src/Photo.vala"
	if (_tmp31_ != NULL) {
#line 40810 "Photo.c"
		{
			GeeIterator* _path_it = NULL;
			HierarchicalTagIndex* _tmp32_;
			GeeCollection* _tmp33_;
			GeeCollection* _tmp34_;
			GeeIterator* _tmp35_;
			GeeIterator* _tmp36_;
#line 5462 "../src/Photo.vala"
			_tmp32_ = new_htag_index;
#line 5462 "../src/Photo.vala"
			_tmp33_ = hierarchical_tag_index_get_all_paths (_tmp32_);
#line 5462 "../src/Photo.vala"
			_tmp34_ = _tmp33_;
#line 5462 "../src/Photo.vala"
			_tmp35_ = gee_iterable_iterator (G_TYPE_CHECK_INSTANCE_CAST (_tmp34_, GEE_TYPE_ITERABLE, GeeIterable));
#line 5462 "../src/Photo.vala"
			_tmp36_ = _tmp35_;
#line 5462 "../src/Photo.vala"
			_g_object_unref0 (_tmp34_);
#line 5462 "../src/Photo.vala"
			_path_it = _tmp36_;
#line 5462 "../src/Photo.vala"
			while (TRUE) {
#line 40834 "Photo.c"
				GeeIterator* _tmp37_;
				gchar* path = NULL;
				GeeIterator* _tmp38_;
				gpointer _tmp39_;
				const gchar* _tmp40_;
				Tag* _tmp41_;
				Tag* _tmp42_;
#line 5462 "../src/Photo.vala"
				_tmp37_ = _path_it;
#line 5462 "../src/Photo.vala"
				if (!gee_iterator_next (_tmp37_)) {
#line 5462 "../src/Photo.vala"
					break;
#line 40848 "Photo.c"
				}
#line 5462 "../src/Photo.vala"
				_tmp38_ = _path_it;
#line 5462 "../src/Photo.vala"
				_tmp39_ = gee_iterator_get (_tmp38_);
#line 5462 "../src/Photo.vala"
				path = (gchar*) _tmp39_;
#line 5463 "../src/Photo.vala"
				_tmp40_ = path;
#line 5463 "../src/Photo.vala"
				_tmp41_ = tag_for_path (_tmp40_);
#line 5463 "../src/Photo.vala"
				_tmp42_ = _tmp41_;
#line 5463 "../src/Photo.vala"
				tag_attach (_tmp42_, G_TYPE_CHECK_INSTANCE_CAST (self, TYPE_MEDIA_SOURCE, MediaSource));
#line 5463 "../src/Photo.vala"
				_g_object_unref0 (_tmp42_);
#line 5462 "../src/Photo.vala"
				_g_free0 (path);
#line 40868 "Photo.c"
			}
#line 5462 "../src/Photo.vala"
			_g_object_unref0 (_path_it);
#line 40872 "Photo.c"
		}
	}
#line 5429 "../src/Photo.vala"
	_g_object_unref0 (keywords);
#line 5429 "../src/Photo.vala"
	_hierarchical_tag_index_unref0 (new_htag_index);
#line 40879 "Photo.c"
}

static void
library_photo_class_init (LibraryPhotoClass * klass,
                          gpointer klass_data)
{
#line 5001 "../src/Photo.vala"
	library_photo_parent_class = g_type_class_peek_parent (klass);
#line 5001 "../src/Photo.vala"
	g_type_class_adjust_private_offset (klass, &LibraryPhoto_private_offset);
#line 5001 "../src/Photo.vala"
	((PhotoClass *) klass)->notify_master_reimported = (void (*) (Photo*, PhotoMetadata*)) library_photo_real_notify_master_reimported;
#line 5001 "../src/Photo.vala"
	((PhotoClass *) klass)->notify_editable_reimported = (void (*) (Photo*, PhotoMetadata*)) library_photo_real_notify_editable_reimported;
#line 5001 "../src/Photo.vala"
	((PhotoClass *) klass)->notify_source_reimported = (void (*) (Photo*, PhotoMetadata*)) library_photo_real_notify_source_reimported;
#line 5001 "../src/Photo.vala"
	((PhotoClass *) klass)->notify_baseline_reimported = (void (*) (Photo*, PhotoMetadata*)) library_photo_real_notify_baseline_reimported;
#line 5001 "../src/Photo.vala"
	((DataObjectClass *) klass)->notify_altered = (void (*) (DataObject*, Alteration*)) library_photo_real_notify_altered;
#line 5001 "../src/Photo.vala"
	((MediaSourceClass *) klass)->get_preview_pixbuf = (GdkPixbuf* (*) (MediaSource*, Scaling*, GError**)) library_photo_real_get_preview_pixbuf;
#line 5001 "../src/Photo.vala"
	((PhotoClass *) klass)->rotate = (void (*) (Photo*, Rotation)) library_photo_real_rotate;
#line 5001 "../src/Photo.vala"
	((ThumbnailSourceClass *) klass)->get_thumbnail = (GdkPixbuf* (*) (ThumbnailSource*, gint, GError**)) library_photo_real_get_thumbnail;
#line 5001 "../src/Photo.vala"
	((MediaSourceClass *) klass)->is_trashed = (gboolean (*) (MediaSource*)) library_photo_real_is_trashed;
#line 5001 "../src/Photo.vala"
	((MediaSourceClass *) klass)->trash = (void (*) (MediaSource*)) library_photo_real_trash;
#line 5001 "../src/Photo.vala"
	((MediaSourceClass *) klass)->untrash = (void (*) (MediaSource*)) library_photo_real_untrash;
#line 5001 "../src/Photo.vala"
	((MediaSourceClass *) klass)->is_offline = (gboolean (*) (MediaSource*)) library_photo_real_is_offline;
#line 5001 "../src/Photo.vala"
	((MediaSourceClass *) klass)->mark_offline = (void (*) (MediaSource*)) library_photo_real_mark_offline;
#line 5001 "../src/Photo.vala"
	((MediaSourceClass *) klass)->mark_online = (void (*) (MediaSource*)) library_photo_real_mark_online;
#line 5001 "../src/Photo.vala"
	((DataSourceClass *) klass)->internal_delete_backing = (gboolean (*) (DataSource*, GError**)) library_photo_real_internal_delete_backing;
#line 5001 "../src/Photo.vala"
	((DataSourceClass *) klass)->destroy = (void (*) (DataSource*)) library_photo_real_destroy;
#line 5001 "../src/Photo.vala"
	((PhotoClass *) klass)->has_user_generated_metadata = (gboolean (*) (Photo*)) library_photo_real_has_user_generated_metadata;
#line 5001 "../src/Photo.vala"
	((PhotoClass *) klass)->set_user_metadata_for_export = (void (*) (Photo*, PhotoMetadata*)) library_photo_real_set_user_metadata_for_export;
#line 5001 "../src/Photo.vala"
	((PhotoClass *) klass)->apply_user_metadata_for_reimport = (void (*) (Photo*, PhotoMetadata*)) library_photo_real_apply_user_metadata_for_reimport;
#line 5001 "../src/Photo.vala"
	G_OBJECT_CLASS (klass)->finalize = library_photo_finalize;
#line 40930 "Photo.c"
}

static void
library_photo_flaggable_interface_init (FlaggableIface * iface,
                                        gpointer iface_data)
{
#line 5001 "../src/Photo.vala"
	library_photo_flaggable_parent_iface = g_type_interface_peek_parent (iface);
#line 5001 "../src/Photo.vala"
	iface->is_flagged = (gboolean (*) (Flaggable*)) library_photo_real_is_flagged;
#line 5001 "../src/Photo.vala"
	iface->mark_flagged = (void (*) (Flaggable*)) library_photo_real_mark_flagged;
#line 5001 "../src/Photo.vala"
	iface->mark_unflagged = (void (*) (Flaggable*)) library_photo_real_mark_unflagged;
#line 40945 "Photo.c"
}

static void
library_photo_monitorable_interface_init (MonitorableIface * iface,
                                          gpointer iface_data)
{
#line 5001 "../src/Photo.vala"
	library_photo_monitorable_parent_iface = g_type_interface_peek_parent (iface);
#line 5001 "../src/Photo.vala"
	iface->is_offline = (gboolean (*) (Monitorable*)) library_photo_real_is_offline;
#line 5001 "../src/Photo.vala"
	iface->mark_offline = (void (*) (Monitorable*)) library_photo_real_mark_offline;
#line 5001 "../src/Photo.vala"
	iface->mark_online = (void (*) (Monitorable*)) library_photo_real_mark_online;
#line 5001 "../src/Photo.vala"
	iface->set_master_file = (void (*) (Monitorable*, GFile*)) photo_set_master_file;
#line 5001 "../src/Photo.vala"
	iface->set_master_timestamp = (void (*) (Monitorable*, GFileInfo*)) photo_set_master_timestamp;
#line 40964 "Photo.c"
}

static void
library_photo_instance_init (LibraryPhoto * self,
                             gpointer klass)
{
#line 5001 "../src/Photo.vala"
	self->priv = library_photo_get_instance_private (self);
#line 5012 "../src/Photo.vala"
	self->priv->block_thumbnail_generation = FALSE;
#line 5013 "../src/Photo.vala"
	self->priv->thumbnail_scheduler = NULL;
#line 40977 "Photo.c"
}

static void
library_photo_finalize (GObject * obj)
{
	LibraryPhoto * self;
#line 5001 "../src/Photo.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, TYPE_LIBRARY_PHOTO, LibraryPhoto);
#line 5013 "../src/Photo.vala"
	_one_shot_scheduler_unref0 (self->priv->thumbnail_scheduler);
#line 5014 "../src/Photo.vala"
	_g_object_unref0 (self->priv->import_keywords);
#line 5001 "../src/Photo.vala"
	G_OBJECT_CLASS (library_photo_parent_class)->finalize (obj);
#line 40992 "Photo.c"
}

static GType
library_photo_get_type_once (void)
{
	static const GTypeInfo g_define_type_info = { sizeof (LibraryPhotoClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) library_photo_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (LibraryPhoto), 0, (GInstanceInitFunc) library_photo_instance_init, NULL };
	static const GInterfaceInfo flaggable_info = { (GInterfaceInitFunc) library_photo_flaggable_interface_init, (GInterfaceFinalizeFunc) NULL, NULL};
	static const GInterfaceInfo monitorable_info = { (GInterfaceInitFunc) library_photo_monitorable_interface_init, (GInterfaceFinalizeFunc) NULL, NULL};
	GType library_photo_type_id;
	library_photo_type_id = g_type_register_static (TYPE_PHOTO, "LibraryPhoto", &g_define_type_info, 0);
	g_type_add_interface_static (library_photo_type_id, TYPE_FLAGGABLE, &flaggable_info);
	g_type_add_interface_static (library_photo_type_id, TYPE_MONITORABLE, &monitorable_info);
	LibraryPhoto_private_offset = g_type_add_instance_private (library_photo_type_id, sizeof (LibraryPhotoPrivate));
	return library_photo_type_id;
}

GType
library_photo_get_type (void)
{
	static volatile gsize library_photo_type_id__once = 0;
	if (g_once_init_enter (&library_photo_type_id__once)) {
		GType library_photo_type_id;
		library_photo_type_id = library_photo_get_type_once ();
		g_once_init_leave (&library_photo_type_id__once, library_photo_type_id);
	}
	return library_photo_type_id__once;
}

static inline gpointer
library_photo_source_holding_tank_get_instance_private (LibraryPhotoSourceHoldingTank* self)
{
	return G_STRUCT_MEMBER_P (self, LibraryPhotoSourceHoldingTank_private_offset);
}

LibraryPhotoSourceHoldingTank*
library_photo_source_holding_tank_construct (GType object_type,
                                             LibraryPhotoSourceCollection* sources,
                                             SourceHoldingTankCheckToKeep check_to_keep,
                                             gpointer check_to_keep_target,
                                             GetSourceDatabaseKey get_key,
                                             gpointer get_key_target)
{
	LibraryPhotoSourceHoldingTank* self = NULL;
#line 5479 "../src/Photo.vala"
	g_return_val_if_fail (IS_LIBRARY_PHOTO_SOURCE_COLLECTION (sources), NULL);
#line 5481 "../src/Photo.vala"
	self = (LibraryPhotoSourceHoldingTank*) media_source_holding_tank_construct (object_type, G_TYPE_CHECK_INSTANCE_CAST (sources, TYPE_MEDIA_SOURCE_COLLECTION, MediaSourceCollection), check_to_keep, check_to_keep_target, get_key, get_key_target);
#line 5479 "../src/Photo.vala"
	return self;
#line 41042 "Photo.c"
}

LibraryPhotoSourceHoldingTank*
library_photo_source_holding_tank_new (LibraryPhotoSourceCollection* sources,
                                       SourceHoldingTankCheckToKeep check_to_keep,
                                       gpointer check_to_keep_target,
                                       GetSourceDatabaseKey get_key,
                                       gpointer get_key_target)
{
#line 5479 "../src/Photo.vala"
	return library_photo_source_holding_tank_construct (TYPE_LIBRARY_PHOTO_SOURCE_HOLDING_TANK, sources, check_to_keep, check_to_keep_target, get_key, get_key_target);
#line 41054 "Photo.c"
}

LibraryPhoto*
library_photo_source_holding_tank_fetch_by_backing_file (LibraryPhotoSourceHoldingTank* self,
                                                         GFile* file)
{
	LibraryPhoto* ret = NULL;
	GeeHashMap* _tmp0_;
	gpointer _tmp1_;
	LibraryPhoto* _tmp2_;
	GeeHashMap* _tmp3_;
	gpointer _tmp4_;
	LibraryPhoto* result;
#line 5484 "../src/Photo.vala"
	g_return_val_if_fail (IS_LIBRARY_PHOTO_SOURCE_HOLDING_TANK (self), NULL);
#line 5484 "../src/Photo.vala"
	g_return_val_if_fail (G_TYPE_CHECK_INSTANCE_TYPE (file, g_file_get_type ()), NULL);
#line 5485 "../src/Photo.vala"
	ret = NULL;
#line 5486 "../src/Photo.vala"
	_tmp0_ = self->priv->editable_file_map;
#line 5486 "../src/Photo.vala"
	_tmp1_ = gee_abstract_map_get (G_TYPE_CHECK_INSTANCE_CAST (_tmp0_, GEE_TYPE_ABSTRACT_MAP, GeeAbstractMap), file);
#line 5486 "../src/Photo.vala"
	_g_object_unref0 (ret);
#line 5486 "../src/Photo.vala"
	ret = (LibraryPhoto*) _tmp1_;
#line 5487 "../src/Photo.vala"
	_tmp2_ = ret;
#line 5487 "../src/Photo.vala"
	if (_tmp2_ != NULL) {
#line 5488 "../src/Photo.vala"
		result = ret;
#line 5488 "../src/Photo.vala"
		return result;
#line 41090 "Photo.c"
	}
#line 5490 "../src/Photo.vala"
	_tmp3_ = self->priv->development_file_map;
#line 5490 "../src/Photo.vala"
	_tmp4_ = gee_abstract_map_get (G_TYPE_CHECK_INSTANCE_CAST (_tmp3_, GEE_TYPE_ABSTRACT_MAP, GeeAbstractMap), file);
#line 5490 "../src/Photo.vala"
	result = (LibraryPhoto*) _tmp4_;
#line 5490 "../src/Photo.vala"
	_g_object_unref0 (ret);
#line 5490 "../src/Photo.vala"
	return result;
#line 41102 "Photo.c"
}

static void
_library_photo_source_holding_tank_on_editable_replaced_photo_editable_replaced (Photo* _sender,
                                                                                 GFile* old_file,
                                                                                 GFile* new_file,
                                                                                 gpointer self)
{
#line 5514 "../src/Photo.vala"
	library_photo_source_holding_tank_on_editable_replaced ((LibraryPhotoSourceHoldingTank*) self, _sender, old_file, new_file);
#line 41113 "Photo.c"
}

static void
_library_photo_source_holding_tank_on_raw_development_modified_photo_raw_development_modified (Photo* _sender,
                                                                                               gpointer self)
{
#line 5515 "../src/Photo.vala"
	library_photo_source_holding_tank_on_raw_development_modified ((LibraryPhotoSourceHoldingTank*) self, _sender);
#line 41122 "Photo.c"
}

static void
library_photo_source_holding_tank_real_notify_contents_altered (SourceHoldingTank* base,
                                                                GeeCollection* added,
                                                                GeeCollection* removed)
{
	LibraryPhotoSourceHoldingTank * self;
#line 5493 "../src/Photo.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (base, TYPE_LIBRARY_PHOTO_SOURCE_HOLDING_TANK, LibraryPhotoSourceHoldingTank);
#line 5493 "../src/Photo.vala"
	g_return_if_fail ((added == NULL) || G_TYPE_CHECK_INSTANCE_TYPE (added, GEE_TYPE_COLLECTION));
#line 5493 "../src/Photo.vala"
	g_return_if_fail ((removed == NULL) || G_TYPE_CHECK_INSTANCE_TYPE (removed, GEE_TYPE_COLLECTION));
#line 5495 "../src/Photo.vala"
	if (added != NULL) {
#line 41139 "Photo.c"
		{
			GeeIterator* _source_it = NULL;
			GeeIterator* _tmp0_;
#line 5496 "../src/Photo.vala"
			_tmp0_ = gee_iterable_iterator (G_TYPE_CHECK_INSTANCE_CAST (added, GEE_TYPE_ITERABLE, GeeIterable));
#line 5496 "../src/Photo.vala"
			_source_it = _tmp0_;
#line 5496 "../src/Photo.vala"
			while (TRUE) {
#line 41149 "Photo.c"
				GeeIterator* _tmp1_;
				DataSource* source = NULL;
				GeeIterator* _tmp2_;
				gpointer _tmp3_;
				LibraryPhoto* photo = NULL;
				DataSource* _tmp4_;
				LibraryPhoto* _tmp5_;
				LibraryPhoto* _tmp6_;
				GFile* _tmp7_;
				GFile* _tmp8_;
				gboolean _tmp9_;
				GeeCollection* raw_files = NULL;
				LibraryPhoto* _tmp20_;
				GeeCollection* _tmp21_;
				GeeCollection* _tmp22_;
				LibraryPhoto* _tmp34_;
				LibraryPhoto* _tmp35_;
#line 5496 "../src/Photo.vala"
				_tmp1_ = _source_it;
#line 5496 "../src/Photo.vala"
				if (!gee_iterator_next (_tmp1_)) {
#line 5496 "../src/Photo.vala"
					break;
#line 41173 "Photo.c"
				}
#line 5496 "../src/Photo.vala"
				_tmp2_ = _source_it;
#line 5496 "../src/Photo.vala"
				_tmp3_ = gee_iterator_get (_tmp2_);
#line 5496 "../src/Photo.vala"
				source = (DataSource*) _tmp3_;
#line 5497 "../src/Photo.vala"
				_tmp4_ = source;
#line 5497 "../src/Photo.vala"
				_tmp5_ = _g_object_ref0 (G_TYPE_CHECK_INSTANCE_CAST (_tmp4_, TYPE_LIBRARY_PHOTO, LibraryPhoto));
#line 5497 "../src/Photo.vala"
				photo = _tmp5_;
#line 5500 "../src/Photo.vala"
				_tmp6_ = photo;
#line 5500 "../src/Photo.vala"
				_tmp7_ = photo_get_editable_file (G_TYPE_CHECK_INSTANCE_CAST (_tmp6_, TYPE_PHOTO, Photo));
#line 5500 "../src/Photo.vala"
				_tmp8_ = _tmp7_;
#line 5500 "../src/Photo.vala"
				_tmp9_ = _tmp8_ != NULL;
#line 5500 "../src/Photo.vala"
				_g_object_unref0 (_tmp8_);
#line 5500 "../src/Photo.vala"
				if (_tmp9_) {
#line 41199 "Photo.c"
					GeeHashMap* _tmp10_;
					LibraryPhoto* _tmp11_;
					GFile* _tmp12_;
					GFile* _tmp13_;
					LibraryPhoto* _tmp14_;
					GeeMultiMap* _tmp15_;
					LibraryPhoto* _tmp16_;
					LibraryPhoto* _tmp17_;
					GFile* _tmp18_;
					GFile* _tmp19_;
#line 5501 "../src/Photo.vala"
					_tmp10_ = self->priv->editable_file_map;
#line 5501 "../src/Photo.vala"
					_tmp11_ = photo;
#line 5501 "../src/Photo.vala"
					_tmp12_ = photo_get_editable_file (G_TYPE_CHECK_INSTANCE_CAST (_tmp11_, TYPE_PHOTO, Photo));
#line 5501 "../src/Photo.vala"
					_tmp13_ = _tmp12_;
#line 5501 "../src/Photo.vala"
					_tmp14_ = photo;
#line 5501 "../src/Photo.vala"
					gee_abstract_map_set (G_TYPE_CHECK_INSTANCE_CAST (_tmp10_, GEE_TYPE_ABSTRACT_MAP, GeeAbstractMap), _tmp13_, _tmp14_);
#line 5501 "../src/Photo.vala"
					_g_object_unref0 (_tmp13_);
#line 5502 "../src/Photo.vala"
					_tmp15_ = self->priv->reverse_editable_file_map;
#line 5502 "../src/Photo.vala"
					_tmp16_ = photo;
#line 5502 "../src/Photo.vala"
					_tmp17_ = photo;
#line 5502 "../src/Photo.vala"
					_tmp18_ = photo_get_editable_file (G_TYPE_CHECK_INSTANCE_CAST (_tmp17_, TYPE_PHOTO, Photo));
#line 5502 "../src/Photo.vala"
					_tmp19_ = _tmp18_;
#line 5502 "../src/Photo.vala"
					gee_multi_map_set (_tmp15_, _tmp16_, _tmp19_);
#line 5502 "../src/Photo.vala"
					_g_object_unref0 (_tmp19_);
#line 41238 "Photo.c"
				}
#line 5506 "../src/Photo.vala"
				_tmp20_ = photo;
#line 5506 "../src/Photo.vala"
				_tmp21_ = photo_get_raw_developer_files (G_TYPE_CHECK_INSTANCE_CAST (_tmp20_, TYPE_PHOTO, Photo));
#line 5506 "../src/Photo.vala"
				raw_files = _tmp21_;
#line 5507 "../src/Photo.vala"
				_tmp22_ = raw_files;
#line 5507 "../src/Photo.vala"
				if (_tmp22_ != NULL) {
#line 41250 "Photo.c"
					{
						GeeIterator* _f_it = NULL;
						GeeCollection* _tmp23_;
						GeeIterator* _tmp24_;
#line 5508 "../src/Photo.vala"
						_tmp23_ = raw_files;
#line 5508 "../src/Photo.vala"
						_tmp24_ = gee_iterable_iterator (G_TYPE_CHECK_INSTANCE_CAST (_tmp23_, GEE_TYPE_ITERABLE, GeeIterable));
#line 5508 "../src/Photo.vala"
						_f_it = _tmp24_;
#line 5508 "../src/Photo.vala"
						while (TRUE) {
#line 41263 "Photo.c"
							GeeIterator* _tmp25_;
							GFile* f = NULL;
							GeeIterator* _tmp26_;
							gpointer _tmp27_;
							GeeHashMap* _tmp28_;
							GFile* _tmp29_;
							LibraryPhoto* _tmp30_;
							GeeMultiMap* _tmp31_;
							LibraryPhoto* _tmp32_;
							GFile* _tmp33_;
#line 5508 "../src/Photo.vala"
							_tmp25_ = _f_it;
#line 5508 "../src/Photo.vala"
							if (!gee_iterator_next (_tmp25_)) {
#line 5508 "../src/Photo.vala"
								break;
#line 41280 "Photo.c"
							}
#line 5508 "../src/Photo.vala"
							_tmp26_ = _f_it;
#line 5508 "../src/Photo.vala"
							_tmp27_ = gee_iterator_get (_tmp26_);
#line 5508 "../src/Photo.vala"
							f = (GFile*) _tmp27_;
#line 5509 "../src/Photo.vala"
							_tmp28_ = self->priv->development_file_map;
#line 5509 "../src/Photo.vala"
							_tmp29_ = f;
#line 5509 "../src/Photo.vala"
							_tmp30_ = photo;
#line 5509 "../src/Photo.vala"
							gee_abstract_map_set (G_TYPE_CHECK_INSTANCE_CAST (_tmp28_, GEE_TYPE_ABSTRACT_MAP, GeeAbstractMap), _tmp29_, _tmp30_);
#line 5510 "../src/Photo.vala"
							_tmp31_ = self->priv->reverse_development_file_map;
#line 5510 "../src/Photo.vala"
							_tmp32_ = photo;
#line 5510 "../src/Photo.vala"
							_tmp33_ = f;
#line 5510 "../src/Photo.vala"
							gee_multi_map_set (_tmp31_, _tmp32_, _tmp33_);
#line 5508 "../src/Photo.vala"
							_g_object_unref0 (f);
#line 41306 "Photo.c"
						}
#line 5508 "../src/Photo.vala"
						_g_object_unref0 (_f_it);
#line 41310 "Photo.c"
					}
				}
#line 5514 "../src/Photo.vala"
				_tmp34_ = photo;
#line 5514 "../src/Photo.vala"
				g_signal_connect (G_TYPE_CHECK_INSTANCE_CAST (_tmp34_, TYPE_PHOTO, Photo), "editable-replaced", (GCallback) _library_photo_source_holding_tank_on_editable_replaced_photo_editable_replaced, self);
#line 5515 "../src/Photo.vala"
				_tmp35_ = photo;
#line 5515 "../src/Photo.vala"
				g_signal_connect (G_TYPE_CHECK_INSTANCE_CAST (_tmp35_, TYPE_PHOTO, Photo), "raw-development-modified", (GCallback) _library_photo_source_holding_tank_on_raw_development_modified_photo_raw_development_modified, self);
#line 5496 "../src/Photo.vala"
				_g_object_unref0 (raw_files);
#line 5496 "../src/Photo.vala"
				_g_object_unref0 (photo);
#line 5496 "../src/Photo.vala"
				_g_object_unref0 (source);
#line 41327 "Photo.c"
			}
#line 5496 "../src/Photo.vala"
			_g_object_unref0 (_source_it);
#line 41331 "Photo.c"
		}
	}
#line 5519 "../src/Photo.vala"
	if (removed != NULL) {
#line 41336 "Photo.c"
		{
			GeeIterator* _source_it = NULL;
			GeeIterator* _tmp36_;
#line 5520 "../src/Photo.vala"
			_tmp36_ = gee_iterable_iterator (G_TYPE_CHECK_INSTANCE_CAST (removed, GEE_TYPE_ITERABLE, GeeIterable));
#line 5520 "../src/Photo.vala"
			_source_it = _tmp36_;
#line 5520 "../src/Photo.vala"
			while (TRUE) {
#line 41346 "Photo.c"
				GeeIterator* _tmp37_;
				DataSource* source = NULL;
				GeeIterator* _tmp38_;
				gpointer _tmp39_;
				LibraryPhoto* photo = NULL;
				DataSource* _tmp40_;
				LibraryPhoto* _tmp41_;
				GeeMultiMap* _tmp64_;
				LibraryPhoto* _tmp65_;
				GeeMultiMap* _tmp66_;
				LibraryPhoto* _tmp67_;
				LibraryPhoto* _tmp68_;
				guint _tmp69_;
				LibraryPhoto* _tmp70_;
				guint _tmp71_;
#line 5520 "../src/Photo.vala"
				_tmp37_ = _source_it;
#line 5520 "../src/Photo.vala"
				if (!gee_iterator_next (_tmp37_)) {
#line 5520 "../src/Photo.vala"
					break;
#line 41368 "Photo.c"
				}
#line 5520 "../src/Photo.vala"
				_tmp38_ = _source_it;
#line 5520 "../src/Photo.vala"
				_tmp39_ = gee_iterator_get (_tmp38_);
#line 5520 "../src/Photo.vala"
				source = (DataSource*) _tmp39_;
#line 5521 "../src/Photo.vala"
				_tmp40_ = source;
#line 5521 "../src/Photo.vala"
				_tmp41_ = _g_object_ref0 (G_TYPE_CHECK_INSTANCE_CAST (_tmp40_, TYPE_LIBRARY_PHOTO, LibraryPhoto));
#line 5521 "../src/Photo.vala"
				photo = _tmp41_;
#line 41382 "Photo.c"
				{
					GeeIterator* _f_it = NULL;
					GeeMultiMap* _tmp42_;
					LibraryPhoto* _tmp43_;
					GeeCollection* _tmp44_;
					GeeCollection* _tmp45_;
					GeeIterator* _tmp46_;
					GeeIterator* _tmp47_;
#line 5522 "../src/Photo.vala"
					_tmp42_ = self->priv->reverse_editable_file_map;
#line 5522 "../src/Photo.vala"
					_tmp43_ = photo;
#line 5522 "../src/Photo.vala"
					_tmp44_ = gee_multi_map_get (_tmp42_, _tmp43_);
#line 5522 "../src/Photo.vala"
					_tmp45_ = _tmp44_;
#line 5522 "../src/Photo.vala"
					_tmp46_ = gee_iterable_iterator (G_TYPE_CHECK_INSTANCE_CAST (_tmp45_, GEE_TYPE_ITERABLE, GeeIterable));
#line 5522 "../src/Photo.vala"
					_tmp47_ = _tmp46_;
#line 5522 "../src/Photo.vala"
					_g_object_unref0 (_tmp45_);
#line 5522 "../src/Photo.vala"
					_f_it = _tmp47_;
#line 5522 "../src/Photo.vala"
					while (TRUE) {
#line 41409 "Photo.c"
						GeeIterator* _tmp48_;
						GFile* f = NULL;
						GeeIterator* _tmp49_;
						gpointer _tmp50_;
						GeeHashMap* _tmp51_;
						GFile* _tmp52_;
#line 5522 "../src/Photo.vala"
						_tmp48_ = _f_it;
#line 5522 "../src/Photo.vala"
						if (!gee_iterator_next (_tmp48_)) {
#line 5522 "../src/Photo.vala"
							break;
#line 41422 "Photo.c"
						}
#line 5522 "../src/Photo.vala"
						_tmp49_ = _f_it;
#line 5522 "../src/Photo.vala"
						_tmp50_ = gee_iterator_get (_tmp49_);
#line 5522 "../src/Photo.vala"
						f = (GFile*) _tmp50_;
#line 5523 "../src/Photo.vala"
						_tmp51_ = self->priv->editable_file_map;
#line 5523 "../src/Photo.vala"
						_tmp52_ = f;
#line 5523 "../src/Photo.vala"
						gee_abstract_map_unset (G_TYPE_CHECK_INSTANCE_CAST (_tmp51_, GEE_TYPE_ABSTRACT_MAP, GeeAbstractMap), _tmp52_, NULL);
#line 5522 "../src/Photo.vala"
						_g_object_unref0 (f);
#line 41438 "Photo.c"
					}
#line 5522 "../src/Photo.vala"
					_g_object_unref0 (_f_it);
#line 41442 "Photo.c"
				}
				{
					GeeIterator* _f_it = NULL;
					GeeMultiMap* _tmp53_;
					LibraryPhoto* _tmp54_;
					GeeCollection* _tmp55_;
					GeeCollection* _tmp56_;
					GeeIterator* _tmp57_;
					GeeIterator* _tmp58_;
#line 5525 "../src/Photo.vala"
					_tmp53_ = self->priv->reverse_development_file_map;
#line 5525 "../src/Photo.vala"
					_tmp54_ = photo;
#line 5525 "../src/Photo.vala"
					_tmp55_ = gee_multi_map_get (_tmp53_, _tmp54_);
#line 5525 "../src/Photo.vala"
					_tmp56_ = _tmp55_;
#line 5525 "../src/Photo.vala"
					_tmp57_ = gee_iterable_iterator (G_TYPE_CHECK_INSTANCE_CAST (_tmp56_, GEE_TYPE_ITERABLE, GeeIterable));
#line 5525 "../src/Photo.vala"
					_tmp58_ = _tmp57_;
#line 5525 "../src/Photo.vala"
					_g_object_unref0 (_tmp56_);
#line 5525 "../src/Photo.vala"
					_f_it = _tmp58_;
#line 5525 "../src/Photo.vala"
					while (TRUE) {
#line 41470 "Photo.c"
						GeeIterator* _tmp59_;
						GFile* f = NULL;
						GeeIterator* _tmp60_;
						gpointer _tmp61_;
						GeeHashMap* _tmp62_;
						GFile* _tmp63_;
#line 5525 "../src/Photo.vala"
						_tmp59_ = _f_it;
#line 5525 "../src/Photo.vala"
						if (!gee_iterator_next (_tmp59_)) {
#line 5525 "../src/Photo.vala"
							break;
#line 41483 "Photo.c"
						}
#line 5525 "../src/Photo.vala"
						_tmp60_ = _f_it;
#line 5525 "../src/Photo.vala"
						_tmp61_ = gee_iterator_get (_tmp60_);
#line 5525 "../src/Photo.vala"
						f = (GFile*) _tmp61_;
#line 5526 "../src/Photo.vala"
						_tmp62_ = self->priv->development_file_map;
#line 5526 "../src/Photo.vala"
						_tmp63_ = f;
#line 5526 "../src/Photo.vala"
						gee_abstract_map_unset (G_TYPE_CHECK_INSTANCE_CAST (_tmp62_, GEE_TYPE_ABSTRACT_MAP, GeeAbstractMap), _tmp63_, NULL);
#line 5525 "../src/Photo.vala"
						_g_object_unref0 (f);
#line 41499 "Photo.c"
					}
#line 5525 "../src/Photo.vala"
					_g_object_unref0 (_f_it);
#line 41503 "Photo.c"
				}
#line 5528 "../src/Photo.vala"
				_tmp64_ = self->priv->reverse_editable_file_map;
#line 5528 "../src/Photo.vala"
				_tmp65_ = photo;
#line 5528 "../src/Photo.vala"
				gee_multi_map_remove_all (_tmp64_, _tmp65_);
#line 5529 "../src/Photo.vala"
				_tmp66_ = self->priv->reverse_development_file_map;
#line 5529 "../src/Photo.vala"
				_tmp67_ = photo;
#line 5529 "../src/Photo.vala"
				gee_multi_map_remove_all (_tmp66_, _tmp67_);
#line 5531 "../src/Photo.vala"
				_tmp68_ = photo;
#line 5531 "../src/Photo.vala"
				g_signal_parse_name ("editable-replaced", TYPE_PHOTO, &_tmp69_, NULL, FALSE);
#line 5531 "../src/Photo.vala"
				g_signal_handlers_disconnect_matched (G_TYPE_CHECK_INSTANCE_CAST (_tmp68_, TYPE_PHOTO, Photo), G_SIGNAL_MATCH_ID | G_SIGNAL_MATCH_FUNC | G_SIGNAL_MATCH_DATA, _tmp69_, 0, NULL, (GCallback) _library_photo_source_holding_tank_on_editable_replaced_photo_editable_replaced, self);
#line 5532 "../src/Photo.vala"
				_tmp70_ = photo;
#line 5532 "../src/Photo.vala"
				g_signal_parse_name ("raw-development-modified", TYPE_PHOTO, &_tmp71_, NULL, FALSE);
#line 5532 "../src/Photo.vala"
				g_signal_handlers_disconnect_matched (G_TYPE_CHECK_INSTANCE_CAST (_tmp70_, TYPE_PHOTO, Photo), G_SIGNAL_MATCH_ID | G_SIGNAL_MATCH_FUNC | G_SIGNAL_MATCH_DATA, _tmp71_, 0, NULL, (GCallback) _library_photo_source_holding_tank_on_raw_development_modified_photo_raw_development_modified, self);
#line 5520 "../src/Photo.vala"
				_g_object_unref0 (photo);
#line 5520 "../src/Photo.vala"
				_g_object_unref0 (source);
#line 41533 "Photo.c"
			}
#line 5520 "../src/Photo.vala"
			_g_object_unref0 (_source_it);
#line 41537 "Photo.c"
		}
	}
#line 5536 "../src/Photo.vala"
	SOURCE_HOLDING_TANK_CLASS (library_photo_source_holding_tank_parent_class)->notify_contents_altered (G_TYPE_CHECK_INSTANCE_CAST (G_TYPE_CHECK_INSTANCE_CAST (self, TYPE_MEDIA_SOURCE_HOLDING_TANK, MediaSourceHoldingTank), TYPE_SOURCE_HOLDING_TANK, SourceHoldingTank), added, removed);
#line 41542 "Photo.c"
}

static void
library_photo_source_holding_tank_on_editable_replaced (LibraryPhotoSourceHoldingTank* self,
                                                        Photo* _photo,
                                                        GFile* old_file,
                                                        GFile* new_file)
{
	LibraryPhoto* photo = NULL;
	LibraryPhoto* _tmp0_;
	LibraryPhoto* _tmp1_;
	GeeMultiMap* _tmp7_;
	LibraryPhoto* _tmp8_;
#line 5539 "../src/Photo.vala"
	g_return_if_fail (IS_LIBRARY_PHOTO_SOURCE_HOLDING_TANK (self));
#line 5539 "../src/Photo.vala"
	g_return_if_fail (IS_PHOTO (_photo));
#line 5539 "../src/Photo.vala"
	g_return_if_fail ((old_file == NULL) || G_TYPE_CHECK_INSTANCE_TYPE (old_file, g_file_get_type ()));
#line 5539 "../src/Photo.vala"
	g_return_if_fail ((new_file == NULL) || G_TYPE_CHECK_INSTANCE_TYPE (new_file, g_file_get_type ()));
#line 5540 "../src/Photo.vala"
	_tmp0_ = _g_object_ref0 (IS_LIBRARY_PHOTO (_photo) ? ((LibraryPhoto*) _photo) : NULL);
#line 5540 "../src/Photo.vala"
	photo = _tmp0_;
#line 5541 "../src/Photo.vala"
	_tmp1_ = photo;
#line 5541 "../src/Photo.vala"
	_vala_assert (_tmp1_ != NULL, "photo != null");
#line 5543 "../src/Photo.vala"
	if (old_file != NULL) {
#line 41574 "Photo.c"
		GeeHashMap* _tmp2_;
		GeeMultiMap* _tmp3_;
		LibraryPhoto* _tmp4_;
#line 5544 "../src/Photo.vala"
		_tmp2_ = self->priv->editable_file_map;
#line 5544 "../src/Photo.vala"
		gee_abstract_map_unset (G_TYPE_CHECK_INSTANCE_CAST (_tmp2_, GEE_TYPE_ABSTRACT_MAP, GeeAbstractMap), old_file, NULL);
#line 5545 "../src/Photo.vala"
		_tmp3_ = self->priv->reverse_editable_file_map;
#line 5545 "../src/Photo.vala"
		_tmp4_ = photo;
#line 5545 "../src/Photo.vala"
		gee_multi_map_remove (_tmp3_, _tmp4_, old_file);
#line 41588 "Photo.c"
	}
#line 5548 "../src/Photo.vala"
	if (new_file != NULL) {
#line 41592 "Photo.c"
		GeeHashMap* _tmp5_;
		LibraryPhoto* _tmp6_;
#line 5549 "../src/Photo.vala"
		_tmp5_ = self->priv->editable_file_map;
#line 5549 "../src/Photo.vala"
		_tmp6_ = photo;
#line 5549 "../src/Photo.vala"
		gee_abstract_map_set (G_TYPE_CHECK_INSTANCE_CAST (_tmp5_, GEE_TYPE_ABSTRACT_MAP, GeeAbstractMap), new_file, _tmp6_);
#line 41601 "Photo.c"
	}
#line 5550 "../src/Photo.vala"
	_tmp7_ = self->priv->reverse_editable_file_map;
#line 5550 "../src/Photo.vala"
	_tmp8_ = photo;
#line 5550 "../src/Photo.vala"
	gee_multi_map_set (_tmp7_, _tmp8_, new_file);
#line 5539 "../src/Photo.vala"
	_g_object_unref0 (photo);
#line 41611 "Photo.c"
}

static void
library_photo_source_holding_tank_on_raw_development_modified (LibraryPhotoSourceHoldingTank* self,
                                                               Photo* _photo)
{
	LibraryPhoto* photo = NULL;
	LibraryPhoto* _tmp0_;
	LibraryPhoto* _tmp1_;
	GeeMultiMap* _tmp2_;
	LibraryPhoto* _tmp3_;
	GeeCollection* raw_list = NULL;
	LibraryPhoto* _tmp17_;
	GeeCollection* _tmp18_;
	GeeCollection* _tmp19_;
#line 5553 "../src/Photo.vala"
	g_return_if_fail (IS_LIBRARY_PHOTO_SOURCE_HOLDING_TANK (self));
#line 5553 "../src/Photo.vala"
	g_return_if_fail (IS_PHOTO (_photo));
#line 5554 "../src/Photo.vala"
	_tmp0_ = _g_object_ref0 (IS_LIBRARY_PHOTO (_photo) ? ((LibraryPhoto*) _photo) : NULL);
#line 5554 "../src/Photo.vala"
	photo = _tmp0_;
#line 5555 "../src/Photo.vala"
	_tmp1_ = photo;
#line 5555 "../src/Photo.vala"
	_vala_assert (_tmp1_ != NULL, "photo != null");
#line 5558 "../src/Photo.vala"
	_tmp2_ = self->priv->reverse_development_file_map;
#line 5558 "../src/Photo.vala"
	_tmp3_ = photo;
#line 5558 "../src/Photo.vala"
	if (gee_multi_map_contains (_tmp2_, _tmp3_)) {
#line 41645 "Photo.c"
		GeeMultiMap* _tmp15_;
		LibraryPhoto* _tmp16_;
		{
			GeeIterator* _f_it = NULL;
			GeeMultiMap* _tmp4_;
			LibraryPhoto* _tmp5_;
			GeeCollection* _tmp6_;
			GeeCollection* _tmp7_;
			GeeIterator* _tmp8_;
			GeeIterator* _tmp9_;
#line 5559 "../src/Photo.vala"
			_tmp4_ = self->priv->reverse_development_file_map;
#line 5559 "../src/Photo.vala"
			_tmp5_ = photo;
#line 5559 "../src/Photo.vala"
			_tmp6_ = gee_multi_map_get (_tmp4_, _tmp5_);
#line 5559 "../src/Photo.vala"
			_tmp7_ = _tmp6_;
#line 5559 "../src/Photo.vala"
			_tmp8_ = gee_iterable_iterator (G_TYPE_CHECK_INSTANCE_CAST (_tmp7_, GEE_TYPE_ITERABLE, GeeIterable));
#line 5559 "../src/Photo.vala"
			_tmp9_ = _tmp8_;
#line 5559 "../src/Photo.vala"
			_g_object_unref0 (_tmp7_);
#line 5559 "../src/Photo.vala"
			_f_it = _tmp9_;
#line 5559 "../src/Photo.vala"
			while (TRUE) {
#line 41674 "Photo.c"
				GeeIterator* _tmp10_;
				GFile* f = NULL;
				GeeIterator* _tmp11_;
				gpointer _tmp12_;
				GeeHashMap* _tmp13_;
				GFile* _tmp14_;
#line 5559 "../src/Photo.vala"
				_tmp10_ = _f_it;
#line 5559 "../src/Photo.vala"
				if (!gee_iterator_next (_tmp10_)) {
#line 5559 "../src/Photo.vala"
					break;
#line 41687 "Photo.c"
				}
#line 5559 "../src/Photo.vala"
				_tmp11_ = _f_it;
#line 5559 "../src/Photo.vala"
				_tmp12_ = gee_iterator_get (_tmp11_);
#line 5559 "../src/Photo.vala"
				f = (GFile*) _tmp12_;
#line 5560 "../src/Photo.vala"
				_tmp13_ = self->priv->development_file_map;
#line 5560 "../src/Photo.vala"
				_tmp14_ = f;
#line 5560 "../src/Photo.vala"
				gee_abstract_map_unset (G_TYPE_CHECK_INSTANCE_CAST (_tmp13_, GEE_TYPE_ABSTRACT_MAP, GeeAbstractMap), _tmp14_, NULL);
#line 5559 "../src/Photo.vala"
				_g_object_unref0 (f);
#line 41703 "Photo.c"
			}
#line 5559 "../src/Photo.vala"
			_g_object_unref0 (_f_it);
#line 41707 "Photo.c"
		}
#line 5561 "../src/Photo.vala"
		_tmp15_ = self->priv->reverse_development_file_map;
#line 5561 "../src/Photo.vala"
		_tmp16_ = photo;
#line 5561 "../src/Photo.vala"
		gee_multi_map_remove_all (_tmp15_, _tmp16_);
#line 41715 "Photo.c"
	}
#line 5565 "../src/Photo.vala"
	_tmp17_ = photo;
#line 5565 "../src/Photo.vala"
	_tmp18_ = photo_get_raw_developer_files (G_TYPE_CHECK_INSTANCE_CAST (_tmp17_, TYPE_PHOTO, Photo));
#line 5565 "../src/Photo.vala"
	raw_list = _tmp18_;
#line 5566 "../src/Photo.vala"
	_tmp19_ = raw_list;
#line 5566 "../src/Photo.vala"
	if (_tmp19_ != NULL) {
#line 41727 "Photo.c"
		{
			GeeIterator* _f_it = NULL;
			GeeCollection* _tmp20_;
			GeeIterator* _tmp21_;
#line 5567 "../src/Photo.vala"
			_tmp20_ = raw_list;
#line 5567 "../src/Photo.vala"
			_tmp21_ = gee_iterable_iterator (G_TYPE_CHECK_INSTANCE_CAST (_tmp20_, GEE_TYPE_ITERABLE, GeeIterable));
#line 5567 "../src/Photo.vala"
			_f_it = _tmp21_;
#line 5567 "../src/Photo.vala"
			while (TRUE) {
#line 41740 "Photo.c"
				GeeIterator* _tmp22_;
				GFile* f = NULL;
				GeeIterator* _tmp23_;
				gpointer _tmp24_;
				GeeHashMap* _tmp25_;
				GFile* _tmp26_;
				LibraryPhoto* _tmp27_;
				GeeMultiMap* _tmp28_;
				LibraryPhoto* _tmp29_;
				GFile* _tmp30_;
#line 5567 "../src/Photo.vala"
				_tmp22_ = _f_it;
#line 5567 "../src/Photo.vala"
				if (!gee_iterator_next (_tmp22_)) {
#line 5567 "../src/Photo.vala"
					break;
#line 41757 "Photo.c"
				}
#line 5567 "../src/Photo.vala"
				_tmp23_ = _f_it;
#line 5567 "../src/Photo.vala"
				_tmp24_ = gee_iterator_get (_tmp23_);
#line 5567 "../src/Photo.vala"
				f = (GFile*) _tmp24_;
#line 5568 "../src/Photo.vala"
				_tmp25_ = self->priv->development_file_map;
#line 5568 "../src/Photo.vala"
				_tmp26_ = f;
#line 5568 "../src/Photo.vala"
				_tmp27_ = photo;
#line 5568 "../src/Photo.vala"
				gee_abstract_map_set (G_TYPE_CHECK_INSTANCE_CAST (_tmp25_, GEE_TYPE_ABSTRACT_MAP, GeeAbstractMap), _tmp26_, _tmp27_);
#line 5569 "../src/Photo.vala"
				_tmp28_ = self->priv->reverse_development_file_map;
#line 5569 "../src/Photo.vala"
				_tmp29_ = photo;
#line 5569 "../src/Photo.vala"
				_tmp30_ = f;
#line 5569 "../src/Photo.vala"
				gee_multi_map_set (_tmp28_, _tmp29_, _tmp30_);
#line 5567 "../src/Photo.vala"
				_g_object_unref0 (f);
#line 41783 "Photo.c"
			}
#line 5567 "../src/Photo.vala"
			_g_object_unref0 (_f_it);
#line 41787 "Photo.c"
		}
	}
#line 5553 "../src/Photo.vala"
	_g_object_unref0 (raw_list);
#line 5553 "../src/Photo.vala"
	_g_object_unref0 (photo);
#line 41794 "Photo.c"
}

static void
library_photo_source_holding_tank_class_init (LibraryPhotoSourceHoldingTankClass * klass,
                                              gpointer klass_data)
{
#line 5469 "../src/Photo.vala"
	library_photo_source_holding_tank_parent_class = g_type_class_peek_parent (klass);
#line 5469 "../src/Photo.vala"
	((SourceHoldingTankClass *) klass)->finalize = library_photo_source_holding_tank_finalize;
#line 5469 "../src/Photo.vala"
	g_type_class_adjust_private_offset (klass, &LibraryPhotoSourceHoldingTank_private_offset);
#line 5469 "../src/Photo.vala"
	((SourceHoldingTankClass *) klass)->notify_contents_altered = (void (*) (SourceHoldingTank*, GeeCollection*, GeeCollection*)) library_photo_source_holding_tank_real_notify_contents_altered;
#line 41809 "Photo.c"
}

static void
library_photo_source_holding_tank_instance_init (LibraryPhotoSourceHoldingTank * self,
                                                 gpointer klass)
{
	GeeHashMap* _tmp0_;
	GeeHashMap* _tmp1_;
	GeeHashMultiMap* _tmp2_;
	GeeHashMultiMap* _tmp3_;
#line 5469 "../src/Photo.vala"
	self->priv = library_photo_source_holding_tank_get_instance_private (self);
#line 5470 "../src/Photo.vala"
	_tmp0_ = gee_hash_map_new (g_file_get_type (), (GBoxedCopyFunc) g_object_ref, (GDestroyNotify) g_object_unref, TYPE_LIBRARY_PHOTO, (GBoxedCopyFunc) g_object_ref, (GDestroyNotify) g_object_unref, _file_hash_gee_hash_data_func, NULL, NULL, _file_equal_gee_equal_data_func, NULL, NULL, NULL, NULL, NULL);
#line 5470 "../src/Photo.vala"
	self->priv->editable_file_map = _tmp0_;
#line 5472 "../src/Photo.vala"
	_tmp1_ = gee_hash_map_new (g_file_get_type (), (GBoxedCopyFunc) g_object_ref, (GDestroyNotify) g_object_unref, TYPE_LIBRARY_PHOTO, (GBoxedCopyFunc) g_object_ref, (GDestroyNotify) g_object_unref, _file_hash_gee_hash_data_func, NULL, NULL, _file_equal_gee_equal_data_func, NULL, NULL, NULL, NULL, NULL);
#line 5472 "../src/Photo.vala"
	self->priv->development_file_map = _tmp1_;
#line 5474 "../src/Photo.vala"
	_tmp2_ = gee_hash_multi_map_new (TYPE_LIBRARY_PHOTO, (GBoxedCopyFunc) g_object_ref, (GDestroyNotify) g_object_unref, g_file_get_type (), (GBoxedCopyFunc) g_object_ref, (GDestroyNotify) g_object_unref, NULL, NULL, NULL, NULL, NULL, NULL, _file_hash_gee_hash_data_func, NULL, NULL, _file_equal_gee_equal_data_func, NULL, NULL);
#line 5474 "../src/Photo.vala"
	self->priv->reverse_editable_file_map = G_TYPE_CHECK_INSTANCE_CAST (_tmp2_, GEE_TYPE_MULTI_MAP, GeeMultiMap);
#line 5476 "../src/Photo.vala"
	_tmp3_ = gee_hash_multi_map_new (TYPE_LIBRARY_PHOTO, (GBoxedCopyFunc) g_object_ref, (GDestroyNotify) g_object_unref, g_file_get_type (), (GBoxedCopyFunc) g_object_ref, (GDestroyNotify) g_object_unref, NULL, NULL, NULL, NULL, NULL, NULL, _file_hash_gee_hash_data_func, NULL, NULL, _file_equal_gee_equal_data_func, NULL, NULL);
#line 5476 "../src/Photo.vala"
	self->priv->reverse_development_file_map = G_TYPE_CHECK_INSTANCE_CAST (_tmp3_, GEE_TYPE_MULTI_MAP, GeeMultiMap);
#line 41838 "Photo.c"
}

static void
library_photo_source_holding_tank_finalize (SourceHoldingTank * obj)
{
	LibraryPhotoSourceHoldingTank * self;
#line 5469 "../src/Photo.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, TYPE_LIBRARY_PHOTO_SOURCE_HOLDING_TANK, LibraryPhotoSourceHoldingTank);
#line 5470 "../src/Photo.vala"
	_g_object_unref0 (self->priv->editable_file_map);
#line 5472 "../src/Photo.vala"
	_g_object_unref0 (self->priv->development_file_map);
#line 5474 "../src/Photo.vala"
	_g_object_unref0 (self->priv->reverse_editable_file_map);
#line 5476 "../src/Photo.vala"
	_g_object_unref0 (self->priv->reverse_development_file_map);
#line 5469 "../src/Photo.vala"
	SOURCE_HOLDING_TANK_CLASS (library_photo_source_holding_tank_parent_class)->finalize (obj);
#line 41857 "Photo.c"
}

static GType
library_photo_source_holding_tank_get_type_once (void)
{
	static const GTypeInfo g_define_type_info = { sizeof (LibraryPhotoSourceHoldingTankClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) library_photo_source_holding_tank_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (LibraryPhotoSourceHoldingTank), 0, (GInstanceInitFunc) library_photo_source_holding_tank_instance_init, NULL };
	GType library_photo_source_holding_tank_type_id;
	library_photo_source_holding_tank_type_id = g_type_register_static (TYPE_MEDIA_SOURCE_HOLDING_TANK, "LibraryPhotoSourceHoldingTank", &g_define_type_info, 0);
	LibraryPhotoSourceHoldingTank_private_offset = g_type_add_instance_private (library_photo_source_holding_tank_type_id, sizeof (LibraryPhotoSourceHoldingTankPrivate));
	return library_photo_source_holding_tank_type_id;
}

GType
library_photo_source_holding_tank_get_type (void)
{
	static volatile gsize library_photo_source_holding_tank_type_id__once = 0;
	if (g_once_init_enter (&library_photo_source_holding_tank_type_id__once)) {
		GType library_photo_source_holding_tank_type_id;
		library_photo_source_holding_tank_type_id = library_photo_source_holding_tank_get_type_once ();
		g_once_init_leave (&library_photo_source_holding_tank_type_id__once, library_photo_source_holding_tank_type_id);
	}
	return library_photo_source_holding_tank_type_id__once;
}

static void
_vala_array_destroy (gpointer array,
                     gssize array_length,
                     GDestroyNotify destroy_func)
{
	if ((array != NULL) && (destroy_func != NULL)) {
		gssize i;
		for (i = 0; i < array_length; i = i + 1) {
			if (((gpointer*) array)[i] != NULL) {
				destroy_func (((gpointer*) array)[i]);
			}
		}
	}
}

static void
_vala_array_free (gpointer array,
                  gssize array_length,
                  GDestroyNotify destroy_func)
{
	_vala_array_destroy (array, array_length, destroy_func);
	g_free (array);
}

static inline gpointer
_vala_memdup2 (gconstpointer mem,
               gsize byte_size)
{
	gpointer new_mem;
	if (mem && byte_size != 0) {
		new_mem = g_malloc (byte_size);
		memcpy (new_mem, mem, byte_size);
	} else {
		new_mem = NULL;
	}
	return new_mem;
}

